systemheader:(FB    )#                                                  FB     1
####################################################################### FB     2
##      Copyright (C) 2000, The Xtal System, The University of        # FB     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # FB     4
## Distributed under the GNU General Public Licence as published by   # FB     5
## the Free Software Foundation, in the hope that it will be useful   # FB     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # FB     7
## for more details.                                                  # FB     8
#                                                                     # FB     9
#                           *** RFOURR ***                            # FB    10
#                                                                     # FB    11
#    THE PROGRAM RFOURR COMPUTES THE FOURIER TRANSFORM FROM           # FB    12
#    DIRECT SPACE TO RECIPROCAL.  IT IS GENERAL FOR ALL SPACE         # FB    13
#    GROUPS AND SETTINGS IF THE INPUT MAP IS THAT OF A FULL           # FB    14
#    UNIT CELL.  THE OUTPUT WILL CONSIST OF FC VALUES FOR THE         # FB    15
#    UNIQUE REFLECTIONS STORED ON THE BDF.  ONLY FC VALUES FOR        # FB    16
#    THE REFLECTIONS WITHIN THE RESOLUTION OF THE MAP WILL BE         # FB    17
#    CALCULATED.  ALL THE REST WILL BE SET TO VOIDFLG:                # FB    18
#                                                                     # FB    19
####################################################################### FB    20
#                                                                       FB    21
include:(XMACRO)#                                                       FB    22
#                                                                       FB    23
macro:(dirbuf:,4095)#                  Direct access file buffer size   FB    24
#                                                                       FB    25
extrude:(FBCOMN)#                                                       FB    26
REAL    CELLC(6)#   ## Direct cell constants                            FB    27
INTEGER DIRSIG#     ## Signal to use direct access files 3rd sums       FB    28
INTEGER DSET#       ## Dataset number for derivative being calculated   FB    29
REAL    E000#       ## Just that                                        FB    30
REAL    F000#       ## "    "                                           FB    31
REAL    FRAT#       ## Fc to Fo ratio for phase acceptance              FB    32
INTEGER IDF1,IDF2#  ## pointers statistics bins                         FB    33
INTEGER ISM1,ISM2,ISM3## pointers statistics bins                       FB    34
INTEGER IN(3)#      ## Grid point increment on input map                FB    35
INTEGER IHKL#       ## Offset pointer for packed h,k,l in lrrefl:       FB    36
INTEGER IA#         ## Offset pointer for a in lrrefl:                  FB    37
INTEGER IB#         ## Offset pointer for b in lrrefl:                  FB    38
INTEGER IPHI,LPHI#  ## Offset pointer for phase in cycles in lrrefl:    FB    39
INTEGER IPHIO,IPHIC## flags if op and compare phase exist on bdf        FB    40
INTEGER IFC#        ## Offset pointer for calc f in lrrefl:             FB    41
INTEGER IFO#        ## Offset pointer for obs f lrrefl:                 FB    42
INTEGER ISTL#       ## Offset pointer for sin theta / lambda            FB    43
INTEGER ISUM(3)#    ## Summation order correlation between              FB    44
INTEGER JSUM(3)#    ## Crystal axes and map axes                        FB    45
INTEGER JA#         ## ID number for a in lrrefl:                       FB    46
INTEGER JB#         ## ID number for b in lrrefl:                       FB    47
INTEGER JPHI#       ## ID number for phase in cycles in lrrefl:         FB    48
INTEGER JFC#        ## ID number for calc f in lrrefl:                  FB    49
INTEGER JFO#        ## ID number for obs f lrrefl:                      FB    50
INTEGER KPHI#       ## ID number for input phase in cycles in lrrefl:   FB    51
INTEGER MARKP#      ## Start of third sum coef for fft                  FB    52
INTEGER MARKG#      ## Start of sec sum coef for fft                    FB    53
REAL    MAXH(3)#    ## Maximum h,k,l from input bdf                     FB    54
REAL    MINH(3)#    ## Minimum h,k,l from input bdf                     FB    55
INTEGER NEGIND(3)#  ## Signal any neg h,k,l yes:/no: among reflection   FB    56
INTEGER NG(3)#      ## Number of grid points in map                     FB    57
INTEGER NP(3)#      ## Actual number of points in map                   FB    58
INTEGER NSCL#       ## Number of scale groups                           FB    59
INTEGER NBIN#       ## number of stol bins in output                    FB    60
INTEGER NRBIN#      ## number of resolution parameters                  FB    61
INTEGER OG(3)#      ## Grid values of the origin of the map             FB    62
INTEGER PHOLD,PSIZR## Hold the value of psiz from fb10                  FB    63
INTEGER PRINTL#     ## Flag to control printing                         FB    64
REAL    RCELL(6)#   ## Permuted reciprocal cell constants               FB    65
REAL    DSTAT(25)#  ## resolution limits input                          FB    66
REAL    SPACE(25)#  ## stol bin limits                                  FB    67
REAL    STATS(150)# ## stats maintained for stol bins                   FB    68
REAL    SCALE(64)#  ## F relative scale factors                         FB    69
INTEGER SORTOR#     ## Reflection sort order as supplied on rfourr li   FB    70
REAL    STLL(2)#    ## Min/Maximum sin theta on lambda                  FB    71
REAL    THRESH#     ## threshold of calculated a & b                    FB    72
REAL    TWOPI#      ## Twice pi                                         FB    73
REAL    VOL#        ## Unit cell volume                                 FB    74
REAL    SUCUT#      ## Cutoff for inclusion of unphased f in corrln     FB    75
#                                                                       FB    76
COMMON/COMFFB/$#                                                        FB    77
THRESH,CELLC,E000,F000,FRAT,RCELL,#                                     FB    78
MAXH,MINH,SCALE,STLL,TWOPI,VOL,DSTAT,SPACE,STATS,SUCUT#                 FB    79
#                                                                       FB    80
COMMON/COMIFB/$#                                                        FB    81
DIRSIG,DSET,IN,ISTL,NBIN,NRBIN,IPHIO,IPHIC,#                            FB    82
IA,IB,IHKL,IPHI,LPHI,IFC,IFO,ISUM,JSUM,#                                FB    83
JA,JB,JPHI,JFC,JFO,KPHI,MARKP,MARKG,#                                   FB    84
NEGIND,NG,NP,NSCL,IDF1,IDF2,ISM1,ISM2,ISM3,#                            FB    85
OG,PHOLD,PRINTL,PSIZR,SORTOR#                                           FB    86
endext:#                                                                FB    87
#                                                                       FB    88
systemheader:(FB00)#                                                    FB00   1
# ################################################################## #  FB00   2
#                                                                       FB00   3
#                               FB00                                 #  FB00   4
#                                                                    #  FB00   5
# ################################################################## #  FB00   6
SUBROUTINE FB00#                       J.m.stewart,j.r.holden 1985      FB00   7
include:(AACOMN)#                                                       FB00   8
include:(FBCOMN)#                                                       FB00   9
#                                                                       FB00  10
FILEXT(IOUNIT(3))='MAP'#               Ext of fourr input map           FB00  11
FILEXT(ioda1:)='XX1'#                  Ext of scratch file              FB00  12
#                                                                       FB00  13
CALL FB10#                             Bdf input and startup            FB00  14
IF(NRBIN>0) CALL FB15#                 Set up stol bins                 FB00  15
CALL FB70#                             Calculate fft summations         FB00  16
#                                                                       FB00  17
RETURN#                                                                 FB00  18
END#                                                                    FB00  19
systemheader:(FB10)#                   Bdf input and initialization     FB10   1
# ################################################################## #  FB10   2
#                                                                    #  FB10   3
#                               FB10                                 #  FB10   4
#                                                                    #  FB10   5
# ################################################################## #  FB10   6
SUBROUTINE FB10#                       J.m.stewart d.m.collins mar198   FB10   7
include:(AACOMN)#                      J.r.holden nov1985               FB10   8
include:(FBCOMN)#                      S.r.hall jan1988                 FB10   9
#                                                                       FB10  10
INTEGER I,J,K#                         Local indices                    FB10  11
INTEGER PSIZ,IP,IIP#                   Bdf reading parameters           FB10  12
INTEGER FLG(4)#                        Flags for indexpkt:              FB10  13
INTEGER IWNT(24),IREL(25)#             Storage for indexpkt:            FB10  14
INTEGER MAXINP#                        Signal for maxhkl line           FB10  15
INTEGER SORT,SORTP#                    Sort orders                      FB10  16
INTEGER SIGNIN#                        Signal sign patterns in input    FB10  17
#                                                                       FB10  18
chardata:(FB10A, END MAXHKL IDNUMS DSTAT )#                             FB10  19
chardata:(FB10B,DS  PR  DA  PH  PK  PL  $#                              FB10  20
HKL HLK KHL KLH LHK LKH TH  FT  CUT )#                                  FB10  21
chardata:(FB10C, BDF STRUCTURE FACTOR IDNUM                 )#          FB10  22
chardata:(FB10D,XYZ)#                                                   FB10  23
chardata:(FB10E,HKL)#                                                   FB10  24
chardata:(FB10F, HKL SORT ORDER SLO/MED/FAS                 )#          FB10  25
chardata:(FB10G, MAP DIRECTIONS 1ST/2ND/3RD                 )#          FB10  26
chardata:(FB10H, MAXIMUM /H/ /K/ /L/ APPLIED                )#          FB10  27
chardata:(FB10I, MIN/MAX SINE THETA / LAMBDA                )#          FB10  28
chardata:(FB10J,YESNO )#                                                FB10  29
chardata:(FB10K,[ HKL PHASED ONLY IF A OR B >                ])#        FB10  30
chardata:(FB10L, RFOURR CONTROL PARAMETERS)#                            FB10  31
chardata:(FB10M, DATA SET OF COMPARED DATA                  )#          FB10  32
chardata:(FB10N, PRINT REFLECTIONS PER LAYER                )#          FB10  33
chardata:(FB10O,[ OUTPUT IDNUMS FC,AC,BC,PHI                       $#   FB10  34
             ])#                                                        FB10  35
chardata:(FB10P, HKL NEGATIVE INDICES                       )#          FB10  36
chardata:(FB10Q,[ HKL PHASED ONLY IF FC/FOB >                ])#        FB10  37
chardata:(FB10R,[ CORRELN IF UNPHASED FOBS  >                ])#        FB10  38
chardata:(FB10S, INPUT HKL SORT ORDER                       )#          FB10  39
chardata:(FB10W, INPUT FOURIER MAP ORDER                    )#          FB10  40
chardata:(FB10V, HKL SORT CODE  RFOURR LINE                 )#          FB10  41
chardata:(FB10T, + )#                                                   FB10  42
chardata:(FB10U,[+&-])#                                                 FB10  43
chardata:(FB10X, SIGN PATTERN                                      )#   FB10  44
realdata:(FMTMH,[360413.,400413.,440413.])#                             FB10  45
realdata:(FMTSL,[360832.,440832.])#                                     FB10  46
realdata:(FMTID,[360413.,400413.,440413.,480413.])#                     FB10  47
datastuff:#                                                             FB10  48
#                                                                       FB10  49
#  SET DEFAULT PARAMETERS                                               FB10  50
#  ----------------------                                               FB10  51
#                                                                       FB10  52
TWOPI=6.2831853#                       Set twice pi                     FB10  53
NEGIND(1)=yes:; NEGIND(2)=yes:; NEGIND(3)=yes:# Assume -hkls            FB10  54
MAXINP=no:; SIGNIN=no:#                No maxhkl input line or signs    FB10  55
PRINTL=0;   THRESH=0.005;  FRAT=0.#    Suppress refl print              FB10  56
SORT=0; SORTOR=0; DIRSIG=no:#          Order unknown, no dir access     FB10  57
DSET=1;   NRBIN=0#                     Default to dataset 1             FB10  58
JFO=701; JFC=800; JA=801; JB=802#      Set default coeff idnums         FB10  59
JPHI=700;  KPHI=700;  SUCUT=25.#       Default phase values             FB10  60
DO I=1,3; MAXH(I)=999.#                Set default max hkl              FB10  61
STLL(1)=0.;   STLL(2)=2.#              Set default min/max stl          FB10  62
#                                                                       FB10  63
#   EXTRACT OPTIONS FROM RFOURR LINE                                    FB10  64
#   --------------------------------                                    FB10  65
#                                                                       FB10  66
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over input fields           FB10  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB10  68
stringlim:(K,I,J)#                     Find characters in input         FB10  69
compchar:(CHRIN,I,FB10B,1,2,4,NFB10B,J)# Search list of options         FB10  70
IF(J==0) iquit:(FB1001)#               It must be valid                 FB10  71
ELSE IF(J==1)#                         Data set is not 1                FB10  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB10  73
K=K+1; IF(BUFIN(K)<=voidflg:) iquit:(FB1002,K)#                         FB10  74
DSET=NINT(BUFIN(K))#                   Remember data set number         FB10  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB10  76
ELSE IF(J==2)#                         Test reflection print control    FB10  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB10  78
IF(BUFIN(K+1)>0.0)#                    Is print number supplied         FB10  79
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB10  80
K=K+1; PRINTL=NINT(BUFIN(K))#          Get print number                 FB10  81
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB10  82
ELSE PRINTL=99999#                     Set default print number         FB10  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB10  84
ELSE IF(J==3) DIRSIG=yes:#             Force use of direct access       FB10  85
IF(J>3&J<7)#                           Sign patterns specified?         FB10  86
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB10  87
SIGNIN=yes:#                           Signal signs entered             FB10  88
IF     (J==4) NEGIND(1)=no:#           No negative h indices            FB10  89
ELSE IF(J==5) NEGIND(2)=no:#           No negative k indices            FB10  90
ELSE IF(J==6) NEGIND(3)=no:#           No negative l indices            FB10  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB10  92
ELSE IF(J>6&J<13)#                     Sort information?                FB10  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FB10  94
IF     (J== 7) SORTOR=123#             Sort is h slow k med l fast      FB10  95
ELSE IF(J== 8) SORTOR=132#             Sort is h slow l med k fast      FB10  96
ELSE IF(J== 9) SORTOR=213#             Sort is k slow h med l fast      FB10  97
ELSE IF(J==10) SORTOR=231#             Sort is k slow l med h fast      FB10  98
ELSE IF(J==11) SORTOR=312#             Sort is l slow h med k fast      FB10  99
ELSE IF(J==12) SORTOR=321#             Sort is l slow k med h fast      FB10 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FB10 101
ELSE IF(J==13)#                        A & b threshold?                 FB10 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FB10 103
IF(BUFIN(K+1)>small:)#                 Is thresh sensible               FB10 104
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FB10 105
K=K+1;    THRESH=BUFIN(K)#             Store user threshold             FB10 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FB10 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FB10 108
ELSE IF(J==14)#                        Fc to fo threshold               FB10 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FB10 110
IF(BUFIN(K+1)>small:)#                 Is thresh sensible               FB10 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FB10 112
K=K+1;    FRAT=BUFIN(K)#               Store user threshold             FB10 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FB10 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FB10 115
ELSE IF(J==15)#                        Cutoff for correlation           FB10 116
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FB10 117
IF(BUFIN(K+1)>1.0)#                    Is thresh sensible               FB10 118
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FB10 119
K=K+1;  SUCUT =BUFIN(K)#               Store f obs cutoff               FB10 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FB10 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FB10 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB10 123
#                                                                       FB10 124
# TAKE IN ANY OTHER INPUT LINES                                         FB10 125
# -----------------------------                                         FB10 126
#                                                                       FB10 127
REPEAT#                                Loop over lines                  FB10 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FB10 129
readline:(FB10A,NFB10A)#               Enter next input line            FB10 130
IF(LINID==1) BREAK#                    Stop reading when end line       FB10 131
#                                                                       FB10 132
ELSE IF(LINID==2)#                     ********* maxhkl ***********     FB10 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FB10 134
IF(BUFIN(1)>0.0) MAXH(1)=BUFIN(1)#     Test and take max                FB10 135
IF(BUFIN(2)>0.0) MAXH(2)=BUFIN(2)#     Test and take max                FB10 136
IF(BUFIN(3)>0.0) MAXH(3)=BUFIN(3)#     Test and take max                FB10 137
IF(BUFIN(4)>0.0) STLL(1)=BUFIN(4)#     Test and take min                FB10 138
IF(BUFIN(5)>0.0) STLL(2)=BUFIN(5)+.001# Test and take max               FB10 139
MAXINP=yes:#                           Signal event                     FB10 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FB10 141
#                                                                       FB10 142
ELSE IF(LINID==3)#                     ********** coeff *************   FB10 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FB10 144
IF(BUFIN(1)>0.0) JFO =NINT(BUFIN(1))#  Extract fo idnum                 FB10 145
IF(BUFIN(2)>0.0) JFC =NINT(BUFIN(2))#  Extract fc idnum                 FB10 146
IF(BUFIN(3)>0.0) JA  =NINT(BUFIN(3))#  Extract a idnum                  FB10 147
IF(BUFIN(4)>0.0) JB  =NINT(BUFIN(4))#  Extract b idnum                  FB10 148
IF(BUFIN(5)>0.0) JPHI=NINT(BUFIN(5))#  Extract phi idnum                FB10 149
IF(BUFIN(6)>0.0) KPHI=NINT(BUFIN(6))#  Extract input phi idnum          FB10 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FB10 151
#                                                                       FB10 152
ELSE IF(LINID==4)#                     ********* dstat ************     FB10 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FB10 154
FOR(I=1;I<25;I=I+1)#                   Loop over fields                 FB10 155
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FB10 156
ifvo:(BUFIN(I)) BREAK#                 No more active fields            FB10 157
DSTAT(I)=BUFIN(I)#                     Store resolution value           FB10 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FB10 159
NRBIN=I#                               Store number of resol bins       FB10 160
DO I=2,NRBIN-1; IF(DSTAT(I-1)<=DSTAT(I)) iquit:(FB1008)# Incorrect      FB10 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FB10 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FB10 163
#                                                                       FB10 164
# SET UP I/O BUFFERS FOR THREE FILES                                    FB10 165
# ----------------------------------                                    FB10 166
#                                                                       FB10 167
IOMARK(1)=QXSTR#                       Set up input bdf buffer          FB10 168
IOMARK(2)=IOMARK(1)+bdfbuf:#           Set up output bdf buffer         FB10 169
IOMARK(3)=IOMARK(2)+bdfbuf:#           Set up electron density i/p      FB10 170
incrqx:(MARKG,IOMARK(3)+bdfbuf:,FB1005)# Pointer to 2nd sum coef        FB10 171
#                                                                       FB10 172
# READ THE BDF ON FILE A AND PUT AWAY CELL INFORMATION.                 FB10 173
# -----------------------------------------------------                 FB10 174
#                                                                       FB10 175
K=0#                                   Prepare to get needed cell i     FB10 176
REPEAT#                                Loop over lrcell packets         FB10 177
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FB10 178
K=K+1#                                 Count packets as they come i     FB10 179
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read in cell record              FB10 180
IF(IP<=0) BREAK#                       Exit after last record           FB10 181
IF(K==1)movereal:(QX,IP+1,CELLC,1,6,0)# Save real cell constants        FB10 182
ELSE IF(K==3)movereal:(QX,IP+1,RCELL,1,6,0)# Save recip cell const      FB10 183
ELSE IF(K==6)VOL=QX(IP+1)#             Save real cell volume            FB10 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FB10 185
#                                                                       FB10 186
# GET F(0,0,0) AND E(0,0,0) FROM LRSCAT:                                FB10 187
# ------------------------------------                                  FB10 188
#                                                                       FB10 189
E000=.01;  F000=0.#                    Set initial values               FB10 190
IWNT(1)=1;  IWNT(2)=4;   IWNT(3)=3#    Request natom & z value          FB10 191
FLG(1)=0; FLG(2)=3; FLG(3)=0; FLG(4)=0# Set search keys                 FB10 192
indexpkt:(1,lrscat:,PSIZ,IP,0,FLG,IWNT,IREL)# Search lrscat record      FB10 193
IF(IREL(2)==0) IREL(2)=IREL(3)#        Replace no. elects. with z &     FB10 194
IF(IREL(1)*IREL(2)>0)#                 Test if items present            FB10 195
REPEAT#                                Loop over lrscat records         FB10 196
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FB10 197
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Point to lrscat record           FB10 198
IF(IP<=0) BREAK#                       Exit after last pkt              FB10 199
I=IP+IREL(1);  J=IP+IREL(2)#           Point to natom ans z             FB10 200
F000=F000+QX(I)*QX(J)#                 Sum total electrons              FB10 201
E000=E000+QX(I)*QX(J)**2#              Sum total z**2                   FB10 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FB10 203
IF(E000>small:) E000=F000/SQRT(E000)#  Calc e(0,0,0)                    FB10 204
#                                                                       FB10 205
#   ENTER SCALE INFORMATION (LREXPL:)                                   FB10 206
#  ------------------------------                                       FB10 207
#                                                                       FB10 208
IWNT(1)=1;IWNT(2)=12;IWNT(4)=100#      Data set, sort & nscl idnums     FB10 209
IWNT(3)=36#                            Signals about + indices in bdf   FB10 210
FLG(1)=1;  FLG(2)=4;  FLG(3)=0#        Set search delimiters            FB10 211
FLG(4)=0#                              Set update mode                  FB10 212
indexpkt:(1,lrexpl:,PSIZ,IP,0,FLG,IWNT,IREL)# Get packet pointers       FB10 213
IF(FLG(4)<=0) iquit:(FB1004)#          Must have data set number        FB10 214
IF(IREL(2)<=0)#                        Is reflection sort there?        FB10 215
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FB10 216
SORT=SORTOR#                           Complain and try input           FB10 217
IF(SORT==0) iquit:(FB1006)#            We gotta know to do this job     FB10 218
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FB10 219
NSCL=1;   SCALE(1)=0.#                 Default group & rel pointer      FB10 220
FOR(I=IP+1;I<=IP+PSIZ;I=I+1)#          Loop over directory              FB10 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FB10 222
IF((QX(I)<100.9)\(QX(I)>164.1)) NEXT#  Skip if not scale idnm           FB10 223
J=NINT(QX(I))-100#                     Get group number of scale        FB10 224
SCALE(J)=FLOAT(I-IP)#                  Store relative position          FB10 225
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FB10 226
REPEAT#                                Loop over data sets              FB10 227
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FB10 228
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Get packet pointer               FB10 229
IF(IP<=0) BREAK#                       Exit after last packet           FB10 230
IF(IREL(2)>0)#                         Get sort order if there          FB10 231
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FB10 232
I=IP+IREL(2);SORT=NINT(QX(I))#         Save sort order                  FB10 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FB10 234
IF(IREL(3)>0)#                         Get index sign pattern if ther   FB10 235
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FB10 236
I=IP+IREL(3); J=NINT(QX(I))#           Pick up pattern                  FB10 237
IF(MOD(J,10)>0)       NEGIND(3)=no:#   No negative l indices            FB10 238
IF(MOD(J,100)/10>0)   NEGIND(2)=no:#   No negative k indices            FB10 239
IF(MOD(J,1000)/100>0) NEGIND(1)=no:#   No negative h indices            FB10 240
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FB10 241
I=IP+IREL(1)#                          Get index of data set no.        FB10 242
IF(DSET!=NINT(QX(I))) NEXT#            Skip unwanted idnum              FB10 243
I=IP+IREL(4); IF(I>IP) NSCL=MIN0(NINT(QX(I)),64)# Number of scales      FB10 244
DO I=1,NSCL#                           Loop over scale factors          FB10 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FB10 246
J=IP+NINT(SCALE(I))#                   Point to scale location          FB10 247
IF(J>IP) SCALE(I)=QX(J)#               Store scale in table             FB10 248
ELSE     SCALE(I)=1.#                  Default scale is 1.              FB10 249
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FB10 250
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FB10 251
#                                                                       FB10 252
#    ENTER MAXHKL INFORMATION (LRDSET:)                                 FB10 253
#   ---------------------------------                                   FB10 254
#                                                                       FB10 255
IF(MAXINP==no:)#                       If no user values                FB10 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FB10 257
IWNT(1)=1; IWNT(2)=11; IWNT(3)=12#     Set dset,maxh,maxk idnum         FB10 258
IWNT(4)=13; IWNT(5)=14; IWNT(6)=15#    Set maxl,mins,maxs idnum         FB10 259
IWNT(7)=71; IWNT(8)=73; IWNT(9)=75#    Min h,k,l for sort protection    FB10 260
FLG(1)=9; FLG(2)=0; FLG(3)=0; FLG(4)=0# Set search limits               FB10 261
indexpkt:(1,lrdset:,PSIZ,IP,0,FLG,IWNT,IREL)# Search directory          FB10 262
IF(FLG(4)>0)#                          If present extract limits        FB10 263
REPEAT#                                Loop over lrdset pkts            FB10 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FB10 265
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Point to next packet             FB10 266
IF(IP<=0) BREAK#                       Exit after last pkt              FB10 267
I=IP+IREL(1); IF(DSET!=NINT(QX(I))) NEXT# Skip wrong dataset            FB10 268
I=IP+IREL(2); MAXH(1)=QX(I)#           Extract max /h/                  FB10 269
I=IP+IREL(3); MAXH(2)=QX(I)#           Extract max /k/                  FB10 270
I=IP+IREL(4); MAXH(3)=QX(I)#           Extract max /l/                  FB10 271
I=IP+IREL(5); STLL(1)=QX(I)#           Extract min st/l                 FB10 272
I=IP+IREL(6); STLL(2)=QX(I)+.001#      Extract max st/l                 FB10 273
I=IP+IREL(7); MINH(1)=QX(I)#           Extract min  h                   FB10 274
I=IP+IREL(8); MINH(2)=QX(I)#           Extract min  k                   FB10 275
I=IP+IREL(9); MINH(3)=QX(I)#           Extract min  l                   FB10 276
IF(MINH(1)>=0.0) NEGIND(1)=no:#        No negative h indices            FB10 277
IF(MINH(2)>=0.0) NEGIND(2)=no:#        No negative k indices            FB10 278
IF(MINH(3)>=0.0) NEGIND(3)=no:#        No negative l indices            FB10 279
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FB10 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FB10 281
#                                                                       FB10 282
# SET UP THE OUTPUT BINARY DATA FILE FOR CALCULATED PHASES              FB10 283
# --------------------------------------------------------              FB10 284
#                                                                       FB10 285
rewindbdf:(1)#                         Go back to front of file a       FB10 286
copyfile:(1,2,1,decr:(lrrefl:))#       Copy the front part              FB10 287
#                                                                       FB10 288
# SET UP THE OFFSET POINTERS FOR PACKED HKL A AND B OR PHASE IN LRREFL: FB10 289
# --------------------------------------------------------------------- FB10 290
#                                                                       FB10 291
DSET=DSET*1000#                        Scale up data set number         FB10 292
IWNT(1)=1;   IWNT(2)=2#                Request hkl and sintheta/lam     FB10 293
IWNT(3)=DSET+JFO#                      Request input bdf coeff          FB10 294
IWNT(4)=DSET+304#                      Always request frel in case      FB10 295
IWNT(5)=DSET+JFC#                      Request fcal no disp             FB10 296
IWNT(6)=DSET+JA#                       Request sf a no disp             FB10 297
IWNT(7)=DSET+JB#                       Request sf b no disp             FB10 298
IWNT(8)=DSET+JPHI#                     Request sf phase                 FB10 299
IWNT(9)=DSET+KPHI#                     Request sf phase                 FB10 300
FLG(1)=2; FLG(2)=4; FLG(3)=9; FLG(4)=0# Set search flags                FB10 301
indexpkt:(1,lrrefl:,PSIZR,IP,2,FLG,IWNT,IREL)# Get id packet            FB10 302
IF(FLG(4)<=0) iquit:(FB1021)#          Hkl not there                    FB10 303
IHKL=IREL(1); ISTL=IREL(2)#            Keep the offsets                 FB10 304
IF(IREL(3)>0) IFO=IREL(3)#             Keep the offsets                 FB10 305
ELSE IF(IREL(4)>0)#                    Test if frel found               FB10 306
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FB10 307
JFO=304;  IFO=IREL(4)#                 Replace fobs/nodis with frel     FB10 308
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FB10 309
ELSE#                                  No coeff found for comparing     FB10 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FB10 311
JFO=0;    IFO=0#                       No input coeff                   FB10 312
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FB10 313
IFC=IREL(5); IA=IREL(6); IB=IREL(7)#   Keep the offsets                 FB10 314
IPHI=IREL(8); LPHI=IREL(9)#            Keep the offsets                 FB10 315
IF(IPHI>PSIZR) IPHIO=no:#              Old phase value not present      FB10 316
ELSE           IPHIO=yes:#             Old phase present                FB10 317
IF(LPHI>PSIZR) IPHIC=no:#              Compare phase value not presen   FB10 318
ELSE           IPHIC=yes:#             Compare phase present            FB10 319
PHOLD=FLG(4)#                          Save the packet size in comm     FB10 320
#                                                                       FB10 321
# RETRIEVE THE MAP PARAMETERS FROM LR 21 OF FILE C                      FB10 322
# ------------------------------------------------                      FB10 323
#                                                                       FB10 324
readwpkt:(3,21,PSIZ,IP,0)#             Read fourr map parameters        FB10 325
DO K=1,3#                              Loop over axes                   FB10 326
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FB10 327
IIP=IP+K#                                                               FB10 328
OG(K)=NINT(QX(IIP))#                   Pick up origins                  FB10 329
IN(K)=NINT(QX(IIP+3))#                 Increments along axes            FB10 330
NG(K)=NINT(QX(IIP+6))#                 No. of grid points               FB10 331
NP(K)=NINT(QX(IIP+9))#                 Calculated points                FB10 332
IF(OG(K)!=0\NP(K)!=NG(K)) iquit:(FB1048)# Must be mod1 unit cell        FB10 333
#                                                                       FB10 334
#----TO DESCRIBE PERMUTATIONS BETWEEN XTAL AXES AND COMPUTATIONAL AXES, FB10 335
#     TWO PERMUTATION VECTORS ARE DEFINED.       THE ISUM'S AND JSUM'S  FB10 336
#                                                                       FB10 337
#----THE ISUM'S GIVE COMPUTATIONAL VARIABLES CORRESPONDING TO THE XTAL  FB10 338
#     VARIABLES.  THE JSUM'S GIVE XTAL VARIABLES CORRESPONDING TO THE   FB10 339
#     COMPUTATIONAL VARIABLES.                                          FB10 340
#                                                                       FB10 341
#----THUS, FOR ALL POSSIBLE PERMUTATIONS                                FB10 342
#        LAYER  DOWN  ACROSS  ISUM1  ISUM2  ISUM3  JSUM1  JSUM2  JSUM3  FB10 343
#          X      Y     Z       1      2      3      1      2      3    FB10 344
#          X      Z     Y       1      3      2      1      3      2    FB10 345
#          Y      X     Z       2      1      3      2      1      3    FB10 346
#          Z      Y     X       3      2      1      3      2      1    FB10 347
#          Z      X     Y       2      3      1      3      1      2    FB10 348
#          Y      Z     X       3      1      2      2      3      1    FB10 349
#                                                                       FB10 350
#-----STORAGE OF FOURIER SUMMATION COEFFICIENTS                         FB10 351
#                                                                       FB10 352
# ALL TRANSFORMS ARE CARRIED OUT IN THE COMPLEX ARRAY 'W' DECLARED IN   FB10 353
# SUBROUTINE FB70.  AS EACH LINE OF THE ELECTRON DENSITY MAP IS READ IN FB10 354
# THE E-DS ARE MOVED TO THE W ARRAY AS THE REAL PART OF COMPLEX NUMBERS FB10 355
# ONCE MOVED THE ONE DIMENSIONAL FFT OF THE LINE IS MADE BY SUBROUTINE  FB10 356
# FB71 ET.SEQ. TO FORM SECOND SUMMATION COEFFICIENTS WHICH ARE STORED   FB10 357
# IN THE MARKG PORTION OF THE QX ARRAY AS PAIRED REAL-IMAGINARY NUMBERS FB10 358
# AFER ALL THE LINES OF A LAYER ARE THUS TRANSFORMED, THE THIRD         FB10 359
# SUMMATION COEFFICIENTS ARE FORMED AND PLACED IN THE MARKP REGION OF   FB10 360
# THE QX ARRAY, AGAIN AS 2 WORDS PER COEFFICIENT.   IF THERE IS NOT     FB10 361
# ENOUGH IMMEDIATE ACCESS STORAGE FOR THE WHOLE TRANSFORM THE THIRD     FB10 362
# SUM COEFFICIENTS ARE DUMPED TO A RANDOM ACCESS SCRATCH FILE.          FB10 363
# THE STORAGE LAYOUT FOR THE SECOND SUM COEFFICIENTS IN THE MARKG ARRAY FB10 364
# ARE:                                                                  FB10 365
#---------------------------------------------------------------------- FB10 366
#          /X1=CURRENT LAYER VALUE  /    EACH PACKET CONTAINS STEPG     FB10 367
# PACKET 1 /X2=0 TO X2 MAXIMUM      /    WORDS,  WHERE                  FB10 368
#          /H3=1                    /    STEPG=2*(NO. X2 POINTS)        FB10 369
#---------------------------------------------------------------------- FB10 370
#          /X1=CURRENT LAYER VALUE  /                                   FB10 371
# PACKET 2 /X2=0 TO X2 MAXIMUM      /                                   FB10 372
#          /H3=0                    /                                   FB10 373
#---------------------------------------------------------------------- FB10 374
#          / ......       ........  /                                   FB10 375
#          / ......       ........  /                                   FB10 376
#          / ......       ........  /                                   FB10 377
#---------------------------------------------------------------------- FB10 378
#          /X1=CURRENT LAYER VALUE  /                                   FB10 379
# PACKET N /X2=0 TO X2 MAXIMUM      /                                   FB10 380
#          /H3=NYQUIST FREQ OF H3   /                                   FB10 381
#---------------------------------------------------------------------- FB10 382
#                                                                       FB10 383
# IN THE CASE OF THE THIRD SUMMATION COEFFICIENTS THERE ARE PACKETS     FB10 384
# AND SUB PACKETS.  THE SUBPACKETS ARE STEPH=2*(NO. POINTS 3RD SUM)     FB10 385
# AND THE PACKETS, WHICH CONSTITUTE ALL THE COEFFICIENTS NEEDED FOR     FB10 386
# ONE LAYER IN RECIPROCAL SPACE, ARE STEPP=STEPH*(NO. 2ND SUM PTS).     FB10 387
# IF THERE IS SUFFICIENT MEMORY THEN (H3 MAX +1)*STEPP WILL BE HELD.    FB10 388
# IF NOT THEN EACH LAYER WILL BE STORED ON DIRECT ACCESS FILE ON        FB10 389
# FILE H.  THE ORDER OF STORAGE IS AS FOLLOWS:                          FB10 390
#                                                                       FB10 391
#---------------------------------------------------------------------- FB10 392
#          /X1=0 THRU X1 MAXIMUM    /                                   FB10 393
# PACKET 1 /H2=0                    / STEPH SUBPACKET 1                 FB10 394
#          /H3=0                    /                                   FB10 395
#---------------------------------------------------------------------- FB10 396
#          /X1=0 THRU X1 MAXIMUM    /                                   FB10 397
# PACKET 2 /H2=1                    / STEPH SUBPACKET 2                 FB10 398
#          /H3=0                    /                                   FB10 399
#---------------------------------------------------------------------- FB10 400
#          / ......        .......  /                                   FB10 401
#          / ......        .......  /                                   FB10 402
#---------------------------------------------------------------------- FB10 403
#          /X1=0 THRU X1 MAXIMUM    /                                   FB10 404
# PACKET N /H2=H2 MAXIMUM           / STEPH SUBPACKET N                 FB10 405
#          /H3=0                    /                                   FB10 406
#---------------------------------------------------------------------- FB10 407
#          / ......        .......  /                                   FB10 408
#          / ......        .......  /                                   FB10 409
#          / ......        .......  /                                   FB10 410
#          / ......        .......  /                                   FB10 411
#---------------------------------------------------------------------- FB10 412
#          /X1=0 THRU X1 MAXIMUM    /                                   FB10 413
# PACKET M /H2=H2 MAXIMUM           / STEPH SUBPACKET N*(NO. H3S)       FB10 414
#          /H3=NYQUIST FREQ OF H3   /                                   FB10 415
#---------------------------------------------------------------------- FB10 416
#                                                                       FB10 417
ISUM(K)=NINT(QX(IIP+12))#              Correlations between crystal     FB10 418
JSUM(K)=NINT(QX(IIP+15))#              Axes and calculation axes        FB10 419
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FB10 420
SORTP=JSUM(1)+10*JSUM(2)+100*JSUM(3)#  Combine fourr sort codes         FB10 421
#                                                                       FB10 422
# WRITE OUT A SUMMARY OF INSTRUCTIONS                                   FB10 423
# -----------------------------------                                   FB10 424
#                                                                       FB10 425
movechar:(FB10U,3,CHROT,2,NFB10L-1,1)# Underline header                 FB10 426
writeline:(1,FB10L,NFB10L,2,3)#        Write header                     FB10 427
ncodefld:(FLOAT(JFO),1,FB10C,360513.,1)# Format coeff idnum             FB10 428
writeline:(0,FB10C,NFB10C,3,3)#        Write coeff idnum                FB10 429
BUFOT(1)=JFC; BUFOT(2)=JA; BUFOT(3)=JB; BUFOT(4)=JPHI# Store idnums     FB10 430
ncodefld:(BUFOT,1,FB10O,FMTID,4)#      Format coeff idnum               FB10 431
writeline:(0,FB10O,NFB10O,3,3)#        Write coeff idnum                FB10 432
ncodefld:(FLOAT(DSET/1000),1,FB10M,360513.,1)# Format data set          FB10 433
writeline:(0,FB10M,NFB10M,3,3)#        Write data set                   FB10 434
ncodefld:(FLOAT(PRINTL),1,FB10N,360513.,1)# Format printed hkl          FB10 435
writeline:(0,FB10N,NFB10N,3,3)#        Print no. printed                FB10 436
ncodefld:(THRESH,1,FB10K,360842.,1)#   Format a & b threshold           FB10 437
writeline:(0,FB10K,NFB10K,3,3)#        Print a b threshold              FB10 438
ncodefld:(SUCUT,1,FB10R,360712.,1)#    Format fobs cutoff correln       FB10 439
writeline:(0,FB10R,NFB10R,3,3)#        Print fobs cutoff correln        FB10 440
ncodefld:(FRAT,1,FB10Q,360842.,1)#     Format fcal/fobs ratio           FB10 441
writeline:(0,FB10Q,NFB10Q,3,3)#        Print fcal/fobs ratio            FB10 442
ncodefld:(MAXH,1,FB10H,FMTMH,3)#       Format max hkl                   FB10 443
writeline:(0,FB10H,NFB10H,3,3)#        Print max hkl                    FB10 444
ncodefld:(STLL,1,FB10I,FMTSL,2)#       Format stl limits                FB10 445
writeline:(0,FB10I,NFB10I,3,3)#        Print stl limits                 FB10 446
IF(SIGNIN==yes:)#                      User specifies sign pattern      FB10 447
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 FB10 448
IF(NEGIND(1)==yes:) movechar:(FB10J,1,FB10P,34,3,0)#                    FB10 449
IF(NEGIND(2)==yes:) movechar:(FB10J,1,FB10P,36,3,0)#                    FB10 450
IF(NEGIND(3)==yes:) movechar:(FB10J,1,FB10P,38,3,0)#                    FB10 451
writeline:(0,FB10P,NFB10P,3,3)#                                         FB10 452
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 FB10 453
IF(SORTOR>0)#                          Is sort order input              FB10 454
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 FB10 455
ncodefld:(FLOAT(SORTOR),1,FB10V,360333.,1)# Format input sort order     FB10 456
writeline:(0,FB10V,NFB10V,3,3)#        Print input sort order           FB10 457
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 FB10 458
ncodefld:(FLOAT(SORT),1,FB10S,360333.,1)# Format sort from filea        FB10 459
writeline:(0,FB10S,NFB10S,3,3)#        Print filea sort order           FB10 460
ncodefld:(FLOAT(SORTP),1,FB10W,360333.,1)# Format sort from filec       FB10 461
writeline:(0,FB10W,NFB10W,3,3)#        Print filec sort order           FB10 462
I=SORT/100;J=MOD(SORT,100)/10;K=MOD(SORT,10)# Uncombine hkl sort code   FB10 463
movechar:(FB10E,I,FB10F,36,1,0)#       Change to correct axis           FB10 464
movechar:(FB10E,J,FB10F,40,1,0)#       Change to correct axis           FB10 465
movechar:(FB10E,K,FB10F,44,1,0)#       Change to correct axis           FB10 466
writeline:(0,FB10F,NFB10F,3,3)#        Print the sort hkl               FB10 467
IF(NEGIND(I)==yes:)#                   Program cannot cope if negativ   FB10 468
movechar:(FB10U,1,FB10X,35,NFB10U,0)#  Indices on slow sort axis        FB10 469
ELSE                movechar:(FB10T,1,FB10X,35,NFB10T,0)#               FB10 470
IF(NEGIND(J)==yes:) movechar:(FB10U,1,FB10X,39,NFB10U,0)#               FB10 471
ELSE                movechar:(FB10T,1,FB10X,39,NFB10T,0)#               FB10 472
IF(NEGIND(K)==yes:) movechar:(FB10U,1,FB10X,43,NFB10U,0)#               FB10 473
ELSE                movechar:(FB10T,1,FB10X,43,NFB10T,0)#               FB10 474
writeline:(0,FB10X,NFB10X,3,3)#        Tell about signs of hkls         FB10 475
movechar:(FB10D,JSUM(3),FB10G,36,1,0)# Change to correct axis           FB10 476
movechar:(FB10D,JSUM(2),FB10G,40,1,0)# Change to correct axis           FB10 477
movechar:(FB10D,JSUM(1),FB10G,44,1,0)# Change to correct axis           FB10 478
writeline:(0,FB10G,NFB10G,3,3)#                                         FB10 479
IF(NEGIND(I)==yes:)#                   Program cannot cope if negativ   FB10 480
iquit:(FB1003)#                        Might as well stop               FB10 481
IF(SORT!=SORTP) iquit:(FB1007)#        Orders on map & input diff       FB10 482
#                                                                       FB10 483
RETURN#                                                                 FB10 484
END#                                                                    FB10 485
systemheader:(FB15)#                                                    FB15   1
# ################################################################## #  FB15   2
#                                                                       FB15   3
#                               FB15                                 #  FB15   4
#                                                                    #  FB15   5
# ################################################################## #  FB15   6
SUBROUTINE FB15#                       D.r.holland                      FB15   7
include:(AACOMN)#                                                       FB15   8
include:(FBCOMN)#                                                       FB15   9
INTEGER I#                             Local index                      FB15  10
#                                                                       FB15  11
#  INITIALIZE STL2 BIN STATISTICS                                       FB15  12
#  -------------------------------                                      FB15  13
#                                                                       FB15  14
IF(NRBIN==1)#                          Resol requested but no values    FB15  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB15  16
SPACE(1)=0.1*(STLL(2)**2)#             Get st**2 incr as stmax**2/10    FB15  17
DO I=2,10; SPACE(I)=SPACE(I-1)+SPACE(1)# Generate st**2 bin limits      FB15  18
SPACE(11)=SPACE(10)#                   Starting st**2 bin               FB15  19
NBIN=11#                               Default 6 stol bins              FB15  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB15  21
ELSE#                                  User-defined stol bins           FB15  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB15  23
DO I=1,NRBIN-1; SPACE(I)=0.25/DSTAT(I)**2#                              FB15  24
NBIN=NRBIN#                            Allow for added infinity bin     FB15  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB15  26
IDF1=NBIN#                             Index for phase diff from old    FB15  27
IDF2=NBIN*2#                           Index for phase diff from calc   FB15  28
ISM1=NBIN*3#                           Index for new phase sum          FB15  29
ISM2=NBIN*4#                           Index for old phase sum          FB15  30
ISM3=NBIN*5#                           Index for calc phase sum         FB15  31
DO I=1,NBIN*6; STATS(I)=0.0#           Reset stats bins                 FB15  32
#                                                                       FB15  33
RETURN#                                                                 FB15  34
END#                                                                    FB15  35
systemheader:(FB20)#                   Accumulate statistics for bins   FB20   1
#################################################################### #  FB20   2
#                                                                    #  FB20   3
#                               FB20                                 #  FB20   4
#                                                                    #  FB20   5
#################################################################### #  FB20   6
SUBROUTINE FB20(OLDPHA,NEWPHA,CALPHA,STL2)# D.r.holland 87              FB20   7
include:(AACOMN)##                                                      FB20   8
include:(FBCOMN)#                                                       FB20   9
INTEGER I#                             Local index                      FB20  10
REAL STL2,DIFF#                                                         FB20  11
REAL OLDPHA,NEWPHA,CALPHA#                                              FB20  12
#                                                                       FB20  13
ifnv:(NEWPHA)#                         New phase must be determined     FB20  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB20  15
FOR(I=1;I<NBIN;I=I+1)#                 Loop over storage bins           FB20  16
IF(STL2<SPACE(I)) BREAK#               In the correct stol bin          FB20  17
#                                                                       FB20  18
STATS(I)        =STATS(I)   +1.0#      Count of refls in bin            FB20  19
STATS(NBIN)     =STATS(NBIN)+1.0#      Total refls processed            FB20  20
STATS(ISM2+I)   =STATS(ISM2+I)   +NEWPHA# Accumulate phase values       FB20  21
STATS(ISM2+NBIN)=STATS(ISM2+NBIN)+NEWPHA# Total                         FB20  22
#                                                                       FB20  23
ifnv:(OLDPHA)#                         Is old phase available           FB20  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB20  25
DIFF=ABS(OLDPHA-NEWPHA)#               Get change in phase              FB20  26
IF(DIFF>0.5) DIFF=1.-DIFF#             Get min phase diff               FB20  27
STATS(IDF1+I)   =STATS(IDF1+I)   +DIFF# Accumulate differences          FB20  28
STATS(IDF1+NBIN)=STATS(IDF1+NBIN)+DIFF# Total                           FB20  29
STATS(ISM1+I)   =STATS(ISM1+I)   +OLDPHA# Accumulate phase values       FB20  30
STATS(ISM1+NBIN)=STATS(ISM1+NBIN)+OLDPHA# Total                         FB20  31
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB20  32
#                                                                       FB20  33
ifnv:(CALPHA)$#                        Is cal phase available           FB20  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB20  35
DIFF=ABS(CALPHA-NEWPHA)#               Get change in phase              FB20  36
IF(DIFF>0.5) DIFF=1.-DIFF#             Get min phase diff               FB20  37
STATS(IDF2+I)   =STATS(IDF2+I)+   DIFF# Accumulate differences          FB20  38
STATS(IDF2+NBIN)=STATS(IDF2+NBIN)+DIFF# Total                           FB20  39
STATS(ISM3+I)   =STATS(ISM3+I)   +CALPHA# Accumulate differences        FB20  40
STATS(ISM3+NBIN)=STATS(ISM3+NBIN)+CALPHA# Total                         FB20  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB20  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB20  43
#                                                                       FB20  44
RETURN#                                                                 FB20  45
END#                                                                    FB20  46
systemheader:(FB25)#                   Print phase statisics            FB25   1
# ################################################################## #  FB25   2
#                                                                    #  FB25   3
#                               FB25                                 #  FB25   4
#                                                                    #  FB25   5
# ################################################################## #  FB25   6
SUBROUTINE FB25#                       D.b. holland 1987                FB25   7
include:(AACOMN)#                                                       FB25   8
include:(FBCOMN)#                                                       FB25   9
#                                                                       FB25  10
INTEGER I,J#                                                            FB25  11
REAL BINCNT#                                                            FB25  12
chardata:(FB251,[     D-RESOLUTION      COUNT  <PHIN-PHIO>$#            FB25  13
 <PHIN-PHIC> <PHIN>    <PHIO>    <PHIC>])#                              FB25  14
chardata:(FB252, INFINITY TO )#                                         FB25  15
chardata:(FB253, PHIO IS THE OLD INPUT  PHASE WITH IDNUM     )#         FB25  16
chardata:(FB254, PHIC IS THE CAL INPUT  PHASE WITH IDNUM     )#         FB25  17
chardata:(FB255, PHIN IS THE NEW OUTPUT PHASE WITH IDNUM     )#         FB25  18
realdata:(FMT8,[090832.,190732.,270613.,381022.,501022.,601022.,$#      FB25  19
701022.,801022.])#                                                      FB25  20
datastuff:#                                                             FB25  21
#                                                                       FB25  22
writeline:(0,0,0,1,3); LINRM=10#       Force space for header           FB25  23
DO I=1,NBIN#                                                            FB25  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB25  25
DO J=4,8; BUFOT(J)=voidflg:#           Reset op buffer                  FB25  26
BINCNT=STATS(I)/360.#                  Number refls in current bin      FB25  27
BUFOT(3)=STATS(I)#                     Get reflns per bin               FB25  28
ifne:(BINCNT,0.)#                      Avoid zero divide                FB25  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB25  30
IF(IPHIO==yes:) BUFOT(4)=STATS(I+IDF1)/BINCNT# Average(oldpha-newpha)   FB25  31
IF(IPHIC==yes:) BUFOT(5)=STATS(I+IDF2)/BINCNT# Average(calpha-newpha)   FB25  32
BUFOT(6)=STATS(I+ISM2)/BINCNT#         Sum(newpha)                      FB25  33
IF(IPHIO==yes:) BUFOT(7)=STATS(I+ISM1)/BINCNT# Sum(oldpha)              FB25  34
IF(IPHIC==yes:) BUFOT(8)=STATS(I+ISM3)/BINCNT# Sum(calpha)              FB25  35
DO J=4,8; ifnv:(BUFOT(J)) ncodefld:(BUFOT,J,CHROT,FMT8(J),1)#           FB25  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB25  37
#                                                                       FB25  38
movechar:(FB252,1,CHROT,1,NFB252,0)#   Insert 'to'                      FB25  39
IF(I>1&I<NBIN)#                        All except first & last bins     FB25  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB25  41
BUFOT(1)=0.5/SQRT(SPACE(I-1))#                                          FB25  42
BUFOT(2)=0.5/SQRT(SPACE(I))#                                            FB25  43
ncodefld:(BUFOT,1,CHROT,FMT8,3)#                                        FB25  44
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB25  45
ELSE#                                  First & last bins                FB25  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB25  47
IF(I==1) BUFOT(2)=0.5/SQRT(SPACE(1))#                                   FB25  48
ELSE     BUFOT(2)=0.5/SQRT(SPACE(NBIN))#                                FB25  49
ncodefld:(BUFOT,2,CHROT,FMT8(2),2)#                                     FB25  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB25  51
writeline:(0,FB251,NFB251,1,3)#                                         FB25  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB25  53
#                                                                       FB25  54
ncodefld:(FLOAT(DSET+JPHI),1,FB255,450443.,1)#                          FB25  55
writeline:(1,FB255,NFB255,3,3)#        Footnotes to stats table         FB25  56
ncodefld:(FLOAT(DSET+JPHI),1,FB253,450443.,1)#                          FB25  57
IF(IPHIO>0)writeline:(0,FB253,NFB253,3,3)# Footnotes to stats table     FB25  58
ncodefld:(FLOAT(DSET+KPHI),1,FB254,450443.,1)#                          FB25  59
IF(IPHIC>0)writeline:(0,FB254,NFB254,3,3)# Footnotes to stats table     FB25  60
#                                                                       FB25  61
RETURN#                                                                 FB25  62
END#                                                                    FB25  63
systemheader:(FB70)#                   Fft reverse transform            FB70   1
# ################################################################## #  FB70   2
#                                                                    #  FB70   3
#                               FB70                                 #  FB70   4
#                                                                    #  FB70   5
# ################################################################## #  FB70   6
SUBROUTINE FB70#                       J.m.stewart d.m.collins mar 87   FB70   7
include:(AACOMN)#                      S.r.hall jan1988                 FB70   8
include:(FBCOMN)#                                                       FB70   9
#                                                                       FB70  10
# THIS ROUTINE CALCULATES A REVERSE (DIRECT SPACE TO RECIPROCAL SPACE)  FB70  11
# FOURIER TRANSFORM USING THE WFFT CODE OF WINOGRAD.                    FB70  12
#                                                                       FB70  13
REAL A,B,NEWPHA## Real and imaginary parts of Fc, phase in cycles       FB70  14
REAL OLDPHA,CALPHA## existing phase and compare phase                   FB70  15
REAL CNT(5)## Count of reflections total and used                       FB70  16
REAL DENLIM(3)## El-dens statistics                                     FB70  17
INTEGER DIRACC## Direct access in action flag                           FB70  18
REAL FMT## Word for creating formats                                    FB70  19
INTEGER FILIN1,FILIN2,FILIN3## Miller indices from input bdf packets    FB70  20
INTEGER FIRST,LAST## First and last words of a direct access buffer     FB70  21
REAL OBS,CAL## Observed and calculated structure facts                  FB70  22
INTEGER GENIN1,GENIN2,GENIN3## Miller indices from generation loops     FB70  23
INTEGER GETG,GETPN,GETPP## Coefficient storage pointers                 FB70  24
REAL HKL(3)## Miller indices from bdf straight                          FB70  25
INTEGER J,K,L,N## Local indices for loops etc.                          FB70  26
INTEGER INPROS## Signal for reflection in process                       FB70  27
INTEGER NDIV1,NDIV2,NDIV3## Division pointers for use by fft            FB70  28
INTEGER NEGH2P## Signal negative sec sum indices in bdf                 FB70  29
INTEGER NH1,NH2,NH3## No. of indices in each direction 0,+&-            FB70  30
INTEGER NREADS## Number of direct access reads to get in a layer        FB70  31
INTEGER NX1,NX2,NX3## No. of points in each direction                   FB70  32
INTEGER NYQF1,NYQF2,NYQF3## Nyquist frequencies in the 3 directions     FB70  33
INTEGER NYQF3P## Third nyquist frequency plus one                       FB70  34
INTEGER PRINTP## Reflection dumping control                             FB70  35
INTEGER PSIZ,IP,JP## I/o pointers                                       FB70  36
INTEGER PUTG,PUTP## Coefficient storage pointers                        FB70  37
INTEGER RECRD## Direct access unit record pointer                       FB70  38
INTEGER RSUM1,RSUM2,RSUM3## Permutation of axes numbers                 FB70  39
REAL SCAPTS## Scale factor for el-dens to F (vol/total pts)             FB70  40
INTEGER STEPG,STEPP,STEPGP,STEPH## Stepping sizes for 2nd and 3rd su    FB70  41
INTEGER STOPP## End of third sum coeff storage                          FB70  42
INTEGER I,IE,JJ#                                                        FB70  43
REAL Q,STL,STL2#                                                        FB70  44
REAL SUMDF,SUMFO## Sums for r value                                     FB70  45
REAL SUFC,SUFC2,SUFO,SUFOFC,SUFO2,SUREF## Sums for correlation          FB70  46
REAL SUTEST## Test for contributor                                      FB70  47
COMPLEX W(1681),WP(1681)## Complex 1 dim arrays for transforms          FB70  48
INTEGER X1,X2## Layer, down the layer, across the layer                 FB70  49
#                                                                       FB70  50
chardata:(FB7A, ONE OR MORE SUMMATION DIRECTIONS ARE NOT IN $#          FB70  51
GRID DIVISIONS HANDLED BY FFT SUBROUTINES.)#                            FB70  52
chardata:(FB7B,[ GIVEN     ,     , AND     .   ACCEPTABLE.......])#     FB70  53
chardata:(FB7C,REFLECTION OUTSIDE MAP RESOLUTION)#                      FB70  54
chardata:(FB7D,A OR B BELOW THRESHOLD -- UNPHASED)#                     FB70  55
chardata:(FB7E, MAP CELL VOLUME                         )#              FB70  56
chardata:(FB7F, TOTAL POINTS IN MAP                     )#              FB70  57
chardata:(FB7G,   H    K    L     OBS       CAL     PHIN      $#        FB70  58
A       B)#                                                             FB70  59
chardata:(FB7H,OUTSIDE OF MAX HKL OR STL LIMITS)#                       FB70  60
chardata:(FB7J, SUMMATION SUMMARY)#                                     FB70  61
chardata:(FB7K, ORDER   NO. OF POINTS  NYQUIST FREQ  CRYSTAL AXIS)#     FB70  62
chardata:(FB7L,FAST  MEDIUMSLOW  )#                                     FB70  63
chardata:(FB7M,ABC)#                                                    FB70  64
chardata:(FB7N, PSEUDO-R VALUE FOR SUM(OBS-CAL)/SUM(OBS)=        )#     FB70  65
chardata:(FB7O, REFLECTIONS INPUT                                  )#   FB70  66
chardata:(FB7P, ELECTRON DENSITY SCALE                   )#             FB70  67
chardata:(FB7Q, ELECTRON DENSITY MAX/MIN/MEAN                     $#    FB70  68
                 )#                                                     FB70  69
chardata:(FB7R, REFLECTIONS PHASED                                 )#   FB70  70
chardata:(FB7S,[ INSUFFICIENT MEMORY - SCRATCH FILE USED ])#            FB70  71
chardata:(FB7SS,[ MAXIMUM MEMORY available:            MEMORY $#        FB70  72
requested:                     ])#                                      FB70  73
chardata:(FB7T,[ REFLECTIONS REJECTED - MAP RESOLUTION              ])# FB70  74
chardata:(FB7U,[ REFLECTIONS REJECTED - HKL, STL LIMIT              ])# FB70  75
chardata:(FB7V,[ REFLECTIONS REJECTED - A, B THRESHOLD              ])# FB70  76
chardata:(FB7W,FCAL LESS THAN FOBS*FACTOR)#                             FB70  77
chardata:(FB7X,[ REFLECTIONS REJECTED - FC < FO*FACTOR              ])# FB70  78
chardata:(FB7Y,[ CORRELATION COEFFICIENT OF           UNPHASED $#       FB70  79
REFLECTIONS         ])#                                                 FB70  80
chardata:(FB7Z,[        UNPHASED REFLECTIONS WITH FOBS >            ])# FB70  81
#                                                                       FB70  82
#------  ALLOWED VALUES OF NX IN FOURIER GRIDS                          FB70  83
#        (RANGE FROM 2 TO 5040) ONLY MXGRID IMPLEMENTED                 FB70  84
intdata:(ND,[$#                                                         FB70  85
 2,   3,   4,   5,   6,   7,   8,   9,#                                 FB70  86
10,  12,  14,  15,  16,  18,  20,  21,#                                 FB70  87
24,  28,  30,  35,  36,  40,  42,  45,#                                 FB70  88
48,  56,  60,  63,  70,  72,  80,  84,#                                 FB70  89
90, 105, 112, 120, 126, 140, 144, 168,#                                 FB70  90
180, 210, 240, 252, 280, 315, 336, 360,#                                FB70  91
420, 504, 560, 630, 720, 840,1008,1260,#                                FB70  92
1680,2520,5040])#                                                       FB70  93
intdata:(MXGRID,[57])#                                                  FB70  94
realdata:(FMNX,[110413.,170413.,270413.])#                              FB70  95
realdata:(FMTHKL,[40413.,90413.,140413.,220822.])#                      FB70  96
realdata:(FMTFC,[320822.,410413.,490822.,570822.])#                     FB70  97
realdata:(FMTRP,[200513.,330513.])#                                     FB70  98
realdata:(FMTST,[400832.,480832.,560832.])#                             FB70  99
realdata:(FMTDA,[371003.,651003.])#                                     FB70 100
realdata:(FMTCR,[70613.,480712.])#                                      FB70 101
datastuff:#                                                             FB70 102
#                                                                       FB70 103
# INITIALIZE COUNTS, NUMBERS OF POINTS IN SUMMATIONS AND PRINT OUT      FB70 104
# ----------------------------------------------------------------      FB70 105
#                                                                       FB70 106
INPROS=no:#                            No reflections in process        FB70 107
DO I=1,5; CNT(I)=0.0#                  Zero reflection counts           FB70 108
SUMFO=0.0; SUMDF=0.0#                  R value calculation              FB70 109
# ZERO SUMS FOR CALCULATION OF CORRELATION COEFFICIENT FOR FO WITH      FB70 110
# FC OF THOSE REFLECTIONS IN THE INPUT FILE WHICH HAVE NOT PREVIOUSLY   FB70 111
# BEEN PHASED.                                                          FB70 112
SUFOFC=0.0 ; SUFC=0.0 ; SUFC2=0.0 ; SUFO=0.0 ; SUFO2=0.0 ; SUREF=0.0#   FB70 113
DENLIM(1)=-99999.; DENLIM(2)=99999.; DENLIM(3)=0.0# El-den stats        FB70 114
RSUM1=JSUM(1);RSUM2=JSUM(2);RSUM3=JSUM(3)# Set permutation order        FB70 115
NEGH2P=yes:#                           Assume some negative h2s         FB70 116
IF(NEGIND(RSUM2)==no:)NEGH2P=no:#      Negative h2 indices in bdf       FB70 117
NX1=NG(1);NX2=NG(2);NX3=NG(3)#         Get points in 3 directions       FB70 118
NH1=NX1;NH2=NX2;NH3=NX3#               Also set indices for clarity     FB70 119
NYQF1=(NH1-1)/2; NYQF2=(NH2-1)/2; NYQF3=(NH3-1)/2# Set nyquist freq     FB70 120
NDIV1=0;NDIV2=0;NDIV3=0#               Set grid size pointers           FB70 121
#                                                                       FB70 122
#  PRINT SUMMATION SUMMARY                                              FB70 123
#  -----------------------                                              FB70 124
#                                                                       FB70 125
LINRM=6; movechar:(FB7N,8,CHROT,2,NFB7J-1,1)# Underline header          FB70 126
writeline:(1,FB7J,NFB7J,2,3)#          Print summary header             FB70 127
writeline:(0,FB7K,NFB7K,3,3)#          Print order header               FB70 128
BUFOT(1)=FLOAT(NX3); BUFOT(2)=FLOAT(NYQF3)#                             FB70 129
ncodefld:(BUFOT,1,CHROT,FMTRP,2)#                                       FB70 130
movechar:(FB7L,1,CHROT,2,6,0); J=ISUM(3)#                               FB70 131
movechar:(FB7M,J,CHROT,45,1,0)#        Insert axis                      FB70 132
writeline:(0,0,0,1,3)#                                                  FB70 133
BUFOT(1)=FLOAT(NX2); BUFOT(2)=FLOAT(NYQF2)#                             FB70 134
ncodefld:(BUFOT,1,CHROT,FMTRP,2)#                                       FB70 135
movechar:(FB7L,7,CHROT,2,6,0); J=ISUM(2)#                               FB70 136
movechar:(FB7M,J,CHROT,45,1,0)#        Insert axis                      FB70 137
writeline:(0,0,0,1,3)#                                                  FB70 138
BUFOT(1)=FLOAT(NX1); BUFOT(2)=FLOAT(NYQF1)#                             FB70 139
ncodefld:(BUFOT,1,CHROT,FMTRP,2)#                                       FB70 140
movechar:(FB7L,13,CHROT,2,6,0); J=ISUM(1)#                              FB70 141
movechar:(FB7M,J,CHROT,45,1,0)#        Insert axis                      FB70 142
writeline:(0,0,0,1,3)#                                                  FB70 143
#                                                                       FB70 144
# MAKE SURE GRID SIZES ARE POSSIBLE TO DO                               FB70 145
# ---------------------------------------                               FB70 146
#                                                                       FB70 147
DO J=1,MXGRID#                         Loop over possible grids         FB70 148
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB70 149
IF(NX1==ND(J)) NDIV1=J#                Set layer divisions              FB70 150
IF(NX2==ND(J)) NDIV2=J#                Set down layer divisions         FB70 151
IF(NX3==ND(J)) NDIV3=J#                Set across layer divisions       FB70 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB70 153
IF((NDIV1==0)\(NDIV2==0)\(NDIV3==0))#  Test that all o.k.               FB70 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB70 155
BUFOT(1)=FLOAT(NX1);BUFOT(2)=FLOAT(NX2);BUFOT(3)=FLOAT(NX3)#            FB70 156
writeline:(1,FB7A,NFB7A,3,1)#                                           FB70 157
ncodefld:(BUFOT,1,FB7B,FMNX,3)#                                         FB70 158
writeline:(0,FB7B,NFB7B,3,1)#                                           FB70 159
K=0; FOR(J=1;J<=4;J=J+1)#              Dump all possible grids          FB70 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB70 161
IF(J<4) N=15#                          15 items per line for three li   FB70 162
ELSE N=14#                             14 on the last                   FB70 163
FMT=413.#                              Start building the format        FB70 164
DO L=1,N#                                                               FB70 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB70 166
K=K+1; FMT=FMT+50000.; BUFOT(1)=FLOAT(ND(K))#                           FB70 167
ncodefld:(BUFOT,1,CHROT,FMT,1)#                                         FB70 168
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB70 169
writeline:(0,0,0,1,1)#                                                  FB70 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB70 171
iquit:(FB7001)#                        Impossible grid for fft          FB70 172
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB70 173
#                                                                       FB70 174
# REPORT OUT ELECTRON DENSITY SCALE FACTOR                              FB70 175
# ----------------------------------------                              FB70 176
#                                                                       FB70 177
SCAPTS=AMAX1(VOL,1.0)/FLOAT(NX1*NX2*NX3)# Point compensation scale      FB70 178
ncodefld:(VOL,1,FB7E,400812.,1)#       Format cell volume               FB70 179
writeline:(1,FB7E,NFB7E,3,3)#          Print value                      FB70 180
ncodefld:(FLOAT(NX1*NX2*NX3),1,FB7F,401013.,1)# Format density values   FB70 181
writeline:(0,FB7F,NFB7F,3,3)#          Print value                      FB70 182
ncodefld:(SCAPTS,1,FB7P,400842.,1)#    Format density scale             FB70 183
writeline:(0,FB7P,NFB7P,3,3)#                                           FB70 184
#                                                                       FB70 185
# GET STORAGE AND SET UP DIRECT ACCESS FILES                            FB70 186
# ------------------------------------------                            FB70 187
#                                                                       FB70 188
STEPG=2*NX2;  STEPH=2*NX1#             Set up array steps               FB70 189
STEPGP=0;     STEPP=2*NX1*NH2#         For third sum with direct acce   FB70 190
NYQF3P=NYQF3+1#                        Incr positive h3 count           FB70 191
incrqx:(MARKP,MARKG+NYQF3P*STEPG,FB7002)# Memory sec sum coefs          FB70 192
STOPP=MARKP+NYQF3P*STEPP#              Get storage for third sum coef   FB70 193
IF(STOPP<=QXMAX) qxmemory:(STOPP)#     Will it all go in memory?        FB70 194
ELSE#                                  Direct access file needed        FB70 195
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB70 196
DIRACC=yes:#                           Have to use direct access file   FB70 197
BUFOT(1)=QXMAX ; BUFOT(2)=STOPP#       Store memory allocations         FB70 198
STOPP=MARKP+STEPP#                     Memory pointer for one layer     FB70 199
IF(STOPP<=QXMAX) qxmemory:(STOPP)#     Request memory for one layer     FB70 200
ELSE  iquit:(FB7003.)#                 Test if completely out of memo   FB70 201
ncodefld:(BUFOT,1,FB7SS,FMTDA,2)#      Encode memory problem            FB70 202
writeline:(1,FB7SS,NFB7SS,3,3)#        Report facts                     FB70 203
writeline:(0,FB7S,NFB7S,3,3)#          Explain use of random file       FB70 204
iquit:(-FB7005.)#                      Tell user how to inrease mem     FB70 205
NREADS=(STEPP-1)/dirbuf:+1#            No. of reads per layer           FB70 206
opendac:(ioda1:,3,arith:(dirbuf:,*,mxchwd:),' ')# Open direct access    FB70 207
RECRD=0#                               Direct access record pointer     FB70 208
DO I=1,NYQF3P#                         Loop over all layers             FB70 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FB70 210
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   FB70 211
DO K=1,NREADS#                         Loop over no. of buffers         FB70 212
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FB70 213
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     FB70 214
RECRD=RECRD+1 ; writedac:(ioda1:,,RECRD,(QX(JJ),JJ=FIRST,LAST))#        FB70 215
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FB70 216
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FB70 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB70 218
#                                                                       FB70 219
# LOOP OVER POINTS TO PRODUCE A HEMISPHERE                              FB70 220
# ----------------------------------------                              FB70 221
#                                                                       FB70 222
DO X1=0,NX1-1#                         Loop over layers in cell         FB70 223
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FB70 224
PUTP=MARKP+2*X1;   GETG=MARKG#         Set storage position             FB70 225
#                                                                       FB70 226
DO X2=0,NX2-1#                         Loop over lines in layer         FB70 227
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FB70 228
PUTG=MARKG+2*X2#                       Set pointer to sec sum array     FB70 229
readwpkt:(3,22,PSIZ,IP,0)#             Read next line                   FB70 230
IF(IP<=0) BREAK#                       Quit if all layers done          FB70 231
#                                                                       FB70 232
DO J=1,NX3#                            Loop over points in line         FB70 233
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FB70 234
Q=QX(IP+J)#                            Get each value                   FB70 235
DENLIM(1)=AMAX1(Q,DENLIM(1))#          Get maximum value                FB70 236
DENLIM(2)=AMIN1(Q,DENLIM(2))#          Get minimum value                FB70 237
DENLIM(3)=DENLIM(3)+Q#                 Build statistics                 FB70 238
W(J)=CMPLX(Q*SCAPTS)#                  Scale and load el-dens           FB70 239
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FB70 240
CALL FB71(W,NX3,1,NDIV3)#              Fft the line                     FB70 241
#                                                                       FB70 242
# FOURIER TRANSFORM EACH LINE TO PUT SECOND SUM COEFFICIENT IN STORE    FB70 243
# -------------------------------------------------------------------   FB70 244
#                                                                       FB70 245
DO J=1,NYQF3P#                         Loop over all positive h3        FB70 246
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FB70 247
QX(PUTG+1)=REAL(W(J))#                 Save the real component          FB70 248
QX(PUTG+2)=AIMAG(W(J))#                Save the imaginary component     FB70 249
PUTG=PUTG+STEPG#                       Set offset based on h3           FB70 250
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FB70 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FB70 252
#                                                                       FB70 253
# TRANSFORM THE LAYER INTO THIRD SUM COEFFICIENTS                       FB70 254
# -----------------------------------------------                       FB70 255
#                                                                       FB70 256
DO J=1,NYQF3P#                         Loop over all positive h3        FB70 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FB70 258
IF(DIRACC==yes:)#                      If direct access file used       FB70 259
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FB70 260
RECRD=(J-1)*NREADS#                    Direct access record pointer     FB70 261
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   FB70 262
DO K=1,NREADS#                         Loop over no. of buffers         FB70 263
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FB70 264
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     FB70 265
RECRD=RECRD+1 ; readdac:(ioda1:,,RECRD,(QX(JJ),JJ=FIRST,LAST))#         FB70 266
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FB70 267
PUTP=MARKP+2*X1#                       Reset output pointer             FB70 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FB70 269
DO K=1,NX2#                            For all second sum points        FB70 270
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FB70 271
W(K)=CMPLX(QX(GETG+1),QX(GETG+2))#     Fetch back complex coefficient   FB70 272
GETG=GETG+2#                           Step through coefficients        FB70 273
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FB70 274
CALL FB71(W,NX2,1,NDIV2)#              Transform one line at a time     FB70 275
#                                                                       FB70 276
# FOURIER TRANSFORM SEC SUM COEFFICIENTS INTO THIRD SUM COEFFICIENTS    FB70 277
# ------------------------------------------------------------------    FB70 278
#                                                                       FB70 279
DO K=1,NH2#                            Loop over all h2                 FB70 280
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FB70 281
QX(PUTP+1)=REAL(W(K))#                 Save real component third sum    FB70 282
QX(PUTP+2)=AIMAG(W(K))#                Save imaginary as well           FB70 283
PUTP=PUTP+STEPH#                                                        FB70 284
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FB70 285
IF(DIRACC==yes:)#                      Must direct access be used       FB70 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FB70 287
RECRD=(J-1)*NREADS#                    Direct access record pointer     FB70 288
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   FB70 289
DO K=1,NREADS#                         Loop over no. of buffers         FB70 290
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FB70 291
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     FB70 292
RECRD=RECRD+1 ; writedac:(ioda1:,,RECRD,(QX(JJ),JJ=FIRST,LAST))#        FB70 293
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FB70 294
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FB70 295
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FB70 296
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FB70 297
#                                                                       FB70 298
# AT THE END OF READING THE WHOLE MAP GIVE EL-DENS STATS                FB70 299
# ------------------------------------------------------                FB70 300
#                                                                       FB70 301
DENLIM(3)=DENLIM(3)/FLOAT(NX1*NX2*NX3)# Find ave el-dens                FB70 302
ncodefld:(DENLIM,1,FB7Q,FMTST,3)#      Format density values            FB70 303
writeline:(1,FB7Q,NFB7Q,2,3)#          Print density values             FB70 304
OBS=0.; CAL=0.#                        Default values                   FB70 305
GENIN3=9999; GENIN2=9999#              Falsify current indices          FB70 306
PRINTP=PRINTL; LINRM=6#                Set reflns/layer to dump         FB70 307
OLDPHA=voidflg:; CALPHA=voidflg:#      Set default phase values         FB70 308
#                                                                       FB70 309
# DO THE THIRD SUMS TO PRODUCE A, B, FC, AND PHASE                      FB70 310
# ------------------------------------------------                      FB70 311
#                                                                       FB70 312
REPEAT#                                Spool across reflns in bdf       FB70 313
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FB70 314
readwpkt:(1,lrrefl:,PSIZR,IP,0)#       Read next reflection             FB70 315
IF(IP<=0) BREAK#                       When record ends, get out.       FB70 316
writepkt:(2,lrrefl:,PHOLD,JP)#         Output packet for fc             FB70 317
movereal:(QX,IP+1,QX,JP+1,PSIZR,0)#    Copy old stuff across            FB70 318
IE=0;   CNT(1)=CNT(1)+1.0#             Total reflections in file        FB70 319
#                                                                       FB70 320
# PERMUTE H,K,L ACCORDING TO GIVEN SUMMATION ORDER                      FB70 321
# ------------------------------------------------                      FB70 322
#                                                                       FB70 323
STL=QX(IP+ISTL); STL2=STL*STL#         Get sin theta / lambda           FB70 324
IF(IFO>0)#                             If fobs pointer there            FB70 325
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FB70 326
ifvo:(QX(IP+IFO)) OBS=voidflg:#        Avoid void fobs                  FB70 327
ELSE  OBS=QX(IP+IFO)*SCALE(1)#         Get fobs                         FB70 328
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FB70 329
IF(IPHIO>0) OLDPHA=QX(IP+IPHI)#        Get old phase estimate           FB70 330
IF(IPHIC>0) CALPHA=QX(IP+LPHI)#        Get compare phase value          FB70 331
gethkl:(IP+IHKL,HKL)#                  Get real h,k,l                   FB70 332
DO I=1,3;IF(ABS(HKL(I))>MAXH(I))GOTO50# Skip if outside range           FB70 333
IF(STL<STLL(1)\ STL>STLL(2)) GOTO50#   Skip if outside range            FB70 334
FILIN1=NINT(HKL(RSUM1));GENIN1=IABS(FILIN1)# Fix fast and permute it    FB70 335
FILIN2=NINT(HKL(RSUM2))#               Fix medium and permute it        FB70 336
FILIN3=NINT(HKL(RSUM3))#               Fix slow and permute it          FB70 337
#                                                                       FB70 338
# STORE VOIDFLGS FOR UNKNOWABLE FC STUFF                                FB70 339
# --------------------------------------                                FB70 340
#                                                                       FB70 341
IF((IABS(FILIN1)>NYQF1)\$#             Refl outside map resolution      FB70 342
   (IABS(FILIN2)>NYQF2)\$#             Refl outside map resolution      FB70 343
   (IABS(FILIN3)>NYQF3))#              Refl outside map resolution      FB70 344
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FB70 345
IE=2; CNT(3)=CNT(3)+1.0;   GOTO 60#    Flag as resolution limit         FB70 346
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FB70 347
#                                                                       FB70 348
IF(GENIN3!=IABS(FILIN3))#              Change in slow sum index?        FB70 349
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FB70 350
PRINTP=PRINTL#                         Reset reflns/layer to dump       FB70 351
INPROS=yes:; GENIN3=IABS(FILIN3)#      Note change and reset index      FB70 352
IF(DIRACC==yes:)#                      Must direct access be used       FB70 353
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FB70 354
RECRD=GENIN3*NREADS#                   Direct access record pointer     FB70 355
FIRST=MARKP+1-dirbuf:#                 Prepare to point to first word   FB70 356
DO K=1,NREADS#                         Loop over no. of buffers         FB70 357
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FB70 358
FIRST=FIRST+dirbuf: ; LAST=MIN0(FIRST+dirbuf:-1,STOPP)# Read region     FB70 359
RECRD=RECRD+1 ; readdac:(ioda1:,,RECRD,(QX(JJ),JJ=FIRST,LAST))#         FB70 360
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FB70 361
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FB70 362
ELSE STEPGP=GENIN3*STEPP#              Calculate storage offset         FB70 363
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FB70 364
IF(GENIN2!=IABS(FILIN2))#              Change in medium index?          FB70 365
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FB70 366
INPROS=yes:; GENIN2=IABS(FILIN2)#      Note change and reset index      FB70 367
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FB70 368
#                                                                       FB70 369
# FOURIER TRANSFORM ALONG X1, LINE BY LINE                              FB70 370
# ----------------------------------------                              FB70 371
#                                                                       FB70 372
IF(INPROS==yes:)#                      Test if slow or medium change    FB70 373
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FB70 374
INPROS=no:#                            Shut off processing till next    FB70 375
GETPP=MARKP+STEPGP+GENIN2*STEPH#       Point to third sum coefficient   FB70 376
DO L=1,NX1#                            Loop over all x1                 FB70 377
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FB70 378
W(L)=CMPLX(QX(GETPP+1),QX(GETPP+2))#   Recomplex coef                   FB70 379
GETPP=GETPP+2#                         Incr pointer                     FB70 380
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FB70 381
CALL FB71(W,NX1,1,NDIV1)#              Transform the line               FB70 382
#                                                                       FB70 383
IF((GENIN2>0)&(NEGH2P==yes:))#         Any non zero negative index?     FB70 384
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FB70 385
GETPN=MARKP+STEPGP+(NH2-GENIN2)*STEPH# Point to 3rd sum coeff           FB70 386
DO L=1,NX1#                            Loop over all x1                 FB70 387
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FB70 388
WP(L)=CMPLX(QX(GETPN+1),QX(GETPN+2))#  Recomplex coef                   FB70 389
GETPN=GETPN+2#                         Incr pointer                     FB70 390
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FB70 391
CALL FB71(WP,NX1,1,NDIV1)#             Transform the line               FB70 392
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FB70 393
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FB70 394
#                                                                       FB70 395
#  AT THIS POINT A LINE IN RECIPROCAL SPACE IS IN THE W ARRAY           FB70 396
#  FOR POSITIVE H2 AND, IF NECESSARY, IN WP FOR NEGATIVE H2             FB70 397
#  ONLY THE UNIQUE ASSEMETRIC REFLECTIONS FROM THE BDF WILL             FB70 398
#  HAVE THEIR A, B, AND PHASE PICKED UP AND PUT TO OUTPUT.              FB70 399
# ------------------------------------------------------------          FB70 400
#                                                                       FB70 401
IF(FILIN1<0) L=NH1+FILIN1#             Make pointer out of - index      FB70 402
ELSE         L=FILIN1#                 Positives are easy               FB70 403
IF(FILIN2<0)#                          Negative h2?                     FB70 404
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FB70 405
A=REAL(WP(L+1)); B=AIMAG(WP(L+1))#     Get a and b for - h2             FB70 406
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FB70 407
ELSE#                                                                   FB70 408
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 FB70 409
A=REAL(W(L+1)); B=AIMAG(W(L+1))#       Get a and b for + h2             FB70 410
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 FB70 411
IF(FILIN3<0) B=-B#                     Freidel it!                      FB70 412
CAL=SQRT(A**2+B**2)#                   Get magnitude of fc              FB70 413
IF(CAL<OBS*FRAT\OBS<=voidflg:)#        Skip if fc too small             FB70 414
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 FB70 415
CNT(5)=CNT(5)+1.#                      Count rejected phases            FB70 416
IE=3;    GOTO 60#                      Skip to void phase               FB70 417
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 FB70 418
#                                                                       FB70 419
#   CALCULATE THE PHASE                                                 FB70 420
#   -------------------                                                 FB70 421
#                                                                       FB70 422
IF((ABS(A)>THRESH)&(ABS(B)>THRESH))#   Test if a & b significant        FB70 423
NEWPHA=AMOD(ATAN2(B,A)/TWOPI+1.000001,1.0)# Get cycles                  FB70 424
ELSE IF(ABS(A)>THRESH)#                Test if a significant            FB70 425
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 FB70 426
IF(A>0.0) NEWPHA=0.0; ELSE NEWPHA=0.5;  B=0.# Set as o and pi           FB70 427
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 FB70 428
ELSE IF(ABS(B)>THRESH)#                Test if a significant            FB70 429
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 FB70 430
IF(B>0.0) NEWPHA=.25; ELSE NEWPHA=.75;  A=0.# Set as pi/2 and 3pi/2     FB70 431
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 FB70 432
ELSE GOTO 40#                          Store voids for unknown fc stu   FB70 433
GOTO 90#                               Phase has been determined        FB70 434
40 CONTINUE#                           Branchpoint for fc too small     FB70 435
IE=1#                                  Signal fc too small              FB70 436
CNT(2)=CNT(2)+1.0; GOTO 60#            Count hkl with low a or b        FB70 437
50 CONTINUE#                           Max hkl entry point              FB70 438
CNT(4)=CNT(4)+1.0#                     Count outside hkl max            FB70 439
60 CONTINUE#                           Resolution limit entry point     FB70 440
NEWPHA=voidflg:;  CAL=voidflg:#        Give up on this one              FB70 441
A=voidflg:;       B=voidflg:#          Zero values                      FB70 442
90 CONTINUE#                           Branchpoint if phase ok          FB70 443
#                                                                       FB70 444
# GET SUMS FOR CORRELATION COEFFICIENT OF UNPHASED REFLECTIONS          FB70 445
# ------------------------------------------------------------          FB70 446
#                                                                       FB70 447
IF(OBS>SUCUT&CAL>0.0)#                 Only if f obs & f cal there      FB70 448
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 FB70 449
IF(IPHI>0) SUTEST=QX(IP+IPHI)#         Pick up input phase              FB70 450
ELSE IF(IA>0) SUTEST=QX(IP+IA)#        Or a part of fc                  FB70 451
ELSE SUTEST=voidflg:#                  Or disregard                     FB70 452
ifvo:(SUTEST)#                         Must use the undetermined        FB70 453
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 FB70 454
ifnv:(CAL)#                            No undetermined reflections      FB70 455
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 FB70 456
SUREF=SUREF+1.0 ; SUFO=SUFO+OBS ; SUFO2=SUFO2+OBS**2#                   FB70 457
SUFC=SUFC+CAL ; SUFC2=SUFC2+CAL**2 ; SUFOFC=SUFOFC+OBS*CAL#             FB70 458
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 FB70 459
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 FB70 460
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 FB70 461
#                                                                       FB70 462
#  STORE A, B, AND PHASE, AND PRINT                                     FB70 463
#  --------------------------------                                     FB70 464
#                                                                       FB70 465
IF(IPHI>0) QX(JP+IPHI)=NEWPHA#         Store phase in bdf packet        FB70 466
IF(IA>0)   QX(JP+IA)=A#                Store sf in bdf packet           FB70 467
IF(IB>0)   QX(JP+IB)=B#                Store sf in bdf packet           FB70 468
IF(IFC>0)  QX(JP+IFC)=CAL#             Store sf in bdf packet           FB70 469
IF(OBS>0.0&CAL>THRESH)#                Check if phased for stats        FB70 470
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 FB70 471
SUMFO=SUMFO+OBS#                       Sum total input coeff            FB70 472
SUMDF=SUMDF+ABS(OBS-CAL)#              Build a pseudo-r value           FB70 473
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 FB70 474
#                                                                       FB70 475
IF(PRINTP>0)#                          Print if required                FB70 476
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 FB70 477
PRINTP=PRINTP-1#                                                        FB70 478
ncodefld:(HKL,1,CHROT,FMTHKL,3)#       Format hkl                       FB70 479
IF(IFO>0) ncodefld:(OBS,1,CHROT,FMTHKL(4),1)# Format input coeff        FB70 480
ifnv:(CAL)#                            Test if phased                   FB70 481
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 FB70 482
BUFOT(1)=CAL;   BUFOT(2)=NEWPHA*360.#  Store calc coeff & phase         FB70 483
BUFOT(3)=A;     BUFOT(4)=B#            Store a & b structure factors    FB70 484
ncodefld:(BUFOT,1,CHROT,FMTFC,4)#      Format values                    FB70 485
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 FB70 486
ELSE IF(IE==0)#                        If outside hkl & stl limits      FB70 487
movechar:(FB7H,1,CHROT,40,NFB7H,0)#    Message 'outside hkl limits'     FB70 488
ELSE IF(IE==1)#                        If below cal threshold           FB70 489
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 FB70 490
movechar:(FB7D,1,CHROT,40,NFB7D,0)#    Message 'unphased'               FB70 491
ncodefld:(CAL,1,CHROT,FMTFC,1)#        Format values                    FB70 492
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 FB70 493
ELSE IF(IE==2)#                        Test for map resolution error    FB70 494
movechar:(FB7C,1,CHROT,40,NFB7C,0)#    Message 'resolution'             FB70 495
ELSE movechar:(FB7W,1,CHROT,40,NFB7W,0)# Message fc/fo ratio            FB70 496
writeline:(0,FB7G,NFB7G,1,3)#          Print exclusion message          FB70 497
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 FB70 498
IF(NRBIN>0) CALL FB20(OLDPHA,NEWPHA,CALPHA,STL2)# Phase stats           FB70 499
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FB70 500
#                                                                       FB70 501
#  PRINT PHASE STATISTICS IF REQUESTED                                  FB70 502
#  -----------------------------------                                  FB70 503
#                                                                       FB70 504
IF(NRBIN>0) CALL FB25#                 Report phase statistics          FB70 505
#                                                                       FB70 506
# FINISH OFF ALL BDFS REPORT R FACTOR AND QUIT                          FB70 507
# --------------------------------------------                          FB70 508
#                                                                       FB70 509
ncodefld:(CNT,1,FB7O,500513.,1)#       Format reflection stats          FB70 510
writeline:(1,FB7O,NFB7O,3,3)#          Print reflection stats           FB70 511
CNT(1)=CNT(1)-CNT(2)-CNT(3)-CNT(4)-CNT(5)# Get hkl phased               FB70 512
ncodefld:(CNT,1,FB7R,500513.,1)#       Format reflection stats          FB70 513
writeline:(0,FB7R,NFB7R,3,3)#          Print reflection stats           FB70 514
ncodefld:(CNT,2,FB7V,500513.,1)#       Format reflection stats          FB70 515
IF(CNT(2)>0.)writeline:(0,FB7V,NFB7V,3,3)# Print reflection stats       FB70 516
ncodefld:(CNT,3,FB7T,500513.,1)#       Format reflection stats          FB70 517
IF(CNT(3)>0.)writeline:(0,FB7T,NFB7T,3,3)# Print reflection stats       FB70 518
ncodefld:(CNT,4,FB7U,500513.,1)#       Format reflection stats          FB70 519
IF(CNT(4)>0.)writeline:(0,FB7U,NFB7U,3,3)# Print reflection stats       FB70 520
ncodefld:(CNT,5,FB7X,500513.,1)#       Format reflection stats          FB70 521
IF(CNT(5)>0.)writeline:(0,FB7X,NFB7X,3,3)# Print reflection stats       FB70 522
BUFOT(1)=SUMDF/AMAX1(SUMFO,0.01)#      Calculate r value                FB70 523
ncodefld:(BUFOT,1,FB7N,500732.,1)#     Format r-factor                  FB70 524
writeline:(1,FB7N,NFB7N,3,3)#          Print r-factor                   FB70 525
BUFOT(1)=SUREF;   BUFOT(2)=SUCUT#      Get counts and minimum           FB70 526
ncodefld:(BUFOT,1,FB7Z,FMTCR,2)#       Format correln ref count         FB70 527
writeline:(1,FB7Z,NFB7Z,3,3)#          Print correln ref count          FB70 528
IF(SUREF>0.0)#                         Any refls for correlation?       FB70 529
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 FB70 530
BUFOT(1)=(SUFOFC-(SUFO*SUFC/SUREF))/$# Compute correlation for          FB70 531
AMAX1(1.0,(SQRT(SUFO2-(SUFO**2/SUREF))*$# Fobs with fcalc               FB70 532
SQRT(SUFC2-(SUFC**2/SUREF))))#         For unphased refls               FB70 533
ncodefld:(BUFOT,1,FB7Y,370852.,1)#     Format correlation-factor        FB70 534
writeline:(1,FB7Y,NFB7Y,3,3)#          Print correlation-factor         FB70 535
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 FB70 536
#                                                                       FB70 537
readwpkt:(3,endrecord:,PSIZ,IP,0)#     End off el-dens file             FB70 538
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Copy all the rest             FB70 539
IF(DIRACC==yes:) closedac:(ioda1:)#    Close direct access file         FB70 540
#                                                                       FB70 541
RETURN#                                                                 FB70 542
END#                                                                    FB70 543
systemheader:(FB71)#                   Winograd's fft suite wfft        FB71   1
# ################################################################## #  FB71   2
#                                                                    #  FB71   3
#                               FB71                                 #  FB71   4
#                                                                    #  FB71   5
# ################################################################## #  FB71   6
SUBROUTINE FB71(X1,N,ISN,IDIV)#        J.m.stewart mar 1987             FB71   7
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  FB71   8
#      <<< WFFT >>>    COMPUTES 1 DIMENSIONAL FOURIER TRANSFORM         FB71   9
#     X1=INPUT VECTOR(COMPLEX) OF LENGTH N, OUTPUT IS IN SAME LOC...    FB71  10
#     ISN= CONTROLS FORWARD OR REV TRANSFORM, 1= DEN TO SF, -1=SF TO DE FB71  11
#     ALLOWED VALUES OF N ARE GIVEN IN VECTOR << ND(59) >>              FB71  12
#     IDIV IS THE POINTER TO ONE OF THE 59 POSSIBLE GRID SIZES          FB71  13
#- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -  FB71  14
INTEGER NF(2),LFIN(2),IP(80),OP(80),F(108),ALPHA,BETA,OP1#              FB71  15
INTEGER I,IDIV,IDIM,ID,ID1,ID2,IFD,IP1,IS,ISN,J,K,L,LIN,LL,LLL,L22,M1#  FB71  16
INTEGER L1,L2,L1IN,L2IN,M2#                                             FB71  17
INTEGER N,N1,N2,NOVL#                                                   FB71  18
REAL C(108),D#                                                          FB71  19
COMPLEX X1(N),X(108),Y(108),T1,T2,T3,T4,T5,T6,S1,S2,S3#                 FB71  20
intdata:(NF1,[1,1,1,1,2,1,1,1,1,3,2,1,1,2,1,1,3,4,2,5,4,1,2,5,3,6,4,1,# FB71  21
6,7,1,4,8,6,6,7,2,6,8,7,8,10,11,4,6,5,9,8,12,7,6,10,8,13,9,12,13,#      FB71  22
14,15])#                                                                FB71  23
intdata:(NB,[1,2,3,4,5,7,8,9,16,10,15,20,21,40,63,80])#                 FB71  24
intdata:(NBF1,[1,2,3,4,5,6,7,8,9,2,3,4,3,7,8,9])#                       FB71  25
intdata:(NBF2,[1,1,1,1,1,1,1,1,1,5,5,5,6,5,6,5])#                       FB71  26
intdata:(PHI,[1,1,2,2,4,6,4,6,8])#                                      FB71  27
intdata:(MB,[1,2,3,4,6,9,8,11,18])#                                     FB71  28
intdata:(MIND,[0,0,2,5,9,15,24,32,43])#                                 FB71  29
intdata:(FD,[1,1,1,1,-1,1,1,1,-1,1,1,1,-1,-1,-1,1,1,1,1,1,-1,-1,-1,-1,# FB71  30
1,1,1,1,-1,-1,1,-1,1,1,1,1,1,1,-1,-1,-1,-1,-1,1,1,1,1,1,-1,-1,-1,#      FB71  31
1,1,1,1,1,-1,-1,-1,-1,-1])#                                             FB71  32
realdata:(CD,[1.0,1.0,1.0,-1.5,.866025403,#                             FB71  33
1.0,1.0,1.0,1.0,1.0,-1.25,.559016994,#                                  FB71  34
.951056516,1.538841768,-.363271264,#                                    FB71  35
1.0,-1.166666667,.790156468,#                                           FB71  36
.0558542672,.734302201,.440958551,#                                     FB71  37
.340872930,-.53396936,.87484229,#                                       FB71  38
1.0,1.0,1.0,1.0,1.0,1.0,#                                               FB71  39
.707106782,.707106782,1.0,-.5,-1.5,.766044443,.93969262,#               FB71  40
-.173648177,.866025403,.866025403,#                                     FB71  41
.64278761,-.342020143,.984807753,#                                      FB71  42
1.0,1.0,1.0,1.0,1.0,1.0,1.0,1.0,#                                       FB71  43
.707106782,.707106782,.382683432,1.306562965,#                          FB71  44
-.5411961,.707106782,.707106782,#                                       FB71  45
.923879533,-.5411961,1.306562965])#                                     FB71  46
EQUIVALENCE (L1IN,LFIN(1)),(L2IN,LFIN(2))#                              FB71  47
datastuff:#                                                             FB71  48
#                                                                       FB71  49
NF(1)=NB(NF1(IDIV))#                                                    FB71  50
NF(2)=N/NF(1)#                                                          FB71  51
FOR(IDIM=1;IDIM<=2;IDIM=IDIM+1)#                                        FB71  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB71  53
L=NF(IDIM)#                                                             FB71  54
IF(L==1) NEXT#                                                          FB71  55
NOVL=N/L#                                                               FB71  56
LIN=0#                                                                  FB71  57
DO I=1,16#                                                              FB71  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB71  59
IF(L==NB(I)) BREAK#                                                     FB71  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB71  61
LIN=I#                                                                  FB71  62
L1IN=NBF1(LIN); L2IN=NBF2(LIN); L1=NB(L1IN); M1=MB(L1IN)#               FB71  63
L2=NB(L2IN); M2=MB(L2IN)#                                               FB71  64
IF(M2>1)#                                                               FB71  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB71  66
I=0; ID2=MIND(L2IN)#                                                    FB71  67
DO K=1,M2#                                                              FB71  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB71  69
ID2=ID2+1; ID1=MIND(L1IN); IFD=ISN+FD(ID2)#                             FB71  70
DO J=1,M1#                                                              FB71  71
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB71  72
I=I+1; ID1=ID1+1; C(I)=CD(ID1)*CD(ID2); F(I)=FD(ID1)*FD(ID2)#           FB71  73
IF((FD(ID1)+IFD)<0) C(I)=-C(I)#                                         FB71  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB71  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB71  76
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB71  77
ELSE#                                                                   FB71  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FB71  79
ID=MIND(L1IN)#                                                          FB71  80
DO J=1,M1#                                                              FB71  81
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FB71  82
C(J)=CD(J+ID); F(J)=FD(J+ID)#                                           FB71  83
IF((F(J)+ISN)==(-2)) C(J)=-C(J)#                                        FB71  84
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FB71  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FB71  86
ALPHA=MOD(N/L1,L1)#                                                     FB71  87
IF((ALPHA>1)&(L1>4)) ALPHA=MOD(ALPHA**(PHI(L1IN)-1),L1)#                FB71  88
BETA=MOD(N/L2,L2)#                                                      FB71  89
IF((BETA>1)&(L2>4)) BETA=MOD(BETA**(PHI(L2IN)-1),L2)#                   FB71  90
ID1=ALPHA*L2; ID2=BETA*L1#                                              FB71  91
I=0; IP1=1-L1-L2; OP1=1-ID1-ID2#                                        FB71  92
DO K=1,L2#                                                              FB71  93
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FB71  94
IP1=IP1+L1; OP1=OP1+ID2#                                                FB71  95
IF(OP1>L)OP1=OP1-L#                                                     FB71  96
DO J=1,L1#                                                              FB71  97
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FB71  98
I=I+1; IP1=IP1+L2#                                                      FB71  99
IF(IP1>L)IP1=IP1-L#                                                     FB71 100
IP(IP1)=I; OP1=OP1+ID1#                                                 FB71 101
IF(OP1>L)OP1=OP1-L#                                                     FB71 102
OP(OP1)=I#                                                              FB71 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FB71 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FB71 105
ID=1-L-NOVL#                                                            FB71 106
DO N2=1,NOVL#                                                           FB71 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FB71 108
ID=ID+L; LL=(N-ID)/NOVL; ID1=ID+NOVL*LL-N; I=ID#                        FB71 109
DO N1=1,LL#                                                             FB71 110
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FB71 111
I=I+NOVL; X(IP(N1))=X1(I)#                                              FB71 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FB71 113
IF(LL!=L)#                                                              FB71 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FB71 115
LLL=LL+1; I=ID1#                                                        FB71 116
DO N1=LLL,L#                                                            FB71 117
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FB71 118
I=I+NOVL; X(IP(N1))=X1(I)#                                              FB71 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FB71 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FB71 121
#                                                                       FB71 122
#  NOW PICK OUT THE CORRECT PROCEEDURE FOR TRANSFORMING BASED ON        FB71 123
#  REQUESTED GRID FINENESS.                                             FB71 124
#  --------------------------------------------------------------       FB71 125
#                                                                       FB71 126
GO TO (1000,202,203,204,205,207,208,209,2016,2010,2015,2020,2021,#      FB71 127
2040,2063,2080),LIN#                                                    FB71 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FB71 129
202 CONTINUE#                                                           FB71 130
T1=X(1); X(1)=X(2)+T1; X(2)=T1-X(2)#                                    FB71 131
GO TO 240#                                                              FB71 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FB71 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FB71 134
203 CONTINUE#                                                           FB71 135
Y(2)=X(2)+X(3); X(1)=X(1)+Y(2); Y(3)=X(2)-X(3)#                         FB71 136
Y(2)=CMPLX(C(2)*REAL(Y(2)),C(2)*AIMAG(Y(2)))#                           FB71 137
Y(3)=CMPLX(-C(3)*AIMAG(Y(3)),C(3)*REAL(Y(3)))#                          FB71 138
S1=X(1)+Y(2); X(3)=S1-Y(3); X(2)=S1+Y(3)#                               FB71 139
GO TO 240#                                                              FB71 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FB71 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FB71 142
204 CONTINUE#                                                           FB71 143
S1=X(2)-X(4); S2=X(1)-X(3)#            204 214                          FB71 144
S1=CMPLX(AIMAG(S1),-REAL(S1))#         264                              FB71 145
IF(ISN==1)S1=-S1#                      274                              FB71 146
T2=X(2)+X(4); X(4)=S2-S1; T1=X(1)+X(3)# 234 284 224                     FB71 147
X(3)=T1-T2; X(1)=T1+T2; X(2)=S2+S1#    244 254 294                      FB71 148
GO TO 240#                                                              FB71 149
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FB71 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FB71 151
205 CONTINUE#                                                           FB71 152
T1=X(2)+X(5); T2=X(3)+X(4); Y(3)=T1-T2# 205 215 225                     FB71 153
Y(2)=T1+T2; Y(6)=X(2)-X(5); Y(5)=X(4)-X(3)# 235 245 255                 FB71 154
X(1)=Y(2)+X(1); Y(4)=Y(6)+Y(5)#        265 275                          FB71 155
DO IS=2,6#                                                              FB71 156
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FB71 157
D=C(IS)#                                                                FB71 158
IF(IS<4) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 285                 FB71 159
ELSE     Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 295                FB71 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FB71 161
S1=X(1)+Y(2); S2=S1+Y(3); S3=Y(4)-Y(5)# 305 315 325                     FB71 162
X(5)=S2-S3; X(2)=S2+S3; S2=S1-Y(3)#    335 345 355                      FB71 163
S3=Y(4)+Y(6); X(4)=S2-S3; X(3)=S2+S3#  365 375 385                      FB71 164
GO TO 240#                                                              FB71 165
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FB71 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FB71 167
207 CONTINUE#                                                           FB71 168
T1=X(2)+X(7); T2=X(3)+X(6); Y(5)=T2-T1# 207 217 227                     FB71 169
T3=X(4)+X(5); Y(3)=T1-T3; Y(4)=T3-T2#  237 247 257                      FB71 170
Y(2)=T1+T2+T3; T1=X(2)-X(7); T2=X(3)-X(6)# 267 277 287                  FB71 171
Y(9)=T2-T1; X(1)=X(1)+Y(2); T3=X(5)-X(4)# 297 307 317                   FB71 172
Y(7)=T1-T3; Y(8)=T3-T2; Y(6)=T1+T2+T3# 327 337 347                      FB71 173
DO IS=2,9#                                                              FB71 174
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FB71 175
D=C(IS)#                                                                FB71 176
IF(IS<6) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 357                 FB71 177
ELSE     Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 367                FB71 178
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FB71 179
S1=X(1)+Y(2); S2=S1+Y(3)+Y(4); S3=Y(6)+Y(7)+Y(8)# 377 387 397           FB71 180
X(7)=S2-S3; X(2)=S3+S2; S2=S1-Y(3)-Y(5)# 407 417 427                    FB71 181
S3=Y(6)-Y(7)-Y(9); X(6)=S2-S3; X(3)=S3+S2# 437 447 457                  FB71 182
S2=S1-Y(4)+Y(5); S3=Y(6)-Y(8)+Y(9); X(4)=S2-S3# 467 477 487             FB71 183
X(5)=S3+S2#                            497                              FB71 184
GO TO 240#                                                              FB71 185
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FB71 186
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FB71 187
208 CONTINUE#                                                           FB71 188
I=-8#                                                                   FB71 189
DO L22=1,L2#                                                            FB71 190
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FB71 191
I=I+8#                                                                  FB71 192
T2=X(I+4)-X(I+8); T1=X(I+2)-X(I+6); Y(I+7)=T1-T2# 488 218 228           FB71 193
Y(I+8)=T1+T2; T2=X(I+3)+X(I+7); T1=X(I+1)+X(I+5)# 238 248 258           FB71 194
Y(I+3)=T1-T2; T3=T1+T2; T2=X(I+4)+X(I+8)# 268 278 288                   FB71 195
T1=X(I+2)+X(I+6); Y(I+5)=T1-T2; T4=T1+T2# 298 308 318                   FB71 196
Y(I+1)=T4+T3; Y(I+2)=T3-T4; Y(I+4)=X(I+1)-X(I+5)# 328 338 348           FB71 197
Y(I+6)=X(I+3)-X(I+7)#                  358                              FB71 198
Y(5)=CMPLX(-AIMAG(Y(5)),REAL(Y(5)))#                                    FB71 199
IF(ISN==-1)Y(5)=-Y(5)#                                                  FB71 200
Y(6)=CMPLX(-AIMAG(Y(6)),REAL(Y(6)))#                                    FB71 201
IF(ISN==-1)Y(6)=-Y(6)#                                                  FB71 202
Y(7)=CMPLX(C(7)*REAL(Y(7)),C(7)*AIMAG(Y(7)))#                           FB71 203
Y(8)=CMPLX(-C(8)*AIMAG(Y(8)),C(8)*REAL(Y(8)))#                          FB71 204
X(I+5)=Y(I+2); X(I+1)=Y(I+1); X(I+7)=Y(I+3)-Y(I+5)# 368 378 388         FB71 205
T2=Y(I+6)+Y(I+8); T1=Y(I+4)+Y(I+7); X(I+8)=T1-T2# 398 408 418           FB71 206
X(I+2)=T1+T2; T2=Y(I+6)-Y(I+8); T1=Y(I+4)-Y(I+7)# 428 438 448           FB71 207
X(I+4)=T1-T2; X(I+6)=T1+T2; X(I+3)=Y(I+3)+Y(I+5)# 458 468 478           FB71 208
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FB71 209
GO TO 240#                                                              FB71 210
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FB71 211
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FB71 212
209 CONTINUE#                                                           FB71 213
I=-8#                                                                   FB71 214
DO L22=1,L2#                                                            FB71 215
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FB71 216
I=I+8#                                                                  FB71 217
Y(I+3)=X(I+4)+X(I+7);T2=X(I+3)+X(I+8);T1=X(I+2)+X(I+9)# 609 219 229     FB71 218
Y(I+4)=T1-T2; T3=X(I+5)+X(I+6); Y(I+2)=T3+T1+T2# 239 249 259            FB71 219
Y(I+6)=T3-T1; Y(I+5)=T2-T3#            269 279                          FB71 220
Y(I+1)=X(I+1)+Y(I+3)+Y(I+2); Y(I+8)=X(I+4)-X(I+7)# 289 299              FB71 221
T2=X(I+8)-X(I+3); T1=X(I+2)-X(I+9); Y(I+9)=T1-T2# 309 319 329           FB71 222
T3=X(I+5)-X(I+6); Y(I+7)=T3+T1+T2; Y(I+11)=T3-T1# 339 349 359           FB71 223
Y(I+10)=T2-T3#                         369                              FB71 224
DO IS=2,11#                            379                              FB71 225
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FB71 226
D=C(IS)#                                                                FB71 227
IF(IS<7) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 409                 FB71 228
ELSE     Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 419                FB71 229
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FB71 230
T4=Y(I+2)+Y(I+2); T1=T4+Y(I+1)+Y(I+3)# 429 439                          FB71 231
T3=T1+Y(I+4)+Y(I+5); T2=Y(I+8)+Y(I+9)+Y(I+10)# 449 459                  FB71 232
X(I+2)=T2+T3; X(I+9)=T3-T2; T2=Y(I+1)+Y(I+2)+T4# 469 479 489            FB71 233
X(I+7)=T2-Y(I+7); T4=T1+Y(I+6)-Y(I+5)# 499 509                          FB71 234
T3=Y(I+8)+Y(I+11)-Y(I+10); X(I+8)=T3+T4# 519 529                        FB71 235
X(I+3)=T4-T3; X(I+4)=T2+Y(I+7)#        539 549                          FB71 236
T2=T1-Y(I+4)-Y(I+6); T1=Y(I+8)-Y(I+9)-Y(I+11)# 559 569                  FB71 237
X(I+5)=T1+T2; X(I+6)=T2-T1; X(I+1)=Y(I+1)# 579 589 599                  FB71 238
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FB71 239
GO TO 240#                                                              FB71 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FB71 241
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FB71 242
2016  CONTINUE#                                                         FB71 243
T1=X(1)+X(9); T2=X(5)+X(13); T3=T1+T2; Y(4)=T1-T2#                      FB71 244
T1=X(3)+X(11); T2=X(7)+X(15); T4=T1+T2; Y(7)=T1-T2#                     FB71 245
T5=T3+T4; Y(3)=T3-T4; T1=X(3)-X(11); T2=X(7)-X(15)#                     FB71 246
Y(15)=T1+T2; Y(10)=T1-T2; T1=X(2)+X(10); T2=X(6)+X(14)#                 FB71 247
T3=T1+T2; T4=T1-T2; T1=X(4)+X(12); T2=X(8)+X(16)#                       FB71 248
T6=T1+T2; T1=T1-T2; Y(14)=T4+T1; Y(9)=T4-T1#                            FB71 249
Y(6)=T3-T6; T1=T3+T6; Y(1)=T5+T1; Y(2)=T5-T1#                           FB71 250
T1=X(2)-X(10); T2=X(8)-X(16); Y(17)=T1+T2; Y(12)=T1-T2#                 FB71 251
T1=X(6)-X(14); T2=X(4)-X(12); Y(18)=T1+T2; Y(13)=T1-T2#                 FB71 252
Y(5)=X(1)-X(9); Y(8)=X(5)-X(13); Y(16)=Y(17)+Y(18)#                     FB71 253
Y(11)=Y(12)+Y(13)#                                                      FB71 254
DO IS=6,8#                                                              FB71 255
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FB71 256
Y(IS)=CMPLX(-AIMAG(Y(IS)),REAL(Y(IS)))#                                 FB71 257
IF(ISN==-1) Y(IS)=-Y(IS)#                                               FB71 258
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FB71 259
DO IS=9,18#                                                             FB71 260
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FB71 261
D=C(IS)#                                                                FB71 262
IF(IS<14) Y(IS)=CMPLX(D*REAL(Y(IS)),D*AIMAG(Y(IS)))# 6316               FB71 263
ELSE      Y(IS)=CMPLX(-D*AIMAG(Y(IS)),D*REAL(Y(IS)))# 6416              FB71 264
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FB71 265
T1=Y(4)+Y(9); T2=Y(7)+Y(14); X(3)=T1+T2; X(15)=T1-T2#                   FB71 266
T1=Y(4)-Y(9); T2=Y(14)-Y(7); X(7)=T1+T2; X(11)=T1-T2#                   FB71 267
T1=Y(5)+Y(10); T2=Y(12)-Y(11); T3=T1+T2; T4=T1-T2#                      FB71 268
T1=Y(8)+Y(15); T2=Y(16)+Y(17); T5=T1+T2; T6=T1-T2#                      FB71 269
X(10)=T4+T6; X(8)=T4-T6; X(2)=T3+T5; X(16)=T3-T5#                       FB71 270
X(1)=Y(1); X(5)=Y(3)+Y(6); T1=Y(5)-Y(10); T2=Y(13)-Y(11)#               FB71 271
T3=T1+T2; T4=T1-T2; T1=Y(8)-Y(15); T2=Y(16)-Y(18)#                      FB71 272
T5=T1+T2; T6=T1-T2; X(14)=T4+T6; X(4)=T4-T6; X(6)=T3+T5#                FB71 273
X(12)=T3-T5; X(9)=Y(2); X(13)=Y(3)-Y(6)#                                FB71 274
GO TO 240#                                                              FB71 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FB71 276
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FB71 277
2010 CONTINUE#                                                          FB71 278
CALL FB72(X,Y,C,F)#                    Call wfft10(x,y,c,f)             FB71 279
GO TO 240#                                                              FB71 280
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FB71 281
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 FB71 282
2015 CONTINUE#                                                          FB71 283
CALL FB73(X,Y,C,F)#                    Call wfft15(x,y,c,f)             FB71 284
GO TO 240#                                                              FB71 285
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 FB71 286
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 FB71 287
2020 CONTINUE#                                                          FB71 288
CALL FB74(X,Y,C,F)#                    Call wfft20(x,y,c,f)             FB71 289
GO TO 240#                                                              FB71 290
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 FB71 291
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 FB71 292
2021 CONTINUE#                                                          FB71 293
CALL FB75(X,Y,C,F)#                    Call wfft21(x,y,c,f)             FB71 294
GO TO 240#                                                              FB71 295
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 FB71 296
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 FB71 297
2040 CONTINUE#                                                          FB71 298
CALL FB76(X,Y,C,F)#                    Call wfft40(x,y,c,f)             FB71 299
GO TO 240#                                                              FB71 300
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 FB71 301
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 FB71 302
2063 CONTINUE#                                                          FB71 303
CALL FB77(X,Y,C,F)#                    Call wfft63(x,y,c,f)             FB71 304
GO TO 240#                                                              FB71 305
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 FB71 306
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 FB71 307
2080 CONTINUE#                                                          FB71 308
CALL FB78(X,Y,C,F)#                    Call wfft80(x,y,c,f)             FB71 309
GO TO 240#                                                              FB71 310
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 FB71 311
240   CONTINUE#                                                         FB71 312
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 FB71 313
I=ID#                                                                   FB71 314
DO N1=1,LL#                                                             FB71 315
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 FB71 316
I=I+NOVL; X1(I)=X(OP(N1))#                                              FB71 317
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 FB71 318
IF(LL!=L)#                                                              FB71 319
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 FB71 320
I=ID1#                                                                  FB71 321
DO N1=LLL,L#                                                            FB71 322
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 FB71 323
I=I+NOVL; X1(I)=X(OP(N1))#                                              FB71 324
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 FB71 325
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 FB71 326
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 FB71 327
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FB71 328
#                                                                       FB71 329
1000  CONTINUE#                                                         FB71 330
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB71 331
RETURN#                                                                 FB71 332
END#                                                                    FB71 333
systemheader:(FB72)#                   Winograd's fft suite wfft10      FB72   1
# ################################################################## #  FB72   2
#                                                                    #  FB72   3
#                               FB72                                 #  FB72   4
#                                                                    #  FB72   5
# ################################################################## #  FB72   6
SUBROUTINE FB72(X,Y,C,F)#              J.m.stewart mar 1987             FB72   7
COMPLEX X(12),Y(12),T1,T2,T3#                                           FB72   8
REAL C(12)#                                                             FB72   9
INTEGER F(12)#                                                          FB72  10
INTEGER I,N,N1,N2#                                                      FB72  11
REAL D#                                                                 FB72  12
#                                                                       FB72  13
I=-1#                                                                   FB72  14
DO N2=1,5#                                                              FB72  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB72  16
I=I+2#                                                                  FB72  17
T1=X(I); X(I)=X(I+1)+T1; X(I+1)=T1-X(I+1)# 101 102 100                  FB72  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB72  19
DO N1=1,2#                                                              FB72  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB72  21
T1=X(N1+2)+X(N1+8); T2=X(N1+4)+X(N1+6); Y(N1+4)=T1-T2# 201 202 203      FB72  22
Y(N1+2)=T1+T2; Y(N1+10)=X(N1+2)-X(N1+8)# 204 205                        FB72  23
Y(N1+8)=X(N1+6)-X(N1+4); X(N1)=Y(N1+2)+X(N1)# 206 207                   FB72  24
Y(N1+6)=Y(N1+10)+Y(N1+8)#              200                              FB72  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB72  26
DO N=3,12#                                                              FB72  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB72  28
D=C(N)#                                                                 FB72  29
IF(F(N)>0) Y(N)=CMPLX(D*REAL(Y(N)),D*AIMAG(Y(N)))# 250                  FB72  30
ELSE       Y(N)=CMPLX(-D*AIMAG(Y(N)),D*REAL(Y(N)))# 300                 FB72  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB72  32
DO N1=1,2#                                                              FB72  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB72  34
T1=X(N1)+Y(N1+2); T2=T1+Y(N1+4); T3=Y(N1+6)-Y(N1+8)# 401 402 403        FB72  35
X(N1+8)=T2-T3; X(N1+2)=T2+T3; T2=T1-Y(N1+4)# 404 405 406                FB72  36
T3=Y(N1+6)+Y(N1+10); X(N1+6)=T2-T3; X(N1+4)=T2+T3# 407 408 400          FB72  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB72  38
RETURN#                                                                 FB72  39
END#                                                                    FB72  40
systemheader:(FB73)#                   Winograd's fft suite wfft15      FB73   1
# ################################################################## #  FB73   2
#                                                                    #  FB73   3
#                               FB73                                 #  FB73   4
#                                                                    #  FB73   5
# ################################################################## #  FB73   6
SUBROUTINE FB73(X,Y,C,F)#              J.m.stewart mar 1987             FB73   7
COMPLEX X(18),Y(18),T1,T2,T3#                                           FB73   8
REAL C(18)#                                                             FB73   9
INTEGER F(18)#                                                          FB73  10
INTEGER I,N,N1,N2#                                                      FB73  11
REAL D#                                                                 FB73  12
#                                                                       FB73  13
I=-2#                                                                   FB73  14
DO N2=1,5#                                                              FB73  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB73  16
I=I+3#                                 101                              FB73  17
Y(I+1)=X(I+1)+X(I+2); Y(I)=X(I)+Y(I+1)# 102 103                         FB73  18
Y(I+2)=X(I+1)-X(I+2)#                  100                              FB73  19
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB73  20
DO N1=1,3#                                                              FB73  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB73  22
T1=Y(N1+3)+Y(N1+12); T2=Y(N1+6)+Y(N1+9)# 201 202                        FB73  23
X(N1+6)=T1-T2; X(N1+3)=T1+T2#          203 204                          FB73  24
X(N1+15)=Y(N1+3)-Y(N1+12); X(N1+12)=Y(N1+9)-Y(N1+6)# 205 206            FB73  25
X(N1)=Y(N1)+X(N1+3); X(N1+9)=X(N1+15)+X(N1+12)# 207 200                 FB73  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB73  27
DO N=2,18#                                                              FB73  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB73  29
D=C(N)#                                                                 FB73  30
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  FB73  31
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 FB73  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB73  33
DO N1=1,3#                                                              FB73  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB73  35
T1=X(N1)+X(N1+3); T2=T1+X(N1+6); T3=X(N1+9)-X(N1+12)# 401 402 403       FB73  36
Y(N1+12)=T2-T3; Y(N1+3)=T3+T2; T2=T1-X(N1+6)# 404 405 406               FB73  37
T3=X(N1+9)+X(N1+15); Y(N1+9)=T2-T3#    407 408                          FB73  38
Y(N1+6)=T3+T2; Y(N1)=X(N1)#            409 400                          FB73  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB73  40
I=-2#                                                                   FB73  41
DO N2=1,5#                                                              FB73  42
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB73  43
I=I+3; T1=Y(I)+Y(I+1); X(I+2)=T1-Y(I+2)# 501 502 503                    FB73  44
X(I)=Y(I); X(I+1)=T1+Y(I+2)#           504 500                          FB73  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB73  46
RETURN#                                                                 FB73  47
END#                                                                    FB73  48
systemheader:(FB74)#                   Winograd's fft suite wfft20      FB74   1
# ################################################################## #  FB74   2
#                                                                    #  FB74   3
#                               FB74                                 #  FB74   4
#                                                                    #  FB74   5
# ################################################################## #  FB74   6
SUBROUTINE FB74(X,Y,C,F)#              J.m.stewart mar 1987             FB74   7
COMPLEX X(24),Y(24),T1,T2,T3,T4,T5#                                     FB74   8
REAL C(24)#                                                             FB74   9
INTEGER F(24)#                                                          FB74  10
INTEGER I,N,N1,N2#                                                      FB74  11
REAL D#                                                                 FB74  12
I=-3#                                                                   FB74  13
DO N2=1,5#                                                              FB74  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB74  15
I=I+4; T1=X(I)+X(I+2); T2=X(I+1)+X(I+3)# 102 103 104                    FB74  16
Y(I+1)=T1-T2; Y(I)=T1+T2#              105 106                          FB74  17
Y(I+2)=X(I)-X(I+2); Y(I+3)=X(I+1)-X(I+3)# 107 108                       FB74  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB74  19
DO N1=1,4#                                                              FB74  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB74  21
T1=Y(N1+4)+Y(N1+16); T2=Y(N1+8)+Y(N1+12)# 201 202                       FB74  22
X(N1+8)=T1-T2; X(N1+4)=T1+T2#          203 204                          FB74  23
X(N1+20)=Y(N1+4)-Y(N1+16); X(N1+16)=Y(N1+12)-Y(N1+8)# 205 206           FB74  24
X(N1)=X(N1+4)+Y(N1); X(N1+12)=X(N1+20)+X(N1+16)# 207 208                FB74  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB74  26
DO N=4,24#                                                              FB74  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB74  28
D=C(N)#                                                                 FB74  29
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  FB74  30
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 FB74  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB74  32
DO N1=1,4#                                                              FB74  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB74  34
T1=X(N1)+X(N1+4);T2=T1+X(N1+8);T3=X(N1+12)-X(N1+16)# 401 402 403        FB74  35
Y(N1+16)=T2-T3; Y(N1+4)=T2+T3; T4=T1-X(N1+8)# 404 405 406               FB74  36
T5=X(N1+12)+X(N1+20)#                  407                              FB74  37
Y(N1+12)=T4-T5; Y(N1+8)=T4+T5; Y(N1)=X(N1)# 408 409 410                 FB74  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB74  39
I=-3#                                                                   FB74  40
DO N2=1,5#                                                              FB74  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB74  42
I=I+4; X(I+3)=Y(I+2)-Y(I+3); X(I)=Y(I)# 501 502 503                     FB74  43
X(I+2)=Y(I+1); X(I+1)=Y(I+2)+Y(I+3)#   504 505                          FB74  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB74  45
RETURN#                                                                 FB74  46
END#                                                                    FB74  47
systemheader:(FB75)#                   Winograd's fft suite wfft21      FB75   1
# ################################################################## #  FB75   2
#                                                                    #  FB75   3
#                               FB75                                 #  FB75   4
#                                                                    #  FB75   5
# ################################################################## #  FB75   6
SUBROUTINE FB75(X,Y,C,F)#              J.m.stewart mar 1987             FB75   7
COMPLEX X(27),Y(27),T1,T2,T3#                                           FB75   8
REAL C(27)#                                                             FB75   9
INTEGER F(27)#                                                          FB75  10
INTEGER I,N,N2#                                                         FB75  11
REAL D#                                                                 FB75  12
I=-2#                                                                   FB75  13
DO N2=1,7#                                                              FB75  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB75  15
I=I+3; Y(I+1)=X(I+1)+X(I+2)#           101 102                          FB75  16
Y(I)=X(I)+Y(I+1); Y(I+2)=X(I+1)-X(I+2)# 103 104                         FB75  17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB75  18
DO I=1,3#                                                               FB75  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB75  20
T1=Y(I+3)+Y(I+18); T2=Y(I+6)+Y(I+15); X(I+12)=T2-T1# 201 202 203        FB75  21
T3=Y(I+9)+Y(I+12); X(I+6)=T1-T3; X(I+9)=T3-T2# 204 205 206              FB75  22
X(I+3)=T1+T2+T3; T1=Y(I+3)-Y(I+18); T2=Y(I+6)-Y(I+15)# 207 208 209      FB75  23
X(I+24)=T2-T1; X(I)=Y(I)+X(I+3); T3=Y(I+12)-Y(I+9)# 210 211 212         FB75  24
X(I+18)=T1-T3; X(I+21)=T3-T2; X(I+15)=T1+T2+T3# 213 214 215             FB75  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB75  26
DO N=2,27#                                                              FB75  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB75  28
D=C(N)#                                                                 FB75  29
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  FB75  30
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 FB75  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB75  32
DO I=1,3#                                                               FB75  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB75  34
T1=X(I)+X(I+3); T2=T1+X(I+6)+X(I+9)#   401 402                          FB75  35
T3=X(I+15)+X(I+18)+X(I+21); Y(I+18)=T2-T3# 403 404                      FB75  36
Y(I+3)=T3+T2; T2=T1-X(I+6)-X(I+12)#    405 406                          FB75  37
T3=X(I+15)-X(I+18)-X(I+24); Y(I+15)=T2-T3# 407 408                      FB75  38
Y(I+6)=T3+T2; T2=T1-X(I+9)+X(I+12)#    409 410                          FB75  39
T3=X(I+15)-X(I+21)+X(I+24)#            411                              FB75  40
Y(I+9)=T2-T3; Y(I+12)=T3+T2; Y(I)=X(I)# 412 413 414                     FB75  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB75  42
I=-2#                                                                   FB75  43
DO N2=1,7#                                                              FB75  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB75  45
I=I+3; T1=Y(I)+Y(I+1); X(I+2)=T1-Y(I+2)# 501 502 503                    FB75  46
X(I)=Y(I); X(I+1)=T1+Y(I+2)#           504 505                          FB75  47
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB75  48
RETURN#                                                                 FB75  49
END#                                                                    FB75  50
systemheader:(FB76)#                   Winograd's fft suite wfft40      FB76   1
# ################################################################## #  FB76   2
#                                                                    #  FB76   3
#                               FB76                                 #  FB76   4
#                                                                    #  FB76   5
# ################################################################## #  FB76   6
SUBROUTINE FB76(X,Y,C,F)#              J.m.stewart mar 1987             FB76   7
COMPLEX X(48),Y(48),T1,T2,T3,T4#                                        FB76   8
REAL C(48)#                                                             FB76   9
INTEGER F(48)#                                                          FB76  10
INTEGER I,N,N1,N2#                                                      FB76  11
REAL D#                                                                 FB76  12
I=-8#                                                                   FB76  13
DO N2=1,5#                                                              FB76  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB76  15
I=I+8; T2=X(I+4)-X(I+8); T1=X(I+2)-X(I+6)# 208 218                      FB76  16
Y(I+7)=T1-T2; Y(I+8)=T1+T2; T2=X(I+3)+X(I+7)# 228 238 248               FB76  17
T1=X(I+1)+X(I+5); Y(I+3)=T1-T2; T3=T1+T2# 258 268 278                   FB76  18
T2=X(I+4)+X(I+8); T1=X(I+2)+X(I+6); Y(I+5)=T1-T2# 288 298 308           FB76  19
T4=T1+T2; Y(I+1)=T4+T3; Y(I+2)=T3-T4#  318 328 338                      FB76  20
Y(I+4)=X(I+1)-X(I+5); Y(I+6)=X(I+3)-X(I+7)#                             FB76  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB76  22
DO N1=1,8#                                                              FB76  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB76  24
T1=Y(N1+8)+Y(N1+32); T2=Y(N1+16)+Y(N1+24)# 201 202                      FB76  25
X(N1+16)=T1-T2; X(N1+8)=T1+T2#         203 204                          FB76  26
X(N1+40)=Y(N1+8)-Y(N1+32); X(N1+32)=Y(N1+24)-Y(N1+16)# 205 206          FB76  27
X(N1)=X(N1+8)+Y(N1); X(N1+24)=X(N1+40)+X(N1+32)# 207 209                FB76  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB76  29
DO N=5,48#                                                              FB76  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB76  31
D=C(N)#                                                                 FB76  32
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  FB76  33
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 FB76  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB76  35
DO N1=1,8#                                                              FB76  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB76  37
T1=X(N1)+X(N1+8); T2=T1+X(N1+16); T3=X(N1+24)-X(N1+32)# 401 402 403     FB76  38
Y(N1+32)=T2-T3; Y(N1+8)=T2+T3; T2=T1-X(N1+16)# 404 405 406              FB76  39
T3=X(N1+24)+X(N1+40); Y(N1+24)=T2-T3#  407 411                          FB76  40
Y(N1+16)=T2+T3; Y(N1)=X(N1)#           409 410                          FB76  41
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB76  42
I=-8#                                                                   FB76  43
DO N2=1,5#                                                              FB76  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB76  45
I=I+8; X(I+5)=Y(I+2); X(I+1)=Y(I+1)#   501 368 378                      FB76  46
X(I+7)=Y(I+3)-Y(I+5);T2=Y(I+6)+Y(I+8);T1=Y(I+4)+Y(I+7)# 388 398 408     FB76  47
X(I+8)=T1-T2; X(I+2)=T1+T2; T2=Y(I+6)-Y(I+8)# 418 428 438               FB76  48
T1=Y(I+4)-Y(I+7); X(I+4)=T1-T2#        448 458                          FB76  49
X(I+6)=T1+T2; X(I+3)=Y(I+3)+Y(I+5)#    468 478                          FB76  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB76  51
RETURN#                                                                 FB76  52
END#                                                                    FB76  53
systemheader:(FB77)#                   Winograd's fft suite wfft63      FB77   1
# ################################################################## #  FB77   2
#                                                                    #  FB77   3
#                               FB77                                 #  FB77   4
#                                                                    #  FB77   5
# ################################################################## #  FB77   6
SUBROUTINE FB77(X,Y,C,F)#              J.m.stewart mar 1987             FB77   7
COMPLEX X(99),Y(99),T1,T2,T3,T4#                                        FB77   8
REAL C(99)#                                                             FB77   9
INTEGER F(99)#                                                          FB77  10
INTEGER I,IY,N,N2#                                                      FB77  11
REAL D#                                                                 FB77  12
I=-9; IY=-11#                                                           FB77  13
DO N2=1,7#                                                              FB77  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB77  15
I=I+9; IY=IY+11#                                                        FB77  16
Y(IY+3)=X(I+4)+X(I+7); T2=X(I+3)+X(I+8); T1=X(I+2)+X(I+9)# 209 219      FB77  17
Y(IY+4)=T1-T2; T3=X(I+5)+X(I+6); Y(IY+2)=T3+T1+T2# 239 249 259          FB77  18
Y(IY+6)=T3-T1; Y(IY+5)=T2-T3; Y(IY+1)=X(I+1)+Y(IY+3)+Y(IY+2)# 269 2     FB77  19
Y(IY+8)=X(I+4)-X(I+7); T2=X(I+8)-X(I+3); T1=X(I+2)-X(I+9)# 299 309      FB77  20
Y(IY+9)=T1-T2; T3=X(I+5)-X(I+6); Y(IY+7)=T3+T1+T2# 329 339 349          FB77  21
Y(IY+11)=T3-T1; Y(IY+10)=T2-T3#        359 369                          FB77  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB77  23
DO I=1,11#                                                              FB77  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB77  25
T1=Y(I+11)+Y(I+66); T2=Y(I+22)+Y(I+55); X(I+44)=T2-T1# 201 202 203      FB77  26
T3=Y(I+33)+Y(I+44); X(I+22)=T1-T3; X(I+33)=T3-T2# 204 205 206           FB77  27
X(I+11)=T1+T2+T3; T1=Y(I+11)-Y(I+66); T2=Y(I+22)-Y(I+55)# 207 208 2     FB77  28
X(I+88)=T2-T1; X(I)=Y(I)+X(I+11); T3=Y(I+44)-Y(I+33)# 210 211 212       FB77  29
X(I+66)=T1-T3; X(I+77) =T3-T2; X(I+55)=T1+T2+T3# 213 214 215            FB77  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB77  31
DO N=2,99#                                                              FB77  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB77  33
D=C(N)#                                                                 FB77  34
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  FB77  35
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 FB77  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB77  37
DO I=1,11#                                                              FB77  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB77  39
T1=X(I)+X(I+11); T2=T1+X(I+22)+X(I+33)# 401 402                         FB77  40
T3=X(I+55)+X(I+66)+X(I+77)#            403                              FB77  41
Y(I+66)=T2-T3; Y(I+11)=T3+T2; T2=T1-X(I+22)-X(I+44)# 404 405 406        FB77  42
T3=X(I+55)-X(I+66)-X(I+88);Y(I+55)=T2-T3;Y(I+22)=T3+T2# 407 408 415     FB77  43
T2=T1-X(I+33)+X(I+44); T3=X(I+55)-X(I+77)+X(I+88)# 410 411              FB77  44
Y(I+33)=T2-T3; Y(I+44)=T3+T2; Y(I)=X(I)# 412 413 414                    FB77  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB77  46
I=-9; IY=-11#                                                           FB77  47
DO N2=1,7#                                                              FB77  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB77  49
I=I+9; IY=IY+11#                                                        FB77  50
T4=Y(IY+2)+Y(IY+2); T1=T4+Y(IY+1)+Y(IY+3)# 429 439                      FB77  51
T3=T1+Y(IY+4)+Y(IY+5); T2=Y(IY+8)+Y(IY+9)+Y(IY+10)# 449 459             FB77  52
X(I+2)=T2+T3; X(I+9)=T3-T2; T2=Y(IY+1)+Y(IY+2)+T4# 469 479 489          FB77  53
X(I+7)=T2-Y(IY+7); T4=T1+Y(IY+6)-Y(IY+5)# 499 509                       FB77  54
T3=Y(IY+8)+Y(IY+11)-Y(IY+10)#          519                              FB77  55
X(I+8)=T3+T4; X(I+3)=T4-T3; X(I+4)=T2+Y(IY+7)# 529 539 549              FB77  56
T2=T1-Y(IY+4)-Y(IY+6); T1=Y(IY+8)-Y(IY+9)-Y(IY+11)# 559 569             FB77  57
X(I+5)=T1+T2; X(I+6)=T2-T1; X(I+1)=Y(IY+1)# 579 589 599                 FB77  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB77  59
RETURN#                                                                 FB77  60
END#                                                                    FB77  61
systemheader:(FB78)#                   Winograd's fft suite wfft80      FB78   1
# ################################################################## #  FB78   2
#                                                                    #  FB78   3
#                               FB78                                 #  FB78   4
#                                                                    #  FB78   5
# ################################################################## #  FB78   6
SUBROUTINE FB78(X,Y,C,F)#              J.m.stewart mar 1987             FB78   7
COMPLEX X(108),Y(108),T1,T2,T3,T4,T5,T6#                                FB78   8
REAL C(108)#                                                            FB78   9
INTEGER F(108)#                                                         FB78  10
INTEGER I,IY,N,N1,N2#                                                   FB78  11
REAL D#                                                                 FB78  12
I=-16; IY=-18#                                                          FB78  13
DO N2=1,5#                                                              FB78  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FB78  15
I=I+16; IY=IY+18#                                                       FB78  16
T1=X(I+1)+X(I+9); T2=X(I+5)+X(I+13); T3=T1+T2# 2116 2216 2316           FB78  17
Y(IY+4)=T1-T2; T1=X(I+3)+X(I+11); T2=X(I+7)+X(I+15)# 2416 2516 2616     FB78  18
T4=T1+T2; Y(IY+7)=T1-T2; T5=T3+T4#     2716 2816 2916                   FB78  19
Y(IY+3)=T3-T4; T1=X(I+3)-X(I+11); T2=X(I+7)-X(I+15)# 3016 3116 3216     FB78  20
Y(IY+15)=T1+T2; Y(IY+10)=T1-T2; T1=X(I+2)+X(I+10)# 3316 3416 3516       FB78  21
T2=X(I+6)+X(I+14); T3=T1+T2; T4=T1-T2# 3616 3716 3816                   FB78  22
T1=X(I+4)+X(I+12); T2=X(I+8)+X(I+16); T6=T1+T2# 3916 4016 4116          FB78  23
T1=T1-T2; Y(IY+14)=T4+T1; Y(IY+9)=T4-T1# 4216 4316 4416                 FB78  24
Y(IY+6)=T3-T6; T1=T3+T6; Y(IY+1)=T5+T1# 4516 4616 4716                  FB78  25
Y(IY+2)=T5-T1; T1=X(I+2)-X(I+10); T2=X(I+8)-X(I+16)# 4816 4916 5016     FB78  26
Y(IY+17)=T1+T2; Y(IY+12)=T1-T2; T1=X(I+6)-X(I+14)# 5116 5216 5316       FB78  27
T2=X(I+4)-X(I+12); Y(IY+18)=T1+T2; Y(IY+13)=T1-T2# 5416 5516 5616       FB78  28
Y(IY+5)=X(I+1)-X(I+9); Y(IY+8)=X(I+5)-X(I+13)# 5716 5816                FB78  29
Y(IY+16)=Y(IY+17)+Y(IY+18); Y(IY+11)=Y(IY+12)+Y(IY+13)# 5916 6016       FB78  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FB78  31
DO N1=1,18#                                                             FB78  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FB78  33
T1=Y(N1+18)+Y(N1+72); T2=Y(N1+36)+Y(N1+54)# 201 202                     FB78  34
X(N1+36)=T1-T2; X(N1+18)=T1+T2#        203 204                          FB78  35
X(N1+90)=Y(N1+18)-Y(N1+72); X(N1+72)=Y(N1+54)-Y(N1+36)# 205 206         FB78  36
X(N1)   =X(N1+18)+Y(N1); X(N1+54)=X(N1+90)+X(N1+72)# 207 209            FB78  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FB78  38
DO N=6,108#                                                             FB78  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FB78  40
D=C(N)#                                                                 FB78  41
IF(F(N)>0) X(N)=CMPLX(D*REAL(X(N)),D*AIMAG(X(N)))# 250                  FB78  42
ELSE       X(N)=CMPLX(-D*AIMAG(X(N)),D*REAL(X(N)))# 300                 FB78  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FB78  44
DO N1=1,18#                                                             FB78  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FB78  46
T1=X(N1)+X(N1+18); T2=T1+X(N1+36); T3=X(N1+54)-X(N1+72)# 401 402 40     FB78  47
Y(N1+72)=T2-T3; Y(N1+18)=T2+T3; T2=T1-X(N1+36)# 404 405 406             FB78  48
T3=X(N1+54)+X(N1+90)#                  407                              FB78  49
Y(N1+54)=T2-T3; Y(N1+36)=T2+T3; Y(N1)=X(N1)# 411 409 410                FB78  50
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FB78  51
I=-16; IY=-18#                                                          FB78  52
DO N2=1,5#                                                              FB78  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FB78  54
I=I+16; IY=IY+18#                                                       FB78  55
T1=Y(IY+4)+Y(IY+9); T2=Y(IY+7)+Y(IY+14); X(I+3)=T1+T2# 6516 6616 67     FB78  56
X(I+15)=T1-T2; T1=Y(IY+4)-Y(IY+9); T2=Y(IY+14)-Y(IY+7)# 6816 6916 7     FB78  57
X(I+7)=T1+T2; X(I+11)=T1-T2; T1=Y(IY+5)+Y(IY+10)# 7116 7216 7316        FB78  58
T2=Y(IY+12)-Y(IY+11); T3=T1+T2; T4=T1-T2# 7416 7516 7616                FB78  59
T1=Y(IY+8)+Y(IY+15); T2=Y(IY+16)+Y(IY+17); T5=T1+T2# 7716 7816 7916     FB78  60
T6=T1-T2; X(I+10)=T4+T6; X(I+8)=T4-T6# 8016 8116 8216                   FB78  61
X(I+2)=T3+T5; X(I+16)=T3-T5; X(I+1)=Y(IY+1)# 8316 8416 8516             FB78  62
X(I+5)=Y(IY+3)+Y(IY+6); T1=Y(IY+5)-Y(IY+10)# 8616 8716                  FB78  63
T2=Y(IY+13)-Y(IY+11)#                  8816                             FB78  64
T3=T1+T2; T4=T1-T2; T1=Y(IY+8)-Y(IY+15)# 8916 9016 9116                 FB78  65
T2=Y(IY+16)-Y(IY+18); T5=T1+T2; T6=T1-T2# 9216 9316 9416                FB78  66
X(I+14)=T4+T6; X(I+4)=T4-T6; X(I+6)=T3+T5# 9516 9616 9716               FB78  67
X(I+12)=T3-T5; X(I+9)=Y(IY+2); X(I+13)=Y(IY+3)-Y(IY+6)# 9816 9916 1     FB78  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FB78  69
RETURN#                                                                 FB78  70
END#                                                                    FB78  71
pmacro:([no:])#                        Purge xtal system macros         FB78  72
