systemheader:(LC    )#                 Calculates lattice params.       LC     1
##*****************************************************************##   LC     2
##      Copyright (C) 2000, The Xtal System, The University of        # LC     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # LC     4
## Distributed under the GNU General Public Licence as published by   # LC     5
## the Free Software Foundation, in the hope that it will be useful   # LC     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # LC     7
## for more details.                                                  # LC     8
##                                                                 ##   LC     9
##                      *** LATCON ***                             ##   LC    10
##                                                                 ##   LC    11
##*****************************************************************##   LC    12
#                                                                       LC    13
include:(XMACRO)#                                                       LC    14
#                                                                       LC    15
extrude:(LCCOMN)#                                                       LC    16
INTEGER BDFOUT#                        Update the bdf flag              LC    17
INTEGER ICORR#                         Zero refinement flag             LC    18
INTEGER ICYC#                          Zero refinement cycles           LC    19
INTEGER IGVEC(5)#                                                       LC    20
INTEGER INCREF#                        Variables per reflexion          LC    21
INTEGER IPCH#                          Punch flag                       LC    22
INTEGER ISTOP#                         Pointer to last place in qx      LC    23
INTEGER ISYM#                          Symmetry code                    LC    24
INTEGER ISVEC(5)#                                                       LC    25
INTEGER MARK#                          Pointer to first place in qx     LC    26
INTEGER NREF#                          Number of reflexions stored      LC    27
INTEGER NCREF#                         Number of contributing reflns    LC    28
INTEGER KEY(4),IW(800),IR(801)#        Bdf indexpacket handlers         LC    29
INTEGER STREAM#                        Do/dont stream sx after latcon   LC    30
REAL AMAT(7,14)#                       Normal equation matrix           LC    31
REAL COV(6,12)#                        Variance-covariance matrix       LC    32
REAL MTMAT(3,6)#                       Metric tensor as matrix          LC    33
REAL CORR#                             2-theta zero value               LC    34
REAL MTVEC(9)#                         Metric tensor as vector          LC    35
REAL PVEC(9)#                          Parameter vector                 LC    36
REAL DERIV(6,6)#                       Derivative matrix                LC    37
REAL ESD1(6)#                                                           LC    38
REAL ESD2(9)#                                                           LC    39
REAL GVEC(5)#                                                           LC    40
REAL SIGLAM#                           E.s.d of wavelength              LC    41
REAL WLAM#                             Wavelength                       LC    42
REAL WLAMDF(4)#                        Wavelengths, mean, alpha 1,2,3   LC    43
REAL CVEC(7)#                                                           LC    44
REAL THMIN, THMAX#                     Min/max theta                    LC    45
REAL DATSET#                           Data set number                  LC    46
REAL CELVOL,SIGVOL#                    Cell volume variables            LC    47
COMMON /COMILC/ ICORR,ICYC,IPCH,ISTOP,ISYM,IGVEC,INCREF,ISVEC,MARK,$#   LC    48
NREF,NCREF,BDFOUT,KEY,IW,IR, STREAM#                                    LC    49
COMMON /COMFLC/ AMAT,CORR,COV,CVEC,DERIV,ESD1,ESD2,GVEC,$#              LC    50
MTMAT,MTVEC,PVEC,SIGLAM,WLAM,THMIN,THMAX,DATSET,CELVOL,SIGVOL,$#        LC    51
WLAMDF#                                                                 LC    52
endext:#                                                                LC    53
#                                                                       LC    54
systemheader:(LC00)#                   Latcon main programme            LC00   1
##*****************************************************************##   LC00   2
##                                                                 ##   LC00   3
##                           latcon                                ##   LC00   4
##                                                                 ##   LC00   5
##*****************************************************************##   LC00   6
#                                                                       LC00   7
SUBROUTINE LC00#                       G.s.d. king 10.05.89             LC00   8
## A general program for the LS-refinement of lattice constants. this   LC00   9
## is a one-pass non-iterative program which determines the ls-values   LC00  10
## of the reciprocal metric tensor and its variance-covariance matrix.  LC00  11
## constraints due to symmetry may be introduced. input is h, k, l,     LC00  12
## 2-theta, sigma of 2-theta. from this, the appropriate weight for     LC00  13
## 1/d**2 (d = spacing of lattice planes) is calculated.                LC00  14
#                                                                       LC00  15
## Based on the program LATCON written for the XRAY76 system by         LC00  16
## D. Schwarzenbach ETH-Zuerich. the main parts of this program         LC00  17
## were copied from a similar IBM-1620 program by                       LC00  18
## D. Schwarzenbach (Pittsburgh, PA. 1966).       Christmas 1971.       LC00  19
#                                                                       LC00  20
include:(AACOMN)#                                                       LC00  21
include:(LCCOMN)#                                                       LC00  22
#                                                                       LC00  23
CALL LC01#                             Decode latcon line, initialise   LC00  24
CALL LC02#                             Calculate parameters             LC00  25
IF(BDFOUT==yes:)CALL LC04#             Update the bdf                   LC00  26
RETURN#                                                                 LC00  27
END#                                                                    LC00  28
#                                                                       LC00  29
systemheader:(LC01)#                   Decode latcon line, initialise   LC01   1
##*****************************************************************##   LC01   2
##                                                                 ##   LC01   3
##                           lc01                                  ##   LC01   4
##                                                                 ##   LC01   5
##*****************************************************************##   LC01   6
SUBROUTINE LC01#                                                        LC01   7
include:(AACOMN)#                                                       LC01   8
include:(LCCOMN)#                                                       LC01   9
INTEGER I,IP,J,JP,K,MM,N#                                               LC01  10
REAL WLAMSQ#                           4.0/wavelength**2                LC01  11
chardata:(LC11,TR MC MB MA OR TE HE RH CU MO WL SW TZ RQ $#             LC01  12
RZ PU BI BO DS ZF )#                                                    LC01  13
chardata:(LC12,TRICLINIC     MONOCLINIC    ORTHORHOMBIC  $#             LC01  14
TETRAGONAL    HEXAGONAL     RHOMBOHEDRAL  CUBIC         $#              LC01  15
 C-AXIS UNIQUE B-AXIS UNIQUE A-AXIS UNIQUE)#                            LC01  16
chardata:(LC13, SYSTEM                            )#                    LC01  17
chardata:(LC14,[ WAVELENGTH ESD X.YYYYYA, INITIAL ZERO X.YYY DEG.])#    LC01  18
chardata:(LC15, TWO-THETA ZERO WILL BE REFINED FROM A STARTING VALUE$#  LC01  19
 OF X.YYY)#                                                             LC01  20
chardata:(LC16, Q-VALUES WILL BE REFINED FOR NN CYCLES)#                LC01  21
chardata:(LC18,THETA  SKIP  END    )#                                   LC01  22
chardata:(LC19, DATA INPUT FROM DATASET XX OF THE BDF.)#                LC01  23
chardata:(LC20, CELL PARAMETERS OUTPUT TO DATASET XX OF THE BDF.)#      LC01  24
realdata:(FMT1,[80852.,230852.,440632.,320303.])#                       LC01  25
realdata:(FMT2,620532.)#                                                LC01  26
realdata:(GII,[0.0,0.0,0.0,0.0,0.0, 0.0,0.0,0.0,0.0,0.0,$#              LC01  27
0.0,0.0,0.0,0.0,0.0, 0.0,0.0,0.0,0.0,0.0, 0.0,0.0,0.0,0.0,0.0, $#       LC01  28
1.0,0.0,0.0,0.0,0.0, 1.0,0.5,0.0,0.0,0.0, 1.0,1.0,1.0,1.0,0.0, $#       LC01  29
1.0,1.0,0.0,0.0,0.0])#                                                  LC01  30
intdata:(IIS,[0,0,0,0,0, 5,6,0,0,0, 4,6,0,0,0, 4,5,0,0,0, 4,5,6,0,0,$#  LC01  31
2,4,5,6,0, 2,4,5,6,0, 2,3,5,6,0, 2,3,4,5,6])#                           LC01  32
intdata:(IIG,[0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0, 0,0,0,0,0,$#  LC01  33
1,0,0,0,0, 1,1,0,0,0, 1,1,4,4,0, 1,1,0,0,0])#                           LC01  34
intdata:(CSYS,[1,3,5,6,7,8,7,9])#                                       LC01  35
intdata:(BDFIN,no:)#                                                    LC01  36
datastuff:#                                                             LC01  37
#                                                                       LC01  38
# SET UP I/O BUFFER FOR BDF AND ASK FOR MEMORY                          LC01  39
# --------------------------------------------                          LC01  40
#                                                                       LC01  41
IOMARK(1)=QXSTR#                       Save buffer for input bdf        LC01  42
IOMARK(2)=IOMARK(1)+bdfbuf:#           Save buffer for output bdf       LC01  43
MARK=IOMARK(2)+bdfbuf:+1#                                               LC01  44
INCREF = 10#                                                            LC01  45
incrqx:(ISTOP,100*INCREF+MARK,LC0100)#                                  LC01  46
#                                                                       LC01  47
#DECODE LATCON LINE PARAMETERS                                          LC01  48
#                                                                       LC01  49
BDFOUT=no:;DATSET=1.#                                                   LC01  50
STREAM=yes:#                           Stream startx afterwards         LC01  51
ICORR=0;ICYC=1;IPCH=0;ISYM=1#                                           LC01  52
CORR=0.0;SIGLAM=0.0;WLAM=1.54182#                                       LC01  53
FOR (I=1;I<30;I=I+1)#                  Loop over input fields           LC01  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LC01  55
ifvo:(BUFIN(I)) BREAK#                 Exit after last field            LC01  56
IF (BUFIN(I)<voidflg:)#                                                 LC01  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LC01  58
stringlim:(I,J,K)#                     Character field; get limits      LC01  59
compchar:(CHRIN,J,LC11,1,2,3,NLC11,K)#                                  LC01  60
IF (K==0) iquit:(LC0101,I)#            Dud field........lc0101          LC01  61
IF (K==10) K=3#                        Monoclinic, assume b unique      LC01  62
IF (K<10) ISYM = K#                    Symmetry code                    LC01  63
ELSE IF (K==11)#                       Wavelength                       LC01  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LC01  65
WLAM = BUFIN(I+1)#                                                      LC01  66
I=I+1#                                                                  LC01  67
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LC01  68
ELSE IF (K==12)#                       S.d. of wavelength               LC01  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LC01  70
SIGLAM = BUFIN(I+1)#                                                    LC01  71
I=I+1#                                                                  LC01  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LC01  73
ELSE IF (K==13)#                       Two-theta zero                   LC01  74
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LC01  75
CORR=BUFIN(I+1)#                                                        LC01  76
I=I+1#                                                                  LC01  77
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LC01  78
ELSE IF (K==14)#                       Refine q                         LC01  79
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LC01  80
IF (ICORR!=0) iquit:(LC0102)#          Cannot refine both q and zero    LC01  81
ICORR = -1#                                                             LC01  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LC01  83
ELSE IF (K==15)#                       Refine two-theta zero            LC01  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LC01  85
IF (ICORR!=0) iquit:(LC0102)#          Cannot refine both q and zero    LC01  86
IF (BUFIN(I+1)>voidflg:)#                                               LC01  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LC01  88
ICORR=NINT(BUFIN(I+1))#                Number of cycles                 LC01  89
I=I+1#                                                                  LC01  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LC01  91
ELSE ICORR = 4#                        Default 4 cycles                 LC01  92
ICYC = ICORR#                                                           LC01  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LC01  94
ELSE IF (K==16) IPCH=1#                Punch cell and cellsd            LC01  95
ELSE IF (K==17) BDFIN=yes:#            Get data from bdf                LC01  96
ELSE IF (K==18) BDFOUT=yes:#           Update the bdf                   LC01  97
ELSE IF (K==19)#                       Data set number                  LC01  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LC01  99
I=I+1#                                                                  LC01 100
ifnm:(BUFIN(I)) IF(BUFIN(I)>0.) DATSET=BUFIN(I)#                        LC01 101
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LC01 102
ELSE IF (K==20) STREAM=no:#            Don't stream startx              LC01 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LC01 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LC01 105
#                                                                       LC01 106
# READ DATA FROM BDF                                                    LC01 107
#                                                                       LC01 108
IF(BDFIN==yes:)#                                                        LC01 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 LC01 110
readwpkt:(1,lrsymm:,JP,IP,0)#          Lrsymm: first packet             LC01 111
ifnm:(QX(IP+9)) ISYM=NINT(QX(IP+9))#   Bdf version of crystal system    LC01 112
ISYM=CSYS(ISYM)#                       Convert to latcon coding         LC01 113
DO I=1,4; IW(I)=I+1#                   Wavelengths mean,1,2,3           LC01 114
DO I=1,4; WLAMDF(I)=1.0#               Set to stupid value              LC01 115
KEY(1)=0; KEY(2)=4; KEY(3)=0; KEY(4)=0# Set search limits               LC01 116
indexpkt:(1,lrexpl:,JP,IP,0,KEY,IW,IR)# Get relative pointers           LC01 117
readwpkt:(1,lrexpl:,JP,IP,0)#          Point to experimental packet     LC01 118
DO I=1,4; IF(IR(I)>0) $#               Install the wavelengths          LC01 119
ifnm:(QX(IP+IR(I))) WLAMDF(I)=QX(IP+IR(I))# Wavelength                  LC01 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 LC01 121
#                                                                       LC01 122
# CHECK INPUT AND ECHO                                                  LC01 123
#                                                                       LC01 124
IF (ISYM==1) J = 1#                    Triclinic                        LC01 125
ELSE IF ((ISYM>=2)&(ISYM<=4))#         Monoclinic                       LC01 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 LC01 127
J = 15#                                                                 LC01 128
movechar:(LC12,14*ISYM+71,LC13,22,14,0)#                                LC01 129
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 LC01 130
ELSE J = (ISYM-3)*14+1#                                                 LC01 131
movechar:(LC12,J,LC13,9,14,0)#                                          LC01 132
writeline:(1,LC13,NLC13,3,3)#                                           LC01 133
BUFOT(1) = SIGLAM#                                                      LC01 134
BUFOT(2) = CORR#                                                        LC01 135
LINRM = 4#                                                              LC01 136
ncodefld:(BUFOT,1,LC14,FMT1(2),2)#                                      LC01 137
writeline:(1,LC14,NLC14,3,3)#                                           LC01 138
IF (ICORR<0)#                                                           LC01 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 LC01 140
ncodefld:(CORR,1,LC15,FMT2,1)#                                          LC01 141
writeline:(1,LC15,NLC15,3,3)#                                           LC01 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 LC01 143
ELSE IF (ICORR>0)#                                                      LC01 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 LC01 145
BUFOT(1) = FLOAT(ICORR)#                                                LC01 146
ncodefld:(BUFOT,1,LC16,FMT1(4),1)#                                      LC01 147
writeline:(1,LC16,NLC16,3,3)#                                           LC01 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 LC01 149
ncodefld:(DATSET,1,LC19,270213.,1)#    Insert dataset number            LC01 150
IF(BDFIN==yes:) writeline:(1,LC19,NLC19,3,3)#                           LC01 151
ncodefld:(DATSET,1,LC20,370213.,1)#    Insert dataset number            LC01 152
IF(BDFOUT==yes:) writeline:(1,LC20,NLC20,3,3)#                          LC01 153
#                                                                       LC01 154
## initialise arrays and storage                                        LC01 155
#                                                                       LC01 156
J = (ISYM-1)*5#                                                         LC01 157
DO I=1,5#                                                               LC01 158
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 LC01 159
ISVEC(I) = IIS(I+J)#                                                    LC01 160
IGVEC(I) = IIG(I+J)#                                                    LC01 161
GVEC(I) = GII(I+J)#                                                     LC01 162
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 LC01 163
WLAMSQ = 4.0/(WLAM*WLAM)#                                               LC01 164
#                                                                       LC01 165
NREF = 0#                                                               LC01 166
#                                                                       LC01 167
## read and store data for one reflexion                                LC01 168
#                                                                       LC01 169
MM = MARK-INCREF-1#                                                     LC01 170
IF(BDFIN==yes:)#                       Read angles from bdf             LC01 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 LC01 172
REPEAT#                                                                 LC01 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 LC01 174
readwpkt:(1,lrthet:,JP,IP,0)#          Point to experimental packet     LC01 175
IF(IP<=0)BREAK#                                                         LC01 176
ifne:(DATSET,QX(IP+1)) NEXT#           Use specified data set only      LC01 177
NREF = NREF+1; MM = MM+INCREF#                                          LC01 178
IF (MM>=ISTOP) incrqx:(ISTOP,ISTOP+100*INCREF,LC0104)# L                LC01 179
movereal:(QX,IP+2,QX,MM+1,4,0)#        Get h k l 2theta                 LC01 180
N=NINT(QX(IP+6))+1#                    Pointer to wavelength            LC01 181
QX(MM+5) = 0.01#                                                        LC01 182
QX(MM+6) = 4.0/WLAMDF(N)**2#                                            LC01 183
QX(MM+9) = 1.0#                        Use (don't skip) this measure    LC01 184
QX(MM+10)= WLAMDF(N)#                  Wavelength for printing          LC01 185
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 LC01 186
readwpkt:(1,endrecord:,JP,IP,0)#       Close off archive file           LC01 187
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 LC01 188
#                                                                       LC01 189
REPEAT#                                                                 LC01 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 LC01 191
readline:(LC18,NLC18)#                                                  LC01 192
IF (LINID==1)#                         A theta line                     LC01 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 LC01 194
NREF = NREF+1#                                                          LC01 195
MM = MM+INCREF#                                                         LC01 196
IF (MM>=ISTOP) incrqx:(ISTOP,ISTOP+100*INCREF,LC0104)# L                LC01 197
IF (BUFIN(4)<=CORR) NEXT#              Non-positive theta               LC01 198
DO I=1,4#                                                               LC01 199
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 LC01 200
QX(MM+I) = BUFIN(I)#                                                    LC01 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 LC01 202
ifvo:(BUFIN(5)) QX(MM+5) = 0.1#                                         LC01 203
ELSE            QX(MM+5) = BUFIN(5)#                                    LC01 204
ifvo:(BUFIN(6)) QX(MM+6) = WLAMSQ#                                      LC01 205
ELSE            QX(MM+6) = 4.0/BUFIN(6)**2#                             LC01 206
ifvo:(BUFIN(9)) QX(MM+9) = 1.0#                                         LC01 207
ELSE            QX(MM+9) = BUFIN(9)#                                    LC01 208
ifvo:(BUFIN(6)) QX(MM+10) = WLAM#                                       LC01 209
ELSE            QX(MM+10) = BUFIN(6)#                                   LC01 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 LC01 211
ELSEIF(LINID==2)#                      Skip line                        LC01 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 LC01 213
FOR (I=1;;I=I+1)#                                                       LC01 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 LC01 215
ifvo:(BUFIN(I)) BREAK#                                                  LC01 216
J=NINT(BUFIN(I))-1#                                                     LC01 217
IF ((J<NREF)&(J>=0)) QX(MARK+J*INCREF+8)=0.0# Skip this reflection      LC01 218
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 LC01 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 LC01 220
ELSE BREAK#                            End line                         LC01 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 LC01 222
ISTOP = MM+INCREF#                     Set to last place in qx          LC01 223
#                                                                       LC01 224
RETURN#                                                                 LC01 225
END#                                                                    LC01 226
#                                                                       LC01 227
systemheader:(LC02)#                   Calculate parameters             LC02   1
##*****************************************************************##   LC02   2
##                                                                 ##   LC02   3
##                           lc02                                  ##   LC02   4
##                                                                 ##   LC02   5
##*****************************************************************##   LC02   6
SUBROUTINE LC02#                                                        LC02   7
include:(AACOMN)#                                                       LC02   8
include:(LCCOMN)#                                                       LC02   9
#                                                                       LC02  10
INTEGER I,J,K,L,M,N#                                                    LC02  11
INTEGER ISW#                                                            LC02  12
INTEGER NPARM#                         Number of parameters refined     LC02  13
REAL AJUNK,DELTA,DESD,ESD#                                              LC02  14
REAL FREE#                             Number of degrees of freedom     LC02  15
REAL DK#                                                                LC02  16
REAL Q#                                4.0*sin**2(theta)/lambda**2      LC02  17
REAL QCALC#                            Q calculated from cell pars      LC02  18
REAL R#                                                                 LC02  19
REAL SIGLQ#                                                             LC02  20
REAL SIGSQ#                            E.s.d.of q**2???????             LC02  21
REAL SIGTH#                            E.s.d in 2-theta                 LC02  22
REAL SINT#                             Sin(theta)                       LC02  23
REAL THETAC#                           Calculated 2-theta               LC02  24
REAL TWOTH#                            Corrected 2-theta                LC02  25
REAL WEIGHT#                                                            LC02  26
REAL WLAMSQ#                           4.0/lambda**2                    LC02  27
REAL CAVAR(4)#                         Cell covariances                 LC02  28
chardata:(LC22, THIS IS TOO FEW TO SOLVE FOR X PARAMETERS)#             LC02  29
chardata:(LC23, 2-THETA-ZERO HAS BEEN CHANGED BY XXX.XXX$#              LC02  30
 TO YYY.YYY DEG.)#                                                      LC02  31
chardata:(LC24, THE CORRELATIONS WITH THE ELEMENTS OF THE RECIPROCAL$#  LC02  32
 METRIC TENSOR are:)#                                                   LC02  33
chardata:(LC25, MEASURED AND COMPUTED 2-THETA ANGLES AND Q-VALUES $#    LC02  34
   * SKIPPED REFLECTIONS)#                                              LC02  35
chardata:(LC26, 2THETA-TRUE = 2THETA-OBS - CORR. CORR =XXX.XXX)#        LC02  36
chardata:(LC27,[ FOR ICORR = -1, 2THETA-CALC AND Q-CALC ARE NOT THE $#  LC02  37
"TRUE" VALUES BUT ARE DERIVED FROM Q-TRUE + CORRECTION TERM])#          LC02  38
chardata:(LC28,  NR    H   K   L    WAVELNG  2T(OBS)  2T(TRUE)$#        LC02  39
   2T(CAL)   2T(DIF)   2T(ESD)   DIF/ESD    Q(OBS)    Q(CAL))#          LC02  40
chardata:(LC29, ERROR OF FIT XXXXX.XXXX FOR XXXXX DEGREES OF FREEDOM)#  LC02  41
chardata:(LC210, THE E.S.D. OF 2-THETA-ZERO ISWWWW.WWWWW)#              LC02  42
chardata:(LC211, THE CORRECTION COEFFICIENT (ICORR =-1) IS$#            LC02  43
12345678901234 WITH E.S.D.XXXX.XXXXX)#                                  LC02  44
chardata:(LC212, AND WITH CORRELATION COEFFICIENTS AA.AAAA BB.BBBB$#    LC02  45
 CC.CCCC DD.DDDD EE.EEEE FF.FFFF)#                                      LC02  46
chardata:(LC213, A RELATIVE ERROR OF X.XXX PERCENT IN THE WAVELENGTH$#  LC02  47
 IS USED TO CORRECT THE STANDARD DEVIATIONS.)#                          LC02  48
chardata:(LC214, ----------------------------------------------------$# LC02  49
---------------------------------------------------------------------)# LC02  50
chardata:(LC215, RECIPROCAL ELEMENTS)#                                  LC02  51
chardata:(LC216, DIRECT ELEMENTS)#                                      LC02  52
chardata:(LC217,CELLSD)#                                                LC02  53
chardata:(LC218,*)#                                                     LC02  54
chardata:(LC219, CELL VOLUME   XXXXX.XX)#                               LC02  55
realdata:(CON,[0.008726647,0.017453294])#                               LC02  56
realdata:(FMT1,60503.)#                                                 LC02  57
realdata:(FMT2,31013.)#                                                 LC02  58
realdata:(FMT3,[410832.,520832.])#                                      LC02  59
realdata:(FMT4,[100952.,200952.,300952.,400952.,500952.,600952.])#      LC02  60
realdata:(FMT6,470832.)#                                                LC02  61
realdata:(FMT8,[40313.,90413.,130413.,170413.,270752.,370932.,$#        LC02  62
471032.,571032.,671032.,771032.,871032.,971062.,1071062.])#             LC02  63
realdata:(FMT9,[241042.,340513.])#                                      LC02  64
realdata:(FMT10,401052.)#                                               LC02  65
realdata:(FMT11,[561461.,781052.])#                                     LC02  66
realdata:(FMT12,[420842.,500842.,580842.,660842.,740842.,820842.])#     LC02  67
realdata:(FMT13,260632.)#                                               LC02  68
realdata:(FMT14,[181042.,281042.,381042.,491032.,591032.,691032.])#     LC02  69
realdata:(FMT15,231022.)#                                               LC02  70
datastuff:#                                                             LC02  71
#                                                                       LC02  72
REPEAT#                                                                 LC02  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LC02  74
IF (ICYC>0)#                                                            LC02  75
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LC02  76
DO I=1,7#                                                               LC02  77
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LC02  78
DO J=1,14; AMAT(I,J) = 0.0#                                             LC02  79
CVEC(I) = 0.0#                                                          LC02  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LC02  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LC02  82
NCREF=0#                               Count contributing reflns        LC02  83
THMIN=90.;THMAX=0.#                    Minimum/maximum theta            LC02  84
DO K=MARK,ISTOP,INCREF#                                                 LC02  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LC02  86
TWOTH = QX(K+3)-CORR#                                                   LC02  87
SIGTH = QX(K+4)#                                                        LC02  88
WLAMSQ = QX(K+5)#                                                       LC02  89
SINT = SIN(CON(2)*TWOTH)#                                               LC02  90
Q = WLAMSQ*(SIN(CON(1)*TWOTH)**2)#                                      LC02  91
#                                                                       LC02  92
## siglam may not be included here (it comes later)                     LC02  93
#                                                                       LC02  94
SIGSQ = (WLAMSQ*SINT*CON(1)*SIGTH)**2#                                  LC02  95
IF (SIGSQ<0.0) SIGSQ = 0.0001*Q*Q#                                      LC02  96
QX(K+6) = Q#                                                            LC02  97
WEIGHT = 1.0/SIGSQ#                                                     LC02  98
QX(K+7) = WEIGHT#                                                       LC02  99
IF(NINT(QX(K+8))==1)#                                                   LC02 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LC02 101
NCREF=NCREF+1#                         Count contributing reflns        LC02 102
THMIN=AMIN1(0.5*QX(K+3),THMIN)#                                         LC02 103
THMAX=AMAX1(0.5*QX(K+3),THMAX)#                                         LC02 104
IF (ICYC>0)#                           Build matrix                     LC02 105
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LC02 106
DO J=1,3#                                                               LC02 107
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LC02 108
MTVEC(J) = QX(K+J-1)**2#                                                LC02 109
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LC02 110
MTVEC(4) = 2.0*QX(K)*QX(K+1)#                                           LC02 111
MTVEC(5) = 2.0*QX(K+2)*QX(K)#                                           LC02 112
MTVEC(6) = 2.0*QX(K+1)*QX(K+2)#                                         LC02 113
IF (ICORR!=0)#                                                          LC02 114
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LC02 115
MTVEC(7) = WLAMSQ*SINT#                                                 LC02 116
IF (ICORR<0) MTVEC(7) = MTVEC(7)*SINT#                                  LC02 117
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LC02 118
ELSE MTVEC(7) = 0.0#                                                    LC02 119
DO I=1,7#                                                               LC02 120
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LC02 121
DO J=1,7#                                                               LC02 122
AMAT(I,J) = AMAT(I,J)+WEIGHT*MTVEC(I)*MTVEC(J)#                         LC02 123
CVEC(I) = CVEC(I)+WEIGHT*MTVEC(I)*Q#                                    LC02 124
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LC02 125
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LC02 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LC02 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LC02 128
IF (ICYC<=0) BREAK#                                                     LC02 129
#                                                                       LC02 130
## introduce symmetry constraints                                       LC02 131
#                                                                       LC02 132
DO I=1,7; AMAT(I,I+7) = 1.0#                                            LC02 133
NPARM = 7#                                                              LC02 134
DO I=1,5#                                                               LC02 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 LC02 136
K = ISVEC(I)#                                                           LC02 137
J = IGVEC(I)#                                                           LC02 138
IF (K!=0)#                                                              LC02 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 LC02 140
IF (J!=0)#                                                              LC02 141
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 LC02 142
DO L=1,7#                                                               LC02 143
AMAT(L,J) = AMAT(L,J)+GVEC(I)*AMAT(L,K)#                                LC02 144
DO L=1,7#                                                               LC02 145
AMAT(J,L) = AMAT(J,L)+GVEC(I)*AMAT(K,L)#                                LC02 146
CVEC(J) = CVEC(J)+GVEC(I)*CVEC(K)#                                      LC02 147
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 LC02 148
DO L=1,7#                                                               LC02 149
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 LC02 150
AMAT(L,K) = 0.0#                                                        LC02 151
AMAT(K,L) = 0.0#                                                        LC02 152
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 LC02 153
CVEC(K) = 0.0#                                                          LC02 154
AMAT(K,K+7) = 0.0#                                                      LC02 155
NPARM = NPARM-1#                                                        LC02 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 LC02 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 LC02 158
IF (ICORR==0)#                                                          LC02 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 LC02 160
AMAT(7,7) = 1.0#                                                        LC02 161
NPARM = NPARM-1#                                                        LC02 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 LC02 163
#                                                                       LC02 164
## are there enough observations?                                       LC02 165
#                                                                       LC02 166
IF (NCREF<NPARM)#                                                       LC02 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 LC02 168
BUFOT(1) = FLOAT(NCREF)#                                                LC02 169
ncodefld:(BUFOT,1,LC22,FMT2,1)#                                         LC02 170
writeline:(0,LC22,NLC22,3,3)#                                           LC02 171
iquit:(LC0201)#                        L                                LC02 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 LC02 173
#                                                                       LC02 174
## invert amat(i,j) taking into account zero rows and columns           LC02 175
## for dependent variables                                              LC02 176
#                                                                       LC02 177
DO N=1,7#                                                               LC02 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 LC02 179
ISW = 0#                                                                LC02 180
DO K=1,5#                                                               LC02 181
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 LC02 182
IF(ISVEC(K)==N) ISW = 1#                                                LC02 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 LC02 184
IF (ISW==0)#                                                            LC02 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 LC02 186
IF (AMAT(N,N)==0) iquit:(LC0202)#      L                                LC02 187
AJUNK = 1.0/AMAT(N,N)#                                                  LC02 188
DO J=1,14; AMAT(N,J) = AMAT(N,J)*AJUNK#                                 LC02 189
DO I=1,6#                                                               LC02 190
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 LC02 191
M = N+I#                                                                LC02 192
IF (M>7) M = M-7#                                                       LC02 193
ISW = 0#                                                                LC02 194
DO K=1,5#                                                               LC02 195
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 LC02 196
IF (ISVEC(K)==M) ISW = 1#                                               LC02 197
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 LC02 198
IF (ISW==0)#                                                            LC02 199
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 LC02 200
AJUNK = AMAT(M,N)#                                                      LC02 201
DO J=1,14; AMAT(M,J) = AMAT(M,J)-AMAT(N,J)*AJUNK#                       LC02 202
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 LC02 203
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 LC02 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 LC02 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 LC02 206
#                                                                       LC02 207
## inverse matrix now in amat(i,j),i=1,7, j=8,14                        LC02 208
#                                                                       LC02 209
## calculate reciprocal metric tensor                                   LC02 210
#                                                                       LC02 211
DO I=1,7#                                                               LC02 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 LC02 213
MTVEC(I) = 0.0#                                                         LC02 214
DO J=1,7; MTVEC(I) = MTVEC(I)+AMAT(I,J+7)*CVEC(J)#                      LC02 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 LC02 216
#                                                                       LC02 217
## calculate solution vector                                            LC02 218
#                                                                       LC02 219
DO I=1,5#                                                               LC02 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 LC02 221
K = ISVEC(I)#                                                           LC02 222
J = IGVEC(I)#                                                           LC02 223
IF (K!=0)#                                                              LC02 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 LC02 225
IF (J!=0)#                                                              LC02 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 LC02 227
MTVEC(K) = GVEC(I)*MTVEC(J)#                                            LC02 228
DO L=1,7#                                                               LC02 229
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 LC02 230
AMAT(K,L+7) = GVEC(I)*AMAT(J,L+7)#                                      LC02 231
AMAT(L,K+7) = GVEC(I)*AMAT(L,J+7)#                                      LC02 232
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 LC02 233
AMAT(K,K+7) = AMAT(J,J+7)*GVEC(I)*GVEC(I)#                              LC02 234
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 LC02 235
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 LC02 236
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 LC02 237
#                                                                       LC02 238
## first part of old 1620 (god rest its soul) programme finished        LC02 239
## in mtvec we have the reciprocal metric tensor                        LC02 240
ESD = AMAT(7,14)#                                                       LC02 241
DO I=1,6#                                                               LC02 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 LC02 243
CVEC(I) = 0.0#                                                          LC02 244
AJUNK = ESD*AMAT(I,I+7)#                                                LC02 245
IF (AJUNK>0.0) CVEC(I) = AMAT(7,I+7)/SQRT(AJUNK)#                       LC02 246
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 LC02 247
IF (ICORR<=0) BREAK#                                                    LC02 248
#                                                                       LC02 249
## is there an appreciable change in 2-theta zero                       LC02 250
## this is a shortened iterative procedure to get this one parameter.   LC02 251
#                                                                       LC02 252
DK = MTVEC(7)/CON(1)#                                                   LC02 253
CORR = CORR+DK#                                                         LC02 254
BUFOT(1) = DK#                                                          LC02 255
BUFOT(2) = CORR#                                                        LC02 256
ncodefld:(BUFOT,1,LC23,FMT3,2)#                                         LC02 257
LINRM = 3#                                                              LC02 258
writeline:(1,LC23,NLC23,3,3)#                                           LC02 259
writeline:(0,LC24,NLC24,3,4)#                                           LC02 260
ncodefld:(CVEC,1,CHROT,FMT4,6)#                                         LC02 261
writeline:(0,0,0,1,4)#                                                  LC02 262
ICYC = ICYC-1#                                                          LC02 263
IF (ABS(DK)<0.002) ICYC = 0#                                            LC02 264
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LC02 265
# CALCULATE Q, 2-THETA AND WEIGHTED RESIDUALS                           LC02 266
R = 0.0#                                                                LC02 267
DK = MTVEC(7)#                                                          LC02 268
ncodefld:(CORR ,1,LC26,FMT6,1)#                                         LC02 269
writeline:(1,LC26,NLC26,3,4)#                                           LC02 270
IF (ICORR<1)#                                                           LC02 271
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 LC02 272
writeline:(1,LC27,NLC27,3,4)#                                           LC02 273
writeline:(1,LC28,NLC28,3,4)#                                           LC02 274
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 LC02 275
LINRM = 6#                                                              LC02 276
movechar:(LC214,2,CHROT,2,NLC25-1,2)#  Underline header                 LC02 277
writeline:(1,LC25,NLC25,2,3)#                                           LC02 278
#                                                                       LC02 279
MTMAT(1,1) = MTVEC(1)#                                                  LC02 280
MTMAT(1,2) = MTVEC(4)#                                                  LC02 281
MTMAT(1,3) = MTVEC(5)#                                                  LC02 282
MTMAT(2,1) = MTVEC(4)#                                                  LC02 283
MTMAT(2,2) = MTVEC(2)#                                                  LC02 284
MTMAT(2,3) = MTVEC(6)#                                                  LC02 285
MTMAT(3,1) = MTVEC(5)#                                                  LC02 286
MTMAT(3,2) = MTVEC(6)#                                                  LC02 287
MTMAT(3,3) = MTVEC(3)#                                                  LC02 288
DO I=MARK,ISTOP,INCREF#                                                 LC02 289
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 LC02 290
QCALC = 0.0#                                                            LC02 291
WLAMSQ = QX(I+5)#                                                       LC02 292
TWOTH = QX(I+3)-CORR#                                                   LC02 293
DO J=1,3#                                                               LC02 294
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 LC02 295
DO K=1,3#                                                               LC02 296
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 LC02 297
QCALC = QCALC+MTMAT(J,K)*QX(I+J-1)*QX(I+K-1)#                           LC02 298
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 LC02 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 LC02 300
IF (ICORR<0) QCALC = QCALC+WLAMSQ*DK*(SIN(CON(2)*TWOTH)**2)#            LC02 301
SINT = SQRT(QCALC/WLAMSQ)#                                              LC02 302
THETAC = ASIN(SINT)/CON(1)#                                             LC02 303
DELTA = TWOTH-THETAC#                                                   LC02 304
DESD = DELTA/QX(I+4)#                                                   LC02 305
IF(NINT(QX(I+8))==0)#                  Skipped reflection               LC02 306
movechar:(LC218,1,CHROT,18,1,0)#       Mark with a *                    LC02 307
ELSE#                                  Acceptable reflection            LC02 308
R = R+QX(I+7)*((QX(I+6)-QCALC)**2)#                                     LC02 309
# WRITE THIS REFLEXION                                                  LC02 310
BUFOT(1) = 1+(I-MARK)/INCREF#                                           LC02 311
BUFOT(2) = QX(I)#                                                       LC02 312
BUFOT(3) = QX(I+1)#                    K                                LC02 313
BUFOT(4) = QX(I+2)#                    L                                LC02 314
BUFOT(5) = QX(I+9)#                    Wavelength                       LC02 315
BUFOT(6) = QX(I+3)#                    2-theta obs                      LC02 316
BUFOT(7) = TWOTH#                                                       LC02 317
BUFOT(8) = THETAC#                                                      LC02 318
BUFOT(9) = DELTA#                                                       LC02 319
BUFOT(10) = QX(I+4)#                   E.s.d                            LC02 320
BUFOT(11) = DESD#                                                       LC02 321
BUFOT(12)= QX(I+6)#                    Qobs                             LC02 322
BUFOT(13)= QCALC#                                                       LC02 323
ncodefld:(BUFOT,1,CHROT,FMT8,13)#                                       LC02 324
writeline:(0,LC28,NLC28,1,3)#                                           LC02 325
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 LC02 326
#                                                                       LC02 327
## finally get the variance-covariance matrix                           LC02 328
#                                                                       LC02 329
FREE = NCREF-NPARM#                                                     LC02 330
IF (NCREF>NPARM) R=R/FREE#                                              LC02 331
DO I=1,7#                                                               LC02 332
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 LC02 333
DO J=1,7#                                                               LC02 334
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 LC02 335
AMAT(I,J) = R*AMAT(I,J+7)#                                              LC02 336
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 LC02 337
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 LC02 338
BUFOT(1) = SQRT(R)#                                                     LC02 339
BUFOT(2) = FREE#                                                        LC02 340
ncodefld:(BUFOT,1,LC29,FMT9,2)#                                         LC02 341
writeline:(1,LC29,NLC29,3,3)#                                           LC02 342
BUFOT(2) = SQRT(AMAT(7,7))#                                             LC02 343
IF (ICORR>0)#                                                           LC02 344
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 LC02 345
BUFOT(2) = BUFOT(2)/CON(1)#                                             LC02 346
ncodefld:(BUFOT,2,LC210,FMT10,1)#                                       LC02 347
writeline:(1,LC210,NLC210,3,3)#                                         LC02 348
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 LC02 349
ELSE IF (ICORR<0)#                                                      LC02 350
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 LC02 351
BUFOT(1) = DK#                                                          LC02 352
DO I=1,6#                                                               LC02 353
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 LC02 354
BUFOT(I+2) = CVEC(I)#                                                   LC02 355
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 LC02 356
ncodefld:(BUFOT,1,LC211,FMT11,2)#                                       LC02 357
LINRM = 3#                                                              LC02 358
writeline:(1,LC211,NLC211,3,3)#                                         LC02 359
ncodefld:(BUFOT,3,LC212,FMT12,6)#                                       LC02 360
writeline:(1,LC212,NLC212,3,3)#                                         LC02 361
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 LC02 362
#                                                                       LC02 363
## now we have reciprocal metric tensor and var-covar matrix.           LC02 364
#                                                                       LC02 365
##  an uncertainty in the wavelength -siglam- introduces a relative     LC02 366
##  error in q, namely 2*(siglam/wlam). the same relative error is      LC02 367
##  introduced in the components of the metric tensor, i.e. the         LC02 368
##  variances have to be corrected by adding                            LC02 369
##  (2*(siglam/wlam)*component))**2. The covariances are corrected      LC02 370
##  so that the correlations remain unchanged.                          LC02 371
#                                                                       LC02 372
SIGLQ = 0.0#                                                            LC02 373
IF (SIGLAM>0.0)#                                                        LC02 374
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 LC02 375
SIGLQ = (2.0*SIGLAM)/WLAM#                                              LC02 376
BUFOT(1) = (SIGLAM/WLAM)*100.0#                                         LC02 377
ncodefld:(BUFOT,1,LC213,FMT13,1)#                                       LC02 378
writeline:(1,LC213,NLC213,3,3)#                                         LC02 379
DO I=1,6#                                                               LC02 380
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 LC02 381
CVEC(I) = 0.0#                                                          LC02 382
IF (AMAT(I,I)>0.0)#                                                     LC02 383
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 LC02 384
CVEC(I) = 1.0/SQRT(AMAT(I,I))#                                          LC02 385
AMAT(I,I) = AMAT(I,I)+(SIGLQ*MTVEC(I))**2#                              LC02 386
CVEC(I) = SQRT(AMAT(I,I))/CVEC(I)#                                      LC02 387
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 LC02 388
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 LC02 389
DO I=1,5#                                                               LC02 390
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 LC02 391
N=I+1#                                                                  LC02 392
DO J=N,6#                                                               LC02 393
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 LC02 394
AMAT(I,J) = AMAT(I,J)*CVEC(I)*CVEC(J)#                                  LC02 395
AMAT(J,I) = AMAT(I,J)#                                                  LC02 396
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 LC02 397
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 LC02 398
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 LC02 399
#                                                                       LC02 400
# CALCULATE RECIPROCAL VECTORS AND THEIR VAR-COVAR MATRIX               LC02 401
#                                                                       LC02 402
LINRM = 12#                                                             LC02 403
writeline:(1,LC214,NLC214,3,4)#                                         LC02 404
writeline:(1,LC215,NLC215,3,3)#                                         LC02 405
CALL LC03#                             Analyse reciprocal metric tens   LC02 406
#                                                                       LC02 407
## invert reciprocal metric tensor and get direct lattice.              LC02 408
#                                                                       LC02 409
DO N=1,3#                                                               LC02 410
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 LC02 411
DO M=4,6#                                                               LC02 412
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 LC02 413
MTMAT(N,M) = 0.0#                      Lc0                              LC02 414
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 LC02 415
MTMAT(N,N+3) = 1.0#                    Lc0                              LC02 416
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 LC02 417
DO N=1,3#                                                               LC02 418
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 LC02 419
IF (ABS(MTMAT(N,N))<0.0) iquit:(LC0203)# Singular                       LC02 420
AJUNK = 1.0/MTMAT(N,N)#                                                 LC02 421
DO J=1,6#                                                               LC02 422
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 LC02 423
MTMAT(N,J) = MTMAT(N,J)*AJUNK#                                          LC02 424
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 LC02 425
DO I=1,2#                                                               LC02 426
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 LC02 427
M = N+I#                                                                LC02 428
IF (M>3) M =M-3#                                                        LC02 429
AJUNK = MTMAT(M,N)#                                                     LC02 430
DO J=1,6#                                                               LC02 431
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 LC02 432
MTMAT(M,J) = MTMAT(M,J)-MTMAT(N,J)*AJUNK#                               LC02 433
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 LC02 434
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 LC02 435
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 LC02 436
#                                                                       LC02 437
MTVEC(1) = MTMAT(1,4)#                                                  LC02 438
MTVEC(2) = MTMAT(2,5)#                                                  LC02 439
MTVEC(3) = MTMAT(3,6)#                                                  LC02 440
MTVEC(4) = MTMAT(1,5)#                                                  LC02 441
MTVEC(5) = MTMAT(1,6)#                                                  LC02 442
MTVEC(6) = MTMAT(2,6)#                                                  LC02 443
## compute the derivatives of the metric tensor elements with respect   LC02 444
## to the reciprocal tensor elements.                                   LC02 445
#                                                                       LC02 446
DO I=1,3#                                                               LC02 447
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 LC02 448
DO K=1,3#                                                               LC02 449
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 LC02 450
DERIV(I,K) = -MTMAT(I,K+3)**2#                                          LC02 451
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 LC02 452
DO J=1,2#                                                               LC02 453
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 LC02 454
M = J+1#                                                                LC02 455
DO N=M,3#                                                               LC02 456
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 LC02 457
K = J+N+1#                                                              LC02 458
DERIV(I,K) = -MTMAT(I,J+3)*MTMAT(I,N+3)#                                LC02 459
DERIV(K,I) = 2.0*DERIV(I,K)#                                            LC02 460
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 LC02 461
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 LC02 462
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 LC02 463
DERIV(4,4) = -MTVEC(4)**2-MTVEC(1)*MTVEC(2)#                            LC02 464
DERIV(5,5) = -MTVEC(5)**2-MTVEC(1)*MTVEC(3)#                            LC02 465
DERIV(6,6) = -MTVEC(6)**2-MTVEC(2)*MTVEC(3)#                            LC02 466
DERIV(4,5) = -MTVEC(4)*MTVEC(5)-MTVEC(1)*MTVEC(6)#                      LC02 467
DERIV(4,6) = -MTVEC(4)*MTVEC(6)-MTVEC(2)*MTVEC(5)#                      LC02 468
DERIV(5,6) = -MTVEC(5)*MTVEC(6)-MTVEC(3)*MTVEC(4)#                      LC02 469
DO I=4,6#                                                               LC02 470
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 LC02 471
DO K=I,6#                                                               LC02 472
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 LC02 473
DERIV(K,I) = DERIV(I,K)#                                                LC02 474
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 LC02 475
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 LC02 476
# DERIV(I,K) = DERIVATIVE OF METRIC TENSOR ELEMENT (K) W.R.T. THE       LC02 477
# RECIPROCAL METRIC TENSOR ELEMENT (I) WHERE THE ORDER OF THE           LC02 478
# ELEMENTS IS 11, 22, 33, 12, 13, 23.                                   LC02 479
#                                                                       LC02 480
# COMPUTE VARIANCE-COVARIANCE MATRIX OF DIRECT METRIC TENSOR            LC02 481
DO I=1,6#                                                               LC02 482
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 LC02 483
DO K=1,6#                                                               LC02 484
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 LC02 485
J = K+6#                                                                LC02 486
AMAT(I,J) = 0.0#                                                        LC02 487
DO M=1,6#                                                               LC02 488
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 LC02 489
DO N=1,6#                                                               LC02 490
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 LC02 491
AMAT(I,J) = AMAT(I,J) + DERIV(M,I)*DERIV(N,K)*AMAT(M,N)#                LC02 492
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 LC02 493
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 LC02 494
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 LC02 495
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 LC02 496
DO I=1,6#                                                               LC02 497
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 LC02 498
DO J=I,6#                                                               LC02 499
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 LC02 500
AMAT(I,J) = AMAT(I,J+6)#                                                LC02 501
AMAT(J,I) = AMAT(I,J)#                                                  LC02 502
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 LC02 503
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 LC02 504
#                                                                       LC02 505
# READY AGAIN TO COMPUTE THE VECTORS AND THEIR VAR-COVAR MATRICES.      LC02 506
LINRM = 12#                                                             LC02 507
writeline:(1,LC214,NLC214,3,4)#                                         LC02 508
writeline:(1,LC216,NLC216,3,3)#                                         LC02 509
CALL LC03#                             Analyse direct metric tensor     LC02 510
#                                      Calculate the cell volume        LC02 511
CAVAR(1)=1.0;CAVAR(2)=1.0#             Set sigvol covariances           LC02 512
CAVAR(3)=1.0;CAVAR(4)=1.0#             Set sigvol covariances           LC02 513
IF ((ISYM==6)\(ISYM==7))#              Tetragonal, hexagonal            LC02 514
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 LC02 515
CAVAR(1)=2.0;CAVAR(2)=2.0#                                              LC02 516
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 LC02 517
ELSEIF (ISYM==7)#                      Rhombohedral                     LC02 518
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 LC02 519
CAVAR(1)=3.0;CAVAR(2)=3.0;CAVAR(3)=3.0#                                 LC02 520
CAVAR(4)=3.0#                                                           LC02 521
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 LC02 522
ELSEIF (ISYM==8)#                      Cubic                            LC02 523
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 LC02 524
CAVAR(1)=3.0;CAVAR(2)=3.0;CAVAR(3)=3.0#                                 LC02 525
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 LC02 526
CELVOL=PVEC(1)*PVEC(2)*PVEC(3)*$#      Calc cell volume                 LC02 527
       SQRT(1.0+2.0*PVEC(6)*PVEC(5)*PVEC(4)$#                           LC02 528
       -PVEC(6)**2-PVEC(5)**2-PVEC(4)**2)#                              LC02 529
SIGVOL=CELVOL*SQRT(CAVAR(1)*(ESD2(1)/PVEC(1))**2$# Sigma cell volume    LC02 530
                  +CAVAR(2)*(ESD2(2)/PVEC(2))**2$# Sigma cell volume    LC02 531
                  +CAVAR(3)*(ESD2(3)/PVEC(3))**2$# Sigma cell volume    LC02 532
+CAVAR(4)*(PVEC(1)*PVEC(2)*PVEC(3)/CELVOL)**4$# Sigma cell volume       LC02 533
*(ESD2(6)**2*(PVEC(6)-PVEC(5)*PVEC(4))**2$#                             LC02 534
 +ESD2(5)**2*(PVEC(5)-PVEC(6)*PVEC(4))**2$#                             LC02 535
 +ESD2(4)**2*(PVEC(4)-PVEC(5)*PVEC(6))**2))#                            LC02 536
ncodefld:(CELVOL,1,LC219,FMT15,1)#                                      LC02 537
writeline:(1,LC219,NLC219,3,3)#                                         LC02 538
ncodefld:(SIGVOL,1,CHROT,FMT15,1)#                                      LC02 539
writeline:(0,0,0,1,3)#                                                  LC02 540
IF(IPCH==1)#                           Punch cell and cellsd lines      LC02 541
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 LC02 542
movechar:(BLANK,1,CHROT,1,80,1)#       Blank out output                 LC02 543
DO I=4,6#                                                               LC02 544
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 LC02 545
PVEC(I) = PVEC(I+3)#                                                    LC02 546
ESD1(I) = ESD1(I+3)#                                                    LC02 547
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 LC02 548
movechar:(LC217,1,CHROT,1,4,0)#                                         LC02 549
ncodefld:(PVEC,1,CHROT,FMT14,6)#                                        LC02 550
writepch:(CHROT,80)#                                                    LC02 551
movechar:(LC217,1,CHROT,1,6,0)#                                         LC02 552
ncodefld:(ESD1,1,CHROT,FMT14,6)#                                        LC02 553
writepch:(CHROT,80)#                                                    LC02 554
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 LC02 555
RETURN#                                                                 LC02 556
END#                                                                    LC02 557
systemheader:(LC03)#                   Vectors from metric tensor       LC03   1
##*****************************************************************##   LC03   2
##                                                                 ##   LC03   3
##                           lc03                                  ##   LC03   4
##                                                                 ##   LC03   5
##*****************************************************************##   LC03   6
#                                                                       LC03   7
SUBROUTINE LC03#                                                        LC03   8
#                                                                       LC03   9
## This subroutine computes the vectors from a metric tensor, their     LC03  10
## e.s.d.'s, the variance covariance matrices and the correlation       LC03  11
## matrices                                                             LC03  12
#                                                                       LC03  13
include:(AACOMN)#                                                       LC03  14
include:(LCCOMN)#                                                       LC03  15
INTEGER I,J,K,L,M#                                                      LC03  16
REAL AJUNK,DELTA,DESD,ESD#                                              LC03  17
REAL POWRS(2)#                                                          LC03  18
realdata:(CON,57.295780)#                                               LC03  19
realdata:(FMT1,930213.)#                                                LC03  20
realdata:(FMT2,[111361.,241361.,371361.,501361.,631361.,761361.])#      LC03  21
realdata:(FMT3,[121361.,251361.,381361.,511361.,641361.,771361.,$#      LC03  22
860742.,930742.,1000742.,1070742.,1140742.,1210742.])#                  LC03  23
realdata:(FMT4,170213.)#                                                LC03  24
realdata:(FMT5,[131262.,251262.,371262.,491042.,611042.,731042.,$#      LC03  25
851062.,971062.,1091062.])#                                             LC03  26
realdata:(FMT5D,[131242.,251242.,371242.])#                             LC03  27
chardata:(LC31,[ METRIC TENSOR ELEMENTS AND THEIR E.S.D-S LISTED IN$#   LC03  28
 THE ORDER 11, 22, 33, 12, 13, 23 IN A**XX])#                           LC03  29
chardata:(LC32, VARIANCE-COVARIANCE AND CORRELATION MATRICES)#          LC03  30
chardata:(LC34,[ VECTORS IN A**XX  -- A, B, C,  ALPHA, BETA, $#         LC03  31
GAMMA, COSA, COSB, COSC AND THEIR E.S.D-S])#                            LC03  32
datastuff:#                                                             LC03  33
#                                                                       LC03  34
## Compute e.s.d's and correlation matrix of metric tensor.             LC03  35
## amat = variance-covariance matrix of metric tensor                   LC03  36
## cov = variance-covariance matrix of vectors and angles               LC03  37
## deriv = derivatives                                                  LC03  38
## mtmat = metric tensor in order 11, 22, 33, 12, 13, 23                LC03  39
## pvec = corresponding lengths and angles                              LC03  40
#                                                                       LC03  41
#                                                                       LC03  42
## set angstrom powers according to value of mtvec(1)                   LC03  43
#                                                                       LC03  44
IF(MTVEC(1)<1.0)#                                                       LC03  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LC03  46
POWRS(1) = -2.0#                       Reciprocal values                LC03  47
POWRS(2) = -1.0#                                                        LC03  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LC03  49
ELSE#                                                                   LC03  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LC03  51
POWRS(1) = 2.0#                        Real values                      LC03  52
POWRS(2) = 1.0#                                                         LC03  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LC03  54
DO I=1,6#                                                               LC03  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LC03  56
DO J=1,6#                                                               LC03  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LC03  58
DERIV(I,J) = 0.0#                                                       LC03  59
AMAT(I,J+6) = 0.0#                                                      LC03  60
COV(I,J+6) = 0.0#                                                       LC03  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LC03  62
AMAT(I,I+6) = 1.0#                                                      LC03  63
COV(I,I+6) = 1.0#                                                       LC03  64
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LC03  65
DO I=1,6#                                                               LC03  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LC03  67
ESD1(I) = SQRT(AMAT(I,I))#                                              LC03  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LC03  69
DO I=1,6#                                                               LC03  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LC03  71
DO J=1,6#                                                               LC03  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LC03  73
ESD = ESD1(I)*ESD1(J)#                                                  LC03  74
IF (ESD>0.0) AMAT(I,J+6) = AMAT(I,J)/ESD#                               LC03  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LC03  76
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LC03  77
#                                                                       LC03  78
## compute vectors and their derivatives                                LC03  79
#                                                                       LC03  80
DO I=1,6#                                                               LC03  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LC03  82
DO J=1,6#                                                               LC03  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LC03  84
DERIV(I,J) = 0.0#                                                       LC03  85
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LC03  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LC03  87
DO I=1,3#                                                               LC03  88
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 LC03  89
PVEC(I) = SQRT(MTVEC(I))#                                               LC03  90
DERIV(I,I) = 0.5/PVEC(I)#                                               LC03  91
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 LC03  92
DO I=4,6#                                                               LC03  93
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 LC03  94
J = MOD(7-I,3)+1#                                                       LC03  95
K = MOD(8-I,3)+1#                                                       LC03  96
DERIV(I,I) = 1.0/(PVEC(J)*PVEC(K))#                                     LC03  97
PVEC(I) = MTVEC(I)*DERIV(I,I)#                                          LC03  98
DERIV(J,I) = -0.5*PVEC(I)/MTVEC(J)#                                     LC03  99
DERIV(K,I) = -0.5*PVEC(I)/MTVEC(K)#                                     LC03 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 LC03 101
#                                                                       LC03 102
## deriv(i,j) contains the derivative of pvec(j) w.r.t. mtvec(i)        LC03 103
#                                                                       LC03 104
## calculate variance-covariance matrix in cov                          LC03 105
#                                                                       LC03 106
DO I=1,6#                                                               LC03 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 LC03 108
DO K=1,6#                                                               LC03 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 LC03 110
COV(I,K) = 0.0#                                                         LC03 111
DO L=1,6#                                                               LC03 112
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 LC03 113
DO M=1,6#                                                               LC03 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 LC03 115
COV(I,K) = COV(I,K)+DERIV(L,I)*DERIV(M,K)*AMAT(L,M)#                    LC03 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 LC03 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 LC03 118
COV(K,I) = COV(I,K)#                                                    LC03 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 LC03 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 LC03 121
#                                                                       LC03 122
## treat rounding-off errors in var-covar of angle cosines.             LC03 123
#                                                                       LC03 124
DO I=1,6#                                                               LC03 125
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 LC03 126
DO J=4,6#                                                               LC03 127
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 LC03 128
IF (ABS(COV(I,J))<1.0E-15)#                                             LC03 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 LC03 130
COV(I,J) = 0.0#                                                         LC03 131
COV(J,I) = 0.0#                                                         LC03 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 LC03 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 LC03 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 LC03 135
#                                                                       LC03 136
#                                                                       LC03 137
## compute e.s.d's and correlation matrix                               LC03 138
#                                                                       LC03 139
DO I=1,6#                                                               LC03 140
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 LC03 141
IF (COV(I,I)>0.0) ESD2(I) = SQRT(COV(I,I))#                             LC03 142
ELSE              ESD2(I) = 0.0#                                        LC03 143
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 LC03 144
DO I=1,6#                                                               LC03 145
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 LC03 146
DO J=1,6#                                                               LC03 147
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 LC03 148
ESD = ESD2(I)*ESD2(J)#                                                  LC03 149
IF (ESD>0.0) COV(I,J+6) = COV(I,J)/ESD#                                 LC03 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 LC03 151
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 LC03 152
#                                                                       LC03 153
## compute angles and their variances                                   LC03 154
#                                                                       LC03 155
DO I=4,6#                                                               LC03 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 LC03 157
IF(ABS(PVEC(I))<=small:)#              Test 90 degrees                  LC03 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 LC03 159
PVEC(I) = 0.0#                                                          LC03 160
PVEC(I+3) = 90.0#                                                       LC03 161
ESD2(I+3) = CON*ESD2(I)#                                                LC03 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 LC03 163
ELSE#                                                                   LC03 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 LC03 165
AJUNK = ACOS(PVEC(I))#                                                  LC03 166
PVEC(I+3) = CON*AJUNK#                                                  LC03 167
ESD2(I+3) = CON*ESD2(I)/SIN(AJUNK)#                                     LC03 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 LC03 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 LC03 170
IF (ISYM==7)#                          Hexagonal                        LC03 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 LC03 172
IF (POWRS(1)<0.0)#                     Reciprocal values                LC03 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 LC03 174
PVEC(4) = 0.5#                         Cos gamma*                       LC03 175
PVEC(7) = 60.0#                        Gamma*                           LC03 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 LC03 177
ELSE#                                  Direct values                    LC03 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 LC03 179
PVEC(4) = -0.5#                        Cos gamma                        LC03 180
PVEC(7) = 120.0#                       Gamma                            LC03 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 LC03 182
ESD2(4) = 0.0#                                                          LC03 183
ESD2(7) = 0.0#                                                          LC03 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 LC03 185
#                                                                       LC03 186
## set esd's of fixed values to zero                                    LC03 187
#                                                                       LC03 188
IF(ISYM!=8)#                           Leave rhombohedral               LC03 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 LC03 190
DO I=1,5#                                                               LC03 191
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 LC03 192
J = ISVEC(I)#                                                           LC03 193
IF(J>3)#                               A constant angle                 LC03 194
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 LC03 195
ESD2(J) = 0.0#                                                          LC03 196
ESD2(J+3) = 0.0#                                                        LC03 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 LC03 198
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 LC03 199
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 LC03 200
#                                                                       LC03 201
## write the results                                                    LC03 202
#                                                                       LC03 203
LINRM = 12#                                                             LC03 204
ncodefld:(POWRS,1,LC31,FMT1,1)#                                         LC03 205
writeline:(1,LC31,NLC31,1,4)#                                           LC03 206
DO I=1,6#                                                               LC03 207
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 LC03 208
BUFOT(I) = MTVEC(I)#                                                    LC03 209
BUFOT(I+6) = ESD1(I)#                                                   LC03 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 LC03 211
ncodefld:(BUFOT,1,CHROT,FMT2,6)#                                        LC03 212
writeline:(0,0,0,1,4)#                                                  LC03 213
ncodefld:(BUFOT,7,CHROT,FMT2,6)#                                        LC03 214
writeline:(0,0,0,1,4)#                                                  LC03 215
writeline:(1,LC32,NLC32,3,4)#                                           LC03 216
DO I=1,6#                                                               LC03 217
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 LC03 218
DO J=1,12#                                                              LC03 219
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 LC03 220
BUFOT(J) = AMAT(I,J)#                                                   LC03 221
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 LC03 222
ncodefld:(BUFOT,1,CHROT,FMT3,12)#                                       LC03 223
writeline:(0,0,0,1,4)#                                                  LC03 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 LC03 225
DO I=1,12#                                                              LC03 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 LC03 227
AJUNK = COV(6,I)#                                                       LC03 228
COV(6,I) = COV(4,I)#                                                    LC03 229
COV(4,I) = AJUNK#                                                       LC03 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 LC03 231
LINRM = 4#                                                              LC03 232
ncodefld:(POWRS,2,LC34,FMT4,1)#                                         LC03 233
writeline:(1,LC34,NLC34,3,3)#                                           LC03 234
DO I=1,3#                                                               LC03 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 LC03 236
BUFOT(I)   = PVEC(I)#                                                   LC03 237
BUFOT(I+6) = PVEC(7-I)#                                                 LC03 238
BUFOT(I+3) = PVEC(10-I)#                                                LC03 239
BUFOT(I+9)  = ESD2(I)#                                                  LC03 240
BUFOT(I+15) = ESD2(7-I)#                                                LC03 241
BUFOT(I+12) = ESD2(10-I)#                                               LC03 242
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 LC03 243
IF(BUFOT(1)>1.0)movereal:(FMT5D,1,FMT5,1,3,0)# Change format            LC03 244
ncodefld:(BUFOT,1,CHROT,FMT5,9)#                                        LC03 245
writeline:(0,0,0,1,3)#                                                  LC03 246
ncodefld:(BUFOT,10,CHROT,FMT5,9)#                                       LC03 247
writeline:(0,0,0,1,3)#                                                  LC03 248
writeline:(1,LC32,NLC32,3,4)#                                           LC03 249
DO I=1,6#                                                               LC03 250
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 LC03 251
DO J=1,3#                                                               LC03 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 LC03 253
BUFOT(J)   = COV(I,J)#                                                  LC03 254
BUFOT(J+3) = COV(I,7-J)#                                                LC03 255
BUFOT(J+6) = COV(I,J+6)#                                                LC03 256
BUFOT(J+9) = COV(I,13-J)#                                               LC03 257
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 LC03 258
ncodefld:(BUFOT,1,CHROT,FMT3,12)#                                       LC03 259
writeline:(0,0,0,1,4)#                                                  LC03 260
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 LC03 261
RETURN#                                                                 LC03 262
END#                                                                    LC03 263
systemheader:(LC04)#                   Output the bdf                   LC04   1
##*****************************************************************##   LC04   2
##                                                                 ##   LC04   3
##                           LC04                                  ##   LC04   4
##                                                                 ##   LC04   5
##*****************************************************************##   LC04   6
#                                                                       LC04   7
SUBROUTINE LC04#                                                        LC04   8
#                                                                       LC04   9
include:(AACOMN)#                                                       LC04  10
include:(LCCOMN)#                                                       LC04  11
#                                                                       LC04  12
INTEGER I,JP,IP,PSIZE#                                                  LC04  13
string:(LINE,80)#                                                       LC04  14
#                                                                       LC04  15
#     UPDATE THE BDF                                                    LC04  16
#                                                                       LC04  17
copyfile:(1,2,lrhist:,decr:(lrcell:))#                                  LC04  18
ifeq:(DATSET,1.0)#                     Lrcell: get data set 1           LC04  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  LC04  20
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Lrcell: first packet read        LC04  21
writepkt:(2,lrcell:,PSIZE,JP)#         Write first packet               LC04  22
DO I=1,3#                                                               LC04  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  LC04  24
QX(JP+I)   = PVEC(I)#                  A, b, c                          LC04  25
QX(JP+I+3) = PVEC(7-I)#                Cosines alpha, beta, gamma       LC04  26
QX(JP+I+6) = PVEC(10-I)/360.#          Alpha, beta, gamma cycles        LC04  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  LC04  28
readwpkt:(1,lrcell:,JP,IP,0)#          Lrcell: second packet            LC04  29
writepkt:(2,lrcell:,PSIZE,JP)#         Write second packet              LC04  30
DO I=1,3#                                                               LC04  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  LC04  32
QX(JP+I)   = ESD2(I)#                  Esd a b c                        LC04  33
QX(JP+I+3) = ESD2(7-I)#                Esd cosines                      LC04  34
QX(JP+I+6) = ESD2(10-I)/360.0#         Esd angles                       LC04  35
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  LC04  36
writepkt:(2,lrcell:,PSIZE,JP)#         Write third packet               LC04  37
movereal:(voidflg:,1,QX,JP+1,PSIZE,2)# Void fill                        LC04  38
writepkt:(2,lrcell:,PSIZE,JP)#         Write fourth packet              LC04  39
movereal:(voidflg:,1,QX,JP+1,PSIZE,2)# Void fill                        LC04  40
writepkt:(2,lrcell:,PSIZE,JP)#         Write fifth packet               LC04  41
movereal:(voidflg:,1,QX,JP+1,PSIZE,2)# Void fill                        LC04  42
writepkt:(2,lrcell:,PSIZE,JP)#         Write sixth packet               LC04  43
movereal:(voidflg:,1,QX,JP+1,PSIZE,2)# Void fill                        LC04  44
QX(JP+1)=CELVOL;QX(JP+2)=SIGVOL#       Put in cell volume esd           LC04  45
copyfile:(1,2,incr:(lrcell:),decr:(lrexpl:))#                           LC04  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  LC04  47
ELSE copyfile:(1,2,lrcell:,decr:(lrexpl:))#                             LC04  48
#                                                                       LC04  49
#                                      Deal with lrexpl:                LC04  50
IW(1)=1#                               Data set number                  LC04  51
DO I = 1,9;IW(I+1)=I+12#               A,b,c cosines, angles            LC04  52
DO I = 1,6;IW(I+10)=I+22#              Esd's a,b,c, angles              LC04  53
DO I = 1,3;IW(I+17)=I+89#              N hkl min max theta              LC04  54
IW(21)=22.;IW(22)=29.#                 Cel vol and esd                  LC04  55
KEY(1)=0; KEY(2)=0; KEY(3)=22; KEY(4)=0# Set search limits              LC04  56
indexpkt:(1,lrexpl:,PSIZE,IP,2,KEY,IW,IR)# Get directory packet         LC04  57
REPEAT#                                                                 LC04  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  LC04  59
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Input packet                     LC04  60
IF(IP<=0)BREAK#                                                         LC04  61
writepkt:(2,lrexpl:,PSIZE,JP)#         Write output packet              LC04  62
movereal:(QX,IP+1,QX,JP+1,PSIZE,1)#    Copy across the input packet     LC04  63
ifeq:(QX(IP+IR(1)),DATSET)#            Update this packet               LC04  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  LC04  65
DO I=1,3#                                                               LC04  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  LC04  67
QX(JP+IR(I+1)) = PVEC(I)#              A, b, c                          LC04  68
QX(JP+IR(I+4)) = PVEC(7-I)#            Cosines alpha, beta, gamma       LC04  69
QX(JP+IR(I+7)) = PVEC(10-I)/360.#      Alpha, beta, gamma cycles        LC04  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  LC04  71
DO I=1,3#                                                               LC04  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  LC04  73
QX(JP+IR(I+10)) = ESD2(I)#             Esd a b c                        LC04  74
QX(JP+IR(I+13)) = ESD2(10-I)/360.0#    Esd angles                       LC04  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  LC04  76
QX(JP+IR(18)) = REAL(NCREF)#           Number of contributing reflns    LC04  77
QX(JP+IR(19)) = THMIN#                 Min theta                        LC04  78
QX(JP+IR(20)) = THMAX#                 Max theta                        LC04  79
QX(JP+IR(21)) = CELVOL#                Cell volume                      LC04  80
QX(JP+IR(22)) = SIGVOL#                Esd cell volume                  LC04  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  LC04  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  LC04  83
#                                      Finished with lrexpl:            LC04  84
copyfile:(1,2,incr:(lrexpl:),endrecord:)#                               LC04  85
#                                                                       LC04  86
#                                                                       LC04  87
#     OUTPUT STARTX LINES AND FORCE EXECUTION                           LC04  88
#     ----------------------------------------                          LC04  89
#                                                                       LC04  90
IF(STREAM==yes:)#                      Here goes                        LC04  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  LC04  92
FILEXT(iofm1:)='sxl'#                  Define fmt as re-entrant file    LC04  93
openfmt:(iofm1:,' ')#                  Open line file                   LC04  94
LINE='STARTX UPD'#                     Reset line buffer                LC04  95
writefmt:(iofm1:,'(A)',LINE(1^10))#    Write startx header to file      LC04  96
IF((CHRIN(1^4)!='END ')&(CHREOF!=1))#  If next input line is not end    LC04  97
#                                      And not an eof                   LC04  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  LC04  99
LINFLG=1; LINE=CHRIP#                  Ensure this line not lost        LC04 100
writefmt:(iofm1:,'(A)',LINE(1^44))#    Write header to file             LC04 101
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  LC04 102
closefmt:(iofm1:)#                     Shut down the line file          LC04 103
linestream:('sxl')#                    Insert lines into stream         LC04 104
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  LC04 105
RETURN#                                                                 LC04 106
END#                                                                    LC04 107
pmacro:([no:])#                                                         LC04 108
