systemheader:(RB    )#                                                  RB     1
#####################################################################   RB     2
##      Copyright (C) 2000, The Xtal System, The University of        # RB     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # RB     4
## Distributed under the GNU General Public Licence as published by   # RB     5
## the Free Software Foundation, in the hope that it will be useful   # RB     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # RB     7
## for more details.                                                  # RB     8
#                                                                   #   RB     9
#                        *** RIGBOD ***                             #   RB    10
#                                                                   #   RB    11
#     THE PROGRAM RIGBOD IS DESIGNED TO ACCEPT AND CONVERT          #   RB    12
#     ORTHOGONAL ANGSTROM COORDINATES OR FRACTIONAL COORDINATES     #   RB    13
#     OF AN IDEALIZED GROUP OF ATOMS INTO FRACTIONAL COORDINATES    #   RB    14
#     PROPERLY LOCATED IN A GIVEN UNIT CELL.                        #   RB    15
#                                                                   #   RB    16
#####################################################################   RB    17
#                                                                       RB    18
include:(XMACRO)#                                                       RB    19
#                                                                       RB    20
macro:(atname:,incr:(arith:(23,/,mxchwd:)))#                            RB    21
#                                                                       RB    22
extrude:(RBCOMN)#                                                       RB    23
REAL    A(18)#      ## Transformation matrices                          RB    24
#                   ##  1- 9 fractional to orthogonal coordinates       RB    25
#                   ## 10-18 orthogonal to fractional coordinates       RB    26
REAL    GR(3)#      ## Group parameters: temp, pop and mlt              RB    27
INTEGER DATSET#     ## Data set number                                  RB    28
INTEGER IPNCH#      ## (1)/(2) for (fract.)/(orthog.)                   RB    29
INTEGER STEP0#      ## Increment in mark0-array                         RB    30
INTEGER STEP1#      ## Increment in mark1-array                         RB    31
INTEGER MARK0#      ## Data for real atoms                              RB    32
#                   ## QX(L0+1)  ATOM TYPE NUMBER                       RB    33
#                   ## QX(L0+2)  X                                      RB    34
#                   ## QX(L0+3)  Y                                      RB    35
#                   ## QX(L0+4)  Z                                      RB    36
#                   ## QX(L0+5)  U                                      RB    37
#                   ## QX(L0+6)  POP                                    RB    38
#                   ## QX(L0+7)  AT.MLT.                                RB    39
#                   ## QX(L0+8)  (0)/(1) (do not)/(do) output site      RB    40
#                   ## QX(L0+9)  (0)/(1) (do not)/(do) compare with ide RB    41
#                   ## QX(L0+10) ATOM LABEL                             RB    42
INTEGER MARK1#      ## Data for ideal atoms                             RB    43
#                   ## QX(L1+1)  (0)/(1) (do not)/do) compare with real RB    44
#                   ## QX(L1+2)  POINTER TO CORRESP. REAL ATOM          RB    45
#                   ## QX(L1+3)  X(ORTH; IDEAL ATOM)                    RB    46
#                   ## QX(L1+4)  Y(ORTH; IDEAL ATOM)                    RB    47
#                   ## QX(L1+5)  Z(ORTH; IDEAL ATOM)                    RB    48
#                   ## QX(L1+6)  X(ORTH; REAL ATOM)                     RB    49
#                   ## QX(L1+7)  Y(ORTH; REAL ATOM)                     RB    50
#                   ## QX(L1+8)  Z(ORTH; REAL ATOM)                     RB    51
#                   ## QX(L1+10) ATOM LABEL                             RB    52
INTEGER STOP0,STOP1#                                                    RB    53
#                                                                       RB    54
COMMON/COMFRB/A,GR#                                                     RB    55
COMMON/COMIRB/DATSET,IPNCH,STEP0,STEP1,MARK0,MARK1,STOP0,STOP1#         RB    56
endext:#                                                                RB    57
#                                                                       RB    58
systemheader:(RB00)#                   Main program                     RB00   1
# ################################################################### # RB00   2
#                                                                     # RB00   3
#                                RB00                                 # RB00   4
#                                                                     # RB00   5
# ################################################################### # RB00   6
SUBROUTINE RB00#                                                        RB00   7
include:(AACOMN)#                                                       RB00   8
include:(RBCOMN)#                                                       RB00   9
#                                                                       RB00  10
CALL RB10#                             Read bdf and lines               RB00  11
CALL RB20#                             Generation of rigid groups       RB00  12
#                                                                       RB00  13
RETURN#                                                                 RB00  14
END#                                                                    RB00  15
systemheader:(RB02)#                   Matrix multiplication            RB02   1
#####################################################################   RB02   2
#                                                                   #   RB02   3
#                              RB02                                 #   RB02   4
#                                                                   #   RB02   5
#####################################################################   RB02   6
SUBROUTINE RB02(N,A,B,C)#              Numbering of the matrix e        RB02   7
#                                       # Elements: column by col       RB02   8
REAL    A(1)#                                                           RB02   9
REAL    B(1)#                                                           RB02  10
REAL    C(1)#                                                           RB02  11
INTEGER I,II,J,JJ,K,N#                                                  RB02  12
#                                                                       RB02  13
JJ=-3;K=0#                             Set pointers                     RB02  14
DO I=1,N#                              Loop over number of matrices     RB02  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RB02  16
II=-1;JJ=JJ+3#                         Set/incr pointers                RB02  17
DO J=1,3#                                                               RB02  18
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RB02  19
II=II+1;K=K+1#                         Incr pointers                    RB02  20
C(K)=A(II+1)*B(JJ+1)+A(II+4)*B(JJ+2)+A(II+7)*B(JJ+3)#                   RB02  21
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RB02  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RB02  23
RETURN#                                                                 RB02  24
END#                                                                    RB02  25
systemheader:(RB03)#                   Calculation of cell data         RB03   1
#####################################################################   RB03   2
#                                                                   #   RB03   3
#                              RB03                                 #   RB03   4
#                                                                   #   RB03   5
#####################################################################   RB03   6
SUBROUTINE RB03(K,A,B)#                                                 RB03   7
#                                                                       RB03   8
REAL    A(7)#       ## Cell parameters                                  RB03   9
REAL    B(18)#      ## Transformation matrix(ces)                       RB03  10
INTEGER K#          ## (1)/(2) (transf.m.)/(transf.m.+inverse)          RB03  11
REAL    VCELL#      ## Cell volume                                      RB03  12
#                                                                       RB03  13
VCELL=A(1)*A(2)*A(3)*SQRT(1.0-A(4)*A(4)-A(5)*A(5)-A(6)*A(6)-$#          RB03  14
      2.*A(4)*A(5)*A(6))#                                               RB03  15
B(1)=VCELL/(A(2)*A(3)*A(7))#           Transformation matrix            RB03  16
B(2)=A(1)*(A(6)-A(4)*A(5))/A(7)#                                        RB03  17
B(3)=A(1)*A(5)#                                                         RB03  18
B(4)=0.#                                                                RB03  19
B(5)=A(2)*A(7)#                                                         RB03  20
B(6)=A(2)*A(4)#                                                         RB03  21
B(7)=0.#                                                                RB03  22
B(8)=0.#                                                                RB03  23
B(9)=A(3)#                                                              RB03  24
#                                                                       RB03  25
IF(K==2)#                              Recipr. to direct                RB03  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RB03  27
B(10)=1./B(1)#                                                          RB03  28
B(11)=-B(2)*A(3)/VCELL#                                                 RB03  29
B(12)=-A(1)*A(2)*(A(5)-A(4)*A(6))/(VCELL*A(7))#                         RB03  30
B(13)=0.#                                                               RB03  31
B(14)=1./B(5)#                                                          RB03  32
B(15)=-A(4)/(A(3)*A(7))#                                                RB03  33
B(16)=0.#                                                               RB03  34
B(17)=0.#                                                               RB03  35
B(18)=1./B(9)#                                                          RB03  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RB03  37
#                                                                       RB03  38
END#                                                                    RB03  39
systemheader:(RB10)#                   Initializations                  RB10   1
# ################################################################## #  RB10   2
#                                                                    #  RB10   3
#                                   RB10                             #  RB10   4
#                                                                    #  RB10   5
# ################################################################## #  RB10   6
SUBROUTINE RB10#                                                        RB10   7
include:(AACOMN)#                                                       RB10   8
include:(RBCOMN)#                                                       RB10   9
#                                                                       RB10  10
REAL UOVA#           ## U(overall)                                      RB10  11
INTEGER I,J,IP,NTYPE,PSIZ#                                              RB10  12
INTEGER IREL(11)#    ## Offsets of iwant                                RB10  13
INTEGER IWANT(10)#   ## Wanted items in lr                              RB10  14
INTEGER K,L,M#                                                          RB10  15
INTEGER N1,N2#                                                          RB10  16
INTEGER PACK#        ## Packet size                                     RB10  17
INTEGER SIGNAL(4)#   ##                                                 RB10  18
#                                                                       RB10  19
string:(LABEL,24)#                                                      RB10  20
string:(NAME ,24)#                                                      RB10  21
string:(ATYPE,128)#                                                     RB10  22
chardata:(RB101, ATOMSY INSERT DELETE RIGID )#                          RB10  23
chardata:(RB102, P1 P2 DS SY )#                                         RB10  24
datastuff:#                                                             RB10  25
#                                                                       RB10  26
IPNCH=1#                               Punch fractional coords          RB10  27
UOVA=0.0380#                           U(overall)                       RB10  28
DATSET=1#                              Data set number                  RB10  29
GR(1)=0.;  GR(2)=0.;  GR(3)=0.#        Temp, pop, mlt of group          RB10  30
IOMARK(1)=QXSTR#                       Set start of input bdf buffer    RB10  31
incrqx:(MARK0,IOMARK(1)+bdfbuf:,RB1007)# Get required memory            RB10  32
STEP0=atname:+9#                       Data for real atoms              RB10  33
#                                                                       RB10  34
#  PROCESS RIGBOD LINE                                                  RB10  35
#  -------------------                                                  RB10  36
#                                                                       RB10  37
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop input fields                RB10  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RB10  39
stringlim:(I,N1,N2)#                                                    RB10  40
compchar:(CHRIN,N1,RB102,2,2,3,NRB102,K)#                               RB10  41
IF(K<3) IPNCH=K#                       Punch mode                       RB10  42
ELSE IF(K==3)#                         Data set number                  RB10  43
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RB10  44
I=I+1;DATSET=NINT(BUFIN(I))#           Get the value of datset          RB10  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RB10  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RB10  47
#                                                                       RB10  48
# GET CELL DATA FROM BDF                                                RB10  49
# ----------------------                                                RB10  50
#                                                                       RB10  51
readwpkt:(1,lrcell:,PACK,IP,0)#        Read 1-st pack                   RB10  52
IF(IP==0) iquit:(RB1001)#              Cell record not present          RB10  53
DO I=1,3; readwpkt:(1,lrcell:,PACK,IP,0)#                               RB10  54
movereal:(QX,IP+1,A,1,9,0)#            Transf.matrix; fract to orth     RB10  55
readwpkt:(1,lrcell:,PACK,IP,0)#        Transf.matrix; miller ind.       RB10  56
QX(IP+2)=QX(IP+4)#                     Transpose of transf.matrix       RB10  57
QX(IP+3)=QX(IP+7)#                                                      RB10  58
QX(IP+6)=QX(IP+8)#                                                      RB10  59
QX(IP+4)=0.;QX(IP+7)=0.;QX(IP+8)=0.#                                    RB10  60
movereal:(QX,IP+1,A,10,9,0)#           Transf.matrix: orth to rel       RB10  61
#                                                                       RB10  62
IWANT(1)=1;IWANT(2)=2#                 Datset; uova                     RB10  63
SIGNAL(1)=0;SIGNAL(2)=0;SIGNAL(3)=2;SIGNAL(4)=0#                        RB10  64
indexpkt:(1,lrdset:,PACK,IP,0,SIGNAL,IWANT,IREL)#                       RB10  65
REPEAT#                                Loop over packets                RB10  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RB10  67
readwpkt:(1,lrdset:,PACK,IP,0)#                                         RB10  68
IF(IP<=0) BREAK#                                                        RB10  69
M=IP+IREL(1)#                          Pointer to datset                RB10  70
IF(NINT(QX(M))==DATSET) BREAK#         Wanted data set                  RB10  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RB10  72
UOVA=QX(IP+IREL(2))#                   Get overall u value              RB10  73
#                                                                       RB10  74
# GET SCATFAC NAMES FROM BDF                                            RB10  75
# --------------------------                                            RB10  76
#                                                                       RB10  77
IWANT(1)=11#                           Ff name                          RB10  78
SIGNAL(1)=1; SIGNAL(2)=1; SIGNAL(3)=0; SIGNAL(4)=0# Search parameters   RB10  79
indexpkt:(1,lrscat:,PACK,IP,0,SIGNAL,IWANT,IREL)# Search ff parameter   RB10  80
IF(SIGNAL(1)<=0) iquit:(RB1015)#       No ff........bn2105              RB10  81
DO NTYPE=1,16#                         Loop over ff table               RB10  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RB10  83
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Read next ff packet              RB10  84
IF(IP<=0) BREAK#                       Exit if no more                  RB10  85
K=IP+IREL(1)#                          Point ff name                    RB10  86
movertoc:(QX(K),1,ATYPE,NTYPE*8-7,8,0)# Store ff name                   RB10  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RB10  88
#                                                                       RB10  89
# GET ATOM DATA FROM BDF                                                RB10  90
# ----------------------                                                RB10  91
#                                                                       RB10  92
IWANT(1)=14; IWANT(2)=22#              Atom id; attyp                   RB10  93
IWANT(3)=1;  IWANT(4)=2;  IWANT(5)=3#  X; y; z                          RB10  94
IWANT(6)=4;  IWANT(7)=11; IWANT(8)=21# Uiso; pop; mlt                   RB10  95
SIGNAL(1)=5;SIGNAL(2)=8;SIGNAL(3)=8;SIGNAL(4)=0#                        RB10  96
indexpkt:(1,lratom:,PACK,IP,0,SIGNAL,IWANT,IREL)#                       RB10  97
IF(IP==0) iquit:(RB1003)#              Atom record is missing           RB10  98
IF(IREL(6)==0) GR(1)=-1.#              Group uiso not in bdf            RB10  99
IF(IREL(7)==0) GR(2)=-1.#              Group pop  not in bdf            RB10 100
IF(IREL(8)==0) GR(3)=-1.#              Group mult not in bdf            RB10 101
FOR(L=MARK0;L>0;L=STOP0)#              Read atoms from bdf              RB10 102
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RB10 103
readwpkt:(1,lratom:,PACK,IP,0)#        Read the next packet             RB10 104
IF(IP<=0) BREAK#                       Last atom read                   RB10 105
incrqx:(STOP0,L+STEP0,RB1007)#         Incr the memory                  RB10 106
movertoc:(QX(IP+IREL(1)),1,LABEL,1,24,0)# Move atom label               RB10 107
label:(LABEL,I,J)#                     Process atom label               RB10 108
QX(L+1)=QX(IP+IREL(2))#                Store atom type number           RB10 109
QX(L+2)=QX(IP+IREL(3))#                Store x fractional               RB10 110
QX(L+3)=QX(IP+IREL(4))#                Store y fractional               RB10 111
QX(L+4)=QX(IP+IREL(5))#                Store z fractional               RB10 112
IF(IREL(6)>0) QX(L+5)=QX(IP+IREL(6))#  Store overall u                  RB10 113
ELSE          QX(L+5)=UOVA#            U(overall) default               RB10 114
IF(IREL(7)>0) QX(L+6)=QX(IP+IREL(7))#  Store pop parameter              RB10 115
ELSE          QX(L+6)=1.0#             Pop parameter                    RB10 116
IF(IREL(8)>0) QX(L+7)=QX(IP+IREL(8))#  Store multiplicity               RB10 117
ELSE          QX(L+7)=1.0#             Multiplicity                     RB10 118
QX(L+8)=1.#                            Do write to punch                RB10 119
QX(L+9)=1.#                            Do compare with ideal            RB10 120
movereal:(QX,IP+IREL(1),QX,L+10,atname:,1)# Move atom id                RB10 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RB10 122
readwpkt:(1,endrecord:,I,I,0)#         Close the input bdf              RB10 123
#                                                                       RB10 124
#  PROCESS INPUT LINES                                                  RB10 125
#  -------------------                                                  RB10 126
#                                                                       RB10 127
REPEAT#                                Loop over lines                  RB10 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RB10 129
readline:(RB101,NRB101)#                                                RB10 130
#                                                                       RB10 131
IF(LINID>=4) BREAK#                    Exit on rigid line               RB10 132
#                                                                       RB10 133
IF(LINID==1)#                          ******** atomsy ************     RB10 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RB10 135
L=STOP0; incrqx:(STOP0,L+STEP0,RB1007)# Get list memory                 RB10 136
stringlim:(1,N1,N2)#                   Get string limits                RB10 137
LABEL=CHRIP(N1^N2)#                    Store atom label                 RB10 138
label:(LABEL,I,J,ATYPE,K)#             Get the atom type number         RB10 139
QX(L+1)=FLOAT(K)#                      Store atom type                  RB10 140
DO I=2,4; QX(L+I)=BUFIN(I)#            Store x,y,z                      RB10 141
ifnv:(BUFIN(5)) QX(L+5)=BUFIN(5)#      Uiso                             RB10 142
ELSE            QX(L+5)=UOVA#          U    default                     RB10 143
ifnv:(BUFIN(6)) QX(L+6)=BUFIN(6)#      Pop                              RB10 144
ELSE            QX(L+6)=1.#            Pop. default                     RB10 145
ifnv:(BUFIN(7)) QX(L+7)=BUFIN(7)#      Mult                             RB10 146
ELSE            QX(L+7)=1.#            Mult default                     RB10 147
QX(L+8)=0.#                            Do not write to bdf              RB10 148
QX(L+9)=0.#                            Not for comparison               RB10 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RB10 150
#                                                                       RB10 151
ELSE IF(LINID==2)#                     ********** insert ***********    RB10 152
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over the items              RB10 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RB10 154
L=STOP0; incrqx:(STOP0,L+STEP0,RB1007)# Get list memory                 RB10 155
stringlim:(I,N1,N2)#                   Get string limits                RB10 156
LABEL=CHRIP(N1^N2)#                    Store atom label                 RB10 157
label:(LABEL,I,J,ATYPE,K)#             Get the atom type number         RB10 158
IF(K==0) iquit:(RB1005)#               Atom id not found                RB10 159
QX(L+1)=FLOAT(K)#                      Store atom type                  RB10 160
QX(L+8)=0.#                            Do not output to punch file      RB10 161
QX(L+9)=0.#                            Do not compare with ideal at     RB10 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RB10 163
#                                                                       RB10 164
ELSE IF(LINID==3)#                     ********** delete ***********    RB10 165
FOR(I=1;BUFIN(I)<voidflg:;I=I+1)#      Loop over the items              RB10 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RB10 167
stringlim:(I,N1,N2)#                   Get string limits                RB10 168
LABEL=CHRIP(N1^N2)#                    Store atom label                 RB10 169
FOR(L=MARK0;L<STOP0;L=L+STEP0)#        Loop over atom list              RB10 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RB10 171
movertoc:(QX(L+10),1,NAME,1,24,0)#     Get atom name                    RB10 172
IF(LABEL==NAME) BREAK#                 Exit if labels match             RB10 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RB10 174
IF(L>=STOP0) iquit:(RB1011)#           Quit if delete label missing     RB10 175
QX(L+8)=1.#                            Do not output to punch file      RB10 176
QX(L+9)=0.#                            Do not compare with ideal at     RB10 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RB10 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RB10 179
IF(LINID!=4) iquit:(RB1006)#           A rigid line must be present     RB10 180
#                                                                       RB10 181
RETURN#                                                                 RB10 182
END#                                                                    RB10 183
systemheader:(RB20)#                   Generation of rigid group        RB20   1
# ################################################################### # RB20   2
#                                                                     # RB20   3
#                                 RB20                                # RB20   4
#                                                                     # RB20   5
# ################################################################### # RB20   6
SUBROUTINE RB20#                                                        RB20   7
include:(AACOMN)#                                                       RB20   8
include:(RBCOMN)#                                                       RB20   9
#                                                                       RB20  10
REAL    AID(9)#     ## Transformation matrix for ideal coord.           RB20  11
string:(LABEL,24)#                                                      RB20  12
string:(NAME ,24)#                                                      RB20  13
string:(BFPCH,80)#                                                      RB20  14
INTEGER DEF#        ## (0)/(1) for (not defined)/(defined) atom         RB20  15
REAL    D1,D2,D3#   ##                                                  RB20  16
REAL    E(18)#      ## Group based unitary systems                      RB20  17
#                   ## E( 1)-E( 9) MATRIX FOR IDEAL GROUP               RB20  18
#                   ## E(10)-E(18) TRANSPOSE MATRIX FOR REAL GROUP      RB20  19
INTEGER I,J#        ##                                                  RB20  20
INTEGER IM(3)#      ## Pointer in mark1-array to first 3 refined atom   RB20  21
INTEGER II,L0,L1,N,N1,N2,N3#                                            RB20  22
INTEGER M,M1,M2,M3# ##                                                  RB20  23
INTEGER NATGR#      ## number of atoms per group                        RB20  24
INTEGER NATNAM#     ## Number of atoms names                            RB20  25
INTEGER NDEF#       ## Number of defined atoms in a group               RB20  26
REAL    Q#          ##                                                  RB20  27
REAL    R(3)#       ## Vector: origin to first defined atom             RB20  28
INTEGER RIGID#      ## Number of rigid group                            RB20  29
REAL    ROT(9)#     ## Rotation matrix: ideal to idialized coord.       RB20  30
REAL    U(3)#       ## Vector: atom1 to atom2                           RB20  31
REAL    V(3)#       ## Vector: atom1 to atom3                           RB20  32
REAL    W(3)#       ## Vector: perpendicular to u and v                 RB20  33
REAL    Z(3)#       ## Scratch vector                                   RB20  34
#                                                                       RB20  35
chardata:(RB201, CELLID ATOMFR ATOMOR ATNAME RIGID END )#               RB20  36
chardata:(RB202, *** START COORDINATES ***)#                            RB20  37
chardata:(RB203, *** FINAL COORDINATES ***)#                            RB20  38
chardata:(RB204,      IDEAL ATOMS$#                                     RB20  39
                   REAL ATOMS)#                                         RB20  40
chardata:(RB205, ORTHOGONAL COORDINATES$#                               RB20  41
      FRACTIONAL COORDINATES)#                                          RB20  42
chardata:(RB206, X        Y        Z$#                                  RB20  43
        X        Y        Z    U  POP  MLT)#                            RB20  44
#                                                                       RB20  45
realdata:(DTOR,[.0174532925])#                                          RB20  46
realdata:(FMT,[942.,942.,942.,942.,942.,942.,522.,522.,522.])#          RB20  47
realdata:(FMTP,[942.,942.,942.])#                                       RB20  48
datastuff:#                                                             RB20  49
#                                                                       RB20  50
STEP1=STEP0;  MARK1=STOP0; STOP1=STOP0# Set ideal list pointers         RB20  51
RIGID=0#                               Count rigid groups               RB20  52
movereal:(A,1,AID,1,9,0)#              Move transformation matrix       RB20  53
LINRM=10;   LINID=LINID+1#             Force header                     RB20  54
#                                                                       RB20  55
#  LOOP OVER RIGID GROUPS                                               RB20  56
#  ----------------------                                               RB20  57
#                                                                       RB20  58
REPEAT#                                Loop over rigid groups           RB20  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RB20  60
NDEF=0#                                Initialization                   RB20  61
#                                                                       RB20  62
IF(LINID!=5) BREAK#                    Not a =rigid= line               RB20  63
RIGID=RIGID+1#                         Count the rigid group            RB20  64
L1=MARK1-STEP1#                        Start pointer                    RB20  65
NATNAM=0#                              Count atom names                 RB20  66
DO I=1,3; ifnv:(BUFIN(I)) GR(I)=BUFIN(I)# Set group param               RB20  67
#                                                                       RB20  68
readline:(RB201,NRB201)#               Read next line                   RB20  69
IF(LINID==1)#                          ******** cellid ************     RB20  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RB20  71
DO I=1,3#                              Check the angles                 RB20  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RB20  73
ifvo:(BUFIN(I+3))      BUFIN(I+3)=0.#  Default: cos=0.                  RB20  74
ELSE IF(BUFIN(I+3)>1.) BUFIN(I+3)=COS(DTOR*BUFIN(I+3))# Cosine angle    RB20  75
BUFIN(I+6)=SQRT(1.-BUFIN(I+3)*BUFIN(I+3))# Back to angle                RB20  76
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RB20  77
CALL RB03(1,BUFIN,AID)#                Transformation matrix            RB20  78
readline:(RB201,NRB201)#               Read next line                   RB20  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RB20  80
#                                                                       RB20  81
I=1#                                   Start field pointer              RB20  82
REPEAT#                                Read atomfr,atomor,atname        RB20  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RB20  84
IF(LINID>4) BREAK#                     Rigid or end line encountered    RB20  85
#                                                                       RB20  86
stringlim:(I,N1,N2)#                   Get string limits                RB20  87
LABEL=CHRIP(N1^N2)#                    Store atom label                 RB20  88
FOR(L0=MARK0;L0<STOP0;L0=L0+STEP0)#    Loop over atom list              RB20  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RB20  90
movertoc:(QX(L0+10),1,NAME,1,24,0)#    Get atom name                    RB20  91
IF(LABEL==NAME) BREAK#                 Exit if labels match             RB20  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RB20  93
IF(L0>=STOP0)        DEF=0#            No match with real atom          RB20  94
ELSE IF(QX(L0+9)<.5) DEF=0#            Real atom is deleted             RB20  95
ELSE                 DEF=1#            Real atom is defined             RB20  96
L1=L1+STEP1#                           Advance pointer                  RB20  97
IF(RIGID==1)#                          If first rigid group             RB20  98
incrqx:(STOP1,L1+STEP1,RB2005)#        Get list memory                  RB20  99
NDEF=NDEF+DEF#                         Number of defined atom           RB20 100
movector:(LABEL,1,QX(L1+10),1,24,0)#   Move atom id to mark1-array      RB20 101
QX(L1+1)=FLOAT(DEF)#                   Compare flag                     RB20 102
QX(L1+2)=FLOAT(L0)#                    Pointer to corresp. real ato     RB20 103
IF(DEF>0) CALL RB02(1,A,QX(L0+2),QX(L1+6))# Transformation              RB20 104
#                                                                       RB20 105
IF(LINID<4)#                           ****** atomfr/atomor *******     RB20 106
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RB20 107
IF(L1==MARK1) RIGID=1#                 Set to new rigid group           RB20 108
IF(L1==MARK1) NATGR=1#                 Start of count of atoms          RB20 109
ELSE          NATGR=NATGR+1#           Count atoms in group             RB20 110
IF(LINID==2) CALL RB02(1,AID,BUFIN(2),QX(L1+3))# ****** atomfr *****    RB20 111
ELSE         movereal:(BUFIN,2,QX(L1+3),1,3,0)# ****** atomor *****     RB20 112
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RB20 113
ELSE#                                  ********* atname ************    RB20 114
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RB20 115
IF(RIGID<=1) iquit:(RB2001)#           First group not defined          RB20 116
I=I+1;   NATNAM=NATNAM+1#                                               RB20 117
IF(BUFIN(I)<voidflg:) NEXT#            Continue with this line          RB20 118
I=1#                                   Goto next line                   RB20 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RB20 120
readline:(RB201,NRB201)#               Read next line                   RB20 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RB20 122
IF(RIGID>1 & NATNAM!=NATGR) iquit:(RB2002)# Not same nr of atoms        RB20 123
#                                                                       RB20 124
#  OUTPUT OF START COORDINATES                                          RB20 125
#  ---------------------------                                          RB20 126
#                                                                       RB20 127
LINRM=10#                                                               RB20 128
writeline:(3,RB202,NRB202,3,3)#        Start coordinates                RB20 129
HEADOT=' '; HEADOT(LABMAX+6^)=RB204#   Set header line                  RB20 130
writeline:(1,HEADOT,100,3,3)#          Ideal/real atoms                 RB20 131
HEADOT=' '; HEADOT(LABMAX+11^)=RB206#  Set header line                  RB20 132
LINRM=4#                                                                RB20 133
FOR (L1=MARK1;L1<STOP1;L1=L1+STEP1)#   Loop over ideal atoms            RB20 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RB20 135
movertoc:(QX(L1+10),1,CHROT,2,24,0)#   Move atom id                     RB20 136
IF(QX(L1+1)>.5) N=6#                   Nr of output items               RB20 137
ELSE            N=3#                                                    RB20 138
LCHROT=LABMAX+3#                       Set format pointer               RB20 139
ncodefld:(QX(L1+3),1,CHROT,FMT,N)#                                      RB20 140
writeline:(0,HEADOT,100,1,3)#                                           RB20 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RB20 142
#                                                                       RB20 143
IF(NDEF<3) iquit:(RB2003)#             Not enough overlapping           RB20 144
#                                                                       RB20 145
#  SEARCH FOR FIRST THREE OVERLAPPING ATOMS                             RB20 146
#  ----------------------------------------                             RB20 147
#                                                                       RB20 148
I=0#                                   Count of overl. atoms            RB20 149
FOR(L1=MARK1;L1<STOP1;L1=L1+STEP1)#    Loop over ideal atoms            RB20 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RB20 151
IF(QX(L1+1)<0.5) NEXT#                 Undefined atom                   RB20 152
I=I+1;  IM(I)=L1+2#                    Save pointer to ideal coord      RB20 153
IF(I>=3) BREAK#                        We need 3 atoms                  RB20 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RB20 155
#                                                                       RB20 156
## CALCULATE ORTHOGONAL AXES FOR IDEAL AND REAL ATOMS                   RB20 157
## VECTOR R FROM ORIGIN TO ATOM1                                        RB20 158
## VECTOR U FROM ATOM1 TO ATOM2                                         RB20 159
## VECTOR V FROM ATOM1 TO ATOM3                                         RB20 160
#                                                                       RB20 161
M=MARK1+2#                             Pointer to first ideal coord     RB20 162
M1=IM(1);M2=IM(2);M3=IM(3)#            Pointers to defined coord        RB20 163
DO II=1,2#                             Loop over ideal and real gro     RB20 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RB20 165
DO I=1,3#                              Loop over the coords             RB20 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RB20 167
M1=M1+1;R(I)=QX(M1)#                                                    RB20 168
M2=M2+1;U(I)=QX(M2)-R(I)#                                               RB20 169
M3=M3+1;V(I)=QX(M3)-R(I)#                                               RB20 170
M=M+1#                                                                  RB20 171
FOR(L1=M;L1<=STOP1;L1=L1+STEP1)$#      Shift orth.coord. to             RB20 172
QX(L1)=QX(L1)-R(I)#                    Origin in atom1                  RB20 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RB20 174
#                                                                       RB20 175
## VECTOR PRODUCT U*V                                                   RB20 176
#                                                                       RB20 177
W(1)=U(2)*V(3)-U(3)*V(2)#                                               RB20 178
W(2)=U(3)*V(1)-U(1)*V(3)#                                               RB20 179
W(3)=U(1)*V(2)-U(2)*V(1)#                                               RB20 180
#                                                                       RB20 181
## VECTOR PRODUCT W*U                                                   RB20 182
#                                                                       RB20 183
V(1)=W(2)*U(3)-W(3)*U(2)#                                               RB20 184
V(2)=W(3)*U(1)-W(1)*U(3)#                                               RB20 185
V(3)=W(1)*U(2)-W(2)*U(1)#                                               RB20 186
#                                                                       RB20 187
## NORMALIZE                                                            RB20 188
#                                                                       RB20 189
D1=SQRT(U(1)*U(1)+U(2)*U(2)+U(3)*U(3))#                                 RB20 190
D2=SQRT(V(1)*V(1)+V(2)*V(2)+V(3)*V(3))#                                 RB20 191
D3=SQRT(W(1)*W(1)+W(2)*W(2)+W(3)*W(3))#                                 RB20 192
IF((D1<=0.)\(D2<=0.)\(D3<=0.)) iquit:(RB2004)# R                        RB20 193
IF(II==1)#                             Ideal atom                       RB20 194
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RB20 195
N=3;N1=1;N2=2;N3=3#                    Set pointers                     RB20 196
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RB20 197
ELSE#                                  Real atom                        RB20 198
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RB20 199
N=1;N1=10;N2=13;N3=16#                 Set pointers                     RB20 200
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RB20 201
DO I=1,3#                              X, y, z                          RB20 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RB20 203
E(N1)=U(I)/D1#                                                          RB20 204
E(N2)=V(I)/D2#                                                          RB20 205
E(N3)=W(I)/D3#                                                          RB20 206
N1=N1+N;N2=N2+N;N3=N3+N#               Reset pointers                   RB20 207
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RB20 208
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RB20 209
#                                                                       RB20 210
## CALCULATE ROTATION MATRIX                                            RB20 211
#                                                                       RB20 212
CALL RB02(3,E(10),E(1),ROT)#           Matrix multiplication            RB20 213
#                                                                       RB20 214
## ROTATE IDEAL MODEL                                                   RB20 215
#                                                                       RB20 216
FOR (L1=MARK1;L1<STOP1;L1=L1+STEP1)#   Loop over ideal atoms            RB20 217
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RB20 218
CALL RB02(1,ROT,QX(L1+3),Z)#           Rotate                           RB20 219
movereal:(Z,1,QX(L1+3),1,3,0)#         Move into mark1-array            RB20 220
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RB20 221
#                                                                       RB20 222
## MINIMIZE DX, DY, DZ AND SHIFT TO CELL ORIGIN                         RB20 223
#                                                                       RB20 224
D1=0.;D2=0.;D3=0.;N=0#                 Init.                            RB20 225
FOR(L1=MARK1;L1<STOP1;L1=L1+STEP1)#    Loop over ideal atoms            RB20 226
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RB20 227
ifeq:(QX(L1+1),0.) NEXT#               Undefined atom                   RB20 228
D1=D1+QX(L1+3)-QX(L1+6)#               Delta x                          RB20 229
D2=D2+QX(L1+4)-QX(L1+7)#               Delta y                          RB20 230
D3=D3+QX(L1+5)-QX(L1+8)#               Delta z                          RB20 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RB20 232
Q=1./FLOAT(NDEF)#                                                       RB20 233
D1=R(1)-D1*Q;D2=R(2)-D2*Q;D3=R(3)-D3*Q# Shifts to be applied            RB20 234
#                                                                       RB20 235
## SHIFT THE IDEAL COORDINATES                                          RB20 236
#                                                                       RB20 237
FOR(L1=MARK1;L1<STOP1;L1=L1+STEP1)#    Loop over ideal atoms            RB20 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RB20 239
QX(L1+3)=QX(L1+3)+D1#                                                   RB20 240
QX(L1+4)=QX(L1+4)+D2#                                                   RB20 241
QX(L1+5)=QX(L1+5)+D3#                                                   RB20 242
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RB20 243
#                                                                       RB20 244
## OUTPUT OF FINAL COORDINATES                                          RB20 245
#                                                                       RB20 246
LINRM=10#                                                               RB20 247
writeline:(3,RB203,NRB203,3,3)#        Final coordinates                RB20 248
HEADOT=' ';HEADOT(LABMAX+6^)=RB205#    Set header line                  RB20 249
writeline:(1,HEADOT,100,3,3)#          Orth/fract. coordinates          RB20 250
HEADOT=' ';HEADOT(LABMAX+11^)=RB206#   Set header line                  RB20 251
LINRM=4#                                                                RB20 252
FOR(L1=MARK1;L1<STOP1;L1=L1+STEP1)#    Loop over ideal atoms            RB20 253
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RB20 254
movertoc:(QX(L1+10),1,CHROT,2,24,0)#   Move atom id                     RB20 255
LCHROT=LABMAX+3#                       Set format pointer               RB20 256
ncodefld:(QX(L1+3),1,CHROT,FMT,3)#     Orth. coord.                     RB20 257
CALL RB02(1,A(10),QX(L1+3),BUFOT(4))#  Transform to fract.coord.        RB20 258
ncodefld:(BUFOT,4,CHROT,FMT(4),3)#     Fract. coord.                    RB20 259
L0=NINT(QX(L1+2))#                     Pointer in real atom-a           RB20 260
movereal:(BUFOT,4,QX(L0+2),1,3,0)#     Move the coord.                  RB20 261
L0=L0+4#                               Pointer to group param           RB20 262
DO J=1,3; IF(GR(J)>0.) QX(L0+J)=GR(J)#                                  RB20 263
ncodefld:(QX(L0+1),1,CHROT,FMT(7),3)#  Encode uova, pop, mult           RB20 264
BFPCH='atom '#                         Initialize punch buffer          RB20 265
movechar:(CHROT,2,BFPCH,6,LABMAX,0)#   Put atom name next               RB20 266
LCHROT=LABMAX+10#                      Set format pointer               RB20 267
ncodefld:(BUFOT,4,BFPCH,FMTP,3)#       X,y,z in middle                  RB20 268
ncodefld:(QX(L0+1),1,BFPCH,FMT(7),2)#  Encode uova, pop                 RB20 269
writepch:(BFPCH,80)#                   Punch the line                   RB20 270
writeline:(0,HEADOT,120,1,3)#          List atom coords                 RB20 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RB20 272
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RB20 273
#                                                                       RB20 274
RETURN#                                                                 RB20 275
END#                                                                    RB20 276
pmacro:([no:])#                        Purge xtal system macros         RB20 277
