systemheader:(RF    )#                                                  RF     1
####################################################################### RF     2
##      Copyright (C) 2000, The Xtal System, The University of        # RF     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # RF     4
## Distributed under the GNU General Public Licence as published by   # RF     5
## the Free Software Foundation, in the hope that it will be useful   # RF     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # RF     7
## for more details.                                                  # RF     8
##                                                                    # RF     9
##                          *** REFCAL ***                            # RF    10
##                                                                    # RF    11
##   REFCAL processes raw diffractometer data including treatment of  # RF    12
##   reference reflections, LP calculations, etc                      # RF    13
##   Input comes from the bdf in the form of raw diffractometer data  # RF    14
##                                                                    # RF    15
####################################################################### RF    16
#                                      H.d. flack october 1990          RF    17
#                                                                       RF    18
include:(XMACRO)#                                                       RF    19
#                                                                       RF    20
macro:(mw40dm:,incr:(arith:(39,/,mxchwd:)))# No. words for 40 chars     RF    21
extrude:(RFCOMN)#                                                       RF    22
REAL    ATTENU(0^9)#                   Attenuator factors none - 9      RF    23
INTEGER DATIN#                         Input data 1 = raw, 2 = neti     RF    24
INTEGER DATOUT#                        Output data 3 = f**2, 4 = f      RF    25
REAL    DIHEDR#                        Dihedral angle of diffracto      RF    26
REAL    DM(9)#                         Direct space metric tensor       RF    27
string:(DSNAME,12)#                    Data set name                    RF    28
REAL    DSNM#                          Data set number                  RF    29
REAL    EPOLO#                         Esd polarization ration          RF    30
REAL    ESFREL#                        Esd f rel                        RF    31
REAL    ESF2RE#                        Esd of |f|**2                    RF    32
REAL    ESIREL#                        Esd i rel                        RF    33
REAL    ESTENU(0^9)#                   Esd attenuators                  RF    34
REAL    ETIME#                         Elapsed time                     RF    35
INTEGER FFAC#                          Interpol. scat. facs. on bdf     RF    36
REAL    FREL#                          |f| relative                     RF    37
REAL    F2REL#                         |f|**2 relative                  RF    38
REAL    HKL(3)#                        Unpacked h,k,l                   RF    39
INTEGER IAPPLY#                        Scale application flag           RF    40
INTEGER ICNT#                          Centrosymmetry non=0, cen=1      RF    41
INTEGER IHH(3,30)#                     H,k,l values of reference refl   RF    42
INTEGER INEU#                          Neutron or xray data             RF    43
INTEGER INSTAB#                        Set application of instabili     RF    44
REAL    INTERC(4)#                     Intercepts of instability        RF    45
INTEGER IP#                            Packet address                   RF    46
INTEGER IPRINT#                        Printed output flag              RF    47
INTEGER IR(1001)#                      Packet pointers for bdf          RF    48
REAL    IREL#                          Relative intensity               RF    49
INTEGER ISC#                           Count of reference reflns        RF    50
INTEGER ISTOP#                         Stop of current memory           RF    51
INTEGER IWANT(1000)#                   Wanted items from bdf            RF    52
INTEGER IXRFN#                         Exclude reference reflns from    RF    53
REAL    LAMBDA#                        Radiation wavelength             RF    54
INTEGER LPINS#                         Keep/dont lp factor in bdf       RF    55
INTEGER MARKR#                         Region for rescale factors       RF    56
INTEGER MARKS#                         Region for reference refln sto   RF    57
INTEGER MARK2#                         Region for symmetry storage      RF    58
INTEGER MARK3#                         Region for scattering factors    RF    59
INTEGER MAXHKL(3)#                     Maximum values of hkl            RF    60
REAL    MXTIME#                        Maximum elapsed time             RF    61
INTEGER MINHKL(3)#                     Minimum values of hkl            RF    62
INTEGER NSETS#                         Number of scale sets             RF    63
INTEGER NREF#                          Number of reflections            RF    64
INTEGER NSCAT#                         Number of atom types             RF    65
INTEGER NSYM#                          Total no of symmetry operation   RF    66
INTEGER NTAB(50)#                      Table of discont. sets           RF    67
INTEGER NTABS#                         No. of discontinuities in da     RF    68
INTEGER NUMATT#                        Number of attenuator factors     RF    69
INTEGER OPP,OPSIZ#                     Output packet pointers           RF    70
REAL    POLO#                          Polarization ratio               RF    71
REAL    PSICR#                         Azimuthal angle                  RF    72
INTEGER PSIZE#                         Packet size for lrrefl:          RF    73
REAL    RM(9)#                         Recip metric tensor              RF    74
INTEGER SABS#                          Keep/delete sys abs reflns.      RF    75
INTEGER SCRFN#                         Instab from scaled refs (y/n)    RF    76
REAL    SLOPE(4)#                      Slopes of instability            RF    77
INTEGER SMOOTH#                        Span of smoothing range          RF    78
INTEGER STEPR#                         Items per rescale factor         RF    79
INTEGER STEPS#                         Items per measured reference r   RF    80
INTEGER STEP2#                         Items per symmetry operation     RF    81
INTEGER STEP3#                         Items per scattering factors     RF    82
INTEGER STOPR#                         End of rescales                  RF    83
INTEGER STOPS#                         End of reference reflns storag   RF    84
INTEGER STOP2#                         End of symmetry                  RF    85
INTEGER STOP3#                         End of scattering factors        RF    86
REAL    THRESH#                        Sigmas to set observability      RF    87
INTEGER TOTRFN#                        Total number of reference refl   RF    88
#                                                                       RF    89
COMMON/COMIRF/DATIN,DATOUT,FFAC,IAPPLY,ICNT,IHH,INEU,#                  RF    90
INSTAB,IP,IPRINT,ISC,IR,ISTOP,IWANT,IXRFN,LPINS,#                       RF    91
MARKR,MARKS,MARK2,MARK3,MAXHKL,MINHKL,NSETS,NREF,NSYM,NSCAT,NTAB,#      RF    92
NTABS,NUMATT,OPP,OPSIZ,PSIZE,SABS,SCRFN,SMOOTH,STEPR,STEPS,STEP2,#      RF    93
STEP3,STOPR,STOPS,STOP2,STOP3,TOTRFN#                                   RF    94
#                                                                       RF    95
COMMON/COMFRF/ATTENU,DIHEDR,DM,DSNM,EPOLO,ESFREL,ESF2RE,ESIREL,#        RF    96
ESTENU,ETIME,FREL,F2REL,HKL,INTERC,IREL,LAMBDA,MXTIME,POLO,PSICR,#      RF    97
RM,SLOPE,THRESH#                                                        RF    98
#                                                                       RF    99
COMMON/COMCRF/DSNAME#                                                   RF   100
endext:#                                                                RF   101
#                                                                       RF   102
systemheader:(RF00)#                                                    RF00   1
#*********************************************************************# RF00   2
#                                                                     # RF00   3
#                                RF00                                 # RF00   4
#                                                                     # RF00   5
#*********************************************************************# RF00   6
SUBROUTINE RF00#                                                        RF00   7
include:(AACOMN)#                      N spadaccini may 1989            RF00   8
include:(RFCOMN)#                      H.d.flack nov 1990               RF00   9
#                                                                       RF00  10
CALL RF10#                             Process refcal and control lin   RF00  11
CALL RF20#                             First reading of input bdf       RF00  12
CALL RF25#                             Print controls                   RF00  13
CALL RF30(1)#                          Plot reference reflns            RF00  14
CALL RF40#                             Find  & print raw scales         RF00  15
CALL RF50#                             Find  & print smoothed scales    RF00  16
IF(SCRFN==yes:) CALL RF80#             Scale reference reflns before    RF00  17
CALL RF60#                             Find instability factors         RF00  18
IF(SCRFN==no:)  CALL RF80#             Scale reference reflns after     RF00  19
CALL RF70#                             2nd read/write pass - lrexpl:    RF00  20
CALL RF71#                             2nd read/write pass - lrrefl:    RF00  21
IF(TOTRFN>0)#                          If there are reference reflns    RF00  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF00  23
CALL RF30(2)#                          Report them as rescaled          RF00  24
IF((INSTAB>0)&(INSTAB<4&SCRFN==no:)) CALL RF60# Recalculate statistic   RF00  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF00  26
#                                                                       RF00  27
RETURN#                                                                 RF00  28
END#                                                                    RF00  29
systemheader:(RF10)#                   Process the refcal/control lin   RF10   1
#********************************************************************** RF10   2
#                                                                       RF10   3
#                                RF10                                   RF10   4
#                                                                       RF10   5
#********************************************************************** RF10   6
SUBROUTINE RF10#                       J.m. stewart apr 83              RF10   7
include:(AACOMN)#                      N spadaccini may 1989#           RF10   8
include:(RFCOMN)#                      H.d. flack nov 1990#             RF10   9
#                                                                       RF10  10
INTEGER I,J,K,KEY#                     Misc pointers and indexes        RF10  11
#                                                                       RF10  12
chardata:(RF101, END    SETSCL DISCON )#                                RF10  13
chardata:(RF102, DSET RAWI NETI FSQR FREL NOFF FFAC SABS RSAB SLIS $#   RF10  14
LIST INCL EXCL OBST INST APPL NAPS AFTR BEFR SCLM )#                    RF10  15
datastuff:#                                                             RF10  16
#                                                                       RF10  17
# SET DEFAULT OPTIONS                                                   RF10  18
# -------------------                                                   RF10  19
#                                                                       RF10  20
DO J=0,9; ATTENU(J)=1.0#               Set attenuators none - 9         RF10  21
DO J=0,9; ESTENU(J)=0.0#               No esds on attenuators           RF10  22
DATOUT=2#                              Net intensities output           RF10  23
DIHEDR=0.#                             Dihedral angle                   RF10  24
DSNM=1.#                               Set default data set number      RF10  25
#EPOLO=0.0#                             ESD POLARIZATION RATIO          RF10  26
FFAC=no:#                              No bdf interpolated form facs    RF10  27
IAPPLY=yes:#                           Apply scale factors              RF10  28
INEU=no:#                              Default xray data                RF10  29
INSTAB=0#                              Instability option               RF10  30
DO J=1,4; INTERC(J)=0.0#               Zero intercept                   RF10  31
IPRINT=10#                             Print 10 reflections             RF10  32
ISC=0#                                 Count of reference reflections   RF10  33
IXRFN=yes:#                            Do exclude references            RF10  34
LAMBDA=0.71069#                        Molbdenum k alpha                RF10  35
DO I=1,3; MAXHKL(I)=-9999#             Maximum values of hkl            RF10  36
DO I=1,3; MINHKL(I)=+9999#             Minimum values of hkl            RF10  37
MXTIME=0.0#                            Maxmimum elapsed time            RF10  38
NTABS=0#                               Set default no. of discontin     RF10  39
#POLO=1.0#                              POLARIZATION RATIO              RF10  40
POLO=0.5#                              Polarization ratio               RF10  41
SABS=yes:#                             Keep sys abs reflections         RF10  42
SCRFN=yes:#                            Scaled references for instabil   RF10  43
DO J=1,4; SLOPE(J)=0.0#                Zero slope                       RF10  44
SMOOTH=5#                              Smoothing range                  RF10  45
THRESH=-99.0#                          No observability threshold       RF10  46
#                                                                       RF10  47
#    LOOP OVER REFCAL FIELDS                                            RF10  48
#    -----------------------                                            RF10  49
#                                                                       RF10  50
FOR(K=1;K<=mxfdim:;K=K+1)#             Loop over refcal line fields     RF10  51
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF10  52
ifvo:(BUFIN(K)) BREAK#                 Quit on first void field         RF10  53
IF (BUFIN(K)>voidflg:) NEXT#           Check for alphabetics            RF10  54
stringlim:(K,I,J)#                     Get limits of character field    RF10  55
compchar:(CHRIN,I,RF102,2,4,5,NRF102,KEY)# Identify key                 RF10  56
IF(KEY==0) iquit:(RF1001,K)#           Unrecognizable input field       RF10  57
ELSE IF(KEY==1)#                       Data set number                  RF10  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF10  59
IF(BUFIN(K+1)<1.) iquit:(RF1002,K+1)#  Test data set number             RF10  60
DSNM=REAL(NINT(BUFIN(K+1)));K=K+1#     Data set number                  RF10  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF10  62
ELSE IF((KEY>=2) & (KEY<=5)) DATOUT =KEY-1# Mark output type            RF10  63
ELSE IF(KEY==6)  FFAC=no:#             Do not insert ff                 RF10  64
ELSE IF(KEY==7) FFAC=yes:#             Insert ff                        RF10  65
ELSE IF(KEY==8) SABS=yes:#             Leave in sys abs hkl             RF10  66
ELSE IF(KEY==9) SABS=no:#              Leave out sys abs hkl            RF10  67
ELSE IF(KEY==10) IPRINT=10#            List 10 reflections              RF10  68
ELSE IF(KEY==11)#                      Check for print                  RF10  69
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF10  70
IPRINT=99999#                                                           RF10  71
IF(BUFIN(K+1)>=0.)#                                                     RF10  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF10  73
IPRINT=NINT(BUFIN(K+1));  K=K+1#       Take users desires               RF10  74
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF10  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF10  76
ELSE IF(KEY==12) IXRFN=no:#            Inclusion of reference reflns    RF10  77
ELSE IF(KEY==13) IXRFN=yes:#           Exclusion of reference reflns    RF10  78
ELSE IF(KEY==14)#                      Check for thresh                 RF10  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF10  80
THRESH=BUFIN(K+1);   K=K+1#            Set thresh and bump pointer      RF10  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF10  82
ELSE IF(KEY==15)#                      Check on instability             RF10  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF10  84
IF((BUFIN(K+1)>=1.0)&(BUFIN(K+1)<=4.0))# Test options                   RF10  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RF10  86
INSTAB=NINT(BUFIN(K+1));  K=K+1#       Accept method                    RF10  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RF10  88
IF(INSTAB==4)#                         User supplies consts.            RF10  89
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RF10  90
IF(BUFIN(K+1)>voidflg:)#               Must be a number                 RF10  91
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RF10  92
SLOPE(4)=BUFIN(K+1);    K=K+1#         Take slope                       RF10  93
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RF10  94
IF(BUFIN(K+1)>voidflg:)#               Check second fld                 RF10  95
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RF10  96
INTERC(4)=BUFIN(K+1);   K=K+1#         Take intercept                   RF10  97
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RF10  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RF10  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF10 100
ELSE IF(KEY==16) IAPPLY=yes:#          Check for scale application      RF10 101
ELSE IF(KEY==17) IAPPLY=no:#           Check for scale application      RF10 102
ELSE IF(KEY==18) SCRFN=yes:#           Scaled referencs for instabili   RF10 103
ELSE IF(KEY==19) SCRFN=no:#            Unscaled references for instab   RF10 104
ELSE IF(KEY==20)#                      Check for smoothing range        RF10 105
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RF10 106
IF(BUFIN(K+1)<0.) iquit:(RF1004,K+1)#  Test range                       RF10 107
SMOOTH=NINT(BUFIN(K+1));   K=K+1#      Set smooth range                 RF10 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RF10 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF10 110
IF (DATOUT>=3) LPINS=no:#              No lp in bdf with f**2 and f     RF10 111
ELSE LPINS=yes:#                       Lp in bdf with raw i or net i    RF10 112
#                                                                       RF10 113
# READ INPUT LINES                                                      RF10 114
# ----------------                                                      RF10 115
#                                                                       RF10 116
REPEAT#                                Loop over input lines            RF10 117
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RF10 118
readline:(RF101,NRF101)#               Read the next input line         RF10 119
IF(LINID<4) BREAK#                     Exit end, setscl, discon         RF10 120
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RF10 121
RETURN#                                                                 RF10 122
END#                                                                    RF10 123
systemheader:(RF20)#                   First reading pass over bdf      RF20   1
#********************************************************************** RF20   2
#                                                                       RF20   3
#                                RF20                                   RF20   4
#                                                                       RF20   5
#********************************************************************** RF20   6
SUBROUTINE RF20#                       H.d.flack nov 1990               RF20   7
include:(AACOMN)#                                                       RF20   8
include:(RFCOMN)#                                                       RF20   9
#                                                                       RF20  10
REAL    CBL, CBH#                      Low - & high angle background    RF20  11
REAL    CNP, CNB, CNL, CNH#            Flack & blanc coefficients       RF20  12
REAL    CSUM#                          Brut peak counts                 RF20  13
REAL    XBH,XBL,XNB,XNH,XNL,XNP#                                        RF20  14
INTEGER IDN,JJ#                                                         RF20  15
INTEGER GOTRFN(30)#                    Found reference flag             RF20  16
INTEGER RFNX#                          Reference flag                   RF20  17
INTEGER KEY(4)#                        Keys for indexpkt:               RF20  18
INTEGER LTYP#                          Lattice code                     RF20  19
INTEGER NEWSET#                        Switch for reference sets        RF20  20
INTEGER NROT#                          No. of rotation matrices         RF20  21
INTEGER I,J,K,L,M,N#                   Odd temporary variables          RF20  22
INTEGER II,LL#                         Odd counters/pointers            RF20  23
#                                                                       RF20  24
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              RF20  25
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              RF20  26
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              RF20  27
realdata:(TR21,[.3333333,.5])#                                          RF20  28
realdata:(TR22,[.6666667,0.])#                                          RF20  29
realdata:(TR23,[.6666667,.5])#                                          RF20  30
datastuff:#                                                             RF20  31
#                                                                       RF20  32
# SET UP I/O BUFFER FOR BDF AND ASK FOR MEMORY                          RF20  33
# --------------------------------------------                          RF20  34
#                                                                       RF20  35
IOMARK(1)=QXSTR#                       Save buffer for input bdf        RF20  36
IOMARK(2)=IOMARK(1)+bdfbuf:#           Save buffer for output bdf       RF20  37
incrqx:(ISTOP,IOMARK(2)+bdfbuf:,RF2001)# Mark end of current mem        RF20  38
#                                                                       RF20  39
#   READ LRCELL:                                                        RF20  40
# --------------                                                        RF20  41
#                                                                       RF20  42
readwpkt:(1,1,PSIZE,IP,0)#             Start up the input bdf           RF20  43
DO I=1,9#                              Loop over lrcell: packets        RF20  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF20  45
readwpkt:(1,lrcell:,PSIZE,IP,0)#       Read packet                      RF20  46
IF(IP<=0) BREAK#                       Break at end of lrcell:          RF20  47
IF(I==7)#                              Correct packet                   RF20  48
DO J=1,9; DM(J)=QX(IP+J)#              Get direct metric tensor         RF20  49
ELSE IF(I==8)#                         Correct packet                   RF20  50
DO J=1,9; RM(J)=QX(IP+J)#              Get recip metric tensor          RF20  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF20  52
#                                                                       RF20  53
#   READ LRSYMM:                                                        RF20  54
# --------------                                                        RF20  55
#                                                                       RF20  56
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read packet                      RF20  57
IF(IP<=0) iquit:(RF2002)#              Quit if pkt not there            RF20  58
ICNT=1-NINT(QX(IP+2))#                 Centrosymmetry n=0   c=1         RF20  59
LTYP=NINT(QX(IP+1))-7*ICNT#            Lattice code                     RF20  60
NSYM=NINT(QX(IP+3))#                   Total symmetry matrices          RF20  61
NROT=NINT(QX(IP+4))*12#                Limit of rotation matrices       RF20  62
#                                                                       RF20  63
# GET SYMMETRY EQUIVALENT POSITIONS                                     RF20  64
# ---------------------------------                                     RF20  65
#                                                                       RF20  66
MARK2=ISTOP;STEP2=12#                  Pick up current end of mem       RF20  67
incrqx:(STOP2,MARK2+NSYM*STEP2,RF2003)# Request memory all symops       RF20  68
JJ=MARK2+NROT#                         Limit of rotation matrices       RF20  69
FOR(II=MARK2;II<JJ;II=II+STEP2)#       Loop over symmetry matrices      RF20  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF20  71
readwpkt:(1,lrsymm:,PSIZE,IP,0)#       Read packet                      RF20  72
IF(IP<=0) BREAK#                       Break at end                     RF20  73
movereal:(QX,IP+1,QX,II+1,STEP2,1)#    Transfer packet                  RF20  74
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF20  75
IF(ICNT==1)#                           If centrosymmetric               RF20  76
DO I=1,NROT; QX(JJ+I)=-QX(MARK2+I)#    Store inverse matrix             RF20  77
#                                                                       RF20  78
#     EXPAND SYMOP TABLE FOR CENTRING                                   RF20  79
#     -------------------------------                                   RF20  80
#                                                                       RF20  81
II=JJ+ICNT*NROT; ISTOP=II#             Store primitive marker           RF20  82
IF(LTYP>1)#                            Test if sg centered              RF20  83
FOR(J=MARK2;J<ISTOP;J=J+STEP2)#        Loop over symm matrices          RF20  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF20  85
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            RF20  86
QX(II+10)=QX(J+10)+TR11(LTYP-1)#       Transfer t1                      RF20  87
QX(II+11)=QX(J+11)+TR12(LTYP-1)#       Transfer t2                      RF20  88
QX(II+12)=QX(J+12)+TR13(LTYP-1)#       Transfer t3                      RF20  89
II=II+STEP2#                           Incr storage pointer             RF20  90
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               RF20  91
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            RF20  92
QX(II+10)=QX(J+10)+TR21(LTYP-2)#       Transfer t1                      RF20  93
QX(II+11)=QX(J+11)+TR22(LTYP-2)#       Transfer t2                      RF20  94
QX(II+12)=QX(J+12)+TR23(LTYP-2)#       Transfer t3                      RF20  95
II=II+STEP2#                           Incr storage pointer             RF20  96
IF(LTYP!=4) NEXT#                      Skip if not f-centre             RF20  97
movereal:(QX,J+1,QX,II+1,9,0)#         Transfer rot elements            RF20  98
QX(II+10)=QX(J+10)+0.5#                Transfer t1                      RF20  99
QX(II+11)=QX(J+11)+0.5#                Transfer t2                      RF20 100
QX(II+12)=QX(J+12)+0.0#                Transfer t3                      RF20 101
II=II+STEP2#                           Incr storage pointer             RF20 102
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF20 103
ISTOP=STOP2#                           Current end of memory            RF20 104
#                                                                       RF20 105
#   READ LRSCAT:                                                        RF20 106
#   ------------                                                        RF20 107
#                                                                       RF20 108
# STORE STOL VALUES AND RELATIVE POINTERS IN TABLE                      RF20 109
# FOR EACH STOL VALUE, WE HAVE THE FOLLOWING:                           RF20 110
# STOL,RELATIVE POINTER,Y1,Y2,....,Y10                                  RF20 111
# WHERE Y1,...,Y10 ARE THE SCATTERING FACTORS FOR THAT STOL VALUE       RF20 112
# FOR UP TO 10 ATOMS                                                    RF20 113
# ---------------------------------------------------------------       RF20 114
#                                                                       RF20 115
MARK3=ISTOP;II=MARK3;STEP3=12#         Start of ff table/ run pointer   RF20 116
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read directory                   RF20 117
IF(IP<=0) iquit:(RF2004)#              Quit if not there                RF20 118
FOR(I=IP+1;I<=IP+PSIZE;I=I+1)#         Loop over directory              RF20 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF20 120
ifeq:(QX(I),10.) INEU=yes:#            Check for neutron ff             RF20 121
IF(FFAC==yes:)#                        Form factors requested           RF20 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF20 123
IF((QX(I)<99.9)\(QX(I)>299.1)) NEXT#   Skip non-ff                      RF20 124
incrqx:(ISTOP,II+STEP3,RF2005)#        Mem request                      RF20 125
QX(II+1)=(QX(I)-100.)/100.#            Stol value                       RF20 126
QX(II+2)=FLOAT(I-IP);II=ISTOP#         Relative & running pointers      RF20 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF20 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF20 129
STOP3=II;ISTOP=STOP3#                  End of mark3 array               RF20 130
#                                                                       RF20 131
# GET FORM FACTOR TABLES                                                RF20 132
# ----------------------                                                RF20 133
#                                                                       RF20 134
NSCAT=0#                               Number of atom types loaded      RF20 135
FOR(II=1;II>0;II=II+1)#                Loop over atom types             RF20 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF20 137
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read packet                      RF20 138
IF(IP<=0) BREAK#                       Break at end of lr               RF20 139
IF(FFAC==yes:)#                        Form factors requested           RF20 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RF20 141
NSCAT=NSCAT+1#                         Up the atom types                RF20 142
FOR(I=MARK3;I<STOP3;I=I+STEP3)#        Loop over ff pointers            RF20 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RF20 144
L=IP+NINT(QX(I+2))#                    Point to ff                      RF20 145
IF(QX(L)<small:) QX(L)=2.*QX(L-1)-QX(L-2)# Interpolate                  RF20 146
LL=II+I+2#                             Pointer into mark3               RF20 147
QX(LL)=QX(L)#                          Store ff                         RF20 148
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RF20 149
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RF20 150
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF20 151
#                                                                       RF20 152
#    READ LRDDEF:                                                       RF20 153
#    ------------                                                       RF20 154
#                                                                       RF20 155
DO I=1,100#                            Loop over packets                RF20 156
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RF20 157
readwpkt:(1,lrddef:,PSIZE,IP,0)#       Read and stop at end             RF20 158
IF(IP==0)BREAK#                                                         RF20 159
IF(NINT(DSNM)==I) movertoc:(QX(IP+1),1,DSNAME,1,12,0)# Get data set n   RF20 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RF20 161
#                                                                       RF20 162
#    READ LREXPL:                                                       RF20 163
#    ------------                                                       RF20 164
#                                                                       RF20 165
KEY(1)=0;KEY(2)=127;KEY(3)=0;KEY(4)=0# Directory packet setup           RF20 166
IWANT(1)=1;IWANT(2)=2#                 Dsk no. & wavelength             RF20 167
IWANT(3)=52; IWANT(4)=53#              Polarization and esd             RF20 168
IWANT(5)=54#                           Dihedral angle                   RF20 169
IWANT(6)=601#                          No. of reference reflections     RF20 170
DO I=1,90 ; IWANT(I+6)=609+I#          Hkl of 30 reference reflection   RF20 171
IWANT(97)=701;J=701;K=97#              No. of attenuators               RF20 172
DO I=1,10#                             Space for 10 attenuators         RF20 173
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RF20 174
IWANT(K+1)=J+1;IWANT(K+2)=J+2;IWANT(K+3)=J+3# Filter factor i           RF20 175
K=K+3;J=J+4#                                                            RF20 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RF20 177
indexpkt:(1,lrexpl:,PSIZE,IP,0,KEY,IWANT,IR)#                           RF20 178
REPEAT#                                Loop over packets                RF20 179
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RF20 180
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Read and stop at end             RF20 181
IF(IP==0)BREAK#                                                         RF20 182
IF(IR(1)>0) ifeq:(DSNM,QX(IP+IR(1)))#  Is this the data set we want     RF20 183
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RF20 184
IF(IR(2)>0) LAMBDA=QX(IP+IR(2))#       Wavelength                       RF20 185
IF(IR(3)>0) POLO=QX(IP+IR(3))#         Polarization ratio               RF20 186
#IF(IR(4)>0) EPOLO=QX(IP+IR(4))#        ESD POLARIZATION RATIO          RF20 187
IF(IR(5)>0) DIHEDR=QX(IP+IR(5))#       Dihedral angle                   RF20 188
IF(IR(6)>0) ISC=NINT(QX(IP+IR(6)))#    Store number of reference refl   RF20 189
DO J=1,ISC#                            Reference reflns                 RF20 190
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RF20 191
DO K=1,3;HKL(K)=QX(IP+IR(3*J+K+3))#    Indices                          RF20 192
DO K=1,3;IHH(K,J)=NINT(HKL(K))#        Store reference transformed hk   RF20 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RF20 194
IF(IR(97)>0)#                          Is attenuator info present       RF20 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RF20 196
I=IP+IR(97)#                           Point to number of attenuators   RF20 197
IF(QX(I)>0.5)#                                                          RF20 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RF20 199
NUMATT=NINT(QX(I));L=97#               Number of attenuators            RF20 200
DO J=1,NUMATT#                                                          RF20 201
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RF20 202
I=IP+IR(L+1);N=IP+IR(L+2)#             Point to index and value         RF20 203
K=IP+IR(L+3);M=NINT(QX(I))#            Point to esd and array           RF20 204
ATTENU(M)=QX(N);ESTENU(M)=QX(K)#       Keep values                      RF20 205
L=L+3#                                                                  RF20 206
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RF20 207
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RF20 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RF20 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RF20 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RF20 211
#                                                                       RF20 212
#    ANALYSE DIRECTORY PACKET OF LRREFL: TO SEE WHAT IS THERE           RF20 213
#    --------------------------------------------------------           RF20 214
#                                                                       RF20 215
# IWANT(1,2,3,4) FOR RAW, NET, F**2 AND F RESPECTIVELY                  RF20 216
readwpkt:(1,lrrefl:,PSIZE,IP,0)#       Read directory of lrrefl:        RF20 217
I=NINT(DSNM)*1000#                     Dataset key offset               RF20 218
DO J=1,4; IWANT(J)=0#                  Use iwant to test presence       RF20 219
DO J=1,10; IR(J)=0#                    Pointers for raw data            RF20 220
DO J=1,PSIZE#                          Loop over directory packet       RF20 221
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RF20 222
IDN=NINT(QX(IP+J))#                    Extract the id number            RF20 223
IF      (IDN==1)#                      Hkl for all and min/max          RF20 224
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RF20 225
DO K=1,4; IWANT(K)=IWANT(K)+1#                                          RF20 226
IR(10)=J#                                                               RF20 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RF20 228
ELSE IF (IDN==I)#                      Peak for refs and raw gross      RF20 229
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RF20 230
IR(2)=J;IWANT(1)=IWANT(1)+1#                                            RF20 231
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RF20 232
ELSE IF (IDN==I+21)#                   Peak for refs and raw peak       RF20 233
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RF20 234
IR(2)=J;IWANT(1)=IWANT(1)+1#                                            RF20 235
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RF20 236
ELSE IF (IDN==I+23)#                   Low backg for refs and raw       RF20 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RF20 238
IR(3)=J;IWANT(1)=IWANT(1)+1#                                            RF20 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RF20 240
ELSE IF (IDN==I+24)#                   High backg for refs and raw      RF20 241
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RF20 242
IR(4)=J;IWANT(1)=IWANT(1)+1#                                            RF20 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RF20 244
ELSE IF (IDN==I+11)#                   Azimuth for raw and net          RF20 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RF20 246
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RF20 248
ELSE IF (IDN==I+14)#                   Time for refs, raw & net         RF20 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RF20 250
IR(5)=J;IWANT(1)=IWANT(1)+1#                                            RF20 251
IWANT(2)=IWANT(2)+1#                                                    RF20 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RF20 253
ELSE IF (IDN==I+26)#                   Attenu for raw & net             RF20 254
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RF20 255
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 256
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RF20 257
ELSE IF (IDN==I+309)#                  Scale for raw & net              RF20 258
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RF20 259
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 260
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RF20 261
ELSE IF (IDN==I+18)#                                                    RF20 262
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RF20 263
IR(1)=J;IWANT(1)=IWANT(1)+1#           Stand flag for refs, raw & net   RF20 264
IWANT(2)=IWANT(2)+1#                                                    RF20 265
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RF20 266
ELSE IF (IDN==I+46)#                   Back scan for raw & net          RF20 267
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RF20 268
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RF20 270
ELSE IF (IDN==I+47)#                   Cnp for refs and raw             RF20 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RF20 272
IR(6)=J;IWANT(1)=IWANT(1)+1#                                            RF20 273
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RF20 274
ELSE IF (IDN==I+48)#                   Cnb for refs and raw             RF20 275
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RF20 276
IR(7)=J;IWANT(1)=IWANT(1)+1#                                            RF20 277
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RF20 278
ELSE IF (IDN==I+49)#                   Cnl for refs and raw             RF20 279
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RF20 280
IR(8)=J;IWANT(1)=IWANT(1)+1#                                            RF20 281
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RF20 282
ELSE IF (IDN==I+50)#                   Cnh for refs and raw             RF20 283
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RF20 284
IR(9)=J;IWANT(1)=IWANT(1)+1#                                            RF20 285
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RF20 286
ELSE IF (IDN==I+10)#                   Scan width for raw & net         RF20 287
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RF20 288
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 289
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RF20 290
ELSE IF (IDN==I+51)#                   Scan type for raw & net          RF20 291
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RF20 292
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 293
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RF20 294
ELSE IF (IDN==I+52)#                   Hor det for raw & net            RF20 295
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 RF20 296
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 297
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 RF20 298
ELSE IF (IDN==I+53)#                   Vert det for raw & net           RF20 299
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 RF20 300
IWANT(1)=IWANT(1)+1;IWANT(2)=IWANT(2)+1#                                RF20 301
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 RF20 302
ELSE IF (IDN==I+300) IWANT(2)=IWANT(2)+1# I rel for net                 RF20 303
ELSE IF (IDN==I+301) IWANT(2)=IWANT(2)+1# Esd i rel for ne              RF20 304
ELSE IF (IDN==I+302) IWANT(3)=IWANT(3)+1# F**2                          RF20 305
ELSE IF (IDN==I+303) IWANT(3)=IWANT(3)+1# Esd f**2                      RF20 306
ELSE IF (IDN==I+304) IWANT(4)=IWANT(4)+1# |f|                           RF20 307
ELSE IF (IDN==I+305) IWANT(4)=IWANT(4)+1# Esd |f|                       RF20 308
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RF20 309
DATIN=0#                               Set datin                        RF20 310
IF(IWANT(1)==18) DATIN=1#              All ok for raw                   RF20 311
ELSE IF(IWANT(2)==13) DATIN=2#         All ok for net                   RF20 312
ELSE IF(IWANT(3)==3) DATIN=3#          All ok for f**2                  RF20 313
ELSE IF(IWANT(4)==3) DATIN=4#          All ok for f                     RF20 314
IF(DATIN==0)iquit:(RF2008)#            Die input no good                RF20 315
#                                                                       RF20 316
#    READ LRREFL: LOADING REFERENCE REFLECTION INTENSITY DATA           RF20 317
#    --------------------------------------------------------           RF20 318
#                                                                       RF20 319
NSETS=1;NEWSET=yes:#                   Number of scale sets             RF20 320
MARKS=ISTOP; STEPS=5#                  Set memory ref reflns limits     RF20 321
REPEAT#                                Loop over packets                RF20 322
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 RF20 323
readwpkt:(1,lrrefl:,PSIZE,IP,0)#       Read and stop at end             RF20 324
IF(IP==0)BREAK#                                                         RF20 325
gethkl:(IP+IR(10),HKL)#                Unpack hkl                       RF20 326
DO I=1,3#                              Get min/max values hkl           RF20 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 RF20 328
MINHKL(I)=MIN(NINT(HKL(I)),MINHKL(I))#                                  RF20 329
MAXHKL(I)=MAX(NINT(HKL(I)),MAXHKL(I))#                                  RF20 330
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 RF20 331
ETIME=voidflg:#                        Void time and correction         RF20 332
IF(IR(5)>0) ETIME=QX(IP+IR(5))#        Get elapsed time                 RF20 333
ifnm:(ETIME) MXTIME=MAX(ETIME,MXTIME)# Keep max elapsed time            RF20 334
RFNX=0; J=IP+IR(1)#                    Default not a reference refln    RF20 335
ifnm:(QX(J)) RFNX=NINT(QX(J))#         Get reference refln flag         RF20 336
IF((RFNX>0)&(DATIN==1))#               Only do reference reflns         RF20 337
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 RF20 338
IF((NEWSET==yes:)\(GOTRFN(RFNX)==yes:))# Initialise new set             RF20 339
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 RF20 340
NEWSET=no:#                            Next references belong here      RF20 341
NSETS=NSETS+1#                         Set number of this lot           RF20 342
DO I=1,30; GOTRFN(I)=no:#              Don't have the references yet    RF20 343
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 RF20 344
GOTRFN(RFNX)=yes:#                     Got this refrn in this set       RF20 345
J=IP+IR(2);CSUM=QX(J)#                 Peak counts                      RF20 346
J=IP+IR(3);CBL=QX(J);XBL=CBL#          Low-angle background             RF20 347
J=IP+IR(4);CBH=QX(J);XBH=CBH#          High-angle background            RF20 348
J=IP+IR(6);CNP=QX(J);XNP=CNP#          Cnp                              RF20 349
J=IP+IR(7);CNB=QX(J);XNB=CNB#          Cnb                              RF20 350
J=IP+IR(8);CNL=QX(J);XNL=CNL#          Cnl                              RF20 351
J=IP+IR(9);CNH=QX(J);XNH=CNH#          Cnh                              RF20 352
IF((XNL==0.0) \ (XNH==0.0))#           No background measurment         RF20 353
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 RF20 354
XNL=1.0;XNH=1.0;XBL=0.0;XBH=0.0#       Fiddle for formula below         RF20 355
IF(DATOUT!=1) IXRFN=yes:#              Exclude reference reflns if no   RF20 356
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 RF20 357
L=ISTOP;incrqx:(ISTOP,ISTOP+STEPS,RF2007)#                              RF20 358
QX(L+1)=REAL(RFNX)#                    Store reference refln flag       RF20 359
QX(L+2)=(CSUM/XNP-0.5*XNB/XNP*(XBL/XNL+XBH/XNH))# Net intensity         RF20 360
QX(L+3)=CSUM/XNP**2+0.25*XNB**2/XNP**2*(XBL/XNL**2+XBH/XNH**2)# Var(n   RF20 361
QX(L+4)=ETIME#                         Store elapsed time               RF20 362
QX(L+5)=REAL(NSETS)#                   Store set number                 RF20 363
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 RF20 364
ELSE NEWSET=yes:#                      Ordinary reflection ends ref s   RF20 365
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 RF20 366
STOPS=ISTOP#                           End of marks and current         RF20 367
MXTIME=MXTIME+1.0#                     Slightly larger than max time    RF20 368
NSETS=NSETS+1#                         Final set past references        RF20 369
#                                                                       RF20 370
#   FINISH OFF AND REWIND THE INPUT BDF                                 RF20 371
#   -----------------------------------                                 RF20 372
#                                                                       RF20 373
readwpkt:(1,endrecord:,PSIZE,IP,0)#    This should finish it            RF20 374
#                                                                       RF20 375
RETURN#                                                                 RF20 376
END#                                                                    RF20 377
systemheader:(RF25)#                   Print out controls               RF25   1
#********************************************************************** RF25   2
#                                                                       RF25   3
#                                RF25                                   RF25   4
#                                                                       RF25   5
#********************************************************************** RF25   6
SUBROUTINE RF25#                       H.d. flack nov. 1990             RF25   7
include:(AACOMN)#                                                       RF25   8
INTEGER M,N#                           Misc pointers and indexes        RF25   9
include:(RFCOMN)#                                                       RF25  10
#                                                                       RF25  11
chardata:(RF251, REFCAL CONTROL PARAMETERS-)#                           RF25  12
chardata:(RF252," Instability option                            ")#     RF25  13
chardata:(RF253," Instability factor from  scaled  reference reflns ")# RF25  14
chardata:(RF254,"unscaled")#                                            RF25  15
chardata:(RF255," Rescale data for reference refln variation  no")#     RF25  16
chardata:(RF256," Smoothing range in scale calculation          ")#     RF25  17
chardata:(RF257,"[ Rcode=1 if |Frel|/esd(|Frel|)    >            ]")#   RF25  18
chardata:(RF25K," Data set     XXXXXXXXXXXX        number         ")#   RF25  19
chardata:(RF258," Data input                                    ")#     RF25  20
chardata:(RF259," Data output                                   ")#     RF25  21
chardata:(RF25A,"RawI NetI Fsqr Frel ")#                                RF25  22
chardata:(RF25B," Include interpolated form factors in bdf    no")#     RF25  23
chardata:(RF25C," Include systematic absences in bdf          no")#     RF25  24
chardata:(RF25E," Include reference reflns in bdf             no")#     RF25  25
chardata:(RF25F," Number of reflections printed                 ")#     RF25  26
chardata:(RF25J,"yes")#                                                 RF25  27
datastuff:#                                                             RF25  28
#                                      Check datin vs datout - print    RF25  29
#                                                                       RF25  30
#   PRINT CONTROL SUMMARY                                               RF25  31
#   ---------------------                                               RF25  32
#                                                                       RF25  33
writeline:(1,RF251,NRF251-1,3,3)#      Refcal control param             RF25  34
movechar:(RF251,NRF251,CHROT,2,25,1)#  Underline                        RF25  35
writeline:(0,0,0,1,3)#                                                  RF25  36
IF(INSTAB>0&SCRFN==no:) movechar:(RF254,1,RF253,26,8,0)# Scaling inst   RF25  37
writeline:(0,RF253,NRF253,3,3)#                                         RF25  38
ncodefld:(FLOAT(INSTAB),1,RF252,470213.,1)# Instability option          RF25  39
writeline:(0,RF252,NRF252,3,3)#                                         RF25  40
IF(IAPPLY==yes:)movechar:(RF25J,1,RF255,45,3,0)# Apply scales           RF25  41
writeline:(0,RF255,NRF255,3,3)#                                         RF25  42
ncodefld:(FLOAT(SMOOTH),1,RF256,470213.,1)# Smoothing range             RF25  43
writeline:(0,RF256,NRF256,3,3)#                                         RF25  44
ncodefld:(THRESH,1,RF257,470822.,1)#   Observed threshold               RF25  45
writeline:(0,RF257,NRF257,3,3)#                                         RF25  46
ncodefld:(DSNM,1,RF25K,470213.,1)#     Data set number                  RF25  47
movechar:(DSNAME,1,RF25K,15,12,0)#     Data set name                    RF25  48
writeline:(0,RF25K,NRF25K,3,3)#                                         RF25  49
M=5*DATIN-4;N=5*DATOUT-4#              Point to data input/output       RF25  50
movechar:(RF25A,M,RF258,44,4,0)#       Tell conversion types            RF25  51
writeline:(0,RF258,NRF258,3,3)#                                         RF25  52
movechar:(RF25A,N,RF259,44,4,0)#       Tell conversion types            RF25  53
writeline:(0,RF259,NRF259,3,3)#                                         RF25  54
IF(FFAC==yes:) movechar:(RF25J,1,RF25B,45,3,0)# Ff required             RF25  55
writeline:(0,RF25B,NRF25B,3,3)#                                         RF25  56
IF(SABS==yes:) movechar:(RF25J,1,RF25C,45,3,0)# Include sys abs         RF25  57
writeline:(0,RF25C,NRF25C,3,3)#                                         RF25  58
IF(IXRFN==no:) movechar:(RF25J,1,RF25E,45,3,0)# Exclude reference re    RF25  59
writeline:(0,RF25E,NRF25E,3,3)#                                         RF25  60
ncodefld:(FLOAT(IPRINT),1,RF25F,470613.,1)# Hkl printed                 RF25  61
writeline:(0,RF25F,NRF25F,3,3)#                                         RF25  62
#                                                                       RF25  63
IF(DATOUT<DATIN)iquit:(RF2502)#        Impossible conversion            RF25  64
#                                                                       RF25  65
RETURN#                                                                 RF25  66
END#                                                                    RF25  67
systemheader:(RF30)#                   Plot reference reflections       RF30   1
#********************************************************************** RF30   2
#                                                                       RF30   3
#                                RF30                                   RF30   4
#                                                                       RF30   5
#********************************************************************** RF30   6
SUBROUTINE RF30(ICALL)#                                                 RF30   7
include:(AACOMN)#                                                       RF30   8
include:(RFCOMN)#                                                       RF30   9
#                                                                       RF30  10
REAL    AVE#                           Average reference refln intens   RF30  11
REAL    DIV#                           Size of a plot point divisio     RF30  12
REAL    FI#                            Real of i above                  RF30  13
REAL    FMT1(3)#                       Arrays for formats               RF30  14
INTEGER L,M#                                                            RF30  15
INTEGER I#                             Count of number of observati     RF30  16
INTEGER ICALL#                         Call 1=raw, 2=smoothed           RF30  17
INTEGER IHOLD#                         Temp storage for reference ref   RF30  18
INTEGER IP1,IP2,IP3,IP4#               Pointers to plotter position     RF30  19
INTEGER J#                             Loop counter for reference ref   RF30  20
INTEGER K#                             Loop index for stored observ     RF30  21
REAL    OFFS#                          Offset for plot mid pt           RF30  22
REAL    RANGE#                         Range of intensities for a s     RF30  23
REAL    S#                             Sum of observed intensities      RF30  24
REAL    SIGA#                          Std dev of a reference refln     RF30  25
REAL    SMAX#                          For finding range of i's         RF30  26
REAL    SMIN#                          Ditto                            RF30  27
REAL    SQ#                            Sum of squares of obs int        RF30  28
REAL    STENTY#                        Counting sigma i                 RF30  29
REAL    TENTY#                         Intensity of a reference refln   RF30  30
#                                                                       RF30  31
chardata:(RF302,"[   h   k   l    Times obs  Average I  Calc $#         RF30  32
sig(I)  Iten/div  Plot I  2*sig ave]")#                                 RF30  33
chardata:(RF303,X.*0123456789)#                                         RF30  34
chardata:(RF304," RAW REFERENCE REFLECTIONS-")#                         RF30  35
chardata:(RF305," SCALED REFERENCE REFLECTIONS-")#                      RF30  36
chardata:(RF308,"[ No information on reference reflections, $#          RF30  37
no plots.]")#                                                           RF30  38
realdata:(BIG,9999999.)#                                                RF30  39
realdata:(POINTS,78.)#                                                  RF30  40
realdata:(FORM,[430413.,480413.,530413.])#                              RF30  41
realdata:(FMT,[40413.,080413.,120413.,220613.,361022.,481032.,#         RF30  42
591042.])#                                                              RF30  43
datastuff:#                                                             RF30  44
#                                                                       RF30  45
#  SET UP FORMATS FOR HEADING GRAPHS AT MID POINT AND RIGHT             RF30  46
#  --------------------------------------------------------             RF30  47
#                                                                       RF30  48
FMT1(1)=90831.#                        Set left of graph                RF30  49
FMT1(2)=5000.*POINTS+30831.#           Center point                     RF30  50
FMT1(3)=10000.*POINTS+10831.#          Right end point                  RF30  51
OFFS=0.5*POINTS#                       Set center of graph              RF30  52
#                                                                       RF30  53
#  REPORT OUT TREND OF ALL REFERENCE REFLECTIONS HELD IN MEMORY         RF30  54
#  ------------------------------------------------------------         RF30  55
#                                                                       RF30  56
TOTRFN=(STOPS-MARKS)/STEPS#            Calculate total reference refl   RF30  57
IF(TOTRFN<=0)#                         Test if any reference reflns g   RF30  58
writeline:(1,RF308,NRF308,3,3)#        Swan song                        RF30  59
ELSE#                                  There are some reference refln   RF30  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF30  61
LINRM=8#                               Stick title with graph           RF30  62
IF(ICALL==1)#                          Raw reference reflections        RF30  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF30  64
writeline:(2,RF304,NRF304-1,3,3)#                                       RF30  65
movechar:(RF304,NRF304,CHROT,2,NRF304-2,1)# Underline                   RF30  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF30  67
ELSE#                                  Smoothed reference reflections   RF30  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF30  69
writeline:(1,RF305,NRF305-1,3,3)#                                       RF30  70
movechar:(RF305,NRF305,CHROT,2,NRF305-2,1)# Underline                   RF30  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF30  72
writeline:(0,0,0,1,3)#                 Output underline                 RF30  73
FOR(J=1;J<=ISC;J=J+1)#                 Loop over reference reflns       RF30  74
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF30  75
I=0#                                   Zero count of times measured     RF30  76
S=0.0;SQ=0.0#                          Zero sums of i and i**2          RF30  77
SMAX=-BIG;SMIN=BIG#                    Set extremes for searching       RF30  78
#                                                                       RF30  79
#  SCAN THROUGH LIST LOOKING FOR JTH REFERENCE REFLECTION               RF30  80
#  ------------------------------------------------------               RF30  81
#                                                                       RF30  82
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over storage                RF30  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF30  84
IHOLD=NINT(QX(K+1))#                   Pull out reference refln no.     RF30  85
IF(IHOLD==J)#                          Check if current j               RF30  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF30  87
I=I+1#                                 Count it                         RF30  88
TENTY=QX(K+2)#                         Retrieve the intensity           RF30  89
S=S+TENTY#                             Sum of all observations          RF30  90
SQ=SQ+TENTY**2#                        Sum of squares                   RF30  91
STENTY=2.*SQRT(ABS(QX(K+3)))#          Get out 2sigma i                 RF30  92
SMAX=AMAX1(SMAX,TENTY+STENTY)#         Seek maximum in i + sigi         RF30  93
SMIN=AMIN1(SMIN,TENTY-STENTY)#         Seek minimum in i - sigi         RF30  94
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF30  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF30  96
#                                                                       RF30  97
BUFOT(1)=FLOAT(IHH(1,J))#              Pick up h of reference refln.    RF30  98
BUFOT(2)=FLOAT(IHH(2,J))#              K                                RF30  99
BUFOT(3)=FLOAT(IHH(3,J))#              L                                RF30 100
#                                                                       RF30 101
#  CALCULATE THE STATISTICS ON THE JTH REFERENCE REFLECTION             RF30 102
#  --------------------------------------------------------             RF30 103
#                                                                       RF30 104
FI=FLOAT(I)#                                                            RF30 105
AVE=S/FI#                              Calculate the mean of all me     RF30 106
SIGA=SQRT(ABS((FI*SQ-S**2)/AMAX1((FI**2-FI),1.0)))# Get standard dev.   RF30 107
SMAX=AMAX1(SMAX,AVE+2.*SIGA)#          Reexamine maximum                RF30 108
SMIN=AMIN1(SMIN,AVE-2.*SIGA)#          And minimum also                 RF30 109
RANGE = 2.0*(SMAX-SMIN)#               Get total spread of i net        RF30 110
DIV=RANGE/POINTS#                      Get division size                RF30 111
LINRM=10#                              Force space                      RF30 112
BUFOT(4)=FI;BUFOT(5)=AVE;BUFOT(6)=SIGA;BUFOT(7)=DIV#                    RF30 113
BUFOT(8)=AVE-.5*RANGE;BUFOT(9)=AVE#    Store for print                  RF30 114
BUFOT(10)=AVE+.5*RANGE#                                                 RF30 115
RANGE=POINTS/RANGE#                    Set for plotting                 RF30 116
ncodefld:(BUFOT,1,CHROT,FMT,7)#                                         RF30 117
movechar:(RF303,1,CHROT,65,1,1)#       Move x                           RF30 118
movechar:(RF303,2,CHROT,72,1,1)#       Move .                           RF30 119
movechar:(RF303,3,CHROT,77,1,1)#       Move *                           RF30 120
writeline:(1,RF302,NRF302,2,3)#        Write the plot heading           RF30 121
ncodefld:(BUFOT,8,CHROT,FMT1,3)#       Encode min/ave/max               RF30 122
writeline:(0,0,0,1,3)#                                                  RF30 123
#                                                                       RF30 124
IP1=NINT((SMIN-AVE)*RANGE+OFFS)#       Get upper two sigma              RF30 125
IP4=NINT(OFFS)#                        Get average for graph            RF30 126
IP3=NINT((SMAX-AVE)*RANGE+OFFS)#       Get lower two sigma              RF30 127
movechar:(RF303,2,CHROT,IP1,IP3-IP1+1,1)# Plug in character .           RF30 128
movechar:(RF303,3,CHROT,IP4,1,1)#      Plug in character *              RF30 129
writeline:(0,0,0,1,3)#                 Write heading of plot itself     RF30 130
#                                                                       RF30 131
I=1#                                   Set initial digit pointer        RF30 132
FOR(K=MARKS;K<STOPS;K=K+STEPS)#        Loop over all stored data        RF30 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RF30 134
IHOLD=NINT(QX(K+1))#                   Pull out reference refln no.     RF30 135
IF(IHOLD!=J) NEXT#                     Check if it is j                 RF30 136
TENTY=QX(K+2)#                         Pick up individual intensity     RF30 137
STENTY=2.*SQRT(ABS(QX(K+3)))#          Estimated sigma(i)               RF30 138
IP1=NINT((TENTY+STENTY-AVE)*RANGE+OFFS)# Get upper s(i) pt              RF30 139
IP2=NINT((TENTY-AVE)*RANGE+OFFS)#      Get measured i pt                RF30 140
IP3=NINT((TENTY-STENTY-AVE)*RANGE+OFFS)# Get lower bound                RF30 141
IP1=MIN0(MAX0(IP1,1),79)#              Protect graph pointer            RF30 142
IP2=MIN0(MAX0(IP2,1),79)#              Protect graph pointer            RF30 143
IP3=MIN0(MAX0(IP3,1),79)#              Protect graph pointer            RF30 144
L=NINT(QX(K+5))#                       Set pointer of this measuremen   RF30 145
WHILE(I!=L)#                           Advance up to this set no.       RF30 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RF30 147
I=I+1;M=MOD(I-1,10)#                   Get digit pointer                RF30 148
movechar:(RF303,M+4,CHROT,IP4,1,1)#    Plug in digit                    RF30 149
IF(I==L)#                              Output measurement               RF30 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RF30 151
movechar:(RF303,2,CHROT,IP1,1,1)#      Plug in character .              RF30 152
movechar:(RF303,2,CHROT,IP3,1,1)#      Plug in character .              RF30 153
movechar:(RF303,1,CHROT,IP2,1,1)#      Plug in character x              RF30 154
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RF30 155
writeline:(0,0,0,1,3)#                 Put out line of plot             RF30 156
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RF30 157
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RF30 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF30 159
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF30 160
RETURN#                                                                 RF30 161
END#                                                                    RF30 162
systemheader:(RF40)#                   Find scales from reference ref   RF40   1
#********************************************************************** RF40   2
#                                                                       RF40   3
#                                RF40                                   RF40   4
#                                                                       RF40   5
#********************************************************************** RF40   6
SUBROUTINE RF40#                       J. m. stewart  april 1983        RF40   7
include:(AACOMN)#                      H.d. flack november 1990         RF40   8
include:(RFCOMN)#                                                       RF40   9
#                                                                       RF40  10
#  SUBROUTINE TO READ INSTRUCTIONS FOR SETTING DISCONTINUITIES IN       RF40  11
#  SCALE FACTOR SETS, OR SETTING SPECIFIED SCALE VALUES.                RF40  12
#                                                                       RF40  13
INTEGER I,K,KK,KKK,J#                  Misc. pointers                   RF40  14
INTEGER IHIT#                          For time check                   RF40  15
INTEGER IRFN#                          Reference refln number           RF40  16
INTEGER ISET#                          Set number of reference refln    RF40  17
REAL    NZEROT(30)#                    Intensity at zero time           RF40  18
INTEGER REFLN#                         Reference reflection pointer     RF40  19
REAL    SCALE#                         Scale factor                     RF40  20
REAL    SUM1,SUM2#                     Sum for scale calculation        RF40  21
REAL    TIME#                          Scale set time (last ref)        RF40  22
#                                                                       RF40  23
chardata:(RF401, END    SETSCL DISCON )#                                RF40  24
chardata:(RF402,"setscl")#                                              RF40  25
chardata:(RF40A," Scale Set    Scale Factor         Time")#             RF40  26
chardata:(RF40B,"discontinuity")#                                       RF40  27
chardata:(RF40C," RAW SCALE FACTORS-")#                                 RF40  28
realdata:(FMT,[70413.,231052.,390812.])#                                RF40  29
datastuff:#                                                             RF40  30
#                                                                       RF40  31
#  INITIALIZATIONS                                                      RF40  32
#  ---------------                                                      RF40  33
#                                                                       RF40  34
MARKR=ISTOP; STOPR=MARKR; STEPR=2#     Set up scale array               RF40  35
DO I=1,30; NZEROT(I)=0.0#              Zero intensity at t=0            RF40  36
SUM1=1.0;SUM2=1.0;TIME=0.0#            Initial sums                     RF40  37
KKK=1;REFLN=MARKS-STEPS#               Start with scale set 1 & 1st r   RF40  38
#                                                                       RF40  39
#  GENERATE THE SCALES FROM REFERENCE REFLECTIONS                       RF40  40
#  ----------------------------------------------                       RF40  41
#                                                                       RF40  42
REPEAT#                                                                 RF40  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF40  44
REFLN=REFLN+STEPS#                     Move to next reference refln     RF40  45
IF(REFLN>=STOPS) ISET=0#               Flag last set to treat           RF40  46
ELSE ISET=NINT(QX(REFLN+5))#           Set number                       RF40  47
IF(ISET!=KKK)#                         Reflection in new set            RF40  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF40  49
ifeq:(SUM1,0.0) SCALE=QX(STOPR-STEPR+1)# Use previous scale             RF40  50
ELSE SCALE=SUM2/SUM1#                  Get the scale                    RF40  51
K=STOPR;incrqx:(STOPR,STOPR+STEPR,RF4001)# Expand memory                RF40  52
ISTOP=STOPR#                           Current end of memory            RF40  53
QX(K+1)=SCALE#                         Save scale                       RF40  54
QX(K+2)=TIME#                          Save time of last member         RF40  55
DO I=1,30#                             Look for new references          RF40  56
IF(NZEROT(I)<0.0) NZEROT(I)=ABS(NZEROT(I)*SCALE)# New refrn             RF40  57
KKK=KKK+1#                             Next set                         RF40  58
SUM1=0.0;SUM2=0.0#                     Initial sums                     RF40  59
IF(ISET==0) BREAK#                     Finished                         RF40  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF40  61
IRFN=NINT(QX(REFLN+1));TIME=QX(REFLN+4)# Ref refln number & last time   RF40  62
IF(NZEROT(IRFN)>0.0)#                  Scaled reflection                RF40  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF40  64
SUM1=SUM1+ABS(QX(REFLN+2))#            Sum scaled references            RF40  65
SUM2=SUM2+NZEROT(IRFN)#                Sum scales                       RF40  66
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF40  67
ELSE NZEROT(IRFN)=-ABS(QX(REFLN+2))#   Mark as new, keep value          RF40  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF40  69
#                                                                       RF40  70
#  PUT IN A FINAL SCALE FACTOR TO COMPLETE THE TABLE                    RF40  71
#  AND STORE THE MAXIMUM TIME AT THE END OF THE TABLE                   RF40  72
# ------------------------------------------------------------          RF40  73
#                                                                       RF40  74
K=STOPR;incrqx:(STOPR,STOPR+STEPR,RF4001)# Get memory                   RF40  75
ISTOP=STOPR#                           Current end of memory            RF40  76
QX(K+1)=QX(K-STEPR+1)#                 Pick up penultimate scale        RF40  77
QX(K+2)=MXTIME#                        Save the last of the last        RF40  78
#                                                                       RF40  79
#  READ FURTHER INPUT LINES IF PRESENT                                  RF40  80
#  -----------------------------------                                  RF40  81
#                                                                       RF40  82
REPEAT#                                Loop over input lines            RF40  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF40  84
IF(LINID==1) BREAK#                    Quit at end line                 RF40  85
#                                                                       RF40  86
#                                                                       RF40  87
#  SET UP INPUT SCALES                                                  RF40  88
#  -------------------                                                  RF40  89
#                                                                       RF40  90
ELSE IF(LINID==2)#                     **setscl** line entrered         RF40  91
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF40  92
IF((BUFIN(1)>small:)&(BUFIN(2)>=0.0)& $#                                RF40  93
(BUFIN(2)<=MXTIME))#                                                    RF40  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF40  95
IHIT=no:#                              Assume scale no good             RF40  96
FOR(I=MARKR;I<=STOPR;I=I+STEPR)#       Loop over all sets               RF40  97
ifeq:(BUFIN(2),QX(I+2),0.1)#           Test ending time                 RF40  98
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RF40  99
QX(I+1)=-BUFIN(1);IHIT=yes:#           Force the scale for set -ve      RF40 100
BREAK#                                 And get out to do next           RF40 101
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RF40 102
IF(IHIT==no:)iquit:(RF4002,2)#         Elapsed time does not correspo   RF40 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF40 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF40 105
#                                                                       RF40 106
#  SET UP DISCONTINUITY POINTS IN SCALES                                RF40 107
#  -------------------------------------                                RF40 108
#                                                                       RF40 109
ELSE IF(LINID==3)#                     **discon** line entered          RF40 110
FOR(I=1;I>0;I=I+1)#                    Loop over input fields           RF40 111
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RF40 112
IF(BUFIN(I)<=0.0)BREAK#                Stop when data stops             RF40 113
IF(NTABS>48) NEXT#                     Table only 50 long               RF40 114
J=0;IHIT=no:#                          Zero set count                   RF40 115
FOR(K=MARKR;K<STOPR;K=K+STEPR)#        Loop over scales                 RF40 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RF40 117
J=J+1#                                 Count sets                       RF40 118
ifeq:(QX(K+2),BUFIN(I),0.1)#           Seek to match time               RF40 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RF40 120
NTABS=NTABS+1#                                                          RF40 121
NTAB(NTABS)=J#                         Save the set pointer             RF40 122
IHIT=yes:;BREAK#                                                        RF40 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RF40 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RF40 125
IF(IHIT==no:)iquit:(RF4002,I)#         Elapsed time does not correspo   RF40 126
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RF40 127
readline:(RF401,NRF401)#               Replenish the buffer             RF40 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF40 129
#                                                                       RF40 130
#  PUT ONE ADDITIONAL ENTRY IN SCALE TABLE TO ALLOW FOR INTERPOLATION   RF40 131
#  -------------------------------------------------------------------  RF40 132
#                                                                       RF40 133
I=STOPR-STEPR;K=STOPR;incrqx:(STOPR,STOPR+STEPR,RF4001)# Memory         RF40 134
ISTOP=STOPR#                           Current end of memory            RF40 135
QX(K+1)=QX(I+1)#                       Same scale                       RF40 136
QX(K+2)=MXTIME+FLOAT(ISC)#             More time                        RF40 137
writeline:(1,0,0,3,3)#                 Force a blank line               RF40 138
IF(NTABS<=0)#                                                           RF40 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RF40 140
NTABS=1;    NTAB(NTABS)=NSETS#                                          RF40 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RF40 142
ELSE#                                                                   RF40 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RF40 144
NTABS=NTABS+1#                         Count last tab                   RF40 145
NTAB(NTABS)=NSETS#                     Set upper limit for sure         RF40 146
FOR(J=1;J<=NTABS;J=J+1)$#              Loop over whole table            RF40 147
NTAB(J)=MIN0(NSETS,NTAB(J))#           Don't let it fall off            RF40 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RF40 149
#                                                                       RF40 150
# PRINT OUT THE RAW SCALE FACTORS                                       RF40 151
# -------------------------------                                       RF40 152
#                                                                       RF40 153
KK=MARKR-STEPR;    J=1#                Set a running pointer            RF40 154
LINRM=8#                               Keep title with 4 values         RF40 155
writeline:(1,RF40C,NRF40C-1,3,3)#      Title raw scale factors          RF40 156
movechar:(RF40C,NRF40C,CHROT,2,NRF40C-2,1)# Underline                   RF40 157
writeline:(0,0,0,1,3)#                 Output underline                 RF40 158
LINRM=4#                               Force first header               RF40 159
movechar:(RF40B,1,CHROT,41,NRF40B,0)#  Discontinuity at start           RF40 160
DO K=1,NSETS#                          Loop over scale sets             RF40 161
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RF40 162
KK=KK+STEPR#                           Advance storage                  RF40 163
IF(QX(KK+1)<0.0)#                      Value from setscl                RF40 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RF40 165
movechar:(RF402,1,CHROT,25,NRF402,0)#  Indicate "setscl"                RF40 166
QX(KK+1)=ABS(QX(KK+1))#                                                 RF40 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RF40 168
BUFOT(1)=FLOAT(K-1);BUFOT(2)=QX(KK+1);BUFOT(3)=QX(KK+2)#                RF40 169
ncodefld:(BUFOT,1,CHROT,FMT,3)#                                         RF40 170
IF((NTAB(J)==K)&(J<=NTABS))#           Find discontinuities             RF40 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RF40 172
movechar:(RF40B,1,CHROT,41,NRF40B,0)#  Tell user                        RF40 173
J=J+1#                                 Having writ, move on             RF40 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RF40 175
writeline:(0,RF40A,NRF40A,1,3)#        Print raw scales                 RF40 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RF40 177
writeline:(1,0,0,3,3)#                 Force a blank line               RF40 178
#                                                                       RF40 179
RETURN#                                                                 RF40 180
END#                                                                    RF40 181
systemheader:(RF50)#                   Smooth the scales                RF50   1
#********************************************************************** RF50   2
#                                                                       RF50   3
#                                RF50                                   RF50   4
#                                                                       RF50   5
#********************************************************************** RF50   6
SUBROUTINE RF50#                       J.m. stewart april 1983          RF50   7
include:(AACOMN)#                      H.d. flack nov. 1990             RF50   8
include:(RFCOMN)#                                                       RF50   9
#                                                                       RF50  10
#  SUBROUTINE TO SMOOTH THE SCALES. THE CONCEPT OF SETTING 'TABS' IS    RF50  11
#  USED TO ALLOW SMOOTHING OVER SETS OF SCALE FACTORS. HENCE            RF50  12
#  DISCONTINUITIES IN DATA GATHERING ARE ALLOWED FOR.                   RF50  13
#  IF NO SMOOTHING IS CARRIED OUT THE SCALE FACTOR VARIATIONS TEND TO   RF50  14
#  BE DUE MAINLY TO STATISTICAL COUNTING FLUCTATIONS, CAUSING SENSELESS RF50  15
#  VARIATIONS IN THE SUCCESSIVE SET SCALES GENERATED FROM THE REFERENCE RF50  16
#  REFLECTIONS. ONE MAY EVEN OBTAIN NEGATIVE STABILITY CONSTANTS FROM   RF50  17
#  SUCH A CALCULATION. THE SMOOTHING WORKS BY FINDING THE AVERAGE OF    RF50  18
#  THE <SMOOTH> PREVIOUS AND <SMOOTH> FOLLOWING SET SCALES AND APPLYING RF50  19
#  THIS AVERAGE AS THE CURRENT SCALE.                                   RF50  20
#                                                                       RF50  21
REAL AVE#                              Average scale                    RF50  22
INTEGER NSTART,NSTOP#                  Dynamic tabs                     RF50  23
REAL PFACT#                            Scaling factor for smoothing     RF50  24
INTEGER J,J1,J2,JJ1,JJ2,K,KK#          Pointers for smoothing           RF50  25
#                                                                       RF50  26
chardata:(RF501," Scale Set    Scale Factor   Time")#                   RF50  27
chardata:(RF502,"discontinuity")#                                       RF50  28
chardata:(RF505," SMOOTHED SCALE FACTORS-")#                            RF50  29
realdata:(FMT,[80413.,231052.,331012.])#                                RF50  30
datastuff:#                                                             RF50  31
#                                                                       RF50  32
#  PREPARE SMOOTHED SCALE FACTORS                                       RF50  33
#  ------------------------------                                       RF50  34
#                                                                       RF50  35
IF(SMOOTH>0)#                          Do we want to smooth             RF50  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF50  37
PFACT=1.0/FLOAT(2*SMOOTH+1)#           Prepare 1/n for ave              RF50  38
NSTART=1#                              Always start with set one        RF50  39
FOR(J=1;J<=NTABS;J=J+1)#               Loop over all tabs               RF50  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF50  41
NSTOP=NTAB(J)#                         Pick up the last member          RF50  42
#                                                                       RF50  43
#  SET THE BASE AVERAGE FROM SCALE OF THE FIRST SET                     RF50  44
#  ------------------------------------------------                     RF50  45
#                                                                       RF50  46
JJ1=(NSTART-1)*STEPR+MARKR#            Find first at tab                RF50  47
AVE=FLOAT(SMOOTH+1)*QX(JJ1+1)#                                          RF50  48
DO K=1,SMOOTH#                         Loop over smoothing interval     RF50  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF50  50
J1=NSTART+K-1#                                                          RF50  51
IF(J1>NSTOP) J1=NSTOP#                 Keep in bounds                   RF50  52
JJ1=(J1-1)*STEPR+MARKR#                Get out a pointer                RF50  53
AVE=AVE+QX(JJ1+1)#                     Sum set scales                   RF50  54
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF50  55
AVE=AVE*PFACT#                         Get average scale                RF50  56
#                                                                       RF50  57
# CALCULATE FOR THE KTH SCALE BY ADDING ON THE                          RF50  58
# SCALE OF THE K + SMOOTH AND SUBTRACTING OFF THE SCALE                 RF50  59
# OF THE K - SMOOTH SET.                                                RF50  60
# ------------------------------------------------------                RF50  61
#                                                                       RF50  62
DO K=NSTART,NSTOP#                     Loop over each set of scales     RF50  63
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF50  64
J1=K-SMOOTH#                           Look back                        RF50  65
IF(J1<NSTART)J1=NSTART#                But not too far back             RF50  66
J2=K+SMOOTH#                           Look ahead                       RF50  67
IF(J2>NSTOP)J2=NSTOP#                  But carefully                    RF50  68
JJ1=(J1-1)*STEPR+MARKR;JJ2=(J2-1)*STEPR+MARKR#                          RF50  69
AVE=AVE+PFACT*(QX(JJ2+1)-QX(JJ1+1))#   Adjust the average               RF50  70
KK=(K-1)*STEPR+MARKR#                  Find the set                     RF50  71
QX(KK+1)=AVE#                          Damp the scale factor            RF50  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF50  73
NSTART=NSTOP+1#                        Go on to next set                RF50  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF50  75
#                                                                       RF50  76
# PRINT OUT THE SMOOTHED SCALE FACTORS                                  RF50  77
# ------------------------------------                                  RF50  78
#                                                                       RF50  79
KK=MARKR-STEPR;   J=1#                 Set a running pointer            RF50  80
LINRM=8#                               Keep title with 4 values         RF50  81
writeline:(1,RF505,NRF505-1,3,3)#      Title smoothed scale factors     RF50  82
movechar:(RF505,NRF505,CHROT,2,NRF505-2,1)# Underline                   RF50  83
writeline:(0,0,0,1,3)#                 Output underline                 RF50  84
LINRM=4#                               Force first header               RF50  85
movechar:(RF502,1,CHROT,35,NRF502,0)#  Discontinuity at start           RF50  86
DO K=1,NSETS#                          Loop number of scale sets        RF50  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF50  88
KK=KK+STEPR#                           Advance storage                  RF50  89
BUFOT(1)=FLOAT(K-1);BUFOT(2)=QX(KK+1);BUFOT(3)=QX(KK+2)#                RF50  90
ncodefld:(BUFOT,1,CHROT,FMT,3)#                                         RF50  91
IF((NTAB(J)==K)&(J<=NTABS))#           Find discontinuities             RF50  92
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF50  93
movechar:(RF502,1,CHROT,35,NRF502,0)#  Tell user                        RF50  94
J=J+1#                                 Having writ, move on             RF50  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF50  96
writeline:(0,RF501,NRF501,1,3)#        Print smoothed scale             RF50  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF50  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF50  99
#                                                                       RF50 100
RETURN#                                                                 RF50 101
END#                                                                    RF50 102
systemheader:(RF60)#                   Find the instability constants   RF60   1
####################################################################### RF60   2
#                                                                       RF60   3
#                               RF60                                    RF60   4
#                                                                       RF60   5
####################################################################### RF60   6
SUBROUTINE RF60#                       J.m.stewart april 1983           RF60   7
include:(AACOMN)#                                                       RF60   8
include:(RFCOMN)#                                                       RF60   9
#                                                                       RF60  10
#  THE ALGORITHM MAKES A LEAST-SQUARES ANALYSIS OF THE VARIATION        RF60  11
#  IN THE NET INTENSITY FOR THE REFERENCE REFLECTIONS OVER THE WHOLE    RF60  12
#  DATA SET.                                                            RF60  13
#  THERE ARE FOUR OPTIONS:                                              RF60  14
#  1.  CALCULATE A FACTOR BASED ON THE SCATTER OF THE REFERENCE         RF60  15
#      REFLECTIONS.                                                     RF60  16
#  2.  CALCULATE TWO FACTORS BASED ON THE SCATTER AND TREND IN THE      RF60  17
#      REFERENCE REFLECTIONS. A LEAST-SQUARES LINE THROUGH THE          RF60  18
#      REFERENCE REFLECTIONS AS A FUNCTION OF TIME.                     RF60  19
#  3.  LIKE 2 BUT THE INTERCEPT IS FORCED TO ZERO.                      RF60  20
#  4.  USE VALUES FOR THE SLOPE AND INTERCEPT WHICH ARE SUPPLIED BY     RF60  21
#      THE USER IN THE REFCAL INPUT LINE.                               RF60  22
#                                                                       RF60  23
REAL AVERAG(30)#                       Calculated average i net         RF60  24
REAL DENOM#                            Denominator temp.                RF60  25
INTEGER I,K,NQ,J#                      Loop control                     RF60  26
INTEGER NGO#                           No of different options pointe   RF60  27
INTEGER NRFN(30)#                      No. obs of reference reflns      RF60  28
REAL SUMX#                             Sum of x for l-s line            RF60  29
REAL SUMXSQ#                           Sum of x**2 for l-s line         RF60  30
REAL SUMY#                             Sum of y for l-s line            RF60  31
REAL SUMYX#                            Sum of xy product for l-s line   RF60  32
REAL SSIGMA(30)#                       Calc std dev in i net            RF60  33
REAL VARI(30)#                         Sums of variances of i net       RF60  34
REAL X#                                X for least squares line         RF60  35
REAL Y#                                Y for least squares lines        RF60  36
#                                                                       RF60  37
chardata:(RF601," INSTABILITY FACTORS DETERMINED FROM$#                 RF60  38
 -- REFERENCE REFLECTIONS")#                                            RF60  39
chardata:(RF602,"-*+ b")#                                               RF60  40
chardata:(RF603,"[   Option 0   From counting statistics only $#        RF60  41
TV = CV]")#                                                             RF60  42
chardata:(RF604,"            External    Average     Average   Times")# RF60  43
chardata:(RF605," Ref Refln  variance   var(Inet)     I net   $#        RF60  44
measured")#                                                             RF60  45
chardata:(RF606,"[ *  Option stored in bdf and used in the $#           RF60  46
calculation of var(|F|**2)]")#                                          RF60  47
chardata:(RF607," TV Total variance of I net")#                         RF60  48
chardata:(RF608," CV Counting variance of I net")#                      RF60  49
chardata:(RF609," User supplied values")#                               RF60  50
chardata:(RF60A,"[   Option x   Least squares fit to TV = CV     + $#   RF60  51
m*(I net)**2]")#                                                        RF60  52
chardata:(RF60B,"[   TV = CV + |          | + |          |*$#           RF60  53
(I net)**2]")#                                                          RF60  54
realdata:(FMT,[80213.,201241.,320841.,431041.,500613.])#                RF60  55
realdata:(FMT1,[110113.,240951.,390951.])#                              RF60  56
realdata:(TINY,.000001)#                                                RF60  57
datastuff:#                                                             RF60  58
#                                                                       RF60  59
#  CLEAR OUT SUMS FOR EACH AND EVERY DIFFERENT REFERENCE REFLECTION     RF60  60
#  ----------------------------------------------------------------     RF60  61
#                                                                       RF60  62
DO I=1,ISC#                                                             RF60  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF60  64
NRFN(I)=0;SSIGMA(I)=0.0#                                                RF60  65
VARI(I)=0.0;AVERAG(I)=0.0#                                              RF60  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF60  67
#                                                                       RF60  68
#  FORM AVERAGE OF I NET OVER THE WHOLE DATA SESSION.                   RF60  69
#  --------------------------------------------------                   RF60  70
#                                                                       RF60  71
FOR(I=MARKS;I<STOPS;I=I+STEPS)#        Loop over reference reflns       RF60  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF60  73
K=NINT(QX(I+1))#                       Pick up each reference refln i   RF60  74
IF(K>ISC) NEXT#                        Keep within tables               RF60  75
NRFN(K)=NRFN(K)+1#                     Count times observed             RF60  76
AVERAG(K)=AVERAG(K)+QX(I+2)#           Sum for average of i net         RF60  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF60  78
NQ=0#                                  Set to count acceptible          RF60  79
DO I=1,ISC#                            Loop over possible               RF60  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF60  81
IF(NRFN(I)<4) NEXT#                    Ignore small samples             RF60  82
NQ=NQ+1#                               Count as good                    RF60  83
AVERAG(I)=AVERAG(I)/FLOAT(NRFN(I))#    Sum i net / counts               RF60  84
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF60  85
#                                                                       RF60  86
#  REPORT RAW DATA TO USER                                              RF60  87
#  -----------------------                                              RF60  88
#                                                                       RF60  89
LINRM=8+NQ#                            Keep header together             RF60  90
movechar:(RF602,1,CHROT,2,NRF601-1,1)# Insert underline                 RF60  91
ncodefld:(FLOAT(NQ),1,RF601,390213.,1)# Format no. reference reflns     RF60  92
writeline:(1,RF601,NRF601,2,3)#                                         RF60  93
IF(NQ!=0)#                             Title only for something valid   RF60  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF60  95
writeline:(0,RF604,NRF604,3,3)#                                         RF60  96
writeline:(0,RF605,NRF605,3,3)#                                         RF60  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF60  98
#                                                                       RF60  99
#  CALCULATE THE EXTERNAL ESTIMATED VARIANCE FOR EACH                   RF60 100
#  REFERENCE REFLECTION MEASURED MORE THAN SIX TIMES.                   RF60 101
#  ----------------------------------------------------                 RF60 102
#                                                                       RF60 103
DO I=1,ISC#                                                             RF60 104
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF60 105
IF(NRFN(I)<7) NEXT#                    Forget those with too few        RF60 106
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over all reference reflns   RF60 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF60 108
K=NINT(QX(J+1))#                       Pick up reference refln no.      RF60 109
IF(K!=I)NEXT#                                                           RF60 110
VARI(I)=VARI(I)+(QX(J+2)-AVERAG(I))**2# Sum delta                       RF60 111
SSIGMA(I)=SSIGMA(I)+QX(J+3)#           Sum counting variance            RF60 112
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF60 113
#                                                                       RF60 114
#  CALCULATE THE EXTERNAL AND INTERNAL ESTIMATED VARIANCES OF I NET.    RF60 115
#  EXTERNAL MEANS ITS BASED ON OBSERVED VARIATIONS RATHER THAN          RF60 116
#  COUNTING STATISTICS.                                                 RF60 117
#  --------------------------------------------------------             RF60 118
#                                                                       RF60 119
VARI(I)=VARI(I)/REAL(NRFN(I)-1)#       External variance                RF60 120
SSIGMA(I)=SSIGMA(I)/REAL(NRFN(I))#     Internal variance                RF60 121
BUFOT(1)=FLOAT(I)#                                                      RF60 122
BUFOT(2)=VARI(I)#                                                       RF60 123
BUFOT(3)=SSIGMA(I)#                                                     RF60 124
BUFOT(4)=AVERAG(I)#                                                     RF60 125
BUFOT(5)=FLOAT(NRFN(I))#                                                RF60 126
ncodefld:(BUFOT,1,CHROT,FMT,5)#                                         RF60 127
writeline:(0,0,0,1,3)#                                                  RF60 128
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF60 129
writeline:(1,RF606,NRF606,3,3)#        Print meaning of *               RF60 130
writeline:(0,RF607,NRF607,3,3)#        Print meaning of tv              RF60 131
writeline:(0,RF608,NRF608,3,3)#        Print meaning of cv              RF60 132
IF(INSTAB==0)movechar:(RF602,2,RF603,2,1,0)# Insert *                   RF60 133
writeline:(1,RF603,NRF603,3,3)#        Print option 0.                  RF60 134
#                                                                       RF60 135
#  CALCULATE THE SLOPE AND INTERCEPT OF A LEAST SQUARES LINE            RF60 136
#  BASED ON THE SCATTER OF THE I NET.                                   RF60 137
#  FIND VARI(I) = SSIGMA(I) + INTERCEPT + SLOPE*AVERAG(I)**2            RF60 138
#  ---------------------------------------------------------            RF60 139
#                                                                       RF60 140
FOR(NGO=1;NGO<=4;NGO=NGO+1)#                                            RF60 141
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RF60 142
SUMYX=0.0;SUMXSQ=0.0#                                                   RF60 143
#                                                                       RF60 144
#   LEAST SQUARES LINE WITH A ZERO INTERCEPT.                           RF60 145
#  ------------------------------------------                           RF60 146
#                                                                       RF60 147
IF(NGO==1)#                                                             RF60 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RF60 149
DO I=1,ISC#                                                             RF60 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RF60 151
IF(NRFN(I)<7)NEXT#                     No small potatoes                RF60 152
X=AVERAG(I)**2#                                                         RF60 153
SUMYX=(VARI(I)-SSIGMA(I))*X+SUMYX#                                      RF60 154
SUMXSQ=SUMXSQ+X**2#                                                     RF60 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RF60 156
IF(SUMXSQ>TINY)#                       Protect divide                   RF60 157
SLOPE(NGO)=SUMYX/SUMXSQ#               Get the slope                    RF60 158
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RF60 159
#                                                                       RF60 160
#   LEAST SQUARES LINE WITH A CALCULATED INTERCEPT.                     RF60 161
#  ------------------------------------------------                     RF60 162
#                                                                       RF60 163
ELSE IF(NGO==2)#                                                        RF60 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RF60 165
SUMX=0.0;SUMY=0.0#                                                      RF60 166
DO I=1,ISC#                                                             RF60 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RF60 168
IF(NRFN(I)<7) NEXT#                    Skip reference reflns of no ac   RF60 169
Y=VARI(I)-SSIGMA(I)#                                                    RF60 170
X=AVERAG(I)**2#                                                         RF60 171
SUMYX=SUMYX+Y*X#                                                        RF60 172
SUMX=SUMX+X#                                                            RF60 173
SUMY=SUMY+Y#                                                            RF60 174
SUMXSQ=SUMXSQ+X**2#                                                     RF60 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RF60 176
DENOM=-SUMXSQ+SUMX**2/FLOAT(MAX0(1,NQ))# Get denominator                RF60 177
IF(ABS(DENOM)>TINY)#                   Protect divide                   RF60 178
SLOPE(NGO)=(-SUMYX+SUMX*SUMY/FLOAT(NQ))/DENOM#                          RF60 179
INTERC(NGO)=(SUMY-SLOPE(NGO)*SUMX)/FLOAT(MAX0(1,NQ))# And save them     RF60 180
movechar:(RF602,3,RF60A,44,3,0)#       Insert + b                       RF60 181
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RF60 182
#                                                                       RF60 183
#  IN THE THIRD CASE INTERCEPT IS FORCED TO ZERO                        RF60 184
#  SLOPE IS ACCEPTED FROM CALCULATION LIKE CASE 2                       RF60 185
#  ----------------------------------------------                       RF60 186
#                                                                       RF60 187
ELSE IF(NGO==3)#                                                        RF60 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RF60 189
SLOPE(NGO)=SLOPE(NGO-1)#               Take slope from ii.              RF60 190
movechar:(RF602,4,RF60A,44,3,1)#       Insert "   "                     RF60 191
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RF60 192
ELSE IF(NGO==4)#                                                        RF60 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RF60 194
movechar:(RF602,3,RF60A,44,3,0)#       Insert + b                       RF60 195
movechar:(RF609,1,RF60A,14,21,0)#      Insert user supplied values      RF60 196
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RF60 197
#                                                                       RF60 198
IF(INSTAB==NGO)movechar:(RF602,2,RF60A,2,1,0)# Insert *                 RF60 199
ELSE movechar:(RF602,4,RF60A,2,1,0)#   Insert " "                       RF60 200
BUFOT(1)=FLOAT(NGO);BUFOT(2)=INTERC(NGO);BUFOT(3)=SLOPE(NGO)#           RF60 201
ncodefld:(BUFOT,1,RF60A,FMT1(1),1)#                                     RF60 202
ncodefld:(BUFOT,2,RF60B,FMT1(2),2)#                                     RF60 203
writeline:(1,RF60A,NRF60A,3,3)#                                         RF60 204
writeline:(0,RF60B,NRF60B,3,3)#                                         RF60 205
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RF60 206
#                                                                       RF60 207
RETURN#                                                                 RF60 208
END#                                                                    RF60 209
systemheader:(RF70)#                   2nd read/write first part        RF70   1
#********************************************************************** RF70   2
#                                                                       RF70   3
#                                RF70                                   RF70   4
#                                                                       RF70   5
#********************************************************************** RF70   6
SUBROUTINE RF70#                       H.d. flack november 1990         RF70   7
include:(AACOMN)#                                                       RF70   8
include:(RFCOMN)#                                                       RF70   9
INTEGER I#                                                              RF70  10
INTEGER KEY(4)#                                                         RF70  11
chardata:(RF701,'Less-thans defined by |Fo| < 0 esd(|Fo|)')#            RF70  12
datastuff:#                                                             RF70  13
#                                                                       RF70  14
#  LREXPL: NEEDS UPDATING FOR THE MINIMUM AND MAXIMUM VALUES OF HKL.    RF70  15
#                                                                       RF70  16
copyfile:(1,2,lrhist:,decr:(lrscat:))# Copy leading records             RF70  17
KEY(1)=0;KEY(2)=298;KEY(3)=299;KEY(4)=0# Directory packet setup         RF70  18
DO I=1,6; IWANT(I)=I#                  Need everything to copy          RF70  19
DO I=7,298; IWANT(I)=I+1#              But missing interpol flag        RF70  20
IWANT(299)=7#                          Add interpol flag if not there   RF70  21
indexpkt:(1,lrscat:,PSIZE,IP,2,KEY,IWANT,IR)#                           RF70  22
OPSIZ=KEY(4)#                          Set output packet size           RF70  23
#                                                                       RF70  24
#  LOOP OVER ALL LRSCAT: PACKETS                                        RF70  25
#  -----------------------------                                        RF70  26
#                                                                       RF70  27
REPEAT#                                Loop over all data               RF70  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF70  29
readwpkt:(1,lrscat:,PSIZE,IP,0)#       Read/write pkt                   RF70  30
IF(IP<=0) BREAK#                       Quit when done                   RF70  31
writepkt:(2,lrscat:,OPSIZ,OPP)#        Get ouput packet                 RF70  32
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Move input to output             RF70  33
IF(FFAC==yes:)QX(OPP+IR(299))=1.0#     Interpol scattering factors in   RF70  34
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF70  35
#                                                                       RF70  36
copyfile:(1,2,incr:(lrscat:),decr:(lrexpl:))# Copy records up to lrex   RF70  37
KEY(1)=0;KEY(2)=793;KEY(3)=799+mw40dm:;KEY(4)=0# Directory packet set   RF70  38
DO I=1,500; IWANT(I)=I#                Need everything to copy          RF70  39
DO I=501,525; IWANT(I)=I+6#            But missing min/max hkl          RF70  40
DO I=526,793; IWANT(I)=I+7#            And less-than definition         RF70  41
DO I=794,799; IWANT(I)=I-293#          Add min/max hkl if not there     RF70  42
DO I=1,mw40dm:; IWANT(799+I)=532#      Add less-than definition if no   RF70  43
indexpkt:(1,lrexpl:,PSIZE,IP,2,KEY,IWANT,IR)#                           RF70  44
OPSIZ=KEY(4)#                          Set output packet size           RF70  45
#                                                                       RF70  46
#  LOOP OVER ALL LREXPL: PACKETS                                        RF70  47
#  -----------------------------                                        RF70  48
#                                                                       RF70  49
REPEAT#                                Loop over all data               RF70  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF70  51
readwpkt:(1,lrexpl:,PSIZE,IP,0)#       Read/write pkt                   RF70  52
IF(IP<=0) BREAK#                       Quit when done                   RF70  53
writepkt:(2,lrexpl:,OPSIZ,OPP)#        Get ouput packet                 RF70  54
movereal:(QX,IP+1,QX,OPP+1,PSIZE,1)#   Move input to output             RF70  55
IF(IR(1)>0) ifeq:(QX(IP+IR(1)),DSNM)#  Is it the data set we want?      RF70  56
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF70  57
#                                      Transfer min/max hkl to output   RF70  58
QX(OPP+IR(794))=REAL(MINHKL(1))#       Min h                            RF70  59
QX(OPP+IR(795))=REAL(MAXHKL(1))#       Max h                            RF70  60
QX(OPP+IR(796))=REAL(MINHKL(2))#       Min k                            RF70  61
QX(OPP+IR(797))=REAL(MAXHKL(2))#       Max k                            RF70  62
QX(OPP+IR(798))=REAL(MINHKL(3))#       Min l                            RF70  63
QX(OPP+IR(799))=REAL(MAXHKL(3))#       Max l                            RF70  64
BUFOT(1)=AMAX1(0.0,THRESH)#            Less-than threshold factor       RF70  65
ncodefld:(BUFOT,1,RF701,300113.,1)#    Format factor                    RF70  66
movector:(RF701,1,QX(OPP+IR(800)),1,40,0)# Keep less-thans defn strin   RF70  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF70  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF70  69
copyfile:(1,2,incr:(lrexpl:),decr:(lrrefl:))# Copy upto lrrefl:         RF70  70
RETURN#                                                                 RF70  71
END#                                                                    RF70  72
systemheader:(RF71)#                   2nd read/write lrrefl:           RF71   1
#********************************************************************** RF71   2
#                                                                       RF71   3
#                                RF71                                   RF71   4
#                                                                       RF71   5
#********************************************************************** RF71   6
SUBROUTINE RF71#                       J.m. stewart april 1983          RF71   7
include:(AACOMN)#                      H.d. flack october 1990          RF71   8
include:(RFCOMN)#                                                       RF71   9
#                                                                       RF71  10
#  FOR EACH REFLECTION CALCULATE SCALE FACTORS, STABILITY FACTORS,      RF71  11
#  EPSILON, INTERPOLATED SCATTERING FACTORS, LORENTZ-POLARIZATION,      RF71  12
#  CLASSIFICATION AS SYSTEMATIC ABSENCE, RCODE AND CONVERSION TO        RF71  13
#  REQUIRED BDF FORM. COPY AND UPDATE THE BINARY DATA FILE.             RF71  14
#                                                                       RF71  15
REAL    A,B,C,D#                       Rotated h,k,l & shift            RF71  16
REAL    ABSCOR#                        Intensity absorption correctio   RF71  17
INTEGER ATTPT#                         Attenuator filter index          RF71  18
INTEGER BACKSN#                        Background scan type             RF71  19
REAL    CORR#                          Scale correction                 RF71  20
#REAL    CSSQDR#                        COS SQUARED DIHEDRAL            RF71  21
REAL    DETHZ#                         Horizontal detector aperture     RF71  22
REAL    DETVT#                         Vertical detector aperature      RF71  23
REAL    EMUL#                          Epsilon and multiplicity         RF71  24
INTEGER EPS#                           Augment to epsilon               RF71  25
REAL    FRACT#                         Interpolation fraction           RF71  26
INTEGER I1,IOFF,KK,LL,M#                                                RF71  27
REAL    CBH,CBL,CNB,CNH,CNL,CNP,CSUM,SNSQ2T,XBH,XBL,XNB,XNH,XNL,XNP#    RF71  28
INTEGER KEY(4)#                        Input lrrefl: key array          RF71  29
INTEGER I,J,K,L,JJ,IJK#                Pointers                         RF71  30
REAL    MAXESD#                        Maximum esd(i/f**2/f)            RF71  31
REAL    MAXSTL#                        Maximum sint/l                   RF71  32
REAL    MAXVAL#                        Maximum of i/f**2/f              RF71  33
REAL    MINESD#                        Minimum esd(i/f**2/f)            RF71  34
REAL    MINSTL#                        Minimum sint/l                   RF71  35
REAL    MINVAL#                        Minimum of i/f**2/f              RF71  36
INTEGER MUL#                           Multiplicity                     RF71  37
INTEGER NRCD(6)#                       Count of rcodes (6 rejected)     RF71  38
REAL    PAKHKL#                        Packed hkl                       RF71  39
REAL    POLARZ#                        Polarization factor              RF71  40
INTEGER PRC#                           Phase restriction code           RF71  41
REAL    PROD#                          Product for interpol sf          RF71  42
INTEGER RCODE#                         Reflection rcode                 RF71  43
REAL    RLOREN#                        Reciprocal lorenz factor         RF71  44
REAL    RLP#                           Reciprocal lp factor             RF71  45
REAL    SCLPT#                         Scale factor set index           RF71  46
REAL    SCNTP#                         Scan type                        RF71  47
INTEGER RFNX#                          Reference refln index            RF71  48
REAL    STOL#                          Sin(theta)/lambda                RF71  49
REAL    SUM#                           Sum for interpolated sf          RF71  50
REAL    SWOM#                          Total scan width                 RF71  51
REAL    TBAR#                          Absorption weighted mean path    RF71  52
REAL    X,Y,Z#                         Floated indices                  RF71  53
#                                                                       RF71  54
chardata:(RF712,"[    h   k   l rcd   time  scale $#                    RF71  55
       inpt    esd(inpt)      outp    esd(outp)]")#                     RF71  56
chardata:(RF713,"[RawINetIFsqrFrel]")#                                  RF71  57
chardata:(RF714,"[ INPUT/OUTPUT REFLECTION DATA-]")#                    RF71  58
chardata:(RF715,"[ Output Statistics  Item            $#                RF71  59
Max       Min]")#                                                       RF71  60
chardata:(RF716," Output file contains          reflections")#          RF71  61
chardata:(RF717,"                               with rcode 1")#         RF71  62
chardata:(RF718," Rejected from input           reflections")#          RF71  63
chardata:(RF719,"[H        K        L        Sint/l   Esd(xxxx)]")#     RF71  64
realdata:(HFMT,[50413., 90413.,130413.,160213.,240812.,320642.,#        RF71  65
451251.,550931.,681251.,780931.])#                                      RF71  66
realdata:(FMU,[390313.,530313.])#                                       RF71  67
realdata:(DAR,0.017453293)#            Convert degrees to radians       RF71  68
intdata:(JPR,[1,0,2,3,4,0,5,0,6,7,8,0])#                                RF71  69
datastuff:#                                                             RF71  70
#                                                                       RF71  71
MAXSTL=0.0;MAXVAL=-100.;MAXESD=0.0#    Initial maximum values           RF71  72
MINSTL=20.;MINVAL=1.E10;MINESD=1.E10#  Initial minimum values           RF71  73
DO I=1,6; NRCD(I)=0#                   Count types of reflection        RF71  74
writeline:(1,RF714,NRF714-1,3,3)#                                       RF71  75
movechar:(RF714,NRF714,CHROT,2,NRF714-2,1)# Underline                   RF71  76
writeline:(0,0,0,1,3)#                                                  RF71  77
IJK=NINT(DSNM)*1000#                   Dataset key offset               RF71  78
movechar:(RF713,4*DATIN-3,RF712,40,4,0)# Reflection heading setup       RF71  79
movechar:(RF713,4*DATIN-3,RF712,52,4,0)# Reflection heading setup       RF71  80
movechar:(RF713,4*DATOUT-3,RF712,63,4,0)# Reflection heading setup      RF71  81
movechar:(RF713,4*DATOUT-3,RF712,75,4,0)# Reflection heading setup      RF71  82
#                                      Input bdf                        RF71  83
KEY(1)=0;KEY(2)=26;KEY(3)=0;KEY(4)=0#  Directory packet setup           RF71  84
IWANT(1)=1;IWANT(2)=IJK+11;IWANT(3)=IJK+18# Hkl, azimuth, reference f   RF71  85
IWANT(4)=IJK+21;IWANT(5)=IJK+23;IWANT(6)=IJK+24# Peak counts low high   RF71  86
IWANT(7)=IJK+14;IWANT(8)=IJK+26;IWANT(9)=IJK+309# Time, atten, scale    RF71  87
IWANT(10)=IJK+46;IWANT(11)=IJK+47;IWANT(12)=IJK+48# Back scan, cnp, c   RF71  88
IWANT(13)=IJK+49;IWANT(14)=IJK+50;IWANT(15)=IJK+10# Cnl, cnh, scan wi   RF71  89
IWANT(16)=IJK+51;IWANT(17)=IJK+52;IWANT(18)=IJK+53# Scan type, hor &    RF71  90
IWANT(19)=IJK+300;IWANT(20)=IJK+301#   I rel and esd                    RF71  91
IWANT(21)=IJK+302;IWANT(22)=IJK+303#   |f|**2 rel and esd               RF71  92
IWANT(23)=IJK+304;IWANT(24)=IJK+305#   |f| rel and esd                  RF71  93
IWANT(25)=IJK+200;IWANT(26)=IJK+201#   Tbar and a*                      RF71  94
indexpkt:(1,lrrefl:,PSIZE,IP,0,KEY,IWANT,IR)#                           RF71  95
#                                      Output bdf                       RF71  96
OPSIZ=5+NSCAT#                         Count the number of items        RF71  97
IF (DATOUT==1) OPSIZ=OPSIZ+17#         Items for raw i                  RF71  98
ELSE IF(DATOUT==2) OPSIZ=OPSIZ+12#     Items for net i                  RF71  99
ELSE           OPSIZ=OPSIZ+3#          Items for f**2 or f              RF71 100
IF (LPINS==yes:) OPSIZ=OPSIZ+1#        Item for 1/lp                    RF71 101
writepkt:(2,lrrefl:,OPSIZ,OPP);IOFF=OPP# Write output file index        RF71 102
IOFF=IOFF+1;QX(IOFF)=1.#               Packed hkl                       RF71 103
IOFF=IOFF+1;QX(IOFF)=2.#               Sint/l                           RF71 104
IOFF=IOFF+1;QX(IOFF)=3.#               Emul                             RF71 105
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+11)#     Azimuth                          RF71 106
DO I=1,NSCAT#                          Loaded atom types                RF71 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF71 108
IOFF=IOFF+1;QX(IOFF)=REAL(500+I)#      Loaded atom types                RF71 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF71 110
IF (LPINS==yes:)#                      Keep on 1/lp on bdf              RF71 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF71 112
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+204)#    Store reciprocal lp              RF71 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF71 114
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+308)#    Rcode                            RF71 115
IF(DATOUT==1)#                         Raw intensity output             RF71 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RF71 117
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+18)#     Reference refln flag             RF71 118
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+21)#     Peak counts           $$         RF71 119
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+23)#     Low angle background             RF71 120
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+24)#     High angle background            RF71 121
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+14)#     Time                             RF71 122
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+26)#     Attenuator index                 RF71 123
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+309)#    Scale index                      RF71 124
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+46)#     Back scan                        RF71 125
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+47)#     Cnp                              RF71 126
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+48)#     Cnb                              RF71 127
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+49)#     Cnl                              RF71 128
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+50)#     Cnh                              RF71 129
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+10)#     Scan width                       RF71 130
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+51)#     Scan type                        RF71 131
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+52)#     Horizontal detector              RF71 132
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+53)#     Vertical detector                RF71 133
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+205)#    Scale factor from references     RF71 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RF71 135
ELSE IF(DATOUT==2)#                    Net intensity output             RF71 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RF71 137
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+18)#     Reference refln flag             RF71 138
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+14)#     Time                             RF71 139
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+26)#     Attenuator index                 RF71 140
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+309)#    Scale index                      RF71 141
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+46)#     Back scan                        RF71 142
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+10)#     Scan width                       RF71 143
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+51)#     Scan type                        RF71 144
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+52)#     Horizontal detector              RF71 145
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+53)#     Vertical detector                RF71 146
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+205)#    Scale factor from references     RF71 147
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+300)#    I rel                            RF71 148
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+301)#    Esd                              RF71 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RF71 150
ELSE IF(DATOUT==3)#                    |f| squared output               RF71 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RF71 152
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+302)#    |f|**2                           RF71 153
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+303)#    Esd                              RF71 154
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+200)#    Tbar                             RF71 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RF71 156
ELSE IF(DATOUT==4)#                    |f| output                       RF71 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RF71 158
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+304)#    |f|                              RF71 159
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+305)#    Esd                              RF71 160
IOFF=IOFF+1;QX(IOFF)=REAL(IJK+200)#    Tbar                             RF71 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RF71 162
#                                                                       RF71 163
writeline:(0,0,0,1,3)#                 Insert blank line                RF71 164
LINRM=4;NREF=0;PRVOID=0#               Initialize printing              RF71 165
#                                                                       RF71 166
#  LOOP OVER ALL REFLECTIONS                                            RF71 167
#  -------------------------                                            RF71 168
#                                                                       RF71 169
REPEAT#                                Loop over all data               RF71 170
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RF71 171
readwpkt:(1,lrrefl:,PSIZE,IP,0)#       Read index record                RF71 172
IF(IP<=0) BREAK#                       Quit when done                   RF71 173
RCODE=1#                               Default rcode                    RF71 174
#                                                                       RF71 175
# PROCESS HKL INDICES                                                   RF71 176
# -------------------                                                   RF71 177
#                                                                       RF71 178
gethkl:(IP+IR(1),HKL)#                 Unpack hkl                       RF71 179
IF(IR(2)>0) PSICR=QX(IP+IR(2))#        Get azmimuth                     RF71 180
ELSE        PSICR=voidflg:#                                             RF71 181
movepakwd:(QX(IP+IR(1)),PAKHKL)#       Transfer input hkl word          RF71 182
#                                                                       RF71 183
# CALCULATE SIN(THETA)/LAMBDA                                           RF71 184
# ---------------------------                                           RF71 185
#                                                                       RF71 186
X=HKL(1) ; Y=HKL(2) ; Z=HKL(3)#        Store temporary                  RF71 187
STOL=.5*SQRT(X*(X*RM(1)+Y*RM(2)+Z*RM(3))$# Apply metric tensor          RF71 188
            +Y*(X*RM(4)+Y*RM(5)+Z*RM(6))$# Apply metric tensor          RF71 189
            +Z*(X*RM(7)+Y*RM(8)+Z*RM(9)))# Apply metric tensor          RF71 190
#                                                                       RF71 191
# DO EPSILON AND MULTIPLICITY                                           RF71 192
# ---------------------------                                           RF71 193
#                                                                       RF71 194
MUL=0;   EPS=0;   PRC=ICNT#            Reset hkl mult/epsilon/prc       RF71 195
FOR(K=MARK2;K<STOP2;K=K+STEP2)#        Loop over symmetry matrices      RF71 196
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RF71 197
A=X*QX(K+1)+Y*QX(K+2)+Z*QX(K+3)#       Generate h'                      RF71 198
B=X*QX(K+4)+Y*QX(K+5)+Z*QX(K+6)#       Generate k'                      RF71 199
C=X*QX(K+7)+Y*QX(K+8)+Z*QX(K+9)#       Generate l'                      RF71 200
D=X*QX(K+10)+Y*QX(K+11)+Z*QX(K+12)#    Generate shift                   RF71 201
M=MOD(NINT(12.*D)+120,12)#             Ensure d in 12ths of 2pi         RF71 202
ifeq:(A,X) ifeq:(B,Y) ifeq:(C,Z)#      H=h', k=k', l=l'                 RF71 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RF71 204
MUL=MUL+1#                             Count equiv hkl                  RF71 205
IF(M==0) EPS=EPS+1#                    Count reinforcement factor       RF71 206
ELSE RCODE=5#                          Mark systematic absence          RF71 207
NEXT#                                  Next eq pos                      RF71 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RF71 209
ifeq:(A,-X) ifeq:(B,-Y) ifeq:(C,-Z)#   H=-h', k=-k', l=-l'              RF71 210
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RF71 211
MUL=MUL+1#                             Incr multiplicity counter        RF71 212
IF(PRC==0) PRC=JPR(M+1)#               Store phase restriction code     RF71 213
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RF71 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RF71 215
MUL=NSYM/MUL#                          Calculate hkl multiplicity       RF71 216
intpak:(0,EMUL,0,mxbtwd:)#             Clear word                       RF71 217
intpak:(MUL,EMUL,0,5)#                 Pack multiplicity                RF71 218
intpak:(EPS,EMUL,5,7)#                 Pack epsilon                     RF71 219
intpak:(PRC,EMUL,12,4)#                Pack phase restriction code      RF71 220
#                                                                       RF71 221
# SEE IF NEED TO KEEP REFLECTION                                        RF71 222
# ------------------------------                                        RF71 223
#                                                                       RF71 224
NRCD(6)=NRCD(6)+1#                     Count it as rejected             RF71 225
IF((SABS==no:) & (RCODE==5)) NEXT#     Skip sys absence not wanted      RF71 226
IF(IXRFN==yes:) IF(IR(3)>0) $#                                          RF71 227
IF(NINT(QX(IP+IR(3)))!=0) NEXT#        Skip reference reflns            RF71 228
NRCD(6)=NRCD(6)-1#                     Uncount it as rejected           RF71 229
MAXSTL=MAX(MAXSTL,STOL)#               Keep max sint/l                  RF71 230
MINSTL=MIN(MINSTL,STOL)#               Keep min sint/l                  RF71 231
#                                                                       RF71 232
# FIND PACKET TO OUTPUT THIS REFLECTION                                 RF71 233
# -------------------------------------                                 RF71 234
#                                                                       RF71 235
writepkt:(2,lrrefl:,OPSIZ,OPP);IOFF=OPP# Output packet & item offset    RF71 236
NREF=NREF+1#                           Count output refs                RF71 237
IOFF=IOFF+1;movepakwd:(PAKHKL,QX(IOFF))# Output packed hkl word         RF71 238
IOFF=IOFF+1;QX(IOFF)=STOL#             Output sin(theta)/lambda         RF71 239
IOFF=IOFF+1;movepakwd:(EMUL,QX(IOFF))# Output epsilon/multiplicity      RF71 240
IOFF=IOFF+1;QX(IOFF)=PSICR#            Output azimuth                   RF71 241
#                                                                       RF71 242
# DO FORM FACTORS                                                       RF71 243
# ---------------                                                       RF71 244
#                                                                       RF71 245
IF(FFAC==yes:)#                        Interpolated form factors want   RF71 246
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RF71 247
I1=0#                                  First interpolation point        RF71 248
FOR(K=MARK3;K<STOP3;K=K+STEP3)#        Loop over table                  RF71 249
IF(STOL>=QX(K+1) & STOL<=QX(K+STEP3+1)) I1=K-STEP3# Calc stol interva   RF71 250
IF(I1==0)            I1=STOP3-4*STEP3# Default last 4 points            RF71 251
IF(I1>STOP3-4*STEP3) I1=STOP3-4*STEP3# Again                            RF71 252
IF(I1<MARK3)       I1=MARK3#           Default first 4 points           RF71 253
DO JJ=1,NSCAT#                         Loop over loaded atom types      RF71 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RF71 255
SUM=0.; KK=I1+3*STEP3#                 Interpolated ff                  RF71 256
FOR(K=I1;K<=KK;K=K+STEP3)#             Loop over 4 points               RF71 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RF71 258
PROD=1.#                               Term of equation                 RF71 259
FOR(L=I1;L<=KK;L=L+STEP3)#             Loop over 4 points               RF71 260
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RF71 261
IF(K==L) NEXT#                         Skip if k=l                      RF71 262
PROD=PROD*(STOL-QX(L+1))/(QX(K+1)-QX(L+1))# Factor                      RF71 263
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RF71 264
LL=K+JJ+2#                             Point to ff table                RF71 265
PROD=PROD*QX(LL); SUM=SUM+PROD#        Term and accumulate              RF71 266
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RF71 267
IOFF=IOFF+1;QX(IOFF)=SUM#              Store sum                        RF71 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RF71 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RF71 270
#                                                                       RF71 271
# DO LORENTZ-POLARIZATION FACTOR                                        RF71 272
# ------------------------------                                        RF71 273
#                                                                       RF71 274
SNSQ2T=(STOL*LAMBDA)**2#               Sin squared theta                RF71 275
SNSQ2T=4.0*SNSQ2T*(1.0-SNSQ2T)#        Sin squared two theta            RF71 276
RLOREN=2.0*SQRT(SNSQ2T)#               Reciprocal lorentz factor        RF71 277
IF(INEU==yes:) POLARZ=1.0#             No polarization for neutrons     RF71 278
ELSE#                                  X-ray polarization               RF71 279
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RF71 280
POLARZ=POLO+(1.-POLO)*(1.-SNSQ2T)#     Polarization                     RF71 281
#CSSQDR=(COS(DAR*DIHEDR))**2#           COS SQUARED DIHEDRAL ANGLE      RF71 282
#POLARZ=(CSSQDR+POLO*(1.0-CSSQDR)+((1.0-$#                              RF71 283
#        CSSQDR)+POLO*CSSQDR)*(1.0-SNSQ2T))/(1.0+POLO)#                 RF71 284
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RF71 285
RLP=RLOREN/POLARZ#                     Reciprocal lp factor             RF71 286
IF (LPINS==yes:)#                      Keep on bdf                      RF71 287
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RF71 288
IOFF=IOFF+1;QX(IOFF)=RLP#              Store reciprocal lp              RF71 289
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RF71 290
#                                                                       RF71 291
#  TREAT INTENSITY OR F ITEMS IN A CASCADE ARRANGEMENT                  RF71 292
#  ---------------------------------------------------                  RF71 293
#                                                                       RF71 294
ETIME=voidflg:;CORR=voidflg:#          Void time and scale factor       RF71 295
IF(DATIN==1)#                          Get in raw data - calc i net     RF71 296
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RF71 297
J=IP+IR(4);CSUM=QX(J)#                 Peak counts                      RF71 298
J=IP+IR(5);CBL=QX(J);XBL=CBL#          Low-angle background             RF71 299
J=IP+IR(6);CBH=QX(J);XBH=CBH#          High-angle background            RF71 300
J=IP+IR(11);CNP=QX(J);XNP=CNP#         Cnp                              RF71 301
J=IP+IR(12);CNB=QX(J);XNB=CNB#         Cnb                              RF71 302
J=IP+IR(13);CNL=QX(J);XNL=CNL#         Cnl                              RF71 303
J=IP+IR(14);CNH=QX(J);XNH=CNH#         Cnh                              RF71 304
IF((XNL==0.0) \ (XNH==0.0))#           No background measurment         RF71 305
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RF71 306
XNL=1.0;XNH=1.0;XBL=0.0;XBH=0.0#       Fiddle for formula below         RF71 307
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RF71 308
IREL=(CSUM/XNP-0.5*XNB/XNP*(XBL/XNL+XBH/XNH))# Convert raw data to      RF71 309
ESIREL=SQRT(CSUM/XNP**2+0.25*XNB**2/$# To net intensity & esd.          RF71 310
XNP**2*(XBL/XNL**2+XBH/XNH**2))#                                        RF71 311
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RF71 312
IF(DATIN==2)#                          Get in irel and esd              RF71 313
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 RF71 314
IREL=QX(IP+IR(19));ESIREL=QX(IP+IR(20))#                                RF71 315
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 RF71 316
IF(DATIN<=2)#                          Conditions for raw & net         RF71 317
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 RF71 318
J=IP+IR(3);RFNX=NINT(QX(J))#           Get reference refln index        RF71 319
J=IP+IR(7);ETIME=QX(J)#                Get elapsed time                 RF71 320
J=IP+IR(8);ATTPT=NINT(QX(J))#          Attenuator index                 RF71 321
J=IP+IR(9);SCLPT=NINT(QX(J))#          Scale set pointer                RF71 322
J=IP+IR(10);BACKSN=NINT(QX(J))#        Backg scan type                  RF71 323
J=IP+IR(15);SWOM=QX(J)#                Scan width                       RF71 324
J=IP+IR(16);SCNTP=QX(J)#               Scan type                        RF71 325
J=IP+IR(17);DETHZ=QX(J)#               Horiz det                        RF71 326
J=IP+IR(18);DETVT=QX(J)#               Vert det                         RF71 327
IF(IR(25)>0) TBAR=QX(IP+IR(25))#       Tbar                             RF71 328
ELSE TBAR=voidflg:#                                                     RF71 329
IF(IR(26)>0) ABSCOR=QX(IP+IR(26))#     A*                               RF71 330
ELSE ABSCOR=1.0#                                                        RF71 331
#                                                                       RF71 332
#  CALCULATE AND APPLY INSTABILITY CONTRIBUTION TO ESD INTENSITY        RF71 333
#  -------------------------------------------------------------        RF71 334
#                                                                       RF71 335
F2REL=IREL;ESF2RE=ESIREL#              Apply corrections in f**2        RF71 336
IF(INSTAB>0)#                          Include instability in esd       RF71 337
ESF2RE=SQRT(ESF2RE**2+ABS(INTERC(INSTAB))$# Var=tc+slp*i**2+cept        RF71 338
     +ABS(SLOPE(INSTAB))*F2REL**2)#                                     RF71 339
#                                                                       RF71 340
#  CALCULATE AND APPLY SCALE FACTOR                                     RF71 341
#  --------------------------------                                     RF71 342
#                                                                       RF71 343
FOR(JJ=MARKR;JJ<=STOPR;JJ=JJ+STEPR)#   Loop over scales                 RF71 344
IF(ETIME>=QX(JJ+2)&ETIME<=QX(JJ+STEPR+2))BREAK# Find interval           RF71 345
FRACT=(ETIME-QX(JJ+2))/(QX(JJ+STEPR+2)-QX(JJ+2))# Fraction of span      RF71 346
CORR=QX(JJ+1)+FRACT*(QX(JJ+STEPR+1)-QX(JJ+1))# Linear interpolation     RF71 347
#                                                                       RF71 348
IF(IAPPLY==yes:) F2REL=CORR*F2REL#     Correct i rel for scale          RF71 349
IF(IAPPLY==yes:) ESF2RE=CORR*ESF2RE#   Correct esd irel for scale       RF71 350
#                                                                       RF71 351
#  APPLY ATTENUATOR AND LORENTZ-POLARIZATION FACTORS                    RF71 352
#  -------------------------------------------------                    RF71 353
#                                                                       RF71 354
ESF2RE=SQRT((ESF2RE*ATTENU(ATTPT))**2+$#                                RF71 355
(ESTENU(ATTPT)*F2REL)**2)#             Esd i rel with attenuator        RF71 356
F2REL=F2REL*ATTENU(ATTPT)#             I rel with attenuator            RF71 357
F2REL=F2REL*RLP#                       I rel with lorentz polar         RF71 358
ESF2RE=ESF2RE*RLP#                     Esd i rel with lp                RF71 359
#                                                                       RF71 360
#  APPLY ABSORPTION CORRECTION FACTOR                                   RF71 361
#  ----------------------------------                                   RF71 362
#                                                                       RF71 363
F2REL=F2REL*ABSCOR#                    Irel with absorption correctio   RF71 364
ESF2RE=ESF2RE*ABSCOR#                  Esd i rel with absorption corr   RF71 365
#                                                                       RF71 366
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 RF71 367
IF(DATIN==3)#                          Get in f squared and esd         RF71 368
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 RF71 369
F2REL=QX(IP+IR(21));ESF2RE=QX(IP+IR(22))#                               RF71 370
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 RF71 371
IF(DATIN<=3)#                          Convert f**2 to f                RF71 372
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 RF71 373
IF(F2REL>=0.0) FREL=SQRT(F2REL)#                                        RF71 374
ELSE FREL=0.0#                                                          RF71 375
ESFREL=SQRT(FREL*FREL+ESF2RE)-FREL#                                     RF71 376
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 RF71 377
IF(DATIN==4)#                          Get in f  and esd                RF71 378
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 RF71 379
FREL=QX(IP+IR(23));ESFREL=QX(IP+IR(24))#                                RF71 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 RF71 381
#                                                                       RF71 382
# DO RCODE                                                              RF71 383
# --------                                                              RF71 384
#                                                                       RF71 385
IF(RCODE!=5) IF(FREL<=THRESH*ESFREL) RCODE=2# Less thans - not sys a    RF71 386
IOFF=IOFF+1;QX(IOFF)=REAL(RCODE)#      Store rcode                      RF71 387
NRCD(RCODE)=NRCD(RCODE)+1#             Count no of this rcode           RF71 388
#                                                                       RF71 389
#  OUTPUT INTENSITY OR F ITEMS                                          RF71 390
#                                                                       RF71 391
IF(DATOUT==1)#                         Raw intensity output             RF71 392
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 RF71 393
IOFF=IOFF+1;QX(IOFF)=RFNX#             Reference refln flag             RF71 394
IOFF=IOFF+1;QX(IOFF)=CSUM#             Peak counts                      RF71 395
IOFF=IOFF+1;QX(IOFF)=CBL#              Low angle background             RF71 396
IOFF=IOFF+1;QX(IOFF)=CBH#              High angle background            RF71 397
IOFF=IOFF+1;QX(IOFF)=ETIME#            Time                             RF71 398
IOFF=IOFF+1;QX(IOFF)=ATTPT#            Attenuator index                 RF71 399
IOFF=IOFF+1;QX(IOFF)=SCLPT#            Scale index                      RF71 400
IOFF=IOFF+1;QX(IOFF)=BACKSN#           Back scan                        RF71 401
IOFF=IOFF+1;QX(IOFF)=CNP#              Cnp                              RF71 402
IOFF=IOFF+1;QX(IOFF)=CNB#              Cnb                              RF71 403
IOFF=IOFF+1;QX(IOFF)=CNL#              Cnl                              RF71 404
IOFF=IOFF+1;QX(IOFF)=CNH#              Cnh                              RF71 405
IOFF=IOFF+1;QX(IOFF)=SWOM#             Scan width                       RF71 406
IOFF=IOFF+1;QX(IOFF)=SCNTP#            Scan type                        RF71 407
IOFF=IOFF+1;QX(IOFF)=DETHZ#            Horizontal detector              RF71 408
IOFF=IOFF+1;QX(IOFF)=DETVT#            Vertical detector                RF71 409
IOFF=IOFF+1;QX(IOFF)=CORR#             Scale factor from references     RF71 410
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 RF71 411
ELSE IF(DATOUT==2)#                    Net intensity output             RF71 412
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 RF71 413
IOFF=IOFF+1;QX(IOFF)=RFNX#             Reference refln flag             RF71 414
IOFF=IOFF+1;QX(IOFF)=ETIME#            Time                             RF71 415
IOFF=IOFF+1;QX(IOFF)=ATTPT#            Attenuator index                 RF71 416
IOFF=IOFF+1;QX(IOFF)=SCLPT#            Scale index                      RF71 417
IOFF=IOFF+1;QX(IOFF)=BACKSN#           Back scan                        RF71 418
IOFF=IOFF+1;QX(IOFF)=SWOM#             Scan width                       RF71 419
IOFF=IOFF+1;QX(IOFF)=SCNTP#            Scan type                        RF71 420
IOFF=IOFF+1;QX(IOFF)=DETHZ#            Horizontal detector              RF71 421
IOFF=IOFF+1;QX(IOFF)=DETVT#            Vertical detector                RF71 422
IOFF=IOFF+1;QX(IOFF)=CORR#             Scale factor from references     RF71 423
IOFF=IOFF+1;QX(IOFF)=IREL#             I rel                            RF71 424
IOFF=IOFF+1;QX(IOFF)=ESIREL#           Esd                              RF71 425
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 RF71 426
ELSE IF(DATOUT==3)#                    |f| squared output               RF71 427
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 RF71 428
IOFF=IOFF+1;QX(IOFF)=F2REL#            |f|**2                           RF71 429
IOFF=IOFF+1;QX(IOFF)=ESF2RE#           Esd                              RF71 430
IOFF=IOFF+1;QX(IOFF)=TBAR#             Tbar                             RF71 431
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 RF71 432
ELSE IF(DATOUT==4)#                    |f| output                       RF71 433
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 RF71 434
IOFF=IOFF+1;QX(IOFF)=FREL#             |f|                              RF71 435
IOFF=IOFF+1;QX(IOFF)=ESFREL#           Esd                              RF71 436
IOFF=IOFF+1;QX(IOFF)=TBAR#             Tbar                             RF71 437
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 RF71 438
#                                                                       RF71 439
#    PRINT REFLECTIONS                                                  RF71 440
#    -----------------                                                  RF71 441
#                                                                       RF71 442
movereal:(HKL,1,BUFOT,1,3,0)#          Store hkl for printing           RF71 443
BUFOT(4)=REAL(RCODE)#                  Put up for printing              RF71 444
BUFOT(5)=ETIME#                        Serial to print                  RF71 445
BUFOT(6)=CORR#                         Print correction                 RF71 446
IF(DATOUT!=DATIN)#                     Values if different else blank   RF71 447
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 RF71 448
IF(DATIN==1)#                          Print input form                 RF71 449
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 RF71 450
BUFOT(7)=CSUM#                         Print peak intensity             RF71 451
BUFOT(8)=SQRT(CSUM)#                   Print esd(i)                     RF71 452
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 RF71 453
ELSE IF(DATIN==2)#                                                      RF71 454
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 RF71 455
BUFOT(7)=IREL#                         Print net intensity              RF71 456
BUFOT(8)=ESIREL#                       Print esd(i)                     RF71 457
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 RF71 458
ELSE IF(DATIN==3)#                                                      RF71 459
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 RF71 460
BUFOT(7)=F2REL#                        Print fsqr                       RF71 461
BUFOT(8)=ESF2RE#                       Print esd fsqr                   RF71 462
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 RF71 463
ELSE IF(DATIN==4)#                                                      RF71 464
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 RF71 465
BUFOT(7)=FREL#                         Print frel                       RF71 466
BUFOT(8)=ESFREL#                       Print esd frel                   RF71 467
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 RF71 468
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 RF71 469
ELSE#                                                                   RF71 470
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 RF71 471
BUFOT(7)=voidflg:#                     Print blank                      RF71 472
BUFOT(8)=voidflg:#                     Print blank                      RF71 473
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 RF71 474
IF(DATOUT==1)#                         Print output form                RF71 475
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 RF71 476
BUFOT(9)=CSUM#                         Print peak counts                RF71 477
BUFOT(10)=SQRT(CSUM)#                  Print esd(peak)                  RF71 478
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 RF71 479
ELSE IF(DATOUT==2)#                                                     RF71 480
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 RF71 481
BUFOT(9)=IREL#                         Print net intensity              RF71 482
BUFOT(10)=ESIREL#                      Print esd(i)                     RF71 483
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 RF71 484
ELSE IF(DATOUT==3)#                                                     RF71 485
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 RF71 486
BUFOT(9)=F2REL#                        Print fsqr                       RF71 487
BUFOT(10)=ESF2RE#                      Print esd fsqr                   RF71 488
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 RF71 489
ELSE IF(DATOUT==4)#                                                     RF71 490
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 RF71 491
BUFOT(9)=FREL#                         Print frel                       RF71 492
BUFOT(10)=ESFREL#                      Print esd frel                   RF71 493
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 RF71 494
MAXVAL=MAX(BUFOT(9),MAXVAL)#           Max item                         RF71 495
MINVAL=MIN(BUFOT(9),MINVAL)#           Max item                         RF71 496
MAXESD=MAX(BUFOT(10),MAXESD)#          Max item                         RF71 497
MINESD=MIN(BUFOT(10),MINESD)#          Max item                         RF71 498
IF(NREF>IPRINT) NEXT#                  Skip print if too large          RF71 499
ncodefld:(BUFOT,1,CHROT,HFMT,10)#                                       RF71 500
writeline:(0,RF712,NRF712,1,3)#                                         RF71 501
#                                      End of reflection loop           RF71 502
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RF71 503
#                                                                       RF71 504
#  PRINT OUT STATISTICS                                                 RF71 505
#  --------------------                                                 RF71 506
#                                                                       RF71 507
PRVOID=1;LINRM=8#                      Reset printing of voids          RF71 508
writeline:(1,RF715,NRF715,3,3)#        Statistics title                 RF71 509
DO I=1,3#                              Max/min hkl                      RF71 510
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 RF71 511
movechar:(RF719,9*I-8,CHROT,21,9,0)#   Item as h,k or l                 RF71 512
ncodefld:(REAL(MAXHKL(I)),1,CHROT,390513.,1)# Format max hkl            RF71 513
ncodefld:(REAL(MINHKL(I)),1,CHROT,490513.,1)# Format min hkl            RF71 514
writeline:(0,0,0,1,3)#                 Output chrot                     RF71 515
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 RF71 516
movechar:(RF719,28,CHROT,21,9,0)#      Item sint/l                      RF71 517
ncodefld:(MAXSTL,1,CHROT,390832.,1)#   Format max sint/l                RF71 518
ncodefld:(MINSTL,1,CHROT,490832.,1)#   Format min sint/l                RF71 519
writeline:(0,0,0,1,3)#                 Output chrot                     RF71 520
movechar:(RF713,4*DATOUT-3,CHROT,21,4,0)# Data type                     RF71 521
ncodefld:(MAXVAL,1,CHROT,390832.,1)#   Format max value                 RF71 522
ncodefld:(MINVAL,1,CHROT,490832.,1)#   Format min value                 RF71 523
writeline:(0,0,0,1,3)#                 Output chrot                     RF71 524
movechar:(RF719,37,CHROT,21,9,0)#      Item esd                         RF71 525
movechar:(RF713,4*DATOUT-3,CHROT,25,4,0)# Data type                     RF71 526
ncodefld:(MAXESD,1,CHROT,390832.,1)#   Format max esd                   RF71 527
ncodefld:(MINESD,1,CHROT,490832.,1)#   Format min esd                   RF71 528
writeline:(0,0,0,1,3)#                 Output chrot                     RF71 529
LINRM=8#                               Keep together                    RF71 530
ncodefld:(FLOAT(NREF),1,RF716,290513.,1)# Format no. output refletns    RF71 531
writeline:(1,RF716,NRF716,3,3)#        Print no. refs to bdf            RF71 532
DO I=1,5#                              Detail of rcodes                 RF71 533
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 RF71 534
ncodefld:(FLOAT(NRCD(I)),1,RF717,290513.,1)# Format no. refs for rcod   RF71 535
ncodefld:(FLOAT(I),1,RF717,430113.,1)# Format rcode no.                 RF71 536
writeline:(0,RF717,NRF717,3,3)#        Print no. refs to bdf            RF71 537
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 RF71 538
ncodefld:(FLOAT(NRCD(6)),1,RF718,290513.,1)# Format no. rejects to bd   RF71 539
writeline:(0,RF718,NRF718,3,3)#        Print no. rejects to bdf         RF71 540
#                                                                       RF71 541
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Copy all the rest             RF71 542
#                                                                       RF71 543
RETURN#                                                                 RF71 544
END#                                                                    RF71 545
systemheader:(RF80)#                   Scale the reference reflection   RF80   1
######################################################################  RF80   2
#                                                                    #  RF80   3
#                               RF80                                 #  RF80   4
#                                                                    #  RF80   5
######################################################################  RF80   6
SUBROUTINE RF80#                       N spadaccini may 1989            RF80   7
include:(AACOMN)#                      H.d. flack nov 1990              RF80   8
include:(RFCOMN)#                                                       RF80   9
#                                                                       RF80  10
INTEGER J,JJ#                                                           RF80  11
REAL FRACT, CORR#                      For linear interpolation         RF80  12
#                                                                       RF80  13
#                                                                       RF80  14
#  RESCALE THE REFERENCE REFLECTIONS                                    RF80  15
#  ---------------------------------                                    RF80  16
#                                                                       RF80  17
IF(TOTRFN>0)#                          Don't if no reference reflns     RF80  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RF80  19
FOR(J=MARKS;J<=STOPS;J=J+STEPS)#       Loop over all reference reflns   RF80  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RF80  21
ETIME=QX(J+4)#                         Find time of this reference      RF80  22
FOR(JJ=MARKR;JJ<=STOPR;JJ=JJ+STEPR)#   Loop over scales                 RF80  23
IF(ETIME>=QX(JJ+2)&ETIME<=QX(JJ+STEPR+2))BREAK# Find interval           RF80  24
FRACT=(ETIME-QX(JJ+2))/(QX(JJ+STEPR+2)-QX(JJ+2))# Fraction of span      RF80  25
CORR=QX(JJ+1)+FRACT*(QX(JJ+STEPR+1)-QX(JJ+1))# Linear interpolation     RF80  26
QX(J+2)=QX(J+2)*CORR#                  Correct intensity                RF80  27
QX(J+3)=QX(J+3)*CORR*CORR#             Correct variance i               RF80  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RF80  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RF80  30
#                                                                       RF80  31
RETURN#                                                                 RF80  32
END#                                                                    RF80  33
pmacro:([no:])#                        Purge xtal system macros         RF80  34
