systemheader:(RS    )#                                                  RS     1
####################################################################### RS     2
##      Copyright (C) 2000, The Xtal System, The University of        # RS     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # RS     4
## Distributed under the GNU General Public Licence as published by   # RS     5
## the Free Software Foundation, in the hope that it will be useful   # RS     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # RS     7
## for more details.                                                  # RS     8
#                                                                     # RS     9
#                            *** RSCAN ***                            # RS    10
#                                                                     # RS    11
#    THE PROGRAM RSCAN ANALYZES STRUCTURE FACTOR DATA IN TERMS OF     # RS    12
#    R-FACTORS.  REFLECTIONS DATA IS DIVIDED INTO RANGES OF:          # RS    13
#   INDICES H, K, AND L; FREL; INTENSITY AND SIN THETA ON LAMBDA.     # RS    14
#   RESULTS FOR 'OBSERVED' DATA (RCODE=1) AND 'LESS THAN' DATA        # RS    15
#   ARE LISTED SEPARATELY.  OVERALL SCALE AND TF SHIFTS ARE LISTED.   # RS    16
#                                                                     # RS    17
####################################################################### RS    18
#                                                                       RS    19
include:(XMACRO)#                                                       RS    20
#                                                                       RS    21
extrude:(RSCOMN)#                                                       RS    22
REAL DF1#                              Interval frel range 1            RS    23
REAL DF2#                              Interval frel range 2            RS    24
REAL DIO#                              Interval intensity range         RS    25
REAL DSL#                              Interval sin(t/l)**2 range       RS    26
REAL FMAX1#                            Max boundary frel range 1        RS    27
REAL HMAX,KMAX,LMAX#                   Max /h/,/k/,/l/                  RS    28
INTEGER ISET#                          Data set number                  RS    29
INTEGER JMAX(6)#                       Max intervals for each range     RS    30
INTEGER JMAX1#                         Intervals in frel range 1        RS    31
INTEGER MARK1#                         Begin mark1 array in qx          RS    32
INTEGER MARK2#                         Begin mark2 array in qx          RS    33
INTEGER MARK3#                         Begin mark3 array in qx          RS    34
REAL SMIN,SMAX#                        Min/max of st/l                  RS    35
#                                                                       RS    36
COMMON/COMFRS/ DF1,DF2,DIO,DSL,FMAX1,HMAX,KMAX,LMAX,SMIN,SMAX#          RS    37
COMMON/COMIRS/ISET,JMAX,JMAX1,MARK1,MARK2,MARK3#                        RS    38
endext:#                                                                RS    39
#                                                                       RS    40
systemheader:(RS00)#                                                    RS00   1
####################################################################    RS00   2
#                                                                       RS00   3
#                             RS00                                      RS00   4
#                                                                       RS00   5
####################################################################    RS00   6
SUBROUTINE RS00#                       Xtal -- g.davenport 1983         RS00   7
include:(AACOMN)#                                                       RS00   8
include:(RSCOMN)#                                                       RS00   9
#                                                                       RS00  10
CALL RS01#                                                              RS00  11
CALL RS02#                                                              RS00  12
CALL RS03#                                                              RS00  13
#                                                                       RS00  14
RETURN#                                                                 RS00  15
END#                                                                    RS00  16
systemheader:(RS01)#                                                    RS01   1
############################################################            RS01   2
#                                                                       RS01   3
#                                 RS01                                  RS01   4
#                                                                       RS01   5
############################################################            RS01   6
SUBROUTINE RS01#                                                        RS01   7
include:(AACOMN)#                                                       RS01   8
include:(RSCOMN)#                                                       RS01   9
#                                                                       RS01  10
REAL A#                                Temp real variable               RS01  11
INTEGER I#                             Loop index                       RS01  12
INTEGER II#                            Pkt loc of scale factor          RS01  13
INTEGER INP#                           Pkt locations                    RS01  14
INTEGER IP#                            Base pkt pointer                 RS01  15
INTEGER IREL(67)#                      Relative offsets                 RS01  16
INTEGER IWANT(66)#                     Needs from pkt                   RS01  17
INTEGER KEY(4)#                        Specs for indexpkt:              RS01  18
INTEGER MARK4#                         End of qx                        RS01  19
INTEGER MAXJ#                          Max no. of intervals             RS01  20
INTEGER NSG#                           Number of scale groups           RS01  21
INTEGER PSIZ#                          Packet size                      RS01  22
#                                                                       RS01  23
chardata:(RS010, GROUP    SCALE FACTOR           )#                     RS01  24
chardata:(RS011, SCALE  MAXHKL END   )#                                 RS01  25
chardata:(RS012, MAX H K L  MIN MAX ST/L                        )# &    RS01  26
realdata:(FMT,[280313.,320313.,360313.,420632.,480632.])#               RS01  27
realdata:(RF1,19.);   realdata:(RF2,500.)#                              RS01  28
realdata:(RIO,1000000.);  realdata:(RSL,4.)#                            RS01  29
datastuff:#                                                             RS01  30
#                                                                       RS01  31
# DEFAULTS FOR COMMON VARIABLES                                         RS01  32
# -----------------------------                                         RS01  33
#                                                                       RS01  34
DF1=1.0#                               Interval frel range 1            RS01  35
DF2=10.0#                              Interval frel range 2            RS01  36
DIO=2.0#                               Intensity interval factor        RS01  37
DSL=0.02#                              (sin(t)/l)**2 interval           RS01  38
ISET=1#                                Data set number                  RS01  39
NSG=1#                                 Number of scale groups           RS01  40
HMAX=50.; KMAX=50.; LMAX=50.#          Default h,k,l max                RS01  41
SMIN=0. ; SMAX=1.#                     Default smin, smax               RS01  42
#                                                                       RS01  43
# READ THE RSCAN CALLING LINE                                           RS01  44
# ---------------------------                                           RS01  45
#                                                                       RS01  46
IF(BUFIN(1)>0.0) RF1=BUFIN(1)#         Max frel range 1                 RS01  47
IF(BUFIN(2)>0.0) DF1=BUFIN(2)#         Interval frel range 1            RS01  48
IF(BUFIN(3)>0.0) RF2=BUFIN(3)#         Max frel range 2                 RS01  49
IF(BUFIN(4)>0.0) DF2=BUFIN(4)#         Interval frel range 2            RS01  50
IF(BUFIN(5)>0.0) RSL=BUFIN(5)#         Max s2t/l2 range                 RS01  51
IF(BUFIN(6)>0.0) DSL=BUFIN(6)#         Interval s2t/l2 range            RS01  52
IF(BUFIN(7)>0.0) RIO=BUFIN(7)#         Max intensity range              RS01  53
IF(BUFIN(8)>0.0) DIO=BUFIN(8)#         Interval range factor            RS01  54
IF(BUFIN(9)>0.0) ISET=NINT(BUFIN(9))#  Data set                         RS01  55
#                                                                       RS01  56
IF(RF1>=RF2) iquit:(RS0105)#           Make sure range 2>range 1        RS01  57
IF(DF1>=DF2) iquit:(RS0106)#           Make sure size 2>size 1          RS01  58
IF(DIO<=1.0) iquit:(RS0107)#           Make sure range factor>1         RS01  59
#                                                                       RS01  60
IOMARK(1)=QXSTR#                       Start file input buffer          RS01  61
incrqx:(MARK1,IOMARK(1)+bdfbuf:,RS0101)# Get space                      RS01  62
#                                                                       RS01  63
# GET SCALE FACTORS FROM LREXPL:                                        RS01  64
# ---------------------------                                           RS01  65
#                                                                       RS01  66
incrqx:(MARK2,MARK1+64,RS0102)#        Space for scale factors          RS01  67
FOR(I=MARK1+1;I<=MARK2;I=I+1) QX(I) =-1.# Initialize scales             RS01  68
QX(MARK1+1)=1.#                        Default scale is 1.              RS01  69
IWANT(1)=1#                            Request data set number          RS01  70
IWANT(2)=100#                          Request no. scale groups         RS01  71
DO I=1,64; IWANT(I+2)=I+100#           Request scale groups             RS01  72
KEY(1)=1; KEY(2)=66; KEY(3)=0; KEY(4)=0# Non-update mode                RS01  73
indexpkt:(1,lrexpl:,PSIZ,IP,0,KEY,IWANT,IREL)# Search directory         RS01  74
REPEAT#                                Loop over packets                RS01  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RS01  76
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Read packet from lrexpl          RS01  77
IF(IP<=0) BREAK#                       Data set not found               RS01  78
IF(NINT(QX(IP+IREL(1)))!=ISET) NEXT#   Test for correct data set        RS01  79
NSG=NINT(QX(IP+IREL(2)))#              No. scale groups                 RS01  80
DO I=1,NSG#                            Loop over scale groups           RS01  81
QX(MARK1+I)=QX(IP+IREL(I+2))#          Store scale factor               RS01  82
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RS01  83
#                                                                       RS01  84
# GET MAX H,K,L FROM LRDSET                                             RS01  85
# ------------------------                                              RS01  86
#                                                                       RS01  87
IWANT(1)=1#                            Request data set number          RS01  88
IWANT(2)=11#                           Request max h                    RS01  89
IWANT(3)=12#                           Request max k                    RS01  90
IWANT(4)=13#                           Request max l                    RS01  91
IWANT(5)=14;    IWANT(6)=15#           Request smin & smax              RS01  92
KEY(1)=1#                              Dataset number needed            RS01  93
KEY(2)=6#                              Optional items                   RS01  94
KEY(3)=0#                              No additions or deletions        RS01  95
KEY(4)=0#                              Non-update mode                  RS01  96
indexpkt:(1,lrdset:,PSIZ,IP,0,KEY,IWANT,IREL)# Search directory         RS01  97
REPEAT#                                Loop over packets                RS01  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RS01  99
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Read packet from lrdset          RS01 100
IF(IP<=0) BREAK#                       Data set not found               RS01 101
INP=IP+IREL(1)#                        Point to data set number         RS01 102
IF(NINT(QX(INP))!=ISET) NEXT#          Exit with data set               RS01 103
I=IP+IREL(2); IF(I>IP) HMAX=QX(I)#     Extract max /h/                  RS01 104
I=IP+IREL(3); IF(I>IP) KMAX=QX(I)#     Extract max /k/                  RS01 105
I=IP+IREL(4); IF(I>IP) LMAX=QX(I)#     Extract max /l/                  RS01 106
I=IP+IREL(5); IF(I>IP) SMIN=QX(I)#     Extract min st/l                 RS01 107
I=IP+IREL(6); IF(I>IP) SMAX=QX(I)#     Extract max st/l                 RS01 108
BREAK#                                 Exit read loop                   RS01 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RS01 110
#                                                                       RS01 111
# READ INPUT LINES                                                      RS01 112
# ----------------                                                      RS01 113
#                                                                       RS01 114
DO I=1,6 ; JMAX(I)=0#                  Initialize jmax array            RS01 115
REPEAT#                                Loop over input lines            RS01 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RS01 117
readline:(RS011,NRS011)#               Read a line                      RS01 118
IF(LINID==3) BREAK#                    Exit on end line                 RS01 119
#                                                                       RS01 120
# SCALE LINE                                                            RS01 121
# ----------                                                            RS01 122
#                                                                       RS01 123
IF(LINID==1)#                          =scale= line                     RS01 124
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RS01 125
ifnv:(BUFIN(2)) II=NINT(BUFIN(2))#     Extract scale group              RS01 126
ELSE             II=1#                 Default is one                   RS01 127
QX(MARK1+II)=BUFIN(1)#                 Store scale in table             RS01 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RS01 129
#                                                                       RS01 130
# MAXHKL LINE                                                           RS01 131
# -----------                                                           RS01 132
#                                                                       RS01 133
ELSE IF(LINID==2)#                     Maxhkl line                      RS01 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RS01 135
ifnv:(BUFIN(1)) HMAX=BUFIN(1)#         Extract max /h/                  RS01 136
ifnv:(BUFIN(2)) KMAX=BUFIN(2)#         Extract max /k/                  RS01 137
ifnv:(BUFIN(3)) HMAX=BUFIN(3)#         Extract max /l/                  RS01 138
ifnv:(BUFIN(4)) SMIN=BUFIN(4)#         Extract min st/l                 RS01 139
ifnv:(BUFIN(5)) SMAX=BUFIN(5)#         Extract max st/l                 RS01 140
BUFOT(1)=HMAX#                         Store hmax for op                RS01 141
BUFOT(2)=KMAX#                         Store kmax for op                RS01 142
BUFOT(3)=LMAX#                         Store lmax for op                RS01 143
BUFOT(4)=SMIN#                         Store smin for op                RS01 144
BUFOT(5)=SMAX#                         Store smax for op                RS01 145
ncodefld:(BUFOT,1,RS012,FMT,5)#        Format max hkls & min s          RS01 146
writeline:(1,RS012,NRS012,3,3)#        Print max hkls                   RS01 147
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RS01 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RS01 149
#                                                                       RS01 150
# PRINT OUT SCALE FACTORS                                               RS01 151
# -----------------------                                               RS01 152
#                                                                       RS01 153
writeline:(0,0,0,1,3)#                 Write 1 blank line               RS01 154
FOR(I=MARK1+1;I<=MARK2;I=I+1)#         Loop over scale factors          RS01 155
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RS01 156
IF(QX(I)<=small:) NEXT#                Skip if not active               RS01 157
BUFOT(1)=FLOAT(I-MARK1)#               Convert scale group to real      RS01 158
ncodefld:(BUFOT,1,RS010,90213.,1)#     Encode scale group               RS01 159
ncodefld:(QX,I,RS010,310852.,1)#       Encode scale factor              RS01 160
writeline:(0,RS010,NRS010,3,3)#        Write it                         RS01 161
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RS01 162
#                                                                       RS01 163
# FIND MAX DIMENSION FOR MARK2, MARK3 ARRAYS                            RS01 164
# ------------------------------------------                            RS01 165
#                                                                       RS01 166
JMAX1=INT(RF1/DF1)+2#                  No. intervals frel range 1       RS01 167
FMAX1=FLOAT(JMAX1-1)*DF1#              Max frel range 1                 RS01 168
JMAX(1)=JMAX1+INT((RF2-FLOAT(JMAX1-1)*DF1)/DF2)+1# Total intervals      RS01 169
JMAX(2)=INT(SMAX**2/DSL)+1#            Intervals s2t/l2 range           RS01 170
I=0#                                   Exponent                         RS01 171
REPEAT#                                Loop over intensity interval     RS01 172
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RS01 173
A=DIO**I#                              Value of boundary                RS01 174
I=I+1#                                 Increment exponent               RS01 175
IF(A>RIO) BREAK#                       Exit on last boundary            RS01 176
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RS01 177
JMAX(3)=I#                             Number of intervals              RS01 178
JMAX(4)=2*HMAX+1#                      Calc h range                     RS01 179
JMAX(5)=2*KMAX+1#                      Calc k range                     RS01 180
JMAX(6)=2*LMAX+1#                      Calc l range                     RS01 181
#                                                                       RS01 182
# FIND MAXIMUM DIMENSION FOR QX MEMORY REQUEST                          RS01 183
# --------------------------------------------                          RS01 184
#                                                                       RS01 185
MAXJ=0#                                Find max of the jmax array       RS01 186
DO I=1,6#                              Loop over array                  RS01 187
IF(JMAX(I)>MAXJ) MAXJ=JMAX(I)#         Test for new max                 RS01 188
incrqx:(MARK3,MARK2+30*MAXJ,RS0103)#   For rcod=1 data                  RS01 189
incrqx:(MARK4,MARK3+30*MAXJ,RS0104)#   For rcod>1 data                  RS01 190
#                                                                       RS01 191
RETURN#                                                                 RS01 192
END#                                                                    RS01 193
systemheader:(RS02)#                                                    RS02   1
#####################################################################   RS02   2
#                                                                       RS02   3
#                                 RS02                                  RS02   4
#                                                                       RS02   5
####################################################################    RS02   6
SUBROUTINE RS02#                                                        RS02   7
include:(AACOMN)#                                                       RS02   8
include:(RSCOMN)#                                                       RS02   9
#                                                                       RS02  10
REAL A#                                Temp,fcal/frel cor               RS02  11
REAL B#                                Temp,l.s. intercept cor          RS02  12
REAL C#                                Temp,t.f. cor                    RS02  13
REAL FCAL#                             Calculated f                     RS02  14
REAL FCFR#                             Fcal/frel                        RS02  15
REAL FDEL#                             Abs(frel-fcal)                   RS02  16
REAL FREL#                             Frel                             RS02  17
REAL HKL(3)#                           Miller indices                   RS02  18
REAL DIF(3)#                           Sum of differences               RS02  19
INTEGER I,J,K#                         Loop indices                     RS02  20
INTEGER INP#                           Locations in file buffer         RS02  21
INTEGER IP#                            Base pkt pointer                 RS02  22
INTEGER IPT#                           Pointer into mark2,mark3         RS02  23
INTEGER IREL(21)#                      Relative offsets                 RS02  24
INTEGER ISGP#                          Scale group number               RS02  25
INTEGER IWANT(20)#                     Packet needs                     RS02  26
INTEGER RCOD#                          1=observed,2=less than,>2=ex     RS02  27
INTEGER KEY(4)#                        Indexpkt: specs                  RS02  28
INTEGER PSIZ#                          Packet size                      RS02  29
INTEGER N(4)#                          Reflection counts                RS02  30
INTEGER OVFL#                          Overall flag                     RS02  31
INTEGER II,JJ#                                                          RS02  32
REAL STOL#                             Sin(t)/l                         RS02  33
REAL S1,S2,S3,S4,S5,S6,S7,S8#          Wilson plot sums                 RS02  34
REAL OINT#                             Obs intensity                    RS02  35
REAL STL2#                             (sin(t)/l)**2                    RS02  36
#                                                                       RS02  37
chardata:(RS021,                  NUMBER    RFACTOR)#                   RS02  38
chardata:(RS022, REFLECTIONS USED                    )#                 RS02  39
chardata:(RS023,      WITH RCODE1                     )#                RS02  40
chardata:(RS024, ***** WARNING-- FREL EXCEEDS MAX SCAN RANGE *****)#    RS02  41
chardata:(RS028,[ OVERALL SCALE (SUMFC/SUMFR)             ])#           RS02  42
chardata:(RS029, WILSON PLOT SCALE ESTIMATE                )#           RS02  43
chardata:(RS02A, WILSON PLOT T.F. SHIFT                    )#           RS02  44
realdata:(FMT,[230613.,330632.,170113.])#                               RS02  45
datastuff:#                                                             RS02  46
#                                                                       RS02  47
# SET UP TO READ LRREFL                                                 RS02  48
# --------------------                                                  RS02  49
#                                                                       RS02  50
DO I=1,4; N(I)=0#                      Zero reflection counts           RS02  51
S1=0.;  S2=0.;  S3=0.;  S4=0.#         Zero wilson sum flags            RS02  52
S5=0.;  S6=0.;  S7=0.;  S8=0.#         Zero wilson sum flags            RS02  53
OINT=0.;  OVFL=no:#                    Set starting values              RS02  54
ISGP=MARK1+1;   RCOD=1#                Reset scale & rcode              RS02  55
DO I=1,3; JMAX(I+3)=(JMAX(I+3)-1)/2#   Reset hkl range to max           RS02  56
I=ISET*1000#                           Scale dataset number             RS02  57
IWANT(1)=1#                            Request hkl                      RS02  58
IWANT(2)=2#                            Request (sin(t)/l)               RS02  59
IWANT(3)=304+I#                        Request frel                     RS02  60
IWANT(4)=800+I#                        Request fcal                     RS02  61
IWANT(5)=309+I#                        Request scale group              RS02  62
IWANT(6)=308+I#                        Request rcod                     RS02  63
IWANT(7)=300+I#                        Request obs intensity            RS02  64
IWANT(8)=805+I#                        Request acal                     RS02  65
IWANT(9)=806+I#                        Request bcal                     RS02  66
IWANT(10)=202+I#                       Request extinction               RS02  67
IWANT(11)=820+I#                       Request fully corrected fc       RS02  68
IWANT(12)=302+I#                       Request frel**2                  RS02  69
KEY(1)=2#                              Items 1-2 mandatory              RS02  70
KEY(2)=12#                             Items 3-12 optional              RS02  71
KEY(3)=0#                              No additions or deletions        RS02  72
KEY(4)=0#                              Non-update mode                  RS02  73
#                                                                       RS02  74
indexpkt:(1,lrrefl:,PSIZ,IP,0,KEY,IWANT,IREL)# Search directory         RS02  75
IF(KEY(4)<0) iquit:(RS0201)#           Mandatory item missing           RS02  76
#                                                                       RS02  77
# DATA FROM REFLECTION PACKETS                                          RS02  78
# ----------------------------                                          RS02  79
#                                                                       RS02  80
REPEAT#                                Loop over reflections            RS02  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RS02  82
readwpkt:(1,lrrefl:,PSIZ,IP,0)#        Read packet from lrrefl          RS02  83
IF(IP<=0) BREAK#                       End of lr                        RS02  84
#                                                                       RS02  85
RCOD=1#                                Default rcod just in case        RS02  86
INP=IP+IREL(1)#                        Point to hkl                     RS02  87
gethkl:(INP,HKL)#                      Hkl                              RS02  88
IF(ABS(HKL(1))>HMAX) NEXT#             Skip if outside range            RS02  89
IF(ABS(HKL(2))>KMAX) NEXT#             Skip if outside range            RS02  90
IF(ABS(HKL(3))>LMAX) NEXT#             Skip if outside range            RS02  91
#                                                                       RS02  92
INP=IP+IREL(2)#                        Point to (sin(t)/l)              RS02  93
STOL=QX(INP)#                          Extract st/l                     RS02  94
IF((STOL<SMIN)\(STOL>SMAX)) NEXT#      Skip if outside range            RS02  95
STL2=STOL**2#                          Calc st/l squared                RS02  96
#                                                                       RS02  97
IF(IREL(3)>0)#                         If frel present                  RS02  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RS02  99
INP=IP+IREL(3)#                        Point to frel                    RS02 100
FREL=QX(INP)#                          Unscaled frel                    RS02 101
IF(FREL<0.0) NEXT#                     Ditch void frels                 RS02 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RS02 103
ELSE IF(IREL(12)>0)#                   If frel**2 present               RS02 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RS02 105
INP=IP+IREL(12)#                       Point to frel                    RS02 106
IF(QX(INP)>0.0) FREL=SQRT(QX(INP))#    Unscaled frel                    RS02 107
ELSE            FREL=0.#               Frel is zero                     RS02 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RS02 109
ELSE iquit:(RS0211)#                   Coeff is missing                 RS02 110
#                                                                       RS02 111
II=IP+IREL(11)#                        Point to fc with dis & ext       RS02 112
IF(II>IP)#                             If term is present               RS02 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RS02 114
FCAL=QX(II)#                           Extract fc with dis/ex applied   RS02 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RS02 116
ELSE#                                  Get fc from else where           RS02 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RS02 118
II=IP+IREL(8); JJ=IP+IREL(9)#          Point to acal & bcal             RS02 119
IF((II>IP)&(JJ>IP))#                   And if present                   RS02 120
FCAL=SQRT(QX(II)**2+QX(JJ)**2)#        Calculate fcal                   RS02 121
ELSE#                                  Else use fc nodisp               RS02 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RS02 123
INP=IP+IREL(4)#                        Point to fcal                    RS02 124
FCAL=QX(INP)#                          Fcal                             RS02 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RS02 126
II=IP+IREL(10)#                        Point to extinction correction   RS02 127
IF(II>IP) FCAL=FCAL*SQRT(QX(II))#      Apply extinction corr            RS02 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RS02 129
#                                                                       RS02 130
INP=IP+IREL(5)#                        Point to scale group             RS02 131
IF(INP>IP) ISGP=MARK1+NINT(QX(INP))#   Scale group                      RS02 132
FREL=FREL*QX(ISGP)#                    Scaled frel                      RS02 133
#                                                                       RS02 134
INP=IP+IREL(6)#                        Point to rcod                    RS02 135
IF(INP>IP) RCOD=NINT(QX(INP))#         Extract rcode                    RS02 136
IF(RCOD>2) NEXT#                       Skip other than obs/less-tha     RS02 137
N(RCOD)=N(RCOD)+1#                     Count refl wrt rcod              RS02 138
#                                                                       RS02 139
IF(IREL(7)<=0) JMAX(3)=0#              No obs intensity                 RS02 140
ELSE#                                  Get obs intensity                RS02 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RS02 142
INP=IP+IREL(7)#                        Point to obs int                 RS02 143
OINT=QX(INP)*QX(ISGP)**2#              Scaled obs int                   RS02 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RS02 145
#                                                                       RS02 146
FDEL=ABS(FREL-FCAL)#                   Delta f                          RS02 147
IF(FREL<=0.0) FCFR=10.*FCAL#           Default fcfr                     RS02 148
ELSE FCFR=FCAL/FREL#                   Ratio fcal to frel               RS02 149
#                                                                       RS02 150
# DETERMINE INTERVAL FOR EACH OF SIX QUANTITIES                         RS02 151
#    FREL,(SIN(T)/L)**2,OINT,H,K,L                                      RS02 152
# AND AUGMENT SUMS ACCORDINGLY                                          RS02 153
# ---------------------------------------------                         RS02 154
#                                                                       RS02 155
# FREL                                                                  RS02 156
IF(FREL>FMAX1) J=JMAX1+INT((FREL-FMAX1)/DF2)+1# Frel in range 2         RS02 157
ELSE           J=INT(FREL/DF1)+2#      Frel in range 1                  RS02 158
IF(J<=JMAX(1))#                        Within range                     RS02 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RS02 160
IF(RCOD==1) IPT=MARK2+30*J-30#         Point to rcod=1 data             RS02 161
ELSE        IPT=MARK3+30*J-30#         Point to rcod>1 data             RS02 162
QX(IPT+1)=QX(IPT+1)+1.0#               Sum reflections                  RS02 163
QX(IPT+2)=QX(IPT+2)+FREL#              Sum frel                         RS02 164
QX(IPT+3)=QX(IPT+3)+FCAL#              Sum fcal                         RS02 165
QX(IPT+4)=QX(IPT+4)+FCFR#              Sum fcfr                         RS02 166
QX(IPT+5)=QX(IPT+5)+FDEL#              Sum fdel                         RS02 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RS02 168
ELSE IF(OVFL==no:)#                    Frel outside ranges              RS02 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RS02 170
OVFL=yes:;  LINRM=3#                   Set overflow flag                RS02 171
writeline:(1,RS024,NRS024,1,3)#        Warn user only once              RS02 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RS02 173
#                                                                       RS02 174
# (SIN(T)/L)**2                                                         RS02 175
# -----------                                                           RS02 176
J=INT(STL2/DSL)+1#                     Interval                         RS02 177
IF(RCOD==1) IPT=MARK2+30*J-25#         Point to rcod=1 data             RS02 178
ELSE        IPT=MARK3+30*J-25#         Point to rcod>1 data             RS02 179
QX(IPT+1)=QX(IPT+1)+1.0#               Sum reflections                  RS02 180
QX(IPT+2)=QX(IPT+2)+FREL#              Sum frel                         RS02 181
QX(IPT+3)=QX(IPT+3)+FCAL#              Sum fcal                         RS02 182
QX(IPT+4)=QX(IPT+4)+FCFR#              Sum fcfr                         RS02 183
QX(IPT+5)=QX(IPT+5)+FDEL#              Sum fdel                         RS02 184
#                                                                       RS02 185
# OBSERVED INTENSITY                                                    RS02 186
# ------------------                                                    RS02 187
IF(JMAX(3)>0)#                         If obs int exists                RS02 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RS02 189
J=0#                                   Initialize pointer as zero       RS02 190
FOR(K=0;K<JMAX(3);K=K+1)#              Loop over intensity interval     RS02 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 RS02 192
IF(OINT>DIO**K) J=K+1#                 Correct interval                 RS02 193
ELSE            BREAK#                 Exit if over limit               RS02 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 RS02 195
IF(J>0)#                               Within range                     RS02 196
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 RS02 197
IF(RCOD==1) IPT=MARK2+30*J-20#         Point to rcod=1 data             RS02 198
ELSE        IPT=MARK3+30*J-20#         Point to rcod>1 data             RS02 199
QX(IPT+1)=QX(IPT+1)+1.0#               Sum reflections                  RS02 200
QX(IPT+2)=QX(IPT+2)+FREL#              Sum frel                         RS02 201
QX(IPT+3)=QX(IPT+3)+FCAL#              Sum fcal                         RS02 202
QX(IPT+4)=QX(IPT+4)+FCFR#              Sum fcfr                         RS02 203
QX(IPT+5)=QX(IPT+5)+FDEL#              Sum fdel                         RS02 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 RS02 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RS02 206
#                                                                       RS02 207
# H,K,L                                                                 RS02 208
# -----                                                                 RS02 209
DO I=1,3#                              Loop over h,k,l                  RS02 210
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 RS02 211
J=NINT(HKL(I))+JMAX(I+3)#              Interval of hkl                  RS02 212
IF(RCOD==1) IPT=MARK2+30*J+5*I-20#     Point to rcod=1 data             RS02 213
ELSE        IPT=MARK3+30*J+5*I-20#     Point to rcod>1 data             RS02 214
QX(IPT+1)=QX(IPT+1)+1.0#               Sum reflections                  RS02 215
QX(IPT+2)=QX(IPT+2)+FREL#              Sum frel                         RS02 216
QX(IPT+3)=QX(IPT+3)+FCAL#              Sum fcal                         RS02 217
QX(IPT+4)=QX(IPT+4)+FCFR#              Sum fcfr                         RS02 218
QX(IPT+5)=QX(IPT+5)+FDEL#              Sum fdel                         RS02 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 RS02 220
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RS02 221
#                                                                       RS02 222
# WILSON PLOT AND (SUM FCAL)/(SUM FREL) CALCULATIONS                    RS02 223
# --------------------------------------------------                    RS02 224
#                                                                       RS02 225
DO I=1,3#                              Loop over three elements         RS02 226
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 RS02 227
JMAX(I+3)=2*JMAX(I+3)+1#               Reset as hkl range               RS02 228
HKL(I)=.1#                             Reset hkl array as sum           RS02 229
DIF(I)=0.#                             Reset dif array as sum           RS02 230
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 RS02 231
FOR(J=1;J<=JMAX(2);J=J+1)#             Loop over intervals              RS02 232
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 RS02 233
DO K=1,2#                              1 for rcod=1,2 for rcod>1        RS02 234
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 RS02 235
IF(K==1) IPT=MARK2+30*J-25#            Point to rcod=1 data             RS02 236
ELSE     IPT=MARK3+30*J-25#            Point to rcod>1 data             RS02 237
IF(QX(IPT+1)>0.0 & QX(IPT+2)>0.0)#     >0 refl in that interval         RS02 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 RS02 239
A=QX(IPT+1)#                           No. of refl in interval          RS02 240
B=(FLOAT(J)-1.5)*DSL#                  Middle of interval               RS02 241
IF(QX(IPT+3)<=0.0) QX(IPT+3)=0.1#      Protect from alog(0)             RS02 242
C=ALOG(QX(IPT+3)/QX(IPT+2))#           Log(fcal/frel)                   RS02 243
S1=S1+A#                               Sum a                            RS02 244
S2=S2+A*B#                             Sum a*b                          RS02 245
S3=S3+A*B*B#                           Sum a*b*b                        RS02 246
S4=S4+A*C#                             Sum a*c                          RS02 247
S5=S5+A*B*C#                           Sum a*b*c                        RS02 248
S6=S6+QX(IPT+2)#                       Sum frel all refl                RS02 249
S7=S7+QX(IPT+3)#                       Sum fcal all refl                RS02 250
S8=S8+QX(IPT+5)#                       Sum delta f all refl             RS02 251
HKL(K)=HKL(K)+QX(IPT+2)#               Sum frel obs/less-than           RS02 252
DIF(K)=DIF(K)+QX(IPT+5)#               Sum fdif obs/less-than           RS02 253
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 RS02 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 RS02 255
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 RS02 256
A=1.0/(S1*S3-S2*S2)#                                                    RS02 257
B=EXP(A*(S3*S4-S2*S5))#                L.s. intercept correction        RS02 258
C=A*(S1*S5-S2*S4)#                     Overall t.f. correction          RS02 259
A=S7/S6#                               Fcal/frel correction             RS02 260
#                                                                       RS02 261
writeline:(1,RS021,NRS021,3,3)#        Print count rfactor header       RS02 262
BUFOT(1)=FLOAT(N(1)+N(2))#             Total number hkl processed       RS02 263
BUFOT(2)=S8/S6#                        Overall r-factor                 RS02 264
ncodefld:(BUFOT,1,RS022,FMT,2)#        Format count & rfactor           RS02 265
writeline:(0,RS022,NRS022,3,3)#        Write count & rfactor            RS02 266
DO K=1,2#                              Loop over rcodes                 RS02 267
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 RS02 268
IF(N(K)==0) NEXT#                      Skip rcode if void               RS02 269
BUFOT(1)=FLOAT(N(K))#                  Store hkl count                  RS02 270
BUFOT(2)=DIF(K)/HKL(K)#                Store rfactor                    RS02 271
BUFOT(3)=FLOAT(K)#                     Store rcode                      RS02 272
ncodefld:(BUFOT,1,RS023,FMT,3)#        Format count & rfactor           RS02 273
writeline:(0,RS023,NRS023,3,3)#        Write count & rfactor            RS02 274
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 RS02 275
ncodefld:(A,1,RS028,400852.,1)#        Encode fcal/frel cor             RS02 276
writeline:(0,RS028,NRS028,3,3)#        Write it                         RS02 277
ncodefld:(B,1,RS029,400852.,1)#        Wilson plot scale estimate       RS02 278
writeline:(0,RS029,NRS029,3,3)#        Write it                         RS02 279
ncodefld:(C,1,RS02A,400832.,1)#        Encode t.f. shift                RS02 280
writeline:(0,RS02A,NRS02A,3,3)#        Write it                         RS02 281
#                                                                       RS02 282
RETURN#                                                                 RS02 283
END#                                                                    RS02 284
systemheader:(RS03)#                                                    RS03   1
######################################################################  RS03   2
#                                                                       RS03   3
#                              RS03                                     RS03   4
#                                                                       RS03   5
####################################################################    RS03   6
SUBROUTINE RS03#                                                        RS03   7
include:(AACOMN)#                                                       RS03   8
include:(RSCOMN)#                                                       RS03   9
#                                                                       RS03  10
INTEGER I#                             Loop index                       RS03  11
INTEGER IPT,IPT1,IPT2#                 Qx pointers                      RS03  12
INTEGER J#                             Loop index                       RS03  13
#                                                                       RS03  14
chardata:(RS030, R-FACTORS IN TERMS OF              )#                  RS03  15
chardata:(RS031,   RCODE1    RCODE2   -=--)#                            RS03  16
chardata:(RS032,       RANGE    NREF  FREL   FCAL FC/FR DF  RFAC)#      RS03  17
chardata:(RS033,     FREL    STOL**2     INTENSITY   INDEX H   $#       RS03  18
   INDEX K     INDEX L    )#                                            RS03  19
realdata:(FMT,[190413.,260622.,330622.,380422.,#                        RS03  20
430422.,480432.,530413.,600622.,670622.,720422.,770422.,820432.])#      RS03  21
datastuff:#                                                             RS03  22
#                                                                       RS03  23
# WRITE OUTPUT TABLES FOR EACH OF SIX QUANTITIES                        RS03  24
#   FREL,(SIN(T)/L)**2,INTENSITY,H,K,L                                  RS03  25
# ----------------------------------------------                        RS03  26
#                                                                       RS03  27
DO I=1,6#                              Loop over quantities             RS03  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  RS03  29
IPT=12*I-10;   LINRM=8#                Point to char string             RS03  30
movechar:(RS033,IPT,RS030,24,12,0)#    Heading                          RS03  31
movechar:(RS031,24,CHROT,2,30,1)#      Underline heading                RS03  32
writeline:(1,RS030,NRS030,1,3)#        Write heading                    RS03  33
movechar:(RS033,IPT,CHROT,4,12,0)#     Group headings                   RS03  34
movechar:(RS031,2,CHROT,29,10,0)#      Group headings                   RS03  35
movechar:(RS031,12,CHROT,63,10,0)#     Group headings                   RS03  36
movechar:(RS031,23,CHROT,17,13,1)#     Rcode header                     RS03  37
movechar:(RS031,25,CHROT,38,10,1)#     Rcode header                     RS03  38
movechar:(RS031,23,CHROT,51,13,1)#     Rcode header                     RS03  39
movechar:(RS031,25,CHROT,72,10,1)#     Rcode header                     RS03  40
writeline:(0,0,0,1,3)#                 Print rcode header               RS03  41
movechar:(RS032,1,CHROT,1,48,0)#       Column headings                  RS03  42
movechar:(RS032,16,CHROT,50,33,0)#     Column headings                  RS03  43
writeline:(0,0,0,1,3)#                 Column headings                  RS03  44
#                                                                       RS03  45
FOR(J=1;J<JMAX(I);J=J+1)#              Loop over intervals              RS03  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  RS03  47
#                                                                       RS03  48
# DETERMINE INTERVAL BOUNDARIES                                         RS03  49
# -----------------------------                                         RS03  50
#                                                                       RS03  51
IF(I==1)#                              Frel                             RS03  52
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  RS03  53
IF(J<=JMAX1)#                          Frel in range 1                  RS03  54
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  RS03  55
BUFOT(1)=FLOAT(J-2)*DF1#               Lower boundary                   RS03  56
BUFOT(2)=FLOAT(J-1)*DF1#               Upper boundary                   RS03  57
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  RS03  58
ELSE#                                  Frel in range 2                  RS03  59
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  RS03  60
BUFOT(1)=FMAX1+FLOAT(J-JMAX1-1)*DF2## Lower boundary                    RS03  61
BUFOT(2)=FMAX1+FLOAT(J-JMAX1)*DF2#     Upper boundary                   RS03  62
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  RS03  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  RS03  64
#                                                                       RS03  65
ELSE IF(I==2)#                         (sin(t)/l)**2                    RS03  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  RS03  67
BUFOT(1)=FLOAT(J-1)*DSL#               Lower boundary                   RS03  68
BUFOT(2)=FLOAT(J)*DSL#                 Upper boundary                   RS03  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  RS03  70
#                                                                       RS03  71
ELSE IF(I==3)#                         Observed intensity               RS03  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  RS03  73
BUFOT(1)=DIO**(J-1)#                   Lower boundary                   RS03  74
BUFOT(2)=DIO**J#                       Upper boundary                   RS03  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  RS03  76
#                                                                       RS03  77
ELSE BUFOT(1)=FLOAT(J-(JMAX(I)-1)/2)#  H,k,l                            RS03  78
#                                                                       RS03  79
#                                                                       RS03  80
#                                                                       RS03  81
# LOAD THE NUMBERS INTO THE OUTPUT BUFFER                               RS03  82
# ---------------------------------------                               RS03  83
#                                                                       RS03  84
IPT1=MARK2+30*J+5*I-35#                Rcod=1                           RS03  85
IPT2=MARK3+30*J+5*I-35#                Rcod>1                           RS03  86
IF((QX(IPT1+1)<=.01)&(QX(IPT2+1)<=.01)) NEXT# No refl in interval       RS03  87
IF(I<=3)#                              Frel,(sin(t)/l)**2,oint          RS03  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  RS03  89
ncodefld:(BUFOT,1,CHROT,70622.,1)#     Encode lower boundary            RS03  90
ncodefld:(BUFOT,2,CHROT,140622.,1)#    Encode upper boundary            RS03  91
IF(I==2) movechar:(RS031,26,CHROT,9,1,0)# Move hyphen                   RS03  92
ELSE movechar:(RS031,26,CHROT,8,1,0)#  Move hyphen                      RS03  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  RS03  94
ELSE ncodefld:(BUFOT,1,CHROT,90413.,1)# H,k,l                           RS03  95
IF(QX(IPT1+1)>0.0)#                    Exist refl w/rcod=1              RS03  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  RS03  97
BUFOT(1)=QX(IPT1+1)#                   No. refl in interval             RS03  98
BUFOT(2)=QX(IPT1+2)/QX(IPT1+1)#        Mean frel for interval           RS03  99
BUFOT(3)=QX(IPT1+3)/QX(IPT1+1)#        Mean fcal for interval           RS03 100
BUFOT(4)=QX(IPT1+4)/QX(IPT1+1)#        Mean fcfr for interval           RS03 101
BUFOT(5)=QX(IPT1+5)/QX(IPT1+1)#        Mean fdel for interval           RS03 102
BUFOT(6)=2.0*QX(IPT1+5)/(QX(IPT1+2)+QX(IPT1+3))# R-factor               RS03 103
ncodefld:(BUFOT,1,CHROT,FMT,6)#        Encode above items               RS03 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  RS03 105
#                                                                       RS03 106
IF(QX(IPT2+1)>0.0)#                    Exist refl w/rcod>1              RS03 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 RS03 108
BUFOT(7)=QX(IPT2+1)#                   No. refl in interval             RS03 109
BUFOT(8)=QX(IPT2+2)/QX(IPT2+1)#        Mean frel for interval           RS03 110
BUFOT(9)=QX(IPT2+3)/QX(IPT2+1)#        Mean fcal for interval           RS03 111
BUFOT(10)=QX(IPT2+4)/QX(IPT2+1)#       Mean fcfr for interval           RS03 112
BUFOT(11)=QX(IPT2+5)/QX(IPT2+1)#       Mean fdel for interval           RS03 113
BUFOT(12)=2.0*QX(IPT2+5)/(QX(IPT2+2)+QX(IPT2+3))# R-factor              RS03 114
ncodefld:(BUFOT,7,CHROT,FMT(7),6)#     Encode above items               RS03 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 RS03 116
#                                                                       RS03 117
writeline:(0,0,0,1,3)#                 Write the line                   RS03 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  RS03 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  RS03 120
readwpkt:(1,endrecord:,I,I,0)#         Finish off bdf                   RS03 121
#                                                                       RS03 122
RETURN#                                                                 RS03 123
END#                                                                    RS03 124
pmacro:([no:])#                        Purge xtal system macros         RS03 125
