systemheader:(SH    )#                                                  SH     1
######################################################################  SH     2
##      Copyright (C) 2000, The Xtal System, The University of        # SH     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # SH     4
## Distributed under the GNU General Public Licence as published by   # SH     5
## the Free Software Foundation, in the hope that it will be useful   # SH     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # SH     7
## for more details.                                                  # SH     8
#                                                                    #  SH     9
#                         *** SHELIN ***                             #  SH    10
#                                                                    #  SH    11
#   PROGRAM FOR CONVERTING SHELX INPUT TO XTAL INPUT -- INLINE!      #  SH    12
#                                                                    #  SH    13
######################################################################  SH    14
#                                                                       SH    15
include:(XMACRO)#                                                       SH    16
#                                                                       SH    17
#MACRO:(PUT:,[WRITEFMT:(IOFM1:,'(A)',CHROT(1^$1));CHROT(1^$1)=' '])#    SH    18
macro:(put:,CALL SH01($1,CHROT))#                                       SH    19
#                                                                       SH    20
systemheader:(SH00)#                   Convert the input file           SH00   1
######################################################################  SH00   2
#                                                                    #  SH00   3
#                             SH00                                   #  SH00   4
#                                                                    #  SH00   5
######################################################################  SH00   6
SUBROUTINE SH00#                       S.r. hall oct. 88                SH00   7
include:(AACOMN)#                                                       SH00   8
#                                                                       SH00   9
INTEGER I,J,K,SFT,HKLIN#                                                SH00  10
INTEGER LINE,SYMF,IATM,IHKL,CONT#                                       SH00  11
INTEGER HKL(3),DPFL,POPF,ILAT,NTYP#                                     SH00  12
REAL U11,U22,WLEN,SCL,FVAR(9)#                                          SH00  13
CHARACTER*6 SFNAM(10)#                                                  SH00  14
#                                                                       SH00  15
string:(NAME,8); string:(ADP,3)#                                        SH00  16
string:(LINE1,80); string:(LINE2,80); string:(LINE3,80)#                SH00  17
chardata:(SH0, CELL LATT SYMM SFAC UNIT HKLF FVAR END AFIX )#           SH00  18
chardata:(SH1,PIRFABC)#                                                 SH00  19
chardata:(SH2,'1234567890.,+-xyzXYZ ')#                                 SH00  20
chardata:(SH3,[1/61/41/3   1/22/33/45/6])#                              SH00  21
realdata:(FMT1,[201052.,301052.,401052.,501052.,601052.,701052.])#      SH00  22
realdata:(FMT2,[100513.,150513.,200513.,301032.,401032.,501013.])#      SH00  23
realdata:(FMT3,[210842.,290842.,370842.,520732.,450742.])#              SH00  24
realdata:(FMT4,[401052.,701052.,601052.,501052.,201052.,301052.])#      SH00  25
realdata:(FMT5,[590742.,660742.,730742.,800642.])#                      SH00  26
realdata:(FMT6,[201052.,301052.,401052.,701052.,601052.,501052.])#      SH00  27
datastuff:#                                                             SH00  28
#                                                                       SH00  29
FILEXT(iofm1:)='SHX'#                  Ext of output shx/xtal file      SH00  30
openfmt:(iofm1:,' ')#                  Open xtal data file              SH00  31
#                                                                       SH00  32
#   SET DEFAULT FLAGS                                                   SH00  33
#   -----------------                                                   SH00  34
#                                                                       SH00  35
IF(BUFIN(1)<voidflg:) POPF=yes:#       Set population values = sof      SH00  36
ELSE                  POPF=no:#        Set population always = 1.0      SH00  37
SYMF=no:#                              Set first symmetry line          SH00  38
IATM=no:#                              Set atoms in off                 SH00  39
IHKL=no:#                              Set hkl in off                   SH00  40
ILAT=no:#                              Set lattice code off             SH00  41
CONT=no:#                              Set continue flag off            SH00  42
SYNTXF=1#                              Set syntax checking off          SH00  43
LINE=0#                                Start line count                 SH00  44
LINE1=' '; LINE2=' '; LINE3=' '#       Reset atom output lines          SH00  45
HKLIN=yes:#                            Include hkls and addref          SH00  46
#                                                                       SH00  47
select:(version:)#                     Select on version                SH00  48
ifsel:(_GX)#                           Xtal_gx version                  SH00  49
HKLIN=no:#                             No hkls in xtal_gx               SH00  50
SFT=3#                                 Initialise variable              SH00  51
endsel:#                               End of selection criteria        SH00  52
select:(compiler:)#                    Reselect on compiler             SH00  53
#                                                                       SH00  54
#   READ DATA LINES -- SYNTAX OFF                                       SH00  55
#   -----------------------------                                       SH00  56
#                                                                       SH00  57
REPEAT#                                Loop over all input line         SH00  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SH00  59
LINE=LINE+1#                           Count input lines                SH00  60
readline:(SH0,-NSH0)#                  Read each line into chrin        SH00  61
LINFLG=1#                              Reset new read flag              SH00  62
#                                                                       SH00  63
IF(LINID==0&LINE==1)#                  ******** title **********        SH00  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SH00  65
CHROT(1^80)='title '//CHRIP(5^74)#     Insert title header              SH00  66
put:(80)#                              Output the data line             SH00  67
CHROT(1^14)='compid '//COMPID#         Insert compid header             SH00  68
put:(14)#                              Output the data line             SH00  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SH00  70
#                                                                       SH00  71
ELSE IF(LINID==1)#                     ********* cell *************     SH00  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SH00  73
CHROT(1^6)='STARTX'; put:(6)#          Output the data line             SH00  74
WLEN=BUFIN(1)#                         Store the input wavelength       SH00  75
CHROT(1^6)='cell  '#                   Insert the cell header           SH00  76
ncodefld:(BUFIN,2,CHROT,FMT1,3)#       Format the cell lengths          SH00  77
ifnv:(BUFIN(5))ncodefld:(BUFIN,5,CHROT,FMT1(4),3)# Cell angles          SH00  78
put:(70)#                              Output the data line             SH00  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SH00  80
#                                                                       SH00  81
ELSE IF(LINID==2)#                     ********* latt *************     SH00  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SH00  83
ILAT=NINT(BUFIN(1))#                   Get lattice code                 SH00  84
CHROT(1^6)='latice'#                   Insert the lattice header        SH00  85
IF(ILAT>0) CHROT(8^8)='C'#             Insert centro flag               SH00  86
ELSE       CHROT(8^8)='N'#             Insert noncentro flag            SH00  87
movechar:(SH1,ABS(ILAT),CHROT,10,1,0)# Insert centre flag               SH00  88
put:(11)#                              Output the data line             SH00  89
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SH00  90
#                                                                       SH00  91
ELSE IF(LINID==3)#                     ********* symm *************     SH00  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SH00  93
IF(SYMF==no:)#                         Test for first entry             SH00  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SH00  95
IF(ILAT==no:)#                         Test if lattice line entered     SH00  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SH00  97
ILAT=yes:#                             Default lattice assumed          SH00  98
CHROT(1^10)='latice C P'#              Insert the lattice header        SH00  99
put:(11)#                              Output data line                 SH00 100
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SH00 101
CHROT(1^12)='symtry x,y,z'#            Insert symtry header             SH00 102
SYMF=yes:#                             Switch off first sym flag        SH00 103
put:(13)#                              Output the data line             SH00 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SH00 105
J=8#                                   Start output char pointer        SH00 106
FOR(I=6;I<=80;I=I+1)#                  Scan line as characters          SH00 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SH00 108
compchar:(CHRIN,I,SH2,1,1,1,NSH2,K)#   Identify character               SH00 109
IF(K==11) DPFL=yes:#                   Signal dp encountered            SH00 110
ELSE IF(DPFL==yes:)#                   Test first digit trans           SH00 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SH00 112
movechar:(SH3,K*3-2,CHROT,J,3,0)#      Insert trans fraction            SH00 113
J=J+3;   DPFL=no:#                     Incr output pointer              SH00 114
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SH00 115
ELSE IF(K>11&K<NSH2)#                  Test for ,+-xyz                  SH00 116
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SH00 117
movechar:(SH2,K,CHROT,J,1,0)#          Insert trans fraction            SH00 118
J=J+1#                                 Incr output pointer              SH00 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SH00 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SH00 121
CHROT(1^6)='symtry'#                   Insert symtry header             SH00 122
put:(J)#                               Output the data line             SH00 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SH00 124
#                                                                       SH00 125
ELSE IF(LINID==4)#                     ********* sfac *************     SH00 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SH00 127
IF(SYMF==no:)#                         Test if symmetry entered         SH00 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SH00 129
CHROT(1^12)='symtry x,y,z'#            Insert symtry header             SH00 130
SYMF=yes:#                             Switch off first sym flag        SH00 131
put:(13)#                              Output the data line             SH00 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SH00 133
DO I=1,10#                             Loop over atom types             SH00 134
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SH00 135
ifvo:(BUFIN(I)) BREAK#                 Exit after last name             SH00 136
stringlim:(I,J,K)#                     Get limits of type names         SH00 137
NTYP=NTYP+1#                           Count atom types                 SH00 138
SFNAM(NTYP)=CHRIN(J^K)#                Store atom names                 SH00 139
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SH00 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SH00 141
#                                                                       SH00 142
ELSE IF(LINID==5)#                     ********* unit *************     SH00 143
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SH00 144
DO I=1,10#                             Loop over atom types             SH00 145
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SH00 146
IF(BUFIN(I)<0.5) BREAK#                Exit when no value               SH00 147
CHROT(1^6)='celcon'#                   Store celcon header              SH00 148
CHROT(8^10)=SFNAM(I)#                  Store atom type name             SH00 149
ncodefld:(BUFIN,I,CHROT,200513.,1)#    Format atom contents             SH00 150
put:(20)#                              Output the data line             SH00 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SH00 152
CHROT(1^8)='exper  1'#                 Insert experimental header       SH00 153
ncodefld:(WLEN,1,CHROT,200852.,1)#     Format wavelength                SH00 154
put:(20)#                              Output the data line             SH00 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SH00 156
#                                                                       SH00 157
ELSE IF(LINID==6&HKLIN==yes:)#         ********* hklf *************     SH00 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SH00 159
ifvo:(BUFIN(1)) iquit:(SH0020)#        Test correct hkl type entered    SH00 160
SFT=-NINT(BUFIN(1))#                   Set sf type flag                 SH00 161
IF(SFT<3\SFT>4)     iquit:(SH0020)#    Test correct hkl type entered    SH00 162
IHKL=yes:;  IATM=no:;  ILAT=no:#       Switch on the hkl in flag        SH00 163
CHROT(1^6)='ADDREF'; put:(6)#          Output the data line             SH00 164
IF(SFT==3)CHROT(1^24)='hklin hkl frel sigf rcod'# Store hklin line      SH00 165
ELSE      CHROT(1^24)='hklin hkl f2rl sgf2 rcod'# Store hklin line      SH00 166
put:(25)#                              Output the data line             SH00 167
FIELDF=yes:#                           Switch on the input formatter    SH00 168
ifnv:(BUFIN(2))#                       Is format 3i3,f7.2,f6.2          SH00 169
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SH00 170
BUFPNT(1)=3; BUFPNT(2)=6; BUFPNT(3)=9# Set rh cols of h,k,l             SH00 171
BUFPNT(4)=16;BUFPNT(5)=22#             Set rh cols of frel,sigf         SH00 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SH00 173
ELSE#                                  Format is 3i4,2f8.2              SH00 174
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SH00 175
BUFPNT(1)=4; BUFPNT(2)=8; BUFPNT(3)=12# Set rh cols of h,k,l            SH00 176
BUFPNT(4)=20;BUFPNT(5)=28#             Set rh cols of frel,sigf         SH00 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SH00 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SH00 179
#                                                                       SH00 180
ELSE IF(LINID==7)#                     ********* fvar *************     SH00 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SH00 182
ifvo:(BUFIN(1)) SCL=1.0#               Assume scale is one              SH00 183
ELSE            SCL=BUFIN(1)#          Store scale factor               SH00 184
DO I=2,9; FVAR(I)=BUFIN(I)#            Store free variables             SH00 185
IATM=yes:;  IHKL=no:;  ILAT=no:#       Switch on atom input flag        SH00 186
CHROT(1^6)='ADDATM'; put:(6)#          Output the data line             SH00 187
CHROT(1^23)='scale                 1'# Insert scale header              SH00 188
ncodefld:(SCL,1,CHROT,200952.,1)#      Format fc scale factor           SH00 189
put:(24)#                              Output the data line             SH00 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SH00 191
#                                                                       SH00 192
ELSE IF(LINID==8) BREAK#               ********* end  *************     SH00 193
#                                                                       SH00 194
ELSE IF(LINID==9) NEXT#                ********* afix *************     SH00 195
#                                                                       SH00 196
ELSE IF(LINID==0)#                     **** atom? or hkl? *********     SH00 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SH00 198
CHRCOL=1;   dcodefld:#                 Convert char to numeric          SH00 199
IF(IATM==yes:&CONT==no:)#              Check atom line continuation     SH00 200
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SH00 201
IF(CHRIN(1^1)!=' ')#                   Test if label present            SH00 202
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SH00 203
IF(LINE1(1^1)!=' ') writefmt:(iofm1:,'(a)',LINE1)# Output atom line     SH00 204
IF(LINE2(1^1)!=' ') writefmt:(iofm1:,'(a)',LINE2)# Output uij  line     SH00 205
IF(LINE3(1^1)!=' ') writefmt:(iofm1:,'(a)',LINE3)# Output suij line     SH00 206
LINE1=' '; LINE2=' '; LINE3=' '#       Reset atom output lines          SH00 207
stringlim:(1,J,K)#                     Get limits of atom name          SH00 208
NAME=CHRIN(J^K-1)#                     Insert atom name                 SH00 209
LINE1(1^4)='atom'#                     Insert atom header               SH00 210
LINE1(6^13)=NAME#                      Insert atom name                 SH00 211
IF(BUFIN(7)>10.) ADP='iso'#            Flag as isotropic                SH00 212
ELSE             ADP='ani'#            Flag as anisotropic              SH00 213
DO I=2,8#                              Loop over input fields           SH00 214
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SH00 215
IF(BUFIN(I)>10.)BUFIN(I)=BUFIN(I)-10.# Remove constraint flag           SH00 216
IF(BUFIN(I)>=2.)BUFIN(I)=FVAR(NINT(BUFIN(I)))# Store free variable      SH00 217
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SH00 218
U11=BUFIN(7); U22=BUFIN(8)#            Get uij's for later              SH00 219
IF(POPF==no:) BUFIN(6)=1.0#            Force all sof to 1.0000!         SH00 220
ncodefld:(BUFIN,3,LINE1,FMT3,5)#       Format x,y,z,pp,isou             SH00 221
IF(BUFIN(9)<voidflg:) CONT=yes:#       Switch on continue flag          SH00 222
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SH00 223
ELSE IF(ADP=='iso')#                   Are these esds for x,y,z,iso     SH00 224
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SH00 225
ncodefld:(BUFIN,1,LINE1,FMT5,4)#       Format esds for x,y,z,u          SH00 226
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SH00 227
ELSE#                                  Are these esds for x,y,z,uij     SH00 228
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SH00 229
ncodefld:(BUFIN,1,LINE1,FMT5,3)#       Format esd of x,y,z              SH00 230
LINE3(1^5)='suij '#                    Insert suij header               SH00 231
LINE3(6^13)=NAME#                      Insert atom name                 SH00 232
ncodefld:(BUFIN,4,LINE3,FMT6,6)#       Format esd of uij                SH00 233
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SH00 234
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SH00 235
ELSE IF(IATM==yes:)#                   This is an atom continue         SH00 236
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SH00 237
CONT=no:#                              Switch off the continue flag     SH00 238
LINE2(1^4)='uij '#                     Insert uij header                SH00 239
LINE2(6^13)=NAME#                      Insert atom name                 SH00 240
DO I=1,4#                              Loop over input fields           SH00 241
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SH00 242
IF(BUFIN(I)>10.)BUFIN(I)=BUFIN(I)-10.# Remove constraint flag           SH00 243
IF(BUFIN(I)>=2.)BUFIN(I)=FVAR(NINT(BUFIN(I)))# Store free variable      SH00 244
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SH00 245
BUFIN(5)=U11;   BUFIN(6)=U22#          Restore uij for formatting       SH00 246
ncodefld:(BUFIN,1,LINE2,FMT4,6)#       Format uij's                     SH00 247
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SH00 248
ELSE IF(IHKL==yes:)#                   This is a hkl line               SH00 249
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SH00 250
DO I=1,3; HKL(I)=NINT(BUFIN(I))#       Get integer hkl                  SH00 251
IF((HKL(1)== 0&HKL(2)== 0&HKL(3)== 0)$# Test for end hkl                SH00 252
  \(HKL(1)==99&HKL(2)==99&HKL(3)==99))# Test for end hkl                SH00 253
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SH00 254
CHROT(1^4)='end '#                     Store end header                 SH00 255
put:(4)#                               Output the data line             SH00 256
FIELDF=no:;       NEXT#                Switch off hkl input             SH00 257
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SH00 258
CHROT(1^6)='hkl   '#                   Store hkl header                 SH00 259
IF(BUFIN(5)<0.) BUFIN(6)=2.#           Set ref-code as less than        SH00 260
ELSE            BUFIN(6)=1.#           Set ref-code as observed         SH00 261
IF(SFT==3)BUFIN(4)=ABS(BUFIN(4))#      Make all frels positive          SH00 262
ELSE      BUFIN(4)=BUFIN(4)#           Allow negative f2rels            SH00 263
BUFIN(5)=ABS(BUFIN(5))#                Make all sigfs positive          SH00 264
ncodefld:(BUFIN,1,CHROT,FMT2,6)#       Format hkl,frel,sigf,rcode       SH00 265
put:(50)#                              Output the data line             SH00 266
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SH00 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SH00 268
#                                                                       SH00 269
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SH00 270
#                                                                       SH00 271
#   FINISH OFF FILE AND REDIRECT                                        SH00 272
#   ----------------------------                                        SH00 273
#                                                                       SH00 274
IF(LINE1(1^1)!=' ') writefmt:(iofm1:,'(a)',LINE1)# Output atom line     SH00 275
IF(LINE2(1^1)!=' ') writefmt:(iofm1:,'(a)',LINE2)# Output uij  line     SH00 276
IF(LINE3(1^1)!=' ') writefmt:(iofm1:,'(a)',LINE3)# Output suij line     SH00 277
SYNTXF=0;   FIELDF=no:#                Set syntax checking on           SH00 278
CHROT(1^4)='end '#                     Store end header                 SH00 279
IF(ILAT==no:&IHKL==no:) put:(4)#       Output the data line             SH00 280
IF(CHRIN(1^4)!='END ')#                If next input line is not end    SH00 281
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SH00 282
LINFLG=1; CHROT=CHRIP; put:(80)#       Ensure this line not lost        SH00 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SH00 284
closefmt:(iofm1:)#                     Close formated file              SH00 285
linestream:('shx')#                    Insert lines into line stream    SH00 286
#                                                                       SH00 287
RETURN#                                                                 SH00 288
END#                                                                    SH00 289
systemheader:(SH01)#                   Write out abbreviated string     SH01   1
######################################################################  SH01   2
#                                                                    #  SH01   3
#                             SH01     PUT:                          #  SH01   4
#                                                                    #  SH01   5
######################################################################  SH01   6
SUBROUTINE SH01(NUM,STRG)#             Strip trailing blanks by         SH01   7
include:(AACOMN)#                                                       SH01   8
#                                      Setting explicit char width      SH01   9
INTEGER NUM#                           How many characters?             SH01  10
string:(STRG,*)#                       The input string                 SH01  11
chardata:(CW,'(a   )')#                The character format descripto   SH01  12
datastuff:#                                                             SH01  13
#                                                                       SH01  14
CW(3^5)='   '#                         Ensure empty number string       SH01  15
IF    (NUM>999\NUM<0);#                Do nothing - just in case        SH01  16
ELSEIF(NUM> 99)ncodefld:(FLOAT(NUM),1,CW,50333.,1)# 3 digits            SH01  17
ELSEIF(NUM>  9)ncodefld:(FLOAT(NUM),1,CW,40223.,1)# 2 digits            SH01  18
ELSE           ncodefld:(FLOAT(NUM),1,CW,30113.,1)# 1 digit             SH01  19
writefmt:(iofm1:,CW,STRG(1^NUM))#      Somewhat belatedly write the     SH01  20
STRG(1^NUM)=' '#                       String and then reset.           SH01  21
#                                                                       SH01  22
RETURN#                                                                 SH01  23
END#                                                                    SH01  24
pmacro:([no:])#                                                         SH01  25
