systemheader:(XT    )#                                                  XT     1
####################################################################### XT     2
##      Copyright (C) 2000, The Xtal System, The University of        # XT     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # XT     4
## Distributed under the GNU General Public Licence as published by   # XT     5
## the Free Software Foundation, in the hope that it will be useful   # XT     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # XT     7
## for more details.                                                  # XT     8
##                                                                    # XT     9
##                          *** XTINCT ***                            # XT    10
##                                                                    # XT    11
##  XTINCT calculates the secondary extinction coefficient r* from    # XT    12
##  the intensity differences and tbars of equivalent reflections     # XT    13
##  measured from an asymmetric crystal.                              # XT    14
##                                                                    # XT    15
####################################################################### XT    16
#                                                                       XT    17
include:(XMACRO)#                                                       XT    18
#                                                                       XT    19
#                                                                       XT    20
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     XT    21
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            XT    22
macro:(dp:,ifelse:(mxbtwd:,32,DOUBLE PRECISION ,REAL ))#                XT    23
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  XT    24
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            XT    25
#                                                                       XT    26
extrude:(XTCOMN)#                                                       XT    27
INTEGER FRDL#                          Friedel's law flag yes/no        XT    28
INTEGER NPNT#                          Lines to print                   XT    29
INTEGER NHKL#                          Total number of reflns           XT    30
INTEGER SREF#                          Size of refln packet in qx       XT    31
INTEGER NTYP#                          Type of data processed 0 2 4     XT    32
INTEGER REFN#                          Refine or apply correction?      XT    33
INTEGER CENT#                          Separate friedel equivalents?    XT    34
INTEGER INDV#                          Refine individually on equivs    XT    35
INTEGER ABEQ#                          Abort if equal tbars y/n         XT    36
INTEGER ABXV#                          Abort if xcessive variation      XT    37
INTEGER DISAT#                         Distributn and extincn type      XT    38
INTEGER MARKS#                         Start of workspace               XT    39
INTEGER MARKQ#                         End of symops in workspace       XT    40
INTEGER MARKP#                         End of lrrefl in workspace       XT    41
INTEGER LMIT#                          Limits on stol or _rel in refn   XT    42
INTEGER NGTV#                          Apply a negative refined r*      XT    43
INTEGER RADTYP#                        Radiation type 1 2 3 or 4        XT    44
INTEGER STOPP#                         Flag for direct access io        XT    45
REAL CVOL#                             Unit cell volume                 XT    46
REAL LAMBDA#                           Wavelength                       XT    47
REAL PPFAC#                            Perpendicular polarization fac   XT    48
REAL RX#                               R*                               XT    49
REAL SRX#                              Sigma for r*                     XT    50
REAL VMIN,VMAX#                        Limits for stol or f2rel ..etc   XT    51
REAL DSET#                             Data set number*1000             XT    52
REAL SCAL#                             Scale factor for lrrefl data     XT    53
REAL TBAV#                             Mean tbar                        XT    54
REAL RRAT#                             Limiting rfactor ratio           XT    55
#                                                                       XT    56
COMMON/COMIXT/NPNT,CENT,NGTV,INDV,NHKL,NTYP,FRDL,REFN,#                 XT    57
STOPP,ABEQ,ABXV,MARKS,MARKQ,MARKP,LMIT,SREF,DISAT,RADTYP#               XT    58
#                                                                       XT    59
COMMON/COMFXT/RX,SRX,VMIN,VMAX,DSET,SCAL,TBAV,PPFAC,#                   XT    60
CVOL,LAMBDA,RRAT#                                                       XT    61
endext:#                                                                XT    62
#                                                                       XT    63
systemheader:(XT00)#                   General routine                  XT00   1
# ################################################################## #  XT00   2
#                                                                    #  XT00   3
#                               XT00                                 #  XT00   4
#                                                                    #  XT00   5
# ################################################################## #  XT00   6
SUBROUTINE XT00#                       N. spadaccini may 91             XT00   7
include:(AACOMN)#                      D. du boulay nov 91              XT00   8
include:(XTCOMN)#                                                       XT00   9
#                                                                       XT00  10
FILEXT(ioda1:)='XX5'#                  For direct access file           XT00  11
#                                                                       XT00  12
CALL XT10#                             Read controls and print          XT00  13
CALL XT20#                             Get data from bdf                XT00  14
IF(REFN==yes:) CALL XT30#              R* for whole data set            XT00  15
IF(INDV==yes:) CALL XT40#              R* for each group of equivs      XT00  16
CALL XT50#                             Apply correction to lrrefl       XT00  17
#                                                                       XT00  18
RETURN#                                                                 XT00  19
END#                                                                    XT00  20
systemheader:(XT10)#                   Enter control lines & bdf        XT10   1
# ################################################################## #  XT10   2
#                                                                    #  XT10   3
#                               XT10                                 #  XT10   4
#                                                                    #  XT10   5
# ################################################################## #  XT10   6
SUBROUTINE XT10#                                                        XT10   7
include:(AACOMN)#                                                       XT10   8
include:(XTCOMN)#                                                       XT10   9
#                                                                       XT10  10
INTEGER J,K,L,M,N#                     General indices                  XT10  11
INTEGER PSIZ,IP#                       Packet sizes                     XT10  12
INTEGER POLL#                          Polarization specifier           XT10  13
INTEGER IWNT(5),IREL(6),KEY(4)#        Pointers to lrexpl               XT10  14
INTEGER LTEST#                         Test for lambda                  XT10  15
chardata:(XT101, LIMITS  END   )#                                       XT10  16
chardata:(XT102,IRE F2R FRE APP REF EQF SAL PRI INC NEG $#              XT10  17
DSE DFA POL RRR )#                                                      XT10  18
chardata:(XT103,STOL IREL F2RL FREL )#                                  XT10  19
chardata:(XT104," XTINCT control parameters ")#                         XT10  20
chardata:(XT105," Friedel pairs treated as              $#              XT10  21
EQUIVALENT")#                                                           XT10  22
chardata:(XT106," Extinction applied/refined             $#             XT10  23
  REFINED")#                                                            XT10  24
chardata:(XT107," Applied  r*                            $#             XT10  25
         ")#                                                            XT10  26
chardata:(XT108," Applied sigma(r*)                      $#             XT10  27
         ")#                                                            XT10  28
chardata:(XT109," Reflections printed                    $#             XT10  29
         ")#                                                            XT10  30
chardata:(XT10A," Correction applied to                  $#             XT10  31
         ")#                                                            XT10  32
chardata:(XT10B," Refinement on individual equiv         $#             XT10  33
       NO")#                                                            XT10  34
chardata:(XT10C," Minimum                                $#             XT10  35
         ")#                                                            XT10  36
chardata:(XT10D," Limiting parameter                     $#             XT10  37
     NONE")#                                                            XT10  38
chardata:(XT10E,"-STOL   SEPARATEAPPLIED YES NO   OMIT")#               XT10  39
chardata:(XT10I,"IRELATIVEFREL SQRDFRELATIVE R-FACTOR")#                XT10  40
chardata:(XT10K,"    NEUTRONS   ELECTRONS      X-RAYSSYNCH X-RAYS")#    XT10  41
chardata:(XT10F," Maximum                                $#             XT10  42
         ")#                                                            XT10  43
chardata:(XT10G," Skip equivs with identical tbars       $#             XT10  44
      YES")#                                                            XT10  45
chardata:(XT10H," Correct if r* is less than  0.0        $#             XT10  46
       NO")#                                                            XT10  47
chardata:(XT10J," Radiation type                         $#             XT10  48
         ")#                                                            XT10  49
chardata:(XT10L," Perpendicular polarization fraction    $#             XT10  50
         ")#                                                            XT10  51
chardata:(XT10M," Extinction type                        $#             XT10  52
  CASE   ")#                                                            XT10  53
chardata:(XT10N," Limiting R-factor ratio R(f**2)/R(tbar)$#             XT10  54
         ")#                                                            XT10  55
datastuff:#                                                             XT10  56
#                                                                       XT10  57
#   SET DEFAULT PARAMETERS                                              XT10  58
#   ----------------------                                              XT10  59
#                                                                       XT10  60
NPNT=25#                               Set default print lines          XT10  61
FRDL=no:#                              Set freidels as not equivalent   XT10  62
ABEQ=yes:#                             Skip equ sets if tbars are =     XT10  63
ABXV=no:#                              Do not abort if excess variatn   XT10  64
RRAT=0.5#                              Rfactor ratio test value         XT10  65
INDV=no:#                              Refine r* separately for eq se   XT10  66
NGTV=no:#                              No application of r* < 0         XT10  67
LTEST=no:#                             Lambda has not been found        XT10  68
POLL=no:#                              Polarization not specified       XT10  69
REFN=yes:#                             Refine r*                        XT10  70
DISAT=2#                               Normal treatment of lorentz      XT10  71
PPFAC=0.5#                             Perpendic polarize fraction      XT10  72
LMIT=0#                                No limits                        XT10  73
RX=0.0#                                Default value for r*             XT10  74
NTYP=2#                                Set f**2 default                 XT10  75
SREF=6#                                Default pkt size for f**2        XT10  76
DSET=1.#                               Default data set is 1            XT10  77
RADTYP=3#                              Conventional x-rays              XT10  78
VMIN=-10000.;   VMAX=9999.E+15#        Default limits                   XT10  79
#                                                                       XT10  80
#   EXTRACT OTHER INPUT OPTIONS                                         XT10  81
#   ---------------------------                                         XT10  82
#                                                                       XT10  83
FOR(K=1;BUFIN(K)<voidflg:;K=K+1)#      Loop over chrin                  XT10  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT10  85
stringlim:(K,L,J)#                     Get string pointers              XT10  86
compchar:(CHRIN,L,XT102,1,3,4,NXT102,N)# Check the list                 XT10  87
IF(N==0) iquit:(XT1001,K)#             Not recognised input option      XT10  88
IF(N<=3) NTYP=N#                       Process i,f**2 or f data         XT10  89
ELSE IF(N==4)#                         Apply extinction as input belo   XT10  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT10  91
REFN=no:#                              Branch control for apply         XT10  92
IF(BUFIN(K+1)<=voidflg:) iquit:(XT1002)# If no r* quit                  XT10  93
IF(BUFIN(K+2)<=voidflg:) iquit:(XT1003)# If no sigma r* quit            XT10  94
RX=BUFIN(K+1)#                         R* as given                      XT10  95
SRX=BUFIN(K+2)#                        S(r*) as given                   XT10  96
K=K+2#                                 Update bufin pointer             XT10  97
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT10  98
ELSE IF(N==5) REFN=yes:#               Refine and apply r*              XT10  99
ELSE IF(N==6) FRDL=yes:#               Friedels are equivalent          XT10 100
ELSE IF(N==7) INDV=yes:#               Refine individual r* for equiv   XT10 101
ELSE IF(N==8)#                         Print control                    XT10 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XT10 103
IF(BUFIN(K+1)<=voidflg:) NPNT=999999#  Print all reflections            XT10 104
ELSE#                                  Specific count is input          XT10 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XT10 106
K=K+1; NPNT=ABS(NINT(BUFIN(K)))#       Number of refls                  XT10 107
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XT10 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XT10 109
ELSE IF(N== 9) ABEQ=no:#               Skip if tbars equal              XT10 110
ELSE IF(N==10) NGTV=yes:#              Apply r* if negative             XT10 111
ELSE IF(N==11)#                        Specifying data set              XT10 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  XT10 113
IF(BUFIN(K+1)<=voidflg:) iquit:(XT1004)# Must be a number               XT10 114
DSET=BUFIN(K+1);K=K+1#                 Store the data set number        XT10 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  XT10 116
ELSE IF(N==12)#                        Distribution and extinction ty   XT10 117
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  XT10 118
IF(BUFIN(K+1)<1.0\BUFIN(K+1)>2.0)#     Restrictions on possible value   XT10 119
iquit:(XT1005)#                        Quit if out of range             XT10 120
ELSE DISAT=NINT(BUFIN(K+1));K=K+1#     Iether 1,2 or 3                  XT10 121
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  XT10 122
ELSE IF(N==13)#                        Specify polarization             XT10 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  XT10 124
IF(BUFIN(K+1)<0.0\BUFIN(K+1)>1.0)#     Restrictions on possible value   XT10 125
iquit:(XT1006)#                        Quit if out of range             XT10 126
PPFAC=BUFIN(K+1);K=K+1#                Store the polarization factor    XT10 127
POLL=yes:#                             Polarization is as specified     XT10 128
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  XT10 129
ELSE IF(N==14)#                        Rfactor ratio restrictions       XT10 130
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  XT10 131
IF(BUFIN(K+1)>0.0)#                    Limiting r-factor is positive    XT10 132
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  XT10 133
K=K+1 ; RRAT=BUFIN(K)#                 Store the rfactr ratio           XT10 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  XT10 135
ABXV=yes:#                             Flag abort on xs variation       XT10 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  XT10 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT10 138
#                                                                       XT10 139
#                                                                       XT10 140
#    SET IO BUFFERS AND ARRAY MARKERS                                   XT10 141
#    --------------------------------                                   XT10 142
#                                                                       XT10 143
IOMARK(1)=QXSTR#                       Start of file a buffer           XT10 144
IOMARK(2)=IOMARK(1)+bdfbuf:#           Start of file b buffer           XT10 145
incrqx:(MARKS,IOMARK(2)+bdfbuf:,XT1007)# Start of symmetry matrices     XT10 146
#                                                                       XT10 147
#    GET CELL VOLUME FROM LRCELL                                        XT10 148
#    --------------------------                                         XT10 149
#                                                                       XT10 150
DO K=1,16#                             Loop over lrcell packets         XT10 151
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 XT10 152
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read packet k of input bdf       XT10 153
IF(IP<=0) BREAK#                       Read last packet                 XT10 154
IF(K==6) CVOL=QX(IP+1)#                Got the the cell volume          XT10 155
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 XT10 156
#                                                                       XT10 157
#    GET THE SYMOPS AND SYMMETRY CONDITIONS                             XT10 158
#    -------------------------------------                              XT10 159
#                                                                       XT10 160
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read packet one of lrsymm        XT10 161
IF(IP<=0) iquit:(XT1008)#              No symmetry information availa   XT10 162
CENT=NINT(QX(IP+2))#                   Centrosymmetric=0,non=1          XT10 163
MARKQ=MARKS#                           Set current limit                XT10 164
REPEAT#                                Loop symop packets               XT10 165
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 XT10 166
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Get symops                       XT10 167
IF(IP<=0) BREAK#                       If finished                      XT10 168
incrqx:(MARKQ,MARKQ+PSIZ,XT1007)#      Get memory for symops            XT10 169
movereal:(QX,IP+1,QX,MARKQ+1-PSIZ,PSIZ,1)# Copy symops to work area     XT10 170
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 XT10 171
#                                                                       XT10 172
#     GET RADIATION WAVELENGTH                                          XT10 173
#     ------------------------                                          XT10 174
#                                                                       XT10 175
SCAL=1.0#                              Default scale factor             XT10 176
IWNT(1)=1#                             Data set number                  XT10 177
IWNT(2)=2#                             Wavelength                       XT10 178
IWNT(3)=101#                           Scale factor                     XT10 179
IWNT(4)=52#                            Polarization ratio               XT10 180
IWNT(5)=94#                            Radiation type                   XT10 181
KEY(1)=2;KEY(2)=5;KEY(3)=0;KEY(4)=0#   Set search keys                  XT10 182
indexpkt:(1,lrexpl:,PSIZ,IP,0,KEY,IWNT,IREL)# Get packet pointers       XT10 183
REPEAT#                                Loop over lrexpl packets         XT10 184
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 XT10 185
readwpkt:(1,lrexpl:,PSIZ,IP,0)#        Read packet dataset of lrexpl    XT10 186
IF(IP<=0) BREAK#                       Exit after last packet           XT10 187
ifne:(DSET,QX(IP+IREL(1)))NEXT#        Test for correct data set        XT10 188
LAMBDA=QX(IP+IREL(2))#                 Now we have the wavelength       XT10 189
SCAL=QX(IP+IREL(3))#                   Got the scale factor for dset    XT10 190
IF(POLL==no:&IREL(4)!=0)#              Factor is available              XT10 191
PPFAC=QX(IP+IREL(4))#                  Perp polarization factr          XT10 192
IF(IREL(5)!=0)RADTYP=QX(IP+IREL(5))#   Radiation type 1=n,2=e,3=x,4=s   XT10 193
ELSE RADTYP=3#                         Treat as normal x-rays           XT10 194
LTEST=yes:#                            Lambda test is true              XT10 195
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 XT10 196
IF(LTEST==no:) iquit:(XT1009)#         Failed to pick up lambda         XT10 197
#                                                                       XT10 198
#    LIST SELECTED OPTIONS                                              XT10 199
#    ---------------------                                              XT10 200
#                                                                       XT10 201
movechar:(XT10E,1,CHROT,2,NXT104-3,1)# Underline header                 XT10 202
writeline:(1,XT104,NXT104,2,3)#        Header                           XT10 203
movechar:(XT10K,RADTYP*12-11,XT10J,38,12,0)# Get radiation type         XT10 204
writeline:(0,XT10J,NXT10J,3,3)#        Print radiation type             XT10 205
ncodefld:(PPFAC,1,XT10L,490542.,1)#    Get  polarization                XT10 206
writeline:(0,XT10L,NXT10L,3,3)#        Print polarization               XT10 207
ncodefld:(FLOAT(DISAT),1,XT10M,490313.,1)# Distribution and type        XT10 208
writeline:(0,XT10M,NXT10M,3,3)#        Print distribution and type      XT10 209
IF(REFN==no:)#                         Apply input correction           XT10 210
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 XT10 211
movechar:(XT10E,17,XT106,43,7,0)#      Get apply label                  XT10 212
writeline:(0,XT106,NXT106,3,3)#        Apply extinction                 XT10 213
ncodefld:(RX,1,XT107,490831.,1)#       Get r*                           XT10 214
writeline:(0,XT107,NXT107,3,3)#        Use r* as input                  XT10 215
ncodefld:(SRX,1,XT108,490831.,1)#      Get sigma r*                     XT10 216
writeline:(0,XT108,NXT108,3,3)#        Write value of srx used          XT10 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 XT10 218
ELSE IF(REFN==yes:)#                   Refine extinction                XT10 219
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 XT10 220
writeline:(0,XT106,NXT106,3,3)#        Write extinction control line    XT10 221
IF(NGTV==no:) writeline:(0,XT10H,NXT10H,3,3)# No application of -r*     XT10 222
ELSE#                                                                   XT10 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 XT10 224
movechar:(XT10E,25,XT10H,47,3,0)#      Get "yes" control                XT10 225
writeline:(0,XT10H,NXT10H,3,3)#        Application of negative r*       XT10 226
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 XT10 227
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 XT10 228
IF(INDV==yes:)#                        Refining on individual equiv s   XT10 229
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 XT10 230
movechar:(XT10E,25,XT10B,47,3,0)#      Get "yes" control                XT10 231
writeline:(0,XT10B,NXT10B,3,3)#        Write individual "yes" line      XT10 232
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 XT10 233
ELSE writeline:(0,XT10B,NXT10B,3,3)#   No refinement on individuals     XT10 234
IF(REFN==yes:\(REFN==no:&INDV==yes:))#                                  XT10 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 XT10 236
IF(ABEQ==yes:)writeline:(0,XT10G,NXT10G,3,3)# Skip if = tbars           XT10 237
ELSE#                                                                   XT10 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 XT10 239
movechar:(XT10E,28,XT10G,47,3,0)#      Don't skip if = tbars            XT10 240
writeline:(0,XT10G,NXT10G,3,3)#                                         XT10 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 XT10 242
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 XT10 243
movechar:(XT10I,NTYP*9-8,XT10A,41,9,0)# Get irel control card           XT10 244
writeline:(0,XT10A,NXT10A,3,3)#        Refine on intensity lrexpl dat   XT10 245
IF(CENT==1)#                           A non-centrosymmetric crystal    XT10 246
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 XT10 247
IF(FRDL==no:)#                         Default frdls are inequivalent   XT10 248
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 XT10 249
movechar:(XT10E,7,XT105,40,10,0)#      Separate                         XT10 250
writeline:(0,XT105,NXT105,3,3)#        Treat friedels as separate       XT10 251
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 XT10 252
ELSE#                                  Treat friedels as equivalent     XT10 253
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 XT10 254
writeline:(0,XT105,NXT105,3,3)#        Write friedel control line       XT10 255
CENT=0#                                Treat structure as centrosym     XT10 256
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 XT10 257
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 XT10 258
#                                                                       XT10 259
ncodefld:(FLOAT(NPNT),1,XT109,490713.,1)# Number of reflections print   XT10 260
writeline:(0,XT109,NXT109,3,3)#        Write print control line         XT10 261
#                                                                       XT10 262
#   ENTER =LIMITS= OR =END= LINES                                       XT10 263
#   ----------------------------                                        XT10 264
#                                                                       XT10 265
REPEAT#                                                                 XT10 266
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 XT10 267
readline:(XT101,NXT101)#               Read a control line              XT10 268
IF(LINID==2) BREAK#                    End line detected            	   XT10 269
#                                                                       XT10 270
IF(REFN==yes:)#                        ********* limits ************    XT10 271
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 XT10 272
stringlim:(1,L,M)#                     Get the string limits            XT10 273
compchar:(CHRIN,L,XT103,1,4,5,NXT103,LMIT)# Look for a string match     XT10 274
IF(LMIT==0) iquit:(XT1010)#            No match so exit                 XT10 275
ifnm:(BUFIN(2)) VMIN=BUFIN(2)#         Get limiting minimum             XT10 276
ifnm:(BUFIN(3)) VMAX=BUFIN(3)#         Get limiting maximum             XT10 277
IF(VMAX<=VMIN) iquit:(XT1011)#         Can't do a great deal here.      XT10 278
#                                                                       XT10 279
IF     (LMIT==1) movechar:(XT10E,2,XT10D,41,4,0)# Stol                  XT10 280
ELSE LMIT=NTYP+1#                                                       XT10 281
IF     (LMIT==2) movechar:(XT10I,1,XT10D,41,9,0)# Irel                  XT10 282
ELSE IF(LMIT==3) movechar:(XT10I,9,XT10D,41,9,0)# F2rel                 XT10 283
ELSE IF(LMIT==4) movechar:(XT10I,18,XT10D,41,9,0)# Frel                 XT10 284
writeline:(0,XT10D,NXT10D,3,3)#        Print limits on what data        XT10 285
ncodefld:(VMIN,1,XT10C,491041.,1)#     Put min in position              XT10 286
writeline:(0,XT10C,NXT10C,3,3)#        Print minimum                    XT10 287
ncodefld:(VMAX,1,XT10F,491041.,1)#     Put max in position              XT10 288
writeline:(0,XT10F,NXT10F,3,3)#        Print maximum                    XT10 289
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 XT10 290
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 XT10 291
IF(LMIT==0)#                           No limits from limit line        XT10 292
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 XT10 293
IF (ABXV==yes:) movechar:(XT10I,28,XT10D,41,9,0)# Rfactor               XT10 294
writeline:(0,XT10D,NXT10D,3,3)#        Limits applied - rfactor         XT10 295
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 XT10 296
IF(ABXV==yes:)#                        Do skip equivs if xs variatn     XT10 297
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 XT10 298
ncodefld:(RRAT,1,XT10N,490622.,1)#     Put min in position              XT10 299
writeline:(0,XT10N,NXT10N,3,3)#        Limiting rfactor ratio           XT10 300
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 XT10 301
#                                                                       XT10 302
RETURN#                                                                 XT10 303
END#                                                                    XT10 304
systemheader:(XT20)#                   Get equivalents from  bdf        XT20   1
# ###################################################################   XT20   2
#                                                                   #   XT20   3
#                              XT20                                 #   XT20   4
#                                                                   #   XT20   5
# ################################################################# #   XT20   6
SUBROUTINE XT20#                                                        XT20   7
include:(AACOMN)#                                                       XT20   8
include:(XTCOMN)#                                                       XT20   9
#                                                                       XT20  10
INTEGER KK#                            Loop counters                    XT20  11
INTEGER IP,PSIZ#                       Packet pointers                  XT20  12
INTEGER ICODE,LCODE,NCODE#             Sorting words                    XT20  13
INTEGER NREC#                          Dac file refln counter           XT20  14
INTEGER LPAK#                          Length of refln pkt              XT20  15
INTEGER I#                                                              XT20  16
INTEGER IH(3)#                         Miller indices                   XT20  17
INTEGER IR#                                                             XT20  18
REAL FF,SF#                                                             XT20  19
REAL CONS#                             Geometric constant?              XT20  20
REAL COST#                             Cos theta                        XT20  21
REAL SINT#                             Sin theta                        XT20  22
REAL SIN2T#                            Sin twotheta                     XT20  23
REAL COS2T#                            Cos twotheta                     XT20  24
REAL POLT#                             Polarisation term                XT20  25
REAL EXTP#                             Extinctn distbn and typ param    XT20  26
REAL GAMMA#                            Gamma                            XT20  27
REAL H(3)#                             Miller indices                   XT20  28
REAL TMIN,TMAX,TBAR#                   Min and max tbars                XT20  29
INTEGER IWNT(10),KEY(4),IREL(11)#      For indexpkt                     XT20  30
chardata:(XT200," Reflections processed               $#                XT20  31
               ")#                                                      XT20  32
chardata:(XT201," Cell volume                   (A**3)$#                XT20  33
               ")#                                                      XT20  34
chardata:(XT202," Radiation wavelength lambda   (A)   $#                XT20  35
               ")#                                                      XT20  36
chardata:(XT203," Constant   0.0794*lambda**3/volume**$#                XT20  37
2              ")#                                                      XT20  38
chardata:(XT204," Maximum radiation path length Tbar ($#                XT20  39
cm)            ")#                                                      XT20  40
chardata:(XT205," Minimum radiation path length Tbar ($#                XT20  41
cm)            ")#                                                      XT20  42
chardata:(XT206," |F| scale factor for data set       $#                XT20  43
               ")#                                                      XT20  44
chardata:(XT207," warning: Scale factor may be incorrect$#              XT20  45
- GENEV is a prerequisite for the scale.")#                             XT20  46
chardata:(XT208," Mean    radiation path length Tbar ($#                XT20  47
cm)            ")#                                                      XT20  48
chardata:(XT209," warning: requested data item unavail$#                XT20  49
able - processing            data")#                                    XT20  50
chardata:(XT210,"IRELATIVEFREL SQRDFRELATIVE")#                         XT20  51
chardata:(XT211," Constant   1.000*lambda**3/volume**$#                 XT20  52
2              ")#                                                      XT20  53
datastuff:#                                                             XT20  54
#                                                                       XT20  55
ncodefld:(CVOL,1,XT201,490822.,1)#     Output cell volume               XT20  56
writeline:(2,XT201,NXT201,3,3)#                                         XT20  57
ncodefld:(LAMBDA,1,XT202,490862.,1)#   Radiation wavelength             XT20  58
writeline:(0,XT202,NXT202,3,3)#                                         XT20  59
#                                                                       XT20  60
#                                                                       XT20  61
IF      (RADTYP>=3)#                   X-rays, normal and synch         XT20  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT20  63
#CONS=(0.0794075*LAMBDA**3)/CVOL**2#    CONSTANT FOR TBAR IN CM         XT20  64
CONS=0.00794075*LAMBDA**3/CVOL**2#     Constant for tbar in mm          XT20  65
ncodefld:(CONS,1,XT203,490841.,1)#     Output constant                  XT20  66
writeline:(0,XT203,NXT203,3,3)#                                         XT20  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT20  68
ELSE IF (RADTYP==1)#                   Case of neutrons                 XT20  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT20  70
#CONS=(1.0000*LAMBDA**3)/CVOL**2#       CONSTANT FOR TBAR IN CM         XT20  71
CONS=0.1000*LAMBDA**3/CVOL**2#         Constant for tbar in mm          XT20  72
ncodefld:(CONS,1,XT211,490841.,1)#     Output constant                  XT20  73
writeline:(0,XT211,NXT211,3,3)#                                         XT20  74
PPFAC=1.0#                             Eliminate polariztn factrs       XT20  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT20  76
ELSE iquit:(XT2001)#                   Electrons are not kinematic      XT20  77
#                                                                       XT20  78
#                                                                       XT20  79
ncodefld:(SCAL,1,XT206,490842.,1)#     Output scale                     XT20  80
writeline:(0,XT206,NXT206,3,3)#                                         XT20  81
ifeq:(SCAL,1.0)writeline:(1,XT207,NXT207,3,3)# Warning on scale         XT20  82
#                                                                       XT20  83
#    EXTRACT THE LRREFL: POINTERS                                       XT20  84
#    ----------------------------                                       XT20  85
#                                                                       XT20  86
I=NINT(DSET)*1000#                     To get data from  the right pa   XT20  87
IWNT(1)=1#                             Hkl                              XT20  88
IWNT(2)=2#                             Sintheta/lambda                  XT20  89
IWNT(3)=I+200#                         Tbar                             XT20  90
IWNT(4)=I+300; IWNT(5)=I+301#          Irel & sigma irel                XT20  91
IWNT(6)=I+302; IWNT(7)=I+303#          F**2 & sigma f**2                XT20  92
IWNT(8)=I+304; IWNT(9)=I+305#          Frel & sigma frel                XT20  93
IWNT(10)=I+204#                        Rlp                              XT20  94
KEY(1)=3; KEY(2)=10; KEY(3)=0; KEY(4)=0# Set search keys                XT20  95
indexpkt:(1,lrrefl:,PSIZ,IP,0,KEY,IWNT,IREL)# Get packet pointers       XT20  96
IF(KEY(4)<=0) iquit:(XT2002)#          Missing items on bdf             XT20  97
IR=NTYP*2+2#                           Point to correct sf              XT20  98
IF(IREL(IR)==0\IREL(IR+1)==0)#         Is the selected sf there?        XT20  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XT20 100
IF     (IREL(6)*IREL(7)>0) NTYP=2#     Set f**2 as input sf             XT20 101
ELSE IF(IREL(8)*IREL(9)>0) NTYP=3#     Set frel as input sf             XT20 102
ELSE IF(IREL(4)*IREL(5)*IREL(10)>0) NTYP=1# Set irel as input sf        XT20 103
ELSE iquit:(XT2003)#                   Nothing there!                   XT20 104
IR=NTYP*2+2#                           Point to correct sf              XT20 105
movechar:(XT210,NTYP*9-8,XT209,57,9,0)# Insert new sf                   XT20 106
writeline:(1,XT209,NXT209,2,3)#        Print warning                    XT20 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XT20 108
IF(NTYP==1) SREF=7#                    Increase ref rec to hold rlp f   XT20 109
NHKL=0;   NREC=0#                      Initialized reflection counter   XT20 110
LCODE=0#                               Last code initialized            XT20 111
TMIN= 100.; TMAX=-100.;  TBAV=0.#      Maximum tbar initialized         XT20 112
MARKP=MARKQ#                           Start of refln packets           XT20 113
STOPP=QXMAX-1200#                      Max qx for refln packets         XT20 114
#                                                                       XT20 115
#    LOOP REFLECTION DATA                                               XT20 116
#    --------------------                                               XT20 117
#                                                                       XT20 118
REPEAT#                                Loop over lrrefl and get refl    XT20 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XT20 120
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Read vital statistics            XT20 121
IF(IP<=0) BREAK#                       Exit when finished               XT20 122
TBAR=QX(IP+IREL(3))#                   Extract tbar                     XT20 123
TMIN=MIN(TMIN,TBAR)#                   Get the min tbar                 XT20 124
TMAX=MAX(TMAX,TBAR)#                   Get the max tbar                 XT20 125
TBAV=TBAV+TBAR#                        Sum all tbars                    XT20 126
#                                                                       XT20 127
#   FIND A SORTING WORD TO GROUP EQUIVALENT REFLECTIONS                 XT20 128
#   --------------------------------------------------                  XT20 129
#                                                                       XT20 130
gethkl:(IP+IREL(1),H)#                 Unpack hkl into h(3)             XT20 131
NCODE=99999999#                        Set highest refln code           XT20 132
FOR(KK=MARKS;KK<MARKQ;KK=KK+12)#       Loop over symops                 XT20 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  XT20 134
IH(1)=NINT(H(1)*QX(1+KK)+H(2)*QX(2+KK)+H(3)*QX(3+KK))# Get new h        XT20 135
IH(2)=NINT(H(1)*QX(4+KK)+H(2)*QX(5+KK)+H(3)*QX(6+KK))# Get new k        XT20 136
IH(3)=NINT(H(1)*QX(7+KK)+H(2)*QX(8+KK)+H(3)*QX(9+KK))# Get new l        XT20 137
ICODE=+1000000*IH(1)+1000*IH(2)+ IH(3)# If centro                       XT20 138
IF(CENT==0) NCODE=MIN(NCODE,ICODE,-ICODE)# If centro                    XT20 139
ELSE        NCODE=MIN(NCODE,ICODE)#    If non-centro                    XT20 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  XT20 141
#                                                                       XT20 142
#   STORE EXTINCTION GEOMETRIC FACTORS IF NEW GROUP                     XT20 143
#   -----------------------------------------------                     XT20 144
#                                                                       XT20 145
IF(NCODE!=LCODE)#                      Different reflection             XT20 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  XT20 147
IF(STOPP>0&MARKP>=STOPP)#              Has memory finished              XT20 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  XT20 149
STOPP=-1#                              Flag end of memory               XT20 150
opendac:(ioda1:,3,SREF*4,' ')#         Open a direct access file        XT20 151
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  XT20 152
LCODE=NCODE#                           Store new sort word              XT20 153
SINT=QX(IP+IREL(2))* LAMBDA#           Get sine theta                   XT20 154
COST=SQRT(1.-SINT*SINT)#               Get cosine theta                 XT20 155
SIN2T=2.*SINT*COST#                    Lorentz term                     XT20 156
COS2T=COST*COST-SINT*SINT#             Cosine 2 theta                   XT20 157
IF     (DISAT==1) EXTP=SIN2T#          Primary extinction               XT20 158
ELSE IF(DISAT==2) EXTP=1.#             Zachariasen secondary extinctn   XT20 159
POLT=(PPFAC+(1.0-PPFAC)*COS2T**4)/$#   Polarisation term                XT20 160
     (PPFAC+(1.0-PPFAC)*COS2T**2)#                                      XT20 161
GAMMA=CONS*POLT*EXTP/SIN2T#            Gamma                            XT20 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  XT20 163
#                                                                       XT20 164
#     STORE DATA AND WRITE DIRECT ACCESS FILE                           XT20 165
#     ---------------------------------------                           XT20 166
#                                                                       XT20 167
FF=QX(IP+IREL(IR));  SF=QX(IP+IREL(IR+1))# Get sf and sigma sf          XT20 168
IF(NTYP==1)#                           Is this intensity?               XT20 169
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  XT20 170
FF=FF*QX(IP+IREL(10)); SF=SF*QX(IP+IREL(10))# Get f**2 & sigma f**2     XT20 171
BUFOT(7)=QX(IP+IREL(10))#              Store rlpfac in qx also          XT20 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  XT20 173
ELSE IF(NTYP==3)#                      Is this frel?                    XT20 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  XT20 175
FF=FF*FF;   SF=SF*SF#                  Get f**2 & sigma f**2            XT20 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  XT20 177
#                                                                       XT20 178
#                                                                       XT20 179
BUFOT(1)=QX(IP+IREL(2))#               Store stol                       XT20 180
BUFOT(2)=FF#                           F2rel                            XT20 181
intpak:(LCODE,BUFOT(3),0,32)#          Store the sort code              XT20 182
BUFOT(4)=QX(IP+IREL(3))#               Store tbar                       XT20 183
BUFOT(5)=GAMMA*BUFOT(2)*BUFOT(4)#      Chi/r*                           XT20 184
IF(SF>0.) BUFOT(6)=1./SF**2#           Weighting                        XT20 185
ELSE      BUFOT(6)=1.#                 Default weight is one            XT20 186
NHKL=NHKL+1#                           Increment reflection counter     XT20 187
#                                                                       XT20 188
#   STORE PACKET IN MEMORY OR ON DIRECT ACCESS FILE                     XT20 189
#   -----------------------------------------------                     XT20 190
#                                                                       XT20 191
IF(STOPP>0)#                           Test if sufficient memory        XT20 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 XT20 193
incrqx:(MARKP,MARKP+SREF,XT2004)#      Incr memory                      XT20 194
DO I=1,SREF; QX(MARKP+I-SREF)=BUFOT(I)# Store values in memory          XT20 195
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 XT20 196
ELSE#                                  Must store in file xx5           XT20 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 XT20 198
NREC=NREC+1#                           Count number of records          XT20 199
writedac:(ioda1:,,NREC,(BUFOT(I),I=1,SREF))# Write out the data         XT20 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 XT20 201
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XT20 202
#                                                                       XT20 203
#     PRINT THE DATA SUMMARY                                            XT20 204
#     ----------------------                                            XT20 205
#                                                                       XT20 206
TBAV=TBAV/FLOAT(NHKL)#                 Calc mean tbar                   XT20 207
ncodefld:(FLOAT(NHKL),1,XT200,490513.,1)# Format the number of reflns   XT20 208
writeline:(1,XT200,NXT200,3,3)#        Print the number of reflns       XT20 209
ncodefld:(TBAV,1,XT208,490762.,1)#     Encode mean tbar                 XT20 210
writeline:(0,XT208,NXT208,3,3)#                                         XT20 211
ncodefld:(TMAX,1,XT204,490762.,1)#     Encode max tbar                  XT20 212
writeline:(0,XT204,NXT204,3,3)#                                         XT20 213
ncodefld:(TMIN,1,XT205,490762.,1)#     Encode min tbar                  XT20 214
writeline:(0,XT205,NXT205,2,3)#                                         XT20 215
readwpkt:(1,endrecord:,PSIZ,I,0)#      Close off the input bdf          XT20 216
#                                                                       XT20 217
RETURN#                                                                 XT20 218
END#                                                                    XT20 219
#                                                                       XT20 220
systemheader:(XT21)#                   Refinement algorithm             XT21   1
# ###################################################################   XT21   2
#                                                                   #   XT21   3
#                              XT21                                 #   XT21   4
#                                                                   #   XT21   5
# ################################################################# #   XT21   6
SUBROUTINE XT21(RX2,MARKA,MARKB,DELNUM,DELDEN,DELXS)#                   XT21   7
include:(AACOMN)#                                                       XT21   8
include:(XTCOMN)#                                                       XT21   9
#                                                                       XT21  10
dp: SUM1,SUM2,SUM3,SUM4,SUM5,SUM6,SUM7,SUM8# Sums                       XT21  11
dp: XR,X1,X2#                                                           XT21  12
dp: XRP,X1P,X2P#                                                        XT21  13
dp: Y,YI#                                                               XT21  14
dp: YP,YIP#                                                             XT21  15
dp: SUM1P,SUM2P,SUM2PA,SUM2PB#                                          XT21  16
dp: F,W#                                                                XT21  17
dp: DELNUM#                            Numerator                        XT21  18
dp: DELDEN#                            Denominator                      XT21  19
dp: DELXS#                                                              XT21  20
dp: RX2#                               R* for each equiv                XT21  21
INTEGER J,K#                                                            XT21  22
INTEGER MARKA#                         Begin of equivalents in qx       XT21  23
INTEGER MARKB#                         End of equivalents in qx         XT21  24
datastuff:#                                                             XT21  25
#                                                                       XT21  26
SUM1=0.0 ; SUM2=0.0 ; SUM3=0.0 ; SUM4=0.0# Zero sums                    XT21  27
SUM5=0.0 ; SUM6=0.0 ; SUM7=0.0 ; SUM8=0.0# Zero sums                    XT21  28
FOR(J=MARKA;J<MARKB;J=J+SREF)#         Sum equivs for average _rel      XT21  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT21  30
XR=db:(QX(J+5))#                       Get chi/r*                       XT21  31
X1=XR*RX2#                             Calc chi                         XT21  32
X2=dsqrt:(1.+X1**2)#                   Calc sqrt(1-chi squared)         XT21  33
YI=X1+X2#                              1./extinction correction         XT21  34
Y=X2-X1#                               Extinction correction            XT21  35
SUM1P=0.0 ; SUM2PA=0.0 ; SUM2PB=0.0#                                    XT21  36
FOR(K=MARKA;K<MARKB;K=K+SREF)#         Sum equivs for average _rel      XT21  37
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT21  38
XRP=db:(QX(K+5))#                      Get chi/r*                       XT21  39
X1P=XRP*RX2#                           Calc chi                         XT21  40
X2P=dsqrt:(1.+X1P**2)#                 Calc sqrt(1-chi squared)         XT21  41
YIP=X1P+X2P#                           1/extinction correction          XT21  42
YP=X2P-X1P#                            Extinction correction            XT21  43
W=db:(QX(K+6)*QX(K+2))#                Extract the weight*_rel          XT21  44
SUM1P=SUM1P+W*YIP*Y#                                                    XT21  45
SUM2PA=SUM2PA+W*YIP*Y*(XRP/X2P)#                                        XT21  46
SUM2PB=SUM2PB+W*YIP*Y*(XR/X2)#                                          XT21  47
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT21  48
SUM2P=SUM2PA-SUM2PB#                                                    XT21  49
W=db:(QX(J+6));   F=db:(QX(J+2))#      Extract the weight and _rel      XT21  50
SUM1=SUM1+W*SUM1P*SUM2P#                                                XT21  51
SUM2=SUM2+W*SUM2P*F#                                                    XT21  52
SUM3=SUM3+W*SUM2P*SUM2P#                                                XT21  53
SUM4=SUM4+W#                                                            XT21  54
SUM5=SUM5+W*F*F#                                                        XT21  55
SUM6=SUM6+W*YI*F#                                                       XT21  56
SUM7=SUM7+W*Y*F#                                                        XT21  57
SUM8=SUM8+W*Y*Y#                                                        XT21  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT21  59
DELNUM=(SUM2/SUM4)-(SUM1/SUM4**2)#                                      XT21  60
DELDEN=SUM3/SUM4**2#                                                    XT21  61
DELXS=SUM5+SUM8*(SUM6/SUM4)**2-2*SUM6*SUM7/SUM4#                        XT21  62
#                                                                       XT21  63
RETURN#                                                                 XT21  64
END#                                                                    XT21  65
#                                                                       XT21  66
systemheader:(XT22)#                   Process group of equiv hkl       XT22   1
# ###################################################################   XT22   2
#                                                                   #   XT22   3
#                              XT22                                 #   XT22   4
#                                                                   #   XT22   5
# ################################################################# #   XT22   6
SUBROUTINE XT22(MARKA,MARKB,NEQ,RAVE,TAVE,SKIP)#                        XT22   7
include:(AACOMN)#                                                       XT22   8
include:(XTCOMN)#                                                       XT22   9
REAL STOL#                             Sin theta/lambda                 XT22  10
REAL FF#                               Intensity                        XT22  11
REAL TSUM#                             Sum of tbars                     XT22  12
REAL RSUM#                             Sum of _rel                      XT22  13
REAL FSUM#                             Sum of f**2                      XT22  14
REAL RAVE#                             Average intensity of equ         XT22  15
REAL FAVE#                             Average intensity of equ         XT22  16
REAL TAVE#                             Average intensity of equ         XT22  17
REAL DFSUM#                                                             XT22  18
REAL DTSUM#                                                             XT22  19
REAL RFACF#                                                             XT22  20
REAL RFACT#                                                             XT22  21
REAL RATIO#                                                             XT22  22
REAL REL,TEST2#                                                         XT22  23
INTEGER J#                                                              XT22  24
#                                                                       XT22  25
INTEGER SKIP#                                                           XT22  26
INTEGER NEQ#                           Numb of equivs                   XT22  27
INTEGER MARKA#                         Begin of current equivs          XT22  28
INTEGER MARKB#                         End of current equivs            XT22  29
INTEGER SAME#                          Test for = tbars                 XT22  30
INTEGER XVAR#                          Xsessive variation               XT22  31
datastuff:#                                                             XT22  32
#                                                                       XT22  33
TEST2=no:#                             Values are within limits         XT22  34
DFSUM=0.0;DTSUM=0.0#                   Initialize sums                  XT22  35
FSUM=0.0 ; RSUM = 0.0 ; TSUM = 0.0#    Initialize sums                  XT22  36
STOL=QX(MARKA+1)#                      Get sine theta on lambda         XT22  37
#                                                                       XT22  38
FOR(J=MARKA;J<MARKB;J=J+SREF)#         Loop over equivalents            XT22  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT22  40
FF=QX(J+2)#                            Get f**2                         XT22  41
REL= FF#                               For intensity                    XT22  42
IF(NTYP==3) REL=SQRT(REL)#             Convert to frel                  XT22  43
TSUM=TSUM+QX(J+4)#                     Summing tbars                    XT22  44
FSUM=FSUM+FF#                          Summing f**2                     XT22  45
RSUM=RSUM+REL#                         Summing _rel                     XT22  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT22  47
FAVE=FSUM/FLOAT(NEQ)#                  Got an average f**2              XT22  48
RAVE=RSUM/FLOAT(NEQ)#                  Got an average _rel              XT22  49
TAVE=TSUM/FLOAT(NEQ)#                  Got an average tbar              XT22  50
IF(NTYP==1) RAVE=RAVE/QX(MARKA+SREF)#  Convert to average irel          XT22  51
#                                                                       XT22  52
#      TEST FOR EXCESSIVE VARIATION                                     XT22  53
#      ----------------------------                                     XT22  54
#                                                                       XT22  55
SAME=no: ;XVAR=no:#                    Initialize tests                 XT22  56
FOR(J=MARKA;J<MARKB-SREF;J=J+SREF)#    Loop over equivalents            XT22  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT22  58
DFSUM=DFSUM+ABS(QX(J+2)-FAVE)#         R-factor delta sum for f**2      XT22  59
DTSUM=DTSUM+ABS(QX(J+4)-TAVE)#         R-factor delta sum for tbars     XT22  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT22  61
ifne:(FSUM,0.0) RFACF=DFSUM/FSUM#      F**2 r-factor                    XT22  62
ELSE RFACF=0.0#                                                         XT22  63
ifne:(TSUM,0.0) RFACT=DTSUM/TSUM#      Tbar r-factor                    XT22  64
ELSE RFACT=0.0#                                                         XT22  65
ifeq:(RFACT,0.0,0.000001)#             All tbars are equal              XT22  66
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XT22  67
SAME=yes: ;RATIO=10000.0#              Tbar test                        XT22  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XT22  69
ELSE RATIO=RFACF/RFACT#                                                 XT22  70
IF (ABS(RATIO)>RRAT) XVAR=yes:#        Excessive variation              XT22  71
#                                                                       XT22  72
#    PERFORM TESTS                                                      XT22  73
#    -------------                                                      XT22  74
#                                                                       XT22  75
SKIP=no:#                                                               XT22  76
IF (LMIT==1&(STOL<VMIN\STOL>VMAX)) SKIP=yes:# Stol out of range         XT22  77
IF (LMIT >1&(RAVE<VMIN\RAVE>VMAX)) SKIP=yes:# _rel out of range         XT22  78
IF (SAME==yes:&ABEQ==yes:)         SKIP=yes:# Equal tbars               XT22  79
IF (XVAR==yes:&ABXV==yes:)         SKIP=yes:# Xcessive variatn of f2    XT22  80
IF (NEQ==1)                        SKIP=yes:# Only one equivalent       XT22  81
#                                                                       XT22  82
RETURN#                                                                 XT22  83
END#                                                                    XT22  84
#                                                                       XT22  85
systemheader:(XT30)#                   Find extinction parameter r*     XT30   1
# ###################################################################   XT30   2
#                                                                   #   XT30   3
#                              XT30                                 #   XT30   4
#                                                                   #   XT30   5
# ################################################################# #   XT30   6
SUBROUTINE XT30#                                                        XT30   7
include:(AACOMN)#                                                       XT30   8
include:(XTCOMN)#                                                       XT30   9
#                                                                       XT30  10
dp: CX,DSX#                                                             XT30  11
dp: NUM,DNUM#                          Numerator                        XT30  12
dp: DEN,DDEN#                          Denominator                      XT30  13
dp: XS,DXS#                                                             XT30  14
dp: DX#                                Ls shift in rx                   XT30  15
dp: SRX2,RX2#                          Temporary r* and sigma           XT30  16
#                                                                       XT30  17
REAL RAVE#                             Average intensity of equ         XT30  18
REAL TAVE#                             Average intensity of equ         XT30  19
#                                                                       XT30  20
INTEGER J,NEQ#                         Numb of equivs                   XT30  21
REAL    LCODE#                         Sorting codes                    XT30  22
INTEGER MARK#                          End of current equivs            XT30  23
INTEGER MARK1#                         Begin of current equivs          XT30  24
INTEGER LOOP#                          Loop number                      XT30  25
INTEGER ONE#                           Counter single reflns            XT30  26
INTEGER NREJ#                          Rejected reflection counter      XT30  27
INTEGER NREF#                          Reflection counter               XT30  28
INTEGER NREC#                          Dac file reflection counter      XT30  29
INTEGER SKIP#                          Flag to skip group of equivs     XT30  30
chardata:(XT302," Reduced chi square                        ")#         XT30  31
chardata:(XT303," r* old                                    ")#         XT30  32
chardata:(XT304," r* shift                                  ")#         XT30  33
chardata:(XT305," r* new                                    ")#         XT30  34
chardata:(XT306," r* esd                                    ")#         XT30  35
chardata:(XT307," r* shift/esd                              ")#         XT30  36
chardata:(XT308," Refinement converged by cycle             ")#         XT30  37
chardata:(XT309," Refinement cycle   ")#                                XT30  38
chardata:(XT30A," Reflections skipped in refinement         ")#         XT30  39
chardata:(XT30B,"-")#                                                   XT30  40
chardata:(XT30C," Warning:  REFLECTION DATA MAY NOT BE PROPERLY$#       XT30  41
 ORDERED.")#                                                            XT30  42
datastuff:#                                                             XT30  43
#                                                                       XT30  44
#   LOOP EXTINCTION CYCLES                                              XT30  45
#   ======================                                              XT30  46
#                                                                       XT30  47
RX2 = db:(RX)#                         Store current r*                 XT30  48
SRX2= db:(SRX)#                        Store current sigma r*           XT30  49
NREJ=0#                                Number of rejected hkl           XT30  50
#                                                                       XT30  51
DO LOOP=1,10#                          Do 10 loops (maximimum)          XT30  52
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT30  53
NUM=0. ; DEN=0.#                       Zero numerator denominator       XT30  54
XS=0.#                                 Zero chi square sum              XT30  55
NEQ=0;   NREC=0#                       Number of equivs                 XT30  56
ONE=0#                                 Count of single refln            XT30  57
MARK=MARKQ;    MARK1=MARK#             Start of the input buffer        XT30  58
movepakwd:(QX(MARK+3),LCODE)#          Get first sort code              XT30  59
#                                                                       XT30  60
#    LOOP REFLECTION DATA                                               XT30  61
#    --------------------                 RLP?                          XT30  62
#                                          V                            XT30  63
# MARKQ   1     2     3     4     5     6    & & & & &  MARKP +XX5      XT30  64
#        STOL F**2  CODE  TBAR   GAMM WEIGHT                            XT30  65
#                                                                       XT30  66
DO NREF=1,NHKL#                        Loop over all refns              XT30  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT30  68
NEQ=NEQ+1;   MARK=MARK+SREF#           Incr equiv counter               XT30  69
IF(MARK>=MARKP&NREF<NHKL)#             Test if refln from file          XT30  70
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XT30  71
NREC=NREC+1#                           Count input packets              XT30  72
readdac:(ioda1:,,NREC,(QX(J),J=MARK+1,MARK+SREF))# Read in next buffe   XT30  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XT30  74
IF(NREF<NHKL)#                         If not end of list               XT30  75
compakwd:(QX(MARK+3),EQ,LCODE,NEXT)#   Skip to next refln if same gro   XT30  76
#                                                                       XT30  77
#        PROCESS GROUP OF EQUIV HKL                                     XT30  78
#        -------------------------                                      XT30  79
#                                                                       XT30  80
CALL XT22(MARK1,MARK,NEQ,RAVE,TAVE,SKIP)#                               XT30  81
IF(LOOP==1 &SKIP==yes:)#                                                XT30  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XT30  83
NREJ=NREJ + NEQ#                       Rejected                         XT30  84
IF (NEQ==1) ONE=ONE+1#                 Count when only one equiv        XT30  85
IF(ONE==10&LOOP==1) writeline:(2,XT30C,NXT30C,3,3)# Warning message o   XT30  86
GOTO 100#                              Avoid refinement on one equiv    XT30  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XT30  88
IF (SKIP==yes:) GOTO 100#                                               XT30  89
#                                                                       XT30  90
#                                                                       XT30  91
#     SUM VALUES FOR EXTINCTION CORRECTION                              XT30  92
#     ------------------------------------                              XT30  93
#                                                                       XT30  94
CALL XT21(RX2,MARK1,MARK,DNUM,DDEN,DXS)# Determine shifts for equivs    XT30  95
NUM=NUM+DNUM#                          Sum over inequivalent groups     XT30  96
DEN=DEN+DDEN#                          Sum over inequivalent groups     XT30  97
XS=XS+DXS#                             Sum over inequivalent groups     XT30  98
#                                                                       XT30  99
#   RESET THE EQUIV BUFFER POINTER                                      XT30 100
#   ------------------------------                                      XT30 101
#                                                                       XT30 102
100 NEQ=0; MARK1=MARK; movepakwd:(QX(MARK+3),LCODE)# Reset number equ   XT30 103
IF(MARK<MARKP\NREF==NHKL) NEXT#        If memory not exceeded           XT30 104
movereal:(QX,MARK+1,QX,MARKP+1,SREF,0)# Move last packet                XT30 105
MARK1=MARKP#                           Reset pointer                    XT30 106
MARK=MARKP#                            Reset pointer                    XT30 107
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT30 108
#                                                                       XT30 109
#    FINISHED ITERATION CYCLE -- CALCULATE R*                           XT30 110
#    ----------------------------------------                           XT30 111
#                                                                       XT30 112
IF(ONE>=NHKL-1)iquit:(XT3001)#         Nothing to refine on so quit     XT30 113
IF(NREJ>=NHKL-1)iquit:(XT3002)#        Nothing to refine on so quit     XT30 114
CX=dsqrt:(XS/FLOAT(NHKL-1))#           Calc the chi square              XT30 115
DX=NUM/DEN#                            Calc the r* shift                XT30 116
RX2=RX2+DX#                            Calc the new r*                  XT30 117
SRX2=dsqrt:(1./DEN)#                   Calc the sigma r*                XT30 118
DSX=DX/SRX2#                           Calc shift/sigma ratio           XT30 119
#                                                                       XT30 120
movechar:(XT30B,1,CHROT,2,19,1)#       Underline the header             XT30 121
ncodefld:(FLOAT(LOOP),1,XT309,200213.,1)# Get loop                      XT30 122
writeline:(1,XT309,NXT309,2,3)#        Write refinement cycle           XT30 123
ncodefld:(sg:(CX),1,XT302,420942.,1)#  Chi square                       XT30 124
writeline:(0,XT302,NXT302,3,3)#        Write reduc chi squre            XT30 125
ncodefld:(sg:(RX2-DX),1,XT303,420912.,1)# Get old r*                    XT30 126
writeline:(0,XT303,NXT303,3,3)#        Write old r*                     XT30 127
ncodefld:(sg:(DX),1,XT304,420912.,1)#  Get shift                        XT30 128
writeline:(0,XT304,NXT304,3,3)#        Write shift                      XT30 129
ncodefld:(sg:(RX2),1,XT305,420912.,1)# Get new r*                       XT30 130
writeline:(0,XT305,NXT305,3,3)#        Write new r*                     XT30 131
ncodefld:(sg:(SRX2),1,XT306,420912.,1)# Get sigma                       XT30 132
writeline:(0,XT306,NXT306,3,3)#        Write sigma                      XT30 133
ncodefld:(sg:(DSX),1,XT307,420942.,1)# Get shift/esd                    XT30 134
writeline:(0,XT307,NXT307,3,3)#        Write shift/esd                  XT30 135
#                                                                       XT30 136
IF(dabs:(DSX)<.0001)#                  Test for convergence             XT30 137
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  XT30 138
ncodefld:(FLOAT(LOOP),1,XT308,420213.,1)# Get loop                      XT30 139
writeline:(1,XT308,NXT308,3,3)#        Write convergence loop           XT30 140
BREAK#                                                                  XT30 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  XT30 142
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT30 143
ncodefld:(FLOAT(NREJ),1,XT30A,420713.,1)# Get rejected reflections      XT30 144
writeline:(0,XT30A,NXT30A,3,3)#        Write rejected reflections       XT30 145
RX=sg:(RX2)#                           Return r*                        XT30 146
SRX=sg:(SRX2)#                         Return sigma r*                  XT30 147
#                                                                       XT30 148
RETURN#                                                                 XT30 149
END#                                                                    XT30 150
#                                                                       XT30 151
systemheader:(XT40)#                   Refine on individual sets of     XT40   1
# ###################################################################   XT40   2
#                                                                   #   XT40   3
#                              XT40                                 #   XT40   4
#                                                                   #   XT40   5
# ################################################################# #   XT40   6
SUBROUTINE XT40#                       Equivalents                      XT40   7
include:(AACOMN)#                                                       XT40   8
include:(XTCOMN)#                                                       XT40   9
macro:(limitfac:,ifelse:(dp:,REAL, 1.0E10, 1.0D10 ))#                   XT40  10
#                                                                       XT40  11
dp: NUM#                               Numerator                        XT40  12
dp: DEN#                               Denominator                      XT40  13
dp: XS#                                                                 XT40  14
dp: DX#                                Ls shift in rx                   XT40  15
dp: RX2,SRX2#                          R* and sigma for each equiv      XT40  16
#                                                                       XT40  17
REAL RAVE#                             Average of equivalent inten.     XT40  18
REAL TAVE#                             Average tbar of equivs           XT40  19
#                                                                       XT40  20
INTEGER H,K,L#                                                          XT40  21
INTEGER NEQ#                           Number of equivalents            XT40  22
INTEGER MARK#                          End of equivalents in qx         XT40  23
INTEGER MARK1#                         Begin of equivalents in qx       XT40  24
REAL    LCODE#                         Old sorting word                 XT40  25
REAL    ICODE#                         Current sorting word             XT40  26
INTEGER CODE#                          Decode into hkl                  XT40  27
INTEGER J#                             Counters                         XT40  28
INTEGER LOOP#                          Loop number                      XT40  29
INTEGER NREF#                          Reflection counter               XT40  30
INTEGER NREC#                          Reflection counter for dac xx5   XT40  31
INTEGER SKIP#                          Flag to skip group of equivs     XT40  32
realdata:(FM1,[30313.,70413.,110413.,180642.,280862.,$#                 XT40  33
400941.,510941.,630941.,670313.,790941.])#                              XT40  34
chardata:(XT400," note: REFLECTIONS WITH INFINITE R* HAVE BEEN SET $#   XT40  35
AT R* = 0.0000")#                                                       XT40  36
chardata:(XT401,"  H   K   L   STOL     TBAR         R*$#               XT40  37
       SIGMA     SHFT/ESD CGTCYC  AV  REL")#                            XT40  38
chardata:(XT402," IF2 F")#                                              XT40  39
datastuff:#                                                             XT40  40
#                                                                       XT40  41
#     TO REFINE SEPARATELY ON INDIVIDUAL PACKETS OF EQUIVS              XT40  42
#     ----------------------------------------------------              XT40  43
#                                                                       XT40  44
writepch:(XT400,NXT400)#               Write headings                   XT40  45
movechar:(XT402,NTYP*2-1,XT401,75,2,0)# Is it irel, f2rel or frel?      XT40  46
writepch:(XT401,NXT401)#                                                XT40  47
MARK=MARKQ#                            Start of qx refln storage        XT40  48
MARK1=MARKQ#                           Initialize mark1                 XT40  49
movepakwd:(QX(MARK+3),LCODE,)#         Initialize 1st sort word         XT40  50
NREC=0#                                Initialize dac rec number        XT40  51
NEQ=0#                                 Initialize number of equivs      XT40  52
#                                                                       XT40  53
#     LOOP OVER ALL REFLECTIONS                                         XT40  54
#     -------------------------                                         XT40  55
#                                                                       XT40  56
DO NREF=1,NHKL#                        Loop over all reflections        XT40  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT40  58
NEQ=NEQ+1;    MARK=MARK+SREF#          Incrmnt qx pntr and equv cntr    XT40  59
IF (MARK>=MARKP&NREF<NHKL)#            Read dac file                    XT40  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT40  61
NREC=NREC+1#                           Update the record number         XT40  62
readdac:(ioda1:,,NREC,(QX(J),J=MARK+1,MARK+SREF))# Read in next buffe   XT40  63
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT40  64
movepakwd:(QX(MARK+3),ICODE,)#         Get sort word                    XT40  65
IF(NREF<NHKL)#                         Not end of refln list            XT40  66
compakwd:(ICODE,EQ,LCODE,NEXT)#        If an equiv skip                 XT40  67
#                                                                       XT40  68
#        PROCESS GROUP OF EQUIV HKL                                     XT40  69
#        -------------------------                                      XT40  70
#                                                                       XT40  71
CALL XT22(MARK1,MARK,NEQ,RAVE,TAVE,SKIP)# Test for data limits          XT40  72
IF (SKIP==yes:) GOTO 200#              If beyond limits skip            XT40  73
#                                                                       XT40  74
#     REFINE R* ON SINGLE SET OF EQUIVALENTS                            XT40  75
#     --------------------------------------                            XT40  76
#                                                                       XT40  77
RX2=0.0#                               Initialize r*                    XT40  78
DO LOOP=1,10#                          Do 10 loops                      XT40  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XT40  80
CALL XT21(RX2,MARK1,MARK,NUM,DEN,XS)#  Determine shifts for equivs      XT40  81
#                                      If denominator = 0 avoid         XT40  82
IF(dabs:(NUM)>limitfac:*DEN)#          Divide by zero errors            XT40  83
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XT40  84
RX2 = 0.0 ; SRX2 = 1.0 ; DX = 0.0#     Mark r* as zero in pch file      XT40  85
BREAK#                                 And break loop                   XT40  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XT40  87
DX=NUM/DEN#                            Shift in r*                      XT40  88
RX2=RX2+DX#                            New r*                           XT40  89
SRX2=dsqrt:(1./DEN)#                   New sigma of r*                  XT40  90
IF(dabs:(DX/SRX2)<.0001) BREAK#        If converged then break loop     XT40  91
#                                      End of refinement loop           XT40  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XT40  93
#                                                                       XT40  94
intunpak:(LCODE,CODE,0,mxbtwd:)#       Decode the code                  XT40  95
IF (CENT==1) CODE=-CODE#               Opposite of code                 XT40  96
H=NINT(FLOAT(CODE)/1000000.)#          H index                          XT40  97
K=NINT(FLOAT(H*1000000-CODE)/1000.)#   K index                          XT40  98
L=NINT(FLOAT(H*1000000-K*1000-CODE))#  L index                          XT40  99
IF (CENT==1 ) H =-H#                   Get correct parity               XT40 100
ELSE IF(CENT==0 &H<0)H=-H#                                              XT40 101
#                                                                       XT40 102
BUFOT(1)=FLOAT(H)#                     Output h                         XT40 103
BUFOT(2)=FLOAT(K)#                     Output k                         XT40 104
BUFOT(3)=FLOAT(L)#                     Output l                         XT40 105
BUFOT(4)=QX(MARK1+1)#                  Output stol to pch file          XT40 106
BUFOT(5)=TAVE#                         Output average tbar              XT40 107
BUFOT(6)=sg:(RX2)#                     Output r*                        XT40 108
BUFOT(7)=sg:(SRX2)#                    Output sigma(r*)                 XT40 109
BUFOT(8)=sg:(DX/SRX2)#                 Output shift/esd                 XT40 110
BUFOT(9)=FLOAT(LOOP)#                  Output convergence cycle         XT40 111
BUFOT(10)=RAVE#                        Output average _rel              XT40 112
ncodefld:(BUFOT,1,CHROT,FM1,10)#                                        XT40 113
writepch:(CHROT,80)#                   Write pch file                   XT40 114
#                                                                       XT40 115
#   RESET THE EQUIV BUFFER POINTER                                      XT40 116
#   ------------------------------                                      XT40 117
#                                                                       XT40 118
200 NEQ=0; MARK1=MARK;movepakwd:(ICODE,LCODE)# Reset number of equivs   XT40 119
IF (MARK<MARKP\NREF==NHKL) NEXT#       If enuf mem step to next group   XT40 120
movereal:(QX,MARK+1,QX,MARKP+1,SREF,0)# Else  move last packet          XT40 121
MARK=MARKP#                            Reset last pointer               XT40 122
MARK1=MARKP#                           Reset first pointer              XT40 123
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT40 124
movechar:(BLANK,1,CHROT,1,mxchln:,1)#  Blank character output           XT40 125
#                                                                       XT40 126
RETURN#                                                                 XT40 127
END#                                                                    XT40 128
#                                                                       XT40 129
systemheader:(XT50)#                   Apply the correction             XT50   1
# ###################################################################   XT50   2
#                                                                   #   XT50   3
#                              XT50                                 #   XT50   4
#                                                                   #   XT50   5
# ################################################################# #   XT50   6
SUBROUTINE XT50#                                                        XT50   7
include:(AACOMN)#                                                       XT50   8
include:(XTCOMN)#                                                       XT50   9
#                                                                       XT50  10
#   THIS SECTION WILL APPLY A CORRECTION FOR SECONDARY EXTINCTION       XT50  11
#   TO THE LRREFL DATA. THE VALUE OF THE EXTINCTION FACTOR R* WILL      XT50  12
#   HAVE IETHER A.  BEEN DETERMINED FROM XT30                           XT50  13
#               B.  BEEN INPUT UNDER THE CONTROL LINE =AX= R*,SR*       XT50  14
#           OR  C.  BE SET TO ZERO IN XT50 , IN WHICH CASE              XT50  15
#                   APPLYING THE CORRECTION IS A NULL OPERATION.        XT50  16
#                                                                       XT50  17
dp: X1,X2,XR,YI,IY,SYI#                                                 XT50  18
dp: IYMIN#                             Minimum value of y               XT50  19
dp:  FK,SFK,FF#                        Corrected _rel and s(_rel)       XT50  20
REAL H(3),HH(3)#                       Miller indices                   XT50  21
#                                                                       XT50  22
INTEGER I#                             A  counter                       XT50  23
INTEGER LPAK#                          Length of refln pkt              XT50  24
INTEGER IWNT(19),IREL(20)#             Pointers for lrdset              XT50  25
INTEGER KEY(4)#                        Key to indexpkt                  XT50  26
INTEGER IP,JP,PSIZ,OSIZ#               Pointers to qx array             XT50  27
INTEGER MARK#                          Qx marker                        XT50  28
INTEGER NREF#                          Reflection counter               XT50  29
INTEGER NREC#                          Dac file reflection counter      XT50  30
#                                                                       XT50  31
realdata:(FM2,[30313.,70413.,110413.,210762.,280542.,350542.,$#         XT50  32
461022.,570922.,681022.,780922.])#                                      XT50  33
realdata:(FMT,[420542.,560413.,600413.,640413.])#                       XT50  34
chardata:(XT501," IF2 F")#                                              XT50  35
chardata:(XT502,"  H   K   L     Tbar     Y     sigY   $#               XT50  36
  F2rl       sigF2     F2rlcor   sigF2cor ")#                           XT50  37
chardata:(XT503," Scaled extinction parameter r*                 ")#    XT50  38
chardata:(XT504," Scaled extinction    sigma  r*                 ")#    XT50  39
chardata:(XT505,"  Minimum extinction factor Y is         $#            XT50  40
    for the              reflection")#                                  XT50  41
chardata:(XT506,"  THE EXTINCTION CORRECTION WAS NOT APPLIED")#         XT50  42
datastuff:#                                                             XT50  43
#                                                                       XT50  44
#    UPDATE THE ARCHIVE BDF                                             XT50  45
#    ----------------------                                             XT50  46
#                                                                       XT50  47
copyfile:(1,2,1,decr:(lrdset:))#       Copy bdf up to lrdset:           XT50  48
IWNT(1)=1#                             Data set number                  XT50  49
DO I=1,17; IWNT(I+1)=I+100#            Extinction values                XT50  50
KEY(1)=1;KEY(2)=1;KEY(3)=18;KEY(4)=0#  Set search keys                  XT50  51
indexpkt:(1,lrdset:,PSIZ,IP,2,KEY,IWNT,IREL)# Get packet pointers       XT50  52
OSIZ=KEY(4)#                           Output packet size               XT50  53
REPEAT#                                Loop over lrexpl packets         XT50  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XT50  55
readwpkt:(1,lrdset:,PSIZ,IP,0)#        Read packet dataset of lrexpl    XT50  56
IF(IP<=0) BREAK#                       Exit after last packet           XT50  57
writepkt:(2,lrdset:,OSIZ,JP)#          Write out lrdset                 XT50  58
movereal:(QX,IP+1,QX,JP+1,PSIZ,1)#     Transfer data                    XT50  59
DO I=1,17; QX(JP+IREL(I+1))=voidflg:#  Void all extinction terms        XT50  60
ifeq:(DSET,QX(IP+IREL(1)))#            Test for correct data set        XT50  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XT50  62
QX(JP+IREL(2))=0.0#                    Stor the extinction type - zac   XT50  63
QX(JP+IREL(3))=0.0#                    Store as gaussian                XT50  64
IF (RX>=0.0)#                          Avoid problems in crylsq         XT50  65
QX(JP+IREL(4))= RX/(SCAL*SCAL)#        Store r* in bdf 2                XT50  66
QX(JP+IREL(18))=TBAV#                  Store mean tbar                  XT50  67
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XT50  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XT50  69
copyfile:(1,2,incr:(lrdset:),decr:(lrrefl:))# Copy up to lrrefl:        XT50  70
#                                                                       XT50  71
#    APPLY THE CORRECTION      (EITHER GIVEN OR REFINED)                XT50  72
#    --------------------                                               XT50  73
#                                                                       XT50  74
ncodefld:(RX/SCAL**2,1,XT503,420912.,2)# Format r*                      XT50  75
writeline:(0,XT503,NXT503,3,3)#        Print final r* value             XT50  76
ncodefld:(SRX/SCAL**2,1,XT504,420912.,2)# Format sigma r*               XT50  77
writeline:(0,XT504,NXT504,3,3)#        Print sigma r* value             XT50  78
IYMIN= 1000.#                          Initialized larger than likely   XT50  79
#                                                                       XT50  80
IF(NGTV==no:&RX<0.)#                   No application of negative r*    XT50  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XT50  82
RX=0.0;     SRX=0.0#                   Load zero for no apply           XT50  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XT50  84
LINRM=2;     writeline:(1,0,0,3,3)#    Set pagination                   XT50  85
movechar:(XT501,NTYP*2-1,XT502,41,2,0)# Put approp heading to list      XT50  86
movechar:(XT501,NTYP*2-1,XT502,55,2,0)# Put approp heading to list      XT50  87
movechar:(XT501,NTYP*2-1,XT502,62,2,0)# Put approp heading to list      XT50  88
movechar:(XT501,NTYP*2-1,XT502,75,2,0)#                                 XT50  89
#                                                                       XT50  90
#    SET UP THE REFLECTION PACKET                                       XT50  91
#    ----------------------------                                       XT50  92
#                                                                       XT50  93
I=NINT(DSET)*1000#                     To get data from  the right pa   XT50  94
IWNT(1)=1#                             Hkl                              XT50  95
IWNT(2)=I+298+NTYP*2#                  _rel                             XT50  96
IWNT(3)=I+299+NTYP*2#                  Sigma(_rel)                      XT50  97
IWNT(4)=I+202#                         Extinction factor  (new)         XT50  98
KEY(1)=3;KEY(2)=3;KEY(3)=4;KEY(4)=0#   Set search keys                  XT50  99
indexpkt:(1,lrrefl:,PSIZ,IP,2,KEY,IWNT,IREL)# Get packet pointers       XT50 100
IF(KEY(4)<=0) iquit:(5001)#            Something missing?               XT50 101
PSIZ=KEY(4)#                           Store new packet size            XT50 102
#                                                                       XT50 103
#    LOOP OF REFLECTION DATA                                            XT50 104
#    -----------------------                                            XT50 105
#                                                                       XT50 106
MARK=MARKQ#                            Begin at 1st refln in qx         XT50 107
NREF=1#                                Count reflections                XT50 108
NREC=1#                                Number of reflections in dac f   XT50 109
REPEAT#                                Loop over lrrefl and get refl    XT50 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XT50 111
readwpkt:(1,lrrefl:,LPAK,IP,0)#        Read vital statistics            XT50 112
IF(IP<=0) BREAK#                       Exit when finished               XT50 113
writepkt:(2,lrrefl:,PSIZ,JP)#          Point to output bdf              XT50 114
movereal:(QX,IP+1,QX,JP+1,LPAK,1)#     Transfer data                    XT50 115
#                                                                       XT50 116
IF (MARK<MARKP)#                       If not at qx limit               XT50 117
DO I=1,SREF;BUFIN(I)=QX(MARK+I)#       Load bufin from qx               XT50 118
ELSE readdac:(ioda1:,,NREC,(BUFIN(I),I=1,SREF))# Get bufin from xx5     XT50 119
#                                                                       XT50 120
XR=db:(BUFIN(5))#                      Chi/r*  ie gamma                 XT50 121
X1=XR*db:(RX)#                         Chi                              XT50 122
X2=dsqrt:(1.+X1**2)#                   Chi square                       XT50 123
YI=X1+X2#                              1./extinction correction         XT50 124
FF=db:(BUFIN(2))#                      Get scaled f**2                  XT50 125
FK=YI*FF#                              Kinematic fsqr                   XT50 126
SYI= dabs:(XR*(1+X1/X2)*db:(SRX))#                                      XT50 127
SFK=(2.*X1+X2+X1*X1/X2)**2 /db:(BUFIN(6))+(FF*SYI)**2#                  XT50 128
SFK=dsqrt:(SFK)#                       Sigma of f**2                    XT50 129
IY=1.0/YI#                             Extinction correction y          XT50 130
#                                                                       XT50 131
IF(IY<IYMIN)#                          Test for smallest ext factor     XT50 132
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  XT50 133
gethkl:(IP+IREL(1),HH)#                Extract hkl                      XT50 134
IYMIN=IY#                              Store smallest ext factor        XT50 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  XT50 136
#                                                                       XT50 137
#   IF NOT F**2 INITIALLY - RECONVERT TO REQUESTED ITEM                 XT50 138
#   ---------------------------------------------------                 XT50 139
#                                                                       XT50 140
IF(NTYP==1)#                           Is this intensity?               XT50 141
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  XT50 142
FK=FK/db:(BUFIN(SREF))#                Get irel                         XT50 143
SFK=SFK/db:(BUFIN(SREF))#              Get sigma(irel)                  XT50 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  XT50 145
ELSE IF(NTYP==3)#                      Is this frel?                    XT50 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  XT50 147
FK=dsqrt:(FK);   SFK=dsqrt:(SFK)#      Get frel & sigma(frel)           XT50 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  XT50 149
#                                                                       XT50 150
#   OUTPUT REFLECTION LISTING                                           XT50 151
#   -------------------------                                           XT50 152
#                                                                       XT50 153
IF(NREF<=NPNT)#                        In this case print               XT50 154
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  XT50 155
gethkl:(IP+1,H)#                       Extract hkl                      XT50 156
BUFOT(1)=H(1)#                         Print h                          XT50 157
BUFOT(2)=H(2)#                         Print k                          XT50 158
BUFOT(3)=H(3)#                         Print l                          XT50 159
BUFOT(4)=BUFIN(4)#                     Print tbar                       XT50 160
BUFOT(5)=sg:(IY)#                      Print extinction factor y        XT50 161
BUFOT(6)=sg:((SYI)/(YI*YI))#           Print sigma                      XT50 162
BUFOT(7)=QX(IP+IREL(2))#               Print intial _rel                XT50 163
BUFOT(8)=QX(IP+IREL(3))#               Print initial  sigma(_rel)       XT50 164
BUFOT(9)=sg:(FK)#                      Print corrected _rel             XT50 165
BUFOT(10)=sg:(SFK)#                    Print corrected sigma(_rel)      XT50 166
ncodefld:(BUFOT,1,CHROT,FM2,10)#                                        XT50 167
writeline:(0,XT502,NXT502,1,3)#        Write to outfile                 XT50 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  XT50 169
#                                                                       XT50 170
#     UPDATE REFLECTION RECORD ON BDF 2                                 XT50 171
#     ---------------------------------                                 XT50 172
#                                                                       XT50 173
movepakwd:(sg:(FK),QX(JP+IREL(2)))#    Move fk to _rel                  XT50 174
movepakwd:(sg:(SFK),QX(JP+IREL(3)))#   Move sfk to sigma(_rel)          XT50 175
movepakwd:(sg:(IY),QX(JP+IREL(4)))#    Move extinction factor           XT50 176
IF (MARK<MARKP) MARK=MARK+SREF#        Step to next reflection          XT50 177
ELSE NREC=NREC+1#                      Next dac refln record            XT50 178
NREF=NREF+1#                           Increment reflection counter     XT50 179
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XT50 180
#                                                                       XT50 181
IF((NGTV==no:)&(RX<0))#                Do not find ymin as obviously    XT50 182
writeline:(1,XT506,NXT506,3,3)#        The ext parameter was not appx   XT50 183
ELSE#                                  Otherwise find ymin              XT50 184
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  XT50 185
BUFOT(1)=sg:(IYMIN)#                   Minimum y                        XT50 186
BUFOT(2)=HH(1)#                        H miller indicy                  XT50 187
BUFOT(3)=HH(2)#                        K miller indicy                  XT50 188
BUFOT(4)=HH(3)#                        L miller indicy                  XT50 189
ncodefld:(BUFOT,1,XT505,FMT,4)#        Print hkl and y of ymin ref      XT50 190
writeline:(1,XT505,NXT505,3,3)#                                         XT50 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  XT50 192
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off bdf                XT50 193
IF(STOPP<0) closedac:(ioda1:)#         Close direct access file         XT50 194
#                                                                       XT50 195
RETURN#                                                                 XT50 196
END#                                                                    XT50 197
pmacro:([no:])#                        Finish finish finish finish fi   XT50 198
