systemheader:(BU    )#                                                  BU     1
####################################################################### BU     2
##      Copyright (C) 2000, The Xtal System, The University of        # BU     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # BU     4
## Distributed under the GNU General Public Licence as published by   # BU     5
## the Free Software Foundation, in the hope that it will be useful   # BU     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # BU     7
## for more details.                                                  # BU     8
##                                                                    # BU     9
##                        *** BUNYIP ***                              # BU    10
##                                                                    # BU    11
## BUNYIP inputs atomic positions and searches the asymmetic unit for # BU    12
## additional symmetry elements. This is done by checking the mid-    # BU    13
## point of all interatomic vectors for a common origin line or plane # BU    14
## which represents an inversion, rotor or screw, or mirror or glide. # BU    15
##                                                                    # BU    16
####################################################################### BU    17
##                                                                      BU    18
include:(XMACRO)#                                                       BU    19
##                                                                      BU    20
ifsel:(UNIXCRA,CRA)#                                                    BU    21
macro:(dp:,REAL)#                                                       BU    22
macro:(sd:,$1)#                                                         BU    23
macro:(ds:,$1)#                                                         BU    24
ifsel:#                                                                 BU    25
macro:(dp:,DOUBLE PRECISION)#                                           BU    26
macro:(sd:,DBLE($1))#                                                   BU    27
macro:(ds:,REAL($1))#                                                   BU    28
endsel:#                                                                BU    29
##                                                                      BU    30
macro:(atomlist:,[ifelse:($1,,IA,$1)])# Define atom list pointer        BU    31
macro:(na:,[QX(atomlist:($1)+ 1)])#    Define start of atom name        BU    32
macro:(xf:,[QX(atomlist:($1)+ 3)])#    Define frac x coord              BU    33
macro:(yf:,[QX(atomlist:($1)+ 4)])#    Define frac y coord              BU    34
macro:(zf:,[QX(atomlist:($1)+ 5)])#    Define frac z coord              BU    35
macro:(ty:,[QX(atomlist:($1)+ 6)])#    Define atom type number          BU    36
macro:(fr:,[QX(atomlist:($1)+ 7)])#    Define known symmetry site       BU    37
macro:(bn:,[QX(atomlist:($1)+ 8)])#    Define cluster/group number      BU    38
macro:(cx:,[QX(atomlist:($1)+ 9)])#    Define complex connections       BU    39
macro:(ia:,IA+9)#                                                       BU    40
##                                                                      BU    41
macro:(diff:,MOD(9.25+$1-$2,.5)-.25)#                                   BU    42
macro:(lablen:,incr:(arith:(23,/,mxchwd:)))# Atom label length in wor   BU    43
##                                                                      BU    44
macro:(amx1:,ifelse:(mxbtwd:,32,DMAX1($1),AMAX1($1)))#                  BU    45
macro:(dabs:,ifelse:(mxbtwd:,32,DABS($1),ABS($1)))#                     BU    46
macro:(db:,ifelse:(mxbtwd:,32,DBLE($1),$1))#                            BU    47
macro:(dcos:,ifelse:(mxbtwd:,32,DCOS($1),COS($1)))#                     BU    48
macro:(dsign:,ifelse:(mxbtwd:,32,DSIGN(1.0D0,$1),SIGN(1.0,$1)))#        BU    49
macro:(dsmall:,ifelse:(mxbtwd:,32,5.0D-mxsgfp:,5.0E-mxsgfp:))#          BU    50
macro:(dsqrt:,ifelse:(mxbtwd:,32,DSQRT($1),SQRT($1)))#                  BU    51
macro:(sg:,ifelse:(mxbtwd:,32,SNGL($1),$1))#                            BU    52
macro:(vsmall:,ifelse:(mxbtwd:,32,1.0D-13,1.0E-13))#                    BU    53
macro:(zero:,ifelse:(mxbtwd:,32,0.0D0,0.0))#                            BU    54
macro:(p01:,ifelse:(mxbtwd:,32,1D-2,1E-2))#                             BU    55
macro:(quart:,ifelse:(mxbtwd:,32,0.25D0,0.25))#                         BU    56
macro:(half:,ifelse:(mxbtwd:,32,0.5D0,0.5))#                            BU    57
macro:(one:,ifelse:(mxbtwd:,32,1.0D0,1.0))#                             BU    58
macro:(two:,ifelse:(mxbtwd:,32,2.0D0,2.0))#                             BU    59
macro:(three:,ifelse:(mxbtwd:,32,3.0D0,3.0))#                           BU    60
macro:(four:,ifelse:(mxbtwd:,32,4.0D0,4.0))#                            BU    61
macro:(nine:,ifelse:(mxbtwd:,32,9.0D0,9.0))#                            BU    62
macro:(two7:,ifelse:(mxbtwd:,32,27.0D0,27.0))#                          BU    63
#                                                                       BU    64
extrude:(BUCOMN)#                                                       BU    65
INTEGER MARKA,STEPA,STOPA,STOPI#       Atom list pointers               BU    66
INTEGER MARKS,STEPS,STOPS,STOPN#       Symmetry list pointers           BU    67
INTEGER MARKC,STEPC,STOPC#             Cluster list pointers            BU    68
INTEGER MARKM,STEPM,STOPM#             Midpoint list pointers           BU    69
INTEGER MARKP,STEPP,STOPP#             Chain list pointers              BU    70
INTEGER JCENT,JPLAN,JAXIS#             Set symmetry flags               BU    71
INTEGER TEMPP,STARP#                   Current chain pointers           BU    72
INTEGER CLUS#                          Atom site cluster flag           BU    73
INTEGER MXAD#                          Max no atoms diff in clusters    BU    74
INTEGER NTYP#                          Max atom types used              BU    75
INTEGER INRAD#                         No of radii input on radii       BU    76
INTEGER IALL#                          Intra-mol search flag            BU    77
INTEGER NCPX#                          Number of complex labels         BU    78
INTEGER NIGN#                          Number of ignored atoms or typ   BU    79
INTEGER INAT#                          No of atoms pre-identified       BU    80
INTEGER ISIT#                          No of atoms on symmetry elemen   BU    81
INTEGER INATID(10)#                    Numerical id pre-identified at   BU    82
INTEGER NCL#                           Number of clusters               BU    83
INTEGER ANUM#                          Total atoms in list              BU    84
INTEGER MPTS#                          Midpoint table output            BU    85
INTEGER HIT(1000)#                     Midpoint hit list                BU    86
INTEGER FINAL#                         Flag finished search             BU    87
INTEGER LORP#                          Line or plane flag               BU    88
INTEGER ABORT#                         Small eigenvalue flag            BU    89
INTEGER WROTE#                         Flag .bun file header written    BU    90
INTEGER PSIZ#                          Lratom output packet size        BU    91
INTEGER ITEST#                         Count of first or second test    BU    92
INTEGER DEBUG#                         Debugging status                 BU    93
INTEGER SKIPSTRT#                      Minimum to try fast search       BU    94
INTEGER MCNT(3,2)#                     Hit counts for each pass         BU    95
#                                                                       BU    96
REAL G1,G2,G3,G4,G5,G6#                Metric tensor                    BU    97
REAL DISTMX#                           Max distance parameter           BU    98
REAL CNTR(3)#                          Coord centre values              BU    99
REAL RADII(10)#                        Atomic radii                     BU   100
REAL RADINP(10)#                       Atomic radii modified            BU   101
REAL TOLC#                             Tolerance for hit                BU   102
REAL RLAP#                             Peak overlap cutoff              BU   103
REAL MACOR(3),MICOR(3)#                Max/min coords in frac. frag.    BU   104
REAL TM(4)#                            Plane/line normal                BU   105
REAL SIGTM(4)#                         Esd of tm                        BU   106
REAL TR(3,3)#                          Transformation miller-> ortho    BU   107
REAL TF(3,3)#                          Transformation frac-> ortho      BU   108
REAL FT(3,3)#                          Transformation ortho->frac       BU   109
REAL OX(3)#                            Centroid coordinates             BU   110
REAL LIMIT#                            Closeness for line calculation   BU   111
#                                                                       BU   112
dp:  RMET(3,3)#                        Reciprocal metric tensor         BU   113
#                                                                       BU   114
CHARACTER*8 ASITE(100),IGNLAB(100)#                                     BU   115
CHARACTER*8 ATLAB(10),RADLAB(10),ASSAT(10),CPXLAB(100)#                 BU   116
string:(SFTAB,120)#                                                     BU   117
#                                                                       BU   118
COMMON/COMIBU/ MXAD,MARKA,STEPA,STOPA,STOPI,MCNT,#                      BU   119
MARKS,STEPS,STOPS,CLUS,ANUM,MPTS,MARKP,STEPP,STOPP,#                    BU   120
STOPN,INRAD,NTYP,FINAL,TEMPP,STARP,INAT,NCPX,NIGN,#                     BU   121
MARKC,STEPC,STOPC,MARKM,STEPM,STOPM,NCL,LORP,ABORT,INATID,#             BU   122
HIT,ISIT,JCENT,JPLAN,JAXIS,IALL,PSIZ,WROTE,ITEST,DEBUG,#                BU   123
SKIPSTRT#                                                               BU   124
#                                                                       BU   125
COMMON/COMFBU/ DISTMX,CNTR,RADII,RADINP,RLAP,LIMIT,OX,#                 BU   126
G1,G2,G3,G4,G5,G6,MACOR,MICOR,TOLC,TM,SIGTM,TR,TF,FT#                   BU   127
#                                                                       BU   128
COMMON/COMDBU/RMET#                                                     BU   129
#                                                                       BU   130
COMMON/COMCBU/ATLAB,RADLAB,SFTAB,ASSAT,ASITE,CPXLAB,IGNLAB#             BU   131
endext:#                                                                BU   132
#                                                                       BU   133
systemheader:(BU00)#                                                    BU00   1
####################################################################### BU00   2
#                                                                     # BU00   3
#                          BU00                                       # BU00   4
#                                                                     # BU00   5
####################################################################### BU00   6
SUBROUTINE BU00#                       J. hester mar 94                 BU00   7
include:(AACOMN)#                                                       BU00   8
include:(BUCOMN)#                                                       BU00   9
#                                                                       BU00  10
INTEGER IP#                            Qx pointer                       BU00  11
INTEGER I,NDEVPR#                                                       BU00  12
CALL BU10#                             Enter control lines              BU00  13
CALL BU11#                             Enter symmetry & atom data       BU00  14
CALL BU20#                             Generate connected atom list     BU00  15
CALL BU25#                             Create midpoint table            BU00  16
#                                                                       BU00  17
closepch:#                             Close the punch file if open     BU00  18
iopch:=-iopch:;  openpch:#             Open the .pch file               BU00  19
NDEVPR=ioprt:; ioprt:=iopch:#          Pass 1 send printout to .pch     BU00  20
DO ITEST=1,2#                          Apply two sets of tests          BU00  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU00  22
IF(JCENT==yes:) CALL BU30#             Search for inversion centre      BU00  23
IF((MCNT(1,1)<2*ANUM/3)&(MCNT(1,2)<2*ANUM/3))# No search if found       BU00  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU00  25
IF(JAXIS==yes:) CALL BU50#             Search for rotor or screw        BU00  26
IF((MCNT(3,1)<2*ANUM/3)&(MCNT(3,2)<2*ANUM/3))# No search if found       BU00  27
IF(JPLAN==yes:) CALL BU40#             Search for mirror or glide       BU00  28
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU00  29
ioprt:=NDEVPR#                         Reset the printer                BU00  30
closepch:#                             Close the .pch file              BU00  31
IF(FINAL==no:) NEXT#                   Were any full matches found?     BU00  32
IF(JCENT==10) JCENT=yes:#              Redo full matches                BU00  33
ELSE          JCENT=no:#               Ignore partial matches           BU00  34
IF(JAXIS==10) JAXIS=yes:#              Redo full matches                BU00  35
ELSE          JAXIS=no:#               Ignore partial matches           BU00  36
IF(JPLAN==10) JPLAN=yes:#              Redo full matches                BU00  37
ELSE          JPLAN=no:#               Ignore partial matches           BU00  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU00  39
IF(WROTE==yes:)#                       Output file written              BU00  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU00  41
writepkt:(3,endrecord:,3,IP)#          Close output file                BU00  42
readwpkt:(1,endrecord:,I,I,0)#         Finish off file a                BU00  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU00  44
#                                                                       BU00  45
RETURN#                                                                 BU00  46
END#                                                                    BU00  47
#                                                                       BU00  48
systemheader:(BU10)#                   Input line controls              BU10   1
####################################################################### BU10   2
#                                                                     # BU10   3
#                          BU10                                       # BU10   4
#                                                                     # BU10   5
####################################################################### BU10   6
SUBROUTINE BU10#                       J r hester mar 94                BU10   7
include:(AACOMN)#                                                       BU10   8
include:(BUCOMN)#                                                       BU10   9
#                                                                       BU10  10
INTEGER I,J,K#                         Loop indices                     BU10  11
#                                                                       BU10  12
chardata:(BU110, RADII ASSUME ALIGN SEARCH COMPLX REMOVE END )#         BU10  13
chardata:(BU111,INPU MIDP ALLO TOLC CLOS INTR FAST DEBU )#              BU10  14
chardata:(BU112,CENT PLAN AXIS )#                                       BU10  15
datastuff:#                                                             BU10  16
#                                                                       BU10  17
#              SET DEFAULTS                                             BU10  18
#              ------------                                             BU10  19
#                                                                       BU10  20
FINAL=no:#                             Symmetry not found yet           BU10  21
CLUS=yes:#                             Assume input sites clustered     BU10  22
IALL=1#                                Search only between clusters     BU10  23
INRAD=0#                               Number of input radii            BU10  24
INAT=0; ISIT=0#                        Number of atoms assumed          BU10  25
RLAP=0.4#                              Default overlap radius           BU10  26
MXAD=0#                                No atom number tolerance         BU10  27
NCPX=0#                                No of complex connections        BU10  28
NIGN=0#                                No of ignored atoms or types     BU10  29
TOLC=0.5#                              Midpoint coincidence tolerance   BU10  30
LIMIT=0.25#                            Points are too close to distin   BU10  31
MPTS=no:#                              Do not output midpoint table     BU10  32
JCENT=no:; JPLAN=no:; JAXIS=no:#       Reset to no search               BU10  33
WROTE=no:#                             No .bun file opened              BU10  34
SKIPSTRT=10#                           When to fast search              BU10  35
#                                                                       BU10  36
#   PROCESS BUNYIP LINE                                                 BU10  37
#   -------------------                                                 BU10  38
#                                                                       BU10  39
FOR(K=1;K<30;K=K+1)#                   Loop over input fields           BU10  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU10  41
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10  42
stringlim:(K,I,J)#                     Find string limits               BU10  43
compchar:(CHRIN,I,BU111,1,4,5,NBU111,J)# Search for match               BU10  44
IF     (J==0) iquit:(BU1010)#          Unknown option                   BU10  45
ELSE IF(J==1) CLUS=no:#                Use input atom sites             BU10  46
ELSE IF(J==2) MPTS=yes:#               Output midpoint table            BU10  47
ELSE IF(J==3)#                         ******* mismatches ********      BU10  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU10  49
K=K+1#                                 Incr field pointer               BU10  50
IF(BUFIN(K)<0.) iquit:(BU1005)#        Must be positive number          BU10  51
MXAD=NINT(BUFIN(K))#                   Get max difference for compar    BU10  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU10  53
ELSE IF(J==4)#                         ******* tolerance ***********    BU10  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU10  55
K=K+1#                                 Incr field pointer               BU10  56
IF(BUFIN(K)<0.) iquit:(BU1005)#        Must be positive number          BU10  57
TOLC=BUFIN(K)#                         Get max difference for compar    BU10  58
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU10  59
ELSE IF(J==5)#                         ***** closeness ************     BU10  60
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU10  61
K=K+1#                                 Incr field pointer               BU10  62
IF(BUFIN(K)<0.) iquit:(BU1005)#        Must be positive number          BU10  63
LIMIT=BUFIN(K)#                        Closeness limit                  BU10  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU10  65
ELSE IF(J==6) IALL=2#                  ***** intra-mol search******     BU10  66
ELSE IF(J==7)#                         ***** fast search start ****     BU10  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU10  68
K=K+1#                                 Incr field pointer               BU10  69
IF(BUFIN(K)<0.) iquit:(BU1005)#        Must be positive number          BU10  70
SKIPSTRT=BUFIN(K)#                     When to start fast search        BU10  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU10  72
ELSE IF(J==8) DEBUG = 1#               For debug output                 BU10  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU10  74
#                                                                       BU10  75
#     PROCESS INPUT LINE OPTIONS                                        BU10  76
#     --------------------------                                        BU10  77
#                                                                       BU10  78
REPEAT#                                Loop over input lines            BU10  79
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU10  80
readline:(BU110,NBU110)#               Read next input line             BU10  81
#                                                                       BU10  82
IF(LINID==1)#                          *********** set atom radii       BU10  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU10  84
FOR(K=1;K<30;K=K+1)#                   Loop over fields                 BU10  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU10  86
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10  87
IF(BUFIN(K)>voidflg:) iquit:(BU1004)#  Must be alpha code               BU10  88
stringlim:(K,I,J)#                     Find string limits               BU10  89
INRAD=INRAD+1#                         New radii counter                BU10  90
K=K+1; IF(BUFIN(K)<0.) iquit:(BU1006)# Must be numberic value           BU10  91
RADLAB(INRAD)=CHRIN(I^J-1)#            New type of atom                 BU10  92
RADINP(INRAD)=BUFIN(K)#                New radii                        BU10  93
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU10  94
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU10  95
#                                                                       BU10  96
ELSE IF(LINID==2)#                     *********** assume atom types    BU10  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU10  98
FOR(K=1;K<30;K=K+1)#                   Loop over atom types             BU10  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU10 100
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10 101
IF(BUFIN(K)>voidflg:) iquit:(BU1007)#  Must be alpha code               BU10 102
stringlim:(K,I,J)#                     Find string limits               BU10 103
INAT=INAT+1#                           Count matched atom types         BU10 104
ASSAT(INAT)=CHRIN(I^J-1)#              Store atom type                  BU10 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU10 106
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU10 107
#                                                                       BU10 108
ELSE IF(LINID==3)#                     *********** align atom sites     BU10 109
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU10 110
FOR(K=1;K<30;K=K+1)#                   Loop over atom sites             BU10 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU10 112
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10 113
IF(BUFIN(K)>voidflg:) iquit:(BU1008)#  Must be alpha code               BU10 114
stringlim:(K,I,J)#                     Find string limits               BU10 115
ISIT=ISIT+1#                           Count atom sites                 BU10 116
ASITE(ISIT)=CHRIN(I^J-1)#              Store atom label                 BU10 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU10 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU10 119
#                                                                       BU10 120
ELSE IF(LINID==4)#                     *********** search symmetry      BU10 121
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU10 122
FOR(K=1;K<30;K=K+1)#                   Loop over symmetries             BU10 123
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU10 124
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10 125
IF(BUFIN(K)>voidflg:) iquit:(BU1009)#  Must be alpha code               BU10 126
stringlim:(K,I,J)#                     Find string limits               BU10 127
compchar:(CHRIN,I,BU112,1,4,5,NBU112,J)# Search for match               BU10 128
IF     (J==0) iquit:(BU1011)#          Unknown option                   BU10 129
ELSE IF(J==1) JCENT=yes:#              Search for inv centre            BU10 130
ELSE IF(J==2) JPLAN=yes:#              Search for mirror/glide plane    BU10 131
ELSE IF(J==3) JAXIS=yes:#              Search for rotor/screw axis      BU10 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU10 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU10 134
#                                                                       BU10 135
ELSE IF(LINID==5)#                     *********** complx line          BU10 136
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU10 137
FOR(K=1;K<30;K=K+1)#                   Loop over complx labels          BU10 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BU10 139
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10 140
IF(BUFIN(K)>voidflg:) iquit:(PG1015)#  Must be alpha code               BU10 141
stringlim:(K,I,J)#                     Find string limits               BU10 142
NCPX=NCPX+1#                           Count complex labels             BU10 143
CPXLAB(NCPX)=CHRIN(I^J-1)#             Store the label in upper case    BU10 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BU10 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU10 146
#                                                                       BU10 147
ELSE IF(LINID==6)#                     *********** remove line          BU10 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BU10 149
FOR(K=1;K<30;K=K+1)#                   Loop over ignore labels          BU10 150
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BU10 151
ifvo:(BUFIN(K)) BREAK#                 Exit on first void               BU10 152
IF(BUFIN(K)>voidflg:) iquit:(PG1016)#  Must be alpha code               BU10 153
stringlim:(K,I,J)#                     Find string limits               BU10 154
NIGN=NIGN+1#                           Count ignore labels              BU10 155
IGNLAB(NIGN)=CHRIN(I^J-1)#             Store the label in upper case    BU10 156
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BU10 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BU10 158
#                                                                       BU10 159
ELSE BREAK#                            *********** end line             BU10 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU10 161
IF(JCENT+JPLAN+JAXIS==0)#              Test if search requested         BU10 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BU10 163
JCENT=yes:; JPLAN=yes:; JAXIS=yes:#    Reset to search all              BU10 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BU10 165
#                                                                       BU10 166
RETURN#                                                                 BU10 167
END#                                                                    BU10 168
#                                                                       BU10 169
systemheader:(BU11)#                   Input atoms list                 BU11   1
####################################################################### BU11   2
#                                                                     # BU11   3
#                          BU11                                       # BU11   4
#                                                                     # BU11   5
####################################################################### BU11   6
SUBROUTINE BU11#                       J r hester mar 94                BU11   7
include:(AACOMN)#                                                       BU11   8
include:(BUCOMN)#                                                       BU11   9
#                                                                       BU11  10
INTEGER I,J,K,L,N#                     Loop indices                     BU11  11
INTEGER II,IA#                         Working indices                  BU11  12
INTEGER LATYP,NCENT,NOSYM#             Latt, centro, atom & symm cnt.   BU11  13
INTEGER LPAK,IP#                       Pack. size, index                BU11  14
INTEGER IWNT(10)#                      Want list for indexpkt           BU11  15
INTEGER RELPT(11)#                     Returned relative pointers       BU11  16
INTEGER KEY(4)#                        Control functions for aa15       BU11  17
INTEGER NINP#                                                           BU11  18
REAL CDIM(9)#                          Cell a,b,c & cos a b g           BU11  19
REAL A#                                Hydrogen type number             BU11  20
#                                                                       BU11  21
string:(NAME,8); string:(LABL,8)#                                       BU11  22
string:(SGNAME,30)#                                                     BU11  23
chardata:(BU1," BUNYIP ...in search of errant symmetry")#               BU11  24
chardata:(BU2," Known symmetry                                 ")#      BU11  25
chardata:(BU3," Assume valid identification of atom types: ")#          BU11  26
chardata:(BU5," Search applied to nnn atom sites.")#                    BU11  27
chardata:(BU6," Reject mid-points further than nnnA from symmetry$#     BU11  28
 element.")#                                                            BU11  29
chardata:(BU8," Allow n unmatched atom sites before terminating $#      BU11  30
search.")#                                                              BU11  31
chardata:(BU9," Atom sites clustered using atom radii...")#             BU11  32
chardata:(BU10," Start fast searching after nn matches")#               BU11  33
realdata:(CENT,[$#                                                      BU11  34
0.,0.,0.,0.,0.,0.,0.,0.,0.,0.,#        Add for lattice type p           BU11  35
.5,.5,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type i           BU11  36
.333333,.666667,.666667,.666667,.333333,.333333,0.,0.,0.,2.,# Type r    BU11  37
.0,.5,.5,.5,.0,.5,.5,.5,.0,3.,#        Add for lattice type f           BU11  38
.0,.5,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type a           BU11  39
.5,.0,.5,0.,0.,0.,0.,0.,0.,1.,#        Add for lattice type b           BU11  40
.5,.5,.0,0.,0.,0.,0.,0.,0.,1.])#       Add for lattice type c           BU11  41
realdata:(FMC,[220832.,300832.,380832.,460822.,540822.,620822.])#       BU11  42
datastuff:#                                                             BU11  43
#                                                                       BU11  44
#                                                                       BU11  45
#      SET MEMORY FOR IO BUFFERS                                        BU11  46
#      -------------------------                                        BU11  47
#                                                                       BU11  48
FILEXT(IOUNIT(3))='BUN'#               Extension for output file        BU11  49
IOMARK(1)=QXSTR#                       Start of file a buffer           BU11  50
incrqx:(IOMARK(3),QXSTR+bdfbuf:,BU1025)# Expand buffer qx               BU11  51
incrqx:(MARKS,IOMARK(3)+bdfbuf:,BU1025)# Expand buffer qx               BU11  52
readwpkt:(1,1,LPAK,IP,0)#              Force to write list header       BU11  53
#                                                                       BU11  54
#      READ REAL CELL PARAMETERS FROM LRCELL                            BU11  55
#      -------------------------------------                            BU11  56
#                                                                       BU11  57
DO I=1,8#                              Loop over lrcell: packets        BU11  58
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU11  59
readwpkt:(1,lrcell:,LPAK,IP,0)#        Read the next pkt                BU11  60
IF(IP<=0) BREAK#                       End of logical record            BU11  61
#                                                                       BU11  62
IF(I==1) DO L=1,9; CDIM(L)=QX(IP+L)#   Real cell a,b,c & cos a,b,g      BU11  63
#                                                                       BU11  64
IF(I==4)#                              Transform to ortho angs          BU11  65
DO J=1,3; DO K=1,3#                    Col index row index              BU11  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU11  67
II=IP+3*(J-1)+K#                       Pointer to element               BU11  68
TF(K,J)=QX(II)#                        Get element                      BU11  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU11  70
#                                                                       BU11  71
IF(I==7)#                              Test if metric tensor            BU11  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU11  73
G1=QX(IP+1)#                           A**2                             BU11  74
G2=QX(IP+5)#                           B**2                             BU11  75
G3=QX(IP+9)#                           C**2                             BU11  76
G4=QX(IP+2)*2.#                        2 a b cosg                       BU11  77
G5=QX(IP+3)*2.#                        2 a c cosb                       BU11  78
G6=QX(IP+6)*2.#                        2 b c cosa                       BU11  79
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU11  80
#                                                                       BU11  81
IF(I==8) DO J=1,3; DO K=1,3#           Loop over matrix                 BU11  82
RMET(J,K)=sd:(QX(IP+K+(J-1)*3))#       Get recip metric tensor          BU11  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU11  84
##                                                                      BU11  85
##  CALC ORTHOGONAL TRANSF MATRIX (Cart x // cell a)                    BU11  86
##  ------------------------------------------------                    BU11  87
##                                                                      BU11  88
CALL BU12(TF,FT)#                      Calc cart to fract matrix        BU11  89
#                                                                       BU11  90
#      READ SYMMETRY INFORMATION FROM LRSYMM                            BU11  91
#      -------------------------------------                            BU11  92
#                                                                       BU11  93
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read the 1st sym pkt             BU11  94
LATYP=NINT(QX(IP+1))#                  Lattice type                     BU11  95
NCENT=NINT(QX(IP+2))#                  Centric / acentric  0/1          BU11  96
NOSYM=NINT(QX(IP+3))#                  Total no of symm. rel. rot.      BU11  97
incrqx:(MARKA,MARKS+NOSYM*LPAK,BU1028)# Memory for symop table          BU11  98
FOR(J=MARKS;J>0;J=J+LPAK)#             Loop thro. symm. rec.            BU11  99
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU11 100
readwpkt:(1,lrsymm:,LPAK,IP,0)#        Read sym. rel. rotations         BU11 101
IF(IP<=0) BREAK#                       Finished                         BU11 102
movereal:(QX,IP+1,QX,J+1,LPAK,1)#      Store symm. rel. rotations       BU11 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU11 104
STEPS=LPAK#                            Step through sym. rec.           BU11 105
STOPS=J;    IP=STOPS#                  End of sym. rec. read in         BU11 106
IF(LATYP>7) LATYP=LATYP-7#             Reduce to centrosymmetric        BU11 107
IF(LATYP>1)#                           Add symmops if non-primitive     BU11 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU11 109
L =(LATYP-1)*10#                       Start in cent array              BU11 110
N =NINT(CENT(LATYP*10))*3-1#           No. of triples to add            BU11 111
DO K=0,N,3#                            Loop thro. cent array            BU11 112
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop thro. symm. rec.            BU11 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU11 114
movereal:(QX,J+1,QX,IP+1,STEPS,1)#     Rotation matrix equivalent       BU11 115
QX(IP+10)=MOD(QX(IP+10)+CENT(L+K+1),1.)# Add to translation in x        BU11 116
QX(IP+11)=MOD(QX(IP+11)+CENT(L+K+2),1.)# Add to translation in y        BU11 117
QX(IP+12)=MOD(QX(IP+12)+CENT(L+K+3),1.)# Add to translation in z        BU11 118
IP=IP+STEPS#                           Set start of new symm. rec.      BU11 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU11 120
STOPS=IP#                              End of symops.                   BU11 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU11 122
N=STOPS-MARKS+1#                       Number of elements               BU11 123
IF(NCENT==0)#                          In case of centrosymmetry        BU11 124
DO J=1,N; QX(STOPS+J)=-QX(MARKS+J)#    Set centro elements              BU11 125
STOPN=STOPS;  STOPS=MARKA#             End of symops.                   BU11 126
STEPA=9#                               Atom list step size              BU11 127
#                                                                       BU11 128
#      READ SYMMETRY NAME FROM SGNM                                     BU11 129
#      ----------------------------                                     BU11 130
#                                                                       BU11 131
readwpkt:(1,lrsgnm:,LPAK,IP,0)#        Read the 1st sym pkt             BU11 132
movertoc:(QX(IP+1),1,SGNAME,1,30,0)#   Store hall sgname                BU11 133
DO I=1,30; IF(SGNAME(I^I)=='_') SGNAME(I^I)=' '# Replace underline      BU11 134
#                                                                       BU11 135
#        LRSCAT REQUEST ATOM TYPE DATA                                  BU11 136
#        -----------------------------                                  BU11 137
#                                                                       BU11 138
IWNT(1)=5; IWNT(2)=11; IWNT(3)=3#      Bond radius and atom name        BU11 139
KEY(1)=3; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 BU11 140
indexpkt:(1,lrscat:,LPAK,IP,0,KEY,IWNT,RELPT)# Test for wanted items    BU11 141
IF(KEY(4)<=0) iquit:(BU1110)#          Item not found-exit              BU11 142
A=0.;       SFTAB=' '#                 Zero max radius                  BU11 143
DO I=1,16#                             Loop for atom types              BU11 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU11 145
readwpkt:(1,lrscat:,LPAK,IP,0)#        Read atom type param.            BU11 146
IF(IP<=0) BREAK#                       Test for end of types            BU11 147
movertoc:(QX(IP+RELPT(2)),1,NAME,1,8,0)# Extract atom type label        BU11 148
movechar:(NAME,1,SFTAB,I*8-7,8,0)#     Store scat factor table          BU11 149
ATLAB(I)=NAME#                         Store atom label                 BU11 150
RADII(I)=QX(IP+RELPT(1))+0.15#         Store bond radius and incr.      BU11 151
upcase:(NAME,LABL,8)#                  Convert to upper case            BU11 152
DO J=1,INRAD#                          Loop over input radii            BU11 153
IF(RADLAB(J)==LABL) RADII(I)=RADINP(J)# Store input radius              BU11 154
IF(INAT==0&QX(IP+RELPT(3))>1.5)#       If no assumed types entered      BU11 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU11 156
INATID(I)=I; ASSAT(I)=NAME#            Assume atom types correct        BU11 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU11 158
ELSE#                                  Otherwise only entered           BU11 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU11 160
upcase:(NAME,NAME,8)#                  Convert to upper case            BU11 161
DO J=1,INAT#                           Loop over assumed atoms          BU11 162
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU11 163
upcase:(ASSAT(J),LABL,8)#              Convert to upper case            BU11 164
IF(LABL==NAME) INATID(J)=I#            Store atom sequence no           BU11 165
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU11 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU11 167
ifeq:(QX(IP+RELPT(3)),1.0) A=FLOAT(I)# Save hydrogen type number        BU11 168
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU11 169
IF(INAT==0) INAT=(I-1)#                Set inat correctly               BU11 170
NTYP=I-1#                              Store total atom types           BU11 171
#                                                                       BU11 172
#       LRATOM REQUEST ATOMIC PARAMETERS                                BU11 173
#       --------------------------------                                BU11 174
#                                                                       BU11 175
STOPA=MARKA#                           There are no atoms on bdf        BU11 176
IWNT(1)=1;   IWNT(2)=2;   IWNT(3)=3#   X,y,z                            BU11 177
IWNT(4)=22;  IWNT(5)=14#               Atom name (namln: words)         BU11 178
KEY(1)=5; KEY(2)=0; KEY(3)=0; KEY(4)=0# Set search keys                 BU11 179
indexpkt:(1,lratom:,LPAK,IP,0,KEY,IWNT,RELPT)# Test for wanted items    BU11 180
IF(IP>0&KEY(4)>0)#                     If items present extract         BU11 181
FOR(IA=MARKA;IA>0;IA=STOPA)#           Loop thro. atoms                 BU11 182
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU11 183
readwpkt:(1,lratom:,LPAK,IP,0)#        Read atom param.                 BU11 184
IF(IP<=0) BREAK#                       Test for end of atoms            BU11 185
ifeq:(A,QX(IP+RELPT(4))) NEXT#         Skip hydrogens                   BU11 186
movertoc:(QX(IP+RELPT(5)),1,LABL,1,8,1)# Store atom name                BU11 187
upcase:(LABL,LABL,8)#                  Ensure label upper case          BU11 188
label:(LABL,J,K); NAME=LABL(1^K)#      Get the atom type                BU11 189
DO I=1,NIGN#                           Loop over ignored sites          BU11 190
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU11 191
IF(LABL==IGNLAB(I)) BREAK#             Exit if this site ignored        BU11 192
IF(NAME==IGNLAB(I)) BREAK#             Exit if this site ignored        BU11 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU11 194
IF(I<=NIGN) NEXT#                      Skip ignored site                BU11 195
incrqx:(STOPA,IA+STEPA,BU1040)#        Expand qx for one atom           BU11 196
movereal:(QX,IP+RELPT(5),na:,1,2,1)#   Store atom name                  BU11 197
xf:=QX(IP+RELPT(1))#                   Store x frac.                    BU11 198
yf:=QX(IP+RELPT(2))#                   Store y frac.                    BU11 199
zf:=QX(IP+RELPT(3))#                   Store z frac.                    BU11 200
ty:=QX(IP+RELPT(4))#                   Store atom type number           BU11 201
fr:=0.#                                Assume symmetry unknown          BU11 202
bn:=0.#                                Assume type not restricted       BU11 203
cx:=0.#                                Store zero complex connection    BU11 204
DO I=1,ISIT#                           Loop over fixed sites            BU11 205
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU11 206
IF(LABL!=ASITE(I)) NEXT#               Skip if no match                 BU11 207
fr:=1.; BREAK#                         Flag as site on symmetry         BU11 208
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU11 209
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU11 210
readwpkt:(1,endrecord:,I,I,0)#         Finish off file a                BU11 211
NINP=(STOPA-MARKA)/STEPA#              Number of atoms input            BU11 212
IF(NINP==0) iquit:(BU1105)#            No atoms sites to display        BU11 213
#                                                                       BU11 214
#             PRINT BUNYIP PARAMETERS                                   BU11 215
#             -----------------------                                   BU11 216
#                                                                       BU11 217
movechar:('-',1,CHROT,2,NBU1-1,1)#     Put underline into buffer        BU11 218
writeline:(2,BU1,NBU1,2,3)#            Print header                     BU11 219
#                                                                       BU11 220
movechar:(SGNAME,1,BU2,20,30,0)#       Store symmetry                   BU11 221
DO I=1,3; CDIM(I+3)=CDIM(I+6)*360.#    Convert angles to degrees        BU11 222
ncodefld:(CDIM,1,CHROT,FMC,6)#         Encode cell values               BU11 223
writeline:(1,BU2,NBU2,2,3)#            Write rejects header             BU11 224
#                                                                       BU11 225
ncodefld:(TOLC,1,BU6,350422.,1)#       Encode tolerance                 BU11 226
writeline:(1,BU6,NBU6,3,3)#            Write coincidence header         BU11 227
#                                                                       BU11 228
ncodefld:(FLOAT(MXAD),1,BU8,80213.,1)# Encode max rejects               BU11 229
writeline:(1,BU8,NBU8,3,3)#            Write rejects header             BU11 230
#                                                                       BU11 231
ncodefld:(FLOAT(SKIPSTRT),1,BU10,300313.,1)# Encode fast search start   BU11 232
writeline:(1,BU10,NBU10,3,3)#          Write fast search header         BU11 233
#                                                                       BU11 234
CHROT=BU3; K=42#                       Insert atom header               BU11 235
DO J=1,INAT#                                                            BU11 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU11 237
IF(INATID(J)==0) NEXT#                 Skip if not assumed              BU11 238
K=K+4; CHROT(K^K+3)=ASSAT(J)#          Move name to chrot               BU11 239
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU11 240
writeline:(1,0,0,1,3)#                 Output assumed atom id           BU11 241
#                                                                       BU11 242
ncodefld:(FLOAT(NINP),1,BU5,220413.,1)# Number of atoms input           BU11 243
writeline:(1,BU5,NBU5,3,3)#            Write input sites header         BU11 244
#                                                                       BU11 245
writeline:(1,BU9,NBU9,3,3)#            Write radii header               BU11 246
DO J=1,NTYP#                           Loop over input radii            BU11 247
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU11 248
CHROT(5^6)=ATLAB(J)#                   Insert atom type label           BU11 249
ncodefld:(RADII,J,CHROT,200822.,1)#    Format atom radii                BU11 250
writeline:(0,0,0,1,3)#                 Write line                       BU11 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU11 252
#                                                                       BU11 253
RETURN#                                                                 BU11 254
END#                                                                    BU11 255
systemheader:(BU12)#                   Invert a 3x3 matrix              BU12   1
####################################################################### BU12   2
#                                                                     # BU12   3
#                          BU12                                       # BU12   4
#                                                                     # BU12   5
####################################################################### BU12   6
SUBROUTINE BU12(MI,MO)#                                                 BU12   7
include:(AACOMN)#                      S.r. hall  jan 90                BU12   8
include:(BUCOMN)#                      J.c. wasikowski 93               BU12   9
#                                                                       BU12  10
INTEGER I,J#                           Loop variables                   BU12  11
REAL MI(3,3),MO(3,3)#                                                   BU12  12
dp:  DI(3,3),DA(3,3),DD#                                                BU12  13
#                                                                       BU12  14
DO I=1,3; DO J=1,3; DI(I,J)=sd:(MI(I,J))# Store as double precision     BU12  15
DA(1,1)=DI(2,2)*DI(3,3)-DI(2,3)*DI(3,2)# Calculate adjunct              BU12  16
DA(1,2)=DI(1,3)*DI(3,2)-DI(1,2)*DI(3,3)# Calculate adjunct              BU12  17
DA(1,3)=DI(1,2)*DI(2,3)-DI(1,3)*DI(2,2)# Calculate adjunct              BU12  18
DA(2,1)=DI(2,3)*DI(3,1)-DI(2,1)*DI(3,3)# Calculate adjunct              BU12  19
DA(2,2)=DI(1,1)*DI(3,3)-DI(1,3)*DI(3,1)# Calculate adjunct              BU12  20
DA(2,3)=DI(1,3)*DI(2,1)-DI(1,1)*DI(2,3)# Calculate adjunct              BU12  21
DA(3,1)=DI(2,1)*DI(3,2)-DI(3,1)*DI(2,2)# Calculate adjunct              BU12  22
DA(3,2)=DI(1,2)*DI(3,1)-DI(1,1)*DI(3,2)# Calculate adjunct              BU12  23
DA(3,3)=DI(1,1)*DI(2,2)-DI(1,2)*DI(2,1)# Calculate adjunct              BU12  24
DD=DI(1,1)*DA(1,1)+DI(2,1)*DA(1,2)+DI(3,1)*DA(1,3)# Get determinant     BU12  25
DO I=1,3; DO J=1,3; MO(I,J)=ds:(DA(I,J)/DD)# Store as single            BU12  26
RETURN#                                                                 BU12  27
END#                                                                    BU12  28
systemheader:(BU13)#                   Invert a 3x3 dp matrix           BU13   1
####################################################################### BU13   2
#                                                                     # BU13   3
#                          BU13                                       # BU13   4
#                                                                     # BU13   5
####################################################################### BU13   6
SUBROUTINE BU13(DI,DA)#                                                 BU13   7
include:(AACOMN)#                      S.r. hall  jan 90                BU13   8
include:(BUCOMN)#                      J.c. wasikowski 93               BU13   9
#                                                                       BU13  10
INTEGER I,J#                           Loop variables                   BU13  11
dp:  DI(3,3),DA(3,3),DD#                                                BU13  12
#                                                                       BU13  13
DA(1,1)=DI(2,2)*DI(3,3)-DI(2,3)*DI(3,2)# Calculate adjunct              BU13  14
DA(1,2)=DI(1,3)*DI(3,2)-DI(1,2)*DI(3,3)# Calculate adjunct              BU13  15
DA(1,3)=DI(1,2)*DI(2,3)-DI(1,3)*DI(2,2)# Calculate adjunct              BU13  16
DA(2,1)=DI(2,3)*DI(3,1)-DI(2,1)*DI(3,3)# Calculate adjunct              BU13  17
DA(2,2)=DI(1,1)*DI(3,3)-DI(1,3)*DI(3,1)# Calculate adjunct              BU13  18
DA(2,3)=DI(1,3)*DI(2,1)-DI(1,1)*DI(2,3)# Calculate adjunct              BU13  19
DA(3,1)=DI(2,1)*DI(3,2)-DI(3,1)*DI(2,2)# Calculate adjunct              BU13  20
DA(3,2)=DI(1,2)*DI(3,1)-DI(1,1)*DI(3,2)# Calculate adjunct              BU13  21
DA(3,3)=DI(1,1)*DI(2,2)-DI(1,2)*DI(2,1)# Calculate adjunct              BU13  22
DD=DI(1,1)*DA(1,1)+DI(2,1)*DA(1,2)+DI(3,1)*DA(1,3)# Get determinant     BU13  23
DO I=1,3; DO J=1,3; DA(I,J)=DA(I,J)/DD# Store as inverted matrix        BU13  24
RETURN#                                                                 BU13  25
END#                                                                    BU13  26
systemheader:(BU20)#                   Generate atom connections list   BU20   1
####################################################################### BU20   2
#                                                                     # BU20   3
#                          BU20                                       # BU20   4
#                                                                     # BU20   5
####################################################################### BU20   6
SUBROUTINE BU20#                       J.r. hester mar 94               BU20   7
include:(AACOMN)#                                                       BU20   8
include:(BUCOMN)#                                                       BU20   9
#                                                                       BU20  10
INTEGER I,J,K,N#                                                        BU20  11
INTEGER IA,JA,KA,KK,JJ#                                                 BU20  12
INTEGER FNEW#                                                           BU20  13
INTEGER MARKG,STOPG,STEPG#             Temporary qx markers             BU20  14
REAL    X,Y,Z,U,V,W,P,Q,R#                                              BU20  15
REAL    CX,CY,CZ,CN,SN#                                                 BU20  16
REAL    SX,SY,SZ,A,B,C#                                                 BU20  17
REAL    DIST,RAD,D#                                                     BU20  18
REAL    CP(3),SP(3)#                                                    BU20  19
REAL    DD,UU,VV,WW#                                                    BU20  20
#                                                                       BU20  21
string:(NAME,8)#                                                        BU20  22
chardata:(BU101,' Sites have been clustered into n group(s)')#          BU20  23
chardata:(BU102,' Group           x/a      y/b      z/c')#              BU20  24
chardata:(BU103,' Input sites are in n group(s)')#                      BU20  25
realdata:(FMT,[220752.,310752.,400752.])#                               BU20  26
datastuff:#                                                             BU20  27
#                                                                       BU20  28
#    STORE POINTERS OF SITES CONNECTING A COMPLEX                       BU20  29
#    --------------------------------------------                       BU20  30
#                                                                       BU20  31
IF(NCPX>0)#                            If complex labels entered        BU20  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU20  33
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Loop over input atoms            BU20  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU20  35
IF(cx:(JA)>0.1) NEXT#                  Complex already flagged          BU20  36
movertoc:(na:(JA),1,NAME,1,8,1)#       Stom label                       BU20  37
upcase:(NAME,NAME,8)#                  Store upper case atom label      BU20  38
DO I=1,NCPX; IF(NAME==CPXLAB(I)) BREAK# Loop over the complex labels    BU20  39
IF(MOD(I,2)==0) J=I-1#                 Get the partner label            BU20  40
ELSE            J=I+1#                 Get the partner label            BU20  41
IF(I>NCPX) NEXT#                       Skip if no match                 BU20  42
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over input atoms            BU20  43
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU20  44
IF(cx:>0.1\IA==JA) NEXT#               Complex already flagged          BU20  45
movertoc:(na:,1,NAME,1,8,1)#           Stom label                       BU20  46
upcase:(NAME,NAME,8)#                  Store upper case atom label      BU20  47
IF(NAME!=CPXLAB(J)) NEXT#              Skip if no match                 BU20  48
cx:=FLOAT(JA);  cx:(JA)=FLOAT(IA)#     Flag connections                 BU20  49
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU20  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU20  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU20  52
#                                                                       BU20  53
#    PLACE SITES IN CLUSTERS ABOUT THE BODY CENTRE                      BU20  54
#    ---------------------------------------------                      BU20  55
#                                                                       BU20  56
NCL=0;     STOPI=STOPA#                Zero cluster counter             BU20  57
###IF(CLUS==yes:)#                        If the sites are clustered    BU20  58
###$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> BU20  59
IF(CLUS==no:) STOPS=MARKS+STEPS#       Do not apply symops              BU20  60
REPEAT#                                Loop until all atoms clustered   BU20  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU20  62
DIST=9999999.;   FNEW=yes:#            Set starting distance            BU20  63
#                                                                       BU20  64
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Loop over input atoms            BU20  65
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU20  66
IF(bn:(JA)>0.) NEXT#                   Skip if already positioned       BU20  67
A=xf:(JA);  B=yf:(JA);  C=zf:(JA)#     Store coordinates                BU20  68
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 BU20  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU20  70
X=A*QX(J+1)+B*QX(J+4)+C*QX(J+7)+QX(J+10)# Get symoped x                 BU20  71
Y=A*QX(J+2)+B*QX(J+5)+C*QX(J+8)+QX(J+11)# Get symoped y                 BU20  72
Z=A*QX(J+3)+B*QX(J+6)+C*QX(J+9)+QX(J+12)# Get symoped z                 BU20  73
U=MOD(99.+X,1.0)-0.5#                  Get closest to body centre       BU20  74
V=MOD(99.+Y,1.0)-0.5#                  Get closest to body centre       BU20  75
W=MOD(99.+Z,1.0)-0.5#                  Get closest to body centre       BU20  76
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       BU20  77
IF(D>=DIST) NEXT#                      New eq. pos. closer to center    BU20  78
P=U+.5;  Q=V+.5;  R=W+.5#              Store coordinates                BU20  79
DIST=D-0.01;   IA=JA#                  Store dist. to cell center       BU20  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU20  81
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU20  82
IF(DIST>9999998.) BREAK#               Exit if all clustered            BU20  83
#                                                                       BU20  84
NCL=NCL+1;      bn:=FLOAT(NCL)#        Counter for cluster              BU20  85
xf:=P;  yf:=Q;  zf:=R#                 Store new atom coords            BU20  86
#                                                                       BU20  87
WHILE(FNEW==yes:)#                     Loop over all connected atoms    BU20  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU20  89
FNEW=no:#                              Assume no connections            BU20  90
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Loop over input atoms            BU20  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU20  92
ifne:(bn:(JA),bn:) NEXT#               Process only new bonded atoms    BU20  93
RAD=RADII(NINT(ty:(JA)))#              Bond radius                      BU20  94
P=xf:(JA);  Q=yf:(JA);  R=zf:(JA)#     Store current x,y,z              BU20  95
JJ=NINT(cx:(JA))#                      Extract complex number           BU20  96
#                                                                       BU20  97
FOR(KA=MARKA;KA<STOPA;KA=KA+STEPA)#    Loop over input atoms            BU20  98
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU20  99
ifne:(bn:(KA),0.) NEXT#                Skip if atom already bonded      BU20 100
KK=NINT(cx:(KA));  DD=99999.#          Extract complex number           BU20 101
IF(JJ==KA&KK==JA) DIST=-9999.#         Force complexed connection       BU20 102
ELSE DIST=(RAD+RADII(NINT(ty:(KA))))**2# Get max distance squared       BU20 103
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 BU20 104
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU20 105
X=xf:(KA)*QX(J+1)+yf:(KA)*QX(J+4)+zf:(KA)*QX(J+7)+QX(J+10)# Get x       BU20 106
Y=xf:(KA)*QX(J+2)+yf:(KA)*QX(J+5)+zf:(KA)*QX(J+8)+QX(J+11)# Get y       BU20 107
Z=xf:(KA)*QX(J+3)+yf:(KA)*QX(J+6)+zf:(KA)*QX(J+9)+QX(J+12)# Get x       BU20 108
U=MOD(99.5+X-P,1.0)-0.5#               Get closest to bonded atom       BU20 109
V=MOD(99.5+Y-Q,1.0)-0.5#               Get closest to bonded atom       BU20 110
W=MOD(99.5+Z-R,1.0)-0.5#               Get closest to bonded atom       BU20 111
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       BU20 112
IF(D<DIST) GOTO 100#                   Contact found so exit            BU20 113
IF(DIST>0.\D>=DD) NEXT#                For complexed sites              BU20 114
DD=D; UU=U; VV=V; WW=W#                Save the closest fit             BU20 115
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU20 116
IF(DIST>0.) NEXT#                      For non complexed sites          BU20 117
cx:(JA)=0.; cx:(KA)=0.#                Cancel this connection           BU20 118
U=UU; V=VV; W=WW; GOTO 100#            Store the closest fit            BU20 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU20 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU20 121
NEXT#                                  Connect not found                BU20 122
100 FNEW=yes:;    bn:(KA)=bn:#         New bonded atom                  BU20 123
xf:(KA)=P+U; yf:(KA)=Q+V; zf:(KA)=R+W# Store new coordinates            BU20 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU20 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU20 126
#                                                                       BU20 127
#    PACK CLUSTERS CLOSE TOGETHER                                       BU20 128
#    ----------------------------                                       BU20 129
#                                                                       BU20 130
DO I=1,3; CP(I)=0.;   CN=0.#           Zero total coord sums            BU20 131
CX=0.;   CY=0.;   CZ=0.#               Zero centroids                   BU20 132
DO N=1,NCL#                            Loop over clusters               BU20 133
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU20 134
IF(CN>1.)#                             Calc centroid of all sites       BU20 135
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU20 136
CX=CP(1)/CN; CY=CP(2)/CN; CZ=CP(3)/CN# Centre of all clusters           BU20 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU20 138
DO I=1,3; SP(I)=0;   SN=0.#            Zero coord sums                  BU20 139
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over input atoms            BU20 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU20 141
IF(NINT(bn:)!=N) NEXT#                 Atom member of cur. cluster      BU20 142
DO I=1,3; SP(I)=SP(I)+QX(IA+I+2)#      Sum all coords                   BU20 143
DO I=1,3; CP(I)=CP(I)+QX(IA+I+2)#      Sum all coords                   BU20 144
SN=SN+1.;  CN=CN+1.;  bn:=-bn:#        Sum members and reset cluster    BU20 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU20 146
DO I=1,3; SP(I)=SP(I)/SN#              Calc cluster centre              BU20 147
IF(N==1) NEXT#                         This is the first cluster        BU20 148
DIST=999999.#                          Set starting distance            BU20 149
FOR(J=MARKS;J<STOPS;J=J+STEPS)#        Loop over symops                 BU20 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU20 151
X=QX(J+1)*SP(1)+QX(J+4)*SP(2)+QX(J+7)*SP(3)+QX(J+10)# Get centre x      BU20 152
Y=QX(J+2)*SP(1)+QX(J+5)*SP(2)+QX(J+8)*SP(3)+QX(J+11)# Get centre y      BU20 153
Z=QX(J+3)*SP(1)+QX(J+6)*SP(2)+QX(J+9)*SP(3)+QX(J+12)# Get centre z      BU20 154
P=X-CX;  Q=Y-CY;  R=Z-CZ#              Get diff with centre 1           BU20 155
U=MOD(99.5+P,1.)-0.5#                  Get smallest difference          BU20 156
V=MOD(99.5+Q,1.)-0.5#                  Get smallest difference          BU20 157
W=MOD(99.5+R,1.)-0.5#                  Get smallest difference          BU20 158
D=G1*U*U+G2*V*V+G3*W*W+G4*U*V+G5*U*W+G6*V*W# Get distance squared       BU20 159
IF(D>=DIST) NEXT#                      Skip if larger                   BU20 160
SX=U-P; SY=V-Q; SZ=W-R; K=J;  DIST=D-0.01# Closest to centre 1          BU20 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU20 162
#                                                                       BU20 163
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over input atoms            BU20 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU20 165
IF(NINT(-bn:)!=N) NEXT#                Select atom from this cluster    BU20 166
X=xf:*QX(K+1)+yf:*QX(K+4)+zf:*QX(K+7)+QX(K+10)# Get symoped x           BU20 167
Y=xf:*QX(K+2)+yf:*QX(K+5)+zf:*QX(K+8)+QX(K+11)# Get symoped y           BU20 168
Z=xf:*QX(K+3)+yf:*QX(K+6)+zf:*QX(K+9)+QX(K+12)# Get symoped z           BU20 169
xf:=X+SX;  yf:=Y+SY;  zf:=Z+SZ#        Store new atom coords            BU20 170
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU20 171
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU20 172
#                                                                       BU20 173
#    ENSURE CENTRE OF PACKED CLUSTERS INSIDE CELL                       BU20 174
#    --------------------------------------------                       BU20 175
#                                                                       BU20 176
DO I=1,3; SP(3)=0.;    CN=0.#          Set centre sums to zero          BU20 177
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over all sites              BU20 178
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BU20 179
CN=CN+1.#                              Count contributions              BU20 180
DO I=1,3; SP(I)=SP(I)+QX(IA+I+2)#      Sum all coords                   BU20 181
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BU20 182
DO I=1,3#                              Loop over coords                 BU20 183
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BU20 184
SP(I)=SP(I)/CN#                        Get average coord                BU20 185
IF     (SP(I)<0.) CP(I)=+1.#           Centre out of cell               BU20 186
ELSE IF(SP(I)>1.) CP(I)=-1.#           Centre out of cell               BU20 187
ELSE              CP(I)= 0.#           Centre in cell                   BU20 188
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BU20 189
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over all sites              BU20 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BU20 191
DO I=1,3; QX(IA+I+2)=QX(IA+I+2)+CP(I)# Move to new centre               BU20 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BU20 193
###$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< BU20 194
###ELSE#                                  Input sites applied           BU20 195
###$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> BU20 196
###NCL=1#                                 Assume one cluster            BU20 197
###FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over current atom list   BU20 198
###bn:=1.#                                Set all as cluster 1          BU20 199
###$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< BU20 200
#                                                                       BU20 201
#     SORT AND STORE CLUSTER INFORMATION                                BU20 202
#     ----------------------------------                                BU20 203
#                                                                       BU20 204
#  INFORMATION STORED FROM MARKC TO STOPC                               BU20 205
#  +1: NO OF ATOMS                                                      BU20 206
#  +2: CLUSTER START IN MARKG ARRAY                                     BU20 207
#  INFORMATION STORED IN MARKG                                          BU20 208
#                                                                       BU20 209
STOPC=STOPA; MARKC=STOPA; STEPC=2#     Initialise pointers              BU20 210
incrqx:(STOPC,STOPC+STEPC*NCL,BU2005)# Incr. qx to store cluster inf.   BU20 211
STOPG=STOPC; MARKG=STOPC; STEPG=STEPA# Initialise pointers              BU20 212
DO N=1,NCL#                            Loop over clusters               BU20 213
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BU20 214
CN=0#                                  Initialise counter               BU20 215
QX(MARKC+((N-1)*STEPC)+2)=STOPG-(MARKG-MARKA)# Group will start here    BU20 216
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over input atoms            BU20 217
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BU20 218
IF(ABS(NINT(bn:))!=N) NEXT#            Atom member of cur. cluster      BU20 219
CN=CN+1.#                              Sum members                      BU20 220
incrqx:(STOPG,STOPG+STEPG,BU2005)#     Incr. qx to store atom inf.      BU20 221
movereal:(QX,IA+1,QX,STOPG-STEPG+1,STEPG,1)# Transfer atom              BU20 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BU20 223
QX(MARKC+(STEPC*(N-1))+1)=CN#          Store number of members          BU20 224
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BU20 225
movereal:(QX,MARKG+1,QX,MARKA+1,STOPG-MARKG,1)# Transfer sorted info    BU20 226
#                                                                       BU20 227
#     TELL USER CLUSTERING INFORMATION                                  BU20 228
#     --------------------------------                                  BU20 229
#                                                                       BU20 230
LINRM=5; D=0.#                         Ensure sufficient space          BU20 231
ncodefld:(FLOAT(NCL),1,BU101,330213.,1)# Number groups                  BU20 232
ncodefld:(FLOAT(NCL),1,BU103,210213.,1)# Number groups                  BU20 233
IF(CLUS==yes:) writeline:(1,BU101,NBU101,3,3)# Print cluster groups     BU20 234
ELSE           writeline:(1,BU103,NBU103,3,3)# Print input groups       BU20 235
FOR(JA=1;JA<=NCL;JA=JA+1)#             Loop over groups                 BU20 236
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BU20 237
ncodefld:(FLOAT(JA),1,BU102,90313.,1)# Format group number              BU20 238
LINRM=3#                               Ensure sufficient space          BU20 239
writeline:(1,BU102,NBU102,3,3)#        Write header                     BU20 240
MARKG=QX(MARKC+((JA-1)*STEPC)+2)#      Get group beginning              BU20 241
FOR(IA=MARKG;IA<STOPA;IA=IA+STEPA)#    Loop over atom table             BU20 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BU20 243
IF(ABS(NINT(bn:))!=JA) BREAK#          Select only those in group       BU20 244
movertoc:(na:,1,CHROT,7,8,0)#          Insert atom name                 BU20 245
D=D+1.; ncodefld:(D,1,CHROT,40313.,1)# Format site number               BU20 246
ncodefld:(QX,IA+3,CHROT,FMT,3)#        Format coords                    BU20 247
writeline:(0,0,0,1,3)#                 Print atom                       BU20 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BU20 249
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BU20 250
ANUM=(STOPA-MARKA)/STEPA#              Total number of atoms            BU20 251
#                                                                       BU20 252
RETURN#                                                                 BU20 253
END#                                                                    BU20 254
#                                                                       BU20 255
systemheader:(BU25)#                   Create midpoint table.           BU25   1
####################################################################### BU25   2
#                                                                     # BU25   3
#                                BU25                                 # BU25   4
#                                                                     # BU25   5
####################################################################### BU25   6
SUBROUTINE BU25#                       J.r. hester                      BU25   7
#                                                                       BU25   8
include:(AACOMN)#                                                       BU25   9
include:(BUCOMN)#                                                       BU25  10
#                                                                       BU25  11
INTEGER I,J,K,N,IA,JA,MA#                                               BU25  12
chardata:(BU252,' ***** Matrix of mid-points as x/a y/b z/c *****')#    BU25  13
chardata:(BU253,' Midpoints for       ')#                               BU25  14
realdata:(FMT,[120842.,190742.,260742.,360842.,#                        BU25  15
430742.,500742.,600842.,670742.,740742.])#                              BU25  16
datastuff:#                                                             BU25  17
#                                                                       BU25  18
#                                                                       BU25  19
#     CALCULATE MIDPOINTS                                               BU25  20
#     -------------------                                               BU25  21
#                                                                       BU25  22
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA) bn:=ABS(bn:)# Make all positive      BU25  23
MARKM=STOPA; STOPM=MARKM; STEPM=ANUM*3# Initial parameters              BU25  24
incrqx:(STOPM,STOPM+STEPM*ANUM,BU2005)# Request table memory            BU25  25
MA=MARKM#                              Midpoint list marker             BU25  26
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Go over all atoms in list        BU25  27
FOR(JA=MARKA;JA<STOPA;JA=JA+STEPA)#    Go over all atoms in list        BU25  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU25  29
DO I=1,3#                                                               BU25  30
QX(MA+I)=(QX(IA+2+I)+QX(JA+2+I))/2.#   Calculate midpoint               BU25  31
MA=MA+3#                               Update marker                    BU25  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU25  33
STOPM=MA#                              End of table                     BU25  34
#                                                                       BU25  35
#     PRINT TABLE IF REQUESTED                                          BU25  36
#     ------------------------                                          BU25  37
#                                                                       BU25  38
IF(NCL==1) IALL=2#                     If 1 mol search all sites        BU25  39
IF(MPTS==yes:)#                        Print midpoint table             BU25  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU25  41
LINRM=5#                               Get enough room                  BU25  42
writeline:(2,BU252,NBU252,2,3)#        Print the matrix header          BU25  43
DO I=1,ANUM#                           Loop over columns                BU25  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU25  45
IA=MARKA+(I-1)*STEPA#                  Point to atom info               BU25  46
IF(IALL==1&NINT(bn:)==NCL) NEXT#       Only unique points               BU25  47
ncodefld:(FLOAT(I),1,BU253,180313.,1)# Encode column number             BU25  48
writeline:(0,BU253,NBU253,3,3)#        Output column number             BU25  49
FOR(J=I;J<=ANUM;J=J+1)#                Loop midpoints                   BU25  50
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU25  51
JA=MARKA+(J-1)*STEPA#                  Point to atom info               BU25  52
IF(IALL==1&bn:==bn:(JA)) NEXT#         Skip inelligible midpoints       BU25  53
IF((ANUM-J)>2) K=9#                    Full column                      BU25  54
ELSE           K=((ANUM-J)+1)*3#       Number to encode                 BU25  55
N=MARKM+(I-1)*STEPM+(J-1)*3#           Calculate table position         BU25  56
ncodefld:(FLOAT(J),1,CHROT,40313.,1)#  Encode current number            BU25  57
ncodefld:(QX,N+1,CHROT,FMT,K)#         Encode table                     BU25  58
writeline:(0,0,0,1,3)#                 Output column number             BU25  59
J=J+2#                                 Three values printed             BU25  60
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU25  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU25  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU25  63
#                                                                       BU25  64
#    PREPARE SEARCH CONSTRAINTS                                         BU25  65
#    --------------------------                                         BU25  66
#                                                                       BU25  67
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              BU25  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU25  69
DO J=1,INAT#                           Loop over accepted atom types    BU25  70
ifeq:(FLOAT(INATID(J)),ty:) BREAK#     Exit if type is fixed            BU25  71
IF(J>INAT) ty:=0.#                     Set an arbitrary                 BU25  72
IF(IALL==2) bn:=FLOAT(IA)#             Assign all sites diff cluster    BU25  73
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU25  74
DO I=1,3; DO J=1,2; MCNT(I,J)=0#       Reset mode hit counts            BU25  75
#                                                                       BU25  76
RETURN#                                                                 BU25  77
END#                                                                    BU25  78
#                                                                       BU25  79
systemheader:(BU30)#                   Search for inversion centre      BU30   1
################################################################        BU30   2
##                                                                      BU30   3
##                           BU30                                       BU30   4
##                                                                      BU30   5
################################################################        BU30   6
SUBROUTINE BU30#                                                        BU30   7
#                                                                       BU30   8
include:(AACOMN)#                                                       BU30   9
include:(BUCOMN)#                                                       BU30  10
#                                                                       BU30  11
INTEGER I,J,K,L,N#                     Loop variables                   BU30  12
INTEGER II,JJ,LL#                      More loop variables              BU30  13
INTEGER IP#                            Qx pointer                       BU30  14
INTEGER IS#                            Symmetry loop counter            BU30  15
INTEGER IA,JA,LA#                      Array markers                    BU30  16
INTEGER INCL,NHIT#                     Count hits                       BU30  17
INTEGER BAD,MINROW#                    Progress markers                 BU30  18
INTEGER STARTL,STARTJ#                 Beginning row and column         BU30  19
INTEGER CENTRE,ISET#                   Flag point found                 BU30  20
INTEGER MODEC#                                                          BU30  21
REAL U(3)#                             Temporary coordinates            BU30  22
REAL AVE(3),DEV(3),AVEDEV,DEVDEV#      Average, deviation               BU30  23
REAL ROWDIS#                           Minimum distance squared         BU30  24
REAL MINMPT(3)#                        Mdpt for minimum                 BU30  25
REAL MPT(3),XYZJ(3)#                   Midpoint                         BU30  26
REAL BADFLG,D,A,DMX2#                  Translation along axis           BU30  27
#                                                                       BU30  28
realdata:(FMT,[281042.,381042.,481042.,581042.])# Output format         BU30  29
realdata:(FMT1,[310512.,380512.,450512.])# Encode points                BU30  30
chardata:(BU300,' ***** Centre found for ALL atom sites *****')#        BU30  31
chardata:(BU301,' ***** Centre found for nn out of nn sites *****')#    BU30  32
chardata:(BU302,"                        x/a       y/b    $#            BU30  33
   z/c       dev(A)")#                                                  BU30  34
chardata:(BU303,"             mean:")#                                  BU30  35
chardata:(BU304,"              esd:")#                                  BU30  36
chardata:(BU305," None found")#                                         BU30  37
chardata:(BU306," Search for inversion centre")#                        BU30  38
chardata:(BU307,"    Possible inversion at  xxxxa  xxxxb  xxxxc")#      BU30  39
string:(MPTNME,24)#                                                     BU30  40
datastuff:#                                                             BU30  41
#                                                                       BU30  42
#     INITIALISE                                                        BU30  43
#     ----------                                                        BU30  44
#                                                                       BU30  45
movechar:('-',1,CHROT,2,NBU306-1,2)#   Insert header underline          BU30  46
writeline:(2,BU306,NBU306,2,3)#        Print start of search            BU30  47
ISET=MIN(ANUM-1,MAX(2*ANUM/3,10))#     Define incr changeover           BU30  48
DMX2=TOLC**2#                          Set square of max dist           BU30  49
STEPP=9#                               Storage for best chains          BU30  50
MARKP=STOPM; STARP=MARKP; TEMPP=STARP# Initialise current chain ptr     BU30  51
incrqx:(STOPP,MARKP+ANUM*STEPP,BU3005)# Make room for working chains    BU30  52
IF(ITEST==1) MODEC=IALL#               Set initial mode                 BU30  53
ELSE#                                  For last pass choose the best    BU30  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU30  55
IF(MCNT(1,1)>=MCNT(1,2)) MODEC=1#      Pick the most successful mode    BU30  56
ELSE                     MODEC=2#      Pick the most successful mode    BU30  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU30  58
#                                                                       BU30  59
#                                                                       BU30  60
#    LOOP OVER INTER OR INTRA CLUSTER SEARCHES                          BU30  61
#    -----------------------------------------                          BU30  62
#                                                                       BU30  63
REPEAT#                                Loop over inter and intra mode   BU30  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU30  65
#                                                                       BU30  66
#                                                                       BU30  67
#    LOOP NON-INVERSION SYMMETRY OPERATIONS                             BU30  68
#    --------------------------------------                             BU30  69
#                                                                       BU30  70
DO IS=MARKS,STOPN,STEPS#               Loop over symmetry operations    BU30  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU30  72
#                                                                       BU30  73
INCL=1;  STARTJ=1;  STARTL=1#          Initialise start of search       BU30  74
BAD=0;  BADFLG=1.;  N=PPRIOR#          Initialise number of rejects     BU30  75
DO I=1,ANUM; HIT(I)=no:#               Reset matched flags              BU30  76
CENTRE=no:#                            No centre found                  BU30  77
TEMPP=STARP#                           Chain back to beginning          BU30  78
#                                                                       BU30  79
IF(N>3\DEBUG==1) WRITE(6,1000)#                                         BU30  80
1000 FORMAT(' Next symmetry operation....')#                            BU30  81
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              BU30  82
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU30  83
IF(fr:<0.5) NEXT#                      Test if site at inversion        BU30  84
CENTRE=yes:#                           Signal that centre is known      BU30  85
I=(IA-MARKA)/STEPA+1#                  Get the atom number              BU30  86
J=MARKM+(I-1)*STEPM+(I-1)*3#           Point to midpoint table          BU30  87
QX(TEMPP+1)=QX(J+1)#                   Store midpoint x                 BU30  88
QX(TEMPP+2)=QX(J+2)#                   Store midpoint y                 BU30  89
QX(TEMPP+3)=QX(J+3)#                   Store midpoint z                 BU30  90
QX(TEMPP+4)=FLOAT(I)#                  Site row number l                BU30  91
QX(TEMPP+5)=FLOAT(I)#                  Site column number j             BU30  92
QX(TEMPP+6)=0.#                        First deviation                  BU30  93
QX(TEMPP+7)=FLOAT(CENTRE)#             Save the centre status           BU30  94
QX(TEMPP+8)=FLOAT(BAD)#                Save the bad count               BU30  95
DO K=1,3; AVE(K)=QX(J+K)#              Store initial inv centre         BU30  96
TEMPP=TEMPP+STEPP#                     Update chain pointer             BU30  97
HIT(I)=yes:#                           Flag this as matched             BU30  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU30  99
#                                                                       BU30 100
#                                                                       BU30 101
#     START SEARCH LOOP                                                 BU30 102
#     -----------------                                                 BU30 103
#                                                                       BU30 104
REPEAT#                                Loop over possible solutions     BU30 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU30 106
#                                                                       BU30 107
#    LOOP OVER MID-POINT MATRIX                                         BU30 108
#    --------------------------                                         BU30 109
#                                                                       BU30 110
DO J=STARTJ,ANUM#                      Loop over columns                BU30 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU30 112
IF(N>3)WRITE(6,1010) J,STARTJ,STARTL,HIT(J),BAD,CENTRE#                 BU30 113
1010 FORMAT(' J  ',8I5)#                                                BU30 114
IF(HIT(J)==no:)#                       Look for match                   BU30 115
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU30 116
ROWDIS=99999.#                         Initialise min distance          BU30 117
JA=MARKA+(J-1)*STEPA#                  Point to atom info               BU30 118
DO I=1,3#                                                               BU30 119
XYZJ(I)=QX(JA+3)*QX(IS+  I)$#          Symoped site j                   BU30 120
       +QX(JA+4)*QX(IS+3+I)$#          Symoped site j                   BU30 121
       +QX(JA+5)*QX(IS+6+I)$#          Symoped site j                   BU30 122
                +QX(IS+9+I)#           Add the translation              BU30 123
#                                                                       BU30 124
DO L=STARTL     ,ANUM#                 Loop over rows                   BU30 125
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU30 126
IF(N>3)WRITE(6,1020) L,STARTJ,STARTL,HIT(L),BAD,CENTRE#                 BU30 127
1020 FORMAT('   L',8I5)#                                                BU30 128
IF(HIT(L)==yes:) NEXT#                 Skip if already matched          BU30 129
IF((L==J) & (IS!=MARKS)) NEXT#         No self--comparison after sym    BU30 130
LA=MARKA+(L-1)*STEPA#                  Point to atom info               BU30 131
IF(MODEC==1)#                          If inter mode                    BU30 132
ifeq:(bn:(JA),bn:(LA)) NEXT#           Check on molecular cluster       BU30 133
ifne:(ty:(JA),ty:(LA)) NEXT#           Skip if no match                 BU30 134
#$)#                                                                    BU30 135
#                                                                       BU30 136
#                                                                       BU30 137
#   CALCULATE MIDPOINT                                                  BU30 138
#   ------------------                                                  BU30 139
#                                                                       BU30 140
DO I=1,3;MPT(I)=(XYZJ(I)+QX(LA+2+I))/2.# Calculate midpoint             BU30 141
#                                                                       BU30 142
D=0.#                                  Reset distance value             BU30 143
IF(CENTRE==no:)#                       Centre unknown, take this mpt    BU30 144
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU30 145
DO I=1,3; MINMPT(I)=MPT(I)#            Store initial inv centre         BU30 146
IF(N>3)WRITE(6,1030) J,L,MINMPT#                                        BU30 147
1030 FORMAT(' STA',2I5,4F8.4)#                                          BU30 148
CENTRE=yes:;   BREAK#                  Assume this is the centre        BU30 149
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU30 150
#                                                                       BU30 151
ELSE#                                  Centre known, test this mpt      BU30 152
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU30 153
DO I=1,3; U(I)=diff:(MPT(I),AVE(I))#   Closest points                   BU30 154
D=G1*U(1)**2+G2*U(2)**2+G3*U(3)**2$#   Get distance squared             BU30 155
 +G4*U(1)*U(2)+G5*U(1)*U(3)+G6*U(2)*U(3)# Get distance squared          BU30 156
IF(ABS(D)>ROWDIS) NEXT#                Save the best fit in the row     BU30 157
MINROW=L; ROWDIS=ABS(D)#               Save min dev and translation     BU30 158
DO I=1,3; MINMPT(I)=U(I)+AVE(I)#       Remember midpoint value          BU30 159
IF(ABS(D)<=DMX2) BREAK#                Take first reasonable match      BU30 160
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU30 161
#-------- END OF ROW (L) LOOP                                           BU30 162
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU30 163
#                                                                       BU30 164
IF(ROWDIS<9999)#                       Only if match found              BU30 165
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU30 166
L=MINROW;  BADFLG=1.#                  Get the current row number       BU30 167
IF(ROWDIS>DMX2)#                       Bad if dev outside limit         BU30 168
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU30 169
BAD=BAD+1; IF(BAD>MXAD) BREAK#         Count bad matches                BU30 170
BADFLG=-1.#                            This is a bad guy                BU30 171
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU30 172
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU30 173
IF((ROWDIS<9999.)\(L<=ANUM))#                                           BU30 174
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU30 175
QX(TEMPP+1)=MINMPT(1)#                 Midpt x in orthogonal anstr      BU30 176
QX(TEMPP+2)=MINMPT(2)#                 Midpt y in orthogonal anstr      BU30 177
QX(TEMPP+3)=MINMPT(3)#                 Midpt z in orthogonal anstr      BU30 178
QX(TEMPP+4)=FLOAT(L)#                  Store row                        BU30 179
QX(TEMPP+5)=FLOAT(J)#                  Store column                     BU30 180
QX(TEMPP+6)=BADFLG#                    Flag the bad matches             BU30 181
QX(TEMPP+7)=FLOAT(CENTRE)#             Save the centre status           BU30 182
QX(TEMPP+8)=FLOAT(BAD)#                Save the bad count               BU30 183
QX(TEMPP+9)=FLOAT(IS)#                 Symmetry operation               BU30 184
TEMPP=TEMPP+STEPP#                     Include in chain                 BU30 185
HIT(J)=yes:;  HIT(L)=yes:#             Flag as matched                  BU30 186
#                                                                       BU30 187
DO I=1,3;  AVE(I)=0.#                  Reinitialise averages            BU30 188
FOR(K=STARP;K<TEMPP;K=K+STEPP)#        Loop over points                 BU30 189
DO I=1,3;  AVE(I)=AVE(I)+QX(K+I)#      Accumulate centre coords         BU30 190
DO I=1,3;  AVE(I)=AVE(I)/FLOAT((TEMPP-STARP)/STEPP)# Average coords     BU30 191
IF(N>3\DEBUG==1)WRITE(6,1040) J,L,ROWDIS,DMX2,AVE#                      BU30 192
1040 FORMAT(' ADD',2I5,F10.3,6F8.3)#                                    BU30 193
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU30 194
#                                                                       BU30 195
IF(L>ANUM) BREAK#                      The site is unassigned           BU30 196
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU30 197
STARTL=J+1#                            Next starting row                BU30 198
#                                                                       BU30 199
#----------- END OF COLUMN (J) LOOP                                     BU30 200
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU30 201
#                                                                       BU30 202
#    CHAIN TERMINATED                                                   BU30 203
#    ----------------                                                   BU30 204
#                                                                       BU30 205
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU30 206
IF((L>ANUM&(J==1\J==ANUM))\J>ANUM\K>=ISET)# Is search complete          BU30 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU30 208
IF(N>3\DEBUG==1)WRITE(6,1050) J,L,K,ISET,ROWDIS,DMX2#                   BU30 209
1050 FORMAT(' I=0',4I5,2F10.3)#                                         BU30 210
IF(INCL==0\K==ANUM) BREAK#             No options left                  BU30 211
INCL=0; STARTJ=1; STARTL=1#            Reset for fresh pass             BU30 212
NEXT#                                  Go do it                         BU30 213
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU30 214
#                                                                       BU30 215
IF(N>3\DEBUG==1)WRITE(6,1060) J,MINROW,ROWDIS,DMX2#                     BU30 216
1060 FORMAT(' BAD',2I5,2F10.3)#                                         BU30 217
IF(TEMPP>STARP)#                       Had we a match?                  BU30 218
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU30 219
TEMPP=TEMPP-STEPP#                     Backup to last match             BU30 220
JJ=NINT(QX(TEMPP+5)); HIT(JJ)=no:#     Cancel this hit                  BU30 221
LL=NINT(QX(TEMPP+4)); HIT(LL)=no:#     Cancel this hit                  BU30 222
STARTJ=JJ;  STARTL=LL+1#               Reset matrix pointers            BU30 223
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU30 224
BAD=0;  CENTRE=no:#                    Initial values                   BU30 225
IF(TEMPP==STARP) NEXT#                 Are there stored values?         BU30 226
CENTRE=NINT(QX(TEMPP-STEPP+7))#        Restore centre status            BU30 227
BAD=   NINT(QX(TEMPP-STEPP+8))#        Hit count from prior             BU30 228
#                                                                       BU30 229
#   END OF CENTRE SEARCHES LOOP                                         BU30 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU30 231
#                                                                       BU30 232
#                                                                       BU30 233
#    IF COMPLETE MATCH FOUND - OUTPUT INFORMATION                       BU30 234
#    --------------------------------------------                       BU30 235
#                                                                       BU30 236
NHIT=0; DO I=1,ANUM; NHIT=NHIT+HIT(I)# Sum all hits                     BU30 237
IF(NHIT>ISET)#                         If points are matched            BU30 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BU30 239
DO I=1,3;AVE(I)=0.#                    Initialise av coords             BU30 240
DO I=1,3;DEV(I)=0.#                    Initialise av deviations         BU30 241
A=FLOAT((TEMPP-STARP)/STEPP)#          Number of matched values         BU30 242
FOR(II=STARP;II<TEMPP;II=II+STEPP)#    Go over current chain            BU30 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BU30 244
DO I=1,3; AVE(I)=AVE(I)+QX(II+I)#      Accumulate sums                  BU30 245
DO I=1,3; DEV(I)=DEV(I)+QX(II+I)**2#   Accumulate sums                  BU30 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BU30 247
DO I=1,3; AVE(I)=AVE(I)/A#             Calculate average                BU30 248
DO I=1,3#                                                               BU30 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BU30 250
DEVDEV=DEV(I)/A-AVE(I)**2#             Calculate deviation              BU30 251
IF(DEVDEV>small:) DEV(I)=SQRT(DEVDEV)#                                  BU30 252
ELSE              DEV(I)=0.0#                                           BU30 253
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BU30 254
#                                                                       BU30 255
AVEDEV=0.; DEVDEV=0.#                  Initialise deviation stats       BU30 256
FOR(II=STARP;II<TEMPP;II=II+STEPP)#    Go over current chain            BU30 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BU30 258
DO I=1,3; U(I)=diff:(QX(II+I),AVE(I))# Closest points                   BU30 259
D=G1*U(1)**2+G2*U(2)**2+G3*U(3)**2$#   Get distance squared             BU30 260
 +G4*U(1)*U(2)+G5*U(1)*U(3)+G6*U(2)*U(3)# Get distance squared          BU30 261
IF(QX(II+6)<0.) QX(II+6)=-SQRT(D)#     Was a reject                     BU30 262
ELSE            QX(II+6)= SQRT(D)#     Store the deviation              BU30 263
AVEDEV=AVEDEV+SQRT(D)#                 Accumulate sum                   BU30 264
DEVDEV=DEVDEV+D#                       Accumulate squares               BU30 265
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BU30 266
AVEDEV=AVEDEV/A#                       Average deviation                BU30 267
DEVDEV=DEVDEV/A-AVEDEV**2#             Approximate deviation            BU30 268
IF(DEVDEV>small:) DEVDEV=SQRT(DEVDEV)#                                  BU30 269
ELSE              DEVDEV=0.0#                                           BU30 270
#                                                                       BU30 271
#     OUTPUT SOLUTION                                                   BU30 272
#     ---------------                                                   BU30 273
#                                                                       BU30 274
IF(NHIT==ANUM)#                        Are all sites matched            BU30 275
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BU30 276
FINAL=yes:;  JCENT=10#                 This is a wrap!                  BU30 277
writeline:(1,BU300,NBU300,3,3)#        All sites matched                BU30 278
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BU30 279
ELSE#                                                                   BU30 280
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BU30 281
ncodefld:(FLOAT(NHIT),1,BU301,260313.,1)# Insert hit count              BU30 282
ncodefld:(FLOAT(ANUM),1,BU301,360313.,1)# Insert total sites            BU30 283
writeline:(1,BU301,NBU301,3,3)#        Tell user                        BU30 284
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BU30 285
CHROT=BU303#                           Standard deviations              BU30 286
ncodefld:(AVE,1,CHROT,FMT,3)#          Encode av coord of centre        BU30 287
ncodefld:(AVEDEV,1,CHROT,FMT(4),1)#    Encode dev of coord              BU30 288
writeline:(1,BU302,NBU302,2,3)#        Tell user                        BU30 289
#                                                                       BU30 290
CHROT=BU304#                           Standard deviations              BU30 291
ncodefld:(DEV,1,CHROT,FMT,3)#          Standard deviations              BU30 292
ncodefld:(DEVDEV,1,CHROT,FMT(4),1)#    Average deviation                BU30 293
writeline:(0,0,0,1,3)#                 Tell user                        BU30 294
ncodefld:(AVE,1,BU307,FMT1,3)#         Encode points                    BU30 295
writeline:(1,BU307,NBU307,2,3)#        Give interpretation              BU30 296
#                                                                       BU30 297
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Output points                    BU30 298
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BU30 299
LA=MARKA+(NINT(QX(I+4))-1)*STEPA#      Atom pointer for row             BU30 300
JA=MARKA+(NINT(QX(I+5))-1)*STEPA#      Atom pointer for column          BU30 301
movertoc:(na:(JA),1,CHROT,2,8,0)#      Output atom name                 BU30 302
movertoc:(na:(LA),1,CHROT,9,8,0)#      Output atom name                 BU30 303
ncodefld:(QX,I+1,CHROT,FMT,3)#         Encode midpoint                  BU30 304
IF(QX(I+6)<0.) CHROT(60^60)='*'#       This one was rejected            BU30 305
ELSE           CHROT(60^60)=' '#       Otherwise ok                     BU30 306
QX(I+6)=ABS(QX(I+6))#                  Remove any negative flag         BU30 307
ncodefld:(QX,I+6,CHROT,FMT(4),1)#      Encode deviation                 BU30 308
writeline:(0,0,0,1,3)#                 Output midpoint                  BU30 309
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BU30 310
BREAK#                                 Do not search further            BU30 311
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BU30 312
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU30 313
MCNT(1,MODEC)=NHIT#                    Store the hits                   BU30 314
IF(ITEST==2\MODEC==2\NHIT==ANUM) BREAK# Exit if intra mode              BU30 315
MODEC=2#                               Set intra-cluster search         BU30 316
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU30 317
#                                                                       BU30 318
#          OUTPUT DATA TO SCRATCH FILE                                  BU30 319
#          ---------------------------                                  BU30 320
#                                                                       BU30 321
IF(NHIT<=ISET)writeline:(1,BU305,NBU305,3,3)# Tell user no extra symm   BU30 322
ELSE IF(ITEST==2)#                     For last pass only               BU30 323
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BU30 324
#                                                                       BU30 325
#     INITIALISE SCRATCH FILE                                           BU30 326
#     -----------------------                                           BU30 327
#                                                                       BU30 328
IF(WROTE==no:)#                        If no header yet written         BU30 329
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BU30 330
copyfile:(1,3,1,1)#                    Copy history                     BU30 331
writepkt:(3,lrgraf:,18,IP)#            Prepare lrgraf: record           BU30 332
DO I=1,9;QX(IP+I  )=FLOAT( 20+I)#      Lrgraf: directory                BU30 333
DO I=1,9;QX(IP+I+9)=FLOAT(120+I)#      Lrgraf: directory                BU30 334
writepkt:(3,lrgraf:,18,IP)#            Prepare orientation matrix       BU30 335
DO I=1,18;QX(IP+I)=0.#                 Make identity matrix             BU30 336
QX(IP+ 1)=1.;QX(IP+ 5)=1.;QX(IP+ 9)=1.# Make identity matrix            BU30 337
QX(IP+10)=1.;QX(IP+14)=1.;QX(IP+18)=1.# Make identity matrix            BU30 338
#                                                                       BU30 339
PSIZ=5+lablen:#                        Set output packet size           BU30 340
writepkt:(3,lratom:,PSIZ,IP)#          Get next output packet           BU30 341
DO I=1,3;QX(IP+I)=FLOAT(I)#            Positions into directory         BU30 342
DO I=1,lablen:#                        Atom label length in words       BU30 343
QX(IP+3+I)=14.#                        Atom name into directory         BU30 344
QX(IP+4+lablen:)=22.#                  Scattering factor pointer        BU30 345
QX(IP+5+lablen:)=23.#                  Thermal parameter type for ort   BU30 346
WROTE=yes:#                            Flag header written              BU30 347
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BU30 348
#                                                                       BU30 349
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over solution               BU30 350
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BU30 351
LA=MARKA+(NINT(QX(I+4))-1)*STEPA#      Atom pointer for row             BU30 352
JA=MARKA+(NINT(QX(I+5))-1)*STEPA#      Atom pointer for column          BU30 353
IS=NINT(QX(I+9))#                      Symmetry element pointer         BU30 354
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU30 355
movereal:(xf:(LA),1,QX,IP+1,3,1)#      Store first atom coords          BU30 356
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU30 357
movereal:(na:(LA),1,QX,IP+4,2,1)#      Store name                       BU30 358
movereal:(ty:(LA),1,QX,IP+4+lablen:,1,1)# Store type                    BU30 359
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU30 360
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU30 361
DO II=1,3#                                                              BU30 362
XYZJ(II)=QX(JA+3)*QX(IS+  II)$#        Symoped site j                   BU30 363
       +QX(JA+4)*QX(IS+3+II)$#         Symoped site j                   BU30 364
       +QX(JA+5)*QX(IS+6+II)$#         Symoped site j                   BU30 365
                +QX(IS+9+II)#          Add the translation              BU30 366
#                                                                       BU30 367
movereal:(XYZJ,1,QX,IP+1,3,0)#         Store second atom coords         BU30 368
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU30 369
movereal:(na:(JA),1,QX,IP+4,2,1)#      Store name                       BU30 370
movereal:(ty:(JA),1,QX,IP+4+lablen:,1,1)# Store type                    BU30 371
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU30 372
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BU30 373
#                                                                       BU30 374
#         OUTPUT MIDPOINT TO SCRATCH FILE                               BU30 375
#         -------------------------------                               BU30 376
#                                                                       BU30 377
MPTNME='MPT                     '#                                      BU30 378
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU30 379
movereal:(AVE,1,QX,IP+1,3,0)#          Store average                    BU30 380
movector:(MPTNME,1,QX(IP+4),1,24,0)#   Store name                       BU30 381
QX(IP+4+lablen:)=-1.#                  Flag midpoint                    BU30 382
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU30 383
#                                                                       BU30 384
#         OUTPUT UNMATCHED ATOMS                                        BU30 385
#         ----------------------                                        BU30 386
#                                                                       BU30 387
DO I=1,ANUM#                                                            BU30 388
IF(HIT(I)==no:)#                                                        BU30 389
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BU30 390
LA=MARKA+(I-1)*STEPA#                  Atom pointer                     BU30 391
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU30 392
movereal:(xf:(LA),1,QX,IP+1,3,1)#      Store atom coords                BU30 393
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU30 394
movereal:(na:(LA),1,QX,IP+4,2,1)#      Store name                       BU30 395
movereal:(ty:(LA),1,QX,IP+4+lablen:,1,1)# Store type                    BU30 396
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU30 397
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BU30 398
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BU30 399
#                                                                       BU30 400
RETURN#                                                                 BU30 401
END#                                                                    BU30 402
#                                                                       BU30 403
systemheader:(BU31)#                   Calculation of best plane/line   BU31   1
####################################################################    BU31   2
#                                                                  #    BU31   3
#                               BU31                               #    BU31   4
#                                                                  #    BU31   5
####################################################################    BU31   6
SUBROUTINE BU31#                                                        BU31   7
include:(AACOMN)#                                                       BU31   8
include:(BUCOMN)#                                                       BU31   9
#                                                                       BU31  10
INTEGER I,J,K,L,M#                                                      BU31  11
REAL A2(2,2)#                          2x2 normal-equations matrix      BU31  12
REAL A3(3,3)#                          Least-squares matrix             BU31  13
REAL AX(3)#                            Shifted coordinates              BU31  14
REAL B2(2,2)#                          2x2 variance-covariance mat.     BU31  15
REAL D#                                Distance point to plane/line     BU31  16
REAL DD#                               Matrix determinant               BU31  17
REAL EQS(3,3)#                         Coefficients of homogeneous e    BU31  18
REAL H(3)#                             Constraint equation              BU31  19
REAL Q(3,2)#                           Variable elimination matrix      BU31  20
REAL SCALE,SCALF#                      Variance-covariance scales       BU31  21
REAL SUMTM#                            Norm constant for tm             BU31  22
REAL SUMSTM#                           Norm constant for e.s.d. tm      BU31  23
REAL TEMP#                             Temporary variable               BU31  24
REAL XL(3)#                            Roots of cubic equation          BU31  25
REAL XLMOM#                            Relevant root for line/plane     BU31  26
REAL WT#                               Centroid weight                  BU31  27
REAL VV(4,4)#                          Var-covar matrix                 BU31  28
#                                                                       BU31  29
chardata:(BU200, ERROR MATRIX                                      $#   BU31  30
CORRELATION MATRIX)#                                                    BU31  31
chardata:(BU203,[ EQUATION OF PLANE AS AX+BY+CZ=D, XYZ IN $#            BU31  32
ORTHOGONAL AND FRACTIONAL UNITS])#                                      BU31  33
chardata:(BU204,        A        B        C        $#                   BU31  34
D     ESDA     ESDB     ESDC     ESDD)#                                 BU31  35
realdata:(FM1,[90842.,180842.,270842.,360842.,#                         BU31  36
450942.,540942.,630942.,720942.])#                                      BU31  37
chardata:(BU207,[ EQUATION OF LINE AS POINT ON LINE X(0), Y(0), Z(0)])# BU31  38
chardata:(BU208,[     X(0)     Y(0)     Z(0)])#                         BU31  39
chardata:(BU209,        A        B        C     ESDA     ESDB     ESDC)#BU31  40
chardata:(BU210,[ AND LINE DIRECTION A, B, C IN RECIPROCAL AND $#       BU31  41
ORTHOGONAL BASES])#                                                     BU31  42
datastuff:#                                                             BU31  43
#                                                                       BU31  44
# FIND THE CENTROID OF POINTS                                           BU31  45
#                                                                       BU31  46
WT=0.0#                                Zeroize weight sum               BU31  47
DO J=1,3;OX(J)=0.0#                    Zeroize centroid                 BU31  48
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over atoms                  BU31  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU31  50
WT=WT+1.#                              Sum atoms                        BU31  51
DO J=1,3; OX(J)=OX(J)+QX(I+J)#         Centroid sum                     BU31  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU31  53
DO J=1,3; OX(J)=OX(J)/WT#              Centroid coordinates             BU31  54
#                                                                       BU31  55
# FORM LS MATRIX A (3 X 3)                                              BU31  56
#                                                                       BU31  57
DO J=1,3; DO K=1,3; A3(J,K)=0.0#       Zero the matrix                  BU31  58
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over atoms                  BU31  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU31  60
DO J=1,3;AX(J)=QX(I+J)-OX(J)#          Shifted coordinates              BU31  61
DO J=1,3;DO K=1,3;A3(J,K)=A3(J,K)+AX(J)*AX(K)# Contribute to a          BU31  62
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU31  63
#                                                                       BU31  64
#   CHANGE INTRODUCED AS ALL POINTS NOW IN ORTHO ANGS                   BU31  65
#                                                                       BU31  66
DO I=1,3;DO J=1,3;RMET(I,J)=0.#        Initialise ortho ang matrix      BU31  67
RMET(1,1)=1.;RMET(2,2)=1.;RMET(3,3)=1.# Already in ortho angs           BU31  68
CALL BU32(A3,RMET,XL)#                 Find cubic roots                 BU31  69
IF(LORP==1)XLMOM=AMAX1(XL(1),XL(2),XL(3))# Largest root for line        BU31  70
ELSE       XLMOM=AMIN1(XL(1),XL(2),XL(3))# Smallest root for plane      BU31  71
#                                                                       BU31  72
# EVALUATE COEFICIENTS OF HOMOGENEOUS EQUATIONS FOR RELEVANT ROOT       BU31  73
#                                                                       BU31  74
DO I=1,3; DO J=1,3; EQS(I,J)=A3(I,J)-XLMOM*RMET(I,J)#                   BU31  75
#                                                                       BU31  76
# SOLVE EQUATIONS FOR THE NON-TRIVIAL SOLUTION. THIS GIVES PLANE        BU31  77
# OR LINE NORMAL.                                                       BU31  78
#                                                                       BU31  79
CALL BU33(EQS,TM)#                     Solve 3x3 homogenous equns.      BU31  80
#                                                                       BU31  81
SUMTM=0.0#                             Make tm a unit vector            BU31  82
DO I=1,3; SUMTM=SUMTM+TM(I)*TM(I)#                                      BU31  83
SUMTM=1.0/SQRT(SUMTM)#                                                  BU31  84
DO I=1,3; TM(I)=SUMTM*TM(I)#                                            BU31  85
#                                                                       BU31  86
IF(FINAL==yes:)#                       Calculate matrix?                BU31  87
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU31  88
#                                                                       BU31  89
# VARIANCE - COVARIANCE MATRIX OF TM                                    BU31  90
#                                                                       BU31  91
# REDUCE THE 3 X 3 NORMAL-EQUATIONS MATRIX A3 TO DIMENSION 2 X 2 BU     BU31  92
# REMOVAL OF VARIABLE TO IMPOSE THE CONSTRAINT THAT TM IS A UNIT        BU31  93
# GEOMETRIC VECTOR. THEN INVERT THIS 2 X 2 NORMAL EQUATIONS MATRIX TO   BU31  94
# OBTAIN THE 2 X 2 VARIANCE-COVARIANCE MATRIX OF THE INDEPENDENT        BU31  95
# VARIABLES. THEN EXPAND THIS MATRIX, FIRST TO 3 X 3 FOR THE            BU31  96
# ELIMINATED COMPONENT OF TM AND THEN TO 4 X 4 FOR THE DISTANCE TO      BU31  97
# ORIGIN.                                                               BU31  98
#                                                                       BU31  99
# FIND SCALE FOR NORMAL EQUATIONS MATRIX                                BU31 100
#                                                                       BU31 101
SCALE=0.0#                                                              BU31 102
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over atoms                  BU31 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU31 104
DO J=1,3;AX(J)=QX(I+J)-OX(J)#          Shifted coordinates              BU31 105
D=0.0#                                                                  BU31 106
DO J=1,3;D=D+TM(J)*AX(J)#              Distance point to plane          BU31 107
IF(LORP==1)#                           Line                             BU31 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU31 109
TEMP=4.0*D*D#                          Mult factor                      BU31 110
DO J=1,3; SCALE=SCALE+TEMP*(AX(J)*AX(J))# Contribute to a               BU31 111
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU31 112
ELSE#                                  Plane                            BU31 113
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU31 114
DO J=1,3;SCALE=SCALE+AX(J)*AX(J)#      Contribute to a                  BU31 115
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU31 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU31 117
SCALE=3.0/SCALE#                       Scale for variance-cov matrix    BU31 118
#                                                                       BU31 119
# FORM LS MATRIX A (3 X 3)                                              BU31 120
#                                                                       BU31 121
DO J=1,3;DO K=1,3;A3(J,K)=0.0#         Zero the matrix                  BU31 122
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over atoms                  BU31 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU31 124
DO J=1,3;AX(J)=QX(I+J)-OX(J)#          Shifted coordinates              BU31 125
D=0.0#                                                                  BU31 126
DO J=1,3;D=D+TM(J)*AX(J)#              Distance point to plane          BU31 127
IF(LORP==1)#                           Line                             BU31 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU31 129
TEMP=4.0*SCALE*D*D#                    Mult factor                      BU31 130
DO J=1,3;DO K=1,3;A3(J,K)=A3(J,K)+TEMP*(AX(J)*AX(K))# Contribute to a   BU31 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU31 132
ELSE#                                  Plane                            BU31 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU31 134
DO J=1,3;DO K=1,3;A3(J,K)=A3(J,K)+SCALE*AX(J)*AX(K)# Contribute t       BU31 135
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU31 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU31 137
#                                                                       BU31 138
DO I=1,3; H(I)=0.0#                    Zero constraint vector           BU31 139
DO I=1,3; DO J=1,3; H(I)=H(I)+RMET(I,J)*TM(J)# Constraint vector        BU31 140
M=1#                                                                    BU31 141
DO I=1,3; IF(ABS(H(I))>ABS(H(M))) M=I# Point to largest abs hi          BU31 142
#                                      Fill up the transformation matri BU31 143
K=0#                                   To eliminate one of the three    BU31 144
DO J=1,2#                              Variables.                       BU31 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU31 146
K=K+1;IF(K==M) K=K+1#                                                   BU31 147
DO I=1,3#                                                               BU31 148
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU31 149
IF(I==M) Q(I,J)=-H(K)/H(M)#                                             BU31 150
ELSE IF(I==K) Q(I,J)=1.0#                                               BU31 151
ELSE Q(I,J)=0.0#                                                        BU31 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU31 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU31 154
DO I=1,3; DO J=1,4; VV(I,J)=0.0#       Zero variance-covariance matr    BU31 155
DO I=1,2; DO L=1,2; A2(I,L)=0.0#       Prepare collapse 3x3 to 2x2      BU31 156
SCALF=0.0#                             Scale for 2x2 matrix             BU31 157
DO I=1,2; DO J=1,3; DO K=1,3#                                           BU31 158
SCALF=SCALF+(Q(J,I)*Q(K,I))*A3(J,K)#                                    BU31 159
ifeq:(SCALF,0.0) SCALF=1.0#            Avoid silly scales               BU31 160
ELSE             SCALF=2.0/SCALF#                                       BU31 161
DO I=1,2; DO J=1,3; DO K=1,3; DO L=1,2#                                 BU31 162
A2(I,L)=A2(I,L)+(Q(J,I)*Q(K,L))*(SCALF*A3(J,K))#                        BU31 163
DD=(A2(1,1)*A2(2,2)-A2(1,2)*A2(2,1))/SCALF# Scaled determinant of 2x2   BU31 164
DO I=1,4; VV(I,4)=0.0#                 Zero correlation                 BU31 165
IF(DD>0.0)#                                                             BU31 166
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU31 167
B2(1,1)=A2(2,2)/DD#                    Invert a2 into b2 to obtain 2x   BU31 168
B2(1,2)=-A2(2,1)/DD#                   Variance-covariance matrix       BU31 169
B2(2,1)=B2(1,2)#                                                        BU31 170
B2(2,2)=A2(1,1)/DD#                                                     BU31 171
#                                      Line removed here                BU31 172
DO I=1,3; DO J=1,2; DO K=1,2; DO L=1,3# Into 3x3 var-covar matrix       BU31 173
VV(I,L)=VV(I,L)+Q(I,J)*B2(J,K)*Q(L,K)#                                  BU31 174
DO I=1,3; DO J=1,3; VV(I,J)=SCALE*VV(I,J)#                              BU31 175
DO I=1,3; DO J=1,3#                                                     BU31 176
VV(4,4)=VV(4,4)+OX(I)*VV(I,J)*OX(J)#   Variance d                       BU31 177
DO I=1,3; DO J=1,3#                                                     BU31 178
VV(I,4)=VV(I,4)+VV(I,J)*OX(J)#         Covariance d tm(i                BU31 179
DO J=1,3; VV(4,J)=VV(J,4)#                                              BU31 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU31 181
DO I=1,4; SIGTM(I)=SQRT(MAX(0.,VV(I,I)))# Esd of values                 BU31 182
#                                                                       BU31 183
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU31 184
#                                                                       BU31 185
TM(4)=0.0#                             Distance to origin               BU31 186
DO I=1,3; TM(4)=TM(4)+OX(I)*TM(I)#                                      BU31 187
#                                                                       BU31 188
IF(FINAL==yes:)#                       If complete chain                BU31 189
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU31 190
#                                                                       BU31 191
#                                                                       BU31 192
# EQUATION OF PLANE, X,Y,Z ORTHOGONAL                                   BU31 193
# -----------------------------------                                   BU31 194
#                                                                       BU31 195
LINRM=10#                              Leave enough room                BU31 196
IF(LORP==2)#                           Plane                            BU31 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU31 198
writeline:(1,BU203,NBU203,3,4)#                                         BU31 199
writeline:(0,BU204,NBU204,3,4)#                                         BU31 200
DO I=1,4#                                                               BU31 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU31 202
BUFOT(I)=TM(I)#                                                         BU31 203
BUFOT(I+4)=SIGTM(I)#                                                    BU31 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU31 205
ncodefld:(BUFOT,1,CHROT,FM1,8)#                                         BU31 206
writeline:(0,0,0,1,4)#                                                  BU31 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU31 208
#                                                                       BU31 209
# EQUATION OF LINE   X,Y,Z ORTHOGONAL                                   BU31 210
# -----------------------------------                                   BU31 211
#                                                                       BU31 212
ELSE#                                  Line                             BU31 213
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BU31 214
writeline:(1,BU207,NBU207,3,4)#                                         BU31 215
writeline:(0,BU208,NBU208,3,4)#                                         BU31 216
DO I=1,3; BUFOT(I)=OX(I)#              Centroid coordinates             BU31 217
ncodefld:(BUFOT,1,CHROT,FM1,3)#                                         BU31 218
writeline:(0,0,0,1,4)#                                                  BU31 219
writeline:(0,BU210,NBU210,3,4)#                                         BU31 220
writeline:(0,BU209,NBU209,3,4)#                                         BU31 221
DO I=1,3#                                                               BU31 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BU31 223
BUFOT(I)=TM(I)#                                                         BU31 224
BUFOT(I+3)=SIGTM(I)#                                                    BU31 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BU31 226
ncodefld:(BUFOT,1,CHROT,FM1,6)#                                         BU31 227
writeline:(0,0,0,1,4)#                                                  BU31 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BU31 229
#                                                                       BU31 230
# EQUATION OF PLANE/LINE IN FRACTIONAL COORDS                           BU31 231
# -------------------------------------------                           BU31 232
#                                                                       BU31 233
DO I=1,3#                                                               BU31 234
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BU31 235
SUMTM=0.0 ; SUMSTM=0.0#                Reset to zero                    BU31 236
DO J=1,3#                              Loop over columns                BU31 237
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BU31 238
SUMTM=SUMTM+TM(J)*FT(I,J)#             Ith element of normal            BU31 239
SUMSTM=SUMSTM+(SIGTM(J)*FT(I,J))**2#   Esd of transformed normal        BU31 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BU31 241
BUFOT(I)=SUMTM#                        Output ith element of normal     BU31 242
BUFOT(I+4)=SQRT(SUMSTM)#               Output esd                       BU31 243
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BU31 244
IF(LORP==2)#                           Plane                            BU31 245
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BU31 246
ncodefld:(BUFOT,1,CHROT,FM1,8)#                                         BU31 247
writeline:(0,0,0,1,4)#                                                  BU31 248
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BU31 249
ELSE#                                                                   BU31 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BU31 251
ncodefld:(BUFOT,1,CHROT,FM1,3)#                                         BU31 252
ncodefld:(BUFOT,5,CHROT,FM1(4),3)#                                      BU31 253
writeline:(0,0,0,1,4)#                                                  BU31 254
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BU31 255
#                                                                       BU31 256
#                                                                       BU31 257
# ERROR MATRIX IN A**2 AND CORRELATION MATRIX                           BU31 258
# -------------------------------------------                           BU31 259
#                                                                       BU31 260
DO I=1,4 ; IF (SIGTM(I)<small:) SIGTM(I)=1.0#                           BU31 261
writeline:(1,BU200,NBU200,3,4)#                                         BU31 262
DO I=1,4#                                                               BU31 263
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BU31 264
DO J=1,4#                                                               BU31 265
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BU31 266
BUFOT(J)=VV(I,J)#                                                       BU31 267
BUFOT(J+4)=VV(I,J)/(SIGTM(I)*SIGTM(J))#                                 BU31 268
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BU31 269
ncodefld:(BUFOT,1,CHROT,FM1,8)#                                         BU31 270
writeline:(0,0,0,1,4)#                                                  BU31 271
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BU31 272
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU31 273
#                                                                       BU31 274
RETURN#                                                                 BU31 275
END#                                                                    BU31 276
#                                                                       BU31 277
systemheader:(BU32)#                   Roots of a cubic equation        BU32   1
####################################################################    BU32   2
#                                                                  #    BU32   3
#                               BU32                               #    BU32   4
#                                                                  #    BU32   5
####################################################################    BU32   6
SUBROUTINE BU32(SA3,GI,SY)#                                             BU32   7
include:(AACOMN)#                                                       BU32   8
include:(BUCOMN)#                                                       BU32   9
#                                                                       BU32  10
REAL SA3(3,3)#                                                          BU32  11
dp: GI(3,3)#                           Matrix and metric tensor         BU32  12
dp: DA3(3,3),DI(3,3)#                  Matrix and metric tensor (d.p.   BU32  13
dp: AA,BB,CC,DD#                                                        BU32  14
REAL SY(3)#                                                             BU32  15
dp: P,Q,R,A,B,U,VVV,W,Z#                                                BU32  16
dp: DISC,A3(3,3),SCALE#                                                 BU32  17
INTEGER I,J#                                                            BU32  18
#                                                                       BU32  19
chardata:(BU325, THE DISCRIMINANT IN THE CUBIC $#                       BU32  20
EQUATION OF THE LAGRANGIAN MULTIPLIER)#                                 BU32  21
chardata:(BU326,[ HAS BEEN SET TO ZERO. 0.0< REAL VALUE < 0.1])#        BU32  22
datastuff:#                                                             BU32  23
#                                                                       BU32  24
DO I=1,3;DO J=1,3#                                                      BU32  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU32  26
DA3(I,J)=db:(SA3(I,J))#                                                 BU32  27
DI(I,J)=db:(GI(I,J))#                                                   BU32  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU32  29
SCALE=(DI(1,1)+DI(2,2)+DI(3,3))/(DA3(1,1)+DA3(2,2)+DA3(3,3))# Scale     BU32  30
DO I=1,3; DO J=1,3; A3(I,J)=SCALE*DA3(I,J)# Normal equations matrix     BU32  31
#                                                                       BU32  32
# EVALUATE THE COEFFICIENTS OF THE CUBIC EQUATION IN LAMBDA AND         BU32  33
# THEN SOLVE FOR THE THREE ROOTS.                                       BU32  34
#                                                                       BU32  35
AA=DI(1,1)*DI(2,3)**2+DI(2,2)*DI(1,3)**2+DI(3,3)*DI(1,2)**2$#           BU32  36
-DI(1,1)*DI(2,2)*DI(3,3)-2.*DI(1,2)*DI(1,3)*DI(2,3)#                    BU32  37
BB=A3(1,1)*DI(2,2)*DI(3,3)+DI(1,1)*(A3(2,2)*DI(3,3)+A3(3,3)*DI(2,2))$#  BU32  38
-A3(1,1)*DI(2,3)**2-A3(2,2)*DI(1,3)**2-A3(3,3)*DI(1,2)**2+2.*($#        BU32  39
A3(1,2)*(DI(1,3)*DI(2,3)-DI(1,2)*DI(3,3))+$#                            BU32  40
A3(1,3)*(DI(1,2)*DI(2,3)-DI(1,3)*DI(2,2))+$#                            BU32  41
A3(2,3)*(DI(1,2)*DI(1,3)-DI(1,1)*DI(2,3)))#                             BU32  42
CC=DI(3,3)*A3(1,2)**2+DI(2,2)*A3(1,3)**2+DI(1,1)*A3(2,3)**2-$#          BU32  43
(A3(1,1)*(A3(2,2)*DI(3,3)+A3(3,3)*DI(2,2))+A3(2,2)*A3(3,3)*DI(1,1))$#   BU32  44
+2.*(A3(1,2)*(A3(3,3)*DI(1,2)-A3(2,3)*DI(1,3)-A3(1,3)*DI(2,3))+$#       BU32  45
A3(1,3)*(A3(2,2)*DI(1,3)-A3(2,3)*DI(1,2))+A3(1,1)*A3(2,3)*DI(2,3))#     BU32  46
DD=A3(1,1)*(A3(2,2)*A3(3,3)-A3(2,3)**2)-A3(2,2)*(A3(1,3)**2) $#         BU32  47
-A3(3,3)*(A3(1,2)**2)+2.*(A3(1,2)*A3(1,3)*A3(2,3))#                     BU32  48
#                                                                       BU32  49
IF(dabs:(AA)<vsmall:)#                 Small lambda**3                  BU32  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU32  51
ABORT=yes:#                            Tell calling routine             BU32  52
RETURN#                                Go back to calling routine       BU32  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU32  54
P=BB/AA; Q=CC/AA; R=DD/AA#                                              BU32  55
IF(R==zero:)#                          Zero determinant                 BU32  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU32  57
DISC=dsqrt:(P*P-four:*Q)#                                               BU32  58
SY(1)=0.5*sg:((-P+DISC)/SCALE)#                                         BU32  59
SY(2)=0.5*sg:((-P-DISC)/SCALE)#                                         BU32  60
SY(3)=0.0#                                                              BU32  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU32  62
ELSE#                                                                   BU32  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU32  64
A=(three:*Q-P*P)/three:#                                                BU32  65
B=(two:*P*P*P-nine:*P*Q+two7:*R)/two7:#                                 BU32  66
U=quart:*B*B; VVV=-(A*A*A/two7:); DISC=U-VVV#                           BU32  67
IF(DISC>p01:)iquit:(BU3202)#           Large positive disc              BU32  68
IF(DISC<=zero:) W=(-half:*B)/dsqrt:(VVV)# Negative disc                 BU32  69
ELSE#                                  Small positive disc              BU32  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU32  71
W=dsign:(-B)#                                                           BU32  72
writeline:(1,BU325,NBU325,3,4)#                                         BU32  73
writeline:(0,BU326,NBU326,3,4)#                                         BU32  74
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU32  75
W=ACOS(W)/three:; Z=two:*SQRT(-A/three:); P=P/three:#                   BU32  76
DO I=1,3; SY(I)=sg:(-P+Z*dcos:(W+ $#                                    BU32  77
  ifelse:(mxbtwd:,32,2.0944D0*DBLE(I-1),2.0944*REAL(I-1))))/SCALE#      BU32  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU32  79
#                                                                       BU32  80
RETURN#                                                                 BU32  81
END#                                                                    BU32  82
systemheader:(BU33)#                   Solve 3 homogeneous equations    BU33   1
####################################################################    BU33   2
#                                                                  #    BU33   3
#                               BU33                               #    BU33   4
#                                                                  #    BU33   5
####################################################################    BU33   6
SUBROUTINE BU33(SC,X)#                                                  BU33   7
include:(AACOMN)#                                                       BU33   8
#                                                                       BU33   9
# THIS SUBROUTINE IS DESIGNED TO GIVE A SOLUTION FOR THREE HOMOGENEOUS  BU33  10
# EQUATIONS OF THREE UNKNOWNS. THE SOLUTION RETURNED IS OF COURSE NOT   BU33  11
# UNIQUE BUT IS PROPORTIONAL TO THE DESIRED SOLUTION. IN THE CALLING    BU33  12
# SEQUENCE C IS THE 3 X 3 MATRIX OF THE COEFFICIENTS OF THE EQUATIONS.  BU33  13
# X IS THE 3 X 1 MATRIX OF THE SOLUTION VALUES.                         BU33  14
#                                                                       BU33  15
REAL SC(3,3),X(3)#                                                      BU33  16
dp: C(3,3),AC(3,3),RCM(3),B(3,3),PM(3),STO,CM,ABM#                      BU33  17
INTEGER I,J,K,K1,K2,K3#                                                 BU33  18
INTEGER ICMAX,JCMAX#                                                    BU33  19
#                                                                       BU33  20
K1=1;K2=2;K3=3#                        Coefficient order and error      BU33  21
DO I=1,3; DO J=1,3#                                                     BU33  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU33  23
C(I,J)=SC(I,J)#                                                         BU33  24
AC(I,J)=dabs:(C(I,J))#                 Ac with absolute values of c     BU33  25
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU33  26
DO I=1,3; RCM(I)=amx1:(AC(I,1)$,AC(I,2)$,AC(I,3))# Row abs. maxima      BU33  27
CM=amx1:(RCM(1)$,RCM(2)$,RCM(3))#      Maximum ac element               BU33  28
IF(CM<dsmall:) iquit:(BU3301)#         Too small largest element        BU33  29
IF(AC(3,3)<CM)#                        Skip is ac(3,3) is largest       BU33  30
# INTERCHANGE ROWS AND COLUMNS IN C TO PUT EL. WITH MAX MAG. IN 3,3     BU33  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU33  32
DO I=1,3;IF(RCM(I)>=CM) ICMAX=I#       Find pointer to row max          BU33  33
DO J=1,3#                                                               BU33  34
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU33  35
STO=C(3,J);C(3,J)=C(ICMAX,J);C(ICMAX,J)=STO# Swop large row to 3        BU33  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU33  37
# INTERCHANGE COLUMNS. NEED TO INTERCHANGE X(I)'S BY WAY OF K1,K2,K3    BU33  38
DO J=1,3;IF(AC(ICMAX,J)>=CM) JCMAX=J#  Find pointer to col max          BU33  39
IF(JCMAX==1)#                          Pointer interchange              BU33  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU33  41
K1=3;K3=1#                                                              BU33  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU33  43
ELSE IF(JCMAX==2)#                     Pointer interchange              BU33  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU33  45
K2=3;K3=2#                                                              BU33  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU33  47
DO I=1,3#                              Column interchange               BU33  48
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU33  49
STO=C(I,3);C(I,3)=C(I,JCMAX);C(I,JCMAX)=STO# Swop large col to 3        BU33  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU33  51
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU33  52
# MAKE EQUIVALENCE TRANSFORMATIONS OF C INTO B                          BU33  53
B(1,1)=C(1,1)-C(3,1)*C(1,3)/C(3,3)#                                     BU33  54
B(1,2)=C(1,2)-C(3,2)*C(1,3)/C(3,3)#                                     BU33  55
B(2,1)=C(2,1)-C(3,1)*C(2,3)/C(3,3)#                                     BU33  56
B(2,2)=C(2,2)-C(3,2)*C(2,3)/C(3,3)#                                     BU33  57
B(3,1)=C(3,1)/C(3,3);B(3,2)=C(3,2)/C(3,3)#                              BU33  58
B(1,3)=zero:;B(2,3)=zero:;B(3,3)=one:#                                  BU33  59
# SOLUTION OF THE EQUIVALENCE. USE 3RD AND EITHER 1ST. OR 2ND. FOR      BU33  60
# DIVISION BY LARGEST MAGNITUDE                                         BU33  61
ABM=zero:; K=0#                                                         BU33  62
DO I=1,2; DO J=1,2; IF(dabs:(B(I,J))>ABM)#                              BU33  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU33  64
K=2*I+J-2; ABM=dabs:(B(I,J))#          Store the largest                BU33  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU33  66
PM(1)=one:;PM(2)=one:#                                                  BU33  67
IF     (K==1) PM(1)=-B(1,2)/B(1,1)#    |b(1,1)| largest                 BU33  68
ELSE IF(K==2) PM(2)=-B(1,1)/B(1,2)#    |b(1,2)| largest                 BU33  69
ELSE IF(K==3) PM(1)=-B(2,2)/B(2,1)#    |b(2,1)| largest                 BU33  70
ELSE IF(K==4) PM(2)=-B(2,1)/B(2,2)#    |b(1,2)| largest                 BU33  71
PM(3)=-B(3,1)*PM(1)-B(3,2)*PM(2)#      The permuted solution            BU33  72
X(1)=sg:(PM(K1));X(2)=sg:(PM(K2));X(3)=sg:(PM(K3))# Permute solution    BU33  73
#                                                                       BU33  74
RETURN#                                                                 BU33  75
END#                                                                    BU33  76
#                                                                       BU33  77
systemheader:(BU40)#                   Search for plane symmetry        BU40   1
################################################################        BU40   2
##                                                                      BU40   3
##                           BU40                                       BU40   4
##                                                                      BU40   5
################################################################        BU40   6
SUBROUTINE BU40#                                                        BU40   7
#                                                                       BU40   8
include:(AACOMN)#                                                       BU40   9
include:(BUCOMN)#                                                       BU40  10
#                                                                       BU40  11
INTEGER I,J,K,L,N,JB,LB#               Loop variables                   BU40  12
INTEGER II,JJ,KK,LL,MM#                More loop variables              BU40  13
INTEGER IA,JA,LA,TESTP#                Array markers                    BU40  14
INTEGER IP#                            Qx pointer                       BU40  15
INTEGER INCL,MODE#                     Increment                        BU40  16
INTEGER BAD,MINROW#                    Progress markers                 BU40  17
INTEGER STARTL,STARTJ#                 Beginning row and column         BU40  18
INTEGER PLANE,ISET#                    Flag point found                 BU40  19
INTEGER MIRROR#                        Flag mirror found                BU40  20
INTEGER MODEC#                                                          BU40  21
INTEGER PLTYPE,RESTART#                Plane interpretation             BU40  22
INTEGER SAVEP,STEMPP#                  String match chain limits        BU40  23
INTEGER SHIT(1000)#                    Hit storage                      BU40  24
INTEGER SKIP#                          Flag skip mode                   BU40  25
INTEGER PLANESTRT#                     Where plane first found          BU40  26
REAL P(3),Q(3),U(3),X(3)#              Temporary coordinates            BU40  27
REAL S(3),V(3)#                        Temporary coordinates            BU40  28
REAL Q1(3),Q2(3),Q3(3),Q4(3)#          Plane corners                    BU40  29
REAL AVEDEV,DEVDEV#                    Average, deviation               BU40  30
REAL AVETRA,DEVTRA#                    Average, deviation               BU40  31
REAL A,AVT,T,TOLD#                     Thresholds                       BU40  32
REAL DMAX,LIM2,DEV#                    Dist max and limit sqd           BU40  33
REAL ROWTRA,ROWDIS#                    Minimum distance whole row       BU40  34
REAL CTRA,STRA#                        Translatio sums                  BU40  35
REAL SCTRA,SSTRA#                      Saved translation sums           BU40  36
REAL MINMPA(3),MINMPF(3)#              Mdpt for minimum                 BU40  37
REAL MAXMPA(3)#                        Limits for display plane         BU40  38
REAL BADFLG,TRANS,DIST,D#              Translation along axis           BU40  39
REAL CDIM(3)#                          Cell dimensions                  BU40  40
REAL TMF(4)#                           Plane equation in frac           BU40  41
REAL SMAX#                             Minimum normal component         BU40  42
REAL LNT(25)#                          Unit vector sum lengths(same o   BU40  43
#                                      As it vol a. p 6)                BU40  44
#                                                                       BU40  45
string:(GLIDE1,1);  string:(GLIDE2,1)#                                  BU40  46
string:(MPTNME,24)#                                                     BU40  47
realdata:(FMT,[281042.,381042.,481042.,581042.,701032.])#               BU40  48
chardata:(BU400,"                        x/a       y/b    $#            BU40  49
   z/c")#                                                               BU40  50
chardata:(BU401," ***** Plane found for ALL atom sites *****")#         BU40  51
chardata:(BU402," Equation AX+BY+CZ=D     A          B         C$#      BU40  52
        D     XYZ orthog Angstr.")#                                     BU40  53
chardata:(BU403,"            Mid-point deviation and translation$#      BU40  54
       dev(A)     tran(A)")#                                            BU40  55
#CHARDATA:(BU404,"             ESD")#                                   BU40  56
chardata:(BU405," None found")#                                         BU40  57
chardata:(BU406," ***** Plane found for nnn out of nnn sites *****")#   BU40  58
chardata:(BU407," Search for mirror/glide plane")#                      BU40  59
chardata:(BU408,"                                        average")#     BU40  60
chardata:(BU409,"                                            esd")#     BU40  61
chardata:(BU410,"     Possible x-GLIDE plane perpendicular to x")#      BU40  62
chardata:(BU411,"     plane displaced by              ")#               BU40  63
chardata:(BU412," -GLIDE MIRROR")#                                      BU40  64
chardata:(BU413,"       **Unable to interpret plane position**")#       BU40  65
chardata:(BU414,"       **Unable to interpret glide type**")#           BU40  66
chardata:(BU415," Translation variation too great for reliable plane")# BU40  67
chardata:(BU416,"abc?????")#                                            BU40  68
chardata:(BU417," Equation ax+by+cz=D     a          b         c$#      BU40  69
              xyz fractional")#                                         BU40  70
datastuff:#                                                             BU40  71
#                                                                       BU40  72
#     INITIALISE                                                        BU40  73
#     ----------                                                        BU40  74
#                                                                       BU40  75
movechar:('-',1,CHROT,2,NBU407-1,2)#   Insert header underline          BU40  76
writeline:(2,BU407,NBU407,2,3)#        Print start of search            BU40  77
LORP=2#                                We want lsq planes               BU40  78
IF(ITEST==1) MODEC=IALL#               Set initial mode                 BU40  79
ELSE#                                  For last pass choose the best    BU40  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU40  81
IF(MCNT(2,1)>=MCNT(2,2)) MODEC=1#      Pick the most successful mode    BU40  82
ELSE                     MODEC=2#      Pick the most successful mode    BU40  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU40  84
RESTART=no:#                           This is a first run              BU40  85
#                                                                       BU40  86
#                                                                       BU40  87
#    LOOP OVER INTER OR INTRA CLUSTER SEARCHES                          BU40  88
#    -----------------------------------------                          BU40  89
#                                                                       BU40  90
REPEAT#                                Loop over inter and intra mode   BU40  91
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU40  92
IF(RESTART==yes:) GOTO 2000#           Check if this is a restart       BU40  93
#                                                                       BU40  94
BAD=0;  BADFLG=1.;  N=PPRIOR#          Initialise number of rejects     BU40  95
ISET=MIN(ANUM-1,MAX(2*ANUM/3,10))#     Define incr changeover           BU40  96
PLANE=no:;   DMAX=TOLC;  LIM2=LIMIT**2# No plane equation yet           BU40  97
STEPP=18#                              Storage for best chains          BU40  98
MARKP=STOPM; STARP=MARKP#              Initialise current chain ptr     BU40  99
incrqx:(STOPP,MARKP+ANUM*STEPP,BU3005)# Make room for working chains    BU40 100
TEMPP=STARP#                           Initialise end of chain          BU40 101
DO I=1,ANUM; HIT(I)=no:#               Reset matched flags              BU40 102
CTRA=0.;  STRA=0.; TOLD=TOLC#          Zero translation sums            BU40 103
D=-1000.#                              Reset distance value             BU40 104
SKIP=0#                                No skipping at first             BU40 105
#                                                                       BU40 106
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              BU40 107
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU40 108
IF(fr:<0.5) NEXT#                      Test if site at inversion        BU40 109
I=(IA-MARKA)/STEPA+1#                  Get the atom number              BU40 110
J=MARKM+(I-1)*STEPM+(I-1)*3#           Point to midpoint table          BU40 111
DO I=1,3; X(I)=QX(J+I)#                Get fractional midpoints         BU40 112
DO I=1,3; DO K=1,3; P(I)=P(I)+TF(I,K)*X(K)# Midpoint in ortho angs      BU40 113
QX(TEMPP+ 1)=P(1)#                     Midpoint x in orthog anstr       BU40 114
QX(TEMPP+ 2)=P(2)#                     Midpoint y in orthog anstr       BU40 115
QX(TEMPP+ 3)=P(3)#                     Midpoint z in orthog anstr       BU40 116
QX(TEMPP+ 4)=FLOAT(I)#                 Store row                        BU40 117
QX(TEMPP+ 5)=FLOAT(I)#                 Store column                     BU40 118
QX(TEMPP+ 6)=0.#                       Flag the bad matches             BU40 119
QX(TEMPP+ 7)=0.#                       Plane equ not known              BU40 120
QX(TEMPP+ 8)=0.#                       Remember hits                    BU40 121
QX(TEMPP+15)=X(1)#                     Midpt x in fractions             BU40 122
QX(TEMPP+16)=X(2)#                     Midpt y in fractions             BU40 123
QX(TEMPP+17)=X(3)#                     Midpt z in fractions             BU40 124
QX(TEMPP+18)=9999.#                    Translation unknown              BU40 125
TEMPP=TEMPP+STEPP#                     Update chain pointer             BU40 126
HIT(I)=yes:#                           Flag this as matched             BU40 127
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU40 128
2000 CONTINUE#                         Restart entry point              BU40 129
#                                                                       BU40 130
#     START SEARCH LOOP                                                 BU40 131
#     -----------------                                                 BU40 132
#                                                                       BU40 133
DO MODE=1,2#                           Loop search/refine modes         BU40 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU40 135
IF(RESTART==yes:) GOTO 2085#           Test if restart                  BU40 136
INCL=2-MODE; STARTL=1;  STARTJ=1#      Starting values                  BU40 137
JB=0;  LB=0#                           Reset bad pointers               BU40 138
TESTP=STARP+2*STEPP#                   Set start of match chain         BU40 139
REPEAT#                                Loop over possible solutions     BU40 140
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU40 141
#                                                                       BU40 142
#    LOOP OVER MID-POINT MATRIX COLUMNS                                 BU40 143
#    ----------------------------------                                 BU40 144
#                                                                       BU40 145
DO J=STARTJ,ANUM#                      Loop over columns                BU40 146
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU40 147
IF(N>3)WRITE(6,1000) J,L,STARTJ,STARTL,PLANE,HIT(J),JB,LB#              BU40 148
1000 FORMAT(' J  ',8I5)#                                                BU40 149
IF(HIT(J)==no:)#                       Look for match                   BU40 150
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU40 151
ROWDIS=99999.#                         Initialise min distance          BU40 152
JA=MARKA+(J-1)*STEPA#                  Point to atom info               BU40 153
JJ=MARKM+(J-1)*STEPM#                  Set column pointer               BU40 154
IF(TEMPP>STARP)#                       Protect for mode 2               BU40 155
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU40 156
II=TEMPP-STEPP#                        Step back one midpoint           BU40 157
DO I=1,3; OX(I)=QX(II+ 8+I)#           Extract plane centroid           BU40 158
DO I=1,3; TM(I)=QX(II+11+I)#           Extract normal vector            BU40 159
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU40 160
IF(N>3)WRITE(6,1010) TM,OX#                                             BU40 161
1010 FORMAT(' MAT ',9F9.5)#                                             BU40 162
#                                                                       BU40 163
#    LOOP OVER MID-POINT MATRIX ROWS                                    BU40 164
#    -------------------------------                                    BU40 165
#                                                                       BU40 166
DO L=STARTL     ,ANUM#                 Loop over rows                   BU40 167
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU40 168
IF(HIT(L)==yes:) NEXT#                 Skip if already matched          BU40 169
LA=MARKA+(L-1)*STEPA#                  Point to atom info               BU40 170
IF(JA!=LA)#                            If diff atom                     BU40 171
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU40 172
IF(MODEC==1)#                          If inter mode                    BU40 173
ifeq:(bn:(JA),bn:(LA)) NEXT#           Check on molecular cluster       BU40 174
ifne:(ty:(JA),ty:(LA)) NEXT#           Skip if no match                 BU40 175
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU40 176
LL=JJ+(L-1)*3#                         Set row pointer                  BU40 177
DO I=1,3; P(I)=0.#                     Initialise midpoint ortho coor   BU40 178
DO I=1,3; Q(I)=0.#                     Initialise centre ortho coords   BU40 179
DO I=1,3; X(I)=QX(LL+I)#               Get fractional midpoints         BU40 180
#                                                                       BU40 181
#    IF NO PLANE EQUATION, STORE POINT IN CHAIN                         BU40 182
#    ------------------------------------------                         BU40 183
#                                                                       BU40 184
D=0.#                                  Reset distance value             BU40 185
IF(PLANE==no:)#                        Plane equ not known              BU40 186
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU40 187
IF(J==JB&L<=LB) NEXT#                  Cannot be bad match              BU40 188
ROWTRA=99999.#                         Translation unknown yet          BU40 189
DO I=1,4; TM(I)=999999.#               Equation is not known            BU40 190
DO I=1,3; DO K=1,3; P(I)=P(I)+TF(I,K)*X(K)# Midpoint in ortho angs      BU40 191
QX(TEMPP+ 1)=P(1)#                     Midpoint x in orthog anstr       BU40 192
QX(TEMPP+ 2)=P(2)#                     Midpoint y in orthog anstr       BU40 193
QX(TEMPP+ 3)=P(3)#                     Midpoint z in orthog anstr       BU40 194
IF(N>3\DEBUG==1)WRITE(6,1020) X,P#                                      BU40 195
1020 FORMAT(' NOP ',6F9.5)#                                             BU40 196
IF(TEMPP>=TESTP)#                      Enough points                    BU40 197
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU40 198
#                                                                       BU40 199
LORP=1#                                Check for collinerarity          BU40 200
TEMPP=TEMPP+STEPP#                     Include latest point             BU40 201
CALL BU31#                             Get tm,ox for a *line*           BU40 202
TEMPP=TEMPP-STEPP#                     Exclude latest point             BU40 203
IF(N>3)WRITE(6,1030) OX,TM#                                             BU40 204
1030 FORMAT(' LIN ',8F9.5)#                                             BU40 205
LORP=2#                                Restore plane flag for later     BU40 206
DO I=1,3; S(I)=P(I)-OX(I)#             Shifted mpt coordinates          BU40 207
DO I=1,3; D=D+TM(I)*S(I)#              Calculate projection onto line   BU40 208
D=-(D*D)#                              Subtract from centroid-pt dist   BU40 209
DO I=1,3; D=D+S(I)**2#                 Calculate point-line distance    BU40 210
IF(N>3)WRITE(6,1040) J,L,D,LIM2,S#                                      BU40 211
1040 FORMAT(' LIN ',2I5,6F9.5)#                                         BU40 212
IF(D>LIM2)#                            We have found a plane            BU40 213
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU40 214
#                                                                       BU40 215
#  NOW CALCULATE AVERAGE TRANSLATION                                    BU40 216
#                                                                       BU40 217
PLANE=yes:#                            Flag that plane is found         BU40 218
IF(MODE==1) PLANESTRT=(TEMPP+STEPP-STARP)/STEPP# Where it was found     BU40 219
QX(TEMPP+4)=FLOAT(L)#                  For translation calculation      BU40 220
QX(TEMPP+5)=FLOAT(J)#                  For translation calculation      BU40 221
TEMPP=TEMPP+STEPP#                     Include latest in chain          BU40 222
IF(MODE==1) CALL BU31#                 Get plane with new chain         BU40 223
TEMPP=TEMPP-STEPP#                     Back to the way it was           BU40 224
STRA=0.;CTRA=0.#                       Initialise translation sum       BU40 225
DO II=STARP,TEMPP,STEPP#               Loop over atoms in chain         BU40 226
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU40 227
JA=MARKA+(QX(II+5)-1)*STEPA#           Point to atom info               BU40 228
LA=MARKA+(QX(II+4)-1)*STEPA#           Point to atom info               BU40 229
DO I=1,3; Q(I)=0#                      Initialise interatom vector      BU40 230
DO I=1,3; U(I)=(QX(JA+2+I)-QX(LA+2+I))# Calculate vector coords         BU40 231
DO I=1,3; DO K=1,3#                    Convert to orthogonal angstrom   BU40 232
Q(I)=Q(I)+TF(I,K)*U(K)#                Interatom vector in ortho angs   BU40 233
T=0.;  DIST=0.#                        Initialise length i/atom vec     BU40 234
DO I=1,3; S(I)=QX(II+I)-OX(I)#         Shifted midpoint in ortho angs   BU40 235
DO I=1,3; DIST=DIST+Q(I)**2#           Length of interatomic vector     BU40 236
DO I=1,3; T=T+Q(I)*TM(I)#              Project vector onto normal  	b   BU40 237
T=SQRT(ABS(DIST-T**2))#                If q,normal parallel trans=di    BU40 238
STRA=STRA+T;CTRA=CTRA+1.#              Add to sum of translations  	b   BU40 239
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU40 240
AVT=STRA/CTRA#                         New average translation          BU40 241
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU40 242
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU40 243
BREAK#                                                                  BU40 244
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU40 245
#                                                                       BU40 246
#                                                                       BU40 247
#   PLANE EQUATION KNOWN - FIT THIS MID-POINT                           BU40 248
#   -----------------------------------------                           BU40 249
#                                                                       BU40 250
ELSE#                                  If plane equation known          BU40 251
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU40 252
IF(J==JB&L<=LB) NEXT#                  Combination tried already        BU40 253
DO I=1,3; U(I)=(QX(JA+2+I)-QX(LA+2+I))# Calculate vector coords         BU40 254
DO I=1,3; DO K=1,3#                    Convert to orthogonal angstrom   BU40 255
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BU40 256
P(I)=P(I)+TF(I,K)*X(K)#                Midpoint in ortho angs           BU40 257
Q(I)=Q(I)+TF(I,K)*U(K)#                Interatom vector in ortho angs   BU40 258
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BU40 259
T=0.;  DIST=0.#                        Initialise length i/atom vec     BU40 260
DO I=1,3; S(I)=P(I)-OX(I)#             Shifted midpoint in ortho angs   BU40 261
DO I=1,3; DIST=DIST+Q(I)**2#           Length of interatomic vector     BU40 262
DO I=1,3; D=D+S(I)*TM(I)#              Calculate distance from plane    BU40 263
DO I=1,3; T=T+Q(I)*TM(I)#              Project vector onto normal       BU40 264
T=SQRT(ABS(DIST-T**2))#                If q,normal parallel trans=di    BU40 265
#                                                                       BU40 266
IF(N>3)WRITE(6,1050) L,D,T,AVT,CTRA#                                    BU40 267
1050 FORMAT(' L,D..',I10,4F10.4)#                                       BU40 268
IF(ABS(D)>DMAX&ABS(D)>ROWDIS) NEXT#    Save the closest                 BU40 269
IF(MODE==1&CTRA>0.\MODE==2)#           Skip if transl too far off       BU40 270
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BU40 271
TOLD=AMAX1(TOLC,0.15*AVT)#             Generous tolerance for trans     BU40 272
IF(ABS(AVT-ABS(T))>TOLD) NEXT#         Skip if transl too far off       BU40 273
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BU40 274
MINROW=L; ROWDIS=ABS(D); ROWTRA=T#     Save min dev and translation     BU40 275
DO I=1,3; MINMPF(I)=X(I)#              Save midpoint value fract        BU40 276
DO I=1,3; MINMPA(I)=P(I)#              Save midpoint value ortho ang    BU40 277
IF(ABS(D)<=DMAX) BREAK#                Try this match                   BU40 278
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU40 279
#                                                                       BU40 280
#-------- END OF ROW (L) LOOP                                           BU40 281
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU40 282
#                                                                       BU40 283
IF((SKIP==0&ROWDIS<9999)\(SKIP==1&ROWDIS<DMAX))# Only if match found    BU40 284
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BU40 285
BADFLG=1.#                             Set flag for bad match           BU40 286
IF(ROWDIS>DMAX)#                       Bad if dev outside limit         BU40 287
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BU40 288
BAD=BAD+1; IF(BAD>MXAD) BREAK#         Count bad matches                BU40 289
BADFLG=-1.#                            This is a bad guy                BU40 290
L=MINROW#                              Set current row                  BU40 291
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BU40 292
DO I=1,3; X(I)=MINMPF(I)#              Get midpoint in fractions        BU40 293
QX(TEMPP+ 1)=MINMPA(1)#                Midpt x in orthogonal anstr      BU40 294
QX(TEMPP+ 2)=MINMPA(2)#                Midpt y in orthogonal anstr      BU40 295
QX(TEMPP+ 3)=MINMPA(3)#                Midpt z in orthogonal anstr      BU40 296
CTRA=CTRA+1.; STRA=STRA+ROWTRA#        Sum the translations             BU40 297
AVT=STRA/CTRA#                         Average translation              BU40 298
IF(N>3\DEBUG==1)WRITE(6,1060) J,L,ROWDIS,DMAX,ROWTRA,AVT,CTRA#          BU40 299
1060 FORMAT(' ADD ',2I5,F10.3,4F8.3)#                                   BU40 300
#                                                                       BU40 301
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BU40 302
IF((SKIP==0&(ROWDIS<9999.\ (L<=ANUM&D>LIM2)))$# Add latest point        BU40 303
\(ROWDIS<DMAX&SKIP==1))#               And calculate new plane          BU40 304
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BU40 305
TEMPP=TEMPP+STEPP#                     Include in chain                 BU40 306
IF(MODE==1) CALL BU31#                 Calc plane with new chain        BU40 307
TEMPP=TEMPP-STEPP#                     Backstep for this insertion      BU40 308
QX(TEMPP+ 9)=OX(1)#                    Centroid x in orthog anstr       BU40 309
QX(TEMPP+10)=OX(2)#                    Centroid y in orthog anstr       BU40 310
QX(TEMPP+11)=OX(3)#                    Centroid z in orthog anstr       BU40 311
QX(TEMPP+12)=TM(1)#                    Normal x in orthog anstr         BU40 312
QX(TEMPP+13)=TM(2)#                    Normal y in orthog anstr         BU40 313
QX(TEMPP+14)=TM(3)#                    Normal z in orthog anstr         BU40 314
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BU40 315
IF((SKIP==0&(ROWDIS<9999. \ L<=ANUM))\(SKIP==1&ROWDIS<DMAX))# New val   BU40 316
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BU40 317
HIT(J)=yes:;  HIT(L)=yes:#             Flag as matched                  BU40 318
QX(TEMPP+ 4)=FLOAT(L)#                 Store row                        BU40 319
QX(TEMPP+ 5)=FLOAT(J)#                 Store column                     BU40 320
QX(TEMPP+ 6)=BADFLG#                   Flag the bad matches             BU40 321
QX(TEMPP+ 7)=FLOAT(PLANE)#             Plane equ known                  BU40 322
QX(TEMPP+ 8)=FLOAT(BAD)#               Remember hits                    BU40 323
QX(TEMPP+15)=X(1)#                     Midpt x in fractions             BU40 324
QX(TEMPP+16)=X(2)#                     Midpt y in fractions             BU40 325
QX(TEMPP+17)=X(3)#                     Midpt z in fractions             BU40 326
QX(TEMPP+18)=ROWTRA#                   Keep current translation         BU40 327
TEMPP=TEMPP+STEPP#                     Include in chain                 BU40 328
JB=0;  LB=0#                           Reset bad pointers               BU40 329
IF(CTRA>(SKIPSTRT+PLANESTRT) & SKIP==0 & PLANE==yes:)# Start fast sea   BU40 330
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BU40 331
SKIP=1#                                Start fast search from now       BU40 332
IF(N>3\DEBUG==1) WRITE(6,1068) J,L,CTRA,(TEMPP-STARP)/STEPP,PLANESTRT#  BU40 333
1068 FORMAT('***Fast search started ***',/,2I5,F8.2,2I5,/)#             BU40 334
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BU40 335
IF(N>3)WRITE(6,1070) J,L,TM,(TEMPP-STARP)/STEPP#                        BU40 336
1070 FORMAT(' J,L..',/,2I5,4F9.5,I9,/)#                                 BU40 337
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BU40 338
#                                                                       BU40 339
IF(L>ANUM&SKIP==0) BREAK#              The site is unassigned           BU40 340
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU40 341
STARTL=J+1#                            Next starting row                BU40 342
#                                                                       BU40 343
#----------- END OF COLUMN (J) LOOP                                     BU40 344
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU40 345
#                                                                       BU40 346
#    SITE CANNOT BE MATCHED                                             BU40 347
#    ----------------------                                             BU40 348
K=0#                                   Reset hit count                  BU40 349
IF(PLANE==yes:)#                       Only if plane found              BU40 350
DO I=1,ANUM; K=K+HIT(I)#               Sum all hits                     BU40 351
IF((L>ANUM&J==1)\K>=ISET) BREAK#       Is search complete               BU40 352
IF(MODE==2&SKIP==1) BREAK#             Don't slow down during mode 2    BU40 353
#$(#                                                                    BU40 354
#IF(N>3)WRITE(6,1080) J,L,K,ISET,ROWDIS,DMAX,ROWTRA#                    BU40 355
#1080 FORMAT(' I=0',4I5,F10.3,3F8.3)#                                   BU40 356
#IF(INCL==0\K==ANUM) BREAK#             NO OPTIONS LEFT                 BU40 357
#INCL=0; STARTJ=1; STARTL=1#            RESET FOR FRESH PASS            BU40 358
#JB=0;LB=0#                             RESET BAD POINTERS              BU40 359
#NEXT#                                  GO DO IT                        BU40 360
#$)#                                                                    BU40 361
#                                                                       BU40 362
#                                                                       BU40 363
# ENTRY POINT IF REFINE STEP FAILED                                     BU40 364
#                                                                       BU40 365
2085 RESTART=no:#                      Entry after failed refine        BU40 366
IF(SKIP==0)#                           Slow search, remove baddies      BU40 367
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BU40 368
#                                                                       BU40 369
IF(N>3\DEBUG==1)WRITE(6,1090) J,MINROW,ROWDIS,DMAX,ROWTRA#              BU40 370
1090 FORMAT(' BAD',2I5,F10.3,3F8.3)#                                    BU40 371
IF(TEMPP>STARP)#                       Had we a match?                  BU40 372
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BU40 373
TEMPP=TEMPP-STEPP#                     Backup to last match             BU40 374
LB=NINT(QX(TEMPP+4)); HIT(LB)=no:#     Cancel this hit                  BU40 375
JB=NINT(QX(TEMPP+5)); HIT(JB)=no:#     Cancel this hit                  BU40 376
IF(QX(TEMPP+18)<9999.)#                Test if translation calculated   BU40 377
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BU40 378
CTRA=CTRA-1.; STRA=STRA-QX(TEMPP+18)#  Reset average translation        BU40 379
AVT=STRA/MAX(1.,CTRA)#                 Find previous average            BU40 380
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BU40 381
STARTJ=JB; STARTL=JB#                  Reset for fresh pass             BU40 382
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BU40 383
BAD=0;  PLANE=no:#                     Initial values                   BU40 384
IF(TEMPP==STARP) NEXT#                 Are there stored values?         BU40 385
PLANE=NINT(QX(TEMPP-STEPP+7))#         Restore plane equ status         BU40 386
BAD=  NINT(QX(TEMPP-STEPP+8))#         Bad count from prior             BU40 387
IF(PLANE==no:) CTRA=0.#                Signal no translation check      BU40 388
#                                                                       BU40 389
#   END OF PLANE SEARCH LOOP                                            BU40 390
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BU40 391
ELSE#                                  Fast search failed               BU40 392
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BU40 393
#                                                                       BU40 394
#  TAKE A BIG BACKSTEP                                                  BU40 395
#                                                                       BU40 396
FOR(TEMPP=TEMPP-STEPP;TEMPP>=STARP+(SKIPSTRT+PLANESTRT)*STEPP;$#        BU40 397
    TEMPP=TEMPP-STEPP)#                                                 BU40 398
#                                      Cancel fast search matches       BU40 399
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 BU40 400
LB=NINT(QX(TEMPP+4)); HIT(LB)=no:#     Cancel this hit                  BU40 401
JB=NINT(QX(TEMPP+5)); HIT(JB)=no:#     Cancel this hit                  BU40 402
STRA=STRA-QX(TEMPP+18)#                Remove contribution              BU40 403
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 BU40 404
TEMPP=TEMPP+STEPP#                     Include latest good hit          BU40 405
CTRA = SKIPSTRT+PLANESTRT#             Simplest method                  BU40 406
AVT=STRA/CTRA#                         Find previous average            BU40 407
STARTJ=JB; STARTL=JB#                  Reset for fresh pass             BU40 408
BAD=0;  PLANE=no:#                     Initial values                   BU40 409
SKIP=0#                                Back to slow search              BU40 410
IF(N>3\DEBUG>=1) WRITE(6,1092) STARTJ,LB,AVT,CTRA#                      BU40 411
1092 FORMAT('***Slow search****',2I5,2F8.4)#                            BU40 412
PLANE=NINT(QX(TEMPP-STEPP+7))#         Restore plane equ status         BU40 413
BAD=  NINT(QX(TEMPP-STEPP+8))#         Bad count from prior             BU40 414
IF(PLANE==no:) CTRA=0.#                Signal no translation check      BU40 415
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BU40 416
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU40 417
#                                                                       BU40 418
#    SEARCH TERMINATED                                                  BU40 419
#    -----------------                                                  BU40 420
#                                                                       BU40 421
IF(MODE==2)#                           Second time through              BU40 422
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 BU40 423
#                                                                       BU40 424
#   CHECK IF REMATCHING WAS SUCCESSFUL                                  BU40 425
#                                                                       BU40 426
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU40 427
IF(K<ISET)#                            Was an abject failure            BU40 428
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 BU40 429
STARP=SAVEP;TEMPP=STEMPP#              Back to stored list              BU40 430
#MODE=1#                                BACK TO SEARCH MODE             BU40 431
TESTP=STARP+2*STEPP#                   Reinitialise test len            BU40 432
CTRA=SCTRA;STRA=SSTRA#                 Restore trans data               BU40 433
DO I=1,ANUM;HIT(I)=SHIT(I)#            Restore hit array                BU40 434
#                                                                       BU40 435
# SEARCH HAS TO RESUME AS THOUGH THE LAST MATCH WAS BAD                 BU40 436
#                                                                       BU40 437
IF(N>3\DEBUG==1)WRITE(6,1110) STARP,TEMPP,CTRA,STRA#                    BU40 438
1110 FORMAT(' MODE 2 FAILS',2I6,2F6.3)#                                 BU40 439
RESTART=yes:; BREAK#                   Jump back in                     BU40 440
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 BU40 441
ELSE IF(N>3\DEBUG==1) WRITE(6,1120)#   Tell user                        BU40 442
1120 FORMAT('MODE 2 PASSES')#                                           BU40 443
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 BU40 444
IF(TEMPP==STARP) BREAK#                No matches                       BU40 445
SCTRA=CTRA;SSTRA=STRA#                 Save translations                BU40 446
CALL BU31#                             Calculate plane equ data         BU40 447
AVEDEV=0.; DEVDEV=0.#                  Initialise deviation stats       BU40 448
AVETRA=0.; DEVTRA=0.#                  Initialise deviation stats       BU40 449
FOR(II=STARP;II<TEMPP;II=II+STEPP)#    Go over current chain            BU40 450
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 BU40 451
JJ=NINT(QX(II+5))#                     Extract column pointer           BU40 452
LL=NINT(QX(II+4))#                     Extract row pointer              BU40 453
JA=MARKA+(JJ-1)*STEPA#                 Point to atom info               BU40 454
LA=MARKA+(LL-1)*STEPA#                 Point to atom info               BU40 455
#                                                                       BU40 456
TRANS=0.; DIST=0.; D=0.#               Initialise distances             BU40 457
DO I=1,3; V(I)=(QX(JA+2+I)-QX(LA+2+I))# Calculate vector coords         BU40 458
DO I=1,3; Q(I)=0.#                     Zero value                       BU40 459
DO I=1,3; DO J=1,3#                    Convert to orthogonal angstrom   BU40 460
Q(I)=Q(I)+TF(I,J)*V(J)#                Interatom vector in ortho angs   BU40 461
DO I=1,3; DIST=DIST+Q(I)**2#           Find vector length               BU40 462
DO I=1,3; TRANS=TRANS+Q(I)*TM(I)#      Project vector onto normal       BU40 463
DO I=1,3; U(I)=QX(II+I)-OX(I)#         Shifted midpoint coord           BU40 464
DO I=1,3; D=D+U(I)*TM(I)#              Deviation from plane             BU40 465
TRANS=SQRT(ABS(DIST-TRANS**2))#        If q,normal parallel trans=di    BU40 466
IF(N>3)WRITE(6,1100) Q,D,DIST,TRANS#                                    BU40 467
1100 FORMAT(' VEC',6F10.5)#                                             BU40 468
#                                                                       BU40 469
AVEDEV=AVEDEV+ABS(D)#                  Accumulate sum                   BU40 470
DEVDEV=DEVDEV+D**2#                    Accumulate squares               BU40 471
AVETRA=AVETRA+TRANS#                   Accumulate translations          BU40 472
DEVTRA=DEVTRA+TRANS**2#                Accumulate squares               BU40 473
IF(QX(II+6)>0.) QX(II+6)= ABS(D)#      Store d for later                BU40 474
ELSE            QX(II+6)=-ABS(D)#      Store d for later                BU40 475
IF(MODE==2)#                           For printout                     BU40 476
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 BU40 477
QX(II+7)=TRANS#                        Store translation                BU40 478
#                                                                       BU40 479
DO I=1,3; U(I)=0.#                     Reinitialise temp coords         BU40 480
DO I=1,3; DO KK=1,3; U(I)=U(I)+FT(I,KK)*QX(II+KK)# Make fractional      BU40 481
DO I=1,3; QX(II+I)=U(I)#               Restore fractional coords        BU40 482
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 BU40 483
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 BU40 484
A=FLOAT((TEMPP-STARP)/STEPP)#          Length of chain                  BU40 485
AVEDEV=AVEDEV/A#                       Average deviation                BU40 486
DEVDEV=ABS((DEVDEV/A)-AVEDEV**2)#      Approximate deviation            BU40 487
IF(DEVDEV>small:) DEVDEV=SQRT(DEVDEV)#                                  BU40 488
ELSE              DEVDEV=0.0#                                           BU40 489
AVETRA=AVETRA/A#                       Average translation              BU40 490
DEVTRA=ABS((DEVTRA/A)-AVETRA**2)#      Approximate sigma translation    BU40 491
IF(DEVTRA>small:) DEVTRA=SQRT(DEVTRA)#                                  BU40 492
ELSE              DEVTRA=0.0#                                           BU40 493
IF(MODE==2) BREAK#                     Don't reset values               BU40 494
CTRA=0.; STRA=0; AVT=AVETRA#           Set the best translation         BU40 495
STEMPP=TEMPP;SAVEP=STARP#              Save current chain limits        BU40 496
STARP=TEMPP+STEPP#                     New beginning for refined chai   BU40 497
TEMPP=STARP#                           Start with no matches            BU40 498
IF(N>3\DEBUG>=1) WRITE(6,1458) SKIP#                                    BU40 499
1458 FORMAT('Starting Mode 2 refinement; Skip =',I3)#                   BU40 500
DO I=1,ANUM#                           Loop over hits array             BU40 501
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 BU40 502
SHIT(I)= HIT(I)#                       Save hit value                   BU40 503
HIT(I)=no:#                            Reset for refine loop            BU40 504
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 BU40 505
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU40 506
IF(RESTART==yes:) NEXT#                Restart mode cycle               BU40 507
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU40 508
MCNT(2,MODEC)=K#                       Store number of matches          BU40 509
IF(ITEST==2\MODEC==2\K==ANUM) BREAK#   Intra mode or all matched        BU40 510
MODEC=2#                               Force intra cluster search       BU40 511
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU40 512
#                                                                       BU40 513
#     OUTPUT SOLUTION                                                   BU40 514
#     ---------------                                                   BU40 515
#                                                                       BU40 516
IF(TEMPP>STARP&PLANE==yes:)#           If any matches found             BU40 517
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 BU40 518
IF(K==ANUM)#                           If a full house                  BU40 519
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 BU40 520
FINAL=yes:;  JPLAN=10#                 This is a wrap!                  BU40 521
writeline:(1,BU401,NBU401,3,3)#        All sites matched                BU40 522
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 BU40 523
ELSE#                                                                   BU40 524
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 BU40 525
ncodefld:(FLOAT(K   ),1,BU406,260313.,1)# Insert hit count              BU40 526
ncodefld:(FLOAT(ANUM),1,BU406,370313.,1)# Insert hit count              BU40 527
writeline:(1,BU406,NBU406,3,3)#        Tell user                        BU40 528
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 BU40 529
#                                                                       BU40 530
writeline:(1,BU402,NBU402,3,3)#        Tell user                        BU40 531
ncodefld:(TM,1,CHROT,FMT,4)#           Equation in orthog angst         BU40 532
writeline:(0,0,0,1,3)#                 Tell user                        BU40 533
#                                                                       BU40 534
writeline:(1,BU403,NBU403,3,3)#        Tell user                        BU40 535
CHROT=BU408#                           Equation header                  BU40 536
ncodefld:(AVEDEV,1,CHROT,FMT(4),1)#    Deviation in orthog angst        BU40 537
ncodefld:(AVETRA,1,CHROT,FMT(5),1)#    Deviation in orthog angst        BU40 538
writeline:(0,0,0,1,3)#                 Tell user                        BU40 539
CHROT=BU409#                           Equation header                  BU40 540
ncodefld:(DEVDEV,1,CHROT,FMT(4),1)#    Translation in orthog angst      BU40 541
ncodefld:(DEVTRA,1,CHROT,FMT(5),1)#    Translation in orthog angst      BU40 542
writeline:(0,0,0,1,3)#                 Tell user                        BU40 543
#                                                                       BU40 544
#   INTEPRET RESULTS                                                    BU40 545
#                                                                       BU40 546
#IF(DEVTRA>0.25) WRITELINE:(1,BU415,NBU415,3,3)# UNTRUSTWORTHY          BU40 547
#ELSE#                                                                  BU40 548
#$(#                                                                    BU40 549
CDIM(1)=SQRT(G1);CDIM(2)=SQRT(G2);CDIM(3)=SQRT(G3)# Cell dimensions     BU40 550
D=0.#                                                                   BU40 551
DO II=1,3#                                                              BU40 552
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 BU40 553
TMF(II)=0.; Q(II)=0.#                  Initialise fractional plane      BU40 554
DO KK=1,3; TMF(II)=TMF(II)+FT(II,KK)*TM(KK)# Normal in frac             BU40 555
DO KK=1,3; Q(II)=Q(II)+FT(II,KK)*TM(KK)*TM(4)# Pt on plane              BU40 556
IF(ABS(TMF(II))>D) D=ABS(TMF(II))#                                      BU40 557
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 BU40 558
DO II=1,3;V(II)=TMF(II)/D#             Normalise fractional normal      BU40 559
D=0.#                                                                   BU40 560
DO II=1,3;D=D+TMF(II)**2#              Length of fractional normal      BU40 561
DO II=1,3;TMF(II)=TMF(II)/SQRT(D)#     Normalise fractional normal      BU40 562
writeline:(1,BU417,NBU417,3,3)#        Tell user                        BU40 563
ncodefld:(V,1,CHROT,FMT,3)#            Equation in fractional coords    BU40 564
writeline:(0,0,0,1,3)#                 Tell user                        BU40 565
D=0.0#                                 Initialise length                BU40 566
DO II=1,3;D=D+Q(II)**2#                Distance to plane                BU40 567
TMF(4)=SQRT(D)#                                                         BU40 568
#                                                                       BU40 569
DEV=MAX(3*DEVTRA,0.1)#                 Give resonable margin            BU40 570
IF((ABS(AVETRA)-DEV<0.)&(ABS(AVETRA)>0.5)) MIRROR=yes:# Mirror plane    BU40 571
ELSE                        MIRROR=no:# Is a glide plane                BU40 572
#                                                                       BU40 573
#  DETERMINE PLANE ORIENTATION BASED ON LENGTH OF DOT PRODUCT           BU40 574
#                                                                       BU40 575
DO PLTYPE=1,3#                         Loop over cell axes              BU40 576
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 BU40 577
D=0.0#                                                                  BU40 578
DO II=1,3;D=D+TM(II)*TF(II,PLTYPE)#    Calculate dot product            BU40 579
IF (ABS(ABS(D)-CDIM(PLTYPE))/CDIM(PLTYPE)<0.1) BREAK# 10% tolerance     BU40 580
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 BU40 581
#                                                                       BU40 582
# CHECK FOR OBLIQUE PLANES                                              BU40 583
#                                                                       BU40 584
IF(PLTYPE>3)#                          Only if no plane found           BU40 585
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 BU40 586
PLTYPE=PLTYPE-1#                       To form unbroken series          BU40 587
DO I=1,3#                              Look for single zeroes           BU40 588
IF(ABS(TMF(I))<0.1) BREAK#             Found a single zero              BU40 589
PLTYPE=PLTYPE+I#                       Remember plane type              BU40 590
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 BU40 591
IF(PLTYPE>=7) writeline:(1,BU413,NBU413,3,3)# Tell user no go           BU40 592
ELSE#                                                                   BU40 593
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 BU40 594
movechar:(BU416,PLTYPE,BU410,46,1,0)#  Encode perp axis                 BU40 595
#                                                                       BU40 596
#       DISPLACEMENT FOUND; IF GLIDE, TRY TO DETERMINE TYPE             BU40 597
#       DECIDE ON A,B,C,N OR D GLIDE                                    BU40 598
#       THIS SEARCH IS BASED ON TABLE 1.3 OF INT TABLES VOL A.          BU40 599
#                                                                       BU40 600
IF(MIRROR==no:)#                       Is a glide plane                 BU40 601
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 BU40 602
#                                                                       BU40 603
#   CALCULATE SUM OF UNIT CELL LENGTHS FOR N AND D GLIDE TESTS          BU40 604
#   CALCULATED IN SAME ORDER AS THEY APPEAR ON P 6 OF IT VOL A          BU40 605
#                                                                       BU40 606
CALL BU41(1.,1.,0.,LNT(1));   CALL BU41(0.,1.,1.,LNT(2))#               BU40 607
CALL BU41(1.,0.,1.,LNT(3));   CALL BU41(1.,1.,1.,LNT(4))#               BU40 608
CALL BU41(-1.,1.,1.,LNT(5));  CALL BU41(1.,-1.,1.,LNT(6))#              BU40 609
CALL BU41(1.,1.,-1.,LNT(7));  CALL BU41(1.,-1.,0.,LNT(9))#              BU40 610
CALL BU41(0.,1.,-1.,LNT(11)); CALL BU41(-1.,0.,1.,LNT(13))#             BU40 611
CALL BU41(1.,1.,-1.,LNT(15)); CALL BU41(-1.,1.,1.,LNT(17))#             BU40 612
CALL BU41(1.,-1.,1.,LNT(19)); CALL BU41(-1.,1.,-1.,LNT(21))#            BU40 613
CALL BU41(-1.,-1.,1.,LNT(23));CALL BU41(1.,-1.,-1.,LNT(25))#            BU40 614
LNT(8)=LNT(1);LNT(10)=LNT(2);LNT(12)=LNT(3)#                            BU40 615
LNT(14)=LNT(4);LNT(16)=LNT(4);LNT(18)=LNT(4)#                           BU40 616
LNT(20)=LNT(17);LNT(22)=LNT(19);LNT(24)=LNT(15)#                        BU40 617
#                                                                       BU40 618
GLIDE1='x';   GLIDE2='x'#              Signals glide unknown            BU40 619
#                                                                       BU40 620
IF((PLTYPE==2\PLTYPE==3)&ABS(ABS(AVETRA)-CDIM(1)/2)< DEV)# A gli        BU40 621
GLIDE1='a'#                            Store name                       BU40 622
#                                                                       BU40 623
IF((PLTYPE==1\PLTYPE==3)&ABS(ABS(AVETRA)-CDIM(2)/2)< DEV)# B gli        BU40 624
IF(GLIDE1=='x') GLIDE1='b'#            Store name                       BU40 625
ELSE            GLIDE2='b'#            Another solution                 BU40 626
#                                                                       BU40 627
IF((PLTYPE==1\PLTYPE==2)&ABS(ABS(AVETRA)-CDIM(3)/2)< DEV)# C gli        BU40 628
IF(GLIDE1=='x') GLIDE1='c'#            Store name                       BU40 629
ELSE            GLIDE2='c'#            Another solution                 BU40 630
#                                                                       BU40 631
IF((PLTYPE==6 & ABS(ABS(TMF(1))-ABS(TMF(2)))<0.1) & $# Test equalit     BU40 632
ABS(ABS(AVETRA)-CDIM(3)/2)< DEV)#      C glide                          BU40 633
IF(GLIDE1=='x') GLIDE1='c'#            Store name                       BU40 634
ELSE            GLIDE2='c'#            Another solution                 BU40 635
#                                                                       BU40 636
IF(PLTYPE==6 & $#                                                       BU40 637
(ABS(TMF(2)-2*TMF(1))<0.1 \ ABS(TMF(1)-2*TMF(1))<0.1))# C glide (hex)   BU40 638
IF(GLIDE1=='x') GLIDE1='c'#            Store name                       BU40 639
ELSE            GLIDE2='c'#            Another solution                 BU40 640
#                                                                       BU40 641
ELSE IF((PLTYPE==1 & ABS(ABS(AVETRA)-LNT(2)/2)< DEV)$#                  BU40 642
\(PLTYPE==2 & ABS(ABS(AVETRA)-LNT(3)/2)< DEV)$#                         BU40 643
\(PLTYPE==3 & ABS(ABS(AVETRA)-LNT(1)/2)< DEV))# N glide                 BU40 644
IF(GLIDE1=='x') GLIDE1='n'#            Store name                       BU40 645
ELSE            GLIDE2='n'#            Another solution                 BU40 646
#                                                                       BU40 647
ELSE IF((PLTYPE==4 & ABS(TMF(3)-TMF(2))<0.1 &$#                         BU40 648
 ABS(ABS(AVETRA)-LNT(6)/2)<0.1)\$#                                      BU40 649
         (PLTYPE==5 & ABS(TMF(1)-TMF(3))<0.1 &$#                        BU40 650
 ABS(ABS(AVETRA)-LNT(7)/2)<0.1)\$#                                      BU40 651
         (PLTYPE==6 & ABS(TMF(1)-TMF(2))<0.1 &$#                        BU40 652
 ABS(ABS(AVETRA)-LNT(5)/2)<0.1))#      N glide                          BU40 653
IF(GLIDE1=='x') GLIDE1='n'#            Store name                       BU40 654
ELSE            GLIDE2='n'#            Another solution                 BU40 655
#                                                                       BU40 656
ELSE IF(((PLTYPE==4 & ABS(TMF(3)+TMF(2))<0.1)\$#                        BU40 657
         (PLTYPE==5 & ABS(TMF(1)+TMF(3))<0.1)\$#                        BU40 658
         (PLTYPE==6 & ABS(TMF(1)+TMF(2))<0.1))&$#                       BU40 659
ABS(ABS(AVETRA)-LNT(4)/2)<3 * DEVTRA)# N glide                          BU40 660
IF(GLIDE1=='x') GLIDE1='n'#            Store name                       BU40 661
ELSE            GLIDE2='n'#            Another solution                 BU40 662
#                                                                       BU40 663
ELSE IF((PLTYPE==1 & $#                                                 BU40 664
           (ABS(ABS(AVETRA)-LNT(10)/4)< DEV $#                          BU40 665
           \ABS(ABS(AVETRA)-LNT(11)/4)< DEV))$#                         BU40 666
  \(PLTYPE==2 & $#                                                      BU40 667
           (ABS(ABS(AVETRA)-LNT(12)/4)< DEV $#                          BU40 668
           \ABS(ABS(AVETRA)-LNT(13)/4)< DEV))$#                         BU40 669
  \(PLTYPE==3 & $#                                                      BU40 670
           (ABS(ABS(AVETRA)-LNT(8)/4)< DEV $#                           BU40 671
           \ABS(ABS(AVETRA)-LNT(9)/4)< DEV))$#                          BU40 672
  \(PLTYPE==4 & $#                                                      BU40 673
           (ABS(TMF(2)+TMF(3))<0.1 & $#                                 BU40 674
           (ABS(ABS(AVETRA)-LNT(16)/4)< DEV $#                          BU40 675
           \ABS(ABS(AVETRA)-LNT(17)/4)< DEV))$#                         BU40 676
           \(ABS(TMF(2)-TMF(3))<0.1 & $#                                BU40 677
            (ABS(ABS(AVETRA)-LNT(22)/4)< DEV $#                         BU40 678
            \ABS(ABS(AVETRA)-LNT(23)/4)< DEV)))$#                       BU40 679
  \(PLTYPE==5 & $#                                                      BU40 680
           (ABS(TMF(1)+TMF(3))<0.1 & $#                                 BU40 681
           (ABS(ABS(AVETRA)-LNT(18)/4)< DEV $#                          BU40 682
           \ABS(ABS(AVETRA)-LNT(19)/4)< DEV))$#                         BU40 683
           \(ABS(TMF(1)-TMF(3))<0.1 & $#                                BU40 684
            (ABS(ABS(AVETRA)-LNT(24)/4)< DEV $#                         BU40 685
            \ABS(ABS(AVETRA)-LNT(25)/4)< DEV)))$#                       BU40 686
  \(PLTYPE==6 & $#                                                      BU40 687
           (ABS(TMF(1)+TMF(2))<0.1 & $#                                 BU40 688
           (ABS(ABS(AVETRA)-LNT(14)/4)< DEV $#                          BU40 689
           \ABS(ABS(AVETRA)-LNT(15)/4)< DEV))$#                         BU40 690
           \(ABS(TMF(1)-TMF(2))<0.1 & $#                                BU40 691
            (ABS(ABS(AVETRA)-LNT(20)/4)< DEV $#                         BU40 692
            \ABS(ABS(AVETRA)-LNT(21)/4)< DEV))))# D glide               BU40 693
IF(GLIDE1=='x') GLIDE1='d'#            Store name                       BU40 694
ELSE            GLIDE2='d'#            Another solution                 BU40 695
#                                                                       BU40 696
IF(GLIDE1=='x') writeline:(0,BU414,NBU414,3,3)# Tell user no ideas      BU40 697
ELSE#                                  We know the glide type           BU40 698
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 BU40 699
movechar:(BU412,1,BU410,15,7,0)#       Insert glide header              BU40 700
movechar:(GLIDE1,1,BU410,15,1,0)#      Insert glide type                BU40 701
writeline:(1,BU410,NBU410,3,3)#        Signal the glide                 BU40 702
IF(GLIDE2!='x')#                       Check for alternate              BU40 703
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 BU40 704
movechar:(GLIDE2,1,BU410,15,1,0)#      Insert glide type                BU40 705
writeline:(0,BU410,NBU410,3,3)#        Signal the glide                 BU40 706
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 BU40 707
IF(PLTYPE<4)#                          Recognise plane?                 BU40 708
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 BU40 709
ncodefld:(TM(4)/CDIM(PLTYPE),1,BU411,300322.,1)# Displacement           BU40 710
movechar:(BU416,PLTYPE,BU411,32,1,0)#  Put in axis name                 BU40 711
writeline:(0,BU411,NBU411,3,3)#        Tell user glide info             BU40 712
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 BU40 713
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 BU40 714
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 BU40 715
ELSE#                                  This is a mirror                 BU40 716
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 BU40 717
movechar:(BU412,8,BU410,15,7,0)#       Insert mirror header             BU40 718
writeline:(0,BU410,NBU410,3,3)#        Tell user mirror info            BU40 719
IF(PLTYPE<4)#                          Recognise plane?                 BU40 720
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 BU40 721
ncodefld:(TM(4)/CDIM(PLTYPE),1,BU411,300322.,1)# Displacement           BU40 722
movechar:(BU416,PLTYPE,BU411,32,1,0)#  Put in axis name                 BU40 723
writeline:(0,BU411,NBU411,3,3)#        Tell user glide info             BU40 724
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 BU40 725
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 BU40 726
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 BU40 727
#$)#                                                                    BU40 728
#                                                                       BU40 729
#                                                                       BU40 730
LINRM=3#                                                                BU40 731
writeline:(1,BU400,NBU400,3,3)#        Tell user                        BU40 732
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Output points                    BU40 733
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 BU40 734
II=MARKA+(NINT(QX(I+4))-1)*STEPA#      Atom pointer                     BU40 735
JJ=MARKA+(NINT(QX(I+5))-1)*STEPA#      Atom pointer                     BU40 736
movertoc:(na:(JJ),1,CHROT,2,8,0)#      Output atom name                 BU40 737
movertoc:(na:(II),1,CHROT,9,8,0)#      Output atom name                 BU40 738
ncodefld:(QX,I+1,CHROT,FMT,3)#         Encode midpoint                  BU40 739
IF(QX(I+6)<0.) CHROT(70^70)='*'#       This one was rejected            BU40 740
ELSE           CHROT(70^70)=' '#       Otherwise ok                     BU40 741
QX(I+6)=ABS(QX(I+6))#                  Remove any negative flag         BU40 742
ncodefld:(QX,I+6,CHROT,FMT(4),1)#      Encode deviation                 BU40 743
ncodefld:(QX,I+7,CHROT,FMT(5),1)#      Encode translation               BU40 744
writeline:(0,0,0,1,3)#                 Output midpoint                  BU40 745
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 BU40 746
##                                                                      BU40 747
#          OUTPUT DATA TO SCRATCH FILE                                  BU40 748
#          ---------------------------                                  BU40 749
#                                                                       BU40 750
IF(ITEST==2)#                          For last cycle only              BU40 751
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 BU40 752
#                                                                       BU40 753
#     INITIALISE SCRATCH FILE                                           BU40 754
#     -----------------------                                           BU40 755
#                                                                       BU40 756
IF(WROTE==no:)#                        If no header yet written         BU40 757
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 BU40 758
copyfile:(1,3,1,1)#                    Copy history                     BU40 759
writepkt:(3,lrgraf:,18,IP)#            Prepare lrgraf: record           BU40 760
DO I=1,9;QX(IP+I  )=FLOAT( 20+I)#      Lrgraf: directory                BU40 761
DO I=1,9;QX(IP+I+9)=FLOAT(120+I)#      Lrgraf: directory                BU40 762
writepkt:(3,lrgraf:,18,IP)#            Prepare orientation matrix       BU40 763
DO I=1,18;QX(IP+I)=0.#                 Make identity matrix             BU40 764
QX(IP+ 1)=1.;QX(IP+ 5)=1.;QX(IP+ 9)=1.# Make identity matrix            BU40 765
QX(IP+10)=1.;QX(IP+14)=1.;QX(IP+18)=1.# Make identity matrix            BU40 766
#                                                                       BU40 767
PSIZ=5+lablen:#                        Set output packet size           BU40 768
writepkt:(3,lratom:,PSIZ,IP)#          Get next output packet           BU40 769
DO I=1,3;QX(IP+I)=FLOAT(I)#            Positions into directory         BU40 770
DO I=1,lablen:#                        Atom label length in words       BU40 771
QX(IP+3+I)=14.#                        Atom name into directory         BU40 772
QX(IP+4+lablen:)=22.#                  Scattering factor pointer        BU40 773
QX(IP+5+lablen:)=23.#                  Thermal parameter type for ort   BU40 774
WROTE=yes:#                            Flag header written              BU40 775
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 BU40 776
#                                                                       BU40 777
DO I=1,3#                              Loop over coordinates            BU40 778
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 BU40 779
MAXMPA(I)=0;MINMPA(I)=9999.#           Initialise max/min coord         BU40 780
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 BU40 781
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over solution               BU40 782
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 BU40 783
LA=MARKA+(NINT(QX(I+4))-1)*STEPA#      Atom pointer for row             BU40 784
JA=MARKA+(NINT(QX(I+5))-1)*STEPA#      Atom pointer for column          BU40 785
DO II=1,3;Q(II)=0.#                    Initialise ortho coords          BU40 786
DO II=1,3#                             Loop over coordinates            BU40 787
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 BU40 788
DO KK=1,3#                             Loop over coordinates            BU40 789
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 BU40 790
Q(II)=Q(II)+TF(II,KK)*xf:(LA-1+KK)#    Convert to ortho angs            BU40 791
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 BU40 792
MAXMPA(II)=MAX(Q(II),MAXMPA(II))#      Get maximum coordinate           BU40 793
MINMPA(II)=MIN(Q(II),MINMPA(II))#      Get minimum coordinate           BU40 794
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 BU40 795
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 796
movereal:(xf:(LA),1,QX,IP+1,3,1)#      Store first atom coords          BU40 797
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU40 798
movereal:(na:(LA),1,QX,IP+4,2,1)#      Store name                       BU40 799
movereal:(ty:(LA),1,QX,IP+4+lablen:,1,1)# Store type                    BU40 800
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 801
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 802
#                                                                       BU40 803
movereal:(xf:(JA),1,QX,IP+1,3,0)#      Store second atom coords         BU40 804
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU40 805
movereal:(na:(JA),1,QX,IP+4,2,1)#      Store name                       BU40 806
movereal:(ty:(JA),1,QX,IP+4+lablen:,1,1)# Store type                    BU40 807
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 808
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 BU40 809
#                                                                       BU40 810
#         OUTPUT PLANE TO SCRATCH FILE                                  BU40 811
#         ---------------------------                                   BU40 812
#                                                                       BU40 813
SMAX=0.#                               Initialise smax#                 BU40 814
DO II=1,3;Q(II)=0.#                    Initialise q                     BU40 815
DO II=1,3#                             Loop over plane values           BU40 816
IF(TM(II)>SMAX)#                       Get most perpendicular side      BU40 817
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 BU40 818
JJ=II#                                 Get most perpendicular side      BU40 819
SMAX=TM(II)#                           Set new maximum                  BU40 820
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 BU40 821
KK=MOD(JJ,3)+1#                        Choose another side              BU40 822
LL=MOD(KK,3)+1#                        And another side                 BU40 823
Q1(KK)=MAXMPA(KK)#                     Get component                    BU40 824
Q1(LL)=MAXMPA(LL)#                     Know these components already    BU40 825
Q1(JJ)=(TM(LL)*Q1(LL)+TM(KK)*Q1(KK)-TM(4))/(-1*TM(JJ))# Missing comp    BU40 826
#                                                                       BU40 827
Q2(LL)=MAXMPA(LL)#                     Get another side                 BU40 828
Q2(KK)=MINMPA(KK)#                     Get another point                BU40 829
Q2(JJ)=(TM(LL)*Q2(LL)+TM(KK)*Q2(KK)-TM(4))/(-1*TM(JJ))# Missing comp    BU40 830
#                                                                       BU40 831
Q3(KK)=MINMPA(KK)#                     Get another point                BU40 832
Q3(LL)=MINMPA(LL)#                     Get another point                BU40 833
Q3(JJ)=(TM(LL)*Q3(LL)+TM(KK)*Q3(KK)-TM(4))/(-1*TM(JJ))# Missing comp    BU40 834
#                                                                       BU40 835
Q4(KK)=MAXMPA(KK)#                     Get another point                BU40 836
Q4(LL)=MINMPA(LL)#                     Get another point                BU40 837
Q4(JJ)=(TM(LL)*Q4(LL)+TM(KK)*Q4(KK)-TM(4))/(-1*TM(JJ))# Missing comp^   BU40 838
#                                                                       BU40 839
D=0.#                                  Initialise vector length         BU40 840
DO II=1,3#                                                              BU40 841
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 BU40 842
S(II)=-(Q1(II)-Q3(II))/2 + Q1(II)#     Find centre of plane             BU40 843
D=D+(Q1(II)-S(II))**2#                 Get diagonal length              BU40 844
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 BU40 845
D=2.5/SQRT(D)#                         Make                             BU40 846
#                                                                       BU40 847
DO II=1,3;P(II)=0#                     Initialise fractionals           BU40 848
DO II=1,3;Q(II)=D* (Q1(II)-S(II))+ S(II)# Find first point              BU40 849
DO II=1,3;DO MM=1,3;P(II)=P(II)+FT(II,MM)*Q(MM)# Convert to fractiona   BU40 850
MPTNME='PLANE1                  '#     Write first point to file        BU40 851
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 852
movereal:(P,1,QX,IP+1,3,0)#            Store endpoint                   BU40 853
movector:(MPTNME,1,QX(IP+4),1,24,0)#   Store name                       BU40 854
QX(IP+4+lablen:)=-3.#                  Flag axis                        BU40 855
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 856
#                                                                       BU40 857
DO II=1,3;Q(II)=D* (Q2(II)-S(II))+ S(II)# Find second point             BU40 858
DO II=1,3;P(II)=0.#                    Reinitialise fractionals         BU40 859
DO II=1,3;DO MM=1,3;P(II)=P(II)+FT(II,MM)*Q(MM)# Convert to fractiona   BU40 860
MPTNME='PLANE2                  '#     Write second point to file       BU40 861
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 862
movereal:(P,1,QX,IP+1,3,0)#            Store endpoint                   BU40 863
movector:(MPTNME,1,QX(IP+4),1,24,0)#   Store name                       BU40 864
QX(IP+4+lablen:)=-3.#                  Flag axis                        BU40 865
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 866
#                                                                       BU40 867
DO II=1,3;Q(II)=D* (Q3(II)-S(II))+ S(II)# Find third point              BU40 868
DO II=1,3;P(II)=0.#                    Reinitialise fractionals     ^   BU40 869
DO II=1,3;DO MM=1,3;P(II)=P(II)+FT(II,MM)*Q(MM)# Convert to fractiona   BU40 870
MPTNME='PLANE3                  '#     Write second point to file       BU40 871
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 872
movereal:(P,1,QX,IP+1,3,0)#            Store endpoint                   BU40 873
movector:(MPTNME,1,QX(IP+4),1,24,0)#   Store name                       BU40 874
QX(IP+4+lablen:)=-3.#                  Flag axis                        BU40 875
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 876
#                                                                       BU40 877
DO II=1,3;Q(II)=D* (Q4(II)-S(II))+ S(II)# Find fourth point             BU40 878
DO II=1,3;P(II)=0.#                    Reinitialise fractionals         BU40 879
DO II=1,3;DO MM=1,3;P(II)=P(II)+FT(II,MM)*Q(MM)# Convert to fractiona   BU40 880
MPTNME='PLANE4                  '#     Write second point to file       BU40 881
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 882
movereal:(P,1,QX,IP+1,3,0)#            Store endpoint                   BU40 883
movector:(MPTNME,1,QX(IP+4),1,24,0)#   Store name                       BU40 884
QX(IP+4+lablen:)=-3.#                  Flag axis                        BU40 885
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 886
#                                                                       BU40 887
#                                                                       BU40 888
#         OUTPUT UNMATCHED ATOMS                                        BU40 889
#         ----------------------                                        BU40 890
#                                                                       BU40 891
DO I=1,ANUM#                                                            BU40 892
IF(HIT(I)==no:)#                                                        BU40 893
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 BU40 894
LA=MARKA+(I-1)*STEPA#                  Atom pointer                     BU40 895
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU40 896
movereal:(xf:(LA),1,QX,IP+1,3,1)#      Store atom coords                BU40 897
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU40 898
movereal:(na:(LA),1,QX,IP+4,2,1)#      Store name                       BU40 899
movereal:(ty:(LA),1,QX,IP+4+lablen:,1,1)# Store type                    BU40 900
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU40 901
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 BU40 902
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 BU40 903
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 BU40 904
ELSE writeline:(1,BU405,NBU405,3,3)#   Tell user no extra symmetry      BU40 905
#                                                                       BU40 906
RETURN#                                                                 BU40 907
END#                                                                    BU40 908
#                                                                       BU40 909
systemheader:(BU41)#                   Cell vector addition             BU41   1
################################################################        BU41   2
##                                                                      BU41   3
##            BU41                                                      BU41   4
##                                                                      BU41   5
################################################################        BU41   6
SUBROUTINE BU41(A,B,C,LENGTH)#         Sum lattice vectors              BU41   7
#                                                                       BU41   8
include:(BUCOMN)#                                                       BU41   9
#                                                                       BU41  10
INTEGER I#                                                              BU41  11
REAL A,B,C#                            Index of lattice vectors         BU41  12
REAL LENGTH#                           Length of sum                    BU41  13
REAL SUM(3)#                           Vector sum                       BU41  14
#                                                                       BU41  15
DO I=1,3;SUM(I)=A*TF(I,1)+B*TF(I,2)+C*TF(I,3)# Do vector sum            BU41  16
LENGTH=SQRT(SUM(1)**2+SUM(2)**2+SUM(3)**2)# Calculate length            BU41  17
RETURN#                                                                 BU41  18
END#                                                                    BU41  19
#                                                                       BU41  20
systemheader:(BU50)#                   Search for axis symmetry         BU50   1
################################################################        BU50   2
##                                                                      BU50   3
##                           BU50                                       BU50   4
##                                                                      BU50   5
################################################################        BU50   6
SUBROUTINE BU50#                                                        BU50   7
#                                                                       BU50   8
include:(AACOMN)#                                                       BU50   9
include:(BUCOMN)#                                                       BU50  10
#                                                                       BU50  11
INTEGER I,J,K,L,N,JB,LB#               Loop variables                   BU50  12
INTEGER II,JJ,KK,LL#                   More loop variables              BU50  13
INTEGER IA,JA,LA,TESTP#                Array markers                    BU50  14
INTEGER INCL,MODE#                     Increment                        BU50  15
INTEGER IP#                            Qx pointer                       BU50  16
INTEGER BAD,MINROW#                    Progress markers                 BU50  17
INTEGER STARTL,STARTJ#                 Beginning row and column         BU50  18
INTEGER AXIS,ISET#                     Flag point found                 BU50  19
INTEGER SCREW#                         Flag screw axis                  BU50  20
INTEGER LTYPE#                         Axis direction                   BU50  21
INTEGER INSPNT,RESTART#                String insertion point           BU50  22
INTEGER MODEC#                                                          BU50  23
INTEGER SAVEP,STEMPP#                  Saved match chain limits         BU50  24
INTEGER SHIT(1000)#                    Hit storage                      BU50  25
REAL DMAX,LIM2#                        Dist max and limit sqd           BU50  26
REAL P(3),Q(3),U(3),X(3)#              Temporary coordinates            BU50  27
REAL S(3),V(3)#                        Temporary coordinates            BU50  28
REAL AVEDEV,DEVDEV#                    Average, deviation               BU50  29
REAL AVETRA,DEVTRA#                    Average, deviation               BU50  30
REAL A,AVT,T,TOLD,DEV#                 Thresholds                       BU50  31
REAL ROWDIS,ROWTRA#                    Minimum distance whole row       BU50  32
REAL CTRA,STRA,DIS2#                   Translation sums                 BU50  33
REAL SCTRA,SSTRA#                      Saved translation sums           BU50  34
REAL MINMPA(3),MINMPF(3)#              Mdpt for minimum                 BU50  35
REAL MAXMPA(3)#                        For maximum coord value          BU50  36
REAL BADFLG,TRANS,DIST,D#              Translation along axis           BU50  37
REAL CDIM(3)#                          Cell dimension storage           BU50  38
REAL TMF(3),OXF(3)#                    Line in fractional coords        BU50  39
REAL INSFMT#                           Format for number insertion      BU50  40
REAL E#                                Axis endpoint calculation        BU50  41
REAL ENTR(3),EXTP(3)#                  Entry and exit points            BU50  42
#                                                                       BU50  43
realdata:(FMT,[281042.,381042.,481042.,581042.,701032.])#               BU50  44
chardata:(BU500,"                        x/a       y/b    $#            BU50  45
   z/c")#                                                               BU50  46
chardata:(BU501," ***** Axis found for ALL atom sites *****")#          BU50  47
chardata:(BU502," Equation AX+BY+CZ=0     A          B         C$#      BU50  48
        XYZ orthog Angstr.")#                                           BU50  49
chardata:(BU503,"            Mid-point deviation and translation$#      BU50  50
       dev(A)     tran(A)")#                                            BU50  51
chardata:(BU505," None found")#                                         BU50  52
chardata:(BU506," ***** Axis found for nnn out of nnn sites *****")#    BU50  53
chardata:(BU507," Search for rotor/screw axis")#                        BU50  54
chardata:(BU508,"                                        average")#     BU50  55
chardata:(BU509,"                                            esd")#     BU50  56
chardata:(BU510,"     Possible 2-fold SCREW parallel to the x axis")#   BU50  57
chardata:(BU511,"     displaced from origin by                    ")#   BU50  58
chardata:(BU512,"SCREWROTOR")#                                          BU50  59
chardata:(BU513,"abc")#                                                 BU50  60
chardata:(BU515,"    **Unable to interpret axis orientation**")#        BU50  61
chardata:(BU516," Translation variation too great for reliable axis")#  BU50  62
chardata:(BU517," Equation ax+by+cz=0     a          b         c$#      BU50  63
        xyz fractional")#                                               BU50  64
string:(MPTNME,24)#                                                     BU50  65
datastuff:#                                                             BU50  66
#                                                                       BU50  67
#     INITIALISE                                                        BU50  68
#     ----------                                                        BU50  69
#                                                                       BU50  70
movechar:('-',1,CHROT,2,NBU507-1,2)#   Insert header underline          BU50  71
writeline:(2,BU507,NBU507,2,3)#        Print start of search            BU50  72
LORP=1#                                We want lsq axiss                BU50  73
IF(ITEST==1) MODEC=IALL#               Set initial mode                 BU50  74
ELSE#                                  For last pass choose the best    BU50  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  BU50  76
IF(MCNT(3,1)>=MCNT(3,2)) MODEC=1#      Pick the most successful mode    BU50  77
ELSE                     MODEC=2#      Pick the most successful mode    BU50  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  BU50  79
RESTART=no:#                           This is a first run              BU50  80
#                                                                       BU50  81
#                                                                       BU50  82
#    LOOP OVER INTER OR INTRA CLUSTER SEARCHES                          BU50  83
#    -----------------------------------------                          BU50  84
#                                                                       BU50  85
REPEAT#                                Loop over inter and intra mode   BU50  86
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  BU50  87
IF(RESTART==yes:) GOTO 2000#           Test if a restart                BU50  88
#                                                                       BU50  89
BAD=0; BADFLG=1.; N=PPRIOR#            Initialise number of rejects     BU50  90
ISET=MIN(ANUM-1,MAX(2*ANUM/3,10))#     Define incr changeover           BU50  91
AXIS=no:;  DMAX=TOLC;  LIM2=LIMIT**2#  No axis equation yet             BU50  92
STEPP=18#                              Storage for best chain           BU50  93
MARKP=STOPM; STARP=MARKP#              Initialise current chain ptr     BU50  94
incrqx:(STOPP,MARKP+ANUM*STEPP,BU3005)# Make room for working chains    BU50  95
TEMPP=STARP#                           Initialise end of chain          BU50  96
DO I=1,ANUM; HIT(I)=no:#               Reset matched flags              BU50  97
CTRA=0.;  STRA=0.; TOLD=TOLC#          Zero translation sums            BU50  98
D=-1000.#                              Reset distance value             BU50  99
#                                                                       BU50 100
#                                                                       BU50 101
FOR(IA=MARKA;IA<STOPA;IA=IA+STEPA)#    Loop over atom list              BU50 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  BU50 103
IF(fr:<0.5) NEXT#                      Test if site at inversion        BU50 104
I=(IA-MARKA)/STEPA+1#                  Get the atom number              BU50 105
J=MARKM+(I-1)*STEPM+(I-1)*3#           Point to midpoint table          BU50 106
DO I=1,3; X(I)=QX(J+I)#                Get fractional midpoints         BU50 107
DO I=1,3; DO K=1,3; P(I)=P(I)+TF(I,K)*X(K)# Midpoint in ortho angs      BU50 108
QX(TEMPP+ 1)=P(1)#                     Midpoint x in orthog anstr       BU50 109
QX(TEMPP+ 2)=P(2)#                     Midpoint y in orthog anstr       BU50 110
QX(TEMPP+ 3)=P(3)#                     Midpoint z in orthog anstr       BU50 111
QX(TEMPP+ 4)=FLOAT(I)#                 Store row                        BU50 112
QX(TEMPP+ 5)=FLOAT(I)#                 Store column                     BU50 113
QX(TEMPP+ 6)=0.#                       Flag the bad matches             BU50 114
QX(TEMPP+ 7)=0.#                       Plane equ not known              BU50 115
QX(TEMPP+ 8)=0.#                       Remember hits                    BU50 116
QX(TEMPP+15)=X(1)#                     Midpt x in fractions             BU50 117
QX(TEMPP+16)=X(2)#                     Midpt y in fractions             BU50 118
QX(TEMPP+17)=X(3)#                     Midpt z in fractions             BU50 119
QX(TEMPP+18)=9999.#                    Translation unknown              BU50 120
TEMPP=TEMPP+STEPP#                     Update chain pointer             BU50 121
HIT(I)=yes:#                           Flag this as matched             BU50 122
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  BU50 123
2000 CONTINUE#                         Restart entry point              BU50 124
#                                                                       BU50 125
#     START SEARCH LOOP                                                 BU50 126
#     -----------------                                                 BU50 127
#                                                                       BU50 128
DO MODE=1,2#                           Loop search/refine modes         BU50 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  BU50 130
IF(RESTART==yes:) GOTO 1085#           Test if a restart                BU50 131
INCL=1; STARTL=1;  STARTJ=1#           Starting values                  BU50 132
JB=0;  LB=0#                           Reset bad pointers               BU50 133
TESTP=STARP+STEPP#                     Initialise test length           BU50 134
REPEAT#                                Loop over possible solutions     BU50 135
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  BU50 136
#                                                                       BU50 137
#    LOOP OVER MID-POINT MATRIX                                         BU50 138
#    --------------------------                                         BU50 139
#                                                                       BU50 140
DO J=STARTJ,ANUM#                      Loop over columns                BU50 141
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  BU50 142
IF(N>3)WRITE(6,1000) J,L,STARTJ,STARTL,HIT(J),JB,LB#                    BU50 143
1000 FORMAT(' J  ',8I5)#                                                BU50 144
IF(HIT(J)==no:)#                       Look for match                   BU50 145
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  BU50 146
ROWDIS=99999.#                         Initialise min distance          BU50 147
JA=MARKA+(J-1)*STEPA#                  Point to atom info               BU50 148
JJ=MARKM+(J-1)*STEPM#                  Set column pointer               BU50 149
IF(TEMPP>STARP)#                       Protect for mode 2               BU50 150
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  BU50 151
II=TEMPP-STEPP#                        Point to last entry              BU50 152
DO I=1,3; OX(I)=QX(II+ 8+I)#           Extract axis centroid            BU50 153
DO I=1,3; TM(I)=QX(II+11+I)#           Extract normal vector            BU50 154
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  BU50 155
#                                                                       BU50 156
DO L=STARTL     ,ANUM#                 Loop over rows                   BU50 157
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  BU50 158
IF(HIT(L)==yes:) NEXT#                 Skip if already matched          BU50 159
LA=MARKA+(L-1)*STEPA#                  Point to atom info               BU50 160
IF(JA!=LA)#                            If diff atom                     BU50 161
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 BU50 162
IF(MODEC==1)#                          If inter mode                    BU50 163
ifeq:(bn:(JA),bn:(LA)) NEXT#           Check on molecular cluster       BU50 164
ifne:(ty:(JA),ty:(LA)) NEXT#           Skip if no match                 BU50 165
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 BU50 166
LL=JJ+(L-1)*3#                         Set row pointer                  BU50 167
DO I=1,3; P(I)=0.#                     Initialise midpoint ortho coor   BU50 168
DO I=1,3; Q(I)=0.#                     Initialise centre ortho coords   BU50 169
DO I=1,3; X(I)=QX(LL+I)#               Get fractional midpoints         BU50 170
IF(TEMPP>STARP)#                       If point in chain                BU50 171
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 BU50 172
II=TEMPP-STEPP#                        Step back one midpoint           BU50 173
DO I=1,3; S(I)=diff:(X(I),QX(II+14+I))# Min fraction midpoint diff      BU50 174
DO I=1,3; X(I)=QX(II+14+I)+S(I)#       Get closest fract midpoint       BU50 175
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 BU50 176
#                                                                       BU50 177
#    IF NO AXIS EQUATION, STORE POINT IN CHAIN                          BU50 178
#    ------------------------------------------                         BU50 179
#                                                                       BU50 180
D=0.#                                  Reset distance value             BU50 181
IF(AXIS==no:)#                         Plane equ not known              BU50 182
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 BU50 183
IF(J==JB&L<=LB) NEXT#                  Cannot be bad match              BU50 184
ROWTRA=9999.#                          Reset unknown translation        BU50 185
DO I=1,3; DO K=1,3; P(I)=P(I)+TF(I,K)*X(K)# Midpt in ortho angs         BU50 186
QX(TEMPP+ 1)=P(1)#                     Midpoint x in orthog anstr       BU50 187
QX(TEMPP+ 2)=P(2)#                     Midpoint y in orthog anstr       BU50 188
QX(TEMPP+ 3)=P(3)#                     Midpoint z in orthog anstr       BU50 189
IF(TEMPP>=TESTP)#                      Enough points                    BU50 190
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 BU50 191
DO I=1,3; D=D+(P(I)-QX(II+I))**2#      Calculate projection onto line   BU50 192
IF(N>3)WRITE(6,1020) J,L,D,LIM2,S#                                      BU50 193
1020 FORMAT(' TES ',2I5,6F9.5)#                                         BU50 194
IF(D>LIM2)#                            We have found an axis            BU50 195
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 BU50 196
#                                                                       BU50 197
#  NOW CALCULATE AVERAGE TRANSLATION                                    BU50 198
#                                                                       BU50 199
AXIS=yes:#                             Flag axis found                  BU50 200
QX(TEMPP+4)=FLOAT(L)#                  For translation calculation      BU50 201
QX(TEMPP+5)=FLOAT(J)#                  For translation calculation      BU50 202
TEMPP=TEMPP+STEPP#                     Include latest in chain          BU50 203
IF(MODE==1) CALL BU31#                 Get axis with new chain          BU50 204
TEMPP=TEMPP-STEPP#                     Back to the way it was           BU50 205
STRA=0.;CTRA=0.#                       Initialise translation sum       BU50 206
DO II=STARP,TEMPP,STEPP#               Loop over atoms in chain         BU50 207
$(#                                    9>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 BU50 208
JA=MARKA+(QX(II+5)-1)*STEPA#           Point to atom info               BU50 209
LA=MARKA+(QX(II+4)-1)*STEPA#           Point to atom info               BU50 210
DO I=1,3; Q(I)=0#                      Initialise interatom vector      BU50 211
DO I=1,3; U(I)=(QX(JA+2+I)-QX(LA+2+I))# Calculate vector coords         BU50 212
DO I=1,3; DO K=1,3#                    Convert to orthogonal angstrom   BU50 213
Q(I)=Q(I)+TF(I,K)*U(K)#                Interatom vector in ortho angs   BU50 214
T=0.#                                  Initialise translation           BU50 215
DO I=1,3; T=T+Q(I)*TM(I)#              Project vector onto normal       BU50 216
STRA=STRA+ABS(T);CTRA=CTRA+1.#         Add to sum of translations       BU50 217
$)#                                    9<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 BU50 218
AVT=STRA/CTRA#                         New average translation          BU50 219
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 BU50 220
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 BU50 221
BREAK#                                                                  BU50 222
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 BU50 223
#                                                                       BU50 224
#                                                                       BU50 225
#   AXIS EQUATION KNOWN - FIT THIS MID-POINT                            BU50 226
#   -----------------------------------------                           BU50 227
#                                                                       BU50 228
ELSE#                                  If axis equation known           BU50 229
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 BU50 230
IF(J==JB&L<=LB) NEXT#                  Combination tried already        BU50 231
DO I=1,3; U(I)=(QX(JA+2+I)-QX(LA+2+I))# Calculate vector coords         BU50 232
DO I=1,3; DO K=1,3#                    Convert to orthogonal angstrom   BU50 233
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 BU50 234
P(I)=P(I)+TF(I,K)*X(K)#                Midpoint in ortho angs           BU50 235
Q(I)=Q(I)+TF(I,K)*U(K)#                Interatom vector in ortho angs   BU50 236
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 BU50 237
DIST=0.;  DIS2=0.; T=0.#               Initialise length i/atom vec     BU50 238
DO I=1,3; S(I)=P(I)-OX(I)#             Shifted midpoint in ortho angs   BU50 239
DO I=1,3; DIST=DIST+Q(I)**2#           Length of interatomic vector     BU50 240
DO I=1,3; DIS2=DIS2+S(I)**2#           Distance to centroid             BU50 241
DO I=1,3; D=D+S(I)*TM(I)#              Calculate distance from axis     BU50 242
DO I=1,3; T=T+Q(I)*TM(I)#              Calculate transl along axis      BU50 243
D=SQRT(ABS(DIS2-D**2))#                Get point-line distance          BU50 244
IF(N>3)WRITE(6,1050) L,D,T,AVT,CTRA#                                    BU50 245
1050 FORMAT(' L,D..',I10,4F10.4)#                                       BU50 246
#                                                                       BU50 247
IF(D>ROWDIS) NEXT#                     Save the best fit in the row     BU50 248
IF(CTRA>0.)#                           Skip if transl too far off       BU50 249
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 BU50 250
IF(ABS(AVT-ABS(T))>TOLD) NEXT#         Skip if transl too far off       BU50 251
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 BU50 252
MINROW=L; ROWDIS=D; ROWTRA=ABS(T)#     Save min dev and translation     BU50 253
DO I=1,3; MINMPF(I)=X(I)#              Save midpoint value fract        BU50 254
DO I=1,3; MINMPA(I)=P(I)#              Save midpoint value ortho ang    BU50 255
IF(ABS(D)<=DMAX) BREAK#                Try this match                   BU50 256
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 BU50 257
#                                                                       BU50 258
#-------- END OF ROW (L) LOOP                                           BU50 259
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  BU50 260
#                                                                       BU50 261
IF(ROWDIS<9999.)#                      Only if match found              BU50 262
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 BU50 263
BADFLG=1.#                             Get the current row number       BU50 264
IF(ROWDIS>DMAX)#                       Bad if dev outside limit         BU50 265
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 BU50 266
BAD=BAD+1; IF(BAD>MXAD) BREAK#         Count bad matches                BU50 267
BADFLG=-1.#                            This is a bad guy                BU50 268
L=MINROW#                              Set current row                  BU50 269
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 BU50 270
DO I=1,3; X(I)=MINMPF(I)#              Get midpoint in fractions        BU50 271
QX(TEMPP+ 1)=MINMPA(1)#                Midpt x in orthogonal anstr      BU50 272
QX(TEMPP+ 2)=MINMPA(2)#                Midpt y in orthogonal anstr      BU50 273
QX(TEMPP+ 3)=MINMPA(3)#                Midpt z in orthogonal anstr      BU50 274
CTRA=CTRA+1.; STRA=STRA+ROWTRA#        Sum the translations             BU50 275
AVT=STRA/CTRA#                         Average translation              BU50 276
IF(N>3)WRITE(6,1030) J,L,ROWDIS,DMAX,ROWTRA,AVT,CTRA#                   BU50 277
1030 FORMAT(' ADD ',2I5,F10.3,4F8.3)#                                   BU50 278
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 BU50 279
IF((ROWDIS<9999.)\((L<=ANUM)&(D>LIM2)))#                                BU50 280
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 BU50 281
TEMPP=TEMPP+STEPP#                     Include in chain                 BU50 282
IF(MODE==1) CALL BU31#                 Calc axis with new chain         BU50 283
TEMPP=TEMPP-STEPP#                     Backstep for this insertion      BU50 284
QX(TEMPP+ 9)=OX(1)#                    Centroid x in orthog anstr       BU50 285
QX(TEMPP+10)=OX(2)#                    Centroid y in orthog anstr       BU50 286
QX(TEMPP+11)=OX(3)#                    Centroid z in orthog anstr       BU50 287
QX(TEMPP+12)=TM(1)#                    Normal x in orthog anstr         BU50 288
QX(TEMPP+13)=TM(2)#                    Normal y in orthog anstr         BU50 289
QX(TEMPP+14)=TM(3)#                    Normal z in orthog anstr         BU50 290
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 BU50 291
IF((ROWDIS<9999.)\(L<=ANUM))#                                           BU50 292
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 BU50 293
HIT(J)=yes:;  HIT(L)=yes:#             Flag as matched                  BU50 294
QX(TEMPP+ 4)=FLOAT(L)#                 Store row                        BU50 295
QX(TEMPP+ 5)=FLOAT(J)#                 Store column                     BU50 296
QX(TEMPP+ 6)=BADFLG#                   Flag the bad matches             BU50 297
QX(TEMPP+ 7)=FLOAT(AXIS)#              Axis equ known                   BU50 298
QX(TEMPP+ 8)=FLOAT(BAD)#               Remember bad hit count           BU50 299
QX(TEMPP+15)=X(1)#                     Midpt x in fractions             BU50 300
QX(TEMPP+16)=X(2)#                     Midpt y in fractions             BU50 301
QX(TEMPP+17)=X(3)#                     Midpt z in fractions             BU50 302
QX(TEMPP+18)=ROWTRA#                   Keep current translation         BU50 303
TEMPP=TEMPP+STEPP#                     Include in chain                 BU50 304
JB=0;  LB=0#                           Reset bad pointers               BU50 305
IF(N>3)WRITE(6,1070) J,L,TM,(TEMPP-STARP)/STEPP#                        BU50 306
1070 FORMAT(' J,L..',/,2I5,4F9.5,I9,/)#                                 BU50 307
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 BU50 308
#                                                                       BU50 309
IF(L>ANUM) BREAK#                      The site is unassigned           BU50 310
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  BU50 311
STARTL=J+1#                            Next starting row                BU50 312
#                                                                       BU50 313
#----------- END OF COLUMN (J) LOOP                                     BU50 314
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  BU50 315
#                                                                       BU50 316
#    CHAIN TERMINATED                                                   BU50 317
#    ----------------                                                   BU50 318
#                                                                       BU50 319
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU50 320
IF((L>ANUM&(J==1\J==ANUM))\J>ANUM\K>=ISET) BREAK# Is search complete    BU50 321
#$(#                                                                    BU50 322
#IF(N>3)WRITE(6,1080) J,L,K,ISET,ROWDIS,DMAX,ROWTRA#                    BU50 323
#1080 FORMAT(' I=0',4I5,F10.3,3F8.3)#                                   BU50 324
#IF(INCL==0\K==ANUM) BREAK#             NO OPTIONS LEFT                 BU50 325
#INCL=0; STARTJ=1; STARTL=1#            RESET FOR FRESH PASS            BU50 326
#JB=0;LB=0#                             RESET BAD POINTERS              BU50 327
#NEXT#                                  GO DO IT                        BU50 328
#$)#                                                                    BU50 329
IF(J>ANUM&K==ANUM) BREAK#              Exit if search complete          BU50 330
#                                                                       BU50 331
#  DEAL WITH A BAD MATCH                                                BU50 332
#                                                                       BU50 333
1085 RESTART=no:#                      Entry after failed refine        BU50 334
#                                                                       BU50 335
IF(N>3)WRITE(6,1090) J,MINROW,STARP,TEMPP,ROWDIS,DMAX,ROWTRA#           BU50 336
1090 FORMAT(' BAD',4I5,F10.3,3F8.3)#                                    BU50 337
IF(TEMPP>STARP)#                       Had we a match?                  BU50 338
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 BU50 339
TEMPP=TEMPP-STEPP#                     Backup to last match             BU50 340
JB=NINT(QX(TEMPP+5)); HIT(JB)=no:#     Cancel this hit                  BU50 341
LB=NINT(QX(TEMPP+4)); HIT(LB)=no:#     Cancel this hit                  BU50 342
IF(QX(TEMPP+18)<9999.)#                Test if translation calculated   BU50 343
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 BU50 344
CTRA=CTRA-1;  STRA=STRA-QX(TEMPP+18)#  Reset average translation        BU50 345
AVT=STRA/CTRA#                         Find previous average            BU50 346
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 BU50 347
STARTJ=JB;  STARTL=JB#                 Reset matrix pointers            BU50 348
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 BU50 349
BAD=0;  AXIS=no:#                      Initial values                   BU50 350
IF(TEMPP==STARP) NEXT#                 Are there stored values?         BU50 351
AXIS=NINT(QX(TEMPP-STEPP+7))#          Restore axis equ status          BU50 352
BAD=  NINT(QX(TEMPP-STEPP+8))#         Hit count from prior             BU50 353
IF(AXIS==no:) CTRA=0.#                 Signal no translation check      BU50 354
#                                                                       BU50 355
#   END OF AXIS SEARCHES LOOP                                           BU50 356
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  BU50 357
#                                                                       BU50 358
#                                                                       BU50 359
#    SEARCH TERMINATED -- CHECK FOR REFINEMENT                          BU50 360
#    -----------------------------------------                          BU50 361
#                                                                       BU50 362
IF(MODE==2)#                           Second time through              BU50 363
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 BU50 364
#                                                                       BU50 365
#   CHECK IF REMATCHING WAS SUCCESSFUL                                  BU50 366
#                                                                       BU50 367
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU50 368
IF(K<ISET)#                            Was an abject failure            BU50 369
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 BU50 370
STARP=SAVEP;TEMPP=STEMPP#              Back to stored list              BU50 371
#MODE=1#                                BACK TO SEARCH MODE             BU50 372
TESTP=STARP+2*STEPP#                   Reinit test length               BU50 373
CTRA=SCTRA;STRA=SSTRA#                 Restore trans data               BU50 374
DO I=1,ANUM;HIT(I)=SHIT(I)#            Restore hit array                BU50 375
#                                                                       BU50 376
# SEARCH HAS TO RESUME AS THOUGH THE LAST MATCH WAS BAD                 BU50 377
#                                                                       BU50 378
IF(N>3)WRITE(6,1110) STARP,TEMPP,CTRA,STRA#                             BU50 379
1110 FORMAT(' MODE 2 FAILS',2I6,2F6.3)#                                 BU50 380
RESTART=yes:; BREAK#                   Jump back in                     BU50 381
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 BU50 382
ELSE IF(N>3) WRITE(6,1120)#            Tell user                        BU50 383
1120 FORMAT('MODE 2 PASSES')#                                           BU50 384
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 BU50 385
IF(TEMPP==STARP) BREAK#                No matches found                 BU50 386
SCTRA=CTRA;SSTRA=STRA#                 Save translations                BU50 387
CALL BU31#                             Calculate axis equ data          BU50 388
AVEDEV=0.; DEVDEV=0.#                  Initialise deviation stats       BU50 389
AVETRA=0.; DEVTRA=0.#                  Initialise deviation stats       BU50 390
FOR(II=STARP;II<TEMPP;II=II+STEPP)#    Go over current chain            BU50 391
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 BU50 392
JJ=NINT(QX(II+5))#                     Extract column pointer           BU50 393
LL=NINT(QX(II+4))#                     Extract row pointer              BU50 394
JA=MARKA+(JJ-1)*STEPA#                 Point to atom info               BU50 395
LA=MARKA+(LL-1)*STEPA#                 Point to atom info               BU50 396
#                                                                       BU50 397
TRANS=0.; D=0.#                        Initialise distances             BU50 398
DO I=1,3; V(I)=(QX(JA+2+I)-QX(LA+2+I))# Calculate vector coords         BU50 399
DO I=1,3; Q(I)=0.#                     Zero value                       BU50 400
DO I=1,3; DO J=1,3#                    Convert to orthogonal angstrom   BU50 401
Q(I)=Q(I)+TF(I,J)*V(J)#                Interatom vector in ortho angs   BU50 402
DO I=1,3; U(I)=QX(II+I)-OX(I)#         Shifted midpoint coord           BU50 403
DO I=1,3; D=D+U(I)*TM(I)#              Deviation from axis              BU50 404
D=-D*D; DO I=1,3; D=D+U(I)**2#         Find distance to line            BU50 405
DO I=1,3; TRANS=TRANS+Q(I)*TM(I)#      Project vector onto normal       BU50 406
IF(N>3)WRITE(6,1100) Q,D,DIST,TRANS#                                    BU50 407
1100 FORMAT(' VEC',6F10.5)#                                             BU50 408
#                                                                       BU50 409
AVEDEV=AVEDEV+SQRT(ABS(D))#            Accumulate sum                   BU50 410
DEVDEV=DEVDEV+ABS(D)#                  Accumulate squares               BU50 411
AVETRA=AVETRA+ABS(TRANS)#              Accumulate translations          BU50 412
DEVTRA=DEVTRA+TRANS**2#                Accumulate squares               BU50 413
IF(QX(II+6)>0.) QX(II+6)= SQRT(ABS(D))# Store d for later               BU50 414
ELSE            QX(II+6)=-SQRT(ABS(D))# Store d for later               BU50 415
IF(MODE==2)#                           For printout                     BU50 416
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 BU50 417
QX(II+7)=ABS(TRANS)#                   Store translation                BU50 418
#                                                                       BU50 419
DO I=1,3; U(I)=0.#                     Reinitialise temp coords         BU50 420
DO I=1,3; DO KK=1,3; U(I)=U(I)+FT(I,KK)*QX(II+KK)# Make fractional      BU50 421
DO I=1,3; QX(II+I)=U(I)#               Restore fractional coords        BU50 422
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 BU50 423
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 BU50 424
A=FLOAT((TEMPP-STARP)/STEPP)#          Length of chain                  BU50 425
AVEDEV=AVEDEV/A#                       Average deviation                BU50 426
DEVDEV=ABS((DEVDEV/A)-AVEDEV**2)#      Approximate deviation            BU50 427
IF(DEVDEV>small:) DEVDEV=SQRT(DEVDEV)#                                  BU50 428
ELSE              DEVDEV=0.0#                                           BU50 429
AVETRA=AVETRA/A#                       Average translation              BU50 430
DEVTRA=ABS((DEVTRA/A)-AVETRA**2)#      Approximate sigma translation    BU50 431
IF(DEVDEV>small:) DEVTRA=SQRT(DEVTRA)#                                  BU50 432
ELSE              DEVTRA=0.0#                                           BU50 433
IF(MODE==2) BREAK#                     Don't reset values               BU50 434
CTRA=1.; STRA=AVETRA; AVT=AVETRA#      Set the best translation         BU50 435
STEMPP=TEMPP;SAVEP=STARP#              Save current chain limits        BU50 436
STARP=TEMPP+STEPP#                     New beginning for refined chai   BU50 437
TEMPP=STARP#                           Start with no matches            BU50 438
DO I=1,ANUM#                           Loop over hits array             BU50 439
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 BU50 440
SHIT(I)= HIT(I)#                       Save hit value                   BU50 441
HIT(I)=no:#                            Reset for refine loop            BU50 442
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 BU50 443
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  BU50 444
IF(RESTART==yes:) NEXT#                Skip and restart mode loop       BU50 445
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU50 446
MCNT(3,MODEC)=K#                       Store number of matches          BU50 447
IF(ITEST==2\MODEC==2\K==ANUM) BREAK#   Intra mode or all matched        BU50 448
MODEC=2#                               Force intra cluster search       BU50 449
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  BU50 450
#                                                                       BU50 451
#     OUTPUT SOLUTION                                                   BU50 452
#     ---------------                                                   BU50 453
#                                                                       BU50 454
IF(TEMPP>STARP)#                       If any matches found             BU50 455
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 BU50 456
K=0; DO I=1,ANUM; K=K+HIT(I)#          Sum all hits                     BU50 457
IF(K==ANUM)#                           If a full house                  BU50 458
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 BU50 459
FINAL=yes:; JAXIS=10#                  This is a wrap!                  BU50 460
writeline:(1,BU501,NBU501,3,3)#        All sites matched                BU50 461
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 BU50 462
ELSE#                                  Some sites not matched           BU50 463
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 BU50 464
ncodefld:(FLOAT(K   ),1,BU506,250313.,1)# Insert hit count              BU50 465
ncodefld:(FLOAT(ANUM),1,BU506,360313.,1)# Insert hit count              BU50 466
writeline:(1,BU506,NBU506,3,3)#        Tell user                        BU50 467
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 BU50 468
#                                                                       BU50 469
writeline:(1,BU502,NBU502,3,3)#        Tell user                        BU50 470
ncodefld:(TM,1,CHROT,FMT,3)#           Equation in orthog angst         BU50 471
writeline:(0,0,0,1,3)#                 Tell user                        BU50 472
#                                                                       BU50 473
writeline:(1,BU503,NBU503,3,3)#        Tell user                        BU50 474
CHROT=BU508#                           Equation header                  BU50 475
ncodefld:(AVEDEV,1,CHROT,FMT(4),1)#    Deviation in orthog angst        BU50 476
ncodefld:(AVETRA,1,CHROT,FMT(5),1)#    Deviation in orthog angst        BU50 477
writeline:(0,0,0,1,3)#                 Tell user                        BU50 478
CHROT=BU509#                           Equation header                  BU50 479
ncodefld:(DEVDEV,1,CHROT,FMT(4),1)#    Translation in orthog angst      BU50 480
ncodefld:(DEVTRA,1,CHROT,FMT(5),1)#    Translation in orthog angst      BU50 481
writeline:(0,0,0,1,3)#                 Tell user                        BU50 482
IF(DEVTRA>0.25) writeline:(1,BU516,NBU516,3,3)# Untrustworthy           BU50 483
#                                                                       BU50 484
#   TRY TO INTERPRET LINE EQUATION                                      BU50 485
#                                                                       BU50 486
CDIM(1)=SQRT(G1);CDIM(2)=SQRT(G2);CDIM(3)=SQRT(G3)# Cell dimensions     BU50 487
D=0.#                                                                   BU50 488
DO II=1,3#                                                              BU50 489
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 BU50 490
TMF(II)=0.#                            Initialise fractional line       BU50 491
DO KK=1,3; TMF(II)=TMF(II)+FT(II,KK)*TM(KK)# Line in fracs              BU50 492
IF(ABS(TMF(II))>D) D=ABS(TMF(II))#                                      BU50 493
OXF(II)=0.#                            Initialise fractional centroid   BU50 494
DO KK=1,3; OXF(II)=OXF(II)+FT(II,KK)*OX(KK)# Centroid in fracs          BU50 495
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 BU50 496
DO II=1,3;V(II)=TMF(II)/D#             Scale max coefficient to one     BU50 497
writeline:(1,BU517,NBU517,3,3)#        Tell user                        BU50 498
ncodefld:(V,1,CHROT,FMT,3)#            Equation in fractional coords    BU50 499
writeline:(0,0,0,1,3)#                 Tell user                        BU50 500
D=0.0#                                                                  BU50 501
DO II=1,3;D=D+TMF(II)**2#              Length of fractional line        BU50 502
DO II=1,3;TMF(II)=TMF(II)/SQRT(D)#     Normalise fractional line        BU50 503
#                                                                       BU50 504
DEV=MAX(3*DEVTRA,0.1)#                 Ensure reasonable dev            BU50 505
IF(ABS(AVETRA)-DEV<0.) SCREW=no:#      Is a rotation axis               BU50 506
ELSE                   SCREW=yes:#     Is a screw axis                  BU50 507
#                                                                       BU50 508
#      DETERMINE AXIS ORIENTATION                                       BU50 509
#                                                                       BU50 510
DO LTYPE=1,3#                          Loop over axes                   BU50 511
IF(ABS(ABS(TMF(LTYPE))-1.0)<0.1)BREAK# Found an axis close to 1         BU50 512
IF(LTYPE<=3)#                          If simple axis found             BU50 513
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 BU50 514
IF(SCREW==yes:) movechar:(BU512,1,BU510,22,5,0)# Screw                  BU50 515
ELSE            movechar:(BU512,6,BU510,22,5,0)# Rotor                  BU50 516
movechar:(BU513,LTYPE,BU510,44,1,0)#   Encode axis                      BU50 517
writeline:(1,BU510,NBU510,3,3)#        Tell user                        BU50 518
INSPNT=35#                             Initialise                       BU50 519
DO I=1,3#                              Loop over axes                   BU50 520
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 BU50 521
IF(I==LTYPE) NEXT#                     Skip parallel axis               BU50 522
INSFMT=INSPNT*10000. + 322.#           Construct format                 BU50 523
ncodefld:(ABS(OXF(I)),1,BU511,INSFMT,1)# Encode float                   BU50 524
movechar:(BU513,I,BU511,INSPNT+2,1,0)# Move axis name                   BU50 525
INSPNT=INSPNT+8#                       Move to next  position           BU50 526
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 BU50 527
writeline:(0,BU511,NBU511,3,3)#        Output axis offset               BU50 528
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 BU50 529
ELSE writeline:(0,BU515,NBU515,3,3)#   Tell user have no idea           BU50 530
#                                                                       BU50 531
LINRM=3#                                                                BU50 532
writeline:(1,BU500,NBU500,3,3)#        Tell user                        BU50 533
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Output points                    BU50 534
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 BU50 535
II=MARKA+(NINT(QX(I+4))-1)*STEPA#      Atom pointer                     BU50 536
JJ=MARKA+(NINT(QX(I+5))-1)*STEPA#      Atom pointer                     BU50 537
movertoc:(na:(JJ),1,CHROT,2,8,0)#      Output atom name                 BU50 538
movertoc:(na:(II),1,CHROT,9,8,0)#      Output atom name                 BU50 539
ncodefld:(QX,I+1,CHROT,FMT,3)#         Encode midpoint                  BU50 540
IF(QX(I+6)<0.) CHROT(70^70)='*'#       This one was rejected            BU50 541
ELSE           CHROT(70^70)=' '#       Otherwise ok                     BU50 542
QX(I+6)=ABS(QX(I+6))#                  Remove any negative flag         BU50 543
ncodefld:(QX,I+6,CHROT,FMT(4),1)#      Encode deviation                 BU50 544
ncodefld:(QX,I+7,CHROT,FMT(5),1)#      Encode translation               BU50 545
writeline:(0,0,0,1,3)#                 Output midpoint                  BU50 546
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 BU50 547
##                                                                      BU50 548
#          OUTPUT DATA TO SCRATCH FILE                                  BU50 549
#          ---------------------------                                  BU50 550
#                                                                       BU50 551
IF(ITEST==2)#                          Only for last pass               BU50 552
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 BU50 553
#                                                                       BU50 554
#     INITIALISE SCRATCH FILE                                           BU50 555
#     -----------------------                                           BU50 556
#                                                                       BU50 557
IF(WROTE==no:)#                        If no header yet written         BU50 558
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 BU50 559
copyfile:(1,3,1,1)#                    Copy history                     BU50 560
writepkt:(3,lrgraf:,18,IP)#            Prepare lrgraf: record           BU50 561
DO I=1,9;QX(IP+I  )=FLOAT( 20+I)#      Lrgraf: directory                BU50 562
DO I=1,9;QX(IP+I+9)=FLOAT(120+I)#      Lrgraf: directory                BU50 563
writepkt:(3,lrgraf:,18,IP)#            Prepare orientation matrix       BU50 564
DO I=1,18;QX(IP+I)=0.#                 Make identity matrix             BU50 565
QX(IP+ 1)=1.;QX(IP+ 5)=1.;QX(IP+ 9)=1.# Make identity matrix            BU50 566
QX(IP+10)=1.;QX(IP+14)=1.;QX(IP+18)=1.# Make identity matrix            BU50 567
#                                                                       BU50 568
PSIZ=5+lablen:#                        Set output packet size           BU50 569
writepkt:(3,lratom:,PSIZ,IP)#          Get next output packet           BU50 570
DO I=1,3;QX(IP+I)=FLOAT(I)#            Positions into directory         BU50 571
DO I=1,lablen:#                        Atom label length in words       BU50 572
QX(IP+3+I)=14.#                        Atom name into directory         BU50 573
QX(IP+4+lablen:)=22.#                  Scattering factor pointer        BU50 574
QX(IP+5+lablen:)=23.#                  Thermal parameter type for ort   BU50 575
WROTE=yes:#                            Flag header written              BU50 576
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 BU50 577
#                                                                       BU50 578
DO I=1,3;MAXMPA(I)=0.#                 Initialise max/min coord         BU50 579
DO I=1,3;MINMPA(I)=0.#                 Initialise max/min coord         BU50 580
FOR(I=STARP;I<TEMPP;I=I+STEPP)#        Loop over solution               BU50 581
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 BU50 582
LA=MARKA+(NINT(QX(I+4))-1)*STEPA#      Atom pointer for row             BU50 583
JA=MARKA+(NINT(QX(I+5))-1)*STEPA#      Atom pointer for column          BU50 584
DO II=1,3#                             Loop over coordinates            BU50 585
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 BU50 586
MAXMPA(II)=MAX(xf:(LA-1+II),xf:(JA-1+II),MAXMPA(II))# Get maximum coo   BU50 587
MINMPA(II)=MIN(xf:(LA-1+II),xf:(JA-1+II),MINMPA(II))# Get minimum coo   BU50 588
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 BU50 589
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU50 590
movereal:(xf:(LA),1,QX,IP+1,3,1)#      Store first atom coords          BU50 591
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU50 592
movereal:(na:(LA),1,QX,IP+4,2,1)#      Store name                       BU50 593
movereal:(ty:(LA),1,QX,IP+4+lablen:,1,1)# Store type                    BU50 594
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU50 595
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU50 596
#                                                                       BU50 597
movereal:(xf:(JA),1,QX,IP+1,3,0)#      Store second atom coords         BU50 598
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU50 599
movereal:(na:(JA),1,QX,IP+4,2,1)#      Store name                       BU50 600
movereal:(ty:(JA),1,QX,IP+4+lablen:,1,1)# Store type                    BU50 601
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU50 602
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 BU50 603
#                                                                       BU50 604
#         OUTPUT AXIS TO SCRATCH FILE                                   BU50 605
#         ---------------------------                                   BU50 606
#                                                                       BU50 607
#  FIRST HAVE TO DETERMINE THE ENDPOINTS OF THE LINE OUTPUT TO THE      BU50 608
#  FILE.                                                                BU50 609
#  HEURISTIC: CLOSEST EXIT/ENTRY TO THE MINIMUM ENTRY/EXIT ARE THE      BU50 610
#  ONES WE WANT                                                         BU50 611
#                                                                       BU50 612
DO II=1,3#                             Determine endpoints              BU50 613
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 BU50 614
ifne:(TMF(II),0.)#                     Avoid singularities              BU50 615
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 BU50 616
D=(MAXMPA(II)-OXF(II))/TMF(II)#        Maximum parameter for line       BU50 617
E=(MINMPA(II)-OXF(II))/TMF(II)#        Minimum parameter for line       BU50 618
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 BU50 619
ELSE#                                  Take care of singularities       BU50 620
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 BU50 621
D=9999;E=-9999.#                       Nice and large                   BU50 622
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 BU50 623
IF(TMF(II)<=0.)#                       Is entering the box              BU50 624
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 BU50 625
ENTR(II)=D#                            Store the value                  BU50 626
EXTP(II)=E#                            Exits other side                 BU50 627
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 BU50 628
ELSE#                                  Is an exit                       BU50 629
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 BU50 630
ENTR(II)=E#                            This is the entry                BU50 631
EXTP(II)=D#                            This is the exit                 BU50 632
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 BU50 633
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 BU50 634
IF(MIN(ENTR(1),ENTR(2),ENTR(3))> MAX(EXTP(1),EXTP(2),EXTP(3)))#         BU50 635
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 BU50 636
Q(1)=MIN(ENTR(1),ENTR(2),ENTR(3))#     One of the points                BU50 637
Q(2)=MAX(EXTP(1),EXTP(2),EXTP(3))#     The other end                    BU50 638
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 BU50 639
ELSE#                                  The other way around             BU50 640
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 BU50 641
Q(1)=MAX(ENTR(1),ENTR(2),ENTR(3))#     One of the points                BU50 642
Q(2)=MIN(EXTP(1),EXTP(2),EXTP(3))#     The other end                    BU50 643
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 BU50 644
MPTNME='AXIS1                   '#     Do this outside loop             BU50 645
DO I=1,2#                              Loop over endpoints              BU50 646
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 BU50 647
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU50 648
DO II=1,3;P(II)=OXF(II)+Q(I)*TMF(II)#  Calculate point                  BU50 649
movereal:(P,1,QX,IP+1,3,0)#            Store endpoint                   BU50 650
movector:(MPTNME,1,QX(IP+4),1,24,0)#   Store name                       BU50 651
QX(IP+4+lablen:)=-2.#                  Flag axis                        BU50 652
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU50 653
MPTNME='AXIS2                   '#     Do this outside loop             BU50 654
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 BU50 655
#                                                                       BU50 656
#                                                                       BU50 657
#         OUTPUT UNMATCHED ATOMS                                        BU50 658
#         ----------------------                                        BU50 659
#                                                                       BU50 660
DO I=1,ANUM#                                                            BU50 661
IF(HIT(I)==no:)#                                                        BU50 662
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 BU50 663
LA=MARKA+(I-1)*STEPA#                  Atom pointer                     BU50 664
writepkt:(3,lratom:,PSIZ,IP)#          Get buffer pointer               BU50 665
movereal:(xf:(LA),1,QX,IP+1,3,1)#      Store atom coords                BU50 666
movector:(BLANK,1,QX(IP+4),1,24,1)#    Blank out name                   BU50 667
movereal:(na:(LA),1,QX,IP+4,2,1)#      Store name                       BU50 668
movereal:(ty:(LA),1,QX,IP+4+lablen:,1,1)# Store type                    BU50 669
QX(IP+5+lablen:)=0.0#                  Overall thermal disp type        BU50 670
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 BU50 671
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 BU50 672
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 BU50 673
ELSE writeline:(1,BU505,NBU505,3,3)#   Tell user no extra symmetry      BU50 674
#                                                                       BU50 675
RETURN#                                                                 BU50 676
END#                                                                    BU50 677
#                                                                       BU50 678
pmacro:([no:])#                                                         BU50 679
#                                                                       BU50 680
#                                                                       BU50 681
#                                                                       BU50 682
