systemheader:(CR    )#                                                  CR     1
####################################################################### CR     2
##      Copyright (C) 2000, The Xtal System, The University of        # CR     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # CR     4
## Distributed under the GNU General Public Licence as published by   # CR     5
## the Free Software Foundation, in the hope that it will be useful   # CR     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # CR     7
## for more details.                                                  # CR     8
#                                                                     # CR     9
#                            *** CRYLSQ ***                           # CR    10
#                                                                     # CR    11
#    THE PROGRAM CRYLSQ REFINES ATOMIC PARAMETERS BY MEANS OF         # CR    12
#    A STRUCTURE FACTOR LEAST SQUARES PROCEDURE. A WIDE RANGE OF      # CR    13
#    USER OPTIONS ARE AVAILABLE.         R.OLTHOF AUGUST 1980         # CR    14
#                                                                     # CR    15
####################################################################### CR    16
#                                                                       CR    17
include:(XMACRO)#                                                       CR    18
#                                                                       CR    19
macro:(nextconstr:,$(LCON=LCON+$1;PCON=NINT(QX(LCON+1))$))#             CR    20
macro:(name:,incr:(arith:(23,/,mxchwd:)))#                              CR    21
macro:(w40c:,incr:(arith:(39,/,mxchwd:)))#                              CR    22
#                                                                       CR    23
macro:(prod:,$(KIK1=$1+$2;KIK2=$1+$3#                                   CR    24
Q1=QX(KIK1);Q2=QX(KIK2)#                                                CR    25
QX(KIK1)=Q1*COSR-Q2*SINR;QX(KIK2)=Q1*SINR+Q2*COSR$))#                   CR    26
#                                                                       CR    27
macro:(swap:,$(Q1=QX($1);QX($1)=QX($2);QX($2)=Q1$))#                    CR    28
#                                                                       CR    29
macro:(eapply:,$(#                                                      CR    30
IF(PARTL==1) M=21+NATTYP+$1; ELSE M=12+NATTYP+$1# Input pointer         CR    31
M=IP+REL(M)#                           Point to wanted fc               CR    32
IF(M>IP) $2=QX(M)#                     Get wanted fc                    CR    33
IF(ICYCLE==NCYCLE)$(#                  Last cycle                       CR    34
N=N+1;   M=N#                          Output pointer                   CR    35
M=IPP+REL(M);QX(M)=$2$)$))#            Establish fc                     CR    36
#                                                                       CR    37
extrude:(CRCOMN)#                                                       CR    38
INTEGER ADDOLD#    ## add old atom para to bdf =0 no / =1 yes           CR    39
INTEGER BLKTYP#    ## BLOCKING TYPE: 0=BLOCK DIAG; 1=FULL MATRIX;       CR    40
#                  ## 2=BLOCK CARD IS PRESENT; 3=USER DEFINED BLOCKS    CR    41
#                  ## DEFAULT 0                                         CR    42
REAL    BTOHU#     ## Convert B to 100*U                                CR    43
REAL    BTOU#      ## Convert B to U                                    CR    44
REAL    CELL(39)#  ## 1- 6 CONVERSION B TO BETA;                        CR    45
#                  ##  7-12 CONVERSION BETA TO 100*U                    CR    46
#                  ## 13-21 TRANSFORMATION FRACT. TO ORTH.              CR    47
#                  ## 22-30 TRANSFORMATION ORTH. TO FRACT.              CR    48
#                  ## 31-39 METRIC TENSOR                               CR    49
REAL    DAMP#      ## DAMPING FACTOR FOR SHIFTS                         CR    50
INTEGER DATSET#    ## DATA SET NUMBER                                   CR    51
REAL    DSDAVE#    ## SHIFT/ERROR AVERAGE                               CR    52
REAL    DSDMAX#    ## SHIFT/ERROR MAXIMUM                               CR    53
REAL    DSDNUM#    ## SHIFT/ERROR NUMBER                                CR    54
REAL    DSFTB#     ## SINE THETA OVER LAMBDA INTERVAL FOR S.F.          CR    55
INTEGER DSTEXT#    ## DISTRIBUTION FOR EXT. 0=GAUSS; 1=LORENTZ          CR    56
REAL    EXTESD#    ## EXTINCTION E.S.D.                                 CR    57
INTEGER EXTTYP#    ## 0 = ZACHARIASEN; 1 T/M 6 = BECKER-COPPENS         CR    58
#                  ## 1=TYPE I,ISO  2=TYPE II,ISO  3=GENERAL,ISO        CR    59
#                  ## 4=TYPE I,ANI  5=TYPE II ANI  6=GENERAL,ANI        CR    60
INTEGER ICENT#     ## 0=CENTRIC CELL; 1=ACENTRIC CELL                   CR    61
INTEGER ICYCLE#    ## NUMBER OF REFINEMENT CYCLES STILL TO GO           CR    62
INTEGER IMAGP#     ## SIGNAL-COUNTER FOR COMPLEX S.F. CALC.             CR    63
INTEGER ISTEP6#    ## NR OF WORDS IN MAIN SET OF GROUP ARRAY            CR    64
INTEGER IWT#       ## WEIGHTING SCHEME; 1=UNIT; 2=1/SIGMA               CR    65
REAL    LAMBDA#    ## WAVE LENGTH                                       CR    66
#                  ## 3: WEIGHT=WEIGHT(BDF); DEFAULT 1                  CR    67
INTEGER LIST#      ## LIST REFLECTIONS: 0=NO; 1=LAST CYCLE; 2=EVERY C   CR    68
INTEGER LISTMA#    ## LIST MATRIX: 0=NO; 1=CORRELATION MATRIX, ELEMEN   CR    69
#                  ## > MALIST,LAST CYCLE; 2= AS 1, EVERY CYCLE;        CR    70
#                  ## 3=DIRECT + INVERTED MATRIX AND VECTOR, LAST CYCLE CR    71
#                  ## 4= AS 3, EVERY CYCLE                              CR    72
INTEGER LTMTRX#    ## LESS-THAN REFLECTIONS CONTRIBUTE TO MATRIX: 0=N   CR    73
#                  ## 1= IF FO>FC                                       CR    74
REAL    MALIST#    ## LOWER LIMIT FOR OUTPUT OF CORRELATION MATRIX      CR    75
INTEGER MARK0#     ## ROTATION MATRICES AND TRANSLATION VECTORS         CR    76
INTEGER MARK1#     ## SCATTERING FACTOR NAMES(NATTYP PACKETS OF 8 CH.   CR    77
#                  ## + DATA SET NAME                                   CR    78
INTEGER MARK2#     ## F', F", REF.FLAG                                  CR    79
#                  ## ATOMIC WEIGHT                                     CR    80
#                  ## S.F. TABLES: IF NO INTERPOL. S.F. IN LRREFL       CR    81
INTEGER MARK3#     ## SCALE FACTOR(S)                                   CR    82
INTEGER MARK4#     ## UOV, EXT.PAR.,MAX/H/, ETC., TBAR                  CR    83
#                  ## IF MAXHKL NOT ON BDF OR CARDS: STORE -1000.       CR    84
INTEGER MARK5#     ## ATOM PARAMETERS                                   CR    85
#                  ## QX(L5+1)-QX(L5A)=ATOM ID                          CR    86
#                  ## QX(L5A+1)=POINTER TO NEXT ATOM                    CR    87
#                  ## QX(L5A+2)=SCATT.FACT.NR. + NO.OF DISPL.PAR.(MIXTM CR    88
#                  ## QX(L5A+3)=X                                       CR    89
#                  ## QX(L5A+4)=Y                                       CR    90
#                  ## QX(L5A+5)=Z                                       CR    91
#                  ## QX(L5A+6)=NOT EXISTING/BISO/BETA11/POP/ML         CR    92
#                  ## QX(L5A+7) ETC. ITEMS AS MENTIONED IN QX(L5A+6)    CR    93
INTEGER MARK6#     ## GROUP INFORMATION (SEE CR04)                      CR    94
INTEGER MARK7#     ## RESTRAINTS INFORMATION (SEE CR05)                 CR    95
#                  ## LAST (OR ONLY) WORD: -MARK8                       CR    96
INTEGER MARK8#     ## TEMPORARY STORAGE OF CONSTR AND NOREF INPUT       CR    97
#                  ## BLOCK INFO:                                       CR    98
#                  ## QX(MARK8+1) TOTAL NR OF BLOCKS                    CR    99
#                  ##    QX(L8+1) NR OF BLOCKS WITH SAME NR OF VAR      CR   100
#                  ##    QX(L8+2) NR OF VAR IN THESE BLOCKS             CR   101
INTEGER MARK9#     ## TEMPORARY STORAGE OF BLOCK INPUT (SEE CR06)       CR   102
#                  ## CONTENTS OF USER DEFINED BLOCKS                   CR   103
#                  ## QX(L9+1) NUMBER OF VAR                            CR   104
#                  ## QX(L9+2) NUMBER OF VAR / -ATOM POINTER (SERIE)    CR   105
INTEGER MARK10#    ## TEMPORARY STORAGE OF BLOCK INFO (SEE MARK8)       CR   106
#                  ## CONSTRAINED AND INVARIANT PARAM:                  CR   107
#                  ## QX(I10+1) POINTER TO SUBJECT PARAM IN MARK5       CR   108
#                  ##           A NEGATIVE VALUE MEANS: NOREF PARAM     CR   109
#                  ##           -(ATPT+1) MEANS: NOREF ALL PARAM        CR   110
#                  ## QX(I10+2) -1 NORMAL CONSTRAINT                    CR   111
#                  ##            0 GROUP CONSTARINT                     CR   112
#                  ##            N GROUP CONSTR., FIRST ATTACH, NVAR    CR   113
#                  ## QX(I10+3) NR OF ITEMS IN THIS SET                 CR   114
#                  ## QX(I10+4) NR OF ITEMS IN SUBSETS                  CR   115
#                  ##    QX(L10+1) VAR NR OF REFERENCE PARAM            CR   116
#                        QX(L10+2) MULTIPLICATION FACTOR                CR   117
INTEGER MARK11#    ## TEMPORARY STORAGE OF BLOCK CONTENTS (SEE MARK9)   CR   118
#                  ## MATRIX / INVERTED MATRIX                          CR   119
INTEGER MARK12#    ## TEMPORARY STORAGE OF CONSTRAINTS (SEE MARK10)     CR   120
#                  ## VECTOR / SHIFTS                                   CR   121
INTEGER MARK13#    ## SCRATCH IN DERIVATIVES CALCULATION / SCRATCH IN   CR   122
#                  ## MATRIX INVERSION / ST.DEV.                        CR   123
INTEGER MARK14#    ## QX(MARK14+1)=SUM(W*DELTASQ)/(N-M)                 CR   124
#                  ## QX(MARK14+2)=BCORR (0/1)                          CR   125
#                  ## QX(MARK14+3)=SHIFT(BOV) (1*1 MATRIX)              CR   126
#                  ## QX(MARK14+4)=MAXIMUM SHIFT/ERROR                  CR   127
#                  ## QX(MARK14+5)=AVERAGE SHIFT/ERROR                  CR   128
#                  ## QX(MARK14+6)=NR OF SHIFT/ERROR VALUES CALCULATED  CR   129
#                  ## ALSO USED FOR SCAT.FACT. AND REFL (CR21)          CR   130
INTEGER MARK15#    ## BUFFER FOR 2-BUFFER BDF OUTPUT                    CR   131
INTEGER MIXTMP#    ## (0)/(1) FOR (NO)/(YES) MIXED DISPL.PAR. IN MARK   CR   132
INTEGER MLT#       ## ATOM MULTIPLICITY PRESENT IN MARK5-ARRAY          CR   133
REAL    MONO2T#    ## (COS(MONOCHROMATOR ANGLE 2THETA))**2              CR   134
REAL    MU#        ## ABSORPTION COEFF.                                 CR   135
INTEGER NAT#       ## NUMBER OF ATOMS, TO BE INCLUDED IN SF AND REF.    CR   136
INTEGER NATTYP#    ## NUMBER OF ATOM TYPES                              CR   137
INTEGER NCYCLE#    ## NUMBER OF REFINEMENT CYCLES                       CR   138
INTEGER NONATM#    ## NUMBER OF NON-ATOMIC PARAMETERS                   CR   139
INTEGER NSFTB#     ## NR OF ENTRIES IN S.F. TABLE (MARK2-ARRAY)         CR   140
INTEGER NSKIP#     ## INCLUDE EACH NSKIP-TH REFLECTION IN THE CALC.     CR   141
INTEGER NSTEP2#    ## NUMBER OF WORDS PER ATOM TYPE IN MARK2            CR   142
INTEGER NSTEP6#    ## NR OF WORDS IN SUBSETS OF GROUP ARRAY             CR   143
INTEGER NSYM#      ## NUMBER OF SYMM. OPERATORS                         CR   144
INTEGER PARTL#     ## PARTIAL CONTRIBUTION TO STRUCTURE FACTORS:        CR   145
#                  ## 0=NO; 1= APPLY; 2= ESTABLISH AND APPLY            CR   146
INTEGER PNCHCD#    ## PUNCH ATOM PARAMETERS: 0=NO; 1= LAST CYCLE;       CR   147
#                  ## 2=EVERY CYCLE                                     CR   148
INTEGER POLSPG(3)# ## POLAIR AXES, IF FULL MATRIX REFINEMENT            CR   149
INTEGER POP#       ## POP.PAR. PRESENT IN MARK5-ARRAY                   CR   150
REAL    RATIO#     ## POLARIZATION FRACTION PPERP/(PTOT)                CR   151
REAL    R0(3)#     ## R-FACTORS                                         CR   152
REAL    RW(3)#     ## R-FACTORS USING WEIGHTED DELTA SQUARED            CR   153
INTEGER RADTYP#    ## TYPE OF RADIATION: 1= XRAY; 2=NEUTRON             CR   154
INTEGER REFABS#    ## ABS. STRUCTURE PARAM: 0=NO; 1=APPLY; 2=REFINE     CR   155
INTEGER REFDSP#    ## 0/1/2 FOR NO DISP/APPLY DISP/REFINE DISP          CR   156
INTEGER REFEXT#    ## 0/1/2 FOR NO EXT./APPLY EXT./REFINE EXT.          CR   157
INTEGER REFPOP#    ## REFINE POP.PAR.: 0=NO; 1=YES                      CR   158
INTEGER REFSKF#    ## REFINE SCALING FACTORS: 0=NO; 1=UNIT; N=SEPARAT   CR   159
INTEGER REFTMP#    ## REFINEMENT FLAG OF DISPL.PAR.:                    CR   160
#                  ## 0: B(OVA); 1: B(ISO); 2 OR 6(AFTER CR02): ANISO;  CR   161
#                  ## 3: MIXED, WITH B(OVA),WITHOUT ANISO;              CR   162
#                  ## 4: MIXED, WITH B(OVA),WITH ANISO;                 CR   163
#                  ## 5: MIXED, WITHOUT B(OVA), WITH ANISO              CR   164
INTEGER REFUOV#    ## REFINEMENT FLAG OF B(OVA)                         CR   165
#                  ## -1 IF ONLY USED FOR SKF-DISPL.PAR. CORRELATION    CR   166
INTEGER REL(99)#   ## TO SPECIFY RELATIVE ITEM POINTERS IN LRREFL:      CR   167
REAL    RFLIST#    ## REFLECTIONS WITH WEIGHTED DELTA(F/F2/I) GREATER   CR   168
#                  ## THAN RFLIST ARE LISTED                            CR   169
INTEGER RFLMLT#    ## GENERAL MULTIPLICITY (LR 5: QX(IP+6))             CR   170
INTEGER RFLTYP#    ## TYPE OF REFLECTION REFINEMENT:                    CR   171
#                  ## 0: F; 1: F*F; 2: INTENSITY                        CR   172
REAL    RFMTRX#    ## REFLECTIONS WITH W*/DELTA(F/F2/I)/ > RFMTRX DO    CR   173
#                  ## NOT CONTRIBUTE TO MATRIX (DEFAULT 1000000)        CR   174
REAL    RSUMS(60)# ## SUMS FOR R VALUE CALCULATIONS IN CR21 & 26        CR   175
INTEGER SAVEMA#    ## SAVE CORRELATION MATRIX: 0=NO; 1= ON TAPE11       CR   176
INTEGER SELECT#    ## PART OF THE BDF ATOMS IS SELECTED (NO:)/(YES:)    CR   177
INTEGER SIGNAL(4)# ## GROUP CODES FOR POINTPKT:                         CR   178
INTEGER STOP0#     ## End of unique symmetry matrices                   CR   179
INTEGER TCYCLE#    ## total cycles                                      CR   180
INTEGER TERMNT#    ## TERMINATE REFINEMENT: 0=NO; 1= WHEN DECREASE IN   CR   181
#                  ## R IS LESS THAN 0.01                               CR   182
INTEGER TMPTST#    ## DISPL.PAR. TEST ON NON-POSITIVITY:                CR   183
#                  ## 0= RESET DISPL.PAR.; 1= WRITE MESSAGE             CR   184
#                  ## 2=TERMINATE REFINEMENT                            CR   185
REAL    TYPELT#    ## TYPE LESS-THANS= RCODE=2 IF OBS<TYPELT*SIGMA      CR   186
REAL    UEQU(6)#   ## CONVERSION FROM UIJ TO U(EQUIV)                   CR   187
INTEGER VARGEN#    ## NUMBER OF GENERAL VARIABLES, TO BE REFINED        CR   188
INTEGER VARTOT#    ## TOTAL NUMBER OF VARIABLES, TO BE REFINED          CR   189
REAL    VOL#       ## CELL VOLUME                                       CR   190
REAL    SS(3)#     ## GOODNESS OF FIT PARAMETERS                        CR   191
REAL    XABS#      ## ABSOLUTE STRUCTURE PARAMETER                      CR   192
REAL    XABSIG#    ## SIGMA on ABSOLUTE STRUCTURE PARAMETER             CR   193
#                                                                       CR   194
COMMON/COMFCR/BTOHU,BTOU,CELL,DAMP,DSFTB,LAMBDA,MALIST,MONO2T,#         CR   195
MU,RFLIST,RFMTRX,RSUMS,TYPELT,UEQU,VOL,XABS,R0,RW,SS,EXTESD,#           CR   196
RATIO,DSDAVE,DSDMAX,DSDNUM,TCYCLE,XABSIG#                               CR   197
#                                                                       CR   198
COMMON/COMICR/ADDOLD,BLKTYP,DATSET,DSTEXT,EXTTYP,ICENT,#                CR   199
ICYCLE,IMAGP,ISTEP6,IWT,LIST,LISTMA,LTMTRX,#                            CR   200
MARK0,MARK1,MARK2,MARK3,MARK4,MARK5,MARK6,MARK7,#                       CR   201
MARK8,MARK9,MARK10,MARK11,MARK12,MARK13,MARK14,MARK15,#                 CR   202
NONATM,MIXTMP,MLT,NAT,NATTYP,NCYCLE,NSFTB,NSKIP,NSTEP2,NSTEP6,NSYM,#    CR   203
PARTL,PNCHCD,POLSPG,POP,RADTYP,STOP0,#                                  CR   204
REFABS,REFDSP,REFEXT,REFPOP,REFSKF,REFTMP,REFUOV,REL,RFLMLT,RFLTYP,#    CR   205
SAVEMA,SELECT,TERMNT,TMPTST,VARGEN,VARTOT,SIGNAL#                       CR   206
endext:#                                                                CR   207
#                                                                       CR   208
systemheader:(CR00)#                   Least squares refinement         CR00   1
# ############################################################# #       CR00   2
#                                                               #       CR00   3
#                          CR00                                 #       CR00   4
#                                                               #       CR00   5
# ############################################################# #       CR00   6
SUBROUTINE CR00#                       R.olthof aug 1980                CR00   7
include:(AACOMN)#                      May 1985 april 1989              CR00   8
include:(CRCOMN)#                                                       CR00   9
#                                                                       CR00  10
FILEXT(IOUNIT(4))='CMX'#               Output correlation matrix        CR00  11
#                                                                       CR00  12
CALL CR01#                             Crylsq,cell,symmetry             CR00  13
CALL CR02#                             Scatt,scale,datset,ext,maxhk     CR00  14
CALL CR03#                             Atom param                       CR00  15
CALL CR04#                             Group and idmol                  CR00  16
CALL CR05#                             Restraints                       CR00  17
CALL CR06#                             Constr, noref and block          CR00  18
CALL CR08#                             Mark8,mark9,mark10-arrays        CR00  19
CALL CR10#                             Output of initial par            CR00  20
REPEAT#                                Loop over refinement cycles      CR00  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR00  22
CALL CR20#                             Initialization of lrrefl:        CR00  23
CALL CR21#                             Calculation of sf and deriv.     CR00  24
CALL CR24#                             Deriv. of restraints             CR00  25
CALL CR26#                             Output of sums and discrepan     CR00  26
IF(ICYCLE==NCYCLE) BREAK#              Break after last cycle           CR00  27
CALL CR30#                             Matrix inversion                 CR00  28
CALL CR36#                             Update general and group par     CR00  29
CALL CR37#                             Update atom param                CR00  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR00  31
CALL CR40#                             End the program                  CR00  32
RETURN#                                                                 CR00  33
END#                                                                    CR00  34
systemheader:(CR01)#                   Crylsq line, cell symtry         CR01   1
# ####################################################################  CR01   2
#                                                                       CR01   3
#                               CR01                                    CR01   4
#                                                                       CR01   5
# ####################################################################  CR01   6
SUBROUTINE CR01#                       R. olthof   august 1980          CR01   7
#                                      May 1985    april  1989          CR01   8
include:(AACOMN)#                                                       CR01   9
include:(CRCOMN)#                                                       CR01  10
#                                                                       CR01  11
REAL       A(6)#             ## RECIPROCAL CELL CONSTANTS               CR01  12
REAL       D(6)#             ## DIRECT     CELL CONSTANTS               CR01  13
REAL       Q1#                                                          CR01  14
INTEGER    I,J,K,L,L0,LTYP,MSYM,N#                                      CR01  15
INTEGER    IP#               ## PACKET POINTER OR ITEM NUMBER           CR01  16
INTEGER    KEY#              ## KEY FOR COMPCHAR:                       CR01  17
INTEGER    PACK#             ## PACK SIZE                               CR01  18
#                                                                       CR01  19
chardata:(CR11,  DS CY SK TL MR FU LR WW M1 M2 ND )#                    CR01  20
chardata:(CR12,  M3 M4 ML XR NU FR F2 IN FH BD FM BL US SS AD RD AX $#  CR01  21
RX OV IS AN MX PP WU WS WW AP EP TR TW TT TC L1 L2 P1 P2 MS AO AA RA )# CR01  22
chardata:(CR13, CRYLSQ CONTROL PARAMETERS/-YES)#                        CR01  23
chardata:(CR14,[                           REFINE SCALE FACTOR   $#     CR01  24
US    DATA SET              1])#                                        CR01  25
chardata:(CR15,[ NUMBER OF CYCLES     1    APPLY/REF DISPERSION  $#     CR01  26
NO    REFL.SKIP FACT.       1])#                                        CR01  27
chardata:(CR16,[ REFINEMENT TYPE     FR    APPLY/REF EXTINCTION  $#     CR01  28
NO    TYPE LESS-THANS, Q=  NO])#                                        CR01  29
chardata:(CR17,[ BLOCKING TYPE       BD    APPLY/REF ABS.STR.PAR $#     CR01  30
NO    PARTIAL CONTRIBUTION NO])#                                        CR01  31
chardata:(CR18,[ DISP.PARM.TYPE      MX    LIST REFLECTIONS      $#     CR01  32
NO    MATRIX CONTR, W*D<   NO])#                                        CR01  33
chardata:(CR19,[ REFINE POP.PAR.     NO    LIST POOR REFL, W*D>  $#     CR01  34
NO    MATRIX CONTR(LT)     NO])#                                        CR01  35
chardata:(CR110,[ WEIGHTING SCHEME    WU    PUNCH PARAM CARDS     $#    CR01  36
NO    DISP.PARM. NON-POS   TR])#                                        CR01  37
chardata:(CR111,[ DAMPING FACTOR    1.00    LIST MATRIX, Q=       $#    CR01  38
NO    TERMINATE REFINEM.   NO])#                                        CR01  39
chardata:(CR112,[ OUTPUT OLD PARAMS   NO    SAVE CORR.MATRIX      $#    CR01  40
NO])#                                                                   CR01  41
realdata:(FMT,[230213.,510213.,780213.,230442.,510442.,780442.])#       CR01  42
realdata:(TR11,[.5,.6666667,0.,0.,.5,.5])#                              CR01  43
realdata:(TR12,[.5,.3333333,.5,.5,0.,.5])#                              CR01  44
realdata:(TR13,[.5,.3333333,.5,.5,.5,0.])#                              CR01  45
realdata:(TR21,[.3333333,.5])#                                          CR01  46
realdata:(TR22,[.6666667,0.])#                                          CR01  47
realdata:(TR23,[.6666667,.5])#                                          CR01  48
datastuff:#                                                             CR01  49
#                                                                       CR01  50
#       SET UP AND REQUEST FILE BUFFERS                                 CR01  51
#       -------------------------------                                 CR01  52
#                                                                       CR01  53
IOMARK(1)=QXSTR#                       Buffer for file 1                CR01  54
incrqx:(MARK0,IOMARK(1)+bdfbuf:,CR0120)# Request memory                 CR01  55
readwpkt:(1,lrlabl:,PACK,IP,0)#        Enter bdf history                CR01  56
#                                                                       CR01  57
#       SET DEFAULT VALUES                                              CR01  58
#       ------------------                                              CR01  59
#                                                                       CR01  60
BTOHU=1.266514795;BTOU=0.012665148#                                     CR01  61
DATSET=1;RADTYP=1;NCYCLE= 1;NSKIP =1#                                   CR01  62
RFLTYP=0;BLKTYP=0;REFUOV=-1;REFTMP=3#                                   CR01  63
REFDSP=0;REFSKF=1;REFEXT= 0;REFABS=0#                                   CR01  64
REFPOP=0;EXTTYP=0;EXTESD=0.#                                            CR01  65
LISTMA=0;LIST  =0#                                                      CR01  66
PNCHCD=0;SAVEMA=0#                                                      CR01  67
RFLIST=1000000.;MALIST=.0;TYPELT=.0;RFMTRX=1000000.#                    CR01  68
PARTL =0;TMPTST=0;TERMNT=0;LTMTRX=0#                                    CR01  69
DAMP=-1.;IWT   =2;XABS =0.;XABSIG=voidflg:;ADDOLD=0#                    CR01  70
DO I=1,3;POLSPG(I)=0#                                                   CR01  71
ICYCLE=1#                                                               CR01  72
#                                                                       CR01  73
#       EXTRACT VALUES FROM CRYLSQ CARD                                 CR01  74
#       -------------------------------                                 CR01  75
#                                                                       CR01  76
FOR(I=1;I<=mxfdim:;I=I+1)#             Loop over input fields           CR01  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR01  78
ifvo:(BUFIN(I)) BREAK#                 Stop at first void field         CR01  79
stringlim:(I,K,L)#                     Get string limits                CR01  80
compchar:(CHRIN,K,CR11,3,2,3,NCR11,KEY)# Test if in cr11                CR01  81
IF(KEY>0)#                             Code found in cr11               CR01  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR01  83
IF(KEY>10)  NEXT#                      Skip default entries             CR01  84
IF(KEY==8)  IWT=3#                     Weighting scheme                 CR01  85
IF(KEY>8)   LISTMA=KEY-8#              List corr.matrix (last/every)    CR01  86
IF(BUFIN(I+1)>voidflg:)#               Next field numeric               CR01  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR01  88
I=I+1#                                 Incr pointer                     CR01  89
IF     (KEY==1) DATSET=NINT(BUFIN(I))# Data set nr                      CR01  90
ELSE IF(KEY==2) NCYCLE=NINT(BUFIN(I))# Nr of cycles                     CR01  91
ELSE IF(KEY==3) NSKIP =NINT(BUFIN(I))# Refelection skip factor          CR01  92
ELSE IF(KEY==4) TYPELT=BUFIN(I)#       Type hkl as lt if y.lt.q*sigy    CR01  93
ELSE IF(KEY==5) RFMTRX=BUFIN(I)#       Use in matrix if w*dy.lt.q       CR01  94
ELSE IF(KEY==6) DAMP  =BUFIN(I)#       Damping factor                   CR01  95
ELSE IF(KEY==7) RFLIST=BUFIN(I)#       List refl if w*dy.gt.q           CR01  96
ELSE IF(KEY==8) IWT   =INT(BUFIN(I))+3# Weighting scheme                CR01  97
ELSE IF(KEY<=10) MALIST=BUFIN(I)#      List corr m. el. if .gt.q        CR01  98
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR01  99
ELSE IF(KEY<=7) iquit:(-CR0101)#       Numerical field absent           CR01 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR01 101
ELSE#                                                                   CR01 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR01 103
compchar:(CHRIN,K,CR12,3,2,3,NCR12,KEY)# Test if in cr12                CR01 104
IF     (KEY<=0) iquit:(-CR0101)#       Strange code                     CR01 105
ELSE IF(KEY<=2) LISTMA=KEY+2#          List der. matrix                 CR01 106
ELSE IF(KEY==3) LTMTRX=1#              Use rcode2 refl. in matrix       CR01 107
ELSE IF(KEY==4) ;#                     Use rcode2 refl. in matrix       CR01 108
ELSE IF(KEY<=9) RFLTYP=KEY-6#          Refinement mode                  CR01 109
ELSE IF(KEY<=12) BLKTYP=KEY-10#        Refinement blocking              CR01 110
ELSE IF(KEY<=14) REFSKF=KEY-12#        Refine skf unit/separate         CR01 111
ELSE IF(KEY<=16) REFDSP=KEY-14#        Apply/refine dispersion          CR01 112
ELSE IF(KEY<=18) REFEXT=KEY-16#        Apply/refine extinction          CR01 113
ELSE IF(KEY<=22) REFTMP=KEY-19#        Displ.param type                 CR01 114
ELSE IF(KEY==23) REFPOP=1#             Refine population                CR01 115
ELSE IF(KEY<=26) IWT   =KEY-23#        Weighting scheme                 CR01 116
ELSE IF(KEY<=28) PARTL =KEY-26#        Fixed atoms used                 CR01 117
ELSE IF(KEY<=31) TMPTST=KEY-29#        Non-positive u                   CR01 118
ELSE IF(KEY==32) TERMNT=1#             Stop if no convergence           CR01 119
ELSE IF(KEY<=34) LIST  =KEY-32#        List refl. last/ecery cy         CR01 120
ELSE IF(KEY<=36) PNCHCD=KEY-34#        Output to coded file             CR01 121
ELSE IF(KEY==37) SAVEMA=1#             Save corr. matrix                CR01 122
ELSE IF(KEY<=38) ADDOLD=1#             Add old parameters to bdf        CR01 123
ELSE IF(KEY<=40) REFABS=KEY-38#        Apply/ref  abs.struct.param      CR01 124
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR01 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR01 126
IF(DAMP<.0)#                           Adapt damping factor             CR01 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR01 128
IF(BLKTYP==1) DAMP=1.#                 If full matrix                   CR01 129
ELSE DAMP=.8#                          If bd or bl                      CR01 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR01 131
#                                                                       CR01 132
#        PRINT CONTROL PARAMETERS                                       CR01 133
#        ------------------------                                       CR01 134
#                                                                       CR01 135
LINRM=10#                              Force header                     CR01 136
writeline:(2,CR13,26,3,1)#             Print header                     CR01 137
movechar:(CR13,28,CHROT,2,26,1)#       Underline header                 CR01 138
writeline:(0,0,0,1,1)#                 Print underline                  CR01 139
#                                                                       CR01 140
IF(REFSKF==2) movechar:(CR12,42,CR14,50,2,0)# Ss                        CR01 141
IF(DATSET!=1) ncodefld:(FLOAT(DATSET),1,CR14,FMT(3),1)# Data set nr     CR01 142
writeline:(0,CR14,NCR14,3,1)#                                           CR01 143
#                                                                       CR01 144
IF(NCYCLE<=0) iquit:(CR0104)#          Require at least one cycle       CR01 145
IF(NCYCLE> 1) ncodefld:(FLOAT(NCYCLE),1,CR15,FMT(1),1)# Nr of cycles    CR01 146
IF(REFDSP> 0) movechar:(CR12,(REFDSP+14)*3,CR15,50,2,0)# Ad/rd          CR01 147
IF(NSKIP > 1) ncodefld:(FLOAT(NSKIP),1,CR15,FMT(3),1)# Refl.skip        CR01 148
writeline:(0,CR15,NCR15,3,1)#                                           CR01 149
NCYCLE=NCYCLE+1#                       End with one more sf calc.       CR01 150
#                                                                       CR01 151
IF(RFLTYP> 0) movechar:(CR12,(RFLTYP+6)*3,CR16,22,2,0)# F2/in           CR01 152
IF(REFEXT> 0) movechar:(CR12,(REFEXT+16)*3,CR16,50,2,0)# Ax/ex          CR01 153
IF(TYPELT>.0) ncodefld:(TYPELT,1,CR16,780412.,1)# Q-value               CR01 154
writeline:(0,CR16,NCR16,3,1)#                                           CR01 155
#                                                                       CR01 156
IF(BLKTYP> 0) movechar:(CR12,(BLKTYP+10)*3,CR17,22,2,0)# Fm/bl          CR01 157
IF(REFABS> 0) movechar:(CR12,(REFABS+38)*3,CR17,50,2,0)# Aa/ra          CR01 158
IF(PARTL > 0) movechar:(CR12,(PARTL+26)*3,CR17,77,2,0)# Ap/ep           CR01 159
writeline:(0,CR17,NCR17,3,1)#                                           CR01 160
#                                                                       CR01 161
IF(REFTMP< 3) movechar:(CR12,(REFTMP+19)*3,CR18,22,2,0)# Ov/is/an       CR01 162
IF(LIST  > 0) movechar:(CR12,(LIST+32)*3,CR18,50,2,0)# L1/l2            CR01 163
IF(RFMTRX<10000.) ncodefld:(RFMTRX,1,CR18,780412.,1)# Q-value           CR01 164
writeline:(0,CR18,NCR18,3,1)#                                           CR01 165
#                                                                       CR01 166
IF(REFPOP> 0)     movechar:(CR12,69,CR19,22,2,0)# Pp                    CR01 167
IF(RFLIST<10000.) ncodefld:(RFLIST,1,CR19,510412.,1)# Q-value           CR01 168
IF(LTMTRX> 0) movechar:(CR13,29,CR19,76,3,0)# Lt refl to m              CR01 169
writeline:(0,CR19,NCR19,3,1)#                                           CR01 170
#                                                                       CR01 171
IF(IWT   > 0) movechar:(CR12,(IWT+23)*3,CR110,22,2,0)# Ws/ww            CR01 172
IF(IWT   >=3) ncodefld:(FLOAT(IWT-3),1,CR110,190213.,1)#                CR01 173
IF(PNCHCD> 0) movechar:(CR12,(PNCHCD+34)*3,CR110,50,2,0)# Atom output   CR01 174
IF(TMPTST> 0) movechar:(CR12,(TMPTST+29)*3,CR110,77,2,0)# Tw/tc         CR01 175
writeline:(0,CR110,NCR110,3,1)#                                         CR01 176
#                                                                       CR01 177
ifne:(DAMP,1.) ncodefld:(DAMP,1,CR111,FMT(4),1)# Damp                   CR01 178
IF(LISTMA> 2) movechar:(CR12,((LISTMA-2)*3),CR111,50,2,0)# M3/m4        CR01 179
ELSE IF(LISTMA>0)#                                                      CR01 180
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR01 181
movechar:(CR11,(LISTMA+8)*3,CR111,50,2,0)# M1/m2                        CR01 182
MALIST=ABS(MALIST)#                                                     CR01 183
IF(MALIST>.0) ncodefld:(MALIST,1,CR111,460422.,1)# Min. value in corr   CR01 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR01 185
IF(TERMNT> 0) movechar:(CR13,29,CR111,76,3,0)# Terminate ref if dr<0    CR01 186
writeline:(0,CR111,NCR111,3,1)#                                         CR01 187
IF(TERMNT> 0) TERMNT=10000000#         Start with large value           CR01 188
#                                                                       CR01 189
IF(ADDOLD> 0) movechar:(CR13,29,CR112,21,3,0)# Save old params on bdf   CR01 190
IF(SAVEMA> 0) movechar:(CR13,29,CR112,49,3,0)# Save corr.matrx          CR01 191
writeline:(0,CR112,NCR112,3,1)#                                         CR01 192
#                                                                       CR01 193
#       CELL AND SYMMETRY INFORMATION                                   CR01 194
#       -----------------------------                                   CR01 195
#                                                                       CR01 196
DO I=1,7#                              Loop over cell packets           CR01 197
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR01 198
readwpkt:(1,lrcell:,PACK,IP,0)#        Cell information                 CR01 199
IF(IP<=0) iquit:(-CR0102)#             Insufficient cell packets        CR01 200
IF(I==1) movereal:(QX,IP+1,D,1,6,0)#   Direct     cell constant         CR01 201
IF(I==3) movereal:(QX,IP+1,A,1,6,0)#   Reciprocal cell constant         CR01 202
IF(I==4) movereal:(QX,IP+1,CELL,13,9,0)# Transformation fract to or     CR01 203
IF(I==5)#                                                               CR01 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR01 205
swap:(IP+2,IP+4);swap:(IP+3,IP+7);swap:(IP+6,IP+8)# Write co * col      CR01 206
movereal:(QX,IP+1,CELL,22,9,0)#        Transformation orth to frac      CR01 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR01 208
IF(I==6) VOL=QX(IP+1)#                 Cell volume                      CR01 209
IF(I==7) movereal:(QX,IP+1,CELL,31,9,0)# Metric tensor                  CR01 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR01 211
DO I=1,3#                              Loop over axes/angles            CR01 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR01 213
CELL(I)=.25*A(I)*A(I)#                 1-6 conversion b to beta         CR01 214
CELL(I+6)=BTOHU/CELL(I)#               7-12 conversion beta to 100*     CR01 215
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR01 216
CELL(4)=.25*A(1)*A(2)*A(6)#                                             CR01 217
CELL(5)=.25*A(1)*A(3)*A(5)#                                             CR01 218
CELL(6)=.25*A(2)*A(3)*A(4)#                                             CR01 219
CELL(10)=4.0*BTOHU/(A(1)*A(2))#                                         CR01 220
CELL(11)=4.0*BTOHU/(A(1)*A(3))#                                         CR01 221
CELL(12)=4.0*BTOHU/(A(2)*A(3))#                                         CR01 222
UEQU(1)=(D(1)*A(1))**2/3.#             U(11) to uequiv                  CR01 223
UEQU(2)=(D(2)*A(2))**2/3.#             U(22) to uequiv                  CR01 224
UEQU(3)=(D(3)*A(3))**2/3.#             U(33) to uequiv                  CR01 225
UEQU(4)=2.*D(1)*A(1)*D(2)*A(2)*D(6)/3.# U(12)                           CR01 226
UEQU(5)=2.*D(1)*A(1)*D(3)*A(3)*D(5)/3.# U(13)                           CR01 227
UEQU(6)=2.*D(2)*A(2)*D(3)*A(3)*D(4)/3.# U(23)                           CR01 228
#                                                                       CR01 229
readwpkt:(1,lrsymm:,PACK,IP,0)#        Read symm packet                 CR01 230
IF(IP<=0) iquit:(-CR0103)#             Lrsymm: is missing               CR01 231
LTYP=NINT(QX(IP+1))#                   Lattice type                     CR01 232
ICENT=NINT(QX(IP+2))#                  Icent (0)/(1) (cen)/(noncen)     CR01 233
MSYM=NINT(QX(IP+3))#                   Total symmetry matrices          CR01 234
NSYM=NINT(QX(IP+4))#                   Unique symmetry matrices         CR01 235
RFLMLT=NINT(QX(IP+6))#                 Refl. multiplicity               CR01 236
incrqx:(MARK1,MARK0+12*MSYM,CR0120)#   Get total symop space            CR01 237
L0=MARK0#                              Pointer into mark0               CR01 238
DO I=1,NSYM#                           Loop over rot. matrices          CR01 239
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR01 240
readwpkt:(1,lrsymm:,PACK,IP,0)#        Read next packet                 CR01 241
IF(IP<=0) iquit:(-CR0103)#             Insufficient symm packets        CR01 242
movereal:(QX,IP+1,QX,L0+1,12,0)#       Move rotation matrix+vector      CR01 243
L0=L0+12#                              Advance pointer                  CR01 244
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR01 245
STOP0=L0; N=L0#                        Store limit of input matrices    CR01 246
IF(ICENT==0)#                          If centrosymmetric               CR01 247
FOR(K=MARK0;K<STOP0;K=K+12)#           Loop over input matrices         CR01 248
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR01 249
DO I=1,12; QX(N+I)=-QX(K+I)#           Store inverse element            CR01 250
N=N+12#                                Incr storage pointer             CR01 251
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR01 252
IF(LTYP>7) LTYP=LTYP-7#                Remove centric part              CR01 253
K=N#                                   Store temp end marker            CR01 254
IF(LTYP>1)#                            Test if sg centered              CR01 255
FOR(J=MARK0;J<N;J=J+12)#               Loop over symm matrices          CR01 256
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR01 257
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            CR01 258
QX(K+10)=QX(J+10)+TR11(LTYP-1)#        Transfer t1                      CR01 259
QX(K+11)=QX(J+11)+TR12(LTYP-1)#        Transfer t2                      CR01 260
QX(K+12)=QX(J+12)+TR13(LTYP-1)#        Transfer t3                      CR01 261
K=K+12#                                Incr storage pointer             CR01 262
IF((LTYP==2)\(LTYP>4)) NEXT#           Skip if not r or f               CR01 263
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            CR01 264
QX(K+10)=QX(J+10)+TR21(LTYP-2)#        Transfer t1                      CR01 265
QX(K+11)=QX(J+11)+TR22(LTYP-2)#        Transfer t2                      CR01 266
QX(K+12)=QX(J+12)+TR23(LTYP-2)#        Transfer t3                      CR01 267
K=K+12#                                Incr storage pointer             CR01 268
IF(LTYP!=4) NEXT#                      Skip if not f-centre             CR01 269
movereal:(QX,J+1,QX,K+1,9,0)#          Transfer rot elements            CR01 270
QX(K+10)=QX(J+10)+0.5#                 Transfer t1                      CR01 271
QX(K+11)=QX(J+11)+0.5#                 Transfer t2                      CR01 272
QX(K+12)=QX(J+12)+0.0#                 Transfer t3                      CR01 273
K=K+12#                                Incr storage pointer             CR01 274
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR01 275
FOR(J=MARK0;J<MARK1;J=J+12)#           Loop over symmetry matrices      CR01 276
DO I=10,12; QX(J+I)=MOD(5.+QX(J+I),1.)# Store translation modulo 1.     CR01 277
#                                                                       CR01 278
RETURN#                                                                 CR01 279
#                                                                       CR01 280
END#                                                                    CR01 281
systemheader:(CR02)#                   Image and bdf:scattering f.,     CR02   1
# ####################################################################  CR02   2
#                                                                       CR02   3
#                               CR02                                    CR02   4
#                                                                       CR02   5
# ####################################################################  CR02   6
SUBROUTINE CR02#                       R. olthof   august 1980          CR02   7
#                                      May 1985    april  1989          CR02   8
include:(AACOMN)#                                                       CR02   9
include:(CRCOMN)#                                                       CR02  10
#                                                                       CR02  11
string:(CH,140)#                                                        CR02  12
INTEGER    I,J,K,L,M,N#  ##                                             CR02  13
INTEGER    IREL(71)#   ## RELATIVE POINTERS IN BDF                      CR02  14
INTEGER    IP#         ## PACKET POINTER                                CR02  15
INTEGER    IWANT(70)#  ## WANTED ITEMS IN BDF                           CR02  16
INTEGER    KEY#        ## KEY FOR COMPARISONS                           CR02  17
INTEGER    L2,L3,L4#   ## POINTERS IN MARK2-, MARK3- AND MARK4-ARRAY    CR02  18
INTEGER    PACK#       ## PACK SIZE                                     CR02  19
#                                                                       CR02  20
chardata:(CR21, DISPER SCALE  EXTINC MAXHKL XABS   SELECT DPTYPE $#     CR02  21
GROUP  ATOMGR RESTR  CONSTR NOREF  BLOCK  END   )#                      CR02  22
chardata:(CR22, MAX /H/ /K/ /L/               )#                        CR02  23
chardata:(CR23, MIN/MAX SIN(T/L)             )#                         CR02  24
chardata:(CR24, ZACH TYP1 TYP2 GEN  ISO  ANIS GAUS LORE )#              CR02  25
realdata:(FMT,[210313.,250313.,290313.,$# Format for maxhkl,            CR02  26
230642.,290642.])#                     Max-min stol                     CR02  27
datastuff:#                                                             CR02  28
#                                                                       CR02  29
readline:(CR21,NCR21)#                 Read first line                  CR02  30
#                                                                       CR02  31
#       SCATTERING FACTORS, DISPERSION                                  CR02  32
#       ------------------------------                                  CR02  33
#                                                                       CR02  34
IWANT(1)=11#                           Scatt.fact.name                  CR02  35
IWANT(2)=20+DATSET; IWANT(3)=60+DATSET# Real/imag dispersion            CR02  36
IWANT(4)=2#                            Atomic weight                    CR02  37
IWANT(5)=7#                            Check for sf in lrrefl:          CR02  38
IWANT(6)=100#                          Get sf tables for xray           CR02  39
IWANT(7)=10#                           Get neutron sf                   CR02  40
SIGNAL(1)=1;SIGNAL(2)=7;SIGNAL(3)=7;SIGNAL(4)=0#                        CR02  41
indexpkt:(1,lrscat:,PACK,IP,0,SIGNAL,IWANT,IREL)#                       CR02  42
IF(IP<=0) iquit:(CR0201)#              Lrscat: is missing               CR02  43
IF(IREL(7)>0) RADTYP=2#                Test if neutron radiation        CR02  44
#                                                                       CR02  45
#                                                                       CR02  46
## COUNT ENTRIES IN SCATTERING FACTOR TABLES                            CR02  47
#                                                                       CR02  48
IF(RADTYP==1)#                         Xrays, not neutrons              CR02  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR02  50
NSFTB=0#                               Nr of entries in sf tabel        CR02  51
M=IP+IREL(6)#                          Point to first entry             CR02  52
IF(M>IP)#                              Tables present                   CR02  53
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR02  54
DSFTB=(QX(M+1)-QX(M))*.01#             Delta stol                       CR02  55
REPEAT#                                Loop over directory              CR02  56
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR02  57
IF((QX(M)<99.5)\(QX(M)>299.5)) BREAK#  Not stol entry                   CR02  58
M=M+1;NSFTB=NSFTB+1#                   Count entry                      CR02  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR02  60
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR02  61
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR02  62
ELSE NSFTB=1#                          Neutrons, not xrays              CR02  63
#                                                                       CR02  64
## GET SF NAMES, DISPERSION AND SF TABLES FROM LRSCAT:                  CR02  65
#                                                                       CR02  66
L=1;MARK2=MARK1+incr:(arith:(139,/,mxchwd:))# For 16 s.f. name          CR02  67
NSTEP2=4+NSFTB#                        Include need for sf tables       CR02  68
L2=MARK2#                              Set storage point disp f         CR02  69
NATTYP=0#                              Count atom types                 CR02  70
REPEAT#                                Loop over lrscat: packets        CR02  71
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR02  72
readwpkt:(1,lrscat:,PACK,IP,0)#        Read a packet                    CR02  73
IF(IP==0) BREAK#                       End of logical record            CR02  74
NATTYP=NATTYP+1#                       Count atom type                  CR02  75
M=IP+IREL(1)#                          Pointer to atom type id          CR02  76
movertoc:(QX(M),1,CH,L,8,0)#           Atom type id                     CR02  77
L=L+8#                                 Add up 8 characters              CR02  78
incrqx:(MARK3,L2+NSTEP2,CR0220)#       Incr qx                          CR02  79
QX(L2+1)=0.;QX(L2+2)=0.;QX(L2+3)=0.#   Default disp. values and flag    CR02  80
M=IREL(2)+IP;IF(M>IP) QX(L2+1)=QX(M)#  Store real disp if present       CR02  81
M=IREL(3)+IP;IF(M>IP) QX(L2+2)=QX(M)#  Store imag disp if present       CR02  82
IF(REFDSP>1) QX(L2+3)=FLOAT(NATTYP)#   Flag and nr of disp.             CR02  83
M=IREL(4)+IP;IF(M>IP) QX(L2+4)=QX(M)#  Store atomic weight              CR02  84
ELSE                  QX(L2+4)=1.#     Unit atomic weight               CR02  85
L2=L2+4#                               Advance pointer                  CR02  86
IF(RADTYP==1)#                         X-rays                           CR02  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR02  88
IF(NSTEP2==4) NEXT#                    No tables if sf in lrrefl:       CR02  89
M=IP+IREL(6)#                          Pointer to sf flag               CR02  90
IF(M<=IP) iquit:(CR0202)#              Better be there                  CR02  91
movereal:(QX,M,QX,L2+1,NSFTB,0)#       Move the table                   CR02  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR02  93
ELSE QX(L2+1)=QX(IP+IREL(7))#          Get neutron length               CR02  94
L2=L2+NSFTB#                           Advance pointer                  CR02  95
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR02  96
#                                                                       CR02  97
## READ DISPER LINES, IF ANY                                            CR02  98
#                                                                       CR02  99
REPEAT#                                Loop over disper lines           CR02 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR02 101
IF(LINID!=1) BREAK#                    Not disper line                  CR02 102
DO I=1,mxfdim:,3#                      Loop over fields                 CR02 103
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR02 104
ifvo:(BUFIN(I)) BREAK#                 Void field                       CR02 105
stringlim:(I,N,J)#                     Get string limits                CR02 106
label:(CHRIN(N^J-1),K,L,CH,KEY)#       Identify atom symbol             CR02 107
IF(KEY==0) iquit:(-CR0203)#            Wrong attyp id                   CR02 108
L2=MARK2+(KEY-1)*NSTEP2#               Pointer for dispersion facto     CR02 109
IF(BUFIN(I+1)>voidflg:) QX(L2+1)=BUFIN(I+1)# Real dispersion val        CR02 110
IF(BUFIN(I+2)>voidflg:) QX(L2+2)=BUFIN(I+2)# Imag dispersion val        CR02 111
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR02 112
readline:(CR21,NCR21)#                                                  CR02 113
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR02 114
#                                                                       CR02 115
#        DATA SET DEFINITIONS                                           CR02 116
#        --------------------                                           CR02 117
#                                                                       CR02 118
DO I=1,DATSET;readwpkt:(1,lrddef:,PACK,IP,0)# Read lrddef:              CR02 119
IF(IP>0) movertoc:(QX(IP+1),1,CH,129,12,0)# Move data set name          CR02 120
ELSE     movechar:(BLANK,1,CH,129,12,1)# Move blank                     CR02 121
movector:(CH,1,QX(MARK1+1),1,140,0)#   Move attyp + data set names      CR02 122
#                                                                       CR02 123
#       SCALE FACTORS, LAMBDA AND MU                                    CR02 124
#       ----------------------------                                    CR02 125
#                                                                       CR02 126
IWANT(1)=1;IWANT(2)=2;IWANT(3)=10#     Data set; lambda; mu             CR02 127
FOR(I=1;I<=64;I=I+1) IWANT(I+3)=100+I# Request scale groups             CR02 128
IWANT(68)=50#                          Two theta monochromator          CR02 129
IWANT(69)=52#                          Polarization fraction            CR02 130
SIGNAL(1)=0; SIGNAL(2)=69;SIGNAL(3)=0;SIGNAL(4)=0#                      CR02 131
indexpkt:(1,lrexpl:,PACK,IP,0,SIGNAL,IWANT,IREL)#                       CR02 132
IF(IP<=0) iquit:(CR0204)#              Lrexpl: not there                CR02 133
incrqx:(MARK4,MARK3+2,CR0220)#         Allow for one scale factor       CR02 134
QX(MARK3+1)=1.;QX(MARK3+2)=1.#         Default scales                   CR02 135
REPEAT#                                Loop over lrexpl: packets        CR02 136
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR02 137
readwpkt:(1,lrexpl:,PACK,IP,0)#        Read a packet                    CR02 138
IF(IP<=0) iquit:(CR0204)#              Requested packet not there       CR02 139
IF(IREL(1)>0)#                         Test if data set nr stored       CR02 140
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR02 141
M=IP+IREL(1)#                          Point to data set                CR02 142
IF(DATSET!=NINT(QX(M))) NEXT#          Skip incorrect data sets         CR02 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR02 144
M=IP+IREL(2);LAMBDA=QX(M)#             Wave length                      CR02 145
M=IP+IREL(3);MU=0.#                    Point to mu                      CR02 146
IF(M>IP) ifnm:(QX(M)) MU=QX(M)#        Store mu                         CR02 147
M=IP+IREL(68)#                         Point to 2theta monochrom        CR02 148
IF(M>IP) ifnm:(QX(M)) MONO2T=QX(M)*.01745329# Two theta monochrom fro   CR02 149
ELSE#                                  Monochrom 2 theta not stored     CR02 150
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR02 151
MONO2T=LAMBDA/6.708#                   Lambda/(2*lattice spacing)       CR02 152
MONO2T=2.*ASIN(MONO2T)#                2 * monochrometer angle          CR02 153
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR02 154
MONO2T=(COS(MONO2T))**2#               Convert to cosine                CR02 155
M=IP+IREL(69)#                         Point to polarization fraction   CR02 156
IF(M>IP) ifnm:(QX(M)) RATIO=QX(M)#     Get the fraction                 CR02 157
ELSE                  RATIO=MONO2T/(MONO2T+1.)# Default                 CR02 158
L3=MARK3#                              Pointer into mark3               CR02 159
DO I=1,64#                             Loop over scale groups           CR02 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR02 161
M=IP+IREL(I+3);IF(M<=IP) NEXT#         Point to scale factor            CR02 162
ifvo:(QX(M))             NEXT#         Skip if scale is void            CR02 163
incrqx:(MARK4,L3+2,CR0220)#            Incr qx                          CR02 164
QX(L3+1)=QX(M)#                        Store scale factor               CR02 165
QX(L3+2)=FLOAT(I)#                     Store scale group number         CR02 166
L3=L3+2#                               Advance pointer                  CR02 167
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR02 168
BREAK#                                                                  CR02 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR02 170
#                                                                       CR02 171
## READ SCALE LINES                                                     CR02 172
#                                                                       CR02 173
REPEAT#                                Loop over scale lines            CR02 174
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR02 175
IF(LINID!=2) BREAK#                    Not a scale line                 CR02 176
DO I=1,mxfdim:,2#                      Loop over fields                 CR02 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR02 178
ifvo:(BUFIN(I)) BREAK#                 Break on first void field        CR02 179
ifvo:(BUFIN(I+1)) BUFIN(I+1)=1.#       Default scale group number       CR02 180
IF((BUFIN(I+1)<0.5)\(BUFIN(I+1)>64.5)) NEXT# Bad scale gro              CR02 181
FOR(L3=MARK3;L3<MARK4;L3=L3+2)#        Loop over scales                 CR02 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR02 183
ifne:(QX(L3+2),BUFIN(I+1)) NEXT#       Not the one we want              CR02 184
QX(L3+1)=BUFIN(I)#                     Store new scale factor           CR02 185
BREAK#                                 Quit looking                     CR02 186
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR02 187
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR02 188
readline:(CR21,NCR21)#                 Read next line                   CR02 189
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR02 190
#                                                                       CR02 191
#       UOV, EXTINCTION, MAXHKL, XABS                                   CR02 192
#       -----------------------------                                   CR02 193
#                                                                       CR02 194
IWANT(1)=1;IWANT(2)=2#                 Data set; uov                    CR02 195
DO I=3,7;  IWANT(I)=I+8#               Request maxhkl, max-min stol     CR02 196
DO I=1,17; IWANT(I+7)=100+I#           Request extinction parameter     CR02 197
IWANT(25)=3#                           Request abs.struct.parameter     CR02 198
SIGNAL(1)=0; SIGNAL(2)=25;SIGNAL(3)=0;SIGNAL(4)=0#                      CR02 199
indexpkt:(1,lrdset:,PACK,IP,0,SIGNAL,IWANT,IREL)#                       CR02 200
IF(IP<=0) iquit:(CR0205)#              Lrdset: is missing               CR02 201
#                                                                       CR02 202
incrqx:(MARK5,MARK4+22,CR0220)#        Incr qx                          CR02 203
QX(MARK4+1)=.035/BTOU#                 Default bov                      CR02 204
QX(MARK4+16)=999.;QX(MARK4+17)=999.;QX(MARK4+18)=999.# Default maxhkl   CR02 205
QX(MARK4+19)=.0001;QX(MARK4+20)=10.#   Default min-max stol             CR02 206
QX(MARK4+21)=-1.#                      Code for maxhkl line inp         CR02 207
REPEAT#                                Loop over packets                CR02 208
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR02 209
readwpkt:(1,lrdset:,PACK,IP,0)#        Read lrdset: packet              CR02 210
IF(IP<=0) BREAK#                       Lr ended too soon                CR02 211
M=IP+IREL(1)#                          Point to datset                  CR02 212
IF(DATSET!=NINT(QX(M))) NEXT#          Skip incorrect data sets         CR02 213
M=IP+IREL(2)#                          Point to uov                     CR02 214
IF(M>IP) QX(MARK4+1)=QX(M)/BTOU#       Store bov if there               CR02 215
DO I=3,7#                              Loop over maxhkl, min-max st     CR02 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR02 217
M=IP+IREL(I);IF(M<=IP) NEXT#           Skip if not present              CR02 218
QX(MARK4+13+I)=QX(M)#                  Store value                      CR02 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR02 220
#                                                                       CR02 221
IF(REFEXT>0)#                          Ext. calc or refinement          CR02 222
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR02 223
M=IP+IREL(8)#                          Extinction type                  CR02 224
IF(M>IP)ifnm:(QX(M)) EXTTYP=NINT(QX(M))# Get exttyp if there            CR02 225
M=IP+IREL(9)#                          Distribution type                CR02 226
IF(M>IP)ifnm:(QX(M)) DSTEXT=NINT(QX(M))# Get distribution type          CR02 227
IF(RADTYP==1)      QX(MARK4+22)=0.3#   Default tbar in mm for xray      CR02 228
ELSE               QX(MARK4+22)=1.5#   Default tbar in mm for neutron   CR02 229
M=IP+IREL(24)#                         Point to mean tbar               CR02 230
IF(M>IP) IF(QX(M)>.0) QX(MARK4+22)=QX(M)# Mean tbar mm                  CR02 231
DO I=10,23#                            Loop over possible params        CR02 232
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR02 233
M=IP+IREL(I)#                                                           CR02 234
IF(M>IP) ifnm:(QX(M))#                 If ext values present            CR02 235
QX(MARK4-8+I)=QX(M)/10000.#            Store extinction parameter       CR02 236
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR02 237
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR02 238
IF(REFABS>0)#                          Abs.struct. param appl/refined   CR02 239
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR02 240
M=IP+IREL(25);IF(M>IP) XABS=QX(M)#     Abs.struct.parameter             CR02 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR02 242
BREAK#                                                                  CR02 243
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR02 244
#                                                                       CR02 245
## READ EXTINC LINE                                                     CR02 246
#                                                                       CR02 247
IF(LINID==3)#                          Extinc line                      CR02 248
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR02 249
ifnv:(BUFIN(1))#                       Extinction type                  CR02 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR02 251
stringlim:(1,K,L);L=MIN0(4,L-K)#       What type of extinction?         CR02 252
compchar:(CHRIN,K,CR24,2,L,5,20,I)#    Compare ext. types               CR02 253
IF(I==0) iquit:(CR0208)#               Wrong type                       CR02 254
EXTTYP=I-1#                            0/1/2/3=zach/bc1/bc2/bcgen       CR02 255
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR02 256
ifnv:(BUFIN(2))#                       Iso or aniso                     CR02 257
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR02 258
stringlim:(2,K,L);L=MIN0(4,L-K)#       Read field 2                     CR02 259
compchar:(CHRIN,K,CR24,22,L,5,10,I)#   Iso or aniso                     CR02 260
IF(I==0) iquit:(CR0208)#               Wrong code                       CR02 261
IF(I==2) EXTTYP=EXTTYP+3#              Anisotropic types                CR02 262
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR02 263
ifnv:(BUFIN(3))#                       Gauss or lorentz                 CR02 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR02 265
stringlim:(3,K,L);L=MIN0(4,L-K)#       Read field 3                     CR02 266
compchar:(CHRIN,K,CR24,32,L,5,10,I)#   Gauss or lorentz                 CR02 267
IF(I==0) iquit:(CR0208)#               Wrong code                       CR02 268
DSTEXT=I-1#                            Distribution type                CR02 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR02 270
L4=MARK4+1#                            Pointer in mark4 array           CR02 271
ifnv:(BUFIN(4)) QX(L4+ 1)=BUFIN(4)/10000.# Store param g/10000          CR02 272
ifnv:(BUFIN(5)) QX(L4+ 2)=BUFIN(5)/10000.# Store param rho/10000        CR02 273
ifnv:(BUFIN(6)) QX(L4+21)=BUFIN(6)#    Store param mean tbar in mm      CR02 274
readline:(CR21,NCR21)#                 Read next line                   CR02 275
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR02 276
#                                                                       CR02 277
## READ MAXHKL LINE                                                     CR02 278
#                                                                       CR02 279
IF(LINID==4)#                          Maxhkl line                      CR02 280
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR02 281
QX(MARK4+21)=1.#                       Code for maxhkl input line       CR02 282
L4=MARK4+15#                           Place to put them                CR02 283
DO I=1,5#                              Maxhkl,min-max stol              CR02 284
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR02 285
L4=L4+1#                               Advance pointer                  CR02 286
IF(BUFIN(I)>=0.0) QX(L4)=BUFIN(I)#     Store item                       CR02 287
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR02 288
ncodefld:(QX,MARK4+16,CR22,FMT(1),3)#  Encode maxhkl                    CR02 289
writeline:(0,CR22,NCR22,3,1)#          Write the line                   CR02 290
ncodefld:(QX,MARK4+19,CR23,FMT(4),2)#  Encode min-max stol              CR02 291
writeline:(0,CR23,NCR23,3,1)#          Write the line                   CR02 292
readline:(CR21,NCR21)#                 Read next line                   CR02 293
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR02 294
IF(EXTTYP>3)iquit:(CR0208)#            Aniso ext not implemented        CR02 295
#                                                                       CR02 296
## READ XABS LINE                                                       CR02 297
#                                                                       CR02 298
IF(LINID==5)#                          Xabs line                        CR02 299
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR02 300
XABS=BUFIN(1)#                         Abs.struct.param.                CR02 301
readline:(CR21,NCR21)#                 Read next line                   CR02 302
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR02 303
#                                                                       CR02 304
RETURN#                                                                 CR02 305
END#                                                                    CR02 306
systemheader:(CR03)#                   Input of atom parameters         CR03   1
# ####################################################################  CR03   2
#                                                                       CR03   3
#                               CR03                                    CR03   4
#                                                                       CR03   5
# ####################################################################  CR03   6
SUBROUTINE CR03#                       R. olthof   august 1980          CR03   7
#                                      May 1985                         CR03   8
include:(AACOMN)#                                                       CR03   9
include:(CRCOMN)#                                                       CR03  10
#                                                                       CR03  11
INTEGER ATTYP#     ## ATOM TYPE                                         CR03  12
string:(CH,500)#   ## SCRATCH CHARACTER ARRAY                           CR03  13
INTEGER DPTYP(10)# ## DISPL.PARAMS TYPE FLAGS                           CR03  14
INTEGER FLGOVA#    ## 1, WHEN ONE OR MORE DISPL.PARAMS ARE OVERALL      CR03  15
INTEGER FLGISO#    ## 1, WHEN ONE OR MORE DISPL.PARAMS ARE ISOTROPIC    CR03  16
INTEGER FLGANI#    ## 1, WHEN ONE OR MORE DISPL.PARAMS ARE ANISOTROPI   CR03  17
INTEGER I,J,J1,K,M,N,N5#                                                CR03  18
INTEGER IP#        ## PACKET POINTER                                    CR03  19
INTEGER IREL(38)#  ## OFFSET FOR IWANT                                  CR03  20
INTEGER IWANT(37)# ## WANTED ITEMS                                      CR03  21
INTEGER JUNK#      ##                                                   CR03  22
INTEGER KEY#       ##                                                   CR03  23
INTEGER L5#        ## POINTER IN MARK5 ARRAY                            CR03  24
string:(NAME,128)#                                                      CR03  25
string:(NAME1,24)#                                                      CR03  26
INTEGER NCH#       ## NR OF CHARACTERS IN CH                            CR03  27
INTEGER NSLAVE#    ## no. slave atoms excluded from calculations        CR03  28
INTEGER N1,NL#     ## SELECT SEARCH, FIRST CHAR/NR OF CHAR IN CH-ARRA   CR03  29
INTEGER PACK#      ## PACKET SIZE                                       CR03  30
REAL    Q#         ## SCRATCH FOR SUMMATION OF ANISOTROPIC DISPL.PARA   CR03  31
INTEGER TMP#       ## NR. OF DISPL.PARAMS FOR REFINEMENT OF CURRENT A   CR03  32
#                                                                       CR03  33
chardata:(CR31, SELECT DPTYPE GROUP  ATOMGR RESTR  CONSTR NOREF $#      CR03  34
 BLOCK  RESTR  END   )#                                                 CR03  35
chardata:(CR32, /  OV IS AN )#                                          CR03  36
chardata:(CR33, SLAVE ATOMS EXCLUDED FROM CALC.          )#             CR03  37
intdata:(ATTMP,[0])#                   Displ.param type of current at   CR03  38
datastuff:#                                                             CR03  39
#                                                                       CR03  40
LINID=LINID-5#                         Adjust linid value               CR03  41
#                                                                       CR03  42
#       ATOM SELECTION LINES                                            CR03  43
#       --------------------                                            CR03  44
#                                                                       CR03  45
SELECT=no:;NCH=1; CH=' '#              Set atom selection flag          CR03  46
REPEAT#                                Loop over select lines           CR03  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR03  48
IF(LINID!=1) BREAK#                    Not a select line                CR03  49
SELECT=yes:#                           Special atom selection           CR03  50
DO I=1,mxfdim:#                        Loop over fields                 CR03  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR03  52
ifvo:(BUFIN(I)) BREAK#                                                  CR03  53
IF(NCH>500) iquit:(CR0301)#            Scratch array is too short       CR03  54
stringlim:(I,N,J)#                     Get string limits                CR03  55
compchar:(CR32,2,CHRIN,N,1,1,J-N,J1)#  Is there a "/"                   CR03  56
IF(J1>0)#                              Yes                              CR03  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR03  58
CH(NCH^)=CHRIP(N^N+J1-2)#                                               CR03  59
CH(NCH+24^)='/'#                                                        CR03  60
NCH=NCH+25;N=N+J1#                     Advance pointers                 CR03  61
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR03  62
CH(NCH^)=CHRIP(N^J-1)#                                                  CR03  63
NCH=NCH+25#                            Advance character pointer        CR03  64
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR03  65
readline:(CR31,NCR31)#                 Read next line                   CR03  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR03  67
NCH=NCH-1#                             Nr of characters in ch           CR03  68
#                                                                       CR03  69
#       DISPLACEMENT PARAMETER TYPE LINES                               CR03  70
#       ---------------------------------                               CR03  71
#                                                                       CR03  72
DO I=1,NATTYP;DPTYP(I)=-1#             Set up default dp types          CR03  73
movertoc:(QX(MARK1+1),1,NAME,1,8*NATTYP,0)# Atom type names             CR03  74
REPEAT#                                Loop over input lines            CR03  75
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR03  76
IF(LINID!=2) BREAK#                    Stop when no more dptype lines   CR03  77
REFTMP=4#                              Set dp type to mixed             CR03  78
DO I=1,mxfdim:,2#                      Loop over input fields           CR03  79
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR03  80
ifvo:(BUFIN(I)) BREAK#                 Stop on first void field         CR03  81
stringlim:(I,N,J)#                     Find string limits               CR03  82
label:(CHRIN(N^),J,K,NAME,KEY)#        Get atom type symbol number      CR03  83
IF(KEY==0) iquit:(-CR0304)#            Nonexistatnt dp type             CR03  84
stringlim:(I+1,N,J)#                   Get string limits                CR03  85
compchar:(CHRIN,N,CR32,5,2,3,9,J)#     Compare dp types                 CR03  86
IF(J==0) iquit:(-CR0304)#              Bad dp type                      CR03  87
DPTYP(KEY)=J-1#                        Save requested tf type           CR03  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR03  89
readline:(CR31,NCR31)#                 Read next line                   CR03  90
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR03  91
#       ATOM PARAMETERS                                                 CR03  92
#       ---------------                                                 CR03  93
#                                                                       CR03  94
## DIRECTORY PACKET                                                     CR03  95
#                                                                       CR03  96
IWANT(1)=14;IWANT(2)=22#               At.id.; sf pointer               CR03  97
DO I= 1,13;IWANT(I+ 2)=I#              Loop over atom paramters         CR03  98
DO I= 1,13;IWANT(I+15)=I+100#          Loop over atom paramters         CR03  99
IWANT(29)=21;IWANT(30)=23;IWANT(31)=24# Atom mlt,tf type,group key      CR03 100
IWANT(32)=25;IWANT(33)=17#             Model key, data set              CR03 101
IWANT(34)=215#                         Slave atom key                   CR03 102
SIGNAL(1)=5;SIGNAL(2)=34#              Mandatory items 1-5              CR03 103
SIGNAL(3)=0;SIGNAL(4)=0#               Set search keys                  CR03 104
indexpkt:(1,lratom:,PACK,IP,0,SIGNAL,IWANT,IREL)#                       CR03 105
IF(IP<=0) iquit:(CR0302)#              Lratom: absent                   CR03 106
IF(SIGNAL(4)<0) iquit:(CR0302)#        Mandatory items absent           CR03 107
IF(IREL(30)==0)#                       All atoms have same dptyp        CR03 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR03 109
IF(IREL(7)>0)      ATTMP=2#            Anisotropic                      CR03 110
ELSE IF(IREL(6)>0) ATTMP=1#            Isotropic                        CR03 111
IF(REFTMP==3) REFTMP=ATTMP#                                             CR03 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR03 113
IF(REFTMP==2) TMP=6#                   Refine 6 dp par                  CR03 114
ELSE          TMP=REFTMP#              Refine 1 or 0 dp par             CR03 115
IF((REFPOP==0)&(IREL(13)==0)) POP=0#   Pop param is absent              CR03 116
ELSE                          POP=1#   Pop param is present             CR03 117
IF(IREL(29)==0) MLT=0#                 No at.mult.                      CR03 118
ELSE            MLT=1#                                                  CR03 119
#                                                                       CR03 120
## LOOP OVER THE ATOMS                                                  CR03 121
#                                                                       CR03 122
L5=MARK5+1;NAT=0#                      Atom pointer,nr of atoms         CR03 123
FLGOVA=0;FLGISO=0;FLGANI=0#            Flags for overall,iso,aniso      CR03 124
N1=1;NL=NCH#                           Counters for select search       CR03 125
NSLAVE=0#                              Reset count of slave atoms       CR03 126
REPEAT#                                Loop over atom packets           CR03 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR03 128
readwpkt:(1,lratom:,PACK,IP,0)#        Read an atom packet              CR03 129
IF(IP==0) BREAK#                       End of lratom:                   CR03 130
M=IP+IREL(33)#                         Point to data set number         CR03 131
IF(M>IP)#                              Test if on bdfa set              CR03 132
IF(DATSET!=NINT(QX(M))) NEXT#          Skip wrong data set              CR03 133
M=IP+IREL(2);ATTYP=NINT(QX(M))#        Sf pointer                       CR03 134
#                                                                       CR03 135
## CHECK ON SLAVE ATOMS                                                 CR03 136
#                                                                       CR03 137
M=IP+IREL(34); IF(M>IP)#               If key is present                CR03 138
ifeq:(QX(M),-9.)#                      Test if slave atom               CR03 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR03 140
NSLAVE=NSLAVE+1;   NEXT#               Count slaves & exit              CR03 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR03 142
#                                                                       CR03 143
## SELECT SPECIFIED ATOMS                                               CR03 144
#                                                                       CR03 145
IF(SELECT==yes:)#                      Select atoms                     CR03 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR03 147
KEY=0#                                 Key for selection                CR03 148
M=IP+IREL(1)#                          Atom id from bdf                 CR03 149
movertoc:(QX(M),1,NAME,1,24,0)#        Move atom id                     CR03 150
compchar:(NAME,1,CH,N1,24,25,NL,KEY)#  Compare                          CR03 151
IF((N1==1)&(KEY>0))#                   Init. for next search            CR03 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR03 153
K=25*KEY#                              Point to last char               CR03 154
IF(CH(K^K)=='/')#                      Compare with "/"                 CR03 155
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR03 156
N1=K+1;NL=25#                          Counters for next search         CR03 157
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR03 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR03 159
ELSE IF(N1>1)#                         Check only one item              CR03 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR03 161
IF(KEY==0) KEY=1#                      Atom in serie of selected at     CR03 162
ELSE#                                  Last atom of serie               CR03 163
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR03 164
N1=1;NL=NCH#                           Init. for next search            CR03 165
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR03 166
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR03 167
IF(KEY==0) NEXT#                       Atom not selected                CR03 168
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR03 169
#                                                                       CR03 170
## GET INFO FROM BDF                                                    CR03 171
#                                                                       CR03 172
NAT=NAT+1#                             Count atoms                      CR03 173
incrqx:(JUNK,L5+26,CR0320)#            Incr qx                          CR03 174
M=IP+IREL(1)#                          Point to atom id                 CR03 175
movereal:(QX,M,QX,L5,name:,0)#         Store atom id                    CR03 176
movertoc:(QX(M),1,NAME1,1,24,0)#       Store atom id                    CR03 177
label:(NAME1,I,J)#                     Process atom label               CR03 178
N5=L5+name:;L5=N5+1#                   Point to atom coord              CR03 179
intpak:(ATTYP,QX(L5),0,5)#             Store packed atom type           CR03 180
DO I=1,3#                              Loop over coord                  CR03 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR03 182
M=IP+IREL(I+2);QX(L5+I)=QX(M)#         X,y,z                            CR03 183
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR03 184
#                                                                       CR03 185
## STORE ATOMIC DISPLACEMENT PARAMETERS AS REQUESTED                    CR03 186
#                                                                       CR03 187
M=IP+IREL(30);IF(M>IP) ATTMP=NINT(QX(M))# Get dp flag                   CR03 188
IF(REFTMP>=3)#                         Mixed dp                         CR03 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR03 190
IF(DPTYP(ATTYP)>=0) TMP=DPTYP(ATTYP)#  Dp from dptype line              CR03 191
ELSE                TMP=ATTMP#         Dp from bdf or crylsq line       CR03 192
IF(TMP==2)          TMP=6#             Set 6 anisotr dp                 CR03 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR03 194
intpak:(TMP,QX(L5),5,3)#               Pack number of stored dp         CR03 195
L5=L5+3#                               Point to next param              CR03 196
IF(TMP==0) FLGOVA=1#                   Set refine ova flag              CR03 197
ELSE IF(TMP==1)#                       Refine iso                       CR03 198
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR03 199
L5=L5+1;FLGISO=1#                      Adjust pointer; set refine iso   CR03 200
QX(L5)=QX(MARK4+1)#                    Stored bova -> biso              CR03 201
IF(ATTMP==1)#                          Test if iso dp requested         CR03 202
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR03 203
M=IP+IREL(6);IF(M>IP) QX(L5)=QX(M)/BTOU# Uiso -> biso                   CR03 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR03 205
ELSE IF(ATTMP==2)#                     Test if aniso dp requested       CR03 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR03 207
M=IP+IREL(7)#                          Point to aniso dp                CR03 208
QX(L5)=(QX(M)+QX(M+1)+QX(M+2))/3.0/BTOU# Mean uij -> biso               CR03 209
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR03 210
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR03 211
ELSE#                                  Refine aniso                     CR03 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR03 213
FLGANI=1#                              Set refine aniso flag            CR03 214
IF(ATTMP<=1)#                          Uova or uiso on bdf              CR03 215
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR03 216
Q=QX(MARK4+1)#                         Stored uova -> q                 CR03 217
IF(ATTMP==1)#                          Uiso on bdf                      CR03 218
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR03 219
M=IP+IREL(6);IF(M>IP) Q=QX(M)/BTOU#    Stored uiso -> q                 CR03 220
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR03 221
DO I=1,6#                              Loop over aniso elements         CR03 222
QX(L5+I)=Q*CELL(I)#                    Q -> betaij                      CR03 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR03 224
ELSE#                                  Uij on bdf                       CR03 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR03 226
DO I=1,6#                                                               CR03 227
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR03 228
M=IP+IREL(I+6);QX(L5+I)=100.*QX(M)/CELL(I+6)# Uij -> betaij             CR03 229
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR03 230
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR03 231
L5=L5+6#                                                                CR03 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR03 233
#                                                                       CR03 234
## POPULATION PARAMETER, ATOM MULTIPLICITY                              CR03 235
#                                                                       CR03 236
IF(POP>0)#                             Pop param present                CR03 237
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR03 238
L5=L5+1#                               Advance pointer                  CR03 239
QX(L5)=1.#                             Default pop param                CR03 240
M=IP+IREL(13);IF(M>IP) QX(L5)=QX(M)#   Store pop param                  CR03 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR03 242
IF(MLT>0)#                             Atom multiplicity present        CR03 243
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR03 244
L5=L5+1#                               Advance pointer                  CR03 245
QX(L5)=1.#                             Default atom mult                CR03 246
M=IP+IREL(29);IF(M>IP) QX(L5)=QX(M)#   Store atom mult                  CR03 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR03 248
L5=L5+1;QX(N5)=FLOAT(L5+name:)#        Store start of next atom         CR03 249
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR03 250
# #                                    End of atom loop                 CR03 251
IF(NAT==0) iquit:(CR0303)#             No atoms for sf calc.            CR03 252
MARK6=L5-1#                            Compensate for l5 offset         CR03 253
#                                                                       CR03 254
## ADJUST DISPL.PARAM TYPE                                              CR03 255
#                                                                       CR03 256
IF(FLGOVA>0) REFUOV=1#                 Refine uova flag                 CR03 257
IF((FLGOVA+FLGISO+FLGANI)==1)#         One dp type for all atoms        CR03 258
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR03 259
MIXTMP=0#                              Turn off mixtmp flag             CR03 260
IF(FLGOVA==1)      REFTMP=0#           Refine overall tf                CR03 261
ELSE IF(FLGISO==1) REFTMP=1#           Refine isotropic tf              CR03 262
ELSE               REFTMP=6#           Refine anisotropic tf            CR03 263
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR03 264
ELSE#                                  Mixed displ.params               CR03 265
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR03 266
MIXTMP=1#                              Turn on mixtmp flag              CR03 267
IF(FLGOVA==0)      REFTMP=5#           Iso+aniso                        CR03 268
ELSE IF(FLGANI==0) REFTMP=3#           Ova+iso                          CR03 269
ELSE               REFTMP=4#           Ova+iso+aniso                    CR03 270
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR03 271
ncodefld:(FLOAT(NSLAVE),1,CR33,350513.,1)# Format no. slave atoms       CR03 272
IF(NSLAVE>0)writeline:(1,CR33,NCR33,3,3)# Print slave atoms             CR03 273
#                                                                       CR03 274
RETURN#                                                                 CR03 275
END#                                                                    CR03 276
systemheader:(CR04)#                   Group,atomgr lines               CR04   1
# ############################################################# #       CR04   2
#                                                               #       CR04   3
#                              CR04                             #       CR04   4
#                                                               #       CR04   5
# ############################################################# #       CR04   6
SUBROUTINE CR04#                       R.olthof   july 1982             CR04   7
#                                      May 1985   april 1989            CR04   8
include:(AACOMN)#                                                       CR04   9
include:(CRCOMN)#                                                       CR04  10
#                                                                       CR04  11
REAL    ATWT#       ## ATOMIC WEIGHT                                    CR04  12
string:(CH,24)#                                                         CR04  13
string:(CH1,24)#                                                        CR04  14
REAL    COSR#       ##                                                  CR04  15
REAL    COSSQ#      ##                                                  CR04  16
REAL    DX,DY,DZ#   ##                                                  CR04  17
INTEGER I,I1,I2,I6# ##                                                  CR04  18
INTEGER II,IJ,IR#   ##                                                  CR04  19
INTEGER IAT#        ## ATOM NUMBER IN MARK5-ARRAY                       CR04  20
INTEGER I6FRST#     ## I6 OF FIRST IDMOL                                CR04  21
INTEGER IGR#        ## NR OF GROUP/IDMOL                                CR04  22
INTEGER IROT,I6ROT# ## POINTERS FOR ROTATION MATRIX                     CR04  23
INTEGER IT#         ## ITERATION FLAG                                   CR04  24
INTEGER J,J1,JC,JI,JJ,JUNK#                                             CR04  25
INTEGER K,KR#       ##                                                  CR04  26
INTEGER KIK1,KIK2#  ##                                                  CR04  27
INTEGER L2,L5,L6#   ##                                                  CR04  28
INTEGER L6FRST#     ## L6 of 1-st idmol                                 CR04  29
INTEGER M,M1,M2#    ##                                                  CR04  30
INTEGER N,NM#       ##                                                  CR04  31
INTEGER NATGR#      ## NR OF ATOMS IN GROUP/IDMOL                       CR04  32
INTEGER NTMP#       ## NR OF TEMP.FACT.                                 CR04  33
REAL    PHI#        ##                                                  CR04  34
REAL    PSI#        ##                                                  CR04  35
REAL    Q,QQ,Q0,Q1,Q2,Q3#                                               CR04  36
INTEGER S#          ##                                                  CR04  37
REAL    SINCOS#     ##                                                  CR04  38
REAL    SINR#       ##                                                  CR04  39
REAL    SINSQ#      ##                                                  CR04  40
REAL    THETA#      ##                                                  CR04  41
#                                                                       CR04  42
chardata:(CR41, GROUP  ATOMGR RESTR  CONSTR NOREF  BLOCK  END   )#      CR04  43
chardata:(CR42,/)#                                                      CR04  44
realdata:(PI,[3.1415926535])#                                           CR04  45
realdata:(DAT,[1.,-1.,-1.,-1.,1.,-1.,$##                                CR04  46
-1.,-1.,1.,1.,1.,1.,-1.,-1.,-1.,$#                                      CR04  47
-1.,1.,1.,1.,-1.,1.,1.,1.,-1.])#                                        CR04  48
intdata:(NN,[0])#                                                       CR04  49
intdata:(LL,[0])#                                                       CR04  50
realdata:(SUMQSQ,[0.])#                Sum q(square)                    CR04  51
##                                                                      CR04  52
datastuff:#                                                             CR04  53
## MARK6-ARRAY FOR GROUP DATA                                           CR04  54
## QX(I6+1)            NUMBER OF ATOMS PER GROUP                        CR04  55
## QX(I6+2)            0/1/N FOR GROUP/FIRST IDMOL/N-TH IDMOL           CR04  56
## QX(I6+3)-QX(I6+5)   X,Y,Z(CENTER OF GRAVITY)                         CR04  57
## QX(I6+6)-QX(I6+8)   PHI, THETA, PSI (EULER ANGLES)                   CR04  58
## QX(I6+9)-QX(I6+14)  REFINEMENT FLAGS FOR EULER PARAMS                CR04  59
##                     VARIABLE NUMBERS                                 CR04  60
## QX(I6+15)-QX(I6+20) REFINEMENT FLAGS FOR DP PARAMS                   CR04  61
##                     VARIABLE NUMBERS                                 CR04  62
## QX(I6+21)           POP PARAM                                        CR04  63
##                     VARIABLE NUMBER                                  CR04  64
## QX(I6+22)-QX(I6+30) ROTATION MATRIX                                  CR04  65
##    QX(L6+1)             POINTER TO ATOM IN MARK5 ARRAY               CR04  66
##    QX(L6+2)             ATOM NUMBER                                  CR04  67
##    QX(L6+3)-QX(L6+5)    X,Y,Z(ORTH.); REL. TO C.OF GR.               CR04  68
##    QX(L6+6)-QX(L6+8)    X,Y,Z(ROTATED)                               CR04  69
#                                                                       CR04  70
LINID=LINID-2#                         Linid value in cr04              CR04  71
#                                                                       CR04  72
#     LOOP OVER THE GROUPS                                              CR04  73
#     --------------------                                              CR04  74
#                                                                       CR04  75
NTMP=6#                                Default dp value                 CR04  76
L6=MARK6;ISTEP6=30;NSTEP6=8#           Init. mark6 pointers             CR04  77
IGR=0;I6FRST=0#                        Group number; pointer            CR04  78
#                                                                       CR04  79
REPEAT#                                Loop over the groups             CR04  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR04  81
IF(LINID!=1) BREAK#                    Not a group line                 CR04  82
I6=L6#                                 Pointer for group param          CR04  83
IGR=IGR+1#                             Add up on group                  CR04  84
incrqx:(L6,I6+ISTEP6,CR0420)#          L6 is pointer for atom param     CR04  85
movereal:(0.,1,QX,I6+1,ISTEP6,2)#      Init. group param                CR04  86
ifnv:(BUFIN(1)) QX(I6+2)=BUFIN(1)#     0=group; n=n-th idmol            CR04  87
I1=I6+8#                               Pointer to refine flags          CR04  88
DO I=2,4#                              Coord. of c.of gravity           CR04  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR04  90
I1=I1+1#                               Next euler param flag            CR04  91
ifvo:(BUFIN(I)) QX(I1)=1.#             Refine coordinate                CR04  92
ELSE QX(I1-6)=BUFIN(I)#                Fixed  coordinate                CR04  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR04  94
#                                                                       CR04  95
ifvo:(BUFIN(5))#                       Code for euler angles            CR04  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR04  97
QX(I6+12)=1.;QX(I6+13)=1.;QX(I6+14)=1.# Euler angles are variant        CR04  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR04  99
IF(BUFIN(5)>0.)#                       Some euler angles invariant      CR04 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR04 101
IF(BUFIN(5)<=2.) QX(I6+13)=1.#         Theta variant                    CR04 102
ELSE             QX(I6+12)=1.#         Phi variant                      CR04 103
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR04 104
#                                                                       CR04 105
ifvo:(BUFIN(6)) BUFIN(6)=1.#           Dp as group                      CR04 106
ifne:(BUFIN(6),0.) movereal:(BUFIN,6,QX,I6+15,NTMP,2)# Set to input     CR04 107
#                                                                       CR04 108
ifvo:(BUFIN(7)) QX(I6+21)=FLOAT(REFPOP)# Pop.par. as group              CR04 109
ELSE            QX(I6+21)=BUFIN(7)#    Set to input value               CR04 110
IF((NINT(QX(I6+21))!=0)&(REFPOP==0)) iquit:(CR0402)# C                  CR04 111
#                                                                       CR04 112
ifeq:(QX(I6+2),0.)      I6FRST=0#      Group                            CR04 113
ELSE ifeq:(QX(I6+2),1.) I6FRST=I6#     1-st idmol                       CR04 114
ELSE#                                  N-th idmol                       CR04 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR04 116
IF(I6FRST<=0) iquit:(CR0401)#          1-st idmol is missing            CR04 117
movereal:(QX,I6FRST+6,QX,I6+6,18,1)#   Group param as in 1-st idmol     CR04 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR04 119
#                                                                       CR04 120
## READ ATOM AND ATOMGR LINES                                           CR04 121
#                                                                       CR04 122
NATGR=0;S=0;Q=0.#                      Initializations                  CR04 123
readline:(CR41,NCR41)#                 Read next input line             CR04 124
IF(LINID!=2) iquit:(CR0408)#           Not a atomgr line                CR04 125
ifvo:(BUFIN(1)) iquit:(CR0406)#        Quit on first void field         CR04 126
stringlim:(1,N,NN);J=NN-N#             Get string limits                CR04 127
compchar:(CR42,1,CHRIN,N,1,1,J,NM)#    Test "/" for serie               CR04 128
IF(NM==0) iquit:(CR0407)#              No "/" found                     CR04 129
J=NM-1;NM=N+NM#                        Nr of char;point to next ato     CR04 130
CH=CHRIP(N^N+J-1)#                     Extract atom label               CR04 131
#                                                                       CR04 132
IAT=0#                                 Atom counter                     CR04 133
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Loop over atoms    CR04 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR04 135
IAT=IAT+1#                             Incr atom counter                CR04 136
movertoc:(QX(L5-name:),1,CH1,1,24,0)#  Move atom id                     CR04 137
IF(CH==CH1 \ S==1)#                    Group atom found                 CR04 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR04 139
incrqx:(JUNK,L6+NSTEP6,CR0420)#        Incr qx for next atom in mar     CR04 140
NATGR=NATGR+1#                         Add up one group atom            CR04 141
QX(L6+1)=FLOAT(L5)#                    Store atom pointer               CR04 142
QX(L6+2)=FLOAT(IAT)#                   Store atom number                CR04 143
intunpak:(QX(L5+1),L2,0,5)#            Unpack atom type                 CR04 144
L2=MARK2+(L2-1)*NSTEP2#                Pointer to atomic weight         CR04 145
ATWT=QX(L2+4);QX(L6+6)=ATWT#           Get and store atomic weight      CR04 146
#                                                                       CR04 147
## SUM FOR CENTER OF GRAVITY                                            CR04 148
#                                                                       CR04 149
I1=I6+2;I2=L5+1#                       Pointer to group param           CR04 150
DO J=1,3#                              Loop over coord.                 CR04 151
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR04 152
I1=I1+1;I2=I2+1#                       Add up pointers                  CR04 153
ifeq:(QX(I1+6),0.) NEXT#               Invariant                        CR04 154
QX(I1)=QX(I1)+ATWT*QX(I2)#             Sum: atwt*coord.                 CR04 155
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR04 156
L6=L6+NSTEP6#                          Next atom in mark6               CR04 157
Q=Q+ATWT#                              Sum atomic weights               CR04 158
#                                                                       CR04 159
IF(S==0)#                              First atom passed                CR04 160
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR04 161
S=1;   CH=CHRIP(NM^NN)#                For following atoms store id     CR04 162
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR04 163
ELSE IF(CH==CH1) BREAK#                Last atom past                   CR04 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR04 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR04 166
IF(CH!=CH1) iquit:(CR0403)#            Unrecognised atom label          CR04 167
#                                                                       CR04 168
IF(NATGR<3) iquit:(CR0404)#            3 atoms are minimal              CR04 169
IF(QX(I6+2)<1.5) QX(I6+1)=FLOAT(NATGR)# Store natgr for group/1-st      CR04 170
ELSE QX(I6+1)=FLOAT(I6FRST)#           Store pointer to 1-st idmol      CR04 171
#                                                                       CR04 172
## CALCULATE CENTER OF GRAVITY                                          CR04 173
#                                                                       CR04 174
FOR(J=I6+3;J<=I6+5;J=J+1)#             Loop over coord of c.of gr.      CR04 175
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR04 176
ifeq:(QX(J+6),0.) NEXT#                Invariant                        CR04 177
QX(J)=QX(J)/Q#                         Divide by sum(atwt)              CR04 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR04 179
QX(I6+37)=Q#                           Save sum atwt                    CR04 180
#                                                                       CR04 181
## CALCULATE ORTH.COORD. RELATIVE TO C.OF GRAVITY                       CR04 182
#                                                                       CR04 183
LL=L6;L6=I6+ISTEP6-NSTEP6#             Save last l6; point to 1-st      CR04 184
incrqx:(JUNK,LL+27,CR0420)#            Incr qx with 27 scratch pos.     CR04 185
movereal:(0.,1,QX,LL+1,18,2)#          Initialize to zero               CR04 186
DO I=1,NATGR#                          Loop over group atoms            CR04 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR04 188
L6=L6+NSTEP6#                          Pointer to next atom             CR04 189
L5=NINT(QX(L6+1))#                     Pointer to x par                 CR04 190
DX=QX(L5+2)-QX(I6+3)#                  Delta x                          CR04 191
DY=QX(L5+3)-QX(I6+4)#                  Delta y                          CR04 192
DZ=QX(L5+4)-QX(I6+5)#                  Delta z                          CR04 193
#                                                                       CR04 194
## CALCULATE ORTHOGONAL COORDINATES                                     CR04 195
#                                                                       CR04 196
QX(L6+3)=CELL(13)*DX+CELL(16)*DY+CELL(19)*DZ# X(orth)                   CR04 197
QX(L6+4)=CELL(14)*DX+CELL(17)*DY+CELL(20)*DZ# Y(orth)                   CR04 198
QX(L6+5)=CELL(15)*DX+CELL(18)*DY+CELL(21)*DZ# Z(orth)                   CR04 199
#                                                                       CR04 200
## CALCULATE INERTIA TENSOR                                             CR04 201
#                                                                       CR04 202
ATWT=QX(L6+6)#                         Get atomic weight                CR04 203
QX(LL+1)=QX(LL+1)+ATWT*(QX(L6+4)*QX(L6+4)+QX(L6+5)*QX(L6+5))#           CR04 204
QX(LL+5)=QX(LL+5)+ATWT*(QX(L6+3)*QX(L6+3)+QX(L6+5)*QX(L6+5))#           CR04 205
QX(LL+9)=QX(LL+9)+ATWT*(QX(L6+3)*QX(L6+3)+QX(L6+4)*QX(L6+4))#           CR04 206
QX(LL+2)=QX(LL+2)-ATWT*QX(L6+3)*QX(L6+4)#                               CR04 207
QX(LL+3)=QX(LL+3)-ATWT*QX(L6+3)*QX(L6+5)#                               CR04 208
QX(LL+6)=QX(LL+6)-ATWT*QX(L6+4)*QX(L6+5)#                               CR04 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR04 210
QX(LL+4)=QX(LL+2);QX(LL+7)=QX(LL+3);QX(LL+8)=QX(LL+6)#                  CR04 211
#                                                                       CR04 212
### CALL JACOBI                                                         CR04 213
#                                                                       CR04 214
Q=SQRT(QX(LL+2)*QX(LL+2)+QX(LL+3)*QX(LL+3)+QX(LL+6)*QX(LL+6))/.666666#  CR04 215
Q0=.0001*Q#                                                             CR04 216
QX(LL+10)=1.;QX(LL+14)=1.;QX(LL+18)=1.# Diagonal elements               CR04 217
#                                                                       CR04 218
WHILE(Q>Q0)#                                                            CR04 219
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR04 220
Q=.333333*Q#                                                            CR04 221
REPEAT#                                                                 CR04 222
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR04 223
IT=0#                                  Iteration flag                   CR04 224
IR=LL#                                 Row index                        CR04 225
DO I=2,3#                              Loop over the rows               CR04 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR04 227
IR=IR+3;JC=LL-3;J1=I-1#                                                 CR04 228
DO J=1,J1#                             Loop over the columns            CR04 229
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR04 230
JC=JC+3#                                                                CR04 231
IJ=IR+J#                                                                CR04 232
IF(ABS(QX(IJ))<Q) NEXT#                Small off-diagonal element       CR04 233
IT=1#                                                                   CR04 234
II=IR+I;JJ=JC+J#                                                        CR04 235
Q1=.5*(QX(JJ)-QX(II))#                                                  CR04 236
Q2=QX(IJ)/SQRT(QX(IJ)*QX(IJ)+Q1*Q1)#                                    CR04 237
IF(Q1>0.) Q2=-Q2#                                                       CR04 238
SINR=Q2/SQRT(2.+2.*SQRT(1.-Q2*Q2))#                                     CR04 239
SINSQ=SINR*SINR#                                                        CR04 240
COSSQ=1.-SINSQ#                                                         CR04 241
COSR=SQRT(COSSQ)#                                                       CR04 242
SINCOS=SINR*COSR#                                                       CR04 243
#                                                                       CR04 244
prod:(9,JC+1,IR+1)#                                                     CR04 245
prod:(9,JC+2,IR+2)#                                                     CR04 246
prod:(9,JC+3,IR+3)#                                                     CR04 247
K=6-I-J;KR=LL+(K-1)*3#                                                  CR04 248
prod:(0,KR+J,KR+I)#                                                     CR04 249
M1=JC+K;M2=KR+J;QX(M1)=QX(M2)#                                          CR04 250
M1=IR+K;M2=KR+I;QX(M1)=QX(M2)#                                          CR04 251
#                                                                       CR04 252
Q1=QX(JJ);Q2=QX(II);Q3=QX(IJ);QQ=2.*SINCOS*Q3#                          CR04 253
QX(JJ)=COSSQ*Q1+SINSQ*Q2-QQ#                                            CR04 254
QX(II)=SINSQ*Q1+COSSQ*Q2+QQ#                                            CR04 255
QX(IJ)=SINCOS*(Q1-Q2)+(COSSQ-SINSQ)*Q3#                                 CR04 256
JI=JC+I;QX(JI)=QX(IJ)#                                                  CR04 257
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR04 258
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR04 259
IF(IT==0) BREAK#                                                        CR04 260
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR04 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR04 262
DO K=1,3#                                                               CR04 263
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR04 264
IF(K==2)#                                                               CR04 265
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR04 266
I=1;J=2;II=LL+1;JJ=LL+5#                                                CR04 267
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR04 268
ELSE#                                                                   CR04 269
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR04 270
I=2;J=3;II=LL+5;JJ=LL+9#                                                CR04 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR04 272
IF(QX(II)<QX(JJ)) NEXT#                                                 CR04 273
swap:(II,JJ)#                                                           CR04 274
M1=LL+3*(I-1)+9;M2=LL+3*(J-1)+9#                                        CR04 275
DO M=1,3#                                                               CR04 276
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR04 277
M1=M1+1;M2=M2+1#                                                        CR04 278
QX(M2)=-QX(M2);swap:(M1,M2)#                                            CR04 279
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR04 280
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR04 281
#                                                                       CR04 282
## SAVE ROTATION MATRIX                                                 CR04 283
#                                                                       CR04 284
I6ROT=I6+ISTEP6-9#                     Pointer to rot.m. in mark6       CR04 285
IF(QX(I6+2)<2.)$#                      Group or 1-st idmol              CR04 286
movereal:(QX,LL+10,QX,I6ROT+1,9,1)#    Rotation matrix                  CR04 287
ELSE#                                  N-th idmol                       CR04 288
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR04 289
#                                                                       CR04 290
## CHECK THE SUBSEQUENT IDENTICAL MOLECULES TO MAKE SURE THAT THEIR     CR04 291
## AXIAL SENSE IS THE SAME AS THE FIRST. ALTER THE EULER MATRIX         CR04 292
## ACCORDINGLY. CALCULATE THE MATRIX WHICH WILL TRANSFORM THE FIRST     CR04 293
## IDMOL INTO THIS ONE.                                                 CR04 294
##                                                                      CR04 295
IROT=I6FRST+ISTEP6-9#                  Point to rot.m. of 1-st idmo     CR04 296
K=0#                                   Pointer in array dat             CR04 297
WHILE(K<24)#                           Loop over axial senses           CR04 298
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR04 299
I1=LL+9;I2=LL+18#                      Pointers in rotation arrays      CR04 300
DO J=1,3#                              Loop over axes                   CR04 301
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR04 302
K=K+1#                                 Point to next dat item           CR04 303
DO J1=1,3#                             Loop over matrix elements        CR04 304
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR04 305
I1=I1+1;I2=I2+1#                       Pointers in rotation arrays      CR04 306
QX(I2)=DAT(K)*QX(I1)#                  Alter axial sense                CR04 307
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR04 308
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR04 309
I=I6ROT;I1=IROT-1#                     Point to rot.m of 1-st/n-th      CR04 310
DO J=1,3#                              Loop over axes                   CR04 311
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR04 312
I2=LL+17;I1=I1+1#                      Pointer for product matrix       CR04 313
DO J1=1,3#                             Loop over matrix elements        CR04 314
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR04 315
I=I+1;I2=I2+1#                         Adjust pointers                  CR04 316
QX(I)=QX(I2+1)*QX(I1+1)+QX(I2+4)*QX(I1+4)+QX(I2+7)*QX(I1+7)# Vector p   CR04 317
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR04 318
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR04 319
L6=I6+ISTEP6-NSTEP6;L6FRST=I6FRST+ISTEP6-NSTEP6# Pointers to 1-st ato   CR04 320
SUMQSQ=0.#                             Sum squared distances            CR04 321
DO N=1,NATGR#                          Loop over group atoms            CR04 322
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR04 323
I=I6ROT-3;L6=L6+NSTEP6;L6FRST=L6FRST+NSTEP6# Rot.m/next atom            CR04 324
DO J=1,3#                              Loop over the coord.             CR04 325
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR04 326
I=I+3;I2=L6FRST+2+J#                   Point to next rot. vect/coor     CR04 327
Q=QX(I+1)*QX(L6+3)+QX(I+2)*QX(L6+4)+QX(I+3)*QX(L6+5)-QX(I2)# Differen   CR04 328
SUMQSQ=SUMQSQ+Q*Q#                     Add up squared difference        CR04 329
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR04 330
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR04 331
IF(SUMQSQ<1.) BREAK#                   Both molecules are identical     CR04 332
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR04 333
IF(SUMQSQ>1.) iquit:(CR0405)#          Molecules are not identical      CR04 334
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR04 335
#                                                                       CR04 336
## CALCULATE EULER ANGLES                                               CR04 337
#                                                                       CR04 338
ifeq:(QX(I6ROT+9),1.)#                 If costhe=1                      CR04 339
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR04 340
THETA=0.;PSI=0.#                       Theta=0;set psi=0                CR04 341
PHI=ACOS(QX(I6ROT+1))#                 Phi=arccos(cosphi)               CR04 342
IF(QX(I6ROT+4)<0.) PHI=-PHI#           If sinphi<0                      CR04 343
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR04 344
ELSE#                                  If costhe != 1                   CR04 345
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR04 346
THETA=ACOS(QX(I6ROT+9))#               0 >= theta > pi                  CR04 347
ifeq:(QX(I6ROT+6),0.)#                 If -sin(the)*cos(phi)=0          CR04 348
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR04 349
IF(QX(I6ROT+3)>=0.) PHI=PI/2#          If sin(the)*sinphi>=0 phi=pi     CR04 350
ELSE PHI=-PI/2.#                       Else phi=-pi/2                   CR04 351
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR04 352
ELSE#                                  If -sinthe*cosphi != 0           CR04 353
PHI=ATAN2(QX(I6ROT+3),-QX(I6ROT+6))#   Phi=arctan2:(sinphi/cosphi)      CR04 354
ifeq:(QX(I6ROT+6),0.)#                 If cospsi*sinthe=0               CR04 355
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR04 356
IF(QX(I6ROT+7)>=0.) PSI=PI/2.#         If sinpsi*sinthe>=0 psi=pi/2     CR04 357
ELSE PSI=-PI/2.#                       Else psi=-pi/2                   CR04 358
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR04 359
ELSE#                                  If cospsi*sinthe != 0            CR04 360
PSI=ATAN2(QX(I6ROT+7),QX(I6ROT+8))#    Psi=arctan2:(sinpsi/cospsi)      CR04 361
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR04 362
IF(PHI<0.) PHI=PHI+2.*PI#              Set 0>= phi >360                 CR04 363
IF(PSI<0.) PSI=PSI+2.*PI#              Set 0>= psi >360                 CR04 364
QX(I6+6)=PHI;QX(I6+7)=THETA;QX(I6+8)=PSI# Store in group array          CR04 365
#                                                                       CR04 366
##                                                                      CR04 367
#                                                                       CR04 368
L6=I6+ISTEP6+NATGR*NSTEP6#             Point to next group              CR04 369
readline:(CR41,NCR41)#                 Read next line                   CR04 370
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR04 371
#                                                                       CR04 372
MARK7=L6#                              End of mark6-array               CR04 373
#                                                                       CR04 374
RETURN#                                                                 CR04 375
END#                                                                    CR04 376
systemheader:(CR05)#                   Read restr lines                 CR05   1
# ############################################################# #       CR05   2
#                                                               #       CR05   3
#                              CR05                             #       CR05   4
#                                                               #       CR05   5
# ############################################################# #       CR05   6
SUBROUTINE CR05#                       R. olthof                        CR05   7
#                                      February 1989                    CR05   8
include:(AACOMN)#                                                       CR05   9
include:(CRCOMN)#                                                       CR05  10
#                                                                       CR05  11
string:(C,1)#                                                           CR05  12
string:(CH ,24)#   ## SCRATCH FOR ATOM ID'S                             CR05  13
string:(CH1,24)#   ## SCRATCH FOR ATOM ID'S                             CR05  14
INTEGER CLASS#     ## RESTRAINT CLASS: BON/ANG/TOR/PLA                  CR05  15
INTEGER I,J,L,N,NT##                                                    CR05  16
INTEGER NATM#      ## NR OF ATOMS IN RESTRAINT                          CR05  17
INTEGER KEY#       ## KEY FOR COMPARISONS                               CR05  18
INTEGER I7#        ## POINTER IN MARK7 ARRAY                            CR05  19
INTEGER JUNK#      ##                                                   CR05  20
INTEGER L5,L7#     ## POINTERS IN MARK5/MARK7 ARRAY                     CR05  21
#                                                                       CR05  22
chardata:(CR51, RESTR  CONSTR NOREF  BLOCK  END   )#                    CR05  23
chardata:(CR52, BON ANG DIH PLA )#                                      CR05  24
datastuff:#                                                             CR05  25
#                                                                       CR05  26
#  MARK7 ARRAY: QX(I7+1)     : RESTRAINT CLASS                          CR05  27
#               QX(I7+2)     : NR OF ATOMS IN RESTR                     CR05  28
#               QX(I7+3)     : RESTRAINED VALUE                         CR05  29
#               QX(I7+4)     : STANDARD DEVIATION                       CR05  30
#               QX(I7+5)     : ATOM POINTERS      ) FOR ALL ATOMS       CR05  31
#               QX(I7+6)     : NSYM*1000+TRANS(BASE 555) ALL ATOMS      CR05  32
#               QX(I7+2N+1)  : VAR NUMBERS FOR COORDS OF ATOMS IN RESTR CR05  33
#                                                                       CR05  34
LINID=LINID-2#                         Adjust linid                     CR05  35
L7=MARK7#                                                               CR05  36
REPEAT#                                Loop over restr lines            CR05  37
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR05  38
IF(LINID!=1) BREAK#                    Not a restr line                 CR05  39
incrqx:(JUNK,L7+30,CR0520)#            Incr memory                      CR05  40
I=2;I7=L7;L7=I7+4;NATM=0#              Pntrs; nr of atoms               CR05  41
stringlim:(1,J,N)#                     Get string limits                CR05  42
compchar:(CHRIN,J,CR52,2,3,4,NCR52,CLASS)# Compare restraint classes    CR05  43
IF(CLASS<=0) iquit:(CR0501)#           Error in restraint class         CR05  44
stringlim:(2,J,N)#                     Get string limits                CR05  45
REPEAT#                                Loop over atom id's              CR05  46
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR05  47
CH1=CHRIP(J^N)#                        Get atom label                   CR05  48
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Loop over atom     CR05  49
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR05  50
movertoc:(QX(L5-name:),1,CH,1,24,0)#   Move atom name                   CR05  51
IF(CH==CH1) BREAK#                     Skip if not a match              CR05  52
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR05  53
IF(L5>=MARK6) iquit:(CR0502)#          Error in atom id                 CR05  54
QX(L7+1)=FLOAT(L5)#                    Store atom pntr                  CR05  55
QX(L7+2)=1555.#                        Default ns_nt value              CR05  56
I=I+1;NATM=NATM+1#                     Adj bufin pntr; incr nr of ato   CR05  57
IF(BUFIN(I)>=voidflg:) BREAK#          Break if next field not alfanu   CR05  58
stringlim:(I,J,N)#                     Get string limits                CR05  59
IF(CHRIN(J^J)=='(')#                   Is this a start of a symop       CR05  60
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR05  61
QX(L7+2)=0.;  NT=0#                    Prepare for input symops         CR05  62
DO L=J+1,N-1#                          Loop over this string            CR05  63
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR05  64
C=CHRIN(L^L)#                          Store current character          CR05  65
IF(C==' '\C==')') NEXT#                Skip blanks                      CR05  66
IF(NT>0) NT=NT+1#                      Count translations               CR05  67
IF(C=='_')#                            Test for translation             CR05  68
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR05  69
NT=1;    NEXT#                         Count translation input          CR05  70
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR05  71
KEY=INDEX('0123456789',C)#             Identify the number              CR05  72
IF(KEY==0) iquit:(CR0505)#             Only numbers allowed             CR05  73
QX(L7+2)=10.*QX(L7+2)+FLOAT(KEY-1)#    Calculate symop nr               CR05  74
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR05  75
IF(NT==0) QX(L7+2)=QX(L7+2)*1000.+555.# Add zero translation            CR05  76
ELSE IF(NT!=4) iquit:(CR0506)#         Illegal translation input        CR05  77
I=I+1#                                 Adj bufin pntr                   CR05  78
IF(BUFIN(I)>=voidflg:) BREAK#          Break if next field not alfanu   CR05  79
stringlim:(I,J,N)#                     Get string limits                CR05  80
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR05  81
L7=L7+2#                               Incr pntr                        CR05  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR05  83
IF(NATM<=CLASS) iquit:(CR0503)#        Not enough atoms for this rest   CR05  84
QX(I7+1)=FLOAT(CLASS)#                 Store restraint class            CR05  85
QX(I7+2)=FLOAT(NATM)#                  Nr of atoms in restr             CR05  86
ifvo:(BUFIN(I)) iquit:(CR0504)#        Value is missing                 CR05  87
QX(I7+3)=BUFIN(I)#                     Store dist/angle. etc.           CR05  88
ifnv:(BUFIN(I+1)) QX(I7+4)=BUFIN(I+1)# Store standard dev.              CR05  89
ELSE              QX(I7+4)=.03*QX(I7+3)#                                CR05  90
L7=L7+2+3*NATM#                        Set pntr for next restr          CR05  91
readline:(CR51,NCR51)#                 Read next line                   CR05  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR05  93
#                                                                       CR05  94
MARK8=L7#                              End of restr info                CR05  95
RETURN#                                                                 CR05  96
END#                                                                    CR05  97
systemheader:(CR06)#                   Constr,noref,block               CR06   1
###################################################################     CR06   2
#                                                                 #     CR06   3
#                            CR06                                 #     CR06   4
#                                                                 #     CR06   5
###################################################################     CR06   6
SUBROUTINE CR06#                       R.olthof   jan.1982              CR06   7
#                                      May 1985   april 1989            CR06   8
include:(AACOMN)#                                                       CR06   9
include:(CRCOMN)#                                                       CR06  10
#                                                                       CR06  11
string:(CH,128)#    ## CHARACTER ARRAY FOR ATTYP                        CR06  12
string:(NAME1,24)#  ## CHARACTER ARRAY FOR ATOM NAME                    CR06  13
string:(NAME2,24)#  ## CHARACTER ARRAY FOR ATOM NAME                    CR06  14
INTEGER ATTYP#      ## NR OF ATOM TYPE                                  CR06  15
INTEGER CONTLI#     ## FLAG FOR CONTINUE ON NEXT LINE                   CR06  16
INTEGER FIRST#      ## FIRST ACCESS TO GROUP PARAMS                     CR06  17
INTEGER I,II,III1,III2,IP,I1,I6#                                        CR06  18
INTEGER IAT,IATSUB# ## NUMBER OF (FIRST) ATOM                           CR06  19
INTEGER IREL(9)#    ## RELATIVE POINTER IN BDF                          CR06  20
INTEGER IWANT(8)#   ## WANTED ITEMS IN BDF                              CR06  21
INTEGER ISUB#       ## SUBJECT PARAM                                    CR06  22
INTEGER I6FRST#     ## POINTER TO 1-ST IDMOL                            CR06  23
INTEGER J,K#        ##                                                  CR06  24
INTEGER JUNK#       ##                                                  CR06  25
INTEGER LINLAS#     ## LAST VALUE OF LINID                              CR06  26
INTEGER KEY#        ## KEY IN CHARACTER COMPARISON                      CR06  27
INTEGER L,LIM,LL,L2,L6,L8,LL2#                                          CR06  28
INTEGER M#          ##                                                  CR06  29
INTEGER NATGR#      ## NUMBER OF ATOMS PER GROUP                        CR06  30
INTEGER NBLK#       ## NUMBER OF INFORMATION BLOCKS                     CR06  31
INTEGER NC,NN#      ## CURRENT / LAST COLUMN POINTER                    CR06  32
INTEGER NCH#        ## NUMBER OF CHAR IN ARRAY CH                       CR06  33
INTEGER NP#         ## NUMBER OF PARAMS/SET                             CR06  34
INTEGER NTMP#       ## NUMBER OF TF                                     CR06  35
INTEGER P#          ##                                                  CR06  36
INTEGER PACK#       ## PACKET SIZE IN BDF LR                            CR06  37
INTEGER PAR,PARSUB# ## PARAM NUMBER                                     CR06  38
INTEGER PARTOT#     ## NUMBER OF PARAM PER ATOM                         CR06  39
INTEGER PFLAG#      ## PARENTHESES FLAG                                 CR06  40
REAL    Q,Q1#       ## SCRATCH                                          CR06  41
INTEGER TYPE#       ## TYPE OF CONSTRAINT                               CR06  42
#                                                                       CR06  43
chardata:(CR61, CONSTR NOREF  BLOCK  END   )#                           CR06  44
chardata:(CR62,X  Y  Z  U  U11U22U33U12U13U23POPAPPNEU)#                CR06  45
chardata:(CR63,[(),-+=* ])#            Delimiters                       CR06  46
chardata:(CR64,SKF UOV EXT DSP )#                                       CR06  47
chardata:(CR65,[(),/ ])#               Delimiters                       CR06  48
intdata:(L6FRST,0)#                    Pointer to first atom in 1-s     CR06  49
intdata:(I8,0)#                                                         CR06  50
intdata:(L5,0)#                                                         CR06  51
intdata:(IL,0)#                                                         CR06  52
intdata:(SPANA,0)#                     Flag for serie of params ato     CR06  53
intdata:(SPANP,0)#                     Flag for serie of params ato     CR06  54
intdata:(DSPFLG,0)#                    Flag for noref dispersion        CR06  55
intdata:(IAT1,0)#                      Number of (first) atom           CR06  56
datastuff:#                                                             CR06  57
#                                                                       CR06  58
LINID=LINID-1#                         Linid in cr06                    CR06  59
#                                                                       CR06  60
## CONSTR AND NOREF INFORMATION FOR THE GROUPS                          CR06  61
#                                                                       CR06  62
## MARK8 - SCRATCH ARRAY                                                CR06  63
##                                                                      CR06  64
## QX(I8+1)  NUMBER OF CONSTRAINT INFO SETS                             CR06  65
## QX(I8+2)  NUMBER OF ITEMS PER INFO SET                               CR06  66
## QX(I8+3)  NUMBER OF SUBJECT ATOM                                     CR06  67
## QX(I8+4)  NUMBER OF SUBJECT PARAMETER                                CR06  68
## QX(I8+5)  CONSTANT Q                                                 CR06  69
##   QX(L8+1)  NUMBER OF REFERENCE ATOM / ADDRESS OF GROUP PARAM REFCOD CR06  70
##   QX(L8+2)  NUMBER OF REFERENCE PARAM/ CODE FIRST REFERENCE TO GROUP CR06  71
##   QX(L8+3)  MULTIPLICATION FACTOR                                    CR06  72
#                                                                       CR06  73
L6=MARK6;L8=MARK8#                     Pointers in mark6/mark8          CR06  74
IF(REFTMP==6) NTMP=6#                  Anisotropic tf                   CR06  75
ELSE IF(REFTMP>0) NTMP=1#              Isotropic tf                     CR06  76
ELSE NTMP=0#                           Overall tf                       CR06  77
WHILE(L6<MARK7)#                       Loop over the groups             CR06  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR06  79
I6=L6;L6=L6+ISTEP6-NSTEP6#             Pointers to group/atoms          CR06  80
Q=QX(I6+37)#                           Sum atwt                         CR06  81
IF(QX(I6+2)<1.5) NATGR=NINT(QX(I6+1))# Nr of at. in group/1-st id       CR06  82
ELSE#                                  N-th idmol                       CR06  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR06  84
I6FRST=NINT(QX(I6+1));NATGR=NINT(QX(I6FRST+1))# Nr of at. in 1-st idm   CR06  85
L6FRST=I6FRST+ISTEP6-NSTEP6#           Point to atoms of 1-st idmol     CR06  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR06  87
FIRST=yes:#                            First reference to group par     CR06  88
DO I=1,NATGR#                          Loop over the group atoms        CR06  89
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR06  90
PAR=0;PARTOT=3+NTMP+REFPOP#            Count param; total nr of par     CR06  91
L6=L6+NSTEP6#                          Pointer to next group atom       CR06  92
L6FRST=L6FRST+NSTEP6#                  Idem, in first idmol             CR06  93
DO P=1,PARTOT#                         Loop over the parameters         CR06  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR06  95
PAR=PAR+1#                             Add up one param                 CR06  96
IF((P==4)&(NTMP==6)) PAR=5#            Anisotropic tf                   CR06  97
IF((P==PARTOT)&(REFPOP==1)) PAR=11#    Pop param                        CR06  98
ifeq:(QX(I6+2),1.)#                    If first idmol                   CR06  99
IF(PAR<=3) NEXT#                       And coordinate: no constr        CR06 100
I8=L8#                                 Start constr info for new gr     CR06 101
incrqx:(L8,I8+5,CR0620)#               Incr qx for general constr i     CR06 102
QX(I8+1)=1.#                           Nr of info sets                  CR06 103
QX(I8+2)=3.#                           Nr of items per set              CR06 104
QX(I8+3)=QX(L6+2)#                     Number of dependent atom         CR06 105
QX(I8+4)=FLOAT(PAR)#                   Number of dependent paramete     CR06 106
QX(I8+5)=0.#                           Constant q                       CR06 107
#                                                                       CR06 108
IF(PAR<=3)#                            Coordinate                       CR06 109
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR06 110
QX(I8+5)=-9999.#                       No re-calculation                CR06 111
J=PAR#                                 Nr of reference(=euler) para     CR06 112
WHILE(J<=6)#                           Loop over euler param            CR06 113
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR06 114
I1=I6+8+J#                             Point to refinement flag         CR06 115
IF(QX(I1)>0.5)#                        Variable coord. or angle         CR06 116
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR06 117
QX(I8+1)=QX(I8+1)+1.#                  Incr number of info sets         CR06 118
incrqx:(JUNK,L8+3,CR0620)#             Incr qx for info set             CR06 119
QX(L8+1)=FLOAT(I1)#                    Store address group ref.flag     CR06 120
IF(FIRST==yes:) QX(L8+2)=FLOAT(J)#     If first refer., store code=     CR06 121
ELSE            QX(L8+2)=0.#           Else store code=0                CR06 122
IF(J==PAR) QX(L8+3)=1.#                Factor coord to coord(c.of g     CR06 123
ELSE       QX(L8+3)=0.#                All other factors                CR06 124
L8=L8+3#                               Incr pointer                     CR06 125
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR06 126
IF((J<4)&(FIRST==no:)) J=4#            Param nr of first euler angl     CR06 127
ELSE J=J+1#                            Param nr of subsequ. euler a     CR06 128
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR06 129
FIRST=no:#                             Flag off first reference to      CR06 130
IF(QX(I6+2)>1.5)#                      N-th idmol                       CR06 131
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR06 132
QX(I8+1)=QX(I8+1)+3.#                  Incr number of info sets         CR06 133
incrqx:(JUNK,L8+9,CR0620)#             Incr qx                          CR06 134
DO J=1,3#                              Loop over coord                  CR06 135
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR06 136
QX(L8+1)=QX(L6FRST+2)#                 Number of reference atom         CR06 137
QX(L8+2)=FLOAT(J)#                     Number of reference param        CR06 138
QX(L8+3)=0.#                           Multiplication factor            CR06 139
L8=L8+3#                               Incr pointer                     CR06 140
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR06 141
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR06 142
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR06 143
#                                                                       CR06 144
ELSE#                                  Temp or pop param                CR06 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR06 146
IF(PAR==4) I1=I6+15#                   Isotropic tf                     CR06 147
ELSE I1=I6+10+PAR#                     Point to refinement flag         CR06 148
IF(QX(I1)<-.5)#                        Individual variable              CR06 149
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR06 150
IF(QX(I6+2)>1.5)#                      N-th idmol                       CR06 151
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR06 152
QX(I8+1)=QX(I8+1)+1.#                  Incr number of info sets         CR06 153
incrqx:(JUNK,L8+3,CR0620)#             Incr qx                          CR06 154
QX(L8+1)=QX(L6FRST+2)#                 Number of reference atom         CR06 155
QX(L8+2)=FLOAT(PAR)#                   Number of reference param        CR06 156
QX(L8+3)=1.#                           Mult. factor                     CR06 157
L8=L8+3#                               Incr pointer                     CR06 158
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR06 159
ELSE L8=I8#                            Not constrained                  CR06 160
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR06 161
ELSE IF(QX(I1)>0.5)#                   Group variable                   CR06 162
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR06 163
QX(I8+1)=QX(I8+1)+1.#                  Incr number of info sets         CR06 164
incrqx:(JUNK,L8+3,CR0620)#             Incr qx                          CR06 165
QX(L8+1)=FLOAT(I1)#                    Address of group param ref.f     CR06 166
IF(I==1) QX(L8+2)=FLOAT(PAR)#          First reference to group par     CR06 167
ELSE QX(L8+2)=0.#                      Dummy value                      CR06 168
QX(L8+3)=1.#                           Mult. factor                     CR06 169
L8=L8+3#                               Incr pointer                     CR06 170
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR06 171
ELSE#                                  Invariant param                  CR06 172
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR06 173
QX(I8+2)=2.#                           Nr of items per set              CR06 174
L8=L8-1#                               Adjust pointer                   CR06 175
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR06 176
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR06 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR06 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR06 179
L6=L6+NSTEP6#                          Point to next group              CR06 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR06 181
MARK14=L8#                             End of group constraints         CR06 182
#                                                                       CR06 183
#         INPUT CONSTRAINTS FROM LRCONS:                                CR06 184
#         ------------------------------                                CR06 185
#                                                                       CR06 186
#                                                                       CR06 187
## SET UP TO FETCH CONSTRAINT, NOREF AND POLAR SIGNALS                  CR06 188
#                                                                       CR06 189
IWANT(1)=1#                            Subj atom name                   CR06 190
IWANT(2)=2#                            Subj parameter id number         CR06 191
IWANT(3)=3#                            Subj atom param multiplier       CR06 192
IWANT(4)=4#                            Constraint constant q            CR06 193
IWANT(5)=5#                            Constraint classification        CR06 194
IWANT(6)=11#                           Reference atom name              CR06 195
IWANT(7)=12#                           Reference parameter id           CR06 196
IWANT(8)=13#                           Parameter multiplier             CR06 197
SIGNAL(1)=8;SIGNAL(2)=0#               All mandatory items              CR06 198
SIGNAL(3)=8;SIGNAL(4)=0#               No additions or deletions        CR06 199
indexpkt:(1,lrcons:,PACK,IP,0,SIGNAL,IWANT,IREL)# Search directory      CR06 200
#                                                                       CR06 201
## LOOP OVER LRCONS: PACKETS                                            CR06 202
#                                                                       CR06 203
IF(IP>0)#                              If something is there            CR06 204
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR06 205
REPEAT#                                Search all the packets           CR06 206
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR06 207
readwpkt:(1,lrcons:,PACK,IP,0)#        Read next constraint pkt         CR06 208
IF(IP<=0) BREAK#                       End of logical record            CR06 209
M=IP+IREL(5);TYPE=NINT(QX(M))#         Type of constraint               CR06 210
M=IP+IREL(2);ISUB=NINT(QX(M))#         Subject parameter                CR06 211
IF(TYPE==4)$#                          Check for polar indicator        CR06 212
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR06 213
IF(BLKTYP==1) POLSPG(ISUB)=1#          Flag for polar axis              CR06 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR06 215
#                                                                       CR06 216
ELSE IF(TYPE>0)#                       If invariant or constraint       CR06 217
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR06 218
M=IP+IREL(1)#                          Point to subject atom name       CR06 219
movertoc:(QX(M),1,NAME1,1,24,0)#       Store subject atom name          CR06 220
IAT=1#                                 Count atoms                      CR06 221
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Atom loop          CR06 222
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR06 223
movertoc:(QX(L5-name:),1,NAME2,1,24,0)# Store atom name                 CR06 224
IF(NAME1==NAME2) BREAK#                Exit if labels match             CR06 225
IAT=IAT+1#                             Count atoms                      CR06 226
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR06 227
IF(L5>=MARK6) NEXT#                    If no match goto next constr     CR06 228
#                                                                       CR06 229
IF(TYPE==3)#                           Test if invariant                CR06 230
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR06 231
incrqx:(JUNK,L8+4,CR0620)#             Advance noref storage            CR06 232
QX(L8+1)=1.#                           Number of noref info sets        CR06 233
QX(L8+2)=2.#                           Number of items per set          CR06 234
QX(L8+3)=FLOAT(IAT)#                   Number of atom                   CR06 235
QX(L8+4)=FLOAT(ISUB)#                  Number of invariant paramete     CR06 236
IF(ISUB>=4)QX(L8+4)=QX(L8+4)+1.#       U11=4 in lrcons;u11=5 in cry     CR06 237
L8=L8+4#                               Point to next constr info se     CR06 238
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR06 239
#                                                                       CR06 240
ELSE IF(TYPE==1)#                      Check functional constraint      CR06 241
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR06 242
incrqx:(JUNK,L8+8,CR0620)#             Incr qx                          CR06 243
QX(L8+1)=2.#                           Number of constr info sets       CR06 244
QX(L8+2)=3.#                           Number of items per set          CR06 245
QX(L8+3)=FLOAT(IAT)#                   Store number                     CR06 246
QX(L8+4)=FLOAT(ISUB)#                  Number of dependent paramete     CR06 247
IF(ISUB>=4)QX(L8+4)=QX(L8+4)+1.#       U11=4 in lrcons;u11=5 in cry     CR06 248
M=IP+IREL(4);QX(L8+5)=QX(M)#           Constraint constant q            CR06 249
J=IP+IREL(6)#                          Point to reference atom name     CR06 250
movertoc:(QX(J),1,NAME1,1,24,0)#       Store ref atom name              CR06 251
IAT=1#                                 Count atoms                      CR06 252
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))#                    CR06 253
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR06 254
movertoc:(QX(L5-name:),1,NAME2,1,24,0)# Store atom name                 CR06 255
IF(NAME1==NAME2) BREAK#                Test if the same                 CR06 256
IAT=IAT+1#                             Count atoms                      CR06 257
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR06 258
IF(L5>=MARK6) NEXT#                    Goto next constraint packet      CR06 259
QX(L8+6)=FLOAT(IAT)#                   Number of reference atom         CR06 260
M=IP+IREL(7);QX(L8+7)=QX(M)#           Reference atom param             CR06 261
IF(QX(M)>=4) QX(L8+7)=QX(L8+7)+1.#     U11=4 in lrcons;u11=5 in cry     CR06 262
M=IP+IREL(8);QX(L8+8)=QX(M)#           Multiplication factor            CR06 263
M=IP+IREL(3)#                          Point to subj param multipli     CR06 264
QX(L8+5)=QX(L8+5)/QX(M)#               Correct q factor                 CR06 265
QX(L8+8)=QX(L8+8)/QX(M)#               Correct multiplier               CR06 266
IF(QX(L8+7)>QX(L8+4))#                 Subject > reference param        CR06 267
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR06 268
ifne:(QX(L8+7),QX(L8-4))#              First use of ref. param.         CR06 269
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR06 270
swap:(L8+4,L8+7)#                      Swap ref. and subject param      CR06 271
QX(L8+8)=1./QX(L8+8)#                  Invert multipl. factor           CR06 272
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR06 273
ELSE#                                  Ref. param used before           CR06 274
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR06 275
QX(L8+7)=QX(L8-1)#                     Use ref. of former constr.       CR06 276
QX(L8+8)=QX(L8+8)*QX(L8)#              New mult. factor                 CR06 277
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR06 278
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR06 279
L8=L8+8#                                                                CR06 280
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR06 281
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR06 282
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR06 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR06 284
#                                                                       CR06 285
#        CONSTRAINT LINES                                               CR06 286
#        ----------------                                               CR06 287
#                                                                       CR06 288
REPEAT#                                Loop over constr lines           CR06 289
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR06 290
IF(LINID!=1) BREAK#                    Not a constr line                CR06 291
movechar:(CHRIP,1,CHROT,2,CHRMAX,0)#   Move line to output buffer       CR06 292
writeline:(0,0,0,1,3)#                 Echo line                        CR06 293
#                                                                       CR06 294
## SCAN CONSTR INPUT LINE, REPLACING ( ) * = WITH BLANKS                CR06 295
##                       , INSERTING BLANK BEFORE - OR +                CR06 296
#                                                                       CR06 297
DO NN=1,CHRMAX-1; IF(CHRIN(NN+1^NN+1)==':') BREAK# Detect colon         CR06 298
IF(NN==CHRMAX) NN=CHRMAX-1#            Avoid substring mis-index        CR06 299
CHRIN(NN+1^CHRMAX)=' '; CHRIP(NN+1^CHRMAX)=' '# Blank out comment       CR06 300
WHILE(CHRIN(NN^NN)==' ') NN=NN-1#      Remove trailing blanks           CR06 301
PFLAG=no:#                             Init parentheses flag            CR06 302
FOR(I=CHRCOL;I<=NN;I=I+1)#             Loop over characters in line     CR06 303
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR06 304
compchar:(CHRIN,I,CR63,1,1,1,8,KEY)#   Look for ( ) - + = * blank       CR06 305
IF(KEY==0) NEXT#                       No match                         CR06 306
ELSE IF(KEY==8)#                       Space encountered                CR06 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR06 308
movechar:(CHRIN,(I+1),CHRIN,I,(NN-I),0)# Squeeze out blanks             CR06 309
movechar:(BLANK,1,CHRIN,NN,1,0)#       Insert a blank                   CR06 310
movechar:(CHRIP,(I+1),CHRIP,I,(NN-I),0)# Squeeze out blanks             CR06 311
movechar:(BLANK,1,CHRIP,NN,1,0)#       Insert a blank                   CR06 312
I=I-1;NN=NN-1;NEXT#                    Adjust pointers                  CR06 313
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR06 314
IF((KEY==4\KEY==5)&PFLAG==no:)#        Found - or +; insert blank       CR06 315
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR06 316
FOR(J=NN-1;J>=I;J=J-1)$#               Backwards through cols           CR06 317
movechar:(CHRIN,J,CHRIN,(J+1),1,0)#    Move character one position      CR06 318
movechar:(BLANK,1,CHRIN,I,1,0)#        Insert a blank                   CR06 319
FOR(J=NN-1;J>=I;J=J-1)#                Loop backwards thru characters   CR06 320
movechar:(CHRIP,J,CHRIP,(J+1),1,0)#    Move character one position      CR06 321
movechar:(BLANK,1,CHRIP,I,1,0)#        Insert a blank                   CR06 322
I=I+1;NN=NN+1;NEXT#                    Skip over + or -                 CR06 323
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR06 324
ELSE IF(KEY==6)#                       '='                              CR06 325
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR06 326
compchar:(CHRIN,I+9,CR63,6,1,1,1,KEY)# Find '='                         CR06 327
IF(KEY>0)#                             Match                            CR06 328
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR06 329
I=I+9;NEXT#                            8 char atom id                   CR06 330
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR06 331
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR06 332
IF(KEY==2) PFLAG=no:#                  Right parenthesis detected       CR06 333
IF(PFLAG==no:)#                        If outside parentheses           CR06 334
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CR06 335
movechar:(BLANK,1,CHRIN,I,1,0)#        Insert a blank                   CR06 336
movechar:(BLANK,1,CHRIP,I,1,0)#        Insert a blank                   CR06 337
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CR06 338
IF(KEY==1) PFLAG=yes:#                 Left parenthesis detected        CR06 339
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR06 340
dcodefld:#                             Decode again                     CR06 341
Q=BUFIN(1);BUFIN(1)=BUFIN(3);BUFIN(3)=BUFIN(2);BUFIN(2)=Q# Reorder      CR06 342
#                                                                       CR06 343
FOR(I=1;I<=mxfdim:;I=I+3)#             Loop over constraint data        CR06 344
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CR06 345
ifvo:(BUFIN(I)) BREAK#                 End of input line                CR06 346
IF(BUFIN(I)<voidflg:) BUFIN(I)=-9999.# Code for constr constant         CR06 347
IF(BUFIN(I+1)>=voidflg:) iquit:(-CR0601)# Not alpha num                 CR06 348
IF(BUFIN(I+2)>=voidflg:) iquit:(-CR0601)# Not alpha num                 CR06 349
stringlim:(I+1,NC,NN)#                 Get parameter string             CR06 350
compchar:(CHRIN,NC,CR62,1,(NN-NC),3,NCR62,PAR)# Identify                CR06 351
IF(PAR==0) iquit:(-CR0601)#            Not in list                      CR06 352
stringlim:((I+2),NC,NN)#               Get atom name                    CR06 353
NAME1=CHRIP(NC^NN-1)#                  Store input atom label           CR06 354
L5=MARK5+incr:(name:);IAT=1#           Point to atom array;count at     CR06 355
WHILE(IAT<=NAT)#                       Loop over atoms                  CR06 356
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CR06 357
movertoc:(QX(L5-name:),1,NAME2,1,24,0)# Store atom name                 CR06 358
IF(NAME1==NAME2) BREAK#                Exit when labels match           CR06 359
L5=NINT(QX(L5));IAT=IAT+1#             Point to next atom;count ato     CR06 360
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CR06 361
IF(IAT>NAT) iquit:(CR0601)#            Die if no match                  CR06 362
IF(I==1)#                              If this is subject atom          CR06 363
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CR06 364
IATSUB=IAT; PARSUB=PAR#                Save subject atom & par number   CR06 365
I8=L8#                                 Start constraint info set        CR06 366
IF(PARSUB>4&PARSUB<11)#                Parameter is a uij               CR06 367
BUFIN(1)=BUFIN(1)*100./CELL(6+PARSUB-4)# Convert uij to betaij          CR06 368
incrqx:(JUNK,I8+5,CR0620)#             Incr qx                          CR06 369
QX(I8+1)=1.#                           Number of constraint info se     CR06 370
QX(I8+2)=3.#                           Number of items per set          CR06 371
QX(I8+3)=FLOAT(IAT)#                   Atom number                      CR06 372
QX(I8+4)=FLOAT(PAR)#                   Number of dependent paramete     CR06 373
QX(I8+5)=BUFIN(1)#                     Constraint constant q            CR06 374
L8=L8+5#                               Incr pointer                     CR06 375
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CR06 376
ELSE#                                  Else if reference info           CR06 377
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CR06 378
IF(IAT>IATSUB) iquit:(CR0610)#         Subject atom must precede refe   CR06 379
IF(IAT==IATSUB&PAR>PARSUB) iquit:(CR0610)# Subject must precede refer   CR06 380
QX(I8+1)=QX(I8+1)+1.#                  Incr number of info sets         CR06 381
incrqx:(JUNK,L8+3,CR0620)#             Incr qx                          CR06 382
IF(PARSUB>4&PARSUB<11)#                Subject param was a uij          CR06 383
BUFIN(I)=BUFIN(I)*100./CELL(6+PARSUB-4)# Scale constants for betaij     CR06 384
IF(PAR>4&PAR<11) BUFIN(I)=BUFIN(I)*CELL(6+PAR-4)/100.# Uij to betaij    CR06 385
QX(L8+1)=FLOAT(IAT)#                   Number of reference atom         CR06 386
QX(L8+2)=FLOAT(PAR)#                   Number of reference param        CR06 387
QX(L8+3)=BUFIN(I)#                     Multiplicative factor            CR06 388
L8=L8+3#                               Incr pointer                     CR06 389
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CR06 390
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CR06 391
readline:(CR61,NCR61)#                 Read next line                   CR06 392
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR06 393
#                                                                       CR06 394
#      NOREF AND BLOCK LINES                                            CR06 395
#      ---------------------                                            CR06 396
#                                                                       CR06 397
#EXAMPLE: NOREF C C1 X(C) X(C1) (X/Z)(C1/C10) SKF UOV DSP(C)            CR06 398
#                                                                       CR06 399
#         BLOCK C1 C10                    # START NEW BLOCKS AT C1 AND  CR06 400
#         BLOCK (X,Y,Z)(C1/C10) (U11/U23)(C1/C10)                       CR06 401
#         BLOCK X(C1),Y(C1),Z(C1),        # CONTINUE ON NEXT CARD       CR06 402
#         BLOCK X(C2),Y(C2),Z(C2)                                       CR06 403
#                                                                       CR06 404
## CREATE LIST IF SCATTERING FACTOR NAMES                               CR06 405
#                                                                       CR06 406
IF(LINID<=3)#                          If noref or block lines          CR06 407
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CR06 408
NCH=8*NATTYP#                          Number of chars in sf names      CR06 409
movertoc:(QX(MARK1+1),1,CH,1,NCH,0)#   Move the names                   CR06 410
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CR06 411
#                                                                       CR06 412
NBLK=0;LINLAS=2#                       Set block/noref signals          CR06 413
L=L8#                                  Set packet building pointer      CR06 414
CONTLI=no:#                            Set continuation line flag       CR06 415
REPEAT#                                Loop over input lines            CR06 416
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CR06 417
IF(LINID>3) BREAK#                     Quit if not noref or block       CR06 418
movechar:(CHRIP,1,CHROT,2,CHRMAX,0)#   Move input to output buffer      CR06 419
writeline:(0,0,0,1,3)#                 Echo input line                  CR06 420
IF(LINID==1) iquit:(CR0607)#           No more constr lines allowed     CR06 421
IF((LINID==2)&(LINLAS==3)) iquit:(CR0602)# Block after noref l          CR06 422
IF((LINID==3)&(LINLAS==2))#            First block line                 CR06 423
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CR06 424
LINLAS=3;MARK9=L#                      Last linid; start of block a     CR06 425
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CR06 426
#                                                                       CR06 427
## LOOP OVER ALL FIELDS                                                 CR06 428
#                                                                       CR06 429
FOR(I=1;I<=mxfdim:;I=I+1)#             Loop over line fields            CR06 430
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CR06 431
ifvo:(BUFIN(I)) BREAK#                 Exit on void field               CR06 432
IF(CONTLI==no:)#                       If not continuation line         CR06 433
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CR06 434
IL=L#                                  Start of info set                CR06 435
incrqx:(L,IL+2,CR0620)#                Incr qx                          CR06 436
QX(IL+1)=0.#                           Number of info sets              CR06 437
QX(IL+2)=2.#                           Number of items per set          CR06 438
SPANP=no:;SPANA=no:#                   Set param and atom span flag     CR06 439
DSPFLG=no:;ATTYP=0;NP=1#               Set flags/counters               CR06 440
IF(LINID==3) NBLK=NBLK+1#              Count the blocks                 CR06 441
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CR06 442
#                                                                       CR06 443
stringlim:(I,NC,NN)#                   Get limits of string             CR06 444
#                                                                       CR06 445
REPEAT#                                Find last char of block/nore     CR06 446
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CR06 447
CONTLI=no:#                            Reset cont. line flag            CR06 448
compchar:(CHRIN,NN,CR63,3,1,1,1,LIM)#  Is last char a comma ?           CR06 449
IF(LIM==0) compchar:(CHRIN,NN,CR63,6,1,1,1,LIM)# = as delimiter?        CR06 450
IF(LIM==0) BREAK#                      Break if not a comma or =        CR06 451
I=I+1#                                 Point to next field              CR06 452
IF(BUFIN(I)<voidflg:) stringlim:(I,K,NN)# If alpha find next limi       CR06 453
ELSE#                                  If void                          CR06 454
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CR06 455
CONTLI=yes:;BREAK#                     Continue on next line            CR06 456
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CR06 457
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CR06 458
#                                                                       CR06 459
## LOOP OVER PARAM(ATOM) PARTS OF STRING                                CR06 460
#                                                                       CR06 461
REPEAT#                                Loop over param(atom)            CR06 462
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CR06 463
compchar:(CHRIN,NC,CR65,1,1,1,4,LIM)#  Test if char ( ) , or /          CR06 464
IF(LIM>0) NC=NC+1#                     Skip char if ( ) , or /          CR06 465
IF(LIM==4) SPANP=yes:#                 Set param span                   CR06 466
#                                                                       CR06 467
## LOOP OVER PARAMETER PART OF STRING                                   CR06 468
#                                                                       CR06 469
compchar:(CHRIN,NC,CR64,1,3,4,NCR64,KEY)# Test if general parameter     CR06 470
IF(KEY>0)#                             General param                    CR06 471
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CR06 472
IF(KEY==1) REFSKF=0#                   Turn off scale factor            CR06 473
ELSE IF(KEY==2) REFUOV=0#              Turn off ovrall t.f.             CR06 474
ELSE IF(KEY==3) REFEXT=0#              Turn off extinction              CR06 475
ELSE IF(KEY==4) DSPFLG=yes:#           Dispersion off                   CR06 476
NC=NC+3;L=IL#                          Col pointer;reset noref poin     CR06 477
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CR06 478
ELSE#                                  Not a general parameter          CR06 479
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CR06 480
REPEAT#                                Loop over atom params            CR06 481
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CR06 482
compchar:(CHRIN,NC,CR62,1,3,3,NCR62,PAR)# Look for param names          CR06 483
IF(PAR>0) NC=NC+2#                     Match,reset column pointer       CR06 484
ELSE#                                                                   CR06 485
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CR06 486
compchar:(CHRIN,NC,CR62,1,1,3,12,PAR)# Check 1 col spelling             CR06 487
IF(PAR>0)#                             Have found a match               CR06 488
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CR06 489
compchar:(CHRIN,NC+1,CR65,1,1,1,5,K)#  Check next char ( ) , / sp       CR06 490
IF(K==0) PAR=0#                        It is not a parameter            CR06 491
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CR06 492
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CR06 493
#                                                                       CR06 494
incrqx:(L,L+2,CR0620)#                 Incr qx                          CR06 495
QX(L-1)=0.#                            Default atom number              CR06 496
IF(SPANP==no:) QX(L)=FLOAT(PAR)#       Number of parameter              CR06 497
ELSE           QX(L)=-FLOAT(PAR)#      Last param of a series           CR06 498
IF(PAR==0) BREAK#                      No param in input                CR06 499
IF(LINID==3) BLKTYP=3#                 Set flag for user def.blocks     CR06 500
NC=NC+1#                               Advance column pointer           CR06 501
compchar:(CHRIN,NC,CR65,1,1,1,4,LIM)#  Is next character ( ) , or -     CR06 502
IF(LIM>0) NC=NC+1#                     Advance column pointer           CR06 503
IF(LIM<=2) BREAK#                      Left or right paren              CR06 504
IF(LIM==4) SPANP=yes:#                 Minus means until                CR06 505
NP=NP+1#                               Count number of param/set        CR06 506
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CR06 507
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CR06 508
#                                                                       CR06 509
IF(NC>=NN)#                            Last char. read                  CR06 510
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 CR06 511
QX(IL+1)=FLOAT(NP);BREAK#              Store number of info sets        CR06 512
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 CR06 513
LL=L;L=L-2*NP#                         Remember l of subset;reset l     CR06 514
compchar:(CHRIN,NC,CR65,1,1,1,1,LIM)#  Id next char '('                 CR06 515
IF(LIM==1) NC=NC+1#                    Skip over '('                    CR06 516
#                                                                       CR06 517
## LOOP OVER ATOM PART OF STRING                                        CR06 518
#                                                                       CR06 519
REPEAT#                                Loop over atom parts             CR06 520
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CR06 521
LIM=0#                                 Reset search flag                CR06 522
FOR(J=NC;(LIM==0)&(J<=NN);J=J+1) $#    Loop to first delimiter          CR06 523
compchar:(CHRIN,J,CR65,1,1,1,5,LIM)#   Exit if delimiter found          CR06 524
IF(CHRIP(NC^NC)=='=')#                                                  CR06 525
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CR06 526
NAME2=CHRIP(NC+1^NC+8)#                Store atom label without =       CR06 527
K=10#                                                                   CR06 528
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CR06 529
ELSE#                                                                   CR06 530
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 CR06 531
K=J-NC-1#                              Width of atom id                 CR06 532
NAME2=CHRIP(NC^NC+K-1)#                Store atom label                 CR06 533
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 CR06 534
IF(SPANA==no:)#                        If not in atom serie             CR06 535
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CR06 536
IAT=1;L5=MARK5+incr:(name:)#           Count atoms;start atom point     CR06 537
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CR06 538
WHILE(IAT<=NAT)#                       Loop over atom list              CR06 539
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CR06 540
movertoc:(QX(L5-name:),1,NAME1,1,24,0)# Pull out atom name              CR06 541
IF(NAME1==NAME2) BREAK#                Exit when labels match           CR06 542
IAT=IAT+1;L5=NINT(QX(L5))#             Count atoms; advance pointer     CR06 543
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CR06 544
IF(IAT>NAT)#                           If match not found               CR06 545
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CR06 546
label:(NAME2,III1,III2,CH,ATTYP)#      Get atom type number             CR06 547
IF(III1!=III2\ATTYP==0) iquit:(CR0603)# No match either                 CR06 548
IAT=ATTYP#                             Set up atom pointer              CR06 549
IF(DSPFLG==yes:)#                      Disp.fact. in mark2-array        CR06 550
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 CR06 551
L2=MARK2+(ATTYP-1)*NSTEP2#             Point to refinement flag         CR06 552
QX(L2+3)=0.#                           Turn off refinement flag         CR06 553
L2=L2+NSTEP2+3#                        Point to next ref. flag          CR06 554
DO LL2=L2,MARK3,NSTEP2;QX(LL2)=QX(LL2)-1.# Nattyp-1                     CR06 555
L=L+2#                                 Adjust pointer                   CR06 556
NC=NC+K+1;BREAK#                       Advance pointer                  CR06 557
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 CR06 558
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CR06 559
IF(SPANA==no:) IAT1=IAT#               First atom (of series)!!         CR06 560
IF(LIM==4) SPANA=yes:#                 Atom span is on                  CR06 561
ELSE       SPANA=no:#                  Atom span is off                 CR06 562
#                                                                       CR06 563
IF(SPANA==no:)#                        If not atom in serie             CR06 564
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 CR06 565
M=NP*(IAT-IAT1+1)#                     Total number of sets             CR06 566
incrqx:(JUNK,L+2*M,CR0620)#            Incr qx                          CR06 567
QX(IL+1)=QX(IL+1)+FLOAT(M)#            Incr number of info sets         CR06 568
DO II=IAT1,IAT#                        Loop over atoms in set           CR06 569
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 CR06 570
DO J=1,NP#                             Loop over subsets with same      CR06 571
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 CR06 572
IF(ATTYP==0) QX(L+1)=FLOAT(II)#        Store atom nr                    CR06 573
ELSE QX(L+1)=-FLOAT(II)#               Or -atom type                    CR06 574
QX(LL+2)=QX(L+2)#                      Same param as former set         CR06 575
L=L+2;LL=LL+2#                         Advance pointers                 CR06 576
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 CR06 577
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 CR06 578
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 CR06 579
#                                                                       CR06 580
NC=NC+K+1#                             Advance column pointer           CR06 581
IF(NC>=NN) BREAK#                      Exit if last char read           CR06 582
IF(LIM<=2) BREAK#                      ( or )                           CR06 583
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CR06 584
NP=1#                                  Reset param counter              CR06 585
IF(NC>=NN) BREAK#                      Last char read                   CR06 586
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CR06 587
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CR06 588
readline:(CR61,NCR61)#                 Get next input line              CR06 589
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CR06 590
#                                                                       CR06 591
IF(LINLAS<=2) MARK9=L#                 No block images read             CR06 592
MARK10=L#                                                               CR06 593
IF(QUITF(1^1)!=' ') iquit:(CR0605)#    Non fatal error i input r.       CR06 594
#                                                                       CR06 595
RETURN#                                                                 CR06 596
END#                                                                    CR06 597
systemheader:(CR08)#                   Order block, noref and const     CR08   1
# ####################################################################  CR08   2
#                                                                       CR08   3
#                             CR08                                      CR08   4
#                                                                       CR08   5
# ####################################################################  CR08   6
SUBROUTINE CR08#                       R.olthof    jan. 1982            CR08   7
include:(AACOMN)#                      April 1989                       CR08   8
include:(CRCOMN)#                                                       CR08   9
#                                                                       CR08  10
INTEGER ATTYP#      ## ATOM TYPE NUMBER                                 CR08  11
INTEGER BLKMOD#     ## MODE FOR CR09 FOR BLOCKS                         CR08  12
INTEGER EULPT#      ## POINTER TO EULER INFO                            CR08  13
INTEGER FLAG#       ##                                                  CR08  14
INTEGER FLAG2#      ##                                                  CR08  15
INTEGER GROUP#      ## GROUP FLAG                                       CR08  16
INTEGER I,II,I6,I7,I8,J,JUNK,K7#                                        CR08  17
INTEGER IAT#        ## ATOM NUMBERS                                     CR08  18
INTEGER IBL,IBLK#   ## BLOCK COUNT AND NUMBER                           CR08  19
INTEGER LL,L2,L5,L7,L10,L11,L12#                                        CR08  20
INTEGER M,M1,M2#    ##                                                  CR08  21
INTEGER MARKAA#     ## START FOR POLAR INFO                             CR08  22
INTEGER MARK8A#     ##                                                  CR08  23
INTEGER MODE#       ## SEE CR09                                         CR08  24
INTEGER N,N10#      ##                                                  CR08  25
INTEGER NGRP#       ## NUMBER OF GROUPS                                 CR08  26
INTEGER NEWBLK#     ## FLAG FOR NEW BLOCK                               CR08  27
INTEGER NRFMOD#     ## NOREF MODE IN CR09                               CR08  28
INTEGER NTMP#       ## NUMBER OF TEMP.FACT.                             CR08  29
INTEGER PAR,PARTOT#                                                     CR08  30
INTEGER PAREUL#     ## EULER PARAMETER                                  CR08  31
INTEGER STOP10,STOP12#                                                  CR08  32
INTEGER SUBPAR#     ## SUBJECT PARAMETER                                CR08  33
INTEGER VAR#                                                            CR08  34
INTEGER VARBLK#                                                         CR08  35
#                                                                       CR08  36
intdata:(PART,[0])#                                                     CR08  37
intdata:(GRP,[1])#                     Atomnr in a group                CR08  38
intdata:(L8,[0])#                                                       CR08  39
intdata:(I12,[0])#                                                      CR08  40
intdata:(N1,[0])#                                                       CR08  41
intdata:(N2,[0])#                                                       CR08  42
datastuff:#                                                             CR08  43
#                                                                       CR08  44
#        SET UP REFINEMENT DIRECTORS FOR GENERAL PARAMETERS             CR08  45
#        --------------------------------------------------             CR08  46
#                                                                       CR08  47
IF(REFSKF>1) REFSKF=(MARK4-MARK3)/2#   Nr of scale fact to be refin     CR08  48
IF((BLKTYP==1)&(REFUOV<0)) REFUOV=0#   If fm and default uov r          CR08  49
ELSE IF((BLKTYP!=1)&(REFUOV<0)&(REFSKF==0)) REFUOV=0#                   CR08  50
#                                      If no scale f. refinement        CR08  51
VARGEN=REFSKF+IABS(REFUOV)#            Set nr of general variables      CR08  52
IF(REFABS==2) VARGEN=VARGEN+1#         Abs.struct.param is variable     CR08  53
IF(REFDSP==2)#                         If ref. of disp.parameters       CR08  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR08  55
LL=MARK3-1#                            Set last l2 value for loop       CR08  56
DO L2=MARK2,LL,NSTEP2#                 Loop over dispersion factors     CR08  57
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR08  58
IF(QX(L2+3)>0) VARGEN=VARGEN+2#        Nr of disp. fact. to be ref.     CR08  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR08  60
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR08  61
IF(REFEXT==2)#                         Is extinction param refi         CR08  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR08  63
IF(EXTTYP<=2)      VARGEN=VARGEN+1#    Isotropic extinction             CR08  64
ELSE IF(EXTTYP==3) VARGEN=VARGEN+2#    Isotr. ext., general             CR08  65
ELSE IF(EXTTYP<=5) VARGEN=VARGEN+6#    Anisotropic extinction           CR08  66
ELSE IF(EXTTYP==6) VARGEN=VARGEN+12#   Anisotr. ext., general           CR08  67
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR08  68
NONATM=VARGEN#                         Keep number of variables         CR08  69
#                                                                       CR08  70
#        SET UP REFINENEMT DIRECTORS FOR ATOM PARAMETERS                CR08  71
#        -----------------------------------------------                CR08  72
#                                                                       CR08  73
## MARK10 ARRAY (SCRATCH): BLOCK INFORMATION                            CR08  74
## QX(I10+1)   TOTAL NUMBER OF BLOCKS                                   CR08  75
##   QX(L10+1) NUMBER OF BLOCKS WITH QX(L10+2) VARIABLES                CR08  76
##   QX(L10+2) NUMBER OF VARIABLES / BLOCK                              CR08  77
##                                                                      CR08  78
## MARK11 ARRAY (SCRATCH): INFORMATION FOR USER DEFINED BLOCKS          CR08  79
## QX(L11+1)  NUMBER OF VARIABLE                                        CR08  80
##            THE NUMBER OF VARIABLES / BLOCK IS SET IN MARK10-ARRAY    CR08  81
##            A NEGATIVE VALUE POINTS TO LAST PARAM OF SERIE            CR08  82
##                                                                      CR08  83
## MARK12 ARRAY (SCRATCH): CONSTR AND NOREF INFORMATION                 CR08  84
## QX(I12+1) POINTER TO CONSTRAINED OR INVARIANT PARAMETER              CR08  85
##           IF NEGATIVE: ONE OR ALL PARAMS ARE INVARIANT               CR08  86
##                        IN THIS CASE ONLY QX(I12+1) IS PRESENT        CR08  87
## QX(I12+2) NR OF GROUP VAR; -1 MEANS NORMAL CONSTRAINT                CR08  88
## QX(I12+3) NR OF ITEMS IN CONSTR INFO SET                             CR08  89
## QX(I12+4) STEP SIZE IN CONSTR INFO SET                               CR08  90
##   QX(L12+1)  NUMBER OF VARIABLE                                      CR08  91
##   QX(L12+2)  MULTIPLICATION FACTOR                                   CR08  92
#                                                                       CR08  93
## INITIALIZATIONS                                                      CR08  94
## ---------------                                                      CR08  95
#                                                                       CR08  96
VARBLK=VARGEN;VARTOT=VARGEN#           Nr of var: 1-st block/total      CR08  97
IF(BLKTYP==0)      N10=3+2*NAT#        Max size of mark10 array         CR08  98
ELSE IF(BLKTYP==1) N10=3#              If full matrix                   CR08  99
ELSE               N10=20*NAT#         Estimate for n10                 CR08 100
incrqx:(MARK11,MARK10+N10,CR0820)#     Mark10 array: block count        CR08 101
IF(BLKTYP<3) MARKAA=MARK11#            No user defined blocks           CR08 102
ELSE incrqx:(MARKAA,MARK11+N10/2,CR0820)# Incr qx                       CR08 103
incrqx:(MARK12,MARKAA+3*NAT,CR0820)#   Markaa array for polar info      CR08 104
#                                                                       CR08 105
L10=MARK10+1;L11=MARK11;L12=MARK12#    Point to arrays                  CR08 106
QX(L10)=0.#                            Set total nr of blocks           CR08 107
STOP10=MARK10#                         Set stop10 pointer               CR08 108
MARK8A=MARK14#                         End of group data in mark8       CR08 109
GROUP=no:#                             Group flag                       CR08 110
#                                                                       CR08 111
## CHECK DEPENDENT CONSTRAINTS                                          CR08 112
## ---------------------------                                          CR08 113
#                                                                       CR08 114
I8=MARK8A;L8=I8#                       Start of search array            CR08 115
WHILE(L8<MARK9)#                       Constraints loop                 CR08 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR08 117
N1=INT(QX(L8+1));N2=INT(QX(L8+2))#     Nr of sets & items               CR08 118
L8=L8+2#                               Adjust pointer                   CR08 119
DO N=2,N1#                             Loop over reference sets         CR08 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR08 121
L8=L8+N2#                                                               CR08 122
IAT=INT(QX(L8+1));PAR=INT(QX(L8+2))#   Atom & param number              CR08 123
M=1#                                   Initiate cr09 variable           CR08 124
CALL CR09(M,IAT,PAR,MARK8A,FLAG)#      Is ref param also subj param     CR08 125
IF(FLAG>0)#                            Yes it is                        CR08 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR08 127
QX(I8+5)=QX(I8+5)+QX(FLAG+5)#          New constraint constant          CR08 128
QX(L8+1)=QX(FLAG+6)#                   New ref atom                     CR08 129
QX(L8+2)=QX(FLAG+7)#                   New ref param                    CR08 130
QX(L8+3)=QX(L8+3)*QX(FLAG+8)#          New factor                       CR08 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR08 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR08 133
I8=I8+2+N1*N2;L8=I8#                   Point to next constr             CR08 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR08 135
#                                                                       CR08 136
## LOOP OVER THE ATOMS                                                  CR08 137
## -------------------                                                  CR08 138
#                                                                       CR08 139
IAT=0#                                 Count atoms                      CR08 140
PART=3+REFPOP#                         X,y,z,pop                        CR08 141
NRFMOD=3;BLKMOD=4#                     Noref and block modes            CR08 142
IF(MARK6!=MARK7)#                      If group info present            CR08 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR08 144
I6=MARK6;NGRP=NINT(QX(I6+1))#          Nr of atoms in group             CR08 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR08 146
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Atom loop    c     CR08 147
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR08 148
IAT=IAT+1#                             Add up one atom                  CR08 149
intunpak:(QX(L5+1),ATTYP,0,5)#         Get atom type nr                 CR08 150
#                                                                       CR08 151
## CHECK NOREF ALL PARAMETERS OF THIS ATOM                              CR08 152
#                                                                       CR08 153
CALL CR09(NRFMOD,-ATTYP,0,MARK8A,FLAG)# Check: all param of attyp       CR08 154
IF(FLAG==0)#                           No match                         CR08 155
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR08 156
CALL CR09(NRFMOD,IAT,0,MARK8A,FLAG)#   Check: all param of atom         CR08 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR08 158
IF(FLAG>0)#                            Noref instruction present        CR08 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR08 160
incrqx:(L12,L12+1,CR0820)#             Incr qx                          CR08 161
QX(L12)=-FLOAT(L5)#                    Store -atom pointer              CR08 162
VAR=0#                                 Zero nr of var                   CR08 163
DO I=1,3;POLSPG(I)=0#                  Polar constraints erased         CR08 164
IF(NINT(QX(L5))>=MARK6) GOTO 999#      Make last block                  CR08 165
NEXT#                                                                   CR08 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR08 167
#                                                                       CR08 168
## LOOP OVER THE PARAMETERS                                             CR08 169
## ------------------------                                             CR08 170
#                                                                       CR08 171
PAR=0;VAR=0#                           Set count of param and var       CR08 172
intunpak:(QX(L5+1),NTMP,5,3);PARTOT=PART+NTMP# Get nr of tf; sum        CR08 173
DO I=1,PARTOT#                         Loop over params                 CR08 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR08 175
PAR=PAR+1;SUBPAR=no:#                  Add one par; no subj.par         CR08 176
IF((I==4)&(NTMP==6)) PAR=5#            U11                              CR08 177
IF((I==PARTOT)&(REFPOP>0)) PAR=11#     Pop param                        CR08 178
#                                                                       CR08 179
## CHECK IF PARAMETER IS INVARIANT                                      CR08 180
#                                                                       CR08 181
CALL CR09(NRFMOD,0,PAR,MARK8A,FLAG)#   Check: par of all atoms          CR08 182
IF(FLAG==0)#                           If no match                      CR08 183
CALL CR09(NRFMOD,-ATTYP,PAR,MARK8A,FLAG)# Check: par of atom type       CR08 184
IF(FLAG==0)#                           If no match                      CR08 185
CALL CR09(NRFMOD,IAT,PAR,MARK8A,FLAG)# Check: par of atom               CR08 186
IF(FLAG>0)#                            Invariant parameter              CR08 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR08 188
incrqx:(L12,L12+1,CR0820)#             Incr qx                          CR08 189
QX(L12)=-FLOAT(L5+I+1)#                Store -param pointer             CR08 190
IF(PAR<4) POLSPG(PAR)=0#               Polar constraint erased          CR08 191
NEXT#                                  Goto next param                  CR08 192
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR08 193
#                                                                       CR08 194
## CHECK IF PARAMETER IS SUBJECT PARAMETER                              CR08 195
#                                                                       CR08 196
M=1#                                   Initiate cr09 variable           CR08 197
IF(GROUP==no:)#                        If not a group                   CR08 198
CALL CR09(M,IAT,PAR,MARK8,FLAG)#       Check: left side of constrai     CR08 199
ELSE#                                  If a group                       CR08 200
CALL CR09(M,IAT,PAR,L8+N2,FLAG)#       Check: left side of constr       CR08 201
IF(FLAG==0) VAR=VAR+1#                 No constraint: add up one va     CR08 202
ELSE#                                  Constrained param                CR08 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR08 204
L8=FLAG;I12=L12#                       Constr input;start output        CR08 205
N1=NINT(QX(L8+1));N2=NINT(QX(L8+2))#   Nr of sets; items/set            CR08 206
incrqx:(JUNK,L12+2+2*N1,CR0820)#       Incr qx                          CR08 207
QX(I12+1)=FLOAT(L5+I+1)#               Store param pointer              CR08 208
IF(NINT(QX(L8+6))<=MARK6)$#            Not a group atom                 CR08 209
QX(I12+2)=QX(L8+7)+1.#                 Code for constraint              CR08 210
ELSE#                                  It is a group atom               CR08 211
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR08 212
GROUP=yes:#                            Set group                        CR08 213
QX(I12+2)=0.#                          Code for group constraint        CR08 214
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR08 215
QX(I12+3)=FLOAT(2+2*N1)#               Nr of items                      CR08 216
QX(I12+4)=2.#                          Stepsize                         CR08 217
L8=L8+2;L12=I12+2#                     Start pointers                   CR08 218
DO N=2,N1#                             Loop over subsets                CR08 219
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR08 220
L8=L8+N2;L12=L12+2#                    Incr pointers                    CR08 221
IF(GROUP==yes:)#                       Group constraints                CR08 222
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR08 223
IF(NINT(QX(L8+1))<=MARK6 & QX(L8+2)>0.)# Identical molec                CR08 224
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR08 225
QX(L12+1)=QX(L8+1)#                    Var nr                           CR08 226
QX(L12+2)=QX(L8+3)#                    Multiplication factor            CR08 227
NEXT#                                                                   CR08 228
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR08 229
EULPT=NINT(QX(L8+1));PAREUL=NINT(QX(L8+2))# Point to euler param        CR08 230
IF(EULPT<MARK12)#                      First access to euler param      CR08 231
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR08 232
IF(PAREUL>0)#                          Variable euler param             CR08 233
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR08 234
M=1#                                   Initiate cr09 variable           CR08 235
IF((PAREUL>3)&(PAR<4)) FLAG2=0#        Euler angle                      CR08 236
ELSE CALL CR09(M,IAT,PAR,MARK8A,FLAG2)# Constr on this param?           CR08 237
IF(FLAG2==0)#                          No                               CR08 238
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR08 239
VAR=VAR+1#                             Add up on variable               CR08 240
QX(EULPT)=FLOAT(VARTOT+VAR)#           Store number of var              CR08 241
QX(I12+2)=QX(I12+2)+1.#                Add up one var to var/group      CR08 242
QX(L12+1)=FLOAT(VARTOT+VAR)#           Store number of var              CR08 243
QX(L12+2)=QX(L8+3)#                    Store factor                     CR08 244
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR08 245
ELSE#                                  Constrained param                CR08 246
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR08 247
QX(EULPT)=0.#                          Noref euler paramgroup           CR08 248
QX(I12+2)=0.#                          Reset code to no-group           CR08 249
M1=NINT(QX(FLAG2+1));M2=NINT(QX(FLAG2+2))# Nr of sets/items per set     CR08 250
QX(I12+3)=FLOAT(2+2*M1)#               Reset nr of items                CR08 251
FLAG2=FLAG2+2;L12=I12+2#               Start pointers in constr         CR08 252
DO II=2,M1#                            Loop over packets                CR08 253
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR08 254
FLAG2=FLAG2+M2;L12=L12+2#              Incr pointers                    CR08 255
QX(L12+1)=QX(FLAG2+1)#                 Store nr of var                  CR08 256
QX(L12+2)=QX(FLAG2+3)#                 Store factor                     CR08 257
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR08 258
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR08 259
QX(FLAG+5)=-9999.#                     Flag off re-calc                 CR08 260
M=MARK8#                               Point to constr array            CR08 261
REPEAT#                                Loop over r.h.s. of constr       CR08 262
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR08 263
MODE=2;CALL CR09(MODE,EULPT,0,M,FLAG2)# Search for same euler ref       CR08 264
IF(FLAG2==0) BREAK#                    No match                         CR08 265
IF(QX(EULPT)>0) QX(MODE+1)=QX(EULPT)#  If variable, store var nr        CR08 266
ELSE QX(MODE+1)=FLOAT(I12)#            Else store constr pt             CR08 267
QX(MODE+2)=-1.#                        Flag off constr                  CR08 268
IF(PAR<4) QX(FLAG2+5)=-9999.#          Flag off re-calc                 CR08 269
ELSE#                                  Re-calc tf factors               CR08 270
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR08 271
M=L5+1+I;QX(FLAG2+5)=QX(M)#            Store old value                  CR08 272
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR08 273
M=FLAG2+2+NINT(QX(FLAG2+1)*QX(FLAG2+2))# Point to next constr           CR08 274
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR08 275
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR08 276
ELSE#                                  Constr euler param               CR08 277
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR08 278
QX(L12+1)=QX(L8+1)#                    Store var nr of ref.param        CR08 279
QX(L12+2)=QX(L8+3)#                    Store factor                     CR08 280
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR08 281
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR08 282
ELSE#                                  Not first access to euler p.     CR08 283
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR08 284
M=NINT(QX(EULPT+3))#                   Point to constraint              CR08 285
movereal:(QX,EULPT+2,QX,I12+2,(M-1),0)# Copy constr items               CR08 286
L12=I12+M-2#                           Point to next constr             CR08 287
BREAK#                                                                  CR08 288
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR08 289
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR08 290
ELSE#                                  Not a group param                CR08 291
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR08 292
QX(L12+1)=QX(L8+1)#                    Store var nr                     CR08 293
QX(L12+2)=QX(L8+3)#                    Store factor                     CR08 294
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR08 295
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR08 296
IF(QX(FLAG+5)>-9999.)#                 If re-calc requested             CR08 297
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR08 298
M=L5+1+I;QX(M)=QX(FLAG+5)#             Store new value                  CR08 299
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR08 300
L12=L12+2#                             Point to next subset             CR08 301
SUBPAR=yes:#                           Par is subject parameter         CR08 302
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR08 303
#                                                                       CR08 304
## CHECK IF PARAMETER IS REFERENCE PARAMETER                            CR08 305
#                                                                       CR08 306
IF(SUBPAR==no: \ GROUP==yes:)#         If not subj.par or if group      CR08 307
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR08 308
M=MARK8A#                              Start pointer in no-group c.     CR08 309
REPEAT#                                Loop over no-group constr        CR08 310
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR08 311
MODE=2;CALL CR09(MODE,IAT,PAR,M,FLAG2)# Search on r.h.s.                CR08 312
IF(FLAG2==0) BREAK#                    No match                         CR08 313
QX(MODE+1)=FLOAT(VARTOT+VAR)#          Store var nr                     CR08 314
QX(MODE+2)=-2.#                        Flag off constr                  CR08 315
IF(QX(FLAG2+5)>-9999.)#                If re-calc requested             CR08 316
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR08 317
M=L5+1+I#                              Point to param                   CR08 318
QX(FLAG2+5)=QX(FLAG2+5)+QX(MODE+3)*QX(M)# Calc new value                CR08 319
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR08 320
M=FLAG2+2+NINT(QX(FLAG2+1)*QX(FLAG2+2))# Point to next constr           CR08 321
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR08 322
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR08 323
#                                                                       CR08 324
#                                                                       CR08 325
## CHECK IF PARAMETER IS POLAR PARAMETER                                CR08 326
#                                                                       CR08 327
IF(PAR<4)#                             If coord                         CR08 328
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CR08 329
IF(POLSPG(PAR)>0)#                     If polar axis                    CR08 330
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CR08 331
IF(NINT(QX(L5))<MARK6)#                If not last atom                 CR08 332
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CR08 333
IF(SUBPAR==yes:) POLSPG(PAR)=no:#      Polar constraint erased          CR08 334
ELSE#                                  Following atoms                  CR08 335
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CR08 336
M=MARKAA+(PAR-1)*NAT+IAT#              Point into markaa-array          CR08 337
QX(M)=FLOAT(VARTOT+VAR)#               Store var nr                     CR08 338
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CR08 339
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CR08 340
ELSE#                                  Last atom                        CR08 341
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CR08 342
VAR=VAR-1#                             This is dependent param          CR08 343
QX(L12+1)=FLOAT(L5+I+1)#               Store param pointer              CR08 344
QX(L12+2)=-1.#                         Store 'non-group' code           CR08 345
QX(L12+3)=FLOAT(NAT+3)#                Store nr of items in set         CR08 346
QX(L12+4)=1.#                          Nr of items per subset           CR08 347
M=MARKAA+(PAR-1)*NAT+1#                Point to first item              CR08 348
movereal:(QX,M,QX,L12+5,(NAT-1),0)#    Move all var nr                  CR08 349
L12=L12+NAT+3#                         Incr l12                         CR08 350
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CR08 351
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CR08 352
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CR08 353
#                                                                       CR08 354
## USER DEFINED BLOCKS                                                  CR08 355
#                                                                       CR08 356
IF(BLKTYP==3)#                         User defined blocks              CR08 357
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CR08 358
CALL CR09(BLKMOD,IAT,PAR,MARK9,FLAG)#  Check block directory            CR08 359
IF(FLAG<MARK9)#                        First atom of serie              CR08 360
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CR08 361
L10=MARK10+3+FLAG*2#                   Pointer in mark10 array          CR08 362
STOP10=MAX0(STOP10,L10)#               End of mark10 array              CR08 363
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CR08 364
QX(L10)=QX(L10)+1.#                    Add up one variable              CR08 365
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CR08 366
#                                                                       CR08 367
## RESTRAINTS                                                           CR08 368
#                                                                       CR08 369
FOR(I7=MARK7;I7<MARK8;I7=I7+4+5*N)#    Loop over restraints             CR08 370
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CR08 371
IF(PAR>3 \ SUBPAR==yes:) BREAK#        Not a variable positional para   CR08 372
N=NINT(QX(I7+2))#                      Nr of atoms                      CR08 373
K7=I7+2;L7=I7+1+2*N#                   Pntrs to frst atom & variable    CR08 374
DO J=1,N#                              Loop over atoms                  CR08 375
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CR08 376
K7=K7+2;L7=L7+3;IF(L5!=NINT(QX(K7+1))) NEXT# Atoms do not match         CR08 377
QX(L7+PAR)=FLOAT(VARTOT+VAR);BREAK#    Store var nr                     CR08 378
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CR08 379
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CR08 380
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR08 381
#                                                                       CR08 382
## START A NEW BLOCK, IF NECESSARY                                      CR08 383
## -------------------------------                                      CR08 384
#                                                                       CR08 385
999   CONTINUE#                                                         CR08 386
NEWBLK=no:#                            No new block                     CR08 387
IF((BLKTYP==0)&(GRP<=1)) NEWBLK=yes:#  Block diagonal                   CR08 388
ELSE IF(BLKTYP==2)#                    Blocks are defined               CR08 389
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CR08 390
CALL CR09(BLKMOD,IAT,0,MARK9,FLAG)#    Search for block dir.            CR08 391
IF(FLAG>0) NEWBLK=yes:#                Block directory found            CR08 392
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CR08 393
DO M=1,2#                              Make max. 2 new blocks           CR08 394
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CR08 395
IF((NEWBLK==yes:)&(VARBLK>0))#         New block wanted                 CR08 396
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CR08 397
IF(VARBLK==NINT(QX(L10)))$#            Same size as former block        CR08 398
QX(L10-1)=QX(L10-1)+1#                 Add up one block                 CR08 399
ELSE#                                  Different size                   CR08 400
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CR08 401
QX(L10+1)=1.#                          One block for this set           CR08 402
QX(L10+2)=FLOAT(VARBLK)#               Nr of variables                  CR08 403
L10=L10+2#                             Incr pointer                     CR08 404
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CR08 405
QX(MARK10+1)=QX(MARK10+1)+1.#          Total nr of blocks               CR08 406
VARBLK=0#                              Reset var per block              CR08 407
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CR08 408
IF(M==2) BREAK#                        End of last block                CR08 409
VARBLK=VARBLK+VAR#                     Add up var/block                 CR08 410
VARTOT=VARTOT+VAR#                     Add up total var                 CR08 411
IF(NINT(QX(L5))<MARK6) BREAK#          Not last atom                    CR08 412
IF(BLKTYP<3) NEWBLK=yes:#              Set for last block               CR08 413
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CR08 414
#                                                                       CR08 415
## ADJUST GROUP COUNTERS                                                CR08 416
#                                                                       CR08 417
IF(GROUP==yes:)#                       If group atom                    CR08 418
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CR08 419
IF(GRP<NGRP) GRP=GRP+1#                Add up one atom                  CR08 420
ELSE#                                  After last atom                  CR08 421
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CR08 422
GROUP=no:;GRP=1#                       Reset group and grp              CR08 423
I6=I6+ISTEP6+NSTEP6*NGRP#              Point to next group              CR08 424
NGRP=NINT(QX(I6+1))#                   Nr of atoms/group                CR08 425
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CR08 426
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CR08 427
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR08 428
IF(BLKTYP<=2) STOP10=L10#              Save last position in mark10     CR08 429
STOP12=L12#                            Save last position in mark12     CR08 430
#                                                                       CR08 431
## PREPARE MARK11-ARRAY FOR INFO ON USER DEFINED BLOCKS                 CR08 432
## ----------------------------------------------------                 CR08 433
#                                                                       CR08 434
IF(BLKTYP==3)#                         User defined block               CR08 435
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CR08 436
IAT=0;VAR=VARGEN#                      Atom & variables counts          CR08 437
QX(MARK10+3)=FLOAT(VARGEN)#            Forst block                      CR08 438
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Atom loop    c     CR08 439
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CR08 440
IAT=IAT+1#                             Add up one atom                  CR08 441
PAR=0#                                 Parameter number                 CR08 442
DO I=1,PARTOT#                         Loop over parameters             CR08 443
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CR08 444
PAR=PAR+1#                             Add up one param                 CR08 445
IF((I==4)&(NTMP==6))       PAR=5#      U11                              CR08 446
IF((I==PARTOT)&(REFPOP>0)) PAR=11#     Pop param                        CR08 447
CALL CR09(BLKMOD,IAT,PAR,MARK9,FLAG)#  Check block directory            CR08 448
IF(FLAG<MARK9)#                        First atom of serie              CR08 449
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 CR08 450
L10=MARK10-1;VAR=0;IBLK=FLAG#          Pointer;nr of var;nr of bloc     CR08 451
DO IBL=1,IBLK#                         Loop over the blocks             CR08 452
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CR08 453
L10=L10+2;VAR=VAR+NINT(QX(L10+2))#     Adv pointer;nr of var/block      CR08 454
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CR08 455
L10=L10+2;VAR=VAR+NINT(QX(L10+1))+1#   Add var in current block         CR08 456
L11=L11+1;QX(L11)=FLOAT(VAR)#          Store var nr                     CR08 457
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 CR08 458
ELSE IF(BLKMOD>0)#                     Last item of serie reached       CR08 459
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CR08 460
L11=L11+1;QX(L11)=-FLOAT(L5+I+1)#      Store -param pointer             CR08 461
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CR08 462
QX(L10+1)=QX(L10+1)+1.#                Add up one varbl                 CR08 463
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CR08 464
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CR08 465
FOR(L10=MARK10+2;L10<STOP10;L10=L10+2) QX(L10)=1.# Reset nr of blo      CR08 466
QX(MARK10+1)=FLOAT((STOP10-MARK10-1)/2)# Total nr of blocks             CR08 467
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CR08 468
#                                                                       CR08 469
## SHIFT ARRAYS TO FINAL POSITION                                       CR08 470
## ------------------------------                                       CR08 471
#                                                                       CR08 472
N=STOP10-MARK10#                       Length of mark10 info            CR08 473
movereal:(QX,MARK10+1,QX,MARK8+1,N,1)# Move to mark8 array              CR08 474
MARK9=MARK8+N#                         Reset mark9                      CR08 475
N=L11-MARK11#                          Length of mark11 info            CR08 476
movereal:(QX,MARK11+1,QX,MARK9+1,N,1)# Move to mark9                    CR08 477
MARK10=MARK9+N#                        Reset mark10                     CR08 478
N=STOP12-MARK12#                       Length of mark12 info            CR08 479
movereal:(QX,MARK12+1,QX,MARK10+1,N,1)# Move to mark10                  CR08 480
MARK11=MARK10+N+1#                     Set mark11                       CR08 481
QX(MARK11)=FLOAT(MARK6+name:+1)#       Store mark11 in qx(mark11)       CR08 482
#                                                                       CR08 483
RETURN#                                Cr08                             CR08 484
END#                                                                    CR08 485
systemheader:(CR09)#                   Check constr,noref,block         CR09   1
# ################################################################# #   CR09   2
#                                                                   #   CR09   3
#                                CR09                               #   CR09   4
#                                                                   #   CR09   5
# ################################################################# #   CR09   6
SUBROUTINE CR09(MODE,IAT,PAR,MARK,FLAG)# R. olthof                      CR09   7
#                                      May 1985                         CR09   8
include:(AACOMN)#                                                       CR09   9
include:(CRCOMN)#                                                       CR09  10
#                                                                       CR09  11
INTEGER FLAG#       ## INPUT: POINTER TO BEGINNING OF SEARCH            CR09  12
#                   ## OUTPUT: POINTER TO WANTED BLOCK                  CR09  13
#                   ## OUTPUT: BLOCKNR, WHEN BLOCK SEARCH               CR09  14
INTEGER IAT#        ## WANTED ATOM NUMBER                               CR09  15
INTEGER IL#         ## POINTER TO BEGINNING BLOCK                       CR09  16
INTEGER L#                                                              CR09  17
INTEGER LAST#       ## LAST INDEX IN ARRAY                              CR09  18
INTEGER MARK#       ## START SEARCH AT THIS MARK                        CR09  19
INTEGER MODE#       ## 1/2/3/4 FOR CONSTRAINTS (LEFT SIDE)/             CR09  20
#                   ## CONSTRAINTS (RIGHT SIDE)/NOREF/BLOCK             CR09  21
#                   ## WHEN NEGATIVE: SERIE OF ITEMS IS MET             CR09  22
#                   ## OUTPUT: POINTER TO SUBSET, WHEN SEARCH ON        CR09  23
#                   ## RIGHT SIDE OF CONSTR EQ. OR                      CR09  24
#                   ##        -POINTER TO SUBSET, WHEN NOREF OR BLOCK   CR09  25
INTEGER N,N1,N2,N3# ## COUNTERS OF SUBSETS                              CR09  26
INTEGER NBLK#       ## COUNT OF BLOCKS                                  CR09  27
INTEGER PAR#        ## WANTED PARAM                                     CR09  28
INTEGER ST#         ## STEP SIZE IN WANTED L                            CR09  29
INTEGER STEP#       ## STEP SIZE                                        CR09  30
#                                                                       CR09  31
IF(MODE>0)#                            Search for new match             CR09  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR09  33
L=MARK;FLAG=0#                         Initializations                  CR09  34
IF(MODE<=3) LAST=MARK9#                Constr or noref search           CR09  35
ELSE        LAST=MARK10#               Block search                     CR09  36
IF(MODE<=2) ST=3#                      Noref and block: step size       CR09  37
ELSE        ST=2#                      Constraints: step size           CR09  38
NBLK=0#                                Count of blocks                  CR09  39
WHILE(L<LAST)#                         Loop over info sets              CR09  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR09  41
NBLK=NBLK+1#                           Add up one block                 CR09  42
N1=1#                                  First set of info                CR09  43
N2=NINT(QX(L+1))#                      Nr of sets of info               CR09  44
STEP=NINT(QX(L+2))#                    Step size                        CR09  45
IF(STEP!=ST)#                          Step sizes do not match          CR09  46
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR09  47
L=L+N2*STEP+2;NEXT#                    Advance pointer; goto next s     CR09  48
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR09  49
IL=L;L=L+2#                            Pointer to start of set          CR09  50
IF(MODE==1)#                           Search in left hand side of      CR09  51
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR09  52
STEP=N2*STEP;N2=1#                     Skip right side;reset n2         CR09  53
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR09  54
ELSE IF(MODE==2)#                      Search in right hand side        CR09  55
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR09  56
N1=2;L=L+STEP#                         Set pointers to right hand s     CR09  57
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR09  58
FOR(N=N1;N<=N2;N=N+1)#                 Loop over subsets                CR09  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR09  60
N3=NINT(QX(L+2))#                      To simplify next line            CR09  61
IF((NINT(QX(L+1))==IAT)&(N3==PAR)) BREAK# Match                         CR09  62
L=L+STEP#                              Pointer to next subset           CR09  63
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR09  64
IF(N>N2) NEXT#                         If no match, goto next const     CR09  65
#                                                                       CR09  66
FLAG=IL#                               Pointer to start of wanted s     CR09  67
IF(MODE==2)#                           Search in r.h.s. of constr       CR09  68
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR09  69
MODE=L#                                Save pointer to subset           CR09  70
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR09  71
ELSE IF(MODE>2)#                                                        CR09  72
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR09  73
IF(MODE==4) FLAG=NBLK#                 Save block count                 CR09  74
L=L+STEP;IF(QX(L+2)<0.) MODE=-L#       When serie of info: save         CR09  75
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR09  76
L=LAST#                                Stop the while loop              CR09  77
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR09  78
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR09  79
ELSE#                                  Serie of atoms                   CR09  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR09  81
L=-MODE;FLAG=MARK#                     Pointer to last atom;def. fl     CR09  82
IF(NINT(QX(L+1))==IAT)#                Last atom of serie               CR09  83
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR09  84
IF(PAR==0) FLAG=0#                     All params of atom               CR09  85
ELSE IF(NINT(QX(L+2))==-PAR)#          Match of last param              CR09  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR09  87
IF(L<MARK9) MODE=3#                    Reset mode for noref             CR09  88
ELSE        MODE=4#                    Reset mode for block             CR09  89
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR09  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR09  91
ELSE IF((IAT<=0)\(QX(L+1)<=0.)) FLAG=0# Only cont. atom serie           CR09  92
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR09  93
#                                                                       CR09  94
RETURN#                                                                 CR09  95
END#                                                                    CR09  96
systemheader:(CR10)#                   Output of initial param          CR10   1
# ############################################################# #       CR10   2
#                                                               #       CR10   3
#                               CR10                            #       CR10   4
#                                                               #       CR10   5
# ###############################################################       CR10   6
SUBROUTINE CR10#                       R. olthof    august 1980         CR10   7
#                                      May 1985     april  1989         CR10   8
include:(AACOMN)#                                                       CR10   9
include:(CRCOMN)#                                                       CR10  10
#                                                                       CR10  11
string:(CH,120)#                                                        CR10  12
INTEGER ATTYP#     ## ATOM TYPE NUMBER                                  CR10  13
INTEGER I,J,K,M,N# ##                                                   CR10  14
INTEGER I1,I2,I6,I7##                                                   CR10  15
INTEGER I6FRST#    ## POINTER TO 1-ST IDMOL                             CR10  16
INTEGER IGR#       ## GROUP NUMBER                                      CR10  17
INTEGER JK,JL,JN#  ##                                                   CR10  18
INTEGER L1,L2,L3,L5,L6,L7#                                              CR10  19
INTEGER LCON#                                                           CR10  20
INTEGER NATM#      ## NR OF ATOMS                                       CR10  21
INTEGER NATGR#     ## NR OF ATOMS IN A GROUP                            CR10  22
INTEGER NCH#       ## NR OF CHARACTERS ON OUTPUT LINE                   CR10  23
INTEGER NCHP#      ## LCHROT FOR POP                                    CR10  24
INTEGER NTMP#      ## NUMBER OF TEMP.PAR.                               CR10  25
INTEGER PAR#       ## PARAMETER NUMBER                                  CR10  26
INTEGER PARTOT#    ## TOTAL NR OF PARAMETERS OF AN ATOM                 CR10  27
INTEGER PCON#      ## CONSTRAINED PARAM                                 CR10  28
INTEGER VAR#       ## COUNT OF VARIABLES OF ONE ATOM                    CR10  29
#                                                                       CR10  30
chardata:(CR101, INITIAL PARAMETERS (I=INVARIANT C=CONSTRAINED $#       CR10  31
G=GROUP R=RESTRAINED ))#                                                CR10  32
chardata:(CR102, ***GENERAL PARAMETERS***)#                             CR10  33
chardata:(CR103, ***GROUP   ***)#                                       CR10  34
chardata:(CR104, ***INDIVIDUAL ATOM PARAMETERS*** (U*100))#             CR10  35
chardata:(CR105, -SCALE FACTOR(S) 100*U(OVERALL)     ABS.STRUCT.$#      CR10  36
PARAM.EXT(G/10000)DISPERSION - ZACH TYP1 TYP2 GEN  GAUS LOR )#          CR10  37
chardata:(CR106, ORTHOGONAL COORDS - CRYST. AXES              $#        CR10  38
ORTHOGONAL COORDS - EULER AXES)#                                        CR10  39
chardata:(CR107, CENTER OF GRAVITY)#                                    CR10  40
chardata:(CR108, EULER ANGLES (PHI THETA PSI))#                         CR10  41
chardata:(CR109, X        Y        Z      U11      $#                   CR10  42
U22      U33      U12      U13      U23)#                               CR10  43
realdata:(FMT1,[942.,942.,942.,942.,942.,942.,942.,942.,942.,722.])#    CR10  44
realdata:(FMT,[160742.,250742.,340742.,430742.,$#                       CR10  45
520742.,610742.,700742.,790742.,$#                                      CR10  46
880742.,970742.,340741.,430741.,520741.,610741.,700741.,790741.])#      CR10  47
realdata:(RAD,[57.29578])#             Factor radians to degrees        CR10  48
intdata:(L6FRST,[0])#                  Pointer to atoms in 1-st idm     CR10  49
datastuff:#                                                             CR10  50
#                                                                       CR10  51
#        GENERAL PARAMETERS                                             CR10  52
#        ------------------                                             CR10  53
#                                                                       CR10  54
LINRM=8#                               Force necessary space            CR10  55
movechar:(CR105,2,CHROT,2,19,1)#       Underline                        CR10  56
writeline:(1,CR101,NCR101,1,3)#        Initial parameters               CR10  57
#                                                                       CR10  58
writeline:(1,CR102,NCR102,3,1)#        General parameters               CR10  59
writeline:(0,0,0,3,1)#                 Print blank line                 CR10  60
#                                                                       CR10  61
movechar:(CR105,3,CHROT,2,15,0)#       Scale factor(s)                  CR10  62
I=0#                                   Set column counter               CR10  63
FOR(L3=MARK3;L3<MARK4;L3=L3+2)#        Loop over scale factors          CR10  64
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR10  65
I=I+1#                                 Count columns                    CR10  66
ncodefld:(QX(L3+1),1,CHROT,FMT(I+2),1)# Encode scale factor             CR10  67
IF(REFSKF==0)#                         Invariant                        CR10  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR10  69
M=NINT(FMT(I+2))/10000+1#              Character position               CR10  70
CHROT(M^M)='I'#                        Flag as invariant (i)            CR10  71
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR10  72
IF(I<6 & L3<MARK4-2) NEXT#             Test for end of list             CR10  73
writeline:(0,0,0,1,3)#                 Print line of scales             CR10  74
I=0#                                   Reset column counter             CR10  75
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR10  76
#                                                                       CR10  77
movechar:(CR105,19,CHROT,2,18,0)#      100*u(overall)                   CR10  78
BUFOT(1)=BTOHU*QX(MARK4+1)#            Store 100 * overall u            CR10  79
ncodefld:(BUFOT,1,CHROT,FMT(3),1)#     Encode 100 * uov                 CR10  80
IF(REFUOV==0) CHROT(35^35)='I'#        Flag as invariant (i)            CR10  81
writeline:(0,0,0,1,1)#                 Print uov                        CR10  82
#                                                                       CR10  83
IF(REFEXT>0)#                          If extinction used               CR10  84
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR10  85
movechar:(CR105,55,CHROT,2,12,0)#      Extinction par.                  CR10  86
JL=80+EXTTYP*5#                        Point to ext. type               CR10  87
movechar:(CR105,JL,CHROT,15,4,0)#      Move ext. type                   CR10  88
JL=100+DSTEXT*5#                       Point to distr. type             CR10  89
movechar:(CR105,JL,CHROT,21,4,0)#      Move distr. type                 CR10  90
IF(EXTTYP<3)       N=1#                Number of params                 CR10  91
ELSE IF(EXTTYP==3) N=2#                                                 CR10  92
ELSE IF(EXTTYP<6)  N=6#                                                 CR10  93
ELSE               N=12#                                                CR10  94
IF(EXTTYP<=1\EXTTYP==3) JN=MARK4+2#    Point to ext. param              CR10  95
ELSE IF(EXTTYP==2)      JN=MARK4+3#                                     CR10  96
ELSE IF(EXTTYP==5)      JN=MARK4+10#                                    CR10  97
ELSE                    JN=MARK4+4#                                     CR10  98
JK=35#                                 Get ready to mark invariant      CR10  99
DO I=1,N#                              Loop over values                 CR10 100
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR10 101
BUFOT(I)=QX(JN)#                       Move them to output              CR10 102
IF(REFEXT==1) CHROT(JK^JK)='I'#        Flag as invariant (i)            CR10 103
JK=JK+9;  JN=JN+1#                     Incr. pointers                   CR10 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR10 105
ncodefld:(BUFOT,1,CHROT,FMT(11),N)#    Code them..                      CR10 106
writeline:(0,0,0,1,1)#                 Print extinction                 CR10 107
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR10 108
#                                                                       CR10 109
IF(REFABS>0)#                          If abs.struct.param used         CR10 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR10 111
movechar:(CR105,38,CHROT,2,17,0)#      Abs.struct.param.                CR10 112
IF(REFABS==1) CHROT(35^35)='I'#        Flag as invariant (i)            CR10 113
ncodefld:(XABS,1,CHROT,FMT(3),1)#      Encode it                        CR10 114
writeline:(0,0,0,1,1)#                 Print abs.struct.param           CR10 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR10 116
#                                                                       CR10 117
IF(REFDSP>0)#                          If dispersion used               CR10 118
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR10 119
movechar:(CR105,67,CHROT,2,10,0)#      Disp. factor                     CR10 120
L2=MARK2-NSTEP2;K=-7#                  Set pointer to atom types        CR10 121
DO I=1,NATTYP#                         Loop over atom types             CR10 122
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR10 123
K=K+8; L2=L2+NSTEP2#                                                    CR10 124
IF((ABS(QX(L2+1))<small:)&$#           Skip if no dispersion            CR10 125
   (ABS(QX(L2+2))<small:)) NEXT#                                        CR10 126
movertoc:(QX(MARK1+1),K,CHROT,18,8,0)#                                  CR10 127
ncodefld:(QX(L2+1),1,CHROT,FMT(3),2)#  Encode real and imag.part        CR10 128
ifeq:(QX(L2+3),0.)#                    Invariant dispersion factor      CR10 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR10 130
CHROT(35^35)='I'#                      Flag as invariant (i)            CR10 131
CHROT(44^44)='I'#                      Flag as invariant (i)            CR10 132
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR10 133
writeline:(0,0,0,1,1)#                 Print dispersion                 CR10 134
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR10 135
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR10 136
#                                                                       CR10 137
#        GROUP PARAMETERS                                               CR10 138
#        ----------------                                               CR10 139
#                                                                       CR10 140
I6=MARK6#                              Point to first group             CR10 141
IGR=0#                                 Count groups                     CR10 142
WHILE(I6<MARK7)#                       Loop over the groups             CR10 143
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR10 144
IGR=IGR+1#                             Add up one group                 CR10 145
BUFOT(1)=FLOAT(IGR)#                   Group nr                         CR10 146
LINRM=12#                              12 lines on this page            CR10 147
ncodefld:(BUFOT,1,CR103,120213.,1)#    Encode group nr                  CR10 148
writeline:(1,CR103,NCR103,3,3)#        *** group nr ***                 CR10 149
IF(QX(I6+2)<1.5) NATGR=NINT(QX(I6+1))# Nr of atoms in group             CR10 150
ELSE#                                  In n-th idmol                    CR10 151
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR10 152
I6FRST=NINT(QX(I6+1))#                 Point to 1-st idmol              CR10 153
NATGR=NINT(QX(I6FRST+1))#              Nr of atoms in idmol             CR10 154
L6FRST=I6FRST+ISTEP6-NSTEP6#           Pointer to first atom            CR10 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR10 156
#                                                                       CR10 157
I1=I6+2#                               Pointer to euler param           CR10 158
DO I=1,2#                              Loop over coord./angles          CR10 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR10 160
DO J=1,3#                              Three coord./angles              CR10 161
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR10 162
I1=I1+1;BUFOT(J)=QX(I1)#               Euler param                      CR10 163
VAR=NINT(QX(I1+6))#                    Variable number                  CR10 164
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR10 165
#                                                                       CR10 166
IF(I==1) movechar:(CR107,1,CHROT,1,NCR107,0)# Center of gravity         CR10 167
ELSE ifne:(QX(I6+2),1.)#               Euler angles, group/nth idmol    CR10 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR10 169
movechar:(CR108,1,CHROT,1,NCR108,0)#   Euler angles                     CR10 170
DO J=1,3; BUFOT(J)=BUFOT(J)*RAD#       Angles in degrees                CR10 171
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR10 172
ELSE BREAK#                            First idmol                      CR10 173
ncodefld:(BUFOT,1,CHROT,FMT(5),3)#     Encode euler param               CR10 174
writeline:(1,0,0,1,3)#                 Print a line                     CR10 175
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR10 176
#                                                                       CR10 177
L6=I6+ISTEP6-NSTEP6#                   Set pointer to group atoms       CR10 178
writeline:(0,0,0,1,3)#                 One blank line                   CR10 179
LINRM=5#                               Force 5 line space               CR10 180
DO I=1,NATGR#                          Loop over the atoms              CR10 181
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR10 182
I2=I6+18#                              Point to euler matrix            CR10 183
L6=L6+NSTEP6#                          Point to next group atom         CR10 184
IF(QX(I6+2)>1.5) L6FRST=L6FRST+NSTEP6# Pointer to first molec           CR10 185
L5=NINT(QX(L6+1))#                     Pointer to atom in mark5 arr     CR10 186
movertoc:(QX(L5-name:),1,CHROT,2,24,0)# Move atom id                    CR10 187
LCHROT=LABMAX+4#                       Set format pointers              CR10 188
ncodefld:(QX(L6+3),1,CHROT,FMT1,3)#    Encode orth. coord.              CR10 189
DO J=1,3#                              Loop over the coordinates        CR10 190
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR10 191
I2=I2+3#                               Point to matrix elements         CR10 192
BUFOT(J)=QX(I2+1)*QX(L6+3)+QX(I2+2)*QX(L6+4)+QX(I2+3)*QX(L6+5)#         CR10 193
ifeq:(QX(I6+2),0.)#                    If group                         CR10 194
IF(QX(I6+2)<1.5)#                      Group or first idmol             CR10 195
movereal:(BUFOT,1,QX(L6+6),1,3,0)#     Save rotated coords              CR10 196
ncodefld:(BUFOT,1,CHROT,FMT1,3)#       Encode rotated coord.            CR10 197
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR10 198
writeline:(0,CR106,NCR106,1,3)#        Print an atom                    CR10 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR10 200
I6=L6+NSTEP6#                          Goto next group                  CR10 201
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR10 202
#                                                                       CR10 203
#         INDIVIDUAL ATOM PARAMETERS                                    CR10 204
#         --------------------------                                    CR10 205
#                                                                       CR10 206
LINRM=6#                               Force 5 lines space              CR10 207
writeline:(1,CR104,NCR104,3,1)#        Atom parameters                  CR10 208
writeline:(0,0,0,3,1)#                 One blank line                   CR10 209
CH=' '#                                Blank out the ch array           CR10 210
movechar:(CR109,1,CH,LABMAX+11,20,0)#  Atom x/a y/b z/c invariant       CR10 211
NCH=LABMAX+31;  PARTOT=3#              Nr of characters in ch           CR10 212
IF(REFTMP>=4)#                         Anisotropic dp present           CR10 213
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR10 214
movechar:(CR109,21,CH,NCH,54,0)#       U11 etc.                         CR10 215
NCH=NCH+54;     PARTOT=9#              Nr of charactres in ch           CR10 216
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR10 217
ELSE IF (REFTMP>0)#                    Isotropic dp present             CR10 218
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR10 219
CH(NCH+8^)='U'#                        Store the u header               CR10 220
NCH=NCH+8;     PARTOT=4#               Number of characters in          CR10 221
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR10 222
IF(POP>0)#                             Pop param is present             CR10 223
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR10 224
CH(NCH+5^)='POP';NCHP=NCH;NCH=NCH+9#   Store the pop header             CR10 225
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR10 226
#                                                                       CR10 227
L5=MARK5+incr:(name:)#                 Point to first atom              CR10 228
LCON=MARK10;nextconstr:(0)#            Point to first constraint        CR10 229
WHILE(L5<MARK6)#                       Loop over the atoms              CR10 230
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR10 231
movertoc:(QX(L5-name:),1,CHROT,2,24,0)# Atom id                         CR10 232
intunpak:(QX(L5+1),ATTYP,0,5)#         Get atom type nr                 CR10 233
intunpak:(QX(L5+1),NTMP,5,3)#          Get number of dp                 CR10 234
PARTOT=3+NTMP#                         Total nr of params               CR10 235
movereal:(QX(L5+2),1,BUFOT,1,PARTOT,0)# Transfer parameters             CR10 236
IF(NTMP==1) BUFOT(4)=BTOHU*BUFOT(4)#   Convert biso ->  uiso*100        CR10 237
ELSE IF(NTMP==6)#                      If anisotropic dp                CR10 238
DO I=1,6; BUFOT(I+3)=CELL(I+6)*BUFOT(I+3)# Convert betaij ->  uij       CR10 239
LCHROT=LABMAX+3#                       Set format pointers              CR10 240
ncodefld:(BUFOT,1,CHROT,FMT1,PARTOT)#  Encode atom parameters           CR10 241
IF(POP>0)#                             If pop param is there            CR10 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR10 243
LCHROT=NCHP#                           Adjust left char pnt             CR10 244
M=L5+5+NTMP#                           Point to pop param               CR10 245
ncodefld:(QX(M),1,CHROT,942.,1)#       Encode pop param                 CR10 246
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR10 247
#                                                                       CR10 248
REPEAT#                                Loop over constr/noref           CR10 249
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR10 250
IF(IABS(PCON)>=NINT(QX(L5))) BREAK#    No constr/noref                  CR10 251
PAR=IABS(PCON)-L5-1#                   Number of invar/constr param     CR10 252
L1=PAR;L2=PAR#                         Set pointer equal to param       CR10 253
IF(PCON<0)#                            Invariant param                  CR10 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR10 255
N=22#                                  Letter i(nvariant)               CR10 256
IF(IABS(PCON)==L5)#                    Noref all parameters             CR10 257
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR10 258
L1=1;L2=PARTOT+POP#                    Point to first and last para     CR10 259
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR10 260
nextconstr:(1)#                        Get pointer to next constr       CR10 261
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR10 262
ELSE#                                  Constraint                       CR10 263
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR10 264
IF(QX(LCON+2)<0.) N=34#                Normal constraint (c)            CR10 265
ELSE              N=48#                Group constraint (g)             CR10 266
nextconstr:(NINT(QX(LCON+3)))#         Set pointers to next constr      CR10 267
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR10 268
DO I=L1,L2#                            Put flag into output line        CR10 269
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR10 270
M=LABMAX+4+I*9#                        Point to output colm             CR10 271
IF(I<=PARTOT) CHROT(M^M) =CR101(N^N)#  Coord or disp.par.               CR10 272
ELSE          CHROT(NCH+1^)=CR101(N^N)# Pop param                       CR10 273
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR10 274
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR10 275
IF(POP==1&REFPOP==0) CHROT(NCH+1^)='I'# Flag invariant (i)              CR10 276
#                                                                       CR10 277
FOR(I7=MARK7;I7<MARK8;I7=I7+4+5*NATM)# Loop over restraints             CR10 278
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR10 279
NATM=NINT(QX(I7+2));L7=I7+2#           Nr of atoms; pnt to atoms        CR10 280
DO I=1,NATM#                           Loop over atoms in restraint     CR10 281
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR10 282
L7=L7+2#                               Incr pointer                     CR10 283
IF(NINT(QX(L7+1))==L5)#                If current atom restrained       CR10 284
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR10 285
L1=I7+4+2*NATM+(I-1)*3#                Point to variable nr             CR10 286
DO J=1,3#                              Loop over coord                  CR10 287
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR10 288
IF(QX(L1+J)>0.)#                       Not an invariant param           CR10 289
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR10 290
M=LABMAX+4+I*9#                        Point to output col              CR10 291
movechar:(CR101,56,CHROT,M,1,0)#       Insert letter r                  CR10 292
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR10 293
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR10 294
GOTO 100#                              Break from loop over restr.      CR10 295
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR10 296
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR10 297
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR10 298
100 CONTINUE#                                                           CR10 299
#                                                                       CR10 300
writeline:(0,CH,NCH,1,3)#              Print atom line                  CR10 301
L5=NINT(QX(L5))#                       Point to next atom               CR10 302
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR10 303
RETURN#                                                                 CR10 304
END#                                                                    CR10 305
systemheader:(CR20)#                   Read directory of lr 20          CR20   1
#                                       # Calc deriv. for groups        CR20   2
# ####################################################################  CR20   3
#                                                                       CR20   4
#                               CR20                                    CR20   5
#                                                                       CR20   6
# ####################################################################  CR20   7
SUBROUTINE CR20#                       R. olthof   august 1980          CR20   8
#                                      May 1985    april  1989          CR20   9
include:(AACOMN)#                                                       CR20  10
include:(CRCOMN)#                                                       CR20  11
#                                                                       CR20  12
REAL    AR(36)#     ## CELL(REC) * ROT.MATRIX                           CR20  13
REAL    COSPHI#     ## COS(PHI)                                         CR20  14
REAL    COSPSI#     ## COS(PSI)                                         CR20  15
REAL    COSTHE#     ## COS(THETA)                                       CR20  16
INTEGER EULPT#      ## POINTER TO EULER PARAM A                         CR20  17
INTEGER I,I3,J,J1,JUNK,L,L1,M,N,NN#                                     CR20  18
INTEGER IATGR#      ## COUNT OF ATOMS PER GROUP                         CR20  19
INTEGER I1,I2,I6,I6FRST#                                                CR20  20
INTEGER IP#         ## PACKET POINTER IN BDF PACKET                     CR20  21
INTEGER IWANT(98)#  ## RELATIVE POINTERS                                CR20  22
INTEGER L5,L6,L6FRST,L8,L10##                                           CR20  23
INTEGER NATGR#      ## NR OF ATOMS IN A GROUP                           CR20  24
INTEGER PACK#       ## PACK SIZE IN BDF PACKET                          CR20  25
INTEGER PAR#        ##                                                  CR20  26
INTEGER PCON#       ## CONSTRAINED PARAM                                CR20  27
REAL    PHI#        ## EULER ANGLE                                      CR20  28
REAL    PSI#        ## EULER ANGLE                                      CR20  29
REAL    R(9)#       ## ROTATION MATRIX                                  CR20  30
REAL    SINPHI#     ## SIN(PHI)                                         CR20  31
REAL    SINPSI#     ## SIN(PSI)                                         CR20  32
REAL    SINTHE#     ## SIN(THETA)                                       CR20  33
REAL    THETA#      ## EULER ANGLE                                      CR20  34
INTEGER VAR#        ## VAR NUMBER                                       CR20  35
chardata:(CR20E,"MemMax=NNNNNNN MemReq=NNNNNNN (Mtx=NNNNNNN Vec=N$#     CR20  36
NNNNN Der=NNNNNN Sym=NNNNNN)")#                                         CR20  37
realdata:(FMT,[140713.,290713.,420713.,530613.,640613.,750613.])#       CR20  38
datastuff:#                                                             CR20  39
#                                                                       CR20  40
#       PROCESS REFLECTION RECORD DIRECTORY                             CR20  41
#       -----------------------------------                             CR20  42
#                                                                       CR20  43
IF((ICYCLE==1)\(ICYCLE==NCYCLE))## FIRST OR LAST ACCESS                 CR20  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR20  45
M=1000*DATSET#                         Data set bias for idnums         CR20  46
IWANT(1)=1;IWANT(2)=2;IWANT(3)=3#      Indices,sin(t/l),mlt,equiv.      CR20  47
IWANT(4)=M+304-2*RFLTYP#               Relative f or f2 or i            CR20  48
IWANT(5)=IWANT(4)+1#                   Sigma(i or f2 or f)              CR20  49
IF(RFLTYP==3) IWANT(4)=800#            F(heavy)                         CR20  50
IWANT(6)=IWANT(4)+10#                  Friedel f or f2 or i             CR20  51
IWANT(7)=IWANT(5)+10#                  Sigma(i or f2 or f), friedel     CR20  52
IWANT(8)=M+897+IWT#                    Weight from bdf                  CR20  53
IWANT(9)=M+204#                        1/lp for refinement on i         CR20  54
IWANT(10)=M+308#                       Rcode                            CR20  55
IWANT(11)=IWANT(10)+10#                Rcode friedel                    CR20  56
IWANT(12)=IWANT(10)+1#                 Scale factor group               CR20  57
IWANT(13)=M+202#                       Exinction correction             CR20  58
IWANT(14)=M+200#                       Tbar                             CR20  59
IWANT(15)=M+201#                       Absorption corr.                 CR20  60
DO I=1,NATTYP; IWANT(I+15)=500+I#      Form factor idnums               CR20  61
NN=18;   N=NATTYP+NN+15#               Set counter for archiv list      CR20  62
#                                                                       CR20  63
IWANT(N+1)=M+800#                      Fcalc; excl. dispersion          CR20  64
IWANT(N+10)=-M-810#                    Same for part. struct.           CR20  65
DO I=2,7#                              Loop over 7 calc params          CR20  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR20  67
IWANT(N+I  )=-M-800-I+1#               Dnum of calc param               CR20  68
IWANT(N+I+9)=-M-810-I+1#               Same for partial values          CR20  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR20  70
IWANT(N+8)=-M-701#                     Rel. f, corrected for disp.      CR20  71
IWANT(N+9)= M+700#                     Calc sf phase                    CR20  72
DO I=1,2#                              Calculated struct.fact.          CR20  73
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR20  74
IF(ICENT==1)#                          If a-centric                     CR20  75
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR20  76
IWANT(N+2)=+M+801#                     Acalc  no-disp   idnum           CR20  77
IWANT(N+3)=+M+802#                     Bcalc  no-disp   idnum           CR20  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR20  79
IF(REFDSP>0 \ REFEXT>0)#               If dispersion or ext applied     CR20  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR20  81
IWANT(N+4)=+M+803#                     Acalc  disp-only idnum           CR20  82
IWANT(N+5)=+M+804#                     Bcalc  disp-only idnum           CR20  83
IWANT(N+6)=+M+805#                     Acalc  total-disp idnum          CR20  84
IWANT(N+7)=+M+806#                     Bcalc  total-disp idnum          CR20  85
IF(I==2) BREAK#                        If pass for partial contr.       CR20  86
IWANT(N+8)=+M+701#                     Frel   no-disp idnum             CR20  87
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR20  88
IF(PARTL==no:) BREAK#                  Exit if no partial fcalc         CR20  89
M=M+10;N=N+9#                          Incr. data set bias;iwant pn     CR20  90
IWANT(N+1)=+M+800#                     Fcalc for part. structure        CR20  91
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR20  92
IWANT(N+17)=IWANT(13)#                 Add extcor to output list        CR20  93
IWANT(N+18)=M+820#                     Add total corrected fc           CR20  94
DO I=1,NN; IWANT(N+I-NN)=IWANT(N+I)#   Move idnums to search list       CR20  95
#                                                                       CR20  96
SIGNAL(1)=4#                           Set search limits                CR20  97
IF(ICYCLE==1)#                         First cycle                      CR20  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR20  99
SIGNAL(2)=NATTYP+15;SIGNAL(3)=N;SIGNAL(4)=0# Update mode                CR20 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR20 101
ELSE#                                  Last cycle                       CR20 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR20 103
SIGNAL(2)=N; SIGNAL(3)=N+NN; SIGNAL(4)=1# Archiv mode                   CR20 104
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR20 105
IF(ICYCLE<NCYCLE) M=0#                 Not last cycle, output=0         CR20 106
ELSE              M=2#                 Last cycle, output=2             CR20 107
indexpkt:(1,lrrefl:,PACK,IP,M,SIGNAL,IWANT,REL)# Directory of lrrefl:   CR20 108
IF(SIGNAL(4)<0) iquit:(CR2001)#        Item missing in lrrefl:          CR20 109
IF(IWT==2) REL(8)=REL(5)#              Swap sigma for weight            CR20 110
#                                                                       CR20 111
## INITIALIZATION FOR CR21                                              CR20 112
#                                                                       CR20 113
IF(ICYCLE==1)#                         First cycle                      CR20 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR20 115
IF(IP<=0) iquit:(CR2001)#              Lrrefl: is not there             CR20 116
IF((IWT==2\TYPELT>0.)&REL(5)==0) iquit:(CR2002)# Sigma( ) is missing    CR20 117
IF((IWT>2)&(REL(8)==0)) iquit:(CR2003)# Weight is missing               CR20 118
IF((RFLTYP==2)&(REL(9)==0)) iquit:(CR2004)# 1/lp is missing             CR20 119
IF(PARTL==1 & REL(NATTYP+16)<=0) iquit:(CR2006)# No part.contr.         CR20 120
IF(REFABS>0 & REL(6)<=0) iquit:(CR2007)# Friedel data not in pkt        CR20 121
#                                                                       CR20 122
## SET UP STORE REQUIREMENTS                                            CR20 123
#                                                                       CR20 124
IF(ICENT==0 & REFDSP==0) IMAGP=1#      Real parts only                  CR20 125
ELSE IF(REFABS==0)       IMAGP=2#      Set for imaginary part           CR20 126
ELSE                     IMAGP=4#      Idem + friedels                  CR20 127
N=0#                                   Set word counter                 CR20 128
FOR(L8=MARK8+2;L8<MARK9;L8=L8+2)#      Loop over block data             CR20 129
N=N+QX(L8)*QX(L8+1)*(QX(L8+1)+1)/2#    Count length                     CR20 130
MARK12=MARK11+N#                       Set mark12: end of matrix        CR20 131
MARK13=MARK12+VARTOT+2#                Set mark13: end of vector        CR20 132
MARK14=MARK13+IMAGP*VARTOT#            Set mark14:end of deriv. arr     CR20 133
IF(REFTMP>3) M=10#                     If anisotr. tf nr of par=10      CR20 134
ELSE M=4#                              Else nr of par=4                 CR20 135
MARK15=MARK14+MAX0(6,(NATTYP+M*NSYM))# Set mark15                       CR20 136
IF(MARK15>QXMAX)#                      Pretest for memory limit         CR20 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR20 138
BUFOT(1)=FLOAT(QXMAX)#                 Current max memory               CR20 139
BUFOT(2)=FLOAT(MARK15)#                Memory request                   CR20 140
BUFOT(3)=FLOAT(N)#                     Matrix                           CR20 141
BUFOT(4)=FLOAT(VARTOT+2)#              Vector                           CR20 142
BUFOT(5)=FLOAT(IMAGP*VARTOT)#          Derivative array                 CR20 143
BUFOT(6)=FLOAT(MARK15-MARK14)#         Symmetry                         CR20 144
ncodefld:(BUFOT,1,CR20E,FMT,6)#        Format message                   CR20 145
writeline:(2,CR20E,NCR20E,3,3)#        Print error message              CR20 146
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR20 147
incrqx:(JUNK,MARK15,CR2020)#           C                                CR20 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR20 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR20 150
N=MARK15-MARK11#                       Total length of elements         CR20 151
movereal:(0.,1,QX,MARK11+1,N,2)#       Zero mark11-mark15 area          CR20 152
#                                                                       CR20 153
#         CALCULATIONS FOR GROUP REFINEMENT                             CR20 154
#         ---------------------------------                             CR20 155
#                                                                       CR20 156
I6=MARK6#                              Start of group array             CR20 157
L10=MARK10-1;N=1#                      Start of constr array            CR20 158
WHILE(I6<MARK7)#                       Loop over the groups             CR20 159
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR20 160
L6=I6+ISTEP6-NSTEP6#                   Pointer to  coords               CR20 161
IF(QX(I6+2)<1.5)#                      If group/1st molec               CR20 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR20 163
NATGR=NINT(QX(I6+1))#                  Nr of atoms                      CR20 164
L1=L6+5#                               Pointer for derivatives          CR20 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR20 166
ELSE#                                  N-th idmol                       CR20 167
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR20 168
I6FRST=NINT(QX(I6+1))#                 Pointer in 1st mol               CR20 169
NATGR=NINT(QX(I6FRST+1))#              Nr of atoms in idmols            CR20 170
L6FRST=I6FRST+ISTEP6-NSTEP6#           Pointer to 1st mol               CR20 171
L1=L6FRST+2#                           Pointer for derivatives          CR20 172
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR20 173
ifeq:(QX(I6+2),1.)#                    If first idmol                   CR20 174
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR20 175
I6=I6+ISTEP6+NATGR*NSTEP6;NEXT#        Point to next group              CR20 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR20 177
#                                                                       CR20 178
##  CALCULATE DERIVATIVES                                               CR20 179
#                                                                       CR20 180
PHI=QX(I6+6)#                          Euler angle phi                  CR20 181
THETA=QX(I6+7)#                        Euler angle theta                CR20 182
PSI=QX(I6+8)#                          Euler angle psi                  CR20 183
COSPHI=COS(PHI);SINPHI=SIN(PHI)#                                        CR20 184
COSTHE=COS(THETA);SINTHE=SIN(THETA)#                                    CR20 185
COSPSI=COS(PSI);SINPSI=SIN(PSI)#                                        CR20 186
#                                                                       CR20 187
L=0#                                   Pointer in product array ar      CR20 188
DO I=1,3#                              Loop over euler angles           CR20 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR20 190
IF(I==1)#                              D(r)/d(phi)                      CR20 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR20 192
R(1)=-COSPSI*SINPHI-SINPSI*COSTHE*COSPHI#                               CR20 193
R(2)= SINPSI*SINPHI-COSPSI*COSTHE*COSPHI#                               CR20 194
R(3)= SINTHE*COSPHI#                                                    CR20 195
R(4)= COSPSI*COSPHI-SINPSI*COSTHE*SINPHI#                               CR20 196
R(5)=-SINPSI*COSPHI-COSPSI*COSTHE*SINPHI#                               CR20 197
R(6)= SINTHE*SINPHI#                                                    CR20 198
R(7)= 0.#                                                               CR20 199
R(8)= 0.#                                                               CR20 200
R(9)= 0.#                                                               CR20 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR20 202
ELSE IF(I==2)#                         D(r)/d(theta)                    CR20 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR20 204
R(1)= SINPSI*SINTHE*SINPHI#                                             CR20 205
R(2)= COSPSI*SINTHE*SINPHI#                                             CR20 206
R(3)= COSTHE*SINPHI#                                                    CR20 207
R(4)=-SINPSI*SINTHE*COSPHI#                                             CR20 208
R(5)=-COSPSI*SINTHE*COSPHI#                                             CR20 209
R(6)=-COSTHE*COSPHI#                                                    CR20 210
R(7)= SINPSI*COSTHE#                                                    CR20 211
R(8)= COSPSI*COSTHE#                                                    CR20 212
R(9)=-SINTHE#                                                           CR20 213
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR20 214
ELSE#                                  D(r)/d(psi)                      CR20 215
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR20 216
R(1)=-SINPSI*COSPHI-COSPSI*COSTHE*SINPHI#                               CR20 217
R(2)=-COSPSI*COSPHI+SINPSI*COSTHE*SINPHI#                               CR20 218
R(3)= 0.#                                                               CR20 219
R(4)=-SINPSI*SINPHI+COSPSI*COSTHE*COSPHI#                               CR20 220
R(5)=-COSPSI*SINPHI-SINPSI*COSTHE*COSPHI#                               CR20 221
R(6)= 0.#                                                               CR20 222
R(7)= COSPSI*SINTHE#                                                    CR20 223
R(8)=-SINPSI*SINTHE#                                                    CR20 224
R(9)= 0.#                                                               CR20 225
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR20 226
#                                                                       CR20 227
## CALCULATE CELL(RECIPR.) * DERIVATIVE                                 CR20 228
#                                                                       CR20 229
I2=-3#                                 Point to deriv.matrix el.        CR20 230
DO J=1,3#                              Loop for first sum               CR20 231
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR20 232
I1=20;I2=I2+3#                         Point to rec.cell el.            CR20 233
DO J1=1,3#                             Loop for second sum              CR20 234
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR20 235
L=L+1;I1=I1+1#                         Incr pointers                    CR20 236
AR(L)=CELL(I1+1)*R(I2+1)+CELL(I1+4)*R(I2+2)+CELL(I1+7)*R(I2+3)# Vect.   CR20 237
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR20 238
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR20 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR20 240
#                                                                       CR20 241
IF(QX(I6+2)>1.)#                       If nth mol                       CR20 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR20 243
I2=I6+18;I3=0#                         Point to euler matr.el.          CR20 244
DO J=1,3#                              Loop for first sum               CR20 245
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR20 246
I1=20;I2=I2+3#                         Point to rec.cell el.            CR20 247
DO J1=1,3#                             Loop for second sum              CR20 248
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR20 249
I1=I1+1;I3=I3+1#                                                        CR20 250
R(I3)=CELL(I1+1)*QX(I2+1)+CELL(I1+4)*QX(I2+2)+CELL(I1+7)*QX(I2+3)#      CR20 251
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR20 252
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR20 253
I2=9#                                  Point to cell el.                CR20 254
DO J=1,3#                              Loop for first sum               CR20 255
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR20 256
I1=-1;I2=I2+3#                         Point to prod. matrix el.        CR20 257
DO J1=1,3#                             Loop for second sum              CR20 258
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR20 259
L=L+1;I1=I1+1#                                                          CR20 260
AR(L)=R(I1+1)*CELL(I2+1)+R(I1+4)*CELL(I2+2)+R(I1+7)*CELL(I2+3)#         CR20 261
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR20 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR20 263
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR20 264
#                                                                       CR20 265
## CALCULATE NEW FACTORS FOR GROUP CONSTRAINTS,                         CR20 266
## DEPENDENT ON EULER ANGLES                                            CR20 267
#                                                                       CR20 268
DO IATGR=1,NATGR#                      Loop over the group atoms        CR20 269
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR20 270
L6=L6+NSTEP6#                          Point to next atom               CR20 271
L5=NINT(QX(L6+1))#                     Point to atom in mark5-array     CR20 272
L1=L1+NSTEP6#                          Pointer for derivatives          CR20 273
FOR(L10=L10+N;L10<MARK11-1;L10=L10+N)# Loop over constraints            CR20 274
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR20 275
N=1#                                   Nr of items in invariants        CR20 276
PCON=NINT(QX(L10+1))#                  Pointer to constr/invar para     CR20 277
IF(PCON<0)  NEXT#                      Invariant param                  CR20 278
N=NINT(QX(L10+3))#                     Number of items in constr        CR20 279
PAR=PCON-L5-1#                         Param number                     CR20 280
IF((PAR<0)\(PAR>3)) NEXT#              Not x, y or z of curren          CR20 281
L=L10+4#                               Pointer in constr array          CR20 282
EULPT=I6+12#                           Pointer to phi-flag              CR20 283
DO J=1,3#                              Loop over euler angles           CR20 284
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR20 285
IF(QX(EULPT)>0.)#                      Euler angle is variable          CR20 286
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR20 287
VAR=NINT(QX(EULPT))#                   Var number of euler angle        CR20 288
WHILE(NINT(QX(L+1))!=VAR) L=L+2#       Search for corresp. var nr       CR20 289
I2=(J-1)*9+PAR-1#                      Pointer in ar array              CR20 290
QX(L+2)=AR(I2+1)*QX(L1+1)+AR(I2+4)*QX(L1+2)+AR(I2+7)*QX(L1+3)# Factor   CR20 291
L=L+2#                                 Goto next subset                 CR20 292
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR20 293
EULPT=EULPT+1#                         Goto next euler param            CR20 294
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR20 295
IF(L>L10+4 & L<L10+N)#                 If more constraints              CR20 296
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR20 297
I2=26+PAR#                             Pointer in o-1 * q * o           CR20 298
DO I=1,9,3#                            Loop over indiv. atom coords     CR20 299
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR20 300
QX(L+2)=AR(I2+I);L=L+2#                                                 CR20 301
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR20 302
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR20 303
IF(PAR>=3) BREAK#                      Go to next atom after z para     CR20 304
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR20 305
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR20 306
I6=L6+NSTEP6#                          Goto next group                  CR20 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR20 308
#                                                                       CR20 309
RETURN#                                                                 CR20 310
END#                                                                    CR20 311
systemheader:(CR21)#                   Calculation of sf and deriv.     CR21   1
# ####################################################################  CR21   2
#                                                                       CR21   3
#                               CR21                                    CR21   4
#                                                                       CR21   5
# ####################################################################  CR21   6
SUBROUTINE CR21#                       R. olthof   august 1980          CR21   7
#                                      May 1985    april  1989          CR21   8
include:(AACOMN)#                                                       CR21   9
include:(CRCOMN)#                                                       CR21  10
#                                                                       CR21  11
REAL    AA(4)#     ## STRUCTURE FACTOR COMPONENTS/ATOM                  CR21  12
REAL    A,B,C,D#   ## STRUCTURE FACTOR COMPONENTS                       CR21  13
REAL    AH,AK,AL#  ## LOCAL H, K, L                                     CR21  14
REAL    ADIS,ANTID,AREFD#                                               CR21  15
REAL    BDIS,BNTID,BREFD#                                               CR21  16
INTEGER ATTYP#     ## ATOM TYPE NUMBER                                  CR21  17
REAL    BH,BK,BL#  ## EQUIVALENT H, K, L                                CR21  18
INTEGER BUILD#     ## CODE FOR MATRIX CONTRIBUTOR                       CR21  19
REAL    CA(4)#     ## MULTIPLICATION FACTORS FOR DERIVATIVES            CR21  20
REAL    CALC#      ## CALCULATED F OR F2 OR I                           CR21  21
REAL    COS2P#     ## COS(2PI*(HX+KY+LZ))                               CR21  22
REAL    DA(4)#     ## DERIVATIVE COMPONENTS/ATOM                        CR21  23
REAL    D1,D2#     ## DERIVATIVE COMPONENTS                             CR21  24
REAL    DELA(9),DELB(9)## Derivative components                         CR21  25
REAL    DELTA#     ## OBS - ABS(CALC)                                   CR21  26
REAL    DERFAC#    ## FACTOR, USED IN DERIVATIVE CALCULATIONS           CR21  27
REAL    DEREXT#    ## PART OF THE DERIVATIVE FOR EXTINCTION CORR.       CR21  28
REAL    DERSKF#    ## FACTOR FOR DERIVATIVE SKF                         CR21  29
REAL    DERTMP#    ## FACTOR FOR DERIVATIVE OF UOV AND BISO             CR21  30
REAL    DFC#       ## DERIVATIVE OF ABS.STRUCT.PARAM                    CR21  31
REAL    EFLACK#    ##                                                   CR21  32
REAL    EXTCOR#    ## EXTINCTION CORRECTION FACTOR                      CR21  33
REAL    FA(6)#     ## STRUCTURE FACTOR COMP.                            CR21  34
REAL    FACT#      ## MULTIPLICATION FACTOR                             CR21  35
REAL    FACT2#     ## MULTIPLICATION FACTOR, INCLUDING IMAG.SCATT.FAC   CR21  36
REAL    FACT1#     ## MULTIPLICATION FACTOR, INCLUDING REAL SCATT.FAC   CR21  37
REAL    FCAL#      ## CALCULATED FOBS                                   CR21  38
REAL    FCT#       ## FACTOR IN CONSTRAINT EQUATIONS                    CR21  39
REAL    FC2#       ## CALCULATED F2                                     CR21  40
REAL    FCFR2#     ## CALCULATED F2 FOR FRIEDEL RELATED REFLECTION      CR21  41
REAL    FCND#      ## CALCULATED F, NO DISPERSION                       CR21  42
REAL    FDEL#      ## CALCULATED F DIFFERENCE                           CR21  43
REAL    FOBS#      ## CALCULATED FOBS                                   CR21  44
REAL    FO2#       ## OBSERVED F2                                       CR21  45
REAL    FO2NE#     ## OBSERVED F2, EXTINCTION REMOVED                   CR21  46
REAL    FOND#      ## OBSERVED F, NO DISPERSION                         CR21  47
REAL    H(3)#      ## REFLECTION INDICES                                CR21  48
REAL    WFRDL#     ##                                                   CR21  49
INTEGER I,J,K,L,LPP,LPPSV,M,N,P#                                        CR21  50
INTEGER IP,IPP#    ## PACKET POINTER IN INPUT AND OUTPUT BUFFER         CR21  51
INTEGER IFRDL#     ## COUNTER IN LOOP OVER FRIEDEL PAIRS                CR21  52
INTEGER ISKF#      ## SCALE GROUP NUMBER                                CR21  53
INTEGER ISKIP#     ## COUNT OF SKIPPED REFLECTIONS                      CR21  54
INTEGER L0,L2,L3#  ## POINTERS IN MARK ARRAYS                           CR21  55
INTEGER L5,L5P,L5M## POINTER IN MARK5 ARRAY* TO ATOM, POP, MULT         CR21  56
INTEGER L8,L9,L11,L12,L13,L14## Pointers in mark arrays                 CR21  57
INTEGER L13DSP,L13UOV## Pointer to derivatives of disp & uov            CR21  58
INTEGER LCON#      ## POINTER IN CONTRAINT ARRAY                        CR21  59
INTEGER LT#        ## LESS-THAN FLAG                                    CR21  60
INTEGER MAXH,MAXK,MAXL## MAXIMUM VALUES OF H,K,L                        CR21  61
INTEGER MAXHKL#    ## SEARCH FLAG FOR MAXHKL ETC.                       CR21  62
INTEGER NBLK#      ## NUMBER OF BLOCKS                                  CR21  63
INTEGER NFRDL#     ## NR OF CYCLES IN LOOPOVER FRIEDEL PAIRS            CR21  64
INTEGER NTMP#      ## NUMBER OF TF                                      CR21  65
INTEGER N1,N2#     ## NUMBER OF ITEMS IN CONSTRAINT INFO SET            CR21  66
INTEGER N9#        ## VARIABLE NR IN USER DEFINED BLOCKS                CR21  67
REAL    OBS#       ## OBSERVED F OR F2 OR I (ON SCALE OF CALC)          CR21  68
INTEGER PACK#      ## PACK SIZE OF LRREFL:                              CR21  69
INTEGER PAR#       ## NUMBER OF PARAMETERS: COORD. + ANISOTR.TEMP.FAC   CR21  70
INTEGER PARTOT#    ## TOTAL NUMBER OF PARAMETERS                        CR21  71
INTEGER PCON#      ## CONSTRAINED PARAM                                 CR21  72
REAL    PHI#       ## PHASE IN CYCLES                                   CR21  73
REAL    Q#         ## TEMP. VARIABLE                                    CR21  74
INTEGER RCODE#     ## REFLECTION STATUS KEY                             CR21  75
INTEGER REF#       ## REFINEMENT FLAG                                   CR21  76
INTEGER REL1,REL2,REL3,REL4,REL5## IREL POINTERS                        CR21  77
INTEGER REL6,REL7,REL8,REL9,REL10,REL11,REL12#                          CR21  78
REAL    S#         ## SIGN OF FCALC                                     CR21  79
REAL    SIN2P#     ## SIN(2PI*(HX+KY+LZ))                               CR21  80
REAL    SIGMA#     ## SIGMA(F OR F2 OR I)                               CR21  81
REAL    SKF#       ## RECIPROCAL SCALE FACTOR                           CR21  82
REAL    SMIN,SMAX# ## SINTH/L MINIMUM AND MAXIMUM                       CR21  83
INTEGER STEP13#    ## TOTAL LENGTH OF MARK13-ARRAY                      CR21  84
INTEGER STOP13#    ## END OF FINAL DERIV PART OF MARK13 ARRAY           CR21  85
INTEGER STEP14#    ## STEPSIZE IN MARK14                                CR21  86
INTEGER STOP14#    ## END OF MARK14 ARRAY                               CR21  87
REAL    STOL#      ## SIN(THETA/LAMBDA)                                 CR21  88
REAL    STOLSQ#    ## SIN(THETA/LAMBDA) SQARE                           CR21  89
REAL    SUMCOS,SUMSIN## SUM(COS2P) AND SUM(SINSP)                       CR21  90
INTEGER VARBLK#    ## NUMBER OF VARIABLES/BLOCK                         CR21  91
REAL    WEIGHT#    ## SQRT(WEIGHT)                                      CR21  92
SAVE DEREXT,DERFAC,DERSKF,DERTMP,PCON#                                  CR21  93
#                                                                       CR21  94
chardata:(CR211,    H   K   L  ST/L RC SG   OBS    CALC     $#          CR21  95
CALCA   CALCB EXTF    FONO    FCNO PHI  DELTA   WW*D SIGMA)#            CR21  96
chardata:(CR212, FF2 I)#                                                CR21  97
realdata:(TWOPI,6.28318531)#           2 * pi                           CR21  98
realdata:(FORM,[50413.,90413.,130413.,190642.,$#                        CR21  99
210203.,250203.,330822.,410822.,490822.,570822.,$#                      CR21 100
620422.,700822.,780822.,820413.,890722.,960722.,1020622.])#             CR21 101
datastuff:#                                                             CR21 102
#                                                                       CR21 103
#       SET RELATIVE POINTERS, INITIALIZATION                           CR21 104
#                                                                       CR21 105
REL1=REL(1);REL2=REL(2)#               Store hkl & st/l pointers        CR21 106
REL3=REL(3);REL4=REL(4)#               Store mul & frel pointers        CR21 107
REL5=REL(5);REL6=REL(6)#               Store sig & friedel pointers     CR21 108
REL7=REL(7);REL8=REL(8)#               Store sig(fr) & weight p.        CR21 109
REL9=REL(9);REL10=REL(10)#             Store rlp & rcode pointers       CR21 110
REL11=REL(11);REL12=REL(12)#           Store rcode (frdl) & slg         CR21 111
ISKF=NINT(QX(MARK3+2));SKF=1./QX(MARK3+1)# Default sgn and 1/scale      CR21 112
IF(RFLTYP>0) SKF=SKF*SKF#              If f2 or i                       CR21 113
WEIGHT=1.;SIGMA=.1;RCODE=1;EXTCOR=1.#  Defaults                         CR21 114
FCFR2=0.#                              Zero fc friedel value            CR21 115
NFRDL=1;IF(REFABS>0) NFRDL=2#          Nr of c. in loop over friedels   CR21 116
#                                                                       CR21 117
IF(QX(MARK4+21)<0.) MAXHKL=no:#        If no maxhkl* set search         CR21 118
ELSE#                                  Maxhkl & st/l are present        CR21 119
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR21 120
MAXHKL=yes:#                           Set search hkl on                CR21 121
MAXH=NINT(QX(MARK4+16));MAXK=NINT(QX(MARK4+17))# Max h and k            CR21 122
MAXL=NINT(QX(MARK4+18))#               Max l                            CR21 123
SMIN=QX(MARK4+19);SMAX=QX(MARK4+20)#   Min and max st/l                 CR21 124
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR21 125
#                                                                       CR21 126
STEP13=VARTOT*IMAGP;STOP13=MARK13+VARTOT# Max. length of deriv. array   CR21 127
IF(REFUOV!=0) L13UOV=MARK13+REFSKF+1;ELSE L13UOV=0# Point to uov deri   CR21 128
L13DSP=MARK13+REFSKF+IABS(REFUOV)+1#                                    CR21 129
IF(REFABS==2) L13DSP=L13DSP+1#                                          CR21 130
IF(REFEXT==2)#                         Pointer to dispersion de         CR21 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR21 132
IF     (EXTTYP<=2) L13DSP=L13DSP+1#    1 ext. variable                  CR21 133
ELSE IF(EXTTYP==3) L13DSP=L13DSP+2#    2 ext. variables                 CR21 134
ELSE IF(EXTTYP<=5) L13DSP=L13DSP+6#    6 ext. variables                 CR21 135
ELSE               L13DSP=L13DSP+12#   12 ext. variables                CR21 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR21 137
#                                                                       CR21 138
IF(RADTYP==2)#                         Neutron radiation scattered      CR21 139
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR21 140
L2=MARK2+5#                            Point to neutron sf              CR21 141
FOR(L14=MARK14+1;L14<=MARK14+NATTYP;L14=L14+1)# Loop over atom types    CR21 142
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR21 143
QX(L14)=QX(L2) ; L2=L2+NSTEP2#         Store sf ; increment pointer     CR21 144
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR21 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR21 146
IF(REFTMP<4) STEP14=4#                 Step size if not anisotr. tf     CR21 147
ELSE         STEP14=10#                Step size if anisotr. tf         CR21 148
STOP14=MARK14+NATTYP+NSYM*STEP14#      Last pos. in mark14 array        CR21 149
#                                                                       CR21 150
ISKIP=0#                               Set reflection skip count        CR21 151
movereal:(0.,1,RSUMS, 1,60,2)#         Used for statistics              CR21 152
writeline:(0,0,0,1,3)#                 Add one blank line               CR21 153
LINRM=5#                               At least 5 lines for refl.ta     CR21 154
I=2*RFLTYP+1#                          Point to character               CR21 155
movechar:(CR212,I,CR211,32,2,0)#       Move f or f2 or i into head      CR21 156
movechar:(CR212,I,CR211,40,2,0)#       Idem                             CR21 157
IF(REFEXT>0) CALL CR22(0,0,0.)#        Initialize ext. calc.            CR21 158
#                                                                       CR21 159
#       LOOP OVER THE REFLECTIONS                                       CR21 160
#       -------------------------                                       CR21 161
#                                                                       CR21 162
REPEAT#                                Reflection loop                  CR21 163
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR21 164
readwpkt:(1,lrrefl:,PACK,IP,0)#        Read reflection packet           CR21 165
IF(IP==0) BREAK#                       End of lrrefl:                   CR21 166
#                                                                       CR21 167
IF(ICYCLE==NCYCLE)#                    Last cycle/2-buffer mode         CR21 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR21 169
writepkt:(2,lrrefl:,SIGNAL(4),IPP)#    Init. next output packe          CR21 170
K=SIGNAL(2)+1;   LPP=IPP+1#            Start output buffer              CR21 171
DO I=1,SIGNAL(4); QX(IPP+I)=voidflg:#  Set all void 4 absent friedel^   CR21 172
DO I=1,PACK#                           Loop over input packet           CR21 173
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR21 174
movepakwd:(QX(IP+I),QX(LPP))#          Move word                        CR21 175
IF(REL(K)==I) K=K+1#                   Deleted item                     CR21 176
ELSE          LPP=LPP+1#               Non-delete item                  CR21 177
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR21 178
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR21 179
ELSE IPP=IP#                           Point to output buffer           CR21 180
#                                                                       CR21 181
BUILD=yes:#                            Assume ref to go to matrix       CR21 182
ISKIP=ISKIP+1#                         Count reflection                 CR21 183
IF(ISKIP!=NSKIP) BUILD=no:#            Skip this reflection             CR21 184
ELSE ISKIP=0#                          Reset skip counter               CR21 185
#                                                                       CR21 186
IF(REL10>0)#                           Test if rcode on bdf             CR21 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR21 188
RCODE=NINT(QX(IP+REL10))#              Get rcode                        CR21 189
IF(RCODE>3 & REFABS==0) NEXT#          Skip reflection                  CR21 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR21 191
#                                                                       CR21 192
gethkl:(IP+REL1,H)#                    Extract h, k, l                  CR21 193
STOL=QX(IP+REL2)#                      Get st/l                         CR21 194
IF(MAXHKL==yes:)#                      Check /hkl/ and sin(th)          CR21 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR21 196
IF(ABS(H(1))>MAXH) BUILD=no:#          H out of bounds                  CR21 197
IF(ABS(H(2))>MAXK) BUILD=no:#          K out of bounds  1910=#          CR21 198
IF(ABS(H(3))>MAXL) BUILD=no:#          L out of bounds                  CR21 199
IF(STOL<SMIN) BUILD=no:#               St/l out of bounds               CR21 200
IF(STOL>SMAX) BUILD=no:#               St/l out of bounds               CR21 201
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR21 202
IF((BUILD==no:)&(ICYCLE<NCYCLE)) NEXT# Skip this refl                   CR21 203
AH=H(1);AK=H(2);AL=H(3)#               Store hkl as real variables      CR21 204
STOLSQ=STOL*STOL#                      St/l **2                         CR21 205
#                                                                       CR21 206
IF(REL12>0)#                           If scale group on bdf            CR21 207
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR21 208
ISKF=NINT(QX(IP+REL12))#               Get scale group number           CR21 209
FOR(L3=MARK3;L3<MARK4;L3=L3+2)#        Loop over scale groups           CR21 210
IF(ISKF==NINT(QX(L3+2))) BREAK#        Exit if match found              CR21 211
SKF=1.0/QX(L3+1)#                      Change frel to fc scale          CR21 212
IF(RFLTYP>0) SKF=SKF*SKF#              For refinement on f2 or i        CR21 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR21 214
#                                                                       CR21 215
IF(IWT>1)#                             Weight is i/sig or bdf w         CR21 216
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR21 217
IF(QX(IP+REL8)>0.0) WEIGHT=QX(IP+REL8)# Extract weight from bdf         CR21 218
ELSE          WEIGHT=1.0#              Or default to one                CR21 219
IF(IWT==2)    WEIGHT=SKF/WEIGHT#       Take recip of sigma              CR21 220
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR21 221
#                                                                       CR21 222
IF(RADTYP==1)#                         Xray scattering?                 CR21 223
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR21 224
L2=MARK2+5;L14=MARK14+1#               Point to sf tables               CR21 225
DO I=1,NATTYP#                         Loop over form factors           CR21 226
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR21 227
IF(REL(I+15)>0) M=IP+REL(I+15)#        Get sf from bdf                  CR21 228
ELSE M=L2+NINT(STOL/DSFTB)#            Get sf from tables               CR21 229
QX(L14)=QX(M)#                         Sf for this reflection           CR21 230
L2=L2+NSTEP2;L14=L14+1#                Advance pointers                 CR21 231
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR21 232
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR21 233
#                                                                       CR21 234
## LOOP OVER SYMMETRY MATRICES                                          CR21 235
#                                                                       CR21 236
L14=MARK14+NATTYP-STEP14#              Set up for symmetry              CR21 237
FOR(L0=MARK0;L0<STOP0;L0=L0+12)#       Loop over symm. matrices         CR21 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR21 239
L14=L14+STEP14#                        Advance pointer                  CR21 240
BH=AH*QX(L0+1)+AK*QX(L0+2)+AL*QX(L0+3)# Equivalent h                    CR21 241
BK=AH*QX(L0+4)+AK*QX(L0+5)+AL*QX(L0+6)# Equivalent k                    CR21 242
BL=AH*QX(L0+7)+AK*QX(L0+8)+AL*QX(L0+9)# Equivalent l                    CR21 243
QX(L14+1)=TWOPI*BH;QX(L14+2)=TWOPI*BK;QX(L14+3)=TWOPI*BL# Store twopi   CR21 244
QX(L14+4)=TWOPI*(AH*QX(L0+10)+AK*QX(L0+11)+AL*QX(L0+12))# Phase shift   CR21 245
IF(REFTMP<=3) NEXT#                    If no anisotropic tf             CR21 246
QX(L14+5)=BH*BH#                       Store new h**2                   CR21 247
QX(L14+6)=BK*BK#                       Store new k**2                   CR21 248
QX(L14+7)=BL*BL#                       Store new l**2                   CR21 249
QX(L14+8)=2.*BH*BK#                    Store new 2*h*k                  CR21 250
QX(L14+9)=2.*BH*BL#                    Store new 2*h*l                  CR21 251
QX(L14+10)=2.*BK*BL#                   Store new 2*k*l                  CR21 252
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR21 253
#                                                                       CR21 254
## INITIALIZE SUMS AND POINTERS                                         CR21 255
#                                                                       CR21 256
DO I=1,6;FA(I)=0.#                     Zero fc components               CR21 257
IF(PARTL>0)#                           Apply partial contribution       CR21 258
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR21 259
S=1.#                                  Sign of fcalc                    CR21 260
IF(PARTL==2)#                          If establish flag on             CR21 261
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR21 262
M=IP+REL(NATTYP+24)#                   Point to phi                     CR21 263
IF(QX(M)>.1) S=-1.#                    Negative fcalc, if centro        CR21 264
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR21 265
N=SIGNAL(3)#                           Point to partial output          CR21 266
eapply:(1,FA(5))#                      Abs(fcalc)                       CR21 267
IF(ICENT==0)#                          Centric                          CR21 268
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR21 269
IF(PARTL==2) FA(5)=S*FA(5)#            Establish from 1800; with si     CR21 270
IF(ICYCLE==NCYCLE) QX(M)=FA(5)#        Partial fcalc in last cycle      CR21 271
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR21 272
ELSE#                                  A-centric                        CR21 273
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR21 274
eapply:(2,FA(5));eapply:(3,FA(6))#     Fa and fb; no-disp               CR21 275
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR21 276
FA(1)=FA(5);FA(2)=FA(6)#               Total fa & fb equal to no-di     CR21 277
IF(REFDSP>0)#                          Dispersion applied               CR21 278
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR21 279
eapply:(4,ADIS);eapply:(5,BDIS)#       Disp terms                       CR21 280
eapply:(6,FA(1));eapply:(7,FA(2))#     Total fa and fb                  CR21 281
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR21 282
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR21 283
#                                                                       CR21 284
IF(ICYCLE!=NCYCLE)#                    If not last cycle                CR21 285
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR21 286
movereal:(0.,1,QX,MARK13+1,STEP13,2)#  Zero derivative array            CR21 287
L9=MARK9+1;N9=NINT(QX(L9))#            Point to user def. block inf     CR21 288
LCON=MARK10;nextconstr:(0)#            Point to constraint array        CR21 289
L13=MARK13+VARGEN#                     Point to derivative sum          CR21 290
DERFAC=WEIGHT#                         Multiplic.factor for deriv       CR21 291
IF(RFLTYP>0) DERFAC=2.*DERFAC#         Deriv. factor for f2             CR21 292
DERSKF=DERFAC#                         Set deriv. scale factor          CR21 293
IF(RFLTYP==2) DERFAC=DERFAC/QX(IP+REL9)# Deriv. factor for i            CR21 294
DERTMP=-STOLSQ/CELL(1)*DERFAC#         For tf derivative                CR21 295
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR21 296
#                                                                       CR21 297
## LOOP OVER THE ATOMS                                                  CR21 298
#                                                                       CR21 299
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Atom loop          CR21 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR21 301
intunpak:(QX(L5+1),ATTYP,0,5)#         Fetch back at.type               CR21 302
intunpak:(QX(L5+1),NTMP,5,3)#          And number of tf                 CR21 303
IF(NTMP<=1) PAR=3#                     X,y,z                            CR21 304
ELSE        PAR=9#                     X,y,z and anisotropic u's        CR21 305
L5P=L5+5+NTMP;L5M=L5P+POP#             Point to pop param & atom mu     CR21 306
PARTOT=3+NTMP+REFPOP#                  Total nr of variable params      CR21 307
REF=yes:#                              Set refine flag on               CR21 308
IF(-PCON==L5)#                         All par. are invariant           CR21 309
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR21 310
REF=no:; nextconstr:(1)#               Put refine off; get next con     CR21 311
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR21 312
ELSE IF(ICYCLE==NCYCLE) REF=no:#       Flag off in last cycle           CR21 313
#                                                                       CR21 314
SUMCOS=0.;SUMSIN=0.#                   Zero fc components               CR21 315
movereal:(0.,1,DELA,1,PAR,2)#          Zero real derivatives comp.      CR21 316
IF(IMAGP>1) movereal:(0.,1,DELB,1,PAR,2)# Zero imag deriv.comp.         CR21 317
FOR(L14=MARK14+NATTYP;L14<STOP14;L14=L14+STEP14)# Loop over equiv.      CR21 318
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR21 319
Q = QX(L14+1)*QX(L5+2)+$#              Sum h*x/a                        CR21 320
    QX(L14+2)*QX(L5+3)+$#              Sum k*y/b                        CR21 321
    QX(L14+3)*QX(L5+4)+QX(L14+4)#      Sum l*z/c and phase shift        CR21 322
COS2P=COS(Q); SIN2P=SIN(Q)#            Sin and cos(hx+ky+lz+t)          CR21 323
IF(NTMP==6)#                           Anisotropic tf                   CR21 324
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR21 325
Q=QX(L14+5)*QX(L5+5)+QX(L14+6)*QX(L5+6)+QX(L14+7)*QX(L5+7)$#            CR21 326
 +QX(L14+8)*QX(L5+8)+QX(L14+9)*QX(L5+9)+QX(L14+10)*QX(L5+10)#           CR21 327
Q=EXP(-Q);COS2P=Q*COS2P;SIN2P=Q*SIN2P# Tf=exp(-q);tf*cos;tf*sin         CR21 328
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR21 329
SUMCOS=SUMCOS+COS2P;SUMSIN=SUMSIN+SIN2P# Sum real comp. and imag comp   CR21 330
IF(REF==no:) NEXT#                     No derivatives wanted            CR21 331
#                                                                       CR21 332
DO I=1,3#                              Loop over x,y,z params           CR21 333
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR21 334
DELA(I)=DELA(I)-QX(L14+I)*SIN2P#       Sum real comp.                   CR21 335
IF(ICENT==1) DELB(I)=DELB(I)+QX(L14+I)*COS2P# Sum imag comp.            CR21 336
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR21 337
DO I=4,PAR#                            Loop over equiv. bij             CR21 338
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR21 339
DELA(I)=DELA(I)-QX(L14+I+1)*COS2P#     Sum real comp.                   CR21 340
IF(ICENT==1) DELB(I)=DELB(I)-QX(L14+I+1)*SIN2P# Sum imag comp.          CR21 341
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR21 342
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR21 343
#                                                                       CR21 344
## APPLY TF, POP, SITE MULT                                             CR21 345
#                                                                       CR21 346
IF(NTMP==0)      FACT=EXP(-STOLSQ*QX(MARK4+1))*RFLMLT# If overall tf    CR21 347
ELSE IF(NTMP==1) FACT=EXP(-STOLSQ*QX(L5+5))*RFLMLT# If isotropic tf     CR21 348
ELSE             FACT=RFLMLT#          If anisotropic tf                CR21 349
IF(POP>0) FACT=FACT*QX(L5P)#           Apply pop param                  CR21 350
IF(MLT>0) FACT=FACT*QX(L5M)#           Apply atom multiplicity          CR21 351
#                                                                       CR21 352
## SUM STRUCTURE FACTOR COMPONENTS                                      CR21 353
#                                                                       CR21 354
L14=MARK14+ATTYP#                      Point to scat.fact.              CR21 355
FACT1=QX(L14)*FACT;FACT2=0.#           Real and imag fact./no-dis       CR21 356
A=FACT1*SUMCOS;FA(5)=FA(5)+A#          Real comp. of fcalc & sum        CR21 357
B=0.;C=0.;D=0.#                                                         CR21 358
IF(ICENT==1)#                          If a-centric                     CR21 359
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR21 360
B=FACT1*SUMSIN;FA(6)=FA(6)+B#          Imag comp. of fcalc & sum        CR21 361
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR21 362
L2=MARK2+(ATTYP-1)*NSTEP2#             Point to disp.fact.              CR21 363
IF(REFDSP>0)#                          Test for dispersion              CR21 364
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR21 365
IF((ABS(QX(L2+1))>small:)&(ABS(QX(L2+2))>small:))#                      CR21 366
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR21 367
FACT1=(QX(L14)+QX(L2+1))*FACT#         Calc real scattering             CR21 368
FACT2=QX(L2+2)*FACT#                   Calc imag scattering             CR21 369
A=FACT1*SUMCOS;C=FACT2*SUMCOS#         Sum disp terms                   CR21 370
IF(ICENT==1)#                                                           CR21 371
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR21 372
B=FACT1*SUMSIN;D=FACT2*SUMSIN#         Add imag parts                   CR21 373
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR21 374
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR21 375
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR21 376
AA(1)=A-D;AA(2)= B+C#                  Real & imag parts/atom           CR21 377
IF(REFABS>0)#                          If abs.struct.param present      CR21 378
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR21 379
AA(3)=A+D;AA(4)=-B+C#                  Friedel comp. per atom           CR21 380
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR21 381
DO I=1,IMAGP;FA(I)=FA(I)+AA(I)#        Sum over atoms                   CR21 382
#                                                                       CR21 383
## ACCUMULATE DERIVATIVES                                               CR21 384
#                                                                       CR21 385
IF((NTMP==REFUOV-1)&(BLKTYP==1))#      Test if overall tf refined       CR21 386
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CR21 387
L=MARK13+REFSKF+1#                     Point to uov-deriv               CR21 388
DO I=1,IMAGP#                          Loop over all terms              CR21 389
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CR21 390
QX(L)=QX(L)+AA(I)*DERTMP#              ???       sum real comp.         CR21 391
L=L+VARTOT#                                                             CR21 392
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CR21 393
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CR21 394
#                                                                       CR21 395
IF(REF==no:) NEXT#                     No refine, goto next atom        CR21 396
#                                                                       CR21 397
IF(QX(L2+3)>0.5)#                      Test if dispersion refined       CR21 398
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CR21 399
D1=FACT*SUMCOS*DERFAC#                 Calc cos comp.                   CR21 400
D2=FACT*SUMSIN*DERFAC#                 Calc sin comp.                   CR21 401
L=L13DSP+(NINT(QX(L2+3))-1)*2#         Point to disp derivative         CR21 402
QX(L)=QX(L)+D1;QX(L+1)=QX(L+1)-D2#     Sum (a-d)deriv terms             CR21 403
L=L+VARTOT#                                                             CR21 404
QX(L)=QX(L)+D2;QX(L+1)=QX(L+1)+D1#     Sum (b+c)deriv terms             CR21 405
IF(REFABS==2)#                         If abs.struct.param present      CR21 406
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CR21 407
L=L+VARTOT#                                                             CR21 408
QX(L)=QX(L)+D1;QX(L+1)=QX(L+1)+D2#     Sum (a+d)deriv terms             CR21 409
L=L+VARTOT#                                                             CR21 410
QX(L)=QX(L)-D2;QX(L+1)=QX(L+1)+D1#     Sum (-b+c)deriv terms            CR21 411
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CR21 412
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CR21 413
#                                                                       CR21 414
FACT1=FACT1*DERFAC; FACT2=FACT2*DERFAC# Apply derivative factor         CR21 415
DO P=1,PARTOT#                         Loop over the variables          CR21 416
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CR21 417
IF(P<=PAR)#                            Test if coord. or anisotr.tf     CR21 418
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CR21 419
IF(IMAGP==1)#                          Cents; no-disp                   CR21 420
DA(1)=FACT1*DELA(P)#                   Calc deriv a                     CR21 421
ELSE#                                  Acentrs                          CR21 422
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CR21 423
DA(1)=FACT1*DELA(P)-FACT2*DELB(P)#     Calc deriv a                     CR21 424
DA(2)=FACT1*DELB(P)+FACT2*DELA(P)#     Calc deriv b                     CR21 425
IF(REFABS>0)#                          If xabs to be applied            CR21 426
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CR21 427
DA(3)= FACT1*DELA(P)+FACT2*DELB(P)#    Calc deriv a (friedel)           CR21 428
DA(4)=-FACT1*DELB(P)+FACT2*DELA(P)#    Cald deriv b (friedel)           CR21 429
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CR21 430
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CR21 431
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CR21 432
ELSE IF((P==4)&(NTMP==1))#             Isotropic tf                     CR21 433
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CR21 434
DO I=1,IMAGP;DA(I)=DERTMP*AA(I)#       Calc deriv all terms             CR21 435
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CR21 436
ELSE#                                  Population parameter             CR21 437
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CR21 438
Q=DERFAC/QX(L5P)#                      Calc factor                      CR21 439
DO I=1,IMAGP;DA(I)=AA(I)*Q#                                             CR21 440
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CR21 441
#                                                                       CR21 442
## TEST FOR CONSTRAINTS                                                 CR21 443
#                                                                       CR21 444
IF((L5+P+1)==IABS(PCON))#              Test for constr/invar param      CR21 445
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CR21 446
IF(PCON<0) nextconstr:(1)#             Invariant param                  CR21 447
ELSE#                                  Constrained param                CR21 448
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CR21 449
IF(QX(LCON+2)>=0.) L13=L13+NINT(QX(LCON+2))# Jump over group var.       CR21 450
N1=NINT(QX(LCON+3))#                   Nr of items                      CR21 451
N2=NINT(QX(LCON+4))#                   Nr of items/set                  CR21 452
LCON=LCON+4#                           Advance constraint pointer       CR21 453
DO J=5,N1,N2#                          Loop over reference sets         CR21 454
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CR21 455
IF(N2>1) FCT=QX(LCON+2)#               Multipl. factor for normal c     CR21 456
ELSE     FCT=-1.#                      Default for polar constraint     CR21 457
L=MARK13+NINT(QX(LCON+1))#             Point to deriv position          CR21 458
DO I=1,IMAGP#                          Loop over all terms              CR21 459
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CR21 460
QX(L)=QX(L)+FCT*DA(I)#                 Sum comp.                        CR21 461
L=L+VARTOT#                            Incr pointer                     CR21 462
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CR21 463
LCON=LCON+N2#                          Advance constr pointer           CR21 464
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CR21 465
nextconstr:(0)#                        Set pointer to next constr       CR21 466
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CR21 467
NEXT#                                  Goto next param                  CR21 468
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CR21 469
#                                                                       CR21 470
IF(BLKTYP==3)#                         User defined blocks              CR21 471
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CR21 472
IF(N9>0)#                              Test if var nr is there          CR21 473
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CR21 474
L13=MARK13+N9-1#                       Calc pointer in deriv array      CR21 475
L9=L9+1;N9=NINT(QX(L9))#               Advance pointer in block arr     CR21 476
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CR21 477
ELSE IF((L5+1+P)==-N9)#                Test if last param of serie      CR21 478
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CR21 479
L9=L9+1;N9=NINT(QX(L9))#               Advance pointer                  CR21 480
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CR21 481
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CR21 482
#                                                                       CR21 483
## SUM DERIVATIVES                                                      CR21 484
#                                                                       CR21 485
L13=L13+1;L=L13#                       Point to deriv array             CR21 486
DO I=1,IMAGP#                          Loop over all terms              CR21 487
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CR21 488
QX(L)=QX(L)+DA(I)#                     Sum all comp.                    CR21 489
L=L+VARTOT#                            Incr pointer                     CR21 490
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CR21 491
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CR21 492
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR21 493
#                                                                       CR21 494
#       CALCULATE STRUCTURE FACTORS, ETC                                CR21 495
#       --------------------------------                                CR21 496
#                                                                       CR21 497
IF(IMAGP==1) FC2=FA(1)*FA(1)#          Fcalc, no-disp,centrosymm.       CR21 498
ELSE#                                                                   CR21 499
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 CR21 500
FC2=FA(1)*FA(1)+FA(2)*FA(2)#           Fc2, disp included,non centr     CR21 501
IF(REFABS>0)#                          If xabs to be applied            CR21 502
FCFR2=FA(3)*FA(3)+FA(4)*FA(4)#         Fc2 (friedel)                    CR21 503
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 CR21 504
IF(REFEXT>0)#                          Test if extinction used          CR21 505
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CR21 506
Q=FC2;CALL CR22(1,IP,Q)#               Calculate ext. corr.             CR21 507
EXTCOR=Q#                              Extinction corr                  CR21 508
FC2=FC2*Q*Q#                           Apply ext. corr.                 CR21 509
IF(REFABS>0) FCFR2=FCFR2*Q*Q#                                           CR21 510
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CR21 511
#                                                                       CR21 512
WFRDL=1.#                              Friedel weight                   CR21 513
DO IFRDL=1,NFRDL#                      Loop over friedel pairs          CR21 514
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CR21 515
IF(IFRDL==1)#                          Main reflection                  CR21 516
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 CR21 517
DFC=0.#                                Set diff(fc2)                    CR21 518
ifvo:(QX(IP+REL4)) NEXT#               Skip if void fobs/f2obs/iobs     CR21 519
OBS=QX(IP+REL4)/SKF#                   Get fobs/f2obs/iobs              CR21 520
CALC=FC2#                              Set fc2                          CR21 521
IF(REL5>0) SIGMA=QX(IP+REL5)/SKF#      Sigma(fobs,etc)                  CR21 522
IF(REFABS>0)#                          If xabs appl.                    CR21 523
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CR21 524
CALC=(1.-XABS)*FC2+XABS*FCFR2#         Total fc2                        CR21 525
ifnv:(QX(IP+REL6))#                                                     CR21 526
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CR21 527
DFC=-FC2+FCFR2;  WFRDL=0.5#            Diff(fc2)                        CR21 528
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CR21 529
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CR21 530
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 CR21 531
ELSE#                                  Friedel related reflection       CR21 532
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CR21 533
ifvo:(QX(IP+REL6)) BREAK#              Not present                      CR21 534
OBS=QX(IP+REL6)/SKF#                   Get fobs, etc for friedel        CR21 535
IF(REL7>0) SIGMA=QX(IP+REL7)/SKF#      Sigma(fobs,etc)                  CR21 536
IF(REL11>0) RCODE=QX(IP+REL11)#        Rcode                            CR21 537
CALC=(1.-XABS)*FCFR2+XABS*FC2#         Total fc2                        CR21 538
DFC=-DFC#                              Diff(fc2)                        CR21 539
AH=-AH;AK=-AK;AL=-AL#                  Invert indices for print         CR21 540
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CR21 541
#                                                                       CR21 542
FCAL=SQRT(MAX(0.,CALC))#               Calculate fcal                   CR21 543
IF(RFLTYP==0)#                         Refinement on f                  CR21 544
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 CR21 545
CALC=FCAL;     FOBS=OBS#               Calculate fobs                   CR21 546
FO2=OBS*OBS#                           Calculate fo**2                  CR21 547
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 CR21 548
ELSE IF(RFLTYP==1)#                    Refinement on f2                 CR21 549
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 CR21 550
FO2=OBS#                               Calculate fo**2                  CR21 551
FOBS=SQRT(MAX(0.,FO2))#                Calculate fobs                   CR21 552
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 CR21 553
ELSE#                                  Refinement on i                  CR21 554
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 CR21 555
CALC=CALC/QX(IP+REL9)#                 Calculate i                      CR21 556
FO2 =OBS*QX(IP+REL9)#                  Calculate io                     CR21 557
FOBS=SQRT(MAX(0.,FO2))#                Calculate fobs                   CR21 558
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 CR21 559
FDEL=FOBS-FCAL#                        Calculate f difference           CR21 560
DELTA=OBS-CALC#                        Calculate delta for coeff        CR21 561
#                                                                       CR21 562
LT=RCODE#                              Set initial rcode                CR21 563
IF(RCODE>2)#                           Suffering from extinction        CR21 564
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 CR21 565
LT=2;BUILD=no:#                        Count as less than not in ls     CR21 566
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 CR21 567
IF((TYPELT>0.)&(RCODE<=2))#            Type less-than reflections       CR21 568
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 CR21 569
IF(OBS<TYPELT*SIGMA) LT=2#             Reset rcode if below limit       CR21 570
ELSE                 LT=1#             Or above limit                   CR21 571
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 CR21 572
#                                                                       CR21 573
IF(BUILD==yes:)#                       Chech contr. to matrix           CR21 574
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 CR21 575
IF(LT==1)#                             If observed reflection           CR21 576
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 CR21 577
IF(ABS(WEIGHT*DELTA)>RFMTRX) BUILD=no:# Exclude big deltas              CR21 578
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 CR21 579
ELSE IF(LT==2)#                        If less-than reflection          CR21 580
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 CR21 581
IF((LTMTRX==0)\(ABS(CALC)<OBS)) BUILD=no:# No-build lt refl.            CR21 582
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 CR21 583
ELSE BUILD=no:#                        Exclude rcode=3, always.         CR21 584
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 CR21 585
#                                                                       CR21 586
## ACCUMULATE STATISTICS                                                CR21 587
#                                                                       CR21 588
FACT=WEIGHT*WEIGHT#                    Weighted diff. squared           CR21 589
RSUMS(LT+ 1)=RSUMS(LT+ 1)+ABS(FOBS)#   Sum fobs                         CR21 590
RSUMS(LT+ 4)=RSUMS(LT+ 4)+ABS(FCAL)#   Sum fcal                         CR21 591
RSUMS(LT+ 7)=RSUMS(LT+ 7)+ABS(FDEL)#   Sum fdel                         CR21 592
RSUMS(LT+16)=RSUMS(LT+16)+FACT*DELTA*DELTA# Sum w*delta**2              CR21 593
RSUMS(LT+19)=RSUMS(LT+19)+FACT*OBS*OBS# Sum w*rel**2                    CR21 594
RSUMS(LT+22)=RSUMS(LT+22)+WFRDL#       Sum number of reflections        CR21 595
IF(BUILD==no:)#                        Sums for no-build refl.          CR21 596
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 65 CR21 597
RSUMS(LT+26)=RSUMS(LT+26)+ABS(FOBS)#   Sum fobs                         CR21 598
RSUMS(LT+29)=RSUMS(LT+29)+ABS(FCAL)#   Sum fcal                         CR21 599
RSUMS(LT+32)=RSUMS(LT+32)+ABS(FDEL)#   Sum fdel                         CR21 600
RSUMS(LT+41)=RSUMS(LT+41)+FACT*DELTA*DELTA# Sum w*delta**2              CR21 601
RSUMS(LT+44)=RSUMS(LT+44)+FACT*OBS*OBS# Sum w*rel**2                    CR21 602
RSUMS(LT+47)=RSUMS(LT+47)+WFRDL#       Nr of refl.                      CR21 603
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 65 CR21 604
#                                                                       CR21 605
## OUTPUT OF REFLECTION DATA                                            CR21 606
#                                                                       CR21 607
IF((LIST==2)\(ABS(WEIGHT*DELTA)>RFLIST)$# Output requested              CR21 608
\(ICYCLE==NCYCLE))#                    Or fcalc values                  CR21 609
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 66 CR21 610
FO2NE=FO2/(EXTCOR*EXTCOR)#             Remove extinction from fobs      CR21 611
FCND=SQRT(FA(5)*FA(5)+FA(6)*FA(6))#    No-disp fcalc                    CR21 612
IF(REFDSP==0) FOND=SQRT(AMAX1(0.,FO2NE))# If dispersion not applied     CR21 613
ELSE#                                  If dispersion applied            CR21 614
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 67 CR21 615
IF(IFRDL==1)#                          Reflection                       CR21 616
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 68 CR21 617
IF(REFABS==0)#                         No xabs available                CR21 618
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 69 CR21 619
ADIS=FA(1)-FA(5);BDIS=FA(2)-FA(6)#     Disp terms for reflection        CR21 620
EFLACK=0.0#                            E in c13 of bernard & flack      CR21 621
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 69 CR21 622
ELSE#                                  Xabs here                        CR21 623
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 70 CR21 624
AREFD=FA(1)-FA(5);BREFD=FA(2)-FA(6)#   Disp terms for reflection        CR21 625
ANTID=FA(3)-FA(5);BNTID=FA(4)+FA(6)#   Disp terms for antireflection    CR21 626
ADIS=(1.-XABS)*AREFD+XABS*ANTID#       Ax of c 11                       CR21 627
BDIS=(1.-XABS)*BREFD-XABS*BNTID#       Bx of c 11                       CR21 628
EFLACK=(1.-XABS)*(AREFD**2+BREFD**2)+XABS*(ANTID**2+BNTID**2)$#         CR21 629
-ADIS**2-BDIS**2#                      E in c12 of bernard & flack      CR21 630
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 70 CR21 631
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 68 CR21 632
ELSE#                                  Antireflection                   CR21 633
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 71 CR21 634
IF(REFABS==0)#                         No xabs available                CR21 635
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 72 CR21 636
ADIS=FA(3)-FA(5);BDIS=FA(4)+FA(6)#     Disp terms for antireflection    CR21 637
EFLACK=0.0#                            E in c13 of bernard & flack      CR21 638
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 72 CR21 639
ELSE#                                  Xabs here                        CR21 640
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 73 CR21 641
ADIS=(1.-XABS)*ANTID+XABS*AREFD#       Ax of c 11                       CR21 642
BDIS=(1.-XABS)*BNTID-XABS*BREFD#       Bx of c 11                       CR21 643
EFLACK=(1.-XABS)*(ANTID**2+BNTID**2)+XABS*(AREFD**2+BREFD**2)$#         CR21 644
-ADIS**2-BDIS**2#                      E in c12 of bernard & flack      CR21 645
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 73 CR21 646
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 71 CR21 647
ifeq:(FCND,0.0)#                       Protect against fcals zero       CR21 648
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 74 CR21 649
A=0.;B=0.#                             Set a and b equal to zero        CR21 650
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 74 CR21 651
ELSE#                                                                   CR21 652
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 75 CR21 653
IF(IFRDL==1)#                                                           CR21 654
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 76 CR21 655
A=(ADIS*FA(6)-BDIS*FA(5))/FCND#        Correction term a for refl       CR21 656
B=(ADIS*FA(5)+BDIS*FA(6))/FCND#        Correction term b for refl       CR21 657
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 76 CR21 658
ELSE#                                                                   CR21 659
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 77 CR21 660
A=(-ADIS*FA(6)-BDIS*FA(5))/FCND#       Correction term a for antirefl   CR21 661
B=(ADIS*FA(5)-BDIS*FA(6))/FCND#        Correction term b                CR21 662
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 77 CR21 663
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 75 CR21 664
FOND=AMAX1(0.,FO2NE-A*A-EFLACK)#       Correction                       CR21 665
FOND=SQRT(FOND)-B#                     No-disp fobs value               CR21 666
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 67 CR21 667
IF((ABS(FA(5))<.01)&(ABS(FA(6))<.01)) FA(5)=.01# Test for indeter       CR21 668
PHI=AMOD(ATAN2(FA(6),FA(5))/TWOPI+1.000001,1.)# Phi in cycles           CR21 669
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 66 CR21 670
#                                                                       CR21 671
IF((LIST>=2)\(ABS(WEIGHT*DELTA)>RFLIST))# Test if refl. p               CR21 672
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 78 CR21 673
BUFOT(1)=AH#                           Store h                          CR21 674
BUFOT(2)=AK#                           Store k                          CR21 675
BUFOT(3)=AL#                           Store l                          CR21 676
BUFOT(4)=STOL#                         Store st/l                       CR21 677
IF(RCODE<3)    BUFOT(5)=FLOAT(LT)#     Store reflection code            CR21 678
ELSE           BUFOT(5)=FLOAT(RCODE)#  Extinct refl.                    CR21 679
IF(BUILD==no:) BUFOT(5)=-BUFOT(5)#     Mark this refl. in output        CR21 680
BUFOT(6)=FLOAT(ISKF)#                  Store scale group                CR21 681
BUFOT(7)=OBS#                          Store observed sf                CR21 682
BUFOT(8)=CALC#                         Store calculated sf              CR21 683
IF(IFRDL==1)#                          Main reflection                  CR21 684
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 79 CR21 685
BUFOT(9)=FA(1)*EXTCOR#                 Store real dispn. term           CR21 686
BUFOT(10)=FA(2)*EXTCOR#                Store imag dispn. term           CR21 687
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 79 CR21 688
ELSE#                                                                   CR21 689
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 80 CR21 690
BUFOT(9)=FA(3)*EXTCOR#                 Store real dispn. term           CR21 691
BUFOT(10)=FA(4)*EXTCOR#                Store imag dispn. term           CR21 692
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 80 CR21 693
BUFOT(11)=EXTCOR#                      Store extinction corr.           CR21 694
BUFOT(12)=FOND#                        Store no-disp fobs               CR21 695
BUFOT(13)=FCND#                        Store no-disp fcalc              CR21 696
BUFOT(14)=PHI*360.#                    Store phase (degrees)            CR21 697
BUFOT(15)=OBS-CALC#                    Store difference                 CR21 698
BUFOT(16)=WEIGHT*BUFOT(15)#            Store weighted difference        CR21 699
BUFOT(17)=SIGMA#                       Store sigma used                 CR21 700
ncodefld:(BUFOT,1,CHROT,FORM(1),17)#   Encode                           CR21 701
writeline:(0,CR211,NCR211,1,3)#        Print output items               CR21 702
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 78 CR21 703
#                                                                       CR21 704
IF(ICYCLE==NCYCLE)#                    Last cycle                       CR21 705
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 81 CR21 706
IF(IFRDL==1)#                          Keep for reflection              CR21 707
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 82 CR21 708
QX(LPP)=ABS(FCND);    LPP=LPP+1#       Fcal no disp idn n800            CR21 709
IF(ICENT==1)#                          If a-centric                     CR21 710
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 83 CR21 711
QX(LPP)=FA(5);        LPP=LPP+1#       Store fa: no-disp n801           CR21 712
QX(LPP)=FA(6);        LPP=LPP+1#       Store fb: no-disp n802           CR21 713
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 83 CR21 714
IF(REFDSP>0 \ REFEXT>0)#               If dispersion or ext applied     CR21 715
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 84 CR21 716
QX(LPP)=ADIS;         LPP=LPP+1#       Store a : disp    n803           CR21 717
QX(LPP)=BDIS;         LPP=LPP+1#       Store b : disp    n804           CR21 718
QX(LPP)=FA(1);        LPP=LPP+1#       Store fa: total   n805           CR21 719
QX(LPP)=FA(2);        LPP=LPP+1#       Store fb: total   n806           CR21 720
IF(RFLTYP>0) QX(LPP)=FOND*SQRT(SKF)#   Store fo : no disp n701          CR21 721
ELSE         QX(LPP)=FOND*SKF#         Store fo : no-disp n701          CR21 722
LPPSV=LPP#                             Keep in case an antirefln also   CR21 723
LPP=LPP+1#                             Incr op pointer                  CR21 724
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 84 CR21 725
QX(LPP)=PHI;          LPP=LPP+1#       Store phi: no-disp n700          CR21 726
QX(LPP)=EXTCOR**2;    LPP=LPP+1#       Store extinct term n202          CR21 727
QX(LPP)=FCAL;         LPP=LPP+1#       Store corrected fc               CR21 728
GOTO 100#                              Goto next reflection             CR21 729
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 82 CR21 730
ELSE#                                                                   CR21 731
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 85 CR21 732
IF((REFDSP>0 \ REFEXT>0)&(RFLTYP>0)) $#                                 CR21 733
      QX(LPPSV)=0.5*(QX(LPPSV)+FOND*SQRT(SKF))# Store fo no disp n701   CR21 734
ELSE  QX(LPPSV)=0.5*(QX(LPPSV)+FOND*SKF)# Store fo : no-disp n701       CR21 735
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 85 CR21 736
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 81 CR21 737
#                                                                       CR21 738
## FORM DERIVATIVES                                                     CR21 739
#                                                                       CR21 740
IF(BUILD==no:) GOTO 100#               No matrix contribution           CR21 741
DELTA=WEIGHT*DELTA#                    Delta * derivatives factor       CR21 742
#                                                                       CR21 743
IF(REFSKF>0)#                          If scale is refined              CR21 744
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 86 CR21 745
IF(REFSKF>1) L13=MARK13+ISKF#          Point to scale deriv             CR21 746
ELSE         L13=MARK13+1#             For unified scale                CR21 747
QX(L13)=CALC*DERSKF#                   Store scale deriv                CR21 748
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 86 CR21 749
L13=MARK13+REFSKF+1#                                                    CR21 750
#                                                                       CR21 751
IF((REFUOV!=0)&(BLKTYP!=1))#           If uov refined for correlati     CR21 752
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 87 CR21 753
L=L13#                                 Point to uov deriv               CR21 754
DO I=1,IMAGP#                          Loop over partial deriv          CR21 755
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 88 CR21 756
QX(L)=FA(I)*DERTMP#                    Multiply with deriv factor       CR21 757
L=L+VARTOT#                            Incr pointer                     CR21 758
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 88 CR21 759
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 87 CR21 760
L13=L13+IABS(REFUOV)#                  Point to next deriv              CR21 761
#                                                                       CR21 762
IF(REFABS==2)#                         Abs.struct.param.                CR21 763
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 89 CR21 764
QX(L13)=WEIGHT*DFC#                    Store xabs deriv                 CR21 765
IF(RFLTYP==0)#                                                          CR21 766
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 90 CR21 767
IF(CALC>0.) QX(L13)=QX(L13)/(2.*CALC)# Refinement on f                  CR21 768
ELSE QX(L13)=0.#                                                        CR21 769
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 90 CR21 770
IF(RFLTYP==2) QX(L13)=QX(L13)/QX(IP+REL9)# Refinement on i              CR21 771
L13=L13+1#                             Point to next deriv              CR21 772
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 89 CR21 773
#                                                                       CR21 774
IF(REFEXT>1)#                          Extinction                       CR21 775
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 91 CR21 776
Q=DERFAC;CALL CR22(2,L13,Q)#           Calc. derivatives                CR21 777
DEREXT=Q#                              Param deriv. factor              CR21 778
DO I=1,IMAGP;CA(I)=DEREXT*FA(I)#       Scale gen derivative multipl     CR21 779
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 91 CR21 780
#                                                                       CR21 781
ELSE IF(RFLTYP==0)#                    If refinement on f no ext        CR21 782
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 92 CR21 783
DO I=1,IMAGP;CA(I)=0.#                 Set mult.factors to zero         CR21 784
IF(CALC>small:)#                                                        CR21 785
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 93 CR21 786
CA(1)=FA(1)/CALC;CA(2)=FA(2)/CALC#     Mult.factors                     CR21 787
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 93 CR21 788
IF(REFABS==2 & FCFR2>small:)#          For friedels                     CR21 789
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 94 CR21 790
CA(3)=FA(3)/SQRT(FCFR2);CA(4)=FA(4)/FCFR2# Mult.factors                 CR21 791
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 94 CR21 792
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 92 CR21 793
ELSE#                                                                   CR21 794
DO I=1,IMAGP;CA(I)=FA(I)#              Refinement on f2 or i            CR21 795
#                                                                       CR21 796
L13=MARK13+REFSKF+1#                   Point to uov deriv               CR21 797
DO L=L13,STOP13#                       Loop over uov and atom params    CR21 798
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 95 CR21 799
IF(L<L13DSP & L!=L13UOV) NEXT#         Not uov or atom param            CR21 800
IF(IMAGP==1)#                          If real comp.                    CR21 801
QX(L)=CA(1)*QX(L)#                     Correct derivatives              CR21 802
ELSE IF(IMAGP==2)#                     If real & imag comp.             CR21 803
QX(L)=CA(1)*QX(L)+CA(2)*QX(L+VARTOT)#  Calculate final derivatives      CR21 804
ELSE IF(IFRDL==1)#                     If friedel present, main refl    CR21 805
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 96 CR21 806
K=L+2*VARTOT#                          Point to friedel derivatives     CR21 807
QX(L+VARTOT)=CA(1)*QX(L)+CA(2)*QX(L+VARTOT)# Sum derivs for main refl   CR21 808
QX(K+VARTOT)=CA(3)*QX(K)+CA(4)*QX(K+VARTOT)# Sum derivs for friedel     CR21 809
QX(L)=(1.-XABS)*QX(L+VARTOT)+XABS*QX(K+VARTOT)# Final deriv             CR21 810
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 96 CR21 811
ELSE#                                  Friedel refl.                    CR21 812
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 97 CR21 813
K=L+2*VARTOT#                          Point to friedel derivs          CR21 814
QX(L)=(1.-XABS)*QX(K+VARTOT)+XABS*QX(L+VARTOT)# Final deriv             CR21 815
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 97 CR21 816
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 95 CR21 817
#                                                                       CR21 818
#       BUILD DERIVATIVE MATRICES                                       CR21 819
#       -------------------------                                       CR21 820
#                                                                       CR21 821
L11=MARK11;L12=MARK12;L13=MARK13#      Set pointers                     CR21 822
FOR(L8=MARK8+2;L8<MARK9;L8=L8+2)#      Loop over block array            CR21 823
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 98 CR21 824
NBLK=NINT(QX(L8));VARBLK=NINT(QX(L8+1))# Nr of blocks;nr of var/blo     CR21 825
DO I=1,NBLK#                           Loop over the blocks             CR21 826
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 99 CR21 827
DO J=1,VARBLK#                         Loop over variables              CR21 828
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 100CR21 829
Q=QX(L13+J)#                           Get derivative                   CR21 830
DO L=J,VARBLK#                         Loop over derivatives            CR21 831
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 101CR21 832
QX(L11+L)=QX(L11+L)+Q*QX(L13+L)#       Form matrix element              CR21 833
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 101CR21 834
L11=L11+VARBLK-J#                      Point to next row                CR21 835
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 100CR21 836
DO J=1,VARBLK#                         Loop over variables              CR21 837
QX(L12+J)=QX(L12+J)+DELTA*QX(L13+J)#   Form vector element              CR21 838
L11=L11+VARBLK;L12=L12+VARBLK;L13=L13+VARBLK# Adjust pointers           CR21 839
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 99 CR21 840
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 98 CR21 841
#                                                                       CR21 842
100 CONTINUE#                                                           CR21 843
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CR21 844
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR21 845
#                                                                       CR21 846
RETURN#                                                                 CR21 847
END#                                                                    CR21 848
systemheader:(CR22)#                   Extinction corrections           CR22   1
# ##################################################################### CR22   2
#                                                                       CR22   3
#                               CR22                                    CR22   4
#                                                                       CR22   5
# ##################################################################### CR22   6
SUBROUTINE CR22(KEY,II,Q)#             R. olthof  may 1986              CR22   7
include:(AACOMN)#                      April 1989                       CR22   8
include:(CRCOMN)#                                                       CR22   9
#                                                                       CR22  10
REAL    AP,AS#     ## COEFF. FOR PRIM. & SEC. EXT. PARAMS (XP & XS      CR22  11
REAL    BP,BS#     ## COEFF. FOR PRIM. & SEC. EXT. PARAMS (XP & XS)     CR22  12
REAL    CP,CS#     ## COEFF. FOR PRIM. & SEC. EXT. PARAMS (XP & XS)     CR22  13
REAL    COST#      ## COS(THETA)                                        CR22  14
REAL    COS2T#     ## COS(2THETA)                                       CR22  15
REAL    DELTXT#    ## Larsons delta for ext.                            CR22  16
REAL    DEREXT#    ## MULT. FACTOR FOR DERIV. OF PARAMS                 CR22  17
REAL    DERFAC#    ## Mult factor for derivatives                       CR22  18
REAL    DPSIG#     ## DERIV. D(PSI)/D(G)                                CR22  19
REAL    DPSIR#     ## DERIV. D(PSI)/D(RHO)                              CR22  20
REAL    FACT#      ## TEMP. FACTORS                                     CR22  21
REAL    FCSQ#      ## FCALC**2                                          CR22  22
REAL    FC#        ## FCALC                                             CR22  23
REAL    G#         ## WIDTH PARAMETER OF MOSAIC DISTRIBUTION            CR22  24
REAL    GAMMAP#    ## GAMMA FOR PRIM. EXTINCTION                        CR22  25
REAL    GAMMAS#    ## GAMMA FOR SEC.  EXTINCTION                        CR22  26
REAL    GFACT#     ## FACTOR FOR GAMMAS                                 CR22  27
INTEGER II#        ## Pointer for derivatives                           CR22  28
INTEGER KEY#       ## 0=INIT.                                           CR22  29
#                  ## 1=CORR.  II=IP      Q(IN)=FCALC Q(OUT)=YEXT       CR22  30
#                  ## 2=DERIV. II=L13EXT  Q(IN)=SKF   Q(OUT)=DERE       CR22  31
INTEGER L13EXT#    ## Pointer to ext. derives.                          CR22  32
REAL    OM1,OM2,OM3## DERIV. TO PARAMS, G AND RHO                       CR22  33
REAL    PAREXT#    ## Extinction parameter                              CR22  34
REAL    POL1#      ## POLARIZATION FACTOR FOR MONOCHROMETER             CR22  35
REAL    POL2#      ## POLARIZATION FACTOR FOR CRYSTAL                   CR22  36
INTEGER PRMEXT#    ## 0/1 FOR NO/YES PRIMARY EXTINCTION PRESENT         CR22  37
REAL    PSI#       ## DISTRIBUTION FUNCTION                             CR22  38
REAL    Q#         ## Communication with CR21                           CR22  39
REAL    RHO#       ## PARTICLE SIZE (R/LAMBDA)                          CR22  40
REAL    SCOS2T#    ##                                                   CR22  41
REAL    SINT#      ## SIN(THETA)                                        CR22  42
REAL    SIN2T#     ## SIN(2THETA)                                       CR22  43
REAL    TBAR#      ## MEAN PATH LENGTH                                  CR22  44
REAL    XP,XS#     ## EXTINCTION PARAMS: PRIM. & SEC. EXT.; NEUTRONS    CR22  45
REAL    XP1,XP2,XS1,XS2## IDEM; XRAY; POLAR. FOR MONOCR & CRYSTAL       CR22  46
REAL    YEXT#      ## Extinction correction                             CR22  47
REAL    YP,YS#     ## EXTINCTION CORR.: PRIM. & SEC. EXT.; NEUTRONS     CR22  48
REAL    YP1,YP2,YS1,YS2## IDEM; XRAY; POLAR. FOR MONOCHR. & CRYSTAL     CR22  49
REAL    ZP,ZS#     ## DERIVATIVES: PRIM. & SEC. EXT.; NEUTRONS          CR22  50
REAL    ZP1,ZP2,ZS1,ZS2## IDEM; XRAY; POLAR. FOR MONOCHR. & CRYSTAL     CR22  51
SAVE#              ## <<<<<<<<<<<<<< ensure local variables saved       CR22  52
#                                                                       CR22  53
#         INITIALIZATIONS                                               CR22  54
#         ---------------                                               CR22  55
#                                                                       CR22  56
IF(KEY==0)#                            Initializations                  CR22  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR22  58
PRMEXT=yes:#                           Refine prim ext.param            CR22  59
IF(EXTTYP<=1 \ EXTTYP==4) PRMEXT=no:#  Type 1 crystal                   CR22  60
GFACT=LAMBDA**3/VOL**2#                For calc of gamma                CR22  61
#IF(RADTYP==1) GFACT=GFACT*794.075#     FOR XRAY DIFFR. T IN CM         CR22  62
IF(RADTYP==1) GFACT=GFACT*79.4075#     For xray diffr. t in mm          CR22  63
ELSE          GFACT=GFACT*10000.#      For neutron diffr.               CR22  64
GAMMAP=1.5*LAMBDA*GFACT/10000.#        Gamma for prim.ext.              CR22  65
POL1=RATIO#                            Polaris.fact. for monochr.       CR22  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR22  67
#                                                                       CR22  68
#         CALCULATION OF EXTINCTION CORRECTION                          CR22  69
#         ------------------------------------                          CR22  70
#                                                                       CR22  71
ELSE IF(KEY==1)#                       Calc. extinction correction      CR22  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR22  73
FCSQ=Q#                                Fc * fc                          CR22  74
TBAR=QX(MARK4+22)#                     Tbar from lrdset or default      CR22  75
IF (REL(15)>0 & MU>0.) ifnm:(QX(II+REL(15)))$#                          CR22  76
TBAR=ALOG(QX(II+REL(15)))/MU+.00001#   Calculated tbar                  CR22  77
IF(REL(14)>0) ifnm:(QX(II+REL(14))) TBAR=QX(II+REL(14))# From lrrefl:   CR22  78
GAMMAS=GFACT*TBAR#                     Gamma for sec. ext.              CR22  79
SINT=QX(II+REL(2))*LAMBDA#             Sin(theta)                       CR22  80
COST=SQRT(1.-SINT*SINT)#               Cos(theta)                       CR22  81
SIN2T=2.*SINT*COST#                    Sin(2theta)                      CR22  82
COS2T=COST*COST-SINT*SINT#             Cos(2theta)                      CR22  83
IF(EXTTYP==0)#                         Zachariasen type                 CR22  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR22  85
DELTXT=GAMMAS*2./SIN2T#                Larson's delta                   CR22  86
IF(RADTYP==1)#                         If xray                          CR22  87
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR22  88
POL2=(1.-POL1)*COS2T*COS2T#            Polarization factor              CR22  89
FACT=1./(POL1+POL2)#                   Multiplier                       CR22  90
SCOS2T=COS2T*COS2T#                    Square cos2t                     CR22  91
DELTXT=DELTXT*(POL1+POL2*SCOS2T)*FACT# Polarization included            CR22  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR22  93
PAREXT=QX(MARK4+2)*DELTXT*FCSQ#        Ext. param                       CR22  94
YEXT=(1.+PAREXT)**(-.25)#              Ext. corr.                       CR22  95
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR22  96
ELSE#                                  Becker-coppens types             CR22  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR22  98
IF(PRMEXT==yes:)#                      Type 2 or mixed                  CR22  99
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR22 100
AP=.20+.45*COS2T#                      Coeff. a                         CR22 101
BP=.22-.12*(.5-COS2T)**2#              Coeff. b                         CR22 102
CP=2.0#                                Coeff. c                         CR22 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR22 104
IF(DSTEXT==0)#                         Gaussian distribution            CR22 105
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR22 106
AS=.58+.48*COS2T+.24*COS2T*COS2T#      Coeff. a                         CR22 107
BS=.020-.025*COS2T#                    Coeff. b                         CR22 108
CS=2.12#                               Coeff. c                         CR22 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR22 110
ELSE#                                  Lorentzian distribut             CR22 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR22 112
AS=.025+.285*COS2T#                    Coeff. a                         CR22 113
IF(COS2T>=0.) BS=.15-.2*(.75-COS2T)**2# Coeff. b as per b & c           CR22 114
ELSE          BS=-.45*COS2T#                                            CR22 115
CS=2.0#                                Coeff. c                         CR22 116
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR22 117
#                                                                       CR22 118
IF(EXTTYP==3 \ EXTTYP==6)#             Mixed crystal                    CR22 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR22 120
G=QX(MARK4+2)#                         Width parameter                  CR22 121
RHO=QX(MARK4+3)#                       Particle size                    CR22 122
IF(DSTEXT==0) PSI=RHO/SQRT(1.+(RHO*SIN2T/G)**2)# Psi-gauss              CR22 123
ELSE          PSI=RHO/(1.+RHO*SIN2T/G)# Psi-lorentz                     CR22 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR22 125
ELSE IF(EXTTYP==2 \ EXTTYP==5)#        Type ii crystal                  CR22 126
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR22 127
RHO=QX(MARK4+3);G=0.;PSI=RHO#          Part. size; mosaic distr.        CR22 128
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR22 129
ELSE#                                  Type i crystal                   CR22 130
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR22 131
RHO=0;G=QX(MARK4+2)#                   Part. size; mosaic distr.        CR22 132
PSI=G/SIN2T#                           Distr. eq.                       CR22 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR22 134
#                                                                       CR22 135
XP=GAMMAP*FCSQ*RHO*RHO#                Prim. ext. parameter             CR22 136
XS=GAMMAS*FCSQ*PSI#                    Sec.  ext. parameter             CR22 137
IF(RADTYP==1)#                         Xray                             CR22 138
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR22 139
POL2=(1.-POL1)*COS2T*COS2T#            Polarization factor              CR22 140
FACT=1./(POL1+POL2)#                   Mult. factor for pol. eq.        CR22 141
YP1=1.;YP2=1.#                         Default extinction corr.         CR22 142
IF(PRMEXT==yes:)#                      Prim. extincion                  CR22 143
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR22 144
XP1=POL1*XP#                           Prim.ext.param; monochr.pol.     CR22 145
YP1=1./SQRT(1.+CP*XP1+AP*XP1*XP1/(1.+BP*XP1))# Prim.ext.corr.           CR22 146
XP2=POL2*XP#                           Sec.ext.param; crystal pol.      CR22 147
YP2=1./SQRT(1.+CP*XP2+AP*XP2*XP2/(1.+BP*XP2))# Prim.ext.corr.           CR22 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR22 149
XS1=POL1*XS*YP1#                       Mono * ext par * corr            CR22 150
YS1=1./SQRT(1.+CS*XS1+AS*XS1*XS1/(1.+BS*XS1))# Sec.ext.corr.            CR22 151
XS2=POL2*XS*YP2#                       Mono * ext par* corr. pol        CR22 152
YS2=1./SQRT(1.+CS*XS2+AS*XS2*XS2/(1.+BS*XS2))#                          CR22 153
YEXT=FACT*(POL1*YP1*YS1+POL2*YP2*YS2)# Total extinction corr.           CR22 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR22 155
ELSE#                                  Neutr.                           CR22 156
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR22 157
YP=1.#                                 Default prim & sec. corr.        CR22 158
IF(PRMEXT==yes:)#                      Prim. ext. corr.                 CR22 159
YP=1./SQRT(1.+CP*XP+AP*XP*XP/(1.+BP*XP))#                               CR22 160
XS=XS*YP#                              Ext par * corr.                  CR22 161
YS=1./SQRT(1.+CS*XS+AS*XS*XS/(1.+BS*XS))#                               CR22 162
YEXT=YP*YS#                            Total extinction corr.           CR22 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR22 164
#                                                                       CR22 165
YEXT=SQRT(YEXT)#                       Extinction correction            CR22 166
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR22 167
#                                                                       CR22 168
Q=YEXT#                                Ext. corr. for use in cr21       CR22 169
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR22 170
#                                                                       CR22 171
#         CALCULATION OF DERIVATIVES                                    CR22 172
#         --------------------------                                    CR22 173
#                                                                       CR22 174
ELSE IF(KEY==2)#                       Calculate derivatives            CR22 175
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR22 176
DERFAC=Q#                              Mult. factor for derivatives     CR22 177
IF(EXTTYP==0)#                         Zachariasen type                 CR22 178
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR22 179
OM1=(1.+.5*PAREXT)/(1.+PAREXT)#        Param deriv; f refine            CR22 180
OM2=-.5/(1.+PAREXT)**1.5#              For g derivative                 CR22 181
GAMMAS=DELTXT#                         For further calcul.              CR22 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR22 183
ELSE#                                  Becker-coppens types             CR22 184
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR22 185
DPSIR=0.;DPSIG=0.#                     D(psi)/d(rho); d(psi)/d(g)       CR22 186
IF(EXTTYP==3 \ EXTTYP==6)#             Mixed type                       CR22 187
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR22 188
IF(DSTEXT==0)#                         Gauss distr.                     CR22 189
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR22 190
DPSIR=(PSI/RHO)**3#                    D(psi)/d(rho)                    CR22 191
DPSIG=(PSI/G)**3*SIN2T*SIN2T#          D(psi)/d(g)                      CR22 192
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR22 193
ELSE#                                  Lorentz distr.                   CR22 194
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR22 195
DPSIR=(PSI/RHO)**2#                    D(psi)/d(rho)                    CR22 196
DPSIG=(PSI/G)**2*SIN2T#                D(psi)/d(g)                      CR22 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR22 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR22 199
ELSE IF(PRMEXT==yes:) DPSIR=1.#        D(psi)/d(rho); prim.ext.         CR22 200
ELSE                  DPSIG=1./SIN2T#  D(psi)/d(g)  ; sec. ext.         CR22 201
#                                                                       CR22 202
IF(RADTYP==1)#                         Xray                             CR22 203
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR22 204
ZP1=0.;ZP2=0.#                         Default deriv.                   CR22 205
IF(PRMEXT==yes:)#                      Prim. extinction                 CR22 206
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR22 207
ZP1=-.5*YP1**3*(CP+AP*XP1*(2.+BP*XP1)/(1.+BP*XP1)**2)#                  CR22 208
ZP2=-.5*YP2**3*(CP+AP*XP2*(2.+BP*XP2)/(1.+BP*XP2)**2)#                  CR22 209
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR22 210
ZS1=-.5*YS1**3*(CS+AS*XS1*(2.+BS*XS1)/(1.+BS*XS1)**2)#                  CR22 211
ZS2=-.5*YS2**3*(CS+AS*XS2*(2.+BS*XS2)/(1.+BS*XS2)**2)#                  CR22 212
#                                                                       CR22 213
OM1=FACT*$#                            Omega 1                          CR22 214
(POL1*(XS1*ZS1+YS1)*(XP1*ZP1+YP1)+$#                                    CR22 215
 POL2*(XS2*ZS2+YS2)*(XP2*ZP2+YP2))#                                     CR22 216
#                                                                       CR22 217
IF(EXTTYP==1\EXTTYP==4\EXTTYP==3\EXTTYP==6)# Some of type i             CR22 218
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR22 219
OM2=FACT*(POL1**2*YP1*ZS1*YP1+$#       Omega 2                          CR22 220
          POL2**2*YP2*ZS2*YP2)*DPSIG#                                   CR22 221
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR22 222
#                                                                       CR22 223
IF(PRMEXT==yes:)#                      Some of type ii                  CR22 224
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR22 225
OM3=FACT*$#                            Omega 3                          CR22 226
(2.*POL1**2*GAMMAP*RHO*ZP1*(XS1*ZS1+YS1)$#                              CR22 227
   +POL1**2*GAMMAS*DPSIR*ZS1*YP1*YP1$#                                  CR22 228
+2.*POL2**2*GAMMAP*RHO*ZP2*(XS2*ZS2+YS2)$#                              CR22 229
   +POL2**2*GAMMAS*DPSIR*ZS2*YP2*YP1)#                                  CR22 230
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR22 231
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR22 232
#                                                                       CR22 233
ELSE#                                  Neutr                            CR22 234
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR22 235
ZP=0.#                                 Default derivative               CR22 236
IF(PRMEXT==yes:)#                      Deriv.; prim. ext.               CR22 237
ZP=-.5*YP**3*(CP+AP*XP*(2.+BP*XP)/(1.+BP*XP)**2)#                       CR22 238
ZS=-.5*YS**2*(CS+AS*XS*(2.+BS*XS)/(1.+BS*XS)**2)#                       CR22 239
OM1=(XS*ZS+YS)*(XP*ZP+YP)#             Omega 1                          CR22 240
IF(EXTTYP==1\EXTTYP==4\EXTTYP==3\EXTTYP==6)# Some of type i             CR22 241
OM2=YP*YP*ZS*DPSIG#                    Omega 2                          CR22 242
IF(PRMEXT==yes:)#                      Some of type ii                  CR22 243
OM3=GAMMAP*RHO*ZP*(XS*ZS+YS)+GAMMAS*YP*YP*ZS*DPSIR# Omega 3             CR22 244
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR22 245
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR22 246
#                                                                       CR22 247
FC=SQRT(FCSQ)#                         Calc fc                          CR22 248
IF(RFLTYP==0) FACT=1.#                 Mult. factor for f ref.          CR22 249
ELSE          FACT=FC*YEXT#            Idem for f2 or i ref.            CR22 250
DEREXT=FACT*YEXT*OM1/FC#               Deriv. multiplier for parms      CR22 251
L13EXT=II#                             Point to ext. deriv.             CR22 252
IF(EXTTYP<=1\EXTTYP==3\EXTTYP==4\EXTTYP==6)# Some of type i             CR22 253
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR22 254
QX(L13EXT)=.5*FACT*DERFAC*FC*FCSQ*GAMMAS*OM2/YEXT# Deriv. to g          CR22 255
IF(EXTTYP==3 \ EXTTYP==6)#             Mixed crystal                    CR22 256
L13EXT=L13EXT+1#                       Incr pointer                     CR22 257
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR22 258
IF(PRMEXT==yes:)$#                     Type 2 or mixed                  CR22 259
QX(L13EXT)=.5*FACT*DERFAC*FC*FCSQ*OM3/YEXT# Deriv. to ro                CR22 260
#                                                                       CR22 261
Q=DEREXT#                              Deriv. fact. for params          CR22 262
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR22 263
#                                                                       CR22 264
RETURN#                                                                 CR22 265
END#                                                                    CR22 266
systemheader:(CR24)#                   Calc restraints & derviv.        CR24   1
# ############################################################# #       CR24   2
#                                                               #       CR24   3
#                              CR24                             #       CR24   4
#                                                               #       CR24   5
# ############################################################# #       CR24   6
SUBROUTINE CR24#                       R. olthof                        CR24   7
#                                      February 1989                    CR24   8
include:(AACOMN)#                                                       CR24   9
include:(CRCOMN)#                                                       CR24  10
#                                                                       CR24  11
INTEGER CLASS#     ## RESTRAINT CLASS: BON/ANG/TOR/PLA                  CR24  12
REAL    C1,C2,C3,C4,C5,C6## VECTOR COORDS IN CALC OF TORSION ANGLE      CR24  13
REAL    COSPHI#    ## COS(ANGLE)                                        CR24  14
REAL    DELTA#     ## IDEAL - CALCULATED VALUE                          CR24  15
REAL    DX(3)#     ## DIFFERENCE VECTOR                                 CR24  16
REAL    DY(6)#     ## DIFFERENCE VECTOR +/- EPS                         CR24  17
REAL    D(9,13)#   ## LENGTH OF DIFFERENCE VECTORS/ORTH. VECOR COORDS   CR24  18
REAL    E(7)#      ## EPS X,Y,Z                                         CR24  19
INTEGER I,J,JJ,K,KK,L,N#               Indices in loops                 CR24  20
INTEGER I1#        ## POINTER TO FIRST VARIABLE PARAMETER               CR24  21
INTEGER I7#        ## POINTER IN MARK7 ARRAY                            CR24  22
INTEGER J1,J2,JH#  ## POINTERS TO TWO RESTR ATOMS                       CR24  23
INTEGER L0,L5,L7,L8,L11,L12## POINTERS IN MARK-ARRAYS                   CR24  24
INTEGER LCON#      ## POINTER IN CONSTRAINTS ARRAY                      CR24  25
INTEGER N1,N2#     ## POINTERS IN MARK5 & MARK11 ARRAY                  CR24  26
INTEGER NATM#      ## NR OF ATOMS IN RESTR                              CR24  27
INTEGER NBLK#      ## NUMBER OF BLOCKS WITH SAME VARBLK                 CR24  28
INTEGER NPAR#      ## NUMBER OF PARAMETERS IN RESTR                     CR24  29
INTEGER NVEC#      ## NR OF VECTORS IN RESTR                            CR24  30
INTEGER PCON#      ## CONSTRAINED PARAM                                 CR24  31
REAL    Q#         ## SCRATCH IN DERIV.MULT.                            CR24  32
INTEGER S#         ## SYMOP NUMBER                                      CR24  33
INTEGER TR(3)#     ## translation vector base 555                       CR24  34
REAL    V#         ## CALCULATED VALUE (BOND, ETC)                      CR24  35
REAL    VAL#       ## VALUE OF BOND/ANGLE/TORSION A/PLANE               CR24  36
INTEGER V1,V2#     ## LAST VARNR IN PRECEEDING AND CURRENT BLOCK        CR24  37
INTEGER VAR1,VAR2# ## VARIABLE NUMBERS                                  CR24  38
INTEGER VARBLK#    ## NUMBER OF VARIABLES/BLOCK                         CR24  39
REAL    W#         ## SCALE FACTOR FOR WEIGHTS                          CR24  40
REAL    WS#        ## SQRT(WEIGHT) FOR RESTRAINTS                       CR24  41
REAL    X(6)#      ## ATOM COORDS                                       CR24  42
#                                                                       CR24  43
chardata:(CR241, RESTRAINTS)#                                           CR24  44
chardata:(CR242, CLASS    IDEAL    CALC   DELTA   SIGMA)#               CR24  45
chardata:(CR243,- BOND ANGLE DIHED PLANE  )#                            CR24  46
realdata:(FMT1,[842.,842.,842.,842.])#                                  CR24  47
realdata:(FMT2,[822.,822.,822.,822.])#                                  CR24  48
realdata:(RAD,[57.29578])#                                              CR24  49
datastuff:#                                                             CR24  50
#                                                                       CR24  51
#         INITIALIZATIONS                                               CR24  52
#         ---------------                                               CR24  53
#                                                                       CR24  54
E(1)=0.#                               Scratch                          CR24  55
DO I=1,3; E(I+1)=.00001#               Eps in deriv calc                CR24  56
DO I=1,3; E(I+4)=-E(I+1)#              Idem, for 2nd at of vector       CR24  57
W=(RSUMS(17)+RSUMS(18)-RSUMS(42)-RSUMS(43))/$# Weight factor            CR24  58
  (RSUMS(23)+RSUMS(24)-RSUMS(48)-RSUMS(49)-FLOAT(VARTOT))#              CR24  59
W=W/FLOAT(NSKIP)#                      Correct for nr of skip refl.     CR24  60
#                                                                       CR24  61
#         CALCULATION OF BONDS, ANGLES, ETC. & DERIVATIVES              CR24  62
#         ------------------------------------------------              CR24  63
#                                                                       CR24  64
FOR(I7=MARK7;I7<MARK8;I7=I7+4+5*NATM)# Loop over restraints             CR24  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR24  66
CLASS=NINT(QX(I7+1))#                  Restraint class                  CR24  67
NATM=NINT(QX(I7+2));L7=I7+4#           Nr of atoms; pntr                CR24  68
NPAR=3*NATM#                           Nr of parameters                 CR24  69
IF(CLASS==1) NVEC=1#                   One vector for class=bon         CR24  70
ELSE         NVEC=3#                   Otherwhise 3 vectors             CR24  71
J1=I7+4;J2=I7+6#                       Pointers to at1 and at2          CR24  72
WS=SQRT(W)/QX(I7+4)#                   Sqrt(weight) for obs.eq.         CR24  73
#                                                                       CR24  74
## LOOP OVER VECTORS                                                    CR24  75
#                                                                       CR24  76
DO J=1,NVEC#                           Loop over vectors                CR24  77
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR24  78
L5=NINT(QX(J1+1))#                     Point to first atom              CR24  79
S=NINT(QX(J1+2))#                      Get nsym and trans               CR24  80
TR(1)=MOD(S/100,10)#                   Get x translation                CR24  81
TR(2)=MOD(S/10,10)#                    Get y translation                CR24  82
TR(3)=MOD(S,10)#                       Get z translation                CR24  83
DO K=1,4,3#                            Loop over atoms of vector        CR24  84
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR24  85
L0=MARK0+(S/1000-1)*12#                Pntr to rot. & transl.           CR24  86
DO JJ=0,2#                             Loop over the coords             CR24  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR24  88
X(K+JJ)=QX(L0+1)*QX(L5+2)$#            Symm. eq. coords                 CR24  89
       +QX(L0+4)*QX(L5+3)$#                                             CR24  90
       +QX(L0+7)*QX(L5+4)$#                                             CR24  91
       +QX(L0+10)+ FLOAT(TR(JJ+1)-5)#  Add translations                 CR24  92
L0=L0+1#                               Adjust pntr                      CR24  93
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR24  94
L5=NINT(QX(J2+1))#                     Point to second atom             CR24  95
S=NINT(QX(J2+2))#                      Get nsym and trans               CR24  96
TR(1)=MOD(S/100,10)#                   Get x translation                CR24  97
TR(2)=MOD(S/10,10)#                    Get y translation                CR24  98
TR(3)=MOD(S,10)#                       Get z translation                CR24  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR24 100
#                                                                       CR24 101
DO JJ=1,3#                             Loop over coords                 CR24 102
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR24 103
DX(JJ)=X(JJ)-X(JJ+3)#                  Dx, dy, dz                       CR24 104
IF(DX(JJ)> .5) DX(JJ)=DX(JJ)-1.#                                        CR24 105
IF(DX(JJ)<-.5) DX(JJ)=DX(JJ)+1.#                                        CR24 106
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR24 107
#                                                                       CR24 108
## LOOP OVER VECTOR & DERIVATIVE VECTORS                                CR24 109
#                                                                       CR24 110
DO K=1,7#                              Loop over 7 vectors              CR24 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR24 112
DO JJ=1,3; DY(JJ)=DX(JJ)#              Start values of dx,dy,dz         CR24 113
IF(K==1) I=1#                          Point to colm in derv matrix     CR24 114
ELSE#                                  Vector for calc of derv          CR24 115
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR24 116
IF(K==2)#                              Derv vector of at1               CR24 117
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR24 118
I=(J1-I7-4)/2*3+2#                     Point to colm in d matrix        CR24 119
S=NINT(QX(J1+2))#                      Symop for at1                    CR24 120
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR24 121
ELSE IF(K==5)#                         Derv vector of at2               CR24 122
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR24 123
I=(J2-I7-4)/2*3+2#                     Point to colm in d matrix        CR24 124
S=NINT(QX(J2+2))#                      Symop of at2                     CR24 125
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR24 126
KK=MOD((K-2),3)+1#                     Point to x,y,z                   CR24 127
IF(KK==1) L0=MARK0+(S/1000-1)*12#      Point to symop                   CR24 128
IF(L0==MARK0) DY(KK)=DX(KK)+E(K)#      Add eps                          CR24 129
ELSE#                                  Symop                            CR24 130
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR24 131
DO JJ=1,3;DY(JJ)=DY(JJ)+QX(L0+JJ)*E(K)# Apply symop to eps              CR24 132
L0=L0+3#                               Incr symop pointer               CR24 133
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR24 134
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR24 135
#                                                                       CR24 136
IF(CLASS<=2)#                          *** bond / angle ***             CR24 137
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR24 138
D(J,I)=CELL(31)*DY(1)*DY(1)+CELL(35)*DY(2)*DY(2)+CELL(39)*DY(3)*DY(3)+$#CR24 139
   2.*(CELL(32)*DY(1)*DY(2)+CELL(33)*DY(1)*DY(3)+CELL(36)*DY(2)*DY(3))# CR24 140
IF(K==1)#                              If current calc is for vector    CR24 141
DO I=1,NPAR; D(J,I+1)=D(J,1)#          Copy dist to all el. of this r   CR24 142
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR24 143
ELSE IF(CLASS==3)#                     *** torsion angle ***            CR24 144
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR24 145
L=(J-1)*3#                             Point to col.                    CR24 146
DO JJ=1,3#                             Loop over dx,dy,dz               CR24 147
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR24 148
D(L+JJ,I)=CELL(JJ+12)*DY(1)+CELL(JJ+15)*DY(2)+CELL(JJ+18)*DY(3)# Orth   CR24 149
IF(K==1)#                              If current calc is for vectors   CR24 150
DO N=1,NPAR; D(L+JJ,N+1)=D(L+JJ,1)#    Copy vector to all el. of this   CR24 151
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR24 152
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR24 153
IF(ICYCLE==NCYCLE) BREAK#              Break if last cycle              CR24 154
I=I+1#                                 Point to next colm in d matrix   CR24 155
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR24 156
#                                                                       CR24 157
IF(J==1)                 J1=I7+ 8#     Point to at3                     CR24 158
ELSE IF(J==2 & CLASS==2) J2=I7+ 4#     Point to at1                     CR24 159
ELSE                     J2=I7+10#     Point to at4                     CR24 160
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR24 161
#                                                                       CR24 162
## CALCULATE  VALUES & DERIVATIVES                                      CR24 163
#                                                                       CR24 164
DO K=1,NPAR+1#                         Loop over vector/derivative ve   CR24 165
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR24 166
IF(CLASS==1)#                          *** bond ***                     CR24 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR24 168
V=SQRT(D(1,K))#                        Bond distance                    CR24 169
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR24 170
ELSE IF(CLASS==2)#                     *** angle ***                    CR24 171
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR24 172
COSPHI=(D(1,K)+D(2,K)-D(3,K))/(2.*SQRT(D(1,K)*D(2,K)))# Cos(angle)      CR24 173
IF(ABS(COSPHI)<.999999)  V=ACOS(COSPHI)*RAD# Angle                      CR24 174
ELSE IF(ABS(COSPHI)>0.0) V=0.0#        Angle = 0.                       CR24 175
ELSE                     V=360.0#      Angle = 360.                     CR24 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR24 177
ELSE IF(CLASS==3)#                     *** dihedral angle ***           CR24 178
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR24 179
C1=D(2,K)*D(6,K)-D(3,K)*D(5,K)#        Vector products                  CR24 180
C2=D(3,K)*D(4,K)-D(1,K)*D(6,K)#                                         CR24 181
C3=D(1,K)*D(5,K)-D(2,K)*D(4,K)#                                         CR24 182
C4=D(6,K)*D(8,K)-D(5,K)*D(9,K)#                                         CR24 183
C5=D(4,K)*D(9,K)-D(6,K)*D(7,K)#                                         CR24 184
C6=D(5,K)*D(7,K)-D(4,K)*D(8,K)#                                         CR24 185
COSPHI=(C1*C4+C2*C5+C3*C6)/$#                                           CR24 186
  SQRT((C1*C1+C2*C2+C3*C3)*(C4*C4+C5*C5+C6*C6))# Cos(dihedral angle)    CR24 187
IF(ABS(COSPHI)>1.0) COSPHI=SIGN(1.0,COSPHI)#                            CR24 188
V=180.-ACOS(COSPHI)*RAD#                                                CR24 189
Q=(C2*C6-C3*C5)*D(4,K)+$#              Place angle in proper quadrant   CR24 190
  (C3*C4-C1*C6)*D(5,K)+$#                                               CR24 191
  (C1*C5-C2*C4)*D(6,K)#                                                 CR24 192
IF(Q>.0) V=-V#                                                          CR24 193
IF(V>180.) V=V-360.#                                                    CR24 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR24 195
IF(K==1)#                              If first pass                    CR24 196
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR24 197
VAL=V#                                 Value of bond, etc.              CR24 198
IF(ICYCLE==NCYCLE) BREAK#              Exit if last cycle               CR24 199
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR24 200
ELSE#                                  Derivative vector                CR24 201
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR24 202
L=MOD(K-2,3)+2#                        Point to shift vector el.        CR24 203
QX(MARK13+K-1)=WS*(V-VAL)/E(L)#        Derivative                       CR24 204
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR24 205
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR24 206
#                                                                       CR24 207
## CALCULATE DELTA                                                      CR24 208
#                                                                       CR24 209
DELTA=QX(I7+3)-VAL#                    Ideal - calc                     CR24 210
IF(CLASS>1)#                           (dihedral) angle                 CR24 211
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR24 212
IF(DELTA>180.)       DELTA=DELTA-360.# Adjust delta                     CR24 213
ELSE IF(DELTA<-180.) DELTA=DELTA+360.#                                  CR24 214
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR24 215
#                                                                       CR24 216
#         APPLY CONSTRAINTS                                             CR24 217
#         -----------------                                             CR24 218
#                                                                       CR24 219
L7=I7+4+2*NATM#                        Point to first var nr            CR24 220
DO I1=1,NPAR#                          Loop over the parameters         CR24 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR24 222
ifne:(QX(L7+I1),0.) NEXT#              Skip if variable                 CR24 223
L=I7+4+(I1-1)/3*2#                     Atom pointer                     CR24 224
L5=NINT(QX(L+1))+MOD(I1-1,3)+2#        Atom parameter pointer           CR24 225
LCON=MARK10;nextconstr:(0)#            Get first constr                 CR24 226
REPEAT#                                Loop over the constr             CR24 227
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR24 228
IF(L5==PCON)#                          Param is constrained             CR24 229
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR24 230
DO I=1,I1#                             Loop over preceeding params      CR24 231
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR24 232
ifne:(QX(LCON+5),QX(L7+2*I-1)) NEXT#   No match of var nrs              CR24 233
QX(MARK13+I)=QX(MARK13+I)+QX(LCON+6)*QX(MARK13+I1)# Adjust deriv        CR24 234
BREAK#                                 Exit second param loop           CR24 235
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR24 236
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR24 237
IF(PCON<0) nextconstr:(1)#             Invariant param                  CR24 238
ELSE       nextconstr:(NINT(QX(LCON+3)))# Constrained param             CR24 239
IF(IABS(PCON)>L5) BREAK#               Exit after constr was passed     CR24 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR24 241
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR24 242
#         STATISTICS                                                    CR24 243
#         ----------                                                    CR24 244
#                                                                       CR24 245
RSUMS(59)=RSUMS(59)+1.#                Sum nr of restraints             CR24 246
RSUMS(60)=RSUMS(60)+WS*WS*DELTA*DELTA# Sum weight*delta**2              CR24 247
#                                                                       CR24 248
#         OUTPUT OF RESTRAINTS INFO                                     CR24 249
#         -------------------------                                     CR24 250
#                                                                       CR24 251
IF(I7==MARK7)#                         If first restraint, print head   CR24 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR24 253
LINRM=10#                              Line room on page                CR24 254
movechar:(CR243,1,CHROT,2,10,1)#       Underline                        CR24 255
writeline:(4,CR241,NCR241,2,3)#        =restraints=                     CR24 256
writeline:(0,0,0,2,3)#                 Write blank line                 CR24 257
HEADOT=' ';HEADOT(2^6)='ATOMS'#        Setup subheader                  CR24 258
JH=LABMAX*4+8;HEADOT(JH^)=CR242#       Setup subheader                  CR24 259
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR24 260
L7=I7+2;  L=-LABMAX#                   Pntr to atom-pntr; in output l   CR24 261
DO J=1,NATM#                           Loop over atoms                  CR24 262
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR24 263
L7=L7+2;L5=NINT(QX(L7+1));L=L+LABMAX+2# Adjust pointers                 CR24 264
movertoc:(QX(L5-name:),1,CHROT,L,24,0)# J-th atom id                    CR24 265
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR24 266
movechar:(CR243,CLASS*6-4,CHROT,JH+1,5,0)# =bond/angle/torsion/plane=   CR24 267
BUFOT(1)=QX(I7+3);  BUFOT(2)=VAL#      Values: ideal & calc             CR24 268
BUFOT(3)=DELTA;     BUFOT(4)=QX(I7+4)# Delta & sigma                    CR24 269
LCHROT=JH+6#                           Point to format start            CR24 270
IF(CLASS==1)ncodefld:(BUFOT,1,CHROT,FMT1,4)# Encode restraints info     CR24 271
ELSE        ncodefld:(BUFOT,1,CHROT,FMT2,4)# Encode restraints info     CR24 272
writeline:(0,HEADOT,100,1,3)#          Write restraints info            CR24 273
#                                                                       CR24 274
#                                                                       CR24 275
#         BUILD THE MATRIX                                              CR24 276
#         ----------------                                              CR24 277
#                                                                       CR24 278
IF(ICYCLE==NCYCLE) NEXT#               Goto next restr if last cycle    CR24 279
DELTA=WS*DELTA#                        Multiply with sqrt(weight)       CR24 280
L7=I7+4+2*NATM#                        Point to variable numbers        CR24 281
FOR(I1=1;I1<=NPAR;I1=I1+1)#            Loop over parameters             CR24 282
ifne:(QX(L7+I1),0.) BREAK#             Exit after first variable        CR24 283
#                                                                       CR24 284
REPEAT#                                Loop over parameters             CR24 285
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR24 286
L11=MARK11;L12=MARK12#                 Pointers in matrix & vector      CR24 287
V1=0;VAR1=NINT(QX(L7+I1))#             Last & current var nr            CR24 288
FOR(L8=MARK8+1;L8<MARK9;L8=L8+2)#      Loop over the blocks             CR24 289
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR24 290
NBLK=NINT(QX(L8+1));VARBLK=NINT(QX(L8+2))# Nr of blocks; nr of var/bl   CR24 291
DO I=1,NBLK#                           Loop over subblocks              CR24 292
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR24 293
IF(VAR1<=V1+VARBLK) GOTO 100#          Requested block found            CR24 294
V1=V1+VARBLK#                          Incr total nr of var             CR24 295
L11=L11+VARBLK*(VARBLK+1)/2#           Adjust pointer in matrix         CR24 296
L12=L12+VARBLK#                        Adjust pointer in vector         CR24 297
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR24 298
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR24 299
100 V2=V1+VARBLK#                      Last var nr in current block     CR24 300
#                                                                       CR24 301
## SUM MATRIX AND VECTOR                                                CR24 302
#                                                                       CR24 303
FOR(I=I1;I<=NPAR;I=I+1)#               First loop over parameters       CR24 304
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR24 305
VAR1=NINT(QX(L7+I))#                   Varnr of current param           CR24 306
IF(VAR1==0) NEXT#                      Invariable                       CR24 307
IF(VAR1<=V1 \ VAR1>V2) BREAK#          Variable not in current block    CR24 308
VAR1=VAR1-V1#                          Varnr in current block           CR24 309
N1=L11+((VAR1-1)*(VARBLK+VARBLK-VAR1+2))/2+1# Pointer in matrix         CR24 310
Q=QX(MARK13+I)#                        Derivative                       CR24 311
QX(N1)=QX(N1)+Q*Q#                     Sum diagonal matrix element      CR24 312
DO J=I+1,NPAR#                         Second loop over parameters      CR24 313
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR24 314
VAR2=NINT(QX(L7+J))#                   Var nr of sec. param             CR24 315
IF(VAR2==0) NEXT#                      Invariable                       CR24 316
IF(VAR2<=V1 \ VAR2>V2) BREAK#          Variable not in current block    CR24 317
VAR2=VAR2-V1#                          Varnr in current block           CR24 318
IF(VAR2>VAR1) N2=N1+VAR2-VAR1#         Point to matrix element          CR24 319
ELSE N2=L11+((VAR2-1)*(VARBLK+VARBLK-VAR2+2))/2+1+VAR1-VAR2#            CR24 320
QX(N2)=QX(N2)+Q*QX(MARK13+J)#          Sum matrix element               CR24 321
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR24 322
QX(L12+VAR1)=QX(L12+VAR1)+Q*DELTA#     Sum vector element               CR24 323
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR24 324
I1=I;IF(I1>NPAR) BREAK#                Exit after last parameter        CR24 325
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR24 326
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR24 327
#                                                                       CR24 328
RETURN#                                                                 CR24 329
END#                                                                    CR24 330
systemheader:(CR26)#                   Sums and discrepancies           CR26   1
# ####################################################################  CR26   2
#                                                                       CR26   3
#                               CR26                                    CR26   4
#                                                                       CR26   5
# ####################################################################  CR26   6
SUBROUTINE CR26#                       R. olthof   august 1980          CR26   7
#                                      May 1985                         CR26   8
include:(CRCOMN)#                                                       CR26   9
include:(AACOMN)#                                                       CR26  10
#                                                                       CR26  11
INTEGER I,L#        ##                                                  CR26  12
REAL    VAR#        ## VAR NR                                           CR26  13
REAL SSS(3)#        ## SIGMA OF CHI_SQUARED (SS)                        CR26  14
#                                                                       CR26  15
chardata:(CR261, STRUCTURE FACTOR SUMS BEFORE CYCLE  1)#                CR26  16
chardata:(CR262,'        Rcode=1        Rcode=2')#                      CR26  17
chardata:(CR263,'sum|FOBS| sum|FCAL| sum|FO-FC|')#                      CR26  18
chardata:(CR264,'R-factor  (using |F|)wR-factor (using |Y|)')#          CR26  19
chardata:(CR265, REFLECTIONS CONTRIBUTING TO LS MATRIX)#                CR26  20
chardata:(CR266, ALL REFLECTIONS)#                                      CR26  21
chardata:(CR267,' Number of restraints')#                               CR26  22
chardata:(CR268,' Number of variables ')#                               CR26  23
chardata:(CR269,' Number of reflections')#                              CR26  24
chardata:(CR26A,' Goodness of fit S with restr.')#                      CR26  25
chardata:(CR26B,'        Rcode=1        Rcode>1')#                      CR26  26
chardata:(CR26C,' Sigma on g.o.f. S with restr ')#                      CR26  27
chardata:(CR270,AFTER BEFORE CYCLE  1)#                                 CR26  28
realdata:(FMT,[401522.,551522.,701522.,$#                               CR26  29
401552.,551552.,701552.,400613.,550613.,700613.])#                      CR26  30
##401532.,551532.,701532.,400613.,550613.,700613.])#                    CR26  31
datastuff:#                                                             CR26  32
#                                                                       CR26  33
#       OUTPUT OF SUMS AND DISCREPANCIES                                CR26  34
#       --------------------------------                                CR26  35
#                                                                       CR26  36
LINRM=18#                                                               CR26  37
IF(ICYCLE==1) movechar:(CR270,7,CR261,24,15,0)# Insert 'before'         CR26  38
ELSE#                                  For all other cycles             CR26  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR26  40
movechar:(CR270,1,CR261,24,6,0)#       Insert 'after'                   CR26  41
ncodefld:(FLOAT(ICYCLE-1),1,CR261,380213.,1)# Format cycle number       CR26  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR26  43
movechar:(CR263,27,CHROT,2,37,1)#      Underline character              CR26  44
writeline:(1,CR261,NCR261,2,1)#        Structure factor sums            CR26  45
#                                                                       CR26  46
#        OUTPUT OF SUMS AND DISCREPANCIES                               CR26  47
#        --------------------------------                               CR26  48
#                                                                       CR26  49
DO I=1,22,3#                           Loop over output items           CR26  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR26  51
RSUMS(I+26)=RSUMS(I+1)-RSUMS(I+26)#    Values for build refl.           CR26  52
RSUMS(I+27)=RSUMS(I+2)-RSUMS(I+27)#    Values for build refl.           CR26  53
RSUMS(I   )=RSUMS(I+1)+RSUMS(I+2)#     Total fobs                       CR26  54
RSUMS(I+25)=RSUMS(I+26)+RSUMS(I+27)#   Total fcal                       CR26  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR26  56
VAR=FLOAT(VARTOT)#                     Nr of variables                  CR26  57
L=25#                                  Point to first item              CR26  58
REPEAT#                                Loop over 2 sets of sums         CR26  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR26  60
DO I=1,3#                              All refl/rcode=1 r./recode=2     CR26  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR26  62
L=L+1;  R0(I)=0.;  RW(I)=0.;  SS(I)=0.; SSS(I)=0.# Point to next        CR26  63
IF(ABS(RSUMS(L   ))>small:) R0(I)=RSUMS(L+6)/RSUMS(L)# R-factor         CR26  64
IF(ABS(RSUMS(L+18))>small:) RW(I)=SQRT(RSUMS(L+15)/RSUMS(L+18))# Rw     CR26  65
IF((RSUMS(L+21)-VAR)>small:)#          If (n-m) not zero                CR26  66
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR26  67
SS(I)=SQRT(RSUMS(L+15)/(RSUMS(L+21)-VAR))# Swd/(n-m)                    CR26  68
SSS(I)=SS(I)/SQRT(2.*(RSUMS(L+21)-VAR))# Sigma on chi-squared (ss)      CR26  69
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR26  70
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR26  71
L=L-2#                                 Reset pointer                    CR26  72
#                                                                       CR26  73
# PRINT TABLE                                                           CR26  74
#                                                                       CR26  75
IF(L>25)#                              Sums for build reflections       CR26  76
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR26  77
QX(MARK14+1)=(RSUMS(41)+RSUMS(60))/$#                                   CR26  78
             (RSUMS(47)+RSUMS(59)-VAR)# Save swd/(n-m) for st.dev       CR26  79
movechar:(CR265,1,CHROT,1,NCR265,0)#   Refl. contr. to matrix           CR26  80
writeline:(1,0,0,1,1)#                 Write this line                  CR26  81
movechar:(CR262,1,CHROT,41,NCR262,0)#  All refl. omit l-t l-t only      CR26  82
writeline:(0,0,0,1,1)#                 Write this line                  CR26  83
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR26  84
ELSE#                                  All reflections                  CR26  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR26  86
movechar:(CR266,1,CHROT,1,NCR266,0)#   All reflections                  CR26  87
writeline:(1,0,0,1,1)#                 Write reflection set             CR26  88
movechar:(CR26B,1,CHROT,41,NCR262,0)#  All refl. omit l-t l-t only      CR26  89
writeline:(0,0,0,1,1)#                 Write this line                  CR26  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR26  91
movechar:(CR263,1,CHROT,2,10,0)#                                        CR26  92
ncodefld:(RSUMS,L,CHROT,FMT,3)#                                         CR26  93
writeline:(0,0,0,1,1)#                 Sum/fobs/                        CR26  94
movechar:(CR263,11,CHROT,2,10,0)#                                       CR26  95
ncodefld:(RSUMS,L+3,CHROT,FMT,3)#                                       CR26  96
writeline:(0,0,0,1,1)#                 Sum/fcal/                        CR26  97
movechar:(CR263,21,CHROT,2,10,0)#                                       CR26  98
ncodefld:(RSUMS,L+6,CHROT,FMT,3)#                                       CR26  99
writeline:(0,0,0,1,1)#                 Sum/fobs-fcal/                   CR26 100
movechar:(CR26A,1,CHROT,1,18,0)#                                        CR26 101
ncodefld:(SS,1,CHROT,FMT(4),3)#                                         CR26 102
writeline:(0,0,0,1,1)#                 Goodness of fit value            CR26 103
movechar:(CR26C,1,CHROT,1,18,0)#                                        CR26 104
ncodefld:(SSS,1,CHROT,FMT(4),3)#                                        CR26 105
writeline:(0,0,0,1,1)#                 Goodness of fit sigma value      CR26 106
movechar:(CR264,1,CHROT,2,21,0)#                                        CR26 107
ncodefld:(R0,1,CHROT,FMT(4),3)#                                         CR26 108
writeline:(1,0,0,1,1)#                 R-factor                         CR26 109
movechar:(CR264,22,CHROT,2,21,0)#                                       CR26 110
ncodefld:(RW,1,CHROT,FMT(4),3)#                                         CR26 111
writeline:(0,0,0,1,1)#                 Rw-factor                        CR26 112
movechar:(CR268,1,CHROT,1,NCR268,0)#                                    CR26 113
RSUMS(L+25)=VAR#                                                        CR26 114
ncodefld:(RSUMS,L+25,CHROT,FMT(7),1)#  Encode number of variables       CR26 115
writeline:(1,0,0,1,1)#                 Number of variables              CR26 116
movechar:(CR269,1,CHROT,1,NCR269,0)#                                    CR26 117
ncodefld:(RSUMS,L+21,CHROT,FMT(7),3)#                                   CR26 118
writeline:(0,0,0,1,1)#                 Number of reflections            CR26 119
IF(RSUMS(59)>0.)#                      If restraints present            CR26 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR26 121
movechar:(CR267,1,CHROT,1,NCR267,0)#                                    CR26 122
ncodefld:(RSUMS(59),1,CHROT,FMT(7),1)#                                  CR26 123
writeline:(0,0,0,1,1)#                 Number of restraints             CR26 124
movechar:(CR26A,1,CHROT,1,NCR26A,0)#                                    CR26 125
ncodefld:(SQRT(QX(MARK14+1)),1,CHROT,FMT(4),1)#                         CR26 126
writeline:(0,0,0,1,1)#                 Sqrt(sum(w*delta**2/(nall-var)   CR26 127
movechar:(CR26C,1,CHROT,1,NCR26C,0)#                                    CR26 128
ncodefld:(SQRT(QX(MARK14+1)/(2.*$#                                      CR26 129
(RSUMS(47)+RSUMS(59)-VAR))),1,CHROT,FMT(4),1)#                          CR26 130
writeline:(0,0,0,1,1)#                 Sigma on s with restraints       CR26 131
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR26 132
IF(L<25) BREAK#                        All has been printed             CR26 133
IF(TERMNT!=0)#                         If convergence or r test         CR26 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR26 135
IF((NINT(1000.*R0(1))+1)>TERMNT)#      Set to last cycle                CR26 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR26 137
NCYCLE=ICYCLE+1;   TERMNT=0#           Set as last cycle                CR26 138
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR26 139
ELSE TERMNT=NINT(1000.*R0(1))#         Save 1000 * r                    CR26 140
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR26 141
IF(ICYCLE<NCYCLE) BREAK#               Not last cycle                   CR26 142
ifeq:(RSUMS(22),RSUMS(47)) BREAK#      All refl reported                CR26 143
L=0#                                   Set pointer to set for all r     CR26 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR26 145
RETURN#                                                                 CR26 146
END#                                                                    CR26 147
systemheader:(CR30)#                   Matrix inversion                 CR30   1
# ####################################################################  CR30   2
#                                                                       CR30   3
#                               CR30                                    CR30   4
#                                                                       CR30   5
# ####################################################################  CR30   6
SUBROUTINE CR30#                       R.olthof   august 1980           CR30   7
#                                      May 1985                         CR30   8
include:(AACOMN)#                                                       CR30   9
include:(CRCOMN)#                                                       CR30  10
#                                                                       CR30  11
REAL    FACT#      ## FACTOR FOR ST.DEV.                                CR30  12
INTEGER I,J,K,P#   ##                                                   CR30  13
INTEGER L8#        ## POINTER IN MARK8 ARRAY                            CR30  14
INTEGER L11,L11K,L11P,L11KK,L11KP,L11KJ,L11PK,L11PP,L11PJ#              CR30  15
INTEGER L12,L12K,L12P,L13,L13J,L13P#                                    CR30  16
INTEGER NBLK#      ## NUMBER OF BLOCKS                                  CR30  17
REAL    Q#         ##                                                   CR30  18
INTEGER VARBLK#    ## NO. OF VARIABLES IN A BLOCK                       CR30  19
#                                                                       CR30  20
#       MATRIX INVERSION                                                CR30  21
#       ----------------                                                CR30  22
#                                                                       CR30  23
IF(ICYCLE==(NCYCLE-1))#                Last cycle for matrix inv.       CR30  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR30  25
IF(LISTMA==1) LISTMA=2#                Direct/inverted matrices         CR30  26
ELSE IF(LISTMA==3) LISTMA=4#           Correlation matrix               CR30  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR30  28
IF(LISTMA==4) CALL CR31(1)#            List direct matrix/vector        CR30  29
IF(REFUOV<0)#                          Skf-b correlation                CR30  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR30  31
L11=MARK11+1;L12=MARK12+REFSKF+1#      Set pointers in matrix & vec     CR30  32
FOR(I=0;I<REFSKF;I=I+1) L11=L11+VARGEN-I# Skip over scale factor e      CR30  33
QX(MARK14+2)=QX(L12)/QX(L11)#          Shift(bov) from 1*1 matrix       CR30  34
QX(MARK14+3)=QX(MARK14+1)/QX(L11)#     Sd(bov) from 1*1 matrix          CR30  35
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR30  36
#                                                                       CR30  37
L11=MARK11; L12=MARK12; L13=MARK13#    Pointer in matric,vector,sig     CR30  38
FOR(L8=MARK8+2;L8<MARK9;L8=L8+2)## LOOP OVER THE BLOCKS                 CR30  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR30  40
NBLK=NINT(QX(L8));VARBLK=NINT(QX(L8+1))# Nr of blocks & variables       CR30  41
DO I=1,NBLK#                           Loop over subset of blocks       CR30  42
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR30  43
L11K=L11#                                                               CR30  44
DO K=1,VARBLK#                         Loop over variables in 1 blo     CR30  45
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR30  46
L11KK=L11K+K;L12K=L12+K#                                                CR30  47
L11P=L11#                                                               CR30  48
FOR(P=1;P<K;P=P+1)#                    Loop over 1 row                  CR30  49
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR30  50
L11PP=L11P+P;L11PK=L11P+K;L12P=L12+P#                                   CR30  51
Q=QX(L11PK)*QX(L11PP)#                                                  CR30  52
DO J=K,VARBLK#                                                          CR30  53
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR30  54
L11KJ=L11K+J;L11PJ=L11P+J#                                              CR30  55
QX(L11KJ)=QX(L11KJ)-Q*QX(L11PJ)#                                        CR30  56
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR30  57
QX(L12K)=QX(L12K)-Q*QX(L12P)#                                           CR30  58
L11P=L11P+VARBLK-P#                                                     CR30  59
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR30  60
ifne:(QX(L11KK),0.) QX(L11KK)=1./QX(L11KK)#                             CR30  61
L11K=L11K+VARBLK-K#                                                     CR30  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR30  63
L11=L11K#                                                               CR30  64
FOR(K=VARBLK;K>=1;K=K-1)#                                               CR30  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR30  66
L11KK=L11K+K;L12K=L12+K#                                                CR30  67
QX(L12K)=QX(L12K)*QX(L11KK)#                                            CR30  68
L11P=L11#                                                               CR30  69
FOR(P=VARBLK;P>K;P=P-1)#                                                CR30  70
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR30  71
L11PP=L11P+P;L11KP=L11K+P#                                              CR30  72
L12P=L12+P;L13P=L13+P#                                                  CR30  73
QX(L13P)=QX(L11KK)*QX(L11KP)#                                           CR30  74
QX(L12K)=QX(L12K)-QX(L13P)*QX(L12P)#                                    CR30  75
IF(ICYCLE!=(NCYCLE-1)) NEXT#           Inversion only in last cycle     CR30  76
QX(L11KP)=-QX(L13P)*QX(L11PP)#                                          CR30  77
FOR(J=P+1;J<=VARBLK;J=J+1)#                                             CR30  78
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR30  79
L11PJ=L11P+J;L11KJ=L11K+J;L13J=L13+J#                                   CR30  80
QX(L11KP)=QX(L11KP)-QX(L13J)*QX(L11PJ)#                                 CR30  81
QX(L11KJ)=QX(L11KJ)-QX(L13P)*QX(L11PJ)#                                 CR30  82
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR30  83
L11P=L11P-VARBLK+P-1#                                                   CR30  84
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR30  85
IF(ICYCLE==(NCYCLE-1))#                Inverted diag.el. in last c.     CR30  86
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR30  87
FOR(J=K+1;J<=VARBLK;J=J+1)#                                             CR30  88
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR30  89
L11KJ=L11K+J;L13J=L13+J#                                                CR30  90
QX(L11KK)=QX(L11KK)-QX(L13J)*QX(L11KJ)#                                 CR30  91
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR30  92
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR30  93
L11K=L11K-VARBLK+K-1#                                                   CR30  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR30  95
L11=L11+VARBLK; L12=L12+VARBLK#                                         CR30  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR30  97
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR30  98
IF(LISTMA==4)    CALL CR31(2)#         List inverted matrix/shifts      CR30  99
ELSE IF(LISTMA==2)#                    List correlation matrix          CR30 100
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR30 101
ifeq:(MALIST,0.) CALL CR31(3)#         Complete matrix                  CR30 102
ELSE             CALL CR31(4)#         Only elements > malist           CR30 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR30 104
IF(SAVEMA>0)     CALL CR31(5)#         Save corr.matrix on file         CR30 105
#                                                                       CR30 106
## CALCULATE ST.DEV. AND MOVE INTO MARK13-ARRAY                         CR30 107
#                                                                       CR30 108
L11=MARK11+1;L13=MARK13+1#             Point to matrix and sigma ar     CR30 109
FACT=QX(MARK14+1)#                     Sum(w*dsq)/(n-m)                 CR30 110
FOR(L8=MARK8+2;L8<MARK9;L8=L8+2)#      Loop over the blocks             CR30 111
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR30 112
NBLK=NINT(QX(L8));VARBLK=NINT(QX(L8+1))# Nr of blocks & variables       CR30 113
DO I=1,NBLK#                           Loop over subsets of blocks      CR30 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR30 115
DO K=1,VARBLK#                                                          CR30 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR30 117
QX(L13)=SQRT(ABS(QX(L11)*FACT))#                                        CR30 118
L11=L11+VARBLK-K+1;L13=L13+1#                                           CR30 119
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR30 120
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR30 121
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR30 122
RETURN#                                                                 CR30 123
END#                                                                    CR30 124
systemheader:(CR31)#                   List/save a matrix               CR31   1
# ################################################################## #  CR31   2
#                                                                    #  CR31   3
#                            CR31                                    #  CR31   4
#                                                                    #  CR31   5
# ################################################################## #  CR31   6
SUBROUTINE CR31(KEY)#                  R. olthof                        CR31   7
#                                      May 1985                         CR31   8
include:(AACOMN)#                                                       CR31   9
include:(CRCOMN)#                                                       CR31  10
#                                                                       CR31  11
REAL FORM(13)#                         Output format                    CR31  12
INTEGER I#         ##                                                   CR31  13
INTEGER IP,IPT#    ## POINTERS                                          CR31  14
INTEGER J,K#       ##                                                   CR31  15
INTEGER KEY#       ## KEY=1/2 LIST DIRECT/INVERTED MATRIX               CR31  16
#                  ## KEY=3/4 LIST CORR.MATRIX: CPMPLETE/ELEMENTS>MALIS CR31  17
#                  ## KEY=5   SAVE CORR.MATRIX ON FILE E                CR31  18
INTEGER L5,L8,L9,L10## POINTER IN BLOCH DIRECTORY                       CR31  19
INTEGER L11,L11K,L11P,L12#             Pointer in matrix and vector     CR31  20
INTEGER LEN#       ## LENGTH OF MATRIX BLOCK                            CR31  21
INTEGER NBLK#      ## NUMBER OF BLOCKS                                  CR31  22
INTEGER NBLOCK#    ## TOTAL BLOCK COUNT                                 CR31  23
INTEGER MW#        ## NO. OF ITEMS ON A LINE                            CR31  24
INTEGER NW1#       ## NUMBER OF ITEMS ON CURRENT LINE                   CR31  25
INTEGER P#         ##                                                   CR31  26
INTEGER PACK,PACKMX## (MAX) PACKET SIZE IN OUTPUT FILE E                CR31  27
INTEGER REC#       ## RECORD NUMBER IN OUTPUT FILE                      CR31  28
INTEGER RLEN#      ## length of array blocks                            CR31  29
INTEGER VARBLK#    ## NO. OF VARIABLES IN A BLOCK                       CR31  30
#                                                                       CR31  31
chardata:(CR311,DIRECT MATRIX      INVERTED MATRIX    CORRELATION $#    CR31  32
MATRIX)#                                                                CR31  33
chardata:(CR312, BLOCK VECTOR)#                                         CR31  34
chardata:(CR313, BLOCK      $, VARIABLE      - VARIABLE      $,$#       CR31  35
CORRELATION COEFFICIENT            )#                                   CR31  36
realdata:(FORM1,[780632.,130313.,280413.,430413.])#                     CR31  37
intdata:(IPMX,0)#                                                       CR31  38
datastuff:#                                                             CR31  39
#                                                                       CR31  40
#        SET UP PRINT PARAMETERS                                        CR31  41
#        -----------------------                                        CR31  42
#                                                                       CR31  43
MW=prtcmax:/10#                        No. of items per line            CR31  44
DO K=1,MW; FORM(K)=FLOAT(K*100000+931)# Output format                   CR31  45
#                                                                       CR31  46
#        PRINT OR SAVE MATRIX                                           CR31  47
#        --------------------                                           CR31  48
#                                                                       CR31  49
IF((KEY!=2)\(ICYCLE==(NCYCLE-1)))#     Only inv.matrix in last cyc      CR31  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR31  51
IF(KEY<=4)#                            List matrix (elements)           CR31  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR31  53
K=KEY*19-18#                           Point to matrix type             CR31  54
IF(KEY==4) K=K-19#                     Adjust pointer                   CR31  55
movechar:(CR311,K,CHROT,2,19,0)#       Insert matrix type               CR31  56
LINRM=8;writeline:(1,0,0,1,3)#         Print matrix header              CR31  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR31  58
ELSE#                                  Save correlation matrix          CR31  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR31  60
IOMARK(4)=MARK15#                      Start of output buffer           CR31  61
incrqx:(I,MARK15+bdfbuf:,CR3120)#      Request for memory               CR31  62
PACKMX=arith:(bdfbuf:,-,4)#            Max. packet size                 CR31  63
PACK=incr:(arith:(15,/,mxchwd:))#      Packet size in lr 2              CR31  64
REC=2;    PACK=PACK+7#                 First record                     CR31  65
writepkt:(4,REC,PACK,IP)#              Init lr 2                        CR31  66
movector:(TITLE,10,QX(IP+1),1,6,0)#    Move compound id                 CR31  67
movector:(TITLE,17,QX(IP+1),9,8,0)#    Move date                        CR31  68
##                                                                      CR31  69
IPT=IP+PACK#                                                            CR31  70
QX(IPT-6)=QX(MARK8+1)#                 Total number of blocks           CR31  71
QX(IPT-5)=NONATM#                      Number of non-atomic para.       CR31  72
QX(IPT-4)=MARK5#                       Off-set of mark5                 CR31  73
QX(IPT-3)=MARK6-MARK5#                 Size of mark5 array              CR31  74
QX(IPT-2)=MARK9-MARK8#                 Size of mark8 array              CR31  75
QX(IPT-1)=MARK10-MARK9#                Size of mark9 array              CR31  76
QX(IPT)=MARK11-MARK10#                 Size of mark10 array             CR31  77
#                                                                       CR31  78
##      ATOM PARAMETER INFORMATION                                      CR31  79
##     ============================                                     CR31  80
##                                                                      CR31  81
RLEN=MARK6-MARK5#                      Size of mark5 array              CR31  82
L5=MARK5+1#                            Pointer of mark5 array           CR31  83
REC=REC+1#                             Next logical record              CR31  84
REPEAT#                                Loop for writing atom informat   CR31  85
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR31  86
IF (RLEN<=0) BREAK#                    If no more item, exit            CR31  87
PACK=MIN0(RLEN,PACKMX)#                                                 CR31  88
writepkt:(4,REC,PACK,IP)#              Get pointer of output buffer     CR31  89
movereal:(QX,L5,QX,IP+1,PACK,1)#       Dump data into output biffer     CR31  90
L5=L5+PACK#                            Next package                     CR31  91
RLEN=RLEN-PACK#                        <<<<<<<<<<<<<<<<<<<<<< bot a.1   CR31  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR31  93
#                                                                       CR31  94
##        BLOCK INFORMATION                                             CR31  95
##       ===================                                            CR31  96
##                                                                      CR31  97
RLEN=MARK9-MARK8#                      Size of mark8 array              CR31  98
L8=MARK8+1#                            Pointer of mark8 array           CR31  99
REC=REC+1#                             Next logical record              CR31 100
REPEAT#                                Loop for writing block informa   CR31 101
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR31 102
IF (RLEN<=0) BREAK#                    If no more data, exit            CR31 103
PACK=MIN0(RLEN,PACKMX)#                Size of package                  CR31 104
writepkt:(4,REC,PACK,IP)#              Get the pointer of output buff   CR31 105
movereal:(QX,L8,QX,IP+1,PACK,1)#       Dump data into output buffer     CR31 106
L8=L8+PACK#                            Next package                     CR31 107
RLEN=RLEN-PACK#                                                         CR31 108
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR31 109
#                                                                       CR31 110
##          BLOCK CONTENTS                                              CR31 111
##        ==================                                            CR31 112
##                                                                      CR31 113
RLEN=MARK10-MARK9#                     Size of mark9 array              CR31 114
L9=MARK9+1#                            Pointer of mark9 array           CR31 115
REC=REC+1#                             Next logical record              CR31 116
REPEAT#                                Loop for writing data            CR31 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR31 118
PACK=MIN0(RLEN,PACKMX)#                Length package of output buffe   CR31 119
IF (RLEN<=0) BREAK#                    Exit, if no more data.           CR31 120
writepkt:(4,REC,PACK,IP)#              Get the pointer of output buff   CR31 121
movereal:(QX,L9,QX,IP+1,PACK,1)#       Dump data into output buffer     CR31 122
L9=L9+PACK#                            Next package                     CR31 123
RLEN=RLEN-PACK#                                                         CR31 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR31 125
#                                                                       CR31 126
##     CONSTRAINTS-NONREFINEMENT                                        CR31 127
##    ===========================                                       CR31 128
##                                                                      CR31 129
RLEN=MARK11-MARK10#                    Size of mark10 array             CR31 130
L10=MARK10+1#                          Pointer of mark10 array          CR31 131
REC=REC+1#                             Next logical record              CR31 132
REPEAT#                                Loop for writing constr. data    CR31 133
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR31 134
PACK=MIN0(RLEN,PACKMX)#                Size of package of output buff   CR31 135
IF (RLEN<=0) BREAK#                    Exit, if no more constr. data    CR31 136
writepkt:(4,REC,PACK,IP)#              Get the pointer of output buff   CR31 137
movereal:(QX,L10,QX,IP+1,PACK,1)#      Dump data into output buffer     CR31 138
L10=L10+PACK#                          Next package                     CR31 139
RLEN=RLEN-PACK#                                                         CR31 140
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR31 141
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR31 142
#                                                                       CR31 143
## LOOP OVER THE BLOCKS                                                 CR31 144
#                                                                       CR31 145
NBLOCK=0#                              Block count                      CR31 146
L11=MARK11+1#                          Point to matrix el.              CR31 147
FOR(L8=MARK8+2;L8<MARK9;L8=L8+2)#      Loop over the blocks             CR31 148
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR31 149
NBLK=NINT(QX(L8));VARBLK=NINT(QX(L8+1))# Nr of blocks & variables       CR31 150
DO I=1,NBLK#                           Loop over subsets of blocks      CR31 151
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR31 152
NBLOCK=NBLOCK+1#                       Count total blocks               CR31 153
IF(KEY<=3)#                            List a complete matrix           CR31 154
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR31 155
movechar:(CR312,2,CHROT,2,5,0)#        Insert block header              CR31 156
ncodefld:(FLOAT(NBLOCK),1,CHROT,90213.,1)# Format total block count     CR31 157
writeline:(0,0,0,1,3)#                 Print block header               CR31 158
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR31 159
ELSE IF(KEY==5)#                       Save correlation matrix          CR31 160
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR31 161
LEN=(VARBLK+1)*VARBLK/2#               Length of matrix block           CR31 162
PACK=MIN0(LEN+1,PACKMX)#               Current packet size              CR31 163
REC=REC+1#                             Add up one record                CR31 164
writepkt:(4,REC,PACK,IP)#              Init next lr                     CR31 165
IPMX=IP+PACKMX#                        Pointer to end of packet         CR31 166
IP=IP+1;QX(IP)=FLOAT(VARBLK)#          Nr of var/block in 1-st word     CR31 167
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR31 168
#                                                                       CR31 169
## LOOP OVER THE ROWS                                                   CR31 170
#                                                                       CR31 171
DO K=1,VARBLK#                         Loop over the rows               CR31 172
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR31 173
L11K=L11;L11P=L11#                     Pointers to diag. elements       CR31 174
#                                                                       CR31 175
## LOOP OVER THE COLUMNS                                                CR31 176
#                                                                       CR31 177
DO P=K,VARBLK,MW#                      Loop over the columns            CR31 178
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR31 179
NW1=MIN0(MW,VARBLK-P+1)#               Limit length of line             CR31 180
DO J=1,NW1#                            Items in current line            CR31 181
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR31 182
IF(KEY<=2) BUFOT(J)=QX(L11)#           Aij                              CR31 183
ELSE IF(QX(L11K)*QX(L11P)<=0.) BUFOT(J)=0.# Allow for silliness         CR31 184
ELSE BUFOT(J)=QX(L11)/SQRT(QX(L11K)*QX(L11P))# Aij/(aii*ajj)            CR31 185
IF(KEY==4)#                            List corr.coeff.                 CR31 186
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR31 187
IF((ABS(BUFOT(J))>MALIST)&(L11!=L11K))# List only values > malist       CR31 188
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR31 189
BUFOT(J+1)=FLOAT(NBLOCK)#              Block nr                         CR31 190
BUFOT(J+2)=FLOAT(K)#                   Row nr                           CR31 191
BUFOT(J+3)=FLOAT(P+J-1)#               Column nr                        CR31 192
ncodefld:(BUFOT,J,CR313,FORM1,4)#      Format output line               CR31 193
writeline:(0,CR313,NCR313,3,3)#        Print correlation coeff.         CR31 194
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR31 195
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR31 196
IF(KEY==5)#                            Save corr. matrix                CR31 197
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR31 198
IF(IP>=IPMX) writepkt:(4,REC,PACK,IP)# Full packet: write to bdf        CR31 199
IP=IP+1;QX(IP)=BUFOT(J)#               Save corr.coeff.                 CR31 200
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR31 201
L11=L11+1#                             Next element                     CR31 202
L11P=L11P+VARBLK-P-J+2#                Next diagonal element            CR31 203
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR31 204
IF(KEY<=3)#                            List complete matrix             CR31 205
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR31 206
ncodefld:(BUFOT,1,CHROT,FORM,NW1)#     Encode current row               CR31 207
writeline:(0,0,0,1,3)#                 Print current row                CR31 208
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR31 209
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR31 210
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR31 211
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR31 212
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR31 213
IF(KEY==5) writepkt:(4,endrecord:,3,IP)# Write last lr to bdf           CR31 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR31 215
#                                                                       CR31 216
#        PRINT VECTOR                                                   CR31 217
#        ------------                                                   CR31 218
#                                                                       CR31 219
IF(KEY<=2)#                            Direct/inverted matrix           CR31 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR31 221
movechar:(CR312,8,CHROT,2,6,0)#        Insert vector header             CR31 222
LINRM=4;writeline:(1,0,0,1,3)#         Print vector header              CR31 223
FOR(L12=MARK12+1;L12<=MARK13-2;L12=L12+MW)# Loop over vector elemen     CR31 224
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR31 225
NW1=MIN0(MW,MARK13-L12-1)#             Limit length on line             CR31 226
ncodefld:(QX,L12,CHROT,FORM,NW1)#      Encode vector line               CR31 227
writeline:(0,0,0,1,3)#                 Print vector line                CR31 228
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR31 229
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR31 230
RETURN#                                                                 CR31 231
END#                                                                    CR31 232
systemheader:(CR36)#                   Update general and group par     CR36   1
# ############################################################# #       CR36   2
#                                                               #       CR36   3
#                               CR36                            #       CR36   4
#                                                               #       CR36   5
# ############################################################# #       CR36   6
SUBROUTINE CR36#                       R.olthof   august 1980           CR36   7
#                                      May 1985                         CR36   8
#                                     # Iso ext j.konnert oct/85        CR36   9
include:(AACOMN)#                                                       CR36  10
include:(CRCOMN)#                                                       CR36  11
#                                                                       CR36  12
string:(CH,mxchln:)#                                                    CR36  13
INTEGER BFMAX#     ## MAX NR OF ITEMS IN BUFOT                          CR36  14
REAL    COSPHI,COSPSI,COSTHE#                                           CR36  15
INTEGER I,I1,I6,IH,IHF,IIII,IP,IPP#                                     CR36  16
INTEGER ICH#       ## POINTER TO CHARACTER POSITION                     CR36  17
INTEGER IGR#       ## GROUP NR                                          CR36  18
INTEGER IREL(101)# ## RELATIVE POINTERS IN BDF                          CR36  19
INTEGER IWANT(100)## WANTED ITEMS IN BDF                                CR36  20
INTEGER J#         ##                                                   CR36  21
INTEGER K,K1#      ##                                                   CR36  22
INTEGER L,L1,L2,L3,L4,L12,L13#                                          CR36  23
INTEGER N#         ##                                                   CR36  24
INTEGER NATGR#     ## NR OF ATOMS IN A GROUP                            CR36  25
INTEGER NDISP#     ## NO. OF DISPERSION FACTORS                         CR36  26
INTEGER NPAR#      ## TOTAL NR OF PARAMS                                CR36  27
INTEGER NSKF#      ## NO. OF SCALE FACTORS                              CR36  28
INTEGER NXABS#     ## NO. OF ABSOLUTE STRUCTURE PARAMETERS              CR36  29
INTEGER NXT#       ## NUMBER OF EXTINCTION PARAMETERS                   CR36  30
INTEGER PACK#      ## PACKET SIZE OF LR ON BDF                          CR36  31
INTEGER PAR#       ## COUNT OF PARAMETERS                               CR36  32
INTEGER PAR1#      ## MAX NR OF PARAMETERS ON ONE LINE                  CR36  33
REAL    PHI#       ##                                                   CR36  34
REAL    PSI#       ##                                                   CR36  35
INTEGER REC#       ##                                                   CR36  36
INTEGER REF#       ## REFINEMENT FLAG                                   CR36  37
INTEGER SGNL(4)#   ## KEYS FOR DIRECTORY PACKETS                        CR36  38
REAL    SINPHI,SINPSI,SINTHE#                                           CR36  39
REAL    THETA#     ##                                                   CR36  40
INTEGER VAR#       ## COUNT OF VARIABLES                                CR36  41
#                                                                       CR36  42
chardata:(CR361, PARAMETERS AFTER CYCLE    (U*100))#                    CR36  43
chardata:(CR362,  SKF  UOV  EXT  DISP SCALE BOV  EXT  RHO  XABS)#       CR36  44
chardata:(CR363,-OLD D   NEW SD  D/SD    )#                             CR36  45
chardata:(CR364, TOTAL LEAST SQUARES CYCLES = XXXXX)#                   CR36  46
chardata:(CR365,***GROUP    ***CENTER OF GRAVITY EULER ANGLES $#        CR36  47
(PHI, THETA, PSI))#                                                     CR36  48
chardata:(CR366, FINAL FREL SCALE                 )#                    CR36  49
chardata:(CR367,'Less-thans defined by |Fo| < 0 esd(|Fo|)')#            CR36  50
chardata:(CR368,'FoF2IoFh')#                                            CR36  51
realdata:(FORM,[241052.,341052.,441052.,541052.,$#                      CR36  52
641052.,741052.,841052.,941052.,$#                                      CR36  53
1041052.,1141052.,1241052.])#                                           CR36  54
realdata:(RAD,57.29579)#               Factor: radians to degrees       CR36  55
intdata:(M,0)#                                                          CR36  56
datastuff:#                                                             CR36  57
#                                                                       CR36  58
#        UPDATE GENERAL PARAMETERS                                      CR36  59
#        -------------------------                                      CR36  60
#                                                                       CR36  61
## INITIALIZATIONS                                                      CR36  62
#                                                                       CR36  63
rewindbdf:(1)#                         Rewind bdf                       CR36  64
ICYCLE=ICYCLE+1#                       Incr nr of cycles                CR36  65
IF(ICYCLE<NCYCLE) readwpkt:(1,lrrefl:,PACK,IP,0)# Read until lrref      CR36  66
ELSE#                                  If last cycle                    CR36  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR36  68
LIST=LIST+1;PNCHCD=PNCHCD+1#           Incr  list and punch options     CR36  69
IOMARK(2)=MARK15#                      Start of output buffer           CR36  70
incrqx:(I,MARK15+bdfbuf:,CR3620)#      Request for memory               CR36  71
copyfile:(1,2,1,decr:(lrcell:))#       Copy file until lrcell:          CR36  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR36  73
#                                                                       CR36  74
NSKF=(MARK4-MARK3)/2#                  No.of scale factors & ext.f.     CR36  75
NXABS=0;NXT=0;NDISP=0#                                                  CR36  76
IF(REFABS>0) NXABS=1#                                                   CR36  77
IF(REFEXT>0)#                          Extinction applied/refined       CR36  78
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR36  79
IF     (EXTTYP<=2) NXT=1#              1 ext. param                     CR36  80
ELSE IF(EXTTYP==3) NXT=2#              2 ext. params                    CR36  81
ELSE IF(EXTTYP<=5) NXT=6#              6 ext. params                    CR36  82
ELSE               NXT=12#             12 ext. params                   CR36  83
IF(EXTTYP<2\EXTTYP==3)       L4=MARK4+2# Point to g(iso)                CR36  84
ELSE IF(EXTTYP==2)           L4=MARK4+3# Point to rho(iso)              CR36  85
ELSE IF(EXTTYP==4\EXTTYP==6) L4=MARK4+4# Point to g(aniso)              CR36  86
ELSE                         L4=MARK4+10# Point to rho(aniso)           CR36  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR36  88
IF(REFDSP>0) NDISP=2*NATTYP#           No.of dispersion fact            CR36  89
NPAR=NSKF+1+NXABS+NXT+NDISP#           Set number of gen. par.          CR36  90
K1=1#                                  Set code for dispersion          CR36  91
L1=1#                                  Point to char.pos. in mark1      CR36  92
L2=MARK2;L3=MARK3;L12=MARK12+1;L13=MARK13+1# Set mark pointers          CR36  93
IF(ICYCLE<NCYCLE) BFMAX=30#            Max nr of output items           CR36  94
ELSE              BFMAX=50#            Idem in last cycle               CR36  95
DSDMAX=0.; DSDAVE=0.; DSDNUM=0.#       Maximun/average d/sd             CR36  96
#                                                                       CR36  97
## PRINT HEAD OF TABLE                                                  CR36  98
#                                                                       CR36  99
LINRM=10#                              Lines on this page               CR36 100
ncodefld:(FLOAT(ICYCLE-1),1,CR361,260213.,1)# Format cycle number       CR36 101
movechar:(CR363,1,CHROT,2,NCR361-1,1)# Underline header                 CR36 102
writeline:(2,CR361,NCR361,2,3)#        Parameters after cycle ..        CR36 103
#                                                                       CR36 104
## LOOP OVER GENERAL PARAMETERS                                         CR36 105
#                                                                       CR36 106
ICH=10;I=0#                            Set char and o/p item count      CR36 107
IHF=1#                                 Set header flag for extinction   CR36 108
DO PAR=1,NPAR#                         Loop over general par            CR36 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR36 110
IF(I==0) movechar:(BLANK,1,CH,1,prtcmax:,1)# Blank header line          CR36 111
ICH=ICH+10;I=I+1;I1=I#                 Advance char.pos. in header      CR36 112
REF=no:;BUFOT(I+30)=-1.#               Do not refine this par           CR36 113
#                                                                       CR36 114
IF(PAR<=NSKF)#                         **************** shift scale     CR36 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR36 116
movechar:(CR362,1,CH,ICH,5,0)#         Insert skf in header             CR36 117
BUFOT(I)=1./QX(L3+1)#                  Store old value                  CR36 118
IF(REFSKF>0)#                          Par is variable                  CR36 119
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR36 120
IF(REFSKF>1 \ PAR==NSKF) REF=yes:#     Set refine flag                  CR36 121
BUFOT(I+10)=QX(L12)*BUFOT(I)#          Store scale shift                CR36 122
BUFOT(I+20)=BUFOT(I)+DAMP*BUFOT(I+10)# Calculate new skf                CR36 123
QX(L3+1)=1./BUFOT(I+20)#               Store new value                  CR36 124
BUFOT(I+30)=QX(L13)*BUFOT(I)#          Store std deviation              CR36 125
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR36 126
IF(PNCHCD>1)#                          Test punch cards requested       CR36 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR36 128
movechar:(CR362,23,CHROT,1,5,0)#       Move =scale= to head             CR36 129
ncodefld:(QX,L3+1,CHROT,FORM(1),2)#    Move sf ad sf group              CR36 130
movertoc:(QX(MARK1+1),129,CHROT,40,12,0)# Move data set name            CR36 131
writepch:(CHROT,80)#                   Punch a scale line               CR36 132
movechar:(BLANK,1,CHROT,1,80,1)#       Blank out the line               CR36 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR36 134
L3=L3+2#                               Advance pointer to skf           CR36 135
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR36 136
#                                                                       CR36 137
ELSE IF(PAR==NSKF+1)#                  *********** shift uov            CR36 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR36 139
movechar:(CR362,6,CH,ICH,5,0)#         Store uov in der                 CR36 140
BUFOT(I)=BTOHU*QX(MARK4+1)#            Old value of 100.*uov            CR36 141
BUFOT(mxfdln:)=0.01*BUFOT(I)#          Uov for uov card                 CR36 142
IF(REFUOV!=0)#                         Update uov                       CR36 143
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR36 144
REF=yes:#                              Par is variable                  CR36 145
BUFOT(I+10)=BTOHU/CELL(1)*QX(L12)#     Store 100.0*uov shift            CR36 146
IF(REFUOV>0)#                          If shift to be applied           CR36 147
QX(MARK4+1)=QX(MARK4+1)+DAMP/CELL(1)*QX(L12)# New uov value in memory   CR36 148
IF(QX(MARK4+1)<=0.&TMPTST==0) QX(MARK4+1)=0.1# Make positive            CR36 149
BUFOT(I+20)=BTOHU*QX(MARK4+1)#         New 100.0*uov on output          CR36 150
BUFOT(I+30)=BTOHU/CELL(1)*QX(L13)#     100.0*e.s.d.(uov) for output     CR36 151
BUFOT(mxfdln:)=0.01*BUFOT(I+20)#       Uov for uov card                 CR36 152
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR36 153
IF(PNCHCD>1)#                          Check punch cards request        CR36 154
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR36 155
movechar:(CR362, 8,CHROT,1,3,0)#       Move =uov=                       CR36 156
ncodefld:(BUFOT(mxfdln:),1,CHROT,FORM(1),1)# Encode uov                 CR36 157
movertoc:(QX(MARK1+1),129,CHROT,40,12,0)# Move data set name            CR36 158
writepch:(CHROT,80)#                   Punch the line                   CR36 159
movechar:(BLANK,1,CHROT,1,80,1)#       Clear the o/p line               CR36 160
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR36 161
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR36 162
#                                                                       CR36 163
ELSE IF(PAR==NSKF+1+NXABS)#            *******shift abs.struct.param.   CR36 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR36 165
movechar:(CR362,43,CH,ICH,5,0)#        Xabs header                      CR36 166
BUFOT(I)=XABS#                         Xabs                             CR36 167
IF(REFABS==2)#                         Xabs refined                     CR36 168
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR36 169
REF=yes:#                              Par is variable                  CR36 170
BUFOT(I+10)=QX(L12)#                   Xabs shift                       CR36 171
XABS=XABS+DAMP*BUFOT(I+10)#            New xabs                         CR36 172
BUFOT(I+20)=XABS#                                                       CR36 173
BUFOT(I+30)=QX(L13)#                   Std deviation                    CR36 174
XABSIG=QX(L13)#                        Save the standard deviation      CR36 175
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR36 176
IF(PNCHCD>1)#                          Check punch cards request        CR36 177
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR36 178
movechar:(CR362,44,CHROT,1,4,0)#       Move =xabs=                      CR36 179
ncodefld:(XABS,1,CHROT,FORM(1),1)#     Encode xabs                      CR36 180
movertoc:(QX(MARK1+1),129,CHROT,40,12,0)# Move data set name            CR36 181
writepch:(CHROT,80)#                   Punch the line                   CR36 182
movechar:(BLANK,1,CHROT,1,80,1)#       Clear the o/p line               CR36 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR36 184
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR36 185
#                                                                       CR36 186
ELSE IF(PAR<=NSKF+1+NXABS+NXT)#        *******shift extinction          CR36 187
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR36 188
IF(EXTTYP<=1)      IH=32#              Point to g                       CR36 189
ELSE IF(EXTTYP==2) IH=37#              Point to rho                     CR36 190
ELSE IF(EXTTYP==3)#                                                     CR36 191
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR36 192
IF(IHF==1)         IH=32#              Point to g                       CR36 193
ELSE               IH=37#              Point to rho                     CR36 194
IHF=-IHF#                                                               CR36 195
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR36 196
movechar:(CR362,IH,CH,ICH,5,0)#        Extinction in header             CR36 197
BUFOT(I)=QX(L4)#                       Old value                        CR36 198
IF(REFEXT>1)#                          Was it refined?                  CR36 199
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR36 200
REF=yes:#                              Refinement flag                  CR36 201
BUFOT(I+10)=QX(L12)#                   Calc shift                       CR36 202
BUFOT(I+20)=BUFOT(I)+DAMP*BUFOT(I+10)# Calc new value                   CR36 203
BUFOT(I+20)=AMAX1(BUFOT(I+20),0.0)#                                     CR36 204
BUFOT(I+30)=QX(L13)#                   Std. deviation                   CR36 205
QX(L4)=BUFOT(I+20)#                    Store new value                  CR36 206
EXTESD=BUFOT(I+30)#                    Store extinction esd             CR36 207
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR36 208
L4=L4+1#                               Point to next ext. param         CR36 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR36 210
#                                                                       CR36 211
ELSE#                                  ********* shift dispersion       CR36 212
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR36 213
IF(K1>0)#                              Real part if positive            CR36 214
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR36 215
movechar:(CR362,17,CH,ICH,5,0)#        Insert disp in header            CR36 216
BUFOT(I)=QX(L2+1)#                     Real part                        CR36 217
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR36 218
ELSE#                                  Imaginary part                   CR36 219
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR36 220
movertoc:(QX(MARK1+1),L1,CH,ICH,8,0)#  Insert atom type name            CR36 221
L1=L1+8#                               Point to next type name          CR36 222
BUFOT(I)=QX(L2+2)#                     Store imag disp                  CR36 223
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR36 224
IF(QX(L2+3)>0.)#                       If refine disp.fact.             CR36 225
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR36 226
REF=yes:#                              Set refine flag                  CR36 227
BUFOT(I+10)=QX(L12)#                   Store shift                      CR36 228
BUFOT(I+20)=BUFOT(I)+DAMP*BUFOT(I+10)# Store new value                  CR36 229
IF(K1>0) QX(L2+1)=BUFOT(I+20)#         Store real disp                  CR36 230
ELSE     QX(L2+2)=BUFOT(I+20)#         Store imag disp                  CR36 231
BUFOT(I+30)=QX(L13)*BUFOT(I)#          Store std deviation              CR36 232
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR36 233
K1=-K1#                                Flag for real/imag part          CR36 234
IF(K1>0) L2=L2+NSTEP2#                 Next atom type                   CR36 235
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR36 236
#                                                                       CR36 237
IF(REF==yes:)#                         Skip incr if not refined         CR36 238
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR36 239
L12=L12+1;L13=L13+1#                   Advance l12 and l13              CR36 240
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR36 241
IF(BUFOT(I1+30)>.0)#                   A std deviation was calc         CR36 242
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR36 243
BUFOT(I1+40)=ABS(BUFOT(I1+10))/BUFOT(I1+30)# Shift/error                CR36 244
DSDMAX=AMAX1(DSDMAX,BUFOT(I1+40))#     Maximum d/sd                     CR36 245
DSDAVE=DSDAVE+BUFOT(I1+40)#            Average d/sd                     CR36 246
DSDNUM=DSDNUM+1.#                      Nr of d/sd values                CR36 247
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR36 248
#                                                                       CR36 249
IF((ICH+34>prtcmax:)\(PAR==NPAR))#                                      CR36 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR36 251
LINRM=6;writeline:(1,CH,ICH+5,3,3)#    Print header line                CR36 252
K=2;PAR1=I#                            Pointer in cr364                 CR36 253
DO J=1,BFMAX,10#                       Write output lines               CR36 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR36 255
movechar:(CR363,K,CHROT,2,4,0);K=K+4#  Old/d/new/sd                     CR36 256
L=J-1#                                 Pointer in bufot                 CR36 257
DO I=1,PAR1#                           Loop over param in current l     CR36 258
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR36 259
L=L+1#                                 Incr pointer in bufot            CR36 260
IF((J==1)\(BUFOT(I+30)>-0.))#          Old value or update item         CR36 261
ncodefld:(BUFOT,L,CHROT,FORM(I),1)#    Ncode output item                CR36 262
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR36 263
writeline:(0,0,0,1,3)#                 Print a line                     CR36 264
IF(VARGEN==0) BREAK#                   No general variables             CR36 265
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR36 266
ICH=10;I=0#                            Reset counters                   CR36 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR36 268
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR36 269
#                                                                       CR36 270
## UPDATE BINARY DATA FILE                                              CR36 271
#                                                                       CR36 272
IF(ICYCLE==NCYCLE)#                    Last cycle: update bdf           CR36 273
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR36 274
DO I=1,20#                             Loop over lrcell: packets        CR36 275
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR36 276
readwpkt:(1,lrcell:,PACK,IP,2)#        Point to next input packet       CR36 277
IF(IP<=0) BREAK#                       Exit after last packet           CR36 278
writepkt:(2,lrcell:,PACK,IPP)#         Point to next output packet      CR36 279
movereal:(QX,IP+1,QX,IPP+1,PACK,1)#    Copy the packet                  CR36 280
IP=IPP#                                Point to output packet           CR36 281
IF(I!=6) NEXT#                         6th packet keeps count           CR36 282
QX(IP+4)=QX(IP+4)+FLOAT(NCYCLE-1)#     Boost running ls cycles          CR36 283
TCYCLE=QX(IP+4)#                       Store total cycles               CR36 284
ncodefld:(QX(IP+4),1,CR364,350513.,1)# Format total cycles              CR36 285
writeline:(1,CR364,NCR364,3,5)#        Report cycles                    CR36 286
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR36 287
#                                                                       CR36 288
copyfile:(1,2,incr:(lrcell:),decr:(lrexpl:))# Copy between lrcell&lre   CR36 289
#                                                                       CR36 290
#                                                                       CR36 291
DO REC=lrexpl:,lrdset:#                Loop over lrexpl: & lrdset:      CR36 292
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR36 293
IWANT(1)=1#                                                             CR36 294
SGNL(1)=0;SGNL(2)=1;SGNL(4)=0#         Set signals for both files       CR36 295
IF(REC==lrexpl:)#                      Set signals for lrexpl:          CR36 296
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR36 297
L=MARK3+2#                             Pointer for lrexpl:              CR36 298
DO J=1,NSKF#                           Loop over scale factors          CR36 299
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR36 300
IWANT(J+1)=NINT(QX(L))+100#            Need scale factors               CR36 301
L=L+2#                                 Increment pointer                CR36 302
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR36 303
SGNL(3)=NSKF+1#                        Set signal for lrexpl:           CR36 304
IF(TYPELT>0.)#                         Did cr type the less thans       CR36 305
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR36 306
DO J=1,w40c:; IWANT(J+NSKF+1)=532#     Need less-thans criterion stri   CR36 307
SGNL(3)=SGNL(3)+w40c:#                 Set signal for lrexpl:           CR36 308
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR36 309
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR36 310
ELSE#                                  Set signals for lrdset:          CR36 311
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR36 312
IWANT(2)=2#                            Need to get uov                  CR36 313
DO J=1,4;IWANT(J+2)=100+J#             Get extinction params            CR36 314
IWANT(7)=117#                          Get average tbar                 CR36 315
IWANT(8)=3#                            Abs.struct.param                 CR36 316
IWANT(9)=87; IWANT(10)=88#             Threshold factor and coeff       CR36 317
SGNL(3)=10#                            Set signal                       CR36 318
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR36 319
indexpkt:(1,REC,PACK,IP,2,SGNL,IWANT,IREL)# Search directory            CR36 320
REPEAT#                                Loop over packets                CR36 321
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CR36 322
readwpkt:(1,REC,PACK,IP,2)#            Point to next input packet       CR36 323
IF (IP<=0) BREAK#                      Exit after last packet           CR36 324
writepkt:(2,REC,PACK,IPP)#             Point to next output packet      CR36 325
movereal:(QX,IP+1,QX,IPP+1,PACK,0)#    Transfer packet                  CR36 326
movereal:(0.,1,QX,IPP+PACK+1,(SGNL(4)-PACK),1)# Init to zero            CR36 327
M=IP+IREL(1)#                          Point to data set                CR36 328
IF(M>IP)#                              Find correct packet              CR36 329
IF(NINT(QX(M))!=DATSET) NEXT#          Try next packet                  CR36 330
IF(REC==lrexpl:)#                      Lrexpl                           CR36 331
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CR36 332
L=MARK3+1#                             Point to scale factor            CR36 333
DO J=1,NSKF#                           Loop over scale factors          CR36 334
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CR36 335
M=IPP+IREL(J+1)#                       Save new scale factor            CR36 336
QX(M)=QX(L)#                                                            CR36 337
ncodefld:(QX,L,CR366,321052.,1)#       Encode frel scale factor         CR36 338
ncodefld:(QX,L+1,CR366,200213.,1)#     Encode scale factor group        CR36 339
writeline:(1,CR366,NCR366,3,3)#        Write line                       CR36 340
L=L+2#                                                                  CR36 341
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CR36 342
IF(TYPELT>0.)#                         Out less-than defn string        CR36 343
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CR36 344
movechar:(CR368,2*RFLTYP+1,CR367,24,2,0)# Format type                   CR36 345
movechar:(CR368,2*RFLTYP+1,CR367,37,2,0)# Format type                   CR36 346
ncodefld:(TYPELT,1,CR367,300113.,1)#   Format factor                    CR36 347
movector:(CR367,1,QX(IPP+IREL(NSKF+2)),1,40,0)# Keep less-thans defn    CR36 348
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CR36 349
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CR36 350
ELSE#                                  Lrdset                           CR36 351
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CR36 352
M=IPP+IREL(2)#                         Point to uov                     CR36 353
QX(M)=BTOU*QX(MARK4+1)#                Uov for bdf as b overall         CR36 354
IF(REFEXT>0)#                          If ext. calc or refined          CR36 355
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CR36 356
IF(EXTTYP==0) QX(MARK4+3)=QX(MARK4+2)# Put rho equal to g if zach       CR36 357
M=IPP+IREL(3);QX(M)=FLOAT(EXTTYP)#     Extinction type                  CR36 358
M=IPP+IREL(4);QX(M)=FLOAT(DSTEXT)#     Distribution type (0=g;1=lor)    CR36 359
M=IPP+IREL(5);QX(M)=QX(MARK4+2)*10000.# Store iso g   correct scale     CR36 360
M=IPP+IREL(6);QX(M)=QX(MARK4+3)*10000.# Store iso rho correct scale     CR36 361
M=IPP+IREL(7);QX(M)=QX(MARK4+22)#      Average tbar in mm               CR36 362
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CR36 363
IF(REFABS>1)#                          If abs.struct.param refined      CR36 364
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CR36 365
M=IPP+IREL(8);QX(M)=XABS#              Store abs.struct.param           CR36 366
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CR36 367
M=IPP+IREL(9);QX(M)=TYPELT#            Threshold coefficient            CR36 368
M=IPP+IREL(10);QX(M)=FLOAT(RFLTYP+1)#  Threshold factor                 CR36 369
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CR36 370
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CR36 371
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR36 372
copyfile:(1,2,incr:(lrdset:),decr:(lratom:))# Copy bfd                  CR36 373
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR36 374
#                                                                       CR36 375
#     GROUP PARAMETERS                                                  CR36 376
#     ----------------                                                  CR36 377
#                                                                       CR36 378
I6=MARK6#                              Start of group array             CR36 379
IGR=0#                                 Group count                      CR36 380
WHILE(I6<MARK7)#                       Loop over the groups             CR36 381
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CR36 382
IGR=IGR+1#                             Add up one group                 CR36 383
IF(QX(I6+2)<1.5) NATGR=NINT(QX(I6+1))# Nr of atoms in group/idmol       CR36 384
ELSE#                                  N-th idmol                       CR36 385
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CR36 386
I1=NINT(QX(I6+1))#                     Pointer to 1-st idmol            CR36 387
NATGR=NINT(QX(I1+1))#                  Nr of atoms in idmol             CR36 388
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CR36 389
ifeq:(QX(I6+2),1.)#                    If first idmol                   CR36 390
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CR36 391
I6=I6+ISTEP6+NATGR*NSTEP6#             Point to next group              CR36 392
NEXT#                                  Goto next group                  CR36 393
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CR36 394
movechar:(CR365,1,CHROT,2,15,0)#       Move ***group   ***              CR36 395
ncodefld:(FLOAT(IGR),1,CHROT,120213.,1)# Encode group nr                CR36 396
LINRM=12;writeline:(1,0,0,1,3)#        Print ***group nr***             CR36 397
#                                                                       CR36 398
## UPDATE EULER PARAMETERS                                              CR36 399
#                                                                       CR36 400
I1=I6+2#                               Pointer to euler param           CR36 401
DO N=1,2#                              Loop over coord/angles           CR36 402
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CR36 403
ICH=22#                                Character position               CR36 404
DO J=1,3#                              Three param                      CR36 405
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CR36 406
I1=I1+1;BUFOT(J)=QX(I1)#               Next euler param                 CR36 407
VAR=NINT(QX(I1+6))#                    Variable number                  CR36 408
IF(VAR==0) BUFOT(J+10)=-1000.#         Invariant                        CR36 409
ELSE#                                  Variable                         CR36 410
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CR36 411
L=MARK12+VAR;BUFOT(J+10)=QX(L)#        Store shift                      CR36 412
QX(I1)=QX(I1)+DAMP*QX(L)#              Calc. new value                  CR36 413
BUFOT(J+20)=QX(I1)#                    Store new value                  CR36 414
ICH=2#                                 Character position               CR36 415
IF(ICYCLE<NCYCLE) NEXT#                Do not print sd and d/sd         CR36 416
L=MARK13+VAR;BUFOT(J+30)=QX(L)#        St.dev.                          CR36 417
BUFOT(J+40)=ABS(BUFOT(J+10))/BUFOT(J+30)# D/sd                          CR36 418
DSDMAX=AMAX1(DSDMAX,BUFOT(J+40))#      Maximum d/sd                     CR36 419
DSDAVE=DSDAVE+BUFOT(J+40)#             Average d/sd                     CR36 420
DSDNUM=DSDNUM+1.#                      Nr of d/sd values                CR36 421
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CR36 422
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CR36 423
#                                                                       CR36 424
writeline:(0,0,0,1,3)#                 Print blank line                 CR36 425
IF(N==1) movechar:(CR365,16,CHROT,2,17,0)# Move **c.of gr.**            CR36 426
ELSE#                                  If euler angle                   CR36 427
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CR36 428
movechar:(CR365,34,CHROT,2,30,0)#      Move **euler angles**            CR36 429
DO J=1,BFMAX,10#                       Loop over output                 CR36 430
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CR36 431
IF(J>40) BREAK#                                                         CR36 432
BUFOT(J)=RAD*BUFOT(J);#                Phi                              CR36 433
BUFOT(J+1)=RAD*BUFOT(J+1)#             Theta                            CR36 434
BUFOT(J+2)=RAD*BUFOT(J+2)#             Psi                              CR36 435
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CR36 436
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CR36 437
DO J=1,BFMAX,10#                       Loop over old/shift/new/         CR36 438
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CR36 439
movechar:(CR363,ICH,CHROT,40,4,0)#     Old/d/new/sd/dsd                 CR36 440
L=J-1#                                 Point to bufot item              CR36 441
DO I=1,3#                              Loop over the params             CR36 442
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CR36 443
L=L+1#                                 Incr pointer                     CR36 444
IF((J==1)\(BUFOT(I+10)>-999.0))#       If old or refined                CR36 445
ncodefld:(BUFOT,L,CHROT,FORM(I+3),1)#  Encode param                     CR36 446
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CR36 447
writeline:(0,0,0,1,1)#                 Print params                     CR36 448
IF(ICH==22) BREAK#                     All param are invariant          CR36 449
ICH=ICH+4#                             Incr char position               CR36 450
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CR36 451
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CR36 452
#                                                                       CR36 453
## UPDATE ROTATION MATRIX                                               CR36 454
#                                                                       CR36 455
PHI=QX(I6+6)#                          Phi   euler angle                CR36 456
THETA=QX(I6+7)#                        Theta euler angle                CR36 457
PSI=QX(I6+8)#                          Psi   euler angle                CR36 458
COSPHI=COS(PHI);SINPHI=SIN(PHI)#                                        CR36 459
COSTHE=COS(THETA);SINTHE=SIN(THETA)#                                    CR36 460
COSPSI=COS(PSI);SINPSI=SIN(PSI)#                                        CR36 461
QX(I6+22)= COSPSI*COSPHI-SINPSI*COSTHE*SINPHI#                          CR36 462
QX(I6+23)=-SINPSI*COSPHI-COSPSI*COSTHE*SINPHI#                          CR36 463
QX(I6+24)= SINTHE*SINPHI#                                               CR36 464
QX(I6+25)= COSPSI*SINPHI+SINPSI*COSTHE*COSPHI#                          CR36 465
QX(I6+26)=-SINPSI*SINPHI+COSPSI*COSTHE*COSPHI#                          CR36 466
QX(I6+27)=-SINTHE*COSPHI#                                               CR36 467
QX(I6+28)= SINPSI*SINTHE#                                               CR36 468
QX(I6+29)= COSPSI*SINTHE#                                               CR36 469
QX(I6+30)= COSTHE#                                                      CR36 470
IIII=I6+20#                                                             CR36 471
#                                                                       CR36 472
I6=I6+ISTEP6+NATGR*NSTEP6#             Point to next group              CR36 473
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CR36 474
#                                                                       CR36 475
RETURN#                                                                 CR36 476
END#                                                                    CR36 477
systemheader:(CR37)#                   Update atom parameters           CR37   1
# ############################################################# #       CR37   2
#                                                               #       CR37   3
#                               CR37                            #       CR37   4
#                                                               #       CR37   5
# ############################################################# #       CR37   6
SUBROUTINE CR37#                       R.olthof   august 1980           CR37   7
#                                      May 1985   april  1989           CR37   8
include:(AACOMN)#                                                       CR37   9
include:(CRCOMN)#                                                       CR37  10
#                                                                       CR37  11
string:(CH,mxchln:)#                                                    CR37  12
string:(NAME,24)#                                                       CR37  13
REAL APOP#                                                              CR37  14
INTEGER BFMAX#     ## MAX NR OF ITEMS IN BUFOT                          CR37  15
REAL    DELB(6)#   ## CORRECTION IN BETA11 ETC. FOR CORRELATION         CR37  16
REAL    DELBOV#    ## CORRECTION IN B FOR CORRELATION                   CR37  17
REAL    FACT#      ## FACTOR IN CONSTRAINT EQ.                          CR37  18
REAL    FACT1#     ## IDEM                                              CR37  19
REAL    FFACT#     ## FUDGE FACT. FOR TEMP. PAR. SHIFTS                 CR37  20
REAL    FLACT#     ##                                                   CR37  21
INTEGER FLAG#      ## DO/DO NOT CHECK FOR CONSTRAINTS                   CR37  22
REAL    FORM(2)#   ## FORMAT FOR PARAMETER OUTPUT                       CR37  23
INTEGER GROUP#     ## ATOM IS/IS NOT PART OF A GROUP                    CR37  24
INTEGER I,I1,I2,I3,I6,I6FRST,IADD,IP#                                   CR37  25
INTEGER IREL(71)#  ## RELATIVE POINTERS IN BDF                          CR37  26
INTEGER IWANT(70)# ## WANTED ITEMS IF BDF                               CR37  27
INTEGER J,J1,JJL,JJP#                                                   CR37  28
INTEGER K,K1,K12,K13# ##                                                CR37  29
INTEGER L,L5,L6,L8,L11,L11BLK,L12,L13,LL5#                              CR37  30
INTEGER LCON#      ## POINTER IN CONSTRAINT ARRAY                       CR37  31
INTEGER M,M1,M2#                                                        CR37  32
INTEGER N,N0,N1,N2,N9#                                                  CR37  33
INTEGER NATGR#     ## NR OF ATOMS IN A GROUP                            CR37  34
INTEGER NBLK#      ## NO. OF BLOCKS IN MARK7-ARRAY                      CR37  35
INTEGER NC#        ## FIELD WIDT IN FORM                                CR37  36
INTEGER NCH#       ## NR OF CHARACTRES IN CH                            CR37  37
INTEGER NCH1,NCH2,NCH3# ## CHARACTER POINTERS                           CR37  38
INTEGER NTMP#      ## NO. OF TEMP. PARAMETERS                           CR37  39
INTEGER P#         ## POINTER IN OUTPUT BUFFER                          CR37  40
INTEGER PACK#      ## PACKET SIZE OF LR ON BDF                          CR37  41
INTEGER PAR#       ## NR OF PARAMETERS                                  CR37  42
INTEGER PARTOT#    ## TOTAL NR OF PARAMS                                CR37  43
INTEGER PCON#      ## CONSTRAINED OR INVARIANT PARAM POINTER            CR37  44
INTEGER PRNT#      ## CODE FOR LINE: PRINT                              CR37  45
REAL    Q,Q1,Q2,Q3##                                                    CR37  46
INTEGER S#         ## SIGN FOR OUTPUT IDNUMS                            CR37  47
REAL    SIGBOV#    ## SIGMA OF CORRELATION CORECTION                    CR37  48
REAL    SIGB(6)#   ## SIGMA IN CORRELATION CORRECTIONS                  CR37  49
INTEGER SGNL(4)#   ## KEYS FOR DIRECTORY PACKETS                        CR37  50
INTEGER VAR#       ## NR OF VARIABLES                                   CR37  51
INTEGER VAR0#      ## FIRST VARIABLE IN A BLOCK                         CR37  52
REAL    XC,YC,ZC#  ##                                                   CR37  53
#                                                                       CR37  54
chardata:(CR371,  X  Y  ZU11U22U33U12U13U23POP)#                        CR37  55
chardata:(CR372,-OLD D   NEW SD  D/SDATOM)#                             CR37  56
chardata:(CR373, UIJ MATRIX FOR ATOM          IS NOT $#                 CR37  57
POSITIVE DEFINITE.)#                                                    CR37  58
chardata:(CR374, SHIFTS ARE MULTIPLIED BY)#                             CR37  59
chardata:(CR375, MAXIMUM SHIFT/ERROR          )#                        CR37  60
chardata:(CR376, AVERAGE SHIFT/ERROR          )#                        CR37  61
#                                                                       CR37  62
realdata:(FMT2,[952.,952.,952.,952.,952.,952.])#                        CR37  63
realdata:(FMT3,[752.,752.,752.])#                                       CR37  64
#                                                                       CR37  65
intdata:(ISKIP,[0])#                   Skip factor in iwant array,      CR37  66
intdata:(L9,[0])#                                                       CR37  67
intdata:(VARBLK,[0])#                  Nr of variables in a block       CR37  68
datastuff:#                                                             CR37  69
#                                                                       CR37  70
#        DEFINE HEAD OF ATOM TABEL                                      CR37  71
#        -------------------------                                      CR37  72
#                                                                       CR37  73
CH=' '#                                Blank header line                CR37  74
IF(REFTMP>=4)      PAR=9#              Nr of coord + dp, if aniso       CR37  75
ELSE IF (REFTMP>0) PAR=4#              Idem, if isotropic dp            CR37  76
ELSE               PAR=3#              Idem, if overall dp              CR37  77
LCHROT=LABMAX+8#                       Left char pointer                CR37  78
NC=MIN0((prtcmax:-LCHROT-5*REFPOP)/PAR,10)# Field width for format      CR37  79
IF(NC>=8)#                             All on one line                  CR37  80
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR37  81
CH(2^5)='ATOM'#                        'atom' in header                 CR37  82
NCH=LCHROT-4;NCH1=2;NCH2=LABMAX+4#     Character pointers               CR37  83
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR37  84
ELSE#                                  Use 2 lines                      CR37  85
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR37  86
NCH=2;NCH1=7;NCH2=2;NC=8#              Character pointers               CR37  87
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR37  88
K=-2#                                  Pointer in cr371                 CR37  89
DO I=1,PAR#                            Make header for all param        CR37  90
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR37  91
K=K+3;NCH=NCH+NC#                      Adjust pointers                  CR37  92
IF(I==4 & PAR==4) CH(NCH^NCH+2)='  U'# 'u' in header                    CR37  93
ELSE movechar:(CR371,K,CH,NCH,3,0)#    Other param names in header      CR37  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR37  95
FORM(1)=FLOAT(NC*100+52)#              Set format for params            CR37  96
IF(REFPOP==yes:)#                      Print pop.param                  CR37  97
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR37  98
NCH3=NCH+2;NCH=NCH+NC-3#               Adjust pointers                  CR37  99
CH(NCH^NCH+2)='POP'#                   'pop' in header                  CR37 100
FORM(2)=FORM(1)-110.#                  Set format for pop               CR37 101
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR37 102
NCH=NCH+3#                             Nch is length of header          CR37 103
BFMAX=30#                              Max nr of items in bufot         CR37 104
PARTOT=PAR+REFPOP#                     Total nr of params               CR37 105
#                                                                       CR37 106
#         DIRECTORY PACKET                                              CR37 107
#         ----------------                                              CR37 108
#                                                                       CR37 109
IF(ICYCLE==NCYCLE)#                    Last cycle: update bdf           CR37 110
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR37 111
IWANT(1)=14#                           Atom label                       CR37 112
IWANT(2)=17#                           Atom datset idnum                CR37 113
IWANT(3)=22#                           Atom type idnum                  CR37 114
IWANT(4)=215#                          Slave atom flag                  CR37 115
K=4#                                   Set up pointer                   CR37 116
ISKIP=1#                               Set up count of items            CR37 117
DO I=1,11#                             Loop over x,y,....,u33,pp        CR37 118
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  CR37 119
J=K+I#                                 Point to next item in iwant      CR37 120
IWANT(J)=I#                            Set parameter idnums             CR37 121
IWANT(J+12)=I+100#                     Set sigma idnums                 CR37 122
S=1#                                   Sign for output idnum            CR37 123
###IF(I==4)#                              Biso                          CR37 124
###$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>  > CR37 125
###IF((REFTMP==0)\(REFTMP==6)) S=-1#      No atoms with biso            CR37 126
###$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<  < CR37 127
IF(I>=5&I<=10&REFTMP<4) S=-1#          No atoms with aniso              CR37 128
IF(I==11&POP==0)        S=-1#          No atoms with pop par            CR37 129
IWANT(J+23)=S*I#                       Set output idnum for param       CR37 130
IWANT(J+35)=S*(100+I)#                 Set output idnum for sigma       CR37 131
IF(S>0)ISKIP=ISKIP+1#                  Count words to sigmas            CR37 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  CR37 133
J=J+1;IWANT(J)=23#                     Dp type idnum                    CR37 134
SGNL(1)=1;SGNL(2)=K+23#                Key 1 and 2                      CR37 135
IWANT(J+23)=23#                        Dp type idnum                    CR37 136
SGNL(3)=K+46;SGNL(4)=1#                Output items;archive mode        CR37 137
#                                                                       CR37 138
IF(ADDOLD>0)#                          Test to add old parameters       CR37 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  CR37 140
DO IADD=1,11; IF(IWANT(IADD+27)>0)#    Test ouput items                 CR37 141
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  CR37 142
SGNL(3)=SGNL(3)+1;  SGNL(4)=1#         Set search signals               CR37 143
IWANT(SGNL(3))=300+IADD#               Set idnum for old parameters     CR37 144
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  CR37 145
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  CR37 146
indexpkt:(1,lratom:,PACK,IP,2,SGNL,IWANT,IREL)# Set directory packet    CR37 147
BFMAX=50#                              Max nr of items in bufot         CR37 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR37 149
#                                                                       CR37 150
#        CORRELATION COEFFICIENTS SKF/DP                                CR37 151
#        -------------------------------                                CR37 152
#                                                                       CR37 153
IF(REFUOV<0)#                          Uov for correlation corr         CR37 154
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  CR37 155
L12=MARK12+REFSKF+1#                   Point to shift(uov)              CR37 156
L13=MARK13+REFSKF+1#                   Point to std(uov)                CR37 157
DELBOV=(QX(L12)-QX(MARK14+2))/CELL(1)# Corrl correction                 CR37 158
SIGBOV=(QX(L13)*QX(L13)-QX(MARK14+3))/(CELL(1)*CELL(1))# Sigma corrl    CR37 159
DO J=1,6#                              Loop over anisotropic terms      CR37 160
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 CR37 161
DELB(J)=DELBOV*CELL(J)#                Shifts(uij)                      CR37 162
SIGB(J)=SIGBOV*CELL(J)*CELL(J)#        Sigma(uij)                       CR37 163
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 CR37 164
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  CR37 165
#                                                                       CR37 166
#        INITIALIZATIONS FOR ATOM LOOP                                  CR37 167
#        -----------------------------                                  CR37 168
#                                                                       CR37 169
LCON=MARK10;nextconstr:(0)#            Set constr pointers              CR37 170
IF(BLKTYP==3)#                         User defined blocks              CR37 171
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 CR37 172
L9=MARK9+1;N9=NINT(QX(L9))#            Pointer/variable no              CR37 173
L12=MARK12+N9;L13=MARK13+N9#           Point to shifts & std            CR37 174
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 CR37 175
ELSE#                                                                   CR37 176
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 CR37 177
N9=0#                                  No mark9-values present          CR37 178
L12=MARK12+VARGEN+1#                   Point to shifts                  CR37 179
L13=MARK13+VARGEN+1#                   Point to std                     CR37 180
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 CR37 181
IF((MARK10+1!=MARK11)\(BLKTYP==3)) FLAG=yes:# Examine constr/b          CR37 182
ELSE FLAG=no:#                         All par are variables            CR37 183
GROUP=no:#                             Not a group atom                 CR37 184
writeline:(0,0,0,1,3);LINRM=7#         Insert blank line                CR37 185
#                                                                       CR37 186
#        LOOP OVER THE ATOMS                                            CR37 187
#        -------------------                                            CR37 188
#                                                                       CR37 189
FOR(L5=MARK5+incr:(name:);L5<MARK6;L5=NINT(QX(L5)))# Atom loop          CR37 190
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 CR37 191
movertoc:(QX(L5-name:),1,NAME,1,24,0)# Move at id                       CR37 192
intunpak:(QX(L5+1),NTMP,5,3)#          Get nr of dp                     CR37 193
PAR=3+NTMP+POP;VAR=3+NTMP+REFPOP#      Nr of par & var                  CR37 194
PRNT=yes:#                             Print flag                       CR37 195
movereal:(-1000.,1,BUFOT,1,mxfdim:,2)# Set output buffer to -1000.      CR37 196
movereal:(QX,L5+2,BUFOT,1,PAR,0)#      Move old parameters              CR37 197
IF(FLAG==0)#                           No constraints or invariants     CR37 198
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 CR37 199
movereal:(QX,L12,BUFOT,11,VAR,0)#      Move shifts                      CR37 200
movereal:(QX,L13,BUFOT,31,VAR,0)#      Move std deviations              CR37 201
L12=L12+VAR;L13=L13+VAR#               Incr l12,l13                     CR37 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 CR37 203
ELSE#                                  Constraints or invariants        CR37 204
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 CR37 205
IF(-PCON==L5)#                         All par. are invariant           CR37 206
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 CR37 207
PRNT=no:#                              Do not print shifts, etc         CR37 208
nextconstr:(1)#                        Initialize next constr           CR37 209
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 CR37 210
ELSE#                                  One or more par of this atom     CR37 211
DO I=1,VAR#                            Loop over variables              CR37 212
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 CR37 213
IF(IABS(PCON)!=L5+I+1)#                Independent parameter            CR37 214
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 CR37 215
BUFOT(I+10)=QX(L12);BUFOT(I+30)=QX(L13)# Shift & std                    CR37 216
L12=L12+1;L13=L13+1#                   Incr pointers to shift & std     CR37 217
IF((L5+I+1==-N9)\(N9>0))#              Get next varnr (user blocks)     CR37 218
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 CR37 219
L9=L9+1;N9=NINT(QX(L9))#               Get next item in mark9 array     CR37 220
IF(N9>0)#                              If positive: varnr               CR37 221
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 CR37 222
L12=MARK12+N9;L13=MARK13+N9#           Point to shifts/std dev          CR37 223
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 CR37 224
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 CR37 225
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 CR37 226
ELSE IF(PCON<0) nextconstr:(1)#        Invariant; set for next cons     CR37 227
ELSE#                                  Constraint                       CR37 228
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 CR37 229
N0=NINT(QX(LCON+2))#                   -1 for normal constraint         CR37 230
IF(N0>0)#                              If first group param             CR37 231
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 CR37 232
L12=L12+N0;L13=L13+N0#                 Incr pointers                    CR37 233
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 CR37 234
N1=NINT(QX(LCON+3))#                   No.of items in constr            CR37 235
N2=NINT(QX(LCON+4))#                   Nr of items per subset           CR37 236
J=LCON+4#                              Point to first ref.var           CR37 237
Q=0.;Q1=0.#                            Sums shift & std**2              CR37 238
REPEAT#                                Loop over the ref. var.          CR37 239
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 CR37 240
K=NINT(QX(J+1))#                       Varnr                            CR37 241
K12=MARK12+K;K13=MARK13+K#             Point to shifts & std            CR37 242
IF(N2>1) FACT=QX(J+2)#                 Constraint                       CR37 243
ELSE FACT=-1.#                         Polar constraint                 CR37 244
IF((N0<0)\(I>3))$#                     Normal constraint or dp          CR37 245
Q=Q+FACT*QX(K12)#                      Sum shifts                       CR37 246
ELSE GROUP=yes:#                       Coord. of group atom             CR37 247
Q1=Q1+FACT*FACT*QX(K13)*QX(K13)#       Sum sd**2                        CR37 248
J=J+N2#                                Point to next reference set      CR37 249
IF(J-LCON>=N1) BREAK#                  Last ref.var.dealt with          CR37 250
#                                                                       CR37 251
## APPROXIMATE SD BY SUM(COV)                                           CR37 252
#                                                                       CR37 253
VAR0=0;L11BLK=MARK11#                  Init. var counter;matr. poin     CR37 254
FOR(L8=MARK8+2;L8<MARK9;L8=L8+2)#      Loop over the blocks             CR37 255
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 CR37 256
NBLK=NINT(QX(L8));VARBLK=NINT(QX(L8+1))# No.of blocks/var               CR37 257
FOR(N=1;N<=NBLK;N=N+1)#                Loop over the block subsets      CR37 258
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 CR37 259
IF((VAR0+VARBLK)>=K) BREAK#            Var is in this block             CR37 260
VAR0=VAR0+VARBLK#                      Incr first var of block          CR37 261
L11BLK=L11BLK+(VARBLK+1)*VARBLK/2#     Incr first index in block        CR37 262
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 CR37 263
IF(N<=NBLK) BREAK#                     Wanted block is reached          CR37 264
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 CR37 265
#                                                                       CR37 266
L=LCON#                                Init. l pointer                  CR37 267
FOR(L=J;L<N1;L=L+N2)#                  Loop over rest of variables      CR37 268
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 CR37 269
K1=NINT(QX(L+1))#                      Next reference var               CR37 270
IF(K1>(VAR0+VARBLK)) NEXT#             Ref.var not in same block        CR37 271
IF(N2>1) FACT1=QX(L+2)#                Get mult factor for normal c     CR37 272
ELSE FACT1=-1.#                        Mult factor for polar c.         CR37 273
M1=K-VAR0#                             Var no. in this block            CR37 274
M2=K1-VAR0#                            Idem, second var                 CR37 275
L11=L11BLK#                            Find pointer to cov-el.          CR37 276
FOR(M=1;M<M1;M=M+1) L11=L11+VARBLK-M#  Loop over the rows               CR37 277
L11=L11+M2#                            Point to cov-el.                 CR37 278
Q1=Q1+2.*FACT*FACT1*QX(L11)*QX(MARK14+1)# Sum sd**2                     CR37 279
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 CR37 280
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 CR37 281
BUFOT(I+10)=Q;BUFOT(I+30)=SQRT(Q1)#    Store shift & std deviation      CR37 282
nextconstr:(N1)#                       Set for next constr              CR37 283
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 CR37 284
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 CR37 285
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 CR37 286
#                                                                       CR37 287
#         ADJUST TEMPERATURE FACTORS                                    CR37 288
#         --------------------------                                    CR37 289
#                                                                       CR37 290
IF(REFUOV<0)#                          Correlation skf/tmp              CR37 291
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 CR37 292
FOR(I=1;I<=NTMP;I=I+1)#                Loop over temp.par               CR37 293
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 CR37 294
IF(BUFOT(I+13)<-999.) NEXT#            Skip invariant params            CR37 295
BUFOT(I+13)=BUFOT(I+13)+DELB(I)#       Adjust shifts                    CR37 296
IF(ICYCLE<NCYCLE) NEXT#                Std only in last cycle           CR37 297
BUFOT(I+33)=SQRT(BUFOT(I+33)*BUFOT(I+33)+SIGB(I))# Adjust std dev       CR37 298
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 CR37 299
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 CR37 300
IF((NTMP==1)&(BUFOT(14)>-999))#        If biso and refined              CR37 301
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 CR37 302
BUFOT(14)=BUFOT(14)/CELL(1)#           Shift : beta to b                CR37 303
BUFOT(34)=BUFOT(34)/CELL(1)#           Std dev: beta to b               CR37 304
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 CR37 305
#                                                                       CR37 306
#         UPDATE ATOM LIST                                              CR37 307
#         ----------------                                              CR37 308
#                                                                       CR37 309
DO I=1,VAR#                            Loop over variables              CR37 310
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 CR37 311
IF(BUFOT(I+10)<-999.) NEXT#            Skip invariant params            CR37 312
M=L5+1+I;QX(M)=QX(M)+DAMP*BUFOT(I+10)# Calculate new parameter          CR37 313
BUFOT(I+20)=QX(M)#                     Store in output buffer           CR37 314
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 CR37 315
#                                                                       CR37 316
#        UPDATE COORDINATES OF GROUP ATOMS                              CR37 317
#        ---------------------------------                              CR37 318
#                                                                       CR37 319
IF(GROUP==yes:)#                       Current atom is group atom       CR37 320
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 CR37 321
I6=MARK6#                              Start of group array             CR37 322
WHILE(I6<MARK7)#                       Loop over the groups             CR37 323
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 CR37 324
IF(QX(I6+2)<1.5) NATGR=NINT(QX(I6+1))# Nr of atoms in group/idmol       CR37 325
ELSE#                                  N-th idmol                       CR37 326
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 CR37 327
I6FRST=NINT(QX(I6+1))#                 Point to 1-st idmol              CR37 328
NATGR=NINT(QX(I6FRST+1))#              Nr of atoms in idmol             CR37 329
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 CR37 330
ifeq:(QX(I6+2),1.)#                    If first idmol                   CR37 331
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 CR37 332
I6=I6+ISTEP6+NATGR*NSTEP6#             Point to next group              CR37 333
NEXT#                                  Goto next group                  CR37 334
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 CR37 335
ifeq:(QX(I6+2),2.)#                    If 2nd idmol                     CR37 336
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 35 CR37 337
L6=I6+ISTEP6#                          Point to first atom in 2nd mol   CR37 338
#                                                                       CR37 339
## CALC NEW  COORDS AND C.OF GR. OF 1ST IDMOL                           CR37 340
#                                                                       CR37 341
IF(L5==NINT(QX(L6+1)))#                Current at is 1st at,2nd idmol   CR37 342
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 36 CR37 343
XC=QX(I6FRST+3);YC=QX(I6FRST+4);ZC=QX(I6FRST+5)# Save old c.of gr.      CR37 344
#                                                                       CR37 345
## CENTER OF GRAVITY                                                    CR37 346
#                                                                       CR37 347
DO J=3,5;QX(I6FRST+J)=0.#              Init sum over coords             CR37 348
L6=I6FRST+ISTEP6#                      Point to first atom in 1st mol   CR37 349
DO I=1,NATGR#                          Loop over the mol atoms          CR37 350
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 37 CR37 351
LL5=NINT(QX(L6+1))-1#                  Atom pointer                     CR37 352
DO J=3,5;QX(I6FRST+J)=QX(I6FRST+J)+QX(L6+6)*QX(LL5+J)# Sum atwt*coord   CR37 353
L6=L6+NSTEP6#                          Point to next atom in mol        CR37 354
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 37 CR37 355
L6=I6FRST+ISTEP6#                      Point to 1st atom                CR37 356
DO J=3,5;QX(I6FRST+J)=QX(I6FRST+J)/QX(L6+7)# Calc c.of gr.              CR37 357
#                                                                       CR37 358
## ORTH.COORDS RELATIVE TO OLD C.OF GR.                                 CR37 359
#                                                                       CR37 360
DO I=1,NATGR#                          Loop over the atoms              CR37 361
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 38 CR37 362
I1=11#                                 Pointer in orth. matrix          CR37 363
LL5=NINT(QX(L6+1))+1#                  Atom pointer                     CR37 364
DO J=1,3#                              Loop over the coords             CR37 365
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 39 CR37 366
I1=I1+1#                               Incr cell pointer                CR37 367
QX(L6+2+J)=CELL(I1+1)*(QX(LL5+1)-XC)+$# Calc orthog coord               CR37 368
           CELL(I1+4)*(QX(LL5+2)-YC)+$#                                 CR37 369
           CELL(I1+7)*(QX(LL5+3)-ZC)#                                   CR37 370
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 39 CR37 371
L6=L6+NSTEP6#                          Point to next atom in mol        CR37 372
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 38 CR37 373
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 36 CR37 374
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 35 CR37 375
#                                                                       CR37 376
## CALC NEW ORTH COORDS                                                 CR37 377
#                                                                       CR37 378
L6=I6+ISTEP6-NSTEP6#                   Point to first atom              CR37 379
DO I=1,NATGR#                          Loop over group atoms            CR37 380
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 40 CR37 381
L6=L6+NSTEP6#                          Point to next atom               CR37 382
IF(NINT(QX(L6+1))==L5) BREAK#          Atoms match                      CR37 383
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 40 CR37 384
IF(I<=NATGR)#                          If atoms match                   CR37 385
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 41 CR37 386
I1=I6+20#                              Point to rotation matrix         CR37 387
IF(QX(I6+2)<1.5) I2=L6+5#              Point to internal coord          CR37 388
ELSE I2=I6FRST+ISTEP6+(I-1)*NSTEP6+2#  Point to orth coord of 1st idm   CR37 389
DO J=1,3#                              Loop over coords                 CR37 390
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 42 CR37 391
I1=I1+1#                               Adjust pointer                   CR37 392
QX(L6+2+J)=QX(I1+1)*QX(I2+1)+QX(I1+4)*QX(I2+2)+QX(I1+7)*QX(I2+3)#       CR37 393
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 42 CR37 394
#                                                                       CR37 395
## CALC NEW REL COORDS                                                  CR37 396
#                                                                       CR37 397
I1=20;I3=I6+2#                         Point to rec.cell & euler par    CR37 398
DO J=1,3#                              Loop over coord.                 CR37 399
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 43 CR37 400
I1=I1+1;I3=I3+1#                       Incr pointers                    CR37 401
Q1=CELL(I1+1)*QX(L6+3)+CELL(I1+4)*QX(L6+4)+$#                           CR37 402
   CELL(I1+7)*QX(L6+5)+QX(I3)#         Orth to relative + c.of.gr.      CR37 403
M=L5+1+J;BUFOT(J+10)=Q1-QX(M)#         Shift = new - old value          CR37 404
QX(M)=Q1;BUFOT(J+20)=Q1#               New value                        CR37 405
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 43 CR37 406
#                                                                       CR37 407
## ADJUST ORTH COORDS OF 1ST IDMOL                                      CR37 408
#                                                                       CR37 409
IF(QX(I6+2)>1.5)#                      If n-th idmol                    CR37 410
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 44 CR37 411
L6=I6FRST+ISTEP6+(I-1)*NSTEP6#         Point to corresp. at in 1st id   CR37 412
QX(L6+3)=QX(L6+3)+XC-QX(I6FRST+3)#     Adjust orth. x coord, 1st idmo   CR37 413
QX(L6+4)=QX(L6+4)+YC-QX(I6FRST+4)#     Adjust orth. y coord, 1st idmo   CR37 414
QX(L6+5)=QX(L6+5)+ZC-QX(I6FRST+5)#     Adjust orth. z coord, 1st idmo   CR37 415
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 44 CR37 416
#                                                                       CR37 417
BREAK#                                 Exit loop over the groups        CR37 418
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 41 CR37 419
I6=L6+NSTEP6#                          Set for next group               CR37 420
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 CR37 421
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 CR37 422
#                                                                       CR37 423
#       CHECK IF DP POSITIVE DEFINITE                                   CR37 424
#       -----------------------------                                   CR37 425
#                                                                       CR37 426
FFACT=0.0#                             Set fudge factor                 CR37 427
IF(NTMP>0)#                            For b iso & b aniso dp           CR37 428
DO J=1,20#                             Loop over 20 corrn of .05        CR37 429
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 45 CR37 430
IF((NTMP==1)&(QX(L5+5)>0.)) BREAK#     Iso,positive                     CR37 431
IF(NTMP==6)#                           Aniso                            CR37 432
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 46 CR37 433
IF((QX(L5+5)>0.)&(QX(L5+6)>0.)&(QX(L5+7)>0.))# B aniso positive         CR37 434
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 47 CR37 435
Q1=QX(L5+5)*QX(L5+6)-QX(L5+8)*QX(L5+8)# Minor                           CR37 436
Q2=QX(L5+5)*QX(L5+7)-QX(L5+9)*QX(L5+9)# Minor                           CR37 437
Q3=QX(L5+6)*QX(L5+7)-QX(L5+10)*QX(L5+10)# Minor                         CR37 438
IF((Q1>0.)&(Q2>0.)&(Q3>0.))#           Minors must be positive          CR37 439
Q=    QX(L5+5)*QX(L5+6)*QX(L5+7)  + $# Determinant                      CR37 440
   2.*QX(L5+8)*QX(L5+9)*QX(L5+10) - $#                                  CR37 441
      QX(L5+5)*QX(L5+10)*QX(L5+10)- $#                                  CR37 442
      QX(L5+6)*QX(L5+9)*QX(L5+9)  - $#                                  CR37 443
      QX(L5+7)*QX(L5+8)*QX(L5+8)#                                       CR37 444
ELSE  Q=0.#                            Set determinant to xero          CR37 445
IF(Q>0.0) BREAK#                       Determinant must be pos.         CR37 446
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 47 CR37 447
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 46 CR37 448
FFACT=FFACT+.05#                       Increment ffact                  CR37 449
IF(TMPTST>0)  BREAK#                   Write a message (later)          CR37 450
DO I=1,NTMP#                           Loop over dp                     CR37 451
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 48 CR37 452
IF(BUFOT(I+13)<-999.) NEXT#            Skip invariant params            CR37 453
M=L5+4+I;QX(M)=QX(M)-DAMP*.05*BUFOT(I+13)# Adjust dp elements           CR37 454
BUFOT(I+23)=QX(M)#                     Store new value                  CR37 455
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 48 CR37 456
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 45 CR37 457
FFACT=1.-FFACT#                        Get ffactor applied              CR37 458
IF(FFACT<1.00)#                        Fudge has been applied           CR37 459
IF(TMPTST==0)#                         Reset temp fact output           CR37 460
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 49 CR37 461
DO I=1,NTMP#                           Loop over aniso dp shfts         CR37 462
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 50 CR37 463
IF(BUFOT(I+13)<-999.) NEXT#            Skip invariant params            CR37 464
BUFOT(I+13)=BUFOT(I+13)*FFACT#         Apply fudge to shifts            CR37 465
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 50 CR37 466
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 49 CR37 467
#                                                                       CR37 468
#        CALCULATE SHIFT/STD                                            CR37 469
#        -------------------                                            CR37 470
#                                                                       CR37 471
IF(ICYCLE==NCYCLE)#                    If last cycle                    CR37 472
DO J=1,VAR#                            Loop over variables              CR37 473
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 51 CR37 474
IF(BUFOT(J+10)<-999.) NEXT#            Skip invariant param             CR37 475
BUFOT(J+40)=0.#                        Set shift/std                    CR37 476
IF(BUFOT(J+30)<small:) NEXT#           Protect against division by ze   CR37 477
BUFOT(J+40)=ABS(BUFOT(J+10))/BUFOT(J+30)# Shift/std                     CR37 478
DSDMAX=AMAX1(DSDMAX,BUFOT(J+40))#      Maximum shift/std                CR37 479
DSDAVE=DSDAVE+BUFOT(J+40)#             Average shift/std                CR37 480
DSDNUM=DSDNUM+1.#                      Number of shift/std values       CR37 481
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 51 CR37 482
#                                                                       CR37 483
#        UPDATE BINARY DATA FILE                                        CR37 484
#        -----------------------                                        CR37 485
#                                                                       CR37 486
IF(ICYCLE==NCYCLE)#                    If last cycle: update bdf        CR37 487
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 52 CR37 488
CALL CR38(NAME,IREL,IWANT,SGNL,P)#     Read and copy atom packet        CR37 489
#                                                                       CR37 490
## INSERT NEW VALUES                                                    CR37 491
#                                                                       CR37 492
K=SGNL(1)+3;J1=0#                      Point to params                  CR37 493
IP=IOPKPT(1)#                          Ip pak pointer                   CR37 494
DO I=1,12#                             Loop over x,y,z,u11,..pp,ndp     CR37 495
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 53 CR37 496
IF(I==4)             FLACT=BTOU#       Convert isotropic b to u on bd   CR37 497
ELSE IF (I>=5&I<=10) FLACT=0.01*CELL(I+2)# Beta ij to uij               CR37 498
ELSE                 FLACT=1.0#        No conversion necessary          CR37 499
J=K+I#                                 Point to next output item        CR37 500
IF(IWANT(J+23)<=0) NEXT#               Not wanted in output             CR37 501
P=P+1;  L=P+ISKIP#                     Pointers to param & std.         CR37 502
M=L+ISKIP-1#                           Posn before old parameters       CR37 503
IF(I==4&NTMP!=1)#                      Uiso -- prepare for u equiv      CR37 504
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 54 CR37 505
JJP=P;   QX(JJP)=0.#                   Zero initial u equiv             CR37 506
JJL=L;   QX(JJL)=0.;  NEXT#            Zero initial sigma u equiv       CR37 507
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 54 CR37 508
IF(I>=5&I<=10&NTMP!=6) NEXT#           Skip aniso if aniso not needed   CR37 509
IF(I<=11)#                             If parameter x,y,...u13,pp       CR37 510
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 55 CR37 511
IF(ADDOLD>0)#                          Are old para to be op?           CR37 512
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 56 CR37 513
M2=IREL(J)+IP; QX(M)=QX(M2)#           Store old parameter in buffer    CR37 514
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 56 CR37 515
J1=J1+1#                               Point to next output item        CR37 516
IF(BUFOT(J1+20)>-999.)#                If refined                       CR37 517
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 57 CR37 518
QX(P)=BUFOT(J1+20)*FLACT#              Save new parameter from memory   CR37 519
QX(L)=BUFOT(J1+30)*FLACT#              Save e.s.d.                      CR37 520
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 57 CR37 521
ELSE#                                  If invariant                     CR37 522
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 58 CR37 523
QX(P)=BUFOT(J1)*FLACT;QX(L)=0.#        Set equal to old value;std=0     CR37 524
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 58 CR37 525
IF(I>=5&I<=10)#                        If aniso calc u equiv            CR37 526
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 59 CR37 527
QX(JJP)=QX(JJP)+QX(P)*UEQU(I-4)#       Calc u equiv                     CR37 528
QX(JJL)=QX(JJL)+QX(L)*UEQU(I-4)#       Calc sigma u equiv               CR37 529
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 59 CR37 530
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 55 CR37 531
ELSE#                                  Dp type                          CR37 532
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 60 CR37 533
N=MIN0(2,NTMP);QX(P)=FLOAT(N)#         Save dp type                     CR37 534
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 60 CR37 535
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 53 CR37 536
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 52 CR37 537
#                                                                       CR37 538
#        PRINT SHIFTS AND NEW PARAMETERS                                CR37 539
#        -------------------------------                                CR37 540
#                                                                       CR37 541
movechar:(NAME,1,CHROT,NCH1,LABMAX,0)# Move atom id                     CR37 542
IF(NCH1>2)#                            If 'atom' on separate line       CR37 543
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 61 CR37 544
CHROT(2^5)='ATOM'#                     'atom' in output line            CR37 545
writeline:(0,CH,NCH,1,3)#              Write this line                  CR37 546
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 61 CR37 547
#                                                                       CR37 548
DO I=1,BFMAX,10#                       Loop over output lines           CR37 549
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 62 CR37 550
IF(I<40)#                              Convert u values, not s/sd       CR37 551
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 63 CR37 552
IF(NTMP==1) BUFOT(I+3)=BTOHU*BUFOT(I+3)# Convert b to 100*u             CR37 553
ELSE#                                  Not isotropic dp                 CR37 554
FOR(J=1;J<=NTMP;J=J+1)#                Loop over anisotropic dp         CR37 555
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 64 CR37 556
M=I+2+J#                                                                CR37 557
IF(BUFOT(M)<-999.) NEXT#               Ditch unrefined                  CR37 558
BUFOT(M)=BUFOT(M)*CELL(J+6)#           Convert betaij to 100*uij        CR37 559
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 64 CR37 560
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 63 CR37 561
L=I/10*4+2#                            Point to char in cr372           CR37 562
movechar:(CR372,L,CHROT,NCH2,3,0)#     Insert line header               CR37 563
LCHROT=NCH2+2;M=1#                     Point to current left char       CR37 564
DO J=1,VAR#                            Loop over params                 CR37 565
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 65 CR37 566
IF(J==PAR & REFPOP>0)#                 If pop param to be printed       CR37 567
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 66 CR37 568
M=2;LCHROT=NCH3#                       Point to format & teft char      CR37 569
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 66 CR37 570
IF(I==1 \ BUFOT(J+10)>-999.)#          If old or refined                CR37 571
ncodefld:(BUFOT,I-1+J,CHROT,FORM(M),1)# Encode value                    CR37 572
ELSE LCHROT=LCHROT+NC#                 Advance left char pnt            CR37 573
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 65 CR37 574
writeline:(0,CH,NCH,1,3)#              Print this line                  CR37 575
IF(PRNT==no:) BREAK#                   Break if all param invariant     CR37 576
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 62 CR37 577
#                                                                       CR37 578
## PRINT MESSAGES                                                       CR37 579
#                                                                       CR37 580
IF(FFACT<1.00)#                        If fudge factor calculated       CR37 581
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 67 CR37 582
movechar:(CR373,1,CHROT,1,NCR373,0)#   Move message                     CR37 583
movechar:(NAME,1,CHROT,22,8,0)#        Move atom label (8chr only)      CR37 584
IF(TMPTST==0)#                         If update dp requested           CR37 585
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 68 CR37 586
movechar:(CR374,1,CHROT,(NCR373+1),NCR374,0)# Move message              CR37 587
ncodefld:(FFACT,1,CHROT,870732.,1)#    Encode fudge fact                CR37 588
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 68 CR37 589
ELSE IF(TMPTST==2) QUITF='CR3701'#     Quit after last atom             CR37 590
writeline:(1,0,0,1,3)#                 Print the message                CR37 591
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 67 CR37 592
IF(PRNT==yes:) writeline:(1,0,0,3,3)#  Write blank line                 CR37 593
IF(LINCT<5) LINRM=5#                                                    CR37 594
#                                                                       CR37 595
#        PUNCH ATOM, U, UIJ, SUIJ LINES                                 CR37 596
#        ------------------------------                                 CR37 597
#                                                                       CR37 598
IF(PNCHCD>1)#                          If punch cards wanted            CR37 599
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 69 CR37 600
movechar:(CR372,22,CHROT,1,4,0)#       *********** atom ************    CR37 601
movechar:(NAME,1,CHROT,6,LABMAX,0)#    Move atom id                     CR37 602
LCHROT=LABMAX+6#                       Start of formats                 CR37 603
ncodefld:(QX(L5+2),1,CHROT,FMT2,3)#    Encode x, y, z                   CR37 604
CHROT(LCHROT+2^)='$1'#                 Skip the uiso                    CR37 605
LCHROT=LCHROT+3#                       Reset the format pointer         CR37 606
IF(POP==1) APOP=QX(L5+1+PAR)#          If pop present                   CR37 607
ELSE       APOP=1.#                    Otherwise pop is 1.0             CR37 608
ncodefld:(APOP,1,CHROT,632.,1)#        Format population                CR37 609
IF(ICYCLE==NCYCLE)#                    St.dev. in last cycle only       CR37 610
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 70 CR37 611
DO I=1,3; IF(BUFOT(I+30)<-999.) BUFOT(I+30)=0.# No esd calculated       CR37 612
ncodefld:(BUFOT,31,CHROT,FMT3,3)#      Encode esd(x, y, z)              CR37 613
IF(REFPOP==1)#                         If population refined            CR37 614
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 71 CR37 615
CHROT(LCHROT+2^)='$1'#                 Skip the esd(uiso)               CR37 616
LCHROT=LCHROT+3#                       Reset the format pointer         CR37 617
IF(BUFOT(VAR+30)<-999.) BUFOT(VAR+30)=0.# No pop esd calculated         CR37 618
ncodefld:(BUFOT,VAR+30,CHROT,532.,1)#  Encode esd(pop)                  CR37 619
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 71 CR37 620
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 70 CR37 621
writepch:(CHROT,80)#                   Punch an =atom= card             CR37 622
CHROT=' '#                             Blank chrot                      CR37 623
#                                                                       CR37 624
IF(NTMP<6)#                            *********** u **************     CR37 625
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 72 CR37 626
CHROT(1^)='U'#                         Move =u=                         CR37 627
movechar:(NAME,1,CHROT,6,LABMAX,0)#    Move atom id                     CR37 628
IF(NTMP==0) BUFOT(24)=BTOU*QX(MARK4+1)# U(overall)                      CR37 629
ELSE        BUFOT(24)=BTOU*QX(L5+5)#   U(isotr)                         CR37 630
LCHROT=LABMAX+6#                       Set format pointer               CR37 631
ncodefld:(BUFOT(24),1,CHROT,952.,1)#   Encode u                         CR37 632
IF(ICYCLE==NCYCLE)#                    St.dev. in last cycle only       CR37 633
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 73 CR37 634
IF(NTMP==0) BUFOT(34)=BTOU/CELL(1)*QX(MARK13+REFSKF+1)# Esd(uov)        CR37 635
ELSE IF(BUFOT(34)>-999.) BUFOT(34)=0.01*BUFOT(34)# Esd(u)               CR37 636
ELSE                     BUFOT(34)=0.# Invariant u                      CR37 637
ncodefld:(BUFOT(34),1,CHROT,952.,1)#   Encode esd(u)                    CR37 638
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 73 CR37 639
writepch:(CHROT,80)#                   Punch line                       CR37 640
CHROT=' '#                             Blank chrot                      CR37 641
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 72 CR37 642
#                                                                       CR37 643
ELSE#                                  *********** uij *************    CR37 644
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 74 CR37 645
CHROT(1^)='UIJ'#                       Inser uij header                 CR37 646
movechar:(NAME,1,CHROT,6,24,0)#        Move atom id                     CR37 647
LCHROT=LABMAX+6#                       Set format pointer               CR37 648
DO I=1,6; BUFOT(I+23)=.01*CELL(I+6)*QX(L5+I+4)# Calculate uij           CR37 649
ncodefld:(BUFOT,24,CHROT,FMT2,6)#      Encode anisotropic dp            CR37 650
writepch:(CHROT,80)#                   Punch a =uij= card               CR37 651
CHROT=' '#                             Blank chrot                      CR37 652
#                                                                       CR37 653
IF(ICYCLE==NCYCLE)#                    ************* suij **********    CR37 654
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 75 CR37 655
CHROT(1^)='SUIJ'#                      Sigma uij                        CR37 656
movechar:(NAME,1,CHROT,6,LABMAX,0)#    Move atom id                     CR37 657
DO I=1,6#                              Loop over dp                     CR37 658
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 76 CR37 659
IF(BUFOT(I+33)<-999.) BUFOT(I+33)=0.#  Invariant uij                    CR37 660
ELSE                  BUFOT(I+33)=.01*BUFOT(I+33)# Uij                  CR37 661
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 76 CR37 662
LCHROT=LABMAX+6#                       Set format pointer               CR37 663
ncodefld:(BUFOT,34,CHROT,FMT2,6)#      Encode s(uij)                    CR37 664
writepch:(CHROT,80)#                   Punch suij                       CR37 665
CHROT=' '#                             Blank chrot                      CR37 666
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 75 CR37 667
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 74 CR37 668
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 69 CR37 669
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 CR37 670
#                                                                       CR37 671
IF(ICYCLE==NCYCLE)#                    If last cycle                    CR37 672
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 77 CR37 673
LINRM=6#                               Ask for 6 lines on this page ^   CR37 674
ncodefld:(DSDMAX,1,CR375,301041.,1)#   Encode maximum std deviation ^   CR37 675
writeline:(2,CR375,NCR375,3,3)#        Print maximum shift/error        CR37 676
BUFOT(1)=DSDAVE/AMAX1(1.0,DSDNUM)#     Average shift/std                CR37 677
ncodefld:(BUFOT,1,CR376,301041.,1)#    Encode average shift/std         CR37 678
writeline:(0,CR376,NCR376,3,3)#        Print average shift/std          CR37 679
IF(SELECT==yes:) CALL CR38(NAME,IREL,IWANT,SGNL,P)# Copy atom packs     CR37 680
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 77 CR37 681
#                                                                       CR37 682
#        COPY FILE UNTIL LRREFL:                                        CR37 683
#        -----------------------                                        CR37 684
#                                                                       CR37 685
IF(ICYCLE==NCYCLE)#                    Last cycle, 2-buffer mode        CR37 686
copyfile:(1,2,incr:(lratom:),decr:(lrrefl:))# Copy bdf                  CR37 687
#                                                                       CR37 688
IF(QUITF(1^1)!=' ') iquit:(CR3701)#                                     CR37 689
RETURN#                                                                 CR37 690
END#                                                                    CR37 691
systemheader:(CR38)#                   Copy atom packet                 CR38   1
# ############################################################# #       CR38   2
#                                                               #       CR38   3
#                          CR38                                 #       CR38   4
#                                                               #       CR38   5
# ############################################################# #       CR38   6
SUBROUTINE CR38(NAME,IREL,IWANT,SGNL,P)#                                CR38   7
#                                      R.olthof august 1980             CR38   8
include:(AACOMN)#                      May 1985                         CR38   9
include:(CRCOMN)#                                                       CR38  10
#                                                                       CR38  11
string:(CH1,24)#           ## NAME OF BDF ATOM                          CR38  12
string:(NAME,24)#          ## NAME OF CURRENT ATOM                      CR38  13
INTEGER I,J,K,L,M,P#       ## POINTERS AND INDICES                      CR38  14
INTEGER IP,IPP#            ## PACKET POINTERS FOR I/O                   CR38  15
INTEGER IREL(*)#           ## RELATIVE POINTERS INTO BDF                CR38  16
INTEGER IWANT(*)#          ## POINTERS TO ITEMS WANTED FROM BDF         CR38  17
INTEGER NEWPCK#            ## NEW PACKET SIZE                           CR38  18
INTEGER PACK#              ## OLD PACKET SIZE                           CR38  19
INTEGER SGNL(4)#           ## KEYS FOR DIRECTORY                        CR38  20
datastuff:#                                                             CR38  21
#                                                                       CR38  22
NEWPCK=SGNL(4)#                        Get new packet size              CR38  23
REPEAT#                                Loop over atom packets           CR38  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR38  25
readwpkt:(1,lratom:,PACK,IP,2)#        Point to next input packet       CR38  26
IF(IP<=0) BREAK#                       Exit after last atom             CR38  27
writepkt:(2,lratom:,NEWPCK,IPP)#       Point to next output packet      CR38  28
movereal:(voidflg:,1,QX,IPP+1,NEWPCK,2)# Clear op buffer to zero        CR38  29
#                                                                       CR38  30
K=SGNL(2)+1 ; P=IPP#                   Point to output items            CR38  31
DO I=1,PACK#                           Loop over all input items        CR38  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR38  33
IF(I==IREL(K)) K=K+1#                  Delete ith item                  CR38  34
ELSE#                                  Else keep ith item               CR38  35
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR38  36
L=IP+I ; P=P+1#                        Point to input & output          CR38  37
movepakwd:(QX(L),QX(P))#               Move item from in to out         CR38  38
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR38  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR38  40
#                                                                       CR38  41
IF(SELECT==no:) BREAK#                 Exit if select key says no:      CR38  42
M=IP+IREL(1)#                          Point to atom id                 CR38  43
movertoc:(QX(M),1,CH1,1,24,0)#         Copy atom id to scratch          CR38  44
IF(CH1==NAME) BREAK#                   Exit if atoms match              CR38  45
K=SGNL(1)+3#                           Point to parameters              CR38  46
DO I=1,23#                             Loop over output items           CR38  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  CR38  48
J=K+I#                                 Point to input item              CR38  49
IF(IWANT(J+23)<=0) NEXT#               Skip if not wanted               CR38  50
P=P+1 ; L=IP+IREL(J)#                  Point to output & input          CR38  51
IF(L>IP)QX(P)=QX(L)#                   Move the item if there           CR38  52
ELSE IF(I==12)#                        If dp type not in input          CR38  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  CR38  54
IF(IREL(K+5)>0)       QX(P)=2.0#       Dp type is anisotropic           CR38  55
ELSE IF(IREL(K+4)>0)  QX(P)=1.0#       Dp type is isotropic             CR38  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  CR38  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  CR38  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR38  59
#                                                                       CR38  60
RETURN#                                                                 CR38  61
END#                                                                    CR38  62
systemheader:(CR40)#                   Add refinement data to bdf       CR40   1
# ############################################################# #       CR40   2
#                                                               #       CR40   3
#                               CR40                            #       CR40   4
#                                                               #       CR40   5
# ############################################################# #       CR40   6
SUBROUTINE CR40#                       R.olthof 1980 1985               CR40   7
#                                      S.r.hall 1990                    CR40   8
include:(AACOMN)#                                                       CR40   9
include:(CRCOMN)#                                                       CR40  10
INTEGER I,IP,ISIZ,J,JP,K#                                               CR40  11
INTEGER PSIZ#                                                           CR40  12
#                                                                       CR40  13
chardata:(SFLS,'sfls ')#                                                CR40  14
chardata:(WEIG,' unitsigma calc')#                                      CR40  15
chardata:(EXTT,'   ZachariasenBecker-Coppens')#                         CR40  16
chardata:(EXTD,'Gaussian  Lorentzian')#                                 CR40  17
chardata:(EXTE,'Eq22 p292 "Cryst. Comp." Munksgaard 1970')#             CR40  18
chardata:(MATX,'atomblock     fulluserblock')#                          CR40  19
chardata:(ABSS,'Flack xabs refined')#                                   CR40  20
chardata:(COEF,'F   FsqdInet')#                                         CR40  21
chardata:(CR1," Refinement History-")#                                  CR40  22
chardata:(CR2," Cycle     R      wR     GoF    Title")#                 CR40  23
realdata:(FMT,[40413.,120832.,200832.,200832.,280832.])#                CR40  24
datastuff:#                                                             CR40  25
#                                                                       CR40  26
copyfile:(1,2,incr:(lrrefl:),decr:(lrsfls:))# Copy up to sfls data      CR40  27
#                                                                       CR40  28
#    OUTPUT REFINEMENT DATA                                             CR40  29
#    ----------------------                                             CR40  30
#                                                                       CR40  31
PSIZ=arith:(arith:(w40c:,*,7),+,22)#   Set new packet length        ^   CR40  32
writepkt:(2,lrsfls:,PSIZ,JP)#          Point to sfls directory pakt     CR40  33
QX(JP+1)=1.#                           Idn data set number              CR40  34
J=JP+1;    DO I=1,w40c:; QX(J+I)=11.#  Idn's overall refine process     CR40  35
J=J+w40c:; DO I=1,w40c:; QX(J+I)=12.#  Idn's sfls weighting scheme      CR40  36
J=J+w40c:; DO I=1,w40c:; QX(J+I)=13.#  Idn's sfls extinction process    CR40  37
J=J+w40c:; DO I=1,w40c:; QX(J+I)=14.#  Idn's sfls matrix description    CR40  38
J=J+w40c:; DO I=1,w40c:; QX(J+I)=15.#  Idn's sfls treatment hydrogens   CR40  39
J=J+w40c:; DO I=1,w40c:; QX(J+I)=16.#  Idn's sfls absolute structure    CR40  40
J=J+w40c:; DO I=1,w40c:; QX(J+I)=17.#  Idn's sfls extinction equ        CR40  41
J=J+w40c:; DO I=1,16;QX(J+I)=FLOAT(I+20)# Idn's of refinement rfactor   CR40  42
J=J+16;    DO I=1,5; QX(J+I)=FLOAT(I+40)# Idn's of refinement summary   CR40  43
#                                                                       CR40  44
IWT=MIN(IWT,3)#                        Confine weights to u/s/c         CR40  45
writepkt:(2,lrsfls:,PSIZ,JP)#          Point to sfls data pakt          CR40  46
J=JP+1; QX(J)=FLOAT(DATSET)#           Store datset number              CR40  47
J=J+1; movector:(BLANK,1,QX(J),1,40,1)# Blank overall refine process    CR40  48
movector:(SFLS,1,QX(J),1,5,0)#         Store overall refine process     CR40  49
movector:(COEF,RFLTYP*4+1,QX(J),7,4,0)# Store refine coefficient        CR40  50
movector:(WEIG,IWT*5-4,QX(J),12,5,0)#  Store refine weight              CR40  51
movector:('weight',1,QX(J),18,6,0)#    Store refine weight              CR40  52
movector:(MATX,BLKTYP*9+1,QX(J),25,9,0)# Store sfls matrix used         CR40  53
movector:('matrix',1,QX(J),35,6,0)#    Store refine coefficient         CR40  54
#                                                                       CR40  55
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls weighting sche   CR40  56
movector:(WEIG,IWT*5-4,QX(J),1,5,0)#   Store sfls weighting scheme      CR40  57
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls extin process    CR40  58
IF(REFEXT>0)#                          If extinction applied            CR40  59
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  CR40  60
K=MIN(EXTTYP,1)*14+1; I=DSTEXT*10+1#   Point to extinct type & distr    CR40  61
movector:(EXTT,K,QX(J),1,14,0)#        Store sfls extinction type       CR40  62
IF(EXTTYP>1) movector:(EXTD,I,QX(J),16,10,0)# Store extinction distr    CR40  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  CR40  64
#ELSE        MOVECTOR:('NONE',1,QX(J),1,4,0)# NO SFLS EXTINCTION        CR40  65
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls matrix used      CR40  66
movector:(MATX,BLKTYP*9+1,QX(J),1,9,0)# Store sfls matrix used          CR40  67
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls hydr treatment   CR40  68
##movector:(hydn,1,qx(j),1,nhydn,0)# store sfls hydr treatment          CR40  69
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls abs structure    CR40  70
IF(REFABS>0)movector:(ABSS,1,QX(J),1,NABSS,0)# Store sfls abs structu   CR40  71
#ELSE        MOVECTOR:('NONE',1,QX(J),1,4,0)# NO SFLS ABS STRUCTURE     CR40  72
J=J+w40c:; movector:(BLANK,1,QX(J),1,40,1)# Blank sfls extin equ        CR40  73
IF(REFEXT>0&EXTTYP<1) movector:(EXTE,1,QX(J),1,40,0)# Store extin equ   CR40  74
J=J+w40c:-1#                           Reset op pointer                 CR40  75
QX(J+ 1)=R0(1);    QX(J+ 2)=R0(2)#     Store r based on delta           CR40  76
QX(J+ 3)=0.;       QX(J+ 4)=0.#        Store r based on w*delta         CR40  77
QX(J+ 5)=RW(1);    QX(J+ 6)=RW(2)#     Store r based on (w*delta)**2    CR40  78
QX(J+ 7)=SS(1);    QX(J+ 8)=SS(2)#     Store goodness of fit data       CR40  79
QX(J+ 9)=DSDMAX;   QX(J+10)=DSDAVE/AMAX1(1.0,DSDNUM)# Store goodness    CR40  80
QX(J+11)=voidflg:#                     Rogers abs config factor         CR40  81
IF(REFABS>0)QX(J+12)=XABS#             Flacks abs config factor         CR40  82
ELSE        QX(J+12)=voidflg:#         Flacks abs config factor         CR40  83
IF(EXTTYP<2\EXTTYP==3) QX(J+13)=QX(MARK4+2)*10000.# Extinction g        CR40  84
ELSE                   QX(J+13)=QX(MARK4+3)*10000.# Extinction rho      CR40  85
QX(J+14)=EXTESD*10000.#                Extinction esd                   CR40  86
QX(J+15)=voidflg:#                     Rogers sigma(su)(always void)^   CR40  87
IF(REFABS>0)QX(J+16)=XABSIG#           Flacks abs config sigma(su)  ^   CR40  88
ELSE        QX(J+16)=voidflg:#         Voided item                  ^   CR40  89
K=J+16#                                Separate op pointers             CR40  90
QX(K+ 1)=FLOAT(RFLTYP+1)#              Coeff type (1=f; 2=f**2; 3=i)    CR40  91
QX(K+ 2)=RSUMS(51)#                    No. of refined parameters        CR40  92
QX(K+ 3)=RSUMS(47)#                    No. reflns used in refinement    CR40  93
QX(K+ 4)=RSUMS(59)#                    No. restrained parameters        CR40  94
QX(K+ 5)=0.#                           No. constrained parameters ???   CR40  95
#                                                                       CR40  96
#   PRINT AND STORE REFINEMENT HISTORY                                  CR40  97
#   ----------------------------------                                  CR40  98
#                                                                       CR40  99
LINRM=8#                               Leave enough space               CR40 100
movechar:(CR1,NCR1,CHROT,2,NCR1-2,2)#  Insert underline                 CR40 101
writeline:(1,CR1,NCR1-1,2,3)#          Print rfac data                  CR40 102
LINRM=2#                               Leave enough space               CR40 103
ISIZ=arith:(arith:(39,/,mxchwd:),+,6)# Get lrrfac record length         CR40 104
REPEAT#                                Loop over rfac records           CR40 105
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  CR40 106
readwpkt:(1,lrrfac:,PSIZ,IP,0)#        Read rfac records                CR40 107
writepkt:(2,lrrfac:,ISIZ,JP)#          Point to next op packet          CR40 108
IF(IP>0) movereal:(QX,IP+1,QX,JP+1,PSIZ,0)# Transfer current record     CR40 109
ELSE#                                  End of previous rfactors         CR40 110
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  CR40 111
QX(JP+1)=TCYCLE#                       Store total cycle number         CR40 112
QX(JP+2)=R0(2)#                        Store rcode=1 r factor           CR40 113
QX(JP+3)=0.#                           Not used                         CR40 114
QX(JP+4)=RW(2)#                        Store rcode=1 rw factor          CR40 115
QX(JP+5)=SS(2)#                        Store rcode=1 g-o-f value        CR40 116
movector:(TITLE,59,QX(JP+6),1,40,0)#   Store current title              CR40 117
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  CR40 118
ncodefld:(QX,JP+1,CHROT,FMT,5)#        Format rfac data                 CR40 119
movertoc:(QX(JP+6),1,CHROT,32,40,0)#   Store title string               CR40 120
writeline:(0,CR2,NCR2,1,3)#            Print rfac data                  CR40 121
IF(IP<=0) BREAK#                       Exit after last cycle            CR40 122
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  CR40 123
#                                                                       CR40 124
copyfile:(1,2,incr:(lrrfac:),endrecord:)# Copy up to eof & close        CR40 125
#                                                                       CR40 126
RETURN#                                                                 CR40 127
END#                                                                    CR40 128
pmacro:([no:])#                                                         CR40 129
