systemheader:(FE    )#                                                  FE     1
####################################################################### FE     2
##      Copyright (C) 2000, The Xtal System, The University of        # FE     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # FE     4
## Distributed under the GNU General Public Licence as published by   # FE     5
## the Free Software Foundation, in the hope that it will be useful   # FE     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # FE     7
## for more details.                                                  # FE     8
#                                                                     # FE     9
#                            *** REGFE ***                            # FE    10
#                                                                     # FE    11
#    PROGRAM REGFE CALCULATES CRYSTALLOGRAPHIC DISTANCE AND ANGLE     # FE    12
#    FUNCTIONS AND THEIR ERRORS.                                      # FE    13
#                                                                     # FE    14
####################################################################### FE    15
include:(XMACRO)#                      H.wang, r.j.barton               FE    16
#                                      B.e.robertson                    FE    17
#                                                                       FE    18
macro:(nextconstr:,[LCON=LCON+$1;PCON=NINT(QX(LCON+1))#                 FE    19
PCON=PCON+OFFSET*ISIGN(1,PCON)])#                                       FE    20
macro:(mxwd8c:,incr:(arith:(7,/,mxchwd:)))#                             FE    21
macro:(name:,incr:(arith:(23,/,mxchwd:)))#                              FE    22
macro:(iqx:,[NINT(QX($1+$2))])#                                         FE    23
macro:(la:,19)#                                                         FE    24
macro:(vxv:,CALL FE81($1,$2,$3))#      Scale producte of vectors        FE    25
macro:(mxv:,CALL FE82($1,$2,$3))#      Multiplication of v and m        FE    26
macro:(vxm:,CALL FE83($1,$2,$3))#      Multiplication of m and v        FE    27
macro:(mxm:,CALL FE84($1,$2,$3))#      Multiplication of matrices       FE    28
macro:(vgv:,CALL FE85($1,$2,$3,$4))#   Multiply v with metric tensor    FE    29
macro:(det:,CALL FE86($1,$2,$3,$4))#   Determinant of 3x3 matrix        FE    30
#                                                                       FE    31
macro:(formatc:,$(label:($1,IZZI,IQQI);$2=IZZI+2#                       FE    32
IF(IQQI!=IZZI) $1=$1(1^IQQI)//'('//$1(IQQI+1^IZZI)//')'$))#             FE    33
macro:(formatn:,CALL FE91($1,$2,$3))#                                   FE    34
#                                                                       FE    35
macro:(search:,#                       Search for atoms, lines and      FE    36
$1=$1+1#                               Planes                           FE    37
stringlim:($1,MXX,NXX)#                Get atom name limits             FE    38
movechar:(BLANK,1,DNAME,1,24,1)#       Blank name buffer                FE    39
movechar:(CHRIN,MXX,DNAME,1,NXX-MXX,0)# Store first part                FE    40
CALLFE97(DNAME,$2,$3))#                                                 FE    41
#                                                                       FE    42
macro:(plsearch:,[#                                                     FE    43
$3=$4; DO M=$5,arith:($4,+,$5)$(#                                       FE    44
search:($1,$2(M),$3)#                                                   FE    45
IF($3==$4)$(#                                                           FE    46
IF(M!=$5) iquit:(FE4504)#                                               FE    47
STATUS(ifelse:($5,1,1,2))=$4#                                           FE    48
BREAK$)$)])#                                                            FE    49
#                                      $1 -- akey pointer               FE    50
macro:(foutput:,MM=AKEY($1)#           $2 -- atom position              FE    51
movertoc:(QX(MM+[la:]),1,CHROT,10,24,0)# Extract atom name              FE    52
[ifelse:($2,0,,#                                                        FE    53
movechar:(FE457,$2,CHROT,LABMAX+12,2,0)#                                FE    54
movechar:(FE457,$3,CHROT,LABMAX+14,1,0))]#                              FE    55
LCHROT=LABMAX+15#                                                       FE    56
ncodefld:(QX,MM+2,CHROT,FMT5,3)#                                        FE    57
writeline:(0,0,0,1,3))#                                                 FE    58
#                                      $1 -- status pointer             FE    59
macro:(fpoutput:,[$#                                                    FE    60
IF(STATUS($1)!=0)$(#                                                    FE    61
MM=AKEY($2)-name:#                     $2 -- akey pointer               FE    62
movertoc:(QX(MM),1,CHROT,10,24,0)#                                      FE    63
MM=AKEY($2)#                                                            FE    64
LCHROT=LABMAX+15#                                                       FE    65
ncodefld:(QX,MM,CHROT,FMT5,4)#                                          FE    66
writeline:(0,0,0,1,3)$)#                                                FE    67
ELSE$( DO M=$2,$2+2$(#                                                  FE    68
foutput:(M,11,$1)$)$)])#                                                FE    69
#                                      $1 -- status pointer             FE    70
macro:(floutput:,[$#                                                    FE    71
IF(STATUS($1)!=0)$(#                                                    FE    72
MM=AKEY($2)-name:#                     $2 -- akey pointer               FE    73
movertoc:(QX(MM),1,CHROT,10,24,0)#                                      FE    74
MM=AKEY($2)#                                                            FE    75
LCHROT=LABMAX+15#                                                       FE    76
ncodefld:(QX,MM,CHROT,FMT5,3)#                                          FE    77
writeline:(0,0,0,1,3)$)#                                                FE    78
ELSE$( DO M=$2,$2+1$(#                                                  FE    79
foutput:(M,13,$1)$)$)])#                                                FE    80
#                                                                       FE    81
macro:(voutput:,#                      $1 -- value of function          FE    82
movechar:(FE459,1,CHROT,7,7,0)#                                         FE    83
BUFOT(1)=$1;ncodefld:(BUFOT,1,CHROT,260952.,1)#                         FE    84
movechar:(FE459,8,CHROT,32,21,0)#                                       FE    85
ncodefld:(SDT,1,CHROT,640952.,1)#                                       FE    86
writeline:(1,0,0,1,3))#                                                 FE    87
#                                                                       FE    88
extrude:(FECOMN)#                                                       FE    89
REAL    DTOR,RTOD# ## SCALE FACTORS FOR DEGREE AND RADIUS CONVERSION    FE    90
INTEGER FANGL#     ## FLAG FOR BOND ANGLE CALCULATION                   FE    91
INTEGER FASSM#     ## FLAG FOR ASSEMBLING MOLECULE.                     FE    92
INTEGER FCOAT#     ## FLAG FOR INCLUDING V-C MATRIX OF ATOM PARAMETER   FE    93
INTEGER FCOCE#     ## FLAG FOR INCLUDING V-C MATRIX OF CELL PARAMETER   FE    94
INTEGER FDIHE#     ## FLAG FOR DIHEDRAL ANGLE CALCULATION               FE    95
INTEGER FLENG#     ## FLAG FOR BOND LENGTH CALCULATION                  FE    96
INTEGER FLSAT#     ## FLAG FOR LISTING ATOMIC PARAMETERS                FE    97
INTEGER FLSCR#     ## FLAG FOR LISTING CORRELATION MATRIX               FE    98
INTEGER FLSVC#     ## FLAG FOR LISTING VARIANCE-COVARIANCE MATRIX       FE    99
INTEGER FTABL#     ## FLAG FOR CREATE A TABLE FOR PUBLICATION           FE   100
REAL    GC(3,3)#   ## METRIC TENSOR (COVARIANCE)                        FE   101
INTEGER ICENT#     ## 0=CENTRIC CELL; 1=ACENTRIC CELL                   FE   102
INTEGER LATYP#     ## LATTICE TYPE (P/I/R/F/A/B/C=0/1/2/3/4/5/6)        FE   103
INTEGER MARK1#     ## UNIT CELL INFORMATION.                            FE   104
INTEGER MARK2#     ## METRIC TENSOR.                                    FE   105
INTEGER MARK3#     ## SYMMETRY OPERATIONS.                              FE   106
INTEGER MARK4#     ## ATOM TYPES                                        FE   107
#                  ##    +1: CONTACT RADIUS;                            FE   108
#                  ##    +2: BOND RADIUS;                               FE   109
#                  ##    +3: MINIMUM BOND RADIUS.                       FE   110
INTEGER MARK5#     ## ATOMIC PARAMETERS: (LENGTH=18)                    FE   111
#                  ##    +01:  TABLE4 POINTER.                          FE   112
#                  ##    +02:  X PARAMETER.                             FE   113
#                  ##    +03:  Y PARAMETER.                             FE   114
#                  ##    +04:  Z PARAMETER.                             FE   115
#                  ##    +05:  SIGMA X.                                 FE   116
#                  ##    +06:  SIGMA Y.                                 FE   117
#                  ##    +07:  SIGMA Z.                                 FE   118
#                  ##    +08:  NUMBER OF TEMPERATURE FACTORS.           FE   119
#                  ##    +09:  OFFSET OF FIRST VARIABLE IN THE BLOCK.   FE   120
#                  ##    +10:  VARIANT/INVARIANT FLAG (00000000000).    FE   121
#                  ##    +11:  BLOCK SEQUENCAL NUMBER.                  FE   122
#                  ##    +12:  NUMBER OF CONNECTED ATOMS                FE   123
#                  ##    +13:  CLUSTER ID NUMBER                        FE   124
#                  ##    +14:  POINTER TO CONNECTED TABLE               FE   125
#                  ##    +15:  SYMMETRY OPERATION CODE                  FE   126
INTEGER MARK6#     ## ATOM PARAMETER INFORMATIONS.                      FE   127
INTEGER MARK7#     ## BLOCK INFORMATIONS.                               FE   128
INTEGER MARK8#     ##                                                   FE   129
INTEGER MARK9#     ## CONSTRAINT AND ...... INFORM                      FE   130
INTEGER MARK10#    ## BLOCK INFORMATIONS AND CONTE                      FE   131
#                  ##     +1: NUMBER OF VARIABLES IN THE BLOCK.         FE   132
#                  ##     +2: QX-ADDRESS OF FIRST ELEMENT OF THE BLOCK. FE   133
INTEGER MARK11#    ## CORRELATION MATRIX                                FE   134
INTEGER MARK12#    ## EQUATION OF PLANES,  (LENGTH=15+label)            FE   135
#                  ##     +1: PLANE INDEX                               FE   136
#                  ##     +2: COEFFICIENT A.                            FE   137
#                  ##     +3: COEFFICIENT B.                            FE   138
#                  ##     +4: COEFFICIENT C.                            FE   139
#                  ##     +5: COEFFICIENT D.                            FE   140
#                  ##     +6: ERROR MATRIX (1,1)                        FE   141
#                  ##     +7, +8, +9, +10, +11, +12, +13, +14, +15      FE   142
INTEGER MARK13#    ## EQUATION OF LINES, (LENGTH=7                      FE   143
#                  ##     +1: SEQUENCE NUMBER.                          FE   144
#                  ##     +2: COEFFICIENT A.                            FE   145
#                  ##     +3: COEFFICIENT B.                            FE   146
#                  ##     +4: COEFFICIENT C.                            FE   147
#                  ##     +5: SIGMA A.                                  FE   148
#                  ##     +6: SIGMA B.                                  FE   149
#                  ##     +7: SIGMA C.                                  FE   150
INTEGER MARK14#    ## ATOM CONNECTION TABLE                             FE   151
#                  ##     +1: CONNECTED ATOM POINTER;                   FE   152
#                  ##     +2: SYMMETRY OPERATOR (ROTATIONAL);           FE   153
#                  ##     +3: SYMMETRY OPERATOR (TRANSLATIONAL).        FE   154
INTEGER MARK15#    ## ALTERNATIVE SYMMETRY OPERATOR                     FE   155
INTEGER MARK16#    ## VARIANCE-COVARAIANCE MATRIX                       FE   156
INTEGER MARK17#    ## VARIANCE-COVARAIANCE MATRIX                       FE   157
INTEGER NATOM#     ## NUMBER OF ATOMS, TO BE INCLUDED                   FE   158
INTEGER NPLANE#    ## NUMBER OF PLANES                                  FE   159
INTEGER NLINE#     ## NUMBER OF LINES                                   FE   160
INTEGER NSFTB#     ## NR OF ENTRIES IN S.F. TABEL                       FE   161
INTEGER NSYM#      ## NUMBER OF SYMM. OPERATORS                         FE   162
INTEGER NUMBLK#    ## TOTAL NUMBER OF BLOCKS                            FE   163
INTEGER NUMCEL#    ## NUMBER OF CELLS TO BE SEARCH                      FE   164
INTEGER NUMVAB#    ## NUMBER OF ATOM PARAMETERS INVOLVED IN THE CALCU   FE   165
INTEGER NONATM#    ## NUMBER OF NON-ATOMIC PARAMET                      FE   166
INTEGER OFFSET#    ##                                                   FE   167
#                  ## 0=NO; 1= APPLY; 2= ESTABLISH AND APPLY            FE   168
INTEGER REC#       ## LOGICAL RECORD NUMBER (FILE-D)                    FE   169
INTEGER REL(45)#   ## RELATIVE ITEM POINTER                             FE   170
REAL    RGC(3,3)#  ## METRIC TENSOR (CONTRAVARIANCE)                    FE   171
INTEGER STATUS(2)# ## 0/1/2 = ATOM / LINE / PLANE                       FE   172
REAL    VOLUMN#    ## UNIT CELL VOLUMN (IN CUBIC A)                     FE   173
INTEGER STOP1, STEP1#                                                   FE   174
INTEGER STOP2, STEP2#                                                   FE   175
INTEGER STOP3, STEP3#                                                   FE   176
INTEGER STOP4, STEP4#                                                   FE   177
INTEGER STOP5, STEP5#                                                   FE   178
INTEGER STOP12,STEP12#                                                  FE   179
INTEGER STOP13,STEP13#                                                  FE   180
INTEGER STOP14#                                                         FE   181
INTEGER STOP15#                                                         FE   182
INTEGER STOP16,STEP16#                                                  FE   183
#                                                                       FE   184
COMMON/COMFFE/OFFSET,REC,GC,RGC,REL,STATUS,DTOR,RTOD,VOLUMN#            FE   185
#                                                                       FE   186
COMMON/COMIFE/ FASSM,FCOAT,FCOCE,FLSAT,FLSCR,FLSVC,FLENG,$#             FE   187
        FANGL,FDIHE,FTABL,ICENT,LATYP,NATOM,NPLANE,NLINE,$#             FE   188
        NSFTB,NSYM,MARK1,MARK2,MARK3,MARK4,MARK5,MARK6,MARK7,$#         FE   189
        MARK8,MARK9,MARK10,MARK11,MARK12,MARK13,MARK14,MARK15,$#        FE   190
        MARK16,MARK17,NONATM,NUMBLK,NUMCEL,NUMVAB,STOP1,STOP2,STOP3,$#  FE   191
        STOP4,STOP5,STOP12,STOP13,STOP15,STOP16,STEP1,STEP2,STEP3,$#    FE   192
        STEP4,STEP5,STEP12,STEP13,STEP16,STOP14#                        FE   193
endext:#                                                                FE   194
#                                                                       FE   195
systemheader:(FE00)#                                                    FE00   1
# ################################################################## #  FE00   2
#                                                                    #  FE00   3
#                            FE00                                    #  FE00   4
#                                                                    #  FE00   5
# ################################################################## #  FE00   6
SUBROUTINE FE00#                       H.wang, r.j.barton               FE00   7
#                                      B.e.robertson  july-1986         FE00   8
include:(AACOMN)#                                                       FE00   9
include:(FECOMN)#                                                       FE00  10
#                                                                       FE00  11
FILEXT(IOUNIT(4))='CMX'#               Ext of correl matrix file        FE00  12
#                                                                       FE00  13
CALL FE01#                             Read control line                FE00  14
CALL FE10#                             Read basic data from bdf         FE00  15
CALL FE20#                             Read basic data and control      FE00  16
#                                      Sequence from cards              FE00  17
IF(FCOAT==yes:)#                       If v-c matrix is required        FE00  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE00  19
CALL FE31#                             Read general data from file      FE00  20
CALL FE32#                             Retrieve refinement data         FE00  21
CALL FE33#                             Read correlation matrix          FE00  22
CALL FE34#                             Convert corr mat to v-c mat      FE00  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE00  24
ELSE#                                  If only variances are used       FE00  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE00  26
MARK6=STOP5; MARK9=STOP5;  MARK11=STOP5#                                FE00  27
MARK7=STOP5; MARK10=STOP5; MARK12=STOP5#                                FE00  28
MARK8=STOP5#                                                            FE00  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE00  30
CALL FE40#                             Planes and lines                 FE00  31
IF(FLENG==yes:\FANGL==yes:\FDIHE==yes:)#                                FE00  32
CALL FE44#                             Calculate bond length, angle     FE00  33
CALL FE45#                             Other functions                  FE00  34
#                                                                       FE00  35
RETURN#                                                                 FE00  36
END#                                                                    FE00  37
systemheader:(FE01)#                   Read control line                FE01   1
# ################################################################## #  FE01   2
#                                                                    #  FE01   3
#                            FE01                                    #  FE01   4
#                                                                    #  FE01   5
# ################################################################## #  FE01   6
SUBROUTINE FE01#                       H.wang, r.j.barton               FE01   7
#                                      B.e.robertson aug-87             FE01   8
include:(AACOMN)#                                                       FE01   9
include:(FECOMN)#                                                       FE01  10
#                                                                       FE01  11
INTEGER I,J,K#                                                          FE01  12
chardata:(FE011,$#                                                      FE01  13
VAR $#    ## 1 # EXCLUDE COVARIANCE TERMS OF ATOM PARAMETERS            FE01  14
COV $#    ## 2 # INCLUDE COVARIANCE TERMS OF ATOM PARAMETERS            FE01  15
LVC $#    ## 3 # LISTING VARIANCE-COVARIANCE MATRIX                     FE01  16
NLI $#    ## 4 # DO NOT LIST ATOM PARAMETERS                            FE01  17
LIS $#    ## 5 # LIST ATOMIC PARAMETERS                                 FE01  18
CVA $#    ## 6 # EXCLUDE COVARIANCE TERMS OF UNIT CELL PARAMETERS       FE01  19
CCO $#    ## 7 # INCLUDE COVARIANCE TERMS OF UNIT CELL PARAMETERS       FE01  20
SR  $#    ## 8 # SEARCH UNIT CELLS                                      FE01  21
BDF $#    ## 9 # READ STRUCTURE DATA FROM BINARY DATA FILE              FE01  22
NBD $#    ## 10 # READ STRUCTURE DATA FROM CARDS                        FE01  23
SYM $#    ## 11 # APPLY SPACE GROUP SYMMETRY OPERATIONS                 FE01  24
NSY $#    ## 12 # DON'T APPLY SPACE GROUP SYMMETRY OPERATIONS           FE01  25
LEN $#    ## 13 # CALCULATE BOND LENGTH                                 FE01  26
NLE $#    ## 14 # DON'T CALCULATE BOND LENGTH                           FE01  27
ANG $#    ## 15 # CALCULATE BOND ANGLE                                  FE01  28
NAN $#    ## 16 # DON'T CALCULATE BOND ANGL                             FE01  29
DIH $#    ## 17 # CALCULATE DIHEDRAL ANGLE                              FE01  30
NDI $#    ## 18 # DON'T CALCULATE DIHEDRAL ANGLE                        FE01  31
LCR $#    ## 19 # LIST CORRELATION MATRIX OF ATOM PARAMETERS            FE01  32
NLR $#    ## 20 # DO NOT LIST CORRELATION MATRIX OF ATOM PARAMETERS     FE01  33
NLV $#    ## 21 # DON'T LIST VARIANCE-COVARIANCE MATRIX                 FE01  34
TAB )#    ## 22 #                                                       FE01  35
datastuff:#                                                             FE01  36
#                                                                       FE01  37
FCOAT=yes:#                            Include covariance of atom p     FE01  38
FLSVC=no:#                             Don't list v-c matrix            FE01  39
FLSAT=yes:#                            List atom parameters             FE01  40
FCOCE=no:#                             Don't include covariance of      FE01  41
FLENG=yes:#                            Calculate bond length            FE01  42
FANGL=yes:#                            Calculate bond angle             FE01  43
FDIHE=no:#                             Don't calculate dihedral ang     FE01  44
FASSM=yes:#                            Assemble molecule                FE01  45
FLSCR=no:#                             Do not list correlation matr     FE01  46
FTABL=no:#                             Don't punch bond l, a & d tabl   FE01  47
NUMCEL=2#                              27 cells                         FE01  48
##                                                                      FE01  49
##      PROGRAM INITIATION LINE                                         FE01  50
##     *************************                                        FE01  51
##                                                                      FE01  52
FOR (I=1;I<18;I=I+1)#                  Loop for reading control lin     FE01  53
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE01  54
ifvo:(BUFIN(I)) BREAK#                 Exit at first void field.        FE01  55
stringlim:(I,J,K)#                     Translate f.p.v. to char.        FE01  56
compchar:(CHRIN,J,FE011,1,3,4,NFE011,K)# Search items.                  FE01  57
IF (K==0) iquit:(FE0101,I)#            Key word no found in =regfe=     FE01  58
ELSE IF (K==1) FCOAT=no:#              Don't include covariance (at     FE01  59
ELSE IF (K==2) FCOAT=yes:#             Include covariance of (atom)     FE01  60
ELSE IF (K==3) FLSVC=yes:#             List v-c matrix                  FE01  61
ELSE IF (K==4) FLSAT=no:#              Don't list atom, plane & lin     FE01  62
ELSE IF (K==5) FLSAT=yes:#             List atom, plane and line        FE01  63
ELSE IF (K==6) FCOCE=no:#              Don't include covariance (ce     FE01  64
ELSE IF (K==7) FCOCE=yes:#             Include covariance of (cell)     FE01  65
ELSE IF (K==8)#                        Number of cell to be search      FE01  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE01  67
ifvo:(BUFIN(I+1)) NUMCEL=2#            Default value (void)             FE01  68
ELSE#                                                                   FE01  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE01  70
I=I+1; NUMCEL=NINT(BUFIN(I))#          Number of cell to be search      FE01  71
IF(NUMCEL>3\NUMCEL<1) iquit:(FE0102)#  Invalid integer number           FE01  72
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE01  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE01  74
ELSE IF (K==11) FASSM=yes:#            Apply space group symmetry o     FE01  75
ELSE IF (K==12) FASSM=no:#             Do not apply s.g. symmetry o     FE01  76
ELSE IF (K==13) FLENG=yes:#            Do calculate bond length         FE01  77
ELSE IF (K==14) FLENG=no:#             Do not calculate bond length     FE01  78
ELSE IF (K==15) FANGL=yes:#            Do calculate bond angle          FE01  79
ELSE IF (K==16) FANGL=no:#             Don't calculate bond angle       FE01  80
ELSE IF (K==17) FDIHE=yes:#            Do calculate dihedral angle      FE01  81
ELSE IF (K==18) FDIHE=no:#             Don't calculate dihedral ang     FE01  82
ELSE IF (K==19) FLSCR=yes:#            List correlation matrix          FE01  83
ELSE IF (K==20) FLSCR=no:#             Don't list correlation matri     FE01  84
ELSE IF (K==21) FLSVC=no:#                                              FE01  85
ELSE            FTABL=yes:#                                             FE01  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE01  87
IF(FCOAT==no:) FLSCR=no:#              Don't list corelation matrix     FE01  88
##                                                                      FE01  89
##    I/O BUFFERS FOR BDF & SCRATCH                                     FE01  90
##   *******************************                                    FE01  91
##                                                                      FE01  92
IOMARK(1)=QXSTR#                       Define start buffer a            FE01  93
IOMARK(4)=QXSTR#                       Define start buffer c            FE01  94
incrqx:(MARK1,IOMARK(1)+bdfbuf:,FE0103)# Define start symm list         FE01  95
STEP1=9#                               Packet size of mark1 array       FE01  96
incrqx:(STOP1,MARK1+8*STEP1,FE0104)#   Set up cell storage              FE01  97
MARK2=STOP1;    STEP2=21#              Reserve space for cell v-c m     FE01  98
incrqx:(STOP2,MARK2+21,FE0105)#        Set up cell v-c matrix stora     FE01  99
MARK3=STOP2;    STEP3=12#              Mark symop table                 FE01 100
RETURN#                                                                 FE01 101
END#                                                                    FE01 102
systemheader:(FE10)#                                                    FE10   1
# ################################################################## #  FE10   2
#                                                                    #  FE10   3
#                            FE10                                    #  FE10   4
#                                                                    #  FE10   5
# ################################################################## #  FE10   6
SUBROUTINE FE10#                       H. wang july 1986                FE10   7
include:(AACOMN)#                                                       FE10   8
include:(FECOMN)#                                                       FE10   9
#                                                                       FE10  10
INTEGER I,J,K#                                                          FE10  11
INTEGER MSYM#                                                           FE10  12
INTEGER PSIZ#                                                           FE10  13
INTEGER IP#                                                             FE10  14
INTEGER IWNT(20)#                                                       FE10  15
INTEGER IREL(20)#                                                       FE10  16
INTEGER KEY(4)#                                                         FE10  17
INTEGER PACK#                                                           FE10  18
string:(LABEL,24)#                                                      FE10  19
intdata:(NTYPE,0)#                                                      FE10  20
datastuff:#                                                             FE10  21
#                                                                       FE10  22
DTOR=.017453293#                       From degree to radian            FE10  23
RTOD=57.2957795#                       From radian to degree            FE10  24
##                                                                      FE10  25
##   GET CELL PARAMETERS FROM LRCELL:                                   FE10  26
##  *********************************                                   FE10  27
##                                                                      FE10  28
I=MARK1#                               Point to place in list           FE10  29
FOR(J=1;J<=3;J=J+1)#                   Loop over packet 1-5             FE10  30
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE10  31
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Point to next lrcell pkt         FE10  32
IF(IP<=0) iquit:(FE1001)#              Exit if missing                  FE10  33
movereal:(QX,IP+1,QX,I+1,9,1)#         Store in table 2                 FE10  34
QX(I+7)=QX(I+7)*360.#                  Store alpha in deg               FE10  35
QX(I+8)=QX(I+8)*360.#                  Store beta  in deg               FE10  36
QX(I+9)=QX(I+9)*360.#                  Store gamma in deg               FE10  37
I=I+STEP1#                             Next packet                      FE10  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE10  39
#                                      Transformation matricse          FE10  40
FOR(J=1;J<=2;J=J+1)#                                                    FE10  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE10  42
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read transformation matrices     FE10  43
IF(IP<=0) iquit:(FE1002)#              Exit if missing                  FE10  44
movereal:(QX,IP+1,QX,I+1,9,1)#         Store in table 2                 FE10  45
I=I+STEP1#                             Next packet                      FE10  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE10  47
#                                                                       FE10  48
FOR(K=1;K<=2;K=K+1)#                                                    FE10  49
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read covariance metri tenso      FE10  50
IF(IP<=0) iquit:(FE1003)#              Data are missing, quit!          FE10  51
I=MARK1+6*STEP1#                       Next packet                      FE10  52
movereal:(QX,IP+1,QX,I+1,STEP1,1)#     Save covariance metric tenso     FE10  53
#                                                                       FE10  54
readwpkt:(1,lrcell:,PSIZ,IP,0)#        Read contravariance metric t     FE10  55
IF(IP<=0) iquit:(FE1008)#              Data are missing, quit!          FE10  56
I=I+STEP1#                             Next packet                      FE10  57
movereal:(QX,IP+1,QX,I+1,STEP1,1)#     Save contravariance metric t     FE10  58
CALL FE72(no:)#                        Retore metric tensors from       FE10  59
#                                      Qx to gc and rgc                 FE10  60
##                                                                      FE10  61
## GET LATTICE & SYMMETRY INFORMATION FROM BDF                          FE10  62
## ===========================================                          FE10  63
##                                                                      FE10  64
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Read first sym packet            FE10  65
IF(IP<=0) iquit:(FE1009)#              Exit if missing                  FE10  66
LATYP=NINT(QX(IP+1))#                  Lattice flag                     FE10  67
IF(LATYP>7) LATYP=LATYP-7#             Remove centric part              FE10  68
ICENT=NINT(QX(IP+2))#                  Centre flag (c=0;nc=1)           FE10  69
MSYM=NINT(QX(IP+3))#                   Total number of matrices         FE10  70
NSYM=NINT(QX(IP+4))#                   Number of matrices on bdf        FE10  71
incrqx:(STOP3,MARK3+12*MSYM,FE1010)#   End of full symop                FE10  72
##                                                                      FE10  73
##   READ IN ALL THE SYMMETRY OPERATIONS                                FE10  74
## ***************************************                              FE10  75
##                                                                      FE10  76
FOR(J=MARK3;J>0;J=J+STEP3)#            Loop over sym matrices           FE10  77
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE10  78
readwpkt:(1,lrsymm:,PSIZ,IP,0)#        Point next matrix                FE10  79
IF(IP<=0) BREAK#                       Exit when no more                FE10  80
movereal:(QX,IP+1,QX,J+1,PSIZ,1)#      Store matrix in table 2          FE10  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE10  82
##                                                                      FE10  83
##     SETUP FF AND ATOM TABLES 4 AND 5                                 FE10  84
##   ************************************                               FE10  85
##                                                                      FE10  86
MARK4=STOP3;          STEP4=3+mxwd8c:# Start/step ff table 4            FE10  87
##                                                                      FE10  88
##    ENTER FF TYPES FROM LRSCAT                                        FE10  89
##   ****************************                                       FE10  90
##                                                                      FE10  91
IWNT(1)=11; IWNT(2)=5; IWNT(3)=6#      Ff name, bond & cont radius      FE10  92
KEY(1)=1; KEY(2)=3; KEY(3)=0; KEY(4)=0# Search parameters               FE10  93
indexpkt:(1,lrscat:,PSIZ,IP,0,KEY,IWNT,IREL)# Search ff parameters      FE10  94
IF(KEY(1)<=0) iquit:(FE1011)#          No ff........fe1011              FE10  95
FOR(J=MARK4;J>0;J=J+STEP4)#            Loop over ff table               FE10  96
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE10  97
readwpkt:(1,lrscat:,PSIZ,IP,0)#        Read next ff packet              FE10  98
IF(IP<=0) BREAK#                       Exit if no more                  FE10  99
incrqx:(STOP4,J+STEP4,FE1012)#         Required more sapce for ff       FE10 100
K=IP+IREL(1)#                          Point ff name                    FE10 101
movereal:(QX,K,QX,J+4,mxwd8c:,1)#      Store ff name                    FE10 102
QX(J+3)=0.15#                          Set default min bond radius      FE10 103
K=IP+IREL(2); IF(K>IP) QX(J+2)=QX(K)+.1# Get max bond radius            FE10 104
K=IP+IREL(3); IF(K>IP) QX(J+1)=QX(K)+.2# Get max contact radius         FE10 105
NTYPE=NTYPE+1#                         Count ff types                   FE10 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE10 107
MARK5=STOP4#                           Set mark5 pointer                FE10 108
STEP5=decr:(la:)+name:#                Start/step atom table 5          FE10 109
##                                                                      FE10 110
##        READ ATOMS FROM BDF                                           FE10 111
##      ***********************                                         FE10 112
##                                                                      FE10 113
IWNT(1)=14;   IWNT(2)=1;   IWNT(3)=2#  Request name, x, y               FE10 114
IWNT(4)=3;    IWNT(5)=22;  IWNT(6)=101# Request z, ffn, sigx            FE10 115
IWNT(7)=102;  IWNT(8)=103#             Request sigy, sigz               FE10 116
KEY(1)=5; KEY(2)=8; KEY(3)=0; KEY(4)=0# Set search keys                 FE10 117
indexpkt:(1,lratom:,PACK,IP,0,KEY,IWNT,IREL)# Search atom record        FE10 118
IF(KEY(4)<0) iquit:(FE1013)#           Missing......fe1013              FE10 119
FOR(J=MARK5;J>0;J=J+STEP5)#            Loop over atom record            FE10 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE10 121
readwpkt:(1,lratom:,PACK,IP,0)#        Read next atom record            FE10 122
IF(IP<=0) BREAK#                       Exit if no more   #              FE10 123
incrqx:(STOP5,J+STEP5,FE1014)#         No mem........fe1014             FE10 124
NATOM=NATOM+1#                         Increment atom count             FE10 125
K=IP+IREL(1)#                          Get pointer to atom name         FE10 126
movereal:(QX,K,QX,J+la:,name:,0)#      Store atom name                  FE10 127
movertoc:(QX(K),1,LABEL,1,24,0)#       Store atom label                 FE10 128
label:(LABEL,I,K)#                     Get max length of labels         FE10 129
K=IP+IREL(5)#                          Get ff index number              FE10 130
QX(J+1)=FLOAT(MARK4+NINT(QX(K)-1.)*STEP4)# Store table4 pointer         FE10 131
K=IP+IREL(2); QX(J+2)=QX(K)#           Store x                          FE10 132
K=IP+IREL(3); QX(J+3)=QX(K)#           Store y                          FE10 133
K=IP+IREL(4); QX(J+4)=QX(K)#           Store z                          FE10 134
K=IP+IREL(6); IF(K>IP) QX(J+5)=QX(K)#  Store sigx                       FE10 135
K=IP+IREL(7); IF(K>IP) QX(J+6)=QX(K)#  Store sigy                       FE10 136
K=IP+IREL(8); IF(K>IP) QX(J+7)=QX(K)#  Store sigz                       FE10 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE10 138
RETURN#                                                                 FE10 139
END#                                                                    FE10 140
systemheader:(FE20)#                                                    FE20   1
# ################################################################## #  FE20   2
#                                                                    #  FE20   3
#                            FE20                                    #  FE20   4
#                                                                    #  FE20   5
# ################################################################## #  FE20   6
SUBROUTINE FE20#                       H. wang jan 1987                 FE20   7
include:(AACOMN)#                                                       FE20   8
include:(FECOMN)#                                                       FE20   9
#                                                                       FE20  10
REAL TL(3,3)#                                                           FE20  11
REAL LSO,VOL#                                                           FE20  12
INTEGER II,ITP,K3,L1,L2,L3,LATRA,LCELL,LCEVC,LLATI,LSTOP3,LSYMT#        FE20  13
INTEGER I,J,K,L,M,N#                                                    FE20  14
#                                                                       FE20  15
realdata:(ZERO,[0.0])#                                                  FE20  16
chardata:(FE202,[ === DIRECT CELL CONSTANTS === ])#                     FE20  17
chardata:(FE203,    A       B       C       ALPHA    BETA   GAMMA)#     FE20  18
chardata:(FE204, CELLVC $#                                              FE20  19
ATRAD PLANE SPLANE VCPLAN LINE SLINE VCLINE FUNCTN END )#               FE20  20
chardata:(FE205,[ === METRIC TENSOR FOR COVARIANT $#                    FE20  21
VECTORS - DIRECT SPACE === ])#                                          FE20  22
chardata:(FE206,[ === METRIC TENSOR FOR CONTROVARIANT $#                FE20  23
VECTORS - RECIPROCAL SPACE === ])#                                      FE20  24
chardata:(FE207, X       Y        Z       SIG X    SIG Y    SIG Z)#     FE20  25
chardata:(FE208,NO YES I-CENTRE     )#                                  FE20  26
#CHARDATA:(FE209,ALL)#                                                  FE20  27
chardata:(FE20A,[ === SYMMETRY OPERATORS === ])#                        FE20  28
chardata:(FE20B, SYMOP    /12 )#                                        FE20  29
chardata:(FE20C,[ === LIST OF ATOMS FROM BDF AND ATOM LINES === ])# F   FE20  30
chardata:(FE20H,[ === REGFE CONTROL PARAMETERS === ])#                  FE20  31
chardata:(FE20J,     INCLUDE COVARIANCE MATRIX CMX)#                    FE20  32
chardata:(FE20K,     CALCULATE BOND LENGTH )#                           FE20  33
chardata:(FE20L,     CALCULATE BOND ANGLE )#                            FE20  34
chardata:(FE20M,     CALCULATE DIHEDRAL ANGLE )#                        FE20  35
chardata:(FE20N,     NUMBER OF UNIT CELL TO SEARCH )#                   FE20  36
chardata:(FE20O,     LIST ATOM/PLANE/LINE PARAMETERS )#                 FE20  37
chardata:(FE20P,     ASSEMBLE MOLECULE )#                               FE20  38
chardata:(FE20Q,     LIST VARIANCE-COVARIANCE MATRIX )#                 FE20  39
chardata:(FE20R,     LIST CORRELATION MATRIX OF ATOM PAR. )#            FE20  40
chardata:(FE20T,[ === VARIANCE-COVARIANCE MATRIX OF CELL $#             FE20  41
PARAMETERS === ])#                                                      FE20  42
#CHARDATA:(FE20X,[0123456789()])#                                       FE20  43
#CHARDATA:(FE20Y,PIRFABC)#                                              FE20  44
#CHARDATA:(FE20Z,[123456XYZ/,+- ])#                                     FE20  45
string:(NAME,24)#                                                       FE20  46
string:(TEMP,24)#                                                       FE20  47
realdata:(FMT,[952.,952.,952.,952.,952.,952.])#                         FE20  48
realdata:(FMT1,[290313.,340313.,390313.,470313.])#                      FE20  49
realdata:(FMT2,[230942.,330942.,430942.])#                              FE20  50
realdata:(FMT3,[230962.,330962.,430962.])#                              FE20  51
realdata:(FMT4,[201051.,321051.,441051.,561051.,681051.,801051.])#      FE20  52
realdata:(FMT5,[842.,842.,842.,822.,822.,822.])#                        FE20  53
datastuff:#                                                             FE20  54
#                                                                       FE20  55
##      PRINT CONTROL PARAMETERS                                        FE20  56
##    ****************************                                      FE20  57
##                                                                      FE20  58
writeline:(1,FE20H,NFE20H,3,3)#        Title                            FE20  59
ITP=3*FCOAT+1#                         Parameters                       FE20  60
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  61
writeline:(0,0,0,1,3)#                 Printing...                      FE20  62
movechar:(FE20K,1,CHROT,1,NFE20K,0)#   Calculate bond length            FE20  63
ITP=3*FLENG+1#                         Parameters                       FE20  64
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  65
writeline:(0,0,0,1,3)#                 Printing...                      FE20  66
movechar:(FE20L,1,CHROT,1,NFE20L,0)#   Calculate bond angle             FE20  67
ITP=3*FANGL+1#                         Parameters                       FE20  68
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  69
writeline:(0,0,0,1,3)#                 Printing...                      FE20  70
movechar:(FE20M,1,CHROT,1,NFE20M,0)#   Calculate dihedral angle         FE20  71
ITP=3*FDIHE+1#                         Parameters                       FE20  72
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  73
writeline:(0,0,0,1,3)#                 Printing...                      FE20  74
movechar:(FE20J,1,CHROT,1,NFE20J,0)#   Variance-covariance of atom      FE20  75
movechar:(FE20N,1,CHROT,1,NFE20N,0)#   Number of unit cell to searc     FE20  76
NUMCEL=2*NUMCEL-1#                                                      FE20  77
ITP=NUMCEL*NUMCEL*NUMCEL#              Number of unit cell              FE20  78
ncodefld:(FLOAT(ITP),1,CHROT,520313.,1)# Formatting...                  FE20  79
writeline:(0,0,0,1,3)#                 Printing...                      FE20  80
movechar:(FE20O,1,CHROT,1,NFE20O,0)#   List atom parameters             FE20  81
ITP=3*FLSAT+1#                         Pointer                          FE20  82
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  83
writeline:(0,0,0,1,3)#                 Printing...                      FE20  84
movechar:(FE20P,1,CHROT,1,NFE20P,0)#   Apply space group symmetry       FE20  85
ITP=3*FASSM+1#                         Operation fo atom connection     FE20  86
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  87
writeline:(0,0,0,1,3)#                 Printing...                      FE20  88
movechar:(FE20Q,1,CHROT,1,NFE20Q,0)#   List variance-covariance         FE20  89
ITP=3*FLSVC+1#                         Matrix                           FE20  90
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  91
writeline:(0,0,0,1,3)#                 Printing...                      FE20  92
movechar:(FE20R,1,CHROT,1,NFE20R,0)#   List correlation matrix of       FE20  93
ITP=3*FLSCR+1#                         Atom parameters                  FE20  94
movechar:(FE208,ITP,CHROT,50,3,0)#     Yes/no                           FE20  95
writeline:(0,0,0,1,3)#                 Printing...                      FE20  96
##                                                                      FE20  97
##   SET DEFAULTS ACCORDING TO BDF OR LINE DATA                         FE20  98
##  **********************************************                      FE20  99
##                                                                      FE20 100
L2=MARK2#                                                               FE20 101
LCEVC=no:#                                                              FE20 102
LCELL=yes:;LLATI=yes:;LSYMT=yes:;LATRA=yes:#                            FE20 103
#                                                                       FE20 104
#      PROCESS CONTROL LINES                                            FE20 105
#      ---------------------                                            FE20 106
#                                                                       FE20 107
REPEAT#                                Loop over input lines            FE20 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE20 109
readline:(FE204,NFE204)#               Call image screener              FE20 110
#                                                                       FE20 111
IF(LINID==1)#                          ********* cellvc line            FE20 112
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE20 113
movereal:(BUFIN,1,QX,L2+1,7,0)#        Save v-c matrix of cell para     FE20 114
L2=L2+7#                               More data...                     FE20 115
LCEVC=yes:#                                                             FE20 116
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE20 117
ELSE BREAK#                            Exit reading loop                FE20 118
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE20 119
IF(LCEVC==yes:&(L2-21)<MARK2) iquit:(FE2002)# Insufficient v-c data     FE20 120
IF(LCELL!=yes:) iquit:(FE2003)#        Need a cell line                 FE20 121
CALL FE61(VOL)#                        Volumn of unit cell              FE20 122
VOLUMN=VOL#                            Volumn of unit cell              FE20 123
#                                                                       FE20 124
##        PRINT CRYSTAL DATA                                            FE20 125
##      **********************                                          FE20 126
##                                                                      FE20 127
writeline:(1,FE202,NFE202,3,3)#        Write heading for cell           FE20 128
writeline:(0,FE203,NFE203,3,3)#        Another table heading.           FE20 129
K=MARK1+1#                             Pointer of cell constants        FE20 130
ncodefld:(QX(K),1,CHROT,FMT5,3)#       Prepare to put out cell data     FE20 131
ncodefld:(QX(K+6),1,CHROT,FMT5(4),3)#  Prepare to put out cell data     FE20 132
writeline:(0,0,0,1,3)#                 Write the line.                  FE20 133
#                                                                       FE20 134
K=K+STEP1#                             Pointer of r-cell constants      FE20 135
ncodefld:(QX(K),1,CHROT,FMT5,3)#       Prepare to put out cell data     FE20 136
ncodefld:(QX(K+6),1,CHROT,FMT5(4),3)#  Prepare to put out cell data     FE20 137
writeline:(0,0,0,1,3)#                 Write the line.                  FE20 138
#                                                                       FE20 139
LINRM=6#                               Require 6 more lines             FE20 140
writeline:(1,FE205,NFE205,3,3)#        Write metric tensor heading      FE20 141
DO I=1,3#                              Print covariance metric tens     FE20 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE20 143
ncodefld:(GC(1,I),1,CHROT,FMT2,3)#     Formatting...                    FE20 144
writeline:(0,0,0,1,3)#                 Printing...                      FE20 145
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE20 146
#                                                                       FE20 147
LINRM=6#                               Require 6 more lines             FE20 148
writeline:(1,FE206,NFE206,3,3)#        Write metric tensor heading      FE20 149
DO I=1,3#                              Print contravariance metric      FE20 150
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE20 151
ncodefld:(RGC(1,I),1,CHROT,FMT3,3)#    Formatting...                    FE20 152
writeline:(0,0,0,1,3)#                 Printing...                      FE20 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE20 154
#                                      Create v-c matrix (cell)         FE20 155
L2=MARK2#                              Pointer of v-c matrix (cell)     FE20 156
IF(FCOCE==no:)#                        If v-c data is not available     FE20 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE20 158
L1=MARK1+STEP1#                        Pointer of s.d. of cell para     FE20 159
movereal:(ZERO,1,QX,L2+1,21,2)#                                         FE20 160
DO I=1,6#                              Loop over diagonal terms         FE20 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE20 162
II=L2+(12-I)*(I-1)/2+I#                Pointer of diagonal term         FE20 163
QX(II)=QX(L1+I)*QX(L1+I)#              Variance = sqre(esd)             FE20 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE20 165
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE20 166
#                                                                       FE20 167
IF(FLSVC==yes:)#                       If listing of v-c is require     FE20 168
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE20 169
writeline:(1,FE20T,NFE20T,3,3)#        Print the title                  FE20 170
L2=MARK2#                              Pointer of v-c matrix (cell)     FE20 171
M=6#                                   Dimenion of the matrix           FE20 172
DO I=1,6#                              Loop over row of the matrix      FE20 173
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE20 174
ncodefld:(QX,L2+1,CHROT,FMT4(I),M)#    Formatting...                    FE20 175
writeline:(0,0,0,1,3)#                 Printing...                      FE20 176
L2=L2+M;   M=M-1#                      Indexes                          FE20 177
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE20 178
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE20 179
#                                                                       FE20 180
L3=MARK3#                              Pointer of symmetry op table     FE20 181
IF(LSYMT!=yes:) iquit:(FE2020)#        Need a symtry line               FE20 182
LSTOP3=NSYM*STEP3+MARK3#                                                FE20 183
#                                                                       FE20 184
##  EXPAND SYMMETRY OPERATION TABLE   ##                                FE20 185
## *********************************  ##                                FE20 186
##                                                                      FE20 187
IF(LATYP==2)#                          Body-centered lattice            FE20 188
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FE20 189
TL(1,1)=0.5; TL(1,1)=0.5; TL(1,1)=0.5# Equivalent position              FE20 190
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FE20 191
ELSE IF(LATYP==3)#                     Rhombohedral lattice             FE20 192
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FE20 193
TL(1,1)=0.66666667; TL(2,1)=0.33333333# Equivalent positions            FE20 194
TL(1,2)=0.33333333; TL(2,2)=0.66666667# Equivalent positions            FE20 195
TL(1,3)=0.33333333; TL(2,3)=0.66666667# Equivalent positions            FE20 196
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FE20 197
ELSE IF(LATYP==4)#                     Face-centered lattic             FE20 198
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FE20 199
TL(1,1)=0.0; TL(1,2)=0.5; TL(1,3)=0.5# Equivalent positions             FE20 200
TL(2,1)=0.5; TL(2,2)=0.0; TL(2,3)=0.5# Equivalent positions             FE20 201
TL(3,1)=0.5; TL(3,2)=0.5; TL(3,3)=0.0# Equivalent positions             FE20 202
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FE20 203
ELSE IF(LATYP==5)#                     A-end-centered lattice           FE20 204
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FE20 205
TL(1,1)=0.0; TL(1,2)=0.5; TL(1,3)=0.5# Equivalent position              FE20 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FE20 207
ELSE IF(LATYP==6)#                     B-end-centered lattice           FE20 208
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FE20 209
TL(1,1)=0.5; TL(1,2)=0.0; TL(1,3)=0.5# Equivalent position              FE20 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FE20 211
ELSE IF(LATYP==7)#                     C-end-centered lattice           FE20 212
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FE20 213
TL(1,1)=0.5; TL(1,2)=0.5; TL(1,3)=0.0# Equivalent position              FE20 214
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FE20 215
#                                                                       FE20 216
K3=LSTOP3#                                                              FE20 217
J=LATYP; IF(J>4) J=2#                  Set number of centres            FE20 218
DO I=2,J#                              Loop over lattice type           FE20 219
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FE20 220
FOR(L3=MARK3;L3<LSTOP3;L3=L3+STEP3)#   Loop over symmetry operation     FE20 221
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FE20 222
movereal:(QX,L3+1,QX,K3+1,9,1)#                                         FE20 223
QX(K3+10)=QX(L3+10)+TL(I,1)#                                            FE20 224
QX(K3+11)=QX(L3+11)+TL(I,2)#                                            FE20 225
QX(K3+12)=QX(L3+12)+TL(I,3)#                                            FE20 226
K3=K3+STEP3#                                                            FE20 227
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FE20 228
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FE20 229
#                                                                       FE20 230
LSTOP3=K3#                                                              FE20 231
IF(ICENT==0)#                                                           FE20 232
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FE20 233
DO L3=MARK3,LSTOP3#                                                     FE20 234
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FE20 235
K3=K3+1#                                                                FE20 236
QX(K3)=-QX(L3+1)#                                                       FE20 237
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FE20 238
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FE20 239
#                                                                       FE20 240
##   PRINT SYMMETRY OPERATION TABLE                                     FE20 241
##  ********************************                                    FE20 242
##                                                                      FE20 243
LINRM=6#                                                                FE20 244
writeline:(1,FE20A,NFE20A,3,3)#                                         FE20 245
LSO=0.0#                                                                FE20 246
FOR(L3=MARK3;L3<STOP3;L3=L3+STEP3)#                                     FE20 247
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FE20 248
writeline:(0,0,0,1,3)#                                                  FE20 249
LSO=LSO+1.0#                                                            FE20 250
DO M=1,3#                                                               FE20 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FE20 252
L=L3+M#                                                                 FE20 253
BUFOT(1)=QX(L)#                                                         FE20 254
BUFOT(2)=QX(L+3)#                                                       FE20 255
BUFOT(3)=QX(L+6)#                                                       FE20 256
BUFOT(4)=QX(L+9)*12.0#                                                  FE20 257
IF(M==2)#                                                               FE20 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FE20 259
movechar:(FE20B,1,CHROT,7,6,0)#                                         FE20 260
ncodefld:(LSO,1,CHROT,150313.,1)#                                       FE20 261
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FE20 262
ncodefld:(BUFOT,1,CHROT,FMT1,4)#                                        FE20 263
movechar:(FE20B,11,CHROT,48,3,0)#                                       FE20 264
writeline:(0,0,0,1,3)#                                                  FE20 265
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FE20 266
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FE20 267
#                                                                       FE20 268
#    READ ATRAD LINES                                                   FE20 269
#    ----------------                                                   FE20 270
#                                                                       FE20 271
REPEAT#                                                                 FE20 272
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FE20 273
IF(LINID!=2) BREAK#                    End line encountered             FE20 274
#                                                                       FE20 275
movechar:(BLANK,1,TEMP,1,24,1)#        Blank out ff name                FE20 276
stringlim:(1,M,N)#                     Pick up atom type                FE20 277
movechar:(CHRIN,M,TEMP,1,N-M,0)#       Store ff name                    FE20 278
IF(TEMP(1^3)=='ALL')#                  Adjust all radii                 FE20 279
FOR(I=MARK4;I<STOP4;I=I+STEP4)#        Loop over ff table               FE20 280
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FE20 281
ifnv:(BUFIN(2)) QX(I+1)=BUFIN(2)#      Store contact radius             FE20 282
ELSE            QX(I+1)=1.25#          Set default                      FE20 283
ifnv:(BUFIN(3)) QX(I+2)=BUFIN(3)#      Store bond radius                FE20 284
ELSE            QX(I+2)=0.90#          Set default                      FE20 285
ifnv:(BUFIN(4)) QX(I+3)=BUFIN(4)#      Store min bond radius            FE20 286
ELSE            QX(I+3)=0.015#         Set default                      FE20 287
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FE20 288
ELSE#                                  Else search for ff               FE20 289
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FE20 290
FOR(I=MARK4;I<STOP4;I=I+STEP4)#        Loop over atom types             FE20 291
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FE20 292
movertoc:(QX(I+4),1,NAME,1,8,0)#       Pick up atom type                FE20 293
upcase:(NAME,NAME,8)#                  Convert to upper case            FE20 294
IF(TEMP(1^8)==NAME(1^8)) BREAK#        Exit if ff match                 FE20 295
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FE20 296
IF(I<STOP4)#                           No new formfactors allowed       FE20 297
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FE20 298
ifnv:(BUFIN(2)) QX(I+1)=BUFIN(2)#      Store contact radius             FE20 299
ELSE            QX(I+1)=1.25#          Set default                      FE20 300
ifnv:(BUFIN(3)) QX(I+2)=BUFIN(3)#      Store bond radius                FE20 301
ELSE            QX(I+2)=0.90#          Set default                      FE20 302
ifnv:(BUFIN(4)) QX(I+3)=BUFIN(4)#      Store min bond radius            FE20 303
ELSE            QX(I+3)=0.015#         Set default                      FE20 304
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FE20 305
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FE20 306
readline:(FE204,NFE204)#                                                FE20 307
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FE20 308
IF(LATRA!=yes:) iquit:(FE2024)#        Need a atrad line                FE20 309
##                                                                      FE20 310
##       PRINT INPUT ATOM LIST                                          FE20 311
##     *************************                                        FE20 312
##                                                                      FE20 313
IF(FLSAT==yes:&NATOM!=0)#                                               FE20 314
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FE20 315
writeline:(2,FE20C,NFE20C,2,3)#                                         FE20 316
LINRM=6#                               Force first header               FE20 317
HEADOT=' '; HEADOT(LABMAX+9^)=FE207#   Set atom header                  FE20 318
FOR(J=MARK5;J<STOP5;J=J+STEP5)#        Loop over atoms table            FE20 319
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FE20 320
movertoc:(QX(J+la:),1,CHROT,2,24,0)#   Extract atom name                FE20 321
LCHROT=LABMAX+3#                       Set format pointer               FE20 322
ncodefld:(QX,J+2,CHROT,FMT,6)#         Format xyz,sigxyz                FE20 323
writeline:(0,HEADOT,120,1,3)#          Print atom parameters            FE20 324
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FE20 325
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FE20 326
LINID=LINID-2#                                                          FE20 327
#                                                                       FE20 328
RETURN#                                                                 FE20 329
END#                                                                    FE20 330
systemheader:(FE31)#                   Read least-squares informati     FE31   1
# ################################################################## #  FE31   2
#                                                                    #  FE31   3
#                            FE31                                    #  FE31   4
#                                                                    #  FE31   5
# ################################################################## #  FE31   6
SUBROUTINE FE31#                       H. wang july 1986                FE31   7
include:(AACOMN)#                                                       FE31   8
include:(FECOMN)#                                                       FE31   9
#                                                                       FE31  10
REAL TEMP#                                                              FE31  11
INTEGER IPT,L6,L7,M,N,NMARKA,NMARKB,NMARKC,NMARKD,NOFF#                 FE31  12
chardata:(FE311,[ === INFORMATION OF VARIANCE-COVARIANCE MATRIX OF $#   FE31  13
LEAST-SQUARES REFINEMENT ])#                                            FE31  14
chardata:(FE312, NUMBER OF BLOCK )#                                     FE31  15
chardata:(FE313, NUMBER OF NON-ATOMIC PARAMETERS )#                     FE31  16
chardata:(FE314, NUMBER OF ATOMIC PARAMETERS )#                         FE31  17
INTEGER I#                                                              FE31  18
INTEGER IP#                            Pointers in output buffer        FE31  19
INTEGER L8#                            Pointer in bloch directory       FE31  20
INTEGER L9#                            Pointer in matrix and vector     FE31  21
INTEGER PACK,PACKMX#                   Size of packet of output buffe   FE31  22
INTEGER OPACK#                                                          FE31  23
INTEGER RLEN#                                                           FE31  24
datastuff:#                                                             FE31  25
#                                                                       FE31  26
MARK6=STOP5#                                                            FE31  27
PACKMX=arith:(bdfbuf:,-,4)#            Max. packet size                 FE31  28
PACK=incr:(arith:(15,/,mxchwd:))#      Packet size in lr 2              FE31  29
REC=2#                                 First record                     FE31  30
readwpkt:(4,REC,PACK,IP,0)#            Init lr 2                        FE31  31
IPT=IP+PACK#                                                            FE31  32
NUMBLK=NINT(QX(IPT-6))#                Total number of blocks.          FE31  33
NONATM=NINT(QX(IPT-5))#                Number of non-atomic paramet     FE31  34
NOFF=NINT(QX(IPT-4))#                  Off-set of location of atom      FE31  35
NMARKA=NINT(QX(IPT-3))#                Atom parameter information.      FE31  36
NMARKB=NINT(QX(IPT-2))#                Block information.               FE31  37
NMARKC=NINT(QX(IPT-1))#                Block contents.                  FE31  38
NMARKD=NINT(QX(IPT))#                  Constraints-nonrefinement in     FE31  39
##                                                                      FE31  40
##      ATOM PARAMETER INFOMATION                                       FE31  41
##     ***************************                                      FE31  42
##                                                                      FE31  43
L6=MARK6+1#                            Pointer of mark6 array           FE31  44
REC=REC+1#                             Next logical record of bdf       FE31  45
RLEN=NMARKA#                           Size of mark6 array              FE31  46
REPEAT#                                Loop reading atom para informa   FE31  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE31  48
readwpkt:(4,REC,PACK,IP,0)#            Get the pointer of input buffe   FE31  49
IF (IP<=0) BREAK#                      Exit, if no more data in the l   FE31  50
IP=IP+1#                               First item in the buffer         FE31  51
OPACK=MIN0(PACK,RLEN)#                 Get the size of package          FE31  52
incrqx:(I,L6+OPACK,FE3101)#            Request space!!                  FE31  53
movereal:(QX,IP,QX,L6,OPACK,1)#        Dump data from input buffer      FE31  54
L6=L6+OPACK#                           Next package                     FE31  55
RLEN=RLEN-OPACK#                                                        FE31  56
IF(RLEN<=0) BREAK#                     Exit, if no more item.           FE31  57
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE31  58
#                                                                       FE31  59
MARK7=L6#                              Set mark7 array                  FE31  60
OFFSET=MARK6-NOFF#                     Offset for table                 FE31  61
##                                                                      FE31  62
##         BLOCK INFORMATION                                            FE31  63
##       *********************                                          FE31  64
##                                                                      FE31  65
L7=MARK7+1#                            Pointer of mark7 array           FE31  66
REC=REC+1#                             Next logical record in bdf       FE31  67
RLEN=NMARKB#                           Size of mark7 array              FE31  68
REPEAT#                                Loop for reading block informa   FE31  69
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE31  70
readwpkt:(4,REC,PACK,IP,0)#            Get the pointer of input buffe   FE31  71
IF (IP<=0) BREAK#                      Exit, if no more data in the l   FE31  72
IP=IP+1#                               Fitst item in the buffer         FE31  73
OPACK=MIN0(PACK,RLEN)#                 Size of the package              FE31  74
incrqx:(I,L7+OPACK,FE3102)#            Request space?!!                 FE31  75
movereal:(QX,IP,QX,L7,OPACK,1)#        Dump data from input buffer      FE31  76
L7=L7+OPACK#                           Next package                     FE31  77
RLEN=RLEN-OPACK#                                                        FE31  78
IF(RLEN<=0) BREAK#                     Exit, if no more item left.      FE31  79
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE31  80
MARK8=L7#                              Set mark8 array                  FE31  81
##                                                                      FE31  82
##           BLOCK CONTENTS                                             FE31  83
##         ******************                                           FE31  84
##                                                                      FE31  85
L8=MARK8+1#                            Pointer of mark8 array           FE31  86
RLEN=NMARKC#                           Size of the package              FE31  87
REC=REC+1#                             Nect logical record of bdf       FE31  88
REPEAT#                                Loop for reading block content   FE31  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE31  90
readwpkt:(4,REC,PACK,IP,0)#            Get the pointer of input buffe   FE31  91
IF (IP<=0) BREAK#                      Exit, if no more data in the l   FE31  92
IP=IP+1#                               First item in the buffer         FE31  93
OPACK=MIN0(PACK,RLEN)#                 Size of the package              FE31  94
incrqx:(I,L8+OPACK,FE3103)#            Request space???                 FE31  95
movereal:(QX,IP,QX,L8,OPACK,1)#        Dump data from input buffer      FE31  96
L8=L8+OPACK#                           Next package                     FE31  97
RLEN=RLEN-OPACK#                                                        FE31  98
IF(RLEN<=0) BREAK#                     Exit, if no more item left       FE31  99
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE31 100
MARK9=L8#                              Set mark9 array                  FE31 101
##                                                                      FE31 102
##     CONSTRAINTS-NONREFINEMENT                                        FE31 103
##   *****************************                                      FE31 104
##                                                                      FE31 105
L9=MARK9+1#                            Pointer of mark9 array           FE31 106
RLEN=NMARKD#                           Size of mark9 array              FE31 107
REC=REC+1#                             Next logical record of bdf       FE31 108
REPEAT#                                Loop for reading constr. data    FE31 109
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE31 110
readwpkt:(4,REC,PACK,IP,0)#            Get the pointer of input buffe   FE31 111
IF (IP<=0) BREAK#                      Exit, if no more data in the l   FE31 112
IP=IP+1#                               First item in the buffer         FE31 113
OPACK=MIN0(PACK,RLEN)#                 Size of the package              FE31 114
incrqx:(I,L9+OPACK,FE3104)#            Request space !!                 FE31 115
movereal:(QX,IP,QX,L9,OPACK,1)#        Dump data from input buffer      FE31 116
L9=L9+OPACK#                           Next package                     FE31 117
RLEN=RLEN-OPACK#                                                        FE31 118
IF(RLEN<=0) BREAK#                     Exit, if no more item left       FE31 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE31 120
MARK10=MARK6#                          Set mark10 array                 FE31 121
#                                                                       FE31 122
writeline:(3,FE311,NFE311,3,3)#        Get the title                    FE31 123
movechar:(FE312,1,CHROT,4,NFE312,0)#                                    FE31 124
TEMP=FLOAT(NUMBLK)#                    Number of blocks in the l.s.r.   FE31 125
ncodefld:(TEMP,1,CHROT,450413.,1)#     Formatting...                    FE31 126
writeline:(2,0,0,1,3)#                                                  FE31 127
movechar:(FE313,1,CHROT,4,NFE313,0)#   Get the title                    FE31 128
TEMP=FLOAT(NONATM)#                    Number of nonatom parameters     FE31 129
ncodefld:(TEMP,1,CHROT,450413.,1)#     Formatting...                    FE31 130
writeline:(1,0,0,1,3)#                                                  FE31 131
M=NUMBLK#                              Number of blocks                 FE31 132
NUMVAB=0#                              Number of l.s. variables         FE31 133
L7=MARK7+1#                            Pointer of mark7 array           FE31 134
REPEAT#                                Loop for counting total ls var   FE31 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE31 136
IF(M<=0) BREAK#                        Exit, no more block              FE31 137
N=NINT(QX(L7+1))#                      Number of block having same ty   FE31 138
NUMVAB=NUMVAB+N*NINT(QX(L7+2))#        Counting l.s. variables          FE31 139
L7=L7+2#                               Next entry                       FE31 140
M=M-N#                                                                  FE31 141
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE31 142
NUMVAB=NUMVAB-NONATM#                  Total number of atom parameter   FE31 143
movechar:(FE314,1,CHROT,4,NFE314,0)#   Get the title                    FE31 144
ncodefld:(FLOAT(NUMVAB),1,CHROT,450413.,1)# Formatting...               FE31 145
writeline:(1,0,0,1,3)#                                                  FE31 146
#                                                                       FE31 147
RETURN#                                                                 FE31 148
END#                                                                    FE31 149
systemheader:(FE32)#                   Directory of correlation mat     FE32   1
# ################################################################## #  FE32   2
#                                                                    #  FE32   3
#                            FE32                                    #  FE32   4
#                                                                    #  FE32   5
# ################################################################## #  FE32   6
SUBROUTINE FE32#                       H.wang, r.j.barton               FE32   7
#                                      B.e.robertson sept 1986          FE32   8
include:(AACOMN)#                                                       FE32   9
include:(FECOMN)#                                                       FE32  10
#                                                                       FE32  11
string:(ATOMA,24)#                                                      FE32  12
string:(ATOMB,24)#                                                      FE32  13
INTEGER I,IG,KEY,L5,L6,L7,LA7,LCON,LNUMV,M,NTMP,NUMT,NUMV#              FE32  14
INTEGER PARTOT#                                                         FE32  15
INTEGER PCON#                                                           FE32  16
#                                                                       FE32  17
NUMV=NONATM+1#                         Counter for ls variables         FE32  18
L7=MARK7+1#                            Pointer of mark7 array           FE32  19
M=1#                                                                    FE32  20
LA7=1#                                                                  FE32  21
LCON=MARK9; nextconstr:(0)#                                             FE32  22
NUMT=NINT(QX(L7))#                     Number of block having same      FE32  23
LNUMV=NINT(QX(L7+1))#                  Number of variables in the b     FE32  24
#                                                                       FE32  25
FOR(L6=MARK6+incr:(name:);L6<MARK7;L6=NINT(QX(L6))+OFFSET)# Atom lo     FE32  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE32  27
#                                                                       FE32  28
IF(NUMV>=LNUMV)#                                                        FE32  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE32  30
NUMV=1#                                                                 FE32  31
IF(LA7>=NUMT)#                                                          FE32  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE32  33
M=M+LA7#                                                                FE32  34
IF(M>NUMBLK) BREAK#                                                     FE32  35
LA7=0#                                                                  FE32  36
L7=L7+2#                                                                FE32  37
NUMT=NINT(QX(L7))#                                                      FE32  38
LNUMV=NINT(QX(L7+1))#                                                   FE32  39
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE32  40
LA7=LA7+1#                                                              FE32  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE32  42
#                                                                       FE32  43
movertoc:(QX(L6-name:),1,ATOMA,1,24,0)#                                 FE32  44
FOR(L5=MARK5;L5<STOP5;L5=L5+STEP5)#    Loop over atom table             FE32  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE32  46
movertoc:(QX(L5+la:),1,ATOMB,1,24,0)#                                   FE32  47
IF(ATOMA!=ATOMB) NEXT#                 Skip if no match                 FE32  48
intunpak:(QX(L6+1),NTMP,5,3)#          And number of tf                 FE32  49
PARTOT=3+NTMP#                         Total nr of variable params      FE32  50
KEY=0#                                                                  FE32  51
QX(L5+8)=NTMP#                                                          FE32  52
#                                                                       FE32  53
IF(-PCON==L6)#                         All par. are invariant           FE32  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE32  55
QX(L5+9)=0.0#                                                           FE32  56
QX(L5+10)=0.0#                                                          FE32  57
QX(L5+11)=0.0#                                                          FE32  58
nextconstr:(1)#                        Put refine off; get next con     FE32  59
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE32  60
ELSE#                                                                   FE32  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE32  62
QX(L5+9)=NUMV#                         Relative position                FE32  63
QX(L5+11)=M+LA7-1#                     Block position (offset)          FE32  64
#                                                                       FE32  65
DO I=1,PARTOT#                         Loop over the variables          FE32  66
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE32  67
IG=1#                                  Set param to variant             FE32  68
IF((L6+I+1)==IABS(PCON))#                                               FE32  69
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE32  70
IF(PCON<0) IG=0#                                                        FE32  71
ELSE LCON=LCON+NINT(QX(LCON+3))-1#     Adjust pointer                   FE32  72
nextconstr:(1)#                        Invariant param                  FE32  73
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE32  74
ELSE NUMV=NUMV+1#                      Count nr variables               FE32  75
KEY=KEY*2+IG#                                                           FE32  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE32  77
QX(L5+10)=KEY#                                                          FE32  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE32  79
BREAK#                                                                  FE32  80
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE32  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE32  82
RETURN#                                                                 FE32  83
END#                                                                    FE32  84
systemheader:(FE33)#                   Read correlation matrix          FE33   1
# ################################################################## #  FE33   2
#                                                                    #  FE33   3
#                            FE33                                    #  FE33   4
#                                                                    #  FE33   5
# ################################################################## #  FE33   6
SUBROUTINE FE33#                       H. wang july 1986                FE33   7
include:(AACOMN)#                                                       FE33   8
include:(FECOMN)#                                                       FE33   9
#                                                                       FE33  10
INTEGER IBLK,IEN,JEN,JP#                                                FE33  11
chardata:(FE331,[ === LIST OF CORRELATION MATRIX === ])#                FE33  12
chardata:(FE332, BLOCK CONTAINING VARIABLES )#                          FE33  13
realdata:(FMT,[100941.,200941.,300941.,400941.,500941.,600941.,$#       FE33  14
700941.,800941.,900941.,1000941.,1100941.,1200941.])#                   FE33  15
INTEGER I#                             F                                FE33  16
INTEGER IP#                            Pointers in output buffer        FE33  17
INTEGER L10,L11#                       Pointer in matrix and vector     FE33  18
INTEGER LEN#                           Length of matrix block           FE33  19
INTEGER NBLOCK#                        Total block count                FE33  20
INTEGER MW#                            No. of items on a line           FE33  21
INTEGER PACK#                          (max) packet size in output      FE33  22
INTEGER VARBLK#                        No. of variables in a block      FE33  23
datastuff:#                                                             FE33  24
#                                                                       FE33  25
## LOOP OVER THE BLOCKS                                                 FE33  26
#                                                                       FE33  27
IF(FLSCR==yes:)#                                                        FE33  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE33  29
writeline:(2,FE331,NFE331,3,4)#                                         FE33  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE33  31
MW=12#                                                                  FE33  32
#                                                                       FE33  33
NBLOCK=0#                              Block count                      FE33  34
L10=MARK10#                                                             FE33  35
incrqx:(MARK11,MARK10+2*NUMBLK,FE3301)# F                               FE33  36
L11=MARK11+1#                                                           FE33  37
#                                                                       FE33  38
FOR(IBLK=1;IBLK<=NUMBLK;IBLK=IBLK+1)#                                   FE33  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE33  40
REC=REC+1#                                                              FE33  41
readwpkt:(4,REC,PACK,IP,0)#                                             FE33  42
NBLOCK=NBLOCK+1#                                                        FE33  43
#                                                                       FE33  44
IP=IP+1; VARBLK=NINT(QX(IP))#                                           FE33  45
PACK=PACK-1#                                                            FE33  46
QX(L10+1)=VARBLK#                      Number of variables.             FE33  47
QX(L10+2)=L11#                         Address of first element.        FE33  48
JP=L11#                                                                 FE33  49
LEN=(VARBLK+1)*VARBLK/2#                                                FE33  50
incrqx:(I,L11+LEN,FE3302)#                                              FE33  51
IP=IP+1#                                                                FE33  52
#                                                                       FE33  53
WHILE(LEN>PACK)#                                                        FE33  54
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE33  55
movereal:(QX,IP,QX,L11,PACK,1)#                                         FE33  56
L11=L11+PACK#                                                           FE33  57
LEN=LEN-PACK#                                                           FE33  58
readwpkt:(4,REC,PACK,IP,0)#                                             FE33  59
IF (IP<=0) iquit:(FE3305)#             F                                FE33  60
IP=IP+1#                                                                FE33  61
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE33  62
#                                                                       FE33  63
movereal:(QX,IP,QX,L11,LEN,1)#                                          FE33  64
L11=L11+LEN#                                                            FE33  65
##                                                                      FE33  66
##  LISTING VARIANCE-COVARIANCE MATRIX                                  FE33  67
## ************************************                                 FE33  68
##                                                                      FE33  69
IF(FLSCR==yes:)#                                                        FE33  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE33  71
movechar:(FE332,1,CHROT,3,7,0)#                                         FE33  72
ncodefld:(FLOAT(IBLK),1,CHROT,150313.,1)#                               FE33  73
movechar:(FE332,7,CHROT,18,12,0)#                                       FE33  74
ncodefld:(FLOAT(VARBLK),1,CHROT,370513.,1)#                             FE33  75
movechar:(FE332,18,CHROT,41,11,0)#                                      FE33  76
writeline:(2,0,0,1,4)#                                                  FE33  77
writeline:(0,BLANK,1,3,4)#                                              FE33  78
IEN=VARBLK#                                                             FE33  79
DO I=1,VARBLK#                                                          FE33  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE33  81
JEN=IEN#                                                                FE33  82
WHILE(JEN>MW)#                                                          FE33  83
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE33  84
movereal:(QX,JP,BUFOT,1,MW,0)#                                          FE33  85
ncodefld:(BUFOT,1,CHROT,FMT,MW)#                                        FE33  86
writeline:(0,0,0,1,4)#                                                  FE33  87
JP=JP+MW#                                                               FE33  88
JEN=JEN-MW#                                                             FE33  89
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE33  90
movereal:(QX,JP,BUFOT,1,JEN,0)#                                         FE33  91
ncodefld:(BUFOT,1,CHROT,FMT,JEN)#                                       FE33  92
writeline:(0,0,0,1,4)#                                                  FE33  93
JP=JP+JEN#                                                              FE33  94
IEN=IEN-1#                                                              FE33  95
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE33  96
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE33  97
L10=L10+2#                                                              FE33  98
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE33  99
MARK12=L11#                                                             FE33 100
#                                                                       FE33 101
RETURN#                                                                 FE33 102
END#                                                                    FE33 103
systemheader:(FE34)#                   Convert correlation matrix t     FE34   1
#                                      Variance-covariance matrix.      FE34   2
# ################################################################## #  FE34   3
#                                                                    #  FE34   4
#                               FE34                                 #  FE34   5
#                                                                    #  FE34   6
# ################################################################## #  FE34   7
SUBROUTINE FE34#                       H.wang, r.j.barton               FE34   8
#                                      B.e.robertson may-1987           FE34   9
include:(AACOMN)#                                                       FE34  10
include:(FECOMN)#                                                       FE34  11
INTEGER NBLK#                          Number of blocks                 FE34  12
INTEGER I,IG,L5,LBAD,M,NBAD,NPIT,NVAD#                                  FE34  13
REAL SIGMA#                                                             FE34  14
intdata:(KEY,0)#                                                        FE34  15
datastuff:#                                                             FE34  16
#                                                                       FE34  17
FOR(L5=MARK5;L5<STOP5;L5=L5+STEP5)#                                     FE34  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE34  19
NBLK=iqx:(L5,11)#                      Pointer of block information     FE34  20
NBLK=NBLK*2#                                                            FE34  21
NVAD=iqx:(MARK10,NBLK-1)#              Number of l.s. variable in b     FE34  22
NVAD=NVAD+1#                                                            FE34  23
NBAD=iqx:(MARK10,NBLK)#                Address of first element of      FE34  24
NPIT=iqx:(L5,9)#                                                        FE34  25
DO I=5,7#                                                               FE34  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE34  27
IG=MOD(KEY,2); KEY=KEY/2#              Find invariant flag              FE34  28
IF(IG==0) NEXT#                        Skip if invariant                FE34  29
SIGMA=QX(L5+I)#                                                         FE34  30
LBAD=NBAD+NPIT-NVAD#                                                    FE34  31
DO M=1,NPIT#                                                            FE34  32
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE34  33
LBAD=LBAD+NVAD-M#                                                       FE34  34
QX(LBAD)=QX(LBAD)*SIGMA#                                                FE34  35
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE34  36
DO M=NPIT,NVAD-1#                                                       FE34  37
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE34  38
QX(LBAD)=QX(LBAD)*SIGMA#                                                FE34  39
LBAD=LBAD+1#                                                            FE34  40
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE34  41
NPIT=NPIT+1#                                                            FE34  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE34  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE34  44
#                                                                       FE34  45
RETURN#                                                                 FE34  46
END#                                                                    FE34  47
systemheader:(FE40)#                                                    FE40   1
# ################################################################## #  FE40   2
#                                                                    #  FE40   3
#                               FE40                                 #  FE40   4
#                                                                    #  FE40   5
#   FORMAT OF PLANE AND LINE LINES:                                  #  FE40   6
#       PLANE:                                                       #  FE40   7
#         FIELD: 1 -- PLANE INDEX.                                   #  FE40   8
#                2 -- DATA TYPE (0/1/2).                             #  FE40   9
#                3 -- A  (ATOM A).                                   #  FE40  10
#                4 -- B  (ATOM B).                                   #  FE40  11
#                5 -- C  (ATOM C).                                   #  FE40  12
#                6 -- D  (ATOM D).                                   #  FE40  13
#                7 -- ERROR MATRIX (1,1)                             #  FE40  14
#                8, 9, 10, 11, 12, 13, 14, 15, 16,                   #  FE40  15
#       LINE:                                                        #  FE40  16
#         FIELD: 1 -- LINE INDEX.                                    #  FE40  17
#                2 -- DATA TYPE (0/1/2).                             #  FE40  18
#                3 -- A   (ATOM A).                                  #  FE40  19
#                4 -- B   (ATOM B).                                  #  FE40  20
#                5 -- C   (ATOM C).                                  #  FE40  21
#                6 -- SA  (ATOM D).                                  #  FE40  22
#                7 -- SB                                             #  FE40  23
#                8 -- SC                                             #  FE40  24
#                                                                    #  FE40  25
# ################################################################## #  FE40  26
SUBROUTINE FE40#                       H.wang, r.j.barton               FE40  27
#                                      B.e.robertson jan-1987           FE40  28
include:(AACOMN)#                                                       FE40  29
include:(FECOMN)#                                                       FE40  30
#                                                                       FE40  31
REAL SDCOEF#                                                            FE40  32
INTEGER I,II,K,KEY,KK,KSD,L1,L12,L13,LL12,LL13,M,MXX,M13,N#             FE40  33
INTEGER FLAG,LTYPE,NUMATM,NXX,PTYPE#                                    FE40  34
INTEGER FIELD#                                                          FE40  35
INTEGER AKEY(4)#                                                        FE40  36
REAL    COEF(4)#                                                        FE40  37
string:(DNAME,24)#                                                      FE40  38
chardata:(FE402, PLANE SPLANE VCPLAN LINE SLINE VCLINE FUNCTN END )#    FE40  39
chardata:(FE403, EQUATION OF PLANE AS AX+BY+CZ=D  (X Y Z) IN$#          FE40  40
 FRACTIONAL SPCE )#                                                     FE40  41
chardata:(FE404, PLANE             A         B         C$#              FE40  42
         D      SIGA      SIGB      SIGC      SIGD )#                   FE40  43
#CHARDATA:(FE405, PLANE                )#                               FE40  44
#CHARDATA:(FE406, LINE           A         B         C       $#         FE40  45
#X(0)       Y(0)       Z(0)    )#                                       FE40  46
#CHARDATA:(FE407, LINE                 )#                               FE40  47
#CHARDATA:(FE408, )#                                                    FE40  48
chardata:(FE409,[ === LIST OF PLANES FROM =PLANE= CARDS === ])#         FE40  49
chardata:(FE40A,[ === LIST OF LINES FROM =LINE= CARDS === ])#           FE40  50
realdata:(FMT,[842.,842.,842.,842.,842.,842.,842.,842.])#               FE40  51
datastuff:#                                                             FE40  52
#                                                                       FE40  53
STEP12=15+name:#                       Plane index, a, b, c, d, s(a     FE40  54
#                                      C, d) and three atom pointers    FE40  55
MARK12=MARK12+1#                                                        FE40  56
L12=MARK12#                                                             FE40  57
NUMATM=0#                              Number of defined atoms          FE40  58
NPLANE=0#                                                               FE40  59
#                                                                       FE40  60
REPEAT#                                                                 FE40  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE40  62
IF(LINID<1) iquit:(FE4001)#            Wrong sequency of control li     FE40  63
IF(LINID==1)#                          Plane line                       FE40  64
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE40  65
incrqx:(LL12,L12+STEP12,FE4002)#                                        FE40  66
IF(BUFIN(1)>=voidflg:) iquit:(FE4003)#                                  FE40  67
stringlim:(1,M,N)#                                                      FE40  68
movechar:(BLANK,1,DNAME,1,24,1)#                                        FE40  69
movechar:(CHRIN,M,DNAME,1,N-M,0)#                                       FE40  70
movector:(DNAME,1,QX(L12),1,24,0)#                                      FE40  71
L12=L12+name:#                                                          FE40  72
ifvo:(BUFIN(2)) PTYPE=0#                                                FE40  73
ELSE PTYPE=NINT(BUFIN(2))#                                              FE40  74
#                                      =========== 0 ==========         FE40  75
IF (PTYPE==0)#                         Coefficients of equation in      FE40  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE40  77
FOR(FIELD=3;FIELD<=10;FIELD=FIELD+1)#                                   FE40  78
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE40  79
ifvo:(BUFIN(FIELD)) NEXT#                                               FE40  80
QX(L12+FIELD-3)=BUFIN(FIELD)#                                           FE40  81
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE40  82
NPLANE=NPLANE+1#                                                        FE40  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE40  84
#                                      =========== 1 ==========         FE40  85
ELSE IF(PTYPE==1)#                     Coefficients of equation in      FE40  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE40  87
FOR(FIELD=3;FIELD<=10;FIELD=FIELD+1)#                                   FE40  88
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE40  89
ifvo:(BUFIN(FIELD)) NEXT#                                               FE40  90
QX(L12+FIELD-3)=BUFIN(FIELD)#                                           FE40  91
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE40  92
L1=MARK1+3*STEP1#                                                       FE40  93
QX(L12)=QX(L12)*QX(L1+1)+QX(L12+1)*QX(L1+2)+QX(L12+2)*QX(L1+3)#         FE40  94
QX(L12+1)=QX(L12+1)*QX(L1+5)+QX(L12+2)*QX(L1+6)#                        FE40  95
QX(L12+2)=QX(L12+2)*QX(L1+9)#                                           FE40  96
NPLANE=NPLANE+1#                                                        FE40  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE40  98
#                                      =========== 2 ==========         FE40  99
ELSE IF(PTYPE==2)#                     Atom coordinates.                FE40 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE40 101
LL12=L12+15#                                                            FE40 102
FIELD=2#                                                                FE40 103
WHILE(PTYPE==2)#                       Repeat....                       FE40 104
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE40 105
ifvo:(BUFIN(FIELD+1)) BREAK#                                            FE40 106
FLAG=0#                                Set flag for atom searching.     FE40 107
search:(FIELD,KEY,FLAG)#                                                FE40 108
LL12=LL12+1#                                                            FE40 109
QX(LL12)=KEY#                          Address of atom parameters.      FE40 110
NUMATM=NUMATM+1#                                                        FE40 111
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE40 112
KSD=L12+4#                                                              FE40 113
IF(NUMATM==3)#                                                          FE40 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FE40 115
DO M=1,3; AKEY(M)=NINT(QX(L12+M+15))#                                   FE40 116
CALL FE54(AKEY,COEF)#                                                   FE40 117
CALL FE74(AKEY,COEF,KSD)#                                               FE40 118
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FE40 119
ELSE#                                                                   FE40 120
DO M=1,4; COEF(M)=0.0#                                                  FE40 121
#CALL FE41(L12,NUMATM,COEF)#                                            FE40 122
#                                                                       FE40 123
movereal:(COEF,1,QX(L12),1,4,0)#                                        FE40 124
NUMATM=0#                                                               FE40 125
NPLANE=NPLANE+1#                                                        FE40 126
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE40 127
#                                      =========== 3 ==========         FE40 128
ELSE#                                  Atom coodinates (cont.)          FE40 129
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FE40 130
LL12=L12+9#                                                             FE40 131
FIELD=2#                                                                FE40 132
WHILE(PTYPE>2)#                                                         FE40 133
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FE40 134
ifvo:(BUFIN(FIELD+1)) BREAK#                                            FE40 135
FLAG=0#                                Set flag for atom searching.     FE40 136
search:(FIELD,KEY,FLAG)#                                                FE40 137
LL12=LL12+1#                                                            FE40 138
QX(LL12)=KEY#                          Address of atom parameters.      FE40 139
NUMATM=NUMATM+1#                                                        FE40 140
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FE40 141
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FE40 142
L12=L12+15#                                                             FE40 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE40 144
ELSE IF(LINID==2) iquit:(-FE4021)#     **** splane ***                  FE40 145
ELSE IF(LINID==3) iquit:(-FE4022)#                                      FE40 146
ELSE BREAK#                                                             FE40 147
#                                                                       FE40 148
readline:(FE402,NFE402)#                                                FE40 149
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE40 150
IF(NUMATM>0) iquit:(FE4004)#                                            FE40 151
STOP12=L12#                                                             FE40 152
##                                                                      FE40 153
##       PRINT PLANE INFORMATION                                        FE40 154
##      *************************                                       FE40 155
##                                                                      FE40 156
IF(NPLANE!=0)#                                                          FE40 157
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FE40 158
writeline:(2,FE409,NFE409,3,3)#                                         FE40 159
writeline:(1,FE403,NFE403,3,3)#                                         FE40 160
writeline:(1,FE404,NFE404,3,3)#                                         FE40 161
FOR(I=MARK12+name:;I<=STOP12;I=I+STEP12)# F                             FE40 162
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FE40 163
movertoc:(QX(I-name:),1,CHROT,3,24,0)# F                                FE40 164
movereal:(QX(I),1,BUFOT,1,4,0)#                                         FE40 165
II=I+4#                                                                 FE40 166
DO K=1,4#                                                               FE40 167
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FE40 168
KK=(8-K)*(K-1)/2+K+II#                                                  FE40 169
BUFOT(K+4)=SQRT(QX(KK))#                                                FE40 170
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FE40 171
LCHROT=LABMAX+2#                       Set format pointer               FE40 172
ncodefld:(BUFOT,1,CHROT,FMT,8)#                                         FE40 173
writeline:(0,0,0,1,3)#                                                  FE40 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FE40 175
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FE40 176
#                                                                       FE40 177
MARK13=L12#                            Line information                 FE40 178
STEP13=18#                             Line index, a, b, c, s(a, b,     FE40 179
L13=MARK13#                                                             FE40 180
NLINE=0#                                                                FE40 181
##                                                                      FE40 182
##       READ LINE INFORMATION                                          FE40 183
##      ***********************                                         FE40 184
##                                                                      FE40 185
REPEAT#                                                                 FE40 186
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FE40 187
IF(LINID<4) iquit:(FE4005)#            Wrong sequency of control li     FE40 188
ELSE IF(LINID==4)#                     Line line                        FE40 189
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FE40 190
ifvo:(BUFIN(1)) iquit:(FE4007)#                                         FE40 191
QX(L13+1)=BUFIN(1)#                                                     FE40 192
ifvo:(BUFIN(2)) LTYPE=0#                                                FE40 193
ELSE LTYPE=BUFIN(2)#                                                    FE40 194
#                                                                       FE40 195
IF (LTYPE==0)#                         ======= type 0 ========          FE40 196
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FE40 197
FOR(FIELD=3;FIELD<=8;FIELD=FIELD+1)#                                    FE40 198
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FE40 199
ifvo:(BUFIN(FIELD)) NEXT#                                               FE40 200
QX(L13+FIELD)=BUFIN(FIELD)#                                             FE40 201
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FE40 202
NLINE=NLINE+1#                                                          FE40 203
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FE40 204
ELSE IF(LTYPE==1)#                     ======= type 1 =========         FE40 205
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FE40 206
FOR(FIELD=3;FIELD<=8;FIELD=FIELD+1)#                                    FE40 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FE40 208
ifvo:(BUFIN(FIELD)) NEXT#                                               FE40 209
QX(L13+FIELD)=BUFIN(FIELD)#                                             FE40 210
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FE40 211
L1=MARK1+3*STEP1#                                                       FE40 212
M13=L13#                                                                FE40 213
DO M=1,2#                                                               FE40 214
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FE40 215
QX(M13)=QX(M13)*QX(L1+1)+QX(M13+1)*QX(L1+2)+QX(M13+2)*QX(L1+3)#         FE40 216
QX(M13+1)=QX(M13+1)*QX(L1+5)+QX(M13+2)*QX(L1+6)#                        FE40 217
QX(M13+2)=QX(M13+2)*QX(L1+9)#                                           FE40 218
M13=M13+3#                                                              FE40 219
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FE40 220
#                                                                       FE40 221
NLINE=NLINE+1#                                                          FE40 222
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FE40 223
ELSE IF(LTYPE==2)#                     ======= type 2 =========         FE40 224
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FE40 225
LL13=L13+7#                                                             FE40 226
FIELD=2#                                                                FE40 227
WHILE(LTYPE==2)#                                                        FE40 228
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FE40 229
ifvo:(BUFIN(FIELD+1)) BREAK#                                            FE40 230
FLAG=0#                                Set flag for atom searching.     FE40 231
search:(FIELD,KEY,FLAG)#                                                FE40 232
LL13=LL13+1#                                                            FE40 233
QX(LL13)=KEY#                          Address of atom parameters.      FE40 234
NUMATM=NUMATM+1#                                                        FE40 235
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FE40 236
IF(NUMATM==2)#                                                          FE40 237
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FE40 238
QX(L13+1)=-QX(L13+1)#                                                   FE40 239
CALL FE55(AKEY,COEF)#                                                   FE40 240
CALL FE75(AKEY,COEF,SDCOEF)#                                            FE40 241
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FE40 242
DO M=1,4; COEF(M)=0.0#                                                  FE40 243
#CALL FE41(LL13,NUMATM,COEF)#                                           FE40 244
##movereal:(COEF,1,QX,L13+2,6,0)#      Two errors copy 6 integer elems  FE40 245
movereal:(COEF,1,QX,L13+2,4,0)#        From a 4 elem array              FE40 246
NUMATM=0#                                                               FE40 247
NLINE=NLINE+1#                                                          FE40 248
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FE40 249
ELSE#                                                                   FE40 250
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FE40 251
LL13=L13+7#                                                             FE40 252
FIELD=2#                                                                FE40 253
WHILE(LTYPE>2)#                                                         FE40 254
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FE40 255
ifvo:(BUFIN(FIELD+1)) BREAK#                                            FE40 256
FLAG=0#                                Set flag for atom searching.     FE40 257
search:(FIELD,KEY,FLAG)#                                                FE40 258
LL13=LL13+1#                                                            FE40 259
QX(LL13)=KEY#                          Address of atom parameters.      FE40 260
NUMATM=NUMATM+1#                                                        FE40 261
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FE40 262
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FE40 263
L13=L13+STEP13#                                                         FE40 264
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FE40 265
ELSE IF(LINID==5) iquit:(-FE4023)#                                      FE40 266
ELSE IF(LINID==6) iquit:(-FE4024)#                                      FE40 267
ELSE BREAK#                                                             FE40 268
readline:(FE402,NFE402)#                                                FE40 269
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FE40 270
#                                                                       FE40 271
STOP13=L13#                                                             FE40 272
MARK14=STOP13#                                                          FE40 273
##                                                                      FE40 274
##       PRINT LINE INFORMATION                                         FE40 275
##      ************************                                        FE40 276
##                                                                      FE40 277
IF(NLINE!=0)#                                                           FE40 278
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FE40 279
writeline:(2,FE40A,NFE40A,3,3)#                                         FE40 280
FOR(I=MARK13;I<=STOP13;I=I+STEP13)#                                     FE40 281
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FE40 282
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FE40 283
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FE40 284
LINID=LINID-6#                                                          FE40 285
RETURN#                                                                 FE40 286
END#                                                                    FE40 287
#FE41 & FE42 REMOVED AS REDUNDANT AND BECAUSE OF BUFIN CONFLICT         FE40 288
systemheader:(FE44)#                   Bond length, angle ...           FE44   1
# ################################################################## #  FE44   2
#                                                                    #  FE44   3
#                               FE44                                 #  FE44   4
#                                                                    #  FE44   5
# ################################################################## #  FE44   6
SUBROUTINE FE44#                       H.wang, r.j.barton               FE44   7
#                                      B.e.robertson  may-1987          FE44   8
include:(AACOMN)#                                                       FE44   9
include:(FECOMN)#                                                       FE44  10
#                                                                       FE44  11
INTEGER L4#                                                             FE44  12
chardata:(FE444,[ ********* DISTANCES, ANGLES AND DIHEDRAL $#           FE44  13
ANGLES BASED ON ATOM LIST ********* ])#                                 FE44  14
chardata:(FE445,       TYPE  CONTACT  MAX BOND MIN BOND )#              FE44  15
chardata:(FE446,              RADIUS   RADIUS   RADIUS  )#              FE44  16
chardata:(FE447,[ === ATOMIC RADII TABLE === ])#                        FE44  17
realdata:(FMT1,[200632.,290632.,380632.])#                              FE44  18
datastuff:#                                                             FE44  19
#                                                                       FE44  20
STOP14=MARK14#                                                          FE44  21
LINRM=10#                                                               FE44  22
writeline:(2,FE444,NFE444,2,3)#                                         FE44  23
#                                                                       FE44  24
##         PRINT ATOM RADIUS                                            FE44  25
##       *********************                                          FE44  26
##                                                                      FE44  27
writeline:(1,FE447,NFE447,3,3)#                                         FE44  28
writeline:(0,FE445,NFE445,3,3)#                                         FE44  29
writeline:(0,FE446,NFE446,3,3)#                                         FE44  30
FOR(L4=MARK4;L4<STOP4;L4=L4+STEP4)#                                     FE44  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE44  32
movertoc:(QX(L4+4),1,CHROT,8,8,0)#     Extract the atom type name       FE44  33
QX(L4+3)=AMAX1(QX(L4+3),0.015)#        Set minimum atomic radii.        FE44  34
ncodefld:(QX,L4+1,CHROT,FMT1,3)#       Formatting...                    FE44  35
writeline:(0,0,0,1,3)#                 Print the atomic radii data      FE44  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE44  37
#                                                                       FE44  38
CALL FE62#                             Call atom connection routine     FE44  39
CALL FE63#                             Call bond length, angle and      FE44  40
#                                      Dihedra angle calculation        FE44  41
MARK16=STOP14#                         Set mark16 for local vc matr     FE44  42
RETURN#                                                                 FE44  43
END#                                                                    FE44  44
systemheader:(FE45)#                   Crystallographic functions       FE45   1
# ################################################################## #  FE45   2
#                                                                    #  FE45   3
#                               FE45                                 #  FE45   4
#                                                                    #  FE45   5
# ################################################################## #  FE45   6
SUBROUTINE FE45#                       H.wang, r.j.barton               FE45   7
#                                      B.e.robertson  jan-1987          FE45   8
include:(AACOMN)#                                                       FE45   9
include:(FECOMN)#                                                       FE45  10
#                                                                       FE45  11
INTEGER J,MM,MXX,NXX#                                                   FE45  12
chardata:(FE451, ********* GEOMETRIC FUNCTION OF MOLECULES OR $#        FE45  13
CLUSTERS ********* )#                                                   FE45  14
chardata:(FE452, FUNCTN END    )#                                       FE45  15
#                                                                       FE45  16
chardata:(FE453,$#                                                      FE45  17
DIS $#                                 1 # distance between two ato     FE45  18
ANG $#                                 2 # angle between two vector     FE45  19
PDA $#                                 3 # distances from atom(s) t     FE45  20
LDA $#                                 4 # distances from atom(s) t     FE45  21
PAP $#                                 5 # angle between planes (6)     FE45  22
PAL $#                                 6 # angle between plane and      FE45  23
LAL $#                                 7 # angle between lines (4)      FE45  24
DIH $#                                 8 # dihedral angle. (4)          FE45  25
VOL )#                                 9 # cell volumn. (0)             FE45  26
chardata:(FE456,[      PLANE/LINE/ATOM   $#                             FE45  27
  X/A       Y/B       Z/C         D])#                                  FE45  28
chardata:(FE457,[1234567890P-L- ])#                                     FE45  29
chardata:(FE459, value: STANDARD deviation: )#                          FE45  30
chardata:(FE45A,[ === FUNCTION =DIS=; DISTANCE BETWEEN ATOMS ])# F      FE45  31
chardata:(FE45B,[ === FUNCTION =ANG=; ANGLE DEFINED BY THREE ATOMS ])#  FE45  32
chardata:(FE45C,[ === FUNCTION =PDA=; DISTANCE FROM ATOM TO PLANE ])#   FE45  33
chardata:(FE45D,[ === FUNCTION =LDA=; DISTANCE FROM ATOM TO LINE ])#    FE45  34
chardata:(FE45E,[ === FUNCTION =PAP=; ANGLE BETWEEN PLANES ])# Pap      FE45  35
chardata:(FE45F,[ === FUNCTION =PAL=; ANGLE BETWEEN PLANE AND LINE ])#  FE45  36
chardata:(FE45G,[ === FUNCTION =LAL=; ANGLE BETWEEN LINES ])# Lal       FE45  37
chardata:(FE45H,[ === FUNCTION =DIH=; DIHEDRAL ANGLE DEFINED BY FOUR $# FE45  38
ATOMS ])#                              F                                FE45  39
chardata:(FE45I,[ === FUNCTION =VOL=; VOLUMN OF UNIT CELL ])# Vol       FE45  40
#REALDATA:(FMT1,[301052.,700962.])#                                     FE45  41
#REALDATA:(FMT2,[0.0])#                                                 FE45  42
#REALDATA:(FMT3,[181052.,300962.,420962.,540962.,660962.])#             FE45  43
#REALDATA:(FMT4,[281062.,6809062.])#                                    FE45  44
realdata:(FMT5,[1052.,1052.,1052.,1052.])#                              FE45  45
INTEGER I,K,M#                                                          FE45  46
INTEGER AKEY(6)#                                                        FE45  47
INTEGER FLAG#                                                           FE45  48
REAL SDT(4)#                                                            FE45  49
DOUBLE PRECISION DIST,ANGLE#                                            FE45  50
REAL SYMO(6)#                                                           FE45  51
string:(DNAME,24)#                                                      FE45  52
datastuff:#                                                             FE45  53
#                                                                       FE45  54
SYMO(1)=-9999.99#                                                       FE45  55
LINRM=6#                                                                FE45  56
IF(LINID==1)#                                                           FE45  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE45  58
LINCT=0#                               Force a new page                 FE45  59
movechar:(FE451,3,CHROT,5,6,0)#                                         FE45  60
movechar:(FE451,3,CHROT,56,6,0)#                                        FE45  61
writeline:(2,0,0,1,3)#                                                  FE45  62
writeline:(0,FE451,NFE451,3,3)#        Write the title "...             FE45  63
movechar:(FE451,3,CHROT,5,6,0)#                                         FE45  64
movechar:(FE451,3,CHROT,56,6,0)#                                        FE45  65
writeline:(0,0,0,1,3)#                                                  FE45  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE45  67
REPEAT#                                                                 FE45  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE45  69
IF(LINID==1)#                          Function line                    FE45  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE45  71
I=1#                                                                    FE45  72
ifvo:(BUFIN(I)) BREAK#                                                  FE45  73
stringlim:(I,M,K)#                                                      FE45  74
compchar:(CHRIN,M,FE453,1,3,4,NFE453,K)#                                FE45  75
#                                                                       FE45  76
IF(K==0) iquit:(FE4501,I)#                                              FE45  77
ELSE IF(K==1)#                         *** dis ***  bond distance       FE45  78
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE45  79
FLAG=0#                                Set flag for atoms searching     FE45  80
search:(I,AKEY(1),FLAG)#               Searching atom_a                 FE45  81
search:(I,AKEY(2),FLAG)#               Searching atom_b                 FE45  82
CALL FE51(AKEY,DIST)#                  Calculate the bond distance      FE45  83
#                                                                       FE45  84
writeline:(2,FE45A,NFE45A,3,3)#                                         FE45  85
writeline:(1,FE456,NFE456,3,3)#                                         FE45  86
DO M=1,2#                                                               FE45  87
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE45  88
foutput:(M,0,0)#                                                        FE45  89
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE45  90
CALL FE71(AKEY,2,DIST,SDT,K,SYMO)#                                      FE45  91
voutput:(DIST)#                                                         FE45  92
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE45  93
ELSE IF(K==2)#                         *** ang ***  bond angle          FE45  94
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE45  95
FLAG=0#                                Set flag for atoms searching     FE45  96
search:(I,AKEY(1),FLAG)#               Searching atom_a                 FE45  97
search:(I,AKEY(2),FLAG)#               Searching atom_a                 FE45  98
search:(I,AKEY(3),FLAG)#                                                FE45  99
CALL FE52(AKEY,ANGLE)#                 Calculate the bond angle         FE45 100
#                                                                       FE45 101
writeline:(2,FE45B,NFE45B,3,3)#                                         FE45 102
writeline:(1,FE456,NFE456,3,3)#                                         FE45 103
DO M=1,3#                                                               FE45 104
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE45 105
foutput:(M,0,0)#                                                        FE45 106
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE45 107
CALL FE71(AKEY,3,ANGLE,SDT,K,SYMO)#                                     FE45 108
voutput:(ANGLE)#                                                        FE45 109
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE45 110
ELSE IF(K==3)#                         *** pda ***                      FE45 111
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE45 112
plsearch:(I,AKEY,FLAG,2,1)#            Search for atoms or plane        FE45 113
FLAG=0#                                Set flag for atoms searching     FE45 114
search:(I,AKEY(4),FLAG)#               Search for atoms                 FE45 115
CALL FE58(AKEY,DIST)#                                                   FE45 116
#                                                                       FE45 117
writeline:(2,FE45C,NFE45C,3,3)#                                         FE45 118
writeline:(1,FE456,NFE456,3,3)#                                         FE45 119
fpoutput:(1,1)#                                                         FE45 120
foutput:(4,0,0)#                                                        FE45 121
CALL FE71(AKEY,4,DIST,SDT,K,SYMO)#                                      FE45 122
voutput:(DIST)#                                                         FE45 123
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE45 124
ELSE IF(K==4)#                         *** lda ***                      FE45 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FE45 126
plsearch:(I,AKEY,FLAG,1,1)#            Search fop atoms or line.        FE45 127
FLAG=0#                                Set flag for atom searching.     FE45 128
search:(I,AKEY(3),FLAG)#               Search for atom.                 FE45 129
CALL FE59(AKEY,DIST)#                  Calculate the distance           FE45 130
#                                                                       FE45 131
writeline:(2,FE45D,NFE45D,3,3)#                                         FE45 132
writeline:(1,FE456,NFE456,3,3)#                                         FE45 133
floutput:(1,1)#                                                         FE45 134
foutput:(3,0,0)#                                                        FE45 135
CALL FE71(AKEY,3,DIST,SDT,K,SYMO)#                                      FE45 136
voutput:(DIST)#                                                         FE45 137
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FE45 138
ELSE IF(K==5)#                         *** pap ***                      FE45 139
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FE45 140
plsearch:(I,AKEY,FLAG,2,1)#            Search for atoms or plane.       FE45 141
plsearch:(I,AKEY,FLAG,2,4)#            Search for atoms or plane.       FE45 142
CALL FE56(AKEY,ANGLE)#                 Calculate the angle.             FE45 143
#                                                                       FE45 144
writeline:(2,FE45E,NFE45E,3,3)#                                         FE45 145
writeline:(1,FE456,NFE456,3,3)#                                         FE45 146
fpoutput:(1,1)#                                                         FE45 147
fpoutput:(2,4)#                                                         FE45 148
CALL FE71(AKEY,6,ANGLE,SDT,K,SYMO)#                                     FE45 149
voutput:(ANGLE)#                                                        FE45 150
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FE45 151
ELSE IF(K==6)#                         *** pal ***                      FE45 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FE45 153
plsearch:(I,AKEY,FLAG,2,1)#            Search for atoms or plane.       FE45 154
plsearch:(I,AKEY,FLAG,1,4)#            Search for atoms or line.        FE45 155
CALL FE57(AKEY,ANGLE)#                 Calculate the angle.             FE45 156
#                                                                       FE45 157
writeline:(2,FE45F,NFE45F,3,3)#                                         FE45 158
writeline:(1,FE456,NFE456,3,3)#                                         FE45 159
fpoutput:(1,1)#                                                         FE45 160
floutput:(2,4)#                                                         FE45 161
CALL FE71(AKEY,5,ANGLE,SDT,K,SYMO)#                                     FE45 162
voutput:(ANGLE)#                                                        FE45 163
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FE45 164
ELSE IF(K==7)#                         *** lal ***                      FE45 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FE45 166
plsearch:(I,AKEY,FLAG,1,1)#                                             FE45 167
plsearch:(I,AKEY,FLAG,1,3)#                                             FE45 168
CALL FE52(AKEY,ANGLE)#                                                  FE45 169
#                                                                       FE45 170
writeline:(2,FE45G,NFE45G,3,3)#                                         FE45 171
writeline:(1,FE456,NFE456,3,3)#                                         FE45 172
floutput:(1,1)#                                                         FE45 173
floutput:(2,3)#                                                         FE45 174
CALL FE71(AKEY,4,ANGLE,SDT,K,SYMO)#                                     FE45 175
voutput:(ANGLE)#                                                        FE45 176
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FE45 177
ELSE IF(K==8)#                         *** dih ***                      FE45 178
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FE45 179
FLAG=0#                                Set flag for atom searching.     FE45 180
DO M=1,4#                                                               FE45 181
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FE45 182
search:(I,AKEY(M),FLAG)#                                                FE45 183
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FE45 184
CALL FE53(AKEY,ANGLE)#                                                  FE45 185
#                                                                       FE45 186
writeline:(2,FE45H,NFE45H,3,3)#                                         FE45 187
writeline:(1,FE456,NFE456,3,3)#                                         FE45 188
DO M=1,4#                                                               FE45 189
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FE45 190
foutput:(M,0,0)#                                                        FE45 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FE45 192
CALL FE71(AKEY,4,ANGLE,SDT,K,SYMO)#                                     FE45 193
voutput:(ANGLE)#                                                        FE45 194
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FE45 195
ELSE IF(K==9)#                         *** vol ***                      FE45 196
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FE45 197
writeline:(2,FE45I,NFE45I,3,3)#                                         FE45 198
CALL FE71(AKEY,1,DBLE(VOLUMN),SDT,K,SYMO)#                              FE45 199
voutput:(VOLUMN)#                                                       FE45 200
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FE45 201
STATUS(1)=0;    STATUS(2)=0#                                            FE45 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE45 203
ELSE IF (LINID==2) BREAK#              End                              FE45 204
ELSE iquit:(FE4503)#                   Unknown controle line.           FE45 205
readline:(FE452,NFE452)#                                                FE45 206
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE45 207
readwpkt:(1,endrecord:,I,J,0)#                                          FE45 208
readwpkt:(4,endrecord:,I,J,0)#                                          FE45 209
#                                                                       FE45 210
RETURN#                                                                 FE45 211
END#                                                                    FE45 212
systemheader:(FE50)#                   Normal vector (contravariant     FE50   1
# ################################################################## #  FE50   2
#                                                                    #  FE50   3
#                               FE50                                 #  FE50   4
#                                                                    #  FE50   5
# ################################################################## #  FE50   6
SUBROUTINE FE50(IA,IB,IC,VECTOR)#      H.wang, r.j.barton               FE50   7
#                                      B.e.robertson   jan-1987         FE50   8
include:(AACOMN)#                                                       FE50   9
include:(FECOMN)#                                                       FE50  10
#                                                                       FE50  11
INTEGER I,IA,IB,IC,LA,LB,LC#                                            FE50  12
REAL A(3),B(3),C(3),D(3),VECTOR(*)#                                     FE50  13
#                                                                       FE50  14
LA=IA+1;   LB=IB+1;   LC=IC+1#                                          FE50  15
DO I=1,3#                                                               FE50  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE50  17
A(I)=QX(LA+I)#                                                          FE50  18
B(I)=QX(LB+I)#                                                          FE50  19
C(I)=QX(LC+I)#                                                          FE50  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE50  21
#                                                                       FE50  22
det:(A,B,D,100.0)#                                                      FE50  23
DO I=1,3; VECTOR(I)=D(I)#                                               FE50  24
det:(B,C,D,100.0)#                                                      FE50  25
DO I=1,3; VECTOR(I)=VECTOR(I)+D(I)#                                     FE50  26
det:(C,A,D,100.0)#                                                      FE50  27
DO I=1,3; VECTOR(I)=VECTOR(I)+D(I)#                                     FE50  28
#                                                                       FE50  29
RETURN#                                                                 FE50  30
END#                                                                    FE50  31
systemheader:(FE51)#                   Distance between two points.     FE51   1
# ################################################################## #  FE51   2
#                                                                    #  FE51   3
#                               FE51                                 #  FE51   4
#                                                                    #  FE51   5
# ################################################################## #  FE51   6
SUBROUTINE FE51(IA,DISTND)#            H.wang, r.j.barton               FE51   7
#                                      B.e.robertson   jan-1987         FE51   8
include:(AACOMN)#                                                       FE51   9
include:(FECOMN)#                                                       FE51  10
#                                                                       FE51  11
INTEGER I,IA(*),LA,LB#                                                  FE51  12
REAL C(3)#                                                              FE51  13
DOUBLE PRECISION DISTND#                                                FE51  14
#                                                                       FE51  15
LA=IA(1)+1; LB=IA(2)+1#                                                 FE51  16
DO I=1,3; C(I)=QX(LA+I)-QX(LB+I)#                                       FE51  17
#                                                                       FE51  18
vgv:(C,GC,C,DISTND)#                                                    FE51  19
DISTND=DSQRT(DISTND)#                                                   FE51  20
#                                                                       FE51  21
RETURN#                                                                 FE51  22
END#                                                                    FE51  23
systemheader:(FE52)#                   Angle between two vectors        FE52   1
# ################################################################## #  FE52   2
#                                                                    #  FE52   3
#                               FE52                                 #  FE52   4
#                                                                    #  FE52   5
# ################################################################## #  FE52   6
SUBROUTINE FE52(IA,ANGLE)#             H.wang, r.j.barton               FE52   7
#                                      B.e.robertson   jan-1987         FE52   8
include:(AACOMN)#                                                       FE52   9
include:(FECOMN)#                                                       FE52  10
#                                                                       FE52  11
INTEGER I,IA(*),LA,LB,LC#                                               FE52  12
REAL A(3),C(3)#                                                         FE52  13
DOUBLE PRECISION ANGLE,DISA,DISB,DISC#                                  FE52  14
#                                                                       FE52  15
LA=IA(1)+1; LB=IA(2)+1; LC=IA(3)+1#                                     FE52  16
DO I=1,3#                                                               FE52  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE52  18
A(I)=QX(LB+I)-QX(LA+I)#                                                 FE52  19
C(I)=QX(LB+I)-QX(LC+I)#                                                 FE52  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE52  21
vgv:(A,GC,A,DISA)#                                                      FE52  22
vgv:(C,GC,C,DISC)#                                                      FE52  23
vgv:(A,GC,C,DISB)#                                                      FE52  24
ANGLE=DISB/DSQRT(DISA*DISC)#           Calc arg for arc cos             FE52  25
IF(ANGLE<1.) ANGLE=RTOD*DACOS(ANGLE)#  Calc angle                       FE52  26
ELSE         ANGLE=0.#                 Assume angle is 0.               FE52  27
#                                                                       FE52  28
RETURN#                                                                 FE52  29
END#                                                                    FE52  30
systemheader:(FE53)#                   Dihedral angle                   FE53   1
# ################################################################## #  FE53   2
#                                                                    #  FE53   3
#                               FE53                                 #  FE53   4
#                                                                    #  FE53   5
# ################################################################## #  FE53   6
SUBROUTINE FE53(IA,ANGLE)#             H.wang, r.j.barton               FE53   7
#                                      B.e.robertson   jan-1987         FE53   8
include:(AACOMN)#                                                       FE53   9
include:(FECOMN)#                                                       FE53  10
#                                                                       FE53  11
INTEGER I,IA(*),LA,LB,LC#                                               FE53  12
REAL A(3),C(3)#                                                         FE53  13
REAL COEFA(3),COEFB(3)#                                                 FE53  14
DOUBLE PRECISION ANGLE,DA,DB,DC,DD#                                     FE53  15
#                                                                       FE53  16
LA=IA(1)+1; LB=IA(2)+1; LC=IA(3)+1#                                     FE53  17
DO I=1,3#                                                               FE53  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE53  19
A(I)=QX(LA+I)-QX(LB+I)#                                                 FE53  20
C(I)=QX(LC+I)-QX(LB+I)#                                                 FE53  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE53  22
det:(A,C,COEFA,100.0)#                                                  FE53  23
LA=IA(4)+1#                                                             FE53  24
DO I=1,3#                                                               FE53  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE53  26
A(I)=QX(LA+I)-QX(LC+I)#                                                 FE53  27
C(I)=QX(LB+I)-QX(LC+I)#                                                 FE53  28
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE53  29
det:(C,A,COEFB,100.0)#                                                  FE53  30
#                                                                       FE53  31
vgv:(COEFA,RGC,COEFA,DA)#                                               FE53  32
vgv:(COEFB,RGC,COEFB,DB)#                                               FE53  33
vgv:(COEFA,RGC,COEFB,DC)#                                               FE53  34
DD=DC/DSQRT(DA*DB)#                                                     FE53  35
IF(DABS(DD)>1.0D0) DD=DSIGN(1.0D0,DD)#                                  FE53  36
ANGLE=RTOD*DACOS(DD)#                                                   FE53  37
#                                                                       FE53  38
vxv:(COEFA,A,DA)#                                                       FE53  39
IF(DA>0.0D0) ANGLE=-ANGLE#                                              FE53  40
RETURN#                                                                 FE53  41
END#                                                                    FE53  42
systemheader:(FE54)#                   Plane equation                   FE54   1
# ################################################################## #  FE54   2
#                                                                    #  FE54   3
#                               FE54                                 #  FE54   4
#                                                                    #  FE54   5
# ################################################################## #  FE54   6
SUBROUTINE FE54(IA,COEF)#              H.wang, r.j.barton               FE54   7
#                                      B.e.robertson   jan-1987         FE54   8
include:(AACOMN)#                                                       FE54   9
include:(FECOMN)#                                                       FE54  10
#                                                                       FE54  11
INTEGER I,IA(*),LA,LB,LC#                                               FE54  12
REAL A(3),B(3),C(3),COEF(*),DET#                                        FE54  13
DOUBLE PRECISION DA#                                                    FE54  14
#                                                                       FE54  15
LA=IA(1)+1; LB=IA(2)+1; LC=IA(3)+1#                                     FE54  16
DO I=1,3#                                                               FE54  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE54  18
A(I)=QX(LA+I)#                                                          FE54  19
B(I)=QX(LB+I)#                                                          FE54  20
C(I)=QX(LC+I)#                                                          FE54  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE54  22
CALL FE50(IA(1),IA(2),IA(3),COEF)#                                      FE54  23
DET=-100.0#                                                             FE54  24
det:(A,B,C,DET)#                                                        FE54  25
COEF(4)=DET#                                                            FE54  26
#                                                                       FE54  27
vgv:(COEF,RGC,COEF,DA)#                                                 FE54  28
DA=DSQRT(DA)#                                                           FE54  29
DO I=1,4; COEF(I)=COEF(I)/DA#                                           FE54  30
#                                                                       FE54  31
RETURN#                                                                 FE54  32
END#                                                                    FE54  33
systemheader:(FE55)#                   Line equation                    FE55   1
# ################################################################## #  FE55   2
#                                                                    #  FE55   3
#                               FE55                                 #  FE55   4
#                                                                    #  FE55   5
# ################################################################## #  FE55   6
SUBROUTINE FE55(IA,COEF)#              H.wang, r.j.barton               FE55   7
#                                      B.e.robertson   jan-1987         FE55   8
include:(AACOMN)#                                                       FE55   9
include:(FECOMN)#                                                       FE55  10
#                                                                       FE55  11
INTEGER I,IA(*),LA,LB#                                                  FE55  12
REAL COEF(*)#                                                           FE55  13
#                                                                       FE55  14
LA=IA(1)+1;       LB=IA(2)+1#                                           FE55  15
DO I=1,3#                                                               FE55  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE55  17
COEF(I)=QX(LA+I)-QX(LB+I)#                                              FE55  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE55  19
#                                                                       FE55  20
RETURN#                                                                 FE55  21
END#                                                                    FE55  22
systemheader:(FE56)#                   Angle between planes.            FE56   1
# ################################################################## #  FE56   2
#                                                                    #  FE56   3
#                               FE56                                 #  FE56   4
#                                                                    #  FE56   5
# ################################################################## #  FE56   6
SUBROUTINE FE56(IA,ANGLE)#             H.wang, r.j.barton               FE56   7
#                                      B.e.robertson   jan-1987         FE56   8
include:(AACOMN)#                                                       FE56   9
include:(FECOMN)#                                                       FE56  10
#                                                                       FE56  11
INTEGER IA(*),K#                                                        FE56  12
REAL COEFA(3),COEFB(3)#                                                 FE56  13
DOUBLE PRECISION ANGLE,DA,DB,DC#                                        FE56  14
#                                                                       FE56  15
IF(STATUS(1)==0)#                                                       FE56  16
CALL FE50(IA(1),IA(2),IA(3),COEFA)#                                     FE56  17
ELSE#                                                                   FE56  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE56  19
K=IA(1)+0#                                                              FE56  20
movereal:(QX,K,COEFA,1,3,0)#                                            FE56  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE56  22
#                                                                       FE56  23
IF(STATUS(2)==0)#                                                       FE56  24
CALL FE50(IA(4),IA(5),IA(6),COEFB)#                                     FE56  25
ELSE#                                                                   FE56  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE56  27
K=IA(4)+0#                                                              FE56  28
movereal:(QX,K,COEFB,1,3,0)#                                            FE56  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE56  30
#                                                                       FE56  31
vgv:(COEFA,RGC,COEFA,DA)#                                               FE56  32
vgv:(COEFB,RGC,COEFB,DB)#                                               FE56  33
vgv:(COEFA,RGC,COEFB,DC)#                                               FE56  34
ANGLE=DC/DSQRT(DA*DB)#                                                  FE56  35
IF(DABS(ANGLE)>1.0D0) ANGLE=DSIGN(1.0D0,ANGLE)#                         FE56  36
ANGLE=RTOD*DACOS(ANGLE)#                                                FE56  37
#                                                                       FE56  38
RETURN#                                                                 FE56  39
END#                                                                    FE56  40
systemheader:(FE57)#                   Angle between plane and line     FE57   1
# ################################################################## #  FE57   2
#                                                                    #  FE57   3
#                               FE57                                 #  FE57   4
#                                                                    #  FE57   5
# ################################################################## #  FE57   6
SUBROUTINE FE57(IA,ANGLE)#             H.wang, r.j.barton               FE57   7
#                                      B.e.robertson   jan-1987         FE57   8
include:(AACOMN)#                                                       FE57   9
include:(FECOMN)#                                                       FE57  10
#                                                                       FE57  11
INTEGER IA(*),K#                                                        FE57  12
REAL COEFA(3),COEFB(3)#                                                 FE57  13
DOUBLE PRECISION ANGLE,DA,DB,DC#                                        FE57  14
#                                                                       FE57  15
IF(STATUS(1)==0)#                                                       FE57  16
CALL FE50(IA(1),IA(2),IA(3),COEFA)#                                     FE57  17
ELSE#                                                                   FE57  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE57  19
K=IA(1)+0#                                                              FE57  20
movereal:(QX,K,COEFA,1,3,0)#                                            FE57  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE57  22
#                                                                       FE57  23
IF(STATUS(2)==0)#                                                       FE57  24
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE57  25
CALL FE55(IA(4),COEFB)#                                                 FE57  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE57  27
ELSE#                                                                   FE57  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE57  29
K=IA(4)#                                                                FE57  30
movereal:(QX,K,COEFB,1,3,0)#                                            FE57  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE57  32
#                                                                       FE57  33
vgv:(COEFA,RGC,COEFA,DA)#                                               FE57  34
vgv:(COEFB,GC,COEFB,DB)#                                                FE57  35
vxv:(COEFA,COEFB,DC)#                                                   FE57  36
ANGLE=RTOD*DACOS(DC/DSQRT(DA*DB))#                                      FE57  37
#                                                                       FE57  38
RETURN#                                                                 FE57  39
END#                                                                    FE57  40
systemheader:(FE58)#                   Distance from a plane to atom    FE58   1
# ################################################################## #  FE58   2
#                                                                    #  FE58   3
#                               FE58                                 #  FE58   4
#                                                                    #  FE58   5
# ################################################################## #  FE58   6
SUBROUTINE FE58(IA,DIST)#              H.wang, r.j.barton               FE58   7
#                                      B.e.robertson   jan-1987         FE58   8
include:(AACOMN)#                                                       FE58   9
include:(FECOMN)#                                                       FE58  10
#                                                                       FE58  11
INTEGER I,IA(*),K,LA#                                                   FE58  12
REAL A(3),COEF(4)#                                                      FE58  13
DOUBLE PRECISION DIST#                                                  FE58  14
#                                                                       FE58  15
LA=IA(4)+1#                            Address of the atom              FE58  16
DO I=1,3;  A(I)=QX(LA+I)#                                               FE58  17
#                                                                       FE58  18
IF(STATUS(1)==0) CALL FE54(IA,COEF)#                                    FE58  19
ELSE#                                                                   FE58  20
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE58  21
K=IA(1)#                                                                FE58  22
movereal:(QX,K,COEF,1,4,0)#                                             FE58  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE58  24
#                                                                       FE58  25
vxv:(COEF,A,DIST)#                     (co * con)                       FE58  26
DIST=DABS(DIST-COEF(4))#                                                FE58  27
#                                                                       FE58  28
RETURN#                                                                 FE58  29
END#                                                                    FE58  30
systemheader:(FE59)#                   Distance from atom to line       FE59   1
# ################################################################## #  FE59   2
#                                                                    #  FE59   3
#                               FE59                                 #  FE59   4
#                                                                    #  FE59   5
# ################################################################## #  FE59   6
SUBROUTINE FE59(IA,DIST)#              H.wang, r.j.barton               FE59   7
#                                      B.e.robertson   jan-1987         FE59   8
include:(AACOMN)#                                                       FE59   9
include:(FECOMN)#                                                       FE59  10
#                                                                       FE59  11
INTEGER I,IA(*),K,LA,LB#                                                FE59  12
REAL B(3),VECTOR(3),TEMP(3)#                                            FE59  13
DOUBLE PRECISION DIST,DA,DB#                                            FE59  14
#                                                                       FE59  15
LB=IA(3)+1; LA=IA(1)+1#                                                 FE59  16
DO I=1,3;  B(I)=QX(LB+I)-QX(LA+I)#                                      FE59  17
#                                                                       FE59  18
IF(STATUS(1)==0)#                                                       FE59  19
CALL FE55(IA,VECTOR)#                                                   FE59  20
ELSE#                                                                   FE59  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE59  22
K=IA(1)#                                                                FE59  23
movereal:(QX,K,VECTOR,1,3,0)#                                           FE59  24
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE59  25
#                                                                       FE59  26
det:(VECTOR,B,TEMP,100.0)#                                              FE59  27
vgv:(VECTOR,GC,VECTOR,DA)#                                              FE59  28
vgv:(TEMP,RGC,TEMP,DB)#                                                 FE59  29
DIST=DSQRT(DB/DA)#                                                      FE59  30
#                                                                       FE59  31
RETURN#                                                                 FE59  32
END#                                                                    FE59  33
systemheader:(FE61)#                   Unit cell volumn                 FE61   1
# ################################################################## #  FE61   2
#                                                                    #  FE61   3
#                               FE61                                 #  FE61   4
#                                                                    #  FE61   5
# ################################################################## #  FE61   6
SUBROUTINE FE61(VOL)#                  H.wang, r.j.barton               FE61   7
#                                      B.e.robertson jan-87             FE61   8
include:(AACOMN)#                                                       FE61   9
include:(FECOMN)#                                                       FE61  10
INTEGER K#                                                              FE61  11
REAL VOL#                                                               FE61  12
K=MARK1#                                                                FE61  13
VOL=1-QX(K+4)*QX(K+4)-QX(K+5)*QX(K+5)-QX(K+6)*QX(K+6)#                  FE61  14
VOL=2.0*QX(K+4)*QX(K+5)*QX(K+6)+VOL#                                    FE61  15
VOL=QX(K+1)*QX(K+2)*QX(K+3)*SQRT(VOL)# Unit cell volumn.                FE61  16
RETURN#                                                                 FE61  17
END#                                                                    FE61  18
systemheader:(FE62)#                   Create atom connection table     FE62   1
# ################################################################## #  FE62   2
#                                                                    #  FE62   3
#                               FE62                                 #  FE62   4
#                                                                    #  FE62   5
# ################################################################## #  FE62   6
SUBROUTINE FE62#                       H.wang, r.j.barton               FE62   7
#                                      B.e.robertson aug-87             FE62   8
include:(AACOMN)#                                                       FE62   9
include:(FECOMN)#                                                       FE62  10
#                                                                       FE62  11
INTEGER I,IC,ICLUS,IS,IT,J,JC,JFLAG,JKEY,K,KEY,KX,KY,KZ#                FE62  12
INTEGER L5,L14,LSTOP3,M,NC,NM,NX#                                       FE62  13
REAL DJ,DW,EJ,U(3),V(3),X,Y,Z#                                          FE62  14
DOUBLE PRECISION DISTAN,DITMAX,DITMIN#                                  FE62  15
chardata:(FE621,      ATOM         X  $#                                FE62  16
      Y        Z     NOCA )#                                            FE62  17
chardata:(FE622,  THERE ARE     GROUPS OF CLUSTERS )#                   FE62  18
chardata:(FE623,IS )#                                                   FE62  19
chardata:(FE624,   GROUP    )#                                          FE62  20
realdata:(FMT,[220752.,310752.,400752.,460513.])#                       FE62  21
REAL AX(3)#                                                             FE62  22
datastuff:#                                                             FE62  23
#                                                                       FE62  24
ICLUS=0#                               Cluster id number.               FE62  25
NM=(NUMCEL+1)/2#                                                        FE62  26
L14=MARK14#                                                             FE62  27
IF(FASSM==yes:) LSTOP3=STOP3#                                           FE62  28
ELSE            LSTOP3=MARK3+STEP3#                                     FE62  29
#                                                                       FE62  30
##       ATOM CONNECTION TABLE        ##                                FE62  31
##     *************************      ##                                FE62  32
##                                    ##                                FE62  33
FOR(I=MARK5;I<STOP5;I=I+STEP5)#        Loop of array (mark5)            FE62  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE62  35
KEY=NINT(QX(I+13))#                    Recall checked/connected fla     FE62  36
IF(KEY>0) NEXT#                        Checked already, skip to nex     FE62  37
IF(KEY==0)#                            New cluster, put atom close      FE62  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE62  39
ICLUS=ICLUS+1#                         Cluster id number.               FE62  40
QX(I+13)=-ICLUS#                       Assign cluster id number.        FE62  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE62  42
#                                                                       FE62  43
JFLAG=1#                               Turn searching flag on           FE62  44
WHILE(JFLAG>0)#                                                         FE62  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE62  46
JFLAG=0#                               Reset searching flag             FE62  47
FOR(J=I;J<STOP5;J=J+STEP5)#            Loop of searching node atoms     FE62  48
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE62  49
JKEY=NINT(QX(J+13))#                   Recall cluster id number         FE62  50
IF(JKEY>=0) NEXT#                      Checked or unconnected, skip     FE62  51
QX(J+13)=FLOAT(ICLUS)#                                                  FE62  52
QX(J+14)=FLOAT(L14)#                   Pointer to connected table.      FE62  53
JFLAG=1#                               Turn searching flag on           FE62  54
NX=0#                                  Number ov connected atoms        FE62  55
#                                                                       FE62  56
IT=NINT(QX(J+1))#                      Pointer of atom type table       FE62  57
DJ=QX(IT+2);      EJ=QX(IT+3)#         Extract max and min bond rad     FE62  58
#                                                                       FE62  59
FOR(K=MARK5;K<STOP5;K=K+STEP5)#        Loop of searching connected      FE62  60
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE62  61
IF(QX(K+13)>0.0)#                                                       FE62  62
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE62  63
NC=NINT(QX(K+12))#                                                      FE62  64
DO IC=1,NC#                                                             FE62  65
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE62  66
JC=NINT(QX(K+14))+IC*3-2#                                               FE62  67
IF(NINT(QX(JC))==J) BREAK#                                              FE62  68
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE62  69
IF(IC>NC) NEXT#                                                         FE62  70
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE62  71
IT=NINT(QX(K+1))#                      Pointer of atom type table       FE62  72
DW=QX(IT+2)+DJ;    DITMAX=DBLE(DW*DW)# Max bond radius and square o     FE62  73
DW=QX(IT+3)+EJ;    DITMIN=DBLE(DW*DW)# Min bond radius and square o     FE62  74
X=QX(K+2);   Y=QX(K+3);   Z=QX(K+4)#                                    FE62  75
#                                                                       FE62  76
FOR(IS=MARK3;IS<LSTOP3;IS=IS+STEP3)#                                    FE62  77
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE62  78
V(1)=QX(IS+1)*X+QX(IS+4)*Y+QX(IS+7)*Z+QX(IS+10)#                        FE62  79
V(2)=QX(IS+2)*X+QX(IS+5)*Y+QX(IS+8)*Z+QX(IS+11)#                        FE62  80
V(3)=QX(IS+3)*X+QX(IS+6)*Y+QX(IS+9)*Z+QX(IS+12)#                        FE62  81
#                                                                       FE62  82
DO M=1,3#                                                               FE62  83
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FE62  84
V(M)=V(M)-QX(J+M+1)#                   Delta x, y and z                 FE62  85
AX(M)=FLOAT(NINT(V(M)))#                                                FE62  86
V(M)=V(M)-AX(M)#                                                        FE62  87
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FE62  88
#                                                                       FE62  89
DO KX=1,NUMCEL#                                                         FE62  90
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FE62  91
U(1)=V(1)+FLOAT(NM-KX)#                                                 FE62  92
DO KY=1,NUMCEL#                                                         FE62  93
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FE62  94
U(2)=V(2)+FLOAT(NM-KY)#                                                 FE62  95
DO KZ=1,NUMCEL#                                                         FE62  96
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FE62  97
U(3)=V(3)+FLOAT(NM-KZ)#                                                 FE62  98
vgv:(U,GC,U,DISTAN)#                                                    FE62  99
IF(DISTAN>DITMAX) NEXT#                                                 FE62 100
IF(DISTAN<DITMIN) NEXT#                                                 FE62 101
incrqx:(L14,L14+3,FE6201)#             F                                FE62 102
QX(L14-2)=K#                                                            FE62 103
QX(L14-1)=IS#                          Symmetry operator                FE62 104
QX(L14)=555+111*NM-KX*100-KY*10-KZ$#   Symmetry operator (translati     FE62 105
        -100*AX(1)-10*AX(2)-AX(3)#                                      FE62 106
NX=NX+1#                               Number of the connected atom     FE62 107
IF(ABS(QX(K+13))<0.1)#                                                  FE62 108
$(#                                    8>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FE62 109
QX(K+13)=-ICLUS#                       Connected atom                   FE62 110
$)#                                    8<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FE62 111
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FE62 112
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FE62 113
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FE62 114
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE62 115
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE62 116
QX(J+12)=FLOAT(NX)#                    Save the number of connected     FE62 117
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE62 118
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE62 119
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE62 120
STOP14=L14#                            End of the connected atom ta     FE62 121
MARK16=STOP14#                                                          FE62 122
##                                    ##                                FE62 123
##      LISTING CONNECTED ATOMS       ##                                FE62 124
##    ***************************     ##                                FE62 125
##                                    ##                                FE62 126
IF(ICLUS==1)#                                                           FE62 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FE62 128
movechar:(FE623,1,FE622,9,3,0)#                                         FE62 129
movechar:(FE623,3,FE622,22,1,0)#                                        FE62 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FE62 131
BUFOT(1)=FLOAT(ICLUS)#                                                  FE62 132
ncodefld:(BUFOT,1,FE622,150303.,1)#                                     FE62 133
writeline:(1,FE622,NFE622,3,3)#                                         FE62 134
DO I=1,ICLUS#                                                           FE62 135
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FE62 136
BUFOT(1)=I#                                                             FE62 137
LINRM=4#                                                                FE62 138
IF(ICLUS>1)#                                                            FE62 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FE62 140
ncodefld:(BUFOT,1,FE624,120303.,1)#                                     FE62 141
writeline:(1,FE624,NFE624,3,3)#                                         FE62 142
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FE62 143
writeline:(0,0,0,3,3)#                                                  FE62 144
FOR(L5=MARK5;L5<STOP5;L5=L5+STEP5)#                                     FE62 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FE62 146
K=NINT(QX(L5+13))#                                                      FE62 147
IF(K!=I) NEXT#                                                          FE62 148
movertoc:(QX(L5+la:),1,CHROT,7,8,0)#   Extract atom name                FE62 149
ncodefld:(QX,L5+2,CHROT,FMT,3)#        Format xyz,sigxyz                FE62 150
ncodefld:(QX,L5+12,CHROT,FMT(4),1)#                                     FE62 151
writeline:(0,FE621,NFE621,1,3)#        Print atom parameters            FE62 152
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FE62 153
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FE62 154
RETURN#                                                                 FE62 155
END#                                                                    FE62 156
systemheader:(FE63)#                   Bond distance, angle & dihea     FE63   1
# ################################################################## #  FE63   2
#                                                                    #  FE63   3
#                               FE63                                 #  FE63   4
#                                                                    #  FE63   5
# ################################################################## #  FE63   6
SUBROUTINE FE63#                       H.wanmg aug-87                   FE63   7
include:(AACOMN)#                                                       FE63   8
include:(FECOMN)#                                                       FE63   9
#                                                                       FE63  10
INTEGER I,IQQI,IZZI,I1,I2,I3,J,J1,J2,J3,K,KA,KB,KC,KK,KL,K2,K3,KD#      FE63  11
INTEGER LS,L5,MS,MX,NX#                                                 FE63  12
REAL DI,SMOM,TEMP#                                                      FE63  13
chardata:(FE631,  ATOM2    ATOM1    ATOM3  LENGTH/ANGLE  ESD $#         FE63  14
 SYMOP TVEC       X        Y        Z )#                                FE63  15
chardata:(FE632,[  ATOM1     ATOM2   $## F                              FE63  16
  ATOM3     ATOM4     ANGLE     ESD ])# F                               FE63  17
chardata:(FE633, **** BOND LENGTHS **** )#                              FE63  18
chardata:(FE636, **** BOND ANGLES **** )#                               FE63  19
chardata:(FE634, **** DIHEDRAL ANGLES **** )#                           FE63  20
chardata:(FE635,[()])#                                                  FE63  21
realdata:(FMT1,[370952.,440842.,500303.,$#                              FE63  22
560403.,660952.,750952.,840952.])#                                      FE63  23
realdata:(FMT2,[660952.,750952.,840952.])#                              FE63  24
realdata:(FMT3,[370832.,440732.])#                                      FE63  25
realdata:(FMT4,[480932.,570952.,$#                                      FE63  26
700952.,800952.,850203.,900403.])#                                      FE63  27
DOUBLE PRECISION DISTAN,ANGLE#                                          FE63  28
REAL SDT(4)#                                                            FE63  29
REAL SYMO(6)#                                                           FE63  30
REAL XATOM(3),YATOM(3),ZATOM(3),TATOM(3)#                               FE63  31
INTEGER IA(4)#                                                          FE63  32
CHARACTER*26 DA,DB,DC,DD#                                               FE63  33
datastuff:#                                                             FE63  34
#                                                                       FE63  35
LINRM=6#                                                                FE63  36
writeline:(2,FE633,NFE633,2,3)#                                         FE63  37
LINRM=1#                                                                FE63  38
##                                                                      FE63  39
##          BOND  DISTANCES           ##                                FE63  40
##        *******************         ##                                FE63  41
##                                    ##                                FE63  42
IF(FLENG==yes:)#                                                        FE63  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE63  44
FOR(L5=MARK5;L5<STOP5;L5=L5+STEP5)#                                     FE63  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE63  46
IA(2)=L5#                              Pointer of x, y, z.              FE63  47
SYMO(2)=-9.99#                                                          FE63  48
NX=NINT(QX(L5+12))#                    Number of connected atoms        FE63  49
I=NINT(QX(L5+1));  DI=QX(I)#                                            FE63  50
LS=NINT(QX(L5+14))#                                                     FE63  51
movertoc:(QX(L5+la:),1,CHROT,3,8,0)#   Extract atom name                FE63  52
IF(FTABL==yes:)#                                                        FE63  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE63  54
movertoc:(QX(L5+la:),1,DA,1,8,0)#                                       FE63  55
formatc:(DA,KA)#                                                        FE63  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE63  57
movereal:(QX(L5+2),1,BUFOT,1,3,0)#                                      FE63  58
ncodefld:(BUFOT,1,CHROT,FMT2,3)#                                        FE63  59
writeline:(1,FE631,NFE631,1,3)#                                         FE63  60
FOR(I=1;I<=NX;I=I+1)#                  Loop over connected atoms        FE63  61
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE63  62
I2=3*I-2+LS#                                                            FE63  63
I1=NINT(QX(I2))#                                                        FE63  64
IA(1)=I1#                                                               FE63  65
#                                                                       FE63  66
movereal:(QX(I1+2),1,XATOM(1),1,3,0)#                                   FE63  67
I2=I2+1;        SYMO(1)=QX(I2)#                                         FE63  68
I2=I2+1#                                                                FE63  69
CALL FE65(SYMO(1),QX(I2),XATOM(1),1,QX(I1+2),1)#                        FE63  70
CALL FE51(IA,DISTAN)#                  Calculate bond length            FE63  71
CALL FE71(IA,2,DISTAN,SDT,1,SYMO)#     Calculate standard deviation     FE63  72
movertoc:(QX(I1+la:),1,CHROT,12,8,0)#  Extract atom name                FE63  73
BUFOT(1)=DISTAN#                       Bond length in anstron           FE63  74
BUFOT(2)=SDT(1)#                       Standard deviations              FE63  75
BUFOT(3)=FLOAT((NINT(SYMO(1))-MARK3)/STEP3+1)# Symmetry operation id    FE63  76
BUFOT(4)=QX(I2)#                       Translational vector             FE63  77
movereal:(QX(I1+2),1,BUFOT,5,3,0)#     Fractional atom coordinates      FE63  78
ncodefld:(BUFOT,1,CHROT,FMT1,7)#       Formatting...                    FE63  79
writeline:(0,FE631,NFE631,1,3)#        Print bond length, sd, sym..     FE63  80
movereal:(XATOM(1),1,QX(I1+2),1,3,0)#  Recall original atom coordin     FE63  81
IF(FTABL==yes:)#                                                        FE63  82
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE63  83
IF(L5<I1)#                                                              FE63  84
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE63  85
movertoc:(QX(I1+la:),1,DB,1,8,0)#                                       FE63  86
formatc:(DB,KB)#                                                        FE63  87
movechar:(DA,1,CHROT,7,KA,0)#                                           FE63  88
movechar:(DB,1,CHROT,16,KB,0)#                                          FE63  89
formatn:(DISTAN,SDT(1),KK)#                                             FE63  90
KL=1#                                                                   FE63  91
IF(KK<0)#                                                               FE63  92
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE63  93
KL=-KK;   KK=0#                                                         FE63  94
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE63  95
BUFOT(1)=DISTAN#                       Store single precision           FE63  96
ncodefld:(BUFOT,1,CHROT,401162.,1)#                                     FE63  97
IF(KK<9)#                                                               FE63  98
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE63  99
KK=KK+34#                                                               FE63 100
movechar:(FE635,1,CHROT,KK,1,0)#                                        FE63 101
KK=KK+KL#                                                               FE63 102
TEMP=FLOAT(KK*10000+KL*100+13)#                                         FE63 103
ncodefld:(SDT(1),1,CHROT,TEMP,1)#                                       FE63 104
KK=KK+1#                                                                FE63 105
movechar:(FE635,2,CHROT,KK,1,0)#                                        FE63 106
KK=KK+1#                                                                FE63 107
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE63 108
ELSE KK=39#                                                             FE63 109
movechar:(BLANK,1,CHROT,KK,4,1)#       Insert four blanks               FE63 110
writepch:(CHROT,80)#                                                    FE63 111
movechar:(BLANK,1,CHROT,1,80,1)#       Blank complete line              FE63 112
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE63 113
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE63 114
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE63 115
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE63 116
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE63 117
##           BOND  ANGLES             ## BOND ANGLE CALCULATION         FE63 118
##         ****************           ##                                FE63 119
IF(FANGL==yes:)#                                                        FE63 120
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FE63 121
LINRM=6#                                                                FE63 122
writeline:(2,FE636,NFE636,2,3)#                                         FE63 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FE63 124
FOR(L5=MARK5;L5<STOP5;L5=L5+STEP5)#                                     FE63 125
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FE63 126
IA(2)=L5#                              Pointer of x, y, z.              FE63 127
SYMO(2)=-9.99#                                                          FE63 128
NX=NINT(QX(L5+12))#                    Number of connected atoms        FE63 129
IF(NX<=1) NEXT#                                                         FE63 130
I=NINT(QX(L5+1));  DI=QX(I)#                                            FE63 131
LS=NINT(QX(L5+14))#                                                     FE63 132
movertoc:(QX(L5+la:),1,CHROT,3,8,0)#   Extract atom name                FE63 133
IF(FTABL==yes:)#                                                        FE63 134
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FE63 135
movertoc:(QX(L5+la:),1,DA,1,8,0)#                                       FE63 136
formatc:(DA,KA)#                                                        FE63 137
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FE63 138
movereal:(QX(L5+2),1,BUFOT,1,3,0)#                                      FE63 139
ncodefld:(BUFOT,1,CHROT,FMT2,3)#                                        FE63 140
writeline:(1,FE631,NFE631,1,3)#                                         FE63 141
#                                                                       FE63 142
FOR(I=1;I<=NX;I=I+1)#                  Loop of first terminal atom      FE63 143
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FE63 144
I2=3*I-2+LS#                                                            FE63 145
I1=NINT(QX(I2))#                                                        FE63 146
IA(1)=I1#                                                               FE63 147
movereal:(QX(I1+2),1,XATOM(1),1,3,0)#  Save atom coordinates            FE63 148
I2=I2+1;        SYMO(1)=QX(I2)#        Symmetry operation code          FE63 149
I2=I2+1#                                                                FE63 150
CALL FE65(SYMO(1),QX(I2),XATOM(1),1,QX(I1+2),1)#                        FE63 151
IF(FTABL==yes:)#                                                        FE63 152
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FE63 153
movertoc:(QX(I1+la:),1,DB,1,8,0)#                                       FE63 154
formatc:(DB,KB)#                                                        FE63 155
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FE63 156
FOR(J=I+1;J<=NX;J=J+1)#                                                 FE63 157
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FE63 158
J2=3*J-2+LS#                                                            FE63 159
J1=NINT(QX(J2))#                                                        FE63 160
IA(3)=J1#                                                               FE63 161
movereal:(QX(J1+2),1,YATOM(1),1,3,0)#                                   FE63 162
J2=J2+1;         SYMO(3)=QX(J2)#                                        FE63 163
J2=J2+1#                                                                FE63 164
CALL FE65(SYMO(3),QX(J2),YATOM(1),1,QX(J1+2),1)#                        FE63 165
CALL FE52(IA,ANGLE)#                                                    FE63 166
CALL FE71(IA,3,ANGLE,SDT,2,SYMO)#                                       FE63 167
movertoc:(QX(I1+la:),1,CHROT,12,8,0)#  Extract atom name                FE63 168
movertoc:(QX(J1+la:),1,CHROT,21,8,0)#  Extract atom name                FE63 169
movereal:(YATOM(1),1,QX(J1+2),1,3,0)#                                   FE63 170
BUFOT(1)=ANGLE#                                                         FE63 171
BUFOT(2)=SDT(1)#                                                        FE63 172
ncodefld:(BUFOT,1,CHROT,FMT3,2)#                                        FE63 173
writeline:(0,FE631,NFE631,1,3)#                                         FE63 174
IF(FTABL==yes:)#                                                        FE63 175
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FE63 176
IF(I1<J1)#                                                              FE63 177
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FE63 178
movertoc:(QX(J1+la:),1,DC,1,8,0)#                                       FE63 179
formatc:(DC,KC)#                                                        FE63 180
movechar:(DB,1,CHROT,7,KB,0)#                                           FE63 181
movechar:(DA,1,CHROT,16,KA,0)#                                          FE63 182
movechar:(DC,1,CHROT,25,KC,0)#                                          FE63 183
formatn:(ANGLE,SDT(1),KK)#                                              FE63 184
KL=1#                                                                   FE63 185
IF(KK<0)#                                                               FE63 186
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FE63 187
KL=ABS(KK)#                                                             FE63 188
KK=0#                                                                   FE63 189
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FE63 190
BUFOT(1)=ANGLE#                        Make singlr precision            FE63 191
ncodefld:(BUFOT,1,CHROT,461142.,1)#                                     FE63 192
KK=KK+42#                                                               FE63 193
movechar:(FE635,1,CHROT,KK,1,0)#                                        FE63 194
KK=KK+KL#                                                               FE63 195
TEMP=KK*10000.+KL*100+13.0#                                             FE63 196
ncodefld:(SDT(1),1,CHROT,TEMP,1)#                                       FE63 197
KK=KK+1#                                                                FE63 198
movechar:(FE635,2,CHROT,KK,1,0)#                                        FE63 199
KK=KK+1#                                                                FE63 200
movechar:(BLANK,1,CHROT,KK,4,0)#                                        FE63 201
writepch:(CHROT,80)#                                                    FE63 202
movechar:(BLANK,1,CHROT,1,80,1)#                                        FE63 203
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FE63 204
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FE63 205
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FE63 206
movereal:(XATOM(1),1,QX(I1+2),1,3,0)#                                   FE63 207
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FE63 208
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FE63 209
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FE63 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FE63 211
##         DIHEDRAL  ANGLES           ##                                FE63 212
##       ********************         ##                                FE63 213
##                                    ##                                FE63 214
IF(FDIHE==yes:)#                       Compute d-angle as specified     FE63 215
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FE63 216
LINRM=7#                                                                FE63 217
MARK15=STOP14;   STOP15=STOP14#        Start of symop matrices          FE63 218
writeline:(3,FE634,NFE634,3,3)#                                         FE63 219
FOR(L5=MARK5;L5<STOP5;L5=L5+STEP5)#    Loop of first center atoms       FE63 220
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FE63 221
IA(2)=L5#                              Pointer of x, y, z.              FE63 222
SYMO(2)=-9.99#                         Pointer of symmetry operator     FE63 223
NX=NINT(QX(L5+12))#                    Number of connected atoms        FE63 224
IF(NX<2) NEXT#                                                          FE63 225
LS=NINT(QX(L5+14))#                    Pointer of connection table      FE63 226
DO I=1,NX#                             Loop of second center atom       FE63 227
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FE63 228
I2=LS+3*I-2#                                                            FE63 229
I3=NINT(QX(I2))#                       Pointer of connected atom        FE63 230
IF(I3<L5) NEXT#                                                         FE63 231
MX=NINT(QX(I3+12))#                                                     FE63 232
IF(MX<2) NEXT#                                                          FE63 233
IA(3)=I3#                              In atom array (mark5)            FE63 234
I2=I2+1;  SYMO(3)=QX(I2)#                                               FE63 235
movereal:(QX,I3+2,XATOM,1,3,0)#                                         FE63 236
I2=I2+1#                                                                FE63 237
CALL FE65(SYMO(3),QX(I2),XATOM(1),1,QX(I3+2),1)#                        FE63 238
MS=NINT(QX(I3+14))#                                                     FE63 239
movertoc:(QX(L5+la:),1,CHROT,13,8,0)#  Extract atom name                FE63 240
movertoc:(QX(I3+la:),1,CHROT,23,8,0)#  Extract atom name                FE63 241
IF(FTABL==yes:)#                                                        FE63 242
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FE63 243
movertoc:(QX(L5+la:),1,DA,1,8,0)#                                       FE63 244
formatc:(DA,KA)#                                                        FE63 245
movertoc:(QX(I3+la:),1,DB,1,8,0)#                                       FE63 246
formatc:(DB,KB)#                                                        FE63 247
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FE63 248
writeline:(1,FE632,NFE632,1,3)#                                         FE63 249
DO J=1,NX#                             Loop of first terminal atom      FE63 250
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FE63 251
IF(J==I) NEXT#                                                          FE63 252
J2=LS+3*J-2#                                                            FE63 253
J3=NINT(QX(J2));     IA(1)=J3#         Atom pointer in atom array       FE63 254
J2=J2+1;      SYMO(1)=QX(J2)#                                           FE63 255
movereal:(QX,J3+2,YATOM,1,3,0)#                                         FE63 256
J2=J2+1#                                                                FE63 257
CALL FE65(SYMO(1),QX(J2),YATOM(1),1,QX(J3+2),1)#                        FE63 258
DO K=1,MX#                             Loop of second terminal atom     FE63 259
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FE63 260
K2=MS+3*K-2#                                                            FE63 261
K3=NINT(QX(K2));     IA(4)=K3#         Atom pointer in atom array       FE63 262
IF(K3==L5) NEXT#                                                        FE63 263
movereal:(QX(K3+2),1,ZATOM,1,3,0)#                                      FE63 264
K2=K2+1#                                                                FE63 265
SMOM=QX(K2)#                                                            FE63 266
CALL FE68(QX(K2),SYMO(3),SYMO(4))#                                      FE63 267
K2=K2+1#                                                                FE63 268
CALL FE65(SMOM,QX(K2),ZATOM(1),1,TATOM(1),1)#                           FE63 269
CALL FE65(SYMO(3),QX(I2),TATOM(1),1,QX(K3+2),1)#                        FE63 270
CALL FE53(IA,ANGLE)#                   Calculate dihedral angle         FE63 271
CALL FE71(IA,4,ANGLE,SDT,8,SYMO)#      Calculate s.d. of d-angle        FE63 272
movertoc:(QX(J3+la:),1,CHROT,3,8,0)#   Extract atom name                FE63 273
movertoc:(QX(K3+la:),1,CHROT,33,8,0)#  Extract atom name                FE63 274
BUFOT(1)=ANGLE#                                                         FE63 275
movereal:(SDT,1,BUFOT,2,4,0)#          Move s.d's to fot buffer         FE63 276
ncodefld:(BUFOT,1,CHROT,FMT4,2)#       Formatted the number in fot      FE63 277
writeline:(0,FE632,NFE632,1,3)#        Print the results to lp          FE63 278
IF(FTABL==yes:)#                                                        FE63 279
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FE63 280
movertoc:(QX(J3+la:),1,DC,1,8,0)#                                       FE63 281
formatc:(DC,KC)#                                                        FE63 282
movertoc:(QX(K3+la:),1,DD,1,8,0)#                                       FE63 283
formatc:(DD,KD)#                                                        FE63 284
movechar:(DC,1,CHROT,7,KC,0)#                                           FE63 285
movechar:(DA,1,CHROT,16,KA,0)#                                          FE63 286
movechar:(DB,1,CHROT,25,KB,0)#                                          FE63 287
movechar:(DD,1,CHROT,34,KD,0)#                                          FE63 288
formatn:(ANGLE,SDT(1),KK)#                                              FE63 289
KL=1#                                                                   FE63 290
IF(KK<0)#                                                               FE63 291
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 FE63 292
KL=ABS(KK)#                                                             FE63 293
KK=0#                                                                   FE63 294
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 FE63 295
ncodefld:(SNGL(ANGLE),1,CHROT,641142.,1)#                               FE63 296
KK=KK+60#                                                               FE63 297
movechar:(FE635,1,CHROT,KK,1,0)#                                        FE63 298
KK=KK+KL#                                                               FE63 299
TEMP=KK*10000.+KL*100+13.0#                                             FE63 300
ncodefld:(SDT(1),1,CHROT,TEMP,1)#                                       FE63 301
KK=KK+1#                                                                FE63 302
movechar:(FE635,2,CHROT,KK,1,0)#                                        FE63 303
KK=KK+1#                                                                FE63 304
movechar:(BLANK,1,CHROT,KK,4,0)#                                        FE63 305
writepch:(CHROT,80)#                                                    FE63 306
movechar:(BLANK,1,CHROT,1,80,1)#                                        FE63 307
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FE63 308
movereal:(ZATOM,1,QX,K3+2,3,0)#                                         FE63 309
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FE63 310
movereal:(YATOM,1,QX,J3+2,3,0)#                                         FE63 311
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FE63 312
movereal:(XATOM,1,QX,I3+2,3,0)#                                         FE63 313
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FE63 314
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FE63 315
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FE63 316
#                                                                       FE63 317
RETURN#                                                                 FE63 318
END#                                                                    FE63 319
systemheader:(FE65)#                   Apply symmetry oper to atoms     FE65   1
# ################################################################## #  FE65   2
#                                                                    #  FE65   3
#                               FE65                                 #  FE65   4
#                                                                    #  FE65   5
#         SC ----- POINTER OF SYMMETRY OPERATION;                    #  FE65   6
#         T ------ TRASLATIONAL VECTOR (555);                        #  FE65   7
#         XATOM(3) SOURCE ATOM COORDINATES;                          #  FE65   8
#         YATOM(3) DESTINATION ATOM COORDINATES;                     #  FE65   9
#                                                                    #  FE65  10
# ################################################################## #  FE65  11
SUBROUTINE FE65(SC,T,XATOM,I,YATOM,J)# H.wang, r.j.barton               FE65  12
#                                      B.e.robertson aug-1987           FE65  13
include:(AACOMN)#                                                       FE65  14
include:(FECOMN)#                                                       FE65  15
REAL SC,T,XATOM(*),YATOM(*)#                                            FE65  16
INTEGER I,IS,J,TC,T1,T2,T3#                                             FE65  17
#                                                                       FE65  18
##        SYMMETRY OPERATION                                            FE65  19
##                                                                      FE65  20
IS=NINT(SC)#                           Pointer of symmetry operatio     FE65  21
YATOM(J)=$#                            X                                FE65  22
QX(IS+1)*XATOM(I)+QX(IS+4)*XATOM(I+1)+QX(IS+7)*XATOM(I+2)+QX(IS+10)#    FE65  23
YATOM(J+1)=$#                          Y                                FE65  24
QX(IS+2)*XATOM(I)+QX(IS+5)*XATOM(I+1)+QX(IS+8)*XATOM(I+2)+QX(IS+11)#    FE65  25
YATOM(J+2)=$#                          Z                                FE65  26
QX(IS+3)*XATOM(I)+QX(IS+6)*XATOM(I+1)+QX(IS+9)*XATOM(I+2)+QX(IS+12)#    FE65  27
#                                                                       FE65  28
##       TRANSLATION OPERATION                                          FE65  29
##                                     APPLY TRANSLATIONAL VECTOR       FE65  30
TC=NINT(T)#                            Translation vector               FE65  31
T1=TC/100;      T2=TC/10#              Decoding...                      FE65  32
T3=TC-T2*10-5#                         Z component                      FE65  33
T2=T2-T1*10-5#                         Y component                      FE65  34
T1=T1-5#                               X component                      FE65  35
YATOM(J)=YATOM(J)+FLOAT(T1)#           X                                FE65  36
YATOM(J+1)=YATOM(J+1)+FLOAT(T2)#       Y                                FE65  37
YATOM(J+2)=YATOM(J+2)+FLOAT(T3)#       Z                                FE65  38
RETURN#                                                                 FE65  39
END#                                                                    FE65  40
systemheader:(FE68)#                                                    FE68   1
# ################################################################## #  FE68   2
#                                                                    #  FE68   3
#                               FE68                                 #  FE68   4
#                                                                    #  FE68   5
# ################################################################## #  FE68   6
SUBROUTINE FE68(A,B,C)#                H.wang, r.j.barton               FE68   7
#                                      B.e.robertson  aug-1987          FE68   8
include:(AACOMN)#                                                       FE68   9
include:(FECOMN)#                                                       FE68  10
#                                                                       FE68  11
REAL A,B,C#                                                             FE68  12
INTEGER IA,IB,L15#                                                      FE68  13
L15=STOP15#                                                             FE68  14
incrqx:(STOP15,L15+12,FE6801)#                                          FE68  15
IA=NINT(A);         IB=NINT(B)#                                         FE68  16
QX(L15+1)=QX(IB+1)*QX(IA+1)+QX(IB+4)*QX(IA+2)+QX(IB+7)*QX(IA+3)#        FE68  17
QX(L15+2)=QX(IB+2)*QX(IA+1)+QX(IB+5)*QX(IA+2)+QX(IB+8)*QX(IA+3)#        FE68  18
QX(L15+3)=QX(IB+3)*QX(IA+1)+QX(IB+6)*QX(IA+2)+QX(IB+9)*QX(IA+3)#        FE68  19
QX(L15+4)=QX(IB+1)*QX(IA+4)+QX(IB+4)*QX(IA+5)+QX(IB+7)*QX(IA+6)#        FE68  20
QX(L15+5)=QX(IB+2)*QX(IA+4)+QX(IB+5)*QX(IA+5)+QX(IB+8)*QX(IA+6)#        FE68  21
QX(L15+6)=QX(IB+3)*QX(IA+4)+QX(IB+6)*QX(IA+5)+QX(IB+9)*QX(IA+6)#        FE68  22
QX(L15+7)=QX(IB+1)*QX(IA+7)+QX(IB+4)*QX(IA+8)+QX(IB+7)*QX(IA+9)#        FE68  23
QX(L15+8)=QX(IB+2)*QX(IA+7)+QX(IB+5)*QX(IA+8)+QX(IB+8)*QX(IA+9)#        FE68  24
QX(L15+9)=QX(IB+3)*QX(IA+7)+QX(IB+6)*QX(IA+8)+QX(IB+9)*QX(IA+9)#        FE68  25
#                                                                       FE68  26
QX(L15+10)=QX(IB+1)*QX(IA+10)+QX(IB+4)*QX(IA+11)+QX(IB+7)*QX(IA+12)#    FE68  27
QX(L15+11)=QX(IB+2)*QX(IA+10)+QX(IB+5)*QX(IA+11)+QX(IB+8)*QX(IA+12)#    FE68  28
QX(L15+12)=QX(IB+3)*QX(IA+10)+QX(IB+6)*QX(IA+11)+QX(IB+9)*QX(IA+12)#    FE68  29
#                                                                       FE68  30
C=FLOAT(L15)#                                                           FE68  31
MARK16=STOP15#                                                          FE68  32
RETURN#                                                                 FE68  33
END#                                                                    FE68  34
systemheader:(FE71)#                   Deviation of functions           FE71   1
# ################################################################## #  FE71   2
#                                                                    #  FE71   3
#                               FE71                                 #  FE71   4
#                                                                    #  FE71   5
#        PTS(*) --- ATOM POINTERS;                                   #  FE71   6
#        NV ------- NUMBER OF ATOMS IN THE FUNCTION;                 #  FE71   7
#        VALU ----- FUNCTION VALUE FROM PREVIOUS CALCULATION;        #  FE71   8
#        SDT(4) --- STANDARD DEVIATIONS OF THE FUNCTION;             #  FE71   9
#        IFUN ----- FUNCTION CODE:                                   #  FE71  10
#                       1:  BOND DISTANCE                 (DIS)      #  FE71  11
#                       2:  BOND ANGLE                    (ANG)      #  FE71  12
#                       3:  DISTANCE FROM ATOM TO PLANE   (PDA)      #  FE71  13
#                       4:  DISTANCE FROM ATOM TO LINE    (LDA)      #  FE71  14
#                       5:  ANGLE BETWEEN PLANES          (PAP)      #  FE71  15
#                       6:  ANGLE BETWEEN PLANE AND LINE  (PAL)      #  FE71  16
#                       7:  ANGLE BETWEEN LINES           (LAL)      #  FE71  17
#                       8:  DIHEDRAL ANGLE                (DAH)      #  FE71  18
#                       9:  CELL VOLUMN                   (VOL)      #  FE71  19
#        SYMO(*) -- SYMMETRY OPERATION ASSOCIATED WITH THE ATOMS.    #  FE71  20
#                                                                    #  FE71  21
# ################################################################## #  FE71  22
SUBROUTINE FE71(PTS,NV,VALU,SDT,IFUN,SYMO)#                             FE71  23
#                                      H.wang, r.j.barton               FE71  24
#                                      B.e.robertson jan-1987           FE71  25
include:(AACOMN)#                                                       FE71  26
include:(FECOMN)#                                                       FE71  27
#                                                                       FE71  28
REAL COVA,SD,TEMP,VARA#                                                 FE71  29
INTEGER I,IATOM,II,IFUN,IJ,IS,IST,I1,J,JATOM,JST,J1,K,KK#               FE71  30
INTEGER L,LA,LENG16,LL,LPTS,L1,L2,L3,L16,M,MV,NV,M1,M2,M3,NA,NB,NI#     FE71  31
INTEGER PTS(*)#                                                         FE71  32
REAL DIRE(18)#                                                          FE71  33
REAL SDT(*)#                                                            FE71  34
DOUBLE PRECISION VALU,DFUN#                                             FE71  35
REAL RDFUN#                                                             FE71  36
REAL SYMO(6)#                                                           FE71  37
chardata:(FE711,[ ++++++ VARIANCE-COVARIANCE MATRIX FOR ERROR $#        FE71  38
CALCULATION ])#                                                         FE71  39
#CHARDATA:(FE712,[ ++++++ DISTRIBUTION OF ERRORS ])#                    FE71  40
realdata:(FMT,[501161.,621161.,741161.,861161.,981161.,1101161.,$#      FE71  41
1221161.])#                                                             FE71  42
datastuff:#                                                             FE71  43
#                                                                       FE71  44
SD=0.0#                                                                 FE71  45
DO I=1,4; SDT(I)=0.0#                                                   FE71  46
#                                                                       FE71  47
IF(IFUN!=9)#                           Skip unit cell volumn            FE71  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE71  49
VARA=0.0#                              Variance of the function         FE71  50
COVA=0.0#                              Covariance of the function       FE71  51
MV=NV*3#                                                                FE71  52
LENG16=MV*(MV+1)/2#                                                     FE71  53
incrqx:(MARK17,MARK16+LENG16,FE7101)#  F                                FE71  54
CALL FE92(MV)#                         Initialize the v-c array.        FE71  55
#                                                                       FE71  56
IATOM=1#                                                                FE71  57
IF(STATUS(1)!=0) IATOM=STATUS(1)+2#                                     FE71  58
JATOM=NV#                                                               FE71  59
IF(STATUS(2)!=0) JATOM=NV-STATUS(2)-1#                                  FE71  60
#                                                                       FE71  61
IF(JATOM>=IATOM)#                                                       FE71  62
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE71  63
IF(FCOAT==yes:)#                       If covariances are included.     FE71  64
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE71  65
K=IATOM*3-3#                                                            FE71  66
CALL FE94(PTS(IATOM),K)#                                                FE71  67
FOR(I=IATOM+1;I<=JATOM;I=I+1)#                                          FE71  68
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE71  69
L=3*I-3#                                                                FE71  70
CALL FE93(PTS(IATOM),PTS(I),K,L,1)#                                     FE71  71
FOR(J=IATOM+1;J<I;J=J+1)#                                               FE71  72
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE71  73
M=3*J-3#                                                                FE71  74
CALL FE93(PTS(J),PTS(I),M,L,2)#                                         FE71  75
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE71  76
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE71  77
#                                                                       FE71  78
##  PRINT V-C MATRIX FOR THE FUNCTION                                   FE71  79
##                                                                      FE71  80
writeline:(1,FE711,NFE711,3,4)#                                         FE71  81
L16=MARK16+1#                                                           FE71  82
FOR(M=MV;M>0;M=M-1)#                                                    FE71  83
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE71  84
I=M#                                                                    FE71  85
REPEAT#                                                                 FE71  86
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE71  87
J=MIN0(I,7)#                                                            FE71  88
ncodefld:(QX(L16),1,CHROT,FMT,J)#                                       FE71  89
writeline:(0,0,0,1,4)#                                                  FE71  90
L16=L16+J#                                                              FE71  91
I=I-J#                                                                  FE71  92
IF(I<=0) BREAK#                                                         FE71  93
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE71  94
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE71  95
writeline:(0,BLANK,1,3,4)#                                              FE71  96
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE71  97
ELSE#                                                                   FE71  98
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE71  99
FOR(I=IATOM;I<=JATOM;I=I+1)#                                            FE71 100
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  FE71 101
K=3*I-3#                                                                FE71 102
CALL FE96(PTS(I),K)#                                                    FE71 103
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  FE71 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE71 105
#                                                                       FE71 106
IF(SYMO(1)>-100.0)#                                                     FE71 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 FE71 108
incrqx:(I,MARK17+LENG16,FE7102)#                                        FE71 109
IST=IATOM*3-2#                                                          FE71 110
JST=JATOM*3#                                                            FE71 111
movereal:(QX,MARK16+1,QX,MARK17+1,LENG16,1)#                            FE71 112
#                                                                       FE71 113
DO NA=IST,JST,3#                                                        FE71 114
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 FE71 115
NB=NA+2#                                                                FE71 116
IS=NB/3;    IS=SYMO(IS)#                                                FE71 117
IF(IS<1) NEXT#                                                          FE71 118
FOR(I=1;I<NA;I=I+1)#                                                    FE71 119
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 FE71 120
LL=(2*STEP16-I)*(I-1)/2+NA#                                             FE71 121
L1=LL+MARK16;       L2=LL+MARK17#                                       FE71 122
QX(L1  )=QX(L2)*QX(IS+1)+QX(L2+1)*QX(IS+2)+QX(L2+2)*QX(IS+3)#           FE71 123
QX(L1+1)=QX(L2)*QX(IS+4)+QX(L2+1)*QX(IS+5)+QX(L2+2)*QX(IS+6)#           FE71 124
QX(L1+2)=QX(L2)*QX(IS+7)+QX(L2+1)*QX(IS+8)+QX(L2+2)*QX(IS+9)#           FE71 125
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 FE71 126
#                                                                       FE71 127
L1=(2*STEP16-NA)*(NA-1)/2+MARK16#                                       FE71 128
L2=(2*STEP16-NA-1)*NA/2+MARK16#                                         FE71 129
L3=(2*STEP16-NB)*(NB-1)/2+MARK16#                                       FE71 130
M1=L1+LENG16; M2=L2+LENG16; M3=L3+LENG16#                               FE71 131
#                                                                       FE71 132
FOR(I=NB+1;I<=JST;I=I+1)#                                               FE71 133
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 FE71 134
QX(L1+I)=QX(IS+1)*QX(M1+I)+QX(IS+2)*QX(M2+I)+QX(IS+3)*QX(M3+I)#         FE71 135
QX(L2+I)=QX(IS+4)*QX(M1+I)+QX(IS+5)*QX(M2+I)+QX(IS+6)*QX(M3+I)#         FE71 136
QX(L3+I)=QX(IS+7)*QX(M1+I)+QX(IS+8)*QX(M2+I)+QX(IS+9)*QX(M3+I)#         FE71 137
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 FE71 138
#                                                                       FE71 139
M1=M1+NA;   M2=M2+NA+1;   M3=M3+NB#                                     FE71 140
I1=IS-1#                                                                FE71 141
DO I=NA,NB#                                                             FE71 142
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 FE71 143
I1=I1+1;          J1=I1-1#                                              FE71 144
LL=(2*STEP16-I)*(I-1)/2+MARK16#                                         FE71 145
DO J=I,NB#                                                              FE71 146
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 FE71 147
J1=J1+1;           IJ=LL+J#                                             FE71 148
QX(IJ)=$#                                                               FE71 149
QX(I1+1)*QX(M1  )*QX(J1+1)+$#                                           FE71 150
QX(I1+1)*QX(M1+1)*QX(J1+4)+$#                                           FE71 151
QX(I1+1)*QX(M1+2)*QX(J1+7)+$#                                           FE71 152
QX(I1+4)*QX(M1+1)*QX(J1+1)+$#                                           FE71 153
QX(I1+4)*QX(M2  )*QX(J1+4)+$#                                           FE71 154
QX(I1+4)*QX(M2+1)*QX(J1+7)+$#                                           FE71 155
QX(I1+7)*QX(M1+2)*QX(J1+1)+$#                                           FE71 156
QX(I1+7)*QX(M2+1)*QX(J1+4)+$#                                           FE71 157
QX(I1+7)*QX(M3  )*QX(J1+7)#                                             FE71 158
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 FE71 159
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 FE71 160
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 FE71 161
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 FE71 162
#                                                                       FE71 163
J=IATOM*3-3#                                                            FE71 164
DO K=IATOM,JATOM#                      Loop over atoms                  FE71 165
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 FE71 166
LA=PTS(K)+1#                           Pointer of atom parameters.      FE71 167
DO I=1,3#                              Loop over parameters of indi     FE71 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 FE71 169
LA=LA+1#                               Advance pointer                  FE71 170
TEMP=QX(LA)#                           Store x (y,z)                    FE71 171
QX(LA)=QX(LA)+0.00001#                 X+detal_x (y+delta_y, z+delt     FE71 172
##                                                                      FE71 173
##       FUNCTION SELECTIONS                                            FE71 174
##      ---------------------                                           FE71 175
IF(IFUN==1)#                           -- function 1  dis               FE71 176
CALL FE51(PTS,DFUN)#                                                    FE71 177
ELSE IF(IFUN==2)#                      -- function 2  ang               FE71 178
CALL FE52(PTS,DFUN)#                                                    FE71 179
ELSE IF(IFUN==3)#                      -- function 3  pda               FE71 180
CALL FE58(PTS,DFUN)#                                                    FE71 181
ELSE IF(IFUN==4)#                      -- function 4  lda               FE71 182
CALL FE59(PTS,DFUN)#                                                    FE71 183
ELSE IF(IFUN==5)#                      -- function 5  pap               FE71 184
CALL FE56(PTS,DFUN)#                                                    FE71 185
ELSE IF(IFUN==6)#                      -- function 6  pal               FE71 186
CALL FE57(PTS,DFUN)#                                                    FE71 187
ELSE IF(IFUN==7)#                      -- function 7  lal               FE71 188
CALL FE52(PTS,DFUN)#                                                    FE71 189
ELSE IF(IFUN==8)#                      -- function 8  dah               FE71 190
CALL FE53(PTS,DFUN)#                                                    FE71 191
ELSE#                                  -- function ?? ???               FE71 192
iquit:(FE7103)#                        The function is not availabl     FE71 193
#                                                                       FE71 194
J=J+1#                                                                  FE71 195
DIRE(J)=(DFUN-VALU)*100000.0#          First derivative of the func     FE71 196
QX(LA)=TEMP#                           Restore the atomic parameter     FE71 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 FE71 198
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 FE71 199
#                                                                       FE71 200
MV=NV*3#                               Total number of atomic param     FE71 201
IATOM=IATOM*3-2#                                                        FE71 202
JATOM=JATOM*3#                                                          FE71 203
FOR(I=IATOM;I<=JATOM;I=I+1)#           Loop for accumulating the va     FE71 204
#                                      Of the function                  FE71 205
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 FE71 206
LL=(2*STEP16-I)*(I-1)/2+MARK16#                                         FE71 207
II=LL+I#                               The variance are contributed     FE71 208
VARA=DIRE(I)*QX(II)*DIRE(I)+VARA#      From variance of atomic para     FE71 209
FOR(J=I+1;J<=JATOM;J=J+1)#                                              FE71 210
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 FE71 211
IJ=LL+J#                               The variance contributed fro     FE71 212
COVA=2.0*DIRE(I)*QX(IJ)*DIRE(J)+COVA#  Covariance of atomic paramet     FE71 213
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 FE71 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 FE71 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE71 216
#                                                                       FE71 217
DO K=1,2#                                                               FE71 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 FE71 219
IF(STATUS(K)==0) NEXT#                                                  FE71 220
KK=(K-1)*STATUS(K)+K#                  Poistion of current equation     FE71 221
LPTS=PTS(KK)#                                                           FE71 222
LA=LPTS+1#                             Pointer of atom parameters.      FE71 223
IF(ABS(STATUS(K))==2) KK=4#            For plane equation.              FE71 224
ELSE                  KK=3#            For line equation.               FE71 225
DO I=1,KK#                             Loop over parameters of indi     FE71 226
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 FE71 227
LA=LA+1#                               Advance pointer                  FE71 228
TEMP=QX(LA)#                           Store x (y,z)                    FE71 229
QX(LA)=QX(LA)+0.00001#                 X+detal_x (y+delta_y, z+delt     FE71 230
##                                                                      FE71 231
##       FUNCTION SELECTIONS                                            FE71 232
##      ---------------------                                           FE71 233
IF(IFUN==1)#                           -- function 1  dis               FE71 234
CALL FE51(PTS,DFUN)#                                                    FE71 235
ELSE IF(IFUN==2)#                      -- function 2  ang               FE71 236
CALL FE52(PTS,DFUN)#                                                    FE71 237
ELSE IF(IFUN==3)#                      -- function 3  pda               FE71 238
CALL FE58(PTS,DFUN)#                                                    FE71 239
ELSE IF(IFUN==4)#                      -- function 4  lda               FE71 240
CALL FE59(PTS,DFUN)#                                                    FE71 241
ELSE IF(IFUN==5)#                      -- function 5  pap               FE71 242
CALL FE56(PTS,DFUN)#                                                    FE71 243
ELSE IF(IFUN==6)#                      -- function 6  pal               FE71 244
CALL FE57(PTS,DFUN)#                                                    FE71 245
ELSE IF(IFUN==7)#                      -- function 7  lal               FE71 246
CALL FE52(PTS,DFUN)#                                                    FE71 247
ELSE IF(IFUN==8)#                      -- function 8  dah               FE71 248
CALL FE53(PTS,DFUN)#                                                    FE71 249
ELSE#                                                                   FE71 250
iquit:(FE7104)#                        The function is not availabl     FE71 251
#                                                                       FE71 252
DIRE(I)=(DFUN-VALU)*100000.0#          First derivative of the func     FE71 253
QX(LA)=TEMP#                           Restore the atomic parameter     FE71 254
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 FE71 255
#                                                                       FE71 256
LPTS=LPTS+4#                                                            FE71 257
FOR(I=1;I<=KK;I=I+1)#                                                   FE71 258
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 FE71 259
LL=(8-I)*(I-1)/2+LPTS#                                                  FE71 260
II=LL+I#                               The variance are contributed     FE71 261
VARA=DIRE(I)*QX(II)*DIRE(I)+VARA#      From variance of atomic para     FE71 262
FOR(J=I+1;J<=KK;J=J+1)#                                                 FE71 263
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 FE71 264
IJ=LL+J#                               The variance contributed fro     FE71 265
COVA=2.0*DIRE(I)*QX(IJ)*DIRE(J)+COVA#  Covariance of atomic paramet     FE71 266
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 FE71 267
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 FE71 268
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 FE71 269
#                                                                       FE71 270
SD=VARA+COVA#                                                           FE71 271
IF(SD<0.0)#                                                             FE71 272
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 FE71 273
SDT(2)=SD#                                                              FE71 274
iquit:(-FE7105)#                                                        FE71 275
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 FE71 276
ELSE SDT(2)=SQRT(SD)#                  S.d.---variance+covariance       FE71 277
SDT(3)=SQRT(VARA)#                     S.d.---variance                  FE71 278
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE71 279
#                                                                       FE71 280
##                                    ##                                FE71 281
##    VARIANCE (CELL PARAMETERS)      ##                                FE71 282
##   ----------------------------     ##                                FE71 283
##                                    ##                                FE71 284
L1=MARK1#                                                               FE71 285
CALL FE72(yes:)#                       Saving (co & contra) metric      FE71 286
DO J=1,6#                              Loop over cell parameters        FE71 287
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 FE71 288
#                                      Function selection               FE71 289
TEMP=QX(L1+J)#                         Saving unit cell parameter       FE71 290
QX(L1+J)=TEMP+0.00001#                                                  FE71 291
CALL FE73(MARK1)#                      Forming metric tensor            FE71 292
CALL FE98(MARK1,MARK1+2*STEP1)#        Calculating reciprocal cell      FE71 293
CALL FE73(MARK1+2*STEP1)#              Forming (contra) metric tens     FE71 294
#                                      Function selection               FE71 295
##                                                                      FE71 296
##       FUNCTION SELECTIONS                                            FE71 297
##      ---------------------                                           FE71 298
IF(IFUN==1)#                           -- function 1  dis               FE71 299
CALL FE51(PTS,DFUN)#                                                    FE71 300
ELSE IF(IFUN==2)#                      -- function 2  ang               FE71 301
CALL FE52(PTS,DFUN)#                                                    FE71 302
ELSE IF(IFUN==3)#                      -- function 3  pda               FE71 303
CALL FE58(PTS,DFUN)#                                                    FE71 304
ELSE IF(IFUN==4)#                      -- function 4  lda               FE71 305
CALL FE59(PTS,DFUN)#                                                    FE71 306
ELSE IF(IFUN==5)#                      -- function 5  pap               FE71 307
CALL FE56(PTS,DFUN)#                                                    FE71 308
ELSE IF(IFUN==6)#                      -- function 6  pal               FE71 309
CALL FE57(PTS,DFUN)#                                                    FE71 310
ELSE IF(IFUN==7)#                      -- function 7  lal               FE71 311
CALL FE52(PTS,DFUN)#                                                    FE71 312
ELSE IF(IFUN==8)#                      -- function 8  dah               FE71 313
CALL FE53(PTS,DFUN)#                                                    FE71 314
ELSE IF(IFUN==9)#                      -- function 9  vol               FE71 315
$(RDFUN=SNGL(DFUN);CALL FE61(RDFUN);DFUN=DBLE(RDFUN)$)#                 FE71 316
ELSE#                                                                   FE71 317
iquit:(FE7106)#                        The function is not availabl     FE71 318
#                                                                       FE71 319
DIRE(J)=(DFUN-VALU)*100000.0#          First derivative of the func     FE71 320
QX(L1+J)=TEMP#                         Restoring unit cell paramete     FE71 321
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 FE71 322
CALL FE98(MARK1,MARK1+2*STEP1)#        Restoring reciprocal cell pa     FE71 323
#                                                                       FE71 324
VARA=0.0#                              Variance of the function         FE71 325
FOR(I=1;I<=6;I=I+1)#                                                    FE71 326
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 FE71 327
NI=MARK2+(12-I)*(I-1)/2#                                                FE71 328
II=NI+I#                                                                FE71 329
VARA=DIRE(I)*QX(II)*DIRE(I)+VARA#                                       FE71 330
FOR(J=I+1;J<=6;J=J+1)#                                                  FE71 331
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 FE71 332
IJ=NI+J#                                                                FE71 333
VARA=2.0*DIRE(I)*QX(IJ)*DIRE(J)+VARA#                                   FE71 334
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 FE71 335
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 FE71 336
SDT(4)=SQRT(VARA)#                                                      FE71 337
SD=SD+VARA#                                                             FE71 338
IF(SD<0.0)#                                                             FE71 339
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 FE71 340
iquit:(FE7107)#                                                         FE71 341
SD=ABS(SD)#                                                             FE71 342
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 FE71 343
SDT(1)=SQRT(SD)#                                                        FE71 344
CALL FE72(no:)#                        Restore (co & contra) metric     FE71 345
#                                                                       FE71 346
RETURN#                                                                 FE71 347
END#                                                                    FE71 348
systemheader:(FE72)#                   Save & restore metric tensor     FE72   1
# ################################################################## #  FE72   2
#                                                                    #  FE72   3
#                               FE72                                 #  FE72   4
#                                                                    #  FE72   5
#          SFLAG --- NO:  RESTORE BOTH CO- AND CONTRAVARIANCE        #  FE72   6
#                         METRIX TENSORS.                            #  FE72   7
#                    YES: SAVE BOTH CO- AND CONTRAVARIANCE METRIC    #  FE72   8
#                         TENSORS.                                   #  FE72   9
#                                                                    #  FE72  10
# ################################################################## #  FE72  11
SUBROUTINE FE72(SFLAG)#                H.wang, r.j.barton               FE72  12
#                                      B.e.robertson  jan-1987          FE72  13
include:(AACOMN)#                                                       FE72  14
include:(FECOMN)#                                                       FE72  15
#                                                                       FE72  16
INTEGER LD,LE,SFLAG#                                                    FE72  17
#                                                                       FE72  18
LD=MARK1+6*STEP1#                                                       FE72  19
LE=LD+STEP1#                                                            FE72  20
#                                                                       FE72  21
IF(SFLAG==yes:)#                                                        FE72  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE72  23
QX(LD+1)=GC(1,1); QX(LD+2)=GC(1,2); QX(LD+3)=GC(1,3)#                   FE72  24
QX(LD+4)=GC(2,1); QX(LD+5)=GC(2,2); QX(LD+6)=GC(2,3)#                   FE72  25
QX(LD+7)=GC(3,1); QX(LD+8)=GC(3,2); QX(LD+9)=GC(3,3)#                   FE72  26
#                                                                       FE72  27
QX(LE+1)=RGC(1,1); QX(LE+2)=RGC(1,2); QX(LE+3)=RGC(1,3)#                FE72  28
QX(LE+4)=RGC(2,1); QX(LE+5)=RGC(2,2); QX(LE+6)=RGC(2,3)#                FE72  29
QX(LE+7)=RGC(3,1); QX(LE+8)=RGC(3,2); QX(LE+9)=RGC(3,3)#                FE72  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE72  31
ELSE#                                                                   FE72  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE72  33
GC(1,1)=QX(LD+1); GC(1,2)=QX(LD+2); GC(1,3)=QX(LD+3)#                   FE72  34
GC(2,1)=QX(LD+4); GC(2,2)=QX(LD+5); GC(2,3)=QX(LD+6)#                   FE72  35
GC(3,1)=QX(LD+7); GC(3,2)=QX(LD+8); GC(3,3)=QX(LD+9)#                   FE72  36
#                                                                       FE72  37
RGC(1,1)=QX(LE+1); RGC(1,2)=QX(LE+2); RGC(1,3)=QX(LE+3)#                FE72  38
RGC(2,1)=QX(LE+4); RGC(2,2)=QX(LE+5); RGC(2,3)=QX(LE+6)#                FE72  39
RGC(3,1)=QX(LE+7); RGC(3,2)=QX(LE+8); RGC(3,3)=QX(LE+9)#                FE72  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE72  41
#                                                                       FE72  42
RETURN#                                                                 FE72  43
END#                                                                    FE72  44
systemheader:(FE73)#                   Forming metric tensors           FE73   1
# ################################################################## #  FE73   2
#                                                                    #  FE73   3
#                               FE73                                 #  FE73   4
#                                                                    #  FE73   5
# ################################################################## #  FE73   6
SUBROUTINE FE73(L)#                    H.wang, r.j.barton               FE73   7
#                                      B.e.robertson  jan-1987          FE73   8
include:(AACOMN)#                                                       FE73   9
include:(FECOMN)#                                                       FE73  10
INTEGER L#                                                              FE73  11
#                                                                       FE73  12
IF(L<=MARK1+1)#                                                         FE73  13
##                                    ##                                FE73  14
##      COVARIANT METRIC TENSOR       ##                                FE73  15
##     -------------------------      ##                                FE73  16
##                                    ##                                FE73  17
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE73  18
GC(1,1)=QX(L+1)*QX(L+1)#               A*a                              FE73  19
GC(1,2)=QX(L+1)*QX(L+2)*QX(L+6)#       A*b*cos(gamma)                   FE73  20
GC(1,3)=QX(L+1)*QX(L+3)*QX(L+5)#       A*c*cos(beta)                    FE73  21
GC(2,1)=GC(1,2)#                       B*a*cos(gamma)                   FE73  22
GC(2,2)=QX(L+2)*QX(L+2)#               B*b                              FE73  23
GC(2,3)=QX(L+2)*QX(L+3)*QX(L+4)#       B*c*cos(alpha)                   FE73  24
GC(3,1)=GC(1,3)#                       C*a*cos(beta)                    FE73  25
GC(3,2)=GC(2,3)#                       C*b*cos(alpha)                   FE73  26
GC(3,3)=QX(L+3)*QX(L+3)#               C*c                              FE73  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE73  28
##                                    ##                                FE73  29
##    CONTRAVARIANT METRIC TENSOR     ##                                FE73  30
##   -----------------------------    ##                                FE73  31
##                                    ## RECIPROCAL ...                 FE73  32
ELSE#                                                                   FE73  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE73  34
RGC(1,1)=QX(L+1)*QX(L+1)#              A*a                              FE73  35
RGC(1,2)=QX(L+1)*QX(L+2)*QX(L+6)#      A*b*cos(gamma)                   FE73  36
RGC(1,3)=QX(L+1)*QX(L+3)*QX(L+5)#      A*c*cos(beta)                    FE73  37
RGC(2,1)=RGC(1,2)#                     B*a*cos(gamma)                   FE73  38
RGC(2,2)=QX(L+2)*QX(L+2)#              B*b                              FE73  39
RGC(2,3)=QX(L+2)*QX(L+3)*QX(L+4)#      B*c*cos(alpha)                   FE73  40
RGC(3,1)=RGC(1,3)#                     C*a*cos(beta)                    FE73  41
RGC(3,2)=RGC(2,3)#                     C*b*cos(alpha)                   FE73  42
RGC(3,3)=QX(L+3)*QX(L+3)#              C*c                              FE73  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE73  44
#                                                                       FE73  45
RETURN#                                                                 FE73  46
END#                                                                    FE73  47
systemheader:(FE74)#                   Error matrix of equation         FE74   1
# ################################################################## #  FE74   2
#                                                                    #  FE74   3
#                               FE74                                 #  FE74   4
#                                                                    #  FE74   5
# ################################################################## #  FE74   6
SUBROUTINE FE74(PTS,VALU,KSD)#         H.wang, r.j.barton               FE74   7
#                                      B.e.robertson  jan-1987          FE74   8
include:(AACOMN)#                                                       FE74   9
include:(FECOMN)#                                                       FE74  10
#                                                                       FE74  11
INTEGER I,J,JK,K,KEY,KSD,L,LA,M,PTS(*)#                                 FE74  12
REAL DFUN(4),TEMP,VALU(*),VARA#                                         FE74  13
REAL DIRE(4,9)#                                                         FE74  14
#                                                                       FE74  15
MARK16=STOP13#                                                          FE74  16
CALL FE92(9)#                          Initial v-c matrix               FE74  17
IF(FCOAT==yes:)#                                                        FE74  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE74  19
CALL FE93(PTS(1),PTS(2),0,3,0)#        Retriving correlation            FE74  20
CALL FE93(PTS(1),PTS(3),0,6,1)#        Coefficients of vraiance         FE74  21
CALL FE93(PTS(2),PTS(3),3,6,2)#        And covariance between           FE74  22
#                                      Atom coordinates.....            FE74  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE74  24
ELSE#                                                                   FE74  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE74  26
CALL FE96(PTS(1),0)#                                                    FE74  27
CALL FE96(PTS(2),3)#                                                    FE74  28
CALL FE96(PTS(3),6)#                                                    FE74  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE74  30
#                                                                       FE74  31
J=0#                                                                    FE74  32
DO K=1,3#                                                               FE74  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE74  34
LA=PTS(K)+1#                                                            FE74  35
DO I=1,3#                                                               FE74  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE74  37
LA=LA+1#                                                                FE74  38
TEMP=QX(LA)#                           X (y,z)                          FE74  39
QX(LA)=QX(LA)+0.001#                   X+deltax y+deltay z+deltaz       FE74  40
CALL FE54(PTS,DFUN)#                                                    FE74  41
J=J+1#                                                                  FE74  42
DO M=1,4#                                                               FE74  43
DIRE(M,J)=(DFUN(M)-VALU(M))*1000.0#                                     FE74  44
QX(LA)=TEMP#                                                            FE74  45
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE74  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE74  47
#                                                                       FE74  48
DO I=1,4#                                                               FE74  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE74  50
DO L=I,4#                                                               FE74  51
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE74  52
VARA=0.0#                                                               FE74  53
DO J=1,9#                                                               FE74  54
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE74  55
DO K=1,9#                                                               FE74  56
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  FE74  57
IF(J<K) JK=(2*STEP16-J)*(J-1)/2+K#                                      FE74  58
ELSE    JK=(2*STEP16-K)*(K-1)/2+J#                                      FE74  59
JK=JK+MARK16#                                                           FE74  60
VARA=DIRE(I,J)*QX(JK)*DIRE(L,K)+VARA#                                   FE74  61
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  FE74  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE74  63
KEY=KSD+(8-I)*(I-1)/2+L#                                                FE74  64
QX(KEY)=VARA#                                                           FE74  65
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE74  66
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE74  67
RETURN#                                                                 FE74  68
END#                                                                    FE74  69
systemheader:(FE75)#                   Error matrix of line             FE75   1
# ################################################################## #  FE75   2
#                                                                    #  FE75   3
#                               FE75                                 #  FE75   4
#                                                                    #  FE75   5
# ################################################################## #  FE75   6
SUBROUTINE FE75(PTS,VALU,SA)#          H.wang, r.j.barton               FE75   7
#                                      B.e.robertson  jan-1987          FE75   8
include:(AACOMN)#                                                       FE75   9
include:(FECOMN)#                                                       FE75  10
REAL SA,VALU#                                                           FE75  11
INTEGER PTS#                           This is usefull                  FE75  12
RETURN#                                                                 FE75  13
END#                                                                    FE75  14
systemheader:(FE81)#                   Multiplication of vectors        FE81   1
# ################################################################## #  FE81   2
#                                                                    #  FE81   3
#                               FE81                                 #  FE81   4
#                                                                    #  FE81   5
# ################################################################## #  FE81   6
SUBROUTINE FE81(A,B,C)#                H.wang, r.j.barton               FE81   7
#                                      B.e.robertson jan-87             FE81   8
INTEGER I#                                                              FE81   9
REAL A(3),B(3)#                                                         FE81  10
DOUBLE PRECISION C#                                                     FE81  11
C=0.0D0#                                                                FE81  12
FOR (I=1;I<=3;I=I+1)#                                                   FE81  13
C=C+A(I)*B(I)#                                                          FE81  14
RETURN#                                                                 FE81  15
END#                                                                    FE81  16
systemheader:(FE82)#                   Matrix-vector multiplication     FE82   1
# ################################################################## #  FE82   2
#                                                                    #  FE82   3
#                               FE82                                 #  FE82   4
#                                                                    #  FE82   5
# ################################################################## #  FE82   6
SUBROUTINE FE82(A,B,C)#                H.wang, r.j.barton               FE82   7
#                                      B.e.robertson jan-87             FE82   8
INTEGER I,J#                                                            FE82   9
REAL A(3,3),B(3),C(3),TEMP#                                             FE82  10
DO I=1,3#                                                               FE82  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE82  12
TEMP=0.0#                                                               FE82  13
DO J=1,3#                                                               FE82  14
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE82  15
TEMP=A(I,J)*B(J)+TEMP#                                                  FE82  16
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE82  17
C(I)=TEMP#                                                              FE82  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE82  19
RETURN#                                                                 FE82  20
END#                                                                    FE82  21
systemheader:(FE83)#                   Vector-matrix multiplication     FE83   1
# ################################################################## #  FE83   2
#                                                                    #  FE83   3
#                               FE83                                 #  FE83   4
#                                                                    #  FE83   5
# ################################################################## #  FE83   6
SUBROUTINE FE83(A,B,C)#                H.wang, r.j.barton               FE83   7
#                                      B.e.robertson jan-87             FE83   8
INTEGER I,J#                                                            FE83   9
REAL A(3),B(3,3),C(3),TEMP#                                             FE83  10
DO I=1,3#                                                               FE83  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE83  12
TEMP=0.0#                                                               FE83  13
DO J=1,3#                                                               FE83  14
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE83  15
TEMP=A(J)*B(J,I)+TEMP#                                                  FE83  16
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE83  17
C(I)=TEMP#                                                              FE83  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE83  19
RETURN#                                                                 FE83  20
END#                                                                    FE83  21
systemheader:(FE84)#                   Matrix-matrix multiplication     FE84   1
# ################################################################## #  FE84   2
#                                                                    #  FE84   3
#                               FE84                                 #  FE84   4
#                                                                    #  FE84   5
# ################################################################## #  FE84   6
SUBROUTINE FE84(A,B,C)#                H.wang, r.j.barton               FE84   7
#                                      B.e.robertson jan-87             FE84   8
INTEGER I,J,K#                                                          FE84   9
REAL A(3,3),B(3,3),C(3,3)#                                              FE84  10
FOR (I=1;I<=3;I=I+1)#                                                   FE84  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE84  12
FOR (J=1;J<=3;J=J+1)#                                                   FE84  13
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE84  14
C(I,J)=0.0#                                                             FE84  15
FOR (K=1;K<=3;K=K+1)#                                                   FE84  16
C(I,J)=A(I,K)*B(K,J)+C(I,J)#                                            FE84  17
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE84  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE84  19
RETURN#                                                                 FE84  20
END#                                                                    FE84  21
systemheader:(FE85)#                   Scale products of vectors.       FE85   1
# ################################################################## #  FE85   2
#                                                                    #  FE85   3
#                               FE85                                 #  FE85   4
#                                                                    #  FE85   5
# ################################################################## #  FE85   6
SUBROUTINE FE85(A,B,C,D)#              H.wang, r.j.barton               FE85   7
#                                      B.e.robertson jan-87             FE85   8
INTEGER I,J#                                                            FE85   9
REAL A(3),B(3,*),C(3)#                                                  FE85  10
DOUBLE PRECISION D#                                                     FE85  11
#                                                                       FE85  12
D=0.0D0#                                                                FE85  13
DO I=1,3#                                                               FE85  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE85  15
DO J=1,3#                                                               FE85  16
D=A(J)*B(J,I)*C(I)+D#                                                   FE85  17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE85  18
#                                                                       FE85  19
RETURN#                                                                 FE85  20
END#                                                                    FE85  21
systemheader:(FE86)#                   Vector products                  FE86   1
# ################################################################## #  FE86   2
#                                                                    #  FE86   3
#                               FE86                                 #  FE86   4
#                                                                    #  FE86   5
# ################################################################## #  FE86   6
SUBROUTINE FE86(A,B,C,DET)#            H.wang, r.j.barton               FE86   7
#                                      B.e.robertson  jan-1987          FE86   8
# THIS ROUTINE PRODUCS VECTOR PRODUCT OR TRIPLE SCALAR PRODUCT. THE     FE86   9
# VECTOR PRODUCED IS STORED IN ITS COAVARIANT COMPONETS. THE VECTOR     FE86  10
# OR THE DETERMINAT ARE SCALED PROPERLY BY THE UNIT CELL VOLUMN.        FE86  11
#                                                                       FE86  12
include:(AACOMN)#                                                       FE86  13
include:(FECOMN)#                                                       FE86  14
#                                                                       FE86  15
REAL A(3),B(3),C(3),D(3),DET#                                           FE86  16
#                                                                       FE86  17
D(1)=A(2)*B(3)-A(3)*B(2)#                                               FE86  18
D(2)=A(3)*B(1)-A(1)*B(3)#                                               FE86  19
D(3)=A(1)*B(2)-A(2)*B(1)#                                               FE86  20
#                                                                       FE86  21
IF(DET>0.0)#                                                            FE86  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE86  23
C(1)=D(1)*VOLUMN#                                                       FE86  24
C(2)=D(2)*VOLUMN#                                                       FE86  25
C(3)=D(3)*VOLUMN#                                                       FE86  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE86  27
ELSE#                                                                   FE86  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE86  29
DET=D(1)*C(1)+D(2)*C(2)+D(3)*C(3)#                                      FE86  30
DET=DET*VOLUMN#                                                         FE86  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE86  32
#                                                                       FE86  33
RETURN#                                                                 FE86  34
END#                                                                    FE86  35
systemheader:(FE89)#                                                    FE89   1
# ################################################################## #  FE89   2
#                                                                       FE89   3
#                               FE89                                    FE89   4
#                                                                       FE89   5
# ################################################################## #  FE89   6
SUBROUTINE FE89(A,E,C)#                H.wang, r.j.barton               FE89   7
#                                      B.e.robertson jan-87             FE89   8
INTEGER I#                                                              FE89   9
REAL A(3,*),B1,B2,B3,C(3,*),D,E(*),U1,U2#                               FE89  10
DO I=1,3#                                                               FE89  11
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE89  12
B1=A(1,1)-E(I)#                                                         FE89  13
B2=A(2,2)-E(I)#                                                         FE89  14
B3=A(3,3)-E(I)#                                                         FE89  15
D=B1*B2-A(2,1)*A(1,2)#                                                  FE89  16
IF (D==0.0)#                                                            FE89  17
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE89  18
D=A(2,1)*A(3,2)-A(3,2)*B2#                                              FE89  19
U1=(B2*B3-A(2,3)*A(3,2))/D#                                             FE89  20
U2=(A(3,1)*A(2,3)-A(2,1)*B3)/D#                                         FE89  21
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE89  22
ELSE#                                                                   FE89  23
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE89  24
U1=(A(1,2)*A(2,3)-A(1,3)*B2)/D#                                         FE89  25
U2=(A(1,3)*A(2,1)-A(2,3)*B1)/D#                                         FE89  26
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE89  27
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE89  28
RETURN#                                                                 FE89  29
END#                                                                    FE89  30
systemheader:(FE91)#                                                    FE91   1
# ####################################################################  FE91   2
#                                                                       FE91   3
#                               FE91                                    FE91   4
#                                                                       FE91   5
# ####################################################################  FE91   6
SUBROUTINE FE91(A,B,K)#                                                 FE91   7
#                                      H. wang  1986                    FE91   8
DOUBLE PRECISION A#                                                     FE91   9
REAL   B,C,D,E,SCK,SIG#                                                 FE91  10
INTEGER I#                                                              FE91  11
INTEGER K#                             Pointer to the relative          FE91  12
#                                      Position from "."                FE91  13
SIG=1.0;  SCK=10.0#                                                     FE91  14
IF(B>=0.9500)#                                                          FE91  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE91  16
SCK=0.1;  SIG=-1.0#                                                     FE91  17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE91  18
K=0;  C=1.0000#                                                         FE91  19
#                                                                       FE91  20
DO I=1,12#                                                              FE91  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE91  22
E=B*C#                                                                  FE91  23
D=SIG*(E+0.05)#                                                         FE91  24
IF (D>=SIG) BREAK#                                                      FE91  25
C=C*SCK#                                                                FE91  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE91  27
IF(SIG>0.0)#                                                            FE91  28
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE91  29
K=I#                                                                    FE91  30
A=A+DSIGN(DBLE(0.5/C),A)#                                               FE91  31
B=E#                                                                    FE91  32
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE91  33
ELSE#                                                                   FE91  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE91  35
K=-I+1#                                                                 FE91  36
A=A+DSIGN(0.5D0,A)#                                                     FE91  37
B=B+0.5#                                                                FE91  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE91  39
#                                                                       FE91  40
RETURN#                                                                 FE91  41
END#                                                                    FE91  42
systemheader:(FE92)#                   Initial v-c matrix.              FE92   1
# ################################################################## #  FE92   2
#                                                                    #  FE92   3
#                               FE92                                 #  FE92   4
#                                                                    #  FE92   5
# ################################################################## #  FE92   6
SUBROUTINE FE92(ORDER)#                H.wang, r.j.barton               FE92   7
#                                      B.e.robertson   oct-1986         FE92   8
include:(AACOMN)#                                                       FE92   9
include:(FECOMN)#                                                       FE92  10
#                                                                       FE92  11
INTEGER I,II,ORDER#                                                     FE92  12
#                                                                       FE92  13
STEP16=ORDER#                                                           FE92  14
STOP16=(STEP16+1)*STEP16/2#                                             FE92  15
DO I=1,STOP16; QX(MARK16+I)=0.0#                                        FE92  16
#                                                                       FE92  17
FOR(I=1;I<=STEP16;I=I+1)#                                               FE92  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE92  19
II=(2*STEP16-I)*(I-1)/2+I+MARK16#                                       FE92  20
QX(II)=1.0#                                                             FE92  21
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE92  22
#                                                                       FE92  23
RETURN#                                                                 FE92  24
END#                                                                    FE92  25
systemheader:(FE93)#                                                    FE93   1
# ################################################################## #  FE93   2
#                                                                    #  FE93   3
#                               FE93                                 #  FE93   4
#                                                                    #  FE93   5
# ################################################################## #  FE93   6
SUBROUTINE FE93(NA,NB,KEYA,KEYB,FLAG)# H.wang, r.j.barton               FE93   7
#                                      B.e.robertson   oct-1986         FE93   8
#  FLAG == 0: RETRIEVE VARIANCES AND COVARIANCES OF FIRST AND SECOND    FE93   9
#             ATOMS INCLUDING COVARIANCES BETWEEN TWO ATOMS.            FE93  10
#       == 1: RETRIEVE VARAINCES AND COVARIANCES OF SECOND ATOM AND     FE93  11
#             THE VARIANCES BETWEEN FIRST AND SECOND ATOMS.             FE93  12
#       == 2: RETRIEVE COVARIANCES BETWEEN FIRST AND SECOND ATOMS.      FE93  13
#                                                                       FE93  14
include:(AACOMN)#                                                       FE93  15
include:(FECOMN)#                                                       FE93  16
#                                                                       FE93  17
INTEGER FLAG,KEYA,KEYB,NA,NAB,NB,NBB#                                   FE93  18
#                                                                       FE93  19
NAB=iqx:(NA,11)#                       Block number of atom a           FE93  20
NBB=iqx:(NB,11)#                       Block number of atom b           FE93  21
IF(FLAG<1) CALL FE94(NA,KEYA)#         Retrive v.c. of atom a only      FE93  22
IF(FLAG<2) CALL FE94(NB,KEYB)#         Retrive v.c. of atom b only      FE93  23
IF(NBB==NAB) CALL FE95(NA,NB,KEYA,KEYB)# Retrive covariance between v   FE93  24
#                                      Of atom a and atom b             FE93  25
RETURN#                                                                 FE93  26
END#                                                                    FE93  27
systemheader:(FE94)#                                                    FE94   1
# ################################################################## #  FE94   2
#                                                                    #  FE94   3
#                               FE94                                 #  FE94   4
#                                                                    #  FE94   5
# ################################################################## #  FE94   6
SUBROUTINE FE94(NA,KEY)#               H.wang, r.j.barton               FE94   7
#                                      B.e.robertson   oct-1986         FE94   8
include:(AACOMN)#                                                       FE94   9
include:(FECOMN)#                                                       FE94  10
#                                                                       FE94  11
INTEGER I,II,IJ,J,JJ,K,KEY,L,LI,LJ,LL#                                  FE94  12
INTEGER M,MADS,MI,N,NA,NBAD,NBLK,NSIZ,NVAD,TEMP#                        FE94  13
#                                                                       FE94  14
TEMP=MOD(iqx:(NA,10),8)#                                                FE94  15
DO I=1,3#                                                               FE94  16
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE94  17
K=MOD(TEMP,2)#                         Check for invar type             FE94  18
TEMP=TEMP/2#                                                            FE94  19
L=I+KEY#                                                                FE94  20
LL=(2*STEP16-L)*(L-1)/2+L+MARK16#                                       FE94  21
IF(K<=0) QX(LL)=0.0#                                                    FE94  22
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE94  23
#                                                                       FE94  24
NBLK=iqx:(NA,11)#                                                       FE94  25
NBAD=iqx:(MARK10,2*NBLK)#                                               FE94  26
NBAD=NBAD-1#                                                            FE94  27
NSIZ=iqx:(MARK10,2*NBLK-1)#                                             FE94  28
NVAD=iqx:(NA,9)#                                                        FE94  29
#                                                                       FE94  30
DO I=1,3#                                                               FE94  31
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE94  32
LI=I+KEY#                                                               FE94  33
MI=(2*STEP16-LI)*(LI-1)/2+MARK16#                                       FE94  34
II=MI+LI#                                                               FE94  35
ifne:(QX(II),0.)#                                                       FE94  36
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE94  37
M=NVAD+I-1#                                                             FE94  38
MADS=(2*NSIZ-M)*(M-1)/2+NBAD#                                           FE94  39
QX(II)=QX(MADS+M)#                                                      FE94  40
FOR(J=I+1;J<=3;J=J+1)#                 Loop over coords                 FE94  41
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE94  42
LJ=J+KEY#                                                               FE94  43
JJ=(2*STEP16-LJ)*(LJ-1)/2+LJ+MARK16#                                    FE94  44
ifne:(QX(JJ),0.)#                                                       FE94  45
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE94  46
N=NVAD+J-1#                                                             FE94  47
IJ=MI+LJ#                                                               FE94  48
QX(IJ)=QX(MADS+N)#                                                      FE94  49
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE94  50
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE94  51
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE94  52
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE94  53
RETURN#                                                                 FE94  54
END#                                                                    FE94  55
systemheader:(FE95)#                                                    FE95   1
# ################################################################## #  FE95   2
#                                                                    #  FE95   3
#                               FE95                                 #  FE95   4
#                                                                    #  FE95   5
# ################################################################## #  FE95   6
SUBROUTINE FE95(NA,NB,KEYA,KEYB)#      H.wang, r.j.barton               FE95   7
#                                      B.e.robertson   oct-1986         FE95   8
include:(AACOMN)#                                                       FE95   9
include:(FECOMN)#                                                       FE95  10
#                                                                       FE95  11
INTEGER I,IA,IB,II,IJ,J,JJ,KEYA,KEYB,M,N,NA,NADS,NB,NBAD,NBLK,NSIZ#     FE95  12
REAL TEMP#                                                              FE95  13
NBLK=iqx:(NA,11)#                                                       FE95  14
NBAD=iqx:(MARK10,2*NBLK)#                                               FE95  15
NBAD=NBAD-1#                                                            FE95  16
NSIZ=iqx:(MARK10,2*NBLK-1)#                                             FE95  17
#                                                                       FE95  18
IA=iqx:(NA,9)#                         Pointer of first para            FE95  19
IB=iqx:(NB,9)#                         Pointer of first para            FE95  20
DO I=KEYA+1,KEYA+3#                                                     FE95  21
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE95  22
II=(2*STEP16-I)*(I-1)/2+I+MARK16#                                       FE95  23
DO J=KEYB+1,KEYB+3#                                                     FE95  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE95  25
JJ=(2*STEP16-J)*(J-1)/2+J+MARK16#                                       FE95  26
TEMP=(QX(II)*QX(JJ))#                                                   FE95  27
ifne:(TEMP,0.)#                                                         FE95  28
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE95  29
M=IA+I-KEYA-1#                                                          FE95  30
N=IB+J-KEYB-1#                                                          FE95  31
IF(IA<IB) NADS=(2*NSIZ-M)*(M-1)/2+N#                                    FE95  32
ELSE      NADS=(2*NSIZ-N)*(N-1)/2+M#                                    FE95  33
NADS=NADS+NBAD#                                                         FE95  34
IJ=(2*STEP16-I)*(I-1)/2+J+MARK16#                                       FE95  35
QX(IJ)=QX(NADS)#                                                        FE95  36
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE95  37
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE95  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE95  39
#                                                                       FE95  40
RETURN#                                                                 FE95  41
END#                                                                    FE95  42
systemheader:(FE96)#                   Extract variance of atom par     FE96   1
# ################################################################## #  FE96   2
#                                                                    #  FE96   3
#                               FE96                                 #  FE96   4
#                                                                    #  FE96   5
# ################################################################## #  FE96   6
SUBROUTINE FE96(NA,KEYA)#              H.wang, r.j.barton               FE96   7
#                                      B.e.robertson   aug-1987         FE96   8
include:(AACOMN)#                                                       FE96   9
include:(FECOMN)#                                                       FE96  10
#                                                                       FE96  11
INTEGER I,KEYA,L,NA#                                                    FE96  12
FOR(I=1;I<=3;I=I+1)#                                                    FE96  13
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE96  14
L=I+KEYA#                                                               FE96  15
L=(2*STEP16-L)*(L-1)/2+L+MARK16#                                        FE96  16
QX(L)=QX(NA+I+4)*QX(NA+I+4)#                                            FE96  17
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE96  18
RETURN#                                                                 FE96  19
END#                                                                    FE96  20
systemheader:(FE97)#                                                    FE97   1
# ################################################################## #  FE97   2
#                                                                    #  FE97   3
#                               FE97                                 #  FE97   4
#                                                                    #  FE97   5
# FLAG : 0 -- ATOM ARRAY.                                               FE97   6
#        1 -- ATOM AND LINE ARRAYS.                                     FE97   7
#        2 -- ATOM AND PLANE ARRAYS.                                    FE97   8
#       -1 -- LINE ARRAYS ONLY.                                         FE97   9
#       -2 -- PLANE ARRAYS ONLY.                                        FE97  10
#                                                                       FE97  11
# ####################################################################  FE97  12
SUBROUTINE FE97(DNAME,KEY,FLAG)#       H.wang, r.j.barton               FE97  13
#                                      B.e.robertson   oct-1986         FE97  14
include:(AACOMN)#                                                       FE97  15
include:(FECOMN)#                                                       FE97  16
#                                                                       FE97  17
string:(DNAME,*)#                                                       FE97  18
string:(SNAME,24)#                                                      FE97  19
INTEGER I,KEY,FLAG#                                                     FE97  20
#                                                                       FE97  21
IF(FLAG>=0)#                                                            FE97  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  FE97  23
FOR(I=MARK5+la:;I<=STOP5;I=I+STEP5)#   Searching...                     FE97  24
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  FE97  25
movertoc:(QX(I),1,SNAME,1,24,0)#                                        FE97  26
IF(DNAME==SNAME) BREAK#                Exit if names match              FE97  27
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  FE97  28
IF(I<=STOP5)#                                                           FE97  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  FE97  30
KEY=I-19; FLAG=0; RETURN#                                               FE97  31
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  FE97  32
ELSE IF(FLAG==0) iquit:(FE9701)#                                        FE97  33
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  FE97  34
#                                                                       FE97  35
IF(ABS(FLAG)==1)#                      Search for line                  FE97  36
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  FE97  37
FOR(I=MARK13+1;I<STOP13;I=I+STEP13)#                                    FE97  38
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  FE97  39
movertoc:(QX(I),1,SNAME,1,24,0)#                                        FE97  40
IF(DNAME==SNAME) BREAK#                Exit if names match              FE97  41
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  FE97  42
IF(I>STOP13) iquit:(FE9702)#                                            FE97  43
KEY=I+name:#                                                            FE97  44
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  FE97  45
#                                                                       FE97  46
IF(ABS(FLAG)==2)#                      Search for plane                 FE97  47
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  FE97  48
FOR(I=MARK12;I<STOP12;I=I+STEP12)#                                      FE97  49
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  FE97  50
movertoc:(QX(I),1,SNAME,1,24,0)#                                        FE97  51
IF(DNAME==SNAME) BREAK#                Exit if names match              FE97  52
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  FE97  53
IF(I>STOP12) iquit:(FE9703)#                                            FE97  54
KEY=I+name:#                                                            FE97  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  FE97  56
#                                                                       FE97  57
RETURN#                                                                 FE97  58
END#                                                                    FE97  59
systemheader:(FE98)#                   Cell constant inversion          FE98   1
# ################################################################## #  FE98   2
#                                                                    #  FE98   3
#                               FE98                                 #  FE98   4
#                                                                    #  FE98   5
# ################################################################## #  FE98   6
SUBROUTINE FE98(L2,M2)#                H.wang, r.j.barton               FE98   7
#                                      B.e.robertson   oct-1986         FE98   8
include:(AACOMN)#                                                       FE98   9
include:(FECOMN)#                                                       FE98  10
#                                                                       FE98  11
INTEGER L2,M2#                                                          FE98  12
REAL SALPHA,SBETA,SGAMMA#                                               FE98  13
SALPHA=SIN(QX(L2+7)*DTOR)#             Sin(alpha)                       FE98  14
SBETA=SIN(QX(L2+8)*DTOR)#              Sin(beta)                        FE98  15
SGAMMA=SIN(QX(L2+9)*DTOR)#             Sin(gamma)                       FE98  16
QX(M2+1)=QX(L2+2)*QX(L2+3)*SALPHA/VOLUMN# A*                            FE98  17
QX(M2+2)=QX(L2+3)*QX(L2+1)*SBETA/VOLUMN# B*                             FE98  18
QX(M2+3)=QX(L2+1)*QX(L2+2)*SGAMMA/VOLUMN# C*                            FE98  19
QX(M2+4)=(QX(L2+5)*QX(L2+6)-QX(L2+4))/(SBETA*SGAMMA)# Cos(alpha*)       FE98  20
QX(M2+5)=(QX(L2+6)*QX(L2+4)-QX(L2+5))/(SGAMMA*SALPHA)# Cos(alpha*)      FE98  21
QX(M2+6)=(QX(L2+4)*QX(L2+5)-QX(L2+6))/(SALPHA*SBETA)# Cos(alpha*)       FE98  22
QX(M2+7)=ACOS(QX(M2+4))*RTOD#          Alpha*                           FE98  23
QX(M2+8)=ACOS(QX(M2+5))*RTOD#          Beta*                            FE98  24
QX(M2+9)=ACOS(QX(M2+6))*RTOD#          Gamma*                           FE98  25
#                                                                       FE98  26
RETURN#                                                                 FE98  27
END#                                                                    FE98  28
pmacro:([no:])#                                                         FE98  29
