systemheader:(PX    )#                                                  PX     1
####################################################################    PX     2
##      Copyright (C) 2000, The Xtal System, The University of        # PX     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # PX     4
## Distributed under the GNU General Public Licence as published by   # PX     5
## the Free Software Foundation, in the hope that it will be useful   # PX     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # PX     7
## for more details.                                                  # PX     8
##                                                                 #    PX     9
##                        *** PLOTX ***                            #    PX    10
##                                                                 #    PX    11
## PLOTX is a graphical output routine which reads the plot data   #    PX    12
## from files generated by programs such as ORTEP, CONTRS, etc.    #    PX    13
## PLOTX uses either internal plot routines such as HPGL, POST,    #    PX    14
## etc., or external libraries such as GKS or Xlib, to produce     #    PX    15
## static graphical images, on hardcopy or screen devices.         #    PX    16
##                                                                 #    PX    17
####################################################################    PX    18
##                                                                      PX    19
include:(XMACRO)#                                                       PX    20
##                                                                      PX    21
## >>>>>>>>>                                        <<<<<<<<<<<<<<      PX    22
## >>>>>>>>> Installers PLEASE read this carefully! <<<<<<<<<<<<<<      PX    23
## >>>>>>>>>                                        <<<<<<<<<<<<<<      PX    24
##                                                                      PX    25
## PLOTX allows the user to select one of 12 output devices. These      PX    26
## devices are specified separately on installation using a sequence    PX    27
## of device dependent macros. PLOTX is supplied with macros for the    PX    28
## most commonly used devices installed. Additional definitions are     PX    29
## supplied in a library at the rear of this file.                      PX    30
##                                                                      PX    31
## The installer must first specify if the GKS and X11 libraries are    PX    32
## available locally, and whether they will be used on the target       PX    33
## processor. For example, if X windows is used on local screen devices PX    34
## x11: should be set to yes: and gks: set to no:. If X is not used the PX    35
## reverse may be true. On some machines both or none will be needed.   PX    36
##                                                                      PX    37
## The installer must then make sure that the installed macro sets are  PX    38
## appropriate for the grahical devices (screen and hardcopy) available PX    39
## The names of the installed devices (defined as dcodeN:) will need to PX    40
## be entered into the Xtal User's Guide.                               PX    41
##                                                                      PX    42
## -------------------------------------------------------------------- PX    43
##                                                                      PX    44
##                                                                      PX    45
##              LOCALLY USED GRAPHICS LIBRARIES                         PX    46
##              -------------------------------                         PX    47
##                                                                      PX    48
macro:(gks:,no:)## Signal application of graphics kernal system         PX    49
macro:(x11:,yes:)#                     Signal application of x window   PX    50
##                                                                      PX    51
## -------------------------------------------------------------------- PX    52
##                                                                      PX    53
##                                                                      PX    54
##             CURRENTLY INSTALLED GRAPHICAL DEVICES                    PX    55
##             -------------------------------------                    PX    56
##                                                                      PX    57
##                                                                      PX    58
## ++++++++++++++++ Define graphical device 2 ++++++++++++++++++++++++  PX    59
##                                                                      PX    60
##  X Window System Version 11 interface                                PX    61
##                                                                      PX    62
macro:(dcode2:,X11LIB)#                Local device name                PX    63
macro:(xmaxw2:,1.)#                    Plot width  (x) in units         PX    64
macro:(ymaxh2:,1.)#                    Plot height (y) in units         PX    65
macro:(xpixl2:,1000.)#                 Pixels per unit along x          PX    66
macro:(ypixl2:,1000.)#                 Pixels per unit along y          PX    67
macro:(buffr2:,1000)#                  Qx buffer size for plot          PX    68
macro:(color2:,yes:)#                  Is colour supported              PX    69
macro:(start2:,x11open:)#              Initialize the output dev        PX    70
macro:(frame2:,x11wait:)#              Start a new plot frame           PX    71
macro:(plotp2:,x11line:($1,$2,$3))#    Plot x,y coordinates             PX    72
macro:(areap2:,x11area:($1,$2,$3))#    Fill area x,y coordinates        PX    73
macro:(nupen2:,x11index:($1,$2))#      Change colour of plot            PX    74
macro:(ptext2:,noop:)#                 Draw characters                  PX    75
macro:(colmp2:,x11colmap:($1,$2,$3,$4))# Amend colormap                 PX    76
macro:(finis2:,x11close:)#             Finish the plot                  PX    77
macro:(marker2:,x11mark:)#             Markers                          PX    78
##                                                                      PX    79
##                                                                      PX    80
## ++++++++++++++++ Define graphical device 3 ++++++++++++++++++++++++  PX    81
##                                                                      PX    82
##  Hewlett-Packard Graphics Language File (A3 landscape)               PX    83
##                                                                      PX    84
macro:(dcode3:,HPGL  )#                Local device name                PX    85
macro:(xmaxw3:,15.)#                   Plot width  (x) in units         PX    86
macro:(ymaxh3:,10.)#                   Plot height (y) in units         PX    87
macro:(xpixl3:,1000.)#                 Pixels per unit along x          PX    88
macro:(ypixl3:,1000.)#                 Pixels per unit along y          PX    89
macro:(buffr3:,1000)#                  Qx buffer size for plot          PX    90
macro:(color3:,yes:)#                  Is color supported               PX    91
macro:(start3:,CALL HPGL(1,3,0,0))#    Initialize the output            PX    92
macro:(frame3:,CALL HPGL(2,1,0,0))#    Start a new plot frame           PX    93
macro:(plotp3:,CALL HPGL(3,$3,$1,$2))# Plot x,y coordinates             PX    94
macro:(areap3:,noop:)#                 Fill area of x,y coordinates     PX    95
macro:(nupen3:,CALL HPGL(4,$1,0,0))#   Change the plot colour           PX    96
macro:(ptext3:,noop:)#                 Draw characters                  PX    97
macro:(colmp3:,noop:)#                 Amend colormap                   PX    98
macro:(finis3:,CALL HPGL(5,0,0,0))#    Finish the plot output           PX    99
macro:(marker3:,noop:)#                Markers                          PX   100
##                                                                      PX   101
##                                                                      PX   102
## ++++++++++++++++ Define graphical device 4 ++++++++++++++++++++++++  PX   103
##                                                                      PX   104
##  Postscript devices - landscape orientation (POST supplied)          PX   105
##                                                                      PX   106
macro:(dcode4:,POSTL )#                Local device name                PX   107
macro:(xmaxw4:,11.)#                   Plot width  (x) in units         PX   108
macro:(ymaxh4:,8.5)#                   Plot height (y) in units         PX   109
macro:(xpixl4:,300.)#                  Pixels per unit along x          PX   110
macro:(ypixl4:,300.)#                  Pixels per unit along y          PX   111
macro:(buffr4:,1000)#                  Qx buffer size for plot          PX   112
macro:(color4:,no:)#                   Is color supported               PX   113
macro:(start4:,CALL POST(1,1,0.,0.,0.,0.,0,' ',0,0))# Initialize        PX   114
macro:(frame4:,CALL POST(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot    PX   115
macro:(plotp4:,CALL POST(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y       PX   116
macro:(areap4:,CALL POST(8,$3,0.,0.,0.,0.,0,' ',$1,$2))# Fill area      PX   117
macro:(nupen4:,CALL POST(4,$1,0.,0.,0.,0.,0,' ',0,$2))# Change colour   PX   118
macro:(ptext4:,CALL POST(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars       PX   119
macro:(colmp4:,CALL POST(7,$4,$1,$2,$3,0.,0,' ',0,0))# Amend colormap   PX   120
macro:(finis4:,CALL POST(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot       PX   121
macro:(marker4:,CALL POST(11,0,0.,0.,0.,0.,0,' ',0,0))# Markers         PX   122
##                                                                      PX   123
##                                                                      PX   124
## ++++++++++++++++ Define graphical device 5 ++++++++++++++++++++++++  PX   125
##                                                                      PX   126
##  Sun GKS commands for Sunview platform.                              PX   127
##                                                                      PX   128
macro:(dcode5:,SUNGKS)#                Local device name (6chrs)        PX   129
macro:(xmaxw5:,1.)#                    Plot width  (x) in units         PX   130
macro:(ymaxh5:,1.)#                    Plot height (y) in units         PX   131
macro:(xpixl5:,1000.)#                 Pixels per unit along x          PX   132
macro:(ypixl5:,1000.)#                 Pixels per unit along y          PX   133
macro:(buffr5:,1000)#                  Qx buffer size for plot          PX   134
macro:(color5:,yes:)#                  Is color supported               PX   135
macro:(start5:,[$(confgks:(4);gksopen:(0,4)$)])# Initialize output      PX   136
macro:(frame5:,[gkswait:(1)])#         Start a new plot frame           PX   137
macro:(plotp5:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             PX   138
macro:(areap5:,noop:)#                 Fill area of x,y coordinates     PX   139
macro:(nupen5:,gksindex:($1))#         Color index for polyline         PX   140
macro:(ptext5:,noop:)#                 Draw characters                  PX   141
macro:(colmp5:,noop:)#                 Amend colormap                   PX   142
macro:(finis5:,[gksclose:])#           Finish the plot output           PX   143
macro:(marker5:,noop:)#                Markers                          PX   144
##                                                                      PX   145
##                                                                      PX   146
## ++++++++++++++++ Define graphical device 6 ++++++++++++++++++++++++  PX   147
##                                                                      PX   148
##  Postscript devices - portrait orientation (POST supplied)           PX   149
##                                                                      PX   150
macro:(dcode6:,POSTP )#                Local device name                PX   151
macro:(xmaxw6:,8.5)#                   Plot width  (x) in units         PX   152
macro:(ymaxh6:,11.)#                   Plot height (y) in units         PX   153
macro:(xpixl6:,300.)#                  Pixels per unit along x          PX   154
macro:(ypixl6:,300.)#                  Pixels per unit along y          PX   155
macro:(buffr6:,1000)#                  Qx buffer size for plot          PX   156
macro:(color6:,no:)#                   Is color supported               PX   157
macro:(start6:,CALL POST(1,0,0.,0.,0.,0.,0,' ',0,0))# Initialize        PX   158
macro:(frame6:,CALL POST(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot    PX   159
macro:(plotp6:,CALL POST(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y       PX   160
macro:(areap6:,CALL POST(8,$3,0.,0.,0.,0.,0,' ',$1,$2))# Fill area      PX   161
macro:(nupen6:,CALL POST(4,$1,0.,0.,0.,0.,0,' ',0,$2))# Change colour   PX   162
macro:(ptext6:,CALL POST(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars       PX   163
macro:(colmp6:,CALL POST(7,$4,$1,$2,$3,0.,0,' ',0,0))# Amend colormap   PX   164
macro:(finis6:,CALL POST(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot       PX   165
macro:(marker6:,CALL POST(11,0,0.,0.,0.,0.,0,' ',0,0))# Markers         PX   166
##                                                                      PX   167
##                                                                      PX   168
## ++++++++++++++++ Define graphical device 7 ++++++++++++++++++++++++  PX   169
##                                                                      PX   170
##  HPGL A4 scale (output to *.hp)                                      PX   171
##                                                                      PX   172
macro:(dcode7:,HPGLA4)#                Local device name (6chrs)        PX   173
macro:(xmaxw7:,10.5)#                  Plot width  (x) in units         PX   174
macro:(ymaxh7:, 7.5)#                  Plot height (y) in units         PX   175
macro:(xpixl7:,1000.)#                 Pixels per unit along x          PX   176
macro:(ypixl7:,1000.)#                 Pixels per unit along y          PX   177
macro:(buffr7:,1000)#                  Qx buffer size for plot          PX   178
macro:(color7:,yes:)#                  Is color supported               PX   179
macro:(start7:,CALL HPGL(1,4,0,0))#    Initialize the output            PX   180
macro:(frame7:,CALL HPGL(2,1,0,0))#    Start a new plot frame           PX   181
macro:(plotp7:,CALL HPGL(3,$3,$1,$2))# Plot x,y coordinates             PX   182
macro:(areap7:,noop:)#                 Fill area of x,y coordinates     PX   183
macro:(nupen7:,CALL HPGL(4,$1,0,0))#   Change the plot colour           PX   184
macro:(ptext7:,noop:)#                 Draw characters                  PX   185
macro:(colmp7:,noop:)#                 Amend colormap                   PX   186
macro:(finis7:,CALL HPGL(5,0,0,0))#    Finish the plot output           PX   187
macro:(marker7:,noop:)#                Markers                          PX   188
##                                                                      PX   189
##                                                                      PX   190
## ++++++++++++++++ Define graphical device 8 ++++++++++++++++++++++++  PX   191
##                                                                      PX   192
##  Mathematica file (output to *.mat)                                  PX   193
##                                                                      PX   194
macro:(dcode8:,MATHL )#                Local device name (6chrs)        PX   195
macro:(xmaxw8:,10.)#                   Plot width  (x) in units         PX   196
macro:(ymaxh8:,10.)#                   Plot height (y) in units         PX   197
macro:(xpixl8:,300.)#                  Pixels per unit along x          PX   198
macro:(ypixl8:,300.)#                  Pixels per unit along y          PX   199
macro:(buffr8:,1000)#                  Qx buffer size for plot          PX   200
macro:(color8:,yes:)#                  Is color supported               PX   201
macro:(start8:,CALL MATH(1,1,0,0))#    Initialize the output            PX   202
macro:(frame8:,CALL MATH(2,1,0,0))#    Start a new plot frame           PX   203
macro:(plotp8:,CALL MATH(3,$3,$1,$2))# Plot x,y coordinates             PX   204
macro:(areap8:,noop:)#                 Fill area of x,y coordinates     PX   205
macro:(nupen8:,noop:)#                 Change the plot colour           PX   206
macro:(ptext8:,noop:)#                 Print characters                 PX   207
macro:(colmp8:,noop:)#                 Amend colormap                   PX   208
macro:(finis8:,CALL MATH(5,0,0,0))#    Finish the plot output           PX   209
macro:(marker8:,noop:)#                Markers                          PX   210
##                                                                      PX   211
##                                                                      PX   212
## ++++++++++++++++ Define graphical device 9 ++++++++++++++++++++++++  PX   213
##                                                                      PX   214
##  Postscript - landscape orientation colour (POST supplied)           PX   215
##                                                                      PX   216
macro:(dcode9:,POSTLC)#                Local device name                PX   217
macro:(xmaxw9:,11.)#                   Plot width  (x) in units         PX   218
macro:(ymaxh9:,8.5)#                   Plot height (y) in units         PX   219
macro:(xpixl9:,300.)#                  Pixels per unit along x          PX   220
macro:(ypixl9:,300.)#                  Pixels per unit along y          PX   221
macro:(buffr9:,1000)#                  Qx buffer size for plot          PX   222
macro:(color9:,yes:)#                  Is color supported               PX   223
macro:(start9:,CALL POST(1,1,0.,0.,0.,0.,0,' ',0,0))# Initialize        PX   224
macro:(frame9:,CALL POST(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot    PX   225
macro:(plotp9:,CALL POST(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y       PX   226
macro:(nupen9:,CALL POST(4,$1,0.,0.,0.,0.,0,' ',0,$2))# Change colour   PX   227
macro:(finis9:,CALL POST(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot       PX   228
macro:(ptext9:,CALL POST(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars       PX   229
macro:(colmp9:,CALL POST(7,$4,$1,$2,$3,0.,0,' ',0,0))# Amend colormap   PX   230
macro:(areap9:,CALL POST(8,$3,0.,0.,0.,0.,0,' ',$1,$2))# Fill area      PX   231
macro:(marker9:,CALL POST(11,0,0.,0.,0.,0.,0,' ',0,0))# Markers         PX   232
##                                                                      PX   233
##                                                                      PX   234
## ++++++++++++++++ Define graphical device 10 ++++++++++++++++++++++++ PX   235
##                                                                      PX   236
##  Postscript - portrait orientation colour (POST supplied)            PX   237
##                                                                      PX   238
macro:(dcode10:,POSTPC)#               Local device name                PX   239
macro:(xmaxw10:,8.5)#                  Plot width  (x) in units         PX   240
macro:(ymaxh10:,11.)#                  Plot height (y) in units         PX   241
macro:(xpixl10:,300.)#                 Pixels per unit along x          PX   242
macro:(ypixl10:,300.)#                 Pixels per unit along y          PX   243
macro:(buffr10:,1000)#                 Qx buffer size for plot          PX   244
macro:(color10:,yes:)#                 Is color supported               PX   245
macro:(start10:,CALL POST(1,0,0.,0.,0.,0.,0,' ',0,0))# Initialize       PX   246
macro:(frame10:,CALL POST(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot   PX   247
macro:(plotp10:,CALL POST(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y      PX   248
macro:(nupen10:,CALL POST(4,$1,0.,0.,0.,0.,0,' ',0,$2))# Change colou   PX   249
macro:(finis10:,CALL POST(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot      PX   250
macro:(ptext10:,CALL POST(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars      PX   251
macro:(colmp10:,CALL POST(7,$4,$1,$2,$3,0.,0,' ',0,0))# Amend colorma   PX   252
macro:(areap10:,CALL POST(8,$3,0.,0.,0.,0.,0,' ',$1,$2))# Fill area     PX   253
macro:(marker10:,CALL POST(11,0,0.,0.,0.,0.,0,' ',0,0))# Markers        PX   254
##                                                                      PX   255
##                                                                      PX   256
## ++++++++++++++++ Define graphical device 11 ++++++++++++++++++++++++ PX   257
##                                                                      PX   258
##  Black & White X-Window workstation using Xelion-GKS.                PX   259
##                                                                      PX   260
macro:(dcode11:,X-WDBW)#               Local device name                PX   261
macro:(xmaxw11:,1.)#                   Plot width  (x) in units         PX   262
macro:(ymaxh11:,1.)#                   Plot height (y) in units         PX   263
macro:(xpixl11:,1000.)#                Pixels per unit along x          PX   264
macro:(ypixl11:,1000.)#                Pixels per unit along y          PX   265
macro:(buffr11:,1000)#                 Qx buffer size for plot          PX   266
macro:(color11:,no:)#                  Is color supported               PX   267
macro:(start11:,[$(gksopen:(41,146);confgks:$)])# Initialize the outp   PX   268
macro:(frame11:,[gkswait:(1)])#        Start a new plot frame           PX   269
macro:(plotp11:,[gksline:($1,$2,$3)])# Plot x,y coordinates             PX   270
macro:(areap11:,[gksarea:($1,$2,$3)])# Fill area of x,y coordinates     PX   271
macro:(nupen11:,[gkscolor:($1,$2)])#   Color index for polyline         PX   272
macro:(ptext11:,noop:)#                Draw characters                  PX   273
macro:(colmp11:,noop:)#                Amend colormap                   PX   274
macro:(finis11:,[gksclose:])#          Finish the plot output           PX   275
macro:(marker11:,noop:)#               No markers here                  PX   276
##                                                                      PX   277
##                                                                      PX   278
## ++++++++++++++++ Define graphical device 12 ++++++++++++++++++++++++ PX   279
##                                                                      PX   280
##  OS/2 2.x Presentation Manager using VREXX                           PX   281
##                                                                      PX   282
macro:(dcode12:,OS2PM )#               Local device name                PX   283
macro:(xmaxw12:,1.)#                   Plot width  (x) in units         PX   284
macro:(ymaxh12:,1.)#                   Plot height (y) in units         PX   285
macro:(xpixl12:,1000.)#                Pixels per unit along x          PX   286
macro:(ypixl12:,1000.)#                Pixels per unit along y          PX   287
macro:(buffr12:,1000)#                 Qx buffer size for plot          PX   288
macro:(color12:,yes:)#                 Is color supported               PX   289
macro:(start12:,CALL OS2PM(1,0,0,0,0))# Initialize                      PX   290
macro:(frame12:,CALL OS2PM(2,0,0,0,0))# Start a new plot frame          PX   291
macro:(plotp12:,CALL OS2PM(3,$1,$2,$3,$4))# Plot x,y coordinates        PX   292
macro:(areap12:,CALL OS2PM(4,$1,$2,$3,$4))# Fill area of x,y coordina   PX   293
macro:(nupen12:,noop:)#                Color index for polyline         PX   294
macro:(ptext12:,noop:)#                Draw characters                  PX   295
macro:(colmp12:,noop:)#                Amend colormap                   PX   296
macro:(marker12:,noop:)#               No markers here                  PX   297
macro:(finis12:,CALL OS2PM(5,0,0,0,0))# Finish the plot output          PX   298
##                                                                      PX   299
macro:(dcode13:,XFIGL )#               Local device name                PX   300
macro:(xmaxw13:,11.)#                  Plot width  (x) in units         PX   301
macro:(ymaxh13:,8.5)#                  Plot height (y) in units         PX   302
macro:(xpixl13:,300.)#                 Pixels per unit along x          PX   303
macro:(ypixl13:,300.)#                 Pixels per unit along y          PX   304
macro:(buffr13:,1000)#                 Qx buffer size for plot          PX   305
macro:(color13:,yes:)#                 Is color supported               PX   306
macro:(start13:,CALL XFIG(1,1,0.,0.,0.,0.,0,' ',0,0))# Initialize       PX   307
macro:(frame13:,CALL XFIG(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot   PX   308
macro:(plotp13:,CALL XFIG(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y      PX   309
macro:(nupen13:,CALL XFIG(4,$1,0.,0.,0.,0.,0,' ',0,$2))# Change colou   PX   310
macro:(finis13:,CALL XFIG(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot      PX   311
macro:(ptext13:,CALL XFIG(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars      PX   312
macro:(colmp13:,CALL XFIG(7,$4,$1,$2,$3,$5,0,' ',0,0))# Amend colorma   PX   313
macro:(areap13:,CALL XFIG(8,$3,0.,0.,0.,0.,0,' ',$1,$2))# Fill area     PX   314
macro:(marker13:,CALL XFIG(11,0,0.,0.,0.,0.,0,' ',0,0))# Markers        PX   315
##                                                                      PX   316
macro:(dcode14:,XFIG  )#               Local device name                PX   317
macro:(ymaxh14:,8.5)#                  Plot height (y) in units         PX   318
macro:(xmaxw14:,11.)#                  Plot width  (x) in units         PX   319
macro:(xpixl14:,300.)#                 Pixels per unit along x          PX   320
macro:(ypixl14:,300.)#                 Pixels per unit along y          PX   321
macro:(buffr14:,1000)#                 Qx buffer size for plot          PX   322
macro:(color14:,yes:)#                 Is color supported               PX   323
macro:(start14:,CALL XFIG(1,1,0.,0.,0.,0.,0,' ',0,0))# Initialize       PX   324
macro:(frame14:,CALL XFIG(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot   PX   325
macro:(plotp14:,CALL XFIG(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y      PX   326
macro:(nupen14:,CALL XFIG(4,$1,0.,0.,0.,0.,0,' ',0,$2))# Change colou   PX   327
macro:(finis14:,CALL XFIG(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot      PX   328
macro:(ptext14:,CALL XFIG(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars      PX   329
macro:(colmp14:,CALL XFIG(7,$4,$1,$2,$3,$5,0,' ',0,0))# Amend colorma   PX   330
macro:(areap14:,CALL XFIG(8,$3,0.,0.,0.,0.,0,' ',$1,$2))# Fill area     PX   331
macro:(marker14:,CALL XFIG(11,0,0.,0.,0.,0.,0,' ',0,0))# Markers        PX   332
##                                                                      PX   333
## -------------------------------------------------------------------- PX   334
##                                                                      PX   335
##                                                                      PX   336
##           DEFAULT DEVICE AND SCREEN CONFIGURATION                    PX   337
##           ---------------------------------------                    PX   338
##                                                                      PX   339
##                                                                      PX   340
## The definition of the macro defdevice: enables the default output    PX   341
## device (as installed above) to be set. This device will be used      PX   342
## when the user does not enter a recognised dcodeN: string on the      PX   343
## PLOTX line. Note that defdevice: will be defined automatically for   PX   344
## each compiler type (e.g. UNXsun, etc.). Check carefully that this    PX   345
## value is going to be applicable at your site and with your device    PX   346
## macro definitions.                                                   PX   347
##                                                                      PX   348
## The macros confgks: and gksconf: are used to configure the default   PX   349
## windows under GKS. These will be null macros under X11.              PX   350
##                                                                      PX   351
##                                                                      PX   352
ifsel:(UNXSUN)#                                                         PX   353
macro:(defdevice:,2)#                  Default screen is x11            PX   354
macro:(confgks:,ifelse:(gks:,0,noop:,[$(#                               PX   355
CALL GOPCFG($1,IDCFG)#                 Get the configuration id         PX   356
CALL GSCFG(IDCFG,  2,  0)#             Set message window lines         PX   357
CALL GSCFG(IDCFG,  6,  0)#             Set text window                  PX   358
CALL GSCFG(IDCFG,  7,  0)#             Set panel                        PX   359
CALL GSCFG(IDCFG, 10,870)#             Set window x width               PX   360
CALL GSCFG(IDCFG, 11,870)#             Set window y height              PX   361
CALL GSCFG(IDCFG, 12,  0)#             Set window x position            PX   362
CALL GSCFG(IDCFG, 13,  0)#             Set window y position            PX   363
CALL GSCFG(IDCFG, 14,' ')#             Blank window header              PX   364
CALL GCLCFG(IDCFG)#                    Install configuration id         PX   365
CALL GDCFG(IDCFG)$)]))#                Destroy config copy              PX   366
macro:(gksconf:,noop:)#                                                 PX   367
##                                                                      PX   368
ifsel:(UNXDEC,UNXULT,VMS)#                                              PX   369
macro:(defdevice:,2)#                  Default screen is x11            PX   370
macro:(confgks:,ifelse:(gks:,0,noop:,[$(#                               PX   371
CALL GSWN(1,0.0,1.02,0.0,1.02)#        Set window                       PX   372
CALL GSVP(1,0.0,1.0,0.0,1.0)#          Set viewport                     PX   373
CALL GSELNT(1)#                        Select normalization tranform.   PX   374
CALL GSCHH(0.0008)#                    Set character height             PX   375
CALL GSCHSP(-0.03)$)]))#               Set character spacing            PX   376
macro:(gksconf:,noop:)#                                                 PX   377
#                                                                       PX   378
#MACRO:(CONFGKS:,IFELSE:(GKS:,0,NOOP:,# SET XELION GKS  WINDOW          PX   379
#[CALL GSWKWN(1,0.,AWIDE,0.,AHIGH)]))#  SET OPTIMAL SURFACE             PX   380
#MACRO:(GKSCONF:,IFELSE:(GKS:,0,NOOP:,# XELION ERROR MESSAGE FILE       PX   381
#[$(FILEXT(99)='GKR';OPENFMT:(99,' ')$)]))# OPEN ERROR MESSAGE FILE     PX   382
##                                                                      PX   383
ifsel:(UNXSNY)#                                                         PX   384
macro:(defdevice:,2)#                  Default screen is x11            PX   385
macro:(confgks:,noop:)#                                                 PX   386
macro:(gksconf:,noop:)#                                                 PX   387
##                                                                      PX   388
ifsel:(UNXIBM)#                                                         PX   389
macro:(defdevice:,2)#                  Default screen is x11            PX   390
macro:(confgks:,noop:)#                                                 PX   391
macro:(gksconf:,noop:)#                                                 PX   392
##                                                                      PX   393
ifsel:(SLPC)#                                                           PX   394
macro:(defdevice:,2)#                  Default screen is screen         PX   395
macro:(confgks:,noop:)#                                                 PX   396
macro:(gksconf:,noop:)#                                                 PX   397
##                                                                      PX   398
ifsel:#                                                                 PX   399
macro:(defdevice:,2)#                  Default screen is x11            PX   400
macro:(confgks:,noop:)#                                                 PX   401
macro:(gksconf:,noop:)#                                                 PX   402
endsel:#                                                                PX   403
##                                                                      PX   404
##                                                                      PX   405
## -------------------------------------------------------------------- PX   406
##                                                                      PX   407
##                                                                      PX   408
##                GENERAL MACRO DEFINITIONS                             PX   409
##                -------------------------                             PX   410
##                                                                      PX   411
##      Normally these definitions will NOT be altered.                 PX   412
##                                                                      PX   413
ifsel:(VMS)#                           Obscure vms-ism                  PX   414
macro:(vms:,%REF($1))#                 Pass by reference, not by desc   PX   415
ifsel:#                                                                 PX   416
macro:(vms:,$1)#                       Always by reference              PX   417
endsel:#                                                                PX   418
##                                                                      PX   419
macro:(noop:,IWIWIW=0)#                Passive no-operation             PX   420
macro:(xcontact:,CALL XCONT($1,vms:($2)))#                              PX   421
macro:(xstart:,  CALL XSTART($1,$2,vms:($3)))#                          PX   422
macro:(xcolmap:, CALL XCOLMP($1))#                                      PX   423
macro:(xstdc:,   CALL XSTDC())#                                         PX   424
macro:(setcol:,  CALL XDEFC($1,$2,$3,$4))#                              PX   425
macro:(xsetpg:,  CALL XSETPG($1,$2))#                                   PX   426
##                                                                      PX   427
##                                                                      PX   428
macro:(x11open:,ifelse:(x11:,0,noop:,# X11 open window                  PX   429
[$(REPLY=0;xcontact:(REPLY,"plotx.tcl")# Contact x server               PX   430
IF(REPLY>0)iquit:(PX4000)#             Quit if none available           PX   431
DBUF=0; xstart:(DBUF,WINID,".plotx.main")#                              PX   432
IF(WINID<=0) iquit:(PX4000)#           Bail out if can't open wndo      PX   433
xstdc:#                                Define standard 8 colors         PX   434
I=0;xsetpg:(WINID,I);CALL XSMAKE(0)$)]))# Open a segment                PX   435
macro:(x11colmap:,CALL XDEFC($1,$2,$3,$4))# Amend colormap              PX   436
##                                                                      PX   437
macro:(x11close:,ifelse:(x11:,0,noop:,#                                 PX   438
[$(CALL XCLOSE(WINID); CALL XFINIS()$)]))#                              PX   439
#                                                                       PX   440
macro:(x11wait:,ifelse:(x11:,0,noop:,#                                  PX   441
[$(CALL XSCLOS();CALL XFRAME(WINID,1)#                                  PX   442
IF (WINID==0) iquit:(PX0001)#                                           PX   443
CALL XSMAKE(0)$)]))#                                                    PX   444
##                                                                      PX   445
macro:(x11line:,ifelse:(x11:,0,noop:,# X11 plot a line                  PX   446
[CALL XLINES($1,QX($2),QX($2+NBUF),$3)]))#                              PX   447
##                                                                      PX   448
macro:(x11area:,ifelse:(x11:,0,noop:,# X11 fill an area                 PX   449
[CALL XFILL($1,QX($2),QX($2+NBUF))]))#                                  PX   450
##                                                                      PX   451
macro:(x11index:,ifelse:(x11:,0,noop:,# X11 colour index                PX   452
[$(IF(COLOR==2) CALL XSETFS($1)#                                        PX   453
ELSEIF(COLOR==1) $(CALL XSETFC($1); CALL XSETLC($1)$)#                  PX   454
CALL XSETLS($2)$)]))#                                                   PX   455
##                                                                      PX   456
macro:(x11mark:,ifelse:(x11:,0,noop:,# X11 fill an area                 PX   457
$(CALL XSETMC(NINT(QX(JP+5)));CALL XSETMS(QX(JP+3)*OMAG)#               PX   458
CALL XMARK(1,(QX(JP+1)+XOFF)*OMAG,(QX(JP+2)+YOFF)*OMAG )$)))#           PX   459
#                                                                       PX   460
##                                                                      PX   461
##                                                                      PX   462
macro:(gksopen:,ifelse:(gks:,0,noop:,[$(# General open gks macro        PX   463
CALL GOPKS(99,-1)#                     Open gks error file as 40        PX   464
CALL GOPWK(1,$1,$2)#                   Open workstation                 PX   465
CALL GACWK(1)#                         Activate workstation             PX   466
CALL GSDS(1,2,0)#                      Set deferral state               PX   467
CALL GSFAIS(0)#                        Set hollow fill area style       PX   468
CALL GSASF(LASF)#                      Set aspect source flags indiv    PX   469
IF(COLOR==1)$(#                        Device supports color initiali   PX   470
CALL GSCR(1,0,0.,0.,0.)#               Set black as 0                   PX   471
CALL GSCR(1,1,1.,0.,0.)#               Set red   as 1                   PX   472
CALL GSCR(1,2,0.,1.,0.)#               Set green as 2                   PX   473
CALL GSCR(1,3,0.,0.,1.)#               Set blue  as 3                   PX   474
CALL GSCR(1,4,1.,1.,0.)#               Set yello as 4                   PX   475
CALL GSCR(1,5,0.,1.,1.)#               Set cyan  as 5                   PX   476
CALL GSCR(1,6,1.,0.,1.)#               Set magen as 6                   PX   477
CALL GSCR(1,7,1.,1.,1.)$)$)]))#        Set white as 7                   PX   478
##                                                                      PX   479
macro:(gkswait:,ifelse:(gks:,0,noop:,[$(# Wait for user to pick         PX   480
CALL GRQLC(1,$1,I,J,XX,YY)#            Request locator input            PX   481
CALL GCLRWK(1,1)$)]))#                 Clear workstation                PX   482
##                                                                      PX   483
macro:(gksline:,ifelse:(gks:,0,noop:,[$(# Polyline drawer               PX   484
IF($1>1)CALL GPL($1,QX($2),QX($2+NBUF))$)]))# Plot points               PX   485
##                                                                      PX   486
macro:(gksarea:,ifelse:(gks:,0,noop:,# General fill area drawer         PX   487
[$(IF($1>2)CALL GFA($1,QX($2),QX($2+NBUF))$)]))# Plot area              PX   488
##                                                                      PX   489
macro:(gksindex:,ifelse:(gks:,0,noop:,# Set colour index                PX   490
CALL GSPLCI($1)))#                     Color index for polyline         PX   491
##                                                                      PX   492
macro:(gkscolor:,ifelse:(gks:,0,noop:,[$(# Color or dot/dash            PX   493
IWIW=1+MOD($2-1,5)#                    Dot/dash index                   PX   494
IF(IWIW==5) IWIW=-2#                   Fix up double line               PX   495
CALL GSLN(IWIW)#                       Dot/dash line style              PX   496
IF(COLOR==1) $(CALL GSPLCI($1)#        Color index for polyline         PX   497
CALL GSFACI($1)#                       Fill colour                      PX   498
CALL GSFAIS(1)$)#                      Fill solid type                  PX   499
IF(COLOR==2) $(CALL GSFAIS(MIN($1-1,3))# B/w fill style                 PX   500
IF ($1==3) CALL GSFASI(1)#             B/w pattern index                PX   501
ELSE CALL GSFASI(-$1+3)$)$)]))#        B/w fill style index             PX   502
##                                                                      PX   503
macro:(gksclose:,ifelse:(gks:,0,noop:,[$(# General gks close            PX   504
CALL GDAWK(1)#                         Deactivate workstation           PX   505
CALL GCLWK(1)#                         Close workstation                PX   506
CALL GCLKS(99)$)]))#                   Close gks error file             PX   507
##                                                                      PX   508
##                                                                      PX   509
##--------------------------------------------------------------------  PX   510
##                                                                      PX   511
extrude:(PXCOMN)#                                                       PX   512
##                                                                      PX   513
INTEGER ALIN(10)#                      Dot-dash array index             PX   514
INTEGER AREAOT#                        Count of area buffer             PX   515
INTEGER BCOL#                          Bond colour index                PX   516
INTEGER CCOL#                          Character colour index           PX   517
INTEGER COLOR#                         Indicates colour changes         PX   518
INTEGER COLR(10)#                      Colour index array               PX   519
INTEGER CONTUR#                        Contour flag                     PX   520
INTEGER FILL#                          Fill bonds/atoms flag            PX   521
INTEGER FILLUP#                        Fillup this item                 PX   522
INTEGER FLUSH#                         Flush the line buffer            PX   523
INTEGER FULL#                          End of coord buffer 1            PX   524
INTEGER FIRSTT#                        Signal first call of py11        PX   525
INTEGER FRAME(20)#                     Frames to be plotted             PX   526
INTEGER IBRDR#                         Flag for drawing border          PX   527
INTEGER ICENTR#                        Flag for auto centering          PX   528
INTEGER ICOL#                          Flag to apply color              PX   529
INTEGER IFRAM#                         Count of frames                  PX   530
INTEGER IP#                            Pointer to coord buffer          PX   531
INTEGER IPND#                          End of section of coord buffer   PX   532
INTEGER JP#                            Pointer to filee buffer          PX   533
INTEGER IBAK#                          Background flag 1 to blank       PX   534
INTEGER ICHR#                          Output buffer pointer px02       PX   535
INTEGER IPLOT#                         Count of plots on file           PX   536
INTEGER ISCALE#                        Flag for auto scaling            PX   537
INTEGER MARK#                          Start of coord buffer            PX   538
INTEGER MAXCOL#                        Maximum colors available         PX   539
INTEGER MXCOL#                         Maximum colors used              PX   540
INTEGER NBUF#                          Max size of one coord buffer     PX   541
INTEGER NCOL#                          Number colour index              PX   542
INTEGER NCOLS#                         Number columns in line           PX   543
INTEGER NDEV#                          Device number                    PX   544
INTEGER NDIS#                          Display identifier               PX   545
INTEGER NEW#                           New colour coming flag           PX   546
INTEGER NF#                            Function number                  PX   547
INTEGER NCC#                           Count pen up movements           PX   548
INTEGER NLINE#                         Number lines per plot page       PX   549
INTEGER NP#                            Number of points in buffer       PX   550
INTEGER NPLOT#                         Plot number                      PX   551
INTEGER NPT#                           Count pen down movements         PX   552
INTEGER NSKIP#                         Column count +1                  PX   553
INTEGER OLDPLT#                        Old plot scale packet            PX   554
INTEGER PAPER#                         Paper type                       PX   555
INTEGER PENCOL#                        Pen colour                       PX   556
INTEGER PENSTY#                        Atom outline style               PX   557
INTEGER RETRACE#                       Retrace fill outline in black    PX   558
INTEGER REPLY#                                                          PX   559
pointer: WINID#                        Window specifiers                PX   560
REAL AHIGH#                            Plot height                      PX   561
REAL AWIDE#                            Plot width                       PX   562
REAL OMAG#                             Magnification factor             PX   563
REAL RESL#                             Resolution                       PX   564
REAL SCALX,SCALY#                      Scale to output frame            PX   565
REAL XCEN,YCEN#                        X,y coord of center              PX   566
REAL XLST,YLST#                        X,y last pen position            PX   567
REAL XOFF,YOFF#                        X,y output offset                PX   568
REAL XPIX,YPIX#                        X,y pixels per unit              PX   569
REAL TSCALE#                           Text scale correction factor     PX   570
#                                                                       PX   571
string:(DNAME,6)#                                                       PX   572
#                                                                       PX   573
COMMON/COMFPX/$#                                                        PX   574
AHIGH,AWIDE,OMAG,RESL,SCALX,SCALY,#                                     PX   575
XCEN,YCEN,XLST,YLST,XOFF,YOFF,XPIX,YPIX,TSCALE#                         PX   576
#                                                                       PX   577
COMMON/COMIPX/$#                                                        PX   578
ALIN,AREAOT,BCOL,CCOL,COLOR,COLR,CONTUR,FILL,FILLUP,FLUSH,FULL,FIRSTT,# PX   579
FRAME,IBRDR,ICENTR,ICOL,IFRAM,IP,IPND,JP,IBAK,ICHR,IPLOT,ISCALE,#       PX   580
MARK,MAXCOL,MXCOL,NBUF,NCOL,NCOLS,NDEV,NDIS,NEW,NF,NCC,NLINE,#          PX   581
NP,NPLOT,NPT,NSKIP,OLDPLT,PENCOL,PENSTY,RETRACE,PAPER,REPLY#            PX   582
COMMON/COMLPX/WINID#                                                    PX   583
#                                                                       PX   584
COMMON/COMCPX/ DNAME#                                                   PX   585
endext:#                                                                PX   586
#                                                                       PX   587
systemheader:(PX00)#                   Main plot sequence routine       PX00   1
####################################################################    PX00   2
#                                                                  #    PX00   3
#                                PX00                              #    PX00   4
#                                                                  #    PX00   5
####################################################################    PX00   6
SUBROUTINE PX00#                       S.r. hall july 88                PX00   7
include:(AACOMN)#                                                       PX00   8
include:(PXCOMN)#                                                       PX00   9
#                                                                       PX00  10
#---------------------------------------------------------------        PX00  11
#                                                                       PX00  12
## >>>>>>>>>>>>>>> Contents of Plot File   <<<<<<<<<<<<<<<<<<<<<<       PX00  13
## >>>>>>>>>>>>>>> input as 7-word packets <<<<<<<<<<<<<<<<<<<<<<       PX00  14
#                                                                       PX00  15
## FUNCTION CODE (in word 7 of each packet)                             PX00  16
#        1       START OF PLOT                                          PX00  17
#        2       FRAME ADVANCE SIGNAL                                   PX00  18
#        3       PEN MOVEMENT                                           PX00  19
#        4       DRAW NUMBER                                            PX00  20
#        5       DRAW CHARACTER STRING                                  PX00  21
#        6       AUTO CENTER AND SCALE                                  PX00  22
#        7       COLOR MAP                                              PX00  23
#       10       END OF PLOT                                            PX00  24
#                                                                       PX00  25
# PEN MOVEMENT (3)                                                      PX00  26
#     WORD 1       DX PLOT MOVEMENT                                     PX00  27
#     WORD 2       DY PLOT MOVEMENT                                     PX00  28
#     WORD 3       X  PLOT MOVEMENT                                     PX00  29
#     WORD 4       Y  PLOT MOVEMENT                                     PX00  30
#     WORD 5       SUBJECT (COLOR) INDEX                                PX00  31
#     WORD 6       PEN UP/DOWN FLAG (3/2)                               PX00  32
#                                                                       PX00  33
#-----------------------------------------------------------------      PX00  34
#                                                                       PX00  35
INTEGER ANSWER#                                                         PX00  36
INTEGER NPEN#                          Pen up/down                      PX00  37
INTEGER PSIZE#                         Packet size                      PX00  38
INTEGER SINDX#                         Subject index                    PX00  39
INTEGER DBUF#                          Double buffered x11 mode         PX00  40
INTEGER SCR(2),DIM#                    Interface dimensions             PX00  41
INTEGER I#                                                              PX00  42
REAL    X,Y#                           X & y coordinates                PX00  43
intdata:(LASF,[1,1,1,1,1,1,1,1,1,1,1,1,1])#                             PX00  44
datastuff:#                                                             PX00  45
#                                                                       PX00  46
FILEXT(IOUNIT(5))='ORT'#               Default ip file is ortep file    PX00  47
#                                                                       PX00  48
CALL PX11#                             ************ read controls       PX00  49
IF     (NDEV==2) start2:#              Request start up  for device     PX00  50
ELSE IF(NDEV==3) start3:#              Request start up  for device     PX00  51
ELSE IF(NDEV==4) start4:#              Request start up  for device     PX00  52
ELSE IF(NDEV==5) start5:#              Request start up  for device     PX00  53
ELSE IF(NDEV==6) start6:#              Request start up  for device     PX00  54
ELSE IF(NDEV==7) start7:#              Request start up  for device     PX00  55
ELSE IF(NDEV==8) start8:#              Request start up  for device     PX00  56
ELSE IF(NDEV==9) start9:#              Request start up  for device     PX00  57
ELSE IF(NDEV==10) start10:#            Request start up  for device     PX00  58
ELSE IF(NDEV==11) start11:#            Request start up  for device     PX00  59
ELSE IF(NDEV==12) start12:#            Request start up  for device     PX00  60
ELSE IF(NDEV==13) start13:#            Request start up  for device     PX00  61
ELSE IF(NDEV==14) start14:#            Request start up  for device     PX00  62
#                                                                       PX00  63
#   LOOP OVER INPUT PLOT FILE DATA                                      PX00  64
#   ------------------------------                                      PX00  65
#                                                                       PX00  66
REPEAT#                                Loop over plot commands          PX00  67
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX00  68
readwpkt:(5,23,PSIZE,JP,0)#            Read packet input plot data      PX00  69
IF(JP<=0) iquit:(PX0001)#              Unexpected end of plot file      PX00  70
#                                                                       PX00  71
NF=NINT(QX(JP+7))#                     Extract plot function id         PX00  72
#                                                                       PX00  73
IF(NF<=2\NF==10)     CALL PX31#        ************* new plot frame     PX00  74
IF(NF==10)           BREAK#            ************* end plot           PX00  75
IF(IPLOT!=NPLOT)     NEXT#             Skip unwanted frames             PX00  76
#                                                                       PX00  77
IF(NF==3)#                             ************** plot point        PX00  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX00  79
X=QX(JP+1)+QX(JP+3)#                   X coordinate                     PX00  80
Y=QX(JP+2)+QX(JP+4)#                   Y coordinate                     PX00  81
SINDX=NINT(QX(JP+5))#                  Subject index                    PX00  82
NPEN= NINT(QX(JP+6))#                  Pen up=3 /pen down=2             PX00  83
CALL PX01(X,Y,NPEN,SINDX)#             Execute plot command             PX00  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX00  85
ELSE IF(NF==4\NF==5) CALL PX41#        ************* draw numb/chars    PX00  86
ELSE IF(NF==6)       CALL PX51#        ************* centre/scale       PX00  87
ELSE IF(NF==7)       CALL PX52#        ************* color map          PX00  88
ELSE IF(NF==11)      CALL PX53#        ************* draw markers       PX00  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX00  90
CALL PX61#                             Finish the plot                  PX00  91
#                                                                       PX00  92
RETURN#                                                                 PX00  93
END#                                                                    PX00  94
systemheader:(PX01)#                   Plot a point on surface          PX01   1
####################################################################    PX01   2
#                                                                  #    PX01   3
#                             PX01                                 #    PX01   4
#                                                                  #    PX01   5
####################################################################    PX01   6
SUBROUTINE PX01(X,Y,PEN,SINDX)#                                         PX01   7
include:(AACOMN)#                                                       PX01   8
include:(PXCOMN)#                                                       PX01   9
#                                                                       PX01  10
INTEGER COL#                           Color code for atom interior     PX01  11
INTEGER STYL#                          Code for atom line style         PX01  12
INTEGER I,J,K#                         Indices                          PX01  13
INTEGER PEN#                           Move/draw flag                   PX01  14
INTEGER SINDX#                         Color index                      PX01  15
INTEGER NEWX,NEWY#                     New printer coordinates          PX01  16
INTEGER LSTX,LSTY#                     Last printer coordinates         PX01  17
INTEGER LAGX,LAGY#                     Change printer coordinates       PX01  18
INTEGER MOVX,MOVY#                     Change printer coordinates       PX01  19
INTEGER MULT#                          Change in pixels                 PX01  20
INTEGER IPST#                          Start point of line output       PX01  21
INTEGER BFULL#                         Flag that buffer is full         PX01  22
ifsel:(SLPC)#                                                           PX01  23
INTEGER*2 IX(1000),IY(1000)#           Integer storage for plot         PX01  24
endsel:#                                                                PX01  25
REAL DX, DY#                           Change in x or y                 PX01  26
REAL X, Y#                             X & y coords. (units)            PX01  27
REAL X1,Y1#                            X & y coords. (scaled)           PX01  28
SAVE COL,LSTX,LSTY#                                                     PX01  29
#                                                                       PX01  30
#  PROCESS COLOR COMMANDS                                               PX01  31
#  ----------------------                                               PX01  32
#                                                                       PX01  33
BFULL=no:#                             Initialise buffer flag           PX01  34
IF(NEW==yes:)#                         New color for new subject?       PX01  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX01  36
FILLUP=no:;STYL=1#                     Don't area fill this item        PX01  37
IF(SINDX>-1000) FILLUP=FILL#           Fill it if requested             PX01  38
IF     (SINDX==1000) COL=BCOL#         Bond color                       PX01  39
ELSE IF(SINDX>-1000)#                  Atom or contur                   PX01  40
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX01  41
I=MIN0(IABS(SINDX),10)#                Get pointer to color index       PX01  42
IF(I==0) COL=BCOL#                     Bond color                       PX01  43
ELSE     COL=COLR(I)#                  Interior atom or contur color    PX01  44
IF(I!=0) STYL=ALIN(I)#                 Atom line style                  PX01  45
IF(MXCOL>7&SINDX<-7)COL=IABS(SINDX)#   Use the specific color           PX01  46
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX01  47
ELSE IF(SINDX==-4000) COL=NCOL#        Numb color                       PX01  48
ELSE IF(SINDX==-5000) COL=CCOL#        Char color                       PX01  49
ELSE IF(SINDX==-6000) COL=BCOL#        Bord color                       PX01  50
IF(COL!=PENCOL) ICOL=yes:#             New color                        PX01  51
IF(STYL!=PENSTY) ICOL=yes:#            New atom line style              PX01  52
NEW=no:#                               Reset new subject flag           PX01  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX01  54
IF(SINDX==0) NEW=yes:#                 Start new subject                PX01  55
#                                                                       PX01  56
#  PROCESS DRAW COMMANDS   (PEN UP = 3 OR BUFFER FULL)                  PX01  57
#  ---------------------                                                PX01  58
#                                                                       PX01  59
X1=OMAG*(X+XOFF);  Y1=OMAG*(Y+YOFF)#   Scaled x,y coordinate            PX01  60
DX=ABS(X1-XLST);   DY=ABS(Y1-YLST)#    Change in x,y coordinate         PX01  61
#                                                                       PX01  62
IF(DX+DY>RESL\PEN==3\ICOL==yes:)#      Test if point needed             PX01  63
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX01  64
IF(NDEV==1) NP=1#                      For lineprinter op               PX01  65
ELSE IF(NBUF==1)#                      Always plot single buffer        PX01  66
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PX01  67
NP=1;         IPST=IP#                 Plot one point                   PX01  68
QX(IP)=X1;    QX(IP+1)=Y1#             Store the current position       PX01  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PX01  70
ELSE#                                                                   PX01  71
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PX01  72
IF((IP==FULL)\(PEN==3&NEW==yes:))#     Lookahead plot test              PX01  73
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PX01  74
IF(IP==FULL) BFULL=yes:#               Flag full buffer                 PX01  75
NP=IP-IPND; IPST=IPND+1#               Reset the buffer pointers        PX01  76
AREAOT=IP-MARK; IP=MARK#               Reset the buffer pointers        PX01  77
IPND=IP#                               Reset the buffer pointers        PX01  78
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PX01  79
ELSE IF(PEN==3)#                       Lookahead plot test              PX01  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PX01  81
NP=IP-IPND; IPST=IPND+1#               Reset the buffer pointers        PX01  82
IPND=IP#                               Reset the buffer pointers        PX01  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PX01  84
IF(FLUSH!=yes:)#                       Dont add a new point             PX01  85
IP=IP+1#                               Incr the buffer pointer          PX01  86
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PX01  87
#                                                                       PX01  88
#    APPLY THE COLOUR COMMANDS                                          PX01  89
#    -------------------------                                          PX01  90
#                                                                       PX01  91
IF(ICOL==yes:)#                        If color change required         PX01  92
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PX01  93
IF(NDEV==2)      nupen2:(COL,STYL)#    Change color on this device      PX01  94
ELSE IF(NDEV==3) nupen3:(COL,STYL)#    Change color on this device      PX01  95
ELSE IF(NDEV==4) nupen4:(COL,STYL)#    Change color on this device      PX01  96
ELSE IF(NDEV==5) nupen5:(COL,STYL)#    Change color on this device      PX01  97
ELSE IF(NDEV==6) nupen6:(COL,STYL)#    Change color on this device      PX01  98
ELSE IF(NDEV==7) nupen7:(COL,STYL)#    Change color on this device      PX01  99
ELSE IF(NDEV==8) nupen8:(COL,STYL)#    Change color on this device      PX01 100
ELSE IF(NDEV==9) nupen9:(COL,STYL)#    Change color on this device      PX01 101
ELSE IF(NDEV==10)nupen10:(COL,STYL)#   Change colour on this device     PX01 102
ELSE IF(NDEV==11)nupen11:(COL,STYL)#   Change colour on this device     PX01 103
ELSE IF(NDEV==12)nupen12:(COL,STYL)#   Change colour on this device     PX01 104
ELSE IF(NDEV==13)nupen13:(COL,STYL)#   Change colour on this device     PX01 105
ELSE IF(NDEV==14)nupen14:(COL,STYL)#   Change colour on this device     PX01 106
ICOL=no:;   NCC=NCC+1#                 Reset and count changes          PX01 107
PENCOL=COL;PENSTY=STYL#                Change the current color         PX01 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PX01 109
#                                                                       PX01 110
#    APPLY THE MOVE COMMANDS                                            PX01 111
#    -----------------------                                            PX01 112
#                                                                       PX01 113
IF(NP>0)#                              If new points required           PX01 114
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PX01 115
#                                                                       PX01 116
IF(FILLUP==yes:&AREAOT>0)#             Empty area buffer?               PX01 117
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PX01 118
#                                      Output the area buffer           PX01 119
IF     (NDEV==2) areap2:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 120
ELSE IF(NDEV==3) areap3:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 121
ELSE IF(NDEV==4) areap4:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 122
ELSE IF(NDEV==5) areap5:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 123
ELSE IF(NDEV==6) areap6:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 124
ELSE IF(NDEV==7) areap7:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 125
ELSE IF(NDEV==8) areap8:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 126
ELSE IF(NDEV==9) areap9:(AREAOT,MARK+1,PEN,COL)# Plot points in buffe   PX01 127
ELSE IF(NDEV==10)areap10:(AREAOT,MARK+1,PEN,COL)# Plot points in buff   PX01 128
ELSE IF(NDEV==11)areap11:(AREAOT,MARK+1,PEN,COL)# Plot points in buff   PX01 129
ELSE IF(NDEV==12)areap12:(AREAOT,MARK+1,PEN,COL)# Plot points in buff   PX01 130
ELSE IF(NDEV==13)areap13:(AREAOT,MARK+1,PEN,COL)# Plot points in buff   PX01 131
ELSE IF(NDEV==14)areap14:(AREAOT,MARK+1,PEN,COL)# Plot points in buff   PX01 132
AREAOT=0#                                                               PX01 133
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PX01 134
#                                                                       PX01 135
IF(NDEV==1)#                           ************* char op device     PX01 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PX01 137
NEWX=MIN0(INT(X1*XPIX),NCOLS)#         Convert to chars on line         PX01 138
NEWY=MIN0(NLINE-INT(Y1*YPIX),NLINE)#   Convert to lines down            PX01 139
IF(PEN==2)#                            Only for pen down movement       PX01 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PX01 141
MOVX=NEWX-LSTX;    MOVY=NEWY-LSTY#     Get change in x,y                PX01 142
IF(MOVX==0)     LAGX= 0#               Get interpolation factor         PX01 143
ELSE IF(MOVX<0) LAGX=-IABS(MOVY)/2#    Get interpolation factor         PX01 144
ELSE            LAGX= IABS(MOVY)/2#    Get interpolation factor         PX01 145
IF(MOVY==0)     LAGY= 0#               Get interpolation factor         PX01 146
ELSE IF(MOVY<0) LAGY=-IABS(MOVX)/2#    Get interpolation factor         PX01 147
ELSE            LAGY= IABS(MOVX)/2#    Get interpolation factor         PX01 148
MULT=MAX0(IABS(MOVX),IABS(MOVY))#      Get max pixels changed           PX01 149
IF(MULT>0)#                            If pixels are needed             PX01 150
FOR(K=0;K<=MULT;K=K+1)#                Loop over pixels                 PX01 151
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PX01 152
I=LSTX+(K*MOVX+LAGX)/MULT#             Get interpolated x               PX01 153
J=LSTY+(K*MOVY+LAGY)/MULT#             Get interpolated y               PX01 154
QX(MARK+I+J*NSKIP+1)=1.#               Store point in map buffer        PX01 155
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PX01 156
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PX01 157
LSTX=NEWX;      LSTY=NEWY#             Save current x,y-coord           PX01 158
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PX01 159
#                                                                       PX01 160
ELSE IF(NDEV==2) plotp2:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 161
ELSE IF(NDEV==3) plotp3:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 162
ELSE IF(NDEV==4) plotp4:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 163
ELSE IF(NDEV==5) plotp5:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 164
ELSE IF(NDEV==6) plotp6:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 165
ELSE IF(NDEV==7) plotp7:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 166
ELSE IF(NDEV==8) plotp8:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 167
ELSE IF(NDEV==9) plotp9:(NP,IPST,PEN,COL)# Plot np points in the buff   PX01 168
ELSE IF(NDEV==10)plotp10:(NP,IPST,PEN,COL)# Plot np points in the buf   PX01 169
ELSE IF(NDEV==11)plotp11:(NP,IPST,PEN,COL)# Plot np points in the buf   PX01 170
ELSE IF(NDEV==12)plotp12:(NP,IPST,PEN,COL)# Plot np points in the buf   PX01 171
ELSE IF(NDEV==13)plotp13:(NP,IPST,PEN,COL)# Plot np points in the buf   PX01 172
ELSE IF(NDEV==14)plotp14:(NP,IPST,PEN,COL)# Plot np points in the buf   PX01 173
#IF(NP>1&BFULL==YES:&PEN!=3)#          IF BUFFER FULL & NOT MOVE        PX01 174
IF(BFULL==yes:&PEN!=3)#                If buffer full & not move        PX01 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PX01 176
QX(MARK+1)     =QX(MARK+NBUF)#         Push down last x                 PX01 177
QX(MARK+1+NBUF)=QX(MARK+NBUF+NBUF)#    Push down last y                 PX01 178
IP=MARK+2#                             Incr buffer pointer              PX01 179
BFULL=no:#                             Reset buffer full flag           PX01 180
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PX01 181
NPT=NPT+NP;     NP=0#                  Reset and count moves            PX01 182
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PX01 183
#                                                                       PX01 184
#   STORE THE NEXT BUFFERED POINT                                       PX01 185
#   -----------------------------                                       PX01 186
#                                                                       PX01 187
IF(NBUF>1&FLUSH!=yes:)#                Store the current value          PX01 188
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PX01 189
QX(IP)=X1;    QX(IP+NBUF)=Y1#          Store the current position       PX01 190
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PX01 191
XLST=X1;           YLST=Y1#            Remember last point plotted      PX01 192
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX01 193
#                                                                       PX01 194
FLUSH=no:#                             Reset flush flag                 PX01 195
RETURN#                                                                 PX01 196
END#                                                                    PX01 197
systemheader:(PX02)#                   Output plot data to plot file    PX02   1
####################################################################    PX02   2
#                                                                  #    PX02   3
#                                PX02                              #    PX02   4
#                                                                  #    PX02   5
####################################################################    PX02   6
SUBROUTINE PX02(NCHR,STRG)#                                             PX02   7
include:(AACOMN)#                                                       PX02   8
include:(PXCOMN)#                                                       PX02   9
INTEGER NCHR#                                                           PX02  10
string:(STRG,*); string:(LINE,80)#                                      PX02  11
SAVE LINE#                                                              PX02  12
#                                                                       PX02  13
IF(ICHR+NCHR>80 \ NCHR==0)#            Test for full buffer             PX02  14
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX02  15
ICHR=MAX(1,ICHR)#                      At least one char                PX02  16
writefmt:(iofm2:,'(A)',LINE(1^ICHR))#  Output the buffer                PX02  17
LINE=' ';  ICHR=0#                     Reset the buffer                 PX02  18
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX02  19
IF(NCHR>0) LINE(ICHR+1^ICHR+NCHR)=STRG(1^NCHR)# Store next string       PX02  20
ICHR=ICHR+NCHR#                        Incr the buffer pointer          PX02  21
#                                                                       PX02  22
RETURN#                                                                 PX02  23
END#                                                                    PX02  24
systemheader:(PX11)#                   Input control lines              PX11   1
####################################################################    PX11   2
#                                                                  #    PX11   3
#                                PX11                              #    PX11   4
#                                                                  #    PX11   5
####################################################################    PX11   6
SUBROUTINE PX11#                                                        PX11   7
include:(AACOMN)#                                                       PX11   8
include:(PXCOMN)#                                                       PX11   9
#                                                                       PX11  10
INTEGER I,J,M,N#                       Local indices                    PX11  11
INTEGER KEY,COLO(14)#                  Signal for character checkin     PX11  12
REAL WIDE(14),HIGH(14),TMP#            Width & height of plot           PX11  13
REAL PIXX(14),PIXY(14)#                Pixels along x and y             PX11  14
string:(TEMP,6)#                                                        PX11  15
#                                                                       PX11  16
chardata:(PX110, PARAMS COLOR FRAMES END )#                             PX11  17
chardata:(PX111,PRINT  dcode2: dcode3: dcode4: dcode5: dcode6: $#       PX11  18
dcode7: dcode8: dcode9: dcode10: dcode11: dcode12: dcode13: dcode14: )# PX11  19
chardata:(PX112,FILL  NOFIL BOND  CHAR  NUMB  CONT  NOCOL $#            PX11  20
ATLIN SHADE )#                                                          PX11  21
chardata:(PX113,NBL RET A3  A4  A5  LET LEG EXE OLD )#                  PX11  22
datastuff:#                                                             PX11  23
#                                                                       PX11  24
IOMARK(5)=QXSTR#                       Start of file e buffer           PX11  25
MARK=IOMARK(5)+bdfbuf:#                Start of map                     PX11  26
#                                                                       PX11  27
#  SET DEFAULT PLOTTER CHARACTERISTICS                                  PX11  28
#  -----------------------------------                                  PX11  29
#                                                                       PX11  30
IBAK=yes:#                             Background will be blanked       PX11  31
FLUSH=no:#                             Default until required           PX11  32
IPLOT=0;      NPLOT=-1#                Set ip & op plot count           PX11  33
NBUF=0;       IFRAM=0#                 Set bufsize & frame cnt          PX11  34
CONTUR=no:;   FILL=no:#                Indicate plot type               PX11  35
BCOL=7;       CCOL=5;        NCOL=6#   Set color bond/char/numb         PX11  36
COLO(1)=no:;        COLO(2)=color2:#   Set color switch per device      PX11  37
COLO(3)=color3:;    COLO(4)=color4:#   Set color switch per device      PX11  38
COLO(5)=color5:;    COLO(6)=color6:#   Set color switch per device      PX11  39
COLO(7)=color7:;    COLO(8)=color8:#   Set color switch per device      PX11  40
COLO(9)=color9:;    COLO(10)=color10:# Set color switch per device      PX11  41
COLO(11)=color11:;  COLO(12)=color12:# Set color switch per device      PX11  42
COLO(13)=color13:;  COLO(14)=color14:#                                  PX11  43
DO I=1,10;    COLR(I)=MOD(I-1,7)+1#    Default colours                  PX11  44
DO I=1,10;    ALIN(I)=1#               Default line styles              PX11  45
NCOLS=prtcmax:-2;    NSKIP=NCOLS+1#    Characters per line              PX11  46
NLINE=prtlmax:-4#                      Lines down page                  PX11  47
WIDE(1)=FLOAT(NCOLS)/FLOAT(prtcpin:)#  Set dim in units                 PX11  48
HIGH(1)=FLOAT(NLINE)/FLOAT(prtlpin:)#  Set dim in units                 PX11  49
WIDE(2)=xmaxw2:;    HIGH(2)=ymaxh2:#   Set dim in units                 PX11  50
WIDE(3)=xmaxw3:;    HIGH(3)=ymaxh3:#   Set dim in units                 PX11  51
WIDE(4)=xmaxw4:;    HIGH(4)=ymaxh4:#   Set dim in units                 PX11  52
WIDE(5)=xmaxw5:;    HIGH(5)=ymaxh5:#   Set dim in units                 PX11  53
WIDE(6)=xmaxw6:;    HIGH(6)=ymaxh6:#   Set dim in units                 PX11  54
WIDE(7)=xmaxw7:;    HIGH(7)=ymaxh7:#   Set dim in units                 PX11  55
WIDE(8)=xmaxw8:;    HIGH(8)=ymaxh8:#   Set dim in units                 PX11  56
WIDE(9)=xmaxw9:;    HIGH(9)=ymaxh9:#   Set dim in units                 PX11  57
WIDE(10)=xmaxw10:;  HIGH(10)=ymaxh10:# Set dim in units                 PX11  58
WIDE(11)=xmaxw11:;  HIGH(11)=ymaxh11:# Set dim in units                 PX11  59
WIDE(12)=xmaxw12:;  HIGH(12)=ymaxh12:# Set dim in units                 PX11  60
WIDE(13)=xmaxw13:;  HIGH(13)=ymaxh13:# Set dim in units                 PX11  61
WIDE(14)=xmaxw14:;  HIGH(14)=ymaxh14:# Set dim in units                 PX11  62
PIXX(1)=prtcpin:;   PIXY(1)=prtlpin:#  Set x,y pixels/unit              PX11  63
PIXX(2)=xpixl2:;    PIXY(2)=ypixl2:#   Set x,y pixels/unit              PX11  64
PIXX(3)=xpixl3:;    PIXY(3)=ypixl3:#   Set x,y pixels/unit              PX11  65
PIXX(4)=xpixl4:;    PIXY(4)=ypixl4:#   Set x,y pixels/unit              PX11  66
PIXX(5)=xpixl5:;    PIXY(5)=ypixl5:#   Set x,y pixels/unit              PX11  67
PIXX(6)=xpixl6:;    PIXY(6)=ypixl6:#   Set x,y pixels/unit              PX11  68
PIXX(7)=xpixl7:;    PIXY(7)=ypixl7:#   Set x,y pixels/unit              PX11  69
PIXX(8)=xpixl8:;    PIXY(8)=ypixl8:#   Set x,y pixels/unit              PX11  70
PIXX(9)=xpixl9:;    PIXY(9)=ypixl9:#   Set x,y pixels/unit              PX11  71
PIXX(10)=xpixl10:;  PIXY(10)=ypixl10:# Set x,y pixels/unit              PX11  72
PIXX(11)=xpixl11:;  PIXY(11)=ypixl11:# Set x,y pixels/unit              PX11  73
PIXX(12)=xpixl12:;  PIXY(12)=ypixl12:# Set x,y pixels/unit              PX11  74
PIXX(13)=xpixl13:;  PIXY(13)=ypixl13:# Set x,y pixels/unit              PX11  75
PIXX(14)=xpixl14:;  PIXY(14)=ypixl14:# Set x,y pixels/unit              PX11  76
AWIDE=0.;           AHIGH=0.#          Start plot dimensions            PX11  77
XCEN =99999.;       YCEN =99999.#      Start plot centre                PX11  78
OMAG =0.0000;       RESL =99999.#      Magnification is auto            PX11  79
ISCALE=no:;         ICENTR=no:#        No auto scale/centre             PX11  80
XOFF=0.00000;       YOFF=0.00000#      X,y plot offset                  PX11  81
XLST=-99999.;       YLST=-99999.#      X,y last pen position            PX11  82
PENCOL=-99999; FILLUP=no:#             Reset colour flags               PX11  83
PENSTY=-99999#                         Reset colour flags               PX11  84
ICOL=no:;           NEW=no:#           New subject color flag           PX11  85
IBRDR=no:;          COLOR=-1#          Default border not drawn         PX11  86
NPT=0;      NP=0;       NCC=0#         Reset point & color counts       PX11  87
IP=MARK;   IF(NBUF==1) IP=IP+1#        Reset buffer pointer             PX11  88
AREAOT=0;  IPND=IP#                    Reset buffer pointers            PX11  89
NDEV=defdevice:#                       Assign default device            PX11  90
DO I=1,20; FRAME(I)=0#                 Zero frames requested            PX11  91
RETRACE=no:#                           No retrace on fill               PX11  92
OLDPLT=no:#                            Not an old plot                  PX11  93
MXCOL=7#                               Maximum color used (expected)    PX11  94
PAPER=2#                                                                PX11  95
#                                                                       PX11  96
#                                                                       PX11  97
#   PROCESS CONTROL LINES                                               PX11  98
#   ---------------------                                               PX11  99
#                                                                       PX11 100
ifnv:(BUFIN(1))#                       Get device from plotx line       PX11 101
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX11 102
stringlim:(1,M,N)#                     Get string limits                PX11 103
TEMP=CHRIN(M^N-1)#                     Store device code                PX11 104
compchar:(TEMP,1,PX111,1,6,7,NPX111,NDEV)# Match with device            PX11 105
IF(NDEV==0) iquit:(PX1101)#            Device unknown                   PX11 106
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX11 107
ifch:(BUFIN(2))#                       Get plot input file              PX11 108
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX11 109
IF(BUFIN(2)>voidflg:) iquit:(PX1102)#  Numeric file ext illegal         PX11 110
stringlim:(2,M,N)#                     Get file extension limits        PX11 111
FILEXT(IOUNIT(5))=CHRIN(M^M+2)#        Store file extension             PX11 112
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX11 113
ELSE ifnm:(BUFIN(2)) iquit:(PX1102)#   Numeric file ext illegal         PX11 114
DNAME=PX111(NDEV*7-6^NDEV*7-1)#        Store device name                PX11 115
FOR(J=3;J>0;J=J+1)#                    Loop over input fields           PX11 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX11 117
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               PX11 118
ifnm:(BUFIN(J)) iquit:(PX1103)#        Illegal input number             PX11 119
stringlim:(J,M,N)#                     Extract char string              PX11 120
compchar:(CHRIN,M,PX113,1,3,4,NPX113,KEY)# Identify string              PX11 121
IF    (KEY==1)   IBAK=no:#             Do not blank background          PX11 122
ELSEIF(KEY==2)RETRACE=yes:#            Yes retrace border for fill      PX11 123
ELSEIF(KEY>2&KEY<9)PAPER=KEY-2#        A4/us letter/legal               PX11 124
ELSEIF(KEY==9) OLDPLT=yes:#            Old style plot positioning       PX11 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX11 126
IF(DNAME(1^4)=='POST'\DNAME(1^4)=='XFIG')# Get the right dimensions     PX11 127
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PX11 128
IF(PAPER==1)$(AWIDE=11.69;AHIGH=16.54$)# A3                             PX11 129
IF(PAPER==2)$(AWIDE=8.27; AHIGH=11.69$)# A4                             PX11 130
IF(PAPER==3)$(AWIDE=5.83; AHIGH= 8.27$)# A5                             PX11 131
IF(PAPER==4)$(AWIDE=8.5 ; AHIGH=11.0 $)# Us letter                      PX11 132
IF(PAPER==5)$(AWIDE=8.5 ; AHIGH=14.0 $)# Us legal                       PX11 133
IF(PAPER==6)$(AWIDE=7.25; AHIGH=10.5 $)# Us executive                   PX11 134
IF(DNAME(5^5)=='L')#                                                    PX11 135
$(TMP=AWIDE;AWIDE=AHIGH;AHIGH=TMP$)#   Swap dims for landscape          PX11 136
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PX11 137
#                                                                       PX11 138
#      PROCESS CONTROL LINES                                            PX11 139
#      ---------------------                                            PX11 140
#                                                                       PX11 141
REPEAT#                                Loop over input lines            PX11 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PX11 143
readline:(PX110,NPX110)#               Read next input line             PX11 144
#                                                                       PX11 145
IF(LINID==1)#                          *********** params line          PX11 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PX11 147
IF(BUFIN(1)>0.0) AWIDE=BUFIN(1)#       Plot width                       PX11 148
IF(BUFIN(2)>0.0) AHIGH=BUFIN(2)#       Plot height                      PX11 149
IF(BUFIN(3)>0.0) OMAG= BUFIN(3)#       Magnification                    PX11 150
ifnv:(BUFIN(4))  XCEN= BUFIN(4)#       Plot center                      PX11 151
ifnv:(BUFIN(5))  YCEN= BUFIN(5)#       Plot center                      PX11 152
ifnv:(BUFIN(6))  IBRDR=yes:#           Plot the border                  PX11 153
IF(BUFIN(7)>0.0) RESL= BUFIN(7)#       Resolution in units              PX11 154
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PX11 155
#                                                                       PX11 156
ELSE IF(LINID==2)#                     *********** color line           PX11 157
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PX11 158
COLOR=1#                               Color and new subject flag       PX11 159
FOR(J=1;J>0;J=J+1)#                    Loop over input fields           PX11 160
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PX11 161
ifvo:(BUFIN(J)) BREAK#                 Exit on first void               PX11 162
ifnm:(BUFIN(J)) iquit:(PX1103)#        Illegal input number             PX11 163
stringlim:(J,M,N)#                     Extract char string              PX11 164
compchar:(CHRIN,M,PX112,1,3,6,NPX112,KEY)# Identify string              PX11 165
IF(KEY<=0) iquit:(PX1103)#             Not recognized                   PX11 166
#  FILL   NOFILL CONT   ATLIN  SHADE                                    PX11 167
IF(KEY==1\KEY==2\KEY==6\KEY==8\KEY==9)#                                 PX11 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PX11 169
IF(KEY==1) FILL=yes:#                  Fill atoms                       PX11 170
IF(KEY==2) FILL=no:#                   No fill atoms                    PX11 171
IF(KEY==6) CONTUR=yes:#                If contour then flag as such     PX11 172
IF(KEY==6) FILL=no:#                   No fill conturs                  PX11 173
IF(KEY==9) COLOR=2#                    Black/white shading              PX11 174
IF(KEY==9) FILL=yes:#                  Fill atoms/bonds                 PX11 175
DO I=1,10#                             Loop over additional fields      PX11 176
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PX11 177
IF(BUFIN(J+1)<=voidflg:) BREAK#        Exit if alpha or void            PX11 178
J=J+1#                                 Incr field counter               PX11 179
IF (KEY==8) ALIN(I)=NINT(BUFIN(J))#    Dot-dash type                    PX11 180
ELSE COLR(I)=NINT(BUFIN(J))#           Get colour index                 PX11 181
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PX11 182
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PX11 183
ELSE IF(KEY<6)#                        Bond/char/numb                   PX11 184
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 PX11 185
IF(BUFIN(J+1)<=voidflg:) NEXT#         No colour code given             PX11 186
J=J+1#                                 Incr field counter               PX11 187
IF(KEY==3) BCOL=NINT(BUFIN(J))#        Store bond colour                PX11 188
IF(KEY==4) CCOL=NINT(BUFIN(J))#        Store char colour                PX11 189
IF(KEY==5) NCOL=NINT(BUFIN(J))#        Store numb colour                PX11 190
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 PX11 191
ELSE COLOR=0#                          No colour                        PX11 192
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PX11 193
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PX11 194
#                                                                       PX11 195
ELSE IF(LINID==3)#                     ************** frames line       PX11 196
DO I=1,20#                             Loop over possible frames        PX11 197
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 PX11 198
ifvo:(BUFIN(I)) BREAK#                 Exit when void                   PX11 199
FRAME(I)=NINT(BUFIN(I))#               Store requested frame            PX11 200
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 PX11 201
#                                                                       PX11 202
IF(LINID==4) BREAK#                    ***************** end line       PX11 203
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PX11 204
#                                                                       PX11 205
#    SET PLOT PARAMETERS                                                PX11 206
#    -------------------                                                PX11 207
#                                                                       PX11 208
ifeq:(AWIDE,0.)  AWIDE=WIDE(NDEV)#     Default plot width               PX11 209
ifeq:(AHIGH,0.)  AHIGH=HIGH(NDEV)#     Default plot height              PX11 210
IF(XCEN>99998.)  ICENTR=yes:#          Default auto center              PX11 211
IF(YCEN>99998.)  ICENTR=yes:#          Default auto center              PX11 212
IF(OMAG<.00001)  ISCALE=yes:#          Default no magnification         PX11 213
IF(RESL>99998.)#                       Default resolution               PX11 214
RESL=MIN(1./PIXX(NDEV),1./PIXY(NDEV))# Default resolution               PX11 215
XPIX=PIXX(NDEV); YPIX=PIXY(NDEV)#      Set pixels per unit              PX11 216
IF(COLOR<0) COLOR=COLO(NDEV)#          Set color switch                 PX11 217
IF(COLOR<2) COLOR=MIN0(COLOR,COLO(NDEV))#                               PX11 218
#                                                                       PX11 219
#   PLOT BUFFER INITIALIZATION                                          PX11 220
#   --------------------------                                          PX11 221
#                                                                       PX11 222
IF(NDEV==1) NBUF=(NLINE+1)*NSKIP#      Line printer map stored          PX11 223
ELSE IF(NDEV==2) NBUF=buffr2:#         Set coord buffer size            PX11 224
ELSE IF(NDEV==3) NBUF=buffr3:#         Set coord buffer size            PX11 225
ELSE IF(NDEV==4) NBUF=buffr4:#         Set coord buffer size            PX11 226
ELSE IF(NDEV==5) NBUF=buffr5:#         Set coord buffer size            PX11 227
ELSE IF(NDEV==6) NBUF=buffr6:#         Set coord buffer size            PX11 228
ELSE IF(NDEV==7) NBUF=buffr7:#         Set coord buffer size            PX11 229
ELSE IF(NDEV==8) NBUF=buffr8:#         Set coord buffer size            PX11 230
ELSE IF(NDEV==9) NBUF=buffr9:#         Set coord buffer size            PX11 231
ELSE IF(NDEV==10) NBUF=buffr10:#       Set coord buffer size            PX11 232
ELSE IF(NDEV==11) NBUF=buffr11:#       Set coord buffer size            PX11 233
ELSE IF(NDEV==12) NBUF=buffr12:#       Set coord buffer size            PX11 234
ELSE IF(NDEV==13) NBUF=buffr13:#       Set coord buffer size            PX11 235
ELSE IF(NDEV==14) NBUF=buffr14:#       Set coord buffer size            PX11 236
incrqx:(FULL,MARK+NBUF,PX1105)#        Get x-coord memory               PX11 237
IF(NDEV>1) incrqx:(I,FULL+NBUF,PX1105)# Get y-coord memory              PX11 238
#                                                                       PX11 239
RETURN#                                                                 PX11 240
END#                                                                    PX11 241
systemheader:(PX31)#                   Advance plot frame               PX31   1
####################################################################    PX31   2
#                                                                  #    PX31   3
#                               PX31                               #    PX31   4
#                                                                  #    PX31   5
####################################################################    PX31   6
SUBROUTINE PX31#                                                        PX31   7
include:(AACOMN)#                                                       PX31   8
include:(PXCOMN)#                                                       PX31   9
#                                                                       PX31  10
ifsel:(SLPC)#                                                           PX31  11
INTEGER*2 MUS(4)#                                                       PX31  12
endsel:#                                                                PX31  13
REAL TEM1,TEM2,TEM3,TEM4#              X,y corners of border            PX31  14
#                                                                       PX31  15
#   DRAW BORDER IF REQUESTED                                            PX31  16
#   ------------------------                                            PX31  17
#                                                                       PX31  18
IF(IBRDR==yes:&NF>1)#                  Check for border request         PX31  19
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX31  20
TEM1=+XOFF+2.*XCEN#                    Right boundary                   PX31  21
TEM2=+YOFF+2.*YCEN#                    Upper boundary                   PX31  22
TEM3=-XOFF#                            Left boundary                    PX31  23
TEM4=-YOFF#                            Lower boubdary                   PX31  24
CALL PX01(TEM3,TEM4,3,0)#              Start border                     PX31  25
CALL PX01(TEM3,TEM2,2,-6000)#          Draw border with color           PX31  26
CALL PX01(TEM1,TEM2,2,-6000)#          Draw border with color           PX31  27
CALL PX01(TEM1,TEM4,2,-6000)#          Draw border with color           PX31  28
CALL PX01(TEM3,TEM4,2,-6000)#          Complete the loop                PX31  29
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX31  30
#                                                                       PX31  31
IF(DNAME(1^4)=='POST')FLUSH=yes:#      Flush line buffer - add none     PX31  32
CALL PX01(0.,0.,3,0)#                  Flush the buffer                 PX31  33
#                                                                       PX31  34
IF(NPLOT==IPLOT)#                      This frame is requested          PX31  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX31  36
IF     (NDEV==2) frame2:#              Request new frame for device     PX31  37
ELSE IF(NDEV==3) frame3:#              Request new frame for device     PX31  38
ELSE IF(NDEV==4) frame4:#              Request new frame for device     PX31  39
ELSE IF(NDEV==5) frame5:#              Request new frame for device     PX31  40
ELSE IF(NDEV==6) frame6:#              Request new frame for device     PX31  41
ELSE IF(NDEV==7) frame7:#              ************* pt7 op device      PX31  42
ELSE IF(NDEV==8) frame8:#              ************* pt8 op device      PX31  43
ELSE IF(NDEV==9) frame9:#              ************* pt9 op device      PX31  44
ELSE IF(NDEV==10) frame10:#            ************* pt10 op device     PX31  45
ELSE IF(NDEV==11) frame11:#            ************* pt11 op device     PX31  46
ELSE IF(NDEV==12) frame12:#            ************* pt12 op device     PX31  47
ELSE IF(NDEV==13) frame13:#            ************* pt12 op device     PX31  48
ELSE IF(NDEV==14) frame14:#            ************* pt12 op device     PX31  49
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX31  50
#                                                                       PX31  51
IPLOT=IPLOT+1#                         Count the next plot frame        PX31  52
IF(FRAME(1)==0) NPLOT=IPLOT#           All plot frames requested        PX31  53
ELSE IF(NPLOT<IPLOT)#                  Is request passed                PX31  54
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX31  55
IFRAM=IFRAM+1#                         Count the next request           PX31  56
NPLOT=FRAME(IFRAM)#                    Set next requested plot          PX31  57
IF(NPLOT==0) NF=10#                    Cause plot to end                PX31  58
ELSE IF(NPLOT<IPLOT) iquit:(PX3101)#   Plots out of order               PX31  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX31  60
#                                                                       PX31  61
RETURN#                                                                 PX31  62
END#                                                                    PX31  63
#                                                                       PX31  64
systemheader:(PX41)#                   Draw characters                  PX41   1
####################################################################    PX41   2
#                                                                  #    PX41   3
#                               PX41                               #    PX41   4
#                                                                  #    PX41   5
####################################################################    PX41   6
SUBROUTINE PX41#                                                        PX41   7
include:(AACOMN)#                                                       PX41   8
include:(PXCOMN)#                                                       PX41   9
# -----------------------------------------------------------------     PX41  10
# INPUT PACKET CONTENTS                                                 PX41  11
#                                                                       PX41  12
# DRAW NUMBER  (4)                                                      PX41  13
#     WORD 1       X START OF NUMBER STRING                             PX41  14
#     WORD 2       Y START OF NUMBER STRING                             PX41  15
#     WORD 3       HEIGHT OF SYMBOLS IN INCHES                          PX41  16
#     WORD 4       NUMBER                                               PX41  17
#     WORD 5       ANGLE TO X-AXIS IN DEGREES                           PX41  18
#     WORD 6       NUMBER OF DIGITS AFTER DECIMAL PX.                   PX41  19
#                                                                       PX41  20
# DRAW CHARACTER (5)                                                    PX41  21
#     WORD 1       X START OF CHARACTER STRING                          PX41  22
#     WORD 2       Y START OF CHARACTER STRING                          PX41  23
#     WORD 3       HEIGHT OF SYMBOLS IN INCHES                          PX41  24
#     WORD 4       ANGLE TO X-AXIS IN DEGREES                           PX41  25
#     WORD 5       NUMBER OF CHARACTERS IN STRING (<73)                 PX41  26
#     WORD 6       DRAW OR SKIP BLANKS                                  PX41  27
#                                                                       PX41  28
# ---------------------------------------------------------------       PX41  29
#                                                                       PX41  30
REAL    DELX,DELY#                     Stepsize in x,y                  PX41  31
REAL    FMT#                           Format                           PX41  32
REAL    HT#                            Char/numb heigth                 PX41  33
INTEGER I,II,JJ#                                                        PX41  34
INTEGER GREEK,SPFLAG,ITALIC#           Flags for greek/offset lett      PX41  35
INTEGER KEY#                           Compchar key                     PX41  36
INTEGER LCAR#                          Count of output characters       PX41  37
INTEGER NBLA#                          0/1 draw blank/skip blanks       PX41  38
string:(NCAR,72)#                      Character string to be plotted   PX41  39
INTEGER NS#                            Number of char in string         PX41  40
INTEGER SINDX#                         Subject index                    PX41  41
INTEGER PSIZE#                         Packet size                      PX41  42
REAL    TH#                            Angle to x-axis in degrees       PX41  43
REAL    X,Y#                           Start of char/numb string        PX41  44
#                                                                       PX41  45
chardata:(PX410,"ABCDEFGHIJKLMNOPQRSTUVWXYZ$#                           PX41  46
abcdefghijklmnopqrstuvwxyz")## ****Warning:Do not alter order of PX41   PX41  47
chardata:(PX411,'0123456789+-*/()=,.!%Q^~ |')# Numbers and special sy   PX41  48
chardata:(PX412, REPLACE UNAVAILABLE SPECIAL CHARACTER)#                PX41  49
datastuff:#                                                             PX41  50
PX411(22^22)=''''#                     Add prime                        PX41  51
#                                                                       PX41  52
#   PROCESS CHAR AND NUMB PACKETS                                       PX41  53
#   -----------------------------                                       PX41  54
#                                                                       PX41  55
GREEK=no:; ITALIC=no:; SPFLAG=0#       Initialize greek/super/sub       PX41  56
X=QX(JP+1);   Y=QX(JP+2)#              Start x,y of char string         PX41  57
HT=QX(JP+3)#                           Extract char height              PX41  58
NF=NINT(QX(JP+7))#                     Extract function code            PX41  59
#                                                                       PX41  60
IF(NF==4)#                             ************* process number     PX41  61
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX41  62
NCAR=' '#                                                               PX41  63
SINDX=-4000.#                          Set colour index                 PX41  64
TH=QX(JP+5)#                           Extract angle to x-axis          PX41  65
NS=10;   NBLA=0#                       Number of chars & blanks         PX41  66
ifne:(QX(JP+6),0.) FMT=QX(JP+6)#       Format the number                PX41  67
ELSE               FMT=101003.#        Format the number                PX41  68
ncodefld:(QX,JP+4,NCAR,FMT,1)#         Store number as chars            PX41  69
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX41  70
#                                                                       PX41  71
ELSE IF(NF==5)#                        ************* process string     PX41  72
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX41  73
SINDX=-5000.#                          Set colour index                 PX41  74
TH=QX(JP+4)#                           Extract angle to x-axis          PX41  75
NS=MAX(MIN(72,NINT(QX(JP+5))),1)#      Extract char string length       PX41  76
NBLA=NINT(QX(JP+6))#                   Extract number of blanks         PX41  77
FOR(II=1;II<=NS;II=II+arith:(7,*,mxchwd:))# Loop over char string       PX41  78
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX41  79
JJ=MIN0(NS-II+1,arith:(7,*,mxchwd:))#  Number of chars to transfer      PX41  80
readwpkt:(5,23,PSIZE,JP,0)#            Read a packet of characters      PX41  81
movertoc:(QX(JP+1),1,NCAR,II,JJ,0)#    Transfer characters              PX41  82
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX41  83
REPEAT#                                Get non-blank string length      PX41  84
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PX41  85
IF(NS==0) BREAK#                       Break if string is all blanks    PX41  86
IF(NCAR(NS^NS)!=' ')BREAK#             Non blank character              PX41  87
NS=NS-1#                               Skip trailing blank              PX41  88
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PX41  89
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX41  90
#                                                                       PX41  91
# NORMAL SYMBOLS                                                        PX41  92
# --------------                                                        PX41  93
#                                                                       PX41  94
IF(NS>0)#                              Normal symbol for ns pos.        PX41  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PX41  96
IF(DNAME(1^4)=='POST')FLUSH=yes:#      Flush line buffer - add none     PX41  97
CALL PX01(X,Y,3,0)#                    Start new subject;pen up         PX41  98
IWIWIW=1#                              Test print flag                  PX41  99
IF     (NDEV==1) noop:#                Draw chars                       PX41 100
ELSE IF(NDEV==2)ptext2:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 101
ELSE IF(NDEV==3)ptext3:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 102
ELSE IF(NDEV==4)ptext4:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 103
ELSE IF(NDEV==5)ptext5:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 104
ELSE IF(NDEV==6)ptext6:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 105
ELSE IF(NDEV==7)ptext7:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 106
ELSE IF(NDEV==8)ptext8:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 107
ELSE IF(NDEV==9)ptext9:(X,Y,HT,TH,NS,NCAR)# Draw characters             PX41 108
ELSE IF(NDEV==10)ptext10:(X,Y,HT,TH,NS,NCAR)# Draw characters           PX41 109
ELSE IF(NDEV==11)ptext11:(X,Y,HT,TH,NS,NCAR)# Draw characters           PX41 110
ELSE IF(NDEV==12)ptext12:(X,Y,HT,TH,NS,NCAR)# Draw characters           PX41 111
ELSE IF(NDEV==13)ptext13:(X,Y,HT,TH,NS,NCAR)# Draw characters           PX41 112
ELSE IF(NDEV==14)ptext14:(X,Y,HT,TH,NS,NCAR)# Draw characters           PX41 113
#                                                                       PX41 114
IF(IWIWIW==0)#                         If chars plotted                 PX41 115
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PX41 116
DELY=HT*COS(TH*.017453)/7.#            Step size in y                   PX41 117
DELX=HT*SIN(TH*.017453)/7.#            Step size in x                   PX41 118
#                                                                       PX41 119
LCAR=0#                                Count output char                PX41 120
DO I=1,NS#                             Loop over charcaters             PX41 121
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PX41 122
KEY = INDEX(PX410,NCAR(I^I))#          Check standard characters        PX41 123
IF(KEY==0)#                                                             PX41 124
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  PX41 125
KEY = INDEX(PX411,NCAR(I^I))#          Must be number or symbol         PX41 126
IF(KEY==0) KEY= 64#                    Is not recognised therefore      PX41 127
ELSE KEY = KEY +52#                    Otherwise is in second list      PX41 128
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  PX41 129
#                                                                       PX41 130
# SET SPECIAL CHARACTER FLAGS                                           PX41 131
# ---------------------------                                           PX41 132
#                                                                       PX41 133
IF(KEY==78 )#                          Flag for italics                 PX41 134
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  PX41 135
IF (ITALIC == yes:) ITALIC =no:#       End of italics                   PX41 136
ELSE ITALIC=yes:#                      Beginning of italics             PX41 137
NEXT#                                  Find next character              PX41 138
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  PX41 139
IF(KEY==73 & GREEK  != yes:)#          Is flag for greek character      PX41 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 PX41 141
GREEK = yes:#                          Set greeks flag                  PX41 142
NEXT#                                  Find next character              PX41 143
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 PX41 144
IF((KEY==75\KEY==76)&SPFLAG==0)#       Now flag subscript               PX41 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 PX41 146
SPFLAG = 2*(75.5 - KEY)#               -1/+1 for super/subscript        PX41 147
NEXT#                                  Get next character               PX41 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 PX41 149
IF(KEY!=77)#                           Not a space                      PX41 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 PX41 151
IF(GREEK==yes:)#                       If is greek                      PX41 152
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 PX41 153
KEY = KEY+76#                          Print greek character            PX41 154
GREEK = no:#                           Reinitialise flag                PX41 155
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 PX41 156
CALL PX42(KEY,X,Y,DELX,DELY,LCAR,SINDX,SPFLAG,ITALIC)# Draw num or ch   PX41 157
SPFLAG = 0#                            Reinitialise spflag              PX41 158
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 PX41 159
ELSE IF(NBLA!=0) LCAR=LCAR-1#          Skip blanks in output            PX41 160
LCAR=LCAR+1#                           Add up one output char           PX41 161
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PX41 162
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PX41 163
#                                                                       PX41 164
# SPECIAL SYMBOLS                                                       PX41 165
# ---------------                                                       PX41 166
#                                                                       PX41 167
ELSE IF(NS<0)#                         Special symbol                   PX41 168
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 PX41 169
IF(NS<-15)#                            Initial move pen down            PX41 170
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 PX41 171
KEY=NS+15#                             Special symbol number            PX41 172
CALL PX01(X,Y,2,-5000)#                Move to symbol center            PX41 173
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 PX41 174
ELSE#                                  Initial move pen up              PX41 175
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 PX41 176
KEY=NS#                                Special symbol number            PX41 177
CALL PX01(X,Y,3,-5000)#                Move to symbol center            PX41 178
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 PX41 179
IF(KEY<-15)#                           No symbol for that number        PX41 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 PX41 181
writeline:(1,PX412,NPX412,3,3)#        Message to user                  PX41 182
KEY=-15#                               Replace with star                PX41 183
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 PX41 184
X=X-2.*DELY+2.*DELX#                   New x                            PX41 185
Y=Y-2.*DELX-2.*DELY#                   New y                            PX41 186
CALL PX42(KEY,X,Y,DELX,DELY,0,SINDX,0,no:)# Draw the symbol             PX41 187
X=X+2.*DELY-2.*DELX#                   Reset x                          PX41 188
Y=Y+2.*DELX+2.*DELY#                   Reset y                          PX41 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 PX41 190
IF(DNAME(1^4)!='POST')CALL PX01(X,Y,3,0)# Skip postscript garbage       PX41 191
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PX41 192
#                                                                       PX41 193
RETURN#                                                                 PX41 194
END#                                                                    PX41 195
systemheader:(PX42)#                   Draw a character symbol          PX42   1
####################################################################    PX42   2
#                                                                  #    PX42   3
#                           PX42 -- PLOTSY                         #    PX42   4
#                                                                  #    PX42   5
####################################################################    PX42   6
SUBROUTINE PX42(N,X,Y,DELX,DELY,LCAR,SINDX,SPFLAG,ITALIC)#              PX42   7
include:(PXCOMN)#                                                       PX42   8
macro:(mvchr:,movereal:($1,$2*20+1,NTABCH,1,20,0))#                     PX42   9
#                                      J. hester apr 1990               PX42  10
REAL    DELX#       ## STEPSIZE IN X-DIRECTION                          PX42  11
REAL    DELY#       ## STEPSIZE IN Y-DIRECTION                          PX42  12
REAL    DX#         ## X RELATIVE TO STRING ORIGIN                      PX42  13
REAL    DXC#        ## X RELATIVE TO CHAR/NUMB ORIGIN                   PX42  14
REAL    DY#         ## Y RELATIVE TO STRING ORIGIN                      PX42  15
REAL    DYC#        ## Y RELATIVE TO CHAR/NUMB ORIGIN                   PX42  16
REALOFFSTX#         ## offset in x direction                            PX42  17
REALOFFSTY#         ## offset in y direction                            PX42  18
INTEGER SPFLAG#     ## FLAG FOR SUPER/SUBSCRIPT                         PX42  19
INTEGER ITALIC#     ## FLAG FOR ITALICS                                 PX42  20
INTEGER LCAR#       ## CHAR/NUMB NUMBER - 1                             PX42  21
INTEGER N,NA,ND#    ##                                                  PX42  22
INTEGER NTABCH(20)# ## ARRAY TO HOLD CURRENT CHAR VECTORS               PX42  23
INTEGER II#         ## LOOP VARIABLES                                   PX42  24
INTEGER IVEC#       ## ENCODED VECTOR                                   PX42  25
INTEGER PEN#        ## 2/3 FOR PEN DOWN/UP                              PX42  26
INTEGER SINDX#      ## SUBJECT INDEX                                    PX42  27
INTEGER IX,IY#      ## TRANS X,Y GRID COORDINATES OF PLOT VECTOR        PX42  28
REALXV,YV#          ## TRUE  GRID COORDINATES                           PX42  29
REAL    X#          ## X OF STRING ORIGIN                               PX42  30
REAL    Y#          ## Y OF STRING ORIGIN                               PX42  31
#                                                                       PX42  32
## TABCH? TABLE REFERS TO CHARACTERS                                    PX42  33
#                                                                       PX42  34
intdata:(TABCH1,[$#                    Upper case abcdefghi             PX42  35
7,65,73,75,69,27,144,48,0,0,0,0,0,0,0,0,0,0,0,0,#                       PX42  36
11,72,75,69,62,54,51,154,48,34,26,23, 0,0,0,0,0,0,0,0,#                 PX42  37
8,169,75,73,65,30,24,26,34,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  38
6,72,75,69,34,26,23,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  39
6,127,23,72,76,151,55,0,0,0,0,0,0,0,0,0,0,0,0,0,#                       PX42  40
4,72,76,151,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42  41
12,169,75,73,65,30,24,26,34,41,47,146,48,0,0,0,0,0,0,0,#                PX42  42
5,72,176,27,151,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  43
6,124,26,125,74,173,75,0,0,0,0,0,0,0,0,0,0,0,0,0])#                     PX42  44
#                                                                       PX42  45
intdata:(TABCH2,[$#                    Upper case jklmnopqr             PX42  46
7,130,24,25,33,75,172,76,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  47
5,72,144,76,152,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  48
3,172,23,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42  49
4,72,53,76,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42  50
3,72,27,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                            PX42  51
9,130,65,73,75,69,34,26,24,30,0,0,0,0,0,0,0,0,0,0,#                     PX42  52
6,72,75,69,62,54,51,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  53
11,130,65,73,75,69,34,26,24,30,139,27,0,0,0,0,0,0,0,0,#                 PX42  54
8,72,75,69,62,54,51,153,27,0,0,0,0,0,0,0,0,0,0,0])#                     PX42  55
#                                                                       PX42  56
intdata:(TABCH3,[$#                    Upper case   stuvwxyza           PX42  57
 12,169,75,73,65,58,52,47,41,34,26,24,30,0,0,0,0,0,0,0,#                PX42  58
4,172,76,174,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  59
6,172,30,24,26,34,76,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  60
3,172,25,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42  61
5,172,24,46,26,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  62
4,172,27,176,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  63
5,172,53,76,153,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  64
4,172,76,23,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42  65
11,133,25,24,30,44,52,53,47,154,26,27,0,0,0,0,0,0,0,0])#                PX42  66
#                                                                       PX42  67
intdata:(TABCH4,[$#                    Lower case bcdefghij             PX42  68
 9,72,144,52,53,47,33,25,24,30,0,0,0,0,0,0,0,0,0,0,#                    PX42  69
8,147,53,52,44,30,24,25,33,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  70
10,133,25,24,30,44,52,53,47,175,26,0,0,0,0,0,0,0,0,0,#                  PX42  71
10,137,40,47,53,52,44,30,24,25,33,0,0,0,0,0,0,0,0,0,#                   PX42  72
7,169,75,74,66,24,151,53,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  73
13,133,25,24,30,44,52,53,47,154,12,4,3,9,0,0,0,0,0,0,#                  PX42  74
8,72,144,52,53,47,40,33,26,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  75
7,123,25,124,52,51,159,59,0,0,0,0,0,0,0,0,0,0,0,0,#                     PX42  76
8,161,61,153,54,12,4,3,9,0,0,0,0,0,0,0,0,0,0,0])#                       PX42  77
#                                                                       PX42  78
intdata:(TABCH5,[$#                    Lower case  k l m n o p q r s    PX42  79
 6,72,137,38,26,138,54,0,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  80
5,172,73,24,123,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  81
9,51,144,52,46,25,146,54,48,27,0,0,0,0,0,0,0,0,0,0,#                    PX42  82
6,51,144,52,53,47,26,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  83
9,130,44,52,53,47,33,25,24,30,0,0,0,0,0,0,0,0,0,0,#                     PX42  84
10,151,2,144,52,53,47,33,25,24,30,0,0,0,0,0,0,0,0,0,#                   PX42  85
11,130,44,52,53,47,33,25,24,30,154,5,0,0,0,0,0,0,0,0,#                  PX42  86
5,51,144,52,53,47,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  87
10,130,24,26,34,40,38,44,52,54,48,0,0,0,0,0,0,0,0,0])#                  PX42  88
#                                                                       PX42  89
intdata:(TABCH6,[$#                    Lower case t u v w x y z 0 1     PX42  90
 6,173,31,25,26,151,54,0,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42  91
8,151,30,24,25,33,154,26,27,0,0,0,0,0,0,0,0,0,0,0,#                     PX42  92
6,151,37,24,25,40,54,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42  93
9,151,30,24,32,46,132,26,34,55,0,0,0,0,0,0,0,0,0,0,#                    PX42  94
4,151,26,154,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42  95
11,151,30,24,25,33,54,133,12,4,3,9,0,0,0,0,0,0,0,0,#                    PX42  96
4,151,54,23,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42  97
11,130,65,73,75,69,34,26,24,30,123,76,0,0,0,0,0,0,0,0,#                 PX42  98
5,166,74,25,124,26,0,0,0,0,0,0,0,0,0,0,0,0,0,0])#                       PX42  99
#                                                                       PX42 100
intdata:(TABCH7,[$#                    2 3 4 5 6 7 8 9 +                PX42 101
 8,165,73,75,69,62,30,23,27,0,0,0,0,0,0,0,0,0,0,0,#                     PX42 102
13,165,73,75,69,62,54,52,154,48,34,26,24,30,0,0,0,0,0,0,#               PX42 103
4,126,75,37,41,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 104
9,130,24,26,34,48,54,51,72,76,0,0,0,0,0,0,0,0,0,0,#                     PX42 105
12,169,75,73,65,30,24,26,34,48,54,52,44,0,0,0,0,0,0,0,#                 PX42 106
5,165,72,76,69,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 107
16,152,44,30,24,26,34,48,54,52,58,65,73,75,69,62,54,0,0,0,#             PX42 108
12,130,24,26,34,69,75,73,65,51,45,47,55,0,0,0,0,0,0,0,#                 PX42 109
4,160,32,144,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])#                        PX42 110
#                                                                       PX42 111
intdata:(TABCH8,[$#                    - * / ( ) = , . !                PX42 112
 2,144,48,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42 113
8,160,32,144,48,158,34,130,62,0,0,0,0,0,0,0,0,0,0,0,#                   PX42 114
1,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                              PX42 115
4,173,65,30,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 116
4,172,66,31,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 117
4,144,48,130,34,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 118
6,30,31,24,23,124,16,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 119
4,30,31,24,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42 120
9,124,26,33,31,24,139,75,73,39,0,0,0,0,0,0,0,0,0,0])#                   PX42 121
#                                                                       PX42 122
intdata:(TABCH9,[$#                    % '  ^ ~ upper case (alpha)      PX42 123
12,165,72,73,66,65,126,33,34,27,26,123,76,0,0,0,0,0,0,0,#               PX42 124
4,172,58,73,72,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 125
3,158,74,62,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42 126
4,144,52,46,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 127
7,65,73,75,69,27,144,48,0,0,0,0,0,0,0,0,0,0,0,0,#                       PX42 128
11,72,75,69,62,54,51,154,48,34,26,23,0,0,0,0,0,0,0,0,#                  PX42 129
4,172,27,176,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 130
3,74,27,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                            PX42 131
6,127,23,72,76,151,55,0,0,0,0,0,0,0,0,0,0,0,0,0])#                      PX42 132
#                                                                       PX42 133
##(beta) (epsilon) (eta) (iota) (ascii j) (kappa) (lambda) (mu)         PX42 134
##(nu)                                                                  PX42 135
intdata:(TABC10,[$#                                                     PX42 136
15,131,37,58,66,68,62,41,33,31,124,26,125,74,173,75,0,0,0,0,#           PX42 137
5,172,76,69,173,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 138
5,72,176,27,151,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 139
6,124,26,125,74,173,75,0,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42 140
7,130,24,25,33,75,172,76,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42 141
5,72,144,76,152,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 142
2,74,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                             PX42 143
4,72,53,76,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                           PX42 144
3,72,27,76,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])#                           PX42 145
#                                                                       PX42 146
#(OMICRON) (PI) (THETA) (RHO) (SIGMA) (TAU) (UPSILON)                   PX42 147
#(...ANGSTROM...) (OMEGA)                                               PX42 148
intdata:(TABC11,[$#                                                     PX42 149
9,130,65,73,75,69,34,26,24,30,0,0,0,0,0,0,0,0,0,0,#                     PX42 150
8,124,73,165,72,76,69,175,26,0,0,0,0,0,0,0,0,0,0,0,#                    PX42 151
15,124,30,65,73,75,69,34,26,24,159,45,152,54,161,47,0,0,0,0,#           PX42 152
6,72,75,69,62,54,51,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 153
7,134,27,23,53,72,76,69,0,0,0,0,0,0,0,0,0,0,0,0,#                       PX42 154
4,172,76,174,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 155
5,172,53,76,153,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 156
11,44,74,48,27,148,44,174,80,88,82,74,0,0,0,0,0,0,0,0,#                 PX42 157
12,130,23,24,37,58,73,75,62,41,26,27,34,0,0,0,0,0,0,0])#                PX42 158
#                                                                       PX42 159
#(XI) (PSI) (ZETA) LOWER CASE (ALPHA) (BETA) (CHI) (DELTA) (EPSILON)    PX42 160
#          (PHI)                                                        PX42 161
intdata:(TABC12,[$#                                                     PX42 162
10,130,23,27,34,152,54,165,72,76,69,0,0,0,0,0,0,0,0,0,#                 PX42 163
12,172,51,45,47,55,76,124,26,125,74,173,75,0,0,0,0,0,0,0,#              PX42 164
4,172,76,23,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 165
10,155,33,25,24,30,44,52,53,47,27,0,0,0,0,0,0,0,0,0,#                   PX42 166
13,109,58,66,67,61,53,52,153,47,33,25,24,30,0,0,0,0,0,0,#               PX42 167
6,158,66,26,27,123,69,0,0,0,0,0,0,0,0,0,0,0,0,0,#                       PX42 168
13,153,52,44,30,24,25,33,47,53,58,65,67,61,0,0,0,0,0,0,#                PX42 169
11,133,25,24,30,38,39,138,44,52,53,47, 0,0,0,0,0,0,0,0,#                PX42 170
11,124,30,44,52,54,48,34,26,24,167,11, 0,0,0,0,0,0,0,0])#               PX42 171
#                                                                       PX42 172
#LOWER CASE (GAMMA) (ETA) (IOTA) (ASCII J) (KAPPA) (LAMBDA)             PX42 173
#           (MU)                                                        PX42 174
#  (NU) (OMICRON)                                                       PX42 175
intdata:(TABC13,[$#                                                     PX42 176
8,151,44,26,19,11,25,41,55, 0,0,0,0,0,0,0,0,0,0,0,#                     PX42 177
6,51,144,52,53,47,12,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 178
5,124,26,125,53,52,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 179
8,161,61,153,54,12,4,3,9,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 180
6,51,147,53,37,25,26,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 181
6,53,165,66,53,33,27,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 182
10,109,51,130,24,25,33,54,133,26,27,0,0,0,0,0,0,0,0,0,#                 PX42 183
5,151,24,33,48,54,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 184
9,124,30,44,52,53,47,33,25,24,0,0,0,0,0,0,0,0,0,0])#                    PX42 185
#                                                                       PX42 186
# LOWER CASE (PI) (THETA) (RHO) (SIGMA) (TAU)                           PX42 187
#          (UPSILON) (ASCII V) (OMEGA) (XI)                             PX42 188
intdata:(TABC14,[$#                                                     PX42 189
8,124,52,144,51,55,48,154,26,0,0,0,0,0,0,0,0,0,0,0,#                    PX42 190
11,124,37,51,66,68,55,41,26,24,144,48, 0,0,0,0,0,0,0,0,#                PX42 191
9,109,44,52,53,47,33,25,24,30,0,0,0,0,0,0,0,0,0,0,#                     PX42 192
9,153,47,33,25,24,30,44,52,55,0,0,0,0,0,0,0,0,0,0,#                     PX42 193
8,144,51,55,48,153,25,26,34,0,0,0,0,0,0,0,0,0,0,0,#                     PX42 194
6,151,30,24,25,33,54,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 195
6,151,37,24,25,40,54,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 196
11,152,44,30,24,32,39,132,26,34,48,54, 0,0,0,0,0,0,0,0,#                PX42 197
15,158,60,68,67,51,45,46,145,37,30,24,25,19,11,10,0,0,0,0])#            PX42 198
#                                                                       PX42 199
# LOWER CASE (PSI) (ZETA)                                               PX42 200
intdata:(TABC15,[$#                                                     PX42 201
8,151,30,24,26,34,55,167,11,0,0,0,0,0,0,0,0,0,0,0,#                     PX42 202
12,158,60,68,67,59,37,30,24,25,19,11,10,0,0,0,0,0,0,0])#                PX42 203
#                                                                       PX42 204
# SPECIAL CENTRED SYMBOLS (0 TO 8)                                      PX42 205
intdata:(TABC16,[$#                                                     PX42 206
7,139,53,51,23,27,55,53,0,0,0,0,0,0,0,0,0,0,0,0,#                       PX42 207
11,139,53,52,44,30,24,26,34,48,54,53,0,0,0,0,0,0,0,0,#                  PX42 208
5,139,53,30,34,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 209
4,137,41,153,25,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 210
4,151,27,123,55,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 211
6,139,53,37,25,41,53,0,0,0,0,0,0,0,0,0,0,0,0,0,#                        PX42 212
5,125,53,37,41,53,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 213
4,123,55,51,27,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                          PX42 214
4,127,23,55,51,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0])#                         PX42 215
#                                                                       PX42 216
# SPECIAL CENTRED SYMBOLS (9 TO 14)                                     PX42 217
intdata:(TABC17,[$#                                                     PX42 218
6,139,51,139,55,139,25,0,0,0,0,0,0,0,0,0,0,0,0,0,#                      PX42 219
13,139,55,147,45,31,33,47,145,51,131,23,133,27,0,0,0,0,0,0,#            PX42 220
8,123,55,151,27,137,41,125,53,0,0,0,0,0,0,0,0,0,0,0,#                   PX42 221
5,123,27,51,55,23,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                         PX42 222
2,132,46,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,#                            PX42 223
6,153,24,48,44,26,53,0,0,0,0,0,0,0,0,0,0,0,0,0])#                       PX42 224
datastuff:#                                                             PX42 225
##                                                                      PX42 226
OFFSTX = -SPFLAG*3*DELX#               Calculate offset                 PX42 227
OFFSTY = SPFLAG*3*DELY#                Calculate offset                 PX42 228
IF(N>127) N = N - 76#                  If n too large, make normal      PX42 229
IF(N<0)   N =135 - N#                  Special centred symbols          PX42 230
##                                                                      PX42 231
## Find Origin for this character                                       PX42 232
#                                                                       PX42 233
DXC=FLOAT(LCAR)*6.*DELY+OFFSTX#        X - origin of char/numb          PX42 234
DYC=FLOAT(LCAR)*6.*DELX+OFFSTY#        Y - origin of char/numb          PX42 235
PEN=3#                                 Start with pen up                PX42 236
CALL PX01(X+DXC,Y+DYC,PEN,SINDX)#      Move pen to character origin     PX42 237
#                                                                       PX42 238
# FIND CORRECT TABLE                                                    PX42 239
# ---------------------                                                 PX42 240
#                                                                       PX42 241
NA = INT((N-1)/9)+1#                   Number of array                  PX42 242
ND = N - (NA-1)*9 -1#                  Position in array                PX42 243
IF(NA==1) mvchr:(TABCH1,ND)#           Table 1                          PX42 244
ELSEIF(NA==2) mvchr:(TABCH2,ND)#       Table 2                          PX42 245
ELSEIF(NA==3) mvchr:(TABCH3,ND)#       Table 3                          PX42 246
ELSEIF(NA==4) mvchr:(TABCH4,ND)#       Table 4                          PX42 247
ELSEIF(NA==5) mvchr:(TABCH5,ND)#       Table 5                          PX42 248
ELSEIF(NA==6) mvchr:(TABCH6,ND)#       Table 6                          PX42 249
ELSEIF(NA==7) mvchr:(TABCH7,ND)#       Table 7                          PX42 250
ELSEIF(NA==8) mvchr:(TABCH8,ND)#       Table 8                          PX42 251
ELSEIF(NA==9) mvchr:(TABCH9,ND)#       Table 9                          PX42 252
ELSEIF(NA==10) mvchr:(TABC10,ND)#      Table 10                         PX42 253
ELSEIF(NA==11) mvchr:(TABC11,ND)#      Table 11                         PX42 254
ELSEIF(NA==12) mvchr:(TABC12,ND)#      Table 12                         PX42 255
ELSEIF(NA==13) mvchr:(TABC13,ND)#      Table 13                         PX42 256
ELSEIF(NA==14) mvchr:(TABC14,ND)#      Table 14                         PX42 257
ELSEIF(NA==15) mvchr:(TABC15,ND)#      Table 15                         PX42 258
ELSEIF(NA==16) mvchr:(TABC16,ND)#      Table 16                         PX42 259
ELSEIF(NA==17) mvchr:(TABC17,ND)#      Table 17                         PX42 260
#                                                                       PX42 261
FOR(II= 2;II<2 + NTABCH(1);II=II+1)#   Loop over vectors                PX42 262
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX42 263
IF(NTABCH(II) > 100)#                                                   PX42 264
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX42 265
PEN  = 3#                              Is a move; pen up                PX42 266
IVEC = NTABCH(II)-100#                 Find move destination            PX42 267
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX42 268
ELSE#                                                                   PX42 269
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX42 270
PEN  = 2#                              Pen down for drawing             PX42 271
IVEC = NTABCH(II)#                     Copy vector                      PX42 272
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX42 273
IY = INT(IVEC/7)#                      Find y position                  PX42 274
IX = IVEC-7*IY#                        Find x position                  PX42 275
XV = FLOAT(IX-2)#                      Translate to grid                PX42 276
IF (ITALIC == yes:) XV=XV+2.*FLOAT(IY)/7.#                              PX42 277
YV = FLOAT(IY-3)#                      Y grid coord                     PX42 278
DX = XV*DELY-YV*DELX + DXC#            Total character movement         PX42 279
DY = XV*DELX+YV*DELY + DYC#            Total character movement         PX42 280
CALL PX01(X+DX,Y+DY,PEN,SINDX)#        Plot                             PX42 281
PEN=2#                                 Next movement pen down           PX42 282
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX42 283
#                                                                       PX42 284
RETURN#                                                                 PX42 285
END#                                                                    PX42 286
systemheader:(PX51)#                   Auto center and scale            PX51   1
####################################################################    PX51   2
#                                                                  #    PX51   3
#                                PX51                              #    PX51   4
#                                                                  #    PX51   5
####################################################################    PX51   6
SUBROUTINE PX51#                                                        PX51   7
include:(AACOMN)#                                                       PX51   8
include:(PXCOMN)#                                                       PX51   9
# ------------------------------------------------------------------    PX51  10
# INPUT PACKET -- AUTO CENTER AND SCALE (6)                             PX51  11
#                                                                       PX51  12
#     WORD 1       FRAME WIDTH                                          PX51  13
#     WORD 2       FRAME HEIGHT                                         PX51  14
#     WORD 3       STEREO FLAG (2=YES 1=NO)                             PX51  15
#     WORD 4       INTERNAL SCALE                                       PX51  16
#     WORD 5       MAXIMUM X-SPAN OF SUBJECT                            PX51  17
#     WORD 6       MAXIMUM Y-SPAN OF SUBJECT                            PX51  18
#                                                                       PX51  19
# ------------------------------------------------------------------    PX51  20
#                                                                       PX51  21
INTEGER I#                                                              PX51  22
chardata:(PX510," PLOTX Control Parameters")#                           PX51  23
chardata:(PX512,[" Plot device name                           "])#      PX51  24
chardata:(PX513,[" Plot max dimn. in  x,y                     "])#      PX51  25
chardata:(PX514,[" Plot max dimn. out x,y                     "])#      PX51  26
chardata:(PX515,[" Plot pixels/unit   x,y                     "])#      PX51  27
chardata:(PX516,[" Plot center        x,y                     "])#      PX51  28
chardata:(PX517,[" Plot scale applied                         "])#      PX51  29
chardata:(PX518,-)#                                                     PX51  30
chardata:(PX51A,[" Color bond,char,numb                       "])#      PX51  31
chardata:(PX51B,[" Color atoms                                    "])#  PX51  32
chardata:(PX51C,[" Color contours                             "])#      PX51  33
realdata:(FMT,[300313.,330313.,360313.,390313.,#                        PX51  34
420313.,450313.,480313.,510313.,#                                       PX51  35
540313.,570313.,600313.,630313.,#                                       PX51  36
660313.,690313.,720313.,750313.])#                                      PX51  37
datastuff:#                                                             PX51  38
#                                                                       PX51  39
#   APPLY CENTRE VALUES                                                 PX51  40
#   -------------------                                                 PX51  41
#                                                                       PX51  42
IF(ICENTR==yes:)#                      Auto centering necessary         PX51  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX51  44
ifeq:(QX(JP+1),QX(JP+5),.1)OLDPLT=yes:# Catch the old plots that esca   PX51  45
ifeq:(QX(JP+2),QX(JP+6),.1)OLDPLT=yes:# Flag as an old style plot       PX51  46
IF(OLDPLT==yes:)#                      Use the old scale mechanism      PX51  47
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX51  48
XCEN=QX(JP+1)*0.5#                     Get x-coord of center            PX51  49
YCEN=QX(JP+2)*0.5#                     Get y-coord of center            PX51  50
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX51  51
ELSE#                                  Use the new scale mechanism      PX51  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX51  53
XCEN=QX(JP+5)+QX(JP+1)*0.5#            Get x-coord of center            PX51  54
YCEN=QX(JP+6)+QX(JP+2)*0.5#            Get y-coord of center            PX51  55
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX51  56
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX51  57
#                                                                       PX51  58
#    SET SCALING TERMS                                                  PX51  59
#    -----------------                                                  PX51  60
#                                                                       PX51  61
IF(ISCALE==yes:)#                      Auto scaling necessary           PX51  62
OMAG=AMIN1(AWIDE/QX(JP+1),AHIGH/QX(JP+2))# Scale op device              PX51  63
XOFF=0.5*AWIDE/OMAG-XCEN#              Calc x offset                    PX51  64
YOFF=0.5*AHIGH/OMAG-YCEN#              Calc y offset                    PX51  65
TSCALE=11./QX(JP+2)#                   Scale to put postscript text     PX51  66
#                                      Of arbitrary dimension figures   PX51  67
#                                      On the 11 inch standard scale    PX51  68
#                                                                       PX51  69
#   PRINT PLOT PARAMETERS                                               PX51  70
#   ---------------------                                               PX51  71
#                                                                       PX51  72
movechar:(PX518,1,CHROT,2,NPX510-1,2)# Insert underline                 PX51  73
writeline:(1,PX510,NPX510,2,3)#        Print header                     PX51  74
movechar:(DNAME,1,PX512,39,6,0)#       Insert device code               PX51  75
writeline:(0,PX512,NPX512,3,3)#        Print device code                PX51  76
ncodefld:(QX,JP+1,PX513,330512.,1)#    Format input max x               PX51  77
ncodefld:(QX,JP+2,PX513,430512.,1)#    Format input max y               PX51  78
writeline:(0,PX513,NPX513,3,3)#        Print x,y                        PX51  79
ncodefld:(XCEN,1,PX516,330522.,1)#     Format centre x                  PX51  80
ncodefld:(YCEN,1,PX516,430522.,1)#     Format centre y                  PX51  81
writeline:(0,PX516,NPX516,3,3)#        Print centre x,y                 PX51  82
ncodefld:(OMAG,1,PX517,330842.,1)#     Format scale                     PX51  83
writeline:(0,PX517,NPX517,3,3)#        Print scale                      PX51  84
ncodefld:(AWIDE,1,PX514,330512.,1)#    Format output max x              PX51  85
ncodefld:(AHIGH,1,PX514,430512.,1)#    Format output max y              PX51  86
writeline:(0,PX514,NPX514,3,3)#        Print x,y                        PX51  87
ncodefld:(XPIX,1,PX515,330612.,1)#     Format pix/in x                  PX51  88
ncodefld:(YPIX,1,PX515,430612.,1)#     Format pix/in y                  PX51  89
writeline:(0,PX515,NPX515,3,3)#        Print pixels x,y                 PX51  90
#                                                                       PX51  91
#   PRINT COLOR PARAMETERS                                              PX51  92
#   ----------------------                                              PX51  93
#                                                                       PX51  94
IF(COLOR!=0)#                          If color graphics                PX51  95
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PX51  96
DO I=1,6; BUFOT(I)=FLOAT(COLR(I))#     Float atom colour indices        PX51  97
IF(CONTUR==yes:)#                      Output for contour plot          PX51  98
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PX51  99
ncodefld:(BUFOT,1,PX51C,FMT,5)#        Format contour indices           PX51 100
ncodefld:(FLOAT(CCOL),1,PX51C,FMT(6),1)# Load char colour               PX51 101
writeline:(0,PX51C,NPX51C,3,3)#        Output char colour message       PX51 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PX51 103
ELSE#                                  This is an atom plot             PX51 104
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PX51 105
ncodefld:(FLOAT(BCOL),1,PX51A,300313.,1)# Load bond colour              PX51 106
ncodefld:(FLOAT(CCOL),1,PX51A,330313.,1)# Load char colour              PX51 107
ncodefld:(FLOAT(NCOL),1,PX51A,360313.,1)# Load numb colour              PX51 108
writeline:(0,PX51A,NPX51A,3,3)#        Output numb colour message       PX51 109
ncodefld:(BUFOT,1,PX51B,FMT,6)#        Load atom colours                PX51 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PX51 111
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PX51 112
#                                                                       PX51 113
RETURN#                                                                 PX51 114
END#                                                                    PX51 115
systemheader:(PX52)#                   Add colormap entry               PX52   1
####################################################################    PX52   2
#                                                                  #    PX52   3
#                               PX52                               #    PX52   4
#                                                                  #    PX52   5
####################################################################    PX52   6
SUBROUTINE PX52#                                                        PX52   7
include:(AACOMN)#                                                       PX52   8
include:(PXCOMN)#                                                       PX52   9
#                                                                       PX52  10
REAL RED,GREEN,BLUE#                                                    PX52  11
INTEGER IDX,C1,C2,C3,KOLOR#                                             PX52  12
#                                                                       PX52  13
intunpak:(QX(JP+5),KOLOR,0,24)#        Rescue rgb hex packed color      PX52  14
IDX = NINT(QX(JP+6))#                  Color index                      PX52  15
C1=MOD(KOLOR,256)#                     Get last  8 bits                 PX52  16
C2=MOD(KOLOR-C1,65536)#                Get second 8 bits                PX52  17
C3=MOD(KOLOR-C1-C2,16777216)#          Get third 8 bits                 PX52  18
RED=FLOAT(C3)/16777215.#               Convert to range 0.0-1.0         PX52  19
GREEN=FLOAT(C2)/65535.#                Convert to range 0.0-1.0         PX52  20
BLUE=FLOAT(C1)/255.#                   Convert to range 0.0-1.0         PX52  21
IF(IDX<MAXCOL)#                        Haven't exceed maximum           PX52  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX52  23
IF     (NDEV==1)    noop:#             Do nothing                       PX52  24
ELSE IF(NDEV==2)  colmp2:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  25
ELSE IF(NDEV==3)  colmp3:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  26
ELSE IF(NDEV==4)  colmp4:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  27
ELSE IF(NDEV==5)  colmp5:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  28
ELSE IF(NDEV==6)  colmp6:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  29
ELSE IF(NDEV==7)  colmp7:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  30
ELSE IF(NDEV==8)  colmp8:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  31
ELSE IF(NDEV==9)  colmp9:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  32
ELSE IF(NDEV==10)colmp10:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  33
ELSE IF(NDEV==11)colmp11:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  34
ELSE IF(NDEV==12)colmp12:(RED,GREEN,BLUE,IDX)# Set new map value        PX52  35
ELSE IF(NDEV==13)colmp13:(RED,GREEN,BLUE,IDX,QX(JP+5))# Set new map v   PX52  36
ELSE IF(NDEV==14)colmp14:(RED,GREEN,BLUE,IDX,QX(JP+5))# Set new alue    PX52  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX52  38
MXCOL=MAX(IDX,7)#                                                       PX52  39
#                                                                       PX52  40
RETURN#                                                                 PX52  41
END#                                                                    PX52  42
systemheader:(PX53)#                   Draw markers                     PX53   1
####################################################################    PX53   2
#                                                                  #    PX53   3
#                               PX53                               #    PX53   4
#                                                                  #    PX53   5
####################################################################    PX53   6
SUBROUTINE PX53#                                                        PX53   7
include:(AACOMN)#                                                       PX53   8
include:(PXCOMN)#                                                       PX53   9
#                                                                       PX53  10
IF     (NDEV==2) marker2:#                                              PX53  11
ELSE IF(NDEV==3) marker3:#                                              PX53  12
ELSE IF(NDEV==4) marker4:#                                              PX53  13
ELSE IF(NDEV==5) marker5:#                                              PX53  14
ELSE IF(NDEV==6) marker6:#                                              PX53  15
ELSE IF(NDEV==7) marker7:#                                              PX53  16
ELSE IF(NDEV==8) marker8:#                                              PX53  17
ELSE IF(NDEV==9) marker9:#                                              PX53  18
ELSE IF(NDEV==10)marker10:#                                             PX53  19
ELSE IF(NDEV==11)marker11:#                                             PX53  20
ELSE IF(NDEV==12)marker12:#                                             PX53  21
ELSE IF(NDEV==13)marker13:#                                             PX53  22
ELSE IF(NDEV==14)marker14:#                                             PX53  23
#                                                                       PX53  24
RETURN#                                                                 PX53  25
END#                                                                    PX53  26
systemheader:(PX61)#                   Finish off the plot              PX61   1
####################################################################    PX61   2
#                                                                  #    PX61   3
#                               PX61                               #    PX61   4
#                                                                  #    PX61   5
####################################################################    PX61   6
SUBROUTINE PX61#                                                        PX61   7
include:(AACOMN)#                                                       PX61   8
include:(PXCOMN)#                                                       PX61   9
INTEGER I,J,PSIZE#                                                      PX61  10
chardata:(STAR,*)#                                                      PX61  11
chardata:(PX611," Number of points plotted         ")#                  PX61  12
chardata:(PX612," Number of colors changed         ")#                  PX61  13
datastuff:#                                                             PX61  14
#                                                                       PX61  15
#   PRINT SUMMARY OF MOVES                                              PX61  16
#   ----------------------                                              PX61  17
#                                                                       PX61  18
ncodefld:(FLOAT(NPT),1,PX611,330613.,1)# Format points plotted          PX61  19
writeline:(0,PX611,NPX611,3,3)#        Print summary                    PX61  20
ncodefld:(FLOAT(NCC),1,PX612,330613.,1)# Format colours changed         PX61  21
IF(COLOR!=0) writeline:(0,PX612,NPX612,3,3)# Print summary              PX61  22
#                                                                       PX61  23
#  FINISH OFF THE PLOTS                                                 PX61  24
#  --------------------                                                 PX61  25
#                                                                       PX61  26
IF(DNAME(1^4)=='POST')FLUSH=yes:#      Flush line buffer - add none     PX61  27
CALL PX01(0.,0.,3,0)#                  Flush buffer & return            PX61  28
IF(NDEV==1)#                           ************* chr op device      PX61  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX61  30
LINRM=1000#                            Force a new page                 PX61  31
FOR(I=MARK+1;I<FULL;I=I+NSKIP)#        Loop over lines out              PX61  32
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX61  33
DO J=0,NCOLS#                          Loop along the line              PX61  34
IF(QX(I+J)>0.5) CHROT(J+2^J+2)=STAR#   Put star in op buff              PX61  35
writeline:(0,0,0,1,3)#                 Print the line                   PX61  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX61  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX61  38
IF(NDEV==2) finis2:#                   ************* dot op device      PX61  39
IF(NDEV==3) finis3:#                   ************* vdu op device      PX61  40
IF(NDEV==4) finis4:#                   ************* pt1 op device      PX61  41
IF(NDEV==5) finis5:#                   ************* pt2 op device      PX61  42
IF(NDEV==6) finis6:#                   ************* pt3 op device      PX61  43
IF(NDEV==7) finis7:#                   ************* pt7 op device      PX61  44
IF(NDEV==8) finis8:#                   ************* pt8 op device      PX61  45
IF(NDEV==9) finis9:#                   ************* pt9 op device      PX61  46
IF(NDEV==10) finis10:#                 ************* pt10 op device     PX61  47
IF(NDEV==11) finis11:#                 ************* pt11 op device     PX61  48
IF(NDEV==12) finis12:#                 ************* pt11 op device     PX61  49
IF(NDEV==13) finis13:#                 ************* pt11 op device     PX61  50
IF(NDEV==14) finis14:#                 ************* pt11 op device     PX61  51
#                                                                       PX61  52
readwpkt:(5,endrecord:,PSIZE,IP,0)#    Close the plot command file      PX61  53
#                                                                       PX61  54
RETURN#                                                                 PX61  55
END#                                                                    PX61  56
systemheader:(PX71)#                   Tektronix 4010/4014 emulation    PX71   1
# ################################################################## #  PX71   2
#                                                                    #  PX71   3
#                              PX71                                  #  PX71   4
#                                                                    #  PX71   5
# ################################################################## #  PX71   6
SUBROUTINE PX71(KEY,NPTK,IPTK)#        R. olthof may 1989               PX71   7
include:(AACOMN)#                                                       PX71   8
include:(PXCOMN)#                                                       PX71   9
#                                                                       PX71  10
INTEGER I,N#                                                            PX71  11
INTEGER KEY#      ## 1/2/3/4/5 FOR START,FRAME,PLOT(12-bit),#           PX71  12
#                 ## PLOT(10-bit),FINIS                                 PX71  13
INTEGER N1,N2,N3# ## HIGH ORDER, LOW ORDER, EXTRA BITS OF X ADDRESS     PX71  14
INTEGER N4,N5,N6# ## HIGH ORDER, LOW ORDER, EXTRA BITS OF Y ADDRESS     PX71  15
INTEGER X,Y#      ## X,Y ADDRESS                                        PX71  16
INTEGER NPTK,IPTK#                                                      PX71  17
intdata:(PX021,[27,91,63,51,56,104])#                                   PX71  18
intdata:(PX022,[27,12])#                                                PX71  19
intdata:(PX023,[27,29])#                                                PX71  20
intdata:(PX025,[27,91,63,51,56,108])#                                   PX71  21
string:(CHART,20)#                                                      PX71  22
datastuff:#                                                             PX71  23
#                                                                       PX71  24
IF(KEY==1)#                            Start plot                       PX71  25
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  PX71  26
FILEXT(iofm2:)='PLT'#                  File extension of output         PX71  27
openfmt:(iofm2:,' ');  ICHR=0#         Open plot file                   PX71  28
DO I=1,6; CHART(I^I)=CHAR(PX021(I))#   Move escape sequence             PX71  29
movechar:(CHART,1,CHROT,1,6,0)#        Move escape sequence             PX71  30
writefmt:(iofm2:,'(A)',CHROT(1^6)); CHROT=' '# Write to output          PX71  31
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  PX71  32
ELSE IF(KEY==2)#                       Advance frame                    PX71  33
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  PX71  34
DO I=1,2; CHART(I^I)=CHAR(PX022(I))#   Move escape sequence             PX71  35
movechar:(CHART,1,CHROT,1,2,0)#        Move escape sequence             PX71  36
writefmt:(iofm2:,'(A)',CHROT(1^2)); CHROT=' '# Write to output          PX71  37
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  PX71  38
ELSE IF(KEY==3)#                       Plot line                        PX71  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  PX71  40
IF(NPTK==1) GOTO 100#                  Quit if only one point           PX71  41
DO I=1,2; CHART(I^I)=CHAR(PX023(I))#   Move escape sequence             PX71  42
movechar:(CHART,1,CHROT,1,2,0)#        Move escape sequence             PX71  43
I=2#                                   Start of five byte addresses     PX71  44
DO N=1,NPTK#                           Loop over coordinates            PX71  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  PX71  46
X=NINT(QX(IPTK+N-1     )*XPIX)#        X address (in pixels)            PX71  47
Y=NINT(QX(IPTK+N+NBUF-1)*YPIX)#        Y address (in pixels)            PX71  48
N1=X/128;N2=(X-128*N1)/4;N3=X-N1*128-N2*4# High,low,extra x             PX71  49
N4=Y/128;N5=(Y-128*N4)/4;N6=Y-N4*128-N5*4# High,low,extra y             PX71  50
CHROT(I+1^I+1)=CHAR(N4+32)#            High order y                     PX71  51
CHROT(I+2^I+2)=CHAR(N3+4*N6+96)#       Extra y, extra x                 PX71  52
CHROT(I+3^I+3)=CHAR(N5+96)#            Low order y                      PX71  53
CHROT(I+4^I+4)=CHAR(N1+32)#            High order x                     PX71  54
CHROT(I+5^I+5)=CHAR(N2+64)#            Low order x                      PX71  55
I=I+5#                                 Incr pointer                     PX71  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  PX71  57
writefmt:(iofm2:,'(A)',CHROT(1^I))#    Write to output                  PX71  58
100 CHROT=' '#                         Reset output char buffer         PX71  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  PX71  60
#### PX71 is never called with an argument of 4                         PX71  61
ELSE IF(KEY==4)#                                                        PX71  62
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  PX71  63
IF(NPTK==1) GOTO 200#                  Quit if only one point           PX71  64
DO I=1,2; CHART(I^I)=CHAR(PX023(I))#   Move escape sequence             PX71  65
movechar:(CHART,1,CHROT,1,2,0)#        Move escape sequence             PX71  66
I=2#                                   Start of 4-byte address          PX71  67
DO N=1,NPTK#                           Loop over the coordinates        PX71  68
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  PX71  69
X=INT(QX(IPTK+N-1     )*XPIX)#         X address in pixels              PX71  70
Y=INT(QX(IPTK+N+NBUF-1)*YPIX)#         Y address in pixels              PX71  71
N1=X/32;N2=X-32*N1#                    High, low x                      PX71  72
N4=Y/32;N5=Y-32*N3#                    High, low y                      PX71  73
CHROT(I+1^I+1)=CHAR(N4+32)#            High order y                     PX71  74
CHROT(I+2^I+2)=CHAR(N5+96)#            Low order y                      PX71  75
CHROT(I+3^I+3)=CHAR(N1+32)#            High order x                     PX71  76
CHROT(I+4^I+4)=CHAR(N2+64)#            Low order x                      PX71  77
I=I+4#                                 Incr pointer                     PX71  78
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  PX71  79
writefmt:(iofm2:,'(A)',CHROT(1^I))#    Write to output                  PX71  80
200 CHROT=' '#                         Reset output char buffer         PX71  81
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  PX71  82
ELSE IF(KEY==5)#                       Finis                            PX71  83
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  PX71  84
DO I=1,6; CHART(I^I)=CHAR(PX025(I))#   Move escape sequence             PX71  85
movechar:(CHART,1,CHROT,1,2,0)#        Move escape sequence             PX71  86
writefmt:(iofm2:,'(A)',CHROT(1^6)); CHROT=' '# Write to output          PX71  87
closefmt:(iofm2:)#                     Close the plot file              PX71  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  PX71  89
#                                                                       PX71  90
RETURN#                                                                 PX71  91
END#                                                                    PX71  92
systemheader:(HPGL)#                   Generate hpgl output             HPGL   1
# ################################################################## #  HPGL   2
#                                                                    #  HPGL   3
#                              HPGL                                  #  HPGL   4
#                                                                    #  HPGL   5
# ################################################################## #  HPGL   6
SUBROUTINE HPGL(KEY,PEN,NPHP,IPQX)#                                     HPGL   7
include:(AACOMN)#                                                       HPGL   8
include:(PXCOMN)#                                                       HPGL   9
#                                                                       HPGL  10
INTEGER N,KEY,PEN,NPHP,IPQX#                                            HPGL  11
REAL  X,Y#                                                              HPGL  12
string:(U,5);   string:(V,5)#                                           HPGL  13
#                                                                       HPGL  14
IF(KEY==1)#                            ********start plot**********     HPGL  15
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  HPGL  16
FILEXT(iofm2:)='HP'#                   File extension of output         HPGL  17
openfmt:(iofm2:,' '); ICHR=0#          Initialise the op buffer         HPGL  18
IF(PEN==4) CALL PX02(20,'PS4;IN;IP;SC;PU;SP1;')# A4 paper               HPGL  19
ELSE       CALL PX02(20,'PS3;IN;IP;SC;PU;SP1;')# A3 paper               HPGL  20
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  HPGL  21
#                                                                       HPGL  22
ELSE IF(KEY==2)#                       *******advance frame**********   HPGL  23
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  HPGL  24
CALL PX02(30,';IP;SC;PU;PA10365,7962;SP0;PG;')# Finish the plot         HPGL  25
CALL PX02(16,'IN;IP;SC;PU;SP1;')#      Generate the startup             HPGL  26
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  HPGL  27
#                                                                       HPGL  28
ELSE IF(KEY==3)#                       **********plot line**********    HPGL  29
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  HPGL  30
DO N=1,NPHP#                           Loop over coordinates            HPGL  31
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  HPGL  32
IF(N==1) CALL PX02( 3,';PU')#          Place move in buffer             HPGL  33
IF(N==2) CALL PX02( 3,';PD')#          Place draw in buffer             HPGL  34
X=(QX(IPQX+N-1     )*XPIX)#            X address (in pixels)            HPGL  35
Y=(QX(IPQX+N+NBUF-1)*YPIX)#            Y address (in pixels)            HPGL  36
ncodefld:(X,1,U,50513.,1)#             Format the x coord               HPGL  37
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               HPGL  38
CALL PX02(12,U//','//V//',')#          Place draw in buffer             HPGL  39
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  HPGL  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  HPGL  41
#                                                                       HPGL  42
ELSE IF(KEY==4&COLOR==yes:)#           ********select pen***********    HPGL  43
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  HPGL  44
ncodefld:(FLOAT(PEN),1,U,10113.,1)#    Format pen number                HPGL  45
CALL PX02( 3,'SP'//U(1^1))#            Put pen into buffer              HPGL  46
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  HPGL  47
#                                                                       HPGL  48
ELSE IF(KEY==5)#                       *********finish plot*********    HPGL  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  HPGL  50
CALL PX02(30,';IP;SC;PU;PA10365,7962;SP0;PG;')# Finish the plot         HPGL  51
CALL PX02(0,' ')#                      Flush the final buffer           HPGL  52
closefmt:(iofm2:)#                     Close the plot file              HPGL  53
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  HPGL  54
#                                                                       HPGL  55
RETURN#                                                                 HPGL  56
END#                                                                    HPGL  57
systemheader:(POST)#                   Postscript output                POST   1
# ################################################################## #  POST   2
#                                                                    #  POST   3
#                              POST                                  #  POST   4
#                                                                    #  POST   5
# ################################################################## #  POST   6
SUBROUTINE POST(KEY,PEN,XSTR,YSTR,HT,TH,NNS,NCAR,NPPS,IPPS)#            POST   7
include:(AACOMN)#                      J. hester jun 91                 POST   8
include:(PXCOMN)#                      V. streltsov                     POST   9
#                                      D. grossi                        POST  10
INTEGER LNBLNK#                                                         POST  11
INTEGER I,N,NPPS,IPPS#                                                  POST  12
INTEGER KEY,PEN#                                                        POST  13
INTEGER NNS,NS#                        Length of character string       POST  14
INTEGER OFFSET#                        Offset flag                      POST  15
INTEGER BSTR#                          Beginning of substring           POST  16
INTEGER KEY1,KEY2#                     Control character locations      POST  17
INTEGER ITALIC#                        Italic flag                      POST  18
INTEGER NSC#                           No. of subscripted characters    POST  19
REAL D1,D2#                                                             POST  20
INTEGER PCOL#                          Postscript color                 POST  21
SAVE PCOL#                             Save between calls               POST  22
REAL FONTSZ,FONTAG#                    Current fontsize and angle       POST  23
SAVE FONTSZ,FONTAG#                    Save these variables             POST  24
REAL XSTR,YSTR#                        Coordinates of beginning of ch   POST  25
REAL PAGE#                             Number of pages                  POST  26
REAL X,Y#                              Coordinates for plotting         POST  27
REAL HT#                               Character height in inches       POST  28
REAL TH#                               Angle to x axis in degrees       POST  29
REAL XSH,YSH#                          Rotated page shift               POST  30
CHARACTER*(*) NCAR#                    Character string                 POST  31
string:(U,5);   string:(V,5); string:(TEMP,80)#                         POST  32
string:(FONT,7);string:(ERASE,7)#      Font type                        POST  33
string:(BKSL,1)#                       Backslash                        POST  34
string:(TMPSTR,200)#                   Temporary string                 POST  35
##                                                                      POST  36
chardata:(GREEK,'Greek  ')#            Greek font                       POST  37
chardata:(MAIN,'Main   ')#             Main font                        POST  38
chardata:(ITALICS,'Italic ')#          Italic font                      POST  39
chardata:(SHOW,'/Erase ')#             String to erase char backgroun   POST  40
chardata:(ENDP,'%%EndPage:   1   1')#  End page comment                 POST  41
chardata:(NEWP,'%%Page:      0   1')#  New page comment                 POST  42
chardata:(TOTL,'%%Pages:   1')#        Total pages comment              POST  43
datastuff:#                                                             POST  44
#                                                                       POST  45
IF(IBAK!=no:) movechar:(SHOW,1,ERASE,1,7,0)# Show background            POST  46
ELSE  ERASE=' '#                       Blank                            POST  47
BKSL = '\\\\'#                         Portable unix backslash          POST  48
IF(KEY==1)#                            *****************start plot      POST  49
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  POST  50
FONTSZ=0.0;FONTAG=-1200.#              Intialize unlikely               POST  51
MAXCOL=16777216#                       Maximum possible colors          POST  52
FILEXT(iofm2:)='PS '#                  File extension of output         POST  53
openfmt:(iofm2:,' ');   ICHR=0#        Open the plot file               POST  54
openfmt:(iofm1:,xtalpsp:)#             Open postscript prolog file      POST  55
readfmt:(iofm1:,'(A80)',50,TEMP)#      Read first line of postscript    POST  56
writefmt:(iofm2:,'(A80)',TEMP)#        Output the buffer                POST  57
readfmt:(iofm1:,'(A80)',50,TEMP)#      Read creator line                POST  58
movechar:(TITLE,39,TEMP,12,17,0)#      Insert creator                   POST  59
writefmt:(iofm2:,'(A80)',TEMP)#        Dump creator line                POST  60
readfmt:(iofm1:,'(A80)',50,TEMP)#      Read title line                  POST  61
movechar:(TITLE,60,TEMP,10,75,0)#      Insert creator                   POST  62
writefmt:(iofm2:,'(A80)',TEMP)#        Dump creator line                POST  63
readfmt:(iofm1:,'(A80)',50,TEMP)#      Read creation date line          POST  64
movechar:(TITLE,18,TEMP,17,8,0)#       Insert date                      POST  65
writefmt:(iofm2:,'(A80)',TEMP)#        Dump creation date line          POST  66
GOTO 75#                                                                POST  67
50 iquit:(PX6000)#                     Unexpected end of file           POST  68
75 CONTINUE#                                                            POST  69
REPEAT#                                                                 POST  70
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  POST  71
readfmt:(iofm1:,'(A80)',100,TEMP)#     Read a line of postscript        POST  72
writefmt:(iofm2:,'(A80)',TEMP)#        Output the buffer                POST  73
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  POST  74
100 CONTINUE#                          Read all postscript headers      POST  75
D1=MIN(AWIDE,AHIGH)*72.#               Page width  in point             POST  76
D2=MAX(AWIDE,AHIGH)*72.#               Page height in point             POST  77
ncodefld:(D1,1,TEMP, 60612.,1)#        Format the page width            POST  78
ncodefld:(D2,1,TEMP,120612.,1)#        Format the page height           POST  79
TEMP(13^22)=' DOCUMENT '#              Document page dimensions         POST  80
CALL PX02(22,TEMP)#                    Write out the page scale+size    POST  81
CALL PX02(0,' ')#                      Line feed                        POST  82
PAGE=0.#                                                                POST  83
CALL PX02(18,NEWP);CALL PX02(0,' ')#   Print comment and flush buffer   POST  84
ncodefld:(72./XPIX,1,TEMP, 50522.,1)#  Format the x scale               POST  85
ncodefld:(72./YPIX,1,TEMP,100522.,1)#  Format the y scale               POST  86
ncodefld:(AWIDE*72.,1,TEMP,160612.,1)# Format the page width            POST  87
ncodefld:(AHIGH*72.,1,TEMP,220612.,1)# Format the page height           POST  88
CALL PX02(27,'save '//TEMP)#           Write out the page scale+size    POST  89
IF(DNAME(5^5)=='L')#                   Landscape flag                   POST  90
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  POST  91
CALL PX02(13,' 90 BEGINPAGE')#         Lanscape dims                    POST  92
CALL PX02(0,' ')#                      Line feed                        POST  93
XSH= (AWIDE*YPIX-AHIGH*XPIX)/2.#       X shift in rotated frame         POST  94
YSH=-(AWIDE*YPIX+AHIGH*XPIX)/2.#       Y shift in rotated frame         POST  95
ncodefld:(XSH,1,TEMP, 70713.,1)#       Format the x shift               POST  96
ncodefld:(YSH,1,TEMP,140713.,1)#       Format the y shift               POST  97
CALL PX02(26,'%'//TEMP(1^14)//' translate ')# Trans rotatd centre bac   POST  98
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  POST  99
ELSE CALL PX02(12,' 0 BEGINPAGE')#     Portrait dims                    POST 100
CALL PX02(0,' ')#                      Line feed                        POST 101
CALL PX02(4,'3 W ')#                   Set the postscript line width    POST 102
closefmt:(iofm1:)#                     Close the punch file             POST 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  POST 104
#                                                                       POST 105
#                                                                       POST 106
ELSE IF(KEY==2&NF==2)#                 *****************advance frame   POST 107
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  POST 108
CALL PX02(0,' ')#                      Line feed                        POST 109
CALL PX02(8,'ENDPAGE ');CALL PX02(0,' ')# End page command and line f   POST 110
ncodefld:(PAGE,1,ENDP,140313.,1)#      Format character string page     POST 111
ncodefld:(PAGE+1.,1,ENDP,180313.,1)#   Format numeric string page       POST 112
CALL PX02(18,ENDP);CALL PX02(0,' ')#   End page command and line feed   POST 113
PAGE=PAGE+1.#                                                           POST 114
ncodefld:(PAGE,1,NEWP,140313.,1)#      Format character string page     POST 115
ncodefld:(PAGE+1.,1,NEWP,180313.,1)#   Format numeric string page       POST 116
CALL PX02(18,NEWP);CALL PX02(0,' ')#   New page command and line feed   POST 117
ncodefld:(72./XPIX,1,TEMP, 50522.,1)#  Format the x scale               POST 118
ncodefld:(72./YPIX,1,TEMP,100522.,1)#  Format the y scale               POST 119
ncodefld:(AWIDE*72.,1,TEMP,160612.,1)# Format the page width            POST 120
ncodefld:(AHIGH*72.,1,TEMP,220612.,1)# Format the page height           POST 121
CALL PX02(27,'save '//TEMP)#           Write out the page scale+size    POST 122
IF(DNAME(5^5)=='L')#                   Landscape flag                   POST 123
CALL      PX02(13,' 90 BEGINPAGE')#    Lanscape dims                    POST 124
ELSE CALL PX02(12,' 0 BEGINPAGE')#     Portrait dims                    POST 125
CALL PX02(0,' ')#                      Line feed                        POST 126
CALL PX02(4,'3 W ')#                   Set the postscript line width    POST 127
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  POST 128
#                                                                       POST 129
ELSE IF((KEY==3&NPPS>1)\#              *****************plot line       POST 130
(KEY==8&NPPS==2))#                     Treat 2 pt fill as a line        POST 131
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  POST 132
IF(FILLUP==yes:)#                      Fudge for contour figures        POST 133
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  POST 134
#IF(RETRACE==YES:&NPPS>2) RETURN#       IGNORE THESE LINES              POST 135
CALL PX02(5,' 7 K ')#                  Overwrite with black             POST 136
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  POST 137
DO N=1,NPPS#                           Loop over coordinates            POST 138
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  POST 139
X=(QX(IPPS+N-1     )*XPIX)#            X address (in pixels)            POST 140
Y=(QX(IPPS+N+NBUF-1)*YPIX)#            Y address (in pixels)            POST 141
ncodefld:(X,1,U,50513.,1)#             Format the x coord               POST 142
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               POST 143
IF(N==1)#                              First point pen up               POST 144
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  POST 145
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             POST 146
CALL PX02(3,' M ')#                    Move moveto sequence             POST 147
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  POST 148
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             POST 149
CALL PX02(3,' L ')#                    Move lineto sequence             POST 150
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  POST 151
CALL PX02(3,' S ')#                    Move stroke sequence             POST 152
IF(FILLUP==yes:)#                      Set color back to normal         POST 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  POST 154
ncodefld:(FLOAT(PCOL),1,U,50513.,1)#   Format the color                 POST 155
CALL PX02(8,U//' K ')#                 Output the color command         POST 156
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  POST 157
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  POST 158
#                                                                       POST 159
ELSE IF(KEY==4 & COLOR==yes:)#         *****************change color    POST 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 POST 161
CALL PX02(0,' ')#                      Linefeed for clarity             POST 162
IF (PEN<0 \PEN >MXCOL)PEN=7#           Ensure valid color               POST 163
ncodefld:(FLOAT(PEN),1,U,50513.,1)#    Format the color                 POST 164
CALL PX02(8,U//' K ')#                 Output the color command         POST 165
PCOL=PEN#                              Save current color               POST 166
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 POST 167
#                                                                       POST 168
ELSE IF(KEY==5)#                       *****************finis           POST 169
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 POST 170
CALL PX02(0,' ')#                      Line feed                        POST 171
CALL PX02(7,'ENDPAGE');CALL PX02(0,' ')# End page command and line fe   POST 172
ncodefld:(PAGE,1,ENDP,140313.,1)#      Format character string page     POST 173
ncodefld:(PAGE+1.,1,ENDP,180313.,1)#   Format numeric string page       POST 174
CALL PX02(18,ENDP);CALL PX02(0,' ')#   End page command and line feed   POST 175
CALL PX02(10,'%%Trailer ');CALL PX02(0,' ')#                            POST 176
D1=MIN(AWIDE,AHIGH)*72.#               Page width  in point             POST 177
D2=MAX(AWIDE,AHIGH)*72.#               Page height in point             POST 178
ncodefld:(D1,1,TEMP, 60613.,1)#        Format the page width  as int    POST 179
ncodefld:(D2,1,TEMP,120613.,1)#        Format the page height as int    POST 180
CALL PX02(32,'%%BoundingBox: 0  0 '//TEMP(1^12));CALL PX02(0,' ')#      POST 181
ncodefld:(PAGE+1.,1,TOTL,120313.,1)#   Format character string page     POST 182
CALL PX02(12,TOTL);CALL PX02(0,' ')#   Print total number of pages      POST 183
closefmt:(iofm2:)#                     Close the punch file             POST 184
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 POST 185
#                                                                       POST 186
ELSE IF(KEY==6)#                       **************plot characters    POST 187
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 POST 188
ITALIC=no:#                                                             POST 189
NS=NNS#                                Copy to local variable           POST 190
WHILE(INDEX('%^~| ',NCAR(NS^NS))!=0) NS=NS-1# Omit trailing controls    POST 191
CALL PX02(0,' ')#                      Line feed for clarity            POST 192
I=1#                                   Point to first char              POST 193
WHILE(NCAR(I^I)==' ') I=I+1#           Find first non blank             POST 194
IF(NCAR(I^I)=='|')#                    Leading italics flag             POST 195
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 POST 196
ITALIC=yes:#                           Flag as italics                  POST 197
I=I+1#                                 Count as blank                   POST 198
WHILE(NCAR(I^I)==' ') I=I+1#           Search next non blank            POST 199
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 POST 200
IF(I>1)#                               There are leading blanks         POST 201
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 POST 202
TEMP=NCAR(I^NS); NCAR=TEMP#            Move chars forwards              POST 203
NS=NS-I+1#                             Adjust number of chars           POST 204
IF (ITALIC==yes:)I=I-1#                Better positioning               POST 205
XSTR=XSTR+FLOAT(6*I-6)*HT/7.#          Adjust x coord of string         POST 206
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 POST 207
ifne:(HT,FONTSZ,0.001)#                Test if a new fontsize           POST 208
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 POST 209
ncodefld:(HT*YPIX*TSCALE,1,U,50512.,1)# Fontsize (integer)              POST 210
#NCODEFLD:(HT*YPIX,1,U,50512.,1)#      FONTSIZE (INTEGER)               POST 211
CALL PX02(9,U//' FS ')#                Set the fontsize                 POST 212
FONTSZ=HT#                             Save the fontsize                POST 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 POST 214
ifne:(TH,FONTAG,0.01)#                 Test if a new font angle         POST 215
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 POST 216
ncodefld:(TH,1,V,50513.,1)#            Encode angle                     POST 217
CALL PX02(9,V//' FA ')#                Set  the fontangle               POST 218
FONTAG=TH#                             Save the fontangle               POST 219
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 POST 220
X=((XSTR+XOFF)*OMAG*XPIX)#             X address (in pixels)            POST 221
Y=((YSTR+YOFF)*OMAG*YPIX)#             Y address (in pixels)            POST 222
ncodefld:(X,1,U,50513.,1)#             Format the x coord               POST 223
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               POST 224
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             POST 225
CALL PX02(3,' M ')#                    Move moveto sequence             POST 226
##                                                                      POST 227
IF(ITALIC==yes:) FONT=ITALICS#         Currentfont is italic            POST 228
ELSE             FONT=MAIN#            Set main font type               POST 229
#                                                                       POST 230
#  TAKE CARE OF PARENTHESES BY INSERTING BACKSLASH BEFORE THEM          POST 231
#  ___________________________________________________________          POST 232
#                                                                       POST 233
N=0#                                   Backslash count                  POST 234
FOR(I=1;I<=NS;I=I+1)#                  Loop through string              POST 235
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 POST 236
IF((NCAR(I^I)== ')') \ (NCAR(I^I) == '('))# Check for parentheses       POST 237
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 POST 238
TMPSTR(I+N^I+N) = BKSL#                Insert backslash                 POST 239
N=N+1#                                 Count backslashes                POST 240
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 POST 241
TMPSTR(I+N^I+N) = NCAR(I^I)#           Now put parentheses              POST 242
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 POST 243
NS = NS + N#                           True length of string with bck   POST 244
#                                                                       POST 245
#  DISSECT CHARACTER STRING TO FIND GREEK AND OFFSET CHARS              POST 246
#  -------------------------------------------------------              POST 247
#                                                                       POST 248
BSTR = 1#                              Beginning of string              POST 249
FOR(N=1;N<=NS;)#                       Loop over characters in string   POST 250
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 POST 251
KEY2 = 0;OFFSET = 0#                   Initialise key2 and offset fla   POST 252
KEY1=INDEX('%^~|',TMPSTR(N^N))#        Check for controls               POST 253
IF(KEY1!=0)#                           Have found control character     POST 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 POST 255
IF(BSTR<N)#                            There are characters to print    POST 256
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 POST 257
CALL PX02(3+N-BSTR ,'('//TMPSTR(BSTR^N-1)//') ')# String so far         POST 258
CALL PX02(16,ERASE//FONT//'T ')#       Set font for printin   post 19   POST 259
CALL PX02(0,' ')#                      Flush buffer                     POST 260
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 POST 261
KEY2=INDEX('%^~|',TMPSTR((N+1)^(N+1)))# Check for second control        POST 262
IF(KEY2!=0)#                           Two control characters           POST 263
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 POST 264
IF(KEY2==KEY1)#                        Simply output control characte   POST 265
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 POST 266
BSTR=N+1#                              Beginning of next output strin   POST 267
N=N+2#                                 Skip characters already checke   POST 268
NEXT#                                  Go to next character in string   POST 269
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 POST 270
ELSE N=N+2#                            Skip control characters          POST 271
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 POST 272
ELSE N=N+1#                            Skip control character           POST 273
IF (KEY1==4 \ KEY2==4) ITALIC=1-ITALIC# An italic flag so switch        POST 274
IF (KEY1==2 \ KEY2==2) CALL PX02(5,'Sups ')# Set superscript mode       POST 275
IF (KEY1==3 \ KEY2==3) CALL PX02(5,'Subs ')# Set subscript mode         POST 276
IF (KEY1==1 \ KEY2==1) FONT=GREEK#     Is greek symbol set greek font   POST 277
#                                                                       POST 278
# NOW READY TO PRINT SPECIAL CHARACTER                                  POST 279
# ------------------------------------                                  POST 280
#                                                                       POST 281
NSC=0#                                 Number of extra special chars    POST 282
IF(TMPSTR(N^N)==BKSL) NSC = 1#         If is escaped bracket            POST 283
CALL PX02(4+NSC,'('//TMPSTR(N^N+NSC)//') ')# Print spec chars           POST 284
CALL PX02(16,ERASE//FONT//'T ')#       Set font for printin   post 23   POST 285
CALL PX02(0,' ')#                      Flush buffer                     POST 286
#                                                                       POST 287
# CHARACTER HAS BEEN OUTPUT.  NOW RETURN TO NORMAL FONT                 POST 288
# _____________________________________________________                 POST 289
#                                                                       POST 290
IF (KEY1==2 \ KEY2==2) CALL PX02(6,'Unsup ')# Undo superscript mode     POST 291
IF (KEY1==3 \ KEY2==3) CALL PX02(6,'Unsub ')# Undo subscript mode       POST 292
IF(ITALIC==yes:) FONT=ITALICS#         Set italic font                  POST 293
ELSE             FONT=MAIN#            Set main font type               POST 294
BSTR=N+1+NSC#                          Next string will begin at posi   POST 295
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 POST 296
N = N+1#                               Test next character              POST 297
KEY1=0;KEY2=0#                         Just to be on the safe side      POST 298
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 POST 299
IF(BSTR<=NS)#                          Nothing to write if string end   POST 300
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 POST 301
CALL PX02(NS-BSTR+4,'('//TMPSTR(BSTR^NS)//') ')# Print rest of string   POST 302
CALL PX02(16,ERASE//FONT//'T ')#       Set font for printin             POST 303
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 POST 304
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 POST 305
#                                                                       POST 306
#  AMMEND THE COLOR MAP                                                 POST 307
#  --------------------                                                 POST 308
#                                                                       POST 309
ELSE IF(KEY==7)#                       Append to color map              POST 310
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 POST 311
ncodefld:(FLOAT(PEN),1,U,50513.,1)#    Format the colormap index        POST 312
CALL PX02(11,'cmap'//U//' [')#         Output first part of setup       POST 313
ncodefld:(XSTR,1,U,50522.,1)#          Format red value                 POST 314
ncodefld:(YSTR,1,V,50522.,1)#          Format green value               POST 315
CALL PX02(10, U//V)#                   Output first part of setup       POST 316
ncodefld:(HT,1,U,50522.,1)#            Format blue value                POST 317
CALL PX02(11,U//'] put ')#             Output first part of setup       POST 318
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 POST 319
#                                                                       POST 320
#  FILL THE DEFINED AREA                                                POST 321
#  ---------------------                                                POST 322
#                                                                       POST 323
ELSE IF(KEY==8)#                       Fill area                        POST 324
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 POST 325
CALL PX02(3,' N ')#                                                     POST 326
DO N=1,NPPS#                           Loop over coordinates            POST 327
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 POST 328
X=(QX(IPPS+N-1     )*XPIX)#            X address (in pixels)            POST 329
Y=(QX(IPPS+N+NBUF-1)*YPIX)#            Y address (in pixels)            POST 330
ncodefld:(X,1,U,50513.,1)#             Format the x coord               POST 331
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               POST 332
IF(N==1)#                              First point pen up               POST 333
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 POST 334
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             POST 335
CALL PX02(3,' M ')#                    Move moveto sequence             POST 336
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 POST 337
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             POST 338
CALL PX02(3,' L ')#                    Move lineto sequence             POST 339
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 POST 340
CALL PX02(7,' s F r ')#                Gsave closepath fill restore     POST 341
IF(RETRACE==yes:)CALL PX02(6,'7 K S ')# Set black and stroke outline    POST 342
CALL PX02(2,'N ')#                     Closepath                        POST 343
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 POST 344
ELSE IF(KEY==11)#                      Draw markers                     POST 345
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 POST 346
N=NINT(QX(JP+5))#                      Marker color                     POST 347
IF(PCOL!=N)#                           Save current color               POST 348
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 POST 349
ncodefld:(QX(JP+5),1,U,50513.,1)#      Format the color index           POST 350
CALL PX02(8,U//' K ')#                 Output the location              POST 351
PCOL=N#                                Save current color               POST 352
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 POST 353
X=(QX(JP+1)+XOFF)*OMAG*XPIX#           X address (in pixels)            POST 354
Y=(QX(JP+2)+YOFF)*OMAG*YPIX#           Y address (in pixels)            POST 355
ncodefld:(X,1,U,50513.,1)#             Format the x coord               POST 356
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               POST 357
CALL PX02(10,U//V)#                    Output the location              POST 358
X=QX(JP+3)*OMAG*XPIX#                  Marker size (in pixels)          POST 359
ncodefld:(X,1,U,50513.,1)#             Format the x coord               POST 360
CALL PX02(9,U//' m1 ')#                Output the marker                POST 361
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 POST 362
#                                                                       POST 363
RETURN#                                                                 POST 364
END#                                                                    POST 365
systemheader:(XFIG)#                   Postscript output                XFIG   1
# ################################################################## #  XFIG   2
#                                                                    #  XFIG   3
#                              POST                                  #  XFIG   4
#                                                                    #  XFIG   5
# ################################################################## #  XFIG   6
SUBROUTINE XFIG(KEY,PEN,XSTR,YSTR,HT,TH,NNS,NCAR,NPPS,IPPS)#            XFIG   7
include:(AACOMN)#                      D du boulay 1999.                XFIG   8
include:(PXCOMN)#                                                       XFIG   9
#                                                                       XFIG  10
macro:(greek:,32.)#                                                     XFIG  11
macro:(main:,18.)#                                                      XFIG  12
macro:(italics:,19.)#                                                   XFIG  13
#                                                                       XFIG  14
INTEGER LNBLNK#                                                         XFIG  15
INTEGER I,N,NPPS,IPPS#                                                  XFIG  16
INTEGER KEY,PEN#                                                        XFIG  17
INTEGER NNS,NS#                        Length of character string       XFIG  18
INTEGER BSTR#                          Beginning of substring           XFIG  19
INTEGER KEY1,KEY2#                     Control character locations      XFIG  20
INTEGER ITALIC#                        Italic flag                      XFIG  21
REAL OFFSET#                           Vertical char offset             XFIG  22
INTEGER PCOL#                          Postscript color                 XFIG  23
SAVE PCOL#                             Save between calls               XFIG  24
REAL FONTSZ,FONTAG#                    Current fontsize and angle       XFIG  25
SAVE FONTSZ,FONTAG#                    Save these variables             XFIG  26
REAL XSTR,YSTR#                        Coordinates of beginning of ch   XFIG  27
REAL PAGE#                             Number of pages                  XFIG  28
REAL X,Y#                              Coordinates for plotting         XFIG  29
REAL HT#                               Character height in inches       XFIG  30
REAL TH#                               Angle to x axis in degrees       XFIG  31
REAL VAL#                                                               XFIG  32
REAL FONT,FONT1#                                                        XFIG  33
CHARACTER*(*) NCAR#                    Character string                 XFIG  34
string:(PAPTYP(6),6)#                                                   XFIG  35
string:(U,5);   string:(V,5); string:(TEMP,80)#                         XFIG  36
string:(BKSL,1)#                       Backslash                        XFIG  37
string:(TMP,200)#                      Temporary string                 XFIG  38
##                                                                      XFIG  39
chardata:(OBJ0,'# Page split here.       ')#                            XFIG  40
chardata:(OBJ1,'#This line is a comment')#                              XFIG  41
chardata:(OBJ2,'#The following leading numbers denote XFIG objects')#   XFIG  42
chardata:(OBJ3,'#0 Colour pseudo object for user defined colours')#     XFIG  43
chardata:(OBJ4,'#1 Ellipse objects')#                                   XFIG  44
chardata:(OBJ5,'#2 Polyline object')#                                   XFIG  45
chardata:(OBJ6,'#3 Spline object')#                                     XFIG  46
chardata:(OBJ7,$#                                                       XFIG  47
'#4 Text object - Var. width fonts render substring positions wrong.')# XFIG  48
chardata:(OBJ8,'#5 Arc for pie wedges')#                                XFIG  49
chardata:(OBJ9,'#6 Compound object for constructing Meta objects')#     XFIG  50
datastuff:#                                                             XFIG  51
DATA PAPTYP(1)/'A3    '/#              Metric a3 papersize              XFIG  52
DATA PAPTYP(2)/'A4    '/#              Metric a3 papersize              XFIG  53
DATA PAPTYP(3)/'A     '/#              Metric a5 papersize              XFIG  54
DATA PAPTYP(4)/'Letter'/#              Us letter papersize              XFIG  55
DATA PAPTYP(5)/'Legal '/#              Us legal  papersize              XFIG  56
DATA PAPTYP(6)/'E     '/#              Us executive papersize           XFIG  57
#                                                                       XFIG  58
BKSL = '\\\\'#                         Portable unix backslash          XFIG  59
IF(KEY==1)#                            *****************start plot      XFIG  60
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  XFIG  61
PCOL=0#                                Use black by default             XFIG  62
FONTSZ=0.0;FONTAG=-1200.#              Intialize unlikely               XFIG  63
MAXCOL=16777216#                       Maximum possible colors          XFIG  64
FILEXT(iofm2:)='fig'#                  File extension of output         XFIG  65
openfmt:(iofm2:,' ');   ICHR=0#        Open the plot file               XFIG  66
writefmt:(iofm2:,'(A)','#FIG 3.2')#    Magic number                     XFIG  67
IF(DNAME(5^5)=='L')writefmt:(iofm2:,'(A)','Landscape')#                 XFIG  68
ELSE               writefmt:(iofm2:,'(A)','Portrait')#                  XFIG  69
writefmt:(iofm2:,'(A)','Center')#      Justification                    XFIG  70
writefmt:(iofm2:,'(A)','Metric')#      Units                            XFIG  71
writefmt:(iofm2:,'(A)',PAPTYP(PAPER))# Papersize                        XFIG  72
writefmt:(iofm2:,'(A)','100.00')#      Magnification  100.00%           XFIG  73
writefmt:(iofm2:,'(A)','Single')#      Multi-page - multiple            XFIG  74
writefmt:(iofm2:,'(A)','-1')#          Transparent background colour    XFIG  75
writefmt:(iofm2:,'(A)','300 2')#       Resolution and upper left orig   XFIG  76
writefmt:(iofm2:,'(A)',OBJ1)#          Header comments                  XFIG  77
writefmt:(iofm2:,'(A)',OBJ2)#          Header comments                  XFIG  78
writefmt:(iofm2:,'(A)',OBJ3)#          Header comments                  XFIG  79
writefmt:(iofm2:,'(A)',OBJ4)#          Header comments                  XFIG  80
writefmt:(iofm2:,'(A)',OBJ5)#          Header comments                  XFIG  81
writefmt:(iofm2:,'(A)',OBJ6)#          Header comments                  XFIG  82
writefmt:(iofm2:,'(A)',OBJ7)#          Header comments                  XFIG  83
writefmt:(iofm2:,'(A)',OBJ8)#          Header comments                  XFIG  84
writefmt:(iofm2:,'(A)',OBJ9)#          Header comments                  XFIG  85
PAGE=1.#                                                                XFIG  86
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  XFIG  87
#                                                                       XFIG  88
ELSE IF(KEY==2&NF==2)#                 *****************advance frame   XFIG  89
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  XFIG  90
# THERE ISN'T A PAGE ADVANCE SIGNAL FOR XFIG YET ...                    XFIG  91
PAGE=PAGE+1.#                                                           XFIG  92
ncodefld:(PAGE,1,OBJ0,250613.,1)#      Encode the page number           XFIG  93
writefmt:(iofm2:,'(A)',OBJ0)#          Write page break comment         XFIG  94
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  XFIG  95
#                                                                       XFIG  96
ELSE IF((KEY==3&NPPS>1)\#              *****************plot line       XFIG  97
(KEY==8&NPPS==2))#                     Treat 2 pt fill as a line        XFIG  98
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  XFIG  99
TEMP='2 1 0 1 xxx xxx 1 -1 -1 0.0000 0 0 -1 0 0 xxxxxx '#               XFIG 100
VAL=FLOAT(PCOL)#                       Expected colour                  XFIG 101
IF(FILLUP==yes:)#                      Fudge for contour figures        XFIG 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  XFIG 103
IF(RETRACE==yes:&NPPS>2) RETURN#       Ignore these lines               XFIG 104
VAL=0.#                                Replace with black               XFIG 105
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  XFIG 106
ncodefld:(VAL,1,TEMP,110313.,1)#       Format the pen color             XFIG 107
ncodefld:(VAL,1,TEMP,150313.,1)#       Format the fill color            XFIG 108
ncodefld:(FLOAT(NPPS),1,TEMP,480613.,1)# Format the number of points    XFIG 109
CALL PX02(48,TEMP)#                    Dump line header                 XFIG 110
CALL PX02(0,' ')#                      Line feed                        XFIG 111
CALL PX02(8,'        ')#               Pre blank                        XFIG 112
DO N=1,NPPS#                           Loop over coordinates            XFIG 113
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  XFIG 114
X=(QX(IPPS+N-1     )*XPIX)#            X address (in pixels)            XFIG 115
Y=AHIGH*YPIX-(QX(IPPS+N+NBUF-1)*YPIX)# Y address relative to top left   XFIG 116
ncodefld:(X,1,U,50513.,1)#             Format the x coord               XFIG 117
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               XFIG 118
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             XFIG 119
IF(MOD(N,6)!=0) NEXT#                  Not ready for a new line yet     XFIG 120
IF(N==NPPS)NEXT#                       Avoid blank lines                XFIG 121
CALL PX02(0,' ')#                      Line feed                        XFIG 122
CALL PX02(8,'        ')#               Pre blank                        XFIG 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  XFIG 124
CALL PX02(0,' ')#                      Line feed                        XFIG 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  XFIG 126
#                                                                       XFIG 127
ELSE IF(KEY==4 & COLOR==yes:)#         *****************change color    XFIG 128
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  XFIG 129
IF (PEN<0 \PEN >MXCOL)PCOL=0#          Ensure valid color               XFIG 130
ELSEIF(PEN>7)PCOL=32+PEN#              Use an indexed colour            XFIG 131
ELSEIF(PEN==0)PCOL=7#                  White not black                  XFIG 132
ELSEIF(PEN==1)PCOL=4#                  Red   ideally  o                 XFIG 133
ELSEIF(PEN==2)PCOL=2#                  Green ideally  c                 XFIG 134
ELSEIF(PEN==3)PCOL=1#                  Blue  ideally  n                 XFIG 135
ELSEIF(PEN==4)PCOL=6#                  Yellow         s                 XFIG 136
ELSEIF(PEN==5)PCOL=3#                  Sky blue cyan  . f               XFIG 137
ELSEIF(PEN==6)PCOL=5#                  Magenta                          XFIG 138
ELSEIF(PEN==7)PCOL=0#                  Black not white                  XFIG 139
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  XFIG 140
#                                                                       XFIG 141
ELSE IF(KEY==5) closefmt:(iofm2:)#     *****************finis           XFIG 142
#                                      Close the punch file             XFIG 143
ELSE IF(KEY==6)#                       **************plot characters    XFIG 144
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  XFIG 145
FONTSZ=HT#                             Save the fontsize                XFIG 146
FONTAG=TH#                             Save the fontangle               XFIG 147
ITALIC=no:#                                                             XFIG 148
NS=NNS#                                Copy to local variable           XFIG 149
WHILE(INDEX('%^~| ',NCAR(NS^NS))!=0) NS=NS-1# Omit trailing controls    XFIG 150
I=1#                                   Point to first char              XFIG 151
WHILE(I<NS&NCAR(I^I)==' ') I=I+1#      Find first non blank             XFIG 152
IF(NCAR(I^I)=='|')#                    Leading italics flag             XFIG 153
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  XFIG 154
ITALIC=yes:#                           Flag as italics                  XFIG 155
I=I+1#                                 Count as blank                   XFIG 156
WHILE(I<NS&NCAR(I^I)==' ') I=I+1#      Search next non blank            XFIG 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  XFIG 158
IF(I>1)#                               There are leading blanks         XFIG 159
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  XFIG 160
TEMP=NCAR(I^NS); NCAR=TEMP#            Move chars forwards              XFIG 161
NS=NS-I+1#                             Adjust number of chars           XFIG 162
IF (ITALIC==yes:)I=I-1#                Better positioning               XFIG 163
XSTR=XSTR+FLOAT(6*I-6)*HT/7.#          Adjust x coord of string         XFIG 164
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  XFIG 165
#                                                                       XFIG 166
X=(XSTR+XOFF)*OMAG*XPIX#               X address (in pixels)            XFIG 167
Y=AHIGH*YPIX-(YSTR+YOFF)*OMAG*YPIX#    Y address (in pixels)            XFIG 168
##                                                                      XFIG 169
IF(ITALIC==yes:) FONT=italics:#        Currentfont is italic            XFIG 170
ELSE             FONT=main:#           Set main font type               XFIG 171
#                                                                       XFIG 172
#  DISSECT CHARACTER STRING TO FIND GREEK AND OFFSET CHARS              XFIG 173
#  -------------------------------------------------------              XFIG 174
#                                                                       XFIG 175
BSTR = 1#                              Beginning of string              XFIG 176
FOR(N=1;N<=NS;N=N+1)#                  Loop over characters in string   XFIG 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 XFIG 178
KEY2 = 0#                              Initialise key2 and offset fla   XFIG 179
KEY1=INDEX('%^~|',NCAR(N^N))#          Check for controls               XFIG 180
IF(KEY1!=0)#                           Have found control character     XFIG 181
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 XFIG 182
IF(BSTR<N)#                            There are characters to print    XFIG 183
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 XFIG 184
ncodefld:(X,1,U,50513.,1)#             Format the x coord               XFIG 185
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               XFIG 186
TMP='4 0 0 0 0  x xxx -xxx.xx 4 -1 -1 '//U//V//' '//$#                  XFIG 187
NCAR(BSTR^N-1)//BKSL//'001'#           String delimiter                 XFIG 188
ncodefld:(FONT,1,TMP,120213.,1)#       Font face                        XFIG 189
ncodefld:(FONTSZ*72.*TSCALE,1,TMP,160313.,1)# Fontsize in pt-72perinc   XFIG 190
ncodefld:(FONTAG/57.29578,1,TMP,240742.,1)# Font angle                  XFIG 191
writefmt:(iofm2:,'(a)',TMP(1^LNBLNK(TMP)))# Dump the text line          XFIG 192
X=X+FLOAT(N-BSTR)*FONTSZ*TSCALE*5./7.*XPIX*OMAG# Adjust x coord of st   XFIG 193
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 XFIG 194
KEY2=INDEX('%^~|',NCAR((N+1)^(N+1)))#  Check for second control         XFIG 195
IF(KEY2!=0)#                           Two control characters           XFIG 196
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 XFIG 197
IF(KEY2==KEY1)#                        Simply output control characte   XFIG 198
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 XFIG 199
BSTR=N+1#                              Beginning of next output strin   XFIG 200
N=N+1#                                 Skip characters already checke   XFIG 201
NEXT#                                  Go to next character in string   XFIG 202
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 XFIG 203
ELSE N=N+1#                            Skip control characters          XFIG 204
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 XFIG 205
ELSE#                                                                   XFIG 206
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 XFIG 207
IF(KEY1==4)#                                                            XFIG 208
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 XFIG 209
ITALIC=1-ITALIC#                       An italic flag so switch         XFIG 210
IF(ITALIC==yes:) FONT=italics:#        Set italic font                  XFIG 211
ELSE             FONT=main:#           Set main font type               XFIG 212
BSTR=N+1#                                                               XFIG 213
NEXT#                                                                   XFIG 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 XFIG 215
N=N+1#                                 Skip control character           XFIG 216
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 XFIG 217
#                                                                       XFIG 218
OFFSET=0.#                                                              XFIG 219
IF (KEY1==2 \ KEY2==2)OFFSET=-0.5#     Set superscript mode       pos   XFIG 220
IF (KEY1==3 \ KEY2==3)OFFSET= 0.5#     Set subscript mode         pos   XFIG 221
ifne:(OFFSET,0.0)FONTSZ=0.80*FONTSZ#   Reduce font for subscripts       XFIG 222
Y=Y+OFFSET*FONTSZ*YPIX*OMAG*TSCALE#    Y address relative to top left   XFIG 223
FONT1=FONT#                            Save old font                    XFIG 224
IF (KEY1==1 \ KEY2==1) FONT=greek:#    Is greek symbol set greek font   XFIG 225
#                                                                       XFIG 226
# NOW READY TO PRINT SPECIAL CHARACTER                                  XFIG 227
# ------------------------------------                                  XFIG 228
#                                                                       XFIG 229
ncodefld:(X,1,U,50513.,1)#             Format the x coord               XFIG 230
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               XFIG 231
TMP='4 0 0 0 0  x xxx -xxx.xx 4 -1 -1 '//U//V//' '//$#                  XFIG 232
NCAR(N^N)//BKSL//'001'#                String delimiter                 XFIG 233
ncodefld:(FONT,1,TMP,120213.,1)#       Font face                        XFIG 234
ncodefld:(FONTSZ*72.*TSCALE,1,TMP,160313.,1)# Fontsize (integer)        XFIG 235
ncodefld:(FONTAG/57.29578,1,TMP,240742.,1)# Font angle                  XFIG 236
writefmt:(iofm2:,'(a)',TMP(1^LNBLNK(TMP)))# Dump the text line          XFIG 237
X=X+5.*FONTSZ*TSCALE/7.*OMAG*XPIX#     X address (in pixels)            XFIG 238
#                                                                       XFIG 239
# CHARACTER HAS BEEN OUTPUT.  NOW RETURN TO NORMAL FONT                 XFIG 240
# _____________________________________________________                 XFIG 241
#                                                                       XFIG 242
ifne:(OFFSET,0.0)#                                                      XFIG 243
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 XFIG 244
FONTSZ=1.25*FONTSZ#                    Reduce font for subscripts       XFIG 245
Y=Y-OFFSET*FONTSZ*YPIX*OMAG*TSCALE#    Y address relative to top left   XFIG 246
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 XFIG 247
FONT=FONT1#                            Revert back to previous font     XFIG 248
BSTR=N+1#                              Next string will begin at posi   XFIG 249
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 XFIG 250
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 XFIG 251
IF(BSTR<=NS)#                          Nothing to write if string end   XFIG 252
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 XFIG 253
ncodefld:(X,1,U,50513.,1)#             Format the x coord               XFIG 254
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               XFIG 255
TMP='4 0 0 0 0  x xxx -x.xxxx 4 -1 -1 '//U//V//' '//$#                  XFIG 256
NCAR(BSTR^NS)//BKSL//'001'#            String delimiter                 XFIG 257
ncodefld:(FONT,1,TMP,120213.,1)#       Font face                        XFIG 258
ncodefld:(FONTSZ*72.*TSCALE,1,TMP,160313.,1)# Fontsize (integer)        XFIG 259
ncodefld:(FONTAG/57.29578,1,TMP,240742.,1)# Font angle                  XFIG 260
writefmt:(iofm2:,'(a)',TMP(1^LNBLNK(TMP)))# Dump the text line          XFIG 261
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 XFIG 262
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  XFIG 263
#                                                                       XFIG 264
#  AMMEND THE COLOR MAP                                                 XFIG 265
#  --------------------                                                 XFIG 266
#                                                                       XFIG 267
ELSE IF(KEY==7)#                       Append to color map              XFIG 268
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 XFIG 269
TEMP='0 12345 # '#                     Blank the string                 XFIG 270
ncodefld:(FLOAT(PEN+32),1,TEMP,70513.,1)# Format the colormap index     XFIG 271
ncodefld:(TH,1,TEMP,150669.,1)#        Format hex rgb values            XFIG 272
CALL PX02(15, TEMP)#                   Output colour map string         XFIG 273
CALL PX02(0,' ')#                      New buffer                       XFIG 274
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 XFIG 275
#                                                                       XFIG 276
#  FILL THE DEFINED AREA                                                XFIG 277
#  ---------------------                                                XFIG 278
#                                                                       XFIG 279
ELSE IF(KEY==8&NPPS>2)#                Fill area                        XFIG 280
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 XFIG 281
TEMP='2 1 0 1   0 xxx 100 -1 20 0.0000 0 0 -1 0 0 xxxxxx '#             XFIG 282
IF(RETRACE==yes:) TEMP(9^11)='  0'#    Retrace black outline            XFIG 283
ELSE ncodefld:(FLOAT(PCOL),1,TEMP,110313.,1)# Boundary is fill color    XFIG 284
ncodefld:(FLOAT(PCOL),1,TEMP,150313.,1)# Format the fill color          XFIG 285
IF(CONTUR==yes:)#                                                       XFIG 286
ncodefld:(FLOAT(150+700*NPPS/buffr13:),1,TEMP,190313.,1)# Fill by npt   XFIG 287
ncodefld:(FLOAT(NPPS),1,TEMP,500613.,1)# Format number of points        XFIG 288
CALL PX02(51,TEMP)#                    Dump line header                 XFIG 289
CALL PX02(0,' ')#                      Line feed                        XFIG 290
CALL PX02(8,'        ')#               Pre blank                        XFIG 291
DO N=1,NPPS#                           Loop over coordinates            XFIG 292
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 XFIG 293
X=(QX(IPPS+N-1     )*XPIX)#            X address (in pixels)            XFIG 294
Y=AHIGH*YPIX-(QX(IPPS+N+NBUF-1)*YPIX)# Y address relative to top left   XFIG 295
ncodefld:(X,1,U,50513.,1)#             Format the x coord               XFIG 296
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               XFIG 297
CALL PX02(12,U//' '//V//' ')#          Place draw in buffer             XFIG 298
IF(MOD(N,6)!=0) NEXT#                                                   XFIG 299
IF(N==NPPS)NEXT#                       Avoid blank lines                XFIG 300
CALL PX02(0,' ')#                      Line feed                        XFIG 301
CALL PX02(8,'        ')#               Pre blank                        XFIG 302
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 XFIG 303
CALL PX02(0,' ')#                      Line feed                        XFIG 304
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 XFIG 305
#                                                                       XFIG 306
ELSE IF(KEY==11)#                      Draw markers                     XFIG 307
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 XFIG 308
X=(QX(JP+1)+XOFF)*OMAG*XPIX#           X address (in pixels)            XFIG 309
Y=AHIGH*YPIX- (QX(JP+2)+YOFF)*OMAG*YPIX# Y address (in pixels)          XFIG 310
ncodefld:(X,1,U,50513.,1)#             Format the x coord               XFIG 311
ncodefld:(Y,1,V,50513.,1)#             Format the y coord               XFIG 312
TMP='1 3 0 1   0 xxx 100 -1 20 0.0000 1 0.000 '//U//$#                  XFIG 313
V//' xxxx xxxx -1 -1 -1 -1 '#                                           XFIG 314
X=QX(JP+3)*OMAG*XPIX#                  Marker size (in pixels)          XFIG 315
ncodefld:(X,1,U,570413.,1)#            Format the x coord               XFIG 316
ncodefld:(X,1,U,620413.,1)#            Format the x coord               XFIG 317
ncodefld:(FLOAT(PCOL),1,TMP,150313.,1)# Format the fill color           XFIG 318
writefmt:(iofm2:,'(a)',TMP(1^LNBLNK(TMP)))# Dump the text line          XFIG 319
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 XFIG 320
#                                                                       XFIG 321
RETURN#                                                                 XFIG 322
END#                                                                    XFIG 323
systemheader:(MATH)#                   Mathematica output               MATH   1
# ################################################################## #  MATH   2
#                                                                    #  MATH   3
#                              MATH                                  #  MATH   4
#                                                                    #  MATH   5
# ################################################################## #  MATH   6
SUBROUTINE MATH(KEY,PEN,NPMT,IPMT)#    J. hester  march 1990            MATH   7
include:(AACOMN)#                                                       MATH   8
include:(PXCOMN)#                                                       MATH   9
#                                                                       MATH  10
INTEGER N,NPMT,IPMT#                                                    MATH  11
INTEGER KEY,PEN#  ## 1/2/3/4/5 FOR START,FRAME,PLOT,SYMBOL,FINIS#       MATH  12
REAL X,Y#                                                               MATH  13
chardata:(PX26,',Line[{')#             Start of line                    MATH  14
string:(U,5);  string:(V,5)#           Strings for enconding numbers    MATH  15
datastuff:#                                                             MATH  16
#                                                                       MATH  17
IF(KEY==1)#                            Start plot                       MATH  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  MATH  19
FILEXT(iofm2:)='MAT'#                  File extension of output         MATH  20
openfmt:(iofm2:,' ');   ICHR=0#        Open the plot file               MATH  21
movechar:(' ',1,CHROT,1,NPX26,1)#                                       MATH  22
CALL PX02(38,'Graphics[{GrayLevel[0],Thickness[.001]')# Open graphics   MATH  23
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  MATH  24
ELSE IF(KEY==2)#                       N.b. no frame advance option h   MATH  25
ELSE IF(KEY==3)#                       Plot line                        MATH  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  MATH  27
IF (NPMT==1) RETURN#                                                    MATH  28
DO N=1,NPMT#                           Loop over coordinates            MATH  29
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  MATH  30
X=QX(IPMT+N-1     )#                   X coord                          MATH  31
Y=QX(IPMT+N+NBUF-1)#                   Y coord                          MATH  32
ncodefld:(X,1,U,50532.,1)#             Encode x,y                       MATH  33
ncodefld:(Y,1,V,50532.,1)#                                              MATH  34
IF(N==1) CALL PX02(21,',Line[{{ '//U//','//V//'}')# Place inside line   MATH  35
CALL PX02(15,',{ '//U//','//V//'}')#   Place inside line function       MATH  36
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  MATH  37
CALL PX02(2,'}]')#                     End of this line instruction     MATH  38
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  MATH  39
ELSE IF(KEY==4);#                      Do nothing                       MATH  40
ELSE IF(KEY==5)#                       Finis                            MATH  41
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  MATH  42
CALL PX02(25,'},AspectRatio->Automatic]')# End of graphics instructio   MATH  43
CALL PX02(0,' ')#                      Flush buffer                     MATH  44
closefmt:(iofm2:)#                     Close plot file                  MATH  45
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  MATH  46
#                                                                       MATH  47
RETURN#                                                                 MATH  48
END#                                                                    MATH  49
systemheader:(OS2PM)#                  Os/2 presentation manager outp   OS2P   1
# ################################################################## #  OS2P   2
#                                                                    #  OS2P   3
#                             OS2PM                                  #  OS2P   4
#                                                                    #  OS2P   5
# ################################################################## #  OS2P   6
SUBROUTINE OS2PM(KEY,NPTS,QXPTR,PUPDWN,NCOLOR)# Bernt karasch jul93     OS2P   7
INTEGER KEY#                           1/2/3/4/5 fort start/frame/plo   OS2P   8
INTEGER NPTS#                          Number of points                 OS2P   9
INTEGER QXPTR#                         Pointer to start of points       OS2P  10
INTEGER PUPDWN#                        3 = pen-down, 2 = pen-up         OS2P  11
INTEGER NCOLOR#                        Color                            OS2P  12
ifsel:(UNXOS2)#                                                         OS2P  13
include:(AACOMN)#                                                       OS2P  14
include:(PXCOMN)#                                                       OS2P  15
INTEGER N, NN#                         Loop variables                   OS2P  16
REAL    X,Y,Z#                         Used for encoding numbers        OS2P  17
INTEGER UP, VP, WP#                    Position of first non-blank ch   OS2P  18
string:(U, 6); string:(V, 6); string:(W, 6)# Strings for enconding nu   OS2P  19
string:(U1,6); string:(V1,6); string:(W1,6)# Strings for enconding nu   OS2P  20
string:(CMDFILE,11)#                                                    OS2P  21
IF (KEY==1)#                                                            OS2P  22
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  OS2P  23
FILEXT(iofm2:)='REX'#                                                   OS2P  24
openfmt:(iofm2:,' ');   ICHR=0#                                         OS2P  25
putstrg:(24,'/* VREXX Command File */')#                                OS2P  26
putstrg:(0,' ')#                                                        OS2P  27
putstrg:(40,'CALL RxFuncAdd ''VInit'', ''VREXX'', ''VINIT''')#          OS2P  28
putstrg:(0,' ')#                                                        OS2P  29
putstrg:(12,'rc = VInit()')#                                            OS2P  30
putstrg:(0,' ')#                                                        OS2P  31
putstrg:(35,'IF rc = ''ERROR'' THEN SIGNAL Cleanup')#                   OS2P  32
putstrg:(0,' ')#                                                        OS2P  33
putstrg:(30,'SIGNAL ON FAILURE NAME Cleanup')#                          OS2P  34
putstrg:(0,' ')#                                                        OS2P  35
putstrg:(30,'SIGNAL ON HALT    NAME Cleanup')#                          OS2P  36
putstrg:(0,' ')#                                                        OS2P  37
putstrg:(30,'SIGNAL ON SYNTAX  NAME Cleanup')#                          OS2P  38
putstrg:(0,' ')#                                                        OS2P  39
putstrg:(15,'color = ''WHITE''')#                                       OS2P  40
putstrg:(0,' ')#                                                        OS2P  41
putstrg:(15,'pos.left   =  5')#                                         OS2P  42
putstrg:(0,' ')#                                                        OS2P  43
putstrg:(15,'pos.right  = 70')#                                         OS2P  44
putstrg:(0,' ')#                                                        OS2P  45
putstrg:(15,'pos.bottom =  5')#                                         OS2P  46
putstrg:(0,' ')#                                                        OS2P  47
putstrg:(15,'pos.top    = 70')#                                         OS2P  48
putstrg:(0,' ')#                                                        OS2P  49
putstrg:(59,'id=VOpenWindow(''Xtal3.2 - Graphics Window'',color,pos)')# OS2P  50
putstrg:(0,' ')#                                                        OS2P  51
putstrg:(27,'CALL VForeColor id, ''BLACK''')#                           OS2P  52
putstrg:(0,' ')#                                                        OS2P  53
putstrg:(27,'CALL VDrawParms id, 0, 0, 1')# Mark: x, solid lines, sol   OS2P  54
putstrg:(0,' ')#                                                        OS2P  55
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  OS2P  56
ELSE IF(KEY==2)#                                                        OS2P  57
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  OS2P  58
putstrg:(22,'CALL VDialogPos 87, 25')#                                  OS2P  59
putstrg:(0,' ')#                                                        OS2P  60
putstrg:(9,'msg.0 = 1')#                                                OS2P  61
putstrg:(0,' ')#                                                        OS2P  62
putstrg:(31,'msg.1 = ''  Press OK to proceed''')#                       OS2P  63
putstrg:(0,' ')#                                                        OS2P  64
putstrg:(47, 'CALL VMsgBox ''Xtal3.2 - Command Window'', msg, 1')#      OS2P  65
putstrg:(0,' ')#                                                        OS2P  66
putstrg:(20,'CALL VClearWindow id')#                                    OS2P  67
putstrg:(0,' ')#                                                        OS2P  68
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  OS2P  69
ELSE IF(KEY==3\KEY==4)#                                                 OS2P  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  OS2P  71
IF (NPTS==1) RETURN#                   Select color                     OS2P  72
IF      (NCOLOR==1) putstrg:( 28, 'CALL VForeColor id,  ''BLACK''')#    OS2P  73
ELSE IF (NCOLOR==2) putstrg:( 28, 'CALL VForeColor id,    ''RED''')#    OS2P  74
ELSE IF (NCOLOR==3) putstrg:( 28, 'CALL VForeColor id,  ''GREEN''')#    OS2P  75
ELSE IF (NCOLOR==4) putstrg:( 28, 'CALL VForeColor id, ''YELLOW''')#    OS2P  76
ELSE IF (NCOLOR==5) putstrg:( 28, 'CALL VForeColor id ,  ''BLUE''')#    OS2P  77
ELSE IF (NCOLOR==6) putstrg:( 28, 'CALL VForeColor id,   ''CYAN''')#    OS2P  78
ELSE IF (NCOLOR==7) putstrg:( 28, 'CALL VForeColor id,   ''PINK''')#    OS2P  79
putstrg:(0,' ')#                                                        OS2P  80
DO N=1,NPTS#                           Loop over coordinates            OS2P  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  OS2P  82
X=QX(QXPTR+N-1     )#                  X coordinate                     OS2P  83
Y=QX(QXPTR+N+NBUF-1)#                  Y coordinate                     OS2P  84
X=X*1000#                                                               OS2P  85
Y=Y*1000#                                                               OS2P  86
ncodefld:(X,1,U,60602.,1)#             Encode x,y                       OS2P  87
ncodefld:(Y,1,V,60602.,1)#                                              OS2P  88
Z=N#                                                                    OS2P  89
ncodefld:(Z,1,W,60602.,1)              ENCODE NUMBER OF CURRENT POINT#  OS2P  90
#                                      Remove leading blanks and decima OS2P  91
UP=1#                                                                   OS2P  92
WHILE (U(UP^UP)==' '&UP<6) UP=UP+1#                                     OS2P  93
U1='0     '#                           Avoid blank result if up=6       OS2P  94
DO NN=UP,5; U1(NN-UP+1^NN-UP+1)=U(NN^NN)#                               OS2P  95
#                                                                       OS2P  96
VP=1#                                                                   OS2P  97
WHILE (V(VP^VP)==' '&VP<6) VP=VP+1#                                     OS2P  98
V1='0     '#                                                            OS2P  99
DO NN=VP,5; V1(NN-VP+1^NN-VP+1)=V(NN^NN)#                               OS2P 100
#                                                                       OS2P 101
WP=1#                                                                   OS2P 102
WHILE (W(WP^WP)==' '&WP<6) WP=WP+1#                                     OS2P 103
W1='0     '#                                                            OS2P 104
DO NN=WP,5; W1(NN-WP+1^NN-WP+1)=W(NN^NN)#                               OS2P 105
#                                                                       OS2P 106
putstrg:(15,'x.'//W1//'='//U1)#                                         OS2P 107
putstrg:(0,' ');#                                                       OS2P 108
putstrg:(15,'y.'//W1//'='//V1)#                                         OS2P 109
putstrg:(0,' ')#                                                        OS2P 110
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  OS2P 111
IF (KEY==3) putstrg:(35,'CALL VDraw id, ''LINE'', x, y, '//W1)#         OS2P 112
ELSE        putstrg:(38,'CALL VDraw id, ''POLYGON'', x, y, '//W1)#      OS2P 113
putstrg:(0,' ')#                                                        OS2P 114
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  OS2P 115
ELSE IF(KEY==5)#                                                        OS2P 116
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  OS2P 117
putstrg:(8,'Cleanup:')#                                                 OS2P 118
putstrg:(0,' ')#                                                        OS2P 119
putstrg:(11,'CALL VExit')#                                              OS2P 120
putstrg:(0,' ')#                                                        OS2P 121
putstrg:(4,'EXIT')#                                                     OS2P 122
closefmt:(iofm2:)#                     Close plot file                  OS2P 123
#                                      Determine name of created file   OS2P 124
WP=0#                                                                   OS2P 125
DO NN=1,6#                             Loop over characters of compid   OS2P 126
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  OS2P 127
IF (!COMPID(NN^NN)==' ')#                                               OS2P 128
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  OS2P 129
WP=WP+1#                                                                OS2P 130
CMDFILE(WP^WP)=COMPID(NN^NN)#                                           OS2P 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  OS2P 132
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  OS2P 133
WP=WP+1#                               Add suffix .rex                  OS2P 134
CMDFILE(WP^WP)='.'#                                                     OS2P 135
WP=WP+1#                                                                OS2P 136
CMDFILE(WP^WP)='r'#                                                     OS2P 137
WP=WP+1#                                                                OS2P 138
CMDFILE(WP^WP)='e'#                                                     OS2P 139
WP=WP+1#                                                                OS2P 140
CMDFILE(WP^WP)='x'#                                                     OS2P 141
WP=WP+1#                                                                OS2P 142
CMDFILE(WP^WP)=CHAR(0)#                Terminate filename               OS2P 143
CALL CALLREXX(CMDFILE)#                Call rexx interpreter with fil   OS2P 144
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  OS2P 145
endsel:#                                                                OS2P 146
#                                                                       OS2P 147
RETURN#                                                                 OS2P 148
END#                                                                    OS2P 149
#                                                                       OS2P 150
systemheader:(UNXC)#                                                    UNXC   1
ifsel:(UNXOS2)#                                                         UNXC   2
extrude:('callrexx.c')#                                                 UNXC   3
/*#                                                                     UNXC   4
flagon:(R)#                            Prevent tidying                          
*/                                                                              
#define INCL_REXXSAA                                                            
#include <os2emx.h>                     /* needed for RexxStart()     */        
#include <stdio.h>                      /* needed for printf()        */        
#include <string.h>                     /* needed for strlen()        */        
                                                                                
int callrexx_(rexxfile)                                                         
char *rexxfile;                                                                 
    {                                                                           
    RXSTRING arg;                       /* argument string for REXX  */         
    RXSTRING rexxretval;                /* return value from REXX    */         
                                                                                
    UCHAR    *str = "";                                                         
                                                                                
    APIRET   rc;                        /* return code from REXX     */         
    SHORT    rexxrc = 0;                /* return code from function */         
                                                                                
    rexxretval.strlength = 0L;          /* initialize return to empty*/         
                                                                                
    MAKERXSTRING(arg, str, strlen(str));/* create input argument     */         
                                                                                
    rc=RexxStart((LONG)      1,             /* number of arguments   */         
                (PRXSTRING)  &arg,          /* array of arguments    */         
                (PSZ)        rexxfile,      /* name of REXX file     */         
                (PRXSTRING)  0,             /* No INSTORE used       */         
                (PSZ)        "XTAL",        /* Command env. name     */         
                (LONG)       1,             /* Code for how invoked  */         
                (PRXSYSEXIT) 0,             /* No EXITs on this call */         
                (PSHORT)     &rexxrc,       /* Rexx program output   */         
                (PRXSTRING)  &rexxretval ); /* Rexx program output   */         
                                                                                
   /*                                                                           
    printf("Interpreter Return Code: %d\n", rc);                                
    printf("Function Return Code:    %d\n", (int) rexxrc);                      
   */                                                                           
                                                                                
    DosFreeMem(rexxretval.strptr);          /* Release storage       */         
                                            /* given to us by REXX.  */         
    return 0;                                                                   
    }                                                                           
endext:#                                                                        
flagoff:(R)#                                                                    
endsel:#                                                                UNXC  48
##                                                                      UNXC  49
## -------------------------------------------------------------------- UNXC  50
##                                                                      UNXC  51
##                                                                      UNXC  52
##    LIBRARY OF MACRO DEFINITIONS FOR DIFFERENT GRAPHICAL DEVICES      UNXC  53
##                                                                      UNXC  54
##    These definitions may be made active by moving them to the        UNXC  55
##    appropriate device category and replacing the '0' with the        UNXC  56
##    category number (2,3,4,5,6,7,8,9,10,11,12).                       UNXC  57
##                                                                      UNXC  58
##                                                                      UNXC  59
ifsel:(GRAFLIB)#                                                        UNXC  60
##                                                                      UNXC  61
## Here is a description of the macros that need to be defined. The     UNXC  62
## 'N' is the device category number (2,3,4,5,6,7,8,9,10,11,12).        UNXC  63
##                                                                      UNXC  64
## dcodeN: Device code of 6 characters (mandatory!). This is used by    UNXC  65
##         the user to select this device for output.                   UNXC  66
##                                                                      UNXC  67
## xmaxwN: Plot width (x-direction) in 'plot units'. The units will     UNXC  68
##         depend on the device and the plot commands used in the       UNXC  69
##         macros below. It may be in cms or inches or, as for GKS      UNXC  70
##         commands, in 'unit dimensions' (see SUNWIN below).           UNXC  71
##                                                                      UNXC  72
## ymaxhN: Plot height (y-direction) in 'plot units'. See xmaxwN:.      UNXC  73
##                                                                      UNXC  74
## xpixlN: Pixels per 'plot unit' in x-direction. This defines the      UNXC  75
##         plot resolution in this direction and must be defined        UNXC  76
##         even when the device is not 'pixel device'.                  UNXC  77
##                                                                      UNXC  78
## ypixlN: Pixels per 'plot unit' in y-direction. See xpixlN:           UNXC  79
##                                                                      UNXC  80
## buffrN: Plot buffer size for x-coordinate(s). If plot commands       UNXC  81
##         use a single set of x,y coordinates this must be defined     UNXC  82
##         as 1. When the plot commands generate lines or vectors       UNXC  83
##         this value must be 2 or more (see SUNWIN below).             UNXC  84
##                                                                      UNXC  85
## colorN: Flag to indicate if the device supports colour. Use          UNXC  86
##         either 'yes:' or 'no:'.                                      UNXC  87
##                                                                      UNXC  88
## startN: This macro defines the sequence of commands needed to        UNXC  89
##         start a plot. This sequence is called in the routine         UNXC  90
##         PX00 for each plot. Note that for the GKS definitions        UNXC  91
##         of this macro given below you need to refer to a separate    UNXC  92
##         set of general GKS macros defined just prior to the the      UNXC  93
##         PX common.                                                   UNXC  94
##                                                                      UNXC  95
## frameN: Initiate a frame advance on the plotter. Applied in the      UNXC  96
##         routine PX31. Also used to 'hold' the picture on the         UNXC  97
##         workstation so that the user can cause the next frame        UNXC  98
##         to be displayed by 'clicking' on the window.                 UNXC  99
##                                                                      UNXC 100
## plotpN:($1=npoints; $2=qx-pointer; $3=penup/down; $4=ncolour)        UNXC 101
##         Plots the $1 coordinates stored in the qx-array. The first   UNXC 102
##         x-coordinate is stored at QX($2) and the first y-coord-      UNXC 103
##         inate is stored at QX($2+buffrN:). The number of sets of     UNXC 104
##         coordinates to be plotted is $1 (if buffrN: is 1, $1 will    UNXC 105
##         always be 1). $3 is 2 for pen-down; 3 for pen-up. $4 is      UNXC 106
##         the current pen colour as an integer (usually 1 to 7).       UNXC 107
##                                                                      UNXC 108
## areapN:($1=npoints; $2=qx-pointer; $3=penup/down; $4=ncolour)        UNXC 109
##         Fills the area defined by the $1 coordinates stored in       UNXC 110
##         the qx-array. The first x-coordinate is stored at QX($2)     UNXC 111
##         and the first y-coordinate is stored at QX($2+buffrN:).      UNXC 112
##         The number of sets of coordinates defining the perimeter     UNXC 113
##         of the area to be filled is $1 (if buffrN: is 1, $1 will     UNXC 114
##         always be 1). $3 is 2 for pen-down; 3 for pen-up. $4 is      UNXC 115
##         the current pen colour as an integer (usually 1 to 7).       UNXC 116
##                                                                      UNXC 117
## nupenN:($1=ncolour)                                                  UNXC 118
##         Defines the new-pen or change-color command. For some        UNXC 119
##         systems this will be done separately from the plotpN:        UNXC 120
##         commands. It is defined as an integer designating the        UNXC 121
##         subject (e.g. bond, atom or contour). See the general        UNXC 122
##         GKS definitions below which define the GKS colours.          UNXC 123
##                                                                      UNXC 124
## ptextN:($1=X,$2=Y,$3=HT,$4=Angle,$5=No of Chars,$6=String)           UNXC 125
##         Defines the routine for printing a character string at       UNXC 126
##         position (X,Y), at Angle to the X axis, with height ht.      UNXC 127
##         No operation draws characters as line vectors.               UNXC 128
##                                                                      UNXC 129
## finisN: Defines the sequence of commands required to close the       UNXC 130
##         down the plot and associated files, windows, etc.            UNXC 131
##                                                                      UNXC 132
##  These are the 'no operation' definitions.                           UNXC 133
##                                                                      UNXC 134
macro:(dcode0:,DEVCOD)#                Local device name (6chrs)        UNXC 135
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 136
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 137
macro:(xpixl0:,1.)#                    Pixels per unit along x          UNXC 138
macro:(ypixl0:,1.)#                    Pixels per unit along y          UNXC 139
macro:(buffr0:,1)#                     Qx buffer size for plot          UNXC 140
macro:(color0:,no:)#                   Is color supported               UNXC 141
macro:(start0:,noop:)#                 Initialize the output            UNXC 142
macro:(frame0:,noop:)#                 Start a new plot frame           UNXC 143
macro:(plotp0:,noop:)#                 Plot x,y coordinates             UNXC 144
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 145
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 146
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 147
macro:(finis0:,noop:)#                 Finish the plot output           UNXC 148
##                                                                      UNXC 149
##     VAX station 2000 using GKS commands.                             UNXC 150
##                                                                      UNXC 151
macro:(dcode0:,VT2000)#                Local device name (6chrs)        UNXC 152
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 153
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 154
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 155
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 156
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 157
macro:(color0:,yes:)#                  Is color supported               UNXC 158
macro:(start0:,[$(confgks:(41);gksopen:(0,41)$)])# Initialize           UNXC 159
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 160
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 161
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 162
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 163
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 164
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 165
##                                                                      UNXC 166
##     VAX station 2000 using MicroVax UIS commands.                    UNXC 167
##                                                                      UNXC 168
macro:(dcode0:,UT2000)#                Local device name (6chrs)        UNXC 169
macro:(xmaxw0:,25.)#                   Plot width  (x) in units         UNXC 170
macro:(ymaxh0:,25.)#                   Plot height (y) in units         UNXC 171
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 172
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 173
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 174
macro:(color0:,no:)#                   Is color supported               UNXC 175
macro:(start0:,NDIS=UIS$$CREATE_DISPLAY(0.,0.,#                         UNXC 176
AWIDE,AHIGH,AWIDE,AHIGH))#             Initialize the output            UNXC 177
macro:(frame0:,$(NW=UIS$$CREATE_WINDOW(NDIS,'SYS$WORKSTATION',#         UNXC 178
TITLE(10:15));PAUSE$))#                Start a new plot frame           UNXC 179
macro:(plotp0:,CALL UIS$$PLOT_ARRAY(NDIS,0,$1,QX($2),QX($2+NBUF)))#     UNXC 180
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 181
macro:(nupen0:,noop:)#                 Color index for polyline         UNXC 182
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 183
macro:(finis0:,$(CALL UIS$$DELETE_DISPLAY(NDIS)$))# Finish              UNXC 184
##                                                                      UNXC 185
##     VT340 DEC colour terminal using GKS commands.                    UNXC 186
##                                                                      UNXC 187
macro:(dcode0:,VT340 )#                Local device name (6chrs)        UNXC 188
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 189
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 190
macro:(xpixl0:,450.)#                  Pixels per unit along x          UNXC 191
macro:(ypixl0:,450.)#                  Pixels per unit along y          UNXC 192
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 193
macro:(color0:,yes:)#                  Is color supported               UNXC 194
macro:(start0:,[gksopen:(0,17)])#      Initialize the output            UNXC 195
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 196
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 197
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 198
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 199
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 200
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 201
##                                                                      UNXC 202
##     VT340 DEC b and w terminal using GKS commands.                   UNXC 203
##                                                                      UNXC 204
macro:(dcode0:,VT340 )#                Local device name (6chrs)        UNXC 205
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 206
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 207
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 208
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 209
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 210
macro:(color0:,no:)#                   Is color supported               UNXC 211
macro:(start0:,[gksopen:(0,41)])#      Initialize the output            UNXC 212
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 213
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 214
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 215
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 216
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 217
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 218
##                                                                      UNXC 219
##     Tektronix 4100 terminal using GKS commands.                      UNXC 220
##                                                                      UNXC 221
macro:(dcode0:,TEK410)#                Local device name (6chrs)        UNXC 222
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 223
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 224
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 225
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 226
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 227
macro:(color0:,yes:)#                  Is color supported               UNXC 228
macro:(start0:,[gksopen:(1,3)])#       Initialize the output            UNXC 229
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 230
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 231
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 232
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 233
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 234
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 235
##                                                                      UNXC 236
##     Standard Sun window  using GKS commands.                         UNXC 237
##                                                                      UNXC 238
macro:(dcode0:,SUNWIN)#                Local device name (6chrs)        UNXC 239
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 240
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 241
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 242
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 243
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 244
macro:(color0:,yes:)#                  Is color supported               UNXC 245
macro:(start0:,[$(confgks:(4);gksopen:(0,4)$)])# Initialize             UNXC 246
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 247
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 248
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 249
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 250
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 251
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 252
##                                                                      UNXC 253
##     TEK4014 B & W terminal using GKS commands.                       UNXC 254
##                                                                      UNXC 255
macro:(dcode0:,TEK401)#                Local device name (6chrs)        UNXC 256
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 257
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 258
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 259
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 260
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 261
macro:(color0:,no:)#                   Is color supported               UNXC 262
macro:(start0:,[gksopen:(0,72)])#      Initialize the output            UNXC 263
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 264
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 265
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 266
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 267
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 268
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 269
##                                                                      UNXC 270
##     Laser printer emulating TEK 4010 mode                            UNXC 271
##     (outputs to line file with extension PLT)                        UNXC 272
##                                                                      UNXC 273
macro:(dcode0:,LASER1)#                Local device name (6chrs)        UNXC 274
macro:(xmaxw0:,25.64)#                 Plot width  (x) in units         UNXC 275
macro:(ymaxh0:,19.3)#                  Plot height (y) in units         UNXC 276
macro:(xpixl0:,160.)#                  Pixels per unit along x          UNXC 277
macro:(ypixl0:,160.)#                  Pixels per unit along y          UNXC 278
macro:(buffr0:,20)#                    Qx buffer size for plot          UNXC 279
macro:(color0:,no:)#                   Is color supported               UNXC 280
macro:(start0:,CALL PX71(1,0,0))#      Initialize the output            UNXC 281
macro:(frame0:,CALL PX71(2,0,0))#      Start a new plot frame           UNXC 282
macro:(plotp0:,CALL PX71(3,$1,$2))#    Plot x,y coordinates             UNXC 283
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 284
macro:(nupen0:,noop:)#                 Color index for polyline         UNXC 285
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 286
macro:(finis0:,CALL PX71(5,0,0))#      Finish the plot output           UNXC 287
##                                                                      UNXC 288
##     HP7220 8-pen plotter using local MPIK drivers                    UNXC 289
##     (outputs to line file with extension PLT)                        UNXC 290
##                                                                      UNXC 291
macro:(dcode0:,HP7220)#                Local device name (6chrs)        UNXC 292
macro:(xmaxw0:,15.5)#                  Plot width  (x) in units         UNXC 293
macro:(ymaxh0:,10.5)#                  Plot height (y) in units         UNXC 294
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 295
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 296
macro:(buffr0:,1)#                     Qx buffer size for plot          UNXC 297
macro:(color0:,yes:)#                  Is color supported               UNXC 298
macro:(start0:,CALL INIHP)#            Initialize the output            UNXC 299
macro:(frame0:,noop:)#                 Start a new plot frame           UNXC 300
macro:(plotp0:,CALL PLOT(QX($2),QX($2+1),$3))# Plot coordinates         UNXC 301
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 302
macro:(nupen0:,CALL NEWPEN($1))#       Change the plot color            UNXC 303
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 304
macro:(finis0:,CALL ENDHP)#            Finish the plot output           UNXC 305
##                                                                      UNXC 306
##     Output a Computer Graphics Metafile using Xelion-GKS.            UNXC 307
##                                                                      UNXC 308
macro:(dcode0:,CGMETA)#                Local device name                UNXC 309
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 310
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 311
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 312
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 313
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 314
macro:(color0:,yes:)#                  Is color supported               UNXC 315
macro:(start0:,[$(#                    Initialize the output            UNXC 316
FILEXT(41)='CGM';openfmt:(41,' ')#     Open cgmeta file                 UNXC 317
gksconf:;gksopen:(41,302);confgks:$)])#                                 UNXC 318
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 319
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 320
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 321
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 322
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 323
macro:(finis0:,[gksclose:;closefmt:(41)])# Finish the plot output       UNXC 324
##                                                                      UNXC 325
##     DISSPLA compressed meta file (Wright State U. implementation)    UNXC 326
##                                                                      UNXC 327
macro:(dcode0:,META  )#                Local device name (6chrs)        UNXC 328
macro:(xmaxw0:,11.)#                   Plot width  (x) in units         UNXC 329
macro:(ymaxh0:,8.5)#                   Plot height (y) in units         UNXC 330
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 331
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 332
macro:(buffr0:,1)#                     Qx buffer size for plot          UNXC 333
macro:(color0:,no:)#                   Is color supported               UNXC 334
macro:(start0:,[$(#                    Initialize the output            UNXC 335
CALL COMPRS; CALL PAGE(11.0,8.5); CALL NOBRDR#                          UNXC 336
CALL AREA2D(AWIDE,AHIGH); CALL PHYSOR(0.0,0.0)$)])#                     UNXC 337
macro:(frame0:,[$(#                    Start a new plot frame           UNXC 338
CALL ENDPL(0); CALL PAGE(11.0,8.5); CALL NOBRDR#                        UNXC 339
CALL AREA2D(AWIDE,AHIGH); CALL PHYSOR(0.0,0.0)$)])#                     UNXC 340
macro:(plotp0:,[$(#                    Plot x,y                         UNXC 341
IF($3==2)CALL CONNPT(QX($2),QX($2+1))#                                  UNXC 342
IF($3==3)CALL STRTPT(QX($2),QX($2+1))$)])# Coordinates                  UNXC 343
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 344
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 345
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 346
macro:(finis0:,CALL DONEPL)#           Finish the plot output           UNXC 347
##                                                                      UNXC 348
##    HPGL A4 scale pen plotter (outputs to *.hp)                       UNXC 349
##                                                                      UNXC 350
macro:(dcode0:,HPGLA4)#                Local device name (6chrs)        UNXC 351
macro:(xmaxw0:,10.5)#                  Plot width  (x) in units         UNXC 352
macro:(ymaxh0:, 7.5)#                  Plot height (y) in units         UNXC 353
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 354
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 355
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 356
macro:(color0:,yes:)#                  Is color supported               UNXC 357
macro:(start0:,CALL HPGL(1,1,0,0))#    Initialize the output            UNXC 358
macro:(frame0:,CALL HPGL(2,1,0,0))#    Start a new plot frame           UNXC 359
macro:(plotp0:,CALL HPGL(3,$3,$1,$2))# Plot x,y coordinates             UNXC 360
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 361
macro:(nupen0:,CALL HPGL(4,$1,0,0))#   Change the plot colour           UNXC 362
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 363
macro:(finis0:,CALL HPGL(5,0,0,0))#    Finish the plot output           UNXC 364
##                                                                      UNXC 365
##    HPGL A3 scale pen plotter (outputs to *.hp)                       UNXC 366
##                                                                      UNXC 367
macro:(dcode0:,HPGL  )#                Local device name (6chrs)        UNXC 368
macro:(xmaxw0:,15.)#                   Plot width  (x) in units         UNXC 369
macro:(ymaxh0:,10.)#                   Plot height (y) in units         UNXC 370
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 371
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 372
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 373
macro:(color0:,yes:)#                  Is color supported               UNXC 374
macro:(start0:,CALL HPGL(1,1,0,0))#    Initialize the output            UNXC 375
macro:(frame0:,CALL HPGL(2,1,0,0))#    Start a new plot frame           UNXC 376
macro:(plotp0:,CALL HPGL(3,$3,$1,$2))# Plot x,y coordinates             UNXC 377
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 378
macro:(nupen0:,CALL HPGL(4,$1,0,0))#   Change the plot colour           UNXC 379
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 380
macro:(finis0:,CALL HPGL(5,0,0,0))#    Finish the plot output           UNXC 381
##                                                                      UNXC 382
##     Postscript landscape (output to *.ps)                            UNXC 383
##                                                                      UNXC 384
macro:(dcode0:,POSTL )#                Local device name (6chrs)        UNXC 385
macro:(xmaxw0:,11.)#                   Plot width  (x) in units         UNXC 386
macro:(ymaxh0:,8.5)#                   Plot height (y) in units         UNXC 387
macro:(xpixl0:,300.)#                  Pixels per unit along x          UNXC 388
macro:(ypixl0:,300.)#                  Pixels per unit along y          UNXC 389
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 390
macro:(color0:,no:)#                   Is color supported               UNXC 391
macro:(start0:,CALL POST(1,1,0.,0.,0.,0.,0,' ',0,0))# Initialize        UNXC 392
macro:(frame0:,CALL POST(2,1,0.,0.,0.,0.,0.,' ',0,0))# Start new plot   UNXC 393
macro:(plotp0:,CALL POST(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y       UNXC 394
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 395
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 396
macro:(ptext0:,CALL POST(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars       UNXC 397
macro:(finis0:,CALL POST(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot       UNXC 398
##                                                                      UNXC 399
##     Postscript portrait (output to *.ps)                             UNXC 400
##                                                                      UNXC 401
macro:(dcode0:,POSTP )#                Local device name (6chrs)        UNXC 402
macro:(xmaxw0:,8.5)#                   Plot width  (x) in units         UNXC 403
macro:(ymaxh0:,11.)#                   Plot height (y) in units         UNXC 404
macro:(xpixl0:,300.)#                  Pixels per unit along x          UNXC 405
macro:(ypixl0:,300.)#                  Pixels per unit along y          UNXC 406
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 407
macro:(color0:,no:)#                   Is color supported               UNXC 408
macro:(start0:,CALL POST(1,1,0.,0.,0.,0.,0,' ',0,0))# Initialize        UNXC 409
macro:(frame0:,CALL POST(2,1,0.,0.,0.,0.,0,' ',0,0))# Start new plot    UNXC 410
macro:(plotp0:,CALL POST(3,$3,0.,0.,0.,0.,0,' ',$1,$2))# Plot x,y       UNXC 411
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 412
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 413
macro:(ptext0:,CALL POST(6,0,$1,$2,$3,$4,$5,$6,0,0))# Print chars       UNXC 414
macro:(finis0:,CALL POST(5,0,0.,0.,0.,0.,0,' ',0,0))# Finish plot       UNXC 415
##                                                                      UNXC 416
##     Mathematica file (output to *.mat)                               UNXC 417
##                                                                      UNXC 418
macro:(dcode0:,MATHL )#                Local device name (6chrs)        UNXC 419
macro:(xmaxw0:,10.)#                   Plot width  (x) in units         UNXC 420
macro:(ymaxh0:,10.)#                   Plot height (y) in units         UNXC 421
macro:(xpixl0:,300.)#                  Pixels per unit along x          UNXC 422
macro:(ypixl0:,300.)#                  Pixels per unit along y          UNXC 423
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 424
macro:(color0:,yes:)#                  Is color supported               UNXC 425
macro:(start0:,CALL MATH(1,1,0,0))#    Initialize the output            UNXC 426
macro:(frame0:,CALL MATH(2,1,0,0))#    Start a new plot frame           UNXC 427
macro:(plotp0:,CALL MATH(3,$3,$1,$2))# Plot x,y coordinates             UNXC 428
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 429
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 430
macro:(ptext0:,noop:)#                 Print characters                 UNXC 431
macro:(finis0:,CALL MATH(5,0,0,0))#    Finish the plot output           UNXC 432
##                                                                      UNXC 433
##     Output a GKS metafile using Xelion-GKS (output to *.gkm)         UNXC 434
##                                                                      UNXC 435
macro:(dcode0:,GKSMET)#                Local device name                UNXC 436
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 437
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 438
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 439
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 440
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 441
macro:(color0:,yes:)#                  Is color supported               UNXC 442
macro:(start0:,[$(#                    Initialize the output            UNXC 443
FILEXT(41)='GKM';openfmt:(41,' ')#     Open gksmeta file                UNXC 444
gksopen:(41,4)$)])#                                                     UNXC 445
macro:(frame0:,noop:)#                 Start a new plot frame           UNXC 446
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 447
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 448
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 449
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 450
macro:(finis0:,[gksclose:;closefmt:(41)])# Finish the plot output       UNXC 451
##                                                                      UNXC 452
## PostScript Printer (Portrait) - Spooled output - Xelion GKS on SUN   UNXC 453
##                                                                      UNXC 454
macro:(dcode0:,TEXAS )#                Local device name                UNXC 455
macro:(xmaxw0:,0.7544)#                Plot width  (x) in units         UNXC 456
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 457
macro:(xpixl0:,2353.)#                 Pixels per unit along x          UNXC 458
macro:(ypixl0:,3119.)#                 Pixels per unit along y          UNXC 459
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 460
macro:(color0:,no:)#                   Is color supported               UNXC 461
macro:(start0:,[$(#                    Initialize the output            UNXC 462
CALL PUTENV('GKS_PS_SPL_CMMND=lpr -Pps  -r -s %s',37)# Spool command    UNXC 463
gksconf:;gksopen:(41,17);confgks:$)])#                                  UNXC 464
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 465
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 466
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 467
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 468
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 469
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 470
##                                                                      UNXC 471
##  HP 7475A Portrait  A4 - spooled output - Xelion GKS on SUN/UNIX     UNXC 472
##                                                                      UNXC 473
macro:(dcode0:,HP74A4)#                Local device name                UNXC 474
macro:(xmaxw0:,0.7200)#                Plot width  (x) in units         UNXC 475
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 476
macro:(xpixl0:,7200.)#                 Pixels per unit along x          UNXC 477
macro:(ypixl0:,10000.)#                Pixels per unit along y          UNXC 478
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 479
macro:(color0:,-1)#                    Colour without initialisation    UNXC 480
macro:(start0:,[gksopen:(41,108)])#    Initialize the output            UNXC 481
macro:(frame0:,noop:)#                 Start a new plot frame           UNXC 482
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 483
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 484
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 485
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 486
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 487
##                                                                      UNXC 488
##     Sun workstation using Xelion-GKS. For Black and White window.    UNXC 489
##                                                                      UNXC 490
macro:(dcode0:,SNBWWD)#                Local device name                UNXC 491
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 492
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 493
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 494
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 495
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 496
macro:(color0:,no:)#                   Is color supported               UNXC 497
macro:(start0:,[gksopen:(41,124)])#    Initialize the output            UNXC 498
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 499
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 500
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 501
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 502
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 503
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 504
##                                                                      UNXC 505
##  Sun workstation using Xelion-GKS. For Black and White Full Screen.  UNXC 506
##                                                                      UNXC 507
macro:(dcode0:,SNBWFS)#                Local device name                UNXC 508
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 509
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 510
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 511
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 512
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 513
macro:(color0:,no:)#                   Is color supported               UNXC 514
macro:(start0:,[gksopen:(41,125)])#    Initialize the output            UNXC 515
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 516
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 517
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 518
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 519
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 520
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 521
##                                                                      UNXC 522
##    HP 7475A Portrait  A3 - spooled output - Xelion GKS on SUN/UNIX   UNXC 523
##                                                                      UNXC 524
macro:(dcode0:,HP74A3)#                Local device name                UNXC 525
macro:(xmaxw0:,0.7200)#                Plot width  (x) in units         UNXC 526
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 527
macro:(xpixl0:,7200.)#                 Pixels per unit along x          UNXC 528
macro:(ypixl0:,10000.)#                Pixels per unit along y          UNXC 529
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 530
macro:(color0:,-1)#                    Colour without initialization    UNXC 531
macro:(start0:,[$(#                    Initialize the output            UNXC 532
CALL PUTENV('GKS_HP_SCLNG_PNTS=170 602 15370 10602',37)# A4 hp          UNXC 533
gksopen:(41,108)$)])#                                                   UNXC 534
macro:(frame0:,noop:)#                 Start a new plot frame           UNXC 535
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 536
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 537
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 538
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 539
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 540
##                                                                      UNXC 541
##    Sun workstation using Xelion-GKS. For Colour Window.              UNXC 542
##                                                                      UNXC 543
macro:(dcode0:,SNCLWD)#                Local device name                UNXC 544
macro:(xmaxw0:, 1.)#                   Plot width  (x) in units         UNXC 545
macro:(ymaxh0:, 1.)#                   Plot height (y) in units         UNXC 546
macro:(xpixl0:, 1000.)#                Pixels per unit along x          UNXC 547
macro:(ypixl0:, 1000.)#                Pixels per unit along y          UNXC 548
macro:(buffr0:, 1000)#                 Qx buffer size for plot          UNXC 549
macro:(color0:, yes:)#                 Is color supported               UNXC 550
macro:(start0:, [gksopen:(41,126)])#   Initialize the output            UNXC 551
macro:(frame0:, [gkswait:(1)])#        Start a new plot frame           UNXC 552
macro:(plotp0:, [gksline:($1,$2,$3)])# Plot x,y coordinates             UNXC 553
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 554
macro:(nupen0:, gksindex:($1))#        Color index for polyline         UNXC 555
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 556
macro:(finis0:, [gksclose:])#          Finish the plot output           UNXC 557
##                                                                      UNXC 558
##     Sun workstation using Xelion-GKS. For Colour Full Screen.        UNXC 559
##                                                                      UNXC 560
macro:(dcode0:, SNCLFS)#               Local device name                UNXC 561
macro:(xmaxw0:, 1.)#                   Plot width  (x) in units         UNXC 562
macro:(ymaxh0:, 1.)#                   Plot height (y) in units         UNXC 563
macro:(xpixl0:, 1000.)#                Pixels per unit along x          UNXC 564
macro:(ypixl0:, 1000.)#                Pixels per unit along y          UNXC 565
macro:(buffr0:, 1000)#                 Qx buffer size for plot          UNXC 566
macro:(color0:, yes:)#                 Is color supported               UNXC 567
macro:(start0:, [gksopen:(41,127)])#   Initialize the output            UNXC 568
macro:(frame0:, [gkswait:(1)])#        Start a new plot frame           UNXC 569
macro:(plotp0:, [gksline:($1,$2,$3)])# Plot x,y coordinates             UNXC 570
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 571
macro:(nupen0:, gksindex:($1))#        Color index for polyline         UNXC 572
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 573
macro:(finis0:, [gksclose:])#          Finish the plot output           UNXC 574
##                                                                      UNXC 575
## PostScript Printer (Portrait) - Spooled output - Xelion GKS on VAX   UNXC 576
##                                                                      UNXC 577
macro:(dcode0:,TEXAS )#                Local device name                UNXC 578
macro:(xmaxw0:,0.7544)#                Plot width  (x) in units         UNXC 579
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 580
macro:(xpixl0:,2353.)#                 Pixels per unit along x          UNXC 581
macro:(ypixl0:,3119.)#                 Pixels per unit along y          UNXC 582
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 583
macro:(color0:,no:)#                   Is color supported               UNXC 584
macro:(start0:,[$(#                    Initialize the output            UNXC 585
CALL LIB$$SET_LOGICAL('GKS_PS_SPL_CMMND','Lpr -f %s -P ps',,,)# Spool   UNXC 586
gksconf:;gksopen:(41,17);confgks:$)])#                                  UNXC 587
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 588
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 589
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 590
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 591
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 592
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 593
##                                                                      UNXC 594
##    HP 7475A Portrait  A4 - spooled output - Xelion GKS on VAX/VMS    UNXC 595
##                                                                      UNXC 596
macro:(dcode0:,HP74A4)#                Local device name                UNXC 597
macro:(xmaxw0:,0.7200)#                Plot width  (x) in units         UNXC 598
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 599
macro:(xpixl0:,7200.)#                 Pixels per unit along x          UNXC 600
macro:(ypixl0:,10000.)#                Pixels per unit along y          UNXC 601
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 602
macro:(color0:,-1)#                    Colour without initialization    UNXC 603
macro:(start0:,[$(#                    Initialize the output            UNXC 604
CALL LIB$$SET_LOGICAL('GKS_HP_SPL_CMMND','Lpr -f %s -P hp',,,)# Spool   UNXC 605
gksconf:;gksopen:(41,108);confgks:$)])#                                 UNXC 606
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 607
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 608
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 609
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 610
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 611
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 612
##                                                                      UNXC 613
##    Dec LN03 Printer - Spooled output - Xelion GKS                    UNXC 614
##                                                                      UNXC 615
macro:(dcode0:,LN03DC)#                Local device name                UNXC 616
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 617
macro:(ymaxh0:,0.7499)#                Plot height (y) in units         UNXC 618
macro:(xpixl0:,4095.)#                 Pixels per unit along x          UNXC 619
macro:(ypixl0:,3071.)#                 Pixels per unit along y          UNXC 620
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 621
macro:(color0:,no:)#                   Is color supported               UNXC 622
macro:(start0:,[$(gksconf:;gksopen:(41,129);confgks:$)])# Initialize    UNXC 623
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 624
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 625
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 626
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 627
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 628
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 629
##                                                                      UNXC 630
##    HP 7475A Portrait  A3 - spooled output - Xelion GKS on VAX/VMS    UNXC 631
##                                                                      UNXC 632
macro:(dcode0:,HP74A3)#                Local device name                UNXC 633
macro:(xmaxw0:,0.7200)#                Plot width  (x) in units         UNXC 634
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 635
macro:(xpixl0:,7200.)#                 Pixels per unit along x          UNXC 636
macro:(ypixl0:,10000.)#                Pixels per unit along y          UNXC 637
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 638
macro:(color0:,-1)#                    Colour without initialization    UNXC 639
macro:(start0:,[$(#                    Initialize the output            UNXC 640
CALL LIB$$SET_LOGICAL('GKS_HP_SPL_CMMND','Lpr -f %s -P hp',,,)# Spool   UNXC 641
CALL LIB$$SET_LOGICAL('GKS_HP_SCLNG_PNTS','170 602 15370 10602',,,)#    UNXC 642
gksconf:;gksopen:(41,108);confgks:$)])#                                 UNXC 643
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 644
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 645
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 646
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 647
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 648
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 649
##                                                                      UNXC 650
##   Cyber 205 plot using TEMPLATE, MEGATEK Corp. plot package          UNXC 651
##                                                                      UNXC 652
macro:(dcode0:,TMPLAT)#                Local device name (6chrs)        UNXC 653
macro:(xmaxw0:,13.)#                   Plot width  (x) in units         UNXC 654
macro:(ymaxh0:,10.)#                   Plot height (y) in units         UNXC 655
macro:(xpixl0:,1.)#                    Pixels per unit along x          UNXC 656
macro:(ypixl0:,1.)#                    Pixels per unit along y          UNXC 657
macro:(buffr0:,1)#                     Qx buffer size for plot          UNXC 658
macro:(color0:,no:)#                   Is color supported               UNXC 659
macro:(start0:,[$(CALL USTART#         Initialize the output            UNXC 660
CALL UWINDO(0.0,xmaxw5:,0.0,ymaxh0:)$)])#                               UNXC 661
macro:(frame0:,CALL UMOVE(XMAXW?:+1.0,0.0))# Start a new plot frame     UNXC 662
macro:(plotp0:,[$(#                    Plot x,y coordinates             UNXC 663
IF($3==2) CALL UDRAW(QX($2),QX($2+buffr0:))#                            UNXC 664
ELSE CALL UMOVE(QX($2),QX($2+buffr0:))$)])#                             UNXC 665
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 666
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 667
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 668
macro:(finis0:,CALL UEND)#             Finish the plot output           UNXC 669
##                                                                      UNXC 670
##     Sun Window  using PHIGS commands.                                UNXC 671
##                                                                      UNXC 672
## >>>>>>Note also set 'SUNFIG' in the reconfigure select: below!!!     UNXC 673
##                                                                      UNXC 674
macro:(dcode0:,SUNFIG)#                Local device name (6chrs)        UNXC 675
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 676
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 677
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 678
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 679
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 680
macro:(color0:,yes:)#                  Is color supported               UNXC 681
macro:(start0:,[$(figopen:(1,0,PHIGSWSTTOOL)$)])# Initialize output     UNXC 682
macro:(frame0:,[figwait:(1)])#         Start a new plot frame           UNXC 683
macro:(plotp0:,[figline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 684
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 685
macro:(nupen0:,CALL PSPLCI($1))#       Color index for polyline         UNXC 686
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 687
macro:(finis0:,[figclose:(1)])#        Finish the plot output           UNXC 688
##                                                                      UNXC 689
##          X-Windows Screen using XGKS                                 UNXC 690
##                                                                      UNXC 691
macro:(dcode0:,X11GKS)#                Local device name (6chrs)        UNXC 692
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 693
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 694
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 695
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 696
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 697
macro:(color0:,no: )#                  Is color supported               UNXC 698
macro:(start0:,[gksopen:(0,4)])#       Initialize the output            UNXC 699
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 700
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 701
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 702
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 703
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 704
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 705
##                                                                      UNXC 706
##  IBM Risc/6000 workstation using GKS option to graPHIGS              UNXC 707
##                                                                      UNXC 708
macro:(dcode0:,RS6000)#                Local device name (6chrs)        UNXC 709
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 710
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 711
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 712
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 713
macro:(buffr0:,1000.)#                 Qx buffer size for plot          UNXC 714
macro:(color0:,yes:)#                  Is color supported               UNXC 715
macro:(start0:,[gksopen:(0,1)])#       Initialize the output            UNXC 716
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 717
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 718
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 719
macro:(nupen0:,gksindex:($1))#         Change the plot colour           UNXC 720
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 721
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 722
##                                                                      UNXC 723
##      DEC5000 workstation with Ultrix GKS                             UNXC 724
##                                                                      UNXC 725
macro:(dcode0:,DC5000)#                Local device name (6chrs)        UNXC 726
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 727
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 728
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 729
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 730
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 731
macro:(color0:,yes:)#                  Is color supported               UNXC 732
macro:(start0:,[gksopen:(0,0)])#       Initialize the output            UNXC 733
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 734
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 735
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 736
macro:(nupen0:,gksindex:($1))#         Color index for polyline         UNXC 737
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 738
macro:(finis0:,[gksclose:])#           Finish the plot output           UNXC 739
##                                                                      UNXC 740
##  HP 7475A Portrait  A4 - spooled output - Xelion GKS on SUN/UNIX     UNXC 741
##                                                                      UNXC 742
macro:(dcode0:,HP74A4)#                Local device name                UNXC 743
macro:(xmaxw0:,0.7200)#                Plot width  (x) in units         UNXC 744
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 745
macro:(xpixl0:,7200.)#                 Pixels per unit along x          UNXC 746
macro:(ypixl0:,10000.)#                Pixels per unit along y          UNXC 747
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 748
macro:(color0:,-1)#                    Colour without initialization    UNXC 749
macro:(start0:,[$(gksconf:;gksopen:(41,108);confgks:$)])# Initialize    UNXC 750
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 751
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 752
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 753
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 754
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 755
macro:(finis0:,[gksclose:(40)])#       Finish the plot output           UNXC 756
##                                                                      UNXC 757
##    HP 7475A Portrait  A3 - spooled output - Xelion GKS on SUN/UNIX   UNXC 758
##                                                                      UNXC 759
macro:(dcode0:,HP74A3)#                Local device name                UNXC 760
macro:(xmaxw0:,0.7200)#                Plot width  (x) in units         UNXC 761
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 762
macro:(xpixl0:,7200.)#                 Pixels per unit along x          UNXC 763
macro:(ypixl0:,10000.)#                Pixels per unit along y          UNXC 764
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 765
macro:(color0:,-1)#                    Colour without initialization    UNXC 766
macro:(start0:,[$(#                    Initialize the output            UNXC 767
CALL PUTENV('GKS_HP_SCLNG_PNTS=170 602 15370 10602',37)# A4 p1 & p2     UNXC 768
gksconf:;gksopen:(41,108);confgks:$)])#                                 UNXC 769
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 770
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 771
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 772
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 773
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 774
macro:(finis0:,[gksclose:(40)])#       Finish the plot output           UNXC 775
##                                                                      UNXC 776
##       Colour X-Window workstation using Xelion-GKS.                  UNXC 777
##                                                                      UNXC 778
macro:(dcode0:,X-WDCL)#                Local device name                UNXC 779
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 780
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 781
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 782
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 783
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 784
macro:(color0:,yes:)#                  Is color supported               UNXC 785
macro:(start0:,[$(gksconf:;gksopen:(41,146);confgks:$)])# Initialize    UNXC 786
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 787
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 788
macro:(areap0:, [gksarea:($1,$2,$3)])# Fill area of x,y coordinates     UNXC 789
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 790
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 791
macro:(finis0:,[gksclose:(40)])#       Finish the plot output           UNXC 792
##                                                                      UNXC 793
## PostScript Printer (Portrait) - Spooled output - Xelion GKS on SUN   UNXC 794
##                                                                      UNXC 795
macro:(dcode0:,SPARC )#                Local device name                UNXC 796
macro:(xmaxw0:,0.7544)#                Plot width  (x) in units         UNXC 797
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 798
macro:(xpixl0:,2353.)#                 Pixels per unit along x          UNXC 799
macro:(ypixl0:,3119.)#                 Pixels per unit along y          UNXC 800
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 801
macro:(color0:,no:)#                   Is color supported               UNXC 802
macro:(start0:,[$(#                    Initialize the output            UNXC 803
CALL PUTENV('GKS_PS_SPL_CMMND=lpr -Psparc -r -s %s',37)# Spool comman   UNXC 804
gksconf:;gksopen:(41,17);CALL GSLWSC(2.7);confgks:$)])#                 UNXC 805
macro:(frame0:,CALL GCLRWK(1,1))#      Start a new plot frame           UNXC 806
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 807
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 808
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 809
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 810
macro:(finis0:,[gksclose:(40)])#       Finish the plot output           UNXC 811
##                                                                      UNXC 812
##       Black & White X-Window workstation using Xelion-GKS.           UNXC 813
##                                                                      UNXC 814
macro:(dcode0:,X-WDBW)#                Local device name                UNXC 815
macro:(xmaxw0:,1.)#                    Plot width  (x) in units         UNXC 816
macro:(ymaxh0:,1.)#                    Plot height (y) in units         UNXC 817
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 818
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 819
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 820
macro:(color0:,no:)#                   Is color supported               UNXC 821
macro:(start0:,[$(gksconf:;gksopen:(41,146);confgks:$)])# Initialize    UNXC 822
macro:(frame0:,[gkswait:(1)])#         Start a new plot frame           UNXC 823
macro:(plotp0:,[gksline:($1,$2,$3)])#  Plot x,y coordinates             UNXC 824
macro:(areap0:,[gksarea:($1,$2,$3)])#  Fill area of x,y coordinates     UNXC 825
macro:(nupen0:,[gkscolor:($1,$2)])#    Color index for polyline         UNXC 826
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 827
macro:(finis0:,[gksclose:(40)])#       Finish the plot output           UNXC 828
#                                                                       UNXC 829
##                                                                      UNXC 830
##     SCREEN display using SLPC FTN77 graphics                         UNXC 831
##                                                                      UNXC 832
macro:(dcode0:,SCREEN)#                Local device name (6chrs)        UNXC 833
macro:(xmaxw0:,640)#                   Plot width  (x) in units         UNXC 834
macro:(ymaxh0:,480)#                   Plot height (y) in units         UNXC 835
macro:(xpixl0:,1000.)#                 Pixels per unit along x          UNXC 836
macro:(ypixl0:,1000.)#                 Pixels per unit along y          UNXC 837
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 838
macro:(color0:,yes:)#                  Is color supported               UNXC 839
macro:(start0:,CALL VGA@)#             Initialize the output            UNXC 840
macro:(frame0:,[$(CALL SET_TEXT_ATTRIBUTE@(1,1.0,0.0,0.0);REPEAT$#      UNXC 841
$(CALL DRAW_TEXT@('Click a mouse button to continue',200,3,14);#        UNXC 842
CALL GET_MOUSE_POSITION@(MUS(1),MUS(2),MUS(3))#                         UNXC 843
IF(MUS(3)!=0) BREAK$);CALL CLEAR_SCREEN@$)])# Start new plot frame      UNXC 844
macro:(plotp0:,[$(IF($1>1)$($#         Plot x,y                         UNXC 845
DO I=0,$1-1;$(IX(I+1)=MIN0(MAX0(NINT(QX($2+I)),0),decr:(xmaxw2:))#      UNXC 846
IY(I+1)=MIN0(MAX0(ymaxh2:-NINT(QX($2+NBUF+I)),0),decr:(ymaxh2:))$)#     UNXC 847
CALL POLYLINE@(IX,IY,$1,$4+8)$)$)])#                                    UNXC 848
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 849
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 850
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 851
macro:(finis0:,CALL TEXT_MODE@)#       Finish the plot output           UNXC 852
##                                                                      UNXC 853
##     Dot matrix printer output using SLPC FTN77 graphics              UNXC 854
##                                                                      UNXC 855
macro:(dcode0:,GPRINT)#                Local device name (6chrs)        UNXC 856
macro:(xmaxw0:,960)#                   Plot width  (x) in units         UNXC 857
macro:(ymaxh0:,576)#                   Plot height (y) in units         UNXC 858
macro:(xpixl0:,10.00)#                 Pixels per unit along x          UNXC 859
macro:(ypixl0:,10.00)#                 Pixels per unit along y          UNXC 860
macro:(buffr0:,1000)#                  Qx buffer size for plot          UNXC 861
macro:(color0:,no:)#                   Is color supported               UNXC 862
macro:(start0:,[$(CALL OPEN_GPRINT_DEVICE@(1,IWIWIW)# Init. output      UNXC 863
IF(IWIWIW!=0)iquit:(PX0002)$)])#                                        UNXC 864
macro:(frame0:,CALL NEW_PAGE@)#                                         UNXC 865
macro:(plotp0:,[$(IF($1>1)$($#         Plot x,y                         UNXC 866
DO I=0,$1-1;$(IX(I+1)=MIN0(MAX0(NINT(QX($2+I)),0),decr:(xmaxw0:))#      UNXC 867
IY(I+1)=MIN0(MAX0(ymaxh0:-NINT(QX($2+NBUF+I)*0.6),0),$#                 UNXC 868
decr:(ymaxh0:))$);CALL POLYLINE@(IX,IY,$1,1)$)$)])#                     UNXC 869
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 870
macro:(nupen0:,noop:)#                 Change the plot colour           UNXC 871
macro:(ptext0:,noop:)#                 Draw characters                  UNXC 872
macro:(finis0:,CALL CLOSE_GRAPHICS_PRINTER@)# Finish plot output        UNXC 873
##                                                                      UNXC 874
##          CALCOMP 748 plotter                                         UNXC 875
##                                                                      UNXC 876
macro:(dcode0:,CALCMP)#                Local device name (6chrs)        UNXC 877
macro:(xmaxw0:,25.0)#                  Plot width  (x) in units         UNXC 878
macro:(ymaxh0:,25.0)#                  Plot height (y) in units         UNXC 879
macro:(xpixl0:,1000.0)#                Pixels per unit along x          UNXC 880
macro:(ypixl0:,1000.0)#                Pixels per unit along y          UNXC 881
macro:(buffr0:,1)#                     Qx buffer size for plot          UNXC 882
macro:(color0:,no:)#                   Default no colour                UNXC 883
macro:(start0:,$(OPEN(2,FILE='XTALPLT');CALL PLOTS(0,0,2)$))# Init ot   UNXC 884
macro:(frame0:,CALL PLOT(0.0,YMAX2+2.0,-3))# Start a new plot frame     UNXC 885
macro:(plotp0:,CALL PLOT(QX($2),QX($2+1),$3))# Plot x,y coordinates     UNXC 886
macro:(areap0:,noop:)#                 Fill area of x,y coordinates     UNXC 887
macro:(nupen0:,CALL NEWPEN($1))#       Color index for polyline         UNXC 888
macro:(ptext0:,CALL SYMBOL($1,$2,$3,$6,0,$4,$5))# Draw characters       UNXC 889
macro:(finis0:,$(CALL PLOT(0.0,0.0,999);CLOSE(2)$))# Finish plot ot     UNXC 890
##                                                                      UNXC 891
endsel:#                                                                UNXC 892
pmacro:([no:])#                                                         UNXC 893
