systemheader:(SI    )#                                                  SI     1
####################################################################### SI     2
##      Copyright (C) 2000, The Xtal System, The University of        # SI     3
##            Western Australia, xtal@crystal.uwa.edu.au.             # SI     4
## Distributed under the GNU General Public Licence as published by   # SI     5
## the Free Software Foundation, in the hope that it will be useful   # SI     6
## but WITHOUT ANY WARRANTY. See the GNU General Public License       # SI     7
## for more details.                                                  # SI     8
#                                                                     # SI     9
#                            *** SIMPEL ***                           # SI    10
#                                                                     # SI    11
#     THE PROGRAM SIMPEL ESTIMATES AND EXTENDS STRUCTURE FACTOR       # SI    12
#     PHASES USING A SYMBOLIC ADDITION PROCEDURE. NUMERIC PHASES      # SI    13
#     ARE ESTIMATED FROM SYMBOL CORRELATION AND A VARIETY OF          # SI    14
#     FIGURES OF MERIT.                                               # SI    15
#                                                                     # SI    16
####################################################################### SI    17
#                                                                       SI    18
include:(XMACRO)#                                                       SI    19
#                                                                       SI    20
macro:(raiseexception:,$(XCEPT=$1;RETURN$))# Throw an exception         SI    21
macro:(catchexception:,IF(XCEPT!=0)RETURN)#                             SI    22
macro:(symbolc:,CALL SI01($1,$2,$3,$4,$5,$6))#                          SI    23
macro:(symboln:,CALL SI02($1,$2,$3,$4,$5,$6,$7))#                       SI    24
macro:(putsymb:,CALL SI03($1,$2,$3))#                                   SI    25
macro:(ib:,NINT(BUFIN($1)))#                                            SI    26
macro:(bf:,BUFIN($1))#                                                  SI    27
macro:(iqx:,NINT(QX($1)))#                                              SI    28
macro:(swapakwd:,$(movepakwd:($1,QIQI);movepakwd:($2,$1)#               SI    29
movepakwd:(QIQI,$2)$))#                                                 SI    30
#                                                                       SI    31
macro:(genlist:,[ifelse:($1,,NG,$1)])# Define gen list pointer          SI    32
macro:(hkl:,[QX(genlist:($1)+ 1)])#    Define packed hkl    +1          SI    33
macro:(uvw:,[QX(genlist:($1)+ 2)])#    Define packed uvw    +2          SI    34
macro:(prc:,[QX(genlist:($1)+ 3)])#    Define restr code    +3          SI    35
macro:(wgt:,[QX(genlist:($1)+ 4)])#    Define phase weight  +4          SI    36
macro:(evl:,[QX(genlist:($1)+ 5)])#    Define /e/-value     +5          SI    37
macro:(alp:,[QX(genlist:($1)+ 6)])#    Define part alfa(e)  +6          SI    38
macro:(sta:,[QX(genlist:($1)+ 8)])#    Define start status  +8          SI    39
macro:(pnt:,[QX(genlist:($1)+ 9)])#    Define sort pointer  +9          SI    40
macro:(sma:,[QX(genlist:($1)+10)])#    Define sum w*alpha   +10         SI    41
macro:(top:,[QX(genlist:($1)+11)])#    Define top si block  +11         SI    42
macro:(bot:,[QX(genlist:($1)+12)])#    Define bot si block  +12         SI    43
#                                                                       SI    44
macro:(sym:,[QX(genlist:($1)+ 5)])#    Define phase symbol1 +5          SI    45
macro:(sy2:,[QX(genlist:($1)+ 6)])#    Define phase symbol2 +6          SI    46
macro:(phi:,[QX(genlist:($1)+ 7)])#    Define phase value   +7          SI    47
macro:(seq:,[QX(genlist:($1)+10)])#    Define sequence ordr +10         SI    48
#                                                                       SI    49
macro:(iprc:,[NINT(prc:($1))])#        Define integer restr code        SI    50
macro:(ista:,[NINT(sta:($1))])#        Define integer start status      SI    51
macro:(ipnt:,[NINT(pnt:($1))])#        Define integer sort order        SI    52
macro:(itop:,[NINT(top:($1))])#        Define integer si block          SI    53
macro:(ibot:,[NINT(bot:($1))])#        Define integer si block          SI    54
macro:(iseq:,[NINT(seq:($1))])#        Define integer sort order        SI    55
#                                                                       SI    56
#                                      Decode file4 (inv) of gensin     SI    57
#                                                      Word    bits     SI    58
macro:(phaserestrict:,intunpak:(QX($1+1),$2, 0, 4))# 1    0 -  3    ^   SI    59
macro:(phisigncode:,  intunpak:(QX($1+1),$2, 4, 3))# 1    4 -  6    ^   SI    60
macro:(phiinvshift:,  intunpak:(QX($1+1),$2, 7, 4))# 1    7 - 10    ^   SI    61
macro:(phifragment:,  intunpak:(QX($1+1),$2,11, 9))# 1   11 - 19    ^   SI    62
macro:(probfactor:,intunpak:(QX($1+1),$2,20,bitlen:(20)))# 1 20 - 31    SI    63
macro:(xvectorsum:,   intunpak:(QX($1+2),$2,10,10))# 2   10 - 10    ^   SI    64
macro:(probfsigma:,intunpak:(QX($1+2),$2,20,bitlen:(20)))# 2 20 - 31    SI    65
macro:(generatornum:,         $2=NINT(QX($1+2+$3)))# 2+n            ^   SI    66
#                                      Macros to compare packed data    SI    67
macro:(comppakwdone:,compakwd:(QX($1+1),$2,$3,$4))# 1st inv word        SI    68
macro:(plastbitsword:,intpak:($1,$2,20,bitlen:(20)))# Pack pfactor      SI    69
#                                                                       SI    70
extrude:(SICOMN)#                                                       SI    71
REAL ALIM#                             Average a value of starters      SI    72
REAL APHI(64)#                         Average phase for sets           SI    73
REAL AMIN(3)#                          Minimum probability factors      SI    74
REAL DSNM#                             Data set number                  SI    75
REAL EDR#                              Edr type no. = 3                 SI    76
REAL ELIM#                             A threshold used for ethr        SI    77
REAL EMIN#                             /e/ minimum for all gens         SI    78
REAL EPAR#                             /e/ min for bdf input phases     SI    79
REAL ETYP#                             Type of /e/ used (1 or 2)        SI    80
INTEGER ETHR(20)#                      A-thresholds for extension       SI    81
REAL FOPT(6)#                          Fom optimal values               SI    82
REAL FOM(8,64)#                        Foms per phase set               SI    83
REAL FRAC#                             Molecular fraction for bdf p     SI    84
REAL H(3)#                             General hkl indices array        SI    85
REAL HEAV#                             Heavy atom factor                SI    86
INTEGER IACC#                          Acceptance mode (1=w;2=na)       SI    87
INTEGER ICNT#                          Centro flag (nc=0, c=1)          SI    88
INTEGER IPRT(10)#                      Print start index yes>0          SI    89
INTEGER IEDR#                          Edr start status = 3             SI    90
INTEGER IH(3)#                         General hkl indices array        SI    91
INTEGER INPH#                          Input phi (no=0,fc=1,si=2)       SI    92
INTEGER INOS#                          No-start status = 1              SI    93
INTEGER INUL#                          Suppress status = 6              SI    94
INTEGER IODR#                          Odr start status = 2             SI    95
INTEGER ISYM#                          Symbol start status = 4          SI    96
INTEGER IPNT#                          Phase set print (=no. sets)      SI    97
INTEGER IQPS#                          Qpsi flag (excl=0,else=1)        SI    98
INTEGER IREC#                          Current lead record number       SI    99
INTEGER IR(77)#                        Relative pkt pointer array       SI   100
INTEGER ISEL#                          Si select(all=-2,q4=0,t3=2)      SI   101
INTEGER ISET#                          Preset start status = 5          SI   102
INTEGER IW(76)#                        Item request (want) array        SI   103
INTEGER IXVF#                          Xvflag(all=1,def=2,part=3)       SI   104
INTEGER DPHI(8)#                       Symbol increments                SI   105
INTEGER LEDR#                          Edr permute limit                SI   106
INTEGER LTYP#                          Lattice type (1 to 7)            SI   107
INTEGER KEY(4)#                        Indexpkt signal array            SI   108
INTEGER MARK#                          Packet lensih of genlist         SI   109
INTEGER MDSI(3)#                       Structure invariant moduli       SI   110
REAL MINE#                             Min expect factor for ale        SI   111
INTEGER MODE#                          Symbad mode (1mult;2sing)        SI   112
INTEGER MSEL#                          Start types to be selected       SI   113
INTEGER MSTR#                          Max phase set from path          SI   114
REAL    MXTG#                          Max trip/gen                     SI   115
REAL    MXQG#                          Max quar/gen                     SI   116
INTEGER M0#                            Start-1 of sin/cos tables        SI   117
INTEGER M1#                            Start-1 of generator list        SI   118
INTEGER ME#                            End of ext generators            SI   119
INTEGER MG#                            End of start generators          SI   120
INTEGER MT#                            End of total nonpsi gener        SI   121
INTEGER M2#                            Start-1 of ran. access buff      SI   122
INTEGER M3#                            End     of temporary buffer      SI   123
INTEGER METH#                          Flag for converge method         SI   124
INTEGER NANT#                          Enantio definition flag          SI   125
INTEGER NBLK#                          Number reflns/ iteration blk     SI   126
INTEGER NCUT#                          Addr limit of top generators     SI   127
INTEGER NEGQ#                          Neg quartet indicator = 3        SI   128
INTEGER NGEN#                          Number of generators             SI   129
INTEGER NLIM#                          Highest addr of starter          SI   130
INTEGER NMDS#                          Dataset offset pointer           SI   131
INTEGER NODR#                          Numb origin def. generators      SI   132
INTEGER NONR#                          No. of nonrestr. odr phases      SI   133
INTEGER NOPS#                          No. of requested phase sets      SI   134
REAL NOS#                              Non-starting phi = 1             SI   135
INTEGER NPER#                          Count of permute starters        SI   136
INTEGER NPSI#                          Count of psi(0) generators       SI   137
INTEGER NQPS#                          Phase shift for nq4 psi          SI   138
INTEGER NRAN#                          For storage                      SI   139
INTEGER NSOP#                          Total number of symops           SI   140
INTEGER NSTR#                          Count of starting phases         SI   141
INTEGER NSTG#                          Count of start generators        SI   142
INTEGER NSYMB#                         Count of symbols assigned        SI   143
INTEGER NSTE#                          Count of extention generator     SI   144
INTEGER NSEL#                          Num gens eligible as starts      SI   145
INTEGER NSET#                          Number phase sets fom test       SI   146
INTEGER NTOT#                          Count of total generators        SI   147
INTEGER NTYP(4)#                       Count of invariant types         SI   148
REAL NUL#                              Null generator type = 6          SI   149
REAL ODR#                              Odr generator type = 2           SI   150
REAL PFAC#                             Sigma ratio of prob. factor      SI   151
REAL PHIAV#                            Mean expected phi                SI   152
INTEGER POSQ#                          Positive quartet  = 2            SI   153
INTEGER POUT#                          Number phase sets output         SI   154
INTEGER PSI0#                          Psi0 triplet indicator = 1       SI   155
REAL PSET(16)#                         Requested op phase sets          SI   156
REAL SCAL#                             Frel scale for bdf phi test      SI   157
REAL SET#                              Set phi generator = 5            SI   158
REAL SIGA#                             Factor of siga to reduce a       SI   159
REAL SIMX(3)#                          Count of ivariant orders         SI   160
REAL SIVC(3,3)#                        Structure invariant vectors      SI   161
INTEGER SPHI(8)#                       Symbol starting values           SI   162
REAL STMN#                             Sin theta /lambda maximum        SI   163
REAL STMX#                             Sin theta /lambda minimum        SI   164
REAL STYP(4)#                          Counts of invariant types        SI   165
REAL SYM#                              Symbol generator type = 4        SI   166
INTEGER TRIP#                          Triplet indicator = 0            SI   167
INTEGER TYPE#                          Start phase (ran=0;per=1;mag     SI   168
REAL WMIN#                             Min accept phase weight          SI   169
REAL WFOM(6)#                          Fom weights                      SI   170
INTEGER XCEPT#                         Exception flag                   SI   171
REAL XSHI#                             Xvec sum upper thresh.           SI   172
REAL XSLO#                             Xvec sum lower thresh.           SI   173
REAL XSMN#                             Xvec sum min found               SI   174
REAL XSMX#                             Xvec sum max found               SI   175
REAL XVMN#                             Xvector lower threshold          SI   176
REAL XVMX#                             Xvector upper threshold          SI   177
#                                                                       SI   178
COMMON /COMISI/$#                                                       SI   179
ETHR,IACC,IEDR,ICNT,ISEL,IPNT,INPH,IQPS,IXVF,IREC,NSYMB,#               SI   180
ISET,IH,IR,IW,KEY,LTYP,MARK,MSEL,MDSI,M0,M1,M2,M3,ME,MG,MT,#            SI   181
MSTR,NANT,NBLK,NLIM,NODR,NONR,NPER,NPSI,NGEN,INOS,INUL,IODR,ISYM,#      SI   182
LEDR,NEGQ,NMDS,NQPS,NRAN,NSEL,NSTR,NTOT,NTYP,POSQ,#                     SI   183
POUT,PSI0,TRIP,NOPS,NCUT,NSET,TYPE,NSTG,NSTE,IPRT,METH,MODE,#           SI   184
SPHI,DPHI,NSOP,XCEPT#                                                   SI   185
#                                                                       SI   186
COMMON /COMFSI/$#                                                       SI   187
ALIM,APHI,AMIN,DSNM,ELIM,EDR,EMIN,EPAR,ETYP,FOM,#                       SI   188
FRAC,H,HEAV,NOS,NUL,ODR,SYM,PFAC,SET,SIGA,SIMX,SCAL,#                   SI   189
STMN,STYP,SIVC,STMX,XVMN,XVMX,XSLO,XSHI,XSMN,XSMX,#                     SI   190
MINE,FOPT,MXTG,MXQG,WMIN,WFOM,PSET,PHIAV#                               SI   191
endext:#                                                                SI   192
#                                                                       SI   193
systemheader:(SI00)#                   Simpel symbolic phasing          SI00   1
####################################################################    SI00   2
#                                                                  #    SI00   3
#                             SI00                                 #    SI00   4
#                                                                  #    SI00   5
####################################################################    SI00   6
SUBROUTINE SI00#                       O. overbeek     1974             SI00   7
#                                        N. vanderputten 1974           SI00   8
include:(AACOMN)#                      C. kiers        1980             SI00   9
include:(SICOMN)#                      S.r. hall       1984             SI00  10
#                                                                       SI00  11
FILEXT(IOUNIT(3))='XX1'#               Extension for scratch unit       SI00  12
FILEXT(IOUNIT(4))='INV'#               Extension for ip invariants      SI00  13
FILEXT(iofm1:)   ='SI0'#               Potential re-entrant fmt file    SI00  14
#                                                                       SI00  15
CALL SI10#                             Enter control lines              SI00  16
catchexception:#                       Abandon run                      SI00  17
CALL SI20#                             Enter elist & invariants         SI00  18
CALL SI25#                             Print control parameters         SI00  19
CALL SI30#                             Convergence & select starts      SI00  20
CALL SI40#                             Apply symbols & divergence       SI00  21
CALL SI50#                             Apply divergence symbols         SI00  22
CALL SI60#                             Apply symbolic addition          SI00  23
CALL SI70#                             Correlate symbol phases          SI00  24
CALL SI80#                             Test phases with fom's           SI00  25
CALL SI90#                             Output phase sets                SI00  26
#                                                                       SI00  27
RETURN#                                                                 SI00  28
END#                                                                    SI00  29
systemheader:(SI01)#                   Centrosymmetric symbol add       SI01   1
####################################################################    SI01   2
#                                                                  #    SI01   3
#                             SI01                                 #    SI01   4
#                                                                  #    SI01   5
####################################################################    SI01   6
SUBROUTINE SI01(IT,S2,S3,S4,IP,IS)#    S.r.hall dec 84                  SI01   7
INTEGER IT,S2,S3,S4,IP,IS#                                              SI01   8
#                                                                       SI01   9
#                                                                       SI01  10
IF(IT<2) IS=xor:(IP,xor:(S2,S3))#      Symbol phase for triplet         SI01  11
ELSE     IS=xor:(IP,xor:(S2,xor:(S3,S4)))# Symbol phase for quartet     SI01  12
#                                                                       SI01  13
RETURN#                                                                 SI01  14
END#                                                                    SI01  15
systemheader:(SI02)#                   Noncentrosymmetric add           SI02   1
####################################################################    SI02   2
#                                                                  #    SI02   3
#                             SI02                                 #    SI02   4
#                                                                  #    SI02   5
####################################################################    SI02   6
SUBROUTINE SI02(IT,S2,S3,S4,II,IP,SJ)# S.r.hall dec 84                  SI02   7
ifsel:(DSI)#                                                            SI02   8
EXTERNAL S2,S3,S4#                                                      SI02   9
endsel:#                                                                SI02  10
include:(AACOMN)#                                                       SI02  11
include:(SICOMN)#                                                       SI02  12
INTEGER I,J,K,L#                                                        SI02  13
INTEGER SJ(3),S2(3),S3(3),S4(3)#                                        SI02  14
REAL    SK(3)#                                                          SI02  15
INTEGER IT,IS,IP,II#                                                    SI02  16
intdata:(I1,1077952576)#               Hex 40404040                     SI02  17
intdata:(I2,hex80:)#                   Hex 80808080                     SI02  18
intdata:(IS2,[+1,-1,+1,-1,+1,-1,+1,-1])#                                SI02  19
intdata:(IS3,[+1,+1,-1,-1,+1,+1,-1,-1])#                                SI02  20
intdata:(IS4,[+1,+1,+1,+1,-1,-1,-1,-1])#                                SI02  21
datastuff:#                                                             SI02  22
#                                                                       SI02  23
#                                                                       SI02  24
IS=II+1;        SJ(2)=0#               Set phase sign code              SI02  25
IF(IS2(IS)<0)#                         Add n2 symbol                    SI02  26
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI02  27
SJ(1)=+S2(1)#                          Add n2 symbol word 1             SI02  28
IF(NSYMB>4) SJ(2)=+S2(2)#              Add n2 symbol word 2             SI02  29
SJ(3)=+S2(3)+IP#                       Add n2 phase + shift             SI02  30
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI02  31
ELSE#                                  Sub n2 symbol                    SI02  32
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI02  33
SJ(1)=-S2(1)+I2#                       Sub n2 symbol word 1             SI02  34
IF(NSYMB>4) SJ(2)=-S2(2)+I2#           Sub n2 symbol word 2             SI02  35
SJ(3)=-S2(3)+IP#                       Sub n2 phase + shift             SI02  36
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI02  37
IF(IS3(IS)<0)#                         Add n3 symbol                    SI02  38
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI02  39
SJ(1)=SJ(1)+S3(1)-I1#                  Add n3 symbol word 1             SI02  40
IF(NSYMB>4) SJ(2)=SJ(2)+S3(2)-I1#      Add n3 symbol word 2             SI02  41
SJ(3)=SJ(3)+S3(3)#                     Add n3 phase                     SI02  42
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI02  43
ELSE#                                  Sub n3 symbol                    SI02  44
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI02  45
SJ(1)=SJ(1)-S3(1)+I1#                  Sub n3 symbol word 1             SI02  46
IF(NSYMB>4) SJ(2)=SJ(2)-S3(2)+I1#      Sub n3 symbol word 2             SI02  47
SJ(3)=SJ(3)-S3(3)#                     Sub n3 phase                     SI02  48
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI02  49
IF(IT>1)#                              If quartet                       SI02  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI02  51
IF(IS4(IS)<0)#                         Add n4 symbol                    SI02  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI02  53
SJ(1)=SJ(1)+S4(1)-I1#                  Add n4 symbol word 1             SI02  54
IF(NSYMB>4) SJ(2)=SJ(2)+S4(2)-I1#      Add n4 symbol word 2             SI02  55
SJ(3)=SJ(3)+S4(3)#                     Add n4 phase                     SI02  56
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI02  57
ELSE#                                  Sub n4 symbol                    SI02  58
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI02  59
SJ(1)=SJ(1)-S4(1)+I1#                  Sub n4 symbol word 1             SI02  60
IF(NSYMB>4) SJ(2)=SJ(2)-S4(2)+I1#      Sub n4 symbol word 2             SI02  61
SJ(3)=SJ(3)-S4(3)#                     Sub n4 phase                     SI02  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI02  63
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI02  64
#                                                                       SI02  65
#   REDUCE MULTIPLICITIES OF RESTRICTED PHASES                          SI02  66
#   ------------------------------------------                          SI02  67
#                                                                       SI02  68
I=and:(SJ(1),I2);  J=and:(SJ(2),I2)#   Test for symbol overflow         SI02  69
IF((I>0)\(J>0)) iquit:(SI0210)#        Symbol error......si0210         SI02  70
intpak:(SJ(1),SK(1),0,mxbtwd:)#        Pack integer into real word      SI02  71
intpak:(SJ(2),SK(2),0,mxbtwd:)#        Pack integer into real word      SI02  72
DO I=1,NSYMB#                          Loop over assigned symbols       SI02  73
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI02  74
IF(DPHI(I)<180) NEXT#                  Skip unrestricted phases         SI02  75
K=(I-1)*8#                             Point to symbol byte             SI02  76
IF(I<5) intunpak:(SK(1),J,K   ,7)#     Extract symbol code word 1       SI02  77
ELSE    intunpak:(SK(2),J,K-32,7)#     Extract symbol code word 2       SI02  78
IF((J==64)\(J==65)) NEXT#              Symbol cannot be reduced         SI02  79
J=J+8#                                 Bias symbol mult with 3*24       SI02  80
IF(MOD(J,2)==0) L=64#                  For even multiplicities          SI02  81
ELSE#                                  For odd  multiplicities          SI02  82
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI02  83
L=65;   J=J-1#                         Set symbol plus phase shift      SI02  84
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI02  85
IF(I<5) intpak:(L,SK(1),K   ,8)#       Insert new symbol multiplici     SI02  86
ELSE    intpak:(L,SK(2),K-32,8)#       Insert new symbol multiplici     SI02  87
IF(SPHI(I)>0) SJ(3)=SJ(3)+J*SPHI(I)#   Adjust phase for reduced mul     SI02  88
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI02  89
intunpak:(SK(1),SJ(1),0,mxbtwd:)#      Recover packed word              SI02  90
intunpak:(SK(2),SJ(2),0,mxbtwd:)#      Recover packed word              SI02  91
SJ(3)=MOD(3600+SJ(3),360)#             Reduce phi to mod360             SI02  92
#                                                                       SI02  93
RETURN#                                                                 SI02  94
END#                                                                    SI02  95
systemheader:(SI03)#                   Output symbol characters         SI03   1
####################################################################    SI03   2
#                                                                  #    SI03   3
#                             SI03                                 #    SI03   4
#                                                                  #    SI03   5
####################################################################    SI03   6
SUBROUTINE SI03(SK,II,MSYMB)#          S.r.hall mar 85                  SI03   7
include:(SICOMN)#                                                       SI03   8
include:(AACOMN)#                                                       SI03   9
#                                                                       SI03  10
REAL A,SK(3)#                                                           SI03  11
INTEGER IC,II,I,J,K,L,IS,MSYMB#                                         SI03  12
chardata:(SI1,-ABCDEFGHIJ+)#                                            SI03  13
datastuff:#                                                             SI03  14
#                                                                       SI03  15
IC=II;   IS=II-2#                      Set initial char position        SI03  16
IF(ICNT>0) CHROT(IS^IS)='+'#           Insert + for centro              SI03  17
DO I=1,MSYMB#                          Loop number of symbols           SI03  18
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI03  19
IF(ICNT==yes:)#                        If centrosymmetric               SI03  20
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI03  21
intunpak:(SK(1),J,I-1,1)#              Extract symbol bit               SI03  22
IF(J>0) CHROT(IS^IS)=SI1(I^I)#         Insert symbolic phase            SI03  23
IS=IS+1#                               Incr char position               SI03  24
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI03  25
ELSE#                                  For noncentrosymmetric           SI03  26
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI03  27
K=(I-1)*8#                             Point to symbol byte             SI03  28
IF(I<5)intunpak:(SK(1),J,K   ,7)#      Extract symbol byte word 1       SI03  29
ELSE   intunpak:(SK(2),J,K-32,7)#      Extract symbol byte word 2       SI03  30
IF(J==64) NEXT;    K=IABS(J-64)#       Comvert byte to number           SI03  31
IF(J>64) L=12;   ELSE L=1#             Point to + & - signs             SI03  32
CHROT(IC^IC)=SI1(L^L)#                 Insert + or - sign               SI03  33
IF(K>1)#                               Provided mult is 2 or more       SI03  34
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI03  35
IF(K<10) L=1;    ELSE L=2#             Set number of op digits          SI03  36
A=FLOAT((IC+L)*10000+L*100+13)#        Construct format of mult         SI03  37
ncodefld:(FLOAT(K),1,CHROT,A,1)#       Format symbol multiplier         SI03  38
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI03  39
ELSE L=0#                              No mult digits output            SI03  40
IC=IC+L+3#                             Point next symbol position       SI03  41
CHROT(IC-2^IC-2)=SI1(I+1^)#            Insert symbol itself             SI03  42
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI03  43
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI03  44
#                                                                       SI03  45
RETURN#                                                                 SI03  46
END#                                                                    SI03  47
systemheader:(SI10)#                   Enter simpel control lines       SI10   1
####################################################################    SI10   2
#                                                                  #    SI10   3
#                             SI10                                 #    SI10   4
#                                                                  #    SI10   5
####################################################################    SI10   6
SUBROUTINE SI10#                       S.r.hall  nov 84                 SI10   7
include:(AACOMN)#                                                       SI10   8
include:(SICOMN)#                                                       SI10   9
#                                                                       SI10  10
INTEGER I,J,K,L,M,N,IP,JSYM,MXIT,NFRG,NG,NP,NSTT#                       SI10  11
INTEGER EXIST#                                                          SI10  12
chardata:(SI1, START  PRINT  SYMBAD SETFOM INVAR  PHASE $#              SI10  13
 PSETS  END    )#                                                       SI10  14
chardata:(SI2,QUAALLTRI)#                                               SI10  15
chardata:(SI3,INVCONEXTDIVSYMCORFOMBDF)#                                SI10  16
chardata:(SI4,WAANMUSI)#                                                SI10  17
chardata:(SI5,ODREDRSYMSETNUL)#                                         SI10  18
chardata:(SI6," Gensin invariant file (.inv) not present -")#           SI10  19
chardata:(SI7," spawning GENEV and GENSIN calculations ...")#           SI10  20
intdata:(PRC,[45,0,30,45,60,75,90,120,135,150])#                        SI10  21
datastuff:#                                                             SI10  22
#                                                                       SI10  23
#                                                                       SI10  24
XCEPT=0#                               No exception                     SI10  25
inquirefile:(IOUNIT(4),EXIST,' ')#     Are the invariants there:        SI10  26
IF(EXIST==0)#                          Throw an exception               SI10  27
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI10  28
openfmt:(iofm1:,' ')#                                                   SI10  29
writefmt:(iofm1:,'(A)','GENEV ')#      Genev to reentrant file          SI10  30
writefmt:(iofm1:,'(A)','GENSIN ')#     Gensin to reentrant file         SI10  31
writefmt:(iofm1:,'(A)', CHRIP(1^80))#  Redo the simpel line             SI10  32
writeline:(2,SI6,NSI6,3,2)#            Output message                   SI10  33
writeline:(0,SI7,NSI7,3,2)#            Output message                   SI10  34
closefmt:(iofm1:)#                     Shut down the line file          SI10  35
linestream:('SI0')#                    Insert file into line stream     SI10  36
LINFLG=1#                              Force to read another line       SI10  37
XCEPT=1#                               Throw the exception              SI10  38
RETURN#                                Go no further                    SI10  39
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI10  40
#                                                                       SI10  41
#   PROCESS PARAMETERS ON SIMPEL LINE                                   SI10  42
#   ---------------------------------                                   SI10  43
#                                                                       SI10  44
ifnv:(bf:(1)) NSTG=ib:(1)#             Extract num start gener          SI10  45
ELSE          NSTG=0#                  Set default start gener          SI10  46
ifnv:(bf:(2)) NSTE=ib:(2)#             Extract num exten gener          SI10  47
ELSE          NSTE=0#                  Set default enten gener          SI10  48
ifnv:(bf:(3)) NSTT=ib:(3)#             Extract num total gener          SI10  49
ELSE          NSTT=0#                  Set default total gener          SI10  50
ifnv:(bf:(4)) EMIN=bf:(4)#             Extract minimum evalue           SI10  51
ELSE          EMIN=0.#                 Set default min evalue           SI10  52
ifnv:(bf:(5)) DSNM=bf:(5)#             Extract dataset number           SI10  53
ELSE          DSNM=1.#                 Default dataset number           SI10  54
ifnv:(bf:(6)) POUT=ib:(6)#             Extract op phase sets            SI10  55
ELSE          POUT=4#                  Default op phase sets            SI10  56
NGEN=1025#                             Default total generators         SI10  57
#                                                                       SI10  58
#   ASSIGN MEMORY AND BUFFERS                                           SI10  59
#   -------------------------                                           SI10  60
#                                                                       SI10  61
MARK=12#                               ****** genlist increment         SI10  62
M0=QXSTR; IOMARK(4)=M0#                Start of buffer for file4        SI10  63
M1=IOMARK(4)+bdfbuf:#                  Mark start of e-list             SI10  64
incrqx:(M1,M1,SI1010)#                 Expand qx .........si1010        SI10  65
#                                                                       SI10  66
#   ENTER GENSIN PARAMETERS FROM FILE4                                  SI10  67
#   ----------------------------------                                  SI10  68
#                                                                       SI10  69
readwpkt:(4,2,NP,IP,0)#                Point to record 2, file 4        SI10  70
IF(IP<=0) iquit:(SI1015)#              No bdf......si1015               SI10  71
ETYP=QX(IP+1)#                         Extract /e/-type used (1 or      SI10  72
EMIN=AMAX1(EMIN,QX(IP+2))#             Extract /e/-min of generator     SI10  73
PFAC=QX(IP+3)#                         Extract probability factor       SI10  74
NTOT=iqx:(IP+4)#                       Extract no. nonpsi0 gens.        SI10  75
NGEN=MIN0(NGEN,NTOT)#                  Set no. gens to be used          SI10  76
STMN=QX(IP+5)#                         Extract st/l min                 SI10  77
STMX=QX(IP+6)#                         Extract st/l max                 SI10  78
LTYP=iqx:(IP+8)#                       Extract lattice type             SI10  79
NFRG=iqx:(IP+9)#                       Extract fragment count           SI10  80
ICNT=iqx:(IP+10)#                      Get centro flag (nc=0,c=1)       SI10  81
NPSI=iqx:(IP+11)#                      Extract no. psi0 gens.           SI10  82
HEAV=QX(IP+12)#                        Extract heavy atom factor        SI10  83
NSOP=iqx:(IP+13)#                      Extract number of symops         SI10  84
IF(NSOP<1) NSOP=2#                     Set default value                SI10  85
NTOT=NTOT+NPSI#                        Set total gens. (incl psi0)      SI10  86
AMIN(1)=QX(IP+29);  AMIN(2)=QX(IP+30)# Extract min prob factors         SI10  87
XVMN=QX(IP+45);     XVMX=QX(IP+46)#    Extract xvec limits              SI10  88
XSLO=QX(IP+47);     XSHI=QX(IP+48)#    Extract xvec sum limits          SI10  89
XSMN=QX(IP+70);     XSMX=QX(IP+71)#    Extract xvec sum min/max         SI10  90
NODR=iqx:(IP+76)#                      Extract no. of odr required      SI10  91
NONR=iqx:(IP+77)#                      Extract no. nonr odr allowed     SI10  92
J=IP+79;   L=IP+82#                    Point to buffer addresses        SI10  93
DO I=1,3#                              Outer odr loop                   SI10  94
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI10  95
J=J+1;  MDSI(I)=iqx:(J)#               Extract si vector moduli         SI10  96
DO K=1,3#                              Inner odr loop                   SI10  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI10  98
L=L+1;  SIVC(K,I)=QX(L)#               Extract si vectors               SI10  99
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI10 100
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI10 101
#                                                                       SI10 102
#   SET DEFAULT CONTROL PARAMETERS                                      SI10 103
#   ------------------------------                                      SI10 104
#                                                                       SI10 105
incrqx:(M2,M1+MARK*NTOT,SI1020)#       Expand qx .......si1020          SI10 106
IF(NONR==0)      NANT=2#               All odr restricted phis          SI10 107
ELSE             NANT=1#               Some odr nonrestricted           SI10 108
IF(ICNT==yes:)   NANT=0#               No edr assigned if centro        SI10 109
EPAR=EMIN;  FRAC=.5;  SCAL=-1.#        Default control parameters       SI10 110
IXVF=3;   MXIT=30;    MINE=0.5#        Default control parameters       SI10 111
IF(NFRG>0) IQPS=yes:;  ELSE IQPS=no:#  Include frag q if present        SI10 112
ISEL=2;   SIGA=1.;  MSEL=-1;   MSTR=4# Default control parameters       SI10 113
NSEL=0;   LEDR=0#                      Default control parameters       SI10 114
NMDS=NINT(DSNM)*1000#                  Set dataset offset               SI10 115
NOS=1.;    ODR=2.;    EDR=3.#          Set status types                 SI10 116
SYM=4.;    SET=5.;    NUL=6.#          Set status types                 SI10 117
INOS=1;    IODR=2;    IEDR=3#          Set status types                 SI10 118
ISYM=4;    ISET=5;    INUL=6#          Set status types                 SI10 119
TRIP=0;  PSI0=1;  POSQ=2;  NEGQ=3#     Invariant type indicators        SI10 120
FOPT(1)=.75;  FOPT(2)=1.;   FOPT(3)=.25# Set default opt foms           SI10 121
FOPT(4)=.75;  FOPT(5)=60.;  FOPT(6)=1.# Set default opt foms            SI10 122
WFOM(1)=1.;   WFOM(2)=1.;   WFOM(3)=1.# Set default fom weights         SI10 123
WFOM(4)=1.;   WFOM(5)=1.;   WFOM(6)=1.# Set default fom weights         SI10 124
MXTG=100.;  MXQG=0.#                   Max t3 & pq per generator        SI10 125
DO I=1,20; ETHR(I)=0#                  Set extension thresholds         SI10 126
DO I=1,10; IPRT(I)=0#                  Set print dumps off              SI10 127
IF(NSTT>0)  NGEN=NSTT#                 Set input total generators       SI10 128
IF(NSTG==0) NSTG=MIN0(100,NGEN/4)#     Default symbol start set         SI10 129
IF(NSTE==0) NSTE=NSTG*2#               Default extension generators     SI10 130
METH=1;     NOPS=0#                    Set non-psi gener total          SI10 131
NSYMB=0;     NQPS=-1#                  Reset symbol count               SI10 132
IACC=1#                                Default accept based on w*a      SI10 133
MODE=1;     NSET=16#                   Default accept mult symb ind     SI10 134
WMIN=0.3;   JSYM=0#                    Min accept weight                SI10 135
ALIM=0.;    NBLK=100#                  Set default a thresholds         SI10 136
PHIAV=-1.#                             Flag for not set                 SI10 137
#                                                                       SI10 138
#   ENTER GENERATOR LIST FROM FILE 4                                    SI10 139
#   --------------------------------                                    SI10 140
#                                                                       SI10 141
FOR(NG=M1;NG<M2;NG=NG+MARK)#           Loop over generator list         SI10 142
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI10 143
readwpkt:(4,3,NP,IP,0)#                Point to next gen. packet        SI10 144
movereal:(QX,IP+1,QX,NG+1,NP,1)#       Store hkl,uvw,prc,sige,e         SI10 145
prc:=FLOAT(iprc:/100)#                 Extract phase restr code only    SI10 146
sta:=NOS#                              Set initial status as nos        SI10 147
wgt:=0.;   phi:=-.0001#                Set weight to zero               SI10 148
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI10 149
I=M1+MARK*NGEN;   J=MARK*NPSI#         Mark psi0 gen boundary           SI10 150
movereal:(QX,M2-J+1,QX,I+1,J,1)#       Remove unused normal gens.       SI10 151
MT=I;   NLIM=NTOT-NGEN-NPSI#           Set gen. pointers                SI10 152
M2=I+J#                                Mark end of gen list             SI10 153
NTOT=NGEN+NPSI#                        Count all generators             SI10 154
readwpkt:(4,endrecord:,I,I,0)#         Rewind and close file 4          SI10 155
#                                                                       SI10 156
#    ENTER CONTROL LINES                                                SI10 157
#    -------------------                                                SI10 158
#                                                                       SI10 159
REPEAT#                                Loop input control lines         SI10 160
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI10 161
readline:(SI1,NSI1)#                   Process input lines              SI10 162
#                                                                       SI10 163
IF(LINID==1)#                          ****** start line *****          SI10 164
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI10 165
IF(bf:(1)<voidflg:)#                   Test if character string         SI10 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI10 167
stringlim:(1,M,N)#                     Get limits of string             SI10 168
compchar:(CHRIN,M,SI2,1,3,3,9,K)#      Search for match in si2          SI10 169
IF(K==0) iquit:(SI1025)#               No match.......si1025            SI10 170
ISEL=K-1#                              Store selection code             SI10 171
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI10 172
IF(bf:(2)>voidflg:) METH=ib:(2)#       Set converge method              SI10 173
IF(bf:(3)>voidflg:) ALIM=bf:(3)*8.#    Set a threshold accept           SI10 174
IF(bf:(4)>voidflg:) SIGA=bf:(4)#       Set frac of siga reduction       SI10 175
IF(bf:(5)>voidflg:) MSTR=ib:(5)+100#   Set number conveg symbols        SI10 176
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI10 177
#                                                                       SI10 178
ELSE IF(LINID==2)#                     ******  print line *****         SI10 179
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI10 180
DO I=1,20#                             Loop over input fields           SI10 181
IF(bf:(I)<voidflg:)#                   Test if string present           SI10 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI10 183
stringlim:(I,M,N)#                     Get limits of string             SI10 184
compchar:(CHRIN,M,SI3,1,3,3,NSI3,J)#   Match with print code            SI10 185
IF(J==0) iquit:(SI1030)#               No match.......si1030            SI10 186
IPRT(J)=1#                             Set print flag                   SI10 187
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI10 188
ifvo:(bf:(1))DO I=1,10; IPRT(I)=1#     Switch on all print dumps        SI10 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI10 190
#                                                                       SI10 191
ELSE IF(LINID==3)#                     ******  symbad line *****        SI10 192
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI10 193
DO I=1,2#                              Loop over character fields       SI10 194
IF(bf:(I)<voidflg:)#                   Test if alpha code               SI10 195
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI10 196
stringlim:(I,M,N)#                     Get string limits                SI10 197
compchar:(CHRIN,M,SI4,1,2,2,NSI4,J)#   Search for match                 SI10 198
IF(J==0) iquit:(SI1040)#               No match.....si1040              SI10 199
IF(J<3) IACC=J#                        Set phase accept mode            SI10 200
ELSE    MODE=J-2#                      Set mult/sing accept             SI10 201
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI10 202
IF(bf:(3)>voidflg:) NBLK=ib:(3)#       Set iteration blocks             SI10 203
IF(bf:(4)>voidflg:) WMIN=bf:(4)#       Set minimum weight               SI10 204
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI10 205
#                                                                       SI10 206
ELSE IF(LINID==4)#                     ******  setfom line *****        SI10 207
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI10 208
IF(bf:(1)>voidflg:) NSET=MIN0(64,ib:(1))# Store number phase sets       SI10 209
DO I=1,6#                              Loop possible foms               SI10 210
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI10 211
J=I*2#                                 Point to field posns             SI10 212
IF(bf:(J  )>voidflg:) FOPT(I)=bf:(J  )# Extract active opt fom          SI10 213
IF(bf:(J+1)>voidflg:) WFOM(I)=bf:(J+1)# Extract active fom wgt          SI10 214
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI10 215
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI10 216
#                                                                       SI10 217
ELSE IF(LINID==5)#                     ****** invar line *****          SI10 218
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI10 219
IF(bf:(1)<voidflg:)#                   Test if character string         SI10 220
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI10 221
stringlim:(1,M,N)#                     Get limits of string             SI10 222
compchar:(CHRIN,M,SI2,1,3,3,9,NPER)#   Search for match in si2          SI10 223
IF(NPER==0) iquit:(SI1045)#            No match.......si1045            SI10 224
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI10 225
IF(bf:(2)>voidflg:) AMIN(1)=bf:(2)#    Set a min for triplets           SI10 226
IF(bf:(3)>voidflg:) AMIN(2)=bf:(3)#    Set b-min for quartets           SI10 227
IF(bf:(4)>voidflg:) MXTG=bf:(4)#       Set max trip/gen                 SI10 228
IF(bf:(5)>voidflg:) MXQG=bf:(5)#       Set max quar/gen                 SI10 229
IF(bf:(6)>voidflg:) XSLO=bf:(6)#       Set lower xvs threshold          SI10 230
IF(bf:(7)>voidflg:) XSHI=bf:(7)#       Set upper xvs threshold          SI10 231
IF(bf:(8)>voidflg:) NQPS=ib:(8)#       Set psi for neg quartets         SI10 232
IF(bf:(9)>voidflg:) PHIAV=bf:(9)#      Set expected average             SI10 233
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI10 234
#                                                                       SI10 235
ELSE IF(LINID==6)#                     ******* phase line ******        SI10 236
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI10 237
FOR(NG=M1;NG<MT;NG=NG+MARK)#           Loop over all generators         SI10 238
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI10 239
gethkl:(NG+1,H)#                       Extract h,k,l values             SI10 240
ifne:(bf:(1),H(1)) NEXT#               Skip if no h match               SI10 241
ifne:(bf:(2),H(2)) NEXT#               Skip if no k match               SI10 242
ifeq:(bf:(3),H(3)) BREAK#              Skip if no l match               SI10 243
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI10 244
IF(bf:(4)>voidflg:)#                   If phase input numeric           SI10 245
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI10 246
IF(MSTR<10) MSTR=0#                    Set default symbols to zero      SI10 247
sta:=SET;    wgt:=1.#                  Assume phase is set numeric      SI10 248
I=iprc:;    K=PRC(I)#                  Extract phase restriction        SI10 249
IF(I==1) phi:=bf:(4)#                  No restr set as input            SI10 250
ELSE#                                  Restricted test input value      SI10 251
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SI10 252
J=ib:(4)-K#                            Get diff with restr value        SI10 253
J=MIN0(IABS(J),IABS(J+360),IABS(J-360))# Ensure smallest diff           SI10 254
IF(J<=90) phi:=FLOAT(K)#               Set as restr value               SI10 255
ELSE      phi:=FLOAT(K+180)#           Set as restr value +pi           SI10 256
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SI10 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI10 258
ELSE sta:=SYM#                         Set as input symbol              SI10 259
IF(bf:(5)<voidflg:)#                   If status is entered             SI10 260
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SI10 261
stringlim:(5,M,N)#                     Find string limits               SI10 262
compchar:(CHRIN,M,SI5,1,3,3,NSI5,K)#   Find match for input             SI10 263
IF(K==0) iquit:(SI1050)#               No match status.....si1050       SI10 264
sta:=FLOAT(K+1)#                       Set status flag                  SI10 265
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SI10 266
IF(ista:==ISYM) JSYM=JSYM+1#           Count input symbols              SI10 267
IF(ista:==IODR) NODR=0#                Reset default odr count          SI10 268
IF(ista:==IEDR) NANT=0#                Reset default edr count          SI10 269
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI10 270
#                                                                       SI10 271
ELSE IF(LINID==7)#                     ******* psets line ******        SI10 272
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SI10 273
DO I=1,16#                             Loop over possible sets          SI10 274
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SI10 275
ifvo:(bf:(I)) BREAK#                   Exit on first void               SI10 276
NOPS=I;   PSET(I)=bf:(I)#              Set input phase set              SI10 277
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SI10 278
POUT=NOPS#                             Reset num op phase sets          SI10 279
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SI10 280
#                                                                       SI10 281
ELSE BREAK#                            ******  end line *****           SI10 282
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI10 283
#                                                                       SI10 284
#                                                                       SI10 285
IF(JSYM>8) iquit:(SI1060)#             Excess sym......si1060           SI10 286
IF(MSTR<10&JSYM>0) MSTR=JSYM#          Set no. symbols to input         SI10 287
IF(MSTR>10) MSTR=MIN0(8,MSTR-100)#     Set to requested count           SI10 288
MSTR=MSTR+NODR+MIN0(1,NANT)#           Set starts for maxcon            SI10 289
IF(MXQG<.5&(NPER==1\NPER==2)) MXQG=100.# Enable   quartets              SI10 290
IF(NPER==1) MXTG=0.#                   Prohibit triplets                SI10 291
IF(NFRG==no:) IQPS=no:#                Only used if available           SI10 292
IF((IQPS==no: )&(NQPS<0)) NQPS=180#    Set nq4 psi for no frag          SI10 293
IF((IQPS==yes:)&(NQPS<0)) NQPS=0#      Set nq4 psi if frag used         SI10 294
ifeq:(XSHI,0.) XSHI=-.1#               Reset xvs hi limit if 0          SI10 295
IF (XSLO>99.) XSLO=AMIN1(1.5,XSMX*.25)## Set default low xvs limit      SI10 296
IF((XSHI<0.)&(IXVF!=3)) XSHI=XSLO#     Set default upper xvs limit      SI10 297
IF((XSHI<0.)&(IXVF==3)) XSHI=AMIN1(5.,XSMX*.75)# Set upper xvs limit    SI10 298
NBLK=MIN0(NGEN,NBLK)#                  Check iteration limit            SI10 299
#                                                                       SI10 300
RETURN#                                                                 SI10 301
END#                                                                    SI10 302
systemheader:(SI20)#                   Input bdf phis & invariants      SI20   1
####################################################################    SI20   2
#                                                                  #    SI20   3
#                             SI20                                 #    SI20   4
#                                                                  #    SI20   5
####################################################################    SI20   6
SUBROUTINE SI20#                       S.r.hall  nov 84                 SI20   7
include:(AACOMN)#                                                       SI20   8
include:(SICOMN)#                                                       SI20   9
#                                                                       SI20  10
INTEGER I,IA,IB,IC,ID,II,IQ,IS,IT,J,IP,JP,K,MM,NINV,NN#                 SI20  11
INTEGER MREC,NREC,N1,N2,N3,N4,NG,NP,TOP,BOT#                            SI20  12
REAL A,AW,B,C,D,W,SUMW,SUMC,SSI(4),XVS#                                 SI20  13
chardata:(SI1,  NGEN  H   K   L    /E/   TYPE  TRIP$#                   SI20  14
  PSI0  POSQ  NEGQ     SUMA    SUMC)#                                   SI20  15
chardata:(SI2,   ODREDRSYMSETNUL)#                                      SI20  16
chardata:(SI3, **********GENERATOR DUMP IN INPUT ORDER)#                SI20  17
realdata:(FM,[90413.,130413.,170413.,50413.,#                           SI20  18
240522.,640812.,720812.,360603.,420603.,480603.,540603.])#              SI20  19
realdata:(ATHR,0.);   realdata:(BTHR,0.)#                               SI20  20
datastuff:#                                                             SI20  21
#                                                                       SI20  22
#   ENTER INVARIANTS FROM FILE 4                                        SI20  23
#   ---------------------------                                         SI20  24
#                                                                       SI20  25
I=NINT(AMIN(1)*128.);J=NINT(AMIN(2)*128.)# Convert ab limits to int     SI20  26
intpak:(I,ATHR,20,bitlen:(20))#        Pack a-limit for test            SI20  27
intpak:(J,BTHR,20,bitlen:(20))#        Pack b-limit for test            SI20  28
DO I=1,4;  NTYP(I)=0#                  Zeroize invariant counters       SI20  29
LINRM=3;    MREC=1;     BOT=M2#        Force first header               SI20  30
NG=M1-MARK;    MM=NG;    M2=MT#        Mark start of genlist            SI20  31
IF(IPRT(1)>0) writeline:(1,SI3,NSI3,3,3)# Print dump header             SI20  32
#                                                                       SI20  33
DO N1=1,NTOT#                          Loop over all generators         SI20  34
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI20  35
NG=NG+MARK;   TOP=BOT#                 Incr to start of this gen        SI20  36
top:=FLOAT(TOP);  pnt:=FLOAT(NG)#      Set genlist pointers             SI20  37
NREC=N1+3#                             Set correct file4 recnum         SI20  38
MREC=MREC+1#                           Set output file3 recnum          SI20  39
IF(N1>NGEN) NREC=NREC+NLIM#            Use skip for psi0 gens.          SI20  40
IF(sta:>5.5) NEXT#                     Skip dud generators              SI20  41
NINV=0;  SUMW=0.; SUMC=0.;  J=0#       Initialize accumulators          SI20  42
DO I=1,4;  SSI(I)=0.#                  Zero invariant counters          SI20  43
#                                                                       SI20  44
REPEAT#                                Loop over all invariants         SI20  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI20  46
W=0.#                                  Reset weight sum                 SI20  47
IF(N1>NGEN) IT=PSI0#                   Set as triplet psi0              SI20  48
ELSE        IT=TRIP#                   Set as triplet                   SI20  49
readwpkt:(4,NREC,NP,IP,0)#             Point to invariant packet        SI20  50
IF(IP<=0) BREAK#                       Exit if no more                  SI20  51
IF(IT==PSI0)generatornum:(IP,NN,4)#    Max gen of a psi0 invariant      SI20  52
ELSE        generatornum:(IP,NN,1)#    Max gen of triplet or quartet    SI20  53
IF(NN>NGEN) NEXT#                      Ignore si with nn>ngen           SI20  54
N4=0#                                  Initialise for psi0              SI20  55
IF(NN<N1) NN=N1#                       Ensure > start gener             SI20  56
IF(IT!=PSI0)#                          Enter if not psi0 triplet        SI20  57
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI20  58
generatornum:(IP,N4,4)#                Generator 4 of a quartet         SI20  59
IF(N4==0)#                             Test if invariant a triplet      SI20  60
comppakwdone:(IP,LT,ATHR,NEXT)#        Ignore trip if a<amin            SI20  61
ELSE#                                  Else must be quartet             SI20  62
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI20  63
comppakwdone:(IP,LT,BTHR,NEXT)#        Ignore quar if b<bmin            SI20  64
xvectorsum:(IP,I)#                     Extract xvector sum*8            SI20  65
XVS=FLOAT(IABS(I-512))/8.#             Convert to +real value           SI20  66
IF((IXVF==2)&(I<512)) NEXT#            If inside & negative skip        SI20  67
IF((IXVF==4)&(I>512)) NEXT#            If outside & positive skip       SI20  68
IF(I<512) IT=POSQ#                     If negative set as posq          SI20  69
ELSE IF(XVS>=XSHI) IT=POSQ#            Set type as pos quartet          SI20  70
ELSE IF(XVS<=XSLO) IT=NEGQ#            Set type as neg quartet          SI20  71
ELSE                 NEXT#                                              SI20  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI20  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI20  74
IF((SSI(1)>=MXTG)&(IT==TRIP)) NEXT#    Skip if t3/gen exceeded          SI20  75
IF((SSI(3)>=MXQG)&(IT==POSQ)) NEXT#    Skip if pq/gen exceeded          SI20  76
IF((SSI(4)>= 100)&(IT==NEGQ)) NEXT#    Skip if nq/gen exceeded          SI20  77
#                                                                       SI20  78
phaserestrict:(IP,IC)#                 Get restr phi code (1-10) wd1    SI20  79
phisigncode:(IP,IS)#                   Get phi sign code (0-7)   wd1    SI20  80
phiinvshift:(IP,ID)#                   Get si shift (deg/30)     wd1    SI20  81
phifragment:(IP,IQ)#                   Get frag psi est (0-359)  wd1    SI20  82
probfactor:(IP,IA)#                    Get ab value*128          wd1    SI20  83
probfsigma:(IP,IB)#                    Get sig(a)*128            wd2    SI20  84
generatornum:(IP,N2,2)#                Get n2 value              wd4    SI20  85
generatornum:(IP,N3,3)#                Get n3 value              wd5    SI20  86
#                                                                       SI20  87
IF(IT==NEGQ)#                          Test if negative quartet         SI20  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI20  89
IF((N1>=N2)\(N1>=N3)\(N1>=N4)$#        Reject redundant neg quar        SI20  90
\  (N2>=N3)\(N2>=N4)\(N3>=N4)) NEXT#   Reject redundant neg quar        SI20  91
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI20  92
IF((N1<=N2)&(N1<=N3)&(N2<=N3))#        Test for unique invariant        SI20  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI20  94
IF(IT==TRIP) NTYP(1)=NTYP(1)+1#        Count unique triplets            SI20  95
ELSE IF((N1<=N4)&(N2<=N4)&(N3<=N4))#   Test for unique quartet          SI20  96
NTYP(IT+1)=NTYP(IT+1)+1#               Count unique quartets            SI20  97
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI20  98
IF(IT==PSI0) NTYP(2)=NTYP(2)+1#        Count psi(0) triplets            SI20  99
SSI(IT+1)=SSI(IT+1)+1.#                Count redundant invars           SI20 100
#                                                                       SI20 101
A=FLOAT(IA)/128.#                      Extract prob fact a or b         SI20 102
B=AMIN1(FLOAT(IB)/128.,A*.5)#          Extract sigma(a)                 SI20 103
A=A-B*SIGA#                            Reduce a by factor siga          SI20 104
C=EXP(A)#                              Exponential of a                 SI20 105
IF(IC==1) D=(C-1./C)/(C+1./C)#         Calc centro expect factor        SI20 106
ELSE D=A*(A+.4807)/(A*(A+.8636)+1.3943)# Calc noncen expect factor      SI20 107
D=AMAX1(D,MINE)#                       Ensure above min expect f        SI20 108
IA=MIN0(127,NINT(A*8.))#               Prepare ab for packing           SI20 109
IB=MIN0(127,NINT(D*64.))#              Prepare expectf for packing      SI20 110
IF(METH==1) AW=FLOAT(IA*IA)#           Set a*a*64 method1               SI20 111
ELSE        AW=FLOAT(IA*IB)#           Set a*expf*512 method2           SI20 112
SUMW=SUMW+AW#                          Sum weighted alpha term          SI20 113
IF((NN<=NSTG)&(IT!=NEGQ)&(IT!=ISEL)$#  Test if selection invar          SI20 114
  &(N1!=N2)&(N1!=N3)&(N1!=N4)$#        Avoid duplicate geners           SI20 115
  &(N2!=N3)&(N2!=N4)&(N3!=N4))#        Avoid duplicate geners           SI20 116
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI20 117
SUMC=SUMC+AW;     II=IT+1#             Sum weighted alpha converge      SI20 118
IF((IT==0)&(IA>ETHR(10))&(N1<N2)&(N2<N3))# Test if > tenth a-value      SI20 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI20 120
FOR(I=1;I<10;I=I+1) IF(IA>ETHR(I))BREAK# Get position in sort a list    SI20 121
FOR(K=9;K>=I;K=K-1) ETHR(K+1)=ETHR(K)# Shift sorted list down           SI20 122
ETHR(I)=IA#                            Insert new a value               SI20 123
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI20 124
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI20 125
ELSE II=0#                             Not converge invariant           SI20 126
#                                                                       SI20 127
JP=BOT;  incrqx:(BOT,BOT+4,SI2010)#    Get mem for next invariant       SI20 128
ID=ID*30#                              Convert si shift to degrees      SI20 129
IF(IQPS==yes:)   ID=ID-IQ#             Adjust shift if qpsi used        SI20 130
IF(IT==NEGQ)     ID=ID-NQPS#           Adjust shift if neg quartet      SI20 131
ID=MOD(ID+3600,360)#                   Ensure total shift is 0-359      SI20 132
IF((ICNT==1)&(ID!=0)) ID=1#            For centro set pi shift as 1     SI20 133
intpak:(IT,QX(JP+1), 0, 2)#            Pack invar. type  bits  1- 0     SI20 134
intpak:(IS,QX(JP+1), 2, 3)#            Pack si sign code bits  4- 2     SI20 135
intpak:(II,QX(JP+1), 5, 4)#            Pack converg flag bits  8- 5     SI20 136
intpak:(ID,QX(JP+1), 9, 9)#            Pack total shift  bits 17- 9     SI20 137
intpak:(IB,QX(JP+1),18, 7)#            Pack expectf*64   bits 24-18     SI20 138
intpak:(IA,QX(JP+1),25,bitlen:(25))#   Pack a*8          bits **-25     SI20 139
QX(JP+2)=FLOAT(M1+(N2-1)*MARK)#        Store invariant number n2        SI20 140
QX(JP+3)=FLOAT(M1+(N3-1)*MARK)#        Store invariant number n3        SI20 141
QX(JP+4)=FLOAT(M1+(N4-1)*MARK)#        Store invariant number n4        SI20 142
NINV=NINV+4#                           Count words per si block         SI20 143
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI20 144
bot:=FLOAT(BOT);  sma:=SUMW;  alp:=SUMC# Store sum w*alf                SI20 145
IF(sta:>1.5&sta:<5.5)#                 Test if start status preset      SI20 146
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI20 147
SUMC=SUMC+100000.#                     Enhance input phase choice       SI20 148
ifeq:(sta:,ODR) NSEL=1#                Set odr    scan for converge     SI20 149
ifeq:(sta:,EDR) LEDR=1#                Set edr    scan for converge     SI20 150
ifeq:(sta:,SYM) ISEL=1#                Set symbol scan for converge     SI20 151
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI20 152
#                                                                       SI20 153
IF((NINV>12)&(N1>NGEN))#               Test if >3 psi(0) gen active     SI20 154
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI20 155
movereal:(QX,NG+1,QX,M2+1,MARK,1)#     Bubble up psi(o) gen's           SI20 156
M2=M2+MARK#                            Incr new psi(o) limit            SI20 157
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI20 158
ELSE IF(N1>NGEN) NEXT#                 Skip if psi gener not used       SI20 159
#                                                                       SI20 160
IF(IPRT(1)==0) NEXT#                   Skip if no dump                  SI20 161
gethkl:(NG+1,BUFOT)#                   Extract h,k,l                    SI20 162
BUFOT(4)=FLOAT(N1)#                    Store generator number           SI20 163
BUFOT(5)=evl:#                         Store /e/ value                  SI20 164
BUFOT(6)=SUMW/64.#                     Store sum w*alpha                SI20 165
BUFOT(7)=SUMC/64.#                     Store sum w*alpha converge       SI20 166
IF     (N1<=NSTG) J=7#                 Set format limit                 SI20 167
ELSE IF(N1<=NGEN) J=6#                 Set format limit                 SI20 168
ELSE              J=5#                 Set format limit                 SI20 169
ncodefld:(BUFOT,1,CHROT,FM,J)#         Format above terms               SI20 170
ncodefld:(SSI,1,CHROT,FM(8),4)#        Format invariant counters        SI20 171
movechar:(SI2,ista:*3-2,CHROT,28,3,0)# Insert generator status          SI20 172
writeline:(0,SI1,NSI1,1,3)#            Print generator items            SI20 173
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI20 174
NTOT=(M2-M1)/MARK#                     Reset total generators           SI20 175
NPSI=(M2-MT)/MARK#                     Reset number psi(0)'s            SI20 176
MG=M1+NSTG*MARK#                       Set pointer to start list        SI20 177
ME=M1+NSTE*MARK#                       Set pointer to exten list        SI20 178
readwpkt:(4,endrecord:,I,I,0)#         Rewind and close file 4          SI20 179
#                                                                       SI20 180
ifeq:(ALIM,0.) ALIM=FLOAT(ETHR(10))+.01# Set e**3 limit for invars      SI20 181
#                                                                       SI20 182
RETURN#                                                                 SI20 183
END#                                                                    SI20 184
systemheader:(SI25)#                   List control parameters          SI25   1
####################################################################    SI25   2
#                                                                  #    SI25   3
#                             SI25                                 #    SI25   4
#                                                                  #    SI25   5
####################################################################    SI25   6
SUBROUTINE SI25#                       S.r.hall  dec 84                 SI25   7
include:(AACOMN)#                                                       SI25   8
include:(SICOMN)#                                                       SI25   9
#                                                                       SI25  10
REAL A#                                                                 SI25  11
chardata:(SI1, SIMPEL CONTROL PARAMETERS)#                              SI25  12
chardata:(SI2, PROCESS BDF DATA SET NUMBER      )#                      SI25  13
chardata:(SI3, GENERATOR /E/-TYPE /E/-MIN     E        )#               SI25  14
chardata:(SI4, REFLNS TO CONVERGE LIMIT           )#                    SI25  15
chardata:(SI5, FRAGMENT PSI TO BE APPLIED         )#                    SI25  16
chardata:(SI6, NUMBER OF TRIPLETS ENTERED          AMIN=     )#         SI25  17
chardata:(SI7, NUMBER OF QUARTETS ENTERED          BMIN=     )#         SI25  18
chardata:(SI8,[ POSITIVE QUARTETS (PQ4)             XVSM>     ])#       SI25  19
chardata:(SI9,[ NEGATIVE QUARTETS (NQ4)             XVSM<     ])#       SI25  20
chardata:(SI10,[ NQ4 USED ONLY IN FOM, PSI=         ])#                 SI25  21
chardata:(SI11,NO YES-T3 + PQ4PQ4 ONLYT3 ONLY )#                        SI25  22
chardata:(SI12, REDUCE A AND B VALUES BY          SIGMA)#               SI25  23
chardata:(SI13, MAX ALLOWED TRIPLETS/GENER        )#                    SI25  24
chardata:(SI14, MAX ALLOWED QUARTETS/GENER        )#                    SI25  25
chardata:(SI15, NUMBER OF REFLNS ENTERED           )#                   SI25  26
chardata:(SI17, REFLNS TO DIVERGE  LIMIT           )#                   SI25  27
chardata:(SI20, PHASE ACCEPTANCE BASED ON    WEIGHTED ALPHA  )#         SI25  28
chardata:(SI21, PHASE IF MULTIPLE SYMBOLS    ACCEPTED)#                 SI25  29
chardata:(SI22, ALPHA LIMIT TO ACCEPT SYMBOL         )#                 SI25  30
chardata:(SI23, MIN W*ALPHA TO ACCEPT SYMBOL         )#                 SI25  31
chardata:(SI24, APPLY SYMBOLS IN BLOCKS OF           )#                 SI25  32
chardata:(SI30,[ALPHA(NPHASE)     REJECTED])#                           SI25  33
datastuff:#                                                             SI25  34
#                                                                       SI25  35
#   PRINT CONTROL PARAMETERS                                            SI25  36
#   ------------------------                                            SI25  37
#                                                                       SI25  38
movechar:(SI11,7,CHROT,2,NSI1-1,2)#    Underline heading in buffer      SI25  39
writeline:(1,SI1,NSI1,2,3)#            Print parameter heading          SI25  40
#                                                                       SI25  41
IF(IACC>1) movechar:(SI30,1,SI20,31,17,0)# Insert n+a message           SI25  42
writeline:(0,SI20,NSI20,3,3)#          Print acceptance method          SI25  43
#                                                                       SI25  44
IF(MODE>1) movechar:(SI30,19,SI21,31,8,0)# Insert single message        SI25  45
writeline:(0,SI21,NSI21,3,3)#          Print mult/sing message          SI25  46
#                                                                       SI25  47
ncodefld:(DSNM,1,SI2,340413.,1)#       Format data set number           SI25  48
writeline:(0,SI2,NSI2,3,3)#            Print data set number            SI25  49
#                                                                       SI25  50
ncodefld:(ETYP,1,SI3,340113.,1)#       Format /e/-type                  SI25  51
ncodefld:(EMIN,1,SI3,400522.,1)#       Format /e/-min of geners         SI25  52
writeline:(0,SI3,NSI3,3,3)#            Print /e/-type and minim         SI25  53
#                                                                       SI25  54
ncodefld:(FLOAT(NGEN),1,SI15,340413.,1)# Format number of geners        SI25  55
writeline:(0,SI15,NSI15,3,3)#          Print number of generators       SI25  56
#                                                                       SI25  57
ncodefld:(FLOAT(NSTG),1,SI4,340413.,1)# Format number of geners         SI25  58
writeline:(0,SI4,NSI4,3,3)#            Print number of generators       SI25  59
#                                                                       SI25  60
ncodefld:(FLOAT(NSTE),1,SI17,340413.,1)# Format number of geners        SI25  61
writeline:(0,SI17,NSI17,3,3)#          Print number of generators       SI25  62
#                                                                       SI25  63
ncodefld:(SIGA,1,SI12,340432.,1)#      Format sigma reduce ratio        SI25  64
writeline:(0,SI12,NSI12,3,3)#          Print it                         SI25  65
#                                                                       SI25  66
movechar:(SI11,IQPS*3+1,SI5,33,3,0)#   Insert yes/no for frag psi       SI25  67
writeline:(0,SI5,NSI5,3,3)#            Print frag psi information       SI25  68
#                                                                       SI25  69
IF(NTYP(1)>0)#                         Test if triplets applied         SI25  70
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI25  71
ncodefld:(MXTG,1,SI13,340413.,1)#      Format max triplets/gen          SI25  72
writeline:(0,SI13,NSI13,3,3)#          Print max t3/gen                 SI25  73
A=FLOAT(NTYP(1))#                      Float number of triplets         SI25  74
ncodefld:(A      ,1,SI6,340413.,1)#    Format number of triplets        SI25  75
ncodefld:(AMIN(1),1,SI6,460412.,1)#    Format a-min of triplets         SI25  76
writeline:(0,SI6,NSI6,3,3)#            Print triplet information        SI25  77
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI25  78
#                                                                       SI25  79
A=FLOAT(NTYP(3)+NTYP(4))#              Float number nq4 & pq4           SI25  80
IF(A>.1)#                              Test if any quartets             SI25  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI25  82
ncodefld:(MXQG,1,SI14,340413.,1)#      Format max quartets/gen          SI25  83
writeline:(0,SI14,NSI14,3,3)#          Print max pq/gen                 SI25  84
ncodefld:(A      ,1,SI7,340413.,1)#    Format number of quartets        SI25  85
ncodefld:(AMIN(2),1,SI7,460412.,1)#    Format b-min of quartets         SI25  86
writeline:(0,SI7,NSI7,3,3)#            Print quartet information        SI25  87
IF(NTYP(3)>0)#                         Test for positive quartets       SI25  88
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI25  89
A=FLOAT(NTYP(3))#                      Float number pq4                 SI25  90
ncodefld:(A     ,1,SI8,340413.,1)#     Format numb of pos quartets      SI25  91
ncodefld:(XSHI  ,1,SI8,460412.,1)#     Format upper xvector limit       SI25  92
writeline:(0,SI8,NSI8,3,3)#            Print pos quartet info           SI25  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI25  94
IF(NTYP(4)>0)#                         Test for negative quartets       SI25  95
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI25  96
A=FLOAT(NTYP(4))#                      Float number nq4                 SI25  97
ncodefld:(A      ,1,SI9,340413.,1)#    Format num of neg quartets       SI25  98
ncodefld:(XSLO   ,1,SI9,460412.,1)#    Format lower xvector limit       SI25  99
writeline:(0,SI9,NSI9,3,3)#            Print neg quartet info           SI25 100
ncodefld:(FLOAT(NQPS),1,SI10,340413.,1)# Format si used for neg q4      SI25 101
writeline:(0,SI10,NSI10,3,3)#          Print neg q4 psi info            SI25 102
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI25 103
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI25 104
#                                                                       SI25 105
ncodefld:(ALIM/8.,1,SI22,350522.,1)#   Format alpha threshold           SI25 106
writeline:(0,SI22,NSI22,3,3)#          Print alpha threshold            SI25 107
#                                                                       SI25 108
ncodefld:(WMIN,1,SI23,350522.,1)#      Format weight minimum            SI25 109
IF(IACC==1)writeline:(0,SI23,NSI23,3,3)# Print weight threshold         SI25 110
#                                                                       SI25 111
ncodefld:(FLOAT(NBLK),1,SI24,350513.,1)# Format iteration block         SI25 112
writeline:(0,SI24,NSI24,3,3)#          Print iteration block            SI25 113
#                                                                       SI25 114
RETURN#                                                                 SI25 115
END#                                                                    SI25 116
systemheader:(SI30)#                   Convergence & odr/edr/start      SI30   1
####################################################################    SI30   2
#                                                                  #    SI30   3
#                             SI30                                 #    SI30   4
#                                                                  #    SI30   5
####################################################################    SI30   6
SUBROUTINE SI30#                       S.r.hall  nov 84                 SI30   7
include:(AACOMN)#                                                       SI30   8
include:(SICOMN)#                                                       SI30   9
#                                                                       SI30  10
INTEGER I,J,K,L,M,N#                                                    SI30  11
INTEGER TOP,BOT#                                                        SI30  12
INTEGER II,JJ,KK,NN,NTOP,NMID,NBOT,NTEM#                                SI30  13
INTEGER ISTR(3)#                                                        SI30  14
INTEGER IA,IB,IDET,IT,JEDR,N1,N2,N3,N4,NG,NORG,NP,NR,NS,NX#             SI30  15
REAL AH(3),AK(3),AL(3),A,AW,B#                                          SI30  16
INTEGER NCUL,NEW#                                                       SI30  17
REAL    ZERO#                                                           SI30  18
#                                                                       SI30  19
chardata:(SI1,  NSEQ   NGEN   H   K   L    /E/    $#                    SI30  20
SUMC  TYPE    C    N1   N2   N3   N4)#                                  SI30  21
chardata:(SI3, **********CONVERGE DUMP IN REVERSE ORDER)#               SI30  22
chardata:(SI4,   ODREDRSYMSETNUL***)#                                   SI30  23
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        SI30  24
realdata:(FM,[170413.,210413.,250413.,50413.,#                          SI30  25
120413.,320622.,400812.,80313.])#                                       SI30  26
realdata:(FN,[520412.,570413.,620413.,670413.,720403.])#                SI30  27
realdata:(Q,[0.,0.,0.,0.,0.,0.,0.,0.,0.])#                              SI30  28
intdata:(MCUL,0)#                                                       SI30  29
datastuff:#                                                             SI30  30
#                                                                       SI30  31
#   CONVERGENCE PROCEDURE                                               SI30  32
#   =====================                                               SI30  33
#                                                                       SI30  34
IF(IPRT(2)>0) writeline:(1,SI3,NSI3,3,3)# Print dump header             SI30  35
LINRM=3;  NN=M1-MARK#                  Set start pointer n4             SI30  36
intpak:(0,ZERO,0,mxbtwd:)#                                              SI30  37
#                                                                       SI30  38
NX=MG-10*MARK#                         Start of accept starters         SI30  39
FOR(NR=MG-MARK;NR>=M1;NR=NR-MARK)#     Reverse genlist loop             SI30  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI30  41
#                                                                       SI30  42
#                                        ******* find low w*alpha       SI30  43
A=1.E10#                               Set initial sum & pointer        SI30  44
FOR(NG=M1;NG<MG;NG=NG+MARK)#           Loop over generator list         SI30  45
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI30  46
IF(evl:<0.) NEXT#                      Skip culled generators           SI30  47
IF(alp:>A ) NEXT#                      Skip if > current min sum        SI30  48
A=alp:;   NCUL=NG#                     Store smaller sum & pointer      SI30  49
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI30  50
#                                                                       SI30  51
#                                        ******* cull generator         SI30  52
pnt:(NR)=FLOAT(NCUL)#                  Gen address reverse order        SI30  53
IF(NR>NX)     alp:(NCUL)=.2#           Ensure not starter               SI30  54
ELSE IF(A<.1)#                         Set generator as starter         SI30  55
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI30  56
IF(alp:(MCUL)<.1) B=alp:(MCUL)#        Test if prev is starter          SI30  57
ELSE              B=-FLOAT(NCUL)#      Else set starter flag            SI30  58
alp:(NCUL)=B;    alp:(MCUL)=B#         Flag gener as starter            SI30  59
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI30  60
MCUL=NCUL#                             Reset previous pointer           SI30  61
#                                                                       SI30  62
IF(IPRT(2)>0)#                         Test if dump requested           SI30  63
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI30  64
gethkl:(NCUL+1,BUFOT)#                 Extract h,k,l                    SI30  65
N1=(NCUL-M1)/MARK+1#                   Extract generator number         SI30  66
NS=(NR  -M1)/MARK+1#                   Get cull sequence number         SI30  67
BUFOT(4)=FLOAT(NS)#                    Store sequence number            SI30  68
BUFOT(5)=FLOAT(N1)#                    Store generator number           SI30  69
BUFOT(6)=evl:(NCUL)#                   Store /e/                        SI30  70
BUFOT(7)=A/64.#                        Store sum w*alpha                SI30  71
I=ista:(NCUL); IF(A<.1) I=7#           Extract gener status             SI30  72
movechar:(SI4,I*3-2,CHROT,44,3,0)#     Insert gener status              SI30  73
ncodefld:(BUFOT,1,CHROT,FM,7)#         Format above items               SI30  74
writeline:(0,SI1,NSI1,1,3)#            Print above items                SI30  75
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI30  76
#                                                                       SI30  77
#                                        ******* reduce w*alphas        SI30  78
TOP=itop:(NCUL)#                       Get top/recn for si block        SI30  79
BOT=ibot:(NCUL)#                       Get bot/blen for si block        SI30  80
FOR(M=TOP;M<BOT;M=M+4)#                Loop over invariant block        SI30  81
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI30  82
intunpak:(QX(M+1),IT, 5, 4)#           Extract summation type           SI30  83
IF(IT==0) NEXT#                        Ignore non-summed invars         SI30  84
N2=NINT(QX(M+2))#                      Extract n2 genlist address       SI30  85
IF(evl:(N2)<0.) NEXT#                  Skip if already culled           SI30  86
N3=NINT(QX(M+3))#                      Extract n3 genlist address       SI30  87
IF(evl:(N3)<0.) NEXT#                  Skip if already culled           SI30  88
intunpak:(QX(M+1),IA,25, 7)#           Extract a*8                      SI30  89
IF(METH==1) AW=FLOAT(IA*IA)#           Use a**2 in method 1             SI30  90
ELSE#                                  Else for method 2                SI30  91
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI30  92
intunpak:(QX(M+1),IB,18, 7)#           Extract expectf*64               SI30  93
AW=FLOAT(IA*IB)#                       Convert to real                  SI30  94
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI30  95
IF(IT==3)#                             Test if quartet                  SI30  96
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI30  97
N4=NINT(QX(M+4))#                      Extract n4 genlist address       SI30  98
IF(evl:(N4)<0.) NEXT#                  Skip if already culled           SI30  99
alp:(N4)=alp:(N4)-AW#                  Reduce alpha sum                 SI30 100
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI30 101
ELSE N4=NN#                            Set n4 to zero                   SI30 102
alp:(N2)=alp:(N2)-AW#                  Reduce alpha sum                 SI30 103
alp:(N3)=alp:(N3)-AW#                  Reduce alpha sum                 SI30 104
#                                                                       SI30 105
IF(IPRT(2)==0) NEXT#                   Test for converge dump           SI30 106
BUFOT(1)=AW/64.#                       Store w*alpha                    SI30 107
BUFOT(2)=FLOAT(N1)#                    Store gener num 1                SI30 108
BUFOT(3)=FLOAT((N2-M1)/MARK+1)#        Store gener num 2                SI30 109
BUFOT(4)=FLOAT((N3-M1)/MARK+1)#        Store gener num 3                SI30 110
BUFOT(5)=FLOAT((N4-M1)/MARK+1)#        Store gener num 4                SI30 111
ncodefld:(BUFOT,1,CHROT,FN,5)#         F0rmat above items               SI30 112
writeline:(0,SI1,NSI1,1,3)#            Print culled invariant           SI30 113
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI30 114
evl:(NCUL)=-ABS(evl:(NCUL))#           Disable culled generator         SI30 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI30 116
#                                                                       SI30 117
#                                                                       SI30 118
#     ASSIGN ODR/EDR/START GENERATORS                                   SI30 119
#     ===============================                                   SI30 120
#                                                                       SI30 121
NSTR=0;   NORG=NODR+MIN0(1,NANT)#      Initialize start set             SI30 122
FOR(NG=M1;NG<ME;NG=NG+MARK)#           Loop over gener list             SI30 123
evl:=ABS(evl:)#                        Reset converge flag              SI30 124
#                                                                       SI30 125
FOR(NS=1;NS<=MSTR;NS=NSTR+1)#          Loop over starters required      SI30 126
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI30 127
IF(NSYMB>=8) BREAK#                    Exit if all symbols set          SI30 128
NEW=no:#                               Reset new gen flag               SI30 129
#                                                                       SI30 130
#   TEST IF NEW ODR SET REQUIRED                                        SI30 131
#   ----------------------------                                        SI30 132
#                                                                       SI30 133
IF(NS<=NODR)#                          Test if apriori or odr cull      SI30 134
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI30 135
DO NP=NSEL,3#                          1 input/2 endgen/3 allgen        SI30 136
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI30 137
NX=MG#                                 Set initial odr search limit     SI30 138
#                                                                       SI30 139
REPEAT#                                Loop over odr attempts           SI30 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI30 141
IF(NODR==0) GO TO 100#                 Test if any odr's                SI30 142
#                                                                       SI30 143
IF(NODR==1)#                           ****** nodr=1 *********          SI30 144
FOR(NG=M1;NG<NX;NG=NG+MARK)#           Loop over generator list         SI30 145
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI30 146
II=ipnt:#                              Store sorted of generator        SI30 147
IF(II>NX) NEXT#                        Skip generators above limit      SI30 148
IF((NP==1)&(ista:(II)!=IODR)) NEXT#    Skip if not preset in pass1      SI30 149
IF((NP==2)&(alp:(II)>0.1)) NEXT#       Skip if not endgen in pass2      SI30 150
IF(ista:(II)>IODR) NEXT#               Skip input starters              SI30 151
IF(prc:(II)<1.5) NN=1#                 Count resr. phi generator        SI30 152
ELSE             NN=0#                 This not restricted phi          SI30 153
IF(NN>NONR) NEXT#                      Skip excess nonrestr gen         SI30 154
gethkl:(II+2,AH)#                      Unpack si vectors uvw            SI30 155
IDET=NINT(AH(1))#                      Get determinant of u             SI30 156
IF(IABS(IDET)!=1) NEXT#                Exit if /det/=1                  SI30 157
ISTR(1)=II;   Q(1)=AH(1);   GOTO 100#  Store addr of new odr            SI30 158
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI30 159
#                                                                       SI30 160
IF(NODR==2)#                           ******* nodr=2 **********        SI30 161
FOR(NG=M1+MARK;NG<NX;NG=NG+MARK)#      Loop remainding genlist          SI30 162
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI30 163
NBOT=NG#                               Reset bot pointer to start       SI30 164
FOR(NTOP=M1;NTOP<NBOT;NTOP=NTOP+MARK)# Inner genlist loop               SI30 165
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI30 166
II=ipnt:(NTOP);  JJ=ipnt:(NBOT)#       Point sorted order of gen        SI30 167
NBOT=NBOT-MARK#                        Decrement bottom pointer         SI30 168
IF((II>NX)\(JJ>NX)) NEXT#              Skip generators above limit      SI30 169
IF((NP==1)&(ista:(II)!=IODR)) NEXT#    Skip if not preset in pass1      SI30 170
IF((NP==1)&(ista:(JJ)!=IODR)) NEXT#    Skip if not preset in pass1      SI30 171
IF((NP==2)&(alp:(II)>0.1)) NEXT#       Skip if not endgen in pass2      SI30 172
IF((NP==2)&(alp:(JJ)>0.1)) NEXT#       Skip if not endgen in pass2      SI30 173
IF(ista:(II)>IODR\ista:(JJ)>IODR) NEXT# Skip starts if edr, per         SI30 174
ELSE             NN=1#                 Count if phi1 restricted         SI30 175
IF(prc:(JJ)<1.5) NN=NN+1#              Count if phi2 restricted         SI30 176
IF(NN>NONR) NEXT#                      Skip if nonrestr exceeded        SI30 177
gethkl:(II+2,AH)#                      Get si vectors for gen1          SI30 178
gethkl:(JJ+2,AK)#                      Get si vectors for gen2          SI30 179
IDET=NINT(AH(1)*AK(2)-AH(2)*AK(1))#    Calc si determinate              SI30 180
IF(IABS(IDET)!=1) NEXT#                Exit if /det/=1                  SI30 181
ISTR(1)=II;  ISTR(2)=JJ#               Store addr of new odr            SI30 182
Q(1)=+AK(2);  Q(2)=-AK(1)#             Store adjt. matrix for edr       SI30 183
Q(4)=-AH(2);  Q(5)=+AH(1)#             Store adjt. matrix for edr       SI30 184
GOTO 100#                              Exit odr search                  SI30 185
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI30 186
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI30 187
#                                                                       SI30 188
IF(NODR==3)#                           ********* nodr=3 *********       SI30 189
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI30 190
K=2*MARK#                              Preset temp test decr.           SI30 191
FOR(NG=M1+K;NG<NX;NG=NG+MARK)#         Loop1 remainder genlist          SI30 192
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI30 193
NTEM=NG+MARK#                          Set temp marker to start         SI30 194
FOR(NTOP=M1;NTOP<NTEM-K;NTOP=NTOP+MARK)# Loop2 remainder genlist        SI30 195
$(#                                    6>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI30 196
NTEM=NTEM-K#                           Decr temp low ker                SI30 197
II=ipnt:(NTOP)#                        Point sorted order of list       SI30 198
IF(II>NX) NEXT#                        Skip generators above limit      SI30 199
IF((NP==1)&(ista:(II)!=IODR)) NEXT#    Skip if not preset in pass1      SI30 200
IF((NP==2)&(alp:(II)>0.1)) NEXT#       Skip if not endgen in pass2      SI30 201
compakwd:(uvw:(II),EQ,ZERO,NEXT)#      Skip if not eligible             SI30 202
gethkl:(II+2,AH)#                      Unpack si vectors for gen1       SI30 203
NBOT=NTEM+MARK#                        Set start of bot pointer         SI30 204
FOR(NMID=NTOP+MARK;NMID<NBOT;NMID=NMID+MARK)# Loop3 of part genlist     SI30 205
$(#                                    7>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI30 206
JJ=ipnt:(NMID);   KK=ipnt:(NBOT)#      Point sorted order of gen        SI30 207
NBOT=NBOT-MARK#                        Decrement bot list pointer       SI30 208
IF((JJ>NX)\(KK>NX)) NEXT#              Skip generators above limit      SI30 209
IF((NP==1)&(ista:(JJ)!=IODR)) NEXT#    Skip if not preset in pass1      SI30 210
IF((NP==1)&(ista:(KK)!=IODR)) NEXT#    Skip if not preset in pass1      SI30 211
IF((NP==2)&(alp:(JJ)>0.1)) NEXT#       Skip if not endgen in pass2      SI30 212
IF((NP==2)&(alp:(KK)>0.1)) NEXT#       Skip if not endgen in pass2      SI30 213
compakwd:(uvw:(JJ),EQ,ZERO,NEXT)#      Skip if not eligible             SI30 214
compakwd:(uvw:(KK),EQ,ZERO,NEXT)#      Skip if not eligible             SI30 215
IF(prc:(II)>1.5) NN=0#                 Zero nonrestr count if not       SI30 216
IF(ista:(II)>IODR) NEXT#               Skip input starters              SI30 217
IF(ista:(JJ)>IODR) NEXT#               Skip input starters              SI30 218
IF(ista:(KK)>IODR) NEXT#               Skip input starters              SI30 219
ELSE             NN=1#                 Count phi1 if nonrestr           SI30 220
IF(prc:(JJ)<1.5) NN=NN+1#              Count phi2 if nonrestr           SI30 221
IF(prc:(KK)<1.5) NN=NN+1#              Count phi2 if nonrestr           SI30 222
IF(NN>NONR) NEXT#                      Skip if nonrestr > limit         SI30 223
gethkl:(JJ+2,AK)#                      Extract si vectors for gen2      SI30 224
gethkl:(KK+2,AL)#                      Extract si vectors for gen3      SI30 225
IDET=NINT(AH(1)*(AK(2)*AL(3)-AK(3)*AL(2))$# Calc 3x3 determinant        SI30 226
+          AH(2)*(AK(3)*AL(1)-AK(1)*AL(3))$# Calc 3x3 determinant       SI30 227
+          AH(3)*(AK(1)*AL(2)-AK(2)*AL(1)))# Calc 3x3 determinant       SI30 228
IF(IABS(IDET)!=1) NEXT#                Exit if /det/=1                  SI30 229
ISTR(1)=II; ISTR(2)=JJ; ISTR(3)=KK#    Store addr of new odr            SI30 230
Q(1)=AK(2)*AL(3)-AK(3)*AL(2)#          Store adjt. matrix for edr       SI30 231
Q(2)=AH(3)*AL(2)-AH(2)*AL(3)#          Store adjt. matrix for edr       SI30 232
Q(3)=AH(2)*AK(3)-AH(3)*AK(2)#          Store adjt. matrix for edr       SI30 233
Q(4)=AK(3)*AL(1)-AK(1)*AL(3)#          Store adjt. matrix for edr       SI30 234
Q(5)=AH(1)*AL(3)-AH(3)*AL(1)#          Store adjt. matrix for edr       SI30 235
Q(6)=AH(3)*AK(1)-AH(1)*AK(3)#          Store adjt. matrix for edr       SI30 236
Q(7)=AK(1)*AL(2)-AK(2)*AL(1)#          Store adjt. matrix for edr       SI30 237
Q(8)=AH(2)*AL(1)-AH(1)*AL(2)#          Store adjt. matrix for edr       SI30 238
Q(9)=AH(1)*AK(2)-AH(2)*AK(1)#          Store adjt. matrix for edr       SI30 239
GOTO 100#                              Exit odr search loop             SI30 240
$)#                                    7<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI30 241
$)#                                    6<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI30 242
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI30 243
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI30 244
#                                                                       SI30 245
IF(NP!=3) BREAK#                       Exit after one pass 1            SI30 246
IF(NX<ME) NX=MIN0(ME,NX+50*MARK)#      Expand odr limits by 50          SI30 247
ELSE IF(NONR<NODR) NONR=NONR+1#        Include nonrestr odrs            SI30 248
ELSE BREAK#                            Try another pass                 SI30 249
NEXT#                                  Repeat with increased list       SI30 250
#                                                                       SI30 251
100 CONTINUE#                          Branch point for new odr         SI30 252
FOR(I=1;I<=NODR;I=I+1)#                Loop over odr's                  SI30 253
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SI30 254
J=ISTR(I);  K=iprc:(J)#                Extract gen addresses            SI30 255
IF(phi:(J)<0.) phi:(J)=FLOAT(PRC(K))#  Store start odr phase            SI30 256
sta:(J)=ODR#                           Store odr status                 SI30 257
wgt:(J)=1.#                            Store odr weight                 SI30 258
NEW=IODR#                              Indicate new gen found           SI30 259
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SI30 260
BREAK#                                 Exit after new odr set           SI30 261
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI30 262
NSTR=NODR#                             Set number of starters           SI30 263
IF(NEW==IODR) BREAK#                   Exit if odr found                SI30 264
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI30 265
IF(NEW==no:) MSTR=MSTR+NODR#           No odr add extra symbols         SI30 266
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI30 267
#                                                                       SI30 268
#    TEST IF EDR STARTER REQUIRED                                       SI30 269
#    ----------------------------                                       SI30 270
#                                                                       SI30 271
ELSE IF(NS==NORG)#                     Is edr needed for new odr        SI30 272
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SI30 273
DO NP=LEDR,3#                          1 preset/2 endgen/3 allgen       SI30 274
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SI30 275
FOR(N=M1;N<MG;N=N+MARK)#               Loop over reduced genlist        SI30 276
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SI30 277
NG=ipnt:(N)#                           Sort order & start status        SI30 278
IF((NG>NX)\(wgt:>0.1)) NEXT#           Skip generator if > limit        SI30 279
IF((NP==1)&(ista:!=IEDR)) NEXT#        Skip if not preset in pass1      SI30 280
IF((NP==2)&(alp:>0.1)) NEXT#           Skip if not endgen in pass2      SI30 281
IF(NANT!=MIN0(2,iprc:)) NEXT#          Ignore if wrong restr type       SI30 282
IF(NANT==2)#                           Is restricted edr needed         SI30 283
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SI30 284
gethkl:(NG+2,H);   L=0;   M=0#         Extract si vectors               SI30 285
FOR(I=1;I<=NODR;I=I+1)#                Loop over odr's                  SI30 286
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SI30 287
J=ISTR(I);   K=NINT(phi:(J))#          Extract odr assigned phase       SI30 288
A=H(1)*Q(I)+H(2)*Q(I+3)+H(3)*Q(I+6)#   Find linear dependence           SI30 289
L=L+NINT(A)*IDET*K#                    Sum odr restricted phases        SI30 290
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SI30 291
J=iprc:;    JEDR=PRC(J)#               Extract restr. phi of edr        SI30 292
M=MOD(L+360000,360)-JEDR#              Calc diff with edr restr         SI30 293
M=MIN0(IABS(M),M+180,IABS(M-180)$#     Find smallest difference         SI30 294
,      M+360,IABS(M-360))#             Find smallest difference         SI30 295
IF(M<30) NEXT#                         Skip if difference < 30          SI30 296
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SI30 297
IF(phi:<0.)#                           If phi not input                 SI30 298
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SI30 299
NSYMB=NSYMB+1#                         Incr symbol counter              SI30 300
phi:=FLOAT(-NSYMB)#                    Store symbol                     SI30 301
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SI30 302
sta:=EDR#                              Store edr status                 SI30 303
wgt:=1.#                               Store edr weight                 SI30 304
NEW=IEDR#                              Flag as assigned                 SI30 305
BREAK#                                 Exit if edr set                  SI30 306
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SI30 307
IF(NEW==IEDR) BREAK#                   Exit if edr set                  SI30 308
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SI30 309
IF(NEW==no:) MSTR=MSTR+1#              Add extra symbol for edr         SI30 310
NSTR=NS#                               Reset start count                SI30 311
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SI30 312
#                                                                       SI30 313
#    TEST IF SYMBOL STARTER REQUIRED                                    SI30 314
#    --------------------------------                                   SI30 315
#                                                                       SI30 316
ELSE#                                  Test if new start required       SI30 317
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SI30 318
DO NP=ISEL,3#                          Pass2 endgen/ 3 allgen           SI30 319
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SI30 320
FOR(N=M1;N<MG;N=N+MARK)#               Loop over reduced gen list       SI30 321
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SI30 322
NG=ipnt:(N)#                           Get order and status             SI30 323
IF(wgt:>0.1) NEXT#                     Test if already assigned         SI30 324
IF((NP==1)&(ista:!=SYM)) NEXT#         Skip if not preset in pass1      SI30 325
IF(NP==2)#                             Pass2 is for conver starts       SI30 326
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SI30 327
IF(alp:>.1) NEXT;   I=NINT(alp:)#      Skip non-conver starters         SI30 328
J=ipnt:(N+MARK);    K=NINT(alp:(J))#   Point to preceding gener         SI30 329
IF((I==K)&(wgt:(J)>.1)) NEXT#          Skip if preced assigned          SI30 330
IF(N>M1)J=ipnt:(N-MARK);  K=NINT(alp:(J))# Point to following gener     SI30 331
IF((I==K)&(wgt:(J)>.1)) NEXT#          Skip if follow assigned          SI30 332
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SI30 333
NSYMB=NSYMB+1#                         Incr symbol counter              SI30 334
phi:=FLOAT(-NSYMB)#                    Store start symbol               SI30 335
sta:=SYM#                              Store symbol status              SI30 336
wgt:=1.#                               Store symbol weight              SI30 337
NEW=ISYM#                              Indicate new start found         SI30 338
BREAK#                                 Exit if new start found          SI30 339
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SI30 340
IF(NEW==ISYM) BREAK#                   Exit if starter found            SI30 341
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SI30 342
IF(NEW==no:) BREAK#                    Exit if no starters found        SI30 343
NSTR=NS#                               Reset starter count              SI30 344
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SI30 345
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI30 346
#                                                                       SI30 347
#   SCAN STARTERS FOR LIMITS                                            SI30 348
#   ------------------------                                            SI30 349
#                                                                       SI30 350
NP=MG-MARK;   I=ipnt:(NP);   ISEL=MG#  Set converge limits              SI30 351
FOR(NG=M1;NG<MT;NG=NG+MARK)#           Loop over generator list         SI30 352
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SI30 353
IF(wgt:<0.9&sta:>1.5&sta:<5.5)#        Cancel any unassigned phases     SI30 354
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 31 SI30 355
sta:=NOS;    phi:=-.0001#              Reset status and phase           SI30 356
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 31 SI30 357
IF((wgt:>.9)&(NG>=MG))#                Test if starter outside          SI30 358
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 32 SI30 359
WHILE(wgt:(I)>.9)#                     Test if already starter          SI30 360
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 33 SI30 361
NP=NP-MARK;     I=ipnt:(NP)#           Back down list and point         SI30 362
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 33 SI30 363
A=pnt:;    pnt:=pnt:(NP);    pnt:(NP)=A# Swap start and nonstart        SI30 364
ISEL=NG#                               Reset sort limit                 SI30 365
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 32 SI30 366
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SI30 367
#                                                                       SI30 368
#    STORE CONVERGE SEQUENCE                                            SI30 369
#    -----------------------                                            SI30 370
#                                                                       SI30 371
FOR(NG=M1;NG<MT;NG=NG+MARK)#           Loop over generator list         SI30 372
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 34 SI30 373
I=ipnt:#                               Extract phase path order         SI30 374
seq:(I)=FLOAT(NG)#                     Store path sequence              SI30 375
pnt:   =FLOAT(NG)#                     Reset to /e/ order               SI30 376
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 34 SI30 377
RETURN#                                                                 SI30 378
END#                                                                    SI30 379
systemheader:(SI40)#                   Prelim. symbol application       SI40   1
####################################################################    SI40   2
#                                                                  #    SI40   3
#                             SI40                                 #    SI40   4
#                                                                  #    SI40   5
####################################################################    SI40   6
SUBROUTINE SI40#                       S.r.hall  dec 84                 SI40   7
include:(AACOMN)#                                                       SI40   8
include:(SICOMN)#                                                       SI40   9
#                                                                       SI40  10
INTEGER I,J,K,L,M,IT,IZ,JCNT#                                           SI40  11
INTEGER TOP,BOT,TEM#                                                    SI40  12
INTEGER SJ(3),SK(3),IN(4),J2(3),J3(3),J4(3)#                            SI40  13
INTEGER IA,IP,ISUM,IZER,MSYMB,N1,N2,N3,N4,NBIAS,NG,NI,NIND,NP,NSYM#     SI40  14
REAL A,QIQI#                                                            SI40  15
#                                                                       SI40  16
chardata:(SI1, STARTING SET FROM CONVERGE PROCEDURE)#                   SI40  17
chardata:(SI2,-ABCDEFGHIJ+)#                                            SI40  18
chardata:(SI3,      ODR   EDR   ASSIGNINPUT )#                          SI40  19
chardata:(SI4, **********CONVERGE EXTENSION CYCLE   )#                  SI40  20
chardata:(SI5,  NGEN    H   K   L    /E/    WGT    $#                   SI40  21
TYPE      PHASE)#                                                       SI40  22
chardata:(SI6,  NGEN    H   K   L    /E/    IND.   SUMA   $#            SI40  23
 PHASE)#                                                                SI40  24
intdata:(ISGN,[0,1,2,3,4,5,6,7,0,2,1,3,4,6,5,7,0,4,2,6,1,5,3,7])#       SI40  25
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        SI40  26
intdata:(IS,0)#                                                         SI40  27
realdata:(FM,[110413.,150413.,190413.,60413.,#                          SI40  28
260522.,470613.,330503.,410612.])#                                      SI40  29
realdata:(FN,[110413.,150413.,190413.,60413.,#                          SI40  30
260522.,490613.,330512.])#                                              SI40  31
datastuff:#                                                             SI40  32
#                                                                       SI40  33
#   CALCULATE A-THRESHOLDS FOR PHASE EXTENSION                          SI40  34
#   ------------------------------------------                          SI40  35
#                                                                       SI40  36
SK(1)=0;  SK(2)=0;  SK(3)=0#                                            SI40  37
DO I=1,20; ETHR(I)=NINT(ALIM*(1.+.3*(FLOAT(I-1))))# Set ext threshol    SI40  38
IF(ICNT==yes:) JCNT=1#                 Set number of phase words        SI40  39
ELSE           JCNT=3#                 Set phase words noncentro        SI40  40
MSYMB=NSYMB+ICNT#                      Symbol count & +/- sign          SI40  41
#                                                                       SI40  42
#   REORDER GENERATOR LIST IN PHASE PATH ORDER                          SI40  43
#   ------------------------------------------                          SI40  44
#                                                                       SI40  45
IS=QXSTR#                              Use buff for sort swap           SI40  46
FOR(N1=M1;N1<ISEL;N1=N1+MARK)#         Loop over generator list         SI40  47
FOR(NG=N1;NG<ISEL;NG=NG+MARK)#         Loop over generator list         SI40  48
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI40  49
IF(iseq:!=N1) NEXT#                                                     SI40  50
movereal:(QX,NG+1,QX,IS+1,MARK,1)#     Swap selected gen to buffer      SI40  51
movereal:(QX,N1+1,QX,NG+1,MARK,1)#     Swap running  gen to slot        SI40  52
movereal:(QX,IS+1,QX,N1+1,MARK,1)#     Swap selected gen to top         SI40  53
BREAK#                                 Exit after transfer of gen       SI40  54
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI40  55
FOR(NG=M1;NG<MT;NG=NG+MARK)#           Loop over genlist                SI40  56
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI40  57
I=ipnt:;   seq:(I)=FLOAT(NG)#          Point to original order          SI40  58
uvw:=evl:#                             Store /e/ in uvw word            SI40  59
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI40  60
#                                                                       SI40  61
#   INPUT INVARIANTS SORT AND OUTPUT                                    SI40  62
#   -------------------------------                                     SI40  63
#                                                                       SI40  64
TEM=M2;  IZ=M1#                        Reset ra file parameters         SI40  65
NBIAS=M2-M1+1#                         Zero sum random alpha            SI40  66
#                                                                       SI40  67
FOR(NG=M1;NG<M2;NG=NG+MARK)#           Loop ordered gen list            SI40  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI40  69
TOP=itop:;   BOT=ibot:#                Get top/bot of si block          SI40  70
#                                                                       SI40  71
FOR(M=TOP;M<BOT;M=M+4)#                Loop over invariant block        SI40  72
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI40  73
IN(2)=NINT(QX(M+2))#                   Extract in(2) genlist addres     SI40  74
IN(3)=NINT(QX(M+3))#                   Extract in(3) genlist addres     SI40  75
IN(4)=NINT(QX(M+4))#                   Extract in(4) genlist addres     SI40  76
intunpak:(QX(M+1),IT, 0, 2)#           Extract invariant type           SI40  77
intunpak:(QX(M+1),IS, 2, 3)#           Extract phi sign code            SI40  78
IF(IT<POSQ) L=3;   ELSE L=4#           Set order of invariant           SI40  79
DO I=2,L#                              Loop over si generators          SI40  80
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI40  81
J=IN(I);  IN(I)=iseq:(J)#              Replace with new sort order      SI40  82
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI40  83
IF(IT==NEGQ) IN(2)=IN(2)+NBIAS#        For neq q4 bias n2 addr          SI40  84
J=MAX0(IN(2),IN(3),IN(4))#             Find largest address             SI40  85
DO I=2,L#                              Loop over last generators        SI40  86
IF(IN(I)==J) BREAK#                    Find which is largest            SI40  87
IN(I)=IN(2);  IN(2)=J#                 Swap gein(2) with largest        SI40  88
IS=IS+I*8-15;   IS=ISGN(IS)#           Adjust phi sign codes            SI40  89
intpak:(IS,QX(M+1), 2, 3)#             Pack sign code  bits  4- 2       SI40  90
QX(M+2)=FLOAT(IN(2))#                  Restore ordered n2               SI40  91
QX(M+3)=FLOAT(IN(3))#                  Restore ordered n3               SI40  92
QX(M+4)=FLOAT(IN(4))#                  Restore ordered n4               SI40  93
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI40  94
#                                                                       SI40  95
#                                       ******** sort si block incr n2  SI40  96
FOR(M=TOP+2;M<BOT;M=M+4)#              Loop over invariant block        SI40  97
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI40  98
A=QX(M);               I=M#            Reset sort value/pointer         SI40  99
FOR(L=M+4;L<BOT;L=L+4)#                Loop over reduced si block       SI40 100
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI40 101
IF(QX(L)>=A) NEXT#                     Find smallest n2                 SI40 102
A=QX(L);               I=L#            Store smaller & pointer          SI40 103
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI40 104
swapakwd:(QX(M-1),QX(I-1))#            Swap invariant word1             SI40 105
A=QX(M  ); QX(M  )=QX(I  ); QX(I  )=A# Swap invariant word 2            SI40 106
A=QX(M+1); QX(M+1)=QX(I+1); QX(I+1)=A# Swap invariant word 3            SI40 107
A=QX(M+2); QX(M+2)=QX(I+2); QX(I+2)=A# Swap invariant word 4            SI40 108
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI40 109
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI40 110
#                                                                       SI40 111
#                                                                       SI40 112
#    SETUP AND PRINT ASSIGNED PHASES                                    SI40 113
#    -------------------------------                                    SI40 114
#                                                                       SI40 115
movechar:(SI2,1,CHROT,2,NSI1-1,1)#     Underline header                 SI40 116
writeline:(1,SI1,NSI1,2,3)#            Print start header               SI40 117
LINRM=3#                               Force first start header         SI40 118
IF(ICNT==yes:) IZER=0#                 For centrosymetric sg            SI40 119
ELSE           IZER=1077952576#        For noncentrosymmetric           SI40 120
#                                                                       SI40 121
FOR(NG=M1;NG<MT;NG=NG+MARK)#           Loop over all generators         SI40 122
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI40 123
intpak:(IZER,sym:,0,bitlen:(0))#       Format symbol word1              SI40 124
intpak:(IZER,sy2:,0,bitlen:(0))#       Format symbol word 2             SI40 125
J=NINT(phi:)#                          Extract num or symbol phase      SI40 126
intpak:(0,phi:,0,bitlen:(0))#          Store phi as packed integer      SI40 127
IF(wgt:<0.1) NEXT#                     Skip non-starters                SI40 128
IF(ICNT==yes:)#                        If centrosymmetric               SI40 129
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI40 130
IF(J<0)#                               If starter is symbol             SI40 131
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI40 132
intpak:(1,sym:,-J,1)#                  Store symbol code                SI40 133
SPHI(-J)=0;    DPHI(-J)=180#           Set phi start & incr             SI40 134
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI40 135
IF(J==180) intpak:(1,sym:, 0,1)#       Store - as symbol                SI40 136
J=0#                                   Set phase to zero                SI40 137
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI40 138
ELSE IF(J<0)#                          For noncentro symbols            SI40 139
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI40 140
I=iprc:;     K=PRC(I)#                 Get phi restr code & value       SI40 141
SPHI(-J)=K#                            Set phi start phase              SI40 142
IF(I==1) DPHI(-J)=45#                  Incr by 45 if unrestricted       SI40 143
ELSE     DPHI(-J)=180#                 Incr by pi if restricted         SI40 144
K=-(J+1)*8#                            Set bit pointer                  SI40 145
IF(J>-5) intpak:(1,sym:,K   ,1)#       Store symbol code in word1       SI40 146
ELSE     intpak:(1,sy2:,K-32,1)#       Store symbol code in word 2      SI40 147
J=0#                                   Set phase to zero                SI40 148
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI40 149
ELSE intpak:(J,phi:,0,10)#             Store phi as packed integer      SI40 150
gethkl:(NG+1,BUFOT)#                   Store hkl in op buffer           SI40 151
BUFOT(4)=FLOAT((ipnt:-M1)/MARK+1)#     Store generator number           SI40 152
BUFOT(5)=uvw:#                         Store /e/ value                  SI40 153
BUFOT(6)=FLOAT(J)#                     Store numeric phase              SI40 154
BUFOT(7)=wgt:#                         Store start weight               SI40 155
ncodefld:(BUFOT,1,CHROT,FN,7)#         Format op items                  SI40 156
putsymb:(sym:,51,MSYMB)#               Insert symbol character          SI40 157
K=ista:#                               Extract status code              SI40 158
movechar:(SI3,K*6-5,CHROT,38,6,0)#     Insert start status              SI40 159
writeline:(0,SI5,NSI5,1,3)#            Print start summary              SI40 160
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI40 161
#                                                                       SI40 162
#      APPLY ASSIGNED PHASES TO START SET                               SI40 163
#      ----------------------------------                               SI40 164
#                                                                       SI40 165
DO NP=1,20#                            Loop over successive passes      SI40 166
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI40 167
ncodefld:(FLOAT(NP),1,SI4,380213.,1)#  Format cycle number              SI40 168
IF(IPRT(3)>0)writeline:(1,SI4,NSI4,3,3)# Print dump header              SI40 169
N1=0;  NSYM=0;   LINRM=3#              Reset first gener counter        SI40 170
#                                                                       SI40 171
FOR(NG=M1;NG<MG;NG=NG+MARK)#           Loop over start generators       SI40 172
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI40 173
N1=N1+1#                               Count start generators           SI40 174
TOP=itop:;   BOT=ibot:#                Set si block limits              SI40 175
IF(wgt:>0.1) NEXT#                     Skip if already assigned         SI40 176
ISUM=0;   NIND=0;   N4=0#              Reset sum a & indicator sum      SI40 177
#                                                                       SI40 178
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        SI40 179
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI40 180
intunpak:(QX(NI+1),IT, 5,4)#           Invar type (=0 not used)         SI40 181
IF(IT==0) NEXT#                        Skip if not applicable           SI40 182
N2=NINT(QX(NI+2))#                     Extract n2 address               SI40 183
IF(N2>MG) BREAK#                       Exit if above gener limit        SI40 184
IF(wgt:(N2)<0.1) NEXT#                 Skip if not yet assigned         SI40 185
N3=NINT(QX(NI+3))#                     Extract n3 address               SI40 186
IF(wgt:(N3)<0.1) NEXT#                 Skip if not yet assigned         SI40 187
IF(IT==3)#                             If positive quartet              SI40 188
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI40 189
N4=NINT(QX(NI+4))#                     Extract n4 address               SI40 190
IF(wgt:(N4)<0.1) NEXT#                 Skip if not yet assigned         SI40 191
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI40 192
intunpak:(QX(NI+1),IP,9,9)#            Extract phase shift value        SI40 193
intunpak:(QX(NI+1),IA,25,7)#           Extract w*alpha*8 value          SI40 194
ISUM=ISUM+IA#                          Sum si a or b values             SI40 195
NIND=NIND+1#                           Count symbol indications         SI40 196
IF(ICNT==yes:)#                        If centrosymmetric               SI40 197
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI40 198
intunpak:(sym:(N2),J2(1),0,bitlen:(0))#                                 SI40 199
intunpak:(sym:(N3),J3(1),0,bitlen:(0))#                                 SI40 200
intunpak:(sym:(N4),J4(1),0,bitlen:(0))#                                 SI40 201
symbolc:(IT-1,J2(1),J3(1),J4(1),IP,SJ(1))# Calc symbolic phase          SI40 202
IF(NIND==1) SK(1)=SJ(1)#               Store initial phase value        SI40 203
IF(SK(1)==SJ(1)) NEXT#                 Skip new phases match            SI40 204
NIND=0;   sta:=1000.;   BREAK#         Flag mismatch and exit           SI40 205
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI40 206
ELSE#                                  If noncentrosymmetric            SI40 207
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI40 208
intunpak:(QX(NI+1),IS,2,3)#            Extract phi sign code            SI40 209
DO I=0,2#                                                               SI40 210
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI40 211
intunpak:(sym:(N2+I),J2(I+1),0,bitlen:(0))#                             SI40 212
intunpak:(sym:(N3+I),J3(I+1),0,bitlen:(0))#                             SI40 213
intunpak:(sym:(N4+I),J4(I+1),0,bitlen:(0))#                             SI40 214
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI40 215
symboln:(IT-1,J2,J3,J4,IS,IP,SJ)#      Calc symbolic phase              SI40 216
#IF(NIND==1) MOVEREAL:(SJ,1,SK,1,3,0)#  STORE INITIAL PHASE VALUES      SI40 217
IF(NIND==1) DO I=1,3 ;SK(I)=SJ(I)#     Store initial phase values       SI40 218
IF(SJ(1)==SK(1)&SJ(2)==SK(2)&SJ(3)==SK(3)) NEXT# Skip if same phase     SI40 219
NIND=0;   sta:=1000.;   BREAK#         Exit on phase mismatch           SI40 220
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI40 221
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI40 222
IF(NIND==0) NEXT#                      Skip if phase not found          SI40 223
I=MIN0(NIND,20)#                       Ensure inside thresh limit       SI40 224
IF(ISUM<ETHR(I)) NEXT#                 Ignore indication if low a       SI40 225
wgt:=.9;   sta:=SET#                   Set start weight/status          SI40 226
NSYM=NSYM+1#                           Cound new phases found           SI40 227
movereal:(SK,1,sym:,1,JCNT,0)#         Store new phase words            SI40 228
#                                                                       SI40 229
IF(IPRT(3)==no:) NEXT#                 Skip if no print dump            SI40 230
gethkl:(NG+1,BUFOT)#                   Store hkl in op buffer           SI40 231
BUFOT(4)=FLOAT((ipnt:-M1)/MARK+1)#     Store generator number           SI40 232
BUFOT(5)=uvw:#                         Store /e/ value                  SI40 233
BUFOT(6)=FLOAT(SK(3))#                 Store numeric phase              SI40 234
BUFOT(7)=FLOAT(NIND)#                  Store number indications         SI40 235
BUFOT(8)=FLOAT(ISUM)/8.#               Store sum of a                   SI40 236
ncodefld:(BUFOT,1,CHROT,FM,8)#         Format op items                  SI40 237
putsymb:(sym:,49,MSYMB)#               Put symbol in output             SI40 238
writeline:(0,SI6,NSI6,1,3)#            Print start summary              SI40 239
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI40 240
IF(NSYM==0) BREAK#                     Exit if extension complete       SI40 241
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI40 242
NSEL=NP-1#                             Store cycles applied             SI40 243
#                                                                       SI40 244
RETURN#                                                                 SI40 245
END#                                                                    SI40 246
systemheader:(SI50)#                   Diverg. symbol application       SI50   1
####################################################################    SI50   2
#                                                                  #    SI50   3
#                             SI50                                 #    SI50   4
#                                                                  #    SI50   5
####################################################################    SI50   6
SUBROUTINE SI50#                       S.r.hall  dec 84                 SI50   7
include:(AACOMN)#                                                       SI50   8
include:(SICOMN)#                                                       SI50   9
#                                                                       SI50  10
INTEGER I,K,M,N,IT#                                                     SI50  11
INTEGER TOP,BOT,NEWS,NG,NI,NIND,NP,NSYM#                                SI50  12
INTEGER IA,ISUM,JSUM,LIM,MIND,MSYM,N2,N3,N4,NCYC#                       SI50  13
REAL A#                                                                 SI50  14
#                                                                       SI50  15
chardata:(SI1, **********DIVERGE EXTENSION CYCLE   )#                   SI50  16
chardata:(SI2,  NGEN    H   K   L    /E/   IND.   SUMA)#                SI50  17
chardata:(SI3,     OF TOP     REFLNS CONNECTED DIVERGE CYCLE   $#       SI50  18
  ATHR=     )#                                                          SI50  19
chardata:(SI4, **********DIVERGE ASSIGN SYMBOL    )#                    SI50  20
chardata:(SI5,ABCDEFGHIJ)#                                              SI50  21
chardata:(SI6,  NGEN    H   K   L  /E/   CONNECT  TOTA)#                SI50  22
chardata:(SI7,[ STARTING SET CONNECTS     OF TOP     REFLNS IN $#       SI50  23
   CONVERGE CYCLE(S)])#                                                 SI50  24
chardata:(SI8,[ SYMBOL   ASSIGNED BY DIVERGENCE TO     $#               SI50  25
(             )])#                                                      SI50  26
chardata:(SI9,[ STARTING SET CONNECTS     OF TOP     REFLNS IN $#       SI50  27
   DIVERGE CYCLE(S)])#                                                  SI50  28
realdata:(FM,[110413.,150413.,190413.,60413.,#                          SI50  29
260522.,320503.,400612.])#                                              SI50  30
realdata:(FMT,[450413.,490413.,530413.,390413.])#                       SI50  31
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        SI50  32
datastuff:#                                                             SI50  33
#                                                                       SI50  34
#                                                                       SI50  35
#    DISABLE ANY PHASE CONFLICTS                                        SI50  36
#    ---------------------------                                        SI50  37
#                                                                       SI50  38
FOR(NG=M1;NG<MG;NG=NG+MARK)#           Loop over start generators       SI50  39
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI50  40
TOP=itop:;   BOT=ibot:#                Set si block limits              SI50  41
IF(sta:<99.) NEXT#                     Skip if already assigned         SI50  42
#                                                                       SI50  43
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        SI50  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI50  45
intunpak:(QX(NI+1),IT, 5,4)#           Invar type (=0 not used)         SI50  46
IF(IT==0) NEXT#                        Skip if not applicable           SI50  47
N2=NINT(QX(NI+2))#                     Extract n2 address               SI50  48
IF(N2>MG) BREAK#                       Exit if above gener limit        SI50  49
IF(sta:(N2)>NUL) wgt:(N2)=0.#          Disable if not starter           SI50  50
N3=NINT(QX(NI+3))#                     Extract n3 address               SI50  51
IF(sta:(N3)>NUL) wgt:(N3)=0.#          Disable if not starter           SI50  52
IF(IT==3)#                             If positive quartet              SI50  53
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI50  54
N4=NINT(QX(NI+4))#                     Extract n4 address               SI50  55
IF(sta:(N4)>NUL) wgt:(N4)=0.#          Disable if not starter           SI50  56
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI50  57
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI50  58
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI50  59
#                                                                       SI50  60
#    COUNT PHASED GENERATORS IN START SET                               SI50  61
#    ------------------------------------                               SI50  62
#                                                                       SI50  63
MSYM=0#                                Reset phased gener count         SI50  64
FOR(NG=M1;NG<MG;NG=NG+MARK)#           Loop over start generators       SI50  65
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI50  66
IF(wgt:<0.1)#                          If not phased                    SI50  67
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI50  68
IF(ista:!=INUL) sta:=NOS#              Reset to not assigned            SI50  69
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI50  70
ELSE MSYM=MSYM+1#                      Count phased generator           SI50  71
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI50  72
ncodefld:(FLOAT(MSYM),1,SI7,260313.,1)# Format connected geners         SI50  73
ncodefld:(FLOAT(NSTG),1,SI7,370313.,1)# Format total start geners       SI50  74
ncodefld:(FLOAT(NSEL),1,SI7,500213.,1)# Format total cycles             SI50  75
writeline:(1,SI7,NSI7,2,3)#            Print connected starters         SI50  76
#                                                                       SI50  77
#     FIND CONNECTIONS IN EXTENSION SET                                 SI50  78
#     ---------------------------------                                 SI50  79
#                                                                       SI50  80
DO NP=1,20#                            Loop over successive passes      SI50  81
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI50  82
ncodefld:(FLOAT(NP),1,SI1,370213.,1)#  Format cycle number              SI50  83
IF(IPRT(4)>0)writeline:(1,SI1,NSI1,3,3)# Print dump header              SI50  84
NSYM=0;    LINRM=3#                    Reset first gener counter        SI50  85
#                                                                       SI50  86
FOR(NG=M1;NG<ME;NG=NG+MARK)#           Loop over exten generators       SI50  87
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI50  88
TOP=itop:;   BOT=ibot:#                Set si block limits              SI50  89
IF(wgt:>0.1) NEXT#                     Skip if already assigned         SI50  90
ISUM=0;   NIND=0#                      Reset sum a & indicator sum      SI50  91
#                                                                       SI50  92
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        SI50  93
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI50  94
intunpak:(QX(NI+1),IT, 0,2)#           Invar type (t3=0; pq4=2)         SI50  95
IF(IT!=0) NEXT#                        Skip if not triplet              SI50  96
N2=NINT(QX(NI+2))#                     Extract n2 address               SI50  97
IF(N2>ME) BREAK#                       Exit if above gener limit        SI50  98
IF(wgt:(N2)<0.1) NEXT#                 Skip if not yet assigned         SI50  99
N3=NINT(QX(NI+3))#                     Extract n3 address               SI50 100
IF(wgt:(N3)<0.1) NEXT#                 Skip if not yet assigned         SI50 101
intunpak:(QX(NI+1),IA,25,7)#           Extract w*alpha*8 value          SI50 102
ISUM=ISUM+IA#                          Sum si a or b values             SI50 103
NIND=NIND+1#                           Count symbol indications         SI50 104
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI50 105
IF(NIND==0) NEXT#                      Skip if phase not found          SI50 106
I=MIN0(NIND,20)#                       Ensure inside thresh limit       SI50 107
IF(ISUM<ETHR(I)) NEXT#                 Ignore indication if low a       SI50 108
wgt:=.5#                               Set temporary start weight1      SI50 109
NSYM=NSYM+1#                           Cound new phases found           SI50 110
#                                                                       SI50 111
IF(IPRT(4)==no:) NEXT#                 Skip if no print dump            SI50 112
gethkl:(NG+1,BUFOT)#                   Store hkl in op buffer           SI50 113
BUFOT(4)=FLOAT((ipnt:-M1)/MARK+1)#     Store generator number           SI50 114
BUFOT(5)=uvw:#                         Store /e/ value                  SI50 115
BUFOT(6)=FLOAT(NIND)#                  Store number indications         SI50 116
BUFOT(7)=FLOAT(ISUM)/8.#               Store sum of a                   SI50 117
ncodefld:(BUFOT,1,CHROT,FM,7)#         Format op items                  SI50 118
writeline:(0,SI2,NSI2,1,3)#            Print start summary              SI50 119
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI50 120
#                                                                       SI50 121
IF(NSYM==0&NP>3) BREAK#                Exit if extension complete       SI50 122
MSYM=MSYM+NSYM#                        Incr phased gener count          SI50 123
A=FLOAT(ETHR(1))/8.#                   Float current a theshold         SI50 124
ncodefld:(A,1,SI3,610522.,1)#          Format current a thresh          SI50 125
ncodefld:(FLOAT(MSYM),1,SI3,040313.,1)# Format gener count              SI50 126
ncodefld:(FLOAT(NP),1,SI3,490213.,1)#  Format cycle count               SI50 127
ncodefld:(FLOAT(NSTE),1,SI3,150313.,1)# Format gener count              SI50 128
writeline:(0,SI3,NSI3,3,3)#            Print phase gener count          SI50 129
DO I=1,20;ETHR(I)=(9*ETHR(I))/10#      Reduce acceptance threshold      SI50 130
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI50 131
NCYC=NP-1#                             Store converge cycles            SI50 132
#                                                                       SI50 133
#     FIND UNCONNECTED GENERATORS IN EXTENSION SET                      SI50 134
#     --------------------------------------------                      SI50 135
#                                                                       SI50 136
NEWS=no:;   LIM=INT(.9*FLOAT(NSTE))#   Reset new symbol flag            SI50 137
WHILE(NSYMB<8)#                        Loop over new symbols            SI50 138
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI50 139
IF(MSYM>LIM) BREAK#                    Exit >90% connected              SI50 140
movechar:(SI5,NSYMB+1,SI4,35,1,0)#     Insert symbol into header        SI50 141
IF(IPRT(4)>0&NEWS<1)writeline:(1,SI4,NSI4,3,3)# Print dump header       SI50 142
LINRM=3;   N=0;   M=0#                 Force first header               SI50 143
#                                                                       SI50 144
FOR(NP=M1;NP<ME;NP=NP+MARK)#           Loop over exten generators       SI50 145
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI50 146
IF(NEWS>0) NP=NEWS#                    Set gener to new symbol          SI50 147
ELSE IF(wgt:(NP)>.1) NEXT#             Skip if already phased           SI50 148
wgt:(NP)=0.9#                          Switch on this generator         SI50 149
MIND=0;      JSUM=0#                   Reset generator counter          SI50 150
#                                                                       SI50 151
FOR(NG=M1;NG<ME;NG=NG+MARK)#           Loop over exten generators       SI50 152
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI50 153
TOP=itop:;   BOT=ibot:#                Set si block limits              SI50 154
IF(wgt:>.1) NEXT#                      Skip phase reflections           SI50 155
NIND=0;    ISUM=0#                     Reset phase indicator            SI50 156
#                                                                       SI50 157
FOR(NI=TOP;NI<BOT;NI=NI+4)#            Loop over invariant block        SI50 158
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI50 159
intunpak:(QX(NI+1),IT, 0,2)#           Invar type (t3=0; pq4=2)         SI50 160
IF(IT==3) NEXT#                        Skip if not t3 or pq4            SI50 161
N2=NINT(QX(NI+2))#                     Extract n2 address               SI50 162
IF(N2>ME) BREAK#                       Exit if above gener limit        SI50 163
IF(wgt:(N2)<0.1) NEXT#                 Skip if not yet assigned         SI50 164
N3=NINT(QX(NI+3))#                     Extract n3 address               SI50 165
IF(wgt:(N3)<0.1) NEXT#                 Skip if not yet assigned         SI50 166
IF(IT==2)#                             If positive quartet              SI50 167
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI50 168
N4=NINT(QX(NI+4))#                     Extract n4 address               SI50 169
IF(wgt:(N4)<0.1) NEXT#                 Skip if not yet assigned         SI50 170
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI50 171
intunpak:(QX(NI+1),IA,25,7)#           Extract w*alpha*8 value          SI50 172
ISUM=ISUM+IA#                          Sum si a or b values             SI50 173
NIND=NIND+1#                           Count symbol indications         SI50 174
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI50 175
#                                                                       SI50 176
IF(NIND==0) NEXT#                      Skip if phase not found          SI50 177
I=MIN0(NIND,20)#                       Ensure inside thresh limit       SI50 178
IF(ISUM<ETHR(I)) NEXT#                 Ignore indication if low a       SI50 179
MIND=MIND+1;    JSUM=JSUM+ISUM#        Count as new phases              SI50 180
IF(NEWS>0) wgt:=0.5#                   Set weight if new symbol         SI50 181
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI50 182
#                                                                       SI50 183
IF(NEWS>0) BREAK#                      Exit after symbol applied        SI50 184
IF(IPRT(4)==yes:)#                     Skip if no print dump            SI50 185
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI50 186
gethkl:(NP+1,BUFOT)#                   Store hkl in op buffer           SI50 187
BUFOT(4)=FLOAT((ipnt:(NP)-M1)/MARK+1)# Store generator number           SI50 188
BUFOT(5)=uvw:(NP)#                     Store e-value                    SI50 189
BUFOT(6)=FLOAT(MIND)#                  Store new connections            SI50 190
BUFOT(7)=FLOAT(JSUM)#                  Store total weight               SI50 191
ncodefld:(BUFOT,1,CHROT,FM,7)#         Format op items                  SI50 192
writeline:(0,SI6,NSI6,1,3)#            Print start summary              SI50 193
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI50 194
wgt:(NP)=0.#                           Reset temporary weight           SI50 195
IF(MIND<=M) NEXT#                      Skip unless largest yet          SI50 196
M=MIND;     N=NP#                      Save count and gener addr        SI50 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI50 198
#                                                                       SI50 199
IF(NEWS>0)#                            Test if in new symb mode         SI50 200
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI50 201
NEWS=0;   NEXT#                        Reset & continue search          SI50 202
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI50 203
IF(M<1) BREAK#                         Exit if no connects              SI50 204
IF(M<4&MSYM>LIM/2) BREAK#              Exit if too few connects         SI50 205
IF(M<2&MSYM>LIM/4) BREAK#              Exit if too few connects         SI50 206
MSYM=MSYM+M;    NSYMB=NSYMB+1#         Add connects to total            SI50 207
NEWS=N;  wgt:(N)=1.0;   sta:(N)=SET#   Set new symbol & start sta       SI50 208
IF(ICNT==yes:)#                        For centrosymmetric              SI50 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI50 210
SPHI(NSYMB)=0;    DPHI(NSYMB)=180#     Set start/delta phase values     SI50 211
intpak:(1,sym:(N),NSYMB,1)#            Set centro symbol                SI50 212
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI50 213
ELSE#                                  Set noncentro symbol             SI50 214
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI50 215
I=iprc:(N);    K=PRC(I)#               Extract phi restr code           SI50 216
SPHI(NSYMB)=K#                         Set start phase value            SI50 217
IF(I==1) DPHI(NSYMB)=45#               Set incr phase for unrestr       SI50 218
ELSE     DPHI(NSYMB)=180#              Set incr phase for restricte     SI50 219
K=NSYMB*8-8#                           Set symbol pointer               SI50 220
IF(NSYMB<5) intpak:(1,sym:(N),K   ,1)# Set symbol in word 1             SI50 221
ELSE        intpak:(1,sy2:(N),K-32,1)# Set symbol in word 2             SI50 222
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI50 223
gethkl:(N+1,BUFOT)#                    Extract symbol hkl               SI50 224
BUFOT(4)=FLOAT((ipnt:(N)-M1)/MARK+1)#  Store e-list number              SI50 225
ncodefld:(BUFOT,1,SI8,FMT,4)#          Format above items               SI50 226
movechar:(SI5,NSYMB,SI8,9,1,0)#        Insert symbol into buffer        SI50 227
writeline:(1,SI8,NSI8,3,3)#            Print new symbol identity        SI50 228
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI50 229
#                                                                       SI50 230
#    COUNT PHASED GENERATORS IN START SET                               SI50 231
#    ------------------------------------                               SI50 232
#                                                                       SI50 233
MSYM=0;    NSEL=0#                     Reset phased gener count         SI50 234
FOR(NG=M1;NG<ME;NG=NG+MARK)#           Loop over start generators       SI50 235
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI50 236
IF(wgt:>.1) MSYM=MSYM+1#               Count connect generators         SI50 237
IF(sta:<1.5) wgt:=0.#                  Reset weights nonstarters        SI50 238
ELSE IF(ista:!=INUL) NSEL=NSEL+1#      Count phased generators          SI50 239
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI50 240
ncodefld:(FLOAT(MSYM),1,SI9,260313.,1)# Format connected geners         SI50 241
ncodefld:(FLOAT(NSTE),1,SI9,370313.,1)# Format total start geners       SI50 242
ncodefld:(FLOAT(NCYC),1,SI9,500213.,1)# Format cycle count              SI50 243
writeline:(1,SI9,NSI9,2,3)#            Print connected starters         SI50 244
#                                                                       SI50 245
RETURN#                                                                 SI50 246
END#                                                                    SI50 247
systemheader:(SI60)#                   Apply symbolic addition          SI60   1
####################################################################    SI60   2
#                                                                  #    SI60   3
#                             SI60                                 #    SI60   4
#                                                                  #    SI60   5
####################################################################    SI60   6
SUBROUTINE SI60#                       S.r.hall  jan 85                 SI60   7
include:(AACOMN)#                                                       SI60   8
include:(SICOMN)#                                                       SI60   9
#                                                                       SI60  10
INTEGER I,M,N,IT,IP,IS#                                                 SI60  11
INTEGER J2(3),J3(3),J4(3),SJ(3),SK(3,10),SUMN(10)#                      SI60  12
INTEGER IA,JSYM,MLIM,MSYM,MSYMB,N2,N3,N4,NCYC,NG,NI,NP,NPHI,NSYM#       SI60  13
REAL A,B,DWGT,QIQI,QJQJ(3),SUMW(10),W,WGT,WTAB(32)#                     SI60  14
INTEGER TOP,BOT#                                                        SI60  15
#                                                                       SI60  16
chardata:(SI2,-ABCDEFGHIJ+REJECT)#                                      SI60  17
chardata:(SI3,     OF TOP     REFLNS PHASED IN SYMBAD CYCLE   $#        SI60  18
  ATHR=     )#                                                          SI60  19
chardata:(SI4, **********SYMBOLIC ADDITION CYCLE   )#                   SI60  20
chardata:(SI5,  NGEN    H   K   L     /E/    WGT   IND.   $#            SI60  21
SUMA    PHASE)#                                                         SI60  22
realdata:(FM,[110413.,150413.,190413.,60413.,#                          SI60  23
270522.,340622.,400413.,480612.,550313.])#                              SI60  24
realdata:(FN,[040313.,150313.,480213.,600522.])#                        SI60  25
intdata:(ALL1,2147483647)#                                              SI60  26
realdata:(WMUL,1.);   realdata:(WSUM,1.)#                               SI60  27
datastuff:#                                                             SI60  28
#                                                                       SI60  29
#   CALCULATE A-THRESHOLDS AND WEIGHT TABLE                             SI60  30
#   ---------------------------------------                             SI60  31
#                                                                       SI60  32
ETHR(1)=0;   WTAB(32)=1.#              Reset accept threshold           SI60  33
IF(IACC==1)#                           If accept based on w*a           SI60  34
DO I=1,31#                             Loop over weight table           SI60  35
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI60  36
A=(FLOAT(I)-0.5)/16.#                  Calculate a incr                 SI60  37
B=EXP(A)#                              Calculate exp of a/2             SI60  38
IF(ICNT==no:) WTAB(I)=A/2.#            Store noncentro weight           SI60  39
ELSE          WTAB(I)=(B-1./B)/(B+1./B)# Store centro weight            SI60  40
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI60  41
ELSE  DO I=1,20#                       Else based on athr & ninv        SI60  42
ETHR(I)=NINT(ALIM*(1.+.3*(FLOAT(I-1))))# Set ext thresholds             SI60  43
DWGT=AMIN1(2.,ALIM/32.)#               Weight scale denominator         SI60  44
MSYMB=NSYMB+ICNT#                      Symbol count & +/- sign          SI60  45
IF(ICNT==yes:) JSYM=1;   ELSE JSYM=3#  Set number of phase items        SI60  46
#                                                                       SI60  47
#      APPLY SYMBOLIC ADDITION PROCEDURE                                SI60  48
#      =================================                                SI60  49
#                                                                       SI60  50
NLIM=MAX0(NSTG,NBLK);     NCYC=0#      Set initial parameters           SI60  51
MLIM=MAX0(MG,M1+NLIM*MARK)#            Diverge initial gener limit      SI60  52
DO I=1,10; SK(3,I)=0#                                                   SI60  53
#                                                                       SI60  54
DO NP=1,100#                           *********loop over iteration     SI60  55
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI60  56
ncodefld:(FLOAT(NP),1,SI4,370213.,1)#  Format cycle number              SI60  57
IF(IPRT(5)>0)writeline:(1,SI4,NSI4,3,3)# Print dump header              SI60  58
MSYM=0;   NSYM=0;    LINRM=3#          Reset first gener counter        SI60  59
#                                                                       SI60  60
FOR(NG=M1;NG<MLIM;NG=NG+MARK)#         **********loop over geners       SI60  61
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI60  62
#                                                                       SI60  63
TOP=itop:;   BOT=ibot:#                Set si block limits              SI60  64
IF(wgt:>0.01) NEXT#                    Skip if already assigned         SI60  65
NPHI=0;   N4=0#                        Reset phase estimates            SI60  66
SK(1,1)=ALL1#                          Reset symbol word                SI60  67
#                                                                       SI60  68
FOR(NI=TOP;NI<BOT;NI=NI+4)#            ************ loop over invar     SI60  69
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI60  70
N2=NINT(QX(NI+2))#                     Extract n2 address               SI60  71
IF(N2>MLIM) BREAK#                     Exit if above gener limit        SI60  72
IF(wgt:(N2)<WMIN) NEXT#                Skip if not yet assigned         SI60  73
N3=NINT(QX(NI+3))#                     Extract n3 address               SI60  74
IF(wgt:(N3)<WMIN) NEXT#                Skip if not yet assigned         SI60  75
IF(IACC==1)#                           For weighted accept method       SI60  76
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI60  77
WMUL=2.*wgt:(N2)*wgt:(N3)#             Triplet weight product           SI60  78
WSUM=wgt:(N2)+wgt:(N3)#                Triplet weight sum               SI60  79
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI60  80
intunpak:(QX(NI+1),IT,0,2)#            Get invariant type               SI60  81
IF(IT==2)#                             If positive quartet              SI60  82
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI60  83
N4=NINT(QX(NI+4))#                     Extract n4 address               SI60  84
IF(wgt:(N4)<WMIN) NEXT#                Skip if not yet assigned         SI60  85
IF(IACC==1)#                           For weighted accept method       SI60  86
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI60  87
WMUL=1.5*WMUL*wgt:(N4)#                Quartet weight product           SI60  88
WSUM=WSUM+wgt:(N4)#                    Quartet weight sum               SI60  89
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI60  90
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI60  91
intunpak:(QX(NI+1),IP,9,9)#            Extract phase shift              SI60  92
intunpak:(QX(NI+1),IA,25,7)#           Extract w*alpha*8 value          SI60  93
IF(IACC==1) WGT=WMUL*FLOAT(IA)/WSUM#   Calc weighted a*8                SI60  94
ELSE        WGT=FLOAT(IA)#             Else use a*8                     SI60  95
IF(ICNT==yes:)#                        If centrosymmetric               SI60  96
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI60  97
intunpak:(sym:(N2),J2(1),0,bitlen:(0))#                                 SI60  98
intunpak:(sym:(N3),J3(1),0,bitlen:(0))#                                 SI60  99
intunpak:(sym:(N4),J4(1),0,bitlen:(0))#                                 SI60 100
symbolc:(IT,J2(1),J3(1),J4(1),IP,SJ(1))# Calc symbolic phase            SI60 101
FOR(I=1;I<=NPHI;I=I+1)#                Loop over phase estimates        SI60 102
IF(SJ(1)==SK(1,I)) BREAK#              Exit on symbol match             SI60 103
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI60 104
ELSE#                                  If noncentrosymmetric            SI60 105
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI60 106
intunpak:(QX(NI+1),IS,2,3)#            Extract phi sign code            SI60 107
DO I=0,2#                                                               SI60 108
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI60 109
intunpak:(sym:(N2+I),J2(I+1),0,bitlen:(0))#                             SI60 110
intunpak:(sym:(N3+I),J3(I+1),0,bitlen:(0))#                             SI60 111
intunpak:(sym:(N4+I),J4(I+1),0,bitlen:(0))#                             SI60 112
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI60 113
symboln:(IT,J2,J3,J4,IS,IP,SJ)#        Calc symbolic phase              SI60 114
FOR(I=1;I<=NPHI;I=I+1)#                Loop over phase estimates        SI60 115
IF(SJ(1)==SK(1,I)&SJ(2)==SK(2,I)&SJ(3)==SK(3,I)) BREAK# Exit on match   SI60 116
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI60 117
#                                                                       SI60 118
IF(I<=NPHI)#                           If match is found                SI60 119
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI60 120
SUMN(I)=SUMN(I)+1#                     Sum number of invariants         SI60 121
SUMW(I)=SUMW(I)+WGT#                   Sum weighted a*8                 SI60 122
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI60 123
ELSE#                                  No match - new symbol phase      SI60 124
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI60 125
IF(I>10) NEXT#                         Skip if too many symbols         SI60 126
NPHI=I#                                Store new phase limit            SI60 127
SUMN(I)=1#                             Initialize new phase cnt         SI60 128
SUMW(I)=WGT#                           Initialize weighted a*8          SI60 129
movereal:(SJ,1,SK(1,I),1,JSYM,0)#      Save new symbol in array         SI60 130
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI60 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI60 132
#                                                                       SI60 133
IF(NPHI==0) NEXT#                      Skip if no new phase             SI60 134
N=1#                                   Set first symbol as best         SI60 135
IF((NPHI>1)&(MODE==2)) W=0.05#         Test for conflicts mode2         SI60 136
ELSE#                                  Else scan for best symbol        SI60 137
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI60 138
W=SUMW(1)#                             Set initial as first sumw        SI60 139
FOR(I=2;I<=NPHI;I=I+1)#                Loop over phase estimates        SI60 140
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI60 141
IF(SUMW(I)<=W) NEXT#                   Look for largest value           SI60 142
N=I;   W=SUMW(I)#                      Store largest weighted a*8       SI60 143
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI60 144
IF(IACC==1)#                           For weighted-a accept            SI60 145
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI60 146
I=MIN0(32,NINT(W/DWGT)+1);   W=WTAB(I)# Calc weight table index &&      SI60 147
IF(W<=WMIN) W=0.#                      Skip if not acceptable           SI60 148
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI60 149
ELSE#                                  If in a and ninv mode            SI60 150
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI60 151
I=MIN0(20,SUMN(N));   M=INT(W);   W=1.# Get number indications          SI60 152
IF(M<ETHR(I)) W=0.#                    Skip if not acceptable           SI60 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI60 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI60 155
wgt:=W#                                Store weight of phase estima     SI60 156
movereal:(SK(1,N),1,sym:,1,JSYM,0)#    Store new symbol phase           SI60 157
ifeq:(W,0.) NEXT#                      Next if not accepted             SI60 158
NSYM=NSYM+1#                           Count phases set <>wmin          SI60 159
IF(W>WMIN) MSYM=MSYM+1#                Count accepted phases            SI60 160
#                                                                       SI60 161
IF(IPRT(5)==no:) NEXT#                 Skip if no print dump            SI60 162
IF((N>1)&(MODE==1))#                   If not first symbol              SI60 163
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI60 164
swapakwd:(SUMN(1),SUMN(N))#            Swap sum of indications          SI60 165
swapakwd:(SUMW(1),SUMW(N))#            Swap sum of alphas               SI60 166
swapakwd:(SK(1,1),SK(1,N))#            Swap symbol word 1               SI60 167
IF(ICNT==no:)#                         For noncentrosymmetric           SI60 168
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI60 169
swapakwd:(SK(2,1),SK(2,N))#            Swap symbol word 2               SI60 170
swapakwd:(SK(3,1),SK(3,N))#            Swap numeric phase               SI60 171
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI60 172
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI60 173
gethkl:(NG+1,BUFOT)#                   Store hkl in op buffer           SI60 174
BUFOT(4)=FLOAT((ipnt:-M1)/MARK+1)#     Store generator number           SI60 175
BUFOT(5)=uvw:#                         Store /e/ value                  SI60 176
BUFOT(6)=wgt:#                         Store phase weight               SI60 177
ncodefld:(BUFOT,1,CHROT,FM,6)#         Format generator data            SI60 178
IF(W<WMIN)movechar:(SI2,13,CHROT,30,6,0)# Insert reject message         SI60 179
DO N=1,NPHI#                           Loop over phase estimates        SI60 180
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SI60 181
BUFOT(7)=FLOAT(SUMN(N))#               Store number indications         SI60 182
BUFOT(8)=SUMW(N)/8.#                   Store sum of w*a                 SI60 183
BUFOT(9)=FLOAT(SK(3,N))#               Store numeric phase              SI60 184
ncodefld:(BUFOT,7,CHROT,FM(7),3)#      Format op items                  SI60 185
DO I=0,1; intpak:(SK(1,N+I),QJQJ(I+1),0,bitlen:(0))#                    SI60 186
putsymb:(QJQJ,57,MSYMB)#               Put symbol to output             SI60 187
writeline:(0,SI5,NSI5,1,3)#            Print start summary              SI60 188
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SI60 189
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI60 190
#                                                                       SI60 191
NSEL=NSEL+MSYM#                        Count total refln phased         SI60 192
BUFOT(1)=FLOAT(NSEL)#                  Store phase count                SI60 193
BUFOT(2)=FLOAT(NLIM)#                  Store phases in block            SI60 194
BUFOT(3)=FLOAT(NP)#                    Store phase cycles               SI60 195
BUFOT(4)=FLOAT(ETHR(1))/8.#            Store first threshold            SI60 196
ncodefld:(BUFOT,1,SI3,FN,4)#           Format above items               SI60 197
writeline:(0,SI3,NSI3,3,3)#            Print above items                SI60 198
IF(NSEL>=NGEN) BREAK#                  Exit if all phased               SI60 199
IF((MSYM>0)&(NSEL<NLIM)) NEXT#         Next cycle if new phases         SI60 200
IF(IACC==2)#                           If a & n used for acceptance     SI60 201
DO I=1,20;ETHR(I)=(9*ETHR(I))/10#      Reduce a thresholds              SI60 202
NCYC=NCYC+1#                           Cycles for this gener block      SI60 203
IF((IACC==2)&(NCYC<6)&(NSEL<NLIM-10))NEXT# Iterate block for 5 cycles   SI60 204
IF(NLIM>=NGEN) BREAK#                  Exit if all data applied         SI60 205
NLIM=MIN0(NGEN,NLIM+NBLK)#             Set new block limit              SI60 206
MLIM=M1+NLIM*MARK#                     Expand generator limit           SI60 207
NCYC=0#                                Reset iteration count            SI60 208
IF(IACC==2)#                           If a & n used for acceptance     SI60 209
DO I=1,20; ETHR(I)=NINT(ALIM*(1.+.3*(FLOAT(I-1))))# Set ext threshol    SI60 210
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI60 211
#                                                                       SI60 212
RETURN#                                                                 SI60 213
END#                                                                    SI60 214
systemheader:(SI70)#                   Correlate symbol phases          SI70   1
####################################################################    SI70   2
#                                                                  #    SI70   3
#                             SI70                                 #    SI70   4
#                                                                  #    SI70   5
####################################################################    SI70   6
SUBROUTINE SI70#                       S.r.hall  feb 85                 SI70   7
include:(AACOMN)#                                                       SI70   8
include:(SICOMN)#                                                       SI70   9
#                                                                       SI70  10
INTEGER I,J,K,L,M,N,IT,IP,IS#                                           SI70  11
INTEGER J2(3),J3(3),J4(3),SJ(3),SK(3,20),SUMN(20)#                      SI70  12
INTEGER IA,II,JJ,JSYM,MSYMB,N2,N3,N4,NG,NI,NPHI,NSYM#                   SI70  13
REAL A,D,QIQI,QJQJ(3),SUMW(20),W,WGT#                                   SI70  14
INTEGER TOP,BOT#                                                        SI70  15
#                                                                       SI70  16
chardata:(SI1, FREQ.    SUMAA     PHASE)#                               SI70  17
chardata:(SI2,-ABCDEFGHIJ+NOT PHASED)#                                  SI70  18
chardata:(SI3,     OF TOP     REFLNS ASSIGNED FINAL SYMBOL PHASE)#      SI70  19
chardata:(SI4,[ SYMBOLS EQUIVALENCED TO PHI=0 (+)])#                    SI70  20
chardata:(SI5,  NGEN    H   K   L     /E/    WGT   IND.   $#            SI70  21
SUMA    PHASE)#                                                         SI70  22
chardata:(SI6, ***********FINAL SYMBOLIC ASSIGNMENTS)#                  SI70  23
chardata:(SI7, *** INDICATES THAT SYMBOL IS +)#                         SI70  24
chardata:(SI8, NEED FOR CAUTION ***)#                                   SI70  25
realdata:(FM,[110413.,150413.,190413.,60413.,#                          SI70  26
270522.,340622.,400413.,480612.,550313.])#                              SI70  27
realdata:(FN,[040313.,150313.,480213.])#                                SI70  28
realdata:(FQ,[050413.,140613.])#                                        SI70  29
realdata:(AVPH,[180.,90.,120.,135.,150.,180.,210.,225.,240.,90.])#      SI70  30
intdata:(ALL1,2147483647)#                                              SI70  31
realdata:(WMUL,1.);    realdata:(WSUM,1.)#                              SI70  32
datastuff:#                                                             SI70  33
#                                                                       SI70  34
#    APPLY ACCEPTED SYMBOLS TO ALL REFLECTIONS                          SI70  35
#    -----------------------------------------                          SI70  36
#                                                                       SI70  37
movereal:(0.,1,QX,M0+1,bdfbuf:,2)#     Zero mem for statistics          SI70  38
IF(IPRT(6)>0)writeline:(1,SI6,NSI6,3,3)# Print dump header              SI70  39
NSYM=0;    LINRM=3;    N4=0#           Reset first gener counter        SI70  40
DO I=1,20; SK(3,I)=0#                                                   SI70  41
MSYMB=NSYMB+ICNT;   D=0.;  NSEL=M0#    Allow for negative sign          SI70  42
IF(ICNT==yes:) JSYM=1;   ELSE JSYM=3#  Set number of phase items        SI70  43
#                                                                       SI70  44
FOR(NG=M1;NG<MT;NG=NG+MARK)#           **********loop over geners       SI70  45
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI70  46
#                                                                       SI70  47
TOP=itop:;   BOT=ibot:#                Set si block limits              SI70  48
NPHI=0#                                Reset phase estimates            SI70  49
SK(1,1)=ALL1#                          Reset symbol word                SI70  50
#                                                                       SI70  51
FOR(NI=TOP;NI<BOT;NI=NI+4)#            ************ loop over invar     SI70  52
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI70  53
N2=NINT(QX(NI+2))#                     Extract n2 address               SI70  54
IF(N2>MT) BREAK#                       Exit if above gener limit        SI70  55
IF(wgt:(N2)<WMIN) NEXT#                Skip if not yet assigned         SI70  56
N3=NINT(QX(NI+3))#                     Extract n3 address               SI70  57
IF(wgt:(N3)<WMIN) NEXT#                Skip if not yet assigned         SI70  58
IF(IACC==1)#                           For weighted accept method       SI70  59
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI70  60
WMUL=2.*wgt:(N2)*wgt:(N3)#             Triplet weight product           SI70  61
WSUM=wgt:(N2)+wgt:(N3)#                Triplet weight sum               SI70  62
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI70  63
intunpak:(QX(NI+1),IT,0,2)#            Get invariant type               SI70  64
IF(IT==2)#                             If positive quartet              SI70  65
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI70  66
N4=NINT(QX(NI+4))#                     Extract n4 address               SI70  67
IF(wgt:(N4)<WMIN) NEXT#                Skip if not yet assigned         SI70  68
IF(IACC==1)#                           For weighted accept method       SI70  69
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI70  70
WMUL=1.5*WMUL*wgt:(N4)#                Quartet weight product           SI70  71
WSUM=WSUM+wgt:(N4)#                    Quartet weight sum               SI70  72
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI70  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI70  74
intunpak:(QX(NI+1),IP,9,9)#            Extract phase shift              SI70  75
intunpak:(QX(NI+1),IA,25,7)#           Extract w*alpha*8 value          SI70  76
IF(IACC==1) WGT=WMUL*FLOAT(IA)/WSUM#   Calc weighted a*8                SI70  77
ELSE        WGT=FLOAT(IA)#             Else use a*8                     SI70  78
IF(ICNT==yes:)#                        If centrosymmetric               SI70  79
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI70  80
intunpak:(sym:(N2),J2(1),0,bitlen:(0))#                                 SI70  81
intunpak:(sym:(N3),J3(1),0,bitlen:(0))#                                 SI70  82
intunpak:(sym:(N4),J4(1),0,bitlen:(0))#                                 SI70  83
symbolc:(IT,J2(1),J3(1),J4(1),IP,SJ(1))# Calc symbolic phase            SI70  84
FOR(I=1;I<=NPHI;I=I+1)#                Loop over phase estimates        SI70  85
IF(SJ(1)==SK(1,I)) BREAK#              Exit on symbol match             SI70  86
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI70  87
ELSE#                                  If noncentrosymmetric            SI70  88
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI70  89
intunpak:(QX(NI+1),IS,2,3)#            Extract phi sign code            SI70  90
DO I=0,2#                                                               SI70  91
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI70  92
intunpak:(sym:(N2+I),J2(I+1),0,bitlen:(0))#                             SI70  93
intunpak:(sym:(N3+I),J3(I+1),0,bitlen:(0))#                             SI70  94
intunpak:(sym:(N4+I),J4(I+1),0,bitlen:(0))#                             SI70  95
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI70  96
symboln:(IT,J2,J3,J4,IS,IP,SJ)#        Calc symbolic phase              SI70  97
FOR(I=1;I<=NPHI;I=I+1)#                Loop over phase estimates        SI70  98
IF(SJ(1)==SK(1,I)&SJ(2)==SK(2,I)&SJ(3)==SK(3,I))BREAK# Exit on match    SI70  99
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI70 100
#                                                                       SI70 101
IF(I<=NPHI)#                           If match is found                SI70 102
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI70 103
SUMN(I)=SUMN(I)+1#                     Sum number of invariants         SI70 104
SUMW(I)=SUMW(I)+WGT#                   Sum weighted a*8                 SI70 105
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI70 106
ELSE#                                  No match - new symbol phase      SI70 107
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI70 108
IF(I>20) NEXT#                         Skip if too many symbols         SI70 109
NPHI=I#                                Store new phase limit            SI70 110
SUMN(I)=1#                             Initialize new phase cnt         SI70 111
SUMW(I)=WGT#                           Initialize weighted a*8          SI70 112
movereal:(SJ,1,SK(1,I),1,JSYM,0)#      Save new symbol in array         SI70 113
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI70 114
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI70 115
#                                                                       SI70 116
#   STORE EQUIVALENT-SYMBOL STATISTICS                                  SI70 117
#   ----------------------------------                                  SI70 118
#                                                                       SI70 119
IF(NPHI>1)#                            If more than one symbol          SI70 120
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI70 121
DO I=1,NPHI#                           Loop over equiv symbols          SI70 122
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI70 123
A=SUMW(I)/64.;   J=I+1#                Store sum of w*a                 SI70 124
DO K=J,NPHI#                           Loop over equiv symbols          SI70 125
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI70 126
IF(ICNT==yes:)#                        For centrosymmetric              SI70 127
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI70 128
symbolc:(0,SK(1,I),SK(1,K),0,0,L)#     Reduce phase equiv to +          SI70 129
M=M0+L*5;     IF(M+5>M1) NEXT#         Point to statistics table        SI70 130
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI70 131
ELSE#                                  If noncentrosymmetric            SI70 132
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI70 133
DO N=1,3#                                                               SI70 134
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI70 135
J2(N)=SK(N,I)#                                                          SI70 136
J3(N)=SK(N,K)#                                                          SI70 137
J4(N)=0#                                                                SI70 138
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI70 139
symboln:(0,J2,J3,J4,1,0,SJ)#           Get symbol phase difference      SI70 140
FOR(M=M0;M<NSEL;M=M+5)#                Loop over correl table           SI70 141
$(#                                    5>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI70 142
compakwd:(SJ(1),NE,QX(M+1),NEXT)#      Test for symbol match word1      SI70 143
compakwd:(SJ(2),NE,QX(M+2),NEXT)#      Test for symbol match word2      SI70 144
compakwd:(SJ(3),NE,QX(M+3),NEXT)#      Test for symbol match phase      SI70 145
BREAK#                                 Exit if same symbol              SI70 146
$)#                                    5<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI70 147
IF(M+5>M1) NEXT#                       Ignore if too many symbols       SI70 148
IF(M==NSEL)movereal:(SJ,1,QX,M+1,3,0)# Store new symbol in table        SI70 149
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI70 150
QX(M+4)=QX(M+4)+1.#                    Count equivalents                SI70 151
QX(M+5)=QX(M+5)+A*SUMW(K)#             Sum weighted-a product           SI70 152
NSEL=MAX0(NSEL,M+5)#                   Save max entry point             SI70 153
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI70 154
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI70 155
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI70 156
#                                                                       SI70 157
#    ASSIGN MOST PROBABLE SYMBOL                                        SI70 158
#    ---------------------------                                        SI70 159
#                                                                       SI70 160
IF(NPHI>0)#                            If new phase determined          SI70 161
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI70 162
NSYM=NSYM+1#                           Count determined phase           SI70 163
I=iprc:;    D=D+AVPH(I)#               Sum expected phase mean          SI70 164
wgt:=AMAX1(wgt:,0.05)#                 Ensure phase above zero          SI70 165
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI70 166
ELSE wgt:=0.#                          Phase not determined             SI70 167
#                                                                       SI70 168
IF(IPRT(6)==no:) NEXT#                 Skip if no print dump            SI70 169
N=1;      W=SUMW(1)#                   Set initial as first sumw        SI70 170
FOR(I=2;I<=NPHI;I=I+1)#                Loop over phase estimates        SI70 171
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SI70 172
IF(SUMW(I)<=W) NEXT#                   Look for largest value           SI70 173
N=I;   W=SUMW(I)#                      Store largest weighted a*8       SI70 174
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SI70 175
#                                                                       SI70 176
IF(N>1)#                               If not first symbol              SI70 177
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SI70 178
swapakwd:(SUMN(1),SUMN(N))#            Swap sum of indications          SI70 179
swapakwd:(SUMW(1),SUMW(N))#            Swap sum of alphas               SI70 180
swapakwd:(SK(1,1),SK(1,N))#            Swap symbol word 1               SI70 181
IF(ICNT==no:)#                         For noncentrosymmetric           SI70 182
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SI70 183
swapakwd:(SK(2,1),SK(2,N))#            Swap symbol word 2               SI70 184
swapakwd:(SK(3,1),SK(3,N))#            Swap symbol phase                SI70 185
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SI70 186
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SI70 187
gethkl:(NG+1,BUFOT)#                   Store hkl in op buffer           SI70 188
BUFOT(4)=FLOAT((ipnt:-M1)/MARK+1)#     Store generator number           SI70 189
BUFOT(5)=uvw:#                         Store /e/ value                  SI70 190
BUFOT(6)=1.00#                         Store phase weight as 1.         SI70 191
ncodefld:(BUFOT,1,CHROT,FM,6)#         Format generator data            SI70 192
IF(NPHI==0)#                           If phase not determined          SI70 193
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SI70 194
movechar:(SI2,13,CHROT,30,10,0)#       Insert nophi message             SI70 195
writeline:(0,SI5,NSI5,1,3)#            Print reflection                 SI70 196
NEXT#                                  Skip to next generator           SI70 197
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SI70 198
DO N=1,NPHI#                           Loop over phase estimates        SI70 199
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SI70 200
BUFOT(7)=FLOAT(SUMN(N))#               Store number indications         SI70 201
BUFOT(8)=SUMW(N)/8.#                   Store sum of w*a                 SI70 202
BUFOT(9)=FLOAT(SK(3,N))#               Store numeric phase              SI70 203
ncodefld:(BUFOT,7,CHROT,FM(7),3)#      Format op items                  SI70 204
DO I=0,1; intpak:(SK(1,N+I),QJQJ(I+1),0,bitlen:(0))#                    SI70 205
putsymb:(QJQJ,57,MSYMB)#               Put symbol to output             SI70 206
writeline:(0,SI5,NSI5,1,3)#            Print start summary              SI70 207
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SI70 208
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI70 209
IF(PHIAV<0.)PHIAV=D/FLOAT(NSYM)#       Calc average expected phase  ^   SI70 210
#                                                                       SI70 211
#    PRINT SUMMARY OF ASSIGNED SYMBOLS                                  SI70 212
#    ---------------------------------                                  SI70 213
#                                                                       SI70 214
BUFOT(1)=FLOAT(NSYM)#                  Store phase count                SI70 215
BUFOT(2)=FLOAT(NGEN)#                  Store reflns in list             SI70 216
ncodefld:(BUFOT,1,SI3,FN,2)#           Format above items               SI70 217
writeline:(1,SI3,NSI3,3,3)#            Print above items                SI70 218
#                                                                       SI70 219
IF(NSYMB>0)#                           If symbols assigned              SI70 220
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SI70 221
LINRM=8#                               Allow room for header            SI70 222
movechar:(SI2,1,CHROT,2,NSI4-1,1)#     Underline header                 SI70 223
writeline:(1,SI4,NSI4,2,3)#            Print header                     SI70 224
II=MSYMB+23;   JJ=II+30;  LINRM=5#     Set op symbol pointers           SI70 225
#                                                                       SI70 226
ELIM=0.;    FRAC=0.1#                  Set initial a*a maximum          SI70 227
FOR(M=M0;M<NSEL;M=M+5)#                Loop over symbol table           SI70 228
ELIM=AMAX1(ELIM,QX(M+5))#              Find largest a*a sum             SI70 229
#                                                                       SI70 230
FOR(M=M0;M<NSEL;M=M+5)#                Loop over symbol table           SI70 231
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SI70 232
ifeq:(QX(M+4),0.) NEXT#                Skip null symbols                SI70 233
QX(M+5)=QX(M+5)*1000./ELIM#            Normalize sum(a*a)               SI70 234
FRAC=FRAC+QX(M+5)#                     Sum all suma*suma                SI70 235
intunpak:(QX(M+3),I,0,10)#             Extract numeric phase            SI70 236
ncodefld:(FLOAT(I),1,CHROT,230313.,1)# Format numeric phase             SI70 237
ncodefld:(QX,M+4,CHROT,FQ,2)#          Format phi, freq and weight      SI70 238
IF(ICNT==yes:)#                        If centrosymmetric               SI70 239
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SI70 240
N=(M-M0)/5;   L=0#                     Point to symbol (-=1)            SI70 241
intpak:(N,QX(M+1),0,10)#               Store centro phase in table      SI70 242
IF(MOD(N,2)>0)intpak:(180,QX(M+3),0,10)# Store numeric phase in tabl    SI70 243
IF(QX(M+5)>150.)#                      For significant weights          SI70 244
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SI70 245
DO I=1,NSYMB#                          Loop over possible symbols       SI70 246
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SI70 247
intunpak:(N,J,I,1);   IF(J>0) L=L+1#   Count components of symbol       SI70 248
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SI70 249
IF(L<2)#                               Is message needed                SI70 250
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SI70 251
movechar:(SI7,1,CHROT,II,NSI7,0)#      Insert alert message             SI70 252
IF(MOD(N,2)>0) CHROT(JJ^JJ)='-'#       Insert negative sign             SI70 253
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SI70 254
ELSE movechar:(SI7,1,CHROT,II,4,0)#    Insert *** indicator             SI70 255
IF(N==1)movechar:(SI8,1,CHROT,II+14,NSI8,0)# Insert warning message     SI70 256
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SI70 257
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SI70 258
putsymb:(QX(M+1),25,MSYMB)#            Put symbol in output             SI70 259
writeline:(0,SI1,NSI1,1,3)#            Print freq and weight            SI70 260
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SI70 261
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SI70 262
#                                                                       SI70 263
RETURN#                                                                 SI70 264
END#                                                                    SI70 265
systemheader:(SI80)#                   Test phase sets with fom's       SI80   1
####################################################################    SI80   2
#                                                                  #    SI80   3
#                             SI80                                 #    SI80   4
#                                                                  #    SI80   5
####################################################################    SI80   6
SUBROUTINE SI80#                       S.r.hall  feb 85                 SI80   7
include:(AACOMN)#                                                       SI80   8
include:(SICOMN)#                                                       SI80   9
#                                                                       SI80  10
INTEGER I,J,K,L,M,N#                                                    SI80  11
INTEGER TOP,BOT,SJ(3),J2(3),J3(3),J4(3)#                                SI80  12
INTEGER IA,IB,IP,IS,IT,MP,MSYMB,N2,N3,N4,NBIAS,NG,NI,NP,NPHI#           SI80  13
REAL C,DWGT,E,PHIA,PHIN,PSIA,PSIE,PSIN,SCOS,SNQA,SNQC,SNQD,SNQN,SNQS#   SI80  14
REAL SSIN,SUMA,SUMB,SUMD,SUMI,SUMN,SUMP,SUMR,WT#                        SI80  15
REAL A,B,D,ASUM(64)#                                                    SI80  16
INTEGER JPHI(8,64),IPHI(8),PHI(9)#                                      SI80  17
REAL WTAB(32)#                                                          SI80  18
#                                                                       SI80  19
chardata:(SI1,-ABCDEFGHIJ+)#                                            SI80  20
chardata:(SI2, PHASE SETS BASED ON SYMBOL CORRELATION)#                 SI80  21
chardata:(SI3, NSET    COFACTOR    A    B    C    D    E$#              SI80  22
    F    G    H)#                                                       SI80  23
chardata:(SI4, ***********FIGURE OF MERIT CALCULATION)#                 SI80  24
chardata:(SI5, NSET  NGEN  APHI   NINV   SUMA   SUME   SUMR  RFOM$#     SI80  25
   SUMD  RFAC   NPSI  NPT3  SUMA  SUME  PSI0   NQGN  NNQ4  NEGQ)#       SI80  26
realdata:(FM,[040313.,140413.])#                                        SI80  27
realdata:(FN,[40413.,110413.,170513.,240513.,310613.,380613.,450613.,#  SI80  28
510422.,580613.,640422.,710413.,770613.,830613.,890613.,950422.,#       SI80  29
1020403.,1080403.,1140503.])#                                           SI80  30
intdata:(PRC,[0,0,30,45,60,90,120,135,150,180])#                        SI80  31
realdata:(X,.01745329)#                                                 SI80  32
datastuff:#                                                             SI80  33
#                                                                       SI80  34
#     ORDER PHASE CHOICE FROM SYMBOL CORRELATION                        SI80  35
#     ------------------------------------------                        SI80  36
#                                                                       SI80  37
FOM(1,1)=1.;   MSYMB=NSYMB+ICNT#       Set fom if no symbols            SI80  38
WTAB(32)=1.;   PHI(1)=180#             Set initial values               SI80  39
IF(NSYMB>0)#                           If symbols assigned              SI80  40
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI80  41
DO I=1,NSYMB; IPHI(I)=SPHI(I)#         Set initial phases               SI80  42
DO I=1,64; ASUM(I)=-100000.#           Set initial values               SI80  43
REPEAT#                                Loop over phase permutations     SI80  44
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI80  45
A=0.1#                                 Zero sum of weights              SI80  46
FOR(M=M0;M<NSEL;M=M+5)#                Loop over correlation stats      SI80  47
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI80  48
ifeq:(QX(M+4),0.) NEXT#                Skip null symbols                SI80  49
N=(M-M0)/5;   intunpak:(QX(M+3),L,0,10)# Get symbol index & phase       SI80  50
#                                                                       SI80  51
DO I=1,NSYMB#                          Loop over possible symbols       SI80  52
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI80  53
IF(IPHI(I)==0) NEXT#                   Skip zero phases                 SI80  54
IF(ICNT==yes:)#                        If centrosymmetric               SI80  55
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI80  56
intunpak:(N,J,I,1)#                    Extract symbol flag j            SI80  57
IF(J>0) L=L+IPHI(I)#                   If active add assigned phi       SI80  58
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI80  59
ELSE#                                  If noncentrosymmetric            SI80  60
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI80  61
K=(I-1)*8#                             Point to symbol byte             SI80  62
IF(I<5) intunpak:(QX(M+1),J,K   ,7)#   Get symbol from word 1           SI80  63
ELSE    intunpak:(QX(M+2),J,K-32,7)#   Get symbol from word 2           SI80  64
IF(J==64) NEXT;    K=J-64#             Skip if null & sign              SI80  65
L=L+K*IPHI(I)#                         Sum numeric phases               SI80  66
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI80  67
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI80  68
#                                                                       SI80  69
L=MOD(36000+L,360)#                    Reduce phase to mod360           SI80  70
IF(L==0)        A=A+QX(M+5)#           Sum weight for zero phi          SI80  71
ELSE IF(L==180) A=A-QX(M+5)#           Sum weight for 180 phi           SI80  72
ELSE            A=A+QX(M+5)*COS(X*FLOAT(L))# Sum weight for gen  phi    SI80  73
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI80  74
#                                                                       SI80  75
IF(A>ASUM(NSET))#                      Is asum > than current limit     SI80  76
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI80  77
FOR(I=1;I<NSET;I=I+1) IF(A>ASUM(I)) BREAK# Get posn in sorted list      SI80  78
K=I*8+1;    L=NSET-I#                  Set phi pointers                 SI80  79
movereal:(JPHI,K-8,JPHI,K,L*8,1)#      Shift sorted phis down           SI80  80
movereal:(ASUM,I,ASUM,I+1,L,1)#        Shift sorted weights down        SI80  81
DO J=1,NSYMB; JPHI(J,I)=IPHI(J)#       Store new phi permutes           SI80  82
ASUM(I)=A#                             Store new value in list          SI80  83
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI80  84
#                                                                       SI80  85
FOR(I=1;I<=NSYMB;I=I+1)#               Loop over possible symbols       SI80  86
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI80  87
IPHI(I)=IPHI(I)+DPHI(I)#               Incr test symbol phase           SI80  88
IF(IPHI(I)<360) BREAK#                 Exit permutation loop            SI80  89
IPHI(I)=SPHI(I)#                       Reset phase base mod 360         SI80  90
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI80  91
IF(I>NSYMB) BREAK#                     Exit after last permutation      SI80  92
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI80  93
#                                                                       SI80  94
#    PRINT ORDERED PHASE SETS                                           SI80  95
#    ------------------------                                           SI80  96
#                                                                       SI80  97
LINRM=8;   M=1;   IOMARK(3)=IOMARK(4)# Ensure sufficient room           SI80  98
movechar:(SI1,1,CHROT,2,NSI2-1,1)#     Inset header underline           SI80  99
writeline:(1,SI2,NSI2,2,3); LINRM=4#   Print phase set header           SI80 100
#                                                                       SI80 101
DO N=1,NSET#                           Loop over ordered phi sets       SI80 102
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI80 103
FOM(1,N)=1.5-ASUM(N)/FRAC#             Store cofactor as fom1           SI80 104
BUFOT(1)=FLOAT(N)#                     Store sorted order               SI80 105
BUFOT(2)=ASUM(N)*100./FRAC#            Store weight base 100            SI80 106
ncodefld:(BUFOT,1,CHROT,FM,2)#         Format order & weight            SI80 107
DO J=1,NSYMB#                          Loop over assigned symbols       SI80 108
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI80 109
K=J*5+17#                              Point to symbol position         SI80 110
IF(ICNT==1)#                           If centrosymmetric               SI80 111
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI80 112
IF(JPHI(J,N)>0) L=1;   ELSE L=12#      Test if + or - char              SI80 113
movechar:(SI1,L,CHROT,K,1,0)#          Insert appropriate sign          SI80 114
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI80 115
ELSE#                                  For noncentrosymmetric           SI80 116
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI80 117
A=FLOAT(K*10000+0313)#                 Set op format                    SI80 118
ncodefld:(FLOAT(JPHI(J,N)),1,CHROT,A,1)# Format permute phase           SI80 119
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI80 120
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI80 121
writeline:(0,SI3,NSI3,1,3)#            Print ordered phase set          SI80 122
IF(FOM(1,N)<1.5) M=N#                  Save last +ve cofactor           SI80 123
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI80 124
IF(NSOP>3) NSET=M#                     Reset nsets for high symm        SI80 125
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI80 126
ELSE NSET=1#                           Reset max phase sets             SI80 127
#                                                                       SI80 128
#   CALCULATE A-THRESHOLDS AND WEIGHT TABLE                             SI80 129
#   ---------------------------------------                             SI80 130
#                                                                       SI80 131
DO I=1,31#                             Loop over weight table           SI80 132
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI80 133
A=(FLOAT(I)-0.5)/16.#                  Calculate a incr                 SI80 134
B=EXP(A)#                              Calculate exp of a/2             SI80 135
IF(ICNT==no:) WTAB(I)=A/2.#            Store noncentro weight           SI80 136
ELSE          WTAB(I)=(B-1./B)/(B+1./B)# Store centro weight            SI80 137
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI80 138
DWGT=AMIN1(2.,ALIM/256.)#              Weight scale denominator         SI80 139
#                                                                       SI80 140
#    APPLY TRIAL PHASE SETS TO ALL REFLECTIONS                          SI80 141
#    -----------------------------------------                          SI80 142
#                                                                       SI80 143
IF(IPRT(7)>0)writeline:(1,SI4,NSI4,3,3)# Print dump header              SI80 144
LINRM=3;   SUMR=0.#                    Reset max phase sets             SI80 145
SUMI=0.;    SUMP=0.;   SUMN=0.#        Zero inv,psi0,negq sums          SI80 146
NBIAS=M2-M1+1#                         Get neg quartet bias             SI80 147
#                                                                       SI80 148
DO NP=1,NSET#                          Loop over phase sets             SI80 149
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI80 150
DO I=1,NSYMB; PHI(I+1)=JPHI(I,NP)#     Store current phase set          SI80 151
N4=MT;   PSIN=0.; WT=WMIN#             Reset first gener counter        SI80 152
SUMA=0.; SUMB=0.; SUMD=0.#             Zero fom summations              SI80 153
PSIA=0.; PSIE=0.; PHIA=0.; PHIN=0.#    Zero fom summations              SI80 154
SNQD=0.; SNQN=0.; SNQA=0.#             Zero fom summations              SI80 155
MP=NP+1#                               Set op record number             SI80 156
#                                                                       SI80 157
FOR(NG=M1;NG<M2;NG=NG+MARK)#           **********loop over geners       SI80 158
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI80 159
#                                                                       SI80 160
TOP=itop:;   BOT=ibot:#                Set si block limits              SI80 161
SCOS=0.;  SSIN=0.;  B=0.#              Zero sin/cos summations          SI80 162
SNQC=0.;  SNQS=0.;  C=0.#              Zero sin/cos sums for negq       SI80 163
IF(NG==MT) WT=0.02#                    Include all trips for psi0       SI80 164
#                                                                       SI80 165
FOR(NI=TOP;NI<BOT;NI=NI+4)#            ************ loop over invar     SI80 166
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI80 167
N2=NINT(QX(NI+2))#                     Extract n2 address               SI80 168
IF(N2>=M2) N2=N2-NBIAS#                Correct for neg quartet          SI80 169
IF(wgt:(N2)<WT) NEXT#                  Skip if not yet assigned         SI80 170
N3=NINT(QX(NI+3))#                     Extract n3 address               SI80 171
IF(wgt:(N3)<WT) NEXT#                  Skip if not yet assigned         SI80 172
intunpak:(QX(NI+1),IT,0,2)#            Get invariant type               SI80 173
IF(IT>1)#                              If pos & neg quartet             SI80 174
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI80 175
N4=NINT(QX(NI+4))#                     Extract n4 address               SI80 176
IF(wgt:(N4)<WT) NEXT#                  Skip if not yet assigned         SI80 177
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI80 178
intunpak:(QX(NI+1),IP,9,9)#            Extract phase shift              SI80 179
intunpak:(QX(NI+1),IA,25,7)#           Extract w*alpha*8 value          SI80 180
intunpak:(QX(NI+1),IB,18,7)#           Extract prob factor*64           SI80 181
A=FLOAT(IA)#                           Float alpha*8                    SI80 182
B=B+FLOAT(IB)*A#                       Sum expected alpha**2            SI80 183
IF(ICNT==yes:)#                        If centrosymmetric               SI80 184
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI80 185
intunpak:(sym:(N2),J2(1),0,bitlen:(0))#                                 SI80 186
intunpak:(sym:(N3),J3(1),0,bitlen:(0))#                                 SI80 187
intunpak:(sym:(N4),J4(1),0,bitlen:(0))#                                 SI80 188
symbolc:(IT,J2(1),J3(1),J4(1),IP,SJ(1))# Calc symbolic phase            SI80 189
DO I=1,MSYMB#                          Loop over symbols                SI80 190
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SI80 191
IF(PHI(I)==0) NEXT#                    Ignore symbol if zero            SI80 192
intunpak:(SJ(1),J,I-1,1)#              Extract symbol flag              SI80 193
IF(J>0) A=-A#                          Reverse sign if phi=180          SI80 194
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SI80 195
IF(IT!=NEGQ) SCOS=SCOS+A#              Sum cos(phi)*alpha               SI80 196
ELSE         SNQC=SNQC+A#              Sum cos(phi)*alpha negq          SI80 197
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI80 198
ELSE#                                  If noncentrosymmetric            SI80 199
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SI80 200
intunpak:(QX(NI+1),IS,2,3)#            Extract phi sign code            SI80 201
intunpak:(sym:(N2),J2(1),0,bitlen:(0))#                                 SI80 202
intunpak:(sym:(N3),J3(1),0,bitlen:(0))#                                 SI80 203
intunpak:(sym:(N4),J4(1),0,bitlen:(0))#                                 SI80 204
symbolc:(IT,J2(1),J3(1),J4(1),IP,SJ(1))# Calc symbolic phase            SI80 205
intunpak:(SJ(3),NPHI,0,10)#            Extract numeric phase            SI80 206
DO I=1,NSYMB#                          Loop over possible symbols       SI80 207
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SI80 208
IF(PHI(I+1)==0) NEXT;    K=(I-1)*8#    Skip if phi=0 & point symbol     SI80 209
IF(I<5) intunpak:(SJ(1),J,K   ,7)#     Extract symbol code word 1       SI80 210
ELSE    intunpak:(SJ(2),J,K-32,7)#     Extract symbol code word 2       SI80 211
IF(J==64) NEXT;    K=J-64#             Skip if null & convert if no     SI80 212
NPHI=NPHI+K*PHI(I+1)#                  Sum active phase values          SI80 213
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SI80 214
D=FLOAT(NPHI)*X#                       Convert phi to radians           SI80 215
E=SIN(D)*A;   D=COS(D)*A#              Calc sin/cosine components       SI80 216
IF(IT!=NEGQ)#                          For trips and pos quartets       SI80 217
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 22 SI80 218
SSIN=SSIN+E;   SCOS=SCOS+D#            Sum sf components                SI80 219
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 22 SI80 220
ELSE#                                  For neg quartets                 SI80 221
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 23 SI80 222
SNQS=SNQS+E;   SNQC=SNQC+D#            Sum sf components                SI80 223
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 23 SI80 224
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SI80 225
IF(NP==1)#                             For first phase set only         SI80 226
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 24 SI80 227
C=C+A**2#                              Sum alpha*8 squared              SI80 228
IF     (IT==PSI0) SUMP=SUMP+1.#        Count psi0 triplets              SI80 229
ELSE IF(IT==NEGQ) SUMN=SUMN+1.#        Count neg quartets               SI80 230
ELSE              SUMI=SUMI+1.#        Count other invariants           SI80 231
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 24 SI80 232
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI80 233
#                                                                       SI80 234
#     ESTIMATE PHASE & SUM FOR FOMS                                     SI80 235
#     -----------------------------                                     SI80 236
#                                                                       SI80 237
writepkt:(3,MP,2,IP)#                  Point to next op packet          SI80 238
QX(IP+1)=0.;    QX(IP+2)=0.#           Store undetermined values        SI80 239
IF(B<.001) NEXT#                       Skip if not phased               SI80 240
A=SQRT(SSIN**2+SCOS**2)/8.;   B=B/512.# Form calc & expect alpha        SI80 241
IF(NG<MT)#                             For non-psi0 generators          SI80 242
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 25 SI80 243
SUMA=SUMA+A#                           Sum calculated alphas            SI80 244
SUMB=SUMB+B#                           Sum expected alphas              SI80 245
SUMD=SUMD+ABS(A-B)#                    Sum alpha differences            SI80 246
IF(NP==1) SUMR=SUMR+SQRT(C)/8.#        Sum random alphas                SI80 247
IF(ICNT>0) K=90-NINT(SIGN(90.,SCOS))#  Get centrosymmetric phase        SI80 248
ELSE#                                  For noncentrosymmetric           SI80 249
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 26 SI80 250
IF((ABS(SSIN)<.01)&(ABS(SCOS)<.01)) NEXT# Skip if uncertain             SI80 251
C=ATAN2(SSIN,SCOS)/X#                  Calc phase in degrees            SI80 252
K=MOD(3600+NINT(C),360)#               Reduce to positive value         SI80 253
IF(prc:>1.5)#                          If restricted phase value        SI80 254
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 27 SI80 255
I=iprc:;    J=PRC(I)#                  Extract phase restriction        SI80 256
K=IABS(K-J);    K=MIN0(K,360-K)#       Get min diff with phi            SI80 257
IF(K==90) NEXT#                        Skip completely wrong            SI80 258
IF(K<90) K=J#                          Set to restriction               SI80 259
ELSE     K=J+180#                      Set to restriction +pi           SI80 260
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 27 SI80 261
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 26 SI80 262
C=FLOAT(K);  I=MIN0(32,NINT(A/DWGT)+1)# Float est phase & wgt ind&&     SI80 263
QX(IP+1)=C#                            Store phase in op packet         SI80 264
QX(IP+2)=WTAB(I)#                      Store weight in packet           SI80 265
PHIN=PHIN+1.#                          Sum number of phases             SI80 266
PHIA=PHIA+C#                           Sum phase values                 SI80 267
#                                                                       SI80 268
ifeq:(SNQC,0.) NEXT#                   Skip if no neg quartets          SI80 269
A=SQRT(SNQS**2+SNQC**2)/8.#            Get calculated alpha             SI80 270
IF(ICNT>0) L=90-NINT(SIGN(90.,SNQC))#  Get centro negq phase            SI80 271
ELSE#                                  For noncentro negq phase         SI80 272
$(#                                    3>>>>>>>>>>>>>>>>>>>>>>>>>>>> 28 SI80 273
IF((ABS(SNQS)<.01)&(ABS(SNQC)<.01)) NEXT# Skip if uncertain             SI80 274
D=ATAN2(SNQS,SNQC)/X#                  Calc phase in degrees            SI80 275
L=MOD(3600+NINT(D),360)#               Reduce to positive value         SI80 276
IF(prc:>1.5)#                          If restricted phase value        SI80 277
$(#                                    4>>>>>>>>>>>>>>>>>>>>>>>>>>>> 29 SI80 278
I=iprc:;    J=PRC(I)#                  Extract phase restriction        SI80 279
L=IABS(L-J);    L=MIN0(L,360-L)#       Get min diff with phi            SI80 280
IF(L==90) NEXT#                        Skip completely wrong            SI80 281
IF(L<90) L=J#                          Set to restriction               SI80 282
ELSE     L=J+180#                      Set to restriction +pi           SI80 283
$)#                                    4<<<<<<<<<<<<<<<<<<<<<<<<<<<< 29 SI80 284
$)#                                    3<<<<<<<<<<<<<<<<<<<<<<<<<<<< 28 SI80 285
D=ABS(FLOAT(L)-C)#                     Get diff with est phase          SI80 286
SNQN=SNQN+1.#                          Count neq quartets               SI80 287
SNQA=SNQA+A#                           Sum calc alphas                  SI80 288
SNQD=SNQD+A*AMIN1(D,360.-D)**2#        Sum phi diff sqd for fom         SI80 289
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 25 SI80 290
ELSE#                                  If psi zero triplets             SI80 291
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 30 SI80 292
PSIN=PSIN+1.#                          Count psi0 triplets              SI80 293
PSIA=PSIA+A#                           Sum calculated alphas            SI80 294
PSIE=PSIE+B#                           Sum expected alphas              SI80 295
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 30 SI80 296
#                                                                       SI80 297
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI80 298
FOM(2,NP)=(SUMB-SUMR)/AMAX1(1.,SUMA-SUMR)# Calc relative fom            SI80 299
FOM(3,NP)=SUMD/AMAX1(1.,SUMB)#         Calculate karle r-factor         SI80 300
IF(PSIE>.1) FOM(4,NP)=PSIA/PSIE#       Calculate psi0 fom               SI80 301
ELSE        FOM(4,NP)=-.0001#          Flag not available               SI80 302
IF(SNQN>.1) FOM(5,NP)=SQRT(SNQD/SNQA)# Calculate neg quartet fom        SI80 303
ELSE        FOM(5,NP)=-.0001#          Flag not available               SI80 304
APHI(NP)=PHIA/AMAX1(1.,PHIN)#          Calculate av phi fom             SI80 305
#                                                                       SI80 306
IF(IPRT(7)==no:) NEXT#                 Skip if no print dump            SI80 307
BUFOT(1)=FLOAT(NP)#                    Store phase set number           SI80 308
BUFOT(2)=PHIN#                         Store number of generators       SI80 309
BUFOT(3)=APHI(NP)#                     Store average phase              SI80 310
BUFOT(4)=SUMI#                         Store number of invariants       SI80 311
BUFOT(5)=SUMA#                         Store sum of calc alphas         SI80 312
BUFOT(6)=SUMB#                         Store sum of expect alphas       SI80 313
BUFOT(7)=SUMR#                         Store sum of random alphas       SI80 314
BUFOT(8)=FOM(2,NP)#                    Store relative fom               SI80 315
BUFOT(9)=SUMD#                         Store of calc-expect alphas      SI80 316
BUFOT(10)=FOM(3,NP)#                   Store karle r-factor             SI80 317
BUFOT(11)=PSIN#                        Store number of psi0 generat     SI80 318
BUFOT(12)=SUMP#                        Store number of psi0 triplet     SI80 319
BUFOT(13)=PSIA#                        Store psi0 alphas                SI80 320
BUFOT(14)=PSIE#                        Store psi0 expect alphas         SI80 321
BUFOT(15)=FOM(4,NP)#                   Store psi0 fom                   SI80 322
BUFOT(16)=SNQN#                        Store number negq generators     SI80 323
BUFOT(17)=SUMN#                        Store number neg quartets        SI80 324
BUFOT(18)=FOM(5,NP)#                   Store negative quartet fom       SI80 325
ncodefld:(BUFOT,1,CHROT,FN,18)#        Format above items               SI80 326
writeline:(0,SI5,NSI5,1,3)#            Print above items                SI80 327
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI80 328
writepkt:(3,endrecord:,4,I)#           Finish off phase set file        SI80 329
NSEL=NINT(PHIN); NRAN=NINT(SUMI)#      Save nphi and ninv               SI80 330
NPER=NINT(SUMP); NANT=NINT(SUMN)#      Save npsi and nnq4               SI80 331
#                                                                       SI80 332
RETURN#                                                                 SI80 333
END#                                                                    SI80 334
systemheader:(SI90)#                   List & archive phase sets        SI90   1
###################################################################     SI90   2
#                                                                  #    SI90   3
#                             SI90                                 #    SI90   4
#                                                                  #    SI90   5
###################################################################     SI90   6
SUBROUTINE SI90#                       S.r.hall  feb 85                 SI90   7
include:(AACOMN)#                                                       SI90   8
include:(SICOMN)#                                                       SI90   9
#                                                                       SI90  10
INTEGER I,J,K,L,N,M#                                                    SI90  11
INTEGER IP,IRP,JP,M4,MM,MGEN,NG,MP,N1,NN,NP,NPNT#                       SI90  12
REAL A,B,D,EVAL,FMIN(6),FMAX(6),FREJ(6),PHI,STOL#                       SI90  13
REAL FMMX,SUMD(16),SUMW(16)#                                            SI90  14
REAL AL,AH,SETN(64)#                                                    SI90  15
#                                                                       SI90  16
chardata:(SI1, REJECT)#                                                 SI90  17
chardata:(SI2,QFACRFOMRFACPSI0NEGQ    )#                                SI90  18
chardata:(SI3, OPTIMAL      AND AMOS WEIGHT                    )#       SI90  19
chardata:(SI4, **** CAUTION PHASE SETS RESTRICTED BY MEMORY SIZE)#      SI90  20
chardata:(SI5, NSET   NPHI  AVPHI   QFAC   NINV  RFOM  RFAC  $#         SI90  21
 NPSI  PSI0   NNQ4  NEGQ)#                                              SI90  22
chardata:(SI6,[ PSET   NSET    QFAC   RFOM   RFAC   PSI0   NEGQ    $#   SI90  23
       *CFOM*   AMOS(%)])#                                              SI90  24
chardata:(SI7,   ODREDRSYMSETNUL-)#                                     SI90  25
chardata:(SI8,  NGEN  H   K   L   PHI  START   PHI  WGT    $#           SI90  26
PHI  WGT    PHI  WGT    PHI  WGT  )#                                    SI90  27
chardata:(SI9,[ PHASE SET ASSESSMENT (IN ORDER O/P TO BDF)])#           SI90  28
chardata:(SI10,[ EXPECTED AVERAGE PHI (AVPHI)          ])#              SI90  29
chardata:(SI11, LIST OF OUTPUT PHASE SETS)#                             SI90  30
chardata:(SI12, NS          NS          NS          NS          )#      SI90  31
chardata:(SI13, SUMMARY OF PHASE SET FOM TESTS)#                        SI90  32
chardata:(SI14,[ WEIGHTED PHASE DIFF (IN DEGREES) FROM BDF VALUES])#    SI90  33
realdata:(FM,[40313.,120413.,180413.,260622.,330513.,390622.,#          SI90  34
450522.,520503.,580422.,650513.,710413.])#                              SI90  35
realdata:(FN,[40313.,110313.,200422.,270422.,340422.,410422.,480413.,#  SI90  36
550403.,640422.,720413.])#                                              SI90  37
realdata:(FQ,[90313.,130313.,170313.,360313.,410422.,#                  SI90  38
480313.,530422.,600313.,650422.,720313.,770422.])#                      SI90  39
realdata:(PI2,6.2831852)#                                               SI90  40
datastuff:#                                                             SI90  41
#                                                                       SI90  42
#                                                                       SI90  43
#   NORMALIZE FOM THRESHOLDS                                            SI90  44
#   ------------------------                                            SI90  45
#                                                                       SI90  46
movechar:(SI7,NSI7,CHROT,2,NSI13-1,2)# Underline summary header         SI90  47
LINRM=10;  writeline:(1,SI13,NSI13,1,3)# Header for fom list            SI90  48
A=0.01#                                Zero accumulator                 SI90  49
DO I=1,5#                              Loop over fom weights            SI90  50
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 1  SI90  51
FREJ(I)=3.*FOPT(I)#                    Store reject level at 3*opt      SI90  52
FMIN(I)=+1000.;   FMAX(I)=-1000.#      Reset fom max/min values         SI90  53
movechar:(SI2,I*4-3,SI3,10,4,0)#       Insert fom type string           SI90  54
ncodefld:(FOPT,I,SI3,360422.,1)#       Format optimum fom               SI90  55
ncodefld:(WFOM,I,SI3,420422.,1)#       Format fom weight                SI90  56
writeline:(0,SI3,NSI3,3,3)#            Print fopt and wfom              SI90  57
#                                                                       SI90  58
DO N=1,NSET#                           Loop over phase sets             SI90  59
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 2  SI90  60
FMIN(I)=AMIN1(FMIN(I),FOM(I,N))#       Find min fom                     SI90  61
FMAX(I)=AMAX1(FMAX(I),FOM(I,N))#       Find max fom                     SI90  62
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 2  SI90  63
IF(FMAX(I)>(-.000001)) A=A+WFOM(I)#    Sum weights of active fom        SI90  64
ELSE                   WFOM(I)=0.#     Exclude inactive fom's           SI90  65
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 1  SI90  66
#                                                                       SI90  67
DO I=1,5#                              Loop over fom types              SI90  68
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 3  SI90  69
WFOM(I)=WFOM(I)/A#                     Normalize fom weights            SI90  70
FOPT(I)=FREJ(I)-AMIN1(FOPT(I),FMIN(I))# Calc ideal fom range            SI90  71
FMIN(I)=AMAX1(.001,FMAX(I)-FMIN(I))#   Calc actual fom range            SI90  72
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 3  SI90  73
AL=PHIAV-45.;   AH=PHIAV+45.#          Set expected range av phi        SI90  74
ncodefld:(PHIAV,1,SI10,360413.,1)#     Format av phi value              SI90  75
writeline:(0,SI10,NSI10,2,3)#          Print av phi value               SI90  76
#                                                                       SI90  77
#    PROCESS STORED PHASE SET FOMS                                      SI90  78
#    ----------------------------                                       SI90  79
#                                                                       SI90  80
FMMX=0.;  LINRM=3;  ISET=0#            Reset max mos value              SI90  81
DO N=1,NSET#                           Loop over phase sets             SI90  82
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 4  SI90  83
A=0.;  B=0.;  M=0;  SETN(N)=FLOAT(N)#  Set accumulators & pointer       SI90  84
FOR(I=1;I<=5;I=I+1)#                   Loop over fom's                  SI90  85
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 5  SI90  86
D=FOM(I,N)#                            Extract fom value                SI90  87
A=A+WFOM(I)*(FMAX(I)-D)/FMIN(I)#       Form cfom value                  SI90  88
IF(D>FREJ(I)) M=I#                     Flag rejected fom's              SI90  89
B=B+WFOM(I)*(FREJ(I)-D)/FOPT(I)#       Form amos value                  SI90  90
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 5  SI90  91
FOM(7,N)=A;     FOM(8,N)=B#            Store rfom and amos              SI90  92
FMMX=AMAX1(FMMX,B,1.)#                 Find max mos value               SI90  93
IF((APHI(N)<AL)\(APHI(N)>AH)) M=10#    Force rejection                  SI90  94
#                                                                       SI90  95
IF(M>0)#                               Test if pset rejected            SI90  96
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 6  SI90  97
FOM(8,N)=0.#                           Cancel amos value                SI90  98
ncodefld:(FLOAT(M),1,CHROT,800213.,1)# Format reject number             SI90  99
movechar:(SI1,1,CHROT,72,7,0)#         Insert reject mess               SI90 100
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 6  SI90 101
ELSE ISET=ISET+1#                      Count accepted phase sets        SI90 102
BUFOT(1)=SETN(N)#                      Store phase set number           SI90 103
BUFOT(2)=FLOAT(NSEL)#                  Store number phases              SI90 104
BUFOT(3)=APHI(N)#                      Store average phase value        SI90 105
BUFOT(4)=FOM(1,N)#                     Store corr factor fom            SI90 106
BUFOT(5)=FLOAT(NRAN)#                  Store number of t3/q4 invars     SI90 107
BUFOT(6)=FOM(2,N)#                     Store relative fom               SI90 108
BUFOT(7)=FOM(3,N)#                     Store karle r-factor             SI90 109
BUFOT(8)=FLOAT(NPER)#                  Store number psi0 trips          SI90 110
BUFOT(9)=FOM(4,N)#                     Store psi0 fom                   SI90 111
BUFOT(10)=FLOAT(NANT)#                 Store number of neg quars        SI90 112
BUFOT(11)=FOM(5,N)#                    Store neg quartet fom            SI90 113
ncodefld:(BUFOT,1,CHROT,FM,11)#        Format above items               SI90 114
writeline:(0,SI5,NSI5,1,3)#            Print phase set info             SI90 115
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 4  SI90 116
#                                                                       SI90 117
#    SORT SETS ON MEASURE-OF-SUCCESS FOM                                SI90 118
#    ------------------------------------                               SI90 119
#                                                                       SI90 120
IF(NOPS==0)#                           If not phase set requests        SI90 121
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 7  SI90 122
DO I=1,NSET#                           Loop over all phase sets         SI90 123
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 8  SI90 124
K=NINT(SETN(I))#                       Point to phase set               SI90 125
A=FOM(8,K);    N=I#                    Set initial fom & index          SI90 126
DO J=I,NSET#                           Loop over phase sets             SI90 127
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 9  SI90 128
L=NINT(SETN(J))#                       Point to phase set               SI90 129
IF(A>=FOM(8,L)) NEXT#                  Skip if fom smaller              SI90 130
A=FOM(8,L);   N=J#                     Replace max fom & index          SI90 131
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 9  SI90 132
B=SETN(N); SETN(N)=SETN(I); SETN(I)=B# Swap pointer word                SI90 133
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 8  SI90 134
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 7  SI90 135
ELSE DO I=1,NOPS; SETN(I)=PSET(I)#     Set requested phase sets         SI90 136
#                                                                       SI90 137
#   ENTER PHASE SETS & STORE FOR OUTPUT                                 SI90 138
#   -----------------------------------                                 SI90 139
#                                                                       SI90 140
NSET=ISET#                             Reset psets to those accepte     SI90 141
POUT=MIN0(POUT,NSET,16)#               Adjust number op sets            SI90 142
MGEN=2*NGEN#                           Double for phi + wgt             SI90 143
IOMARK(1)=MT#                          Define start of buffer 1         SI90 144
IOMARK(2)=MT+bdfbuf:#                  Define start of buffer 2         SI90 145
M3=IOMARK(2)+bdfbuf:#                  Define start of ps store         SI90 146
M4=M3+POUT*MGEN#                       Define end of ps store           SI90 147
IF(M4>QXMAX)#                          Test memory available            SI90 148
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 10 SI90 149
writeline:(1,SI4,NSI4,3,3)#            Print warning message            SI90 150
POUT=(QXMAX-M3)/MGEN#                  Calc phase sets possible         SI90 151
IF(POUT<1) iquit:(SI9010)#             No ps op.......si9010            SI90 152
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 10 SI90 153
NSET=POUT*2;  M4=M3+POUT*MGEN#         Set length of phi+wgt/gen        SI90 154
qxmemory:(M4)#                         Reset memory max                 SI90 155
NPNT=MIN0(POUT,4)#                     Limit print of phase sets        SI90 156
movechar:(SI7,NSI7,CHROT,2,NSI9-1,2)#  Underline fom header             SI90 157
LINRM=12;   writeline:(1,SI9,NSI9,1,3)# Force phase set heading         SI90 158
writeline:(0,SI6,NSI6,3,3)#            Print phase set subheader        SI90 159
K=0;        LINRM=1;     A=50223.#     Temp store for prior ps          SI90 160
#                                                                       SI90 161
DO N=1,POUT#                           Loop over op phase sets          SI90 162
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 11 SI90 163
SUMD(N)=0.;    SUMW(N)=0.#             Zero phase diff sums             SI90 164
M=NINT(SETN(N));   MP=M+1#             Point to stored fom's            SI90 165
FOM(6,M)=0.#                           Unused fom value                 SI90 166
FOM(8,M)=100.*FOM(8,M)/FMMX#           Scale mos values                 SI90 167
ncodefld:(FLOAT(N),1,CHROT,FN,1)#      Format pset number               SI90 168
ncodefld:(SETN,N,CHROT,FN(2),1)#       Format stored ps num             SI90 169
ncodefld:(FOM(1,M),1,CHROT,FN(3),8)#   Format stored fom's              SI90 170
writeline:(0,0,0,1,3)#                 Print stored fom's               SI90 171
#                                                                       SI90 172
IF(N<=NPNT) ncodefld:(SETN,N,SI12,A,1)# Format phase set numbers        SI90 173
A=A+120000.;     L=N+N#                Incr format for ps no.           SI90 174
IF(M<K) rewindbdf:(3)#                 Test posn of next record         SI90 175
FOR(J=M3;J<M4;J=J+NSET)#               Loop over generators             SI90 176
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 12 SI90 177
readwpkt:(3,MP,NP,IP,0)#               Enter phase and weight           SI90 178
QX(J+L-1)=QX(IP+1)#                    Extract phase                    SI90 179
QX(J+L)=QX(IP+2)#                      Extract weight                   SI90 180
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 12 SI90 181
K=M#                                   Reset last record number         SI90 182
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 11 SI90 183
IF(POUT>0)readwpkt:(3,endrecord:,NP,IP,0)# Rewind & close file 3        SI90 184
#                                                                       SI90 185
NPNT=2*NPNT#                           Double print count phi+wgt       SI90 186
#                                                                       SI90 187
#   PREPARE TO OP PHASES ON BDF                                         SI90 188
#   ---------------------------                                         SI90 189
#                                                                       SI90 190
copyfile:(1,2,1,decr:(lrrefl:))#       Copy up to lr refl               SI90 191
IW(1)=1;   IW(2)=2#                    Request hkl and stol idnms       SI90 192
IW(3)=NMDS+599+NINT(ETYP)#             Request eval idnum               SI90 193
IW(4)=NMDS+700#                        Request phi  idnum               SI90 194
IW(5)=NMDS+801#                        Request acal idnum               SI90 195
IW(6)=NMDS+802#                        Request bcal idnum               SI90 196
DO I=1,NSET;  IW(I+6)=NMDS+630+I#      Set phase list                   SI90 197
KEY(1)=3;   KEY(3)=NSET+6#             Set search limits                SI90 198
KEY(2)=6;   KEY(4)=1#                  Set search limits                SI90 199
indexpkt:(1,lrrefl:,NP,IP,2,KEY,IW,IR)# Search & output idnums          SI90 200
IF(KEY(4)<1) iquit:(SI9020)#           No /e/ ......si9020              SI90 201
MP=KEY(4)#                             Store output packet size         SI90 202
IRP=IR(4)+IR(5)+IR(6);  MM=27#         Set calc phase flag              SI90 203
#                                                                       SI90 204
IF(IPRT(8)>0)#                         Test for p.s. listing            SI90 205
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 13 SI90 206
movechar:(SI7,NSI7,CHROT,2,NSI11-1,2)# Insert header underline          SI90 207
LINRM=10;  writeline:(1,SI11,NSI11,2,3)# Print p.s. header              SI90 208
IF(IRP==0)#                            Test if calc phase present       SI90 209
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 14 SI90 210
DO I=1,8; FQ(I+3)=FQ(I+3)-60000.#      Adjust op formats                SI90 211
movechar:(SI8,24,SI8,18,NSI8-23,0)#    Adjust op heading                SI90 212
MM=21#                                 Set length of op line            SI90 213
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 14 SI90 214
movechar:(SI12,1,CHROT,MM+8,NPNT*6,0)# Put phase set no. in buff        SI90 215
LINRM=1;  writeline:(0,0,0,1,3);  LINRM=1# Force first subheader        SI90 216
NN=MM+NPNT*6+5#                        Calc length of header            SI90 217
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 13 SI90 218
#                                                                       SI90 219
#   READ & UPDATE RECORD LRREFL:                                        SI90 220
#   ---------------------------                                         SI90 221
#                                                                       SI90 222
EMIN=EMIN-.1;     PHI=0.#              Ensure all e's found on bdf      SI90 223
REPEAT#                                Loop over reflection packets     SI90 224
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 15 SI90 225
readwpkt:(1,lrrefl:,NP,IP,0)#          Point to next ip packet          SI90 226
IF(IP<=0) BREAK#                       Exit after last packet           SI90 227
writepkt:(2,lrrefl:,MP,JP)#            Point to next op packet          SI90 228
N=JP+1;   M=KEY(2)+1#                  Point to op & rel array          SI90 229
DO I=1,NP#                             Loop over ip packet              SI90 230
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 16 SI90 231
J=IP+I#                                Point to ip pack word            SI90 232
movepakwd:(QX(J),QX(N))#               Put ip item in op                SI90 233
IF(IR(M)==I) M=M+1#                    Test if delete item              SI90 234
ELSE         N=N+1#                    Else is add    item              SI90 235
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 16 SI90 236
movereal:(voidflg:,1,QX,N,NSET,2)#     Initialize add-on area           SI90 237
#                                                                       SI90 238
I=IP+IR(3);  EVAL=QX(I)#               Extract /e/ value                SI90 239
IF(EVAL<EMIN) NEXT#                    Test if /e/ acceptable           SI90 240
I=IP+IR(2);  STOL=QX(I)#               Extract st/l value               SI90 241
IF((STOL<STMN)\(STOL>STMX)) NEXT#      Is st/l inside limits            SI90 242
I=IP+IR(1); movepakwd:(QX(I),A)#       Stored packed hkl                SI90 243
FOR(NG=M1;NG<MT;NG=NG+MARK)#           Loop over generator list         SI90 244
compakwd:(hkl:,EQ,A,BREAK)#            Exit when match found            SI90 245
IF(NG>=MT) NEXT#                       Skip refn if no match            SI90 246
N1=((NG-M1)/MARK)*NSET+M3#             Convert to ps pointer            SI90 247
movereal:(QX,N1+1,QX,N,NSET,1)#        Store phases in op buffer        SI90 248
FOR(J=N;J<N+NSET;J=J+2) QX(J)=QX(J)/360.# Convert phi to cycles         SI90 249
#                                                                       SI90 250
IF(IRP>0)#                             Test if phase on bdf             SI90 251
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 17 SI90 252
I=IP+IR(4); IF(I>IP) PHI=QX(I)#        Extract phase in cycles          SI90 253
ELSE#                                  Else acal $ bcal present         SI90 254
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 18 SI90 255
I=IP+IR(5);  A=QX(I)#                  Extract acal value               SI90 256
I=IP+IR(6);  B=QX(I)#                  Extract bcal value               SI90 257
IF((ABS(A)<.01)&(ABS(B)<.01)) A=.1#    Avoid indeterminancy             SI90 258
PHI=ATAN2(B,A)/PI2#                    Calc phase in cycles             SI90 259
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 18 SI90 260
PHI=AMOD(PHI*360.+3600.,360.)#         Convert to degrees               SI90 261
FOR(J=N1;J<N1+NSET;J=J+2)#             Loop over output sets            SI90 262
$(#                                    2>>>>>>>>>>>>>>>>>>>>>>>>>>>> 19 SI90 263
I=(J-N1)/2+1#                          Get index to sums                SI90 264
A=ABS(PHI-QX(J+1))#                    Get difference with bdf phi      SI90 265
SUMD(I)=SUMD(I)+AMIN1(A,360.-A)*QX(J+2)# Accumulate differences         SI90 266
SUMW(I)=SUMW(I)+QX(J+2)#               Accumulate weights               SI90 267
$)#                                    2<<<<<<<<<<<<<<<<<<<<<<<<<<<< 19 SI90 268
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 17 SI90 269
#                                                                       SI90 270
IF(IPRT(8)==no:) NEXT#                 Skip if not listed               SI90 271
A=FLOAT((ipnt:-M1)/MARK+1)#            Get original genlist order       SI90 272
ncodefld:(A,1,CHROT,50413.,1)#         Format genlist number            SI90 273
ncodefld:(PHI,1,CHROT,230313.,1)#      Format calc phase                SI90 274
I=IP+IR(1);  gethkl:(I,H)#             Extract hkl indices              SI90 275
ncodefld:(H,1,CHROT,FQ,3)#             Format indices hkl               SI90 276
I=MAX0(ista:,1)#                       Extract start status             SI90 277
movechar:(SI7,I*3-2,CHROT,MM,3,0)#     Insert start status              SI90 278
ncodefld:(QX,N1+1,CHROT,FQ(4),NPNT)#   Format phi & wgt's               SI90 279
writeline:(0,SI8,NN,1,3)#              Print phase line                 SI90 280
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 15 SI90 281
#                                                                       SI90 282
IF(IRP>0)#                             Test if bdf phases used          SI90 283
$(#                                    0>>>>>>>>>>>>>>>>>>>>>>>>>>>> 20 SI90 284
writeline:(1,SI14,NSI14,3,3)#          Print phi diff header            SI90 285
DO I=1,POUT#                           Loop over phase sets             SI90 286
$(#                                    1>>>>>>>>>>>>>>>>>>>>>>>>>>>> 21 SI90 287
J=MOD(I-1,10)#                         Reduce to mod 10                 SI90 288
IF(J==0) A=80612.#                     Test if first of 10              SI90 289
B=SUMD(I)/SUMW(I)#                     Get weighted difference          SI90 290
ncodefld:(B,1,CHROT,A,1)#              Format phi difference            SI90 291
A=A+80000.#                            Incr formats                     SI90 292
IF((J==9)\(I==POUT))writeline:(0,0,0,2,3)# Print phi diff values        SI90 293
$)#                                    1<<<<<<<<<<<<<<<<<<<<<<<<<<<< 21 SI90 294
$)#                                    0<<<<<<<<<<<<<<<<<<<<<<<<<<<< 20 SI90 295
copyfile:(1,2,incr:(lrrefl:),endrecord:)# Finish off bdf copy           SI90 296
#                                                                       SI90 297
RETURN#                                                                 SI90 298
END#                                                                    SI90 299
pmacro:([no:])#                        Purge xtal system macros         SI90 300
